/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],re=function(J){for(var e=[],S=0,A=J.length;S<A;S++)e[S]=ne[J[S]];return e};define(ne[134],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function S(w,b,g){const h=A(w,b);if(h!==-1)return w[h]}e.$eb=S;function A(w,b,g=w.length-1){for(let h=g;h>=0;h--){const l=w[h];if(b(l))return h}return-1}e.$fb=A;function s(w,b){const g=M(w,b);return g===-1?void 0:w[g]}e.$gb=s;function M(w,b,g=0,h=w.length){let l=g,E=h;for(;l<E;){const u=Math.floor((l+E)/2);b(w[u])?l=u+1:E=u}return l-1}e.$hb=M;function C(w,b){const g=P(w,b);return g===w.length?void 0:w[g]}e.$ib=C;function P(w,b,g=0,h=w.length){let l=g,E=h;for(;l<E;){const u=Math.floor((l+E)/2);b(w[u])?E=u:l=u+1}return l}e.$jb=P;function d(w,b,g=0,h=w.length){const l=P(w,b,g,h);return l===w.length?-1:l}e.$kb=d;class a{static{this.assertInvariants=!1}constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(a.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!b(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const g=M(this.e,b,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$lb=a;function $(w,b){if(w.length===0)return;let g=w[0];for(let h=1;h<w.length;h++){const l=w[h];b(l,g)>0&&(g=l)}return g}e.$mb=$;function p(w,b){if(w.length===0)return;let g=w[0];for(let h=1;h<w.length;h++){const l=w[h];b(l,g)>=0&&(g=l)}return g}e.$nb=p;function v(w,b){return $(w,(g,h)=>-b(g,h))}e.$ob=v;function f(w,b){if(w.length===0)return-1;let g=0;for(let h=1;h<w.length;h++){const l=w[h];b(l,w[g])>0&&(g=h)}return g}e.$pb=f;function y(w,b){for(const g of w){const h=b(g);if(h!==void 0)return h}}e.$qb=y}),define(ne[135],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function S(C,P){const d=Object.create(null);for(const a of C){const $=P(a);let p=d[$];p||(p=d[$]=[]),p.push(a)}return d}e.$J=S;function A(C,P){const d=[],a=[];for(const $ of C)P.has($)||d.push($);for(const $ of P)C.has($)||a.push($);return{removed:d,added:a}}e.$K=A;function s(C,P){const d=[],a=[];for(const[$,p]of C)P.has($)||d.push(p);for(const[$,p]of P)C.has($)||a.push(p);return{removed:d,added:a}}e.$L=s;function M(C,P){const d=new Set;for(const a of P)C.has(a)&&d.add(a);return d}e.$M=M}),define(ne[136],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=e.$2s=e.$1s=void 0;function S(P,d){const a=Math.pow(10,d);return Math.round(P*a)/a}class A{constructor(d,a,$,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=S(Math.max(Math.min(1,p),0),3)}static equals(d,a){return d.r===a.r&&d.g===a.g&&d.b===a.b&&d.a===a.a}}e.$1s=A;class s{constructor(d,a,$,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=S(Math.max(Math.min(1,a),0),3),this.l=S(Math.max(Math.min(1,$),0),3),this.a=S(Math.max(Math.min(1,p),0),3)}static equals(d,a){return d.h===a.h&&d.s===a.s&&d.l===a.l&&d.a===a.a}static fromRGBA(d){const a=d.r/255,$=d.g/255,p=d.b/255,v=d.a,f=Math.max(a,$,p),y=Math.min(a,$,p);let w=0,b=0;const g=(y+f)/2,h=f-y;if(h>0){switch(b=Math.min(g<=.5?h/(2*g):h/(2-2*g),1),f){case a:w=($-p)/h+($<p?6:0);break;case $:w=(p-a)/h+2;break;case p:w=(a-$)/h+4;break}w*=60,w=Math.round(w)}return new s(w,b,g,v)}static i(d,a,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?d+(a-d)*6*$:$<1/2?a:$<2/3?d+(a-d)*(2/3-$)*6:d}static toRGBA(d){const a=d.h/360,{s:$,l:p,a:v}=d;let f,y,w;if($===0)f=y=w=p;else{const b=p<.5?p*(1+$):p+$-p*$,g=2*p-b;f=s.i(g,b,a+1/3),y=s.i(g,b,a),w=s.i(g,b,a-1/3)}return new A(Math.round(f*255),Math.round(y*255),Math.round(w*255),v)}}e.$2s=s;class M{constructor(d,a,$,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=S(Math.max(Math.min(1,a),0),3),this.v=S(Math.max(Math.min(1,$),0),3),this.a=S(Math.max(Math.min(1,p),0),3)}static equals(d,a){return d.h===a.h&&d.s===a.s&&d.v===a.v&&d.a===a.a}static fromRGBA(d){const a=d.r/255,$=d.g/255,p=d.b/255,v=Math.max(a,$,p),f=Math.min(a,$,p),y=v-f,w=v===0?0:y/v;let b;return y===0?b=0:v===a?b=(($-p)/y%6+6)%6:v===$?b=(p-a)/y+2:b=(a-$)/y+4,new M(Math.round(b*60),w,v,d.a)}static toRGBA(d){const{h:a,s:$,v:p,a:v}=d,f=p*$,y=f*(1-Math.abs(a/60%2-1)),w=p-f;let[b,g,h]=[0,0,0];return a<60?(b=f,g=y):a<120?(b=y,g=f):a<180?(g=f,h=y):a<240?(g=y,h=f):a<300?(b=y,h=f):a<=360&&(b=f,h=y),b=Math.round((b+w)*255),g=Math.round((g+w)*255),h=Math.round((h+w)*255),new A(b,g,h,v)}}e.$3s=M;class C{static fromHex(d){return C.Format.CSS.parseHex(d)||C.red}static equals(d,a){return!d&&!a?!0:!d||!a?!1:d.equals(a)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof A)this.rgba=d;else if(d instanceof s)this.i=d,this.rgba=s.toRGBA(d);else if(d instanceof M)this.j=d,this.rgba=M.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&A.equals(this.rgba,d.rgba)&&s.equals(this.hsla,d.hsla)&&M.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=C.k(this.rgba.r),a=C.k(this.rgba.g),$=C.k(this.rgba.b),p=.2126*d+.7152*a+.0722*$;return S(p,4)}static k(d){const a=d/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(d){const a=this.getRelativeLuminance(),$=d.getRelativeLuminance();return a>$?(a+.05)/($+.05):($+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const a=this.getRelativeLuminance(),$=d.getRelativeLuminance();return a>$}isDarkerThan(d){const a=this.getRelativeLuminance(),$=d.getRelativeLuminance();return a<$}lighten(d){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new C(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:a,g:$,b:p,a:v}=this.rgba;return new C(new A(a,$,p,v*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new A(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const a=d.rgba,$=this.rgba.a,p=a.a,v=$+p*(1-$);if(v<1e-6)return C.transparent;const f=this.rgba.r*$/v+a.r*p*(1-$)/v,y=this.rgba.g*$/v+a.g*p*(1-$)/v,w=this.rgba.b*$/v+a.b*p*(1-$)/v;return new C(new A(f,y,w,v))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:a,g:$,b:p,a:v}=this.rgba;return new C(new A(d.rgba.r-v*(d.rgba.r-a),d.rgba.g-v*(d.rgba.g-$),d.rgba.b-v*(d.rgba.b-p),1))}flatten(...d){const a=d.reduceRight(($,p)=>C.o(p,$));return C.o(this,a)}static o(d,a){const $=1-d.rgba.a;return new C(new A($*a.rgba.r+d.rgba.a*d.rgba.r,$*a.rgba.g+d.rgba.a*d.rgba.g,$*a.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(d,a,$){if(d.isLighterThan(a))return d;$=$||.5;const p=d.getRelativeLuminance(),v=a.getRelativeLuminance();return $=$*(v-p)/v,d.lighten($)}static getDarkerColor(d,a,$){if(d.isDarkerThan(a))return d;$=$||.5;const p=d.getRelativeLuminance(),v=a.getRelativeLuminance();return $=$*(p-v)/p,d.darken($)}static{this.white=new C(new A(255,255,255,1))}static{this.black=new C(new A(0,0,0,1))}static{this.red=new C(new A(255,0,0,1))}static{this.blue=new C(new A(0,0,255,1))}static{this.green=new C(new A(0,255,0,1))}static{this.cyan=new C(new A(0,255,255,1))}static{this.lightgrey=new C(new A(211,211,211,1))}static{this.transparent=new C(new A(0,0,0,0))}}e.$4s=C,function(P){let d;(function(a){let $;(function(p){function v(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:P.Format.CSS.formatRGBA(i)}p.formatRGB=v;function f(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}p.formatRGBA=f;function y(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(i)}p.formatHSL=y;function w(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}p.formatHSLA=w;function b(i){const o=i.toString(16);return o.length!==2?"0"+o:o}function g(i){return`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}`}p.formatHex=g;function h(i,o=!1){return o&&i.rgba.a===1?P.Format.CSS.formatHex(i):`#${b(i.rgba.r)}${b(i.rgba.g)}${b(i.rgba.b)}${b(Math.round(i.rgba.a*255))}`}p.formatHexA=h;function l(i){return i.isOpaque()?P.Format.CSS.formatHex(i):P.Format.CSS.formatRGBA(i)}p.format=l;function E(i){const o=i.length;if(o===0||i.charCodeAt(0)!==35)return null;if(o===7){const r=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),t=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),n=16*u(i.charCodeAt(5))+u(i.charCodeAt(6));return new P(new A(r,t,n,1))}if(o===9){const r=16*u(i.charCodeAt(1))+u(i.charCodeAt(2)),t=16*u(i.charCodeAt(3))+u(i.charCodeAt(4)),n=16*u(i.charCodeAt(5))+u(i.charCodeAt(6)),c=16*u(i.charCodeAt(7))+u(i.charCodeAt(8));return new P(new A(r,t,n,c/255))}if(o===4){const r=u(i.charCodeAt(1)),t=u(i.charCodeAt(2)),n=u(i.charCodeAt(3));return new P(new A(16*r+r,16*t+t,16*n+n))}if(o===5){const r=u(i.charCodeAt(1)),t=u(i.charCodeAt(2)),n=u(i.charCodeAt(3)),c=u(i.charCodeAt(4));return new P(new A(16*r+r,16*t+t,16*n+n,(16*c+c)/255))}return null}p.parseHex=E;function u(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})($=a.CSS||(a.CSS={}))})(d=P.Format||(P.Format={}))}(C||(e.$4s=C={}))}),define(ne[55],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=void 0;function S(C){return(P,d,a)=>{let $=null,p=null;if(typeof a.value=="function"?($="value",p=a.value):typeof a.get=="function"&&($="get",p=a.get),!p)throw new Error("not supported");a[$]=C(p,d)}}function A(C,P,d){let a=null,$=null;if(typeof d.value=="function"?(a="value",$=d.value,$.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(a="get",$=d.get),!$)throw new Error("not supported");const p=`$memoize$${P}`;d[a]=function(...v){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:$.apply(this,v)}),this[p]}}e.$mh=A;function s(C,P,d){return S((a,$)=>{const p=`$debounce$${$}`,v=`$debounce$result$${$}`;return function(...f){this[v]||(this[v]=d?d():void 0),clearTimeout(this[p]),P&&(this[v]=P(this[v],...f),f=[this[v]]),this[p]=setTimeout(()=>{a.apply(this,f),this[v]=d?d():void 0},C)}})}e.$nh=s;function M(C,P,d){return S((a,$)=>{const p=`$throttle$timer$${$}`,v=`$throttle$result$${$}`,f=`$throttle$lastRun$${$}`,y=`$throttle$pending$${$}`;return function(...w){if(this[v]||(this[v]=d?d():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...w)),this[y])return;const b=this[f]+C;b<=Date.now()?(this[f]=Date.now(),a.apply(this,[this[v]]),this[v]=d?d():void 0):(this[y]=!0,this[p]=setTimeout(()=>{this[y]=!1,this[f]=Date.now(),a.apply(this,[this[v]]),this[v]=d?d():void 0},b-Date.now()))}})}e.$oh=M}),define(ne[14],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class S{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?l.isErrorNoTelemetry(i)?new l(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$V=S,e.$W=new S;function A(u){e.$W.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=A;function s(u){if(!u||typeof u!="object")return!1;const i=u;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Y=s;function M(u){a(u)||e.$W.onUnexpectedError(u)}e.$Z=M;function C(u){a(u)||e.$W.onUnexpectedExternalError(u)}e.$1=C;function P(u){if(u instanceof Error){const{name:i,message:o}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:i,message:o,stack:r,noTelemetry:l.isErrorNoTelemetry(u)}}return u}e.$2=P;const d="Canceled";function a(u){return u instanceof $?!0:u instanceof Error&&u.name===d&&u.message===d}e.$3=a;class $ extends Error{constructor(){super(d),this.name=this.message}}e.$4=$;function p(){const u=new Error(d);return u.name=u.message,u}e.$5=p;function v(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.$6=v;function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.$7=f;class y extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=y;function w(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.$9=w;class b extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=b;class g extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=g;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=h;class l extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof l)return i;const o=new l;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=l;class E extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$bb=E}),define(ne[23],re([0,1,14,134]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function s(L,B=0){return L[L.length-(1+B)]}e.$rb=s;function M(L){if(L.length===0)throw new Error("Invalid tail call");return[L.slice(0,L.length-1),L[L.length-1]]}e.$sb=M;function C(L,B,W=(X,he)=>X===he){if(L===B)return!0;if(!L||!B||L.length!==B.length)return!1;for(let X=0,he=L.length;X<he;X++)if(!W(L[X],B[X]))return!1;return!0}e.$tb=C;function P(L,B){const W=L.length-1;B<W&&(L[B]=L[W]),L.pop()}e.$ub=P;function d(L,B,W){return a(L.length,X=>W(L[X],B))}e.$vb=d;function a(L,B){let W=0,X=L-1;for(;W<=X;){const he=(W+X)/2|0,de=B(he);if(de<0)W=he+1;else if(de>0)X=he-1;else return he}return-(W+1)}e.$wb=a;function $(L,B,W){if(L=L|0,L>=B.length)throw new TypeError("invalid index");const X=B[Math.floor(B.length*Math.random())],he=[],de=[],le=[];for(const we of B){const be=W(we,X);be<0?he.push(we):be>0?de.push(we):le.push(we)}return L<he.length?$(L,he,W):L<he.length+le.length?le[0]:$(L-(he.length+le.length),de,W)}e.$xb=$;function p(L,B){const W=[];let X;for(const he of L.slice(0).sort(B))!X||B(X[0],he)!==0?(X=[he],W.push(X)):X.push(he);return W}e.$yb=p;function*v(L,B){let W,X;for(const he of L)X!==void 0&&B(X,he)?W.push(he):(W&&(yield W),W=[he]),X=he;W&&(yield W)}e.$zb=v;function f(L,B){for(let W=0;W<=L.length;W++)B(W===0?void 0:L[W-1],W===L.length?void 0:L[W])}e.$Ab=f;function y(L,B){for(let W=0;W<L.length;W++)B(W===0?void 0:L[W-1],L[W],W+1===L.length?void 0:L[W+1])}e.$Bb=y;function w(L,B,W){const X=[];function he(we,be,Ee){if(be===0&&Ee.length===0)return;const Se=X[X.length-1];Se&&Se.start+Se.deleteCount===we?(Se.deleteCount+=be,Se.toInsert.push(...Ee)):X.push({start:we,deleteCount:be,toInsert:Ee})}let de=0,le=0;for(;;){if(de===L.length){he(de,0,B.slice(le));break}if(le===B.length){he(de,L.length-de,[]);break}const we=L[de],be=B[le],Ee=W(we,be);Ee===0?(de+=1,le+=1):Ee<0?(he(de,1,[]),de+=1):Ee>0&&(he(de,0,[be]),le+=1)}return X}e.$Cb=w;function b(L,B,W){const X=w(L,B,W),he=[],de=[];for(const le of X)he.push(...L.slice(le.start,le.start+le.deleteCount)),de.push(...le.toInsert);return{removed:he,added:de}}e.$Db=b;function g(L,B,W){if(W===0)return[];const X=L.slice(0,W).sort(B);return l(L,B,X,W,L.length),X}e.top=g;function h(L,B,W,X,he){return W===0?Promise.resolve([]):new Promise((de,le)=>{(async()=>{const we=L.length,be=L.slice(0,W).sort(B);for(let Ee=W,Se=Math.min(W+X,we);Ee<we;Ee=Se,Se=Math.min(Se+X,we)){if(Ee>W&&await new Promise(Le=>setTimeout(Le)),he&&he.isCancellationRequested)throw new S.$4;l(L,B,be,Ee,Se)}return be})().then(de,le)})}e.$Fb=h;function l(L,B,W,X,he){for(const de=W.length;X<he;X++){const le=L[X];if(B(le,W[de-1])<0){W.pop();const we=(0,A.$jb)(W,be=>B(le,be)<0);W.splice(we,0,le)}}}function E(L){return L.filter(B=>!!B)}e.$Gb=E;function u(L){let B=0;for(let W=0;W<L.length;W++)L[W]&&(L[B]=L[W],B+=1);L.length=B}e.$Hb=u;function i(L,B,W){L.splice(W,0,L.splice(B,1)[0])}e.$Ib=i;function o(L){return!Array.isArray(L)||L.length===0}e.$Jb=o;function r(L){return Array.isArray(L)&&L.length>0}e.$Kb=r;function t(L,B=W=>W){const W=new Set;return L.filter(X=>{const he=B(X);return W.has(he)?!1:(W.add(he),!0)})}e.$Lb=t;function n(L){const B=new Set;return W=>{const X=L(W);return B.has(X)?!1:(B.add(X),!0)}}e.$Mb=n;function c(L,B){return L.length>0?L[0]:B}e.$Nb=c;function m(L,B){return L.length>0?L[L.length-1]:B}e.$Ob=m;function D(L,B,W=(X,he)=>X===he){let X=0;for(let he=0,de=Math.min(L.length,B.length);he<de&&W(L[he],B[he]);he++)X++;return X}e.$Pb=D;function R(L){return[].concat(...L)}e.$Qb=R;function k(L,B){let W=typeof B=="number"?L:0;typeof B=="number"?W=L:(W=0,B=L);const X=[];if(W<=B)for(let he=W;he<B;he++)X.push(he);else for(let he=W;he>B;he--)X.push(he);return X}e.$Rb=k;function I(L,B,W){return L.reduce((X,he)=>(X[B(he)]=W?W(he):he,X),Object.create(null))}e.$Sb=I;function F(L,B){return L.push(B),()=>U(L,B)}e.$Tb=F;function U(L,B){const W=L.indexOf(B);if(W>-1)return L.splice(W,1),B}e.$Ub=U;function T(L,B,W){const X=L.slice(0,B),he=L.slice(B);return X.concat(W,he)}e.$Vb=T;function x(L,B){let W;if(typeof B=="number"){let X=B;W=()=>{const he=Math.sin(X++)*179426549;return he-Math.floor(he)}}else W=Math.random;for(let X=L.length-1;X>0;X-=1){const he=Math.floor(W()*(X+1)),de=L[X];L[X]=L[he],L[he]=de}}e.$Wb=x;function Y(L,B){const W=L.indexOf(B);W>-1&&(L.splice(W,1),L.unshift(B))}e.$Xb=Y;function ce(L,B){const W=L.indexOf(B);W>-1&&(L.splice(W,1),L.push(B))}e.$Yb=ce;function oe(L,B){for(const W of B)L.push(W)}e.$Zb=oe;function ae(L,B){return Array.isArray(L)?L.map(B):B(L)}e.$1b=ae;function Z(L){return Array.isArray(L)?L:[L]}e.$2b=Z;function K(L){return L[Math.floor(Math.random()*L.length)]}e.$3b=K;function G(L,B,W){const X=N(L,B),he=L.length,de=W.length;L.length=he+de;for(let le=he-1;le>=X;le--)L[le+de]=L[le];for(let le=0;le<de;le++)L[le+X]=W[le]}e.$4b=G;function z(L,B,W,X){const he=N(L,B);let de=L.splice(he,W);return de===void 0&&(de=[]),G(L,he,X),de}e.$5b=z;function N(L,B){return B<0?Math.max(B+L.length,0):Math.min(B,L.length)}var H;(function(L){function B(de){return de<0}L.isLessThan=B;function W(de){return de<=0}L.isLessThanOrEqual=W;function X(de){return de>0}L.isGreaterThan=X;function he(de){return de===0}L.isNeitherLessOrGreaterThan=he,L.greaterThan=1,L.lessThan=-1,L.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function q(L,B){return(W,X)=>B(L(W),L(X))}e.$6b=q;function ee(...L){return(B,W)=>{for(const X of L){const he=X(B,W);if(!H.isNeitherLessOrGreaterThan(he))return he}return H.neitherLessOrGreaterThan}}e.$7b=ee;const se=(L,B)=>L-B;e.$8b=se;const Q=(L,B)=>(0,e.$8b)(L?1:0,B?1:0);e.$9b=Q;function O(L){return(B,W)=>-L(B,W)}e.$0b=O;class j{constructor(B){this.g=B,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(B){let W=this.c;for(;W<this.g.length&&B(this.g[W]);)W++;const X=W===this.c?null:this.g.slice(this.c,W);return this.c=W,X}takeFromEndWhile(B){let W=this.d;for(;W>=0&&B(this.g[W]);)W--;const X=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const B=this.g[this.c];return this.c++,B}removeLast(){const B=this.g[this.d];return this.d--,B}takeCount(B){const W=this.g.slice(this.c,this.c+B);return this.c+=B,W}}e.$$b=j;class V{static{this.empty=new V(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(W=>(B(W),!0))}toArray(){const B=[];return this.iterate(W=>(B.push(W),!0)),B}filter(B){return new V(W=>this.iterate(X=>B(X)?W(X):!0))}map(B){return new V(W=>this.iterate(X=>W(B(X))))}some(B){let W=!1;return this.iterate(X=>(W=B(X),!W)),W}findFirst(B){let W;return this.iterate(X=>B(X)?(W=X,!1):!0),W}findLast(B){let W;return this.iterate(X=>(B(X)&&(W=X),!0)),W}findLastMaxBy(B){let W,X=!0;return this.iterate(he=>((X||H.isGreaterThan(B(he,W)))&&(X=!1,W=he),!0)),W}}e.$_b=V}),define(ne[137],re([0,1,14]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function A(d,a){if(!d)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=A;function s(d,a="Unreachable"){throw new Error(a)}e.$3c=s;function M(d){if(!d)throw new S.$bb("Assertion Failed")}e.$4c=M;function C(d){if(!d()){debugger;d(),(0,S.$Z)(new S.$bb("Assertion Failed"))}}e.$5c=C;function P(d,a){let $=0;for(;$<d.length-1;){const p=d[$],v=d[$+1];if(!a(p,v))return!1;$++}return!0}e.$6c=P}),define(ne[84],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function S(A){const s=this;let M=!1,C;return function(){return M||(M=!0,C=A.apply(s,arguments)),C}}e.$cb=S}),define(ne[71],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var S;(function(A){function s(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}A.is=s;const M=Object.freeze([]);function C(){return M}A.empty=C;function*P(u){yield u}A.single=P;function d(u){return s(u)?u:P(u)}A.wrap=d;function a(u){return u||M}A.from=a;function*$(u){for(let i=u.length-1;i>=0;i--)yield u[i]}A.reverse=$;function p(u){return!u||u[Symbol.iterator]().next().done===!0}A.isEmpty=p;function v(u){return u[Symbol.iterator]().next().value}A.first=v;function f(u,i){for(const o of u)if(i(o))return!0;return!1}A.some=f;function y(u,i){for(const o of u)if(i(o))return o}A.find=y;function*w(u,i){for(const o of u)i(o)&&(yield o)}A.filter=w;function*b(u,i){let o=0;for(const r of u)yield i(r,o++)}A.map=b;function*g(...u){for(const i of u)for(const o of i)yield o}A.concat=g;function h(u,i,o){let r=o;for(const t of u)r=i(r,t);return r}A.reduce=h;function*l(u,i,o=u.length){for(i<0&&(i+=u.length),o<0?o+=u.length:o>u.length&&(o=u.length);i<o;i++)yield u[i]}A.slice=l;function E(u,i=Number.POSITIVE_INFINITY){const o=[];if(i===0)return[o,u];const r=u[Symbol.iterator]();for(let t=0;t<i;t++){const n=r.next();if(n.done)return[o,A.empty()];o.push(n.value)}return[o,{[Symbol.iterator](){return r}}]}A.consume=E})(S||(e.Iterable=S={}))}),define(ne[44],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var s;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function C(i,o=!1){let r=0;const t=i.length;let n="",c=0,m=16,D=0;function R(Y){let ce=0,oe=0;for(;ce<Y;){const ae=i.charCodeAt(r);if(ae>=48&&ae<=57)oe=oe*16+ae-48;else if(ae>=65&&ae<=70)oe=oe*16+ae-65+10;else if(ae>=97&&ae<=102)oe=oe*16+ae-97+10;else break;r++,ce++}return ce<Y&&(oe=-1),oe}function k(Y){r=Y,n="",c=0,m=16,D=0}function I(){const Y=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&a(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&a(i.charCodeAt(r)))for(r++;r<i.length&&a(i.charCodeAt(r));)r++;else return D=3,i.substring(Y,r);let ce=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&a(i.charCodeAt(r))){for(r++;r<i.length&&a(i.charCodeAt(r));)r++;ce=r}else D=3;return i.substring(Y,ce)}function F(){let Y="",ce=r;for(;;){if(r>=t){Y+=i.substring(ce,r),D=2;break}const oe=i.charCodeAt(r);if(oe===34){Y+=i.substring(ce,r),r++;break}if(oe===92){if(Y+=i.substring(ce,r),r++,r>=t){D=2;break}switch(i.charCodeAt(r++)){case 34:Y+='"';break;case 92:Y+="\\";break;case 47:Y+="/";break;case 98:Y+="\b";break;case 102:Y+="\f";break;case 110:Y+=`
`;break;case 114:Y+="\r";break;case 116:Y+="	";break;case 117:{const Z=R(4);Z>=0?Y+=String.fromCharCode(Z):D=4;break}default:D=5}ce=r;continue}if(oe>=0&&oe<=31)if(d(oe)){Y+=i.substring(ce,r),D=2;break}else D=6;r++}return Y}function U(){if(n="",D=0,c=r,r>=t)return c=t,m=17;let Y=i.charCodeAt(r);if(P(Y)){do r++,n+=String.fromCharCode(Y),Y=i.charCodeAt(r);while(P(Y));return m=15}if(d(Y))return r++,n+=String.fromCharCode(Y),Y===13&&i.charCodeAt(r)===10&&(r++,n+=`
`),m=14;switch(Y){case 123:return r++,m=1;case 125:return r++,m=2;case 91:return r++,m=3;case 93:return r++,m=4;case 58:return r++,m=6;case 44:return r++,m=5;case 34:return r++,n=F(),m=10;case 47:{const ce=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<t&&!d(i.charCodeAt(r));)r++;return n=i.substring(ce,r),m=12}if(i.charCodeAt(r+1)===42){r+=2;const oe=t-1;let ae=!1;for(;r<oe;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,ae=!0;break}r++}return ae||(r++,D=1),n=i.substring(ce,r),m=13}return n+=String.fromCharCode(Y),r++,m=16}case 45:if(n+=String.fromCharCode(Y),r++,r===t||!a(i.charCodeAt(r)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=I(),m=11;default:for(;r<t&&T(Y);)r++,Y=i.charCodeAt(r);if(c!==r){switch(n=i.substring(c,r),n){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return n+=String.fromCharCode(Y),r++,m=16}}function T(Y){if(P(Y)||d(Y))return!1;switch(Y){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let Y;do Y=U();while(Y>=12&&Y<=15);return Y}return{setPosition:k,getPosition:()=>r,scan:o?x:U,getToken:()=>m,getTokenValue:()=>n,getTokenOffset:()=>c,getTokenLength:()=>r-c,getTokenError:()=>D}}e.$Zm=C;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function d(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var $;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})($||($={}));function p(i,o){const r=[],t=new Object;let n;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function D(R,k,I,F){c.value=R,c.offset=k,c.length=I,c.type=F,c.colonOffset=void 0,n=c}try{l(i,{onObjectBegin:(R,k)=>{if(o<=R)throw t;n=void 0,m=o>R,r.push("")},onObjectProperty:(R,k,I)=>{if(o<k||(D(R,k,I,"property"),r[r.length-1]=R,o<=k+I))throw t},onObjectEnd:(R,k)=>{if(o<=R)throw t;n=void 0,r.pop()},onArrayBegin:(R,k)=>{if(o<=R)throw t;n=void 0,r.push(0)},onArrayEnd:(R,k)=>{if(o<=R)throw t;n=void 0,r.pop()},onLiteralValue:(R,k,I)=>{if(o<k||(D(R,k,I,u(R)),o<=k+I))throw t},onSeparator:(R,k,I)=>{if(o<=k)throw t;if(R===":"&&n&&n.type==="property")n.colonOffset=k,m=!1,n=void 0;else if(R===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(m=!0,r[r.length-1]=""),n=void 0}}})}catch(R){if(R!==t)throw R}return{path:r,previousNode:n,isAtPropertyKey:m,matches:R=>{let k=0;for(let I=0;k<R.length&&I<r.length;I++)if(R[k]===r[I]||R[k]==="*")k++;else if(R[k]!=="**")return!1;return k===R.length}}}e.$1m=p;function v(i,o=[],r=M.DEFAULT){let t=null,n=[];const c=[];function m(R){Array.isArray(n)?n.push(R):t!==null&&(n[t]=R)}return l(i,{onObjectBegin:()=>{const R={};m(R),c.push(n),n=R,t=null},onObjectProperty:R=>{t=R},onObjectEnd:()=>{n=c.pop()},onArrayBegin:()=>{const R=[];m(R),c.push(n),n=R,t=null},onArrayEnd:()=>{n=c.pop()},onLiteralValue:m,onError:(R,k,I)=>{o.push({error:R,offset:k,length:I})}},r),n[0]}e.$2m=v;function f(i,o=[],r=M.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(R){t.type==="property"&&(t.length=R-t.offset,t=t.parent)}function c(R){return t.children.push(R),R}l(i,{onObjectBegin:R=>{t=c({type:"object",offset:R,length:-1,parent:t,children:[]})},onObjectProperty:(R,k,I)=>{t=c({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:R,offset:k,length:I,parent:t})},onObjectEnd:(R,k)=>{t.length=R+k-t.offset,t=t.parent,n(R+k)},onArrayBegin:(R,k)=>{t=c({type:"array",offset:R,length:-1,parent:t,children:[]})},onArrayEnd:(R,k)=>{t.length=R+k-t.offset,t=t.parent,n(R+k)},onLiteralValue:(R,k,I)=>{c({type:u(R),offset:k,length:I,parent:t,value:R}),n(k+I)},onSeparator:(R,k,I)=>{t.type==="property"&&(R===":"?t.colonOffset=k:R===","&&n(k))},onError:(R,k,I)=>{o.push({error:R,offset:k,length:I})}},r);const D=t.children[0];return D&&delete D.parent,D}e.$3m=f;function y(i,o){if(!i)return;let r=i;for(const t of o)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const c of r.children)if(Array.isArray(c.children)&&c.children[0].value===t){r=c.children[1],n=!0;break}if(!n)return}else{const n=t;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$4m=y;function w(i){if(!i.parent||!i.parent.children)return[];const o=w(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;o.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&o.push(r)}return o}e.$5m=w;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const o=Object.create(null);for(const r of i.children){const t=r.children[1];t&&(o[r.children[0].value]=b(t))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$6m=b;function g(i,o,r=!1){return o>=i.offset&&o<i.offset+i.length||r&&o===i.offset+i.length}e.$7m=g;function h(i,o,r=!1){if(g(i,o,r)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=o;n++){const c=h(t[n],o,r);if(c)return c}return i}}e.$8m=h;function l(i,o,r=M.DEFAULT){const t=C(i,!1);function n(q){return q?()=>q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function c(q){return q?ee=>q(ee,t.getTokenOffset(),t.getTokenLength()):()=>!0}const m=n(o.onObjectBegin),D=c(o.onObjectProperty),R=n(o.onObjectEnd),k=n(o.onArrayBegin),I=n(o.onArrayEnd),F=c(o.onLiteralValue),U=c(o.onSeparator),T=n(o.onComment),x=c(o.onError),Y=r&&r.disallowComments,ce=r&&r.allowTrailingComma;function oe(){for(;;){const q=t.scan();switch(t.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:Y||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(q){case 12:case 13:Y?ae(10):T();break;case 16:ae(1);break;case 15:case 14:break;default:return q}}}function ae(q,ee=[],se=[]){if(x(q),ee.length+se.length>0){let Q=t.getToken();for(;Q!==17;){if(ee.indexOf(Q)!==-1){oe();break}else if(se.indexOf(Q)!==-1)break;Q=oe()}}}function Z(q){const ee=t.getTokenValue();return q?F(ee):D(ee),oe(),!0}function K(){switch(t.getToken()){case 11:{let q=0;try{q=JSON.parse(t.getTokenValue()),typeof q!="number"&&(ae(2),q=0)}catch{ae(2)}F(q);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return oe(),!0}function G(){return t.getToken()!==10?(ae(3,[],[2,5]),!1):(Z(!1),t.getToken()===6?(U(":"),oe(),H()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function z(){m(),oe();let q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(q||ae(4,[],[]),U(","),oe(),t.getToken()===2&&ce)break}else q&&ae(6,[],[]);G()||ae(4,[],[2,5]),q=!0}return R(),t.getToken()!==2?ae(7,[2],[]):oe(),!0}function N(){k(),oe();let q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(q||ae(4,[],[]),U(","),oe(),t.getToken()===4&&ce)break}else q&&ae(6,[],[]);H()||ae(4,[],[4,5]),q=!0}return I(),t.getToken()!==4?ae(8,[4],[]):oe(),!0}function H(){switch(t.getToken()){case 3:return N();case 1:return z();case 10:return Z(!0);default:return K()}}return oe(),t.getToken()===17?r.allowEmptyContent?!0:(ae(4,[],[]),!1):H()?(t.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$9m=l;function E(i,o){const r=C(i),t=[];let n,c=0,m;do switch(m=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:c!==m&&t.push(i.substring(c,m)),o!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,o)),c=r.getPosition();break}while(n!==17);return t.join("")}e.$0m=E;function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$$m=u}),define(ne[138],re([0,1,44]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vT=e.$uT=e.$tT=e.$sT=void 0;function A(a,$,p){let v,f,y,w,b;if($){for(w=$.offset,b=w+$.length,y=w;y>0&&!d(a,y-1);)y--;let m=b;for(;m<a.length&&!d(a,m);)m++;f=a.substring(y,m),v=C(f,p)}else f=a,v=0,y=0,w=0,b=a.length;const g=P(p,a);let h=!1,l=0,E;p.insertSpaces?E=M(" ",p.tabSize||4):E="	";const u=(0,S.$Zm)(f,!1);let i=!1;function o(){return g+M(E,v+l)}function r(){let m=u.scan();for(h=!1;m===15||m===14;)h=h||m===14,m=u.scan();return i=m===16||u.getTokenError()!==0,m}const t=[];function n(m,D,R){!i&&D<b&&R>w&&a.substring(D,R)!==m&&t.push({offset:D,length:R-D,content:m})}let c=r();if(c!==17){const m=u.getTokenOffset()+y,D=M(E,v);n(D,y,m)}for(;c!==17;){let m=u.getTokenOffset()+u.getTokenLength()+y,D=r(),R="";for(;!h&&(D===12||D===13);){const I=u.getTokenOffset()+y;n(" ",m,I),m=u.getTokenOffset()+u.getTokenLength()+y,R=D===12?o():"",D=r()}if(D===2)c!==1&&(l--,R=o());else if(D===4)c!==3&&(l--,R=o());else{switch(c){case 3:case 1:l++,R=o();break;case 5:case 12:R=o();break;case 13:h?R=o():R=" ";break;case 6:R=" ";break;case 10:if(D===6){R="";break}case 7:case 8:case 9:case 11:case 2:case 4:D===12||D===13?R=" ":D!==5&&D!==17&&(i=!0);break;case 16:i=!0;break}h&&(D===12||D===13)&&(R=o())}const k=u.getTokenOffset()+y;n(R,m,k),c=D}return t}e.$sT=A;function s(a,$){const p=JSON.stringify(a,void 0,$.insertSpaces?$.tabSize||4:"	");return $.eol!==void 0?p.replace(/\r\n|\r|\n/g,$.eol):p}e.$tT=s;function M(a,$){let p="";for(let v=0;v<$;v++)p+=a;return p}function C(a,$){let p=0,v=0;const f=$.tabSize||4;for(;p<a.length;){const y=a.charAt(p);if(y===" ")v++;else if(y==="	")v+=f;else break;p++}return Math.floor(v/f)}function P(a,$){for(let p=0;p<$.length;p++){const v=$.charAt(p);if(v==="\r")return p+1<$.length&&$.charAt(p+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return a&&a.eol||`
`}e.$uT=P;function d(a,$){return`\r
`.indexOf(a.charAt($))!==-1}e.$vT=d}),define(ne[139],re([0,1,44,138]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AT=e.$zT=e.$yT=e.$xT=e.$wT=void 0;function s(a,$,p){return M(a,$,void 0,p)}e.$wT=s;function M(a,$,p,v,f){const y=$.slice(),w=[],b=(0,S.$3m)(a,w);let g,h;for(;y.length>0&&(h=y.pop(),g=(0,S.$4m)(b,y),g===void 0&&p!==void 0);)typeof h=="string"?p={[h]:p}:p=[p];if(g)if(g.type==="object"&&typeof h=="string"&&Array.isArray(g.children)){const l=(0,S.$4m)(g,[h]);if(l!==void 0)if(p===void 0){if(!l.parent)throw new Error("Malformed AST");const E=g.children.indexOf(l.parent);let u,i=l.parent.offset+l.parent.length;if(E>0){const o=g.children[E-1];u=o.offset+o.length}else u=g.offset+1,g.children.length>1&&(i=g.children[1].offset);return C(a,{offset:u,length:i-u,content:""},v)}else return C(a,{offset:l.offset,length:l.length,content:JSON.stringify(p)},v);else{if(p===void 0)return[];const E=`${JSON.stringify(h)}: ${JSON.stringify(p)}`,u=f?f(g.children.map(o=>o.children[0].value)):g.children.length;let i;if(u>0){const o=g.children[u-1];i={offset:o.offset+o.length,length:0,content:","+E}}else g.children.length===0?i={offset:g.offset+1,length:0,content:E}:i={offset:g.offset+1,length:0,content:E+","};return C(a,i,v)}}else if(g.type==="array"&&typeof h=="number"&&Array.isArray(g.children))if(p!==void 0){const l=`${JSON.stringify(p)}`;let E;if(g.children.length===0||h===0)E={offset:g.offset+1,length:0,content:g.children.length===0?l:l+","};else{const u=h===-1||h>g.children.length?g.children.length:h,i=g.children[u-1];E={offset:i.offset+i.length,length:0,content:","+l}}return C(a,E,v)}else{const l=h,E=g.children[l];let u;if(g.children.length===1)u={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===l){const i=g.children[l-1],o=i.offset+i.length,r=g.offset+g.length;u={offset:o,length:r-2-o,content:""}}else u={offset:E.offset,length:g.children[l+1].offset-E.offset,content:""};return C(a,u,v)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${g.type}`);else{if(p===void 0)throw new Error("Can not delete in empty document");return C(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(p)},v)}}e.$xT=M;function C(a,$,p){let v=P(a,$),f=$.offset,y=$.offset+$.content.length;if($.length===0||$.content.length===0){for(;f>0&&!(0,A.$vT)(v,f-1);)f--;for(;y<v.length&&!(0,A.$vT)(v,y);)y++}const w=(0,A.$sT)(v,{offset:f,length:y-f},p);for(let g=w.length-1;g>=0;g--){const h=w[g];v=P(v,h),f=Math.min(f,h.offset),y=Math.max(y,h.offset+h.length),y+=h.content.length-h.length}const b=a.length-(v.length-y)-f;return[{offset:f,length:b,content:v.substring(f,y)}]}e.$yT=C;function P(a,$){return a.substring(0,$.offset)+$.content+a.substring($.offset+$.length)}e.$zT=P;function d(a,$){const p=$.slice(0).sort((f,y)=>{const w=f.offset-y.offset;return w===0?f.length-y.length:w});let v=a.length;for(let f=p.length-1;f>=0;f--){const y=p[f];if(y.offset+y.length<=v)a=P(a,y);else throw new Error("Overlapping edit");v=y.offset}return a}e.$AT=d}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class S{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=S}),define(ne[101],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class S{static{this.Undefined=new S(void 0)}constructor(M){this.element=M,this.next=S.Undefined,this.prev=S.Undefined}}class A{constructor(){this.a=S.Undefined,this.b=S.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===S.Undefined}clear(){let M=this.a;for(;M!==S.Undefined;){const C=M.next;M.prev=S.Undefined,M.next=S.Undefined,M=C}this.a=S.Undefined,this.b=S.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,C){const P=new S(M);if(this.a===S.Undefined)this.a=P,this.b=P;else if(C){const a=this.b;this.b=P,P.prev=a,a.next=P}else{const a=this.a;this.a=P,P.next=a,a.prev=P}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(P))}}shift(){if(this.a!==S.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==S.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==S.Undefined&&M.next!==S.Undefined){const C=M.prev;C.next=M.next,M.next.prev=C}else M.prev===S.Undefined&&M.next===S.Undefined?(this.a=S.Undefined,this.b=S.Undefined):M.next===S.Undefined?(this.b=this.b.prev,this.b.next=S.Undefined):M.prev===S.Undefined&&(this.a=this.a.next,this.a.prev=S.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==S.Undefined;)yield M.element,M=M.next}}e.$1c=A}),define(ne[31],re([0,1]),function(J,e){"use strict";var S,A,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function M(h,l,E){let u=h.get(l);return u===void 0&&(u=E,h.set(l,u)),u}e.$wc=M;function C(h){const l=[];return h.forEach((E,u)=>{l.push(`${u} => ${E}`)}),`Map(${h.size}) {${l.join(", ")}}`}e.$xc=C;function P(h){const l=[];return h.forEach(E=>{l.push(E)}),`Set(${h.size}) {${l.join(", ")}}`}e.$yc=P;class d{constructor(l,E){this.uri=l,this.value=E}}function a(h){return Array.isArray(h)}class ${static{this.a=l=>l.toString()}constructor(l,E){if(this[S]="ResourceMap",l instanceof $)this.b=new Map(l.b),this.c=E??$.a;else if(a(l)){this.b=new Map,this.c=E??$.a;for(const[u,i]of l)this.set(u,i)}else this.b=new Map,this.c=l??$.a}set(l,E){return this.b.set(this.c(l),new d(l,E)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,E){typeof E<"u"&&(l=l.bind(E));for(const[u,i]of this.b)l(i.value,i.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}e.$zc=$;class p{constructor(l,E){this[A]="ResourceSet",!l||typeof l=="function"?this.a=new $(l):(this.a=new $(E),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,E){this.a.forEach((u,i)=>l.call(E,i,i,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=p;var v;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class f{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,E=0){const u=this.a.get(l);if(u)return E!==0&&this.j(u,E),u.value}set(l,E,u=0){let i=this.a.get(l);if(i)i.value=E,u!==0&&this.j(i,u);else{switch(i={key:l,value:E,next:void 0,previous:void 0},u){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(l,i),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const E=this.a.get(l);if(E)return this.a.delete(l),this.i(E),this.d--,E.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,E){const u=this.e;let i=this.b;for(;i;){if(E?l.bind(E)(i.value,i.key,this):l(i.value,i.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const l=this,E=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const o={value:u.key,done:!1};return u=u.next,o}else return{value:void 0,done:!0}}};return i}values(){const l=this,E=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const o={value:u.value,done:!1};return u=u.next,o}else return{value:void 0,done:!0}}};return i}entries(){const l=this,E=this.e;let u=this.b;const i={[Symbol.iterator](){return i},next(){if(l.e!==E)throw new Error("LinkedMap got modified during iteration.");if(u){const o={value:[u.key,u.value],done:!1};return u=u.next,o}else return{value:void 0,done:!0}}};return i}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let E=this.b,u=this.size;for(;E&&u>l;)this.a.delete(E.key),E=E.next,u--;this.b=E,this.d=u,E&&(E.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const E=l.next,u=l.previous;if(!E||!u)throw new Error("Invalid list");E.previous=u,u.next=E}l.next=void 0,l.previous=void 0,this.e++}j(l,E){if(!this.b||!this.c)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(l===this.b)return;const u=l.next,i=l.previous;l===this.c?(i.next=void 0,this.c=i):(u.previous=i,i.next=u),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if(E===2){if(l===this.c)return;const u=l.next,i=l.previous;l===this.b?(u.previous=void 0,this.b=u):(u.previous=i,i.next=u),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach((E,u)=>{l.push([u,E])}),l}fromJSON(l){this.clear();for(const[E,u]of l)this.set(E,u)}}e.$Bc=f;class y extends f{constructor(l,E=1){super(),this.k=l,this.l=Math.min(Math.max(0,E),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,E=2){return super.get(l,E)}peek(l){return super.get(l,0)}set(l,E){return super.set(l,E,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=y;class w{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let E=this.a.get(l)||0;return E===0?!1:(E--,E===0?this.a.delete(l):this.a.set(l,E),!0)}has(l){return this.a.has(l)}}e.$Dc=w;class b{constructor(l){if(this.a=new Map,this.b=new Map,l)for(const[E,u]of l)this.set(E,u)}clear(){this.a.clear(),this.b.clear()}set(l,E){this.a.set(l,E),this.b.set(E,l)}get(l){return this.a.get(l)}getKey(l){return this.b.get(l)}delete(l){const E=this.a.get(l);return E===void 0?!1:(this.a.delete(l),this.b.delete(E),!0)}forEach(l,E){this.a.forEach((u,i)=>{l.call(E,u,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=b;class g{constructor(){this.a=new Map}add(l,E){let u=this.a.get(l);u||(u=new Set,this.a.set(l,u)),u.add(E)}delete(l,E){const u=this.a.get(l);u&&(u.delete(E),u.size===0&&this.a.delete(l))}forEach(l,E){const u=this.a.get(l);u&&u.forEach(E)}get(l){const E=this.a.get(l);return E||new Set}}e.$Fc=g}),define(ne[2],re([0,1,23,135,31,84,71]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const P=!1;let d=null;class a{constructor(){this.b=new Map}static{this.a=0}c(I){let F=this.b.get(I);return F||(F={parent:null,source:null,isSingleton:!1,value:I,idx:a.a++},this.b.set(I,F)),F}trackDisposable(I){const F=this.c(I);F.source||(F.source=new Error().stack)}setParent(I,F){const U=this.c(I);U.parent=F}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,F){const U=F.get(I);if(U)return U;const T=I.parent?this.f(this.c(I.parent),F):I;return F.set(I,T),T}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,I).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(I=10,F){let U;if(F)U=F;else{const oe=new Map,ae=[...this.b.values()].filter(K=>K.source!==null&&!this.f(K,oe).isSingleton);if(ae.length===0)return;const Z=new Set(ae.map(K=>K.value));if(U=ae.filter(K=>!(K.parent&&Z.has(K.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function T(oe){function ae(K,G){for(;K.length>0&&G.some(z=>typeof z=="string"?z===K[0]:K[0].match(z));)K.shift()}const Z=oe.source.split(`
`).map(K=>K.trim().replace("at ","")).filter(K=>K!=="");return ae(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const x=new s.$Fc;for(const oe of U){const ae=T(oe);for(let Z=0;Z<=ae.length;Z++)x.add(ae.slice(0,Z).join(`
`),oe)}U.sort((0,S.$6b)(oe=>oe.idx,S.$8b));let Y="",ce=0;for(const oe of U.slice(0,I)){ce++;const ae=T(oe),Z=[];for(let K=0;K<ae.length;K++){let G=ae[K];G=`(shared with ${x.get(ae.slice(0,K+1).join(`
`)).size}/${U.length} leaks) at ${G}`;const N=x.get(ae.slice(0,K).join(`
`)),H=(0,A.$J)([...N].map(q=>T(q)[K]),q=>q);delete H[ae[K]];for(const[q,ee]of Object.entries(H))Z.unshift(`    - stacktraces of ${ee.length} other leaks continue with ${q}`);Z.unshift(G)}Y+=`


==================== Leaking disposable ${ce}/${U.length}: ${oe.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return U.length>I&&(Y+=`


... and ${U.length-I} more leaking disposables

`),{leaks:U,details:Y}}}e.$Gc=a;function $(k){d=k}if(e.$Hc=$,P){const k="__is_disposable_tracked__";$(new class{trackDisposable(I){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[k]||console.log(F)},3e3)}setParent(I,F){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsDisposed(I){if(I&&I!==i.None)try{I[k]=!0}catch{}}markAsSingleton(I){}})}function p(k){return d?.trackDisposable(k),k}e.$Ic=p;function v(k){d?.markAsDisposed(k)}e.$Jc=v;function f(k,I){d?.setParent(k,I)}function y(k,I){if(d)for(const F of k)d.setParent(F,I)}function w(k){return d?.markAsSingleton(k),k}e.$Kc=w;function b(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Lc=b;function g(k){if(C.Iterable.is(k)){const I=[];for(const F of k)if(F)try{F.dispose()}catch(U){I.push(U)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Mc=g;function h(k){for(const I of k)b(I)&&I.dispose();return[]}e.$Nc=h;function l(...k){const I=E(()=>g(k));return y(k,I),I}e.$Oc=l;function E(k){const I=p({dispose:(0,M.$cb)(()=>{v(I),k()})});return I}e.$Pc=E;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return f(I,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),f(I,null))}}e.$Qc=u;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,p(this),f(this.q,this)}dispose(){v(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Rc=i;class o{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&f(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&f(I,null),I}}e.$Sc=o;class r{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=r;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(I){let F=I;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,v(this))},this}}e.$Uc=t;class n{constructor(){this.a=new Map}acquire(I,...F){let U=this.a.get(I);U||(U={counter:0,object:this.b(I,...F)},this.a.set(I,U));const{object:T}=U,x=(0,M.$cb)(()=>{--U.counter===0&&(this.c(I,U.object),this.a.delete(I))});return U.counter++,{object:T,dispose:x}}}e.$Vc=n;class c{constructor(I){this.a=I}async acquire(I,...F){const U=this.a.acquire(I,...F);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(T){throw U.dispose(),T}}}e.$Wc=c;class m{constructor(I){this.object=I}dispose(){}}e.$Xc=m;function D(k){const I=new u;try{k(I)}finally{I.dispose()}}e.$Yc=D;class R{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,F,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(I)?.dispose(),this.a.set(I,F)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=R}),define(ne[85],re([0,1,31]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=void 0;const A=new S.$Cc(1e4);function s(a){return d(a,"NFC",A)}e.$tl=s;const M=new S.$Cc(1e4);function C(a){return d(a,"NFD",M)}e.$ul=C;const P=/[^\u0000-\u0080]/;function d(a,$,p){if(!a)return a;const v=p.get(a);if(v)return v;let f;return P.test(a)?f=a.normalize($):f=a,p.set(a,f),f}e.$vl=function(){const a=/[\u0300-\u036f]/g;return function($){return C($).replace(a,"")}}()}),define(ne[140],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=e.rot=e.$Tl=void 0;function S(P,d,a){return Math.min(Math.max(P,d),a)}e.$Tl=S;function A(P,d){return(d+P%d)%d}e.rot=A;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Vl=s;class M{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Wl=M;class C{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const a=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Xl=C}),function(){function J(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function C(d){M.push(d,Date.now())}function P(){const d=[];for(let a=0;a<M.length;a+=2)d.push({name:M[a],startTime:M[a+1]});return d}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const C of performance.getEntriesByType("mark"))M.push({name:C.name,startTime:Math.round(s+C.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function S(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=S(A))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var A in S)(typeof exports=="object"?exports:J)[A]=S[A]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function S(A){if(e[A])return e[A].exports;var s=e[A]={i:A,l:!1,exports:{}};return J[A].call(s.exports,s,s.exports,S),s.l=!0,s.exports}return S.m=J,S.c=e,S.d=function(A,s,M){S.o(A,s)||Object.defineProperty(A,s,{enumerable:!0,get:M})},S.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},S.t=function(A,s){if(1&s&&(A=S(A)),8&s||4&s&&typeof A=="object"&&A&&A.__esModule)return A;var M=Object.create(null);if(S.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:A}),2&s&&typeof A!="string")for(var C in A)S.d(M,C,function(P){return A[P]}.bind(null,C));return M},S.n=function(A){var s=A&&A.__esModule?function(){return A.default}:function(){return A};return S.d(s,"a",s),s},S.o=function(A,s){return Object.prototype.hasOwnProperty.call(A,s)},S.p="",S(S.s=0)}([function(J,e,S){(function(A){var s;e=J.exports=se,s=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],d=e.src=[],a=0,$=a++;d[$]="0|[1-9]\\d*";var p=a++;d[p]="[0-9]+";var v=a++;d[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=a++;d[f]="("+d[$]+")\\.("+d[$]+")\\.("+d[$]+")";var y=a++;d[y]="("+d[p]+")\\.("+d[p]+")\\.("+d[p]+")";var w=a++;d[w]="(?:"+d[$]+"|"+d[v]+")";var b=a++;d[b]="(?:"+d[p]+"|"+d[v]+")";var g=a++;d[g]="(?:-("+d[w]+"(?:\\."+d[w]+")*))";var h=a++;d[h]="(?:-?("+d[b]+"(?:\\."+d[b]+")*))";var l=a++;d[l]="[0-9A-Za-z-]+";var E=a++;d[E]="(?:\\+("+d[l]+"(?:\\."+d[l]+")*))";var u=a++,i="v?"+d[f]+d[g]+"?"+d[E]+"?";d[u]="^"+i+"$";var o="[v=\\s]*"+d[y]+d[h]+"?"+d[E]+"?",r=a++;d[r]="^"+o+"$";var t=a++;d[t]="((?:<|>)?=?)";var n=a++;d[n]=d[p]+"|x|X|\\*";var c=a++;d[c]=d[$]+"|x|X|\\*";var m=a++;d[m]="[v=\\s]*("+d[c]+")(?:\\.("+d[c]+")(?:\\.("+d[c]+")(?:"+d[g]+")?"+d[E]+"?)?)?";var D=a++;d[D]="[v=\\s]*("+d[n]+")(?:\\.("+d[n]+")(?:\\.("+d[n]+")(?:"+d[h]+")?"+d[E]+"?)?)?";var R=a++;d[R]="^"+d[t]+"\\s*"+d[m]+"$";var k=a++;d[k]="^"+d[t]+"\\s*"+d[D]+"$";var I=a++;d[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=a++;d[F]="(?:~>?)";var U=a++;d[U]="(\\s*)"+d[F]+"\\s+",P[U]=new RegExp(d[U],"g");var T=a++;d[T]="^"+d[F]+d[m]+"$";var x=a++;d[x]="^"+d[F]+d[D]+"$";var Y=a++;d[Y]="(?:\\^)";var ce=a++;d[ce]="(\\s*)"+d[Y]+"\\s+",P[ce]=new RegExp(d[ce],"g");var oe=a++;d[oe]="^"+d[Y]+d[m]+"$";var ae=a++;d[ae]="^"+d[Y]+d[D]+"$";var Z=a++;d[Z]="^"+d[t]+"\\s*("+o+")$|^$";var K=a++;d[K]="^"+d[t]+"\\s*("+i+")$|^$";var G=a++;d[G]="(\\s*)"+d[t]+"\\s*("+o+"|"+d[m]+")",P[G]=new RegExp(d[G],"g");var z=a++;d[z]="^\\s*("+d[m]+")\\s+-\\s+("+d[m]+")\\s*$";var N=a++;d[N]="^\\s*("+d[D]+")\\s+-\\s+("+d[D]+")\\s*$";var H=a++;d[H]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)s(q,d[q]),P[q]||(P[q]=new RegExp(d[q]));function ee(_,ue){if(_ instanceof se)return _;if(typeof _!="string"||_.length>M||!(ue?P[r]:P[u]).test(_))return null;try{return new se(_,ue)}catch{return null}}function se(_,ue){if(_ instanceof se){if(_.loose===ue)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof se))return new se(_,ue);s("SemVer",_,ue),this.loose=ue;var ge=_.trim().match(ue?P[r]:P[u]);if(!ge)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var De=+Re;if(De>=0&&De<C)return De}return Re}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=ee,e.valid=function(_,ue){var ge=ee(_,ue);return ge?ge.version:null},e.clean=function(_,ue){var ge=ee(_.trim().replace(/^[=v]+/,""),ue);return ge?ge.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(_){return s("SemVer.compare",this.version,this.loose,_),_ instanceof se||(_=new se(_,this.loose)),this.compareMain(_)||this.comparePre(_)},se.prototype.compareMain=function(_){return _ instanceof se||(_=new se(_,this.loose)),O(this.major,_.major)||O(this.minor,_.minor)||O(this.patch,_.patch)},se.prototype.comparePre=function(_){if(_ instanceof se||(_=new se(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var ue=0;do{var ge=this.prerelease[ue],Re=_.prerelease[ue];if(s("prerelease compare",ue,ge,Re),ge===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(ge===void 0)return-1;if(ge!==Re)return O(ge,Re)}while(++ue)},se.prototype.inc=function(_,ue){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,ue,ge,Re){typeof ge=="string"&&(Re=ge,ge=void 0);try{return new se(_,ge).inc(ue,Re).version}catch{return null}},e.diff=function(_,ue){if(B(_,ue))return null;var ge=ee(_),Re=ee(ue);if(ge.prerelease.length||Re.prerelease.length){for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Re[De])return"pre"+De;return"prerelease"}for(var De in ge)if((De==="major"||De==="minor"||De==="patch")&&ge[De]!==Re[De])return De},e.compareIdentifiers=O;var Q=/^[0-9]+$/;function O(_,ue){var ge=Q.test(_),Re=Q.test(ue);return ge&&Re&&(_=+_,ue=+ue),ge&&!Re?-1:Re&&!ge?1:_<ue?-1:_>ue?1:0}function j(_,ue,ge){return new se(_,ge).compare(new se(ue,ge))}function V(_,ue,ge){return j(_,ue,ge)>0}function L(_,ue,ge){return j(_,ue,ge)<0}function B(_,ue,ge){return j(_,ue,ge)===0}function W(_,ue,ge){return j(_,ue,ge)!==0}function X(_,ue,ge){return j(_,ue,ge)>=0}function he(_,ue,ge){return j(_,ue,ge)<=0}function de(_,ue,ge,Re){var De;switch(ue){case"===":typeof _=="object"&&(_=_.version),typeof ge=="object"&&(ge=ge.version),De=_===ge;break;case"!==":typeof _=="object"&&(_=_.version),typeof ge=="object"&&(ge=ge.version),De=_!==ge;break;case"":case"=":case"==":De=B(_,ge,Re);break;case"!=":De=W(_,ge,Re);break;case">":De=V(_,ge,Re);break;case">=":De=X(_,ge,Re);break;case"<":De=L(_,ge,Re);break;case"<=":De=he(_,ge,Re);break;default:throw new TypeError("Invalid operator: "+ue)}return De}function le(_,ue){if(_ instanceof le){if(_.loose===ue)return _;_=_.value}if(!(this instanceof le))return new le(_,ue);s("comparator",_,ue),this.loose=ue,this.parse(_),this.semver===we?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(_,ue){return O(ue,_)},e.major=function(_,ue){return new se(_,ue).major},e.minor=function(_,ue){return new se(_,ue).minor},e.patch=function(_,ue){return new se(_,ue).patch},e.compare=j,e.compareLoose=function(_,ue){return j(_,ue,!0)},e.rcompare=function(_,ue,ge){return j(ue,_,ge)},e.sort=function(_,ue){return _.sort(function(ge,Re){return e.compare(ge,Re,ue)})},e.rsort=function(_,ue){return _.sort(function(ge,Re){return e.rcompare(ge,Re,ue)})},e.gt=V,e.lt=L,e.eq=B,e.neq=W,e.gte=X,e.lte=he,e.cmp=de,e.Comparator=le;var we={};function be(_,ue){if(_ instanceof be)return _.loose===ue?_:new be(_.raw,ue);if(_ instanceof le)return new be(_.value,ue);if(!(this instanceof be))return new be(_,ue);if(this.loose=ue,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Ee(_){return!_||_.toLowerCase()==="x"||_==="*"}function Se(_,ue,ge,Re,De,Ue,Me,Ve,ze,ie,fe,me,ye){return((ue=Ee(ge)?"":Ee(Re)?">="+ge+".0.0":Ee(De)?">="+ge+"."+Re+".0":">="+ue)+" "+(Ve=Ee(ze)?"":Ee(ie)?"<"+(+ze+1)+".0.0":Ee(fe)?"<"+ze+"."+(+ie+1)+".0":me?"<="+ze+"."+ie+"."+fe+"-"+me:"<="+Ve)).trim()}function Le(_,ue){for(var ge=0;ge<_.length;ge++)if(!_[ge].test(ue))return!1;if(ue.prerelease.length){for(ge=0;ge<_.length;ge++)if(s(_[ge].semver),_[ge].semver!==we&&_[ge].semver.prerelease.length>0){var Re=_[ge].semver;if(Re.major===ue.major&&Re.minor===ue.minor&&Re.patch===ue.patch)return!0}return!1}return!0}function ke(_,ue,ge){try{ue=new be(ue,ge)}catch{return!1}return ue.test(_)}function pe(_,ue,ge,Re){var De,Ue,Me,Ve,ze;switch(_=new se(_,Re),ue=new be(ue,Re),ge){case">":De=V,Ue=he,Me=L,Ve=">",ze=">=";break;case"<":De=L,Ue=X,Me=V,Ve="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(_,ue,Re))return!1;for(var ie=0;ie<ue.set.length;++ie){var fe=ue.set[ie],me=null,ye=null;if(fe.forEach(function(Ce){Ce.semver===we&&(Ce=new le(">=0.0.0")),me=me||Ce,ye=ye||Ce,De(Ce.semver,me.semver,Re)?me=Ce:Me(Ce.semver,ye.semver,Re)&&(ye=Ce)}),me.operator===Ve||me.operator===ze||(!ye.operator||ye.operator===Ve)&&Ue(_,ye.semver)||ye.operator===ze&&Me(_,ye.semver))return!1}return!0}le.prototype.parse=function(_){var ue=this.loose?P[Z]:P[K],ge=_.match(ue);if(!ge)throw new TypeError("Invalid comparator: "+_);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new se(ge[2],this.loose):this.semver=we},le.prototype.toString=function(){return this.value},le.prototype.test=function(_){return s("Comparator.test",_,this.loose),this.semver===we||(typeof _=="string"&&(_=new se(_,this.loose)),de(_,this.operator,this.semver,this.loose))},le.prototype.intersects=function(_,ue){if(!(_ instanceof le))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(_.value,ue),ke(this.value,ge,ue);if(_.operator==="")return ge=new be(this.value,ue),ke(_.semver,ge,ue);var Re=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Ue=this.semver.version===_.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),Ve=de(this.semver,"<",_.semver,ue)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),ze=de(this.semver,">",_.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return Re||De||Ue&&Me||Ve||ze},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(_){var ue=this.loose;_=_.trim(),s("range",_,ue);var ge=ue?P[N]:P[z];_=_.replace(ge,Se),s("hyphen replace",_),_=_.replace(P[G],"$1$2$3"),s("comparator trim",_,P[G]),_=(_=(_=_.replace(P[U],"$1~")).replace(P[ce],"$1^")).split(/\s+/).join(" ");var Re=ue?P[Z]:P[K],De=_.split(" ").map(function(Ue){return function(Me,Ve){return s("comp",Me),Me=function(ze,ie){return ze.trim().split(/\s+/).map(function(fe){return function(me,ye){s("caret",me,ye);var Ce=ye?P[ae]:P[oe];return me.replace(Ce,function(je,Fe,Te,qe,Ge){var Qe;return s("caret",me,je,Fe,Te,qe,Ge),Ee(Fe)?Qe="":Ee(Te)?Qe=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":Ee(qe)?Qe=Fe==="0"?">="+Fe+"."+Te+".0 <"+Fe+"."+(+Te+1)+".0":">="+Fe+"."+Te+".0 <"+(+Fe+1)+".0.0":Ge?(s("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Qe=Fe==="0"?Te==="0"?">="+Fe+"."+Te+"."+qe+Ge+" <"+Fe+"."+Te+"."+(+qe+1):">="+Fe+"."+Te+"."+qe+Ge+" <"+Fe+"."+(+Te+1)+".0":">="+Fe+"."+Te+"."+qe+Ge+" <"+(+Fe+1)+".0.0"):(s("no pr"),Qe=Fe==="0"?Te==="0"?">="+Fe+"."+Te+"."+qe+" <"+Fe+"."+Te+"."+(+qe+1):">="+Fe+"."+Te+"."+qe+" <"+Fe+"."+(+Te+1)+".0":">="+Fe+"."+Te+"."+qe+" <"+(+Fe+1)+".0.0"),s("caret return",Qe),Qe})}(fe,ie)}).join(" ")}(Me,Ve),s("caret",Me),Me=function(ze,ie){return ze.trim().split(/\s+/).map(function(fe){return function(me,ye){var Ce=ye?P[x]:P[T];return me.replace(Ce,function(je,Fe,Te,qe,Ge){var Qe;return s("tilde",me,je,Fe,Te,qe,Ge),Ee(Fe)?Qe="":Ee(Te)?Qe=">="+Fe+".0.0 <"+(+Fe+1)+".0.0":Ee(qe)?Qe=">="+Fe+"."+Te+".0 <"+Fe+"."+(+Te+1)+".0":Ge?(s("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Qe=">="+Fe+"."+Te+"."+qe+Ge+" <"+Fe+"."+(+Te+1)+".0"):Qe=">="+Fe+"."+Te+"."+qe+" <"+Fe+"."+(+Te+1)+".0",s("tilde return",Qe),Qe})}(fe,ie)}).join(" ")}(Me,Ve),s("tildes",Me),Me=function(ze,ie){return s("replaceXRanges",ze,ie),ze.split(/\s+/).map(function(fe){return function(me,ye){me=me.trim();var Ce=ye?P[k]:P[R];return me.replace(Ce,function(je,Fe,Te,qe,Ge,Qe){s("xRange",me,je,Fe,Te,qe,Ge,Qe);var _e=Ee(Te),Xe=_e||Ee(qe),it=Xe||Ee(Ge);return Fe==="="&&it&&(Fe=""),_e?je=Fe===">"||Fe==="<"?"<0.0.0":"*":Fe&&it?(Xe&&(qe=0),it&&(Ge=0),Fe===">"?(Fe=">=",Xe?(Te=+Te+1,qe=0,Ge=0):it&&(qe=+qe+1,Ge=0)):Fe==="<="&&(Fe="<",Xe?Te=+Te+1:qe=+qe+1),je=Fe+Te+"."+qe+"."+Ge):Xe?je=">="+Te+".0.0 <"+(+Te+1)+".0.0":it&&(je=">="+Te+"."+qe+".0 <"+Te+"."+(+qe+1)+".0"),s("xRange return",je),je})}(fe,ie)}).join(" ")}(Me,Ve),s("xrange",Me),Me=function(ze,ie){return s("replaceStars",ze,ie),ze.trim().replace(P[H],"")}(Me,Ve),s("stars",Me),Me}(Ue,ue)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Ue){return!!Ue.match(Re)})),De=De.map(function(Ue){return new le(Ue,ue)})},be.prototype.intersects=function(_,ue){if(!(_ instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Re){return _.set.some(function(De){return De.every(function(Ue){return Re.intersects(Ue,ue)})})})})},e.toComparators=function(_,ue){return new be(_,ue).set.map(function(ge){return ge.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},be.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new se(_,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Le(this.set[ue],_))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(_,ue,ge){var Re=null,De=null;try{var Ue=new be(ue,ge)}catch{return null}return _.forEach(function(Me){Ue.test(Me)&&(Re&&De.compare(Me)!==-1||(De=new se(Re=Me,ge)))}),Re},e.minSatisfying=function(_,ue,ge){var Re=null,De=null;try{var Ue=new be(ue,ge)}catch{return null}return _.forEach(function(Me){Ue.test(Me)&&(Re&&De.compare(Me)!==1||(De=new se(Re=Me,ge)))}),Re},e.validRange=function(_,ue){try{return new be(_,ue).range||"*"}catch{return null}},e.ltr=function(_,ue,ge){return pe(_,ue,"<",ge)},e.gtr=function(_,ue,ge){return pe(_,ue,">",ge)},e.outside=pe,e.prerelease=function(_,ue){var ge=ee(_,ue);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(_,ue,ge){return _=new be(_,ge),ue=new be(ue,ge),_.intersects(ue)},e.coerce=function(_){if(_ instanceof se)return _;if(typeof _!="string")return null;var ue=_.match(P[I]);return ue==null?null:ee((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,S(1))},function(J,e){var S,A,s=J.exports={};function M(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(b){if(S===setTimeout)return setTimeout(b,0);if((S===M||!S)&&setTimeout)return S=setTimeout,setTimeout(b,0);try{return S(b,0)}catch{try{return S.call(null,b,0)}catch{return S.call(this,b,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:M}catch{S=M}try{A=typeof clearTimeout=="function"?clearTimeout:C}catch{A=C}})();var d,a=[],$=!1,p=-1;function v(){$&&d&&($=!1,d.length?a=d.concat(a):p=-1,a.length&&f())}function f(){if(!$){var b=P(v);$=!0;for(var g=a.length;g;){for(d=a,a=[];++p<g;)d&&d[p].run();p=-1,g=a.length}d=null,$=!1,function(h){if(A===clearTimeout)return clearTimeout(h);if((A===C||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(h);try{A(h)}catch{try{return A.call(null,h)}catch{return A.call(this,h)}}}(b)}}function y(b,g){this.fun=b,this.array=g}function w(){}s.nextTick=function(b){var g=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)g[h-1]=arguments[h];a.push(new y(b,g)),a.length!==1||$||P(f)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=w,s.addListener=w,s.once=w,s.off=w,s.removeListener=w,s.removeAllListeners=w,s.emit=w,s.prependListener=w,s.prependOnceListener=w,s.listeners=function(b){return[]},s.binding=function(b){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(b){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(ne[141],re([0,1]),function(J,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;class A{constructor(P,d,a){this.level=P,this.key=d,this.value=a,this.forward=[]}}const s=void 0;class M{constructor(P,d=2**16){this.comparator=P,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(d)|0),this.e=new A(this.c,s,s)}get size(){return this.f}clear(){this.e=new A(this.c,s,s),this.f=0}has(P){return!!M.g(this,P,this.comparator)}get(P){return M.g(this,P,this.comparator)?.value}set(P,d){return M.h(this,P,d,this.comparator)&&(this.f+=1),this}delete(P){const d=M.k(this,P,this.comparator);return d&&(this.f-=1),d}forEach(P,d){let a=this.e.forward[0];for(;a;)P.call(d,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",d=this.e.forward[0];for(;d;)P+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return P}static g(P,d,a){let $=P.e;for(let p=P.d-1;p>=0;p--)for(;$.forward[p]&&a($.forward[p].key,d)<0;)$=$.forward[p];if($=$.forward[0],$&&a($.key,d)===0)return $}static h(P,d,a,$){const p=[];let v=P.e;for(let f=P.d-1;f>=0;f--){for(;v.forward[f]&&$(v.forward[f].key,d)<0;)v=v.forward[f];p[f]=v}if(v=v.forward[0],v&&$(v.key,d)===0)return v.value=a,!1;{const f=M.j(P);if(f>P.d){for(let y=P.d;y<f;y++)p[y]=P.e;P.d=f}v=new A(f,d,a);for(let y=0;y<f;y++)v.forward[y]=p[y].forward[y],p[y].forward[y]=v;return!0}}static j(P,d=.5){let a=1;for(;Math.random()<d&&a<P.c;)a+=1;return a}static k(P,d,a){const $=[];let p=P.e;for(let v=P.d-1;v>=0;v--){for(;p.forward[v]&&a(p.forward[v].key,d)<0;)p=p.forward[v];$[v]=p}if(p=p.forward[0],!p||a(p.key,d)!==0)return!1;for(let v=0;v<P.d&&$[v].forward[v]===p;v++)$[v].forward[v]=p.forward[v];for(;P.d>0&&P.e.forward[P.d-1]===s;)P.d-=1;return!0}}e.$Er=M}),define(ne[73],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=void 0;const S=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(M){return new A(M)}constructor(M){this.c=S&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Md=A}),define(ne[3],re([0,1,14,84,2,101,73]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.Event=void 0;const P=!1,d=!1;var a;(function(R){R.None=()=>s.$Rc.None;function k(de){if(d){const{onDidAddListener:le}=de,we=y.create();let be=0;de.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),we.print()),le?.()}}}function I(de,le){return K(de,()=>{},0,void 0,!0,void 0,le)}R.defer=I;function F(de){return(le,we=null,be)=>{let Ee=!1,Se;return Se=de(Le=>{if(!Ee)return Se?Se.dispose():Ee=!0,le.call(we,Le)},null,be),Ee&&Se.dispose(),Se}}R.once=F;function U(de,le,we){return ae((be,Ee=null,Se)=>de(Le=>be.call(Ee,le(Le)),null,Se),we)}R.map=U;function T(de,le,we){return ae((be,Ee=null,Se)=>de(Le=>{le(Le),be.call(Ee,Le)},null,Se),we)}R.forEach=T;function x(de,le,we){return ae((be,Ee=null,Se)=>de(Le=>le(Le)&&be.call(Ee,Le),null,Se),we)}R.filter=x;function Y(de){return de}R.signal=Y;function ce(...de){return(le,we=null,be)=>{const Ee=(0,s.$Oc)(...de.map(Se=>Se(Le=>le.call(we,Le))));return Z(Ee,be)}}R.any=ce;function oe(de,le,we,be){let Ee=we;return U(de,Se=>(Ee=le(Ee,Se),Ee),be)}R.reduce=oe;function ae(de,le){let we;const be={onWillAddFirstListener(){we=de(Ee.fire,Ee)},onDidRemoveLastListener(){we?.dispose()}};le||k(be);const Ee=new l(be);return le?.add(Ee),Ee.event}function Z(de,le){return le instanceof Array?le.push(de):le&&le.add(de),de}function K(de,le,we=100,be=!1,Ee=!1,Se,Le){let ke,pe,_,ue=0,ge;const Re={leakWarningThreshold:Se,onWillAddFirstListener(){ke=de(Ue=>{ue++,pe=le(pe,Ue),be&&!_&&(De.fire(pe),pe=void 0),ge=()=>{const Me=pe;pe=void 0,_=void 0,(!be||ue>1)&&De.fire(Me),ue=0},typeof we=="number"?(clearTimeout(_),_=setTimeout(ge,we)):_===void 0&&(_=0,queueMicrotask(ge))})},onWillRemoveListener(){Ee&&ue>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,ke.dispose()}};Le||k(Re);const De=new l(Re);return Le?.add(De),De.event}R.debounce=K;function G(de,le=0,we){return R.debounce(de,(be,Ee)=>be?(be.push(Ee),be):[Ee],le,void 0,!0,void 0,we)}R.accumulate=G;function z(de,le=(be,Ee)=>be===Ee,we){let be=!0,Ee;return x(de,Se=>{const Le=be||!le(Se,Ee);return be=!1,Ee=Se,Le},we)}R.latch=z;function N(de,le,we){return[R.filter(de,le,we),R.filter(de,be=>!le(be),we)]}R.split=N;function H(de,le=!1,we=[],be){let Ee=we.slice(),Se=de(pe=>{Ee?Ee.push(pe):ke.fire(pe)});be&&be.add(Se);const Le=()=>{Ee?.forEach(pe=>ke.fire(pe)),Ee=null},ke=new l({onWillAddFirstListener(){Se||(Se=de(pe=>ke.fire(pe)),be&&be.add(Se))},onDidAddFirstListener(){Ee&&(le?setTimeout(Le):Le())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return be&&be.add(ke),ke.event}R.buffer=H;function q(de,le){return(be,Ee,Se)=>{const Le=le(new se);return de(function(ke){const pe=Le.evaluate(ke);pe!==ee&&be.call(Ee,pe)},void 0,Se)}}R.chain=q;const ee=Symbol("HaltChainable");class se{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push(we=>(le(we),we)),this}filter(le){return this.f.push(we=>le(we)?we:ee),this}reduce(le,we){let be=we;return this.f.push(Ee=>(be=le(be,Ee),be)),this}latch(le=(we,be)=>we===be){let we=!0,be;return this.f.push(Ee=>{const Se=we||!le(Ee,be);return we=!1,be=Ee,Se?Ee:ee}),this}evaluate(le){for(const we of this.f)if(le=we(le),le===ee)break;return le}}function Q(de,le,we=be=>be){const be=(...ke)=>Le.fire(we(...ke)),Ee=()=>de.on(le,be),Se=()=>de.removeListener(le,be),Le=new l({onWillAddFirstListener:Ee,onDidRemoveLastListener:Se});return Le.event}R.fromNodeEventEmitter=Q;function O(de,le,we=be=>be){const be=(...ke)=>Le.fire(we(...ke)),Ee=()=>de.addEventListener(le,be),Se=()=>de.removeEventListener(le,be),Le=new l({onWillAddFirstListener:Ee,onDidRemoveLastListener:Se});return Le.event}R.fromDOMEventEmitter=O;function j(de){return new Promise(le=>F(de)(le))}R.toPromise=j;function V(de){const le=new l;return de.then(we=>{le.fire(we)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}R.fromPromise=V;function L(de,le,we){return le(we),de(be=>le(be))}R.runAndSubscribe=L;function B(de,le){let we=null;function be(Se){we?.dispose(),we=new s.$Qc,le(Se,we)}be(void 0);const Ee=de(Se=>be(Se));return(0,s.$Pc)(()=>{Ee.dispose(),we?.dispose()})}R.runAndSubscribeWithStore=B;class W{constructor(le,we){this._observable=le,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};we||k(be),this.emitter=new l(be),we&&we.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,we){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function X(de,le){return new W(de,le).emitter.event}R.fromObservable=X;function he(de){return le=>{let we=0,be=!1;const Ee={beginUpdate(){we++},endUpdate(){we--,we===0&&(de.reportChanges(),be&&(be=!1,le()))},handlePossibleChange(){},handleChange(){be=!0}};return de.addObserver(Ee),de.reportChanges(),{dispose(){de.removeObserver(Ee)}}}}R.fromObservableLight=he})(a||(e.Event=a={}));class ${static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${$.f++}`,$.all.add(this)}start(k){this.g=new C.$Md,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Od=$;let p=-1;function v(R){const k=p;return p=R,{dispose(){p=k}}}e.$Pd=v;class f{constructor(k,I=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=I,this.g=0}dispose(){this.f?.clear()}check(k,I){const F=this.threshold;if(F<=0||I<F)return;this.f||(this.f=new Map);const U=this.f.get(k.value)||0;if(this.f.set(k.value,U+1),this.g-=1,this.g<=0){this.g=F*.5;let T,x=0;for(const[Y,ce]of this.f)(!T||x<ce)&&(T=Y,x=ce);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${x}):`),console.warn(T)}return()=>{const T=this.f.get(k.value)||0;this.f.set(k.value,T-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class b{constructor(k){this.value=k,this.id=w++}}const g=2,h=(R,k)=>{if(R instanceof b)k(R);else for(let I=0;I<R.length;I++){const F=R[I];F&&k(F)}};class l{constructor(k){this.w=0,this.f=k,this.g=p>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const k=this.t;queueMicrotask(()=>{h(k,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,I,F)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Rc.None;if(this.m)return s.$Rc.None;I&&(k=k.bind(I));const U=new b(k);let T,x;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(U.stack=y.create(),T=this.g.check(U.stack,this.w+1)),P&&(U.stack=x??y.create()),this.t?this.t instanceof b?(this.u??=new u,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.w++;const Y=(0,s.$Pc)(()=>{T?.(),this.x(U)});return F instanceof s.$Qc?F.add(Y):Array.isArray(F)&&F.push(Y),Y},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,F=I.indexOf(k);if(F===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[F]=void 0;const U=this.u.current===this;if(this.w*g<=I.length){let T=0;for(let x=0;x<I.length;x++)I[x]?I[T++]=I[x]:U&&(this.u.end--,T<this.u.i&&this.u.i--);I.length=T}}y(k,I){if(!k)return;const F=this.f?.onListenerError||S.$Z;if(!F){k.value(I);return}try{k.value(I)}catch(U){F(U)}}z(k){const I=k.current.t;for(;k.i<k.end;)this.y(I[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,k);else{const I=this.u;I.enqueue(this,k,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Qd=l;const E=()=>new u;e.$Rd=E;class u{constructor(){this.i=-1,this.end=0}enqueue(k,I,F){this.i=0,this.end=F,this.current=k,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends l{async fireAsync(k,I,F){if(this.t)for(this.h||(this.h=new M.$1c),h(this.t,U=>this.h.push([U.value,k]));this.h.size>0&&!I.isCancellationRequested;){const[U,T]=this.h.shift(),x=[],Y={...T,token:I,waitUntil:ce=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");F&&(ce=F(ce,U)),x.push(ce)}};try{U(Y)}catch(ce){(0,S.$Z)(ce);continue}Object.freeze(x),await Promise.allSettled(x).then(ce=>{for(const oe of ce)oe.status==="rejected"&&(0,S.$Z)(oe.reason)})}}}e.$Sd=i;class o extends l{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new M.$1c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Td=o;class r extends o{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Ud=r;class t extends l{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}e.$Vd=t;class n{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const I={event:k,listener:null};this.h.push(I),this.g&&this.m(I);const F=()=>{this.g&&this.o(I);const U=this.h.indexOf(I);this.h.splice(U,1)};return(0,s.$Pc)((0,A.$cb)(F))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(I=>this.f.fire(I))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Wd=n;class c{constructor(k,I,F,U){this.f=new s.$Qc;const T=this.f.add(new n),x=this.f.add(new s.$Zc);function Y(ce){x.set(ce,T.add(U(ce)))}for(const ce of k)Y(ce);this.f.add(I(ce=>{Y(ce)})),this.f.add(F(ce=>{x.deleteAndDispose(ce)})),this.event=T.event}dispose(){this.f.dispose()}}e.$Xd=c;class m{constructor(){this.f=[]}wrapEvent(k){return(I,F,U)=>k(T=>{const x=this.f[this.f.length-1];x?x.push(()=>I.call(F,T)):I.call(F,T)},void 0,U)}bufferEvents(k){const I=[];this.f.push(I);const F=k();return this.f.pop(),I.forEach(U=>U()),F}}e.$Yd=m;class D{constructor(){this.f=!1,this.g=a.None,this.h=s.$Rc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Zd=D}),define(ne[22],re([0,1,3]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.CancellationToken=void 0;const A=Object.freeze(function(P,d){const a=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(a)}}});var s;(function(P){function d(a){return a===P.None||a===P.Cancelled||a instanceof M?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:S.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new S.$Qd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(d){this.f=void 0,this.g=void 0,this.g=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(d=!1){d&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$1d=C}),define(ne[142],re([0,1,22]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.$ze=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new S.$1d,d=this.b(P.token);return this.a={promise:d,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$ze=A;class s{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const d=JSON.stringify(P);return this.b!==d&&(this.b=d,this.a=this.c(P)),this.a}}e.$Ae=s;class M{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const d=this.b(P);return this.a.set(P,d),d}}e.$Be=M}),define(ne[62],re([0,1,14,2]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=void 0;function s(E){const u=E;return u?typeof u.read=="function":!1}e.$2d=s;function M(E){const u=E;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}e.$3d=M;function C(E){const u=E;return u?M(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$4d=C;function P(E,u){return new d(E,u)}e.$5d=P;class d{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,S.$Z)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let o;switch(u){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(i);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(E,u){const i=[];let o;for(;(o=E.read())!==null;)i.push(o);return u(i)}e.$6d=a;function $(E,u,i){const o=[];let r;for(;(r=E.read())!==null&&o.length<i;)o.push(r);return r===null&&o.length>0?u(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return E.read()}}}e.$7d=$;function p(E,u){return new Promise((i,o)=>{const r=[];v(E,{onData:t=>{u&&r.push(t)},onError:t=>{u?o(t):i(void 0)},onEnd:()=>{i(u?u(r):void 0)}})})}e.$8d=p;function v(E,u,i){E.on("error",o=>{i?.isCancellationRequested||u.onError(o)}),E.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),E.on("data",o=>{i?.isCancellationRequested||u.onData(o)})}e.$9d=v;function f(E,u){return new Promise((i,o)=>{const r=new A.$Qc,t=[],n=D=>{if(t.push(D),t.length>u)return r.dispose(),E.pause(),i({stream:E,buffer:t,ended:!1})},c=D=>(r.dispose(),o(D)),m=()=>(r.dispose(),i({stream:E,buffer:t,ended:!0}));r.add((0,A.$Pc)(()=>E.removeListener("error",c))),E.on("error",c),r.add((0,A.$Pc)(()=>E.removeListener("end",m))),E.on("end",m),r.add((0,A.$Pc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$0d=f;function y(E,u){const i=P(u);return i.end(E),i}e.$$d=y;function w(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}e.$_d=w;function b(E){let u=!1;return{read:()=>u?null:(u=!0,E)}}e.$ae=b;function g(E,u,i){const o=P(i);return v(E,{onData:r=>o.write(u.data(r)),onError:r=>o.error(u.error?u.error(r):r),onEnd:()=>o.end()}),o}e.$be=g;function h(E,u,i){let o=!1;return{read:()=>{const r=u.read();return o?r:(o=!0,r!==null?i([E,r]):E)}}}e.$ce=h;function l(E,u,i){let o=!1;const r=P(i);return v(u,{onData:t=>o?r.write(t):(o=!0,r.write(i([E,t]))),onError:t=>r.error(t),onEnd:()=>{o||(o=!0,r.write(E)),r.end()}}),r}e.$de=l}),define(ne[18],re([0,1,72,62]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;const s=typeof Buffer<"u",M=new S.$U(()=>new Uint8Array(256));let C,P;class d{static alloc(I){return s?new d(Buffer.allocUnsafe(I)):new d(new Uint8Array(I))}static wrap(I){return s&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new d(I)}static fromString(I,F){return!(F?.dontUseNodeBuffer||!1)&&s?new d(Buffer.from(I)):(C||(C=new TextEncoder),new d(C.encode(I)))}static fromByteArray(I){const F=d.alloc(I.length);for(let U=0,T=I.length;U<T;U++)F.buffer[U]=I[U];return F}static concat(I,F){if(typeof F>"u"){F=0;for(let x=0,Y=I.length;x<Y;x++)F+=I[x].byteLength}const U=d.alloc(F);let T=0;for(let x=0,Y=I.length;x<Y;x++){const ce=I[x];U.set(ce,T),T+=ce.byteLength}return U}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=d.alloc(this.byteLength);return I.set(this),I}toString(){return s?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(I,F){return new d(this.buffer.subarray(I,F))}set(I,F){if(I instanceof d)this.buffer.set(I.buffer,F);else if(I instanceof Uint8Array)this.buffer.set(I,F);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),F);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return v(this.buffer,I)}writeUInt32BE(I,F){f(this.buffer,I,F)}readUInt32LE(I){return y(this.buffer,I)}writeUInt32LE(I,F){w(this.buffer,I,F)}readUInt8(I){return b(this.buffer,I)}writeUInt8(I,F){g(this.buffer,I,F)}indexOf(I,F=0){return a(this.buffer,I instanceof d?I.buffer:I,F)}}e.$ee=d;function a(k,I,F=0){const U=I.byteLength,T=k.byteLength;if(U===0)return 0;if(U===1)return k.indexOf(I[0]);if(U>T-F)return-1;const x=M.value;x.fill(I.length);for(let ae=0;ae<I.length;ae++)x[I[ae]]=I.length-ae-1;let Y=F+I.length-1,ce=Y,oe=-1;for(;Y<T;)if(k[Y]===I[ce]){if(ce===0){oe=Y;break}Y--,ce--}else Y+=Math.max(I.length-ce,x[k[Y]]),ce=I.length-1;return oe}e.$fe=a;function $(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0}e.$ge=$;function p(k,I,F){k[F+0]=I&255,I=I>>>8,k[F+1]=I&255}e.$he=p;function v(k,I){return k[I]*2**24+k[I+1]*2**16+k[I+2]*2**8+k[I+3]}e.$ie=v;function f(k,I,F){k[F+3]=I,I=I>>>8,k[F+2]=I,I=I>>>8,k[F+1]=I,I=I>>>8,k[F]=I}e.$je=f;function y(k,I){return k[I+0]<<0>>>0|k[I+1]<<8>>>0|k[I+2]<<16>>>0|k[I+3]<<24>>>0}e.$ke=y;function w(k,I,F){k[F+0]=I&255,I=I>>>8,k[F+1]=I&255,I=I>>>8,k[F+2]=I&255,I=I>>>8,k[F+3]=I&255}e.$le=w;function b(k,I){return k[I]}e.$me=b;function g(k,I,F){k[F]=I}e.$ne=g;function h(k){return A.$6d(k,I=>d.concat(I))}e.$oe=h;function l(k){return A.$ae(k)}e.$pe=l;function E(k){return A.$8d(k,I=>d.concat(I))}e.$qe=E;async function u(k){return k.ended?d.concat(k.buffer):d.concat([...k.buffer,await E(k.stream)])}e.$re=u;function i(k){return A.$$d(k,I=>d.concat(I))}e.$se=i;function o(k){return A.$be(k,{data:I=>typeof I=="string"?d.fromString(I):d.wrap(I)},I=>d.concat(I))}e.$te=o;function r(k){return A.$5d(I=>d.concat(I),k)}e.$ue=r;function t(k,I){return A.$ce(k,I,F=>d.concat(F))}e.$ve=t;function n(k,I){return A.$de(k,I,F=>d.concat(F))}e.$we=n;function c(k){let I=0,F=0,U=0;const T=new Uint8Array(Math.floor(k.length/4*3)),x=ce=>{switch(F){case 3:T[U++]=I|ce,F=0;break;case 2:T[U++]=I|ce>>>2,I=ce<<6,F=3;break;case 1:T[U++]=I|ce>>>4,I=ce<<4,F=2;break;default:I=ce<<2,F=1}};for(let ce=0;ce<k.length;ce++){const oe=k.charCodeAt(ce);if(oe>=65&&oe<=90)x(oe-65);else if(oe>=97&&oe<=122)x(oe-97+26);else if(oe>=48&&oe<=57)x(oe-48+52);else if(oe===43||oe===45)x(62);else if(oe===47||oe===95)x(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ce]}`)}}const Y=U;for(;F>0;)x(0);return d.wrap(T).slice(0,Y)}e.$xe=c;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:k},I=!0,F=!1){const U=F?D:m;let T="";const x=k.byteLength%3;let Y=0;for(;Y<k.byteLength-x;Y+=3){const ce=k[Y+0],oe=k[Y+1],ae=k[Y+2];T+=U[ce>>>2],T+=U[(ce<<4|oe>>>4)&63],T+=U[(oe<<2|ae>>>6)&63],T+=U[ae&63]}if(x===1){const ce=k[Y+0];T+=U[ce>>>2],T+=U[ce<<4&63],I&&(T+="==")}else if(x===2){const ce=k[Y+0],oe=k[Y+1];T+=U[ce>>>2],T+=U[(ce<<4|oe>>>4)&63],T+=U[oe<<2&63],I&&(T+="=")}return T}e.$ye=R}),define(ne[27],re([0,1,142,72]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Af=e.$zf=e.$yf=e.$xf=e.GraphemeBreakType=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=void 0;function s(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$Ee=s;const M=/{(\d+)}/g;function C(ie,...fe){return fe.length===0?ie:ie.replace(M,function(me,ye){const Ce=parseInt(ye,10);return isNaN(Ce)||Ce<0||Ce>=fe.length?me:fe[Ce]})}e.$Fe=C;const P=/{([^}]+)}/g;function d(ie,fe){return Object.keys(fe).length===0?ie:ie.replace(P,(me,ye)=>fe[ye]??me)}e.$Ge=d;function a(ie){return ie.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$He=a;function $(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ie=$;function p(ie,fe){let me=0;const ye=fe.charCodeAt(0);for(let Ce=ie.length-1;Ce>=0;Ce--)ie.charCodeAt(Ce)===ye&&me++;return me}e.$Je=p;function v(ie,fe,me="\u2026"){return ie.length<=fe?ie:`${ie.substr(0,fe)}${me}`}e.$Ke=v;function f(ie,fe=" "){const me=y(ie,fe);return w(me,fe)}e.$Le=f;function y(ie,fe){if(!ie||!fe)return ie;const me=fe.length;if(me===0||ie.length===0)return ie;let ye=0;for(;ie.indexOf(fe,ye)===ye;)ye=ye+me;return ie.substring(ye)}e.$Me=y;function w(ie,fe){if(!ie||!fe)return ie;const me=fe.length,ye=ie.length;if(me===0||ye===0)return ie;let Ce=ye,je=-1;for(;je=ie.lastIndexOf(fe,Ce-1),!(je===-1||je+me!==Ce);){if(je===0)return"";Ce=je}return ie.substring(0,Ce)}e.$Ne=w;function b(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Oe=b;function g(ie){return ie.replace(/\*/g,"")}e.$Pe=g;function h(ie,fe,me={}){if(!ie)throw new Error("Cannot create regex from empty string");fe||(ie=$(ie)),me.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ye="";return me.global&&(ye+="g"),me.matchCase||(ye+="i"),me.multiline&&(ye+="m"),me.unicode&&(ye+="u"),new RegExp(ie,ye)}e.$Qe=h;function l(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$Re=l;function E(ie){return ie.split(/\r\n|\r|\n/)}e.$Se=E;function u(ie){for(let fe=0,me=ie.length;fe<me;fe++){const ye=ie.charCodeAt(fe);if(ye!==32&&ye!==9)return fe}return-1}e.$Te=u;function i(ie,fe=0,me=ie.length){for(let ye=fe;ye<me;ye++){const Ce=ie.charCodeAt(ye);if(Ce!==32&&Ce!==9)return ie.substring(fe,ye)}return ie.substring(fe,me)}e.$Ue=i;function o(ie,fe=ie.length-1){for(let me=fe;me>=0;me--){const ye=ie.charCodeAt(me);if(ye!==32&&ye!==9)return me}return-1}e.$Ve=o;function r(ie,fe,me){const ye=[];let Ce=0;for(const je of ie.matchAll(fe)){if(ye.push(ie.slice(Ce,je.index)),je.index===void 0)throw new Error("match.index should be defined");Ce=je.index+je[0].length,ye.push(me(je[0],...je.slice(1),je.index,ie,je.groups))}return ye.push(ie.slice(Ce)),Promise.all(ye).then(je=>je.join(""))}e.$We=r;function t(ie,fe){return ie<fe?-1:ie>fe?1:0}e.$Xe=t;function n(ie,fe,me=0,ye=ie.length,Ce=0,je=fe.length){for(;me<ye&&Ce<je;me++,Ce++){const qe=ie.charCodeAt(me),Ge=fe.charCodeAt(Ce);if(qe<Ge)return-1;if(qe>Ge)return 1}const Fe=ye-me,Te=je-Ce;return Fe<Te?-1:Fe>Te?1:0}e.$Ye=n;function c(ie,fe){return m(ie,fe,0,ie.length,0,fe.length)}e.$Ze=c;function m(ie,fe,me=0,ye=ie.length,Ce=0,je=fe.length){for(;me<ye&&Ce<je;me++,Ce++){let qe=ie.charCodeAt(me),Ge=fe.charCodeAt(Ce);if(qe===Ge)continue;if(qe>=128||Ge>=128)return n(ie.toLowerCase(),fe.toLowerCase(),me,ye,Ce,je);R(qe)&&(qe-=32),R(Ge)&&(Ge-=32);const Qe=qe-Ge;if(Qe!==0)return Qe}const Fe=ye-me,Te=je-Ce;return Fe<Te?-1:Fe>Te?1:0}e.$1e=m;function D(ie){return ie>=48&&ie<=57}e.$2e=D;function R(ie){return ie>=97&&ie<=122}e.$3e=R;function k(ie){return ie>=65&&ie<=90}e.$4e=k;function I(ie,fe){return ie.length===fe.length&&m(ie,fe)===0}e.$5e=I;function F(ie,fe){const me=fe.length;return fe.length>ie.length?!1:m(ie,fe,0,me)===0}e.$6e=F;function U(ie,fe){const me=Math.min(ie.length,fe.length);let ye;for(ye=0;ye<me;ye++)if(ie.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return me}e.$7e=U;function T(ie,fe){const me=Math.min(ie.length,fe.length);let ye;const Ce=ie.length-1,je=fe.length-1;for(ye=0;ye<me;ye++)if(ie.charCodeAt(Ce-ye)!==fe.charCodeAt(je-ye))return ye;return me}e.$8e=T;function x(ie){return 55296<=ie&&ie<=56319}e.$9e=x;function Y(ie){return 56320<=ie&&ie<=57343}e.$0e=Y;function ce(ie,fe){return(ie-55296<<10)+(fe-56320)+65536}e.$$e=ce;function oe(ie,fe,me){const ye=ie.charCodeAt(me);if(x(ye)&&me+1<fe){const Ce=ie.charCodeAt(me+1);if(Y(Ce))return ce(ye,Ce)}return ye}e.$_e=oe;function ae(ie,fe){const me=ie.charCodeAt(fe-1);if(Y(me)&&fe>1){const ye=ie.charCodeAt(fe-2);if(x(ye))return ce(ye,me)}return me}class Z{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ae(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=oe(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$af=Z;class K{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new Z(fe,me)}nextGraphemeLength(){const fe=ue.getInstance(),me=this.c,ye=me.offset;let Ce=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const je=me.offset,Fe=fe.getGraphemeBreakType(me.nextCodePoint());if(pe(Ce,Fe)){me.setOffset(je);break}Ce=Fe}return me.offset-ye}prevGraphemeLength(){const fe=ue.getInstance(),me=this.c,ye=me.offset;let Ce=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const je=me.offset,Fe=fe.getGraphemeBreakType(me.prevCodePoint());if(pe(Fe,Ce)){me.setOffset(je);break}Ce=Fe}return ye-me.offset}eol(){return this.c.eol()}}e.$bf=K;function G(ie,fe){return new K(ie,fe).nextGraphemeLength()}e.$cf=G;function z(ie,fe){return new K(ie,fe).prevGraphemeLength()}e.$df=z;function N(ie,fe){fe>0&&Y(ie.charCodeAt(fe))&&fe--;const me=fe+G(ie,fe);return[me-z(ie,me),me]}e.$ef=N;function H(ie){const fe=new K(ie);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}e.$ff=H;let q;function ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function se(ie){return q||(q=ee()),q.test(ie)}e.$gf=se;const Q=/^[\t\n\r\x20-\x7E]*$/;function O(ie){return Q.test(ie)}e.$hf=O,e.$if=/[\u2028\u2029]/;function j(ie){return e.$if.test(ie)}e.$jf=j;function V(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$kf=V;function L(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$lf=L;function B(ie,fe){if(ie.length<fe)return ie;const me=/\b/g;let ye=0;for(;me.test(ie)&&!(ie.length-me.lastIndex<fe);)ye=me.lastIndex,me.lastIndex+=1;return ie.substring(ye).replace(/^\s/,"")}e.$mf=B;const W=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,X=/\x1b\].*?\x07/g;function he(ie){return ie&&(ie=ie.replace(W,"").replace(X,"")),ie}e.$nf=he,e.$of=String.fromCharCode(65279);function de(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$pf=de;function le(ie){return de(ie)?ie.substr(1):ie}e.$qf=le;function we(ie,fe){if(!ie||!fe||ie.length<fe.length)return!1;const me=fe.length,ye=ie.toLowerCase();let Ce=0,je=-1;for(;Ce<me;){const Fe=ye.indexOf(fe[Ce],je+1);if(Fe<0)return!1;je=Fe,Ce++}return!0}e.$rf=we;function be(ie,fe=!1){return ie?(fe&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$sf=be;function Ee(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$tf=Ee;function Se(ie,fe=1){if(fe===0)return"";let me=-1;do me=ie.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?ie:(ie[me-1]==="\r"&&me--,ie.substr(0,me))}e.$uf=Se;function Le(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$vf=Le;function ke(ie){return ue.getInstance().getGraphemeBreakType(ie)}e.$wf=ke;function pe(ie,fe){return ie===0?fe!==5&&fe!==7:ie===2&&fe===3?!1:ie===4||ie===2||ie===3||fe===4||fe===2||fe===3?!0:!(ie===8&&(fe===8||fe===9||fe===11||fe===12)||(ie===11||ie===9)&&(fe===9||fe===10)||(ie===12||ie===10)&&fe===10||fe===5||fe===13||fe===7||ie===1||ie===13&&fe===14||ie===6&&fe===6)}var _;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(_||(e.GraphemeBreakType=_={}));class ue{static{this.c=null}static getInstance(){return ue.c||(ue.c=new ue),ue.c}constructor(){this.d=ge()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,ye=me.length/3;let Ce=1;for(;Ce<=ye;)if(fe<me[3*Ce])Ce=2*Ce;else if(fe>me[3*Ce+1])Ce=2*Ce+1;else return me[3*Ce+2];return 0}}function ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(ie,fe){if(ie===0)return 0;const me=De(ie,fe);if(me!==void 0)return me;const ye=new Z(fe,ie);return ye.prevCodePoint(),ye.offset}e.$xf=Re;function De(ie,fe){const me=new Z(fe,ie);let ye=me.prevCodePoint();for(;Ue(ye)||ye===65039||ye===8419;){if(me.offset===0)return;ye=me.prevCodePoint()}if(!L(ye))return;let Ce=me.offset;return Ce>0&&me.prevCodePoint()===8205&&(Ce=me.offset),Ce}function Ue(ie){return 127995<=ie&&ie<=127999}var Me;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.$yf="\xA0";class Ve{static{this.c=new A.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new S.$Ae(fe=>{function me(Qe){const _e=new Map;for(let Xe=0;Xe<Qe.length;Xe+=2)_e.set(Qe[Xe],Qe[Xe+1]);return _e}function ye(Qe,_e){const Xe=new Map(Qe);for(const[it,st]of _e)Xe.set(it,st);return Xe}function Ce(Qe,_e){if(!Qe)return _e;const Xe=new Map;for(const[it,st]of Qe)_e.has(it)&&Xe.set(it,st);return Xe}const je=this.c.value;let Fe=fe.filter(Qe=>!Qe.startsWith("_")&&Qe in je);Fe.length===0&&(Fe=["_default"]);let Te;for(const Qe of Fe){const _e=me(je[Qe]);Te=Ce(Te,_e)}const qe=me(je._common),Ge=ye(qe,Te);return new Ve(Ge)})}static getInstance(fe){return Ve.d.get(Array.from(fe))}static{this.e=new A.$U(()=>Object.keys(Ve.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ve.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$zf=Ve;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(fe){return ze.e().has(fe)}static get codePoints(){return ze.e()}}e.$Af=ze}),define(ne[56],re([0,1,27]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;function A(g){return s(g,0)}e.$Ii=A;function s(g,h){switch(typeof g){case"object":return g===null?M(349,h):Array.isArray(g)?d(g,h):a(g,h);case"string":return P(g,h);case"boolean":return C(g,h);case"number":return M(g,h);case"undefined":return M(937,h);default:return M(617,h)}}e.$Ji=s;function M(g,h){return(h<<5)-h+g|0}e.$Ki=M;function C(g,h){return M(g?433:863,h)}function P(g,h){h=M(149417,h);for(let l=0,E=g.length;l<E;l++)h=M(g.charCodeAt(l),h);return h}e.$Li=P;function d(g,h){return h=M(104579,h),g.reduce((l,E)=>s(E,l),h)}function a(g,h){return h=M(181387,h),Object.keys(g).sort().reduce((l,E)=>(l=P(E,l),s(g[E],l)),h)}class ${constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=s(h,this.g),this.g}}e.$Mi=$;var p;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function v(g,h,l=32){const E=l-h,u=~((1<<E)-1);return(g<<h|(u&g)>>>E)>>>0}function f(g,h=0,l=g.byteLength,E=0){for(let u=0;u<l;u++)g[h+u]=E}function y(g,h,l="0"){for(;g.length<h;)g=l+g;return g}function w(g,h=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(l=>l.toString(16).padStart(2,"0")).join(""):y((g>>>0).toString(16),h/4)}e.$Ni=w;class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const l=h.length;if(l===0)return;const E=this.p;let u=this.r,i=this.u,o,r;for(i!==0?(o=i,r=-1,i=0):(o=h.charCodeAt(0),r=0);;){let t=o;if(S.$9e(o))if(r+1<l){const n=h.charCodeAt(r+1);S.$0e(n)?(r++,t=S.$$e(o,n)):t=65533}else{i=o;break}else S.$0e(o)&&(t=65533);if(u=this.w(E,u,t),r++,r<l)o=h.charCodeAt(r);else break}this.r=u,this.u=i}w(h,l,E){return E<128?h[l++]=E:E<2048?(h[l++]=192|(E&1984)>>>6,h[l++]=128|(E&63)>>>0):E<65536?(h[l++]=224|(E&61440)>>>12,h[l++]=128|(E&4032)>>>6,h[l++]=128|(E&63)>>>0):(h[l++]=240|(E&1835008)>>>18,h[l++]=128|(E&258048)>>>12,h[l++]=128|(E&4032)>>>6,h[l++]=128|(E&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=b.g,l=this.q;for(let m=0;m<64;m+=4)h.setUint32(m,l.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)h.setUint32(m,v(h.getUint32(m-12,!1)^h.getUint32(m-32,!1)^h.getUint32(m-56,!1)^h.getUint32(m-64,!1),1),!1);let E=this.h,u=this.l,i=this.m,o=this.n,r=this.o,t,n,c;for(let m=0;m<80;m++)m<20?(t=u&i|~u&o,n=1518500249):m<40?(t=u^i^o,n=1859775393):m<60?(t=u&i|u&o|i&o,n=2400959708):(t=u^i^o,n=3395469782),c=v(E,5)+t+r+n+h.getUint32(m*4,!1)&4294967295,r=o,o=i,i=v(u,30),u=E,E=c;this.h=this.h+E&4294967295,this.l=this.l+u&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$Oi=b}),define(ne[74],re([0,1,27]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(A||(A={})),function(s){const M="error",C="warning",P="warn",d="info",a="ignore";function $(v){return v?S.$5e(M,v)?s.Error:S.$5e(C,v)||S.$5e(P,v)?s.Warning:S.$5e(d,v)?s.Info:s.Ignore:s.Ignore}s.fromValue=$;function p(v){switch(v){case s.Error:return M;case s.Warning:return C;case s.Info:return d;default:return a}}s.toString=p}(A||(A={})),e.default=A}),define(ne[143],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Nd=Symbol("MicrotaskDelay")}),define(ne[57],re([0,1,23,27]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const y=f.charCodeAt(0),w=this.b.charCodeAt(this.c);return y-w}value(){return this.b[this.c]}}e.$Wh=s;class M{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,A.$Ye)(f,this.b,0,f.length,this.c,this.d):(0,A.$1e)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Xh=M;class C{constructor(f=!0,y=!0){this.f=f,this.g=y}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let y=f.length-1;y>=0;y--,this.c--){const w=this.b.charCodeAt(y);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,A.$Ye)(f,this.b,0,f.length,this.d,this.e):(0,A.$1e)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Yh=C;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class d{constructor(f,y){this.f=f,this.g=y,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,A.$Ze)(f,this.c.scheme);if(this.d[this.e]===2)return(0,A.$Ze)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,A.$Xe)(f,this.c.query);if(this.d[this.e]===5)return(0,A.$Xe)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Zh=d;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})($||($={}));class p{static forUris(f=()=>!1,y=()=>!1){return new p(new d(f,y))}static forPaths(f=!1){return new p(new C(void 0,!f))}static forStrings(){return new p(new s)}static forConfigKeys(){return new p(new M)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,y){if(y){const w=y.slice(0);(0,S.$Wb)(w);for(const b of w)this.set(b,f)}else{const w=f.slice(0);(0,S.$Wb)(w);for(const b of w)this.set(b[0],b[1])}}set(f,y){const w=this.b.reset(f);let b;this.c||(this.c=new a,this.c.segment=w.value());const g=[];for(b=this.c;;){const l=w.cmp(b.segment);if(l>0)b.left||(b.left=new a,b.left.segment=w.value()),g.push([-1,b]),b=b.left;else if(l<0)b.right||(b.right=new a,b.right.segment=w.value()),g.push([1,b]),b=b.right;else if(w.hasNext())w.next(),b.mid||(b.mid=new a,b.mid.segment=w.value()),g.push([0,b]),b=b.mid;else break}const h=b.value;b.value=y,b.key=f;for(let l=g.length-1;l>=0;l--){const E=g[l][1];E.updateHeight();const u=E.balanceFactor();if(u<-1||u>1){const i=g[l][0],o=g[l+1][0];if(i===1&&o===1)g[l][1]=E.rotateLeft();else if(i===-1&&o===-1)g[l][1]=E.rotateRight();else if(i===1&&o===-1)E.right=g[l+1][1]=g[l+1][1].rotateRight(),g[l][1]=E.rotateLeft();else if(i===-1&&o===1)E.left=g[l+1][1]=g[l+1][1].rotateLeft(),g[l][1]=E.rotateRight();else throw new Error;if(l>0)switch(g[l-1][0]){case-1:g[l-1][1].left=g[l][1];break;case 1:g[l-1][1].right=g[l][1];break;case 0:g[l-1][1].mid=g[l][1];break}else this.c=g[0][1]}}return h}get(f){return this.d(f)?.value}d(f){const y=this.b.reset(f);let w=this.c;for(;w;){const b=y.cmp(w.segment);if(b>0)w=w.left;else if(b<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else break}return w}has(f){const y=this.d(f);return!(y?.value===void 0&&y?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,y){const w=this.b.reset(f),b=[];let g=this.c;for(;g;){const h=w.cmp(g.segment);if(h>0)b.push([-1,g]),g=g.left;else if(h<0)b.push([1,g]),g=g.right;else if(w.hasNext())w.next(),b.push([0,g]),g=g.mid;else break}if(g){if(y?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const h=this.f(g.right);if(h.key){const{key:l,value:E,segment:u}=h;this.e(h.key,!1),g.key=l,g.value=E,g.segment=u}}else{const h=g.left??g.right;if(b.length>0){const[l,E]=b[b.length-1];switch(l){case-1:E.left=h;break;case 0:E.mid=h;break;case 1:E.right=h;break}}else this.c=h}for(let h=b.length-1;h>=0;h--){const l=b[h][1];l.updateHeight();const E=l.balanceFactor();if(E>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),b[h][1]=l.rotateLeft()):E<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),b[h][1]=l.rotateRight()),h>0)switch(b[h-1][0]){case-1:b[h-1][1].left=b[h][1];break;case 1:b[h-1][1].right=b[h][1];break;case 0:b[h-1][1].mid=b[h][1];break}else this.c=b[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const y=this.b.reset(f);let w=this.c,b;for(;w;){const g=y.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(y.hasNext())y.next(),b=w.value||b,w=w.mid;else break}return w&&w.value||b}findSuperstr(f){return this.g(f,!1)}g(f,y){const w=this.b.reset(f);let b=this.c;for(;b;){const g=w.cmp(b.segment);if(g>0)b=b.left;else if(g<0)b=b.right;else if(w.hasNext())w.next(),b=b.mid;else return b.mid?this.h(b.mid):y?b.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[y,w]of this)f(w,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const y=[];return this.j(f,y),y[Symbol.iterator]()}j(f,y){f&&(f.left&&this.j(f.left,y),f.value&&y.push([f.key,f.value]),f.mid&&this.j(f.mid,y),f.right&&this.j(f.right,y))}_isBalanced(){const f=y=>{if(!y)return!0;const w=y.balanceFactor();return w<-1||w>1?!1:f(y.left)&&f(y.right)};return f(this.c)}}e.$1h=p}),define(ne[12],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function S(u){return typeof u=="string"}e.$Bf=S;function A(u){return Array.isArray(u)&&u.every(i=>S(i))}e.$Cf=A;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$Df=s;function M(u){const i=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof i}e.$Ef=M;function C(u){return typeof u=="number"&&!isNaN(u)}e.$Ff=C;function P(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$Gf=P;function d(u){return u===!0||u===!1}e.$Hf=d;function a(u){return typeof u>"u"}e.$If=a;function $(u){return!p(u)}e.$Jf=$;function p(u){return a(u)||u===null}e.$Kf=p;function v(u,i){if(!u)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Lf=v;function f(u){if(p(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$Mf=f;function y(...u){const i=[];for(let o=0;o<u.length;o++){const r=u[o];if(p(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(r)}return i}e.$Nf=y;const w=Object.prototype.hasOwnProperty;function b(u){if(!s(u))return!1;for(const i in u)if(w.call(u,i))return!1;return!0}e.$Of=b;function g(u){return typeof u=="function"}e.$Pf=g;function h(...u){return u.length>0&&u.every(g)}e.$Qf=h;function l(u,i){const o=Math.min(u.length,i.length);for(let r=0;r<o;r++)E(u[r],i[r])}e.$Rf=l;function E(u,i){if(S(i)){if(typeof u!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(u instanceof i)return}catch{}if(!p(u)&&u.constructor===i||i.length===1&&i.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Sf=E}),define(ne[75],re([0,1,12]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=void 0;const A=Object.create(null);function s(P,d){if((0,S.$Bf)(d)){const a=A[d];if(a===void 0)throw new Error(`${P} references an unknown codicon: ${d}`);d=a}return A[P]=d,{id:P}}function M(){return A}e.$Xj=M;function C(){return Object.values(e.$Zj)}e.$Yj=C,e.$Zj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(ne[38],re([0,1,12]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=void 0;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const h=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([l,E])=>{h[l]=E&&typeof E=="object"?A(E):E}),h}e.$_m=A;function s(g){if(!g||typeof g!="object")return g;const h=[g];for(;h.length>0;){const l=h.shift();Object.freeze(l);for(const E in l)if(M.call(l,E)){const u=l[E];typeof u=="object"&&!Object.isFrozen(u)&&!(0,S.$Ef)(u)&&h.push(u)}}return g}e.$an=s;const M=Object.prototype.hasOwnProperty;function C(g,h){return P(g,h,new Set)}e.$bn=C;function P(g,h,l){if((0,S.$Kf)(g))return g;const E=h(g);if(typeof E<"u")return E;if(Array.isArray(g)){const u=[];for(const i of g)u.push(P(i,h,l));return u}if((0,S.$Df)(g)){if(l.has(g))throw new Error("Cannot clone recursive data-structure");l.add(g);const u={};for(const i in g)M.call(g,i)&&(u[i]=P(g[i],h,l));return l.delete(g),u}return g}function d(g,h,l=!0){return(0,S.$Df)(g)?((0,S.$Df)(h)&&Object.keys(h).forEach(E=>{E in g?l&&((0,S.$Df)(g[E])&&(0,S.$Df)(h[E])?d(g[E],h[E],l):g[E]=h[E]):g[E]=h[E]}),g):h}e.$cn=d;function a(g,h){if(g===h)return!0;if(g==null||h===null||h===void 0||typeof g!=typeof h||typeof g!="object"||Array.isArray(g)!==Array.isArray(h))return!1;let l,E;if(Array.isArray(g)){if(g.length!==h.length)return!1;for(l=0;l<g.length;l++)if(!a(g[l],h[l]))return!1}else{const u=[];for(E in g)u.push(E);u.sort();const i=[];for(E in h)i.push(E);if(i.sort(),!a(u,i))return!1;for(l=0;l<u.length;l++)if(!a(g[u[l]],h[u[l]]))return!1}return!0}e.$dn=a;function $(g){const h=new Set;return JSON.stringify(g,(l,E)=>{if((0,S.$Df)(E)||Array.isArray(E)){if(h.has(E))return"[Circular]";h.add(E)}return E})}e.$en=$;function p(g,h){const l=Object.create(null);return!g||!h||Object.keys(h).forEach(u=>{const i=g[u],o=h[u];a(i,o)||(l[u]=o)}),l}e.$fn=p;function v(g,h){const l=h.toLowerCase(),E=Object.keys(g).find(u=>u.toLowerCase()===l);return E?g[E]:g[h]}e.$gn=v;function f(g,h){const l=Object.create(null);for(const[E,u]of Object.entries(g))h(E,u)&&(l[E]=u);return l}e.$hn=f;function y(g){let h=[];for(;Object.prototype!==g;)h=h.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return h}e.$in=y;function w(g){const h=[];for(const l of y(g))typeof g[l]=="function"&&h.push(l);return h}e.$jn=w;function b(g,h){const l=u=>function(){const i=Array.prototype.slice.call(arguments,0);return h(u,i)},E={};for(const u of g)E[u]=l(u);return E}e.$kn=b}),define(ne[102],re([0,1,75]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$1j=e.ThemeColor=void 0;var A;(function(C){function P(d){return d&&typeof d=="object"&&typeof d.id=="string"}C.isThemeColor=P})(A||(e.ThemeColor=A={}));function s(C){return{id:C}}e.$1j=s;var M;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function d(h){const l=P.exec(h.id);if(!l)return d(S.$Zj.error);const[,E,u]=l,i=["codicon","codicon-"+E];return u&&i.push("codicon-modifier-"+u.substring(1)),i}C.asClassNameArray=d;function a(h){return d(h).join(" ")}C.asClassName=a;function $(h){return"."+d(h).join(".")}C.asCSSSelector=$;function p(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||A.isThemeColor(h.color))}C.isThemeIcon=p;const v=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function f(h){const l=v.exec(h);if(!l)return;const[,E]=l;return{id:E}}C.fromString=f;function y(h){return{id:h}}C.fromId=y;function w(h,l){let E=h.id;const u=E.lastIndexOf("~");return u!==-1&&(E=E.substring(0,u)),l&&(E=`${E}~${l}`),{id:E}}C.modify=w;function b(h){const l=h.id.lastIndexOf("~");if(l!==-1)return h.id.substring(l+1)}C.getModifier=b;function g(h,l){return h.id===l.id&&h.color?.id===l.color?.id}C.isEqual=g})(M||(e.ThemeIcon=M={}))}),define(ne[32],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(s){return S.test(s)}e.$gg=A,e.$hg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(P){for(let d=0;d<P.length;d++)P[d]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let d=0,a="";return a+=C[M[d++]],a+=C[M[d++]],a+=C[M[d++]],a+=C[M[d++]],a+="-",a+=C[M[d++]],a+=C[M[d++]],a+="-",a+=C[M[d++]],a+=C[M[d++]],a+="-",a+=C[M[d++]],a+=C[M[d++]],a+="-",a+=C[M[d++]],a+=C[M[d++]],a+=C[M[d++]],a+=C[M[d++]],a+=C[M[d++]],a+=C[M[d++]],a}}()}),define(ne[144],re([0,1,86,45,84]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PT=void 0;async function M(C,P){if(await new Promise(($,p)=>{const v=A.createReadStream(C),f=S.createHash("sha1");v.pipe(f);const y=(0,s.$cb)((w,b)=>{v.removeAllListeners(),f.removeAllListeners(),w?p(w):$(b)});v.once("error",y),v.once("end",y),f.once("error",y),f.once("data",w=>y(void 0,w.toString("hex")))})!==P)throw new Error("Hash mismatch")}e.$PT=M}),define(ne[145],re([0,1,28]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(C){const P=C.replace(/\-/g,":").toLowerCase();return!A.has(P)}function M(){const C=(0,S.networkInterfaces)();for(const P in C){const d=C[P];if(d){for(const{mac:a}of d)if(s(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Vm=M}),define(ne[103],re([0,1,87]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=e.$jg=void 0;function A(P,d,a,$=1){let p=!1;return new Promise(v=>{const f=setTimeout(()=>{if(!p)return p=!0,v(0)},a);s(P,d,$,y=>{if(!p)return p=!0,clearTimeout(f),v(y)})})}e.$jg=A;function s(P,d,a,$){if(d===0)return $(0);const p=new S.Socket;p.once("connect",()=>(C(p),s(P+a,d-1,a,$))),p.once("data",()=>{}),p.once("error",v=>(C(p),v.code!=="ECONNREFUSED"?s(P+a,d-1,a,$):$(P))),p.connect(P,"127.0.0.1")}e.$kg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(P,d,a,$="127.0.0.1"){let p=!1,v,f=1;const y=S.createServer({pauseOnConnect:!0});function w(b,g){p||(p=!0,y.removeAllListeners(),y.close(),v&&clearTimeout(v),g(b))}return new Promise(b=>{v=setTimeout(()=>{w(0,b)},a),y.on("listening",()=>{w(P,b)}),y.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&f<d?(P++,f++,y.listen(P,$)):w(0,b)}),y.on("close",()=>{w(0,b)}),y.listen(P,$)})}e.$lg=M;function C(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(d){console.error(d)}}}),function(){function J(){function e(){return process.uncHostAllowlist}function S(d){const a=new Set;if(Array.isArray(d))for(const $ of d)typeof $=="string"&&a.add($);return Array.from(a)}function A(){const d=e();return d?Array.from(d):[]}function s(d){if(process.platform!=="win32")return;const a=e();if(a)if(typeof d=="string")a.add(d.toLowerCase());else for(const $ of S(d))s($)}function M(d){if(typeof d!="string")return;const a=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let $;for(const p of a){if(d.indexOf(p)!==0)continue;const f=d.indexOf("\\",p.length);if(f===-1)continue;const y=d.substring(p.length,f);if(y){$=y;break}}return $}function C(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:A,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:C,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return J()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=J():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ne[146],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TT=e.$ST=void 0,e.$ST="vscode:contextmenu",e.$TT="vscode:onCloseContextMenu"}),define(ne[147],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1T=void 0;class S{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$1T=S}),define(ne[148],re([11,10]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[149],re([0,1,148]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=void 0;const A=60,s=A*60,M=s*24,C=M*7,P=M*30,d=M*365;function a(p,v,f,y){typeof p!="number"&&(p=p.getTime());const w=Math.round((new Date().getTime()-p)/1e3);if(w<-30)return(0,S.localize)(0,null,a(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,S.localize)(1,null);let b;return w<A?(b=w,v?b===1?f?(0,S.localize)(2,null,b):(0,S.localize)(3,null,b):f?(0,S.localize)(4,null,b):(0,S.localize)(5,null,b):b===1?f?(0,S.localize)(6,null,b):(0,S.localize)(7,null,b):f?(0,S.localize)(8,null,b):(0,S.localize)(9,null,b)):w<s?(b=Math.floor(w/A),v?b===1?f?(0,S.localize)(10,null,b):(0,S.localize)(11,null,b):f?(0,S.localize)(12,null,b):(0,S.localize)(13,null,b):b===1?f?(0,S.localize)(14,null,b):(0,S.localize)(15,null,b):f?(0,S.localize)(16,null,b):(0,S.localize)(17,null,b)):w<M?(b=Math.floor(w/s),v?b===1?f?(0,S.localize)(18,null,b):(0,S.localize)(19,null,b):f?(0,S.localize)(20,null,b):(0,S.localize)(21,null,b):b===1?f?(0,S.localize)(22,null,b):(0,S.localize)(23,null,b):f?(0,S.localize)(24,null,b):(0,S.localize)(25,null,b)):w<C?(b=Math.floor(w/M),v?b===1?(0,S.localize)(26,null,b):(0,S.localize)(27,null,b):b===1?(0,S.localize)(28,null,b):(0,S.localize)(29,null,b)):w<P?(b=Math.floor(w/C),v?b===1?f?(0,S.localize)(30,null,b):(0,S.localize)(31,null,b):f?(0,S.localize)(32,null,b):(0,S.localize)(33,null,b):b===1?f?(0,S.localize)(34,null,b):(0,S.localize)(35,null,b):f?(0,S.localize)(36,null,b):(0,S.localize)(37,null,b)):w<d?(b=Math.floor(w/P),v?b===1?f?(0,S.localize)(38,null,b):(0,S.localize)(39,null,b):f?(0,S.localize)(40,null,b):(0,S.localize)(41,null,b):b===1?f?(0,S.localize)(42,null,b):(0,S.localize)(43,null,b):f?(0,S.localize)(44,null,b):(0,S.localize)(45,null,b)):(b=Math.floor(w/d),v?b===1?f?(0,S.localize)(46,null,b):(0,S.localize)(47,null,b):f?(0,S.localize)(48,null,b):(0,S.localize)(49,null,b):b===1?f?(0,S.localize)(50,null,b):(0,S.localize)(51,null,b):f?(0,S.localize)(52,null,b):(0,S.localize)(53,null,b))}e.$im=a;function $(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$jm=$}),define(ne[150],re([11,10]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[49],re([0,1,23,12,150]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=void 0;function M(p,v){return v&&(p.stack||p.stacktrace)?s.localize(0,null,P(p),C(p.stack)||C(p.stacktrace)):P(p)}function C(p){return Array.isArray(p)?p.join(`
`):p}function P(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?s.localize(1,null,p.message):p.message||s.localize(2,null)}function d(p=null,v=!1){if(!p)return s.localize(3,null);if(Array.isArray(p)){const f=S.$Gb(p),y=d(f[0],v);return f.length>1?s.localize(4,null,y,f.length):y}if(A.$Bf(p))return p;if(p.detail){const f=p.detail;if(f.error)return M(f.error,v);if(f.exception)return M(f.exception,v)}return p.stack?M(p,v):p.message?p.message:s.localize(5,null)}e.$Fi=d;function a(p){const v=p;return v instanceof Error&&Array.isArray(v.actions)}e.$Gi=a;function $(p,v){let f;return typeof p=="string"?f=new Error(p):f=p,f.actions=v,f}e.$Hi=$}),define(ne[151],re([11,10]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[152],re([0,1,151]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;function A(s){switch(s){case 1:return(0,S.localize)(0,null);case 2:return(0,S.localize)(1,null);case 3:return(0,S.localize)(2,null);case 4:return(0,S.localize)(3,null);case 5:return(0,S.localize)(4,null);case 6:return(0,S.localize)(5,null);case 7:return(0,S.localize)(6,null);case 8:return(0,S.localize)(7,null);case 9:return(0,S.localize)(8,null);default:return""}}e.$Bp=A}),define(ne[153],re([11,10]),function(J,e){return J.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,153]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let A=!1,s=!1,M=!1,C=!1,P=!1,d=!1,a=!1,$=!1,p=!1,v=!1,f,y=e.$g,w=e.$g,b,g;const h=globalThis;let l;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?l=h.vscode.process:typeof process<"u"&&(l=process);const E=typeof l?.versions?.electron=="string",u=E&&l?.type==="renderer";if(typeof navigator=="object"&&!u)g=navigator.userAgent,A=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,$=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=g.indexOf("Linux")>=0,v=g?.indexOf("Mobi")>=0,d=!0,f=S.getConfiguredDefaultLocale(S.localize(0,null))||e.$g,y=f,w=navigator.language;else if(typeof l=="object"){A=l.platform==="win32",s=l.platform==="darwin",M=l.platform==="linux",C=M&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,a=E,p=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,y=e.$g;const R=l.env.VSCODE_NLS_CONFIG;if(R)try{const k=JSON.parse(R),I=k.availableLanguages["*"];f=k.locale,w=k.osLocale,y=I||e.$g,b=k._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var i;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(R){switch(R){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:A?r=3:M&&(r=2),e.$i=A,e.$j=s,e.$k=M,e.$l=C,e.$m=P,e.$n=a,e.$o=d,e.$p=d&&typeof h.importScripts=="function",e.$q=e.$p?h.origin:void 0,e.$r=$,e.$s=v,e.$t=p,e.$u=r,e.$v=g,e.$w=y;var t;(function(R){function k(){return e.$w}R.value=k;function I(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}R.isDefaultVariant=I;function F(){return e.$w==="en"}R.isDefault=F})(t||(e.Language=t={})),e.$x=f,e.$y=w,e.$z=b,e.$A=typeof h.postMessage=="function"&&!h.importScripts,e.$B=(()=>{if(e.$A){const R=[];h.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let F=0,U=R.length;F<U;F++){const T=R[F];if(T.id===I.data.vscodeScheduleAsyncWork){R.splice(F,1),T.callback();return}}});let k=0;return I=>{const F=++k;R.push({id:F,callback:I}),h.postMessage({vscodeScheduleAsyncWork:F},"*")}}return R=>setTimeout(R)})();var n;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||$?2:A?1:3;let c=!0,m=!1;function D(){if(!m){m=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,c=new Uint16Array(R.buffer)[0]===(2<<8)+1}return c}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ne[35],re([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let A;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const M=s.process;A={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return S.$i?"win32":S.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$cc=A.platform,e.$dc=A.arch}),define(ne[9],re([0,1,35]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const A=65,s=97,M=90,C=122,P=46,d=47,a=92,$=58,p=63;class v extends Error{constructor(o,r,t){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const c=o.indexOf(".")!==-1?"property":"argument";let m=`The "${o}" ${c} ${n} of type ${r}`;m+=`. Received type ${typeof t}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function f(i,o){if(i===null||typeof i!="object")throw new v(o,"Object",i)}function y(i,o){if(typeof i!="string")throw new v(o,"string",i)}const w=S.$cc==="win32";function b(i){return i===d||i===a}function g(i){return i===d}function h(i){return i>=A&&i<=M||i>=s&&i<=C}function l(i,o,r,t){let n="",c=0,m=-1,D=0,R=0;for(let k=0;k<=i.length;++k){if(k<i.length)R=i.charCodeAt(k);else{if(t(R))break;R=d}if(t(R)){if(!(m===k-1||D===1))if(D===2){if(n.length<2||c!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const I=n.lastIndexOf(r);I===-1?(n="",c=0):(n=n.slice(0,I),c=n.length-1-n.lastIndexOf(r)),m=k,D=0;continue}else if(n.length!==0){n="",c=0,m=k,D=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",c=2)}else n.length>0?n+=`${r}${i.slice(m+1,k)}`:n=i.slice(m+1,k),c=k-m-1;m=k,D=0}else R===P&&D!==-1?++D:D=-1}return n}function E(i,o){f(o,"pathObject");const r=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${t}`:`${r}${i}${t}`:t}e.$ec={resolve(...i){let o="",r="",t=!1;for(let n=i.length-1;n>=-1;n--){let c;if(n>=0){if(c=i[n],y(c,"path"),c.length===0)continue}else o.length===0?c=S.cwd():(c=S.env[`=${o}`]||S.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==o.toLowerCase()&&c.charCodeAt(2)===a)&&(c=`${o}\\`));const m=c.length;let D=0,R="",k=!1;const I=c.charCodeAt(0);if(m===1)b(I)&&(D=1,k=!0);else if(b(I))if(k=!0,b(c.charCodeAt(1))){let F=2,U=F;for(;F<m&&!b(c.charCodeAt(F));)F++;if(F<m&&F!==U){const T=c.slice(U,F);for(U=F;F<m&&b(c.charCodeAt(F));)F++;if(F<m&&F!==U){for(U=F;F<m&&!b(c.charCodeAt(F));)F++;(F===m||F!==U)&&(R=`\\\\${T}\\${c.slice(U,F)}`,D=F)}}}else D=1;else h(I)&&c.charCodeAt(1)===$&&(R=c.slice(0,2),D=2,m>2&&b(c.charCodeAt(2))&&(k=!0,D=3));if(R.length>0)if(o.length>0){if(R.toLowerCase()!==o.toLowerCase())continue}else o=R;if(t){if(o.length>0)break}else if(r=`${c.slice(D)}\\${r}`,t=k,k&&o.length>0)break}return r=l(r,!t,"\\",b),t?`${o}\\${r}`:`${o}${r}`||"."},normalize(i){y(i,"path");const o=i.length;if(o===0)return".";let r=0,t,n=!1;const c=i.charCodeAt(0);if(o===1)return g(c)?"\\":i;if(b(c))if(n=!0,b(i.charCodeAt(1))){let D=2,R=D;for(;D<o&&!b(i.charCodeAt(D));)D++;if(D<o&&D!==R){const k=i.slice(R,D);for(R=D;D<o&&b(i.charCodeAt(D));)D++;if(D<o&&D!==R){for(R=D;D<o&&!b(i.charCodeAt(D));)D++;if(D===o)return`\\\\${k}\\${i.slice(R)}\\`;D!==R&&(t=`\\\\${k}\\${i.slice(R,D)}`,r=D)}}}else r=1;else h(c)&&i.charCodeAt(1)===$&&(t=i.slice(0,2),r=2,o>2&&b(i.charCodeAt(2))&&(n=!0,r=3));let m=r<o?l(i.slice(r),!n,"\\",b):"";return m.length===0&&!n&&(m="."),m.length>0&&b(i.charCodeAt(o-1))&&(m+="\\"),t===void 0?n?`\\${m}`:m:n?`${t}\\${m}`:`${t}${m}`},isAbsolute(i){y(i,"path");const o=i.length;if(o===0)return!1;const r=i.charCodeAt(0);return b(r)||o>2&&h(r)&&i.charCodeAt(1)===$&&b(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,r;for(let c=0;c<i.length;++c){const m=i[c];y(m,"path"),m.length>0&&(o===void 0?o=r=m:o+=`\\${m}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof r=="string"&&b(r.charCodeAt(0))){++n;const c=r.length;c>1&&b(r.charCodeAt(1))&&(++n,c>2&&(b(r.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&b(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$ec.normalize(o)},relative(i,o){if(y(i,"from"),y(o,"to"),i===o)return"";const r=e.$ec.resolve(i),t=e.$ec.resolve(o);if(r===t||(i=r.toLowerCase(),o=t.toLowerCase(),i===o))return"";let n=0;for(;n<i.length&&i.charCodeAt(n)===a;)n++;let c=i.length;for(;c-1>n&&i.charCodeAt(c-1)===a;)c--;const m=c-n;let D=0;for(;D<o.length&&o.charCodeAt(D)===a;)D++;let R=o.length;for(;R-1>D&&o.charCodeAt(R-1)===a;)R--;const k=R-D,I=m<k?m:k;let F=-1,U=0;for(;U<I;U++){const x=i.charCodeAt(n+U);if(x!==o.charCodeAt(D+U))break;x===a&&(F=U)}if(U!==I){if(F===-1)return t}else{if(k>I){if(o.charCodeAt(D+U)===a)return t.slice(D+U+1);if(U===2)return t.slice(D+U)}m>I&&(i.charCodeAt(n+U)===a?F=U:U===2&&(F=3)),F===-1&&(F=0)}let T="";for(U=n+F+1;U<=c;++U)(U===c||i.charCodeAt(U)===a)&&(T+=T.length===0?"..":"\\..");return D+=F,T.length>0?`${T}${t.slice(D,R)}`:(t.charCodeAt(D)===a&&++D,t.slice(D,R))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$ec.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===a){if(o.charCodeAt(1)===a){const r=o.charCodeAt(2);if(r!==p&&r!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===$&&o.charCodeAt(2)===a)return`\\\\?\\${o}`;return i},dirname(i){y(i,"path");const o=i.length;if(o===0)return".";let r=-1,t=0;const n=i.charCodeAt(0);if(o===1)return b(n)?i:".";if(b(n)){if(r=t=1,b(i.charCodeAt(1))){let D=2,R=D;for(;D<o&&!b(i.charCodeAt(D));)D++;if(D<o&&D!==R){for(R=D;D<o&&b(i.charCodeAt(D));)D++;if(D<o&&D!==R){for(R=D;D<o&&!b(i.charCodeAt(D));)D++;if(D===o)return i;D!==R&&(r=t=D+1)}}}}else h(n)&&i.charCodeAt(1)===$&&(r=o>2&&b(i.charCodeAt(2))?3:2,t=r);let c=-1,m=!0;for(let D=o-1;D>=t;--D)if(b(i.charCodeAt(D))){if(!m){c=D;break}}else m=!1;if(c===-1){if(r===-1)return".";c=r}return i.slice(0,c)},basename(i,o){o!==void 0&&y(o,"ext"),y(i,"path");let r=0,t=-1,n=!0,c;if(i.length>=2&&h(i.charCodeAt(0))&&i.charCodeAt(1)===$&&(r=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let m=o.length-1,D=-1;for(c=i.length-1;c>=r;--c){const R=i.charCodeAt(c);if(b(R)){if(!n){r=c+1;break}}else D===-1&&(n=!1,D=c+1),m>=0&&(R===o.charCodeAt(m)?--m===-1&&(t=c):(m=-1,t=D))}return r===t?t=D:t===-1&&(t=i.length),i.slice(r,t)}for(c=i.length-1;c>=r;--c)if(b(i.charCodeAt(c))){if(!n){r=c+1;break}}else t===-1&&(n=!1,t=c+1);return t===-1?"":i.slice(r,t)},extname(i){y(i,"path");let o=0,r=-1,t=0,n=-1,c=!0,m=0;i.length>=2&&i.charCodeAt(1)===$&&h(i.charCodeAt(0))&&(o=t=2);for(let D=i.length-1;D>=o;--D){const R=i.charCodeAt(D);if(b(R)){if(!c){t=D+1;break}continue}n===-1&&(c=!1,n=D+1),R===P?r===-1?r=D:m!==1&&(m=1):r!==-1&&(m=-1)}return r===-1||n===-1||m===0||m===1&&r===n-1&&r===t+1?"":i.slice(r,n)},format:E.bind(null,"\\"),parse(i){y(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.length;let t=0,n=i.charCodeAt(0);if(r===1)return b(n)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(b(n)){if(t=1,b(i.charCodeAt(1))){let F=2,U=F;for(;F<r&&!b(i.charCodeAt(F));)F++;if(F<r&&F!==U){for(U=F;F<r&&b(i.charCodeAt(F));)F++;if(F<r&&F!==U){for(U=F;F<r&&!b(i.charCodeAt(F));)F++;F===r?t=F:F!==U&&(t=F+1)}}}}else if(h(n)&&i.charCodeAt(1)===$){if(r<=2)return o.root=o.dir=i,o;if(t=2,b(i.charCodeAt(2))){if(r===3)return o.root=o.dir=i,o;t=3}}t>0&&(o.root=i.slice(0,t));let c=-1,m=t,D=-1,R=!0,k=i.length-1,I=0;for(;k>=t;--k){if(n=i.charCodeAt(k),b(n)){if(!R){m=k+1;break}continue}D===-1&&(R=!1,D=k+1),n===P?c===-1?c=k:I!==1&&(I=1):c!==-1&&(I=-1)}return D!==-1&&(c===-1||I===0||I===1&&c===D-1&&c===m+1?o.base=o.name=i.slice(m,D):(o.name=i.slice(m,c),o.base=i.slice(m,D),o.ext=i.slice(c,D))),m>0&&m!==t?o.dir=i.slice(0,m-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(w){const i=/\\/g;return()=>{const o=S.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>S.cwd()})();e.$fc={resolve(...i){let o="",r=!1;for(let t=i.length-1;t>=-1&&!r;t--){const n=t>=0?i[t]:u();y(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===d)}return o=l(o,!r,"/",g),r?`/${o}`:o.length>0?o:"."},normalize(i){if(y(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===d,r=i.charCodeAt(i.length-1)===d;return i=l(i,!o,"/",g),i.length===0?o?"/":r?"./":".":(r&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return y(i,"path"),i.length>0&&i.charCodeAt(0)===d},join(...i){if(i.length===0)return".";let o;for(let r=0;r<i.length;++r){const t=i[r];y(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.$fc.normalize(o)},relative(i,o){if(y(i,"from"),y(o,"to"),i===o||(i=e.$fc.resolve(i),o=e.$fc.resolve(o),i===o))return"";const r=1,t=i.length,n=t-r,c=1,m=o.length-c,D=n<m?n:m;let R=-1,k=0;for(;k<D;k++){const F=i.charCodeAt(r+k);if(F!==o.charCodeAt(c+k))break;F===d&&(R=k)}if(k===D)if(m>D){if(o.charCodeAt(c+k)===d)return o.slice(c+k+1);if(k===0)return o.slice(c+k)}else n>D&&(i.charCodeAt(r+k)===d?R=k:k===0&&(R=0));let I="";for(k=r+R+1;k<=t;++k)(k===t||i.charCodeAt(k)===d)&&(I+=I.length===0?"..":"/..");return`${I}${o.slice(c+R)}`},toNamespacedPath(i){return i},dirname(i){if(y(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===d;let r=-1,t=!0;for(let n=i.length-1;n>=1;--n)if(i.charCodeAt(n)===d){if(!t){r=n;break}}else t=!1;return r===-1?o?"/":".":o&&r===1?"//":i.slice(0,r)},basename(i,o){o!==void 0&&y(o,"ext"),y(i,"path");let r=0,t=-1,n=!0,c;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let m=o.length-1,D=-1;for(c=i.length-1;c>=0;--c){const R=i.charCodeAt(c);if(R===d){if(!n){r=c+1;break}}else D===-1&&(n=!1,D=c+1),m>=0&&(R===o.charCodeAt(m)?--m===-1&&(t=c):(m=-1,t=D))}return r===t?t=D:t===-1&&(t=i.length),i.slice(r,t)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===d){if(!n){r=c+1;break}}else t===-1&&(n=!1,t=c+1);return t===-1?"":i.slice(r,t)},extname(i){y(i,"path");let o=-1,r=0,t=-1,n=!0,c=0;for(let m=i.length-1;m>=0;--m){const D=i.charCodeAt(m);if(D===d){if(!n){r=m+1;break}continue}t===-1&&(n=!1,t=m+1),D===P?o===-1?o=m:c!==1&&(c=1):o!==-1&&(c=-1)}return o===-1||t===-1||c===0||c===1&&o===t-1&&o===r+1?"":i.slice(o,t)},format:E.bind(null,"/"),parse(i){y(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const r=i.charCodeAt(0)===d;let t;r?(o.root="/",t=1):t=0;let n=-1,c=0,m=-1,D=!0,R=i.length-1,k=0;for(;R>=t;--R){const I=i.charCodeAt(R);if(I===d){if(!D){c=R+1;break}continue}m===-1&&(D=!1,m=R+1),I===P?n===-1?n=R:k!==1&&(k=1):n!==-1&&(k=-1)}if(m!==-1){const I=c===0&&r?1:c;n===-1||k===0||k===1&&n===m-1&&n===c+1?o.base=o.name=i.slice(I,m):(o.name=i.slice(I,n),o.base=i.slice(I,m),o.ext=i.slice(n,m))}return c>0?o.dir=i.slice(0,c-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=w?e.$ec.normalize:e.$fc.normalize,e.$hc=w?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=w?e.$ec.join:e.$fc.join,e.$jc=w?e.$ec.resolve:e.$fc.resolve,e.$kc=w?e.$ec.relative:e.$fc.relative,e.$lc=w?e.$ec.dirname:e.$fc.dirname,e.$mc=w?e.$ec.basename:e.$fc.basename,e.$nc=w?e.$ec.extname:e.$fc.extname,e.$oc=w?e.$ec.format:e.$fc.format,e.$pc=w?e.$ec.parse:e.$fc.parse,e.$qc=w?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=w?e.$ec.sep:e.$fc.sep,e.$sc=w?e.$ec.delimiter:e.$fc.delimiter}),define(ne[33],re([0,1,9,4,27,12]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function C(c){return c===47||c===92}e.$Tf=C;function P(c){return c.replace(/[\\/]/g,S.$fc.sep)}e.$Uf=P;function d(c){return c.indexOf("/")===-1&&(c=P(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$Vf=d;function a(c,m=S.$fc.sep){if(!c)return"";const D=c.length,R=c.charCodeAt(0);if(C(R)){if(C(c.charCodeAt(1))&&!C(c.charCodeAt(2))){let I=3;const F=I;for(;I<D&&!C(c.charCodeAt(I));I++);if(F!==I&&!C(c.charCodeAt(I+1))){for(I+=1;I<D;I++)if(C(c.charCodeAt(I)))return c.slice(0,I+1).replace(/[\\/]/g,m)}}return m}else if(g(R)&&c.charCodeAt(1)===58)return C(c.charCodeAt(2))?c.slice(0,2)+m:c.slice(0,2);let k=c.indexOf("://");if(k!==-1){for(k+=3;k<D;k++)if(C(c.charCodeAt(k)))return c.slice(0,k+1)}return""}e.$Wf=a;function $(c){if(!A.$i||!c||c.length<5)return!1;let m=c.charCodeAt(0);if(m!==92||(m=c.charCodeAt(1),m!==92))return!1;let D=2;const R=D;for(;D<c.length&&(m=c.charCodeAt(D),m!==92);D++);return!(R===D||(m=c.charCodeAt(D+1),isNaN(m)||m===92))}e.$Xf=$;const p=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(c,m=A.$i){const D=m?p:v;return!(!c||c.length===0||/^\s+$/.test(c)||(D.lastIndex=0,D.test(c))||m&&f.test(c)||c==="."||c===".."||m&&c[c.length-1]==="."||m&&c.length!==c.trim().length||c.length>255)}e.$Yf=y;function w(c,m,D){const R=c===m;return!D||R?R:!c||!m?!1:(0,s.$5e)(c,m)}e.$Zf=w;function b(c,m,D,R=S.sep){if(c===m)return!0;if(!c||!m||m.length>c.length)return!1;if(D){if(!(0,s.$6e)(c,m))return!1;if(m.length===c.length)return!0;let I=m.length;return m.charAt(m.length-1)===R&&I--,c.charAt(I)===R}return m.charAt(m.length-1)!==R&&(m+=R),c.indexOf(m)===0}e.$1f=b;function g(c){return c>=65&&c<=90||c>=97&&c<=122}e.$2f=g;function h(c,m){return A.$i&&c.endsWith(":")&&(c+=S.sep),(0,S.$hc)(c)||(c=(0,S.$ic)(m,c)),c=(0,S.$gc)(c),A.$i?(c=(0,s.$Ne)(c,S.sep),c.endsWith(":")&&(c+=S.sep)):(c=(0,s.$Ne)(c,S.sep),c||(c=S.sep)),c}e.$3f=h;function l(c){const m=(0,S.$gc)(c);return A.$i?c.length>3?!1:E(m)&&(c.length===2||m.charCodeAt(2)===92):m===S.$fc.sep}e.$4f=l;function E(c,m=A.$i){return m?g(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$5f=E;function u(c,m=A.$i){return E(c,m)?c[0]:void 0}e.$6f=u;function i(c,m,D){return m.length>c.length?-1:c===m?0:(D&&(c=c.toLowerCase(),m=m.toLowerCase()),c.indexOf(m))}e.$7f=i;function o(c){const m=c.split(":");let D,R,k;for(const I of m){const F=Number(I);(0,M.$Ff)(F)?R===void 0?R=F:k===void 0&&(k=F):D=D?[D,I].join(":"):I}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:R!==void 0?R:void 0,column:k!==void 0?k:R!==void 0?1:void 0}}e.$8f=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(c,m,D=8){let R="";for(let I=0;I<D;I++){let F;I===0&&A.$i&&!m&&(D===3||D===4)?F=t:F=r,R+=F.charAt(Math.floor(Math.random()*F.length))}let k;return m?k=`${m}-${R}`:k=R,c?(0,S.$ic)(c,k):k}e.$9f=n}),define(ne[76],re([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A||(e.Source=A={}));var s;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(P,...d){const a=d.reduce((v,f)=>(v[f]=!0,v),{}),$=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!a[v]).forEach(v=>{for(let f=0;f<$.length;f++)if(v.search($[f])!==-1){delete P[v];break}})}e.$El=M;function C(P){P&&(delete P.DEBUG,S.$j&&delete P.DYLD_LIBRARY_PATH,S.$k&&delete P.LD_PRELOAD)}e.$Fl=C}),define(ne[7],re([0,1,9,4]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,C=/^\/\//;function P(t,n){if(!t.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!s.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!M.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(t,n){return!t&&!n?"file":t}function a(t,n){switch(t){case"https":case"http":case"file":n?n[0]!==p&&(n=p+n):n=p;break}return n}const $="",p="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,c,m,D,R,k=!1){typeof n=="object"?(this.scheme=n.scheme||$,this.authority=n.authority||$,this.path=n.path||$,this.query=n.query||$,this.fragment=n.fragment||$):(this.scheme=d(n,k),this.authority=c||$,this.path=a(this.scheme,m||$),this.query=D||$,this.fragment=R||$,P(this,k))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:c,authority:m,path:D,query:R,fragment:k}=n;return c===void 0?c=this.scheme:c===null&&(c=$),m===void 0?m=this.authority:m===null&&(m=$),D===void 0?D=this.path:D===null&&(D=$),R===void 0?R=this.query:R===null&&(R=$),k===void 0?k=this.fragment:k===null&&(k=$),c===this.scheme&&m===this.authority&&D===this.path&&R===this.query&&k===this.fragment?this:new b(c,m,D,R,k)}static parse(n,c=!1){const m=v.exec(n);return m?new b(m[2]||$,r(m[4]||$),r(m[5]||$),r(m[7]||$),r(m[9]||$),c):new b($,$,$,$,$)}static file(n){let c=$;if(A.$i&&(n=n.replace(/\\/g,p)),n[0]===p&&n[1]===p){const m=n.indexOf(p,2);m===-1?(c=n.substring(2),n=p):(c=n.substring(2,m),n=n.substring(m)||p)}return new b("file",c,n,$,$)}static from(n,c){return new b(n.scheme,n.authority,n.path,n.query,n.fragment,c)}static joinPath(n,...c){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return A.$i&&n.scheme==="file"?m=f.file(S.$ec.join(E(n,!0),...c)).path:m=S.$fc.join(n.path,...c),n.with({path:m})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const c=new b(n);return c._formatted=n.external??null,c._fsPath=n._sep===w?n.fsPath??null:null,c}}else return n}}e.URI=f;function y(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$uc=y;const w=A.$i?1:void 0;class b extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=w),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(t,n,c){let m,D=-1;for(let R=0;R<t.length;R++){const k=t.charCodeAt(R);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||c&&k===91||c&&k===93||c&&k===58)D!==-1&&(m+=encodeURIComponent(t.substring(D,R)),D=-1),m!==void 0&&(m+=t.charAt(R));else{m===void 0&&(m=t.substr(0,R));const I=g[k];I!==void 0?(D!==-1&&(m+=encodeURIComponent(t.substring(D,R)),D=-1),m+=I):D===-1&&(D=R)}}return D!==-1&&(m+=encodeURIComponent(t.substring(D))),m!==void 0?m:t}function l(t){let n;for(let c=0;c<t.length;c++){const m=t.charCodeAt(c);m===35||m===63?(n===void 0&&(n=t.substr(0,c)),n+=g[m]):n!==void 0&&(n+=t[c])}return n!==void 0?n:t}function E(t,n){let c;return t.authority&&t.path.length>1&&t.scheme==="file"?c=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?n?c=t.path.substr(1):c=t.path[1].toLowerCase()+t.path.substr(2):c=t.path,A.$i&&(c=c.replace(/\//g,"\\")),c}e.$vc=E;function u(t,n){const c=n?l:h;let m="",{scheme:D,authority:R,path:k,query:I,fragment:F}=t;if(D&&(m+=D,m+=":"),(R||D==="file")&&(m+=p,m+=p),R){let U=R.indexOf("@");if(U!==-1){const T=R.substr(0,U);R=R.substr(U+1),U=T.lastIndexOf(":"),U===-1?m+=c(T,!1,!1):(m+=c(T.substr(0,U),!1,!1),m+=":",m+=c(T.substr(U+1),!1,!0)),m+="@"}R=R.toLowerCase(),U=R.lastIndexOf(":"),U===-1?m+=c(R,!1,!0):(m+=c(R.substr(0,U),!1,!0),m+=R.substr(U))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const U=k.charCodeAt(1);U>=65&&U<=90&&(k=`/${String.fromCharCode(U+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const U=k.charCodeAt(0);U>=65&&U<=90&&(k=`${String.fromCharCode(U+32)}:${k.substr(2)}`)}m+=c(k,!0,!1)}return I&&(m+="?",m+=c(I,!1,!1)),F&&(m+="#",m+=n?F:h(F,!1,!1)),m}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(o)?t.replace(o,n=>i(n)):t}}),define(ne[154],re([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$5p=e.$4p=e.$3p=void 0;function A(a){const $=a;return $&&typeof $.type=="string"&&typeof $.severity=="string"}e.$3p=A;function s(a){const $=[];let p;try{const v=JSON.parse(a.arguments),f=v[v.length-1];f&&f.__$stack&&(v.pop(),p=f.__$stack),$.push(...v)}catch{$.push("Unable to log remote console arguments",a.arguments)}return{args:$,stack:p}}e.$4p=s;function M(a){if(typeof a!="string")return M(s(a).stack);const $=a;if($){const p=C($),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(v&&v.length===4)return{uri:S.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$5p=M;function C(a){if(!a)return a;const $=a.indexOf(`
`);return $===-1?a:a.substring(0,$)}function P(a,$){const{args:p,stack:v}=s(a),f=typeof p[0]=="string"&&p.length===1;let y=C(v);y&&(y=`(${y.trim()})`);let w=[];if(typeof p[0]=="string"?y&&f?w=[`%c[${$}] %c${p[0]} %c${y}`,d("blue"),d(""),d("grey")]:w=[`%c[${$}] %c${p[0]}`,d("blue"),d(""),...p.slice(1)]:w=[`%c[${$}]%`,d("blue"),...p],y&&!f&&w.push(y),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,w)}e.log=P;function d(a){return`color: ${a}`}}),define(ne[77],re([0,1,18,7]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=void 0;function s(d){return JSON.stringify(d,C)}e.$ph=s;function M(d){let a=JSON.parse(d);return a=P(a),a}e.$qh=M;function C(d,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function P(d,a=0){if(!d||a>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return A.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof S.$ee||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let $=0;$<d.length;++$)d[$]=P(d[$],a+1);else for(const $ in d)Object.hasOwnProperty.call(d,$)&&(d[$]=P(d[$],a+1))}return d}e.$rh=P}),define(ne[13],re([0,1,14,4,7]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.Schemas=void 0;var M;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$0f="vscode-tkn",e.$$f="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${M.vscodeRemoteResource}`}set($,p,v){this.a[$]=p,this.b[$]=v}setConnectionToken($,p){this.c[$]=p}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(b){return S.$Z(b),$}const p=$.authority;let v=this.a[p];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const f=this.b[p],y=this.c[p];let w=`path=${encodeURIComponent($.path)}`;return typeof y=="string"&&(w+=`&${e.$$f}=${encodeURIComponent(y)}`),s.URI.from({scheme:A.$o?this.d:M.vscodeRemoteResource,authority:`${v}:${f}`,path:this.f,query:w})}}e.$_f=new C,e.$ag="vs/../../extensions",e.$bg="vs/../../node_modules",e.$cg="vs/../../node_modules.asar",e.$dg="vs/../../node_modules.asar.unpacked",e.$eg="vscode-app";class P{static{this.a=e.$eg}asBrowserUri($){const p=this.b($,J);return this.uriToBrowserUri(p)}uriToBrowserUri($){return $.scheme===M.vscodeRemote?e.$_f.rewrite($):$.scheme===M.file&&(A.$m||A.$q===`${M.vscodeFileResource}://${P.a}`)?$.with({scheme:M.vscodeFileResource,authority:$.authority||P.a,query:null,fragment:null}):$}asFileUri($){const p=this.b($,J);return this.uriToFileUri(p)}uriToFileUri($){return $.scheme===M.vscodeFileResource?$.with({scheme:M.file,authority:$.authority!==P.a?$.authority:null,query:null,fragment:null}):$}b($,p){return s.URI.isUri($)?$:s.URI.parse(p.toUrl($))}}e.$fg=new P;var d;(function(a){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze($.get("3"));const p="vscode-coi";function v(y){let w;typeof y=="string"?w=new URL(y).searchParams:y instanceof URL?w=y.searchParams:s.URI.isUri(y)&&(w=new URL(y.toString(!0)).searchParams);const b=w?.get(p);if(b)return $.get(b)}a.getHeadersFromQuery=v;function f(y,w,b){if(!globalThis.crossOriginIsolated)return;const g=w&&b?"3":b?"2":"1";y instanceof URLSearchParams?y.set(p,g):y[p]=g}a.addSearchParam=f})(d||(e.COI=d={}))}),define(ne[19],re([0,1,33,13,9,4,27,7]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ig=e.DataUri=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=void 0;function d(f){return(0,P.$vc)(f,!0)}e.$mg=d;class a{constructor(y){this.a=y}compare(y,w,b=!1){return y===w?0:(0,C.$Xe)(this.getComparisonKey(y,b),this.getComparisonKey(w,b))}isEqual(y,w,b=!1){return y===w?!0:!y||!w?!1:this.getComparisonKey(y,b)===this.getComparisonKey(w,b)}getComparisonKey(y,w=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,w,b=!1){if(y.scheme===w.scheme){if(y.scheme===A.Schemas.file)return S.$1f(d(y),d(w),this.a(y))&&y.query===w.query&&(b||y.fragment===w.fragment);if((0,e.$Dg)(y.authority,w.authority))return S.$1f(y.path,w.path,this.a(y),"/")&&y.query===w.query&&(b||y.fragment===w.fragment)}return!1}joinPath(y,...w){return P.URI.joinPath(y,...w)}basenameOrAuthority(y){return(0,e.$vg)(y)||y.authority}basename(y){return s.$fc.basename(y.path)}extname(y){return s.$fc.extname(y.path)}dirname(y){if(y.path.length===0)return y;let w;return y.scheme===A.Schemas.file?w=P.URI.file(s.$lc(d(y))).path:(w=s.$fc.dirname(y.path),y.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),w="/")),y.with({path:w})}normalizePath(y){if(!y.path.length)return y;let w;return y.scheme===A.Schemas.file?w=P.URI.file(s.$gc(d(y))).path:w=s.$fc.normalize(y.path),y.with({path:w})}relativePath(y,w){if(y.scheme!==w.scheme||!(0,e.$Dg)(y.authority,w.authority))return;if(y.scheme===A.Schemas.file){const h=s.$kc(d(y),d(w));return M.$i?S.$Uf(h):h}let b=y.path||"/";const g=w.path||"/";if(this.a(y)){let h=0;for(const l=Math.min(b.length,g.length);h<l&&!(b.charCodeAt(h)!==g.charCodeAt(h)&&b.charAt(h).toLowerCase()!==g.charAt(h).toLowerCase());h++);b=g.substr(0,h)+b.substr(h)}return s.$fc.relative(b,g)}resolvePath(y,w){if(y.scheme===A.Schemas.file){const b=P.URI.file(s.$jc(d(y),w));return y.with({authority:b.authority,path:b.path})}return w=S.$Vf(w),y.with({path:s.$fc.resolve(y.path,w)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,w){return y===w||y!==void 0&&w!==void 0&&(0,C.$5e)(y,w)}hasTrailingPathSeparator(y,w=s.sep){if(y.scheme===A.Schemas.file){const b=d(y);return b.length>S.$Wf(b).length&&b[b.length-1]===w}else{const b=y.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,w=s.sep){return(0,e.$Eg)(y,w)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,w=s.sep){let b=!1;if(y.scheme===A.Schemas.file){const g=d(y);b=g!==void 0&&g.length===S.$Wf(g).length&&g[g.length-1]===w}else{w="/";const g=y.path;b=g.length===1&&g.charCodeAt(g.length-1)===47}return!b&&!(0,e.$Eg)(y,w)?y.with({path:y.path+"/"}):y}}e.$ng=a,e.$og=new a(()=>!1),e.$pg=new a(f=>f.scheme===A.Schemas.file?!M.$k:!0),e.$qg=new a(f=>!0),e.$rg=e.$og.isEqual.bind(e.$og),e.$sg=e.$og.isEqualOrParent.bind(e.$og),e.$tg=e.$og.getComparisonKey.bind(e.$og),e.$ug=e.$og.basenameOrAuthority.bind(e.$og),e.$vg=e.$og.basename.bind(e.$og),e.$wg=e.$og.extname.bind(e.$og),e.$xg=e.$og.dirname.bind(e.$og),e.$yg=e.$og.joinPath.bind(e.$og),e.$zg=e.$og.normalizePath.bind(e.$og),e.$Ag=e.$og.relativePath.bind(e.$og),e.$Bg=e.$og.resolvePath.bind(e.$og),e.$Cg=e.$og.isAbsolutePath.bind(e.$og),e.$Dg=e.$og.isEqualAuthority.bind(e.$og),e.$Eg=e.$og.hasTrailingPathSeparator.bind(e.$og),e.$Fg=e.$og.removeTrailingPathSeparator.bind(e.$og),e.$Gg=e.$og.addTrailingPathSeparator.bind(e.$og);function $(f,y){const w=[];for(let b=0;b<f.length;b++){const g=y(f[b]);f.some((h,l)=>l===b?!1:(0,e.$sg)(g,y(h)))||w.push(f[b])}return w}e.$Hg=$;var p;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function y(w){const b=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(l=>{const[E,u]=l.split(":");E&&u&&b.set(E,u)});const h=w.path.substring(0,w.path.indexOf(";"));return h&&b.set(f.META_DATA_MIME,h),b}f.parseMetaData=y})(p||(e.DataUri=p={}));function v(f,y,w){if(y){let b=f.path;return b&&b[0]!==s.$fc.sep&&(b=s.$fc.sep+b),f.with({scheme:w,authority:y,path:b})}return f.with({scheme:w})}e.$Ig=v}),define(ne[8],re([0,1,22,14,3,2,19,4,143]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.Promises=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0;function a(V){return!!V&&typeof V.then=="function"}e.$Jg=a;function $(V){const L=new S.$1d,B=V(L.token),W=new Promise((X,he)=>{const de=L.token.onCancellationRequested(()=>{de.dispose(),L.dispose(),he(new A.$4)});Promise.resolve(B).then(le=>{de.dispose(),L.dispose(),X(le)},le=>{de.dispose(),L.dispose(),he(le)})});return new class{cancel(){L.cancel()}then(X,he){return W.then(X,he)}catch(X){return this.then(void 0,X)}finally(X){return W.finally(X)}}}e.$Kg=$;function p(V,L,B){return new Promise((W,X)=>{const he=L.onCancellationRequested(()=>{he.dispose(),W(B)});V.then(W,X).finally(()=>he.dispose())})}e.$Lg=p;function v(V,L){return new Promise((B,W)=>{const X=L.onCancellationRequested(()=>{X.dispose(),W(new A.$4)});V.then(B,W).finally(()=>X.dispose())})}e.$Mg=v;async function f(V){let L=-1;const B=V.map((W,X)=>W.then(he=>(L=X,he)));try{return await Promise.race(B)}finally{V.forEach((W,X)=>{X!==L&&W.cancel()})}}e.$Ng=f;function y(V,L,B){let W;const X=setTimeout(()=>{W?.(void 0),B?.()},L);return Promise.race([V.finally(()=>clearTimeout(X)),new Promise(he=>W=he)])}e.$Og=y;function w(V){return new Promise((L,B)=>{const W=V();a(W)?W.then(L,B):L(W)})}e.$Pg=w;class b{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(L){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=L,!this.b){const B=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(B,B).then(W)})}return new Promise((B,W)=>{this.b.then(B,W)})}return this.a=L(),new Promise((B,W)=>{this.a.then(X=>{this.a=null,B(X)},X=>{this.a=null,W(X)})})}dispose(){this.f=!0}}e.$Qg=b;class g{constructor(){this.a=Promise.resolve(null)}queue(L){return this.a=this.a.then(()=>L(),()=>L())}}e.$Rg=g;class h{constructor(){this.a=new Map}queue(L,B){const X=(this.a.get(L)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(L)===X&&this.a.delete(L)});return this.a.set(L,X),X}}e.$Sg=h;const l=(V,L)=>{let B=!0;const W=setTimeout(()=>{B=!1,L()},V);return{isTriggered:()=>B,dispose:()=>{clearTimeout(W),B=!1}}},E=V=>{let L=!0;return queueMicrotask(()=>{L&&(L=!1,V())}),{isTriggered:()=>L,dispose:()=>{L=!1}}};class u{constructor(L){this.defaultDelay=L,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(L,B=this.defaultDelay){this.g=L,this.h(),this.b||(this.b=new Promise((X,he)=>{this.d=X,this.f=he}).then(()=>{if(this.b=null,this.d=null,this.g){const X=this.g;return this.g=null,X()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=B===d.$Nd?E(W):l(B,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Tg=u;class i{constructor(L){this.a=new u(L),this.b=new b}trigger(L,B){return this.a.trigger(()=>this.b.queue(L),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ug=i;class o{constructor(){this.a=!1,this.b=new Promise((L,B)=>{this.d=L})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Vg=o;class r extends o{constructor(L){super(),this.f=setTimeout(()=>this.open(),L)}open(){clearTimeout(this.f),super.open()}}e.$Wg=r;function t(V,L){return L?new Promise((B,W)=>{const X=setTimeout(()=>{he.dispose(),B()},V),he=L.onCancellationRequested(()=>{clearTimeout(X),he.dispose(),W(new A.$4)})}):$(B=>t(V,B))}e.$Xg=t;function n(V,L=0,B){const W=setTimeout(()=>{V(),B&&X.dispose()},L),X=(0,M.$Pc)(()=>{clearTimeout(W),B?.deleteAndLeak(X)});return B?.add(X),X}e.$Yg=n;function c(V){const L=[];let B=0;const W=V.length;function X(){return B<W?V[B++]():null}function he(de){de!=null&&L.push(de);const le=X();return le?le.then(he):Promise.resolve(L)}return Promise.resolve(null).then(he)}e.$Zg=c;function m(V,L=W=>!!W,B=null){let W=0;const X=V.length,he=()=>{if(W>=X)return Promise.resolve(B);const de=V[W++];return Promise.resolve(de()).then(we=>L(we)?Promise.resolve(we):he())};return he()}e.$1g=m;function D(V,L=W=>!!W,B=null){if(V.length===0)return Promise.resolve(B);let W=V.length;const X=()=>{W=-1;for(const he of V)he.cancel?.()};return new Promise((he,de)=>{for(const le of V)le.then(we=>{--W>=0&&L(we)?(X(),he(we)):W===0&&he(B)}).catch(we=>{--W>=0&&(X(),de(we))})})}e.$2g=D;class R{constructor(L){this.a=0,this.d=L,this.f=[],this.b=0,this.g=new s.$Qd}get onDrained(){return this.g.event}get size(){return this.a}queue(L){return this.a++,new Promise((B,W)=>{this.f.push({factory:L,c:B,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const L=this.f.shift();this.b++;const B=L.factory();B.then(L.c,L.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$3g=R;class k extends R{constructor(){super(1)}}e.$4g=k;class I{constructor(){this.a=new G,this.b=0}queue(L){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,L())):this.a.run(this.b++,L())}}e.$5g=I;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const L=new H;return this.b.add(L),L.p}g(){for(const[,L]of this.a)if(L.size>0)return!1;return!0}queueFor(L,B=C.$og){const W=B.getComparisonKey(L);let X=this.a.get(W);if(!X){X=new k;const he=this.f++,de=s.Event.once(X.onDrained)(()=>{X?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(he,de),this.a.set(W,X)}return X}h(){this.g()&&this.j()}j(){for(const L of this.b)L.complete();this.b.clear()}dispose(){for(const[,L]of this.a)L.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$6g=F;class U{constructor(L,B){this.a=-1,typeof L=="function"&&typeof B=="number"&&this.setIfNotSet(L,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(L,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,L()},B)}setIfNotSet(L,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,L()},B))}}e.$7g=U;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(L,B,W=globalThis){this.cancel();const X=W.setInterval(()=>{L()},B);this.d=(0,M.$Pc)(()=>{W.clearInterval(X),this.d=void 0})}dispose(){this.cancel()}}e.$8g=T;class x{constructor(L,B){this.b=-1,this.a=L,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(L=this.d){this.cancel(),this.b=setTimeout(this.f,L)}get delay(){return this.d}set delay(L){this.d=L}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$9g=x;class Y{constructor(L,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=L,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(L=this.b){L%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(L/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$0g=Y;class ce extends x{constructor(L,B){super(L,B),this.j=[]}work(L){this.j.push(L),this.isScheduled()||this.schedule()}h(){const L=this.j;this.j=[],this.a?.(L)}dispose(){this.j=[],super.dispose()}}e.$$g=ce;class oe extends M.$Rc{constructor(L,B){super(),this.g=L,this.h=B,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(L){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+L.length>this.g.maxBufferedWork)return!1}else if(this.pending+L.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of L)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$_g=oe,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$bh=(V,L)=>{(0,P.$B)(()=>{if(B)return;const W=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:e.$bh=(V,L,B)=>{const W=V.requestIdleCallback(L,typeof B=="number"?{timeout:B}:void 0);let X=!1;return{dispose(){X||(X=!0,V.cancelIdleCallback(W))}}},e.$ah=V=>(0,e.$bh)(globalThis,V)}();class ae{constructor(L,B){this.g=!1,this.d=()=>{try{this.j=B()}catch(W){this.l=W}finally{this.g=!0}},this.f=(0,e.$bh)(L,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$ch=ae;class Z extends ae{constructor(L){super(globalThis,L)}}e.$dh=Z;async function K(V,L,B){let W;for(let X=0;X<B;X++)try{return await V()}catch(he){W=he,await t(L)}throw W}e.$eh=K;class G{isRunning(L){return typeof L=="number"?this.a?.taskId===L:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(L,B,W){return this.a={taskId:L,cancel:()=>W?.(),promise:B},B.then(()=>this.d(L),()=>this.d(L)),B}d(L){this.a&&L===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const L=this.b;this.b=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}queue(L){if(this.b)this.b.run=L;else{let B,W;const X=new Promise((he,de)=>{B=he,W=de});this.b={run:L,promise:X,promiseResolve:B,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$fh=G;class z{constructor(L,B=()=>Date.now()){this.d=L,this.f=B,this.a=0,this.b=0}increment(){const L=this.f();return L-this.a>this.d&&(this.a=L,this.b=0),this.b++,this.b}}e.$gh=z;var N;(function(V){V[V.Resolved=0]="Resolved",V[V.Rejected=1]="Rejected"})(N||(N={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((L,B)=>{this.a=L,this.b=B})}complete(L){return new Promise(B=>{this.a(L),this.d={outcome:0,value:L},B()})}error(L){return new Promise(B=>{this.b(L),this.d={outcome:1,value:L},B()})}cancel(){return this.error(new A.$4)}}e.$hh=H;var q;(function(V){async function L(W){let X;const he=await Promise.all(W.map(de=>de.then(le=>le,le=>{X||(X=le)})));if(typeof X<"u")throw X;return he}V.settled=L;function B(W){return new Promise(async(X,he)=>{try{await W(X,he)}catch(de){he(de)}})}V.withAsyncBody=B})(q||(e.Promises=q={}));var ee;(function(V){V[V.Initial=0]="Initial",V[V.DoneOK=1]="DoneOK",V[V.DoneError=2]="DoneError"})(ee||(ee={}));class se{static fromArray(L){return new se(B=>{B.emitMany(L)})}static fromPromise(L){return new se(async B=>{B.emitMany(await L)})}static fromPromises(L){return new se(async B=>{await Promise.all(L.map(async W=>B.emitOne(await W)))})}static merge(L){return new se(async B=>{await Promise.all(L.map(async W=>{for await(const X of W)B.emitOne(X)}))})}static{this.EMPTY=se.fromArray([])}constructor(L){this.a=0,this.b=[],this.d=null,this.f=new s.$Qd,queueMicrotask(async()=>{const B={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(L(B)),this.j()}catch(W){this.k(W)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(L<this.b.length)return{done:!1,value:this.b[L++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(L,B){return new se(async W=>{for await(const X of L)W.emitOne(B(X))})}map(L){return se.map(this,L)}static filter(L,B){return new se(async W=>{for await(const X of L)B(X)&&W.emitOne(X)})}filter(L){return se.filter(this,L)}static coalesce(L){return se.filter(L,B=>!!B)}coalesce(){return se.coalesce(this)}static async toPromise(L){const B=[];for await(const W of L)B.push(W);return B}toPromise(){return se.toPromise(this)}g(L){this.a===0&&(this.b.push(L),this.f.fire())}h(L){this.a===0&&(this.b=this.b.concat(L),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(L){this.a===0&&(this.a=2,this.d=L,this.f.fire())}}e.$ih=se;class Q extends se{constructor(L,B){super(B),this.l=L}cancel(){this.l.cancel()}}e.$jh=Q;function O(V){const L=new S.$1d,B=V(L.token);return new Q(L,async W=>{const X=L.token.onCancellationRequested(()=>{X.dispose(),L.dispose(),W.reject(new A.$4)});try{for await(const he of B){if(L.token.isCancellationRequested)return;W.emitOne(he)}X.dispose(),L.dispose()}catch(he){X.dispose(),L.dispose(),W.reject(he)}})}e.$kh=O;class j{constructor(){this.a=new H,this.b=new se(W=>{if(L){W.reject(L);return}return B&&W.emitMany(B),this.d=X=>W.reject(X),this.f=X=>W.emitOne(X),this.a.p});let L,B;this.f=W=>{B||(B=[]),B.push(W)},this.d=W=>{L||(L=W)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(L){this.d(L),this.a.complete()}emitOne(L){this.f(L)}}e.$lh=j}),define(ne[104],re([0,1,23,8,33,31,9,4,27]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=void 0;function a(){return Object.create(null)}e.$wj=a,e.$xj="**",e.$yj="/";const $="[/\\\\]",p="[^/\\\\]",v=/\//g;function f(K,G){switch(K){case 0:return"";case 1:return`${p}*?`;default:return`(?:${$}|${p}+${$}${G?`|${$}${p}+`:""})*?`}}function y(K,G){if(!K)return[];const z=[];let N=!1,H=!1,q="";for(const ee of K){switch(ee){case G:if(!N&&!H){z.push(q),q="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":H=!0;break;case"]":H=!1;break}q+=ee}return q&&z.push(q),z}e.$zj=y;function w(K){if(!K)return"";let G="";const z=y(K,e.$yj);if(z.every(N=>N===e.$xj))G=".*";else{let N=!1;z.forEach((H,q)=>{if(H===e.$xj){if(N)return;G+=f(2,q===z.length-1)}else{let ee=!1,se="",Q=!1,O="";for(const j of H){if(j!=="}"&&ee){se+=j;continue}if(Q&&(j!=="]"||!O)){let V;j==="-"?V=j:(j==="^"||j==="!")&&!O?V="^":j===e.$yj?V="":V=(0,d.$Ie)(j),O+=V;continue}switch(j){case"{":ee=!0;continue;case"[":Q=!0;continue;case"}":{const L=`(?:${y(se,",").map(B=>w(B)).join("|")})`;G+=L,ee=!1,se="";break}case"]":{G+="["+O+"]",Q=!1,O="";break}case"?":G+=p;continue;case"*":G+=f(1);continue;default:G+=(0,d.$Ie)(j)}}q<z.length-1&&(z[q+1]!==e.$xj||q+2<z.length)&&(G+=$)}N=H===e.$xj})}return G}const b=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Cc(1e4),o=function(){return!1},r=function(){return null};function t(K,G){if(!K)return r;let z;typeof K!="string"?z=K.pattern:z=K,z=z.trim();const N=`${z}_${!!G.trimForExclusions}`;let H=i.get(N);if(H)return n(H,K);let q;return b.test(z)?H=m(z.substr(4),z):(q=g.exec(c(z,G)))?H=D(q[1],z):(G.trimForExclusions?l:h).test(z)?H=R(z,G):(q=E.exec(c(z,G)))?H=k(q[1].substr(1),z,!0):(q=u.exec(c(z,G)))?H=k(q[1],z,!1):H=I(z),i.set(N,H),n(H,K)}function n(K,G){if(typeof G=="string")return K;const z=function(N,H){return(0,s.$1f)(N,G.base,!P.$k)?K((0,d.$Me)(N.substr(G.base.length),C.sep),H):null};return z.allBasenames=K.allBasenames,z.allPaths=K.allPaths,z.basenames=K.basenames,z.patterns=K.patterns,z}function c(K,G){return G.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function m(K,G){return function(z,N){return typeof z=="string"&&z.endsWith(K)?G:null}}function D(K,G){const z=`/${K}`,N=`\\${K}`,H=function(ee,se){return typeof ee!="string"?null:se?se===K?G:null:ee===K||ee.endsWith(z)||ee.endsWith(N)?G:null},q=[K];return H.basenames=q,H.patterns=[G],H.allBasenames=q,H}function R(K,G){const z=ae(K.slice(1,-1).split(",").map(se=>t(se,G)).filter(se=>se!==r),K),N=z.length;if(!N)return r;if(N===1)return z[0];const H=function(se,Q){for(let O=0,j=z.length;O<j;O++)if(z[O](se,Q))return K;return null},q=z.find(se=>!!se.allBasenames);q&&(H.allBasenames=q.allBasenames);const ee=z.reduce((se,Q)=>Q.allPaths?se.concat(Q.allPaths):se,[]);return ee.length&&(H.allPaths=ee),H}function k(K,G,z){const N=C.sep===C.$fc.sep,H=N?K:K.replace(v,C.sep),q=C.sep+H,ee=C.$fc.sep+K;let se;return z?se=function(Q,O){return typeof Q=="string"&&(Q===H||Q.endsWith(q)||!N&&(Q===K||Q.endsWith(ee)))?G:null}:se=function(Q,O){return typeof Q=="string"&&(Q===H||!N&&Q===K)?G:null},se.allPaths=[(z?"*/":"./")+K],se}function I(K){try{const G=new RegExp(`^${w(K)}$`);return function(z){return G.lastIndex=0,typeof z=="string"&&G.test(z)?K:null}}catch{return r}}function F(K,G,z){return!K||typeof G!="string"?!1:U(K)(G,void 0,z)}e.$Aj=F;function U(K,G={}){if(!K)return o;if(typeof K=="string"||T(K)){const z=t(K,G);if(z===r)return o;const N=function(H,q){return!!z(H,q)};return z.allBasenames&&(N.allBasenames=z.allBasenames),z.allPaths&&(N.allPaths=z.allPaths),N}return ce(K,G)}e.$Bj=U;function T(K){const G=K;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$Cj=T;function x(K){return K.allBasenames||[]}e.$Dj=x;function Y(K){return K.allPaths||[]}e.$Ej=Y;function ce(K,G){const z=ae(Object.getOwnPropertyNames(K).map(se=>oe(se,K[se],G)).filter(se=>se!==r)),N=z.length;if(!N)return r;if(!z.some(se=>!!se.requiresSiblings)){if(N===1)return z[0];const se=function(j,V){let L;for(let B=0,W=z.length;B<W;B++){const X=z[B](j,V);if(typeof X=="string")return X;(0,A.$Jg)(X)&&(L||(L=[]),L.push(X))}return L?(async()=>{for(const B of L){const W=await B;if(typeof W=="string")return W}return null})():null},Q=z.find(j=>!!j.allBasenames);Q&&(se.allBasenames=Q.allBasenames);const O=z.reduce((j,V)=>V.allPaths?j.concat(V.allPaths):j,[]);return O.length&&(se.allPaths=O),se}const H=function(se,Q,O){let j,V;for(let L=0,B=z.length;L<B;L++){const W=z[L];W.requiresSiblings&&O&&(Q||(Q=(0,C.$mc)(se)),j||(j=Q.substr(0,Q.length-(0,C.$nc)(se).length)));const X=W(se,Q,j,O);if(typeof X=="string")return X;(0,A.$Jg)(X)&&(V||(V=[]),V.push(X))}return V?(async()=>{for(const L of V){const B=await L;if(typeof B=="string")return B}return null})():null},q=z.find(se=>!!se.allBasenames);q&&(H.allBasenames=q.allBasenames);const ee=z.reduce((se,Q)=>Q.allPaths?se.concat(Q.allPaths):se,[]);return ee.length&&(H.allPaths=ee),H}function oe(K,G,z){if(G===!1)return r;const N=t(K,z);if(N===r)return r;if(typeof G=="boolean")return N;if(G){const H=G.when;if(typeof H=="string"){const q=(ee,se,Q,O)=>{if(!O||!N(ee,se))return null;const j=H.replace("$(basename)",()=>Q),V=O(j);return(0,A.$Jg)(V)?V.then(L=>L?K:null):V?K:null};return q.requiresSiblings=!0,q}}return N}function ae(K,G){const z=K.filter(se=>!!se.basenames);if(z.length<2)return K;const N=z.reduce((se,Q)=>{const O=Q.basenames;return O?se.concat(O):se},[]);let H;if(G){H=[];for(let se=0,Q=N.length;se<Q;se++)H.push(G)}else H=z.reduce((se,Q)=>{const O=Q.patterns;return O?se.concat(O):se},[]);const q=function(se,Q){if(typeof se!="string")return null;if(!Q){let j;for(j=se.length;j>0;j--){const V=se.charCodeAt(j-1);if(V===47||V===92)break}Q=se.substr(j)}const O=N.indexOf(Q);return O!==-1?H[O]:null};q.basenames=N,q.patterns=H,q.allBasenames=N;const ee=K.filter(se=>!se.basenames);return ee.push(q),ee}function Z(K,G){return(0,S.$tb)(K,G,(z,N)=>typeof z=="string"&&typeof N=="string"?z===N:typeof z!="string"&&typeof N!="string"?z.base===N.base&&z.pattern===N.pattern:!1)}e.$Fj=Z}),define(ne[46],re([0,1,23,33,9,4,19,27]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=void 0;function d(t,n){const{os:c,tildify:m,relative:D}=n;if(D){const I=a(t,D,c);if(typeof I=="string")return I}let R=t.fsPath;if(c===1&&!M.$i?R=R.replace(/\//g,"\\"):c!==1&&M.$i&&(R=R.replace(/\\/g,"/")),c!==1&&m?.userHome){const I=m.userHome.fsPath;let F;t.scheme!==m.userHome.scheme&&t.path[0]===s.$fc.sep&&t.path[1]!==s.$fc.sep?F=m.userHome.with({path:t.path}).fsPath:F=R,R=v(F,I,c)}return(c===1?s.$ec:s.$fc).normalize($(R,c===1))}e.$xv=d;function a(t,n,c){const m=c===1?s.$ec:s.$fc,D=c===3?C.$og:C.$qg,R=n.getWorkspace(),k=(0,S.$Nb)(R.folders);if(!k)return;t.scheme!==k.uri.scheme&&t.path[0]===s.$fc.sep&&t.path[1]!==s.$fc.sep&&(t=k.uri.with({path:t.path}));const I=n.getWorkspaceFolder(t);if(!I)return;let F;if(D.isEqual(I.uri,t)?F="":F=D.relativePath(I.uri,t)??"",F&&(F=m.normalize(F)),R.folders.length>1&&!n.noPrefix){const U=I.name?I.name:D.basenameOrAuthority(I.uri);F=F?`${U} \u2022 ${F}`:U}return F}function $(t,n=M.$i){return(0,A.$5f)(t,n)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$yv=$;let p=Object.create(null);function v(t,n,c=M.OS){if(c===1||!t||!n)return t;let m=p.original===n?p.normalized:void 0;m||(m=n,M.$i&&(m=(0,A.$Uf)(m)),m=`${(0,P.$Ne)(m,s.$fc.sep)}${s.$fc.sep}`,p={original:n,normalized:m});let D=t;return M.$i&&(D=(0,A.$Uf)(D)),(c===3?D.startsWith(m):(0,P.$6e)(D,m))?`~/${D.substr(m.length)}`:t}e.$zv=v;function f(t,n){return t.replace(/^~($|\/|\\)/,`${n}$1`)}e.$Av=f;const y="\u2026",w="\\\\",b="~";function g(t,n=s.sep){const c=new Array(t.length);let m=!1;for(let D=0;D<t.length;D++){const R=t[D];if(R===""){c[D]=`.${n}`;continue}if(!R){c[D]=R;continue}m=!0;let k="",I=R;I.indexOf(w)===0?(k=I.substr(0,I.indexOf(w)+w.length),I=I.substr(I.indexOf(w)+w.length)):I.indexOf(n)===0?(k=I.substr(0,I.indexOf(n)+n.length),I=I.substr(I.indexOf(n)+n.length)):I.indexOf(b)===0&&(k=I.substr(0,I.indexOf(b)+b.length),I=I.substr(I.indexOf(b)+b.length));const F=I.split(n);for(let U=1;m&&U<=F.length;U++)for(let T=F.length-U;m&&T>=0;T--){m=!1;let x=F.slice(T,T+U).join(n);for(let Y=0;!m&&Y<t.length;Y++)if(Y!==D&&t[Y]&&t[Y].indexOf(x)>-1){const ce=T+U===F.length,oe=T>0&&t[Y].indexOf(n)>-1?n+x:x,ae=t[Y].endsWith(oe);m=!ce||ae}if(!m){let Y="";(F[0].endsWith(":")||k!=="")&&(T===1&&(T=0,U++,x=F[0]+n+x),T>0&&(Y=F[0]+n),Y=k+Y),T>0&&(Y=Y+y+n),Y=Y+x,T+U<F.length&&(Y=Y+n+y),c[D]=Y}}m&&(c[D]=R)}return c}e.$Bv=g;var h;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function l(t,n=Object.create(null)){const c=[];let m=!1,D="";for(const R of t)if(R==="$"||m&&R==="{")D&&c.push({value:D,type:h.TEXT}),D="",m=!0;else if(R==="}"&&m){const k=n[D];if(typeof k=="string")k.length&&c.push({value:k,type:h.VARIABLE});else if(k){const I=c[c.length-1];(!I||I.type!==h.SEPARATOR)&&c.push({value:k.label,type:h.SEPARATOR})}D="",m=!1}else D+=R;return D&&!m&&c.push({value:D,type:h.TEXT}),c.filter((R,k)=>{if(R.type===h.SEPARATOR){const I=c[k-1],F=c[k+1];return[I,F].every(U=>U&&(U.type===h.VARIABLE||U.type===h.TEXT)&&U.value.length>0)}return!0}).map(R=>R.value).join("")}e.$Cv=l;function E(t,n){return M.$j||n?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):t.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.$Dv=E;function u(t,n){return M.$j||n?t.replace(/\(&&\w\)|&&/g,""):M.$i?t.replace(/&&|&/g,c=>c==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$Ev=u;function i(t){return t.replace(/&/g,"&&")}e.$Fv=i;function o(t){if(t.endsWith("]")){const n=t.lastIndexOf(" [",t.length-2);if(n!==-1){const c=r(t.substring(0,n));return{name:c.name,parentPath:c.parentPath+t.substring(n)}}}return r(t)}e.$Gv=o;function r(t){const n=t.indexOf("/")!==-1?s.$fc:s.$ec,c=n.basename(t),m=n.dirname(t);return c.length?{name:c,parentPath:m}:{name:m,parentPath:""}}}),define(ne[155],re([0,1,18,7]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=void 0;function s(p){return p.toJSON()}class M{constructor(v){this.a=v}transformIncoming(v){const f=this.a.transformIncoming(v);return f===v?v:s(A.URI.from(f))}transformOutgoing(v){const f=this.a.transformOutgoing(v);return f===v?v:s(A.URI.from(f))}transformOutgoingURI(v){const f=this.a.transformOutgoing(v);return f===v?v:A.URI.from(f)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Qm=M,e.$Rm=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function C(p,v,f){if(!p||f>200)return null;if(typeof p=="object"){if(p instanceof A.URI)return v.transformOutgoing(p);for(const y in p)if(Object.hasOwnProperty.call(p,y)){const w=C(p[y],v,f+1);w!==null&&(p[y]=w)}}return null}function P(p,v){const f=C(p,v,0);return f===null?p:f}e.$Sm=P;function d(p,v,f,y){if(!p||y>200)return null;if(typeof p=="object"){if(p.$mid===1)return f?A.URI.revive(v.transformIncoming(p)):v.transformIncoming(p);if(p instanceof S.$ee)return null;for(const w in p)if(Object.hasOwnProperty.call(p,w)){const b=d(p[w],v,f,y+1);b!==null&&(p[w]=b)}}return null}function a(p,v){const f=d(p,v,!1,0);return f===null?p:f}e.$Tm=a;function $(p,v){const f=d(p,v,!0,0);return f===null?p:f}e.$Um=$}),define(ne[88],re([0,1,28,57,32,145,4]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=e.$Wm=void 0,e.$Wm=new class{c(v){return this.a||(this.a=A.$1h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,f=0;const y=(0,S.networkInterfaces)();for(const w in y){const b=y[w];if(b)for(const{mac:g,internal:h}of b)h||(f+=1,this.c(g.toUpperCase())&&(v+=1))}this.b=f>0?v/f:0}return this.b}};let P;async function d(v){return P||(P=(async()=>await a(v)||s.$hg())()),P}e.$Xm=d;async function a(v){try{const f=await new Promise((w,b)=>{J(["crypto"],w,b)}),y=(0,M.$Vm)();return f.createHash("sha256").update(y,"utf8").digest("hex")}catch(f){v(f);return}}const $="Software\\Microsoft\\SQMClient";async function p(v){if(C.$i){const f=await new Promise((y,w)=>{J(["@vscode/windows-registry"],y,w)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",$,"MachineId")||""}catch(y){return v(y),""}}return""}e.$Ym=p}),define(ne[21],re([0,1,45,28,156,8,33,85,9,4,19,7]),function(J,e,S,A,s,M,C,P,d,a,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(oe){oe[oe.UNLINK=0]="UNLINK",oe[oe.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function f(oe,ae=v.UNLINK,Z){if((0,C.$4f)(oe))throw new Error("rimraf - will refuse to recursively delete root");return ae===v.UNLINK?w(oe):y(oe,Z)}async function y(oe,ae=(0,C.$9f)((0,A.tmpdir)())){try{try{await S.promises.rename(oe,ae)}catch(Z){return Z.code==="ENOENT"?void 0:w(oe)}w(ae).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function w(oe){return(0,s.promisify)(S.rm)(oe,{recursive:!0,force:!0,maxRetries:3})}function b(oe){if((0,C.$4f)(oe))throw new Error("rimraf - will refuse to recursively delete root");S.rmSync(oe,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function g(oe,ae){return E(await(ae?h(oe):(0,s.promisify)(S.readdir)(oe)))}async function h(oe){try{return await(0,s.promisify)(S.readdir)(oe,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ae=[],Z=await g(oe);for(const K of Z){let G=!1,z=!1,N=!1;try{const H=await e.Promises.lstat((0,d.$ic)(oe,K));G=H.isFile(),z=H.isDirectory(),N=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ae.push({name:K,isFile:()=>G,isDirectory:()=>z,isSymbolicLink:()=>N})}return ae}function l(oe){return E(S.readdirSync(oe))}e.readdirSync=l;function E(oe){return oe.map(ae=>typeof ae=="string"?a.$j?(0,P.$tl)(ae):ae:(ae.name=a.$j?(0,P.$tl)(ae.name):ae.name,ae))}async function u(oe){const ae=await g(oe),Z=[];for(const K of ae)await o.existsDirectory((0,d.$ic)(oe,K))&&Z.push(K);return Z}function i(oe,ae=1e3){return new Promise(Z=>{let K=!1;const G=setInterval(()=>{K||(K=!0,S.access(oe,z=>{K=!1,z&&(clearInterval(G),Z(void 0))}))},ae)})}e.whenDeleted=i;var o;(function(oe){async function ae(G){let z;try{if(z=await e.Promises.lstat(G),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(a.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw H}throw N}}oe.stat=ae;async function Z(G){try{const{stat:z,symbolicLink:N}=await oe.stat(G);return z.isFile()&&N?.dangling!==!0}catch{}return!1}oe.existsFile=Z;async function K(G){try{const{stat:z,symbolicLink:N}=await oe.stat(G);return z.isDirectory()&&N?.dangling!==!0}catch{}return!1}oe.existsDirectory=K})(o||(e.SymlinkSupport=o={}));const r=new M.$6g;function t(oe,ae,Z){return r.queueFor(p.URI.file(oe),$.$pg).queue(()=>{const K=R(Z);return new Promise((G,z)=>m(oe,ae,K,N=>N?z(N):G()))})}let n=!0;function c(oe){n=oe}e.configureFlushOnWrite=c;function m(oe,ae,Z,K){if(!n)return S.writeFile(oe,ae,{mode:Z.mode,flag:Z.flag},K);S.open(oe,Z.flag,Z.mode,(G,z)=>{if(G)return K(G);S.writeFile(z,ae,N=>{if(N)return S.close(z,()=>K(N));S.fdatasync(z,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),c(!1)),S.close(z,q=>K(q))))})})}function D(oe,ae,Z){const K=R(Z);if(!n)return S.writeFileSync(oe,ae,{mode:K.mode,flag:K.flag});const G=S.openSync(oe,K.flag,K.mode);try{S.writeFileSync(G,ae);try{S.fdatasyncSync(G)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),c(!1)}}finally{S.closeSync(G)}}e.writeFileSync=D;function R(oe){return oe?{mode:typeof oe.mode=="number"?oe.mode:438,flag:typeof oe.flag=="string"?oe.flag:"w"}:{mode:438,flag:"w"}}async function k(oe,ae,Z=6e4){if(oe!==ae)try{a.$i&&typeof Z=="number"?await I(oe,ae,Date.now(),Z):await(0,s.promisify)(S.rename)(oe,ae)}catch(K){if(oe.toLowerCase()!==ae.toLowerCase()&&K.code==="EXDEV"||oe.endsWith("."))await F(oe,ae,{preserveSymlinks:!1}),await f(oe,v.MOVE);else throw K}}async function I(oe,ae,Z,K,G=0){try{return await(0,s.promisify)(S.rename)(oe,ae)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-Z>=K)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${z}`),z;if(G===0){let N=!1;try{const{stat:H}=await o.stat(ae);H.isFile()||(N=!0)}catch{}if(N)throw z}return await(0,M.$Xg)(Math.min(100,G*10)),I(oe,ae,Z,K,G+1)}}async function F(oe,ae,Z){return T(oe,ae,{root:{source:oe,target:ae},options:Z,handledSourcePaths:new Set})}const U=511;async function T(oe,ae,Z){if(Z.handledSourcePaths.has(oe))return;Z.handledSourcePaths.add(oe);const{stat:K,symbolicLink:G}=await o.stat(oe);if(G){if(Z.options.preserveSymlinks)try{return await ce(oe,ae,Z)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(G.dangling)return}return K.isDirectory()?x(oe,ae,K.mode&U,Z):Y(oe,ae,K.mode&U)}async function x(oe,ae,Z,K){await e.Promises.mkdir(ae,{recursive:!0,mode:Z});const G=await g(oe);for(const z of G)await T((0,d.$ic)(oe,z),(0,d.$ic)(ae,z),K)}async function Y(oe,ae,Z){await e.Promises.copyFile(oe,ae),await e.Promises.chmod(ae,Z)}async function ce(oe,ae,Z){let K=await e.Promises.readlink(oe);(0,C.$1f)(K,Z.root.source,!a.$k)&&(K=(0,d.$ic)(Z.root.target,K.substr(Z.root.source.length+1))),await e.Promises.symlink(K,ae)}e.Promises=new class{get access(){return(0,s.promisify)(S.access)}get stat(){return(0,s.promisify)(S.stat)}get lstat(){return(0,s.promisify)(S.lstat)}get utimes(){return(0,s.promisify)(S.utimes)}get read(){return(oe,ae,Z,K,G)=>new Promise((z,N)=>{S.read(oe,ae,Z,K,G,(H,q,ee)=>H?N(H):z({bytesRead:q,buffer:ee}))})}get readFile(){return(0,s.promisify)(S.readFile)}get write(){return(oe,ae,Z,K,G)=>new Promise((z,N)=>{S.write(oe,ae,Z,K,G,(H,q,ee)=>H?N(H):z({bytesWritten:q,buffer:ee}))})}get appendFile(){return(0,s.promisify)(S.appendFile)}get fdatasync(){return(0,s.promisify)(S.fdatasync)}get truncate(){return(0,s.promisify)(S.truncate)}get copyFile(){return(0,s.promisify)(S.copyFile)}get open(){return(0,s.promisify)(S.open)}get close(){return(0,s.promisify)(S.close)}get symlink(){return(0,s.promisify)(S.symlink)}get readlink(){return(0,s.promisify)(S.readlink)}get chmod(){return(0,s.promisify)(S.chmod)}get mkdir(){return(0,s.promisify)(S.mkdir)}get unlink(){return(0,s.promisify)(S.unlink)}get rmdir(){return(0,s.promisify)(S.rmdir)}get realpath(){return(0,s.promisify)(S.realpath)}async exists(oe){try{return await e.Promises.access(oe),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return u}get writeFile(){return t}get rm(){return f}get rename(){return k}get copy(){return F}}}),define(ne[105],re([0,1,45,9,4,27,21]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.$0p=void 0;function P(v){if(s.$k)return v;const f=(0,A.$lc)(v);if(v===f)return v;const y=((0,A.$mc)(v)||v).toLowerCase();try{const b=(0,C.readdirSync)(f).filter(g=>g.toLowerCase()===y);if(b.length===1){const g=P(f);if(g)return(0,A.$ic)(g,b[0])}else if(b.length>1){const g=b.indexOf(y);if(g>=0){const h=P(f);if(h)return(0,A.$ic)(h,b[g])}}}catch{}return null}e.$0p=P;async function d(v){if(s.$k)return v;const f=(0,A.$lc)(v);if(v===f)return v;const y=((0,A.$mc)(v)||v).toLowerCase();try{const b=(await C.Promises.readdir(f)).filter(g=>g.toLowerCase()===y);if(b.length===1){const g=await d(f);if(g)return(0,A.$ic)(g,b[0])}else if(b.length>1){const g=b.indexOf(y);if(g>=0){const h=await d(f);if(h)return(0,A.$ic)(h,b[g])}}}catch{}return null}e.$$p=d;async function a(v){try{return await C.Promises.realpath(v)}catch{const y=p(v);return await C.Promises.access(y,S.constants.R_OK),y}}e.$_p=a;function $(v){try{return S.realpathSync(v)}catch{const y=p(v);return S.accessSync(y,S.constants.R_OK),y}}e.$aq=$;function p(v){return(0,M.$Ne)((0,A.$gc)(v),A.sep)}}),define(ne[106],re([0,1,28,9,21]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=void 0;const M=/^\d+$/,C=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var d;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(d||(d={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let $;process.env.PROCESSOR_ARCHITEW6432?$=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?$=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?$=1:$=0;class p{constructor(u,i,o){this.exePath=u,this.displayName=i,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:E=!1}={}){return E?a===0?process.env["ProgramFiles(x86)"]||null:$===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:u=!1}={}){const i=v({useAlternateBitness:E});if(!i)return null;const o=A.$ic(i,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,t=null;for(const m of await s.Promises.readdir(o)){let D=-1;if(u){const k=m.indexOf("-");if(k<0)continue;const I=m.substring(0,k);if(!M.test(I)||m.substring(k+1)!=="preview")continue;D=parseInt(I,10)}else{if(!M.test(m))continue;D=parseInt(m,10)}if(D<=r)continue;const R=A.$ic(o,m,"pwsh.exe");await s.SymlinkSupport.existsFile(R)&&(t=R,r=D)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",c=u?" Preview":"";return new p(t,`PowerShell${c}${n}`,!0)}async function y({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const u=A.$ic(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:i,pwshMsixName:o}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(u))if(i.test(r)){const t=A.$ic(u,r,"pwsh.exe");return new p(t,o)}return null}function w(){const E=A.$ic(S.homedir(),".dotnet","tools","pwsh.exe");return new p(E,".NET Core PowerShell Global Tool")}function b(){const E=A.$ic(process.env.windir,a===1&&$!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(E,"Windows PowerShell",!0)}async function*g(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await y(),E&&(yield E),E=w(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await y({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=b(),E&&(yield E)}async function*h(){for await(const E of g())await E.exists()&&(yield E)}e.$Cl=h;async function l(){for await(const E of h())return E;return null}e.$Dl=l}),define(ne[89],re([0,1,9,4,35,76,12,21]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Hl=e.$Gl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function d(p=s.env){return p.comspec||"cmd.exe"}e.$Gl=d;function a(p){let v=[],f=!1;const y=function(w){if(f){v.push(w);return}(!p.send(w,g=>{if(g&&console.error(g),f=!1,v.length>0){const h=v.slice(0);v=[],h.forEach(l=>y(l))}})||A.$i)&&(f=!0)};return{send:y}}e.$Hl=a;var $;(function(p){async function v(f,y,w){if(S.$hc(f))return f;if(y===void 0&&(y=s.cwd()),S.$lc(f)!=="."||(w===void 0&&C.$Bf(s.env.PATH)&&(w=s.env.PATH.split(S.$sc)),w===void 0||w.length===0))return S.$ic(y,f);async function g(h){if(await P.Promises.exists(h)){let l;try{l=await P.Promises.stat(h)}catch(E){E.message.startsWith("EACCES")&&(l=await P.Promises.lstat(h))}return l?!l.isDirectory():!1}return!1}for(const h of w){let l;if(S.$hc(h)?l=S.$ic(h,f):l=S.$ic(y,h,f),await g(l))return l;let E=l+".com";if(await g(E)||(E=l+".exe",await g(E)))return E}return S.$ic(y,f)}p.findExecutable=v})($||(e.win32=$={}))}),define(ne[107],re([0,1,47,13]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0;function s(C){return new Promise((P,d)=>{let a;const $=new Map;function p(f,y,w,b,g){const h=$.get(y);if(f===C||h){const l={name:v(w),cmd:w,pid:f,ppid:y,load:b,mem:g};$.set(f,l),f===C&&(a=l),h&&(h.children||(h.children=[]),h.children.push(l),h.children.length>1&&(h.children=h.children.sort((E,u)=>E.pid-u.pid)))}}function v(f){const y=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,b=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if(b.exec(f))return"electron-crash-reporter";if(g.exec(f))return"winpty-agent";if(h.exec(f))return"conpty-agent";let E=l.exec(f);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?y.exec(f)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const u=/[a-zA-Z-]+\.js/g;let i="";do E=u.exec(f),E&&(i+=E+" ");while(E);return i&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${i})`:w.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,w)=>{J(["@vscode/windows-process-tree"],y,w)}).then(y=>{y.getProcessList(C,w=>{if(!w){d(new Error(`Root process ${C} not found`));return}y.getProcessCpuUsage(w,b=>{const g=new Map;b.forEach(h=>{const l=f(h.commandLine||"");g.set(h.pid,{name:v(l),cmd:l,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),a=g.get(C),a?(g.forEach(h=>{const l=g.get(h.ppid);l&&(l.children||(l.children=[]),l.children.push(h))}),g.forEach(h=>{h.children&&(h.children=h.children.sort((l,E)=>l.pid-E.pid))}),P(a)):d(new Error(`Root process ${C} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let f=function(){let y=[a];const w=[];for(;y.length;){const g=y.shift();g&&(w.push(g.pid),g.children&&(y=y.concat(g.children)))}let b=JSON.stringify(A.$fg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+w.join(" "),(0,S.exec)(b,{},(g,h,l)=>{if(g||l)d(g||new Error(l.toString()));else{const E=h.toString().split(`
`);for(let u=0;u<w.length;u++){const i=$.get(w[u]);i.load=parseFloat(E[u])}if(!a){d(new Error(`Root process ${C} not found`));return}P(a)}})};(0,S.exec)("which ps",{},(y,w,b)=>{if(y||b)if(process.platform!=="linux")d(y||new Error(b.toString()));else{const g=JSON.stringify(A.$fg.asFileUri("vs/base/node/ps.sh").fsPath);(0,S.exec)(g,{},(h,l,E)=>{h||E?d(h||new Error(E.toString())):(M(l,p),f())})}else{const g=w.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,S.exec)(`${g} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,E,u)=>{l||u&&!u.includes("screen size is bogus")?d(l||new Error(u.toString())):(M(E,p),process.platform==="linux"?f():a?P(a):d(new Error(`Root process ${C} not found`)))})}})}})}e.$Ir=s;function M(C,P){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,a=C.toString().split(`
`);for(const $ of a){const p=d.exec($.trim());p&&p.length===6&&P(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(ne[108],re([0,1,28,4,106,89]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=void 0;async function C(p,v){return p===1?A.$i?$():M.$Gl(v):d(p,v)}e.$Il=C;let P=null;function d(p,v){if(A.$k&&p===2||A.$j&&p===3)return"/bin/bash";if(!P){let f;if(A.$i)f="/bin/bash";else{if(f=v.SHELL,!f)try{f=(0,S.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}P=f}return P}let a=null;async function $(){return a||(a=(await(0,s.$Dl)()).exePath),a}});var ve=this&&this.__decorate||function(J,e,S,A){var s=arguments.length,M=s<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,S):A,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(J,e,S,A);else for(var P=J.length-1;P>=0;P--)(C=J[P])&&(M=(s<3?C(M):s>3?C(e,S,M):C(e,S))||M);return s>3&&M&&Object.defineProperty(e,S,M),M};define(ne[42],re([0,1,23,8,18,22,55,14,3,2,77,27,12]),function(J,e,S,A,s,M,C,P,d,a,$,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.ProxyChannel=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.RequestInitiator=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0;var f;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(f||(f={}));function y(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(w||(w={}));function b(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(g||(g={}));function h(G){let z=0;for(let N=0;;N+=7){const H=G.read(1);if(z|=(H.buffer[0]&127)<<N,!(H.buffer[0]&128))return z}}const l=r(0);function E(G,z){if(z===0){G.write(l);return}let N=0;for(let q=z;q!==0;q=q>>>7)N++;const H=s.$ee.alloc(N);for(let q=0;z!==0;q++)H.buffer[q]=z&127,z=z>>>7,z>0&&(H.buffer[q]|=128);G.write(H)}class u{constructor(z){this.b=z,this.a=0}read(z){const N=this.b.slice(this.a,this.a+z);return this.a+=N.byteLength,N}}e.$sh=u;class i{constructor(){this.a=[]}get buffer(){return s.$ee.concat(this.a)}write(z){this.a.push(z)}}e.$th=i;var o;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(o||(o={}));function r(G){const z=s.$ee.alloc(1);return z.writeUInt8(G,0),z}const t={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function c(G,z){if(typeof z>"u")G.write(t.Undefined);else if(typeof z=="string"){const N=s.$ee.fromString(z);G.write(t.String),E(G,N.byteLength),G.write(N)}else if(n&&Buffer.isBuffer(z)){const N=s.$ee.wrap(z);G.write(t.Buffer),E(G,N.byteLength),G.write(N)}else if(z instanceof s.$ee)G.write(t.VSBuffer),E(G,z.byteLength),G.write(z);else if(Array.isArray(z)){G.write(t.Array),E(G,z.length);for(const N of z)c(G,N)}else if(typeof z=="number"&&(z|0)===z)G.write(t.Uint),E(G,z);else{const N=s.$ee.fromString(JSON.stringify(z));G.write(t.Object),E(G,N.byteLength),G.write(N)}}e.$uh=c;function m(G){switch(G.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return G.read(h(G)).toString();case o.Buffer:return G.read(h(G)).buffer;case o.VSBuffer:return G.read(h(G));case o.Array:{const N=h(G),H=[];for(let q=0;q<N;q++)H.push(m(G));return H}case o.Object:return JSON.parse(G.read(h(G)).toString());case o.Int:return h(G)}}e.$vh=m;class D{constructor(z,N,H=null,q=1e3){this.h=z,this.j=N,this.k=H,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:200})}registerChannel(z,N){this.b.set(z,N),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case 200:{const N=this.o([z.type]);this.k?.logOutgoing(N,0,1,b(z.type));return}case 201:case 202:case 204:case 203:{const N=this.o([z.type,z.id],z.data);this.k?.logOutgoing(N,z.id,1,b(z.type),z.data);return}}}o(z,N=void 0){const H=new i;return c(H,z),c(H,N),this.p(H.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const N=new u(z),H=m(N),q=m(N),ee=H[0];switch(ee){case 100:return this.k?.logIncoming(z.byteLength,H[1],1,`${y(ee)}: ${H[2]}.${H[3]}`,q),this.s({type:ee,id:H[1],channelName:H[2],name:H[3],arg:q});case 102:return this.k?.logIncoming(z.byteLength,H[1],1,`${y(ee)}: ${H[2]}.${H[3]}`,q),this.t({type:ee,id:H[1],channelName:H[2],name:H[3],arg:q});case 101:return this.k?.logIncoming(z.byteLength,H[1],1,`${y(ee)}`),this.u({type:ee,id:H[1]});case 103:return this.k?.logIncoming(z.byteLength,H[1],1,`${y(ee)}`),this.u({type:ee,id:H[1]})}}s(z){const N=this.b.get(z.channelName);if(!N){this.v(z);return}const H=new M.$1d;let q;try{q=N.call(this.j,z.name,z.arg,H.token)}catch(Q){q=Promise.reject(Q)}const ee=z.id;q.then(Q=>{this.m({id:ee,data:Q,type:201})},Q=>{Q instanceof Error?this.m({id:ee,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.m({id:ee,data:Q,type:203})}).finally(()=>{se.dispose(),this.d.delete(z.id)});const se=(0,a.$Pc)(()=>H.cancel());this.d.set(z.id,se)}t(z){const N=this.b.get(z.channelName);if(!N){this.v(z);return}const H=z.id,ee=N.listen(this.j,z.name,z.arg)(se=>this.m({id:H,data:se,type:204}));this.d.set(z.id,ee)}u(z){const N=this.d.get(z.id);N&&(N.dispose(),this.d.delete(z.id))}v(z){let N=this.g.get(z.channelName);N||(N=[],this.g.set(z.channelName,N));const H=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:z,timeoutTimer:H})}w(z){const N=this.g.get(z);if(N){for(const H of N)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Mc)(this.d.values()),this.d.clear()}}e.$wh=D;var R;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class k{constructor(z,N=null){this.l=z,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.$Qd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=N}getChannel(z){const N=this;return{call(H,q,ee){return N.a?Promise.reject(new P.$4):N.m(z,H,q,ee)},listen(H,q){return N.a?d.Event.None:N.o(z,H,q)}}}m(z,N,H,q=M.CancellationToken.None){const ee=this.g++,Q={id:ee,type:100,channelName:z,name:N,arg:H};if(q.isCancellationRequested)return Promise.reject(new P.$4);let O;return new Promise((V,L)=>{if(q.isCancellationRequested)return L(new P.$4);const B=()=>{const de=le=>{switch(le.type){case 201:this.f.delete(ee),V(le.data);break;case 202:{this.f.delete(ee);const we=new Error(le.data.message);we.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,we.name=le.data.name,L(we);break}case 203:this.f.delete(ee),L(le.data);break}};this.f.set(ee,de),this.p(Q)};let W=null;this.b===g.Idle?B():(W=(0,A.$Kg)(de=>this.u()),W.then(()=>{W=null,B()}));const X=()=>{W?(W.cancel(),W=null):this.p({id:ee,type:101}),L(new P.$4)},he=q.onCancellationRequested(X);O=(0,a.$Oc)((0,a.$Pc)(X),he),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(z,N,H){const q=this.g++,se={id:q,type:102,channelName:z,name:N,arg:H};let Q=null;const O=new d.$Qd({onWillAddFirstListener:()=>{Q=(0,A.$Kg)(V=>this.u()),Q.then(()=>{Q=null,this.d.add(O),this.p(se)})},onDidRemoveLastListener:()=>{Q?(Q.cancel(),Q=null):(this.d.delete(O),this.p({id:q,type:103}))}}),j=V=>O.fire(V.data);return this.f.set(q,j),O.event}p(z){switch(z.type){case 100:case 102:{const N=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(N,z.id,0,`${y(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const N=this.q([z.type,z.id]);this.j?.logOutgoing(N,z.id,0,y(z.type));return}}}q(z,N=void 0){const H=new i;return c(H,z),c(H,N),this.r(H.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const N=new u(z),H=m(N),q=m(N),ee=H[0];switch(ee){case 200:return this.j?.logIncoming(z.byteLength,0,0,b(ee)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(z.byteLength,H[1],0,b(ee),q),this.t({type:H[0],id:H[1],data:q})}}t(z){if(z.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Mc)(this.d.values()),this.d.clear()}}e.$xh=k,ve([C.$mh],k.prototype,"onDidInitializePromise",null);class I{get connections(){const z=[];return this.f.forEach(N=>z.push(N)),z}constructor(z){this.a=new Map,this.f=new Set,this.g=new d.$Qd,this.onDidAddConnection=this.g.event,this.h=new d.$Qd,this.onDidRemoveConnection=this.h.event,this.j=new a.$Qc,this.j.add(z(({protocol:N,onDidClientDisconnect:H})=>{const q=d.Event.once(N.onMessage);this.j.add(q(ee=>{const se=new u(ee),Q=m(se),O=new D(N,Q),j=new k(N);this.a.forEach((L,B)=>O.registerChannel(B,L));const V={channelServer:O,channelClient:j,ctx:Q};this.f.add(V),this.g.fire(V),this.j.add(H(()=>{O.dispose(),j.dispose(),this.f.delete(V),this.h.fire(V)}))}))}))}getChannel(z,N){const H=this;return{call(q,ee,se){let Q;if((0,v.$Pf)(N)){const j=(0,S.$3b)(H.connections.filter(N));Q=j?Promise.resolve(j):d.Event.toPromise(d.Event.filter(H.onDidAddConnection,N))}else Q=N.routeCall(H,q,ee);const O=Q.then(j=>j.channelClient.getChannel(z));return U(O).call(q,ee,se)},listen(q,ee){if((0,v.$Pf)(N))return H.k(z,N,q,ee);const se=N.routeEvent(H,q,ee).then(Q=>Q.channelClient.getChannel(z));return U(se).listen(q,ee)}}}k(z,N,H,q){const ee=this;let se;const Q=new d.$Qd({onWillAddFirstListener:()=>{se=new a.$Qc;const O=new d.$Wd,j=new Map,V=B=>{const X=B.channelClient.getChannel(z).listen(H,q),he=O.add(X);j.set(B,he)},L=B=>{const W=j.get(B);W&&(W.dispose(),j.delete(B))};ee.connections.filter(N).forEach(V),d.Event.filter(ee.onDidAddConnection,N)(V,void 0,se),ee.onDidRemoveConnection(L,void 0,se),O.event(Q.fire,Q,se),se.add(O)},onDidRemoveLastListener:()=>{se?.dispose(),se=void 0}});return Q.event}registerChannel(z,N){this.a.set(z,N);for(const H of this.f)H.channelServer.registerChannel(z,N)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$yh=I;class F{constructor(z,N,H=null){const q=new i;c(q,N),z.send(q.buffer),this.a=new k(z,H),this.d=new D(z,N,H)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,N){this.d.registerChannel(z,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$zh=F;function U(G){return{call(z,N,H){return G.then(q=>q.call(z,N,H))},listen(z,N){const H=new d.$Zd;return G.then(q=>H.input=q.listen(z,N)),H.event}}}e.$Ah=U;function T(G){let z=!1;return{call(N,H,q){return z?G.call(N,H,q):(0,A.$Xg)(0).then(()=>z=!0).then(()=>G.call(N,H,q))},listen(N,H){if(z)return G.listen(N,H);const q=new d.$Zd;return(0,A.$Xg)(0).then(()=>z=!0).then(()=>q.input=G.listen(N,H)),q.event}}}e.$Bh=T;class x{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const N of z.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await d.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$Ch=x;var Y;(function(G){function z(ee,se,Q){const O=ee,j=Q&&Q.disableMarshalling,V=new Map;for(const L in O)H(L)&&V.set(L,d.Event.buffer(O[L],!0,void 0,se));return new class{listen(L,B,W){const X=V.get(B);if(X)return X;if(q(B)){const he=O[B];if(typeof he=="function")return he.call(O,W)}throw new P.$ab(`Event not found: ${B}`)}call(L,B,W){const X=O[B];if(typeof X=="function"){if(!j&&Array.isArray(W))for(let de=0;de<W.length;de++)W[de]=(0,$.$rh)(W[de]);let he=X.apply(O,W);return he instanceof Promise||(he=Promise.resolve(he)),he}throw new P.$ab(`Method not found: ${B}`)}}}G.fromService=z;function N(ee,se){const Q=se&&se.disableMarshalling;return new Proxy({},{get(O,j){if(typeof j=="string")return se?.properties?.has(j)?se.properties.get(j):q(j)?function(V){return ee.listen(j,V)}:H(j)?ee.listen(j):async function(...V){let L;se&&!(0,v.$Kf)(se.context)?L=[se.context,...V]:L=V;const B=await ee.call(j,L);return Q?B:(0,$.$rh)(B)};throw new P.$ab(`Property not found: ${String(j)}`)}})}G.toService=N;function H(ee){return ee[0]==="o"&&ee[1]==="n"&&p.$4e(ee.charCodeAt(2))}function q(ee){return/^onDynamic/.test(ee)&&p.$4e(ee.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const z=G.toString();if(z!=="[object Object]")return z}return G}function ae(G){return Array.isArray(G)?G.map(oe):oe(G)}function Z(G,z,N,H,q,ee,se){se=ae(se);const Q=ce[q],O=Q[H%Q.length];let j=[`%c[${G}]%c[${String(z).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(ee)?(j=j.concat(se),j.push(")")):j.push(se),console.log.apply(console,j)}class K{constructor(z,N){this.d=z,this.f=N,this.a=0,this.b=0}logOutgoing(z,N,H,q,ee){this.b+=z,Z(this.d,this.b,z,N,H,q,ee)}logIncoming(z,N,H,q,ee){this.a+=z,Z(this.f,this.a,z,N,H,q,ee)}}e.$Dh=K}),define(ne[157],re([0,1,18,3,42]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YT=e.$XT=void 0;class M{constructor(d){this.a=d,this.onMessage=A.Event.fromDOMEventEmitter(this.a,"message",a=>S.$ee.wrap(a.data)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}e.$XT=M;class C extends s.$zh{constructor(d,a){const $=new M(d);super($,a),this.b=$}dispose(){this.b.disconnect(),super.dispose()}}e.$YT=C}),define(ne[109],re([0,1,18,3,2,42]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.ProtocolConstants=e.$Eh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(C||(e.SocketDiagnosticsEventType=C={}));var P;(function(t){t.enableDiagnostics=!1,t.records=[];const n=new WeakMap;let c=0;function m(R,k){if(!n.has(R)){const I=String(++c);n.set(R,I)}return n.get(R)}function D(R,k,I,F){if(!t.enableDiagnostics)return;const U=m(R,k);if(F instanceof S.$ee||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const T=S.$ee.alloc(F.byteLength);T.set(F),t.records.push({timestamp:Date.now(),id:U,label:k,type:I,buff:T})}else t.records.push({timestamp:Date.now(),id:U,label:k,type:I,data:F})}t.traceSocketEvent=D})(P||(e.SocketDiagnostics=P={}));var d;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d||(e.SocketCloseEventType=d={}));let a=null;function $(){return a||(a=S.$ee.alloc(0)),a}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,c){if(n===0)return $();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return c&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return c&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const m=S.$ee.alloc(n);let D=0,R=0;for(;n>0;){const k=this.a[R];if(k.byteLength>n){const I=k.slice(0,n);m.set(I,D),D+=n,c&&(this.a[R]=k.slice(n),this.b-=n),n-=n}else m.set(k,D),D+=k.byteLength,c?(this.a.shift(),this.b-=k.byteLength):R++,n-=k.byteLength}return m}}e.$Eh=p;var v;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})(v||(v={}));function f(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class w{constructor(n,c,m,D){this.type=n,this.id=c,this.ack=m,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends s.$Rc{constructor(n){super(),this.f=this.B(new A.$Qd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new p,this.B(this.a.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const c=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=c.readUInt32BE(9),this.g.messageType=c.readUInt8(0),this.g.id=c.readUInt32BE(1),this.g.ack=c.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const m=this.g.messageType,D=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",c),this.f.fire(new w(m,D,R,c)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=S.$ee.alloc(13);c.writeUInt8(n.type,0),c.writeUInt32BE(n.id,1),c.writeUInt32BE(n.ack,5),c.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(c,n.data)}g(n,c){const m=this.f===0;return this.d.push(n,c),this.f+=n.byteLength+c.byteLength,m}h(){const n=S.$ee.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,c){this.g(n,c)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends s.$Rc{constructor(n){super(),this.f=new A.$Qd,this.onMessage=this.f.event,this.g=new A.$Qd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(c=>{c.type===1&&this.f.fire(c.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new w(1,0,0,n))}}e.$Fh=h;class l extends M.$zh{static fromSocket(n,c){return new l(new h(n),c)}get onDidDispose(){return this.b.onDidDispose}constructor(n,c,m=null){super(n,c,m),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Gh=l;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$Qd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Hh=E;class u{constructor(n){this.data=n,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let n=0,c=this.a;for(;c;)c=c.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let c=0,m=this.a;for(;m;)n[c++]=m.data,m=m.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const c=new u(n);if(!this.a){this.a=c,this.b=c;return}this.b.next=c,this.b=c}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let c=0;c<o.a;c++)this.c[c]=n-1e3*c;setInterval(()=>{for(let c=o.a;c>=1;c--)this.c[c]=this.c[c-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),c=(1+o.a)*1e3;let m=0;for(let D=0;D<o.a;D++)n-this.c[D]<=c&&m++;return 1-m/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Qc,this.o=n.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(c=>this.z(c))),this.r.add(this.o.onClose(c=>this.x.fire(c))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new w(5,0,0,$());this.p.write(n),this.p.flush()}sendPause(){const n=new w(7,0,0,$());this.p.write(n)}sendResume(){const n=new w(8,0,0,$());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,c){this.a=!0,this.r.dispose(),this.r=new s.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(m=>this.z(m))),this.r.add(this.o.onClose(m=>this.x.fire(m))),this.q.acceptChunk(c)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new w(3,0,this.h,$());this.p.write(n);const c=this.b.toArray();for(let m=0,D=c.length;m<D;m++)this.p.write(c[m]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const c=this.b.peek();if(c&&c.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const c=Date.now();c-this.m>1e4&&(this.m=c,this.p.write(new w(6,0,0,$())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const c=this.b.toArray();for(let m=0,D=c.length;m<D;m++)this.p.write(c[m]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const c=++this.c;this.h=this.g;const m=new w(1,c,this.h,n);this.b.push(m),this.a||(this.p.write(m),this.B())}sendControl(n){const c=new w(2,0,0,n);this.p.write(c)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),c=Date.now()-n.writtenTime,m=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(c>=2e4&&m>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:c,timeSinceLastReceivedSomeData:m});return}const R=Math.max(2e4-c,2e4-m,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new w(3,0,this.h,$());this.p.write(n)}D(){this.h=this.g;const n=new w(9,0,this.h,$());this.p.write(n)}}e.$Ih=r}),define(ne[36],re([0,1,15,14,13]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UT=void 0;class M{constructor(){this.a=new WeakMap}on(P,d){const a=($,...p)=>{this.b(P,$)&&d($,...p)};return this.a.set(d,a),S.ipcMain.on(P,a),this}once(P,d){return S.ipcMain.once(P,(a,...$)=>{this.b(P,a)&&d(a,...$)}),this}handle(P,d){return S.ipcMain.handle(P,(a,...$)=>this.b(P,a)?d(a,...$):Promise.reject(`Invalid channel '${P}' or sender for ipcMain.handle() usage.`)),this}removeHandler(P){return S.ipcMain.removeHandler(P),this}removeListener(P,d){const a=this.a.get(d);return a&&(S.ipcMain.removeListener(P,a),this.a.delete(d)),this}b(P,d){if(!P||!P.startsWith("vscode:"))return(0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because the channel is unknown.`),!1;const a=d.senderFrame,$=a.url;if(!$||$==="about:blank")return!0;let p="unknown";try{p=new URL($).host}catch{return(0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because of a malformed URL '${$}'.`),!1}return p!==s.$eg?((0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because of a bad origin of '${p}'.`),!1):a.parent!==null?((0,A.$Z)(`Refused to handle ipcMain event for channel '${P}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.$UT=new M}),define(ne[158],re([0,1,15,36,146]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VT=void 0;function M(){A.$UT.on(s.$ST,(P,d,a,$,p)=>{const v=C(P,$,a);v.popup({x:p?p.x:void 0,y:p?p.y:void 0,positioningItem:p?p.positioningItem:void 0,callback:()=>{v&&P.sender.send(s.$TT,d)}})})}e.$VT=M;function C(P,d,a){const $=new S.Menu;return a.forEach(p=>{let v;p.type==="separator"?v=new S.MenuItem({type:p.type}):Array.isArray(p.submenu)?v=new S.MenuItem({submenu:C(P,d,p.submenu),label:p.label}):v=new S.MenuItem({label:p.label,type:p.type,accelerator:p.accelerator,checked:p.checked,enabled:p.enabled,visible:p.visible,click:(f,y,w)=>P.sender.send(d,p.id,w)}),$.append(v)}),$}}),define(ne[159],re([0,1,36,18,3,2,42,147]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2T=void 0;function d($,p){const v=s.Event.fromNodeEventEmitter(S.$UT,p,(y,w)=>({event:y,message:w})),f=s.Event.filter(v,({event:y})=>y.sender.id===$);return s.Event.map(f,({message:y})=>y&&A.$ee.wrap(y))}class a extends C.$yh{static{this.b=new Map}static d(){const p=s.Event.fromNodeEventEmitter(S.$UT,"vscode:hello",({sender:v})=>v);return s.Event.map(p,v=>{const f=v.id;a.b.get(f)?.dispose();const w=new s.$Qd;a.b.set(f,(0,M.$Pc)(()=>w.fire()));const b=d(f,"vscode:message"),g=s.Event.any(s.Event.signal(d(f,"vscode:disconnect")),w.event);return{protocol:new P.$1T(v,b),onDidClientDisconnect:g}})}constructor(){super(a.d())}}e.$2T=a}),define(ne[110],re([0,1,36,3,32,157]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4T=e.$3T=void 0;class C extends M.$YT{constructor(a,$){super({addEventListener:(p,v)=>a.addListener(p,v),removeEventListener:(p,v)=>a.removeListener(p,v),postMessage:p=>a.postMessage(p),start:()=>a.start(),close:()=>a.close()},$)}}e.$3T=C;async function P(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const a=(0,s.$hg)();d.webContents.send("vscode:createMessageChannel",a);const $=A.Event.fromNodeEventEmitter(S.$UT,"vscode:createMessageChannelResult",(v,f)=>({nonce:f,port:v.ports[0]})),{port:p}=await A.Event.toPromise(A.Event.once(A.Event.filter($,v=>v.nonce===a)));return p}e.$4T=P}),define(ne[160],re([0,1,47,8,18,22,154,14,3,2,38,89,76,42]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;class y extends f.$wh{constructor(g){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",h=>s.$ee.wrap(Buffer.from(h,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$7p=y;class w{constructor(g,h){this.i=g,this.j=h,this.c=new Set,this.g=new Map,this.h=new d.$Qd,this.onDidProcessExit=this.h.event;const l=h&&h.timeout?h.timeout:6e4;this.b=new A.$Tg(l),this.d=null,this.f=null}getChannel(g){const h=this;return{call(l,E,u){return h.k(g,l,E,u)},listen(l,E){return h.l(g,l,E)}}}k(g,h,l,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.$5());this.b.cancel();const u=this.n(g),i=(0,A.$Kg)(t=>u.call(h,l,t)),o=E.onCancellationRequested(()=>i.cancel()),r=(0,a.$Pc)(()=>i.cancel());return this.c.add(r),i.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(g,h,l){if(!this.b)return d.Event.None;this.b.cancel();let E;const u=new d.$Qd({onWillAddFirstListener:()=>{E=this.n(g).listen(h,l)(u.fire,u),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,$.$_m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,v.$Fl)(h.env),this.d=(0,S.fork)(this.i,g,h);const l=new d.$Qd;d.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,C.$3p)(n)){(0,C.log)(n,`IPC Library: ${this.j.serverName}`);return}l.fire(s.$ee.wrap(Buffer.from(n,"base64")))});const u=this.j.useQueue?(0,p.$Hl)(this.d):this.d,i=n=>this.d&&this.d.connected&&u.send(n.buffer.toString("base64")),o=l.event,r={send:i,onMessage:o};this.f=new f.$xh(r);const t=()=>this.o();process.once("exit",t),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,c)=>{process.removeListener("exit",t),this.c.forEach(m=>(0,a.$Mc)(m)),this.c.clear(),n!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:c})})}return this.f}n(g){let h=this.g.get(g);return h||(h=this.m.getChannel(g),this.g.set(g,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$8p=w}),define(ne[111],re([0,1,8,3,2,77,12]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.StorageState=e.$6o=e.StorageHint=void 0;var P;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function d(v){const f=v;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$6o=d;var a;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(a||(e.StorageState=a={}));class $ extends s.$Rc{static{this.a=100}constructor(f,y=Object.create(null)){super(),this.r=f,this.s=y,this.b=this.B(new A.$Td),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Ug($.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((y,w)=>this.w(w,y)),f.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(f,y){if(this.c===a.Closed)return;let w=!1;(0,C.$Kf)(y)?w=this.f.delete(f):this.f.get(f)!==y&&(this.f.set(f,y),w=!0),w&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,y){const w=this.f.get(f);return(0,C.$Kf)(w)?y:w}getBoolean(f,y){const w=this.get(f);return(0,C.$Kf)(w)?y:w==="true"}getNumber(f,y){const w=this.get(f);return(0,C.$Kf)(w)?y:parseInt(w,10)}getObject(f,y){const w=this.get(f);return(0,C.$Kf)(w)?y:(0,M.$qh)(w)}async set(f,y,w=!1){if(this.c===a.Closed)return;if((0,C.$Kf)(y))return this.delete(f,w);const b=(0,C.$Df)(y)||Array.isArray(y)?(0,M.$ph)(y):String(y);if(this.f.get(f)!==b)return this.f.set(f,b),this.j.set(f,b),this.h.delete(f),this.b.fire({key:f,external:w}),this.D()}async delete(f,y=!1){if(!(this.c===a.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:y}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$7o=$;class p{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((y,w)=>this.a.set(w,y)),f.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$8o=p}),define(ne[161],re([0,1,8,3,31,9,21]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nU=void 0;class P{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return A.Event.None}static{this.a=2e3}static{this.b=256}constructor($,p=Object.create(null)){this.g=$,this.h=p,this.c=(0,M.$mc)(this.g),this.d=new d(this.h.logging),this.f=this.n(this.g)}async getItems(){const $=await this.f,p=new Map;return(await this.s($,"SELECT * FROM ItemTable")).forEach(f=>p.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${p.size} rows`),p}async updateItems($){const p=await this.f;return this.j(p,$)}j($,p){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${p.insert?(0,s.$xc)(p.insert):"0"}), delete(${p.delete?(0,s.$yc)(p.delete):"0"})`),this.t($,()=>{const v=p.insert,f=p.delete;if(v&&v.size>0){const y=[];y.push([]);let w=0;v.forEach((b,g)=>{let h=y[w];h.length>P.b&&(w++,h=[],y.push(h)),h.push(g,b)}),y.forEach(b=>{this.u($,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,g=>g.run(b),()=>{const g=[];let h=0;return v.forEach((l,E)=>{g.push(E),h+=l.length}),`Keys: ${g.join(", ")} Length: ${h}`})})}if(f&&f.size){const y=[];y.push([]);let w=0;f.forEach(b=>{let g=y[w];g.length>P.b&&(w++,g=[],y.push(g)),g.push(b)}),y.forEach(b=>{this.u($,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,g=>g.run(b),()=>{const g=[];return f.forEach(h=>{g.push(h)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const $=await this.f;return this.q($,"VACUUM")}async close($){this.d.trace(`[storage ${this.c}] close()`);const p=await this.f;return this.k(p,$)}k($,p){return new Promise((v,f)=>{$.db.close(y=>(y&&this.o($,`[storage ${this.c}] close(): ${y}`),this.g===P.IN_MEMORY_PATH?v():!$.isErroneous&&!$.isInMemory?this.l().then(v,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),v())):typeof p=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const b=()=>this.k(w,void 0);return this.j(w,{insert:p()}).then(()=>b(),g=>(b(),Promise.reject(g)))})).then(v,f):f(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const $=this.m(this.g);return C.Promises.copy(this.g,$,{preserveSymlinks:!1})}m($){return`${$}.backup`}async checkIntegrity($){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${$})`);const p=await this.f,v=await this.r(p,$?"PRAGMA integrity_check":"PRAGMA quick_check"),f=$?v.integrity_check:v.quick_check;return p.isErroneous?`${f} (last error: ${p.lastError})`:p.isInMemory?`${f} (in-memory!)`:f}async n($,p=!0){this.d.trace(`[storage ${this.c}] open(${$}, retryOnBusy: ${p})`);try{return await this.p($)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&p)return await(0,S.$Xg)(P.a),this.n($,!1);try{await C.Promises.unlink($);try{await C.Promises.rename(this.m($),$,!1)}catch{}return await this.p($)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(P.IN_MEMORY_PATH)}}}o($,p){$.isErroneous=!0,$.lastError=p,this.d.error(p)}p($){return new Promise((p,v)=>{new Promise((f,y)=>{J(["@vscode/sqlite3"],f,y)}).then(f=>{const y={db:new(this.d.isTracing?f.verbose().Database:f.Database)($,w=>w?y.db&&w.code!=="SQLITE_CANTOPEN"?y.db.close(()=>v(w)):v(w):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>p(y),b=>y.db.close(()=>v(b)))),isInMemory:$===P.IN_MEMORY_PATH};y.db.on("error",w=>this.o(y,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&y.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},v)})}q($,p){return new Promise((v,f)=>{$.db.exec(p,y=>y?(this.o($,`[storage ${this.c}] exec(): ${y}`),f(y)):v())})}r($,p){return new Promise((v,f)=>{$.db.get(p,(y,w)=>y?(this.o($,`[storage ${this.c}] get(): ${y}`),f(y)):v(w))})}s($,p){return new Promise((v,f)=>{$.db.all(p,(y,w)=>y?(this.o($,`[storage ${this.c}] all(): ${y}`),f(y)):v(w))})}t($,p){return new Promise((v,f)=>{$.db.serialize(()=>{$.db.run("BEGIN TRANSACTION"),p(),$.db.run("END TRANSACTION",y=>y?(this.o($,`[storage ${this.c}] transaction(): ${y}`),f(y)):v())})})}u($,p,v,f){const y=$.db.prepare(p),w=b=>{this.o($,`[storage ${this.c}] prepare(): ${b} (${p}). Details: ${f()}`)};y.on("error",w),v(y),y.finalize(b=>{b&&w(b),y.removeListener("error",w)})}}e.$nU=P;class d{static{this.a="VSCODE_TRACE_STORAGE"}constructor($){$&&typeof $.logTrace=="function"&&process.env[d.a]&&(this.b=$.logTrace),$&&typeof $.logError=="function"&&(this.c=$.logError)}get isTracing(){return!!this.b}trace($){this.b?.($)}error($){this.c?.($)}}}),define(ne[162],re([11,10]),function(J,e){return J.create("vs/code/electron-main/app",e)}),define(ne[163],re([11,10]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[164],re([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[165],re([11,10]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[166],re([11,10]),function(J,e){return J.create("vs/platform/dialogs/common/dialogs",e)}),define(ne[167],re([11,10]),function(J,e){return J.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(ne[168],re([11,10]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ne[169],re([11,10]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ne[170],re([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[171],re([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[172],re([11,10]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[173],re([11,10]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[174],re([11,10]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ne[175],re([11,10]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[176],re([11,10]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ne[177],re([11,10]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[178],re([11,10]),function(J,e){return J.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(ne[179],re([11,10]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[180],re([11,10]),function(J,e){return J.create("vs/platform/issue/electron-main/issueMainService",e)}),define(ne[181],re([11,10]),function(J,e){return J.create("vs/platform/menubar/electron-main/menubar",e)}),define(ne[182],re([11,10]),function(J,e){return J.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(ne[183],re([11,10]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[184],re([11,10]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[185],re([11,10]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[186],re([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[187],re([11,10]),function(J,e){return J.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[188],re([11,10]),function(J,e){return J.create("vs/platform/update/common/update.config.contribution",e)}),define(ne[189],re([11,10]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[190],re([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowImpl",e)}),define(ne[191],re([11,10]),function(J,e){return J.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(ne[192],re([11,10]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[193],re([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(ne[194],re([11,10]),function(J,e){return J.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(ne[195],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eV=e.$dV=void 0;function S(s){return s&&s.hasOwnProperty("folderUri")}e.$dV=S;function A(s){return s&&s.hasOwnProperty("workspace")}e.$eV=A}),define(ne[196],re([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=e.$T7b=e.$S7b=void 0;function A(C){return typeof C?.backupFolder=="string"}e.$S7b=A;function s(C){let P=[];try{Array.isArray(C.workspaces)&&(P=C.workspaces.map(d=>({workspace:{id:d.id,configPath:S.URI.parse(d.configURIPath)},remoteAuthority:d.remoteAuthority})))}catch{}return P}e.$T7b=s;function M(C){let P=[];try{Array.isArray(C.folders)&&(P=C.folders.map(d=>({folderUri:S.URI.parse(d.folderUri),remoteAuthority:d.remoteAuthority})))}catch{}return P}e.$U7b=M}),define(ne[197],re([0,1,14,165]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.TokenType=void 0;var s;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...a){switch(a.length){case 1:return(0,A.localize)(0,null,a[0]);case 2:return(0,A.localize)(1,null,a[0],a[1]);case 3:return(0,A.localize)(2,null,a[0],a[1],a[2]);default:return}}const C=(0,A.localize)(3,null),P=(0,A.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return $.isTripleEq?"===":"==";case 4:return $.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return $.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return $.lexeme;case 18:return $.lexeme;case 19:return $.lexeme;case 20:return"EOF";default:throw(0,S.$7)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const p=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:p})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const p=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:p})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const p=this.d,v=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:v};this.g.push({offset:p,lexeme:v,additionalInfo:$}),this.f.push(f)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const p=this.c.substring(this.d,this.e),v=d.b.get(p);v?this.k(v):this.f.push({type:17,lexeme:p,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(C);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,p=!1,v=!1;for(;;){if($>=this.c.length){this.e=$,this.l(P);return}const y=this.c.charCodeAt($);if(p)p=!1;else if(y===47&&!v){$++;break}else y===91?v=!0:y===92?p=!0:y===93&&(v=!1);$++}for(;$<this.c.length&&d.a.has(this.c.charCodeAt($));)$++;this.e=$;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Pi=d}),define(ne[198],re([0,1,3,2]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=e.$Rn=void 0;class s{constructor(){this.a=new S.$Qd,this.b=new S.$Qd,this.c=new S.$Qd,this.d=new S.$Qd}static{this.ChannelName="extensionhostdebugservice"}call(P,d,a){switch(d){case"close":return Promise.resolve(this.a.fire({sessionId:a[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:a[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:a[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:a[0],port:a[1],subId:a[2]}))}throw new Error("Method not implemented.")}listen(P,d,a){switch(d){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Rn=s;class M extends A.$Rc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,d,a){this.b.call("attach",[P,d,a])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,d){this.b.call("terminate",[P,d])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,d){return this.b.call("openExtensionDevelopmentHostWindow",[P,d])}}e.$Sn=M}),define(ne[199],re([0,1,149,55,13,9,35,19,7]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=e.$km=void 0,e.$km=/^([^.]+\..+):(.+)$/;class a{get appRoot(){return(0,M.$lc)(s.$fg.asFileUri("").fsPath)}get userHome(){return d.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return d.URI.file((0,M.$ic)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.b.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,P.$yg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$yg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,S.$jm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$ic)(this.userDataPath,"logs",f)}return d.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$yg)(d.URI.file((0,M.$ic)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$yg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$yg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$yg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=C.env.VSCODE_PORTABLE;return f?d.URI.file((0,M.$ic)(f,"argv.json")):(0,P.$yg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,M.$ic)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,M.$jc)(f):(0,M.$gc)((0,M.$ic)(s.$fg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?d.URI.file((0,M.$jc)(f)):d.URI.file((0,M.$ic)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,M.$jc)(f);const y=C.env.VSCODE_EXTENSIONS;if(y)return y;const w=C.env.VSCODE_PORTABLE;return w?(0,M.$ic)(w,"extensions"):(0,P.$yg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(y=>/^[^:/?#]+?:\/\//.test(y)?d.URI.parse(y):d.URI.file((0,M.$gc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?d.URI.parse(f):d.URI.file((0,M.$gc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return $(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$km.test(f))}get extensionLogLevel(){const f=[];for(const y of this.args.log||[]){const w=e.$km.exec(y);w&&w[1]&&w[2]&&f.push([w[1],w[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,P.$yg)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=C.env.VSCODE_PORTABLE;return f?d.URI.file((0,M.$ic)(f,"policy.json")):(0,P.$yg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,y,w){this.a=f,this.b=y,this.c=w,this.editSessionId=this.args.editSessionId}}e.$lm=a,ve([A.$mh],a.prototype,"appRoot",null),ve([A.$mh],a.prototype,"userHome",null),ve([A.$mh],a.prototype,"userDataPath",null),ve([A.$mh],a.prototype,"appSettingsHome",null),ve([A.$mh],a.prototype,"tmpDir",null),ve([A.$mh],a.prototype,"cacheHome",null),ve([A.$mh],a.prototype,"stateResource",null),ve([A.$mh],a.prototype,"userRoamingDataHome",null),ve([A.$mh],a.prototype,"userDataSyncHome",null),ve([A.$mh],a.prototype,"sync",null),ve([A.$mh],a.prototype,"machineSettingsResource",null),ve([A.$mh],a.prototype,"workspaceStorageHome",null),ve([A.$mh],a.prototype,"localHistoryHome",null),ve([A.$mh],a.prototype,"keyboardLayoutResource",null),ve([A.$mh],a.prototype,"argvResource",null),ve([A.$mh],a.prototype,"isExtensionDevelopment",null),ve([A.$mh],a.prototype,"untitledWorkspacesHome",null),ve([A.$mh],a.prototype,"builtinExtensionsPath",null),ve([A.$mh],a.prototype,"extensionsPath",null),ve([A.$mh],a.prototype,"extensionDevelopmentLocationURI",null),ve([A.$mh],a.prototype,"extensionDevelopmentKind",null),ve([A.$mh],a.prototype,"extensionTestsLocationURI",null),ve([A.$mh],a.prototype,"debugExtensionHost",null),ve([A.$mh],a.prototype,"logLevel",null),ve([A.$mh],a.prototype,"extensionLogLevel",null),ve([A.$mh],a.prototype,"serviceMachineIdResource",null),ve([A.$mh],a.prototype,"disableTelemetry",null),ve([A.$mh],a.prototype,"disableWorkspaceTrust",null),ve([A.$mh],a.prototype,"useInMemorySecretStorage",null),ve([A.$mh],a.prototype,"policyFile",null);function $(v,f){return p(v["inspect-extensions"],v["inspect-brk-extensions"],5870,f,v.debugId,v.extensionEnvironment)}e.$mm=$;function p(v,f,y,w,b,g){const l=Number(f||v)||(w?null:y),E=l?!!f:!1;let u;if(g)try{u=JSON.parse(g)}catch{}return{port:l,break:E,debugId:b,env:u}}e.$nm=p}),define(ne[112],re([0,1,309,4,168]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Jl=["tunnel","serve-web"],e.$Kl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(w,b,g=C){const h=w.find(c=>c.length>0&&c[0]!=="-"),l={},E=["_"],u=[],i={};let o;for(const c in b){const m=b[c];m.type==="subcommand"?c===h&&(o=m):(m.alias&&(l[c]=m.alias),m.type==="string"||m.type==="string[]"?(E.push(c),m.deprecates&&E.push(...m.deprecates)):m.type==="boolean"&&(u.push(c),m.deprecates&&u.push(...m.deprecates)),m.global&&(i[c]=m))}if(o&&h){const c=i;for(const k in o.options)c[k]=o.options[k];const m=w.filter(k=>k!==h),D=g.getSubcommandReporter?g.getSubcommandReporter(h):void 0,R=P(m,c,D);return{[h]:R,_:[]}}const r=S(w,{string:E,boolean:u,alias:l}),t={},n=r;t._=r._.map(c=>String(c)).filter(c=>c.length>0),delete n._;for(const c in b){const m=b[c];if(m.type==="subcommand")continue;m.alias&&delete n[m.alias];let D=n[c];if(m.deprecates)for(const R of m.deprecates)n.hasOwnProperty(R)&&(D||(D=n[R],D&&g.onDeprecatedOption(R,m.deprecationMessage||(0,s.localize)(37,null,c))),delete n[R]);if(typeof D<"u"){if(m.type==="string[]"){if(Array.isArray(D)||(D=[D]),!m.allowEmptyValue){const R=D.filter(k=>k.length>0);R.length!==D.length&&(g.onEmptyValue(c),D=R.length>0?R:void 0)}}else m.type==="string"&&(Array.isArray(D)?(D=D.pop(),g.onMultipleValues(c,D)):!D&&!m.allowEmptyValue&&(g.onEmptyValue(c),D=void 0));t[c]=D,m.deprecationMessage&&g.onDeprecatedOption(c,m.deprecationMessage)}delete n[c]}for(const c in n)g.onUnknownOption(c);return t}e.$Ll=P;function d(w,b){let g="";return b.args&&(Array.isArray(b.args)?g=` <${b.args.join("> <")}>`:g=` <${b.args}>`),b.alias?`-${b.alias} --${w}${g}`:`--${w}${g}`}function a(w,b){const g=[];for(const h in w){const l=w[h],E=d(h,l);g.push([E,l.description])}return $(g,b)}e.$Ml=a;function $(w,b){const h=w.reduce((u,i)=>Math.max(u,i[0].length),12)+2+1;if(b-h<25)return w.reduce((u,i)=>u.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const l=b-h-1,E=[];for(const u of w){const i=u[0],o=v(u[1],l),r=p(h-i.length-2);E.push("  "+i+r+o[0]);for(let t=1;t<o.length;t++)E.push(p(h)+o[t])}return E}function p(w){return" ".repeat(w)}function v(w,b){const g=[];for(;w.length;){const h=w.length<b?w.length:w.lastIndexOf(" ",b),l=w.slice(0,h).trim();w=w.slice(h),g.push(l)}return g}function f(w,b,g,h,l){const E=process.stdout.isTTY&&process.stdout.columns||80,u=l?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",i=[`${w} ${g}`];i.push(""),i.push(`${(0,s.localize)(39,null)}: ${b} [${(0,s.localize)(40,null)}]${u}`),i.push(""),l?.noPipe!==!0&&(A.$i?i.push((0,s.localize)(41,null,b)):i.push((0,s.localize)(42,null,b)),i.push(""));const o={},r=[];for(const t in h){const n=h[t];if(n.type==="subcommand")n.description&&r.push({command:t,description:n.description});else if(n.description&&n.cat){let c=o[n.cat];c||(o[n.cat]=c={}),c[t]=n}}for(const t in o){const n=t,c=o[n];c&&(i.push(M[n]),i.push(...a(c,E)),i.push(""))}return r.length&&(i.push((0,s.localize)(43,null)),i.push(...$(r.map(t=>[t.command,t.description]),E)),i.push("")),i.join(`
`)}e.$Nl=f;function y(w,b){return`${w||(0,s.localize)(44,null)}
${b||(0,s.localize)(45,null)}
${process.arch}`}e.$Ol=y}),define(ne[200],re([0,1,87,198,112]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j8b=void 0;class M extends A.$Rn{constructor(P){super(),this.f=P}call(P,d,a){return d==="openExtensionDevelopmentHostWindow"?this.g(a[0],a[1]):super.call(P,d,a)}async g(P,d){const a=(0,s.$Ll)(P,s.$Kl);a.debugRenderer=d;const $=a.extensionDevelopmentPath;if(!$)return{success:!1};const[p]=await this.f.openExtensionDevelopmentHostWindow($,{context:5,cli:a,forceProfile:a.profile,forceTempProfile:a["profile-temp"]});if(!d)return{success:!0};const v=p.win;if(!v)return{success:!0};const f=v.webContents.debugger;let y=f.isAttached()?1/0:0;const w=(0,S.createServer)(b=>{y++===0&&f.attach();let g=!1;const h=u=>{g||b.write(JSON.stringify(u)+"\0")},l=(u,i,o,r)=>h({method:i,params:o,sessionId:r});v.on("close",()=>{f.removeListener("message",l),b.end(),g=!0}),f.addListener("message",l);let E=Buffer.alloc(0);b.on("data",u=>{E=Buffer.concat([E,u]);for(let i=E.indexOf(0);i!==-1;i=E.indexOf(0)){let o;try{const r=E.slice(0,i).toString("utf8");E=E.slice(i+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}f.sendCommand(o.method,o.params,o.sessionId).then(r=>h({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>h({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),b.on("error",u=>{console.error("error on cdp pipe:",u)}),b.on("close",()=>{g=!0,--y===0&&f.detach()})});return await new Promise(b=>w.listen(0,b)),v.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$j8b=M}),define(ne[63],re([0,1,310,169,112]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0;function M(p,v){const f=(l,E)=>{console.warn((0,A.localize)(0,null,l,E))},y=l=>{console.warn((0,A.localize)(1,null,l))},w=(l,E)=>{console.warn((0,A.localize)(2,null,l,E))},b=l=>({onUnknownOption:E=>{s.$Jl.includes(l)||console.warn((0,A.localize)(3,null,E,l))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:s.$Jl.includes(l)?b:void 0}),g={onUnknownOption:l=>{console.warn((0,A.localize)(4,null,l))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:b},h=(0,s.$Ll)(p,s.$Kl,v?g:void 0);return h.goto&&h._.forEach(l=>S(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,A.localize)(5,null))),h}function C(p){const v=p.findIndex(f=>!/^-/.test(f));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function P(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=C(v)||[]);const f=!$(process.env);return M(v,f)}e.$Pl=P;function d(p){let[,,...v]=p;return process.env.VSCODE_DEV&&(v=C(v)||[]),M(v,!0)}e.$Ql=d;function a(p,...v){const f=p.indexOf("--");return f===-1?p.push(...v):p.splice(f,0,...v),p}e.$Rl=a;function $(p){return p.VSCODE_CLI==="1"}e.$Sl=$}),function(){"use strict";function J(e,S,A){function s(C,P){const d=M(C,P),a=[d];return e.isAbsolute(d)||a.unshift(A),e.resolve(...a)}function M(C,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const $=C["user-data-dir"];if($)return $;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(p,"AppData","Roaming")}break;case"darwin":a=e.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:s}}if(typeof define=="function")define(ne[201],re([113,28,35]),function(e,S,A){return J(e,S,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=J(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[90],re([0,1,28,199,201]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=void 0;class M extends A.$lm{constructor(a,$){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,s.getUserDataPath)(a,$.nameShort)},$)}}e.$om=M;function C(d,a){return(0,A.$nm)(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,a,d.extensionEnvironment)}e.$pm=C;function P(d,a){return(0,A.$nm)(d["inspect-sharedprocess"],d["inspect-brk-sharedprocess"],5879,a,d.extensionEnvironment)}e.$qm=P}),define(ne[202],re([0,1,45,28,33]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B9b=void 0;function M(C){const P=(0,s.$9f)((0,A.tmpdir)());try{return(0,S.writeFileSync)(P,""),C&&console.log(`Marker file for --wait created: ${P}`),P}catch(d){C&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.$B9b=M}),define(ne[203],re([0,1,12,171]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;function s(C,P,d,a){try{M(C,P,d,a)}catch($){C.error($?.message??$)}return P}e.$Cp=s;function M(C,P,d,a){const $=(p,v,f)=>{const y=p[v];if((0,S.$Bf)(y)){const w=y,b=w.length;if(b>1&&w[0]==="%"&&w[b-1]==="%"){const g=w.substr(1,b-2);let h=d[g];h===void 0&&a&&(h=a[g]);const l=typeof h=="string"?h:h?.message,E=a?.[g],u=typeof E=="string"?E:E?.message;if(!l){u||C.warn(`[${P.name}]: ${(0,A.localize)(0,null,g)}`);return}if(f&&(v==="title"||v==="category")&&u&&u!==l){const i={value:l,original:u};p[v]=i}else p[v]=l}}else if((0,S.$Df)(y))for(const w in y)y.hasOwnProperty(w)&&(w==="commands"?$(y,w,!0):$(y,w,f));else if(Array.isArray(y))for(let w=0;w<y.length;w++)$(y,w,f)};for(const p in P)P.hasOwnProperty(p)&&$(P,p)}}),define(ne[204],re([0,1,19,74,173,205]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function d(g){return g=g.trim(),g==="*"||C.test(g)}e.$Qo=d;function a(g){if(!d(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=g.match(C);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$Ro=a;function $(g){if(!g)return null;const h=g.majorBase,l=g.majorMustEqual,E=g.minorBase;let u=g.minorMustEqual;const i=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(h===0||(u=!1),o=!1);let r=0;if(g.preRelease){const t=P.exec(g.preRelease);if(t){const[,n,c,m]=t;r=Date.UTC(Number(n),Number(c)-1,Number(m))}}return{majorBase:h,majorMustEqual:l,minorBase:E,minorMustEqual:u,patchBase:i,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:r}}e.$So=$;function p(g,h,l){let E;typeof g=="string"?E=$(a(g)):E=g;let u;h instanceof Date?u=h.getTime():typeof h=="string"&&(u=new Date(h).getTime());let i;if(typeof l=="string"?i=$(a(l)):i=l,!E||!i)return!1;const o=E.majorBase,r=E.minorBase,t=E.patchBase;let n=i.majorBase,c=i.minorBase,m=i.patchBase;const D=i.notBefore;let R=i.majorMustEqual,k=i.minorMustEqual,I=i.patchMustEqual;return i.isMinimum?o>n?!0:o<n?!1:r>c?!0:r<c||u&&u<D?!1:t>=m:(o===1&&n===0&&(!R||!k||!I)&&(n=1,c=0,m=0,R=!0,k=!1,I=!1),o<n?!1:o>n?!R:r<c?!1:r>c?!k:t<m?!1:t>m?!I:!(u&&u<D))}e.$To=p;function v(g,h,l,E,u){const i=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return i.push([A.default.Error,s.localize(0,null)]),i;if(typeof E.name!="string")return i.push([A.default.Error,s.localize(1,null,"name")]),i;if(typeof E.version!="string")return i.push([A.default.Error,s.localize(2,null,"version")]),i;if(!E.engines)return i.push([A.default.Error,s.localize(3,null,"engines")]),i;if(typeof E.engines.vscode!="string")return i.push([A.default.Error,s.localize(4,null,"engines.vscode")]),i;if(typeof E.extensionDependencies<"u"&&!b(E.extensionDependencies))return i.push([A.default.Error,s.localize(5,null,"extensionDependencies")]),i;if(typeof E.activationEvents<"u"){if(!b(E.activationEvents))return i.push([A.default.Error,s.localize(6,null,"activationEvents")]),i;if(typeof E.main>"u"&&typeof E.browser>"u")return i.push([A.default.Error,s.localize(7,null,"activationEvents","main","browser")]),i}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&i.push([A.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return i.push([A.default.Error,s.localize(9,null,"main")]),i;{const t=(0,S.$yg)(l,E.main);(0,S.$sg)(t,l)||i.push([A.default.Warning,s.localize(10,null,t.path,l.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return i.push([A.default.Error,s.localize(11,null,"browser")]),i;{const t=(0,S.$yg)(l,E.browser);(0,S.$sg)(t,l)||i.push([A.default.Warning,s.localize(12,null,t.path,l.path)])}}if(!M.valid(E.version))return i.push([A.default.Error,s.localize(13,null)]),i;const o=[];if(!f(g,h,E,u,o))for(const t of o)i.push([A.default.Error,t]);return i}e.$Uo=v;function f(g,h,l,E,u){return E||typeof l.main>"u"&&typeof l.browser>"u"?!0:w(g,h,l.engines.vscode,u)}e.$Vo=f;function y(g,h,l){return g==="*"||w(h,l,g)}e.$Wo=y;function w(g,h,l,E=[]){const u=$(a(l));if(!u)return E.push(s.localize(14,null,l)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return E.push(s.localize(15,null,l)),!1}else if(!u.majorMustEqual)return E.push(s.localize(16,null,l)),!1;return p(g,h,u)?!0:(E.push(s.localize(17,null,g,l)),!1)}function b(g){if(!Array.isArray(g))return!1;for(let h=0,l=g.length;h<l;h++)if(typeof g[h]!="string")return!1;return!0}}),define(ne[206],re([0,1,18,32]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;async function s(M,C,P){let d=P&&P.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const $=(await C.readFile(M.serviceMachineIdResource)).value.toString();d=(0,A.$gg)($)?$:null}catch{d=null}if(!d){d=(0,A.$hg)();try{await C.writeFile(M.serviceMachineIdResource,S.$ee.fromString(d))}catch{}}return P?.store("storage.serviceMachineId",d,-1,1),d}e.$ep=s}),define(ne[78],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=void 0;class S{constructor(s,M=[],C=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=C}}e.$Rh=S}),define(ne[207],re([0,1,78]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const A=[];var s;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(P,d,a){d instanceof S.$Rh||(d=new S.$Rh(d,[],!!a)),A.push([P,d])}e.$Cr=M;function C(){return A}e.$Dr=C}),define(ne[208],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;class S{constructor(M,C){this.key=M,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.$gq=S;class A{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const C of this.a.values())C.outgoing.size===0&&M.push(C);return M}insertEdge(M,C){const P=this.lookupOrInsertNode(M),d=this.lookupOrInsertNode(C);P.outgoing.set(d.key,d),d.incoming.set(P.key,P)}removeNode(M){const C=this.b(M);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(M){const C=this.b(M);let P=this.a.get(C);return P||(P=new S(C,M),this.a.set(C,P)),P}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[C,P]of this.a)M.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,C]of this.a){const P=new Set([M]),d=this.c(C,P);if(d)return d}}c(M,C){for(const[P,d]of M.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const a=this.c(d,C);if(a)return a;C.delete(P)}}}e.$hq=A}),define(ne[6],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e._util=void 0;var S;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(d){return d[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(S||(e._util=S={})),e.$Th=s("instantiationService");function A(C,P,d){P[S.DI_TARGET]===P?P[S.DI_DEPENDENCIES].push({id:C,index:d}):(P[S.DI_DEPENDENCIES]=[{id:C,index:d}],P[S.DI_TARGET]=P)}function s(C){if(S.serviceIds.has(C))return S.serviceIds.get(C);const P=function(d,a,$){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,d,$)};return P.toString=()=>C,S.serviceIds.set(C,P),P}e.$Uh=s;function M(C){return C}e.$Vh=M}),define(ne[64],re([0,1,13,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c8b=e.$b8b=void 0,e.$b8b=(0,A.$Uh)("auxiliaryWindowsMainService");function s(M){return M?.opener?.url.startsWith(`${S.Schemas.vscodeFileResource}://${S.$eg}/`)}e.$c8b=s}),define(ne[65],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V7b=void 0,e.$V7b=(0,S.$Uh)("backupMainService")}),define(ne[17],re([0,1,12,7,6]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.ConfigurationTarget=e.$qi=e.$pi=e.$oi=void 0,e.$oi=(0,s.$Uh)("configurationService");function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof A.URI)}e.$pi=M;function C(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof A.URI)}e.$qi=C;var P;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function d(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ri=d;function a(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$si=a;function $(g,h){const l=Object.create(null);for(const E in g)p(l,E,g[E],h);return l}e.$ti=$;function p(g,h,l,E){const u=h.split("."),i=u.pop();let o=g;for(let r=0;r<u.length;r++){const t=u[r];let n=o[t];switch(typeof n){case"undefined":n=o[t]=Object.create(null);break;case"object":break;default:E(`Ignoring ${h} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[i]=l}catch{E(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(o)}`)}else E(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(o)}`)}e.$ui=p;function v(g,h){const l=h.split(".");f(g,l)}e.$vi=v;function f(g,h){const l=h.shift();if(h.length===0){delete g[l];return}if(Object.keys(g).indexOf(l)!==-1){const E=g[l];typeof E=="object"&&!Array.isArray(E)&&(f(E,h),Object.keys(E).length===0&&delete g[l])}}function y(g,h,l){function E(o,r){let t=o;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const u=h.split("."),i=E(g,u);return typeof i>"u"?l:i}e.$wi=y;function w(g,h,l){Object.keys(h).forEach(E=>{E!=="__proto__"&&(E in g?S.$Df(g[E])&&S.$Df(h[E])?w(g[E],h[E],l):l&&(g[E]=h[E]):g[E]=h[E])})}e.$xi=w;function b(g){return g.replace(/[\[\]]/g,"")}e.$yi=b}),define(ne[114],re([0,1,4,27,197,6,164,14]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.ContextKeyExprType=e.$Qi=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",S.$j),d.set("isLinux",S.$k),d.set("isWindows",S.$i),d.set("isWeb",S.$o),d.set("isMacNative",S.$j&&!S.$o),d.set("isEdge",S.$H),d.set("isFirefox",S.$F),d.set("isChrome",S.$E),d.set("isSafari",S.$G);function a(Q,O){if(d.get(Q)!==void 0)throw(0,P.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(Q,O)}e.$Qi=a;const $=Object.prototype.hasOwnProperty;var p;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const v={regexParsingWithErrorRecovery:!0},f=(0,C.localize)(0,null),y=(0,C.localize)(1,null),w=(0,C.localize)(2,null),b=(0,C.localize)(3,null),g=(0,C.localize)(4,null),h=(0,C.localize)(5,null),l=(0,C.localize)(6,null),E=(0,C.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=v){this.k=O,this.d=new s.$Pi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const V=this.D(),L=V.type===17?h:void 0;throw this.h.push({message:g,offset:V.offset,lexeme:s.$Pi.getLexeme(V),additionalInfo:L}),u.c}return j}catch(j){if(j!==u.c)throw j;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const j=this.o();O.push(j)}return O.length===1?O[0]:i.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const j=this.s();O.push(j)}return O.length===1?O[0]:i.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),c.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,b),j?.negate()}case 17:return this.z(),F.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const j=this.l();return this.A(1,b),j}case 17:{const j=O.lexeme;if(this.z(),this.y(9)){const L=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),L.type!==10)throw this.B("REGEX",L);const B=L.lexeme,W=B.lastIndexOf("/"),X=W===B.length-1?void 0:this.w(B.substring(W+1));let he;try{he=new RegExp(B.substring(1,W),X)}catch{throw this.B("REGEX",L)}return oe.create(j,he)}switch(L.type){case 10:case 19:{const B=[L.lexeme];this.z();let W=this.D(),X=0;for(let be=0;be<L.lexeme.length;be++)L.lexeme.charCodeAt(be)===40?X++:L.lexeme.charCodeAt(be)===41&&X--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:X++;break;case 1:X--;break;case 10:case 18:for(let be=0;be<W.lexeme.length;be++)W.lexeme.charCodeAt(be)===40?X++:L.lexeme.charCodeAt(be)===41&&X--}if(X<0)break;B.push(s.$Pi.getLexeme(W)),this.z(),W=this.D()}const he=B.join(""),de=he.lastIndexOf("/"),le=de===he.length-1?void 0:this.w(he.substring(de+1));let we;try{we=new RegExp(he.substring(1,de),le)}catch{throw this.B("REGEX",L)}return i.regex(j,we)}case 18:{const B=L.lexeme;this.z();let W=null;if(!(0,A.$Ee)(B)){const X=B.indexOf("/"),he=B.lastIndexOf("/");if(X!==he&&X>=0){const de=B.slice(X+1,he),le=B[he+1]==="i"?"i":"";try{W=new RegExp(de,le)}catch{throw this.B("REGEX",L)}}}if(W===null)throw this.B("REGEX",L);return oe.create(j,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const L=this.u();return i.notIn(j,L)}switch(this.D().type){case 3:{this.z();const L=this.u();if(this.x().type===18)return i.equals(j,L);switch(L){case"true":return i.has(j);case"false":return i.not(j);default:return i.equals(j,L)}}case 4:{this.z();const L=this.u();if(this.x().type===18)return i.notEquals(j,L);switch(L){case"true":return i.not(j);case"false":return i.has(j);default:return i.notEquals(j,L)}}case 5:return this.z(),Y.create(j,this.u());case 6:return this.z(),ce.create(j,this.u());case 7:return this.z(),T.create(j,this.u());case 8:return this.z(),x.create(j,this.u());case 13:return this.z(),i.in(j,this.u());default:return i.has(j)}}case 20:throw this.h.push({message:l,offset:O.offset,lexeme:"",additionalInfo:E}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,j){if(this.C(O))return this.z();throw this.B(j,this.D())}B(O,j,V){const L=(0,C.localize)(8,null,O,s.$Pi.getLexeme(j)),B=j.offset,W=s.$Pi.getLexeme(j);return this.h.push({message:L,offset:B,lexeme:W,additionalInfo:V}),u.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ri=u;class i{static false(){return n.INSTANCE}static true(){return c.INSTANCE}static has(O){return m.create(O)}static equals(O,j){return D.create(O,j)}static notEquals(O,j){return I.create(O,j)}static regex(O,j){return oe.create(O,j)}static in(O,j){return R.create(O,j)}static notIn(O,j){return k.create(O,j)}static not(O){return F.create(O)}static and(...O){return K.create(O,null,!0)}static or(...O){return G.create(O,null,!0)}static greater(O,j){return T.create(O,j)}static greaterEquals(O,j){return x.create(O,j)}static smaller(O,j){return Y.create(O,j)}static smallerEquals(O,j){return ce.create(O,j)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Si=i;function o(Q){const O=new u({regexParsingWithErrorRecovery:!1});return Q.map(j=>(O.parse(j),O.lexingErrors.length>0?O.lexingErrors.map(V=>({errorMessage:V.additionalInfo?(0,C.localize)(9,null,V.additionalInfo):(0,C.localize)(10,null),offset:V.offset,length:V.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(V=>({errorMessage:V.additionalInfo?`${V.message}. ${V.additionalInfo}`:V.message,offset:V.offset,length:V.lexeme.length})):[]))}e.$Ti=o;function r(Q,O){const j=Q?Q.substituteConstants():void 0,V=O?O.substituteConstants():void 0;return!j&&!V?!0:!j||!V?!1:j.equals(V)}e.$Ui=r;function t(Q,O){return Q.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return c.INSTANCE}}e.$Vi=n;class c{static{this.INSTANCE=new c}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$Wi=c;class m{static create(O,j=null){const V=d.get(O);return typeof V=="boolean"?V?c.INSTANCE:n.INSTANCE:new m(O,j)}constructor(O,j){this.key=O,this.c=j,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:N(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=d.get(this.key);return typeof O=="boolean"?O?c.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Xi=m;class D{static create(O,j,V=null){if(typeof j=="boolean")return j?m.create(O,V):F.create(O,V);const L=d.get(O);return typeof L=="boolean"?j===(L?"true":"false")?c.INSTANCE:n.INSTANCE:new D(O,j,V)}constructor(O,j,V){this.c=O,this.d=j,this.f=V,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=d.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?c.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Yi=D;class R{static create(O,j){return new R(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:H(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.f),V=O.getValue(this.d);return Array.isArray(j)?j.includes(V):typeof V=="string"&&typeof j=="object"&&j!==null?$.call(j,V):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Zi=R;class k{static create(O,j){return new k(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=11,this.c=R.create(O,j)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$1i=k;class I{static create(O,j,V=null){if(typeof j=="boolean")return j?F.create(O,V):m.create(O,V);const L=d.get(O);return typeof L=="boolean"?j===(L?"true":"false")?n.INSTANCE:c.INSTANCE:new I(O,j,V)}constructor(O,j,V){this.c=O,this.d=j,this.f=V,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=d.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?n.INSTANCE:c.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$2i=I;class F{static create(O,j=null){const V=d.get(O);return typeof V=="boolean"?V?n.INSTANCE:c.INSTANCE:new F(O,j)}constructor(O,j){this.c=O,this.d=j,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:N(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=d.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:c.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$3i=F;function U(Q,O){if(typeof Q=="string"){const j=parseFloat(Q);isNaN(j)||(Q=j)}return typeof Q=="string"||typeof Q=="number"?O(Q):n.INSTANCE}class T{static create(O,j,V=null){return U(j,L=>new T(O,L,V))}constructor(O,j,V){this.c=O,this.d=j,this.f=V,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$4i=T;class x{static create(O,j,V=null){return U(j,L=>new x(O,L,V))}constructor(O,j,V){this.c=O,this.d=j,this.f=V,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$5i=x;class Y{static create(O,j,V=null){return U(j,L=>new Y(O,L,V))}constructor(O,j,V){this.c=O,this.d=j,this.f=V,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$6i=Y;class ce{static create(O,j,V=null){return U(j,L=>new ce(O,L,V))}constructor(O,j,V){this.c=O,this.d=j,this.f=V,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$7i=ce;class oe{static create(O,j){return new oe(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const j=this.f?this.f.source:"",V=O.f?O.f.source:"";return j<V?-1:j>V?1:0}equals(O){if(O.type===this.type){const j=this.f?this.f.source:"",V=O.f?O.f.source:"";return this.d===O.d&&j===V}return!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$8i=oe;class ae{static create(O){return new ae(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ae(this.c.map(O))}negate(){return this.c}}e.$9i=ae;function Z(Q){let O=null;for(let j=0,V=Q.length;j<V;j++){const L=Q[j].substituteConstants();if(Q[j]!==L&&O===null){O=[];for(let B=0;B<j;B++)O[B]=Q[B]}O!==null&&(O[j]=L)}return O===null?Q:O}class K{static create(O,j,V){return K.d(O,j,V)}constructor(O,j){this.expr=O,this.c=j,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,V=this.expr.length;j<V;j++){const L=t(this.expr[j],O.expr[j]);if(L!==0)return L}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,V=this.expr.length;j<V;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:K.create(O,this.c,!1)}evaluate(O){for(let j=0,V=this.expr.length;j<V;j++)if(!this.expr[j].evaluate(O))return!1;return!0}static d(O,j,V){const L=[];let B=!1;for(const W of O)if(W){if(W.type===1){B=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){L.push(...W.expr);continue}L.push(W)}if(L.length===0&&B)return c.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(t);for(let W=1;W<L.length;W++)L[W-1].equals(L[W])&&(L.splice(W,1),W--);if(L.length===1)return L[0];for(;L.length>1;){const W=L[L.length-1];if(W.type!==9)break;L.pop();const X=L.pop(),he=L.length===0,de=G.create(W.expr.map(le=>K.create([le,X],null,V)),null,he);de&&(L.push(de),L.sort(t))}if(L.length===1)return L[0];if(V){for(let W=0;W<L.length;W++)for(let X=W+1;X<L.length;X++)if(L[W].negate().equals(L[X]))return n.INSTANCE;if(L.length===1)return L[0]}return new K(L,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new K(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());this.c=G.create(O,this,!0)}return this.c}}e.$0i=K;class G{static create(O,j,V){return G.d(O,j,V)}constructor(O,j){this.expr=O,this.c=j,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,V=this.expr.length;j<V;j++){const L=t(this.expr[j],O.expr[j]);if(L!==0)return L}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,V=this.expr.length;j<V;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:G.create(O,this.c,!1)}evaluate(O){for(let j=0,V=this.expr.length;j<V;j++)if(this.expr[j].evaluate(O))return!0;return!1}static d(O,j,V){let L=[],B=!1;if(O){for(let W=0,X=O.length;W<X;W++){const he=O[W];if(he){if(he.type===0){B=!0;continue}if(he.type===1)return c.INSTANCE;if(he.type===9){L=L.concat(he.expr);continue}L.push(he)}}if(L.length===0&&B)return n.INSTANCE;L.sort(t)}if(L.length!==0){if(L.length===1)return L[0];for(let W=1;W<L.length;W++)L[W-1].equals(L[W])&&(L.splice(W,1),W--);if(L.length===1)return L[0];if(V){for(let W=0;W<L.length;W++)for(let X=W+1;X<L.length;X++)if(L[W].negate().equals(L[X]))return c.INSTANCE;if(L.length===1)return L[0]}return new G(L,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new G(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());for(;O.length>1;){const j=O.shift(),V=O.shift(),L=[];for(const B of se(j))for(const W of se(V))L.push(K.create([B,W],null,!1));O.unshift(G.create(L,null,!1))}this.c=G.create(O,this,!0)}return this.c}}e.$$i=G;class z extends m{static{this.d=[]}static all(){return z.d.values()}constructor(O,j,V){super(O,null),this.f=j,typeof V=="object"?z.d.push({...V,key:O}):V!==!0&&z.d.push({key:O,description:V,type:j!=null?typeof j:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return D.create(this.key,O)}notEqualsTo(O){return I.create(this.key,O)}}e.$_i=z,e.$aj=(0,M.$Uh)("contextKeyService");function N(Q,O){return Q<O?-1:Q>O?1:0}function H(Q,O,j,V){return Q<j?-1:Q>j?1:O<V?-1:O>V?1:0}function q(Q,O){if(Q.type===0||O.type===1)return!0;if(Q.type===9)return O.type===9?ee(Q.expr,O.expr):!1;if(O.type===9){for(const j of O.expr)if(q(Q,j))return!0;return!1}if(Q.type===6){if(O.type===6)return ee(O.expr,Q.expr);for(const j of Q.expr)if(q(j,O))return!0;return!1}return Q.equals(O)}e.$bj=q;function ee(Q,O){let j=0,V=0;for(;j<Q.length&&V<O.length;){const L=Q[j].cmp(O[V]);if(L<0)return!1;L===0&&j++,V++}return j===Q.length}function se(Q){return Q.type===9?Q.expr:[Q]}}),define(ne[91],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=e.$vm=e.ID=void 0,e.ID="diagnosticsService",e.$vm=(0,S.$Uh)(e.ID);function A(M){return!!M.hostName&&!!M.errorMessage}e.$wm=A;class s{async getPerformanceInfo(C,P){return{}}async getSystemInfo(C,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,P){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.$xm=s}),define(ne[115],re([0,1,19,74,166,6,46,4,38]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lv=e.$Kv=e.ConfirmResult=e.$Jv=e.$Iv=e.$Hv=void 0,e.$Hv=(0,M.$Uh)("dialogService");var a;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(a||(a={}));class ${a(b){return this.d(b,a.Confirmation)}b(b){return this.d(b,a.Prompt)}c(b){return this.d(b,a.Input)}d(b,g){const h=[];switch(g){case a.Confirmation:{const l=b;l.primaryButton?h.push(l.primaryButton):h.push((0,s.localize)(0,null)),l.cancelButton?h.push(l.cancelButton):h.push((0,s.localize)(1,null));break}case a.Prompt:{const l=b;Array.isArray(l.buttons)&&l.buttons.length>0&&h.push(...l.buttons.map(E=>E.label)),l.cancelButton&&(l.cancelButton===!0?h.push((0,s.localize)(2,null)):typeof l.cancelButton=="string"?h.push(l.cancelButton):l.cancelButton.label?h.push(l.cancelButton.label):h.push((0,s.localize)(3,null))),h.length===0&&h.push((0,s.localize)(4,null));break}case a.Input:{const l=b;l.primaryButton?h.push(l.primaryButton):h.push((0,s.localize)(5,null)),l.cancelButton?h.push(l.cancelButton):h.push((0,s.localize)(6,null));break}}return h}e(b){if(typeof b=="string")return b;if(typeof b=="number")return b===A.default.Info?"info":b===A.default.Error?"error":b===A.default.Warning?"warning":"none"}f(b,g,h){const l=[...b.buttons??[]];b.cancelButton&&typeof b.cancelButton!="string"&&typeof b.cancelButton!="boolean"&&l.push(b.cancelButton);let E=l[g]?.run({checkboxChecked:h});return E instanceof Promise||(E=Promise.resolve(E)),{result:E,checkboxChecked:h}}}e.$Iv=$,e.$Jv=(0,M.$Uh)("fileDialogService");var p;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(p||(e.ConfirmResult=p={}));const v=10;function f(w){const b=[];return b.push(...w.slice(0,v).map(g=>typeof g=="string"?g:(0,S.$vg)(g))),w.length>v&&(w.length-v===1?b.push((0,s.localize)(7,null)):b.push((0,s.localize)(8,null,w.length-v))),b.push(""),b.join(`
`)}e.$Kv=f;function y(w,b){const g=(0,d.$_m)(w);let h=(g.buttons??[]).map(i=>(0,C.$Ev)(i)),l=(w.buttons||[]).map((i,o)=>o),E=0,u=g.cancelId??h.length-1;if(h.length>1){const i=typeof u=="number"?h[u]:void 0;if(P.$k||P.$j){if(typeof i=="string"&&h.length>1&&u!==1){h.splice(u,1),h.splice(1,0,i);const o=l[u];l.splice(u,1),l.splice(1,0,o),u=1}P.$k&&h.length>1&&(h=h.reverse(),l=l.reverse(),E=h.length-1,typeof i=="string"&&(u=E-1))}else if(P.$i&&typeof i=="string"&&h.length>1&&u!==h.length-1){h.splice(u,1),h.push(i);const o=l[u];l.splice(u,1),l.push(o),u=h.length-1}}return g.buttons=h,g.defaultId=E,g.cancelId=u,g.noLink=!0,g.title=g.title||b.nameLong,{options:g,buttonIndeces:l}}e.$Lv=y}),define(ne[116],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EU=e.$DU=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$CU=e.$BU=void 0,e.$BU=(0,S.$Uh)("encryptionService"),e.$CU=(0,S.$Uh)("encryptionMainService");var A;(function(P){P.kwallet="kwallet",P.kwallet5="kwallet5",P.gnome="gnome",P.gnomeKeyring="gnome-keyring",P.gnomeLibsecret="gnome-libsecret",P.basic="basic"})(A||(e.PasswordStoreCLIOption=A={}));var s;(function(P){P.unknown="unknown",P.basicText="basic_text",P.gnomeAny="gnome_any",P.gnomeLibsecret="gnome_libsecret",P.gnomeKeyring="gnome_keyring",P.kwallet="kwallet",P.kwallet5="kwallet5",P.kwallet6="kwallet6",P.dplib="dpapi",P.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(P){return P==="kwallet"||P==="kwallet5"||P==="kwallet6"}e.$DU=M;function C(P){return P==="gnome_any"||P==="gnome_libsecret"||P==="gnome_keyring"}e.$EU=C}),define(ne[37],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=void 0,e.$2h=(0,S.$Uh)("environmentService"),e.$3h=(0,S.$Vh)(e.$2h)}),define(ne[117],re([0,1,170,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$co=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0,e.$3n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$4n=new RegExp(e.$3n),e.$5n="__web_extension",e.$6n="skipWalkthrough",e.$7n="extensionsSync",e.$8n="dependecyOrPackExtensionInstall";function s(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$9n=s;function M(g){switch(g){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$0n=M;function C(g,h){switch(g){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$$n=C;function P(g,h){return h==="web"&&!g.includes("web")}e.$_n=P;function d(g,h,l){return P(h,l)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===l}e.$ao=d;function a(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.$bo=a;var $;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var p;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var v;(function(g){g.Install="install",g.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var f;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$co=(0,A.$Uh)("extensionGalleryService");var y;(function(g){g.Unsupported="Unsupported",g.Deprecated="Deprecated",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.ReleaseVersionNotFound="ReleaseVersionNotFound",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Signature="Signature",g.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var w;(function(g){g.UnknownError="UnknownError",g.PackageIsInvalidZip="PackageIsInvalidZip",g.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class b extends Error{constructor(h,l){super(h),this.code=l,this.name=l}}e.$do=b,e.$eo=(0,A.$Uh)("extensionManagementService"),e.$fo="extensionsIdentifiers/disabled",e.$go="extensionsIdentifiers/enabled",e.$ho=(0,A.$Uh)("IGlobalExtensionEnablementService"),e.$io=(0,A.$Uh)("IExtensionTipsService"),e.$jo=(0,S.localize)(0,null),e.$ko={value:e.$jo,original:"Extensions"},e.$lo={value:(0,S.localize)(1,null),original:"Preferences"}}),define(ne[209],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r8b=e.$q8b=void 0,e.$q8b=(0,S.$Uh)("extensionHostStarter"),e.$r8b="extensionHostStarter"}),define(ne[210],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yZb=e.$xZb=void 0,e.$xZb=(0,S.$Uh)("externalTerminal"),e.$yZb="Terminal.app"}),define(ne[211],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=void 0,e.$t8b=(0,S.$Uh)("externalTerminal")}),define(ne[212],re([0,1,47,13,9,4,76,21,89,174,210]),function(J,e,S,A,s,M,C,P,d,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8b=e.$v8b=e.$u8b=void 0;const p=a.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends v{static{this.b="cmd.exe"}openTerminal(E,u){return this.spawnTerminal(S,E,d.$Gl(),u)}spawnTerminal(E,u,i,o){const r=u.windowsExec||f.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const t=s.$mc(r,".exe").toLowerCase();if(t==="cmder")return E.spawn(r,o?[o]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),t==="wt"&&n.push("-d ."),new Promise((c,m)=>{const D=b(process),R=E.spawn(i,n,{cwd:o,env:D});R.on("error",m),R.on("exit",()=>c())})}runInTerminal(E,u,i,o,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,c)=>{const m=`"${u} - ${p}"`,D=`""${i.join('" "')}" & pause"`,R=Object.assign({},b(process),o);Object.keys(R).filter(T=>R[T]===null).forEach(T=>delete R[T]);const k={cwd:u,env:R,windowsVerbatimArguments:!0};let I,F;s.$mc(t,".exe")==="wt"?(I=t,F=["-d",".",f.b,"/c",D]):(I=f.b,F=["/c","start",m,"/wait",t,"/c",D]),S.spawn(I,F,k).on("error",T=>{c(g(T))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.$u8b=f;class y extends v{static{this.b="/usr/bin/osascript"}openTerminal(E,u){return this.spawnTerminal(S,E,u)}runInTerminal(E,u,i,o,r){const t=r.osxExec||$.$yZb;return new Promise((n,c)=>{if(t===$.$yZb||t==="iTerm.app"){const m=t===$.$yZb?"TerminalHelper":"iTermHelper",R=[A.$fg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`).fsPath,"-t",E||p,"-w",u];for(const F of i)R.push("-a"),R.push(F);if(o){const F=Object.assign({},b(process),o);for(const U in F){const T=F[U];T===null?(R.push("-u"),R.push(U)):(R.push("-e"),R.push(`${U}=${T}`))}}let k="";const I=S.spawn(y.b,R);I.on("error",F=>{c(g(F))}),I.stderr.on("data",F=>{k+=F.toString()}),I.on("exit",F=>{if(F===0)n(void 0);else if(k){const U=k.split(`
`,1);c(new Error(U[0]))}else c(new Error(a.localize(1,null,m,F)))})}else c(new Error(a.localize(2,null,t)))})}spawnTerminal(E,u,i){const o=u.osxExec||$.$yZb;return new Promise((r,t)=>{const n=["-a",o];i&&n.push(i);const c=b(process),m=E.spawn("/usr/bin/open",n,{cwd:i,env:c});m.on("error",t),m.on("exit",()=>r())})}}e.$v8b=y;class w extends v{static{this.b=a.localize(3,null)}openTerminal(E,u){return this.spawnTerminal(S,E,u)}runInTerminal(E,u,i,o,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((n,c)=>{const m=[];t.then(D=>{D.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const R=`${h(i)}; echo; read -p "${w.b}" -n1;`;m.push(`''${R}''`);const k=Object.assign({},b(process),o);Object.keys(k).filter(T=>k[T]===null).forEach(T=>delete k[T]);const I={cwd:u,env:k};let F="";const U=S.spawn(D,m,I);U.on("error",T=>{c(g(T))}),U.stderr.on("data",T=>{F+=T.toString()}),U.on("exit",T=>{if(T===0)n(void 0);else if(F){const x=F.split(`
`,1);c(new Error(x[0]))}else c(new Error(a.localize(4,null,D,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!M.$k)w.d=Promise.resolve("xterm");else{const E=await P.Promises.exists("/etc/debian_version");w.d=new Promise(u=>{E?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return w.d}spawnTerminal(E,u,i){const o=u.linuxExec?Promise.resolve(u.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{o.then(n=>{const c=b(process),m=E.spawn(n,[],{cwd:i,env:c});m.on("error",t),m.on("exit",()=>r())})})}}e.$w8b=w;function b(l){const E={...l.env};return(0,C.$El)(E),E}function g(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(a.localize(5,null,l.path)):l}function h(l){let E="";for(const u of l)u.indexOf(" ")>=0?E+='"'+u+'"':E+=u,E+=" ";return E}}),define(ne[16],re([0,1,57,9,27,12,7,176,6,4,13,72]),function(J,e,S,A,s,M,C,P,d,a,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileKind=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileOperationResult=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileChangeType=e.$vk=e.FileOperation=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileSystemProviderErrorCode=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileSystemProviderCapabilities=e.$fk=e.FilePermission=e.FileType=e.$ek=e.$dk=void 0,e.$dk=(0,d.$Uh)("fileService");function v(q){return q.create===!0}e.$ek=v;var f;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var y;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(y||(e.FilePermission=y={}));function w(q){const ee=q;return!!ee&&typeof ee.onDidChange=="function"}e.$fk=w;var b;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function g(q){return!!(q.capabilities&2)}e.$gk=g;function h(q){return!!(q.capabilities&8)}e.$hk=h;function l(q){return!!(q.capabilities&131072)}e.$ik=l;function E(q){return!!(q.capabilities&4)}e.$jk=E;function u(q){return!!(q.capabilities&16)}e.$kk=u;function i(q){return g(q)?!!(q.capabilities&16384):!1}e.$lk=i;function o(q){return g(q)?!!(q.capabilities&32768):!1}e.$mk=o;function r(q){return!!(q.capabilities&65536)}e.$nk=r;function t(q){return!!(q.capabilities&2048)}e.$ok=t;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class c extends Error{static create(ee,se){const Q=new c(ee.toString(),se);return R(Q,se),Q}constructor(ee,se){super(ee),this.code=se}}e.$pk=c;function m(q,ee){return c.create(q,ee)}e.$qk=m;function D(q){return q||m((0,P.localize)(0,null),n.Unknown)}e.$rk=D;function R(q,ee){return q.name=ee?`${ee} (FileSystemError)`:"FileSystemError",q}e.$sk=R;function k(q){if(!q)return n.Unknown;if(q instanceof c)return q.code;const ee=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!ee)return n.Unknown;switch(ee[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$tk=k;function I(q){if(q instanceof ce)return q.fileOperationResult;switch(k(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$uk=I;var F;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class U{constructor(ee,se,Q){this.resource=ee,this.operation=se,this.target=Q}isOperation(ee){return this.operation===ee}}e.$vk=U;var T;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class x{static{this.a=null}constructor(ee,se){this.c=se,this.b=void 0,this.d=new p.$U(()=>{const Q=S.$1h.forUris(()=>this.c);return Q.fill(this.rawAdded.map(O=>[O,!0])),Q}),this.f=new p.$U(()=>{const Q=S.$1h.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(O=>[O,!0])),Q}),this.g=new p.$U(()=>{const Q=S.$1h.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(O=>[O,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of ee){switch(Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}this.b!==x.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=x.a):this.b!==void 0&&(this.b=x.a))}}contains(ee,...se){return this.h(ee,{includeChildren:!1},...se)}affects(ee,...se){return this.h(ee,{includeChildren:!0},...se)}h(ee,se,...Q){if(!ee)return!1;const O=Q.length>0;return!!((!O||Q.includes(1))&&(this.d.value.get(ee)||se.includeChildren&&this.d.value.findSuperstr(ee))||(!O||Q.includes(0))&&(this.f.value.get(ee)||se.includeChildren&&this.f.value.findSuperstr(ee))||(!O||Q.includes(2))&&(this.g.value.findSubstr(ee)||se.includeChildren&&this.g.value.findSuperstr(ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ee){return this.b===ee}hasCorrelation(){return typeof this.b=="number"}}e.$wk=x;function Y(q,ee,se){return!q||!ee||q===ee||ee.length>q.length?!1:(ee.charAt(ee.length-1)!==A.sep&&(ee+=A.sep),se?(0,s.$6e)(q,ee):q.indexOf(ee)===0)}e.$xk=Y;class ce extends Error{constructor(ee,se,Q){super(ee),this.fileOperationResult=se,this.options=Q}}e.$yk=ce;class oe extends ce{constructor(ee,se,Q,O){super(ee,se,O),this.fileOperationResult=se,this.size=Q}}e.$zk=oe;class ae extends ce{constructor(ee,se,Q){super(ee,2,Q),this.stat=se}}e.$Ak=ae;var Z;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$Bk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ck={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dk="files.associations",e.$Ek="files.exclude",e.$Fk="files.readonlyInclude",e.$Gk="files.readonlyExclude",e.$Hk="files.readonlyFromPermissions";var K;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(K||(e.FileKind=K={})),e.$Ik="";function G(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Jk=G;async function z(q,ee){if(!ee.hasProvider(C.URI.from({scheme:q.scheme})))return new Promise(se=>{const Q=ee.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===q.scheme&&O.added&&(Q.dispose(),se())})})}e.$Kk=z;class N{static{this.KB=1024}static{this.MB=N.KB*N.KB}static{this.GB=N.MB*N.KB}static{this.TB=N.GB*N.KB}static formatSize(ee){return(0,M.$Ff)(ee)||(ee=0),ee<N.KB?(0,P.localize)(1,null,ee.toFixed(0)):ee<N.MB?(0,P.localize)(2,null,(ee/N.KB).toFixed(2)):ee<N.GB?(0,P.localize)(3,null,(ee/N.MB).toFixed(2)):ee<N.TB?(0,P.localize)(4,null,(ee/N.GB).toFixed(2)):(0,P.localize)(5,null,(ee/N.TB).toFixed(2))}}e.$Lk=N;function H(q){const ee=typeof q=="string"||q?.scheme===$.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===$.Schemas.file?1024*N.MB:ee?10*N.MB:a.$o?50*N.MB:1024*N.MB}e.$Mk=H}),define(ne[118],re([0,1,18,14,177,16]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;async function C($,p,v,f,y,w){let b;try{await P($,p,v,f,y,w)}catch(g){b=g}finally{b&&y.errorTransformer&&(b=y.errorTransformer(b)),typeof b<"u"&&v.error(b),v.end()}}e.$Rp=C;async function P($,p,v,f,y,w){d(w);const b=await $.open(p,{create:!1});try{d(w);let g=0,h=0,l=y&&typeof y.length=="number"?y.length:void 0,E=S.$ee.alloc(Math.min(y.bufferSize,typeof l=="number"?l:y.bufferSize)),u=y&&typeof y.position=="number"?y.position:0,i=0;do h=await $.read(b,u,E.buffer,i,E.byteLength-i),u+=h,i+=h,g+=h,typeof l=="number"&&(l-=h),i===E.byteLength&&(await v.write(f(E)),E=S.$ee.alloc(Math.min(y.bufferSize,typeof l=="number"?l:y.bufferSize)),i=0);while(h>0&&(typeof l!="number"||l>0)&&d(w)&&a(g,y));if(i>0){let o=i;typeof l=="number"&&(o=Math.min(i,l)),v.write(f(E.slice(0,o)))}}catch(g){throw(0,M.$rk)(g)}finally{await $.close(b)}}function d($){if($.isCancellationRequested)throw(0,A.$5)();return!0}function a($,p){if(typeof p?.limits?.size=="number"&&$>p.limits.size)throw(0,M.$qk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[66],re([0,1,104,2,9,4,7,16]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=void 0;function d(g){return g.recursive===!0}e.$Tp=d;class a extends A.$Rc{static{this.a=5}constructor(h,l,E,u){super(),this.h=h,this.j=l,this.m=E,this.n=u,this.c=this.B(new A.$Sc),this.f=void 0,this.g=0}s(){const h=new A.$Qc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(l=>this.h(l))),h.add(this.b.onDidLogMessage(l=>this.j(l))),h.add(this.b.onDidError(l=>this.t(l)))}t(h){this.n.restartOnError?this.g<a.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Up=a;class $ extends a{constructor(h,l,E){super(h,l,E,{type:"node.js",restartOnError:!1})}}e.$Vp=$;class p extends a{constructor(h,l,E){super(h,l,E,{type:"universal",restartOnError:!0})}}e.$Wp=p;function v(g){return g.map(h=>({type:h.type,resource:C.URI.revive(h.resource),cId:h.cId}))}e.$Xp=v;function f(g){const h=new b;for(const l of g)h.processEvent(l);return h.coalesce()}e.$Yp=f;function y(g,h){return typeof h=="string"&&!h.startsWith(S.$xj)&&!(0,s.$hc)(h)?{base:g,pattern:h}:h}e.$Zp=y;function w(g,h){const l=[];for(const E of h)l.push((0,S.$Bj)(y(g,E)));return l}e.$1p=w;class b{constructor(){this.a=new Set,this.b=new Map}c(h){return M.$k?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const l=this.b.get(this.c(h));let E=!1;if(l){const u=l.type,i=h.type;l.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?E=!0:u===1&&i===2?(this.b.delete(this.c(h)),this.a.delete(l)):u===2&&i===1?l.type=0:u===1&&i===0||(l.type=i)}else E=!0;E&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],l=[];return Array.from(this.a).filter(E=>E.type!==2?(h.push(E),!1):!0).sort((E,u)=>E.resource.fsPath.length-u.resource.fsPath.length).filter(E=>l.some(u=>(0,P.$xk)(E.resource.fsPath,u,!M.$k))?!1:(l.push(E.resource.fsPath),!0)).concat(h)}}}),define(ne[213],re([0,1,18,49,14,3,2,62,32,16,66]),function(J,e,S,A,s,M,C,P,d,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.$GN=void 0,e.$GN="localFilesystem";class p extends C.$Rc{constructor(f,y){super(),this.a=f,this.b=y,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Qd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Qd),this.onDidWatchError=this.g.event,this.h=(0,d.$hg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,y){const{buffer:w}=await this.a.call("readFile",[f,y]);return w}readFileStream(f,y,w){const b=(0,P.$5d)(h=>S.$ee.concat(h.map(l=>S.$ee.wrap(l))).buffer),g=new C.$Qc;return g.add(this.a.listen("readFileStream",[f,y])(h=>{if(h instanceof S.$ee)b.write(h.buffer);else{if(h==="end")b.end();else{let l;if(h instanceof Error)l=h;else{const E=h;l=(0,a.$qk)(E.message??(0,A.$Fi)(E),E.code??a.FileSystemProviderErrorCode.Unknown)}b.error(l),b.end()}g.dispose()}})),g.add(w.onCancellationRequested(()=>{b.error((0,s.$5)()),b.end(),g.dispose()})),b}writeFile(f,y,w){return this.a.call("writeFile",[f,S.$ee.wrap(y),w])}open(f,y){return this.a.call("open",[f,y])}close(f){return this.a.call("close",[f])}async read(f,y,w,b,g){const[h,l]=await this.a.call("read",[f,y,g]);return w.set(h.buffer.slice(0,l),b),l}write(f,y,w,b,g){return this.a.call("write",[f,y,S.$ee.wrap(w),b,g])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,y){return this.a.call("delete",[f,y])}rename(f,y,w){return this.a.call("rename",[f,y,w])}copy(f,y,w){return this.a.call("copy",[f,y,w])}cloneFile(f,y){return this.a.call("cloneFile",[f,y])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const y=f;this.f.fire((0,$.$Xp)(y))}else{const y=f;this.g.fire(y)}}))}watch(f,y){const w=(0,d.$hg)();return this.a.call("watch",[this.h,w,f,y]),(0,C.$Pc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$HN=p}),define(ne[214],re([0,1,45,8,22,33,2,85,9,4,19,7,105,21,66]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class w extends C.$Rc{static{this.a=100}static{this.b=75}constructor(h,l,E,u){super(),this.m=h,this.n=l,this.r=E,this.s=u,this.c=this.B(new A.$_g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new A.$$g(i=>this.z(i),w.b)),this.g=(0,y.$1p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$1p)(this.m.path,this.m.includes):void 0,this.j=new s.$1d,this.ready=this.t()}async t(){try{const h=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await f.Promises.stat(h);this.B(await this.w(h,l.isDirectory()))}catch(h){h.code!=="ENOENT"?this.D(h):this.G(h)}}async u(h){let l=h.path;try{l=await f.Promises.realpath(h.path),h.path===l&&(l=await(0,v.$$p)(h.path)??h.path),h.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${l})`)}catch{}return l}async w(h,l){if(a.$j&&(0,M.$1f)(h,"/Volumes/",!0))return this.D(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.$Rc.None;const E=new s.$1d(this.j.token),u=new C.$Qc;try{const i=p.URI.file(this.m.path),o=(0,d.$mc)(h),r=(0,S.watch)(h);u.add((0,C.$Pc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${h}'`);const t=new Set;if(l)try{for(const c of await f.Promises.readdir(h))t.add(c)}catch(c){this.D(c)}const n=new Map;u.add((0,C.$Pc)(()=>{for(const[,c]of n)c.dispose();n.clear()})),r.on("error",(c,m)=>{this.D(`Failed to watch ${h} for changes using fs.watch() (${c}, ${m})`),this.dispose()}),r.on("change",(c,m)=>{if(E.token.isCancellationRequested)return;this.G(`[raw] ["${c}"] ${m}`);let D="";if(m&&(D=m.toString(),a.$j&&(D=(0,P.$tl)(D))),!(!D||c!=="change"&&c!=="rename"))if(l)if(c==="rename"){n.get(D)?.dispose();const R=setTimeout(async()=>{if(n.delete(D),D===o&&!await f.Promises.exists(h)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,d.$ic)(h,D));if(E.token.isCancellationRequested)return;let I;k?t.has(D)?I=0:(I=1,t.add(D)):(t.delete(D),I=2),this.y({resource:(0,$.$yg)(i,D),type:I,cId:this.m.correlationId})},w.a);n.set(D,(0,C.$Pc)(()=>clearTimeout(R)))}else{let R;t.has(D)?R=0:(R=1,t.add(D)),this.y({resource:(0,$.$yg)(i,D),type:R,cId:this.m.correlationId})}else if(c==="rename"||D!==o){const R=setTimeout(async()=>{const k=await f.Promises.exists(h);E.token.isCancellationRequested||(k?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),u.add(await this.w(h,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);u.clear(),u.add((0,C.$Pc)(()=>clearTimeout(R)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await f.Promises.exists(h)&&!E.token.isCancellationRequested&&this.D(`Failed to watch ${h} for changes using fs.watch() (${i.toString()})`)}return(0,C.$Pc)(()=>{E.dispose(!0),u.dispose()})}y(h,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!l&&this.g.some(E=>E(h.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${h.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(E=>E(h.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${h.resource.fsPath}`):this.f.work(h))}z(h){const l=(0,y.$Yp)(h);if(l.length>0){if(this.s)for(const u of l)this.G(` >> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(h){if(a.$k)return f.Promises.exists(h);try{const l=(0,d.$mc)(h);return(await f.Promises.readdir((0,d.$lc)(h))).some(u=>u===l)}catch(l){return this.G(l),!1}}setVerboseLogging(h){this.s=h}D(h){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}F(h){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}G(h){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$bq=w;async function b(g,h,l,E,u=512){const i=await f.Promises.open(g,"r"),o=Buffer.allocUnsafe(u),r=new s.$1d(E);let t,n=!1;const c={path:g,excludes:[],recursive:!1},m=new w(c,D=>{(async()=>{for(const{type:R}of D)if(R===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:k}=await f.Promises.read(i,o,0,u,null);if(!k||r.token.isCancellationRequested)break;h(o.slice(0,k))}}catch(k){t=new Error(k),r.dispose(!0)}finally{n=!1}}})()});return await m.ready,l(),new Promise((D,R)=>{r.token.onCancellationRequested(async()=>{m.dispose();try{await f.Promises.close(i)}catch(k){t=new Error(k)}t?R(t):D()})})}e.$cq=b}),define(ne[215],re([0,1,3,104,2,4,214]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class P extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new S.$Qd),this.onDidChangeFile=this.a.event,this.b=this.B(new S.$Qd),this.onDidLogMessage=this.b.event,this.onDidError=S.Event.None,this.c=new Map,this.f=!1}async watch(a){const $=this.j(a),p=$.filter(f=>{const y=this.c.get(f.path);return y?!(0,A.$Fj)(y.request.excludes,f.excludes)||!(0,A.$Fj)(y.request.includes,f.includes):!0}),v=Array.from(this.c.values()).filter(({request:f})=>!$.find(y=>y.path===f.path&&(0,A.$Fj)(y.excludes,f.excludes)&&(0,A.$Fj)(y.includes,f.includes))).map(({request:f})=>f.path);p.length&&this.m(`Request to start watching: ${p.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const f of v)this.h(f);for(const f of p)this.g(f)}g(a){const $=new C.$bq(a,v=>this.a.fire(v),v=>this.b.fire(v),this.f),p={request:a,instance:$};this.c.set(a.path,p)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const $=this.c.get(a);$&&(this.c.delete(a),$.instance.dispose())}j(a){const $=new Map;for(const p of a){const v=M.$k?p.path:p.path.toLowerCase();let f=$.get(p.correlationId);f||(f=new Map,$.set(p.correlationId,f)),f.set(v,p)}return Array.from($.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,$]of this.c)$.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,$){return $?`[File Watcher (node.js)] ${a} (path: ${$.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$dq=P}),define(ne[216],re([0,1,66,215]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class s extends S.$Vp{constructor(C,P,d){super(C,P,d),this.s()}r(C){return C.add(new A.$dq)}}e.$eq=s}),define(ne[217],re([0,1,13,42,160,66]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class C extends M.$Wp{constructor(d,a,$){super(d,a,$),this.s()}r(d){const a=d.add(new s.$8p(S.$fg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(a.onDidProcessExit(({code:$,signal:p})=>this.t(`terminated by itself with code ${$}, signal: ${p}`))),A.ProxyChannel.toService((0,A.$Bh)(a.getChannel("watcher")))}}e.$9p=C}),define(ne[92],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class S{constructor(...s){this.a=new Map;for(const[M,C]of s)this.set(M,C)}set(s,M){const C=this.a.get(s);return this.a.set(s,M),C}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$Sh=S}),define(ne[218],re([0,1,8,14,2,78,208,6,92,101]),function(J,e,S,A,s,M,C,P,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=void 0;const $=!1;class p extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class v{constructor(b=new d.$Sh,g=!1,h,l=$){this.f=b,this.g=g,this.h=h,this.i=l,this.o=new Set,this.f.set(P.$Th,this),this._globalGraph=l?h?._globalGraph??new C.$hq(E=>E):void 0}createChild(b){return new v(b,this.g,this,this.i)}invokeFunction(b,...g){const h=y.traceInvocation(this.i,b);let l=!1;try{return b({get:u=>{if(l)throw(0,A.$7)("service accessor is only valid during the invocation of its target method");const i=this.m(u,h);if(!i)throw new Error(`[invokeFunction] unknown service '${u}'`);return i}},...g)}finally{l=!0,h.stop()}}createInstance(b,...g){let h,l;return b instanceof M.$Rh?(h=y.traceCreation(this.i,b.ctor),l=this.j(b.ctor,b.staticArguments.concat(g),h)):(h=y.traceCreation(this.i,b),l=this.j(b,g,h)),h.stop(),l}j(b,g=[],h){const l=P._util.getServiceDependencies(b).sort((i,o)=>i.index-o.index),E=[];for(const i of l){const o=this.m(i.id,h);o||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),E.push(o)}const u=l.length>0?l[0].index:g.length;if(g.length!==u){console.trace(`[createInstance] First service dependency of ${b.name} at position ${u+1} conflicts with ${g.length} static arguments`);const i=u-g.length;i>0?g=g.concat(new Array(i)):g=g.slice(0,u)}return Reflect.construct(b,g.concat(E))}k(b,g){if(this.f.get(b)instanceof M.$Rh)this.f.set(b,g);else if(this.h)this.h.k(b,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const g=this.f.get(b);return!g&&this.h?this.h.l(b):g}m(b,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const h=this.l(b);return h instanceof M.$Rh?this.q(b,h,g.branch(b,!0)):(g.branch(b,!1),h)}q(b,g,h){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,g,h)}finally{this.o.delete(b)}}r(b,g,h){const l=new C.$hq(i=>i.id.toString());let E=0;const u=[{id:b,desc:g,_trace:h}];for(;u.length;){const i=u.pop();if(l.lookupOrInsertNode(i),E++>1e3)throw new p(l);for(const o of P._util.getServiceDependencies(i.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${b} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),r instanceof M.$Rh){const t={id:o.id,desc:r,_trace:i._trace.branch(o.id,!0)};l.insertEdge(i,t),u.push(t)}}}for(;;){const i=l.roots();if(i.length===0){if(!l.isEmpty())throw new p(l);break}for(const{data:o}of i){if(this.l(o.id)instanceof M.$Rh){const t=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,t)}l.removeNode(o)}}return this.l(b)}s(b,g,h=[],l,E){if(this.f.get(b)instanceof M.$Rh)return this.t(b,g,h,l,E);if(this.h)return this.h.s(b,g,h,l,E);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(b,g,h=[],l,E){if(l){const u=new v(void 0,this.g,this,this.i);u.c=String(b);const i=new Map,o=new S.$dh(()=>{const r=u.j(g,h,E);for(const[t,n]of i){const c=r[t];if(typeof c=="function")for(const m of n)c.apply(r,m)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,t){if(!o.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let m=i.get(t);return m||(m=new a.$1c,i.set(t,m)),(R,k,I)=>{const F=m.push([R,k,I]);return(0,s.$Pc)(F)}}if(t in r)return r[t];const n=o.value;let c=n[t];return typeof c!="function"||(c=c.bind(n),r[t]=c),c},set(r,t,n){return o.value[t]=n,!0},getPrototypeOf(r){return g.prototype}})}else return this.j(g,h,E)}u(b,g){if(g&&console.warn(b),this.g)throw new Error(b)}}e.$iq=v;var f;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(f||(f={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(b,g){return b?new y(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(b,g){return b?new y(1,g.name):y.c}static{this.f=0}constructor(b,g){this.type=b,this.name=g,this.g=Date.now(),this.h=[]}branch(b,g){const h=new y(3,b.toString());return this.h.push([b,g,h]),h}stop(){const b=Date.now()-this.g;y.f+=b;let g=!1;function h(E,u){const i=[],o=new Array(E+1).join("	");for(const[r,t,n]of u.h)if(t&&n){g=!0,i.push(`${o}CREATES -> ${r}`);const c=h(E+1,n);c&&i.push(c)}else i.push(`${o}uses -> ${r}`);return i.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(b>2||g)&&y.all.add(l.join(`
`))}}e.$jq=y}),define(ne[219],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Txb=e.IssueType=void 0;var A;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(A||(e.IssueType=A={})),e.$Txb=(0,S.$Uh)("issueService")}),define(ne[5],re([0,1,49,3,56,2,31,4,19,12,7,114,6]),function(J,e,S,A,s,M,C,P,d,a,$,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.log=e.$fj=e.LogLevel=e.$ej=e.$dj=e.$cj=void 0,e.$cj=(0,v.$Uh)("logService"),e.$dj=(0,v.$Uh)("loggerService");function f(){return new Date().toISOString()}function y(R){return(0,a.$Ff)(R)}e.$ej=y;var w;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$fj=w.Info;function b(R,k,I){switch(k){case w.Trace:R.trace(I);break;case w.Debug:R.debug(I);break;case w.Info:R.info(I);break;case w.Warning:R.warn(I);break;case w.Error:R.error(I);break;case w.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=b;function g(R,k=!1){let I="";for(let F=0;F<R.length;F++){let U=R[F];if(U instanceof Error&&(U=(0,S.$Fi)(U,k)),typeof U=="object")try{U=JSON.stringify(U)}catch{}I+=(F>0?" ":"")+U}return I}class h extends M.$Rc{constructor(){super(...arguments),this.b=e.$fj,this.c=this.B(new A.$Qd),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==w.Off&&this.b<=k}}e.$hj=h;class l extends h{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...I){this.f(w.Trace)&&this.g(w.Trace,g([k,...I],!0))}debug(k,...I){this.f(w.Debug)&&this.g(w.Debug,g([k,...I]))}info(k,...I){this.f(w.Info)&&this.g(w.Info,g([k,...I]))}warn(k,...I){this.f(w.Warning)&&this.g(w.Warning,g([k,...I]))}error(k,...I){if(this.f(w.Error))if(k instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=k.stack,this.g(w.Error,g(F))}else this.g(w.Error,g([k,...I]))}flush(){}}e.$ij=l;class E extends h{constructor(k=e.$fj){super(),this.setLevel(k),this.g=!P.$i}trace(k,...I){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...I):console.log(`[main ${f()}]`,k,...I))}debug(k,...I){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...I):console.log(`[main ${f()}]`,k,...I))}info(k,...I){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,k,...I):console.log(`[main ${f()}]`,k,...I))}warn(k,...I){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,k,...I):console.warn(`[main ${f()}]`,k,...I))}error(k,...I){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,k,...I):console.error(`[main ${f()}]`,k,...I))}dispose(){}flush(){}}e.$jj=E;class u extends h{constructor(k=e.$fj,I=!0){super(),this.g=I,this.setLevel(k)}trace(k,...I){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...I):console.log(k,...I))}debug(k,...I){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...I):console.log(k,...I))}info(k,...I){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...I):console.log(k,...I))}warn(k,...I){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...I):console.log(k,...I))}error(k,...I){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...I):console.error(k,...I))}dispose(){}flush(){}}e.$kj=u;class i extends h{constructor(k,I=e.$fj){super(),this.g=k,this.setLevel(I)}trace(k,...I){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(k),...I])}debug(k,...I){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(k),...I])}info(k,...I){this.f(w.Info)&&this.g.log(w.Info,[this.h(k),...I])}warn(k,...I){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(k),...I])}error(k,...I){this.f(w.Error)&&this.g.log(w.Error,[this.h(k),...I])}h(k){return typeof k=="string"?k:(0,S.$Fi)(k,this.f(w.Trace))}dispose(){}flush(){}}e.$lj=i;class o extends h{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const I of this.g)I.setLevel(k);super.setLevel(k)}trace(k,...I){for(const F of this.g)F.trace(k,...I)}debug(k,...I){for(const F of this.g)F.debug(k,...I)}info(k,...I){for(const F of this.g)F.info(k,...I)}warn(k,...I){for(const F of this.g)F.warn(k,...I)}error(k,...I){for(const F of this.g)F.error(k,...I)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$mj=o;class r extends M.$Rc{constructor(k,I,F){if(super(),this.h=k,this.j=I,this.b=new C.$zc,this.c=this.B(new A.$Qd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$Qd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$Qd),this.onDidChangeVisibility=this.g.event,F)for(const U of F)this.b.set(U.resource,{logger:void 0,info:U})}m(k){return(0,a.$Bf)(k)?[...this.b.values()].find(I=>I.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,I){const F=this.n(k),U=(0,a.$Bf)(k)?k:I?.id??(0,s.$Ii)(F.toString()).toString(16);let T=this.b.get(F)?.logger;const x=I?.logLevel==="always"?w.Trace:I?.logLevel;T||(T=this.s(F,x??this.getLogLevel(F)??this.h,{...I,id:U}));const Y={logger:T,info:{resource:F,id:U,logLevel:x,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(Y.info),this.b.set(F,Y),T}n(k){return(0,a.$Bf)(k)?(0,d.$yg)(this.j,`${k}.log`):k}setLogLevel(k,I){if($.URI.isUri(k)){const F=k,U=I,T=this.b.get(F);T&&U!==T.info.logLevel&&(T.info.logLevel=U===this.h?void 0:U,T.logger?.setLevel(U),this.b.set(T.info.resource,T),this.f.fire([F,U]))}else{this.h=k;for(const[F,U]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,I){const F=this.m(k);F&&I!==!F.info.hidden&&(F.info.hidden=!I,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,I]))}getLogLevel(k){let I;return k&&(I=this.b.get(k)?.info.logLevel),I??this.h}registerLogger(k){const I=this.b.get(k.resource);I?I.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const I=this.b.get(k);I&&(I.logger&&I.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$nj=r;class t{constructor(){this.onDidChangeLogLevel=new A.$Qd().event}setLevel(k){}getLevel(){return w.Info}trace(k,...I){}debug(k,...I){}info(k,...I){}warn(k,...I){}error(k,...I){}critical(k,...I){}dispose(){}flush(){}}e.$oj=t;class n extends t{}e.$pj=n;function c(R){if(R.verbose)return w.Trace;if(typeof R.logLevel=="string"){const k=D(R.logLevel.toLowerCase());if(k!==void 0)return k}return e.$fj}e.$qj=c;function m(R){switch(R){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$rj=m;function D(R){switch(R){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$sj=D,e.$tj=new p.$_i("logLevel",m(w.Info))});var te=this&&this.__param||function(J,e){return function(S,A){e(S,A,J)}};define(ne[220],re([0,1,15,4,5]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=void 0;const M=S.safeStorage;let C=class{constructor(d){this.a=d,S.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(d){this.a.trace("[EncryptionMainService] Encrypting value.");try{const a=JSON.stringify(M.encryptString(d));return this.a.trace("[EncryptionMainService] Encrypted value."),a}catch(a){throw this.a.error(a),a}}async decrypt(d){let a;try{if(a=JSON.parse(d),!a.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${d}`);const $=Buffer.from(a.data);this.a.trace("[EncryptionMainService] Decrypting value.");const p=M.decryptString($);return this.a.trace("[EncryptionMainService] Decrypted value."),p}catch($){throw this.a.error($),$}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(A.$i)return Promise.resolve("dpapi");if(A.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const d=M.getSelectedStorageBackend();return Promise.resolve(d)}catch(d){this.a.error(d)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(A.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(A.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$p8b=C,e.$p8b=C=ve([te(0,s.$cj)],C)}),define(ne[221],re([0,1,23,8,14,3,2,9,66,5]),function(J,e,S,A,s,M,C,P,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class $ extends C.$Rc{constructor(v,f){super(),this.a=v,this.b=f,this.c=this.B(new M.$Qd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Qd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$Ug(0)),this.w=[],this.y=this.B(new A.$Ug(0))}watch(v,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(v,f):this.z(v,f)}n(v,f){const y={path:this.H(v),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},w=(0,S.$Tb)(this.j,y);return this.r(),(0,C.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,s.$Z)(v))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,d.$Xp)(f)),f=>this.G(f),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const f of this.j)(0,d.$Tp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const f of this.j)(0,d.$Tp)(f)&&v.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,f){const y={path:this.H(v),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},w=(0,S.$Tb)(this.w,y);return this.C(),(0,C.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,s.$Z)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,d.$Xp)(v)),v=>this.G(v),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,P.$gc)(v.fsPath)}}e.$2p=$}),define(ne[222],re([0,1,23,8,18,22,3,56,71,2,57,13,67,19,62,175,16,118,5,14]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;let u=class extends a.$Rc{static{E=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new C.$Qd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.$Qd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.$Qd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new C.$Qd),this.onDidRunOperation=this.r.event,this.X=this.B(new C.$Qd),this.Y=this.B(new C.$Qd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new C.$Qd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$6g)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${o}`);const t=new a.$Qc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),t.add(r.onDidChangeFile(n=>{const c=new b.$wk(n,!this.S(r));this.X.fire(c),c.hasCorrelation()||this.Y.fire(c)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,a.$Pc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,a.$Mc)(t)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(t){r.push(t)}}),!this.h.has(o)&&await A.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const t=this.h.get(o.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return d.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,f.$Cg)(o))throw new b.$yk((0,w.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const t=new l.$ab;throw t.message=(0,w.localize)(1,null,o.toString()),t}return r}async m(o){const r=await this.j(o);if((0,b.$jk)(r)||(0,b.$gk)(r)||(0,b.$kk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,b.$jk)(r)||(0,b.$gk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(t){throw(0,b.$tk)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.$yk((0,w.localize)(2,null,this.sb(o)),1):(0,b.$rk)(t)}}async s(o,r){const t=await this.j(o),n=this.S(t),c=r?.resolveTo,m=r?.resolveSingleChildDescendants,D=r?.resolveMetadata,R=await t.stat(o);let k;return this.t(t,o,R,void 0,!!D,(I,F)=>(k||(k=$.$1h.forUris(()=>!n),k.set(o,!0),c&&k.fill(!0,c)),k.get(I.resource)||k.findSuperstr(I.resource.with({query:null,fragment:null}))?!0:I.isDirectory&&m?F===1:!1))}async t(o,r,t,n,c,m){const{providerExtUri:D}=this.R(o),R={resource:r,name:D.basename(r),isFile:(t.type&b.FileType.File)!==0,isDirectory:(t.type&b.FileType.Directory)!==0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&b.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((t.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Jk)({mtime:t.mtime,size:t.size}),children:void 0};if(R.isDirectory&&m(R,n)){try{const k=await o.readdir(r),I=await A.Promises.settled(k.map(async([F,U])=>{try{const T=D.joinPath(r,F),x=c?await o.stat(T):{type:U};return await this.t(o,T,x,k.length,c,m)}catch(T){return this.b.trace(T),null}}));R.children=(0,S.$Gb)(I)}catch(k){this.b.trace(k),R.children=[]}return R}return R}async resolveAll(o){return A.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),t=await r.stat(o);return this.t(r,o,t,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(t){return t}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new b.$yk((0,w.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$ee.fromString(""),t){await this.u(o,t);const n=await this.writeFile(o,r);return this.r.fire(new b.$vk(o,0,n)),n}async writeFile(o,r,t){const n=this.qb(await this.n(o),o),{providerExtUri:c}=this.R(n);let m=t;if((0,b.$mk)(n)&&!m?.atomic){const D=n.enforceAtomicWriteFile?.(o);D&&(m={...t,atomic:D})}try{await this.w(n,o,m)||await this.U(n,c.dirname(o));let R;if((0,b.$gk)(n)&&!(r instanceof s.$ee))if((0,y.$3d)(r)){const k=await(0,y.$0d)(r,3);k.ended?R=s.$ee.concat(k.buffer):R=k}else R=(0,y.$7d)(r,k=>s.$ee.concat(k),3);else R=r;!(0,b.$jk)(n)||(0,b.$gk)(n)&&R instanceof s.$ee||(0,b.$gk)(n)&&(0,b.$mk)(n)&&m?.atomic?await this.hb(n,o,m,R):await this.db(n,o,m,R instanceof s.$ee?(0,s.$pe)(R):R),this.r.fire(new b.$vk(o,4))}catch(D){throw new b.$yk((0,w.localize)(4,null,this.sb(o),(0,b.$rk)(D).toString()),(0,b.$uk)(D),m)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,t){const n=!!t?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,w.localize)(5,null,this.sb(r)));if(!!t?.atomic){if(!(o.capabilities&32768))throw new Error((0,w.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,w.localize)(7,null,this.sb(r)));if(n)throw new Error((0,w.localize)(8,null,this.sb(r)))}let m;try{m=await o.stat(r)}catch{return}if(m.type&b.FileType.Directory)throw new b.$yk((0,w.localize)(9,null,this.sb(r)),0,t);if(this.rb(r,m),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.$Ik&&typeof m.mtime=="number"&&typeof m.size=="number"&&t.mtime<m.mtime&&t.etag!==(0,b.$Jk)({mtime:t.mtime,size:m.size}))throw new b.$yk((0,w.localize)(10,null),3,t);return m}async readFile(o,r,t){const n=await this.m(o);return r?.atomic?this.z(n,o,r,t):this.C(n,o,r,t)}async z(o,r,t,n){return new Promise((c,m)=>{this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{try{const D=await this.C(o,r,t,n);c(D)}catch(D){m(D)}})})}async C(o,r,t,n){const c=await this.D(o,r,{...t,preferUnbuffered:!0},n);return{...c,value:await(0,s.$qe)(c.value)}}async readFileStream(o,r,t){const n=await this.m(o);return this.D(n,o,r,t)}async D(o,r,t,n){const c=new M.$1d(n);let m=t;(0,b.$lk)(o)&&o.enforceAtomicReadFile?.(r)&&(m={...t,atomic:!0});const D=this.J(r,m).then(k=>k,k=>{throw c.dispose(!0),k});let R;try{return typeof m?.etag=="string"&&m.etag!==b.$Ik&&await D,m?.atomic&&(0,b.$lk)(o)||!((0,b.$jk)(o)||(0,b.$kk)(o))||(0,b.$gk)(o)&&m?.preferUnbuffered?R=this.I(o,r,m):(0,b.$kk)(o)?R=this.G(o,r,c.token,m):R=this.H(o,r,c.token,m),R.on("end",()=>c.dispose()),R.on("error",()=>c.dispose()),{...await D,value:R}}catch(k){throw R&&await(0,y.$8d)(R),this.F(k,r,m)}}F(o,r,t){const n=(0,w.localize)(11,null,this.sb(r),(0,b.$rk)(o).toString());return o instanceof b.$Ak?new b.$Ak(n,o.stat,t):o instanceof b.$zk?new b.$zk(n,o.fileOperationResult,o.size,o.options):new b.$yk(n,(0,b.$uk)(o),t)}G(o,r,t,n=Object.create(null)){const c=o.readFileStream(r,n,t);return(0,y.$be)(c,{data:m=>m instanceof s.$ee?m:s.$ee.wrap(m),error:m=>this.F(m,r,n)},m=>s.$ee.concat(m))}H(o,r,t,n=Object.create(null)){const c=(0,s.$ue)();return(0,g.$Rp)(o,r,c,m=>m,{...n,bufferSize:this.a,errorTransformer:m=>this.F(m,r,n)},t),c}I(o,r,t){const n=(0,y.$5d)(c=>s.$ee.concat(c));return(async()=>{try{let c;t?.atomic&&(0,b.$lk)(o)?c=await o.readFile(r,{atomic:!0}):c=await o.readFile(r),typeof t?.position=="number"&&(c=c.slice(t.position)),typeof t?.length=="number"&&(c=c.slice(0,t.length)),this.L(r,c.byteLength,t),n.end(s.$ee.wrap(c))}catch(c){n.error(c),n.end()}})(),n}async J(o,r){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new b.$yk((0,w.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==b.$Ik&&r.etag===t.etag)throw new b.$Ak((0,w.localize)(13,null),t,r);return this.L(o,t.size,r),t}L(o,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new b.$zk((0,w.localize)(14,null,this.sb(o)),7,r,t)}async canMove(o,r,t){return this.M(o,r,"move",t)}async canCopy(o,r,t){return this.M(o,r,"copy",t)}async M(o,r,t,n){if(o.toString()!==r.toString())try{const c=t==="move"?this.qb(await this.n(o),o):await this.m(o),m=this.qb(await this.n(r),r);await this.Q(c,o,m,r,t,n)}catch(c){return c}return!0}async move(o,r,t){const n=this.qb(await this.n(o),o),c=this.qb(await this.n(r),r),m=await this.N(n,o,c,r,"move",!!t),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$vk(o,m==="move"?2:3,D)),D}async copy(o,r,t){const n=await this.m(o),c=this.qb(await this.n(r),r),m=await this.N(n,o,c,r,"copy",!!t),D=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$vk(o,m==="copy"?3:2,D)),D}async N(o,r,t,n,c,m){if(r.toString()===n.toString())return c;const{exists:D,isSameResourceWithDifferentPathCase:R}=await this.Q(o,r,t,n,c,m);if(D&&!R&&m&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),c==="copy"){if(o===t&&(0,b.$hk)(o))await o.copy(r,n,{overwrite:m});else{const k=await this.resolve(r);k.isDirectory?await this.P(o,k,t,n):await this.O(o,r,t,n)}return c}else return o===t?(await o.rename(r,n,{overwrite:m}),c):(await this.N(o,r,t,n,"copy",m),await this.del(r,{recursive:!0}),"copy")}async O(o,r,t,n){if((0,b.$jk)(o)&&(0,b.$jk)(t))return this.jb(o,r,t,n);if((0,b.$jk)(o)&&(0,b.$gk)(t))return this.pb(o,r,t,n);if((0,b.$gk)(o)&&(0,b.$jk)(t))return this.nb(o,r,t,n);if((0,b.$gk)(o)&&(0,b.$gk)(t))return this.lb(o,r,t,n)}async P(o,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await A.Promises.settled(r.children.map(async c=>{const m=this.R(t).providerExtUri.joinPath(n,c.name);return c.isDirectory?this.P(o,await this.resolve(c.resource),t,m):this.O(o,c.resource,t,m)}))}async Q(o,r,t,n,c,m){let D=!1;if(o===t){const{providerExtUri:k,isPathCaseSensitive:I}=this.R(o);if(I||(D=k.isEqual(r,n)),D&&c==="copy")throw new Error((0,w.localize)(15,null,this.sb(r),this.sb(n)));if(!D&&k.isEqualOrParent(n,r))throw new Error((0,w.localize)(16,null,this.sb(r),this.sb(n)))}const R=await this.exists(n);if(R&&!D){if(!m)throw new b.$yk((0,w.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===t){const{providerExtUri:k}=this.R(o);if(k.isEqualOrParent(r,n))throw new Error((0,w.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:R,isSameResourceWithDifferentPathCase:D}}R(o){const r=this.S(o);return{providerExtUri:r?f.$og:f.$qg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const t=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new b.$vk(o,0,t)),t}async U(o,r){const t=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&b.FileType.Directory))throw new Error((0,w.localize)(19,null,this.sb(r)));break}catch(c){if((0,b.$tk)(c)!==b.FileSystemProviderErrorCode.FileNotFound)throw c;t.push(n.basename(r)),r=n.dirname(r)}for(let c=t.length-1;c>=0;c--){r=n.joinPath(r,t[c]);try{await o.mkdir(r)}catch(m){if((0,b.$tk)(m)!==b.FileSystemProviderErrorCode.FileExists)throw m}}}async canDelete(o,r){try{await this.W(o,r)}catch(t){return t}return!0}async W(o,r){const t=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(t.capabilities&4096))throw new Error((0,w.localize)(20,null,this.sb(o)));const c=r?.atomic;if(c&&!(t.capabilities&65536))throw new Error((0,w.localize)(21,null,this.sb(o)));if(n&&c)throw new Error((0,w.localize)(22,null,this.sb(o)));let m;try{m=await t.stat(o)}catch{}if(m)this.rb(o,m);else throw new b.$yk((0,w.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const R=await this.resolve(o);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,w.localize)(24,null,this.sb(o)))}return t}async del(o,r){const t=await this.W(o,r);let n=r;if((0,b.$nk)(t)&&!n?.atomic){const R=t.enforceAtomicDelete?.(o);R&&(n={...r,atomic:R})}const c=!!n?.useTrash,m=!!n?.recursive,D=n?.atomic??!1;await t.delete(o,{recursive:m,useTrash:c,atomic:D}),this.r.fire(new b.$vk(o,1))}async cloneFile(o,r){const t=await this.j(o),n=this.qb(await this.n(r),r);if(t===n&&this.R(t).providerExtUri.isEqual(o,r))return;if(t===n&&(0,b.$ik)(t))return t.cloneFile(o,r);await this.U(n,this.R(n).providerExtUri.dirname(r));const c=this.cb.queueFor(o,this.R(t).providerExtUri);return t===n&&(0,b.$hk)(t)?c.queue(()=>t.copy(o,r,{overwrite:!0})):c.queue(()=>this.O(t,o,n,r))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:E.ab++})}watch(o,r={recursive:!1,excludes:[]}){const t=new a.$Qc;let n=!1,c=()=>{n=!0};t.add((0,a.$Pc)(()=>c())),(async()=>{try{const D=await this.bb(o,r);n?(0,a.$Mc)(D):c=()=>(0,a.$Mc)(D)}catch(D){this.b.error(D)}})();const m=r.correlationId;if(typeof m=="number"){const D=t.add(new C.$Qd);return t.add(this.X.event(k=>{k.correlates(m)&&D.fire(k)})),{onDidChange:D.event,dispose:()=>t.dispose()}}return t}async bb(o,r){const t=await this.j(o),n=(0,P.$Ii)([this.R(t).providerExtUri.getComparisonKey(o),r]);let c=this.$.get(n);return c||(c={count:0,disposable:t.watch(o,r)},this.$.set(n,c)),c.count+=1,(0,a.$Pc)(()=>{c&&(c.count--,c.count===0&&((0,a.$Mc)(c.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,a.$Mc)(o.disposable);this.$.clear()}async db(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{const c=await o.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,y.$3d)(n)||(0,y.$4d)(n)?await this.eb(o,c,n):await this.fb(o,c,n)}catch(m){throw(0,b.$rk)(m)}finally{await o.close(c)}})}async eb(o,r,t){let n=0,c;if((0,y.$4d)(t)){if(t.buffer.length>0){const m=s.$ee.concat(t.buffer);await this.gb(o,r,m,m.byteLength,n,0),n+=m.byteLength}if(t.ended)return;c=t.stream}else c=t;return new Promise((m,D)=>{(0,y.$9d)(c,{onData:async R=>{c.pause();try{await this.gb(o,r,R,R.byteLength,n,0)}catch(k){return D(k)}n+=R.byteLength,setTimeout(()=>c.resume())},onError:R=>D(R),onEnd:()=>m()})})}async fb(o,r,t){let n=0,c;for(;(c=t.read())!==null;)await this.gb(o,r,c,c.byteLength,n,0),n+=c.byteLength}async gb(o,r,t,n,c,m){let D=0;for(;D<n;){const R=await o.write(r,c+D,t.buffer,m+D,n-D);D+=R}}async hb(o,r,t,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(()=>this.ib(o,r,t,n))}async ib(o,r,t,n){let c;n instanceof s.$ee?c=n:(0,y.$3d)(n)?c=await(0,s.$qe)(n):(0,y.$4d)(n)?c=await(0,s.$re)(n):c=(0,s.$oe)(n),await o.writeFile(r,c.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.kb(o,r,t,n))}async kb(o,r,t,n){let c,m;try{c=await o.open(r,{create:!1}),m=await t.open(n,{create:!0,unlock:!1});const D=s.$ee.alloc(this.a);let R=0,k=0,I=0;do I=await o.read(c,R,D.buffer,k,D.byteLength-k),await this.gb(t,m,D,I,R,k),R+=I,k+=I,k===D.byteLength&&(k=0);while(I>0)}catch(D){throw(0,b.$rk)(D)}finally{await A.Promises.settled([typeof c=="number"?o.close(c):Promise.resolve(),typeof m=="number"?t.close(m):Promise.resolve()])}}async lb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.mb(o,r,t,n))}async mb(o,r,t,n){return t.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,t,n){return this.cb.queueFor(n,this.R(t).providerExtUri).queue(()=>this.ob(o,r,t,n))}async ob(o,r,t,n){const c=await t.open(n,{create:!0,unlock:!1});try{const m=await o.readFile(r);await this.gb(t,c,s.$ee.wrap(m),m.byteLength,0,0)}catch(m){throw(0,b.$rk)(m)}finally{await t.close(c)}}async pb(o,r,t,n){const c=await(0,s.$qe)(this.H(o,r,M.CancellationToken.None));await this.hb(t,n,void 0,c)}qb(o,r){if(o.capabilities&2048)throw new b.$yk((0,w.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.$yk((0,w.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===p.Schemas.file?o.fsPath:o.toString(!0)}};e.$Sp=u,e.$Sp=u=E=ve([te(0,h.$cj)],u)}),define(ne[93],re([0,1,45,311,8,31,18,3,33,2,9,4,19,62,21,179,16,118,221,49,217,216]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0,(()=>{try{(0,A.gracefulify)(S)}catch(o){console.error(`Error enabling graceful-fs: ${(0,l.$Fi)(o)}`)}})();class i extends h.$2p{static{this.I=!1}constructor(r,t){super(r,t),this.onDidChangeCapabilities=P.Event.None,this.N=new M.$zc(n=>v.$pg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,p.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:t,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:b.FilePermission.Locked}}catch(t){throw this.fb(t)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const t=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(t.map(async c=>{try{let m;c.isSymbolicLink()?m=(await this.stat((0,v.$yg)(r,c.name))).type:m=this.M(c),n.push([c.name,m])}catch(m){this.a.trace(m)}})),n}catch(t){throw this.fb(t)}}M(r,t){let n;return t?.dangling?n=b.FileType.Unknown:r.isFile()?n=b.FileType.File:r.isDirectory()?n=b.FileType.Directory:n=b.FileType.Unknown,t&&(n|=b.FileType.SymbolicLink),n}async O(r){const t=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await n.wait();const c=new s.$Vg;return this.N.set(r,c),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,a.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.N.get(r)===c&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),c.open()})}async readFile(r,t){let n;try{t?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const c=this.H(r);return await y.Promises.readFile(c)}catch(c){throw this.fb(c)}finally{n?.dispose()}}P(r){i.I&&this.a.trace(r)}readFileStream(r,t,n){const c=(0,f.$5d)(m=>C.$ee.concat(m.map(D=>C.$ee.wrap(D))).buffer);return(0,g.$Rp)(this,r,c,m=>m.buffer,{...t,bufferSize:256*1024},n),c}async writeFile(r,t,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,v.$yg)((0,v.$xg)(r),`${(0,v.$vg)(r)}${n.atomic.postfix}`),t,n):this.S(r,t,n)}async Q(r){try{const t=this.H(r),{symbolicLink:n}=await y.SymlinkSupport.stat(t);if(n)return!1}catch{}return!0}async R(r,t,n,c){const m=new a.$Qc;try{m.add(await this.O(r)),m.add(await this.O(t)),await this.S(t,n,c,!0);try{await this.rename(t,r,{overwrite:!0})}catch(D){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{m.dispose()}}async S(r,t,n,c){let m;try{const D=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(D)){if(!n.overwrite)throw(0,b.$qk)((0,w.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,b.$qk)((0,w.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(r,{create:!0,unlock:n.unlock},c),await this.write(m,0,t,0,t.byteLength)}catch(D){throw await this.gb(r,D)}finally{typeof m=="number"&&await this.close(m)}}static{this.Y=!0}static configureFlushOnWrite(r){i.Y=r}async open(r,t,n){const c=this.H(r);let m;(0,b.$ek)(t)&&!n&&(m=await this.O(r));let D;try{if((0,b.$ek)(t)&&t.unlock)try{const{stat:k}=await y.SymlinkSupport.stat(c);k.mode&128||await y.Promises.chmod(c,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let R;if((0,b.$ek)(t)){if(p.$i)try{await y.Promises.truncate(c,0),R="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}R||(R="w")}else R="r";D=await y.Promises.open(c,R)}catch(R){throw m?.dispose(),(0,b.$ek)(t)?await this.gb(r,R):this.fb(R)}if(this.U.set(D,0),(0,b.$ek)(t)&&this.X.set(D,r),m){const R=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${c})`),this.W.set(D,m),R&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${c})`),R.dispose())}return D}async close(r){const t=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&i.Y)try{await y.Promises.fdatasync(r)}catch(n){i.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.fb(n)}finally{t&&(this.W.get(r)===t&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),t.dispose())}}async read(r,t,n,c,m){const D=this.Z(r,t);let R=null;try{R=(await y.Promises.read(r,n,c,m,D)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(r,D,R)}return R}Z(r,t){return t===this.U.get(r)?null:t}$(r,t,n){const c=this.U.get(r);typeof c=="number"&&(typeof t=="number"||(typeof n=="number"?this.U.set(r,c+n):this.U.delete(r)))}async write(r,t,n,c,m){return(0,s.$eh)(()=>this.ab(r,t,n,c,m),100,3)}async ab(r,t,n,c,m){const D=this.Z(r,t);let R=null;try{R=(await y.Promises.write(r,n,c,m,D)).bytesWritten}catch(k){throw await this.gb(this.X.get(r),k)}finally{this.$(r,D,R)}return R}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(t){throw this.fb(t)}}async delete(r,t){try{const n=this.H(r);if(t.recursive){let c;t?.atomic!==!1&&t.atomic.postfix&&(c=(0,$.$ic)((0,$.$lc)(n),`${(0,$.$mc)(n)}${t.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,c)}else try{await y.Promises.unlink(n)}catch(c){if(c.code==="EPERM"||c.code==="EISDIR"){let m=!1;try{const{stat:D,symbolicLink:R}=await y.SymlinkSupport.stat(n);m=D.isDirectory()&&!R}catch{}if(m)await y.Promises.rmdir(n);else throw c}else throw c}}catch(n){throw this.fb(n)}}async rename(r,t,n){const c=this.H(r),m=this.H(t);if(c!==m)try{await this.bb(r,t,"move",n.overwrite),await y.Promises.rename(c,m)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(2,null,(0,$.$mc)(c),(0,$.$mc)((0,$.$lc)(m)),D.toString()))),this.fb(D)}}async copy(r,t,n){const c=this.H(r),m=this.H(t);if(c!==m)try{await this.bb(r,t,"copy",n.overwrite),await y.Promises.copy(c,m,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(3,null,(0,$.$mc)(c),(0,$.$mc)((0,$.$lc)(m)),D.toString()))),this.fb(D)}}async bb(r,t,n,c){const m=this.H(r),D=this.H(t);let R=!1;if(!!(this.capabilities&1024)||(R=(0,d.$Zf)(m,D,!0)),R){if(n==="copy")throw(0,b.$qk)((0,w.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const I=await this.L(r);if(!I)throw(0,b.$qk)((0,w.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const F=await this.L(t);if(F){if(!c)throw(0,b.$qk)((0,w.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);I.type&b.FileType.File&&F.type&b.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,t){return this.cb(r,t,!1)}async cb(r,t,n){const c=this.H(r),m=this.H(t),D=!!(this.capabilities&1024);if((0,d.$Zf)(c,m,!D))return;const R=new a.$Qc;try{R.add(await this.O(r)),R.add(await this.O(t)),n&&await y.Promises.mkdir((0,$.$lc)(m),{recursive:!0}),await y.Promises.copyFile(c,m)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(r,t,!0);throw this.fb(k)}finally{R.dispose()}}t(r,t,n){return new E.$9p(c=>r(c),c=>t(c),n)}F(r,t,n){return new u.$eq(c=>r(c),c=>t(c),n)}fb(r){if(r instanceof b.$pk)return r;let t=r,n;switch(r.code){case"ENOENT":n=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=b.FileSystemProviderErrorCode.Unknown;break;default:n=b.FileSystemProviderErrorCode.Unknown}return(0,b.$qk)(t,n)}async gb(r,t){let n=this.fb(t);if(r&&n.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await y.SymlinkSupport.stat(this.H(r));c.mode&128||(n=(0,b.$qk)(t,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return n}}e.$fq=i}),define(ne[223],re([0,1,3,93,2,18,62,22]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=e.$Or=void 0;class d extends s.$Rc{constructor(p,v){super(),this.a=p,this.b=v,this.F=new Map,this.G=new Map}call(p,v,f){const y=this.c(p);switch(v){case"stat":return this.g(y,f[0]);case"readdir":return this.h(y,f[0]);case"open":return this.r(y,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(y,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(y,f[0],f[1],f[2]);case"rename":return this.z(y,f[0],f[1],f[2]);case"copy":return this.C(y,f[0],f[1],f[2]);case"cloneFile":return this.D(y,f[0],f[1]);case"mkdir":return this.w(y,f[0]);case"delete":return this.y(y,f[0],f[1]);case"watch":return this.I(y,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${v} not found`)}listen(p,v,f){const y=this.c(p);switch(v){case"fileChange":return this.H(y,f[0]);case"readFileStream":return this.m(y,f[0],f[1])}throw new Error(`Unknown event ${v}`)}g(p,v){const f=this.f(p,v,!0);return this.a.stat(f)}h(p,v){const f=this.f(p,v);return this.a.readdir(f)}async j(p,v,f){const y=this.f(p,v,!0),w=await this.a.readFile(y,f);return M.$ee.wrap(w)}m(p,v,f){const y=this.f(p,v,!0),w=new P.$1d,b=new S.$Qd({onDidRemoveLastListener:()=>{w.cancel()}}),g=this.a.readFileStream(y,f,w.token);return(0,C.$9d)(g,{onData:h=>b.fire(M.$ee.wrap(h)),onError:h=>b.fire(h),onEnd:()=>{b.fire("end"),b.dispose(),w.dispose()}}),b.event}n(p,v,f,y){const w=this.f(p,v);return this.a.writeFile(w,f.buffer,y)}r(p,v,f){const y=this.f(p,v,!0);return this.a.open(y,f)}s(p){return this.a.close(p)}async t(p,v,f){const y=M.$ee.alloc(f),w=0,b=await this.a.read(p,v,y.buffer,w,f);return[y,b]}u(p,v,f,y,w){return this.a.write(p,v,f.buffer,y,w)}w(p,v){const f=this.f(p,v);return this.a.mkdir(f)}y(p,v,f){const y=this.f(p,v);return this.a.delete(y,f)}z(p,v,f,y){const w=this.f(p,v),b=this.f(p,f);return this.a.rename(w,b,y)}C(p,v,f,y){const w=this.f(p,v),b=this.f(p,f);return this.a.copy(w,b,y)}D(p,v,f){const y=this.f(p,v),w=this.f(p,f);return this.a.cloneFile(y,w)}H(p,v){const f=new S.$Qd({onWillAddFirstListener:()=>{this.F.set(v,this.L(p,f))},onDidRemoveLastListener:()=>{(0,s.$Mc)(this.F.get(v)),this.F.delete(v)}});return f.event}async I(p,v,f,y,w){const b=this.F.get(v);if(b){const g=this.f(p,y),h=b.watch(f,g,w);this.G.set(v+f,h)}}async J(p,v){const f=p+v,y=this.G.get(f);y&&((0,s.$Mc)(y),this.G.delete(f))}dispose(){super.dispose();for(const[,p]of this.G)p.dispose();this.G.clear();for(const[,p]of this.F)p.dispose();this.F.clear()}}e.$Or=d;class a extends s.$Rc{constructor(p,v,f,y){super(),this.c=p,this.f=f,this.g=y,this.a=new Map,this.b=this.B(new A.$fq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(p){const v=this.B(new S.$Qd);this.B(v.event(f=>{p.fire(f.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type,cId:y.cId})))})),this.B(this.b.onDidChangeFile(f=>v.fire(f))),this.B(this.b.onDidWatchError(f=>p.fire(f)))}j(p){}m(p){}watch(p,v,f){const y=this.m(this.g);return Array.isArray(y)&&(f.excludes=[...f.excludes,...y]),this.a.set(p,this.b.watch(v,f)),(0,s.$Pc)(()=>{(0,s.$Mc)(this.a.get(p)),this.a.delete(p)})}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),super.dispose()}}e.$Pr=a}),define(ne[224],re([0,1,15,178,4,7,16,9,223,155]),function(J,e,S,A,s,M,C,P,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x8b=void 0;class $ extends d.$Or{constructor(f,y,w){super(f,y),this.M=w}c(f){return a.$Rm}f(f,y){return M.URI.revive(y)}async y(f,y,w){if(!w.useTrash)return super.y(f,y,w);const b=this.f(f,y),g=(0,P.$gc)(b.fsPath);try{await S.shell.trashItem(g)}catch{throw(0,C.$qk)(s.$i?(0,A.localize)(0,null,(0,P.$mc)(g)):(0,A.localize)(1,null,(0,P.$mc)(g)),C.FileSystemProviderErrorCode.Unknown)}}L(f,y){return new p(f,y,this.b,this.M)}}e.$x8b=$;class p extends d.$Pr{watch(f,y,w){if(w.recursive)throw(0,C.$qk)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,w)}}}),define(ne[225],re([0,1,5]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l5b=void 0;class A extends S.$ij{constructor(M=S.$fj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(C=>{this.n?.setLevel(C)}))}set logger(M){this.n=M;for(const{level:C,message:P}of this.m)(0,S.log)(M,C,P);this.m=[]}g(M,C){this.n?(0,S.log)(this.n,M,C):this.getLevel()<=M&&this.m.push({level:M,message:C})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$l5b=A}),define(ne[226],re([0,1,7,3,5,2]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=void 0;class C extends s.$nj{constructor(p,v,f,y,w){super(v,f,y),this.r=p,this.t=w,this.B(w.listen("onDidChangeLogLevel",p)(b=>{(0,s.$ej)(b)?super.setLogLevel(b):super.setLogLevel(S.URI.revive(b[0]),b[1])})),this.B(w.listen("onDidChangeVisibility",p)(([b,g])=>super.setVisibility(S.URI.revive(b),g))),this.B(w.listen("onDidChangeLoggers",p)(({added:b,removed:g})=>{for(const h of b)super.registerLogger({...h,resource:S.URI.revive(h.resource)});for(const h of g)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new s.$lj({log:(p,v)=>{this.t.call("consoleLog",[p,v])}})}registerLogger(p){super.registerLogger(p),this.t.call("registerLogger",[p,this.r])}deregisterLogger(p){super.deregisterLogger(p),this.t.call("deregisterLogger",[p,this.r])}setLogLevel(p,v){super.setLogLevel(p,v),this.t.call("setLogLevel",[p,v])}setVisibility(p,v){super.setVisibility(p,v),this.t.call("setVisibility",[this.n(p),v])}s(p,v,f){return new P(this.t,p,v,f,this.r)}static setLogLevel(p,v,f){return p.call("setLogLevel",[v,f])}}e.$er=C;class P extends s.$ij{constructor(p,v,f,y,w){super(y?.logLevel==="always"),this.r=p,this.s=v,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[v,y,w]).then(()=>{this.u(this.n),this.m=!0})}g(p,v){const f=[[p,v]];this.m?this.u(f):this.n.push(...f)}u(p){this.r.call("log",[this.s,p])}}class d{constructor(p,v){this.a=p,this.b=v}listen(p,v){const f=this.b(p);switch(v){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(w=>this.c(w,f)),removed:[...y.removed].map(w=>this.c(w,f))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,y=>[f.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$ej)(y)?y:[f.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${v}`)}async call(p,v,f){const y=this.b(p);switch(v){case"setLogLevel":return(0,s.$ej)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(S.URI.revive(y.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,y)))}throw new Error(`Call not found: ${v}`)}c(p,v){return{...p,resource:v.transformOutgoingURI(p.resource)}}}e.$fr=d;class a extends M.$Rc{constructor(p,v){super(),v.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel(f=>v.call("setLogLevel",[f]))),v.call("getRegisteredLoggers").then(f=>{for(const y of f)p.registerLogger({...y,resource:S.URI.revive(y.resource)})}),this.B(v.listen("onDidChangeVisibility")(([f,y])=>p.setVisibility(S.URI.revive(f),y))),this.B(v.listen("onDidChangeLoggers")(({added:f,removed:y})=>{for(const w of f)p.registerLogger({...w,resource:S.URI.revive(w.resource)});for(const w of y)p.deregisterLogger(w.resource)}))}}e.$gr=a}),define(ne[227],re([0,1,2,5]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=void 0;class s extends S.$Rc{constructor(C,P=[]){super(),this.a=new A.$mj([C,...P]),this.B(C.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.$YN=s}),define(ne[228],re([0,1,31,7,5]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r9b=void 0;class M{constructor(P){this.b=P,this.a=new S.$zc}listen(P,d,a){switch(d){case"onDidChangeLoggers":return a?this.b.getOnDidChangeLoggersEvent(a):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return a?this.b.getOnDidChangeLogLevelEvent(a):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return a?this.b.getOnDidChangeVisibilityEvent(a):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${d}`)}async call(P,d,a){switch(d){case"createLogger":this.c(A.URI.revive(a[0]),a[1],a[2]);return;case"log":return this.e(A.URI.revive(a[0]),a[1]);case"consoleLog":return this.d(a[0],a[1]);case"setLogLevel":return(0,s.$ej)(a[0])?this.b.setLogLevel(a[0]):this.b.setLogLevel(A.URI.revive(a[0]),a[1]);case"setVisibility":return this.b.setVisibility(A.URI.revive(a[0]),a[1]);case"registerLogger":return this.b.registerLogger({...a[0],resource:A.URI.revive(a[0].resource)},a[1]);case"deregisterLogger":return this.b.deregisterLogger(A.URI.revive(a[0]))}throw new Error(`Call not found: ${d}`)}c(P,d,a){this.a.set(P,this.b.createLogger(P,d,a))}d(P,d){let a=console.log;switch(P){case s.LogLevel.Error:a=console.error;break;case s.LogLevel.Warning:a=console.warn;break;case s.LogLevel.Info:a=console.info;break}a.call(console,...d)}e(P,d){const a=this.a.get(P);if(!a)throw new Error("Create the logger before logging");for(const[$,p]of d)(0,s.log)(a,$,p)}}e.$r9b=M}),define(ne[229],re([0,1,16,5]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;var s;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(s||(s={}));async function M(a,$,p,v,f){try{const y=await new Promise((b,g)=>{J(["@vscode/spdlog"],b,g)});y.setFlushOn(s.Trace);const w=await y.createAsyncRotatingLogger(a,$,p,v);return f?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(y){console.error(y)}return null}function C(a,$,p){switch($){case A.LogLevel.Trace:a.trace(p);break;case A.LogLevel.Debug:a.debug(p);break;case A.LogLevel.Info:a.info(p);break;case A.LogLevel.Warning:a.warn(p);break;case A.LogLevel.Error:a.error(p);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${$}`)}}function P(a,$){switch($){case A.LogLevel.Trace:a.setLevel(s.Trace);break;case A.LogLevel.Debug:a.setLevel(s.Debug);break;case A.LogLevel.Info:a.setLevel(s.Info);break;case A.LogLevel.Warning:a.setLevel(s.Warning);break;case A.LogLevel.Error:a.setLevel(s.Error);break;case A.LogLevel.Off:a.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${$}`)}}class d extends A.$ij{constructor($,p,v,f,y){super(),this.m=[],this.setLevel(y),this.n=this.s($,p,v,f),this.B(this.onDidChangeLogLevel(w=>{this.r&&P(this.r,w)}))}async s($,p,v,f){const y=v?6:1,w=30/y*S.$Lk.MB,b=await M($,p,w,y,f);if(b){this.r=b,P(this.r,this.getLevel());for(const{level:g,message:h}of this.m)C(this.r,g,h);this.m=[]}}g($,p){this.r?C(this.r,$,p):this.getLevel()<=$&&this.m.push({level:$,message:p})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$NN=d}),define(ne[230],re([0,1,32,5,229]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=void 0;class M extends A.$nj{s(P,d,a){return new s.$NN((0,S.$hg)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,d)}}e.$ON=M}),define(ne[68],re([0,1,31,3,6,5,230]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=e.$97b=void 0,e.$97b=(0,s.$Vh)(M.$dj);class P extends C.$ON{constructor(){super(...arguments),this.u=new S.$zc}createLogger(a,$,p){p!==void 0&&this.u.set(this.n(a),p);try{return super.createLogger(a,$)}catch(v){throw this.u.delete(this.n(a)),v}}registerLogger(a,$){$!==void 0&&this.u.set(a.resource,$),super.registerLogger(a)}deregisterLogger(a){this.u.delete(a),super.deregisterLogger(a)}getRegisteredLoggers(a){const $=[];for(const p of super.getRegisteredLoggers())a===this.u.get(p.resource)&&$.push(p);return $}getOnDidChangeLogLevelEvent(a){return A.Event.filter(this.onDidChangeLogLevel,$=>(0,M.$ej)($)||this.w($[0],a))}getOnDidChangeVisibilityEvent(a){return A.Event.filter(this.onDidChangeVisibility,([$])=>this.w($,a))}getOnDidChangeLoggersEvent(a){return A.Event.filter(A.Event.map(this.onDidChangeLoggers,$=>({added:[...$.added].filter(v=>this.w(v.resource,a)),removed:[...$.removed].filter(v=>this.w(v.resource,a))})),$=>$.added.length>0||$.removed.length>0)}deregisterLoggers(a){for(const[$,p]of this.u)p===a&&this.deregisterLogger($)}w(a,$){const p=this.u.get(a);return p===void 0||p===$}dispose(){super.dispose(),this.u.clear()}}e.$07b=P}),define(ne[231],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M8b=e.$L8b=e.$K8b=e.$J8b=void 0;function S(C){return C.submenu!==void 0}e.$J8b=S;function A(C){return C.id==="vscode.menubar.separator"}e.$K8b=A;function s(C){return C.uri!==void 0}e.$L8b=s;function M(C){return!S(C)&&!A(C)&&!s(C)}e.$M8b=M}),define(ne[39],re([0,1,3,71,2,6]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=void 0,e.$nn=(0,M.$Uh)("policy");class C extends s.$Rc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$Qd),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const $=Object.keys(this.f).length;return this.f={...a,...this.f},$!==Object.keys(this.f).length&&await this.j(a),A.Iterable.reduce(this.g.entries(),(p,[v,f])=>({...p,[v]:f}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(a,[$,p])=>({...a,[$]:{definition:p,value:this.g.get($)}}),{})}}e.$on=C;class P{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$pn=P}),define(ne[232],re([0,1,8,3,71,12,16,5,39]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=void 0;function a(p,v){const f=[];for(const y of new Set(s.Iterable.concat(p.keys(),v.keys())))p.get(y)!==v.get(y)&&f.push(y);return f}let $=class extends d.$on{constructor(v,f,y){super(),this.m=v,this.n=f,this.s=y,this.c=this.B(new S.$Ug(500));const w=A.Event.filter(f.onDidFilesChange,b=>b.affects(v));this.B(f.watch(v)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const v=new Map;try{const f=await this.n.readFile(this.m),y=JSON.parse(f.value.toString());if(!(0,M.$Df)(y))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(y))this.f[w]&&v.set(w,y[w])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return v}async w(){const v=await this.u(),f=a(this.g,v);this.g=v,f.length>0&&this.h.fire(f)}};e.$K9b=$,e.$K9b=$=ve([te(1,C.$dk),te(2,P.$cj)],$)}),define(ne[233],re([0,1,3,2,39]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j9b=e.$i9b=void 0;class M{constructor(d){this.b=d,this.a=new A.$Qc}listen(d,a){switch(a){case"onDidChange":return S.Event.map(this.b.onDidChange,$=>$.reduce((p,v)=>({...p,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${a}`)}call(d,a,$){switch(a){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions($)}throw new Error(`Call not found: ${a}`)}dispose(){this.a.dispose()}}e.$i9b=M;class C extends s.$on{constructor(d,a){super(),this.a=a;for(const $ in d){const{definition:p,value:v}=d[$];this.f[$]=p,v!==void 0&&this.g.set($,v)}this.a.listen("onDidChange")($=>{for(const p in $){const v=$[p];v===null?this.g.delete(p):this.g.set(p,v)}this.h.fire(Object.keys($))})}async j(d){const a=await this.a.call("updatePolicyDefinitions",d);for(const $ in a)this.g.set($,a[$])}}e.$j9b=C}),define(ne[234],re([0,1,39,8,312,2,5]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J9b=void 0;let P=class extends S.$on{constructor(a,$){super(),this.m=a,this.n=$,this.a=new A.$Qg,this.b=this.B(new M.$Sc)}async j(a){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(a).length} policy definitions`),await this.a.queue(()=>new Promise(($,p)=>{try{this.b.value=(0,s.createWatcher)(this.n,a,v=>{this.t(v),$()})}catch(v){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),p(v)}}))}t(a){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(a)}`);for(const $ in a){const p=a[$];p===void 0?this.g.delete($):this.g.set($,p)}this.h.fire(Object.keys(a))}};e.$J9b=P,e.$J9b=P=ve([te(0,C.$cj)],P)}),define(ne[79],re([0,1,35]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const M=s.context.configuration();if(M)A=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,S.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:M.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ne[25],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=void 0,e.$uj=(0,S.$Uh)("productService"),e.$vj="vscode://schemas/vscode-product"}),define(ne[235],re([0,1,8,5]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8b=void 0;let s=class{constructor(C,P,d){this.a=C,this.b=P,this.c=d}async inspect(C){await this.d();const P=this.a.webContents.debugger;await P.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,S.$Xg)(C);const d=await P.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),d.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};e.$A8b=s,e.$A8b=s=ve([te(2,A.$cj)],s)}),define(ne[80],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0,e.$Y7b=(0,S.$Uh)("protocolMainService")}),define(ne[43],re([0,1,137,12]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;class s{constructor(){this.a=new Map}add(C,P){S.ok(A.$Bf(C)),S.ok(A.$Df(P)),S.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.$ln=new s}),define(ne[236],re([0,1,3,43]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0,e.$mn={JSONContribution:"base.contributions.json"};function s(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class M{constructor(){this.b=new S.$Qd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,a){this.a[s(d)]=a,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const C=new M;A.$ln.add(e.$mn.JSONContribution,C)}),define(ne[58],re([0,1,23,3,12,163,17,236,43]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.ConfigurationScope=e.$qn=e.EditPresentationTypes=void 0;var a;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$qn={Configuration:"base.contributions.configuration"};var $;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})($||(e.ConfigurationScope=$={})),e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn="vscode://schemas/settings/resourceLanguage",e.$yn="vscode://schemas/settings/configurationDefaults";const p=d.$ln.as(P.$mn.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.$Qd,this.onDidSchemaChange=this.i.event,this.j=new A.$Qd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.$xn,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const r=new Set;this.n(i,o,r),p.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const o=new Set;this.o(i,o),p.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const r=new Set;this.o(o,r),this.n(i,!1,r),p.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const r=[];for(const{overrides:t,source:n}of i)for(const c in t)if(o.add(c),e.$An.test(c)){const m=this.a.get(c),D=m?.valuesSources??new Map;if(n)for(const F of Object.keys(t[c]))D.set(F,n);const R={...m?.value||{},...t[c]};this.a.set(c,{source:n,value:R,valuesSources:D});const k=(0,C.$yi)(c),I={type:"object",default:R,description:M.localize(1,null,k),$ref:e.$xn,defaultDefaultValue:R,source:s.$Bf(n)?void 0:n,defaultValueSource:n};r.push(...w(c)),this.d[c]=I,this.b.properties[c]=I}else{this.a.set(c,{value:t[c],source:n});const m=this.d[c];m&&(this.w(c,m),this.r(c,m))}this.m(r)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:r,source:t}of i)for(const n in r){const c=this.a.get(n),m=s.$Bf(t)?t:t?.id,D=s.$Bf(c?.source)?c?.source:c?.source?.id;if(m===D)if(o.add(n),this.a.delete(n),e.$An.test(n))delete this.d[n],delete this.b.properties[n];else{const R=this.d[n];R&&(this.w(n,R),this.r(n,R))}}this.u()}deltaConfiguration(i){let o=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,r){i.forEach(t=>{this.p(t,o,t.extensionInfo,t.restrictedProperties,void 0,r),this.c.push(t),this.q(t)})}o(i,o){const r=t=>{if(t.properties)for(const n in t.properties){o.add(n);const c=this.d[n];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>r(n))};for(const t of i){r(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,o=!0,r,t,n=3,c){n=s.$Kf(i.scope)?n:i.scope;const m=i.properties;if(m)for(const R in m){const k=m[R];if(o&&l(R,k)){delete m[R];continue}if(k.source=r,k.defaultDefaultValue=m[R].default,this.w(R,k),e.$An.test(R)?k.scope=void 0:(k.scope=s.$Kf(k.scope)?n:k.scope,k.restricted=s.$Kf(k.restricted)?!!t?.includes(R):k.restricted),m[R].hasOwnProperty("included")&&!m[R].included){this.f[R]=m[R],delete m[R];continue}else this.d[R]=m[R],m[R].policy?.name&&this.e.set(m[R].policy.name,R);!m[R].deprecationMessage&&m[R].markdownDeprecationMessage&&(m[R].deprecationMessage=m[R].markdownDeprecationMessage),c.add(R)}const D=i.allOf;if(D)for(const R of D)this.p(R,o,r,t,n,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=r=>{const t=r.properties;if(t)for(const c in t)this.r(c,t[c]);r.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$rn.properties[i]=o,o.scope){case 1:e.$sn.properties[i]=o;break;case 2:e.$tn.properties[i]=o;break;case 6:e.$un.properties[i]=o;break;case 3:e.$vn.properties[i]=o;break;case 4:e.$wn.properties[i]=o;break;case 5:e.$wn.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$rn.properties[i],o.scope){case 1:delete e.$sn.properties[i];break;case 2:delete e.$tn.properties[i];break;case 6:delete e.$un.properties[i];break;case 3:delete e.$vn.properties[i];break;case 4:case 5:delete e.$wn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$xn};this.w(o,r),e.$rn.properties[o]=r,e.$sn.properties[o]=r,e.$tn.properties[o]=r,e.$un.properties[o]=r,e.$vn.properties[o]=r,e.$wn.properties[o]=r}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$xn};e.$rn.patternProperties[e.$zn]=i,e.$sn.patternProperties[e.$zn]=i,e.$tn.patternProperties[e.$zn]=i,e.$un.patternProperties[e.$zn]=i,e.$vn.patternProperties[e.$zn]=i,e.$wn.patternProperties[e.$zn]=i,this.i.fire()}w(i,o){const r=this.a.get(i);let t=r?.value,n=r?.source;s.$If(t)&&(t=o.defaultDefaultValue,n=void 0),s.$If(t)&&(t=g(o.type)),o.default=t,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.$zn=`^(${f})+$`,e.$An=new RegExp(e.$zn);function w(u){const i=[];if(e.$An.test(u)){let o=y.exec(u);for(;o?.length;){const r=o[1].trim();r&&i.push(r),o=y.exec(u)}}return(0,S.$Lb)(i)}e.$Bn=w;function b(u){return u.reduce((i,o)=>`${i}[${o}]`,"")}e.$Cn=b;function g(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Dn=g;const h=new v;d.$ln.add(e.$qn.Configuration,h);function l(u,i){return u.trim()?e.$An.test(u)?M.localize(7,null,u):h.getConfigurationProperties()[u]!==void 0?M.localize(8,null,u):i.policy?.name&&h.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,u,i.policy?.name,h.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$En=l;function E(){const u=[],i=h.getConfigurationProperties();for(const o of Object.keys(i))u.push([o,i[o].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$Fn=E}),define(ne[119],re([0,1,23,3,44,2,31,38,12,7,17,58,43]),function(J,e,S,A,s,M,C,P,d,a,$,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=void 0;function f(o){return Object.isFrozen(o)?o:P.$an(o)}class y{constructor(r={},t=[],n=[],c){this.b=r,this.c=t,this.d=n,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof y)return t;const n=new w("");return n.parseRaw(t),n.configurationModel});this.f=r.reduce((t,n)=>n===t?n:t.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,$.$wi)(this.contents,r):this.contents}inspect(r,t){const n=this.rawConfiguration.getValue(r),c=t?this.rawConfiguration.getOverrideValue(r,t):void 0,m=t?this.rawConfiguration.override(t).getValue(r):n;return{value:n,override:c,merged:m}}getOverrideValue(r,t){const n=this.i(t);return n?r?(0,$.$wi)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const n of this.overrides)n.identifiers.includes(r)&&t.push(...n.keys);return S.$Lb(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return S.$Lb(r)}override(r){let t=this.a.get(r);return t||(t=this.g(r),this.a.set(r,t)),t}merge(...r){const t=P.$_m(this.contents),n=P.$_m(this.overrides),c=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const D of r)if(m.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(t,D.contents);for(const R of D.overrides){const[k]=n.filter(I=>S.$tb(I.identifiers,R.identifiers));k?(this.h(k.contents,R.contents),k.keys.push(...R.keys),k.keys=S.$Lb(k.keys)):n.push(P.$_m(R))}for(const R of D.keys)c.indexOf(R)===-1&&c.push(R)}return new y(t,c,n,m.every(D=>D instanceof y)?void 0:m)}g(r){const t=this.i(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const n={};for(const c of S.$Lb([...Object.keys(this.contents),...Object.keys(t)])){let m=this.contents[c];const D=t[c];D&&(typeof m=="object"&&typeof D=="object"?(m=P.$_m(m),this.h(m,D)):m=D),n[c]=m}return new y(n,this.keys,this.overrides)}h(r,t){for(const n of Object.keys(t)){if(n in r&&d.$Df(r[n])&&d.$Df(t[n])){this.h(r[n],t[n]);continue}r[n]=P.$_m(t[n])}}i(r){let t=null,n=null;const c=m=>{m&&(n?this.h(n,m):n=P.$_m(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===r?t=m.contents:m.identifiers.includes(r)&&c(m.contents);return c(t),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,t){this.j(r,t,!0)}setValue(r,t){this.j(r,t,!1)}removeValue(r){const t=this.keys.indexOf(r);t!==-1&&(this.keys.splice(t,1),(0,$.$vi)(this.contents,r),p.$An.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>S.$tb(n.identifiers,(0,p.$Bn)(r))),1))}j(r,t,n){(0,$.$ui)(this.contents,r,t,c=>console.error(c)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),p.$An.test(r)&&this.overrides.push({identifiers:(0,p.$Bn)(r),keys:Object.keys(this.contents[r]),contents:(0,$.$ti)(this.contents[r],c=>console.error(c))})}}e.$Gn=y;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!d.$Kf(r)){const n=this.g(r);this.parseRaw(n,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:n,keys:c,overrides:m,restricted:D,hasExcludedProperties:R}=this.h(r,t);this.b=new y(n,c,m,R?[r]:void 0),this.c=D||[]}g(r){let t={},n=null,c=[];const m=[],D=[];function R(I){Array.isArray(c)?c.push(I):n!==null&&(c[n]=I)}const k={onObjectBegin:()=>{const I={};R(I),m.push(c),c=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{c=m.pop()},onArrayBegin:()=>{const I=[];R(I),m.push(c),c=I,n=null},onArrayEnd:()=>{c=m.pop()},onLiteralValue:R,onError:(I,F,U)=>{D.push({error:I,offset:F,length:U})}};if(r)try{s.$9m(r,k),t=c[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return t}h(r,t){const n=v.$ln.as(p.$qn.Configuration).getConfigurationProperties(),c=this.i(r,n,!0,t);r=c.raw;const m=(0,$.$ti)(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),D=Object.keys(r),R=this.j(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:m,keys:D,overrides:R,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(r,t,n,c){let m=!1;if(!c?.scopes&&!c?.skipRestricted&&!c?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:m};const D={},R=[];for(const k in r)if(p.$An.test(k)&&n){const I=this.i(r[k],t,!1,c);D[k]=I.raw,m=m||I.hasExcludedProperties,R.push(...I.restricted)}else{const I=t[k],F=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&R.push(k),!c.exclude?.includes(k)&&(c.include?.includes(k)||(F===void 0||c.scopes===void 0||c.scopes.includes(F))&&!(c.skipRestricted&&I?.restricted))?D[k]=r[k]:m=!0}return{raw:D,restricted:R,hasExcludedProperties:m}}j(r,t){const n=[];for(const c of Object.keys(r))if(p.$An.test(c)){const m={};for(const D in r[c])m[D]=r[c][D];n.push({identifiers:(0,p.$Bn)(c),keys:Object.keys(m),contents:(0,$.$ti)(m,t)})}return n}}e.$Hn=w;class b extends M.$Rc{constructor(r,t,n,c){super(),this.c=r,this.f=t,this.g=c,this.b=this.B(new A.$Qd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,m=>m.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&n.isEqual(m.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$In=b;class g{constructor(r,t,n,c,m,D,R,k,I,F,U,T,x){this.a=r,this.b=t,this.c=n,this.overrideIdentifiers=c,this.d=m,this.f=D,this.g=R,this.h=k,this.i=I,this.j=F,this.k=U,this.l=T,this.m=x}get value(){return f(this.c)}n(r,t,n){const c=r.inspect(t,n);return{get value(){return f(c.value)},get override(){return f(c.override)},get merged(){return f(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,t,n,c,m=new y,D=new y,R=new C.$zc,k=new y,I=new C.$zc){this.c=r,this.d=t,this.f=n,this.g=c,this.h=m,this.i=D,this.j=R,this.l=k,this.m=I,this.a=null,this.b=new C.$zc,this.n=null}getValue(r,t,n){return this.q(r,t,n).getValue(r)}updateValue(r,t,n={}){let c;n.resource?(c=this.m.get(n.resource),c||(c=new y,this.m.set(n.resource,c))):c=this.l,t===void 0?c.removeValue(r):c.setValue(r,t),n.resource||(this.a=null)}inspect(r,t,n){const c=this.q(r,t,n),m=this.u(t.resource,n),D=t.resource?this.m.get(t.resource)||this.l:this.l,R=new Set;for(const k of c.overrides)for(const I of k.identifiers)c.getOverrideValue(r,I)!==void 0&&R.add(I);return new g(r,t,c.getValue(r),R.size?[...R]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,m||void 0,D)}keys(r){const t=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.j.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const n=[];if(!t){const{added:c,updated:m,removed:D}=u(this.c,r);t=[...c,...m,...D]}for(const c of t)for(const m of(0,p.$Bn)(c)){const D=this.c.getKeysForOverrideIdentifier(m),R=r.getKeysForOverrideIdentifier(m),k=[...R.filter(I=>D.indexOf(I)===-1),...D.filter(I=>R.indexOf(I)===-1),...D.filter(I=>!P.$dn(this.c.override(m).getValue(I),r.override(m).getValue(I)))];n.push([m,k])}return this.updateDefaultConfiguration(r),{keys:t,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:n,removed:c}=u(this.d,r),m=[...t,...n,...c];return m.length&&this.updatePolicyConfiguration(r),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:n,removed:c,overrides:m}=u(this.applicationConfiguration,r),D=[...t,...n,...c];return D.length&&this.updateApplicationConfiguration(r),{keys:D,overrides:m}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:n,removed:c,overrides:m}=u(this.localUserConfiguration,r),D=[...t,...n,...c];return D.length&&this.updateLocalUserConfiguration(r),{keys:D,overrides:m}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:n,removed:c,overrides:m}=u(this.remoteUserConfiguration,r),D=[...t,...n,...c];return D.length&&this.updateRemoteUserConfiguration(r),{keys:D,overrides:m}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:n,removed:c,overrides:m}=u(this.workspaceConfiguration,r),D=[...t,...n,...c];return D.length&&this.updateWorkspaceConfiguration(r),{keys:D,overrides:m}}compareAndUpdateFolderConfiguration(r,t){const n=this.p.get(r),{added:c,updated:m,removed:D,overrides:R}=u(n,t),k=[...c,...m,...D];return(k.length||!n)&&this.updateFolderConfiguration(r,t),{keys:k,overrides:R}}compareAndDeleteFolderConfiguration(r){const t=this.p.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:c,removed:m,overrides:D}=u(t,void 0);return{keys:[...n,...c,...m],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,t,n){let c=this.r(t,n);return t.overrideIdentifier&&(c=c.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(c=c.merge(this.d)),c}r({resource:r},t){let n=this.s();if(t&&r){const c=t.getFolder(r);c&&(n=this.t(c.uri)||n);const m=this.m.get(r);m&&(n=n.merge(m))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let t=this.b.get(r);if(!t){const n=this.s(),c=this.j.get(r);c?(t=n.merge(c),this.b.set(r,t)):t=n}return t}u(r,t){if(t&&r){const n=t.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,t)=>{const{contents:n,overrides:c,keys:m}=this.j.get(t);return r.push([t,{contents:n,overrides:c,keys:m}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(t=>r.add(t)),this.userConfiguration.keys.forEach(t=>r.add(t)),this.i.keys.forEach(t=>r.add(t)),this.j.forEach(t=>t.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>t.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(c=>t.add(c))),[...t.values()]}static parse(r){const t=this.x(r.defaults),n=this.x(r.policy),c=this.x(r.application),m=this.x(r.user),D=this.x(r.workspace),R=r.folders.reduce((k,I)=>(k.set(a.URI.revive(I[0]),this.x(I[1])),k),new C.$zc);return new h(t,n,c,m,new y,D,R,new y,new C.$zc)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.$Jn=h;function l(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,t=new Map;for(const c of o)c.keys.forEach(m=>r.add(m)),c.overrides.forEach(([m,D])=>{const R=(0,C.$wc)(t,m,new Set);D.forEach(k=>R.add(k))});const n=[];return t.forEach((c,m)=>n.push([m,[...c.values()]])),{keys:[...r.values()],overrides:n}}e.$Kn=l;class E{constructor(r,t,n,c){this.change=r,this.f=t,this.g=n,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const m of r.keys)this.affectedKeys.add(m);for(const[,m]of r.overrides)for(const D of m)this.affectedKeys.add(D);this.d=this.a;for(const m of this.affectedKeys)this.d+=m+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,t){const n=this.a+r,c=this.d.indexOf(n);if(c<0)return!1;const m=c+n.length;if(m>=this.d.length)return!1;const D=this.d.charCodeAt(m);if(D!==this.b&&D!==this.c)return!1;if(t){const R=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.f?.workspace):void 0,k=this.g.getValue(r,t,this.h);return!P.$dn(R,k)}return!0}}e.$Ln=E;function u(o,r){const{added:t,removed:n,updated:c}=i(r?.rawConfiguration,o?.rawConfiguration),m=[],D=o?.getAllOverrideIdentifiers()||[],R=r?.getAllOverrideIdentifiers()||[];if(r){const k=R.filter(I=>!D.includes(I));for(const I of k)m.push([I,r.getKeysForOverrideIdentifier(I)])}if(o){const k=D.filter(I=>!R.includes(I));for(const I of k)m.push([I,o.getKeysForOverrideIdentifier(I)])}if(r&&o){for(const k of D)if(R.includes(k)){const I=i({contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});m.push([k,[...I.added,...I.removed,...I.updated]])}}return{added:t,removed:n,updated:c,overrides:m}}function i(o,r){const t=o?r?o.keys.filter(m=>r.keys.indexOf(m)===-1):[...o.keys]:[],n=r?o?r.keys.filter(m=>o.keys.indexOf(m)===-1):[...r.keys]:[],c=[];if(o&&r){for(const m of r.keys)if(o.keys.indexOf(m)!==-1){const D=(0,$.$wi)(r.contents,m),R=(0,$.$wi)(o.contents,m);P.$dn(D,R)||c.push(m)}}return{added:t,removed:n,updated:c}}}),define(ne[237],re([0,1,23,3,2,38,12,119,58,5,39,43]),function(J,e,S,A,s,M,C,P,d,a,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=void 0;class v extends s.$Rc{constructor(){super(...arguments),this.a=this.B(new A.$Qd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Gn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(p.$ln.as(d.$qn.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:g})=>this.c(Array.from(b),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(b,g){this.h(b,p.$ln.as(d.$qn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}g(){this.b=new P.$Gn;const b=p.$ln.as(d.$qn.Configuration).getConfigurationProperties();this.h(Object.keys(b),b)}h(b,g){const h=this.f();for(const l of b){const E=h[l],u=g[l];E!==void 0?this.b.addValue(l,E):u?this.b.addValue(l,u.default):this.b.removeValue(l)}}}e.$Mn=v;class f{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new P.$Gn}async initialize(){return this.configurationModel}}e.$Nn=f;let y=class extends s.$Rc{get configurationModel(){return this.b}constructor(b,g,h){super(),this.c=b,this.f=g,this.g=h,this.a=this.B(new A.$Qd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$Gn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const g={},h=[],l=p.$ln.as(d.$qn.Configuration).getConfigurationProperties();for(const E of b){const u=l[E];if(!u){h.push(E);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}h.push(E),g[u.policy.name]={type:u.type}}}return(0,C.$Of)(g)||await this.f.updatePolicyDefinitions(g),h}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const g=p.$ln.as(d.$qn.Configuration).getPolicyConfigurations(),h=(0,S.$Gb)(b.map(l=>g.get(l)));this.m(h,!0)}m(b,g){this.g.trace("PolicyConfiguration#update",b);const h=p.$ln.as(d.$qn.Configuration).getConfigurationProperties(),l=[],E=this.b.isEmpty();for(const u of b){const i=h[u]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(E?o!==void 0:!(0,M.$dn)(this.b.getValue(u),o))&&l.push([u,o])}else this.b.getValue(u)!==void 0&&l.push([u,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const u=this.b;this.b=new P.$Gn;for(const i of u.keys)this.b.setValue(i,u.getValue(i));for(const[i,o]of l)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);g&&this.a.fire(this.b)}}};e.$On=y,e.$On=y=ve([te(1,$.$nn),te(2,a.$cj)],y)}),define(ne[238],re([0,1,8,3,2,19,17,119,237,39]),function(J,e,S,A,s,M,C,P,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0;class $ extends s.$Rc{constructor(v,f,y,w){super(),this.j=v,this.h=this.B(new A.$Qd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.$Mn),this.c=y instanceof a.$pn?new d.$Nn:this.B(new d.$On(this.b,y,w)),this.f=this.B(new P.$In(this.j,{},M.$pg,f)),this.a=new P.$Jn(this.b.configurationModel,this.c.configurationModel,new P.$Gn,new P.$Gn),this.g=this.B(new S.$9g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:b,properties:g})=>this.n(b,g))),this.B(this.c.onDidChangeConfiguration(b=>this.r(b))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,f,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$Jn(v,f,new P.$Gn,y)}getConfigurationData(){return this.a.toData()}getValue(v,f){const y=typeof v=="string"?v:void 0,w=(0,C.$pi)(v)?v:(0,C.$pi)(f)?f:{};return this.a.getValue(y,w,void 0)}updateValue(v,f,y,w){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.m(v)}m(v){const f=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(v);this.s(y,f,2)}n(v,f){const y=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(v,f);this.s(w,y,7)}r(v){const f=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(v);this.s(y,f,7)}s(v,f,y){const w=new P.$Ln(v,{data:f},this.a);w.source=y,w.sourceConfig=this.t(y),this.h.fire(w)}t(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Pn=$}),define(ne[239],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y9b=e.$x9b=e.$w9b=void 0,e.$w9b="request",e.$x9b="remoteResourceHandler";class S{async routeCall(s,M,C){if(M!==e.$w9b)throw new Error(`Call not found: ${M}`);const P=C[0];if(P?.authority){const d=s.connections.find(a=>a.ctx===P.authority);if(d)return d}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$y9b=S}),define(ne[240],re([0,1,14,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.RemoteAuthorityResolverErrorCode=e.$Wk=e.$Vk=e.RemoteConnectionType=e.$Uk=void 0,e.$Uk=(0,A.$Uh)("remoteAuthorityResolverService");var s;(function($){$[$.WebSocket=0]="WebSocket",$[$.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(p){this.id=p,this.type=1}toString(){return`Managed(${this.id})`}}e.$Vk=M;class C{constructor(p,v){this.host=p,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Wk=C;var P;(function($){$.Unknown="Unknown",$.NotAvailable="NotAvailable",$.TemporarilyNotAvailable="TemporarilyNotAvailable",$.NoResolverFound="NoResolverFound",$.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class d extends S.$ab{static isNotAvailable(p){return p instanceof d&&p._code===P.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof d&&p._code===P.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof d&&p._code===P.NoResolverFound}static isInvalidAuthority(p){return p instanceof d&&p._code===P.InvalidAuthority}static isHandled(p){return p instanceof d&&p.isHandled}constructor(p,v=P.Unknown,f){super(p),this._message=p,this._code=v,this._detail=f,this.isHandled=v===P.NotAvailable&&f===!0,Object.setPrototypeOf(this,d.prototype)}}e.$Xk=d;function a($){const p=$.indexOf("+");return p===-1?$:$.substring(0,p)}e.$Yk=a}),define(ne[59],re([0,1,13]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=void 0;function A(a){return a.scheme===S.Schemas.vscodeRemote?a.authority:void 0}e.$Zk=A;function s(a){if(!a)return;const $=a.indexOf("+");return $<0?a:a.substr(0,$)}e.$1k=s;function M(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$2k=M;function C(a){const{host:$,port:p}=d(a);if(typeof p>"u")throw new Error("Remote authority doesn't contain a port!");return{host:$,port:p}}e.$3k=C;function P(a,$){let{host:p,port:v}=d(a);return typeof v>"u"&&(v=$),{host:p,port:v}}e.$4k=P;function d(a){const $=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const p=a.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const v=a.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:a,port:void 0}}}),define(ne[120],re([0,1,27,6,59]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.TargetPlatform=e.ExtensionType=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=void 0,e.$5l="extensions.user.cache",e.$6l="extensions.builtin.cache",e.$7l="undefined_publisher",e.$8l=["ui","workspace","web"];function M(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$9l=M,e.$0l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(C||(e.ExtensionType=C={}));var P;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class d{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,g){if(typeof b>"u"||b===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof b=="string"||typeof g=="string"){const h=typeof b=="string"?b:b.value,l=typeof g=="string"?g:g.value;return S.$5e(h,l)}return b._lower===g._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$$l=d;class a{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const g of b)this.add(g)}add(b){this.c.add(d.toKey(b))}delete(b){return this.c.delete(d.toKey(b))}has(b){return this.c.has(d.toKey(b))}}e.$_l=a;class ${constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(d.toKey(b))}get(b){return this.c.get(d.toKey(b))}has(b){return this.c.has(d.toKey(b))}set(b,g){this.c.set(d.toKey(b),g)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$am=$;function p(w){return v(w)}e.$bm=p;function v(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$cm=v;function f(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$dm=f;function y(w,b){if(b){const g=`onResolveRemoteAuthority:${(0,s.$1k)(b)}`;return!!w.activationEvents?.includes(g)}return!1}e.$em=y,e.$fm=(0,A.$Uh)("IBuiltinExtensionsScannerService")}),define(ne[241],re([0,1,8,18,22,14,3,2,67,73,32,109,240,59]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.PersistentConnectionEventType=e.$$k=e.$0k=e.$9k=e.ConnectionType=void 0;const y=30*1e3;var w;(function(Q){Q[Q.Management=1]="Management",Q[Q.ExtensionHost=2]="ExtensionHost",Q[Q.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function b(Q){switch(Q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(Q){const O=new s.$1d;return setTimeout(()=>O.cancel(),Q),O.token}function h(Q,O){if(Q.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const j=new s.$1d;return Q.onCancellationRequested(()=>j.cancel()),O.onCancellationRequested(()=>j.cancel()),j.token}class l{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new P.$Qc,this.promise=new Promise((j,V)=>{this.f=j,this.g=V}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function E(Q,O){const j=new l(O);return j.registerDisposable(Q.onControlMessage(V=>{const L=JSON.parse(V.toString()),B=z(L);B?j.reject(B):j.resolve(L)})),j.promise}function u(Q,O,j,V,L,B,W,X){const he=new l(X),de=a.$Md.create(!1);return Q.info(`Creating a socket (${W})...`),d.mark(`code/willCreateSocket/${B}`),O.connect(j,V,L,W).then(le=>{he.didTimeout?(d.mark(`code/didCreateSocketError/${B}`),Q.info(`Creating a socket (${W}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(d.mark(`code/didCreateSocketOK/${B}`),Q.info(`Creating a socket (${W}) was successful after ${de.elapsed()} ms.`),he.resolve(le))},le=>{d.mark(`code/didCreateSocketError/${B}`),Q.info(`Creating a socket (${W}) returned an error after ${de.elapsed()} ms.`),Q.error(le),he.reject(le)}),he.promise}function i(Q,O){const j=new l(O);return Q.then(V=>{j.didTimeout||j.resolve(V)},V=>{j.didTimeout||j.reject(V)}),j.promise}async function o(Q,O,j,V){const L=ee(Q,O);Q.logService.trace(`${L} 1/6. invoking socketFactory.connect().`);let B;try{B=await u(Q.logService,Q.remoteSocketFactoryService,Q.connectTo,(0,f.$2k)(Q),`reconnectionToken=${Q.reconnectionToken}&reconnection=${Q.reconnectionProtocol?"true":"false"}`,b(O),`renderer-${b(O)}-${Q.reconnectionToken}`,V)}catch(le){throw Q.logService.error(`${L} socketFactory.connect() failed or timed out. Error:`),Q.logService.error(le),le}Q.logService.trace(`${L} 2/6. socketFactory.connect() was successful.`);let W,X;Q.reconnectionProtocol?(Q.reconnectionProtocol.beginAcceptReconnection(B,null),W=Q.reconnectionProtocol,X=!1):(W=new p.$Ih({socket:B}),X=!0),Q.logService.trace(`${L} 3/6. sending AuthRequest control message.`);const he=await i(Q.signService.createNewMessage((0,$.$hg)()),V),de={type:"auth",auth:Q.connectionToken||"00000000000000000000",data:he.data};W.sendControl(A.$ee.fromString(JSON.stringify(de)));try{const le=await E(W,h(V,g(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(Q.logService.trace(`${L} 4/6. received SignRequest control message.`),!await i(Q.signService.validate(he,le.signedData),V)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const be=await i(Q.signService.sign(le.data),V),Ee={type:"connectionType",commit:Q.commit,signedData:be,desiredConnectionType:O};return j&&(Ee.args=j),Q.logService.trace(`${L} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(A.$ee.fromString(JSON.stringify(Ee))),{protocol:W,ownsProtocol:X}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(Q.logService.error(`${L} the handshake timed out. Error:`),Q.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(Q.logService.error(`${L} received error control message when negotiating connection. Error:`),Q.logService.error(le)),X&&G(W),le}}async function r(Q,O,j,V){const L=Date.now(),B=ee(Q,O),{protocol:W,ownsProtocol:X}=await o(Q,O,j,V),he=new l(V);return he.registerDisposable(W.onControlMessage(de=>{const le=JSON.parse(de.toString()),we=z(le);we?(Q.logService.error(`${B} received error control message when negotiating connection. Error:`),Q.logService.error(we),X&&G(W),he.reject(we)):(Q.reconnectionProtocol?.endAcceptReconnection(),Q.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${se(L)}!`),he.resolve({protocol:W,firstMessage:le}))})),he.promise}async function t(Q,O){const{protocol:j}=await r(Q,1,void 0,O);return{protocol:j}}async function n(Q,O,j){const{protocol:V,firstMessage:L}=await r(Q,2,O,j),B=L&&L.debugPort;return{protocol:V,debugPort:B}}async function c(Q,O,j){const V=Date.now(),L=ee(Q,3),{protocol:B}=await o(Q,3,O,j);return Q.logService.trace(`${L} 6/6. handshake finished, connection is up and running after ${se(V)}!`),B}async function m(Q,O,j){const{connectTo:V,connectionToken:L}=await Q.addressProvider.getAddress();return{commit:Q.commit,quality:Q.quality,connectTo:V,connectionToken:L,reconnectionToken:O,reconnectionProtocol:j,remoteSocketFactoryService:Q.remoteSocketFactoryService,signService:Q.signService,logService:Q.logService}}async function D(Q,O,j){return k(Q,async V=>{const{protocol:L}=await t(V,s.CancellationToken.None);return new Z(Q,O,j,V.reconnectionToken,L)})}e.$9k=D;async function R(Q,O){return k(Q,async j=>{const{protocol:V,debugPort:L}=await n(j,O,s.CancellationToken.None);return new K(Q,O,j.reconnectionToken,V,L)})}e.$0k=R;async function k(Q,O){for(let V=1;;V++)try{const L=(0,$.$hg)(),B=await m(Q,L,null);return await O(B)}catch(L){if(V<5)Q.logService.error(`[remote-connection][attempt ${V}] An error occurred in initial connection! Will retry... Error:`),Q.logService.error(L);else throw Q.logService.error(`[remote-connection][attempt ${V}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Q.logService.error(L),ae.triggerPermanentFailure(0,0,v.$Xk.isHandled(L)),L}}async function I(Q,O,j){const V=await m(Q,(0,$.$hg)(),null);return await c(V,{host:O,port:j},s.CancellationToken.None)}e.$$k=I;function F(Q){return(0,S.$Kg)(O=>new Promise((j,V)=>{const L=setTimeout(j,Q*1e3);O.onCancellationRequested(()=>{clearTimeout(L),j()})}))}var U;(function(Q){Q[Q.ConnectionLost=0]="ConnectionLost",Q[Q.ReconnectionWait=1]="ReconnectionWait",Q[Q.ReconnectionRunning=2]="ReconnectionRunning",Q[Q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Q[Q.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class T{constructor(O,j){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.type=0}}e.$_k=T;class x{constructor(O,j,V,L){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.durationSeconds=V,this.c=L,this.type=1}skipWait(){this.c.cancel()}}e.$al=x;class Y{constructor(O,j,V){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=V,this.type=2}}e.$bl=Y;class ce{constructor(O,j,V){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=V,this.type=4}}e.$cl=ce;class oe{constructor(O,j,V,L){this.reconnectionToken=O,this.millisSinceLastIncomingData=j,this.attempt=V,this.handled=L,this.type=3}}e.$dl=oe;class ae extends P.$Rc{static triggerPermanentFailure(O,j,V){this._permanentFailure=!0,this.f=O,this.g=j,this.h=V,this.j.forEach(L=>L.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ae._permanentFailure}constructor(O,j,V,L,B){super(),this.t=O,this.u=j,this.reconnectionToken=V,this.protocol=L,this.w=B,this.m=this.B(new C.$Qd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ce(this.reconnectionToken,0,0)),this.B(L.onSocketClose(W=>{const X=q(this.t,this.reconnectionToken,!0);W?W.type===0?(this.u.logService.info(`${X} received socket close event (hadError: ${W.hadError}).`),W.error&&this.u.logService.error(W.error)):(this.u.logService.info(`${X} received socket close event (wasClean: ${W.wasClean}, code: ${W.code}, reason: ${W.reason}).`),W.event&&this.u.logService.error(W.event)):this.u.logService.info(`${X} received socket close event.`),this.y()})),this.B(L.onSocketTimeout(W=>{const X=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${X} received socket timeout event (unacknowledgedMsgCount: ${W.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${W.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${W.timeSinceLastReceivedSomeData}).`),this.y()})),ae.j.push(this),this.B((0,P.$Pc)(()=>{const W=ae.j.indexOf(this);W>=0&&ae.j.splice(W,1)})),this.n&&this.D(ae.f,ae.g,ae.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let V=-1;do{V++;const L=V<j.length?j[V]:j[j.length-1];try{if(L>0){const W=F(L);this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),L,W)),this.u.logService.info(`${O} waiting for ${L} seconds before reconnecting...`);try{await W}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1)),this.u.logService.info(`${O} resolving connection...`);const B=await m(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${B.connectTo}...`),await this.G(B,g(y)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ce(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(V>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(v.$Xk.isTemporarilyNotAvailable(B)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if((0,M.$3)(B)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(B);continue}if(B instanceof v.$Xk){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,v.$Xk.isHandled(B));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(B),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}}while(!this.n&&!this.s)}C(O,j,V){this.w?ae.triggerPermanentFailure(O,j,V):this.D(O,j,V)}D(O,j,V){this.m.fire(new oe(this.reconnectionToken,O,j,V)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$el=ae;class Z extends ae{constructor(O,j,V,L,B){super(1,O,L,B,!0),this.client=this.B(new p.$Gh(B,{remoteAuthority:j,clientId:V},O.ipcLogger))}async G(O,j){await t(O,j)}}e.$fl=Z;class K extends ae{constructor(O,j,V,L,B){super(2,O,V,L,!1),this.H=j,this.debugPort=B}async G(O,j){await n(O,this.H,j)}}e.$gl=K;function G(Q){try{Q.acceptDisconnect();const O=Q.getSocket();Q.dispose(),O.dispose()}catch(O){(0,M.$Z)(O)}}function z(Q){if(Q&&Q.type==="error"){const O=new Error(`Connection error: ${Q.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function N(Q,O){for(;Q.length<O;)Q+=" ";return Q}function H(Q,O){return`[remote-connection][${N(b(Q),13)}][${O.substr(0,5)}\u2026]`}function q(Q,O,j){return`${H(Q,O)}[${j?"reconnect":"initial"}]`}function ee(Q,O){return`${q(O,Q.reconnectionToken,!!Q.reconnectionProtocol)}[${Q.connectTo}]`}function se(Q){return`${Date.now()-Q} ms`}}),define(ne[242],re([0,1,2,6]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=void 0,e.$5k=(0,A.$Uh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(C,P){return this.a[C]??=[],this.a[C].push(P),(0,S.$Pc)(()=>{const d=this.a[C]?.indexOf(P);typeof d=="number"&&d>=0&&this.a[C]?.splice(d,1)})}b(C){return(this.a[C.type]||[]).find(d=>d.supports(C))}connect(C,P,d,a){const $=this.b(C);if(!$)throw new Error(`No socket factory found for ${C}`);return $.connect(C,P,d,a)}}e.$6k=s}),define(ne[243],re([0,1,28,47,21,113]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z8b=void 0;let C;async function P(f=!1){return(C===void 0||f)&&(C=d()),C}e.$z8b=P;async function d(){const f=a();if(f===void 0)return!1;if(f>=22e3){const y=p();if(y)return new Promise(w=>{A.execFile(y,["--status"],b=>w(!b))})}else{const y=v();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function a(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());if(f)return parseInt(f[3])}function $(f){const y=process.env.SystemRoot;if(y){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(y,w?"Sysnative":"System32",f)}}function p(){return $("wsl.exe")}function v(){return $("lxss\\LxssManager.dll")}}),define(ne[50],re([0,1,18,14,2,183,58,6,5,43]),function(J,e,S,A,s,M,C,P,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=void 0,e.$Xo=(0,P.$Uh)("requestService");class ${constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?u[i]="*****":u[i]=this.b[i];this.a=u}return this.a}}class p extends s.$Rc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,M.localize)(0,null),when:d.$tj.isEqualTo((0,d.$rj)(d.LogLevel.Trace)).serialize()})}async c(u,i,o){const r=`${u} #${++this.b}: ${i.url}`;this.a.trace(`${r} - begin`,i.type,new $(i.headers??{}));try{const t=await o();return this.a.trace(`${r} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,i.type,(0,A.$9)(t)),t}}}e.$Yo=p;function v(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Zo=v;function f(E){return E.res.statusCode===204}e.$1o=f;async function y(E){return f(E)?null:(await(0,S.$qe)(E.stream)).toString()}e.$2o=y;async function w(E){if(!v(E))throw new Error("Server returned "+E.res.statusCode);return y(E)}e.$3o=w;async function b(E){if(!v(E))throw new Error("Server returned "+E.res.statusCode);if(f(E))return null;const i=(await(0,S.$qe)(E.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$4o=b;function g(E){l(E)}e.$5o=g;let h;function l(E){const u=a.$ln.as(C.$qn.Configuration),i=h;h={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[h],remove:i?[i]:[]})}l(1)}),define(ne[244],re([0,1,18,22]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=void 0;class s{constructor(P){this.a=P}listen(P,d){throw new Error("Invalid listen")}call(P,d,a,$=A.CancellationToken.None){switch(d){case"request":return this.a.request(a[0],$).then(async({res:p,stream:v})=>{const f=await(0,S.$qe)(v);return[{statusCode:p.statusCode,headers:p.headers},f]});case"resolveProxy":return this.a.resolveProxy(a[0])}throw new Error("Invalid call")}}e.$1q=s;class M{constructor(P){this.a=P}async request(P,d){const[a,$]=await this.a.call("request",[P],d);return{res:a,stream:(0,S.$se)($)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.$2q=M}),define(ne[245],re([0,1,246,12]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;function s(C,P){return C.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:C.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function M(C,P,d={}){const a=(0,S.parse)(C),$=d.proxyUrl||s(a,P);if(!$)return null;const p=(0,S.parse)($);if(!/^https?:$/.test(p.protocol||""))return null;const v={host:p.hostname||"",port:(p.port?+p.port:0)||(p.protocol==="https"?443:80),auth:p.auth,rejectUnauthorized:(0,A.$Hf)(d.strictSSL)?d.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((f,y)=>{J(["http-proxy-agent"],f,y)})).HttpProxyAgent($,v):new(await new Promise((f,y)=>{J(["https-proxy-agent"],f,y)})).HttpsProxyAgent($,v)}e.$3q=M}),define(ne[247],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U8b=e.$T8b=e.$S8b=void 0,e.$S8b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$T8b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$U8b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ne[94],re([0,1,47,9,184,22,49,14,4,32,108,63,8,140]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=void 0;let y;async function w(g,h,l,E){return l["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.$i?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.$Sl)(E)&&!l["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.$Sl)(E)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=v.Promises.withAsyncBody(async(u,i)=>{const o=new M.$1d;let r=1e4;const t=g.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,f.$Tl)(t,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),i(new Error((0,s.localize)(0,null)))},r);try{u(await b(h,o.token))}catch(c){!(0,P.$3)(c)&&!o.token.isCancellationRequested?i(new Error((0,s.localize)(1,null,(0,C.$Fi)(c)))):u({})}finally{clearTimeout(n),o.dispose()}})),y)}e.$Yl=w;async function b(g,h){const l=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",l);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",E);const u=(0,a.$hg)().replace(/-/g,"").substr(0,12),i=new RegExp(u+"({.*})"+u),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const r=await(0,$.$Il)(d.OS,o);return g.trace("getUnixShellEnvironment#shell",r),new Promise((t,n)=>{if(h.isCancellationRequested)return n(new P.$4);const c=(0,A.$mc)(r);let m,D;const R=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(m=`& '${process.execPath}' ${R} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,D=["-Login","-Command"]):c==="nu"?(m=`^'${process.execPath}' ${R} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,D=["-i","-l","-c"]):(m=`'${process.execPath}' ${R} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,c==="tcsh"||c==="csh"?D=["-ic"]:D=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),m);const k=(0,S.spawn)(r,[...D,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});h.onCancellationRequested(()=>(k.kill(),n(new P.$4))),k.on("error",U=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,C.$Fi)(U)),n(U)});const I=[];k.stdout.on("data",U=>I.push(U));const F=[];k.stderr.on("data",U=>F.push(U)),k.on("close",(U,T)=>{const x=Buffer.concat(I).toString("utf8");g.trace("getUnixShellEnvironment#raw",x);const Y=Buffer.concat(F).toString("utf8");if(Y.trim()&&g.trace("getUnixShellEnvironment#stderr",Y),U||T)return n(new Error((0,s.localize)(2,null,U,T)));const ce=i.exec(x),oe=ce?ce[1]:"{}";try{const ae=JSON.parse(oe);l?ae.ELECTRON_RUN_AS_NODE=l:delete ae.ELECTRON_RUN_AS_NODE,E?ae.ELECTRON_NO_ATTACH_CONSOLE=E:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ae),t(ae)}catch(ae){g.error("getUnixShellEnvironment#errorCaught",(0,C.$Fi)(ae)),n(ae)}})})}}),define(ne[248],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M4b=void 0;class S{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const C=String(S.a++);return this.b.set(C,M),{id:C,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const C=this.b.get(s.id);if(!C)return!1;this.b.delete(s.id);try{return C.validate(M)==="ok"}catch{return!1}finally{C.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$M4b=S}),define(ne[95],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=void 0,e.$7k="signService",e.$8k=(0,S.$Uh)(e.$7k)}),define(ne[249],re([0,1,248]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I9b=void 0;class A extends S.$M4b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(C=>new C.signer().sign(M))}h(){return new Promise((M,C)=>J(["vsda"],M,C))}}e.$I9b=A}),define(ne[34],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=e.$PN=void 0,e.$PN=(0,S.$Uh)("stateReadService"),e.$QN=(0,S.$Uh)("stateService")}),define(ne[121],re([0,1,8,18,2,12,37,16,5]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=e.$SN=e.$RN=e.SaveStrategy=void 0;var a;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class $ extends s.$Rc{constructor(y,w,b,g){super(),this.h=y,this.j=w,this.m=b,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new S.$Ug(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.m.error(y)}}getItem(y,w){const b=this.a[y];return(0,M.$Kf)(b)?w:b}setItem(y,w){this.setItems([{key:y,data:w}])}setItems(y){let w=!1;for(const{key:b,data:g}of y)this.a[b]!==g&&((0,M.$Kf)(g)?(0,M.$If)(this.a[b])||(this.a[b]=void 0,w=!0):(this.a[b]=g,w=!0));w&&this.s()}removeItem(y){(0,M.$If)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,A.$ee.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(w){this.m.error(w)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$RN=$;let p=class extends s.$Rc{constructor(y,w,b,g){super(),this.a=this.B(new $(w.stateResource,y,b,g))}async init(){await this.a.init()}getItem(y,w){return this.a.getItem(y,w)}};e.$SN=p,e.$SN=p=ve([te(1,C.$2h),te(2,d.$cj),te(3,P.$dk)],p);class v extends p{setItem(y,w){this.a.setItem(y,w)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$TN=v}),define(ne[122],re([0,1,4,35,32]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=void 0;function M(d){if(S.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function C(d,a,$,p,v,f,y,w,b){const g=Object.create(null);g["common.machineId"]=f,g["common.sqmId"]=y,g.sessionID=(0,s.$hg)()+Date.now(),g.commitHash=p,g.version=v,g["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,S.$h)(S.$u),g["common.nodePlatform"]=A.$cc,g["common.nodeArch"]=$,g["common.product"]=b||"desktop",w&&(g["common.msftInternal"]=w);let h=0;const l=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),S.$l&&(g["common.snap"]="true");const E=M(a);return E&&(g["common.platformDetail"]=E),g}e.$mo=C;function P(d){const a=A.env.USERDNSDOMAIN;if(!a)return!1;const $=a.toLowerCase();return d.some(p=>$===p)}e.$no=P}),define(ne[26],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=void 0,e.$hl=(0,S.$Uh)("telemetryService"),e.$il=(0,S.$Uh)("customEndpointTelemetryService"),e.$jl="telemetry.currentSessionDate",e.$kl="telemetry.firstSessionDate",e.$ll="telemetry.lastSessionDate",e.$ml="telemetry.machineId",e.$nl="telemetry.sqmId",e.$ol="telemetry",e.$pl="telemetry.telemetryLevel",e.$ql="telemetry.enableCrashReporter",e.$rl="telemetry.enableTelemetry";var A;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(ne[250],re([0,1,28,8,44,13,9,4,7,88,21,107,91,16,25,26]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.$Kr=e.$Jr=void 0;const b=new Map;async function g(i,o){const r=`${i}::${o.join(":")}`,t=b.get(r);if(t)return t;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,m=new Map,D=2e4;function R(I,F,U,T){const x=F.substring(I.length+1);return A.Promises.withAsyncBody(async Y=>{let ce;try{ce=await $.Promises.readdir(F,{withFileTypes:!0})}catch{Y();return}if(T.count>=D){T.count+=ce.length,T.maxReached=!0,Y();return}let oe=ce.length;if(oe===0){Y();return}let ae=ce;T.count+ce.length>D&&(T.maxReached=!0,oe=D-T.count,ae=ce.slice(0,oe)),T.count+=ce.length;for(const Z of ae)if(Z.isDirectory()){if(U.includes(Z.name)||await R(I,(0,C.$ic)(F,Z.name),U,T),--oe===0){Y();return}}else{const K=Z.name.lastIndexOf(".");if(K>=0){const G=Z.name.substring(K+1);G&&c.set(G,(c.get(G)??0)+1)}for(const G of n)G.relativePathPattern?.test(x)!==!1&&G.filePattern.test(Z.name)&&m.set(G.tag,(m.get(G.tag)??0)+1);if(--oe===0){Y();return}}})}const k=A.Promises.withAsyncBody(async I=>{const F={count:0,maxReached:!1};await R(i,i,o,F);const U=await E(i);I({configFiles:h(m),fileTypes:h(c),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:U})});return b.set(r,k),k}e.$Jr=g;function h(i){return Array.from(i.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function l(){const i={os:`${S.type()} ${S.arch()} ${S.release()}`,memory:`${(S.totalmem()/f.$Lk.GB).toFixed(2)}GB (${(S.freemem()/f.$Lk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(a.$Wm.value()*100)}%`},o=S.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$Kr=l;async function E(i){try{const o=new Map,r=(0,C.$ic)(i,".vscode","launch.json"),t=await $.Promises.readFile(r),n=[],c=(0,s.$2m)(t.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$$m)(c)==="object"&&c.configurations)for(const m of c.configurations){const D=m.type;D&&(o.has(D)?o.set(D,o.get(D)+1):o.set(D,1))}return h(o)}catch{return[]}}e.$Lr=E;let u=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${S.type()} ${S.arch()} ${S.release()}`);const t=S.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(S.totalmem()/f.$Lk.GB).toFixed(2)}GB (${(S.freemem()/f.$Lk.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${S.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(a.$Wm.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,p.$Ir)(o.mainPID),this.k(o)]).then(async t=>{let[n,c]=t,m=this.m(o,n);return r.forEach(D=>{if((0,v.$wm)(D))m+=`
${D.errorMessage}`,c+=`
${D.errorMessage}`;else if(m+=`

Remote: ${D.hostName}`,D.processes&&(m+=`
${this.m(o,D.processes)}`),D.workspaceMetadata){c+=`
|  Remote: ${D.hostName}`;for(const R of Object.keys(D.workspaceMetadata)){const k=D.workspaceMetadata[R];let I=`${k.fileCount} files`;k.maxFilesReached&&(I=`more than ${I}`),c+=`|    Folder (${R}): ${I}`,c+=this.h(k)}}}),{processInfo:m,workspaceInfo:c}})}async getSystemInfo(o,r){const{memory:t,vmHint:n,os:c,cpus:m}=l(),D={os:c,memory:t,cpus:m,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(D.load=`${S.loadavg().map(R=>Math.round(R)).join(", ")}`),P.$k&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(o,r){const t=[];return(0,p.$Ir)(o.mainPID).then(async n=>(t.push(""),t.push(this.g(o)),t.push(""),t.push(this.m(o,n)),o.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.k(o))),r.forEach(c=>{if((0,v.$wm)(c))t.push(`
${c.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${c.hostName}`),t.push(this.f(c.machineInfo)),c.processes&&t.push(this.m(o,c.processes)),c.workspaceMetadata)for(const m of Object.keys(c.workspaceMetadata)){const D=c.workspaceMetadata[m];let R=`${D.fileCount} files`;D.maxFilesReached&&(R=`more than ${R}`),t.push(`Folder (${m}): ${R}`),t.push(this.h(D))}}),t.push(""),t.push(""),t.join(`
`)))}h(o){const r=[];let n=0;const c=(k,I)=>{const F=` ${k}(${I})`;n+F.length>60?(r.push(m),m="|                 ",n=m.length):n+=F.length,m+=F};let m="|      File types:";const D=10,R=o.fileTypes.length>D?D:o.fileTypes.length;for(let k=0;k<R;k++){const I=o.fileTypes[k];c(I.name,I.count)}if(r.push(m),o.configFiles.length>=0&&(m="|      Conf files:",n=0,o.configFiles.forEach(k=>{c(k.name,k.count)}),r.push(m)),o.launchConfigFiles.length>0){let k="|      Launch Configs:";o.launchConfigFiles.forEach(I=>{const F=I.count>1?` ${I.name}(${I.count})`:` ${I.name}`;k+=F}),r.push(k)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(t=>t.length));return Object.keys(o).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${o[t]}`).join(`
                  `)}k(o){const r=[],t=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(c=>{const m=d.URI.revive(c);if(m.scheme===M.Schemas.file){const D=m.fsPath;t.push(g(D,["node_modules",".git"]).then(R=>{let k=`${R.fileCount} files`;R.maxFilesReached&&(k=`more than ${k}`),r.push(`|    Folder (${(0,C.$mc)(D)}): ${k}`),r.push(this.h(R))}).catch(R=>{r.push(`|      Error: Unable to collect workspace stats for folder ${D} (${R.toString()})`)}))}else r.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const t=new Map;o.windows.forEach(c=>t.set(c.pid,`window [${c.id}] (${c.title})`)),o.pidToNames.forEach(({pid:c,name:m})=>t.set(c,m));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,t,n,r,0),n.join(`
`)}n(o,r,t,n,c){const m=c===0;let D;m?D=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?D=r.get(n.pid):D=`${"  ".repeat(c)} ${n.name}`;const R=process.platform==="win32"?n.mem:S.totalmem()*(n.mem/100);t.push(`${n.load.toFixed(0).padStart(5," ")}	${(R/f.$Lk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(o,r,t,k,c+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:t}of o.folders){const n=d.URI.revive(t);if(n.scheme!==M.Schemas.file)continue;const c=n.fsPath;try{(await g(c,["node_modules",".git"])).fileTypes.forEach(D=>r.add(D.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const t=d.URI.revive(r);if(t.scheme!==M.Schemas.file)continue;const n=t.fsPath;try{const c=await g(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),c.fileTypes.forEach(m=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})}),c.launchConfigFiles.forEach(m=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})}),c.configFiles.forEach(m=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};e.$Mr=u,e.$Mr=u=ve([te(0,w.$hl),te(1,y.$uj)],u)}),define(ne[251],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y8b=e.$X8b=void 0;class S{constructor(M){this.b=M}listen(M,C){throw new Error(`Event not found: ${C}`)}call(M,C,{eventName:P,data:d}){return this.b.forEach(a=>a.log(P,d)),Promise.resolve(null)}}e.$X8b=S;class A{constructor(M){this.b=M}log(M,C){return this.b.call("log",{eventName:M,data:C}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Y8b=A}),define(ne[51],re([0,1,38,12,3,17,59,122,26]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;class a{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$oo=a;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$po=$,e.$qo=new $;class p{async publicLog(n,c,m){}async publicLogError(n,c,m){}}e.$ro=p,e.$so="telemetry",e.$to="extensionTelemetryLog",e.$uo={log:()=>null,flush:()=>Promise.resolve(null)};function v(t,n){return s.Event.debounce(n.onDidChangeConfiguration,(m,D)=>{const R=m?new Set([...m.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:R}},1e3,!0)(m=>{m.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,M.$ri)(m.source),configurationKeys:Array.from(m.affectedKeys)})})}e.$vo=v;function f(t,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!t.enableTelemetry)}e.$wo=f;function y(t,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$xo=y;function w(t){const n=t.getValue(d.$pl),c=t.getValue(d.$ql);if(t.getValue(d.$rl)===!1||c===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$yo=w;function b(t){const n={},c={},m={};l(t,m);for(let D in m){D=D.length>150?D.substr(D.length-149):D;const R=m[D];typeof R=="number"?c[D]=R:typeof R=="boolean"?c[D]=R?1:0:typeof R=="string"?(R.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${R.length}`),n[D]=R.substring(0,8191)):typeof R<"u"&&R!==null&&(n[D]=R)}return{properties:n,measurements:c}}e.$zo=b;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(t){if(!t)return"none";const n=(0,C.$1k)(t);return g.has(n)?n:"other"}e.$Ao=h;function l(t,n,c=0,m){if(t)for(const D of Object.getOwnPropertyNames(t)){const R=t[D],k=m?m+D:D;Array.isArray(R)?n[k]=(0,S.$en)(R):R instanceof Date?n[k]=R.toISOString():(0,A.$Df)(R)?c<2?l(R,n,c+1,k+"."):n[k]=(0,S.$en)(R):n[k]=R}}function E(t,n){const c=t.msftInternalDomains||[],m=n.getValue("telemetry.internalTesting");return(0,P.$no)(c)||m}e.$Bo=E;function u(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Co=u;function i(t,n){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const m=[];for(const I of n)for(;;){const F=I.exec(t);if(!F)break;m.push([F.index,I.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,R=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(c="";;){const I=R.exec(t);if(!I)break;const F=m.some(([U,T])=>I.index<T&&U<R.lastIndex);!D.test(I[0])&&!F&&(c+=t.substring(k,I.index)+"<REDACTED: user-file-path>",k=R.lastIndex)}return k<t.length&&(c+=t.substr(k)),c}function o(t){if(!t)return t;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of n)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function r(t,n){return(0,S.$bn)(t,c=>{if(c instanceof a||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let m=c.replaceAll("%20"," ");m=i(m,n);for(const D of n)m=m.replace(D,"");return m=o(m),m}})}e.$Do=r}),define(ne[123],re([0,1,27,117,120,4,7,14,35,51]),function(J,e,S,A,s,M,C,P,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0;function $(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,S.$Ze)(r.id,t.id)===0}e.$Eo=$;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(t){const n=t.manifest?t.manifest.version:t.version,c=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new v(t.identifier,n,c)}static parse(t){const n=p.exec(t);return n&&n[1]&&n[2]?new v({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,c="undefined"){this.version=n,this.targetPlatform=c,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof v?$(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Fo=v;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const t=f.exec(r);return t&&t[1]?[b(t[1]),t[2]]:[b(r),void 0]}e.$Go=y;function w(r,t){return`${r}.${t}`}e.$Ho=w;function b(r){return r.toLowerCase()}e.$Io=b;function g(r,t){return b(w(r??s.$7l,t))}e.$Jo=g;function h(r,t){const n=[],c=m=>{for(const D of n)if(D.some(R=>$(t(R),t(m))))return D;return null};for(const m of r){const D=c(m);D?D.push(m):n.push([m])}return n}e.$Ko=h;function l(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$Lo=l;function E(r){return{id:new a.$oo(r.identifier.id),name:new a.$oo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Mo=E,e.$No=new s.$$l("pprice.better-merge");function u(r,t){const n=[],c=t.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const m=c.shift();if(m&&n.every(D=>!$(D.identifier,{id:m}))){const D=r.filter(R=>$(R.identifier,{id:m}));D.length===1&&(n.push(D[0]),c.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Oo=u;async function i(r,t){if(!M.$k)return!1;let n;try{n=(await r.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){t.debug("Error while getting the os-release file.",(0,P.$9)(m))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,t){const n=await i(r,t),c=(0,A.$$n)(n?"alpine":M.$u,d.$dc);return t.debug("ComputeTargetPlatform:",c),c}e.$Po=o}),define(ne[252],re([0,1,206,51]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=void 0;async function s(M,C,P,d,a,$,p){const v={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${C.nameShort})`};if((0,A.$wo)(C,P)&&(0,A.$yo)(d)===3){const f=await(0,S.$ep)(P,a,$);v["X-Market-User-Id"]=f,v["VSCode-SessionId"]=p.machineId||f}return v}e.$fp=s}),define(ne[253],re([0,1,2,38,4,27,185,17,58,79,25,43,26,51]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,h,l){this.k=h,this.l=l,this.d={},this.i=new S.$Qc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.$Ie)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Ie)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(v.$pl)||E.affectsConfiguration(v.$rl)||E.affectsConfiguration(v.$ql))&&this.m()}))}setExperimentProperty(g,h){this.d[g]=h}m(){let g=(0,f.$yo)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const l=h.usage?3:h.error?2:0;g=Math.min(g,l)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,h,l){this.g<h||(l=(0,A.$cn)(l,this.d),l=(0,f.$Do)(l,this.j),l=(0,A.$cn)(l,this.c),this.b.forEach(E=>E.log(g,l)))}publicLog(g,h){this.n(g,3,h)}publicLog2(g,h){this.publicLog(g,h)}publicLogError(g,h){this.h&&this.n(g,2,h)}publicLogError2(g,h){this.publicLogError(g,h)}};e.$6q=y,e.$6q=y=ve([te(1,P.$oi),te(2,$.$uj)],y);function w(){const b=(0,C.localize)(0,null,a.default.nameLong),g=a.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=s.$o?"":(0,C.localize)(3,null),l=(0,C.localize)(4,null),E=(0,C.localize)(5,null),u=(0,C.localize)(6,null),i=(0,C.localize)(7,null),o=`
|       | ${l} | ${E} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,C.localize)(8,null);return`
${b} ${g} ${h}

&nbsp;

${i}
${o}

&nbsp;

${r}
`}p.$ln.as(d.$qn.Configuration).registerConfiguration({id:v.$ol,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[v.$pl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.$ln.as(d.$qn.Configuration).registerConfiguration({id:v.$ol,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[v.$rl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,C.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,C.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${v.$pl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[254],re([0,1,4,88,26]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o9b=e.$n9b=void 0;async function M(P,d){let a=P.getItem(s.$ml);return(typeof a!="string"||S.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,A.$Xm)(d.error.bind(d))),a}e.$n9b=M;async function C(P,d){let a=P.getItem(s.$nl);return typeof a!="string"&&(a=await(0,A.$Ym)(d.error.bind(d))),a}e.$o9b=C}),define(ne[255],re([0,1,26,254]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q9b=e.$p9b=void 0;async function s(C,P){const d=await(0,A.$n9b)(C,P);return C.setItem(S.$ml,d),d}e.$p9b=s;async function M(C,P){const d=await(0,A.$o9b)(C,P);return C.setItem(S.$nl,d),d}e.$q9b=M}),define(ne[124],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var S;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(S||(e.EnvironmentVariableMutatorType=S={}))}),define(ne[256],re([0,1,4,124]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=void 0;const s=new Map([[A.EnvironmentVariableMutatorType.Append,"APPEND"],[A.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[A.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor($){this.collections=$,this.a=new Map,this.b=new Map,$.forEach((p,v)=>{this.d(p,v);const f=p.map.entries();let y=f.next();for(;!y.done;){const w=y.value[1],b=y.value[0];let g=this.a.get(b);if(g||(g=[],this.a.set(b,g)),g.length>0&&g[0].type===A.EnvironmentVariableMutatorType.Replace){y=f.next();continue}const h={extensionIdentifier:v,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};h.scope||delete h.scope,g.unshift(h),y=f.next()}})}async applyToProcessEnvironment($,p,v){let f;S.$i&&(f={},Object.keys($).forEach(y=>f[y.toLowerCase()]=y));for(const[y,w]of this.getVariableMap(p)){const b=S.$i&&f[y.toLowerCase()]||y;for(const g of w){const h=v?await v(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case A.EnvironmentVariableMutatorType.Append:$[b]=($[b]||"")+h;break;case A.EnvironmentVariableMutatorType.Prepend:$[b]=h+($[b]||"");break;case A.EnvironmentVariableMutatorType.Replace:$[b]=h;break}if(g.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${s.get(g.type)}`;$[l]=($[l]?$[l]+":":"")+y+"="+this.c(h)}}}}c($){return $.replaceAll(":","\\x3a")}diff($,p){const v=new Map,f=new Map,y=new Map;if($.getVariableMap(p).forEach((w,b)=>{const g=this.getVariableMap(p).get(b),h=P(w,g);h&&v.set(b,h)}),this.getVariableMap(p).forEach((w,b)=>{const g=$.getVariableMap(p).get(b),h=P(w,g);h&&y.set(b,h)}),this.getVariableMap(p).forEach((w,b)=>{const g=$.getVariableMap(p).get(b),h=d(w,g);h&&f.set(b,h)}),!(v.size===0&&f.size===0&&y.size===0))return{added:v,changed:f,removed:y}}getVariableMap($){const p=new Map;for(const v of this.a.values()){const f=v.filter(y=>C(y,$));f.length>0&&p.set(f[0].variable,f)}return p}getDescriptionMap($){const p=new Map;for(const v of this.b.values()){const f=v.filter(y=>C(y,$,!0));for(const y of f)p.set(y.extensionIdentifier,y.description)}return p}d($,p){if(!$.descriptionMap)return;const v=$.descriptionMap.entries();let f=v.next();for(;!f.done;){const y=f.value[1],w=f.value[0];let b=this.b.get(w);b||(b=[],this.b.set(w,b));const g={extensionIdentifier:p,scope:y.scope,description:y.description};g.scope||delete g.scope,b.push(g),f=v.next()}}}e.$wr=M;function C(a,$,p=!1){return a.scope?!!(a.scope.workspaceFolder&&$?.workspaceFolder&&a.scope.workspaceFolder.index===$.workspaceFolder.index):p?$===a.scope:!0}function P(a,$){if(!$)return a;const p=new Set;$.forEach(f=>p.add(f.extensionIdentifier));const v=[];return a.forEach(f=>{p.has(f.extensionIdentifier)||v.push(f)}),v.length===0?void 0:v}function d(a,$){if(!$)return;const p=new Map;$.forEach(f=>p.set(f.extensionIdentifier,f));const v=[];return a.forEach(f=>{const y=p.get(f.extensionIdentifier);y&&(f.type!==y.type||f.value!==y.value||f.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&v.push(y)}),v.length===0?void 0:v}}),define(ne[257],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function S(d){return[...d.entries()]}e.$qr=S;function A(d){return d?[...d.entries()]:[]}e.$rr=A;function s(d){return new Map(d)}e.$sr=s;function M(d){return new Map(d??[])}e.$tr=M;function C(d){return Array.from(d.entries()).map(a=>[a[0],S(a[1].map),A(a[1].descriptionMap)])}e.$ur=C;function P(d){return new Map(d.map(a=>[a[0],{map:s(a[1]),descriptionMap:M(a[2])}]))}e.$vr=P}),define(ne[258],re([0,1,8,22,3,2,5]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;let P=class extends M.$Rc{constructor(a,$){super(),this.h=$,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Qd),this.onCreateRequest=this.g.event,this.b=a===void 0?15e3:a,this.B((0,M.$Pc)(()=>{for(const p of this.f.values())(0,M.$Mc)(p)}))}createRequest(a){return new Promise(($,p)=>{const v=++this.a;this.c.set(v,$),this.g.fire({requestId:v,...a});const f=new A.$1d;(0,S.$Xg)(this.b,f.token).then(()=>p(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,M.$Pc)(()=>f.cancel())])})}acceptReply(a,$){const p=this.c.get(a);p?(this.c.delete(a),(0,M.$Mc)(this.f.get(a)||[]),this.f.delete(a),p($)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${a}`)}};e.$hr=P,e.$hr=P=ve([te(1,C.$cj)],P)}),define(ne[125],re([0,1,6,114,43]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$ar=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$_q=void 0,e.$_q=new A.$_i("terminalTabFocusMode",!1,!0);var M;(function(u){u.AutomationProfile="terminal.integrated.automationProfile.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var C;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",u.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",u.EnableStickyScroll="terminal.integrated.enableStickyScroll",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(C||(e.TerminalSettingId=C={}));var P;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(P||(e.PosixShellType=P={}));var d;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(d||(e.WindowsShellType=d={}));var a;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var $;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})($||(e.TerminalIpcChannels=$={}));var p;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.$ar=(0,S.$Uh)("ptyService");var v;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var f;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y||(e.TerminalLocationString=y={}));var w;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var b;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(b||(e.FlowControlConstants=b={}));var g;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var h;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var l;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$br={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const o=this.b(i.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}s.$ln.add(e.$br.Backend,new E),e.$cr=(0,S.$Uh)("localPtyService"),e.$dr=(0,S.$Uh)("terminalLogService")}),define(ne[259],re([0,1,75,7,187,102]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=e.$jr=e.$ir=void 0;function C(v,f){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...v.map(w=>({name:w.profileName,description:P(w)}))),f&&y.push(...f.map(w=>({name:w.title,description:d(w)}))),{values:y.map(w=>w.name),markdownDescriptions:y.map(w=>w.description)}}e.$ir=C;function P(v){let f=`$(${M.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:S.$Zj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?f+=`
- args: "${v.args}"`:f+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(f+=`
- overrideName: ${v.overrideName}`),v.color&&(f+=`
- color: ${v.color}`),v.env&&(f+=`
- env: ${JSON.stringify(v.env)}`),f}function d(v){return`$(${M.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:S.$Zj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function a(v,f){if(!v&&!f)return!0;if(typeof v=="string"&&typeof f=="string")return v===f;if(Array.isArray(v)&&Array.isArray(f)){if(v.length!==f.length)return!1;for(let y=0;y<v.length;y++)if(v[y]!==f[y])return!1;return!0}return!1}e.$jr=a;function $(v,f){if(!v&&!f)return!0;if(!v||!f)return!1;if(M.ThemeIcon.isThemeIcon(v)&&M.ThemeIcon.isThemeIcon(f))return v.id===f.id&&v.color===f.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof f=="object"&&"light"in f&&"dark"in f){const y=v,w=f;if((A.URI.isUri(y.light)||p(y.light))&&(A.URI.isUri(y.dark)||p(y.dark))&&(A.URI.isUri(w.light)||p(w.light))&&(A.URI.isUri(w.dark)||p(w.dark)))return y.light.path===w.light.path&&y.dark.path===w.dark.path}if(A.URI.isUri(v)&&A.URI.isUri(f)||p(v)||p(f)){const y=v,w=f;return y.path===w.path&&y.scheme===w.scheme}return!1}e.$kr=$;function p(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.$lr=p}),define(ne[260],re([0,1,75,4,186,58,43,259]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=e.$nr=e.$mr=void 0,e.$mr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$nr={type:"string",enum:Array.from((0,S.$Yj)(),b=>b.id),markdownEnumDescriptions:Array.from((0,S.$Yj)(),b=>`$(${b.id})`)};const d={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$nr},color:{description:(0,s.localize)(3,null),...e.$mr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},a={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...d}},$={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...d}};function p(b){const g=b===2?"linux":b===1?"osx":"windows";return(0,s.localize)(7,null,(0,A.$h)(b),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:p(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...d}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...d}},{type:"null"},a]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:p(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...d}},{type:"null"},a]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:p(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...d}},{type:"null"},a]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){C.$ln.as(M.$qn.Configuration).registerConfiguration(v),w()}e.$or=f;let y;function w(b,g){const h=C.$ln.as(M.$qn.Configuration);let l;b&&(l=(0,P.$ir)(b?.profiles,g));const E=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:b?.os===3?l?.values:void 0,markdownEnumDescriptions:b?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:b?.os===2?l?.values:void 0,markdownEnumDescriptions:b?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:b?.os===1?l?.values:void 0,markdownEnumDescriptions:b?.os===1?l?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[y],remove:E?[E]:[]})}e.$pr=w}),define(ne[261],re([0,1,28,13,38,9,4,35,27,12,21,124,257,256]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=e.$xr=void 0;function y(){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(S.release());let n=0;return t&&t.length===4&&(n=parseInt(t[3])),n}e.$xr=y;async function w(t,n,c,m=P.env,D=$.Promises.exists){if(M.$hc(t))return await D(t)?t:void 0;if(n===void 0&&(n=P.cwd()),M.$lc(t)!=="."){const F=M.$ic(n,t);return await D(F)?F:void 0}const k=(0,s.$gn)(m,"PATH");if(c===void 0&&(0,a.$Bf)(k)&&(c=k.split(M.$sc)),c===void 0||c.length===0){const F=M.$ic(n,t);return await D(F)?F:void 0}for(const F of c){let U;if(M.$hc(F)?U=M.$ic(F,t):U=M.$ic(n,F,t),await D(U))return U;if(C.$i){let T=U+".com";if(await D(T)||(T=U+".exe",await D(T)))return T}}const I=M.$ic(n,t);return await D(I)?I:void 0}e.$yr=w;function b(t,n,c,m,D){const R=C.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!t.executable||t.isFeatureTerminal||t.hideFromUser||t.ignoreShellIntegration||R)return;const k=t.args,I=P.$cc==="win32"?M.$mc(t.executable).toLowerCase():M.$mc(t.executable),F=M.$lc(A.$fg.asFileUri("").fsPath);let U;const T={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(T.VSCODE_NONCE=n.shellIntegration.nonce),C.$i){if(I==="pwsh.exe"||I==="powershell.exe")return!k||o(k)?U=l.get(h.WindowsPwsh):i(k)&&(U=l.get(h.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,d.$Fe)(U[U.length-1],F,""),{newArgs:U,envMixin:T}):void 0;m.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args);return}switch(I){case"bash":return!k||k.length===0?U=l.get(h.Bash):r(k)&&(T.VSCODE_SHELL_LOGIN="1",g(n,T),U=l.get(h.Bash)),U?(U=[...U],U[U.length-1]=(0,d.$Fe)(U[U.length-1],F),{newArgs:U,envMixin:T}):void 0;case"fish":{const x=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",Y=M.$ic(F,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return T.XDG_DATA_DIRS=`${x}:${Y}`,g(n,T),{newArgs:void 0,envMixin:T}}case"pwsh":return!k||o(k)?U=l.get(h.Pwsh):i(k)&&(U=l.get(h.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,d.$Fe)(U[U.length-1],F,""),{newArgs:U,envMixin:T}):void 0;case"zsh":{if(!k||k.length===0?U=l.get(h.Zsh):r(k)?(U=l.get(h.ZshLogin),g(n,T)):(k===l.get(h.Zsh)||k===l.get(h.ZshLogin))&&(U=k),!U)return;U=[...U],U[U.length-1]=(0,d.$Fe)(U[U.length-1],F);let x;try{x=S.userInfo().username}catch{x="unknown"}const Y=M.$ic(S.tmpdir(),`${x}-${D.applicationName}-zsh`);T.ZDOTDIR=Y;const ce=c?.ZDOTDIR??S.homedir()??"~";T.USER_ZDOTDIR=ce;const oe=[];return oe.push({source:M.$ic(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$ic(Y,".zshrc")}),oe.push({source:M.$ic(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$ic(Y,".zprofile")}),oe.push({source:M.$ic(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$ic(Y,".zshenv")}),oe.push({source:M.$ic(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$ic(Y,".zlogin")}),{newArgs:U,envMixin:T,filesToCopy:oe}}}m.warn(`Shell integration cannot be enabled for executable "${t.executable}" and args`,t.args)}e.$zr=b;function g(t,n){if(C.$j&&t.environmentVariableCollections){const c=(0,v.$vr)(t.environmentVariableCollections),D=new f.$wr(c).getVariableMap({workspaceFolder:t.workspaceFolder}).get("PATH"),R=[];if(D)for(const k of D)k.type===p.EnvironmentVariableMutatorType.Prepend&&R.push(k.value);R.length>0&&(n.VSCODE_PATH_PREFIX=R.join(""))}}var h;(function(t){t.WindowsPwsh="windows-pwsh",t.WindowsPwshLogin="windows-pwsh-login",t.Pwsh="pwsh",t.PwshLogin="pwsh-login",t.Zsh="zsh",t.ZshLogin="zsh-login",t.Bash="bash"})(h||(h={}));const l=new Map;l.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(h.Zsh,["-i"]),l.set(h.ZshLogin,["-il"]),l.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],u=["-nol","-nologo"];function i(t){return typeof t=="string"?E.includes(t.toLowerCase()):t.length===1&&E.includes(t[0].toLowerCase())||t.length===2&&(E.includes(t[0].toLowerCase())||E.includes(t[1].toLowerCase()))&&(u.includes(t[0].toLowerCase())||u.includes(t[1].toLowerCase()))}function o(t){return typeof t=="string"?u.includes(t.toLowerCase()):t.length===0||t?.length===1&&u.includes(t[0].toLowerCase())}function r(t){return t==="string"&&E.includes(t.toLowerCase())||typeof t!="string"&&t.length===1&&E.includes(t[0].toLowerCase())}}),define(ne[262],re([0,1,47,75,9,4,12,21,106,261,113]),function(J,e,S,A,s,M,C,P,d,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;var p;(function(c){c.UnixShellsPath="/etc/shells"})(p||(p={}));let v,f=!0;function y(c,m,D,R,k=process.env,I,F,U,T){return I=I||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},M.$i?w(D,I,k,F,R.getValue("terminal.integrated.useWslProfiles")!==!1,c&&typeof c=="object"?{...c}:R.getValue("terminal.integrated.profiles.windows"),typeof m=="string"?m:R.getValue("terminal.integrated.defaultProfile.windows"),T,U):r(I,F,D,c&&typeof c=="object"?{...c}:R.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof m=="string"?m:R.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,U,k)}e.$Ar=y;async function w(c,m,D,R,k,I,F,U,T){const x=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Y=`${process.env.windir}\\${x?"Sysnative":"System32"}`;let ce=!1;(0,a.$xr)()>=16299&&(ce=!0),await l(U);const oe=new Map;if(c){oe.set("PowerShell",{source:"PowerShell",icon:A.$Zj.terminalPowershell,isAutoDetected:!0}),oe.set("Windows PowerShell",{path:`${Y}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.$Zj.terminalPowershell,isAutoDetected:!0}),oe.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),oe.set("Command Prompt",{path:`${Y}\\cmd.exe`,icon:A.$Zj.terminalCmd,isAutoDetected:!0}),oe.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),oe.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.$Zj.terminalBash,isAutoDetected:!0});const Z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;oe.set("Cmder",{path:`${Y}\\cmd.exe`,args:["/K",Z],requiresPath:process.env.CMDER_ROOT?Z:{path:Z,isUnsafe:!0},isAutoDetected:!0})}t(I,oe);const ae=await b(oe.entries(),F,m,D,R,T);if(c&&k)try{const Z=await i(`${Y}\\${ce?"wsl":"bash"}.exe`,F);for(const K of Z)(!I||!(K.profileName in I))&&ae.push(K)}catch{f&&(R?.info("WSL is not installed, so could not detect WSL profiles"),f=!1)}return ae}async function b(c,m,D,R=process.env,k,I){const F=[];for(const[U,T]of c)F.push(g(U,T,m,D,R,k,I));return(await Promise.all(F)).filter(U=>!!U)}async function g(c,m,D,R,k=process.env,I,F){if(m===null)return;let U,T,x;if("source"in m&&!("path"in m)){const ae=v?.get(m.source);if(!ae)return;U=ae.paths,T=m.args||ae.args,m.icon?x=h(m.icon):ae.icon&&(x=ae.icon)}else U=Array.isArray(m.path)?m.path:[m.path],T=M.$i||Array.isArray(m.args)?m.args:void 0,x=h(m.icon);let Y;if(F){const ae=U.map(K=>typeof K=="string"?K:K.path),Z=await F(ae);Y=new Array(U.length);for(let K=0;K<U.length;K++)typeof U[K]=="string"?Y[K]=Z[K]:Y[K]={path:Z[K],isUnsafe:!0}}else Y=U.slice();let ce;if(m.requiresPath){let ae;if((0,C.$Bf)(m.requiresPath)?ae=m.requiresPath:(ae=m.requiresPath.path,m.requiresPath.isUnsafe&&(ce=ae)),!await R.existsFile(ae))return}const oe=await n(c,D,Y,R,k,T,m.env,m.overrideName,m.isAutoDetected,ce);if(!oe){I?.debug("Terminal profile not validated",c,U);return}return oe.isAutoDetected=m.isAutoDetected,oe.icon=x,oe.color=m.color,oe}function h(c){return typeof c=="string"?{id:c}:c}async function l(c){if(v&&!c)return;const[m,D]=await Promise.all([E(),c||u()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:m,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:D,icon:A.$Zj.terminalPowershell})}async function E(){const c=new Set,m=await(0,a.$yr)("git.exe");if(m){const k=(0,$.dirname)(m);c.add((0,$.resolve)(k,"../.."))}function D(k,I){I&&k.add(I)}D(c,process.env.ProgramW6432),D(c,process.env.ProgramFiles),D(c,process.env["ProgramFiles(X86)"]),D(c,`${process.env.LocalAppData}\\Program`);const R=[];for(const k of c)R.push(`${k}\\Git\\bin\\bash.exe`,`${k}\\Git\\usr\\bin\\bash.exe`,`${k}\\usr\\bin\\bash.exe`);return R.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),R.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),R}async function u(){const c=[];for await(const m of(0,d.$Cl)())c.push(m.exePath);return c}async function i(c,m){const D=[],R=await new Promise((F,U)=>{S.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,x)=>{if(T)return U("Problem occurred when getting wsl distros");F(x)})});if(!R)return[];const k=new RegExp(/[\r?\n]/),I=R.split(k).filter(F=>F.trim().length>0&&F!=="");for(const F of I){if(F===""||F.startsWith("docker-desktop"))continue;const U=`${F} (WSL)`,T={profileName:U,path:c,args:["-d",`${F}`],isDefault:U===m,icon:o(F),isAutoDetected:!1};D.push(T)}return D}function o(c){return c.includes("Ubuntu")?A.$Zj.terminalUbuntu:c.includes("Debian")?A.$Zj.terminalDebian:A.$Zj.terminalLinux}async function r(c,m,D,R,k,I,F,U){const T=new Map;if(D&&await c.existsFile("/etc/shells")){const x=(await c.readFile("/etc/shells")).toString(),Y=(I||x.split(`
`)).map(oe=>{const ae=oe.indexOf("#");return ae===-1?oe:oe.substring(0,ae)}).filter(oe=>oe.trim().length>0),ce=new Map;for(const oe of Y){let ae=(0,s.$mc)(oe),Z=ce.get(ae)||0;Z++,Z>1&&(ae=`${ae} (${Z})`),ce.set(ae,Z),T.set(ae,{path:oe,isAutoDetected:!0})}}return t(R,T),await b(T.entries(),k,c,U,m,F)}function t(c,m){if(c)for(const[D,R]of Object.entries(c))R===null||typeof R!="object"||!("path"in R)&&!("source"in R)?m.delete(D):(R.icon=R.icon||m.get(D)?.icon,m.set(D,R))}async function n(c,m,D,R,k,I,F,U,T,x){if(D.length===0)return Promise.resolve(void 0);const Y=D.shift();if(Y==="")return n(c,m,D,R,k,I,F,U,T);const ce=typeof Y!="string"&&Y.isUnsafe,oe=typeof Y=="string"?Y:Y.path,ae={profileName:c,path:oe,args:I,env:F,overrideName:U,isAutoDetected:T,isDefault:c===m,isUnsafePath:ce,requiresUnsafePath:x};if((0,s.$mc)(oe)===oe){const K=k.PATH?k.PATH.split(s.$sc):void 0,G=await(0,a.$yr)(oe,void 0,K,void 0,R.existsFile);return G?(ae.path=G,ae.isFromPath=!0,ae):n(c,m,D,R,k,I)}return await R.existsFile((0,s.$gc)(oe))?ae:n(c,m,D,R,k,I,F,U,T)}}),define(ne[263],re([0,1,3,2,4,42,17,5,226,94,258,125,260,262,108,73]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;var b;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(b||(b={}));let g=class extends A.$Rc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,E,u,i){super(),this.M=l,this.N=E,this.O=u,this.P=i,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new S.$Qd),this.onPtyHostExit=this.u.event,this.w=this.B(new S.$Qd),this.onPtyHostStart=this.w.event,this.y=this.B(new S.$Qd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new S.$Qd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new S.$Qd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new S.$Qd),this.onProcessData=this.D.event,this.F=this.B(new S.$Qd),this.onProcessReady=this.F.event,this.G=this.B(new S.$Qd),this.onProcessReplay=this.G.event,this.H=this.B(new S.$Qd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$Qd),this.onDidRequestDetach=this.I.event,this.J=this.B(new S.$Qd),this.onDidChangeProperty=this.J.event,this.L=this.B(new S.$Qd),this.onProcessExit=this.L.event,(0,v.$or)(),this.B(this.M),this.B((0,A.$Pc)(()=>this.W())),this.j=this.B(new $.$hr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&S.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,a.$Yl)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),E=l.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(E.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=b.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const i=M.ProxyChannel.toService(E.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(i.onProcessData(o=>this.D.fire(o))),this.B(i.onProcessReady(o=>this.F.fire(o))),this.B(i.onProcessExit(o=>this.L.fire(o))),this.B(i.onDidChangeProperty(o=>this.J.fire(o))),this.B(i.onProcessReplay(o=>this.G.fire(o))),this.B(i.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(i.onDidRequestDetach(o=>this.I.fire(o))),this.B(new d.$gr(this.P,E.getChannel(p.TerminalIpcChannels.Logger))),this.a=l,this.b=i,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,i]}async createProcess(l,E,u,i,o,r,t,n,c,m,D){const R=setTimeout(()=>this.$(),p.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(l,E,u,i,o,r,t,n,c,m,D);return clearTimeout(R),k}updateTitle(l,E,u){return this.f.updateTitle(l,E,u)}updateIcon(l,E,u,i){return this.f.updateIcon(l,E,u,i)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,E){return this.f.detachFromProcess(l,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,E){return this.f.shutdown(l,E)}input(l,E){return this.f.input(l,E)}processBinary(l,E){return this.f.processBinary(l,E)}resize(l,E,u){return this.f.resize(l,E,u)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,E){return this.f.acknowledgeDataEvent(l,E)}setUnicodeVersion(l,E){return this.f.setUnicodeVersion(l,E)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new w.$Md,E=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...E]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,E){return this.f.installAutoReply(l,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,y.$Il)(l??s.OS,process.env)}async getProfiles(l,E,u,i=!1){const o=await this.S();return(0,f.$Ar)(E,u,i,this.N,o,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,E){return this.f.getWslPath(l,E)}getRevivedPtyNewId(l,E){return this.f.getRevivedPtyNewId(l,E)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,E){return this.f.requestDetachInstance(l,E)}async acceptDetachInstanceReply(l,E){return this.f.acceptDetachInstanceReply(l,E)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,E,u){return this.f.reviveTerminalProcesses(l,E,u)}async refreshProperty(l,E){return this.f.refreshProperty(l,E)}async updateProperty(l,E,u){return this.f.updateProperty(l,E,u)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?p.HeartbeatConstants.ConnectingBeatInterval:p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,E){return this.j.createRequest({workspaceId:l,originalText:E})}async acceptPtyHostResolvedVariables(l,E){this.j.acceptReply(l,E)}};e.$Br=g,e.$Br=g=ve([te(1,C.$oi),te(2,P.$cj),te(3,P.$dj)],g)}),define(ne[69],re([0,1,15,3,2,4,17,6,34]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R7b=e.$Q7b=void 0;const a="#FFFFFF",$="#1E1E1E",p="#000000",v="#FFFFFF",f="theme",y="themeBackground",w="windowSplash";e.$Q7b=(0,P.$Uh)("themeMainService");let b=class extends s.$Rc{constructor(h,l){super(),this.b=h,this.c=l,this.a=this.B(new A.$Qd),this.onDidChangeColorScheme=this.a.event,S.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors)return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&S.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:S.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?p:v;let l=this.b.getItem(y,null);if(!l)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":l=a;break;case"hc-black":l=p;break;case"hc-light":l=v;break;default:l=$}return M.$j&&l.toUpperCase()===$&&(l="#171717"),l}saveWindowSplash(h,l){this.b.setItems([{key:f,data:l.baseTheme},{key:y,data:l.colorInfo.background},{key:w,data:l}]),typeof h=="number"&&this.f(h,l)}f(h,l){for(const E of S.BrowserWindow.getAllWindows())if(E.id===h){E.setBackgroundColor(l.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$R7b=b,e.$R7b=b=ve([te(0,d.$QN),te(1,C.$oi)],b)}),define(ne[126],re([0,1,3,17,6,5]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,s.$Uh)("tunnelService"),e.$ev=(0,s.$Uh)("sharedTunnelsService");var C;(function(b){b.Http="http",b.Https="https"})(C||(e.TunnelProtocol=C={}));var P;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(P||(e.TunnelPrivacyId=P={}));function d(b){return!!b.forwardPort}e.$fv=d;var a;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function $(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(g)return{address:g[1],port:+g[2]}}e.$gv=$,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(b){return e.$hv.indexOf(b)>=0}e.$iv=p,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(b){return e.$jv.indexOf(b)>=0}e.$kv=v;function f(b,g,h,l){if(h===1)return!1;if(h===2&&v(g)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(l);if(E?.length===4&&parseInt(E[1])>=18)return!1}return b<1024}e.$lv=f;class y{constructor(g,h,l){this.remoteAddress=g,this.localAddress=h,this.b=l,this.a=new S.$Qd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=y;let w=class{constructor(g,h){this.j=g,this.k=h,this.a=new S.$Qd,this.onTunnelOpened=this.a.event,this.b=new S.$Qd,this.onTunnelClosed=this.b.event,this.c=new S.$Qd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const g=this.k.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.f=g,g?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.g=g.elevation,this.h=g.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const g=[],h=Array.from(this.e.values());for(const l of h){const E=Array.from(l.values());for(const u of E){const i=await u.value;i&&typeof i!="string"&&g.push(i)}}return g}async dispose(){for(const g of this.e.values()){for(const{value:h}of g.values())await h.then(l=>typeof l!="string"?l?.dispose():void 0);g.clear()}this.e.clear()}setEnvironmentTunnel(g,h,l,E,u){this.p(g,h,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:h,localAddress:l,privacy:E,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,h){(v(g)||p(g))&&(g=e.$hv[0]);const l=this.r(g,h);if(l)return++l.refcount,l.value}openTunnel(g,h,l,E,u,i=!1,o,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${l} on local port ${u}.`);const t=this.f??g;if(!t)return;if(h||(h="localhost"),E||(E=this.l),this.f&&this.i.has(l)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(t,h,l,E,u,i,o,r);return n?n.then(c=>{if(c){if(typeof c=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(h,l),c}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(h,l);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.n(c);return(c.tunnelRemoteHost!==h||c.tunnelRemotePort!==l)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&c.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const h=this.e.get(g.tunnelRemoteHost);if(h){const l=h.get(g.tunnelRemotePort);l&&(l.refcount--,await this.o(g.tunnelRemoteHost,g.tunnelRemotePort,l))}}}}async o(g,h,l){if(l.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${h}.`);const E=l.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(g)&&this.e.get(g).delete(h),E}}async closeTunnel(g,h){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${h} `);const l=this.e.get(g);if(l&&l.has(h)){const E=l.get(h);E.refcount=0,await this.o(g,h,E)}}p(g,h,l){this.e.has(g)||this.e.set(g,new Map),this.e.get(g).set(h,{refcount:1,value:l})}async q(g,h){const l=this.e.get(g);if(l){const E=l.get(h),u=E?await E.value:void 0;(!u||typeof u=="string")&&l.delete(h),l.size===0&&this.e.delete(g)}}r(g,h){const l=[g];p(g)?(l.push(...e.$hv),l.push(...e.$jv)):v(g)&&l.push(...e.$jv);const E=l.map(u=>this.e.get(u));for(const u of E){const i=u?.get(h);if(i)return i}}canTunnel(g){return!!$(g)}t(g,h,l,E,u,i,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${l} on local port ${E}.`);const r=l;this.i.add(r);const t=E===void 0?l:E,n={elevationRequired:u?this.isPortPrivileged(t):!1},c={remoteAddress:{host:h,port:l},localAddressPort:E,privacy:i,public:i?i!==P.Private:void 0,protocol:o},m=g.forwardPort(c,n);return m?(this.p(h,l,m),m.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),m}};e.$nv=w,e.$nv=w=ve([te(0,M.$cj),te(1,A.$oi)],w)}),define(ne[48],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UU=e.$TU=e.DisablementReason=e.UpdateType=e.StateType=void 0;var A;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.Disabled="disabled",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(A||(e.StateType=A={}));var s;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(C){C[C.NotBuilt=0]="NotBuilt",C[C.DisabledByEnvironment=1]="DisabledByEnvironment",C[C.ManuallyDisabled=2]="ManuallyDisabled",C[C.MissingConfiguration=3]="MissingConfiguration",C[C.InvalidConfiguration=4]="InvalidConfiguration",C[C.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$TU={Uninitialized:{type:"uninitialized"},Disabled:C=>({type:"disabled",reason:C}),Idle:(C,P)=>({type:"idle",updateType:C,error:P}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.$UU=(0,S.$Uh)("updateService")}),define(ne[264],re([0,1,4,188,58,43]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$ln.as(s.$qn.Configuration).registerConfiguration({id:"update",order:15,title:(0,A.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,A.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,A.localize)(2,null),(0,A.localize)(3,null),(0,A.localize)(4,null),(0,A.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,A.localize)(6,null),deprecationMessage:(0,A.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,A.localize)(8,null),description:(0,A.localize)(9,null),included:S.$i&&!S.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,A.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(ne[265],re([0,1,3,48]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$18b=e.$Z8b=void 0;class s{constructor(P){this.a=P}listen(P,d){switch(d){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${d}`)}call(P,d,a){switch(d){case"checkForUpdates":return this.a.checkForUpdates(a);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(a)}throw new Error(`Call not found: ${d}`)}}e.$Z8b=s;class M{get state(){return this.b}set state(P){this.b=P,this.a.fire(P)}constructor(P){this.c=P,this.a=new S.$Qd,this.onStateChange=this.a.event,this.b=A.$TU.Uninitialized,this.c.listen("onStateChange")(d=>this.state=d),this.c.call("_getInitialState").then(d=>this.state=d)}checkForUpdates(P){return this.c.call("checkForUpdates",P)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(P){return this.c.call("_applySpecificUpdate",P)}}e.$18b=M}),define(ne[40],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=void 0,e.$Nk=(0,S.$Uh)("IUriIdentityService")}),define(ne[266],re([0,1,40,207,16,19,141,3,2]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;class a{static{this._clock=0}constructor(v){this.uri=v,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let $=class{constructor(v){this.g=v,this.c=new d.$Qc,this.f=2**16;const f=new Map,y=w=>{let b=f.get(w.scheme);return b===void 0&&(b=v.hasProvider(w)&&!this.g.hasCapability(w,1024),f.set(w.scheme,b)),b};this.c.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(w=>{f.delete(w.scheme)})),this.extUri=new M.$ng(y),this.d=new C.$Er((w,b)=>this.extUri.compare(w,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,M.$zg)(v));const f=this.d.get(v);return f?f.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new a(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((y,w)=>y[1].time<w[1].time?1:y[1].time>w[1].time?-1:0);a._clock=0,this.d.clear();const f=this.f*.5;for(let y=0;y<f;y++)this.d.set(v[y][0],v[y][1].touch())}};e.$Fr=$,e.$Fr=$=ve([te(0,s.$dk)],$),(0,A.$Cr)(S.$Nk,$,1)}),define(ne[127],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IU=void 0,e.$IU=(0,S.$Uh)("urlService")}),define(ne[267],re([0,1,7]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$08b=e.$98b=e.$88b=void 0;class A{constructor(P){this.a=P}listen(P,d){throw new Error(`Event not found: ${d}`)}call(P,d,a){switch(d){case"handleURL":return this.a.handleURL(S.URI.revive(a[0]),a[1])}throw new Error(`Call not found: ${d}`)}}e.$88b=A;class s{constructor(P){this.a=P}handleURL(P,d){return this.a.call("handleURL",[P.toJSON(),d])}}e.$98b=s;class M{constructor(P,d){this.a=P,this.b=d}async routeCall(P,d,a,$){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(Array.isArray(a)&&a.length>0){const p=S.URI.revive(a[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",p.toString(!0)),p.query){const v=/\bwindowId=(\d+)/.exec(p.query);if(v){const f=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,p.toString(!0));const y=new RegExp(`window:${f}`),w=P.connections.find(b=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",b.ctx),y.test(b.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",p.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",p.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",p.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(P,d,a,$)}routeEvent(P,d){throw new Error(`Event not found: ${d}`)}}e.$08b=M}),define(ne[268],re([0,1,8,2,7,25]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KU=e.$JU=void 0;class C extends A.$Rc{constructor(){super(...arguments),this.a=new Set}open(a,$){const p=[...this.a.values()];return(0,S.$1g)(p.map(v=>()=>v.handleURL(a,$)),void 0,!1).then(v=>v||!1)}registerHandler(a){return this.a.add(a),(0,A.$Pc)(()=>this.a.delete(a))}}e.$JU=C;let P=class extends C{constructor(a){super(),this.b=a}create(a){let{authority:$,path:p,query:v,fragment:f}=a||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return $&&p&&p.indexOf("/")!==0&&(p=`/${p}`),s.URI.from({scheme:this.b.urlProtocol,authority:$,path:p,query:v,fragment:f})}};e.$KU=P,e.$KU=P=ve([te(0,M.$uj)],P)}),define(ne[269],re([0,1,15,8,3,2,4,7]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$8b=void 0;class d extends M.$Rc{constructor($,p,v,f,y,w){if(super(),this.c=p,this.f=w,this.a=[],this.b=0,$&&(w.trace("ElectronURLListener initialUrisToHandle:",$.map(h=>h.originalUrl)),this.a=$),C.$i){const h=f.isBuilt?[]:[`"${f.appRoot}"`];h.push("--open-url","--"),S.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,h)}const b=s.Event.map(s.Event.fromNodeEventEmitter(S.app,"open-url",(h,l)=>({event:h,url:l})),({event:h,url:l})=>(h.preventDefault(),l));this.B(b(h=>{const l=this.g(h);l&&this.c.open(l,{originalUrl:h})})),v.getWindows().filter(h=>h.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(v.onDidSignalReadyWindow)(()=>this.h())))}g($){try{return P.URI.parse($)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const $=[];for(const p of this.a)await this.c.open(p.uri,{originalUrl:p.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",p.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",p.originalUrl),$.push(p));$.length!==0&&(this.a=$,(0,A.$Yg)(()=>this.h(),500,this.q))}}e.$$8b=d}),define(ne[270],re([0,1,3,2,16,57,31]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L9b=void 0;class P extends A.$Rc{constructor(a,$,p,v,f,y){super(),this.f=a,this.g=$,this.h=p,this.j=v,this.m=f,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$Qd),this.onDidChangeFile=this.a.event,this.b=M.$1h.forUris(()=>!(this.capabilities&1024)),this.c=new C.$Ac(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(v.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,$){return this.g.open(this.t(a),$)}close(a){return this.g.close(a)}read(a,$,p,v,f){return this.g.read(a,$,p,v,f)}write(a,$,p,v,f){return this.g.write(a,$,p,v,f)}watch(a,$){this.b.set(a,a);const p=this.g.watch(this.t(a),$);return(0,A.$Pc)(()=>{this.b.delete(a),p.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,$,p){return this.g.rename(this.t(a),this.t($),p)}readFile(a,$){return this.g.readFile(this.t(a),$)}readFileStream(a,$,p){return this.g.readFileStream(this.t(a),$,p)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,$,p){return this.g.writeFile(this.t(a),$,p)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,$){return this.g.delete(this.t(a),$)}copy(a,$,p){if((0,s.$hk)(this.g))return this.g.copy(this.t(a),this.t($),p);throw new Error("copy not supported")}cloneFile(a,$){if((0,s.$ik)(this.g))return this.g.cloneFile(this.t(a),this.t($));throw new Error("clone not supported")}s(a){const $=[];for(const p of a){if(p.resource.scheme!==this.f)continue;const v=this.u(p.resource);this.b.findSubstr(v)&&$.push({resource:v,type:p.type,cId:p.cId})}$.length&&(this.n.debug("User data changed"),this.a.fire($))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$L9b=P}),define(ne[271],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s9b=void 0,e.$s9b="utilityProcessWorker"}),define(ne[272],re([0,1,6]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_8b=void 0,e.$_8b=(0,S.$Uh)("webviewManagerService")}),define(ne[273],re([0,1,15,2,13,7]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a9b=void 0;class C extends A.$Rc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const d=this.b.bind(this);S.protocol.registerFileProtocol(s.Schemas.vscodeWebview,d)}b(d,a){try{const $=M.URI.parse(d.url),p=C.a.get($.path);if(typeof p=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${p}`,f=s.$fg.asFileUri(v);return a({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(d.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return a({error:-10})}catch{}return a({error:-2})}}e.$a9b=C}),define(ne[60],re([0,1,4]),function(J,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=e.$sC=e.$rC=e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=e.$lC=void 0,e.$lC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(p){return typeof p.parentId=="number"}e.$mC=A;function s(p){return!!p.workspaceUri}e.$nC=s;function M(p){return!!p.folderUri}e.$oC=M;function C(p){return!!p.fileUri}e.$pC=C;function P(p){const v=d(p),f=p.getValue("window.menuBarVisibility");return f==="default"||v==="native"&&f==="compact"||S.$j&&S.$m?"classic":f}e.$qC=P;function d(p){if(S.$o)return"custom";const v=p.getValue("window");if(v){if(S.$j&&v.nativeTabs===!0||S.$j&&v.nativeFullScreen===!1)return"native";const w=v.titleBarStyle;if(w==="native"||w==="custom")return w}return S.$k?"native":"custom"}e.$rC=d;function a(p){return!(!S.$i||S.$o||d(p)==="native")}e.$sC=a;function $(p=0){return Math.pow(1.2,p)}e.$tC=$}),define(ne[128],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$B7b=e.UnloadReason=e.LoadReason=void 0;var S;(function(P){P[P.INITIAL=1]="INITIAL",P[P.LOAD=2]="LOAD",P[P.RELOAD=3]="RELOAD"})(S||(e.LoadReason=S={}));var A;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(A||(e.UnloadReason=A={}));const s=function(P=1){return{width:1024,height:768,mode:P}};e.$B7b=s;var M;(function(P){P[P.Maximized=0]="Maximized",P[P.Normal=1]="Normal",P[P.Minimized=2]="Minimized",P[P.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var C;(function(P){P[P.UNRESPONSIVE=1]="UNRESPONSIVE",P[P.PROCESS_GONE=2]="PROCESS_GONE",P[P.LOAD=3]="LOAD"})(C||(e.WindowError=C={}))}),define(ne[274],re([0,1,8,3,2]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g9b=void 0;class M extends s.$Rc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:d,getActiveWindowId:a}){super(),this.a=this.B(new s.$Qc),A.Event.latch(A.Event.any(P,d))(this.f,this,this.a),this.b=(0,S.$Kg)(()=>a()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$g9b=M}),define(ne[30],re([0,1,192,9,57,19,7,6,13]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.WorkbenchState=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0,e.$4h=(0,P.$Uh)("contextService");function a(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.uri)}e.$5h=a;function $(t){return typeof t?.id=="string"&&!a(t)&&!v(t)}e.$6h=$,e.$7h={id:"ext-dev"},e.$8h={id:"empty-window"};function p(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,A.$mc)(t)}:n?e.$7h:e.$8h;const c=t;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.$9h=p;function v(t){const n=t;return typeof n?.id=="string"&&C.URI.isUri(n.configPath)}e.$0h=v;function f(t){const n=t;if(n?.uri)return{id:n.id,uri:C.URI.revive(n.uri)};const c=t;if(c?.configPath)return{id:c.id,configPath:C.URI.revive(c.configPath)};if(t?.id)return{id:t.id}}e.$$h=f;var y;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function w(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$_h=w;function b(t){const n=t;return!!(n&&typeof n=="object"&&C.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$ai=b;class g{constructor(n,c,m,D,R){this.h=n,this.j=m,this.k=D,this.l=R,this.c=s.$1h.forUris(this.l,()=>!0),this.folders=c}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$1h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$bi=g;class h{constructor(n,c){this.raw=c,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$yg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ci=h;function l(t){return new h({uri:t,index:0,name:(0,M.$ug)(t)},{uri:t.toString()})}e.$di=l,e.$ei="code-workspace",e.$fi=`.${e.$ei}`,e.$gi=[{name:(0,S.localize)(0,null),extensions:[e.$ei]}],e.$hi="workspace.json";function E(t,n){return M.$pg.isEqualOrParent(t,n.untitledWorkspacesHome)}e.$ii=E;function u(t){let n;return C.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===d.Schemas.tmp}e.$ji=u,e.$ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$ki}e.$li=i;function o(t,n){return!E(t,n)&&!u(t)}e.$mi=o;function r(t){return(typeof t=="string"?(0,A.$nc)(t):(0,M.$wg)(t))===e.$fi}e.$ni=r}),define(ne[52],re([0,1,15,8,56,46,2,85,4,21,167,115,6,5,25,30]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=e.$W7b=void 0,e.$W7b=(0,v.$Uh)("dialogMainService");let b=class{constructor(h,l){this.d=h,this.e=l,this.a=new Map,this.b=new Map,this.c=new A.$4g}pickFileFolder(h,l){return this.f({...h,pickFolders:!0,pickFiles:!0,title:(0,$.localize)(0,null)},l)}pickFolder(h,l){return this.f({...h,pickFolders:!0,title:(0,$.localize)(1,null)},l)}pickFile(h,l){return this.f({...h,pickFiles:!0,title:(0,$.localize)(2,null)},l)}pickWorkspace(h,l){const E=(0,$.localize)(3,null),u=(0,M.$Ev)((0,$.localize)(4,null)),i=w.$gi;return this.f({...h,pickFiles:!0,title:E,filters:i,buttonLabel:u},l)}async f(h,l){const E={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(E.properties=void 0,h.pickFiles&&h.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),d.$j&&E.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(E,(l||S.BrowserWindow.getFocusedWindow())??void 0);if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}g(h){if(h){let l=this.b.get(h.id);return l||(l=new A.$4g,this.b.set(h.id,l)),l}else return this.c}showMessageBox(h,l){return this.g(l).queue(async()=>{const{options:E,buttonIndeces:u}=(0,p.$Lv)(h,this.e);let i;return l?i=await S.dialog.showMessageBox(l,E):i=await S.dialog.showMessageBox(E),{response:u[i.response],checkboxChecked:i.checkboxChecked}})}async showSaveDialog(h,l){const E=this.j(h,l);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(l).queue(async()=>{let u;return l?u=await S.dialog.showSaveDialog(l,h):u=await S.dialog.showSaveDialog(h),u.filePath=this.h(u.filePath),u})}finally{(0,C.$Mc)(E)}}h(h){return h&&d.$j&&(h=(0,P.$tl)(h)),h}i(h){return h.map(l=>this.h(l))}async showOpenDialog(h,l){h.defaultPath&&(await a.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const E=this.j(h,l);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(l).queue(async()=>{let u;return l?u=await S.dialog.showOpenDialog(l,h):u=await S.dialog.showOpenDialog(h),u.filePaths=this.i(u.filePaths),u})}finally{(0,C.$Mc)(E)}}j(h,l){if(!l)return C.$Rc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let E=this.a.get(l.id);E||(E=new Set,this.a.set(l.id,E));const u=(0,s.$Ii)(h);if(!E.has(u))return this.d.trace("[DialogMainService]: new file dialog lock created",h),E.add(u),(0,C.$Pc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),E?.delete(u),E?.size===0&&this.a.delete(l.id)})}};e.$X7b=b,e.$X7b=b=ve([te(0,f.$cj),te(1,y.$uj)],b)}),define(ne[275],re([0,1,3,2,77,30]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W8b=void 0;class C extends A.$Rc{static{this.a=100}constructor(d,a){super(),this.f=d,this.g=a,this.b=this.B(new S.$Qd),this.c=new Map,this.h(a.applicationStorage,this.b)}h(d,a){this.B(S.Event.debounce(d.onDidChangeStorage,($,p)=>($?$.push(p):$=[p],$),C.a)($=>{$.length&&a.fire(this.j($,d))}))}j(d,a){const $=new Map,p=new Set;return d.forEach(v=>{const f=a.get(v.key);typeof f=="string"?$.set(v.key,f):p.add(v.key)}),{changed:Array.from($.entries()),deleted:Array.from(p.values())}}listen(d,a,$){switch(a){case"onDidChangeStorage":{const p=$.profile?(0,s.$rh)($.profile):void 0;if(!p)return this.b.event;let v=this.c.get(p.id);return v||(v=this.B(new S.$Qd),this.h(this.g.profileStorage(p),v),this.c.set(p.id,v)),v.event}}throw new Error(`Event not found: ${a}`)}async call(d,a,$){const p=$.profile?(0,s.$rh)($.profile):void 0,v=(0,M.$$h)($.workspace),f=await this.m(p,v);switch(a){case"getItems":return Array.from(f.items.entries());case"updateItems":{const y=$;if(y.insert)for(const[w,b]of y.insert)f.set(w,b);y.delete?.forEach(w=>f.delete(w));break}case"optimize":return f.optimize();case"isUsed":{const y=$.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${a}`)}}async m(d,a){let $;a?$=this.g.workspaceStorage(a):d?$=this.g.profileStorage(d):$=this.g.applicationStorage;try{await $.init()}catch(p){this.f.error(`StorageIPC#init: Unable to init ${a?"workspace":d?"profile":"application"} storage due to ${p}`)}return $}}e.$W8b=C}),define(ne[41],re([0,1,56,3,2,19,7,189,37,16,6,5,30,31,40,8,32,27,12]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.ProfileResourceType=void 0;var l;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function E(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&C.URI.isUri(n.location)&&C.URI.isUri(n.globalStorageHome)&&C.URI.isUri(n.settingsResource)&&C.URI.isUri(n.keybindingsResource)&&C.URI.isUri(n.tasksResource)&&C.URI.isUri(n.snippetsHome)&&C.URI.isUri(n.extensionsResource))}e.$Ok=E,e.$Pk=(0,$.$Uh)("IUserDataProfilesService");function u(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:C.URI.revive(t.location).with({scheme:n}),globalStorageHome:C.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:C.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:C.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:C.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:C.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:C.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:C.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.$Qk=u;function i(t,n,c,m,D,R){return{id:t,name:n,location:c,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:R&&D?.useDefaultFlags?.globalState?R.globalStorageHome:(0,M.$yg)(c,"globalStorage"),settingsResource:R&&D?.useDefaultFlags?.settings?R.settingsResource:(0,M.$yg)(c,"settings.json"),keybindingsResource:R&&D?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,M.$yg)(c,"keybindings.json"),tasksResource:R&&D?.useDefaultFlags?.tasks?R.tasksResource:(0,M.$yg)(c,"tasks.json"),snippetsHome:R&&D?.useDefaultFlags?.snippets?R.snippetsHome:(0,M.$yg)(c,"snippets"),extensionsResource:R&&D?.useDefaultFlags?.extensions?R.extensionsResource:(0,M.$yg)(c,"extensions.json"),cacheHome:(0,M.$yg)(m,t),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$Rk=i;let o=class extends s.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,c,m,D){super(),this.t=n,this.u=c,this.w=m,this.y=D,this.f=!0,this.h=this.B(new A.$Qd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$Qd),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$Qd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$Qd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$zc,emptyWindows:new Map},this.profilesHome=(0,M.$yg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$yg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),c=[n];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,h.$Bf)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}c.push(i((0,M.$vg)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},n))}}catch(R){this.y.error(R)}const m=new f.$zc,D=new Map;if(c.length)try{const R=this.Q();if(R.workspaces)for(const[k,I]of Object.entries(R.workspaces)){const F=C.URI.parse(k),U=c.find(T=>T.id===I);U&&m.set(F,U)}if(R.emptyWindows)for(const[k,I]of Object.entries(R.emptyWindows)){const F=c.find(U=>U.id===I);F&&D.set(k,F)}}catch(R){this.y.error(R)}this.z={profiles:c,workspaces:m,emptyWindows:D}}return this.z}D(){const n=i("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const c="Temp",m=new RegExp(`${(0,g.$Ie)(c)}\\s(\\d+)`);let D=0;for(const k of this.profiles){const I=m.exec(k.name),F=I?parseInt(I[1]):0;D=F>D?F:D}const R=`${c} ${D+1}`;return this.createProfile((0,S.$Ii)((0,b.$hg)()).toString(16),R,{transient:!0},n)}async createNamedProfile(n,c,m){return this.createProfile((0,S.$Ii)((0,b.$hg)()).toString(16),n,c,m)}async createProfile(n,c,m,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(n,c,m);return D&&await this.setProfileForWorkspace(D,R),R}async F(n,c,m){if(!(0,h.$Bf)(c)||!c)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(c);return D||(D=(async()=>{try{const R=this.profiles.find(F=>F.name===c||F.id===n);if(R)return R;const k=i(n,c,(0,M.$yg)(this.profilesHome,n),this.g,m,this.defaultProfile);await this.u.createFolder(k.location);const I=[];return this.j.fire({profile:k,join(F){I.push(F)}}),await w.Promises.settled(I),this.I([k],[],[]),k}finally{this.r.delete(c)}})(),this.r.set(c,D)),D}async updateProfile(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(D=>D.id===n.id);if(!m)throw new Error(`Profile '${n.name}' does not exist`);return m=i(m.id,c.name??m.name,m.location,this.g,{shortName:c.shortName??m.shortName,icon:c.icon===null?void 0:c.icon??m.icon,transient:c.transient??m.isTransient,useDefaultFlags:c.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.I([],[],[m]),m}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const c=this.profiles.find(D=>D.id===n.id);if(!c)throw new Error(`Profile '${n.name}' does not exist`);const m=[];this.m.fire({profile:c,join(D){m.push(D)}});try{await Promise.allSettled(m)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])c.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])c.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[c],[]);try{await this.u.del(c.cacheHome,{recursive:!0})}catch(D){(0,a.$uk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(D=>D.id===c.id);if(!m)throw new Error(`Profile '${c.name}' does not exist`);this.L(n,m)}unsetWorkspace(n,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,c)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(c=>c.isDirectory&&this.profiles.every(m=>!this.w.extUri.isEqual(m.location,c.resource))).map(c=>this.u.del(c.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(c=>!this.H(c));await Promise.allSettled(n.map(c=>this.removeProfile(c)))}getProfileForWorkspace(n){const c=this.G(n);return C.URI.isUri(c)?this.s.workspaces.get(c)??this.C.workspaces.get(c):this.s.emptyWindows.get(c)??this.C.emptyWindows.get(c)}G(n){return(0,v.$5h)(n)?n.uri:(0,v.$0h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.s.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.C.emptyWindows.values()].some(c=>this.w.extUri.isEqual(c.location,n.location))||[...this.C.workspaces.values()].some(c=>this.w.extUri.isEqual(c.location,n.location)))}I(n,c,m){const D=[...this.profiles,...n],R=[];this.s.profiles=[];for(let k of D)k.isDefault||c.some(I=>k.id===I.id)||(k=m.find(I=>k.id===I.id)??k,k.isTransient?this.s.profiles.push(k):R.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(R),this.z=void 0,this.J(n,c,m)}J(n,c,m){this.h.fire({added:n,removed:c,updated:m,all:this.profiles})}L(n,c,m){m=c?.isTransient?!0:m,m||this.L(n,void 0,!0);const D=this.G(n),R=m?this.s:this.C;C.URI.isUri(D)?(R.workspaces.delete(D),c&&R.workspaces.set(D,c)):(R.emptyWindows.delete(D),c&&R.emptyWindows.set(D,c)),m||this.M()}M(){const n={};for(const[m,D]of this.C.workspaces.entries())n[m.toString()]=D.id;const c={};for(const[m,D]of this.C.emptyWindows.entries())c[m.toString()]=D.id;this.R({workspaces:n,emptyWindows:c}),this.z=void 0}N(n){const c={},m=this.D();if(n.workspaces)for(const[R,k]of Object.entries(n.workspaces)){const I=C.URI.parse(k);c[R]=this.w.extUri.isEqual(I,m.location)?m.id:this.w.extUri.basename(I)}const D={};if(n.emptyWindows)for(const[R,k]of Object.entries(n.emptyWindows)){const I=C.URI.parse(k);D[R]=this.w.extUri.isEqual(I,m.location)?m.id:this.w.extUri.basename(I)}return{workspaces:c,emptyWindows:D}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Sk=o,e.$Sk=o=ve([te(0,d.$2h),te(1,a.$dk),te(2,y.$Nk),te(3,p.$cj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Tk=r}),define(ne[81],re([0,1,8,18,2,3,31,7,117,123,16,6,5,41,40,12,14,26]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class l extends Error{constructor(r,t){super(r),this.code=t}}e.$yp=l,e.$zp=(0,p.$Uh)("IExtensionsProfileScannerService");let E=class extends s.$Rc{constructor(r,t,n,c,m,D){super(),this.j=r,this.m=t,this.n=n,this.r=c,this.s=m,this.t=D,this.b=this.B(new M.$Qd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Qd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Qd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Qd),this.onDidRemoveExtensions=this.g.event,this.h=new C.$zc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t){const n=[],c=[];try{return await this.u(t,m=>{const D=[];for(const R of m)r.some(([k])=>(0,a.$Eo)(k.identifier,R.identifier)&&k.manifest.version!==R.version)?n.push(R):D.push(R);for(const[R,k]of r){const I=D.findIndex(U=>(0,a.$Eo)(U.identifier,R.identifier)&&U.version===R.manifest.version),F={identifier:R.identifier,version:R.manifest.version,location:R.location,metadata:k};I===-1?(c.push(F),D.push(F)):D.splice(I,1,F)}return c.length&&this.b.fire({extensions:c,profileLocation:t}),n.length&&this.f.fire({extensions:n,profileLocation:t}),D}),c.length&&this.c.fire({extensions:c,profileLocation:t}),n.length&&this.g.fire({extensions:n,profileLocation:t}),c}catch(m){throw c.length&&this.c.fire({extensions:c,error:m,profileLocation:t}),n.length&&this.g.fire({extensions:n,error:m,profileLocation:t}),m}}async updateMetadata(r,t){const n=[];return await this.u(t,c=>{const m=[];for(const D of c){const R=r.find(([k])=>(0,a.$Eo)(k.identifier,D.identifier)&&k.manifest.version===D.version);R&&(D.metadata={...D.metadata,...R[1]},n.push(D)),m.push(D)}return m}),n}async removeExtensionFromProfile(r,t){const n=[];try{await this.u(t,c=>{const m=[];for(const D of c)(0,a.$Eo)(D.identifier,r.identifier)?n.push(D):m.push(D);return n.length&&this.f.fire({extensions:n,profileLocation:t}),m}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(c){throw n.length&&this.g.fire({extensions:n,error:c,profileLocation:t}),c}}async u(r,t,n){return this.F(r).queue(async()=>{let c=[],m;try{const D=await this.m.readFile(r);m=JSON.parse(D.value.toString().trim()||"[]")}catch(D){if((0,$.$uk)(D)!==1)throw D;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(m=await this.D()),!m&&n?.bailOutWhenFileNotFound)throw new l((0,b.$9)(D),"ERROR_PROFILE_NOT_FOUND")}if(m){Array.isArray(m)||this.w(r);let D=!1;for(const R of m){u(R)||this.w(r);let k;if((0,w.$Bf)(R.relativeLocation)&&R.relativeLocation)k=this.z(R.relativeLocation);else if((0,w.$Bf)(R.location))k=this.z(R.location),D=!0,R.relativeLocation=R.location,R.location=k.toJSON();else{k=P.URI.revive(R.location);const I=this.y(k);I&&(D=!0,R.relativeLocation=I)}c.push({identifier:R.identifier,location:k,version:R.version,metadata:R.metadata})}D&&await this.m.writeFile(r,A.$ee.fromString(JSON.stringify(m)))}if(t){c=t(c);const D=c.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(r,A.$ee.fromString(JSON.stringify(D)))}return c})}w(r){const t=new l(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(m){if((0,$.$uk)(m)===1)return;throw m}this.t.info("Migrating extensions from old default profile location",r.toString());let c;try{const m=JSON.parse(n);Array.isArray(m)&&m.every(D=>u(D))?c=m:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",m)}catch(m){this.t.error(m)}if(c)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$ee.fromString(JSON.stringify(c)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(m){if((0,$.$uk)(m)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw m}try{await this.m.del(r)}catch(m){(0,$.$uk)(m)!==1&&this.t.error(m)}try{await this.m.del(t)}catch(m){(0,$.$uk)(m)!==1&&this.t.error(m)}return c})()),this.C}F(r){let t=this.h.get(r);return t||(t=new S.$4g,this.h.set(r,t)),t}};e.$Ap=E,e.$Ap=E=ve([te(1,$.$dk),te(2,f.$Pk),te(3,y.$Nk),te(4,g.$hl),te(5,v.$cj)],E);function u(o){return(0,w.$Df)(o)&&(0,d.$bo)(o.identifier)&&(i(o.location)||(0,w.$Bf)(o.location)&&o.location)&&((0,w.$If)(o.relativeLocation)||(0,w.$Bf)(o.relativeLocation))&&o.version&&(0,w.$Bf)(o.version)}function i(o){return o?(0,w.$Bf)(o.path)&&(0,w.$Bf)(o.scheme):!1}}),define(ne[129],re([0,1,23,8,38,18,14,44,152,2,13,9,4,19,205,74,12,7,172,37,123,120,204,16,6,5,25,3,77,81,41,40,203]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u,i,o,r,t,n,c,m,D,R,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.Translations=void 0;var F;(function(ae){function Z(K,G){if(K===G)return!0;const z=Object.keys(K),N=new Set;for(const H of Object.keys(G))N.add(H);if(z.length!==N.size)return!1;for(const H of z){if(K[H]!==G[H])return!1;N.delete(H)}return N.size===0}ae.equals=Z})(F||(e.Translations=F={})),e.$Dp=(0,r.$Uh)("IExtensionsScannerService");let U=class extends a.$Rc{constructor(Z,K,G,z,N,H,q,ee,se,Q,O,j){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=K,this.r=G,this.s=z,this.t=N,this.u=H,this.w=q,this.y=ee,this.z=se,this.C=Q,this.D=O,this.F=j,this.g=this.B(new c.$Qd),this.onDidChangeCache=this.g.event,this.h=(0,f.$yg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(Y,this.s,this.h)),this.m=this.B(this.F.createInstance(Y,this.s,this.h)),this.n=this.B(this.F.createInstance(x,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Po)(this.w,this.y)),this.G}async scanAllExtensions(Z,K,G){const[z,N]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(K)]),H=G?await this.scanExtensionsUnderDevelopment(Z,[...z,...N]):[];return this.L(z,N,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const K=[];K.push(this.M(!!Z.useCache,Z.language)),K.push(this.N(Z.language,!!Z.checkControlFile));const[G,z]=await Promise.all(K);return this.J([...G,...z],0,Z,!1)}async scanUserExtensions(Z){const K=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",K);const G=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(K,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,G),N=Z.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let H;try{H=await N.scanExtensions(z)}catch(q){if(q instanceof D.$yp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await N.scanExtensions(z);else throw q}return H=await this.J(H,1,Z,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(Z,K){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===$.Schemas.file).map(async z=>{const N=await this.P(z,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(N)).map(q=>(q.type=K.find(ee=>(0,E.$Eo)(ee.identifier,q.identifier))?.type??q.type,this.n.validate(q,N)))}))).flat();return this.J(G,"development",Z,!0)}return[]}async scanExistingExtension(Z,K,G){const z=await this.P(Z,!1,K,!0,G.language,!0,void 0),N=await this.n.scanExtension(z);return!N||!G.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(Z,K,G){const z=await this.P(Z,!1,K,!0,G.language,!0,void 0),N=await this.n.scanOneOrMultipleExtensions(z);return this.J(N,K,G,!0)}async scanMetadata(Z){const K=(0,f.$yg)(Z,"package.json"),G=(await this.w.readFile(K)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(Z,K){const G=(0,f.$yg)(Z,"package.json"),z=(await this.w.readFile(G)).value.toString(),N=JSON.parse(z);K.isMachineScoped===!1&&delete K.isMachineScoped,K.isBuiltin===!1&&delete K.isBuiltin,N.__metadata={...N.__metadata,...K},await this.w.writeFile((0,f.$yg)(Z,"package.json"),M.$ee.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof D.$yp&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(K=>[K,K.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$ee.fromString(JSON.stringify([])))}catch(K){(0,o.$uk)(K)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.$9)(K))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,K,G,z){return G.includeAllVersions||(Z=this.L(K===0?Z:void 0,K===1?Z:void 0,K==="development"?Z:void 0,await this.getTargetPlatform(),z)),G.includeInvalid||(Z=Z.filter(N=>N.isValid)),Z.sort((N,H)=>{const q=p.$mc(N.location.fsPath),ee=p.$mc(H.location.fsPath);return q<ee?-1:q>ee?1:0})}L(Z,K,G,z,N){const H=(ee,se,Q)=>{if(ee.isValid&&!se.isValid)return!1;if(ee.isValid===se.isValid){if(N&&y.gt(ee.manifest.version,se.manifest.version))return this.y.debug(`Skipping extension ${se.location.path} with lower version ${se.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(y.eq(ee.manifest.version,se.manifest.version)){if(ee.type===0)return this.y.debug(`Skipping extension ${se.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===z)return this.y.debug(`Skipping extension ${se.location.path} from different target platform ${se.targetPlatform}`),!1}}return Q?this.y.warn(`Overwriting user extension ${ee.location.path} with ${se.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${se.location.path}.`),!0},q=new u.$am;return Z?.forEach(ee=>{const se=q.get(ee.identifier.id);(!se||H(se,ee,!1))&&q.set(ee.identifier.id,ee)}),K?.forEach(ee=>{const se=q.get(ee.identifier.id);if(!se&&Z&&ee.type===0){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!se||H(se,ee,!1))&&q.set(ee.identifier.id,ee)}),G?.forEach(ee=>{const se=q.get(ee.identifier.id);(!se||H(se,ee,!0))&&q.set(ee.identifier.id,ee),q.set(ee.identifier.id,ee)}),[...q.values()]}async M(Z,K){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,K,!0,void 0),N=await(Z&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",N.length),N}async N(Z,K){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const z=K?await this.O():{},N=[],H=g.URI.file(p.$gc(p.$ic($.$fg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of G){const se=z[ee.name]||"marketplace";switch(se){case"disabled":break;case"marketplace":N.push((0,f.$yg)(H,ee.name));break;default:N.push(g.URI.file(se));break}}const q=await Promise.all(N.map(async ee=>this.n.scanExtension(await this.P(ee,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",q.length),(0,S.$Gb)(q)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,K,G,z,N,H,q){const ee=await this.f(N??v.$w),se=await this.Q(Z),Q=K&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=Q?await this.Q(Q):void 0;return new T(Z,se,Q,O,K,q,G,z,H,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,N,ee)}async Q(Z){try{const K=await this.w.stat(Z);if(typeof K.mtime=="number")return K.mtime}catch{}}};e.$Ep=U,e.$Ep=U=ve([te(4,R.$Pk),te(5,D.$zp),te(6,o.$dk),te(7,t.$cj),te(8,l.$2h),te(9,n.$uj),te(10,k.$Nk),te(11,r.$Th)],U);class T{constructor(Z,K,G,z,N,H,q,ee,se,Q,O,j,V,L,B){this.location=Z,this.mtime=K,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=z,this.profile=N,this.profileScanOptions=H,this.type=q,this.excludeObsolete=ee,this.validate=se,this.productVersion=Q,this.productDate=O,this.productCommit=j,this.devMode=V,this.language=L,this.translations=B}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,K){return(0,f.$rg)(Z.location,K.location)&&Z.mtime===K.mtime&&(0,f.$rg)(Z.applicationExtensionslocation,K.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===K.applicationExtensionslocationMtime&&Z.profile===K.profile&&s.$dn(Z.profileScanOptions,K.profileScanOptions)&&Z.type===K.type&&Z.excludeObsolete===K.excludeObsolete&&Z.validate===K.validate&&Z.productVersion===K.productVersion&&Z.productDate===K.productDate&&Z.productCommit===K.productCommit&&Z.devMode===K.devMode&&Z.language===K.language&&F.equals(Z.translations,K.translations)}}e.$Fp=T;let x=class extends a.$Rc{constructor(Z,K,G,z,N){super(),this.f=Z,this.g=K,this.h=G,this.j=z,this.m=N}async scanExtensions(Z){const K=Z.profile?await this.r(Z):await this.n(Z);let G={};if(Z.excludeObsolete&&Z.type===1)try{const z=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(z)}catch{}return(0,b.$Of)(G)?K:K.filter(z=>!G[E.$Fo.create(z).toString()])}async n(Z){const K=await this.j.resolve(Z.location);if(!K.children?.length)return[];const G=await Promise.all(K.children.map(async z=>{if(!z.isDirectory||Z.type===1&&(0,f.$vg)(z.resource).indexOf(".")===0)return null;const N=new T(z.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(N)}));return(0,S.$Gb)(G).sort((z,N)=>z.location.path<N.location.path?-1:1)}async r(Z){let K=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){K=K.filter(z=>!z.metadata?.isApplicationScoped);const G=await this.s(Z.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,Z);K.push(...G)}return K}async s(Z,K,G){const z=await this.g.scanProfileExtensions(Z,G.profileScanOptions);if(!z.length)return[];const N=await Promise.all(z.map(async H=>{if(K(H)){const q=new T(H.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(q,H.metadata)}return null}));return(0,S.$Gb)(N)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,f.$yg)(Z.location,"package.json"))){const K=await this.scanExtension(Z);return K?[K]:[]}else return await this.scanExtensions(Z)}catch(K){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,C.$9)(K)),[]}}async scanExtension(Z,K){try{let G=await this.scanExtensionManifest(Z.location);if(G){G.publisher||(G.publisher=u.$7l),K=K??G.__metadata,delete G.__metadata;const z=(0,E.$Jo)(G.publisher,G.name),N=K?.id?{id:z,uuid:K.id}:{id:z},H=K?.isSystem?0:Z.type,q=H===0||!!K?.isBuiltin;G=await this.t(Z.location,G,T.createNlsConfiguration(Z));const ee={type:H,identifier:N,manifest:G,location:Z.location,isBuiltin:q,targetPlatform:K?.targetPlatform??"undefined",metadata:K,isValid:!0,validations:[]};return Z.validate?this.validate(ee,Z):ee}}catch(G){Z.type!==0&&this.m.error(G)}return null}validate(Z,K){let G=!0;const z=(0,i.$Uo)(K.productVersion,K.productDate,K.location,Z.manifest,Z.isBuiltin);for(const[N,H]of z)N===w.default.Error&&(G=!1,this.m.error(this.z(K.location,H)));return Z.isValid=G,Z.validations=z,Z}async scanExtensionManifest(Z){const K=(0,f.$yg)(Z,"package.json");let G;try{G=(await this.j.readFile(K)).value.toString()}catch(N){return(0,o.$uk)(N)!==1&&this.m.error(this.z(Z,(0,h.localize)(0,null,K.path,N.message))),null}let z;try{z=JSON.parse(G)}catch{const H=[];(0,P.$2m)(G,H);for(const q of H)this.m.error(this.z(Z,(0,h.localize)(1,null,K.path,q.offset,q.length,(0,d.$Bp)(q.error))));return null}return(0,P.$$m)(z)!=="object"?(this.m.error(this.z(Z,(0,h.localize)(2,null,K.path))),null):z}async t(Z,K,G){const z=await this.u(Z,K,G);if(z)try{const N=[],H=await this.w(z.default,N);if(N.length>0)return N.forEach(ee=>{this.m.error(this.z(Z,(0,h.localize)(3,null,z.default?.path,(0,d.$Bp)(ee.error))))}),K;if((0,P.$$m)(z)!=="object")return this.m.error(this.z(Z,(0,h.localize)(4,null,z.default?.path))),K;const q=z.values||Object.create(null);return(0,I.$Cp)(this.m,K,q,H)}catch{}return K}async u(Z,K,G){const z=(0,f.$yg)(Z,"package.nls.json"),N=(se,Q)=>{Q.forEach(O=>{this.m.error(this.z(Z,(0,h.localize)(5,null,se?.path,(0,d.$Bp)(O.error))))})},H=se=>{this.m.error(this.z(Z,(0,h.localize)(6,null,se?.path)))},q=`${K.publisher}.${K.name}`,ee=G.translations[q];if(ee)try{const se=g.URI.file(ee),Q=(await this.j.readFile(se)).value.toString(),O=[],j=(0,P.$2m)(Q,O);return O.length>0?(N(se,O),{values:void 0,default:z}):(0,P.$$m)(j)!=="object"?(H(se),{values:void 0,default:z}):{values:j.contents?j.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.j.exists(z))return;let Q;try{Q=await this.y(Z,G)}catch{return}if(!Q.localized)return{values:void 0,default:Q.original};try{const O=(await this.j.readFile(Q.localized)).value.toString(),j=[],V=(0,P.$2m)(O,j);return j.length>0?(N(Q.localized,j),{values:void 0,default:Q.original}):(0,P.$$m)(V)!=="object"?(H(Q.localized),{values:void 0,default:Q.original}):{values:V,default:Q.original}}catch{return{values:void 0,default:Q.original}}}}async w(Z,K){if(Z)try{const G=(await this.j.readFile(Z)).value.toString();return(0,P.$2m)(G,K)}catch{}}y(Z,K){return new Promise((G,z)=>{const N=H=>{const q=(0,f.$yg)(Z,`package.nls.${H}.json`);this.j.exists(q).then(ee=>{ee&&G({localized:q,original:(0,f.$yg)(Z,"package.nls.json")});const se=H.lastIndexOf("-");se===-1?G({localized:(0,f.$yg)(Z,"package.nls.json"),original:null}):(H=H.substring(0,se),N(H))})};if(K.devMode||K.pseudo||!K.language)return G({localized:(0,f.$yg)(Z,"package.nls.json"),original:null});N(K.language)})}z(Z,K){return`[${Z.path}]: ${K}`}};x=ve([te(1,D.$zp),te(2,k.$Nk),te(3,o.$dk),te(4,t.$cj)],x);let Y=class extends x{constructor(Z,K,G,z,N,H,q){super(K,z,N,H,q),this.G=Z,this.H=G,this.D=this.B(new A.$Ug(3e3)),this.F=this.B(new c.$Qd),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const K=this.M(Z),G=await this.I(K);if(this.C=Z,G&&G.input&&T.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),G.result.map(N=>(N.location=g.URI.revive(N.location),N));const z=await super.scanExtensions(Z);return await this.J(K,{input:Z,result:z}),z}async I(Z){try{const K=await this.j.readFile(Z),G=JSON.parse(K.value.toString());return{result:G.result,input:(0,m.$rh)(G.input)}}catch(K){this.m.debug("Error while reading the extension cache file:",Z.path,(0,C.$9)(K))}return null}async J(Z,K){try{await this.j.writeFile(Z,M.$ee.fromString(JSON.stringify(K)))}catch(G){this.m.debug("Error while writing the extension cache file:",Z.path,(0,C.$9)(G))}}async L(){if(!this.C)return;const Z=this.M(this.C),K=await this.I(Z);if(!K)return;const G=K.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$dn(z,G))try{this.m.info("Invalidating Cache",G,z),await this.j.del(Z),this.F.fire()}catch(N){this.m.error(N)}}M(Z){const K=this.N(Z);return this.h.extUri.joinPath(K.cacheHome,Z.type===0?u.$6l:u.$5l)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(K=>this.h.extUri.isEqual(Z.location,K.extensionsResource))??this.G:this.H.defaultProfile}};Y=ve([te(2,R.$Pk),te(3,D.$zp),te(4,k.$Nk),te(5,o.$dk),te(6,t.$cj)],Y);function ce(ae,Z){const K=(0,E.$Ho)(ae.manifest.publisher,ae.manifest.name);return{id:K,identifier:new u.$$l(K),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:Z,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$Gp=ce;class oe extends U{constructor(Z,K,G,z,N,H,q,ee,se,Q,O,j){super(Z,K,(0,f.$yg)(G,".vscode-oss-dev","extensions","control.json"),z,N,H,q,ee,se,Q,O,j),this.R=(async()=>{if(v.$z)try{const V=await this.w.readFile(g.URI.file(v.$z));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$Hp=oe}),define(ne[276],re([0,1,5,41,40,26,81,16,37,7]),function(J,e,S,A,s,M,C,P,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=void 0;let $=class extends C.$Ap{constructor(v,f,y,w,b,g){super(a.URI.file(v.extensionsPath),f,y,w,b,g)}};e.$XN=$,e.$XN=$=ve([te(0,d.$3h),te(1,P.$dk),te(2,A.$Pk),te(3,s.$Nk),te(4,M.$hl),te(5,S.$cj)],$)}),define(ne[277],re([0,1,7,37,81,129,16,6,5,25,40,41]),function(J,e,S,A,s,M,C,P,d,a,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k9b=void 0;let v=class extends M.$Hp{constructor(y,w,b,g,h,l,E,u){super(S.URI.file(h.builtinExtensionsPath),S.URI.file(h.extensionsPath),h.userHome,y.defaultProfile,y,w,b,g,h,l,E,u)}};e.$k9b=v,e.$k9b=v=ve([te(0,p.$Pk),te(1,s.$zp),te(2,C.$dk),te(3,d.$cj),te(4,A.$3h),te(5,a.$uj),te(6,$.$Nk),te(7,P.$Th)],v)}),define(ne[278],re([0,1,15,2,13,9,4,57,7,32,36,37,5,41]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C9b=void 0;let y=class extends A.$Rc{constructor(b,g,h){super(),this.c=b,this.f=h,this.a=P.$1h.forPaths(!C.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(b.appRoot),this.addValidFileRoot(b.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(b.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:b}=S.session;b.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,h)=>this.j(g,h)),b.protocol.interceptFileProtocol(s.Schemas.file,(g,h)=>this.h(g,h)),this.B((0,A.$Pc)(()=>{b.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),b.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(b){const g=(0,M.$gc)(b);return this.a.get(g)?A.$Rc.None:(this.a.set(g,!0),(0,A.$Pc)(()=>this.a.delete(g)))}h(b,g){const h=d.URI.parse(b.url);return this.f.error(`Refused to load resource ${h.fsPath} from ${s.Schemas.file}: protocol (original URL: ${b.url})`),g({error:-3})}j(b,g){const h=this.m(b);let l;return this.c.crossOriginIsolated&&((0,M.$mc)(h)==="workbench.html"||(0,M.$mc)(h)==="workbench-dev.html"?l=s.COI.CoopAndCoep:l=s.COI.getHeadersFromQuery(b.url)),this.a.findSubstr(h)?g({path:h,headers:l}):this.b.has((0,M.$nc)(h).toLowerCase())?g({path:h}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${b.url})`),g({error:-3}))}m(b){const g=d.URI.parse(b.url),h=s.$fg.uriToFileUri(g);return(0,M.$gc)(h.fsPath)}createIPCObjectUrl(){let b;const g=d.URI.from({scheme:"vscode",path:(0,a.$hg)()}),h=g.toString(),l=async()=>b;return $.$UT.handle(h,l),this.f.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:g,update:E=>b=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${h}.`),$.$UT.removeHandler(h)}}}};e.$C9b=y,e.$C9b=y=ve([te(0,p.$3h),te(1,f.$Pk),te(2,v.$cj)],y)}),define(ne[96],re([0,1,8,3,2,67,12,111,6,41]),function(J,e,S,A,s,M,C,P,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$$o=e.$0o=e.$9o=void 0,e.$9o="__$__isNewStorageMarker",e.$0o="__$__targetStorageMarker",e.$$o=(0,d.$Uh)("storageService");var $;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})($||(e.WillSaveStateReason=$={}));var p;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var v;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function f(h){const l=h.get(e.$0o);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.$_o=f;class y extends s.$Rc{static{this.a=60*1e3}constructor(l={flushInterval:y.a}){super(),this.m=l,this.b=this.B(new A.$Td),this.c=this.B(new A.$Td),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$Qd),this.onWillSaveState=this.f.event,this.h=this.B(new S.$9g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,E,u){return A.Event.filter(this.b.event,i=>i.scope===l&&(E===void 0||i.key===E),u)}n(){this.j.value=(0,S.$ah)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,E){const{key:u,external:i}=E;if(u===e.$0o){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:u,target:this.J(l)[u],external:i})}w(l){this.f.fire({reason:l})}get(l,E,u){return this.P(E)?.get(l,u)}getBoolean(l,E,u){return this.P(E)?.getBoolean(l,u)}getNumber(l,E,u){return this.P(E)?.getNumber(l,u)}getObject(l,E,u){return this.P(E)?.getObject(l,u)}storeAll(l,E){this.y(()=>{for(const u of l)this.store(u.key,u.value,u.scope,u.target,E)})}store(l,E,u,i,o=!1){if((0,C.$Kf)(E)){this.remove(l,u,o);return}this.y(()=>{this.z(l,u,i),this.P(u)?.set(l,E,o)})}remove(l,E,u=!1){this.y(()=>{this.z(l,E,void 0),this.P(E)?.delete(l,u)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,E){const u=[],i=this.J(l);for(const o of Object.keys(i))i[o]===E&&u.push(o);return u}z(l,E,u,i=!1){const o=this.J(E);typeof u=="number"?o[l]!==u&&(o[l]=u,this.P(E)?.set(e.$0o,JSON.stringify(o),i)):typeof o[l]=="number"&&(delete o[l],this.P(E)?.set(e.$0o,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const E=this.P(l);return E?f(E):Object.create(null)}isNew(l){return this.getBoolean(e.$9o,l)===!0}async flush(l=$.NONE){this.f.fire({reason:l});const E=this.P(-1),u=this.P(0),i=this.P(1);switch(l){case $.NONE:await S.Promises.settled([E?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case $.SHUTDOWN:await S.Promises.settled([E?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return g(l,E,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,E){return this.w($.NONE),(0,a.$Ok)(l)?this.R(l,E):this.S(l,E)}M(l,E){return!(l.id===E.id||w(E)&&w(l))}N(l,E,u){this.y(()=>{const i=new Set;for(const[o,r]of l)i.add(o),E.get(o)!==r&&this.u(u,{key:o,external:!0});for(const[o]of E.items)i.has(o)||this.u(u,{key:o,external:!0})})}}e.$ap=y;function w(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$bp=w;class b extends y{constructor(){super(),this.U=this.B(new P.$7o(new P.$8o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$7o(new P.$8o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$7o(new P.$8o,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$cp=b;async function g(h,l,E,u,i,o){const r=F=>{try{return JSON.parse(F)}catch{return F}},t=new Map,n=new Map;h.forEach((F,U)=>{t.set(U,F),n.set(U,r(F))});const c=new Map,m=new Map;l.forEach((F,U)=>{c.set(U,F),m.set(U,r(F))});const D=new Map,R=new Map;E.forEach((F,U)=>{D.set(U,F),R.set(U,r(F))}),console.group(u!==i?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const k=[];if(t.forEach((F,U)=>{k.push({key:U,value:F})}),console.table(k),console.groupEnd(),console.log(n),u!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const F=[];c.forEach((U,T)=>{F.push({key:T,value:U})}),console.table(F),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${o})`);const I=[];D.forEach((F,U)=>{I.push({key:U,value:F})}),console.table(I),console.groupEnd(),console.log(R)}e.$dp=g}),define(ne[279],re([0,1,23,8,3,2,9,73,7,21,111,161,5,96,26,30,13]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J7b=e.$I7b=e.$H7b=e.$G7b=void 0;class g extends M.$Rc{static{this.a=2e3}get storage(){return this.f}constructor(r,t){super(),this.m=r,this.n=t,this.b=this.B(new s.$Qd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Qd),this.onDidCloseStorage=this.c.event,this.f=this.B(new $.$7o(new $.$8o,{hint:$.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new A.$hh,this.whenInit=this.h.p,this.j=$.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===$.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const t=r.getBoolean(f.$9o);t===void 0?r.set(f.$9o,!0):t&&r.set(f.$9o,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=$.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===v.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,t){return this.f.get(r,t)}set(r,t){return this.f.set(r,t)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new P.$Md(!1);await this.w(),r.stop(),r.elapsed()>g.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const t=(0,S.top)(Array.from(this.f.items.entries()).map(([c,m])=>({key:c,length:m.length})),(c,m)=>m.length-c.length,5).map(c=>`${c.key}:${c.length}`).join(", "),n=(await this.n.stat(d.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${t}`)}catch(t){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",t)}}async w(){this.g&&await this.g,this.j=$.StorageState.Closed,await this.f.close()}}class h extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,C.$ic)(this.z.globalStorageHome.with({scheme:b.Schemas.file}).fsPath,h.y)}constructor(r,t,n,c){super(n,c),this.z=r,this.C=t}async t(){return new $.$7o(new p.$nU(this.path??p.$nU.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:$.StorageHint.STORAGE_IN_MEMORY})}}class l extends h{constructor(r,t,n,c){super(r,t,n,c)}}e.$G7b=l;class E extends h{constructor(r,t,n,c){super(t.defaultProfile,r,n,c)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$kl,void 0)===void 0&&r.set(y.$kl,new Date().toUTCString());const n=r.get(y.$jl,void 0),c=new Date().toUTCString();r.set(y.$ll,typeof n>"u"?null:n),r.set(y.$jl,c)}}e.$H7b=E;class u extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,C.$ic)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id,u.y)}constructor(r,t,n,c,m){super(n,m),this.C=r,this.D=t,this.F=c}async t(){const{storageFilePath:r,wasCreated:t}=await this.H();return new $.$7o(new p.$nU(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?$.StorageHint.STORAGE_IN_MEMORY:t?$.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:p.$nU.IN_MEMORY_PATH,wasCreated:!0};const r=(0,C.$ic)(this.F.workspaceStorageHome.with({scheme:b.Schemas.file}).fsPath,this.C.id),t=(0,C.$ic)(r,u.y);return await a.Promises.exists(r)?{storageFilePath:t,wasCreated:!1}:(await a.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:t,wasCreated:!0})}async I(r){let t;if((0,w.$5h)(this.C)?t={folder:this.C.uri.toString()}:(0,w.$0h)(this.C)&&(t={workspace:this.C.configPath.toString()}),t)try{const n=(0,C.$ic)(r,u.z);await a.Promises.exists(n)||await a.Promises.writeFile(n,JSON.stringify(t,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$I7b=u;class i extends g{get path(){}async t(){return new $.$7o(new $.$8o,{hint:$.StorageHint.STORAGE_IN_MEMORY})}}e.$J7b=i}),define(ne[280],re([0,1,3,2,96]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m9b=void 0;class M extends A.$Rc{constructor(P,d,a){super(),this.b=P,this.c=d,this.f=a;const $=this.B(new A.$Sc);this.a=this.B(new S.$Qd({onWillAddFirstListener:()=>$.value=this.g(),onDidRemoveLastListener:()=>$.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const P=new A.$Qc;return P.add(S.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(d,a)=>(d?d.push(a.key):d=[a.key],d),100)(d=>this.h(d))),P.add(S.Event.debounce(this.b.onDidChangeProfileStorage,(d,a)=>{d||(d=new Map);let $=d.get(a.profile.id);return $||d.set(a.profile.id,$={profile:a.profile,keys:[],storage:a.storage}),$.keys.push(a.key),d},100)(d=>this.j(d))),P}h(P){const d=P.includes(s.$0o)?[this.c.defaultProfile]:[],a=[];if(P=P.filter($=>$!==s.$0o),P.length){const $=(0,s.$_o)(this.b.applicationStorage.storage);a.push({profile:this.c.defaultProfile,changes:P.map(p=>({key:p,scope:0,target:$[p]}))})}this.m(d,a)}j(P){const d=[],a=new Map;for(const[$,p]of P.entries()){p.keys.includes(s.$0o)&&d.push(p.profile);const v=p.keys.filter(f=>f!==s.$0o);if(v.length){const f=(0,s.$_o)(p.storage.storage);a.set($,{profile:p.profile,changes:v.map(y=>({key:y,scope:0,target:f[y]}))})}}this.m(d,[...a.values()])}m(P,d){(P.length||d.length)&&this.a.fire({valueChanges:d,targetChanges:P})}listen(P,d,a){switch(d){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${d}`)}async call(P,d){throw new Error(`Call not found: ${d}`)}}e.$m9b=M}),define(ne[281],re([0,1,7,37,16,5,34,40,41,12,121]),function(J,e,S,A,s,M,C,P,d,a,$){"use strict";var p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=e.$VN=e.$UN=void 0;let f=class extends d.$Sk{static{p=this}static{this.a="profileAssociationsMigration"}constructor(g,h,l,E,u){super(l,E,h,u),this.U=g,this.W=l}O(){return this.U.getItem(p.b,[]).map(h=>({...h,location:(0,a.$Bf)(h.location)?this.w.extUri.joinPath(this.profilesHome,h.location):S.URI.revive(h.location)}))}Q(){const g=this.U.getItem(p.c,{});return this.U.getItem(p.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$UN=f,e.$UN=f=p=ve([te(0,C.$PN),te(1,P.$Nk),te(2,A.$3h),te(3,s.$dk),te(4,M.$cj)],f);let y=v=class extends f{constructor(g,h,l,E,u){super(g,h,l,E,u),this.$=g}P(g){g.length?this.$.setItem(v.b,g.map(h=>({...h,location:this.w.extUri.basename(h.location)}))):this.$.removeItem(v.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(v.c,g):this.$.removeItem(v.c)}Q(){const g="workspaceAndProfileInfo",h=this.$.getItem(g,void 0);if(h){this.$.removeItem(g);const E=h.reduce((u,{workspace:i,profile:o})=>(u[S.URI.revive(i).toString()]=S.URI.revive(o).toString(),u),{});this.$.setItem(v.c,{workspaces:E})}const l=super.Q();return this.$.getItem(v.a,!1)||(this.R(l),this.$.setItem(v.a,!0)),l}};e.$VN=y,e.$VN=y=v=ve([te(0,C.$QN),te(1,P.$Nk),te(2,A.$3h),te(3,s.$dk),te(4,M.$cj)],y);let w=class extends y{constructor(g,h,l,E){super(new $.$TN(0,h,E,l),g,h,l,E)}async init(){return await this.$.init(),super.init()}};e.$WN=w,e.$WN=w=ve([te(0,P.$Nk),te(1,A.$3h),te(2,s.$dk),te(3,M.$cj)],w)}),define(ne[53],re([0,1,37,16,6,5,40,41,281,34]),function(J,e,S,A,s,M,C,P,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=e.$K7b=void 0,e.$K7b=(0,s.$Vh)(P.$Pk);let $=class extends d.$VN{constructor(v,f,y,w,b){super(v,f,y,w,b)}getAssociatedEmptyWindows(){const v=[];for(const f of this.C.emptyWindows.keys())v.push({id:f});return v}};e.$L7b=$,e.$L7b=$=ve([te(0,a.$QN),te(1,C.$Nk),te(2,S.$3h),te(3,A.$dk),te(4,M.$cj)],$)}),define(ne[130],re([0,1,19,7,30]),function(J,e,S,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=e.$17b=e.$Z7b=void 0;async function M(d,a,$){for(const v of d){const f=v.openedWorkspace;if((0,s.$0h)(f)){const y=await $(f);if(y){if(y.folders.some(w=>S.$pg.isEqualOrParent(a,w.uri)))return v}else if(S.$pg.isEqualOrParent(a,f.configPath))return v}}const p=d.filter(v=>(0,s.$5h)(v.openedWorkspace)&&S.$pg.isEqualOrParent(a,v.openedWorkspace.uri));if(p.length)return p.sort((v,f)=>-(v.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.$Z7b=M;function C(d,a){for(const $ of d)if((0,s.$0h)($.openedWorkspace)&&S.$pg.isEqual($.openedWorkspace.configPath,a)||(0,s.$5h)($.openedWorkspace)&&S.$pg.isEqual($.openedWorkspace.uri,a))return $}e.$17b=C;function P(d,a){const $=p=>a.some(v=>S.$pg.isEqual(A.URI.file(v),A.URI.file(p)));for(const p of d)if(p.config?.extensionDevelopmentPath?.some(v=>$(v)))return p}e.$27b=P}),define(ne[97],re([0,1,33,44,139,46,13,9,4,19,7,6,59,30]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oV=e.$nV=e.$mV=e.$lV=e.$kV=e.$jV=e.$iV=e.$hV=e.$gV=e.$fV=void 0,e.$fV=(0,p.$Uh)("workspacesService");function y(R){return R.hasOwnProperty("workspace")}e.$gV=y;function w(R){return R.hasOwnProperty("folderUri")}e.$hV=w;function b(R){return R.hasOwnProperty("fileUri")}e.$iV=b;function g(R){return h(R)||l(R)}e.$jV=g;function h(R){const k=R;return typeof k?.path=="string"&&(!k.name||typeof k.name=="string")}function l(R){const k=R;return typeof k?.uri=="string"&&(!k.name||typeof k.name=="string")}function E(R,k,I,F,U){if(R.scheme!==F.scheme)return{name:I,uri:R.toString(!0)};let T=k?void 0:U.relativePath(F,R);if(T!==void 0)T.length===0?T=".":d.$i&&(T=u(T));else if(R.scheme===C.Schemas.file)T=R.fsPath,d.$i&&(T=u(T));else if(U.isEqualAuthority(R.authority,F.authority))T=R.path;else return{name:I,uri:R.toString(!0)};return{name:I,path:T}}e.$kV=E;function u(R){return R=(0,M.$yv)(R),(0,S.$Xf)(R)||(R=(0,S.$Uf)(R)),R}function i(R,k,I){const F=[],U=new Set,T=I.dirname(k);for(const x of R){let Y;if(h(x))x.path&&(Y=I.resolvePath(T,x.path));else if(l(x))try{Y=$.URI.parse(x.uri),Y.path[0]!==P.$fc.sep&&(Y=Y.with({path:P.$fc.sep+Y.path}))}catch(ce){console.warn(ce)}if(Y){const ce=I.getComparisonKey(Y);if(!U.has(ce)){U.add(ce);const oe=x.name||I.basenameOrAuthority(Y);F.push(new f.$ci({uri:Y,name:oe,index:F.length},x))}}}return F}e.$lV=i;function o(R,k,I,F,U){const T=r(k,R),x=U.dirname(k),Y=U.dirname(F),ce=[];for(const K of T.folders){const G=h(K)?U.resolvePath(x,K.path):$.URI.parse(K.uri);let z;I?z=!1:z=!h(K)||(0,P.$hc)(K.path),ce.push(E(G,z,K.name,Y,U))}const oe={insertSpaces:!1,tabSize:4,eol:d.$k||d.$j?`
`:`\r
`},ae=s.$xT(R,["folders"],ce,oe);let Z=s.$AT(R,ae);return(0,a.$Dg)(T.remoteAuthority,(0,v.$Zk)(F))&&(Z=s.$AT(Z,s.$wT(Z,["remoteAuthority"],oe))),Z}e.$mV=o;function r(R,k){const I=A.$2m(k);if(I&&Array.isArray(I.folders))I.folders=I.folders.filter(F=>g(F));else throw new Error(`${R} looks like an invalid workspace file.`);return I}function t(R){return R.workspace&&typeof R.workspace=="object"&&typeof R.workspace.id=="string"&&typeof R.workspace.configPath=="string"}function n(R){return typeof R.folderUri=="string"}function c(R){return typeof R.fileUri=="string"}function m(R,k){const I={workspaces:[],files:[]};if(R){const F=function(T,x){for(let Y=0;Y<T.length;Y++)try{x(T[Y],Y)}catch(ce){k.warn(`Error restoring recent entry ${JSON.stringify(T[Y])}: ${ce.toString()}. Skip entry.`)}},U=R;Array.isArray(U.entries)&&F(U.entries,T=>{const x=T.label,Y=T.remoteAuthority;t(T)?I.workspaces.push({label:x,remoteAuthority:Y,workspace:{id:T.workspace.id,configPath:$.URI.parse(T.workspace.configPath)}}):n(T)?I.workspaces.push({label:x,remoteAuthority:Y,folderUri:$.URI.parse(T.folderUri)}):c(T)&&I.files.push({label:x,remoteAuthority:Y,fileUri:$.URI.parse(T.fileUri)})})}return I}e.$nV=m;function D(R){const k={entries:[]};for(const I of R.workspaces)w(I)?k.entries.push({folderUri:I.folderUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority}):k.entries.push({workspace:{id:I.workspace.id,configPath:I.workspace.configPath.toString()},label:I.label,remoteAuthority:I.remoteAuthority});for(const I of R.files)k.entries.push({fileUri:I.fileUri.toString(),label:I.label,remoteAuthority:I.remoteAuthority});return k}e.$oV=D}),define(ne[98],re([0,1,86,13,4,19]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67b=e.$57b=e.$47b=e.$37b=void 0,e.$37b=128/4;function C(a){function $(){let p=a.scheme===A.Schemas.file?(0,M.$mg)(a):a.toString();return s.$k||(p=p.toLowerCase()),(0,S.createHash)("md5").update(p).digest("hex")}return{id:$(),configPath:a}}e.$47b=C;function P(a,$){function p(){if(a.scheme!==A.Schemas.file)return(0,S.createHash)("md5").update(a.toString()).digest("hex");if(!$)return;let f;return s.$k?f=$.ino:s.$j?f=$.birthtime.getTime():s.$i&&(typeof $.birthtimeMs=="number"?f=Math.floor($.birthtimeMs):f=$.birthtime.getTime()),(0,S.createHash)("md5").update(a.fsPath).update(f?String(f):"").digest("hex")}const v=p();if(typeof v=="string")return{id:v,uri:a}}e.$57b=P;function d(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$67b=d}),define(ne[99],re([0,1,86,87,28,282,18,14,3,2,9,4,32,42,109]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0;class w{traceSocketEvent(k,I){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,I)}constructor(k,I=""){this.f=!0,this.debugLabel=I,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,P.$Z)(F)}},this.socket.on("error",this.a),this.b=F=>{this.traceSocketEvent("close",{hadError:F}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const I=F=>{this.traceSocketEvent("read",F),k(C.$ee.wrap(F))};return this.socket.on("data",I),{dispose:()=>this.socket.off("data",I)}}onClose(k){const I=F=>{k({type:0,hadError:F,error:void 0})};return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(k){const I=()=>{k()};return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,I=>{if(I){if(I.code==="EPIPE")return;(0,P.$Z)(I)}})}catch(I){if(I.code==="EPIPE")return;(0,P.$Z)(I)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,I)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.$Jh=w;var b;(function(R){R[R.MinHeaderByteSize=2]="MinHeaderByteSize",R[R.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var g;(function(R){R[R.PeekHeader=1]="PeekHeader",R[R.ReadHeader=2]="ReadHeader",R[R.ReadBody=3]="ReadBody",R[R.Fin=4]="Fin"})(g||(g={}));class h extends a.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,I){this.socket.traceSocketEvent(k,I)}constructor(k,I,F,U){super(),this.f=this.B(new d.$Qd),this.g=this.B(new d.$Qd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:I,inflateBytesLength:F?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new l(this,I,F,U,this.f,(T,x)=>this.m(T,x))),this.B(this.a.onError(T=>{console.error(T),(0,P.$Z)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new y.$Eh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let I=0;for(;I<k.byteLength;)this.a.writeMessage(k.slice(I,Math.min(I+262144,k.byteLength)),{compressed:!0,opcode:2}),I+=262144}m(k,{compressed:I,opcode:F}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let U=2;k.byteLength<126?U+=0:k.byteLength<2**16?U+=2:U+=8;const T=C.$ee.alloc(U),x=I?64:0,Y=F&15;if(T.writeUInt8(128|x|Y,0),k.byteLength<126)T.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){T.writeUInt8(126,1);let ce=1;T.writeUInt8(k.byteLength>>>8&255,++ce),T.writeUInt8(k.byteLength>>>0&255,++ce)}else{T.writeUInt8(127,1);let ce=1;T.writeUInt8(0,++ce),T.writeUInt8(0,++ce),T.writeUInt8(0,++ce),T.writeUInt8(0,++ce),T.writeUInt8(k.byteLength>>>24&255,++ce),T.writeUInt8(k.byteLength>>>16&255,++ce),T.writeUInt8(k.byteLength>>>8&255,++ce),T.writeUInt8(k.byteLength>>>0&255,++ce)}this.socket.write(C.$ee.concat([T,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const I=this.b.peek(this.j.readLen),F=I.readUInt8(0),U=(F&128)>>>7,T=(F&64)>>>6,x=F&15,Y=I.readUInt8(1),ce=(Y&128)>>>7,oe=Y&127;this.j.state=2,this.j.readLen=2+(ce?4:0)+(oe===126?2:0)+(oe===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const I=this.b.read(this.j.readLen),F=I.readUInt8(1),U=(F&128)>>>7;let T=F&127,x=1;T===126?T=I.readUInt8(++x)*2**8+I.readUInt8(++x):T===127&&(T=I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*0+I.readUInt8(++x)*2**24+I.readUInt8(++x)*2**16+I.readUInt8(++x)*2**8+I.readUInt8(++x));let Y=0;U&&(Y=I.readUInt8(++x)*2**24+I.readUInt8(++x)*2**16+I.readUInt8(++x)*2**8+I.readUInt8(++x)),this.j.state=3,this.j.readLen=T,this.j.mask=Y,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const I=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",I),i(I,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",I),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(I,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(I,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await d.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Kh=h;class l extends a.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:C.$ee.alloc(0)}constructor(k,I,F,U,T,x){super(),this.n=k,this.r=T,this.s=x,this.a=this.B(new d.$Qd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new d.$Qd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new d.$Qd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,I?(this.b=this.B(new E(this.n,U,F,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(Y=>this.a.fire(Y))),this.B(this.f.onError(Y=>this.a.fire(Y)))):(this.b=null,this.f=null)}writeMessage(k,I){this.g.push({data:k,options:I}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:k,options:I}=this.g.shift();if(this.f&&I.compressed){const F=await this.w(this.f,k);this.s(F,I)}else this.s(k,{...I,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,I){return new Promise((F,U)=>{k.write(I),k.flush(T=>F(T))})}acceptFrame(k,I,F){this.h.push({data:k,isCompressed:I,isLastFrameOfMessage:F}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const I=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(I)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,I,F){return new Promise((U,T)=>{k.write(I),F&&k.write(C.$ee.fromByteArray([0,0,255,255])),k.flush(x=>U(x))})}}class E extends a.$Rc{get recordedInflateBytes(){return this.j?C.$ee.concat(this.f):C.$ee.alloc(0)}constructor(k,I,F,U){super(),this.h=k,this.j=I,this.a=this.B(new d.$Qd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(U),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(C.$ee.wrap(T))}),F&&(this.h.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const I=C.$ee.concat(this.g);this.g.length=0,k(I)})}}class u extends a.$Rc{constructor(k,I){super(),this.g=k,this.a=this.B(new d.$Qd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent("zlibDeflateData",F),this.f.push(C.$ee.wrap(F))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let I=C.$ee.concat(this.f);this.f.length=0,I=I.slice(0,I.byteLength-4),k(I)})}}function i(R,k){if(k===0)return;const I=R.byteLength>>>2;for(let ce=0;ce<I;ce++){const oe=R.readUInt32BE(ce*4);R.writeUInt32BE(oe^k,ce*4)}const F=I*4,U=R.byteLength-F,T=k>>>24&255,x=k>>>16&255,Y=k>>>8&255;U>=1&&R.writeUInt8(R.readUInt8(F)^T,F),U>=2&&R.writeUInt8(R.readUInt8(F+1)^x,F+1),U>=3&&R.writeUInt8(R.readUInt8(F+2)^Y,F+2)}e.$Lh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function r(){const R=(0,v.$hg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${R}-sock`;const k=process.platform!=="darwin"&&e.$Lh?e.$Lh:(0,s.tmpdir)(),I=(0,$.$ic)(k,`vscode-ipc-${R}.sock`);return n(I),I}e.$Mh=r;function t(R,k,I){const F=(0,S.createHash)("md5").update(R).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${I}-${k}-sock`;const U=I.substr(0,4),T=k.substr(0,6),x=F.substr(0,8);let Y;return process.platform!=="darwin"&&e.$Lh&&!process.env.VSCODE_PORTABLE?Y=(0,$.$ic)(e.$Lh,`vscode-${x}-${U}-${T}.sock`):Y=(0,$.$ic)(R,`${U}-${T}.sock`),n(Y),Y}e.$Nh=t;function n(R){const k=o[p.$u];typeof k=="number"&&R.length>=k&&console.warn(`WARNING: IPC handle "${R}" is longer than ${k} chars, try a shorter --user-data-dir`)}class c extends f.$yh{static b(k){const I=d.Event.fromNodeEventEmitter(k,"connection");return d.Event.map(I,F=>({protocol:new y.$Fh(new w(F,"ipc-server-connection")),onDidClientDisconnect:d.Event.once(d.Event.fromNodeEventEmitter(F,"close"))}))}constructor(k){super(c.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Oh=c;function m(R){return new Promise((k,I)=>{const F=(0,A.createServer)();F.on("error",I),F.listen(R,()=>{F.removeListener("error",I),k(new c(F))})})}e.$Ph=m;function D(R,k){return new Promise((I,F)=>{const U=(0,A.createConnection)(R,()=>{U.removeListener("error",F),I(y.$Gh.fromSocket(new w(U,`ipc-client${k}`),k))});U.once("error",F)})}e.$Qh=D}),define(ne[24],re([0,1,55,9,4,99,37,90,6]),function(J,e,S,A,s,M,C,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D7b=e.$C7b=void 0,e.$C7b=(0,d.$Vh)(C.$2h);class a extends P.$om{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,A.$ic)(this.userDataPath,"clp")}get backupHome(){return(0,A.$ic)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$Nh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,A.$ic)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const p in process.env)if(p.endsWith("_VSCODE_SNAP_ORIG")){const v=p.slice(0,-17);if(this.d[v])continue;process.env[v]&&(this.d[v]=process.env[v]),process.env[p]?process.env[v]=process.env[p]:delete process.env[v]}}}restoreSnapExportedVariables(){if(s.$k)for(const p in this.d)process.env[p]=this.d[p],delete this.d[p]}}e.$D7b=a,ve([S.$mh],a.prototype,"cachedLanguagesPath",null),ve([S.$mh],a.prototype,"backupHome",null),ve([S.$mh],a.prototype,"mainIPCHandle",null),ve([S.$mh],a.prototype,"mainLockfile",null),ve([S.$mh],a.prototype,"disableUpdates",null),ve([S.$mh],a.prototype,"crossOriginIsolated",null),ve([S.$mh],a.prototype,"codeCachePath",null),ve([S.$mh],a.prototype,"useCodeCache",null)}),define(ne[283],re([0,1,86,33,13,9,4,19,21,196,17,24,34,16,5,195,30,98]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$i8b=void 0;let l=class{static{h=this}static{this.a="backupWorkspaces"}constructor(u,i,o,r){this.j=u,this.k=i,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=P.$pg,this.i={isEqual:(t,n)=>(0,A.$Zf)(t,n,!C.$k)}}async initialize(){const u=this.m.getItem(h.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(u.emptyWindows),this.d=await this.u((0,a.$T7b)(u)),this.e=await this.v((0,a.$U7b)(u)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.$Ck.OFF}q(){return this.s()===f.$Ck.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.$Ck.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(u,i){this.d.some(r=>u.workspace.id===r.workspace.id)||(this.d.push(u),this.C());const o=(0,M.$ic)(this.c,u.workspace.id);return i?this.t(o,i).then(()=>o):o}async t(u,i){if(await d.Promises.exists(u)&&await this.z(u),await d.Promises.exists(i))try{await d.Promises.rename(i,u,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(u){return this.e.some(i=>this.h.isEqual(u.folderUri,i.folderUri))||(this.e.push(u),this.C()),(0,M.$ic)(this.c,this.D(u))}registerEmptyWindowBackup(u){return this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,u.backupFolder))||(this.g.push(u),this.C()),(0,M.$ic)(this.c,u.backupFolder)}async u(u){if(!Array.isArray(u))return[];const i=new Set,o=[];for(const r of u){const t=r.workspace;if(!(0,b.$0h)(t))return[];if(!i.has(t.id)){i.add(t.id);const n=(0,M.$ic)(this.c,t.id);await this.B(n)?t.configPath.scheme!==s.Schemas.file||await d.Promises.exists(t.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(u){if(!Array.isArray(u))return[];const i=[],o=new Set;for(const r of u){const t=r.folderUri,n=this.h.getComparisonKey(t);if(!o.has(n)){o.add(n);const c=(0,M.$ic)(this.c,this.D(r));await this.B(c)?t.scheme!==s.Schemas.file||await d.Promises.exists(t.fsPath)?i.push(r):await this.z(c):await this.x(c)}}return i}async w(u){if(!Array.isArray(u))return[];const i=[],o=new Set;for(const r of u){const t=r.backupFolder;if(typeof t!="string")return[];if(!o.has(t)){o.add(t);const n=(0,M.$ic)(this.c,t);await this.B(n)?i.push(r):await this.x(n)}}return i}async x(u){try{await d.Promises.rm(u,d.RimRafMode.MOVE)}catch(i){this.l.error(`Backup: Could not delete stale backup: ${i.toString()}`)}}y(){let u=(0,g.$67b)();for(;this.g.some(i=>!!i.backupFolder&&this.i.isEqual(i.backupFolder,u.id));)u=(0,g.$67b)();return{backupFolder:u.id}}async z(u){const i=this.y(),o=(0,M.$ic)(this.c,i.backupFolder);try{await d.Promises.rename(u,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(i),!0}async getDirtyWorkspaces(){const u=[];for(const i of this.d)await this.A(i)&&u.push(i);for(const i of this.e)await this.A(i)&&u.push(i);return u}A(u){let i;return(0,a.$S7b)(u)?i=(0,M.$ic)(this.c,u.backupFolder):(0,w.$dV)(u)?i=(0,M.$ic)(this.c,this.D(u)):i=(0,M.$ic)(this.c,u.workspace.id),this.B(i)}async B(u){try{const i=await d.Promises.readdir(u);for(const o of i)try{if((await d.Promises.readdir((0,M.$ic)(u,o))).length>0)return!0}catch{}}catch{}return!1}C(){const u={workspaces:this.d.map(({workspace:i,remoteAuthority:o})=>{const r={id:i.id,configURIPath:i.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:i,remoteAuthority:o})=>{const r={folderUri:i.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:i,remoteAuthority:o})=>{const r={backupFolder:i};return o&&(r.remoteAuthority=o),r})};this.m.setItem(h.a,u)}D(u){const i=u.folderUri;let o;return i.scheme===s.Schemas.file?o=C.$k?i.fsPath:i.fsPath.toLowerCase():o=i.toString().toLowerCase(),(0,S.createHash)("md5").update(o).digest("hex")}};e.$i8b=l,e.$i8b=l=h=ve([te(0,p.$C7b),te(1,$.$oi),te(2,y.$cj),te(3,v.$QN)],l)}),define(ne[20],re([0,1,15,36,8,3,2,4,35,12,6,5,34,24]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=e.LifecycleMainPhase=e.ShutdownReason=e.$E7b=void 0,e.$E7b=(0,$.$Uh)("lifecycleMainService");var w;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var b;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(b||(e.LifecycleMainPhase=b={}));let g=class extends C.$Rc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(l,E,u){super(),this.F=l,this.G=E,this.H=u,this.c=this.B(new M.$Qd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Qd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Qd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Qd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const l=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),P.$j&&this.t===0&&this.L(1))};S.app.addListener("before-quit",l);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!P.$j)&&S.app.quit()};S.app.addListener("window-all-closed",E),S.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),S.app.removeListener("before-quit",l),S.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),S.app.quit()})})}L(l){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:l,join(i,o){E.trace(`Lifecycle#onWillShutdown - begin '${i}'`),u.push(o.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${i}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(u)}catch(i){this.F.error(i)}try{await this.G.close()}catch(i){this.F.error(i)}})(),this.y}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===l)return;this.S(`lifecycle (main): phase changed (value: ${l})`),this.n=l;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when(l){if(l<=this.n)return;let E=this.C.get(l);E||(E=new s.$Vg,this.C.set(l,E)),await E.wait()}registerWindow(l){const E=new C.$Qc;this.t++,E.add(l.onWillLoad(i=>this.g.fire({window:l,workspace:i.workspace,reason:i.reason})));const u=(0,a.$Mf)(l.win);u.on("close",i=>{const o=l.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${l.id}`),i.preventDefault(),this.unload(l,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(l),l.close()})}),u.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.t--,E.dispose(),this.t===0&&(!P.$j||this.j)&&this.L(1)})}async reload(l,E){await this.unload(l,3)||l.reload(E)}unload(l,E){const u=this.z.get(l.id);if(u)return u;const i=this.M(l,E).finally(()=>{this.z.delete(l.id)});return this.z.set(l.id,i),i}async M(l,E){if(!l.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${l.id}`);const u=this.j?2:E,i=await this.P(l,u);return i?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.N(i)):(await this.Q(l,u),!1)}N(l){return l?(this.O(!0),this.j=!1,!0):!1}O(l){this.w&&(this.w(l),this.w=void 0,this.u=void 0)}P(l,E){return new Promise(u=>{const i=this.s++,o=`vscode:ok${i}`,r=`vscode:cancel${i}`;A.$UT.once(o,()=>{u(!1)}),A.$UT.once(r,()=>{u(!0)}),l.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:E})})}Q(l,E){return new Promise(u=>{const o=`vscode:reply${this.s++}`;A.$UT.once(o,()=>u()),l.send("vscode:onWillUnload",{replyChannel:o,reason:E})})}quit(l){return this.R(l).then(E=>{if(!E&&l)try{if(P.$i){const u=(0,d.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return E})}R(l){return this.S(`Lifecycle#quit() - begin (willRestart: ${l})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(l&&this.G.setItem(y.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),S.app.quit()}),this.u)}S(l){this.H.args["enable-smoke-test-driver"]?this.F.info(l):this.F.trace(l)}setRelaunchHandler(l){this.D=l}async relaunch(l){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if(l?.addArgs&&E.push(...l.addArgs),l?.removeArgs)for(const o of l.removeArgs){const r=E.indexOf(o);r>=0&&E.splice(r,1)}const u=()=>{this.D?.handleRelaunch(l)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),S.app.relaunch({args:E}))};S.app.once("quit",u),await this.quit(!0)&&S.app.removeListener("quit",u)}async kill(l){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Xg)(1e3),(async()=>{for(const E of S.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let u;E.webContents&&!E.webContents.isDestroyed()?u=new Promise(i=>E.once("closed",i)):u=Promise.resolve(),E.destroy(),await u}})()]),S.app.exit(l)}};e.$F7b=g,e.$F7b=g=y=ve([te(0,p.$cj),te(1,v.$QN),te(2,f.$C7b)],g)}),define(ne[284],re([0,1,4,3,2,6,20]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F8b=e.$E8b=void 0,e.$E8b=(0,M.$Uh)("keyboardLayoutMainService");let P=class extends s.$Rc{constructor($){super(),this.a=this.B(new A.$Qd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,$.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const $=await new Promise((p,v)=>{J(["native-keymap"],p,v)});this.c=d($),S.$t||$.onDidChangeKeyboardLayout(()=>{this.c=d($),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$F8b=P,e.$F8b=P=ve([te(0,C.$E7b)],P);function d(a){const $=a.getKeyMap(),p=a.getCurrentKeyboardLayout();return{keyboardMapping:$,keyboardLayoutInfo:p}}}),define(ne[285],re([0,1,246,8,18,14,12,17,37,94,5,50,245,282]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;let y=class extends p.$Yo{constructor(h,l,E,u){super(u),this.m=h,this.n=l,this.r=E,this.s(),this.B(h.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const h=this.m.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,l){const{f:E,g:u}=this;let i;try{i=await(0,a.$Yl)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$9)(t)))}const o={...process.env,...i},r=h.agent?h.agent:await(0,v.$3q)(h.url||"",o,{proxyUrl:E,strictSSL:u});return h.agent=r,h.strictSSL=u,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>b(h,l))}async resolveProxy(h){}};e.$4q=y,e.$4q=y=ve([te(0,P.$oi),te(1,d.$3h),te(2,$.$cj),te(3,$.$dj)],y);async function w(g){return((0,S.parse)(g.url).protocol==="https:"?await new Promise((E,u)=>{J(["https"],E,u)}):await new Promise((E,u)=>{J(["http"],E,u)})).request}async function b(g,h){return A.Promises.withAsyncBody(async(l,E)=>{const u=(0,S.parse)(g.url),i=g.getRawRequest?g.getRawRequest(g):await w(g),o={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,C.$Hf)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const r=i(o,t=>{const n=(0,C.$Ff)(g.followRedirects)?g.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)b({...g,url:t.headers.location,followRedirects:n-1},h).then(l,E);else{let c=t;!g.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(c=t.pipe((0,f.createGunzip)())),l({res:t,stream:(0,s.$te)(c)})}});r.on("error",E),g.timeout&&r.setTimeout(g.timeout),g.isChromiumNetwork&&r.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&r.write(g.data),r.end(),h.onCancellationRequested(()=>{r.abort(),E(new M.$4)})})}e.$5q=b}),define(ne[286],re([0,1,15,285]),function(J,e,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H9b=void 0;function s(C){return S.net.request}class M extends A.$4q{request(P,d){return super.request({...P||{},getRawRequest:s,isChromiumNetwork:!0},d)}}e.$H9b=M}),define(ne[82],re([0,1,7,3,2,37,16,6,20,5,96,279,41,53,40,13]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=e.$O7b=e.$N7b=e.$M7b=void 0,e.$M7b=(0,P.$Uh)("storageMainService");let b=class extends s.$Rc{constructor(l,E,u,i,o,r){super(),this.c=l,this.f=E,this.g=u,this.h=i,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new A.$Qd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(l=>{l.window.profile&&this.profileStorage(l.window.profile).init(),l.workspace&&this.workspaceStorage(l.workspace).init()})),this.B(this.h.onWillShutdown(l=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=l.reason,l.join("applicationStorage",this.applicationStorage.close());for(const[,E]of this.t)l.join("profileStorage",E.close());for(const[,E]of this.w)l.join("workspaceStorage",E.close())})),this.B(this.g.onWillCreateProfile(l=>{l.join((async()=>{await this.j.exists(l.profile.globalStorageHome)||await this.j.createFolder(l.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(l=>{const E=this.t.get(l.profile.id);E&&l.join(E.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const l=new p.$H7b(this.n(),this.g,this.c,this.j);return this.B(A.Event.once(l.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),l}profileStorage(l){if((0,$.$bp)(l))return this.applicationStorage;let E=this.t.get(l.id);if(!E){this.c.trace(`StorageMainService: creating profile storage (${l.name})`),E=this.B(this.u(l)),this.t.set(l.id,E);const u=this.B(E.onDidChangeStorage(i=>this.b.fire({...i,storage:E,profile:l})));this.B(A.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${l.name})`),this.t.delete(l.id),u.dispose()}))}return E}u(l){return this.a===2?new p.$J7b(this.c,this.j):new p.$G7b(l,this.n(),this.c,this.j)}workspaceStorage(l){let E=this.w.get(l.id);return E||(this.c.trace(`StorageMainService: creating workspace storage (${l.id})`),E=this.B(this.y(l)),this.w.set(l.id,E),this.B(A.Event.once(E.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${l.id})`),this.w.delete(l.id)}))),E}y(l){return this.a===2?new p.$J7b(this.c,this.j):new p.$I7b(l,this.n(),this.c,this.f,this.j)}isUsed(l){const E=S.URI.file(l);for(const u of[this.applicationStorage,...this.t.values(),...this.w.values()])if(u.path&&this.m.extUri.isEqualOrParent(S.URI.file(u.path),E))return!0;return!1}};e.$N7b=b,e.$N7b=b=ve([te(0,a.$cj),te(1,M.$2h),te(2,f.$K7b),te(3,d.$E7b),te(4,C.$dk),te(5,y.$Nk)],b),e.$O7b=(0,P.$Uh)("applicationStorageMainService");let g=class extends $.$ap{constructor(l,E){super(),this.s=l,this.U=E,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(l){if(l===-1)return this.U.applicationStorage.storage}Q(l){if(l===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$P7b=g,e.$P7b=g=ve([te(0,v.$Pk),te(1,e.$M7b)],g)}),define(ne[287],re([0,1,87,28,103,99,8,2,4,17,5,25,241,242,95,126,18]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=e.$F9b=e.$E9b=e.$D9b=void 0;async function g(i,o,r,t,n){let c;for(let m=3;m&&(c?.dispose(),c=await new h(i,o,r,t,n).waitForReady(),!(n&&s.$kg[n]||!s.$kg[c.tunnelLocalPort]));m--);return c}class h extends P.$Rc{constructor(o,r,t,n,c){super(),this.m=r,this.n=c,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=S.createServer(),this.c=new C.$Vg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=m=>this.r(m),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=t}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,w.$kv)(this.m)?"0.0.0.0":"127.0.0.1";let t=await(0,s.$lg)(o,2,1e3,r),n=null;return this.b.listen(t,this.m),await this.c.wait(),n=this.b.address(),n||(t=0,this.b.listen(t,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,w.$iv)(this.tunnelRemoteHost)||(0,w.$kv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,t=await(0,v.$$k)(this.a,r,this.tunnelRemotePort),n=t.getSocket(),c=t.readEntireBuffer();t.dispose(),c.byteLength>0&&o.write(c.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof M.$Jh?n.socket.destroy():n.end()}),n instanceof M.$Jh?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(t=>o.write(t.buffer)),o.on("data",t=>r.write(b.$ee.wrap(t))),o.resume()}t(o,r){const t=r.socket;t.on("end",()=>o.end()),t.on("close",()=>o.end()),t.on("error",()=>{o.destroy()}),t.pipe(o),o.pipe(t)}}e.$D9b=h;let l=class extends w.$nv{constructor(o,r,t,n,c){super(r,c),this.u=o,this.v=t,this.w=n}isPortPrivileged(o){return(0,w.$lv)(o,this.l,d.OS,A.release())}s(o,r,t,n,c,m,D,R){const k=this.r(r,t);if(k)return++k.refcount,k.value;if((0,w.$fv)(o))return this.t(o,r,t,c,m,D,R);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${t} on local port ${c}.`);const I={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},F=g(I,n,r,t,c);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,t,F),F}}};e.$E9b=l,e.$E9b=l=ve([te(0,f.$5k),te(1,$.$cj),te(2,y.$8k),te(3,p.$uj),te(4,a.$oi)],l);let E=class extends l{constructor(o,r,t,n,c){super(o,r,t,n,c)}};e.$F9b=E,e.$F9b=E=ve([te(0,f.$5k),te(1,$.$cj),te(2,y.$8k),te(3,p.$uj),te(4,a.$oi)],E);let u=class extends P.$Rc{constructor(o,r,t,n,c){super(),this.b=o,this.c=r,this.f=t,this.g=n,this.h=c,this.a=new Map}async openTunnel(o,r,t,n,c,m,D,R,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${t}:${n} on local port ${m}.`),!this.a.has(o)){const I=new E(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(o,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,t,n,c,m,D,R,k)}};e.$G9b=u,e.$G9b=u=ve([te(0,f.$5k),te(1,$.$cj),te(2,p.$uj),te(3,y.$8k),te(4,a.$oi)],u)}),define(ne[100],re([0,1,8,22,3,17,24,20,5,25,50,48]),function(J,e,S,A,s,M,C,P,d,a,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$38b=e.$28b=void 0;function v(y,w,b){return`${b.updateUrl}/api/update/${y}/${w}/${b.commit}`}e.$28b=v;let f=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,b,g,h,l,E){this.f=w,this.g=b,this.h=g,this.i=h,this.j=l,this.k=E,this.b=p.$TU.Uninitialized,this.c=new s.$Qd,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(p.$TU.Disabled(0));return}if(this.h.disableUpdates){this.d(p.$TU.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(p.$TU.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),b=this.m(w);if(!b){this.d(p.$TU.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(b),!this.a){this.d(p.$TU.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(p.$TU.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,S.$Xg)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},A.CancellationToken.None)).res.statusCode===204}catch(b){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(b);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$38b=f,e.$38b=f=ve([te(0,P.$E7b),te(1,M.$oi),te(2,C.$C7b),te(3,$.$Xo),te(4,d.$cj),te(5,a.$uj)],f)}),define(ne[288],re([0,1,15,55,3,2,17,24,20,5,25,50,26,48,100]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$48b=void 0;let w=class extends y.$38b{get v(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"error",(g,h)=>h)}get w(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-available",(g,h,l)=>({url:h,version:l,productVersion:l}))}get y(){return s.Event.fromNodeEventEmitter(S.autoUpdater,"update-downloaded",(g,h,l,E)=>({releaseNotes:h,version:l,productVersion:l,date:E}))}constructor(g,h,l,E,u,i,o){super(g,h,E,u,i,o),this.z=l,this.u=new M.$Qc,g.setRelaunchHandler(this)}handleRelaunch(g){return g?.addArgs||g?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.j.error("UpdateService error:",g);const h=this.state.type==="checking for updates"&&this.state.explicit?g:void 0;this.d(f.$TU.Idle(1,h))}s(g){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,y.$28b)(h,g,this.k);try{S.autoUpdater.setFeedURL({url:l})}catch(E){this.j.error("Failed to set update feed URL",E);return}return l}t(g){this.d(f.$TU.CheckingForUpdates(g)),S.autoUpdater.checkForUpdates()}E(g){this.state.type==="checking for updates"&&this.d(f.$TU.Downloading(g))}F(g){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:g.version}),this.d(f.$TU.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$TU.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),S.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$48b=w,ve([A.$mh],w.prototype,"v",null),ve([A.$mh],w.prototype,"w",null),ve([A.$mh],w.prototype,"x",null),ve([A.$mh],w.prototype,"y",null),e.$48b=w=ve([te(0,d.$E7b),te(1,C.$oi),te(2,v.$hl),te(3,P.$C7b),te(4,p.$Xo),te(5,a.$cj),te(6,$.$uj)],w)}),define(ne[289],re([0,1,47,45,8,3,9,24,20,5,26,48]),function(J,e,S,A,s,M,C,P,d,a,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$68b=void 0;let v=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,b,g){if(this.f=w,this.g=g,this.a=p.$TU.Uninitialized,this.b=new M.$Qd,this.onStateChange=this.b.event,b.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(p.$TU.Idle(this.k())),this.h(30*1e3).then(void 0,h=>this.g.error(h))}h(w=60*60*1e3){return(0,s.$Xg)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};v=ve([te(0,d.$E7b),te(1,P.$C7b),te(2,a.$cj)],v);let f=class extends v{constructor(w,b,g,h,l,E){super(g,h,l),this.o=w,this.p=b,this.q=E;const u=(0,A.watch)(C.$lc(this.o)),i=M.Event.fromNodeEventEmitter(u,"change",(n,c)=>c),o=M.Event.filter(i,n=>n==="current"),t=M.Event.debounce(o,(n,c)=>c,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{t.dispose(),u.close()})}m(){this.d(p.$TU.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(p.$TU.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.$TU.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.$TU.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,S.spawn)("sleep 3 && "+C.$mc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((g,h)=>(0,A.realpath)(`${C.$lc(this.o)}/current`,(l,E)=>l?h(l):g(E))),b=C.$mc(w);return this.p!==b}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$68b=f,e.$68b=f=ve([te(2,d.$E7b),te(3,P.$C7b),te(4,a.$cj),te(5,$.$hl)],f)}),define(ne[29],re([0,1,4,6,60,69,25,17,24,9,64]),function(J,e,S,A,s,M,C,P,d,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8b=e.$f8b=e.$e8b=e.OpenContext=e.$d8b=void 0,e.$d8b=(0,A.$Uh)("windowsMainService");var p;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(p||(e.OpenContext=p={}));function v(w,b,g){const h=w.get(M.$Q7b),l=w.get(C.$uj),E=w.get(P.$oi),u=w.get(d.$C7b),i=E.getValue("window"),o={backgroundColor:h.getBackgroundColor(),minWidth:s.$lC.WIDTH,minHeight:s.$lC.HEIGHT,title:l.nameLong,...g,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$tC)(i?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...g?.webPreferences,sandbox:!0},experimentalDarkMode:!0};return b&&(o.x=b.x,o.y=b.y,o.width=b.width,o.height=b.height),S.$k?o.icon=(0,a.$ic)(u.appRoot,"resources/linux/code.png"):S.$i&&!u.isBuilt&&(o.icon=(0,a.$ic)(u.appRoot,"resources/win32/code_150x150.png")),S.$j&&(o.acceptFirstMouse=!0,i?.clickThroughInactive===!1&&(o.acceptFirstMouse=!1)),o}e.$e8b=v;function f(w){const b=w.get(e.$d8b),g=w.get($.$b8b),h=b.getFocusedWindow()??g.getFocusedWindow();if(h)return h;const l=b.getLastActiveWindow(),E=g.getLastActiveWindow();return l&&E?l.lastFocusTime<E.lastFocusTime?E:l:l??E}e.$f8b=f;function y(w){let b,g=Number.MIN_VALUE;for(const h of w)h.lastFocusTime>g&&(g=h.lastFocusTime,b=h);return b}e.$g8b=y}),define(ne[290],re([0,1,15,22,3,56,2,32,116,5,82,29]),function(J,e,S,A,s,M,C,P,d,a,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h8b=void 0;var v;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let f=class extends C.$Rc{constructor(w,b,g,h){super(),this.g=w,this.h=b,this.j=g,this.m=h,this.a="proxy-credentials://",this.b=void 0,this.c=v.Initial,this.f=void 0,this.n()}n(){const w=s.Event.fromNodeEventEmitter(S.app,"login",(b,g,h,l,E)=>({event:b,webContents:g,req:h,authInfo:l,callback:E}));this.B(w(this.r,this))}async r({event:w,authInfo:b,req:g,callback:h}){if(!b.isProxy)return;if(!this.b&&this.c===v.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let l;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(b);try{l=await this.b}finally{this.b=void 0}}h(l?.username,l?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.t(w);if(b)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const b=String((0,M.$Ii)({scheme:w.scheme,host:w.host,port:w.port}));let g,h;try{const i=this.m.get(this.a+b,-1);if(i){const o=JSON.parse(await this.j.decrypt(i));g=o.username,h=o.password}}catch(i){this.g.error(i)}if(this.c!==v.StoredCredentialsUsed&&typeof g=="string"&&typeof h=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=v.StoredCredentialsUsed,{username:g,password:h};const l=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!l){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const E={authInfo:w,username:this.f?.username??g,password:this.f?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,P.$hg)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",A.CancellationToken.None,E),this.c=v.LoginDialogShown;const u=await new Promise(i=>{const o=async(r,t,n)=>{if(t===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",o),n){const c={username:n.username,password:n.password};try{if(n.remember){const m=await this.j.encrypt(JSON.stringify(c));this.m.store(this.a+b,m,-1,1)}else this.m.remove(this.a+b,-1)}catch(m){this.g.error(m)}i({username:c.username,password:c.password})}else i(void 0)};l.win?.webContents.on("ipc-message",o)});return this.f=u,u}};e.$h8b=f,e.$h8b=f=ve([te(0,a.$cj),te(1,p.$d8b),te(2,d.$CU),te(3,$.$O7b)],f)}),define(ne[291],re([0,1,15,23,4,7,21,17,63,6,5,127,29]),function(J,e,S,A,s,M,C,P,d,a,$,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I8b=e.$H8b=e.ID=void 0,e.ID="launchMainService",e.$H8b=(0,a.$Uh)(e.ID);let f=class{constructor(w,b,g,h){this.a=w,this.b=b,this.c=g,this.d=h}async start(w,b){this.a.trace("Received data from other instance: ",w,b),s.$j&&S.app.focus({steal:!0});const g=this.e(w);if(g.length){let h=Promise.resolve();if(this.b.getWindowCount()===0){const l=(0,A.$Nb)(await this.b.openEmptyWindow({context:4}));l&&(h=l.ready())}h.then(()=>{for(const{uri:l,originalUrl:E}of g)this.c.open(l,{originalUrl:E})})}else return this.f(w,b)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,A.$Gb)(w._urls.map(b=>{try{return{uri:M.URI.parse(b),originalUrl:b}}catch{return null}})):[]}async f(w,b){const g=(0,d.$Sl)(b)?0:4;let h=[];const l=w.wait&&w.waitMarkerFilePath?M.URI.file(w.waitMarkerFilePath):void 0,E=w.remote||void 0,u={context:g,cli:w,userEnv:b,waitMarkerFileURI:l,remoteAuthority:E,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,u);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let i=!1;if(w["new-window"]||w["unity-launch"]||u.forceProfile||u.forceTempProfile)i=!0;else if(w["reuse-window"])i=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!s.$j}if(i)h=await this.b.open({...u,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,u),h=[o]):h=await this.b.open({...u,forceEmpty:!0})}}else h=await this.b.open({...u,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(l&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,C.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$I8b=f,e.$I8b=f=ve([te(0,$.$cj),te(1,v.$d8b),te(2,p.$IU),te(3,P.$oi)],f)}),define(ne[292],re([0,1,2,20,53,30,8,29]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l9b=void 0;let d=class extends S.$Rc{constructor($,p,v){super(),this.a=p,this.b=v,this.B($.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B($.onBeforeCloseWindow(f=>this.c(f))),this.B(new C.$9g(()=>this.g(),30*1e3)).schedule()}async c($){const p=this.f($),v=this.a.getProfileForWorkspace(p);v?.isTransient&&(this.a.unsetWorkspace(p,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f($){return $.openedWorkspace??(0,M.$9h)($.backupPath,$.isExtensionDevelopmentHost)}g(){const $=this.a.getAssociatedEmptyWindows();if($.length===0)return;const p=this.b.getWindows().map(v=>this.f(v));for(const v of $)p.some(f=>f.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.$l9b=d,e.$l9b=d=ve([te(0,A.$E7b),te(1,s.$K7b),te(2,P.$d8b)],d)}),define(ne[61],re([0,1,15,2,3,5,313,8,13,29,74,26,20,76,38,4,131]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=e.$k8b=void 0;function h(u){return typeof u.responseWindowId=="number"}let l=class extends A.$Rc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(i,o,r){super(),this.u=i,this.w=o,this.y=r,this.c=String(++g.a),this.f=this.B(new s.$Qd),this.onStdout=this.f.event,this.g=this.B(new s.$Qd),this.onStderr=this.g.event,this.h=this.B(new s.$Qd),this.onMessage=this.h.event,this.j=this.B(new s.$Qd),this.onSpawn=this.j.event,this.m=this.B(new s.$Qd),this.onExit=this.m.event,this.n=this.B(new s.$Qd),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(i,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${i}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${i}`,o){case $.default.Error:this.u.error(r);break;case $.default.Warning:this.u.warn(r);break;case $.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",$.default.Error),!1):!0}start(i){const o=this.D(i);return o&&i.payload&&this.postMessage(i.payload),o}D(i){if(!this.C())return!1;this.t=i;const o=`${this.t.type}-${this.c}`,r=d.$fg.asFileUri("bootstrap-fork.js").fsPath,t=this.t.args??[],n=this.t.execArgv??[],c=this.t.allowLoadingUnsignedLibraries,m=this.t.forceAllocationsToV8Sandbox,D="pipe",R=this.F(i);return this.z("creating new...",$.default.Info),this.r=S.utilityProcess.fork(r,t,{serviceName:o,env:R,execArgv:n,allowLoadingUnsignedLibraries:c,forceAllocationsToV8Sandbox:m,stdio:D}),this.G(this.r,this.t,o),!0}F(i){const o=i.env?{...i.env}:{...(0,y.$_m)(process.env)};o.VSCODE_AMD_ENTRYPOINT=i.entryPoint,typeof i.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(i.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=i.type,w.$i&&((0,b.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,b.getUNCHostAllowlist)().join("\\")),(0,f.$Fl)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(i,o,r){if(i.stdout){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:t.write(n))))}if(i.stderr){const t=new C.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(i.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:t.write(n))))}this.B(s.Event.fromNodeEventEmitter(i,"message")(t=>this.h.fire(t))),this.B(s.Event.fromNodeEventEmitter(i,"spawn")(()=>{this.s=i.pid,typeof i.pid=="number"&&g.b.set(i.pid,{pid:i.pid,name:h(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",$.default.Info),this.j.fire(i.pid)})),this.B(s.Event.fromNodeEventEmitter(i,"exit")(t=>{this.z(`received exit event with code ${t}`,$.default.Info),this.m.fire({pid:this.s,code:t,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(S.app,"child-process-gone",(t,n)=>({event:t,details:n}))(({details:t})=>{t.type==="Utility"&&t.name===r&&(this.z(`crashed with code ${t.exitCode} and reason '${t.reason}'`,$.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:t.reason,code:t.exitCode}),this.n.fire({pid:this.s,code:t.exitCode,reason:t.reason}),this.H())}))}once(i,o){const r=this.B(this.h.event(t=>{t===i&&(r.dispose(),o())}))}postMessage(i,o){this.r&&this.r.postMessage(i,o)}connect(i){const{port1:o,port2:r}=new S.MessageChannelMain;return this.postMessage(i,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",$.default.Info);const i=process;return typeof i._debugProcess=="function"?(i._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",$.default.Info),this.r.kill()?(this.z("successfully killed the process",$.default.Info),this.H()):this.z("unable to kill the process",$.default.Warning)}H(){typeof this.s=="number"&&g.b.delete(this.s),this.r=void 0}async waitForExit(i){this.r&&(this.z("waiting to exit...",$.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,P.$Xg)(i)]),this.r&&(this.z(`did not exit within ${i}ms, will kill it now...`,$.default.Info),this.kill()))}};e.$k8b=l,e.$k8b=l=g=ve([te(0,M.$cj),te(1,p.$hl),te(2,v.$E7b)],l);let E=class extends l{constructor(i,o,r,t){super(i,r,t),this.I=o}start(i){const o=this.I.getWindowById(i.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",$.default.Error),!0;if(!super.D(i))return!1;this.J(o.win,i);const t=this.connect(i.payload);return o.win.webContents.postMessage(i.responseChannel,i.responseNonce,[t]),!0}J(i,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===i)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(i,"closed")(()=>this.kill())))}};e.$l8b=E,e.$l8b=E=ve([te(0,M.$cj),te(1,a.$d8b),te(2,p.$hl),te(3,v.$E7b)],E)}),define(ne[293],re([0,1,14,3,5,20,8,61,29,26]),function(J,e,S,A,s,M,C,P,d,a){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=void 0;let p=class{static{$=this}static{this.a=0}constructor(f,y,w,b){this.d=f,this.f=y,this.g=w,this.h=b,this.b=new Map,this.c=!1,this.f.onWillShutdown(g=>{this.c=!0,g.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(f){const y=this.b.get(f);if(!y)throw new Error("Unknown extension host!");return y}onDynamicStdout(f){return this.i(f).onStdout}onDynamicStderr(f){return this.i(f).onStderr}onDynamicMessage(f){return this.i(f).onMessage}onDynamicExit(f){return this.i(f).onExit}async createExtensionHost(){if(this.c)throw(0,S.$5)();const f=String(++$.a),y=new P.$l8b(this.d,this.g,this.h,this.f);return this.b.set(f,y),y.onExit(({pid:w,code:b,signal:g})=>{this.d.info(`Extension host with pid ${w} exited with code: ${b}, signal: ${g}.`),setTimeout(()=>{y.dispose(),this.b.delete(f)}),setTimeout(()=>{try{process.kill(w,0),this.d.error(`Extension host with pid ${w} still exists, forcefully killing it...`),process.kill(w)}catch{}},1e3)}),{id:f}}async start(f,y){if(this.c)throw(0,S.$5)();const w=this.i(f);return w.start({...y,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:y.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:f}),{pid:await A.Event.toPromise(w.onSpawn)}}async enableInspectPort(f){if(this.c)throw(0,S.$5)();const y=this.b.get(f);return y?y.enableInspectPort():!1}async kill(f){if(this.c)throw(0,S.$5)();const y=this.b.get(f);y&&y.kill()}async _killAllNow(){for(const[,f]of this.b)f.kill()}async _waitForAllExit(f){const y=[];for(const[,w]of this.b)y.push(w.waitForExit(f));return C.Promises.settled(y).then(()=>{})}};e.$s8b=p,e.$s8b=p=$=ve([te(0,s.$cj),te(1,M.$E7b),te(2,d.$d8b),te(3,a.$hl)],p)}),define(ne[294],re([0,1,36,8,2,24,20,5,41,39,68,61,51,90,12,247]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V8b=void 0;let b=class extends s.$Rc{constructor(h,l,E,u,i,o,r,t){super(),this.c=h,this.f=l,this.g=E,this.h=u,this.j=i,this.m=o,this.n=r,this.r=t,this.a=new A.$Vg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){S.$UT.on(w.$T8b.request,(h,l)=>this.t(h,l,w.$T8b.response)),S.$UT.on(w.$U8b.request,(h,l)=>this.t(h,l,w.$U8b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(h,l,E){this.m.trace(`[SharedProcess] onWindowConnection for: ${E}`),this.a.isOpen()||this.a.open(),await this.whenReady();const u=await this.connect(E);if(h.sender.isDestroyed())return u.close();h.sender.postMessage(E,l,[u])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$S8b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const h=new A.$hh;this.b?this.b.once(w.$S8b.initDone,()=>h.complete()):S.$UT.once(w.$S8b.initDone,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const h=new A.$hh;this.b?this.b.once(w.$S8b.ipcReady,()=>h.complete()):S.$UT.once(w.$S8b.ipcReady,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new p.$k8b(this.m,v.$qo,this.j));const h=(0,f.$qm)(this.g.args,this.g.isBuilt);let l;h.port&&(l=["--nolazy"],h.break?l.push(`--inspect-brk=${h.port}`):l.push(`--inspect=${h.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:l})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(h){return await this.z,(0,y.$Mf)(this.b).connect(h)}};e.$V8b=b,e.$V8b=b=ve([te(2,M.$C7b),te(3,d.$Pk),te(4,C.$E7b),te(5,P.$cj),te(6,$.$97b),te(7,a.$nn)],b)}),define(ne[295],re([0,1,24,90,20,5,51,61,110,36,2,3,38,17,13]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v9b=void 0;let w=class extends $.$Rc{constructor(g,h,l,E,u){super(),this.f=g,this.g=h,this.h=l,this.j=E,this.m=u,this.a=void 0,this.b=new p.$Qd,this.onRequestConnection=this.b.event,this.c=new p.$Qd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),a.$UT.on("vscode:createPtyHostMessageChannel",(i,o)=>this.r(i,o)),this.B((0,$.$Pc)(()=>{a.$UT.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new P.$k8b(this.m,C.$qo,this.j);const g=(0,A.$pm)(this.h.args,this.h.isBuilt),h=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const l=this.a.connect(),E=new d.$3T(l,"ptyHost"),u=new $.$Qc;return u.add(E),u.add((0,$.$Pc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,v.$_m)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},h=this.g.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(g.VSCODE_LATENCY=String(h));const l=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&(g.VSCODE_STARTUP_DELAY=String(l)),this.h.restoreSnapExportedVariables(),g}r(g,h){this.b.fire();const l=this.a.connect();if(g.sender.isDestroyed()){l.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[l])}};e.$v9b=w,e.$v9b=w=ve([te(1,f.$oi),te(2,S.$C7b),te(3,s.$E7b),te(4,M.$cj)],w)}),define(ne[296],re([0,1,2,6,5,29,61,26,56,3,8,20]),function(J,e,S,A,s,M,C,P,d,a,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u9b=e.$t9b=void 0,e.$t9b=(0,A.$Uh)("utilityProcessWorker");let v=class extends S.$Rc{constructor(w,b,g,h){super(),this.b=w,this.c=b,this.f=g,this.g=h,this.a=new Map}async createWorker(w){const b=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${b})`);const g=this.h(w);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${b})`),this.disposeWorker(w));const h=new f(this.b,this.c,this.f,this.g,w);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,h);const l=new $.$hh;return a.Event.once(h.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(g),l.complete({reason:E})}),l.p}h(w){return(0,d.$Ii)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const b=this.h(w),g=this.a.get(b);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),g.kill(),this.a.delete(b))}};e.$u9b=v,e.$u9b=v=ve([te(0,s.$cj),te(1,M.$d8b),te(2,P.$hl),te(3,p.$E7b)],v);let f=class extends S.$Rc{constructor(w,b,g,h,l){super(),this.c=w,this.f=b,this.g=g,this.h=h,this.j=l,this.a=this.B(new a.$Qd),this.onDidTerminate=this.a.event,this.b=new C.$l8b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const b=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:b,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};f=ve([te(0,s.$cj),te(1,M.$d8b),te(2,P.$hl),te(3,p.$E7b)],f)}),define(ne[297],re([0,1,15,3,2,273,29]),function(J,e,S,A,s,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b9b=void 0;let P=class extends s.$Rc{constructor(a){super(),this.b=a,this.a=this.B(new A.$Qd),this.onFoundInFrame=this.a.event,this.B(new M.$a9b)}async setIgnoreMenuShortcuts(a,$){let p;if(typeof a.windowId=="number"){const{windowId:v}=a,f=this.b.getWindowById(v);if(!f?.win)throw new Error(`Invalid windowId: ${v}`);p=f.win.webContents}else{const{webContentsId:v}=a;if(p=S.webContents.fromId(v),!p)throw new Error(`Invalid webContentsId: ${v}`)}p.isDestroyed()||p.setIgnoreMenuShortcuts($)}async findInFrame(a,$,p,v){const y=this.c(a,$);if(typeof y.findInFrame=="function"){y.findInFrame(p,{findNext:v.findNext,forward:v.forward});const w=(b,g)=>{g.finalUpdate&&(this.a.fire(g),y.removeListener("found-in-frame",w))};y.on("found-in-frame",w)}}async stopFindInFrame(a,$,p){const f=this.c(a,$);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(p.keepSelection?"keepSelection":"clearSelection")}c(a,$){const p=this.b.getWindowById(a.windowId);if(!p?.win)throw new Error(`Invalid windowId: ${a}`);const v=p.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===$);if(!v)throw new Error(`Unknown frame: ${$}`);return v}};e.$b9b=P,e.$b9b=P=ve([te(0,C.$d8b)],P)}),define(ne[298],re([0,1,15,2,4,19,7,17,20,5,34,29,128,30]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$e9b=e.$d9b=e.$c9b=void 0;let w=class extends A.$Rc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(u,i,o,r,t){super(),this.g=u,this.h=i,this.j=o,this.m=r,this.n=t,this.b=b(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){S.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(u=>this.u(u)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(u=>this.u(u))}s(){this.f=!0,this.t()}t(){const u=new Set,i={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!i.lastActiveWindow){let t=this.g.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),t&&(i.lastActiveWindow=this.w(t),i.lastActiveWindow.uiState.mode===3&&u.add(i.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(i.lastPluginDevelopmentHostWindow=this.w(o),i.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(i.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(i.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(i.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(i.openedWindows=this.g.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>{const n=this.w(t);return n.uiState.mode===3&&(u.has(n.uiState.display)?s.$j&&n.windowId!==i.lastActiveWindow?.windowId&&!t.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const r=h(i);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(u){if(this.j.quitRequested)return;const i=this.w(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=i:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,f.$0h)(u.openedWorkspace)&&o.workspace?.id===u.openedWorkspace.id,t=(0,f.$5h)(u.openedWorkspace)&&o.folderUri&&M.$pg.isEqual(o.folderUri,u.openedWorkspace.uri);(r||t)&&(o.uiState=i.uiState)}),this.g.getWindowCount()===1&&(this.c=i)}w(u){return{windowId:u.id,workspace:(0,f.$0h)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,f.$5h)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const i=this.z(u),o=this.n.getValue("window");if(i.mode===3){let r;i.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(i.mode=1)}return i}z(u){const i=this.g.getLastActiveWindow();if(!u.extensionTestsPath){if(u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const m=u.workspace;if((0,f.$0h)(m)){const R=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===m.id).map(k=>k.uiState);if(R.length)return R[0]}if((0,f.$5h)(m)){const R=this.state.openedWindows.filter(k=>k.folderUri&&M.$pg.isEqual(k.folderUri,m.uri)).map(k=>k.uiState);if(R.length)return R[0]}else if(u.backupPath){const R=this.state.openedWindows.filter(k=>k.backupPath===u.backupPath).map(k=>k.uiState);if(R.length)return R[0]}const D=this.c||this.state.lastActiveWindow;if(!i&&D)return D.uiState}let o;const r=S.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const m=S.screen.getCursorScreenPoint();o=S.screen.getDisplayNearestPoint(m)}!o&&i&&(o=S.screen.getDisplayMatching(i.getBounds())),o||(o=S.screen.getPrimaryDisplay()||r[0])}let t=(0,v.$B7b)();t.x=Math.round(o.bounds.x+o.bounds.width/2-t.width/2),t.y=Math.round(o.bounds.y+o.bounds.height/2-t.height/2);const n=this.n.getValue("window");let c=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")t.mode=0,c=!1;else if(n.newWindowDimensions==="fullscreen")t.mode=3,c=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&i){const m=i.serializeWindowState();m.mode===3?t.mode=3:t=m,c=t.mode!==3&&n.newWindowDimensions==="offset"}}return c&&(t=this.C(t)),t.hasDefaultState=!0,t}C(u){if(this.g.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const i=this.g.getWindows().map(o=>o.getBounds());for(;i.some(o=>o.x===u.x||o.y===u.y);)u.x+=30,u.y+=30;return u}};e.$c9b=w,e.$c9b=w=y=ve([te(0,p.$d8b),te(1,$.$QN),te(2,d.$E7b),te(3,a.$cj),te(4,P.$oi)],w);function b(E){const u={openedWindows:[]},i=E||{openedWindows:[]};return i.lastActiveWindow&&(u.lastActiveWindow=g(i.lastActiveWindow)),i.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=g(i.lastPluginDevelopmentHostWindow)),Array.isArray(i.openedWindows)&&(u.openedWindows=i.openedWindows.map(o=>g(o))),u}e.$d9b=b;function g(E){const u={uiState:E.uiState};return E.backupPath&&(u.backupPath=E.backupPath),E.remoteAuthority&&(u.remoteAuthority=E.remoteAuthority),E.folder&&(u.folderUri=C.URI.parse(E.folder)),E.workspaceIdentifier&&(u.workspace={id:E.workspaceIdentifier.id,configPath:C.URI.parse(E.workspaceIdentifier.configURIPath)}),u}function h(E){return{lastActiveWindow:E.lastActiveWindow&&l(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&l(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(u=>l(u))}}e.$e9b=h;function l(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(ne[54],re([0,1,15,3,44,2,13,9,19,21,194,65,52,24,6,5,53,130,30,97,98]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=e.$77b=void 0,e.$77b=(0,y.$Uh)("workspacesManagementMainService");let u=class extends M.$Rc{constructor(o,r,t,n,c){super(),this.g=o,this.h=r,this.j=t,this.m=n,this.n=c,this.a=this.B(new A.$Qd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new A.$Qd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await a.Promises.readdir(this.c.with({scheme:C.Schemas.file}).fsPath)).map(r=>(0,d.$yg)(this.c,r,h.$hi));for(const r of o){const t=(0,E.$47b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:t,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(t)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>a.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===C.Schemas.file)try{const t=r(o.fsPath);return t instanceof Promise?t.then(n=>this.t(o,n),n=>{}):this.t(o,t)}catch{return}}s(o){return(0,h.$ii)(o,this.g)||(0,h.$ni)(o)}t(o,r){try{const t=this.u(o,r),n=(0,E.$47b)(o);return{id:n.id,configPath:n.configPath,folders:(0,l.$lV)(t.folders,n.configPath,d.$pg),remoteAuthority:t.remoteAuthority,transient:t.transient}}catch(t){this.h.warn(t.toString())}}u(o,r){const t=(0,s.$2m)(r);if(t&&Array.isArray(t.folders))t.folders=t.folders.filter(n=>(0,l.$jV)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return t}async createUntitledWorkspace(o,r){const{workspace:t,storedWorkspace:n}=this.w(o,r),c=t.configPath.fsPath;return await a.Promises.mkdir((0,P.$lc)(c),{recursive:!0}),await a.Promises.writeFile(c,JSON.stringify(n,null,"	")),this.f.push({workspace:t,remoteAuthority:r}),t}w(o=[],r){const t=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,d.$yg)(this.c,t),c=(0,d.$yg)(n,h.$hi),m=[];for(const D of o)m.push((0,l.$kV)(D.uri,!0,D.name,n,d.$pg));return{workspace:(0,E.$47b)(c),storedWorkspace:{folders:m,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,E.$47b)(o)}isUntitledWorkspace(o){return(0,h.$ii)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,d.$mg)(o.configPath);try{await a.Promises.rm((0,P.$lc)(r));const t=(0,P.$ic)(this.g.workspaceStorageHome.with({scheme:C.Schemas.file}).fsPath,o.id);await a.Promises.exists(t)&&await a.Promises.writeFile((0,P.$ic)(t,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(t){this.h.warn(`Unable to delete untitled workspace ${r} (${t}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,t){if(!o||!o.win||!o.isReady||!await this.z(o,r,t))return;const c=await this.C(o,(0,E.$47b)(t));if(c)return this.b.fire({window:o,workspace:c.workspace}),c}async z(o,r,t){return t?(0,h.$0h)(o.openedWorkspace)&&d.$pg.isEqual(o.openedWorkspace.configPath,t)?!1:(0,g.$17b)(r,t)?(await this.n.showMessageBox({type:"info",buttons:[(0,$.localize)(0,null)],message:(0,$.localize)(1,null,(0,d.$vg)(t)),detail:(0,$.localize)(2,null)},S.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let t;return o.config.extensionDevelopmentPath||(o.config.backupPath?t=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):t=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,h.$0h)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=t,{workspace:r,backupPath:t}}};e.$87b=u,e.$87b=u=ve([te(0,f.$C7b),te(1,w.$cj),te(2,b.$K7b),te(3,p.$V7b),te(4,v.$W7b)],u)}),define(ne[132],re([0,1,15,36,22,6,29,30,54,12,5,61]),function(J,e,S,A,s,M,C,P,d,a,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o8b=e.$n8b=e.ID=void 0,e.ID="diagnosticsMainService",e.$n8b=(0,M.$Uh)(e.ID);let v=class{constructor(y,w,b){this.a=y,this.b=w,this.c=b}async getRemoteDiagnostics(y){const w=this.a.getWindows();return(await Promise.all(w.map(async g=>{const h=g.remoteAuthority;if(!h)return;const l=`vscode:getDiagnosticInfoResponse${g.id}`,E={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(u=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:l,args:E}),A.$UT.once(l,(i,o)=>{o||u({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),u(o)}),setTimeout(()=>{u({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const b of S.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(b.id);g?y.push(await this.d(g)):y.push(this.e(b))}const w=[];for(const{pid:b,name:g}of p.$k8b.getAll())w.push({pid:b,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:w,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async d(y){const w=await this.f(y),b=(0,a.$Mf)(y.win);return this.e(b,w,y.remoteAuthority)}e(y,w=[],b){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:w,remoteAuthority:b}}async f(y){const w=[],b=y.openedWorkspace;if((0,P.$5h)(b))w.push(b.uri);else if((0,P.$0h)(b)){const g=await this.b.resolveLocalWorkspace(b.configPath);g&&g.folders.forEach(l=>{w.push(l.uri)})}return w}};e.$o8b=v,e.$o8b=v=ve([te(0,C.$d8b),te(1,d.$77b),te(2,$.$cj)],v)}),define(ne[70],re([0,1,47,15,28,156,55,3,2,13,9,4,7,105,88,21,103,182,52,24,6,20,5,25,69,29,30,54,18,243,235,64]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u,i,o,r,t,n,c,m,D,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C8b=e.$B8b=void 0,e.$B8b=(0,E.$Uh)("nativeHostMainService");let I=class extends d.$Rc{constructor(U,T,x,Y,ce,oe,ae,Z,K,G){super(),this.a=U,this.b=T,this.c=x,this.f=Y,this.g=ce,this.h=oe,this.j=ae,this.m=Z,this.n=K,this.r=G,this.onDidOpenMainWindow=P.Event.map(this.a.onDidOpenWindow,z=>z.id),this.onDidTriggerMainWindowSystemContextMenu=P.Event.filter(P.Event.map(this.a.onDidTriggerSystemContextMenu,({window:z,x:N,y:H})=>({windowId:z.id,x:N,y:H})),({windowId:z})=>!!this.a.getWindowById(z)),this.onDidMaximizeMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-maximize",(z,N)=>N.id),z=>!!this.a.getWindowById(z)),this.onDidUnmaximizeMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-unmaximize",(z,N)=>N.id),z=>!!this.a.getWindowById(z)),this.onDidBlurMainWindow=P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(z,N)=>N.id),z=>!!this.a.getWindowById(z)),this.onDidFocusMainWindow=P.Event.any(P.Event.map(P.Event.filter(P.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),z=>!!z),z=>z.id),P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(z,N)=>N.id),z=>!!this.a.getWindowById(z))),this.onDidBlurMainOrAuxiliaryWindow=P.Event.any(this.onDidBlurMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-blur",(z,N)=>N),z=>(0,k.$c8b)(z.webContents)),z=>z.id)),this.onDidFocusMainOrAuxiliaryWindow=P.Event.any(this.onDidFocusMainWindow,P.Event.map(P.Event.filter(P.Event.fromNodeEventEmitter(A.app,"browser-window-focus",(z,N)=>N),z=>(0,k.$c8b)(z.webContents)),z=>z.id)),this.onDidResumeOS=P.Event.fromNodeEventEmitter(A.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new P.$Qd),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=P.Event.debounce(P.Event.any(P.Event.filter(P.Event.fromNodeEventEmitter(A.screen,"display-metrics-changed",(z,N,H)=>H),z=>!(Array.isArray(z)&&z.length===1&&z[0]==="workArea")),P.Event.fromNodeEventEmitter(A.screen,"display-added"),P.Event.fromNodeEventEmitter(A.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(U,T){const x=this.a.getWindows().map(ce=>({id:ce.id,workspace:ce.openedWorkspace??(0,n.$9h)(ce.backupPath,ce.isExtensionDevelopmentHost),title:ce.win?.getTitle()??"",filename:ce.getRepresentedFilename(),dirty:ce.isDocumentEdited()})),Y=[];return T.includeAuxiliaryWindows&&Y.push(...this.b.getWindows().map(ce=>({id:ce.id,parentId:ce.parentId,title:ce.win?.getTitle()??"",filename:ce.getRepresentedFilename()}))),[...x,...Y]}async getWindowCount(U){return this.a.getWindowCount()}async getActiveWindowId(U){const T=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(U,T,x){return Array.isArray(T)?this.t(U,T,x):this.u(U,T)}async t(U,T,x=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:U,urisToOpen:T,cli:this.g.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0,forceProfile:x.forceProfile,forceTempProfile:x.forceTempProfile})}async u(U,T){await this.a.openEmptyWindow({context:5,contextWindowId:U},T)}async toggleFullScreen(U,T){this.D(T?.targetWindowId,U)?.toggleFullScreen()}async handleTitleDoubleClick(U){this.F(U)?.handleTitleDoubleClick()}async isMaximized(U){const T=this.F(U);return T?.win?T.win.isMaximized():!1}async maximizeWindow(U){const T=this.F(U);T?.win&&T.win.maximize()}async unmaximizeWindow(U){const T=this.F(U);T?.win&&T.win.unmaximize()}async minimizeWindow(U){const T=this.F(U);T?.win&&T.win.minimize()}async moveWindowTop(U,T){const x=this.D(T?.targetWindowId,U);x?.win&&x.win.moveTop()}async positionWindow(U,T,x){const Y=this.D(x?.targetWindowId)??this.F(U);if(Y?.win){if(Y.win.isFullScreen()){const ce=P.Event.toPromise(P.Event.once(P.Event.fromNodeEventEmitter(Y.win,"leave-full-screen")));Y.win.setFullScreen(!1),await ce}Y.win.setBounds(T)}}async updateWindowControls(U,T){const x=this.F(U);x&&x.updateWindowControls(T)}async focusWindow(U,T){this.D(T?.targetWindowId,U)?.focus({force:T?.force??!1})}async setMinimumSize(U,T,x){const Y=this.F(U);if(Y?.win){const[ce,oe]=Y.win.getSize(),[ae,Z]=Y.win.getMinimumSize(),[K,G]=[T??ae,x??Z],[z,N]=[Math.max(ce,K),Math.max(oe,G)];(ae!==K||Z!==G)&&Y.win.setMinimumSize(K,G),(ce!==z||oe!==N)&&Y.win.setSize(z,N)}}async saveWindowSplash(U,T){this.m.saveWindowSplash(U,T)}async installShellCommand(U){const{source:T,target:x}=await this.w();try{const{symbolicLink:Y}=await w.SymlinkSupport.stat(T);if(Y&&!Y.dangling){const ce=await(0,f.$_p)(T);if(x===ce)return}await w.Promises.unlink(T)}catch(Y){if(Y.code!=="ENOENT")throw Y}try{await w.Promises.symlink(x,T)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="ENOENT")throw Y;const{response:ce}=await this.showMessageBox(U,{type:"info",message:(0,g.localize)(0,null,this.j.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ce===0)try{const oe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${T}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(oe)}catch{throw new Error((0,g.localize)(3,null,T))}}}async uninstallShellCommand(U){const{source:T}=await this.w();try{await w.Promises.unlink(T)}catch(x){switch(x.code){case"EACCES":{const{response:Y}=await this.showMessageBox(U,{type:"info",message:(0,g.localize)(4,null,this.j.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(Y===0)try{const ce=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,M.promisify)(S.exec)(ce)}catch{throw new Error((0,g.localize)(7,null,T))}break}case"ENOENT":break;default:throw x}}}async w(){const U=(0,$.$jc)(this.g.appRoot,"bin","code"),T=`/usr/local/bin/${this.j.applicationName}`;if(!await w.Promises.exists(U))throw new Error((0,g.localize)(8,null,U));return{source:T,target:U}}async showMessageBox(U,T){const x=this.H(U);return this.c.showMessageBox(T,x?.win??void 0)}async showSaveDialog(U,T){const x=this.H(U);return this.c.showSaveDialog(T,x?.win??void 0)}async showOpenDialog(U,T){const x=this.H(U);return this.c.showOpenDialog(T,x?.win??void 0)}async pickFileFolderAndOpen(U,T){const x=await this.c.pickFileFolder(T);x&&await this.z(await Promise.all(x.map(async Y=>await w.SymlinkSupport.existsDirectory(Y)?{folderUri:v.URI.file(Y)}:{fileUri:v.URI.file(Y)})),T,U)}async pickFolderAndOpen(U,T){const x=await this.c.pickFolder(T);x&&await this.z(x.map(Y=>({folderUri:v.URI.file(Y)})),T,U)}async pickFileAndOpen(U,T){const x=await this.c.pickFile(T);x&&await this.z(x.map(Y=>({fileUri:v.URI.file(Y)})),T,U)}async pickWorkspaceAndOpen(U,T){const x=await this.c.pickWorkspace(T);x&&await this.z(x.map(Y=>({workspaceUri:v.URI.file(Y)})),T,U)}async z(U,T,x){await this.a.open({context:3,contextWindowId:x,cli:this.g.args,urisToOpen:U,forceNewWindow:T.forceNewWindow})}async showItemInFolder(U,T){A.shell.showItemInFolder(T)}async setRepresentedFilename(U,T,x){this.D(x?.targetWindowId,U)?.setRepresentedFilename(T)}async setDocumentEdited(U,T,x){this.D(x?.targetWindowId,U)?.setDocumentEdited(T)}async openExternal(U,T){return this.g.unsetSnapExportedVariables(),A.shell.openExternal(T),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(U,T){return A.shell.trashItem(T)}async isAdmin(){let U;return p.$i?U=(await new Promise((T,x)=>{J(["native-is-elevated"],T,x)}))():U=process.getuid?.()===0,U}async writeElevated(U,T,x,Y){const ce=await new Promise((oe,ae)=>{J(["@vscode/sudo-prompt"],oe,ae)});return new Promise((oe,ae)=>{const Z=[`"${this.C}"`];Y?.unlock&&Z.push("--file-chmod"),Z.push("--file-write",`"${T.fsPath}"`,`"${x.fsPath}"`);const K={name:this.j.nameLong.replace("-",""),icns:p.$j&&this.g.isBuilt?(0,$.$ic)((0,$.$lc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ce.exec(Z.join(" "),K,(G,z,N)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),N&&this.h.trace(`[sudo-prompt] received stderr: ${N}`),G?ae(G):oe(void 0)})})}async isRunningUnderARM64Translation(){return p.$k||p.$i?!1:A.app.runningUnderARM64Translation}get C(){return p.$i?this.g.isBuilt?(0,$.$ic)((0,$.$lc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,$.$ic)(this.g.appRoot,"scripts","code-cli.bat"):p.$k?this.g.isBuilt?(0,$.$ic)((0,$.$lc)(process.execPath),"bin",`${this.j.applicationName}`):(0,$.$ic)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,$.$ic)(this.g.appRoot,"bin","code"):(0,$.$ic)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$Wm.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return p.$i&&(0,D.$z8b)()}async killProcess(U,T,x){process.kill(T,x)}async readClipboardText(U,T){return A.clipboard.readText(T)}async writeClipboardText(U,T,x){return A.clipboard.writeText(T,x)}async readClipboardFindText(U){return A.clipboard.readFindText()}async writeClipboardFindText(U,T){return A.clipboard.writeFindText(T)}async writeClipboardBuffer(U,T,x,Y){return A.clipboard.writeBuffer(T,Buffer.from(x.buffer),Y)}async readClipboardBuffer(U,T){return m.$ee.wrap(A.clipboard.readBuffer(T))}async hasClipboard(U,T,x){return A.clipboard.has(T,x)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){A.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){A.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){A.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){A.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){A.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(U,T){this.F(U)?.updateTouchBar(T)}async notifyReady(U){this.F(U)?.setReady()}async relaunch(U,T){return this.f.relaunch(T)}async reload(U,T){const x=this.F(U);if(x){if((0,n.$0h)(x.openedWorkspace)){const Y=x.openedWorkspace.configPath;if(Y.scheme===a.Schemas.file&&(await this.n.resolveLocalWorkspace(Y))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.f.reload(x,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(U){this.closeWindowById(U,U)}async closeWindowById(U,T){return(this.D(T)??this.F(T))?.win?.close()}async quit(U){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.f.quit()}async exit(U,T){await this.f.kill(T)}async resolveProxy(U,T){return this.F(U)?.win?.webContents?.session?.resolveProxy(T)}findFreePort(U,T,x,Y,ce=1){return(0,b.$jg)(T,x,Y,ce)}async openDevTools(U,T){this.H(U)?.win?.webContents.openDevTools(T)}async toggleDevTools(U){this.H(U)?.win?.webContents.toggleDevTools()}async sendInputEvent(U,T){const x=this.F(U);x?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&x.win.webContents.sendInputEvent(T)}async profileRenderer(U,T,x){const Y=this.F(U);if(!Y||!Y.win)throw new Error;return await new R.$A8b(Y.win,T,this.h).inspect(x)}async windowsGetStringRegKey(U,T,x,Y){if(!p.$i)return;const ce=await new Promise((oe,ae)=>{J(["@vscode/windows-registry"],oe,ae)});try{return ce.GetStringRegKey(T,x,Y)}catch{return}}D(U,T){return this.F(U)??this.G(U)??this.F(T)}F(U){if(typeof U=="number")return this.a.getWindowById(U)}G(U){if(typeof U=="number")return this.b.getWindowById(U)}H(U){let T=this.r.invokeFunction(t.$f8b);return T||(T=this.D(U)),T}};e.$C8b=I,ve([C.$mh],I.prototype,"C",null),e.$C8b=I=ve([te(0,t.$d8b),te(1,k.$b8b),te(2,h.$W7b),te(3,u.$E7b),te(4,l.$C7b),te(5,i.$cj),te(6,o.$uj),te(7,r.$Q7b),te(8,c.$77b),te(9,E.$Th)],I)}),define(ne[299],re([0,1,15,28,8,22,33,2,13,4,7,107,36,180,91,132,52,24,5,70,79,25,80,34,61,60,29]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u,i,o,r,t,n){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$D8b=void 0;const m="issue.processExplorerWindowState";let D=class{static{c=this}static{this.a="#1E1E1E"}constructor(I,F,U,T,x,Y,ce,oe,ae,Z,K){this.g=I,this.h=F,this.i=U,this.j=T,this.k=x,this.l=Y,this.m=ce,this.n=oe,this.o=ae,this.p=Z,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){v.$UT.on("vscode:listProcesses",async I=>{const F=[];try{F.push({name:(0,f.localize)(0,null),rootProcess:await(0,p.$Ir)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,y.$wm)(T)?F.push({name:T.hostName,rootProcess:T}):T.processes&&F.push({name:T.hostName,rootProcess:T.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(I,"vscode:listProcessesResponse",F)}),v.$UT.on("vscode:workbenchCommand",(I,F)=>{const{id:U,from:T,args:x}=F;let Y;switch(T){case"processExplorer":Y=this.f;break;default:throw new Error(`Unexpected command source: ${T}`)}Y?.webContents.send("vscode:runAction",{id:U,from:T,args:x})}),v.$UT.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),v.$UT.on("vscode:pidToNameRequest",async I=>{const F=await this.k.getMainDiagnostics(),U=[];for(const T of F.windows)U.push([T.pid,`window [${T.id}] (${T.title})`]);for(const{pid:T,name:x}of r.$k8b.getAll())U.push([T,x]);this.t(I,"vscode:pidToNameResponse",U)})}async openReporter(I){if(!this.b&&(this.c=S.BrowserWindow.getFocusedWindow(),this.c)){const F=new P.$Qc,U=F.add(this.n.createIPCObjectUrl()),T=this.v(this.c,700,800);this.b=this.u(T,U,{backgroundColor:I.styles.backgroundColor,title:(0,f.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:E.default}),this.b.loadURL(d.$fg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,F.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,F.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(I){if(!this.d&&(this.f=S.BrowserWindow.getFocusedWindow(),this.f)){const F=new P.$Qc,U=F.add(this.n.createIPCObjectUrl()),T=this.p.getItem(m,void 0),x=R(T)?T:this.v(this.f,800,500);this.d=this.u(x,U,{backgroundColor:I.styles.backgroundColor,title:(0,f.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:E.default}),this.d.loadURL(d.$fg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,F.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,F.dispose())});const Y=()=>{if(!this.d)return;const ce=this.d.getSize(),oe=this.d.getPosition();if(!ce||!oe)return;const ae={width:ce[0],height:ce[1],x:oe[0],y:oe[1]};this.p.setItem(m,ae)};this.d.on("moved",Y),this.d.on("resized",Y)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await S.contentTracing.stopRecording(`${(0,C.$9f)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null,I),buttons:[(0,f.localize)(5,null)]},S.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,F]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,F)}async $getSystemInfo(){const[I,F]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,F)}async $getPerformanceInfo(){try{const[I,F]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,F)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,f.localize)(6,null),buttons:[(0,f.localize)(7,null),(0,f.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,f.localize)(9,null),buttons:[(0,f.localize)(10,null),(0,f.localize)(11,null)]},this.b);return I===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const I=this.q.getWindowById(this.c.id);if(!I)throw new Error("Window not found");return I}async $getIssueReporterUri(I){const F=this.issueReporterWindowCheck(),U=`vscode:triggerIssueUriRequestHandlerResponse${F.id}`;return s.Promises.withAsyncBody(async(T,x)=>{const Y=new M.$1d;F.sendWhenReady("vscode:triggerIssueUriRequestHandler",Y.token,{replyChannel:U,extensionId:I}),v.$UT.once(U,(ce,oe)=>{T($.URI.parse(oe))});try{await(0,s.$Xg)(5e3),Y.cancel(),x(new Error("Timed out waiting for issue reporter URI"))}finally{v.$UT.removeHandler(U)}})}async $getIssueReporterData(I){const F=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataProviderResponse${F.id}`;return s.Promises.withAsyncBody(async T=>{const x=new M.$1d;F.sendWhenReady("vscode:triggerIssueDataProvider",x.token,{replyChannel:U,extensionId:I}),v.$UT.once(U,(Y,ce)=>{T(ce)});try{await(0,s.$Xg)(5e3),x.cancel(),T("Error: Extension timed out waiting for issue reporter data")}finally{v.$UT.removeHandler(U)}})}async $getIssueReporterTemplate(I){const F=this.issueReporterWindowCheck(),U=`vscode:triggerIssueDataTemplateResponse${F.id}`;return s.Promises.withAsyncBody(async T=>{const x=new M.$1d;F.sendWhenReady("vscode:triggerIssueDataTemplate",x.token,{replyChannel:U,extensionId:I}),v.$UT.once(U,(Y,ce)=>{T(ce)});try{await(0,s.$Xg)(5e3),x.cancel(),T("Error: Extension timed out waiting for issue reporter template")}finally{v.$UT.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,F,...U){I.sender.isDestroyed()||I.sender.send(F,...U)}u(I,F,U,T){const x=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:U.title,backgroundColor:U.backgroundColor||c.a,webPreferences:{preload:d.$fg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${F.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,t.$tC)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return x.setMenuBarVisibility(!1),x}v(I,F,U){let T;const x=S.screen.getAllDisplays();if(x.length===1)T=x[0];else{if(a.$j){const oe=S.screen.getCursorScreenPoint();T=S.screen.getDisplayNearestPoint(oe)}!T&&I&&(T=S.screen.getDisplayMatching(I.getBounds())),T||(T=S.screen.getPrimaryDisplay()||x[0])}const Y=T.bounds,ce={width:F,height:U,x:Y.x+Y.width/2-F/2,y:Y.y+Y.height/2-U/2};return Y.width>0&&Y.height>0&&(ce.x<Y.x&&(ce.x=Y.x),ce.y<Y.y&&(ce.y=Y.y),ce.x>Y.x+Y.width&&(ce.x=Y.x),ce.y>Y.y+Y.height&&(ce.y=Y.y),ce.width>Y.width&&(ce.width=Y.width),ce.height>Y.height&&(ce.height=Y.height)),ce}};e.$D8b=D,e.$D8b=D=c=ve([te(1,g.$C7b),te(2,h.$cj),te(3,y.$vm),te(4,w.$n8b),te(5,b.$W7b),te(6,l.$B8b),te(7,i.$Y7b),te(8,u.$uj),te(9,o.$QN),te(10,n.$d8b)],D);function R(k){return typeof k!="object"||k===null?!1:"x"in k&&"y"in k&&"width"in k&&"height"in k}}),define(ne[300],re([0,1,22,17,24,20,5,70,25,50,26,48,100]),function(J,e,S,A,s,M,C,P,d,a,$,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$58b=void 0;let f=class extends v.$38b{constructor(w,b,g,h,l,E,u,i){super(w,b,h,l,E,i),this.e=g,this.u=u}s(w){return(0,v.$28b)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(p.$TU.CheckingForUpdates(w)),this.i.request({url:this.a},S.CancellationToken.None).then(a.$4o).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(p.$TU.Idle(1))):this.d(p.$TU.AvailableForDownload(b))}).then(void 0,b=>{this.j.error(b),this.e.publicLog2("update:notAvailable",{explicit:!!w});const g=w?b.message||b:void 0;this.d(p.$TU.Idle(1,g))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(p.$TU.Idle(1))}};e.$58b=f,e.$58b=f=ve([te(0,M.$E7b),te(1,A.$oi),te(2,$.$hl),te(3,s.$C7b),te(4,a.$Xo),te(5,C.$cj),te(6,P.$B8b),te(7,d.$uj)],f)}),define(ne[301],re([0,1,47,45,28,8,22,55,9,7,144,21,17,24,16,20,5,70,25,50,26,48,100]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$78b=void 0;async function o(c,m=1e3){for(;!c();)await(0,M.$Xg)(m)}let r;function t(){return typeof r>"u"&&(r=A.existsSync(d.$ic(d.$lc(process.execPath),"unins000.exe"))?0:1),r}let n=class extends i.$38b{get cachePath(){const m=d.$ic((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return p.Promises.mkdir(m,{recursive:!0}).then(()=>m)}constructor(m,D,R,k,I,F,U,T,x){super(m,D,k,I,F,x),this.u=R,this.v=U,this.w=T,m.setRelaunchHandler(this)}handleRelaunch(m){return m?.addArgs||m?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$TU.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(m){let D=`win32-${process.arch}`;return t()===1?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,i.$28b)(D,m,this.k)}t(m){this.a&&(this.d(u.$TU.CheckingForUpdates(m)),this.i.request({url:this.a},C.CancellationToken.None).then(l.$4o).then(D=>{const R=t();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!m}),this.d(u.$TU.Idle(R)),Promise.resolve(null)):R===1?(this.d(u.$TU.AvailableForDownload(D)),Promise.resolve(null)):(this.d(u.$TU.Downloading(D)),this.C(D.version).then(()=>this.B(D.version).then(k=>p.Promises.exists(k).then(I=>{if(I)return Promise.resolve(k);const F=D.url,U=D.hash,T=`${k}.tmp`;return this.i.request({url:F},C.CancellationToken.None).then(x=>this.v.writeFile(a.URI.file(T),x.stream)).then(U?()=>(0,$.$PT)(T,D.hash):()=>{}).then(()=>p.Promises.rename(T,k,!1)).then(()=>k)})).then(k=>{const I=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(u.$TU.Downloaded(D)):this.d(u.$TU.Ready(D))})))}).then(void 0,D=>{this.j.error(D),this.u.publicLog2("update:notAvailable",{explicit:!!m});const R=m?D.message||D:void 0;this.d(u.$TU.Idle(t(),R))}))}async o(m){m.update.url&&this.w.openExternal(void 0,m.update.url),this.d(u.$TU.Idle(t()))}async B(m){const D=await this.cachePath;return d.$ic(D,`CodeSetup-${this.k.quality}-${m}.exe`)}async C(m=null){const D=m?F=>!new RegExp(`${this.k.quality}-${m}\\.exe$`).test(F):()=>!0,R=await this.cachePath,I=(await p.Promises.readdir(R)).filter(D).map(async F=>{try{await p.Promises.unlink(d.$ic(R,F))}catch{}});await Promise.all(I)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const m=this.state.update;this.d(u.$TU.Updating(m));const D=await this.cachePath;this.e.updateFilePath=d.$ic(D,`CodeSetup-${this.k.quality}-${m.version}.flag`),await p.Promises.writeFile(this.e.updateFilePath,"flag"),(0,S.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$TU.Idle(t()))});const k=`${this.k.win32MutexName}-ready`,I=await new Promise((F,U)=>{J(["@vscode/windows-mutex"],F,U)});o(()=>I.isActive(k)).then(()=>this.d(u.$TU.Ready(m)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?A.unlinkSync(this.e.updateFilePath):(0,S.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return t()}async _applySpecificUpdate(m){if(this.state.type!=="idle")return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),R={version:"unknown",productVersion:"unknown"};this.d(u.$TU.Downloading(R)),this.e={packagePath:m},D?this.k.target==="user"?this.p():this.d(u.$TU.Downloaded(R)):this.d(u.$TU.Ready(R))}};e.$78b=n,ve([P.$mh],n.prototype,"cachePath",null),e.$78b=n=ve([te(0,w.$E7b),te(1,v.$oi),te(2,E.$hl),te(3,f.$C7b),te(4,l.$Xo),te(5,b.$cj),te(6,y.$dk),te(7,g.$B8b),te(8,h.$uj)],n)}),define(ne[133],re([0,1,15,8,22,49,3,2,13,67,4,7,190,65,17,52,24,63,16,20,5,25,80,252,82,26,102,69,60,29,30,54,128,136,39,34,53,68,23,6]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u,i,o,r,t,n,c,m,D,R,k,I,F,U,T,x,Y,ce,oe){"use strict";var ae;Object.defineProperty(e,"__esModule",{value:!0}),e.$_7b=e.$$7b=void 0;var Z;(function(z){z[z.NONE=0]="NONE",z[z.NAVIGATING=1]="NAVIGATING",z[z.READY=2]="READY"})(Z||(Z={}));class K extends P.$Rc{constructor(N){super(),this.a=N,this.f=void 0,this.g=void 0}setRepresentedFilename(N){$.$j?this.win?.setRepresentedFilename(N):this.b=N}getRepresentedFilename(){return $.$j?this.win?.getRepresentedFilename():this.b}setDocumentEdited(N){$.$j&&this.win?.setDocumentEdited(N),this.c=N}isDocumentEdited(){return $.$j?!!this.win?.isDocumentEdited():!!this.c}focus(N){$.$j&&N?.force&&S.app.focus({steal:!0});const H=this.win;H&&(H.isMinimized()&&H.restore(),H.focus())}toggleFullScreen(){this.h(!this.isFullScreen)}h(N){this.r()?this.j(N):this.n(N)}get isFullScreen(){if($.$j&&typeof this.f=="boolean")return this.f;const N=this.win,H=N?.isFullScreen(),q=N?.isSimpleFullScreen();return!!(H||q)}j(N){const H=this.win;H?.isSimpleFullScreen()&&H?.setSimpleFullScreen(!1),this.m(N)}m(N){$.$j&&(this.f=N,this.g=new A.$hh,Promise.race([this.g.p,(0,A.$Xg)(1e4)]).finally(()=>{this.f=void 0})),this.win?.setFullScreen(N)}n(N){const H=this.win;H?.isFullScreen()&&this.m(!1),H?.setSimpleFullScreen(N),H?.webContents.focus()}r(){const N=this.a.getValue("window");return!N||typeof N.nativeFullScreen!="boolean"||N.nativeTabs?!0:N.nativeFullScreen!==!1}}e.$$7b=K;let G=class extends K{static{ae=this}static{this.s="windowControlHeight"}get id(){return this.D}get win(){return this.F}get lastFocusTime(){return this.G}get backupPath(){return this.H?.backupPath}get openedWorkspace(){return this.H?.workspace}get profile(){if(!this.config)return;const N=this.Z.profiles.find(H=>H.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&N?N:this.Z.getProfileForWorkspace(this.config.workspace??(0,R.$9h)(this.backupPath,this.isExtensionDevelopmentHost))??this.Z.defaultProfile}get remoteAuthority(){return this.H?.remoteAuthority}get config(){return this.H}get isExtensionDevelopmentHost(){return!!this.H?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.H?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.H?.debugId}constructor(N,H,q,ee,se,Q,O,j,V,L,B,W,X,he,de,le,we,be,Ee,Se,Le){super(L),this.U=H,this.W=q,this.X=ee,this.Y=se,this.Z=Q,this.$=O,this.ab=j,this.bb=V,this.db=B,this.eb=W,this.fb=X,this.gb=he,this.hb=de,this.ib=le,this.jb=we,this.kb=be,this.lb=Ee,this.mb=Se,this.t=this.B(new C.$Qd),this.onWillLoad=this.t.event,this.u=this.B(new C.$Qd),this.onDidSignalReady=this.u.event,this.w=this.B(new C.$Qd),this.onDidTriggerSystemContextMenu=this.w.event,this.z=this.B(new C.$Qd),this.onDidClose=this.z.event,this.C=this.B(new C.$Qd),this.onDidDestroy=this.C.event,this.G=-1,this.L=!1,this.M=[],this.N=[],this.O=void 0,this.P=void 0,this.Q=this.B(this.kb.createIPCObjectUrl()),this.S=!1,this.nb=0;{const[ke,pe]=this.xb(N.state);this.I=ke,this.U.trace("window#ctor: using window state",ke);const _=this.I.mode===0||this.I.mode===3,ue=this.a.getValue("window"),ge=Le.invokeFunction(D.$e8b,this.I,{show:!_,webPreferences:{preload:d.$fg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.Q.resource.toString()}`],v8CacheOptions:this.X.useCodeCache?"bypassHeatCheck":"none"}});$.$j&&!this.r()&&(ge.fullscreenable=!1);const Re=$.$j&&ue?.nativeTabs===!0;Re&&(ge.tabbingIdentifier=this.jb.nameShort);const De=(0,m.$rC)(this.a)==="custom";if(De&&(ge.titleBarStyle="hidden",$.$j||(ge.frame=!1),(0,m.$sC)(this.a))){const Ue=this.db.getWindowSplash()?.colorInfo.titleBarBackground??this.db.getBackgroundColor(),Me=F.$4s.fromHex(Ue).isDarker()?"#FFFFFF":"#000000";ge.titleBarOverlay={height:29,color:Ue,symbolColor:Me},this.L=!0}if((0,a.mark)("code/willCreateCodeBrowserWindow"),this.F=new S.BrowserWindow(ge),(0,a.mark)("code/didCreateCodeBrowserWindow"),this.D=this.F.id,$.$j&&De&&this.F.setSheetOffset(22),De&&($.$i&&(0,m.$sC)(this.a)||$.$j)){const Ue=this.mb.getItem(ae.s);Ue&&this.updateWindowControls({height:Ue})}$.$i&&De&&this.F.hookWindowMessage(278,()=>{const[Me,Ve]=this.F.getPosition(),ze=S.screen.getCursorScreenPoint(),ie=ze.x-Me,fe=ze.y-Ve;return(()=>!(ie>30&&fe>=0&&fe<=Math.max(this.F.getBounds().height*.15,35)))()||(this.F.setEnabled(!1),this.F.setEnabled(!0),this.w.fire({x:ie,y:fe})),0}),($.$j||$.$i)&&pe&&(!Re||S.BrowserWindow.getAllWindows().length===1)&&[this.I.width,this.I.height,this.I.x,this.I.y].every(Ue=>typeof Ue=="number")&&this.F.setBounds({width:this.I.width,height:this.I.height,x:this.I.x,y:this.I.y}),_&&((0,a.mark)("code/willMaximizeCodeWindow"),this.F.maximize(),this.I.mode===3&&this.h(!0),this.F.show(),(0,a.mark)("code/didMaximizeCodeWindow")),this.G=Date.now()}this.X.args["open-devtools"]===!0&&this.F.webContents.openDevTools(),this.ub(),this.Eb(),this.ob()}setReady(){for(this.U.trace(`window#load: window reported ready (id: ${this.D})`),this.nb=2;this.M.length;)this.M.pop()(this);this.u.fire()}ready(){return new Promise(N=>{if(this.isReady)return N(this);this.M.push(N)})}get isReady(){return this.nb===2}get whenClosedOrLoaded(){return new Promise(N=>{function H(){q.dispose(),ee.dispose(),N()}const q=this.onDidClose(()=>H()),ee=this.onWillLoad(()=>H())})}ob(){this.F.on("unresponsive",()=>this.rb(1)),this.F.webContents.on("render-process-gone",(H,q)=>this.rb(2,{...q})),this.F.webContents.on("did-fail-load",(H,q,ee)=>this.rb(3,{reason:ee,exitCode:q})),this.F.webContents.on("will-prevent-unload",H=>{H.preventDefault()}),this.F.on("closed",()=>{this.z.fire(),this.dispose()}),this.F.webContents.on("did-finish-load",()=>{this.R&&(this.H=this.R,this.R=void 0)}),this.F.on("focus",()=>{this.G=Date.now()}),this.F.on("maximize",H=>{this.H&&(this.H.maximized=!0),S.app.emit("browser-window-maximize",H,this.F)}),this.F.on("unmaximize",H=>{this.H&&(this.H.maximized=!1),S.app.emit("browser-window-unmaximize",H,this.F)}),this.F.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.g?.complete(),this.g=void 0}),this.F.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.g?.complete(),this.g=void 0}),this.B(this.a.onDidChangeConfiguration(H=>this.ub(H))),this.B(this.eb.onDidDeleteUntitledWorkspace(H=>this.tb(H)));const N=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.F.webContents.session.webRequest.onBeforeSendHeaders({urls:N},async(H,q)=>{const ee=await this.qb();q({cancel:!1,requestHeaders:Object.assign(H.requestHeaders,ee)})})}qb(){return this.pb||(this.pb=(0,o.$fp)(this.jb.version,this.jb,this.X,this.a,this.$,this.ab,this.gb)),this.pb}async rb(N,H){switch(N){case 2:this.U.error(`CodeWindow: renderer process gone (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break;case 1:this.U.error("CodeWindow: detected unresponsive");break;case 3:this.U.error(`CodeWindow: failed to load (reason: ${H?.reason||"<unknown>"}, code: ${H?.exitCode||"<unknown>"})`);break}switch(this.gb.publicLog2("windowerror",{type:N,reason:H?.reason,code:H?.exitCode}),N){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.ib.kill(1);return}if(this.X.args["enable-smoke-test-driver"]){await this.sb(!1,!1),this.ib.quit();return}if(N===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.F&&this.F.webContents&&this.F.webContents.isDevToolsOpened())return;const{response:q,checkboxChecked:ee}=await this.hb.showMessageBox({type:"warning",buttons:[(0,v.localize)(0,null),(0,v.localize)(1,null),(0,v.localize)(2,null)],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),checkboxLabel:this.H?.workspace?(0,v.localize)(5,null):void 0},this.F);if(q!==2){const se=q===0;await this.sb(se,ee)}}else if(N===2){let q;H?q=(0,v.localize)(7,null,H.reason,H.exitCode??"<unknown>"):q=(0,v.localize)(6,null);const{response:ee,checkboxChecked:se}=await this.hb.showMessageBox({type:"warning",buttons:[this.H?.workspace?(0,v.localize)(8,null):(0,v.localize)(9,null),(0,v.localize)(10,null)],message:q,detail:this.H?.workspace?(0,v.localize)(11,null):(0,v.localize)(12,null),checkboxLabel:this.H?.workspace?(0,v.localize)(13,null):void 0},this.F),Q=ee===0;await this.sb(Q,se)}break}}async sb(N,H){const q=this.H?.workspace;if(H&&q)try{const ee=this.bb.workspaceStorage(q);await ee.init(),ee.delete("memento/workbench.parts.editor"),await ee.close()}catch(ee){this.U.error(ee)}if(this.C.fire(),this.F?.destroy(),N&&this.H){let ee,se;(0,R.$5h)(q)?ee={folderUri:q.uri}:(0,R.$0h)(q)?ee={workspaceUri:q.configPath}:se=!0,(0,ce.$Nb)(await this.lb.open({context:5,userEnv:this.H.userEnv,cli:{...this.X.args,_:[]},urisToOpen:ee?[ee]:void 0,forceEmpty:se,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}tb(N){this.H?.workspace?.id===N.id&&(this.H.workspace=void 0)}ub(N){if(!N||N.affectsConfiguration("window.menuBarVisibility")){const H=this.Bb();H!==this.J&&(this.J=H,this.Cb(H))}if(!N||N.affectsConfiguration("http.proxy")){let H=(this.a.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;H?.endsWith("/")&&(H=H.substr(0,H.length-1));const q=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((H||"").indexOf("@")===-1&&(H!==this.O||q!==this.P)){this.O=H,this.P=q;const ee=H||"",se=q?`${q},<local>`:"<local>";this.U.trace(`Setting proxy to '${ee}', bypassing '${se}'`),this.F.webContents.session.setProxy({proxyRules:ee,proxyBypassRules:se,pacScript:""})}}}addTabbedWindow(N){$.$j&&N.win&&this.F.addTabbedWindow(N.win)}load(N,H=Object.create(null)){this.U.trace(`window#load: attempt to load window (id: ${this.D})`),this.isDocumentEdited()&&(!H.isReload||!this.fb.isHotExitEnabled())&&this.setDocumentEdited(!1),H.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.F.setTitle(this.jb.nameLong)),this.vb(N,H),this.nb===0?this.H=N:this.R=N,this.nb=1,this.F.loadURL(d.$fg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.X.isBuilt?"":"-dev"}.html`).toString(!0));const q=this.S;this.S=!0,!this.X.isBuilt&&!this.X.extensionTestsLocationURI&&this.B(new A.$9g(()=>{this.F&&!this.F.isVisible()&&!this.F.isMinimized()&&(this.F.show(),this.focus({force:!0}),this.F.webContents.openDevTools())},1e4)).schedule(),this.t.fire({workspace:N.workspace,reason:H.isReload?3:q?2:1})}vb(N,H){const q=(this.H??this.R)?.userEnv;if(q){const ee=(0,g.$Sl)(q)&&!(0,g.$Sl)(N.userEnv),se=this.isExtensionDevelopmentHost;(ee||se)&&(N.userEnv={...q,...N.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(N.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),H.disableExtensions!==void 0&&(N["disable-extensions"]=H.disableExtensions),N.fullscreen=this.isFullScreen,N.maximized=this.F.isMaximized(),N.partsSplash=this.db.getWindowSplash(),(0,a.mark)("code/willOpenNewWindow"),N.perfMarks=(0,a.getMarks)(),this.Q.update(N)}async reload(N){const H=Object.assign({},this.H);H.workspace=await this.wb(H),delete H.filesToOpenOrCreate,delete H.filesToDiff,delete H.filesToMerge,delete H.filesToWait,this.isExtensionDevelopmentHost&&N&&(H.verbose=N.verbose,H.debugId=N.debugId,H.extensionEnvironment=N.extensionEnvironment,H["inspect-extensions"]=N["inspect-extensions"],H["inspect-brk-extensions"]=N["inspect-brk-extensions"],H["extensions-dir"]=N["extensions-dir"]),H.accessibilitySupport=S.app.isAccessibilitySupportEnabled(),H.isInitialStartup=!1,H.policiesData=this.Y.serialize(),H.continueOn=this.X.continueOn,H.profiles={all:this.Z.profiles,profile:this.profile||this.Z.defaultProfile,home:this.Z.profilesHome},H.logLevel=this.W.getLogLevel(),H.loggers={window:this.W.getRegisteredLoggers(this.id),global:this.W.getRegisteredLoggers()},this.load(H,{isReload:!0,disableExtensions:N?.["disable-extensions"]})}async wb(N){if((0,R.$0h)(N.workspace)){const H=N.workspace.configPath;if(H.scheme===d.Schemas.file&&!await this.$.exists(H))return}else if((0,R.$5h)(N.workspace)){const H=N.workspace.uri;if(H.scheme===d.Schemas.file&&!await this.$.exists(H))return}return N.workspace}serializeWindowState(){if(!this.F)return(0,I.$B7b)();if(this.isFullScreen){let q;try{q=S.screen.getDisplayMatching(this.getBounds())}catch{}const ee=(0,I.$B7b)();return{mode:3,display:q?q.id:void 0,width:this.I.width||ee.width,height:this.I.height||ee.height,x:this.I.x||0,y:this.I.y||0}}const N=Object.create(null);let H;if(!$.$j&&this.F.isMaximized()?H=0:H=1,H===0?N.mode=0:N.mode=1,H===1||H===0){let q;H===1?q=this.getBounds():q=this.F.getNormalBounds(),N.x=q.x,N.y=q.y,N.width=q.width,N.height=q.height}return N}updateWindowControls(N){if(N.height&&this.mb.setItem(ae.s,N.height),$.$i&&this.L)this.F.setTitleBarOverlay({color:N.backgroundColor?.trim()===""?void 0:N.backgroundColor,symbolColor:N.foregroundColor?.trim()===""?void 0:N.foregroundColor,height:N.height?N.height-1:void 0});else if($.$j&&N.height!==void 0){const H=(N.height-15)/2;H?this.F.setWindowButtonPosition({x:H,y:H}):this.F.setWindowButtonPosition(null)}}xb(N){(0,a.mark)("code/willRestoreCodeWindowState");let H=!1;if(N)try{const q=S.screen.getAllDisplays();H=q.length>1,N=this.yb(N,q)}catch(q){this.U.warn(`Unexpected error validating window state: ${q}
${q.stack}`)}return(0,a.mark)("code/didRestoreCodeWindowState"),[N||(0,I.$B7b)(),H]}yb(N,H){if(this.U.trace(`window#validateWindowState: validating window state on ${H.length} display(s)`,N),typeof N.x!="number"||typeof N.y!="number"||typeof N.width!="number"||typeof N.height!="number"){this.U.trace("window#validateWindowState: unexpected type of state values");return}if(N.width<=0||N.height<=0){this.U.trace("window#validateWindowState: unexpected negative values");return}if(H.length===1){const se=this.zb(H[0]);if(se){let Q=function(){!N||typeof N.x!="number"||typeof N.y!="number"||!se||(N.x<se.x&&(N.x=se.x),N.y<se.y&&(N.y=se.y))};this.U.trace("window#validateWindowState: 1 monitor working area",se),Q(),N.width>se.width&&(N.width=se.width),N.height>se.height&&(N.height=se.height),N.x>se.x+se.width-128&&(N.x=se.x+se.width-N.width),N.y>se.y+se.height-128&&(N.y=se.y+se.height-N.height),Q()}return N}if(N.display&&N.mode===3){const se=H.find(Q=>Q.id===N.display);if(se&&typeof se.bounds?.x=="number"&&typeof se.bounds?.y=="number"){this.U.trace("window#validateWindowState: restoring fullscreen to previous display");const Q=(0,I.$B7b)(3);return Q.x=se.bounds.x,Q.y=se.bounds.y,Q}}let q,ee;try{q=S.screen.getDisplayMatching({x:N.x,y:N.y,width:N.width,height:N.height}),ee=this.zb(q)}catch{}if(q&&ee&&N.x+N.width>ee.x&&N.y+N.height>ee.y&&N.x<ee.x+ee.width&&N.y<ee.y+ee.height)return this.U.trace("window#validateWindowState: multi-monitor working area",ee),N}zb(N){if(N.workArea.width>0&&N.workArea.height>0)return N.workArea;if(N.bounds.width>0&&N.bounds.height>0)return N.bounds}getBounds(){const[N,H]=this.F.getPosition(),[q,ee]=this.F.getSize();return{x:N,y:H,width:q,height:ee}}h(N){super.h(N),this.sendWhenReady(N?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.J&&this.Cb(this.J,!1)}Bb(){let N=(0,m.$qC)(this.a);return["visible","toggle","hidden"].indexOf(N)<0&&(N="classic"),N}Cb(N,H=!0){$.$j||(N==="toggle"&&H&&this.send("vscode:showInfoMessage",(0,v.localize)(14,null)),N==="hidden"?setTimeout(()=>{this.Db(N)}):this.Db(N))}Db(N){const H=this.isFullScreen;switch(N){case"classic":this.F.setMenuBarVisibility(!H),this.F.autoHideMenuBar=H;break;case"visible":this.F.setMenuBarVisibility(!0),this.F.autoHideMenuBar=!1;break;case"toggle":this.F.setMenuBarVisibility(!1),this.F.autoHideMenuBar=!0;break;case"hidden":this.F.setMenuBarVisibility(!1),this.F.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if($.$j)switch(S.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.F.minimize();break;case"None":break;case"Maximize":default:this.F.isMaximized()?this.F.unmaximize():this.F.maximize()}else this.F.isMaximized()?this.F.unmaximize():this.F.maximize()}close(){this.F?.close()}sendWhenReady(N,H,...q){this.isReady?this.send(N,...q):this.ready().then(()=>{H.isCancellationRequested||this.send(N,...q)})}send(N,...H){if(this.F){if(this.F.isDestroyed()||this.F.webContents.isDestroyed()){this.U.warn(`Sending IPC message to channel '${N}' for window that is destroyed`);return}try{this.F.webContents.send(N,...H)}catch(q){this.U.warn(`Error sending IPC message to channel '${N}' of window ${this.D}: ${(0,M.$Fi)(q)}`)}}}updateTouchBar(N){$.$j&&this.N.forEach((H,q)=>{const ee=N[q];H.segments=this.Gb(ee)})}Eb(){if($.$j){for(let N=0;N<10;N++){const H=this.Fb();this.N.push(H)}this.F.setTouchBar(new S.TouchBar({items:this.N}))}}Fb(N=[]){const H=this.Gb(N),q=new S.TouchBar.TouchBarSegmentedControl({segments:H,mode:"buttons",segmentStyle:"automatic",change:ee=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:q.segments[ee].id,from:"touchbar"})}});return q}Gb(N=[]){return N.map(q=>{let ee;q.icon&&!n.ThemeIcon.isThemeIcon(q.icon)&&q.icon?.dark?.scheme===d.Schemas.file&&(ee=S.nativeImage.createFromPath(p.URI.revive(q.icon.dark).fsPath),ee.isEmpty()&&(ee=void 0));let se;return typeof q.title=="string"?se=q.title:se=q.title.value,{id:q.id,label:ee?void 0:se,icon:ee}})}dispose(){super.dispose(),this.W.deregisterLoggers(this.id),this.F=null}};e.$_7b=G,e.$_7b=G=ae=ve([te(1,E.$cj),te(2,Y.$97b),te(3,b.$C7b),te(4,U.$nn),te(5,x.$K7b),te(6,h.$dk),te(7,r.$O7b),te(8,r.$M7b),te(9,y.$oi),te(10,c.$Q7b),te(11,k.$77b),te(12,f.$V7b),te(13,t.$hl),te(14,w.$W7b),te(15,l.$E7b),te(16,u.$uj),te(17,i.$Y7b),te(18,D.$d8b),te(19,T.$QN),te(20,oe.$Th)],G)}),define(ne[302],re([0,1,15,3,17,24,5,133]),function(J,e,S,A,s,M,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=void 0;let d=class extends P.$$7b{get win(){return this.t||this.tryClaimWindow(),this.t}get lastFocusTime(){return this.u}constructor($,p,v,f){super(f),this.w=$,this.z=p,this.C=v,this.s=this.B(new A.$Qd),this.onDidClose=this.s.event,this.id=this.w.id,this.parentId=-1,this.t=null,this.u=Date.now(),this.D()}D(){this.z.args["open-devtools"]===!0&&this.w.openDevTools({mode:"bottom"}),this.tryClaimWindow()}tryClaimWindow(){if(this.t||this.q.isDisposed||this.w.isDestroyed())return;const $=S.BrowserWindow.fromWebContents(this.w);$&&(this.C.trace("[aux window] Claimed browser window instance"),this.t=$,$.setMenu(null),this.F($))}F($){$.on("closed",()=>{this.C.trace("[aux window] Closed window"),this.s.fire(),this.dispose()}),$.on("focus",()=>{this.u=Date.now()})}dispose(){super.dispose(),this.t=null}};e.$a8b=d,e.$a8b=d=ve([te(1,M.$C7b),te(2,C.$cj),te(3,s.$oi)],d)}),define(ne[303],re([0,1,15,3,13,36,302,6,5,29]),function(J,e,S,A,s,M,C,P,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z9b=void 0;let $=class{constructor(v,f){this.b=v,this.c=f,this.a=new Map,this.d()}d(){S.app.on("browser-window-created",(v,f)=>{const y=this.getWindowById(f.id);y&&(this.c.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),y.tryClaimWindow())}),M.$UT.handle("vscode:registerAuxiliaryWindow",async(v,f)=>{const y=this.getWindowById(v.sender.id);return y&&(this.c.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),y.parentId=f),v.sender.id})}createWindow(){return this.b.invokeFunction(a.$e8b,void 0,{webPreferences:{preload:s.$fg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(v){const f=this.b.createInstance(C.$a8b,v);this.a.set(f.id,f),A.Event.once(f.onDidClose)(()=>this.a.delete(f.id))}getWindowById(v){return this.a.get(v)}getFocusedWindow(){const v=S.BrowserWindow.getFocusedWindow();if(v)return this.getWindowById(v.id)}getLastActiveWindow(){return(0,a.$g8b)(Array.from(this.a.values()))}getWindows(){return Array.from(this.a.values())}};e.$z9b=$,e.$z9b=$=ve([te(0,P.$Th),te(1,d.$cj)],$)}),define(ne[83],re([0,1,15,23,8,3,46,2,13,4,19,7,21,193,6,20,5,82,97,30,54,31,52]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$O8b=e.$N8b=void 0,e.$N8b=(0,y.$Uh)("workspacesHistoryMainService");let r=class extends P.$Rc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,c,m,D,R){super(),this.f=n,this.g=c,this.h=m,this.j=D,this.m=R,this.c=this.B(new M.$Qd),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$Ug(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let c=[],m=[];for(const R of n)if((0,h.$gV)(R))!this.g.isUntitledWorkspace(R.workspace)&&!this.w(c,R.workspace)&&c.push(R);else if((0,h.$hV)(R))this.y(c,R.folderUri)||c.push(R);else{const k=this.z(m,R.fileUri),I=R.fileUri.scheme===d.Schemas.file&&o.G.indexOf((0,$.$vg)(R.fileUri))>=0;!k&&!I&&(m.push(R),a.$i&&R.fileUri.scheme===d.Schemas.file&&S.app.addRecentDocument(R.fileUri.fsPath))}const D=await this.r({workspaces:c,files:m});c=D.workspaces,m=D.files,c.length>o.a&&(c.length=o.a),m.length>o.a&&(m.length=o.a),await this.t({workspaces:c,files:m}),this.c.fire(),a.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const c=k=>{const I=this.u(k);for(const F of n)if($.$pg.isEqual(F,I))return!1;return!0},m=await this.getRecentlyOpened(),D=m.workspaces.filter(c),R=m.files.filter(c);(D.length!==m.workspaces.length||R.length!==m.files.length)&&(await this.t({files:R,workspaces:D}),this.c.fire(),a.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:c}=await this.m.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null)],message:(0,f.localize)(2,null),detail:(0,f.localize)(3,null),cancelId:1});if(c!==0)return}await this.t({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const c=new u.$zc(R=>$.$pg.getComparisonKey(R));if(n?.workspaces)for(const R of n.workspaces)c.set(this.u(R),R);const m=new u.$zc(R=>$.$pg.getComparisonKey(R));if(n?.files)for(const R of n.files)m.set(this.u(R),R);const D=await this.s();for(const R of D.workspaces){const k=c.get(this.u(R));k?k.label=k.label??R.label:c.set(this.u(R),R)}for(const R of D.files){const k=m.get(this.u(R));k?k.label=k.label??R.label:m.set(this.u(R),R)}return{workspaces:[...c.values()],files:[...m.values()]}}async s(){await this.j.whenReady;let n;const c=this.j.get(o.b,-1);if(typeof c=="string")try{n=JSON.parse(c)}catch(m){this.f.error("Unexpected error parsing opened paths list",m)}return(0,h.$nV)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,h.$oV)(n)),-1,1)}u(n){return(0,h.$hV)(n)?n.folderUri:(0,h.$iV)(n)?n.fileUri:n.workspace.configPath}w(n,c){return!!n.find(m=>(0,h.$gV)(m)&&m.workspace.id===c.id)}y(n,c){return!!n.find(m=>(0,h.$hV)(m)&&$.$pg.isEqual(m.folderUri,c))}z(n,c){return!!n.find(m=>$.$pg.isEqual(m.fileUri,c))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){a.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!a.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(4,null),description:(0,f.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const c=[];for(const R of S.app.getJumpListSettings().removedItems){const k=R.args;if(k){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(k);I&&c.push(p.URI.parse(I[2]))}}await this.removeRecentlyOpened(c);let m=!1;const D=(0,A.$Gb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(R=>{const k=(0,h.$gV)(R)?R.workspace:R.folderUri,{title:I,description:F}=this.L(k,R.label);let U;return p.URI.isUri(k)?U=`--folder-uri "${k.toString()}"`:(m=!0,U=`--file-uri "${k.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:F.substr(0,255),program:process.execPath,args:U,iconPath:"explorer.exe",iconIndex:0}}));D.length>0&&n.push({type:"custom",name:m?(0,f.localize)(6,null):(0,f.localize)(7,null),items:D})}n.push({type:"recent"});try{const c=S.app.setJumpList(n);c&&c!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${c}`)}catch(c){this.f.warn("updateWindowsJumpList#setJumpList",c)}}L(n,c){if(c)return{title:(0,C.$Gv)(c).name,description:c};if(p.URI.isUri(n))return{title:(0,$.$vg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,f.localize)(8,null),description:""};let m=(0,$.$vg)(n.configPath);return m.endsWith(l.$ei)&&(m=m.substr(0,m.length-l.$ei.length-1)),{title:(0,f.localize)(9,null,m),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,C.$yv)(n.fsPath):n.toString()}async N(){if(!a.$j)return;S.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),c=[];let m=0;for(let R=0;R<n.workspaces.length&&m<o.C;R++){const k=this.u(n.workspaces[R]);if(k.scheme===d.Schemas.file){const I=(0,$.$mg)(k);await v.Promises.exists(I)&&(c.push(I),m++)}}const D=[];for(let R=0;R<n.files.length&&m<o.D;R++){const k=this.u(n.files[R]);if(k.scheme===d.Schemas.file){const I=(0,$.$mg)(k);if(o.G.includes((0,$.$vg)(k))||c.includes(I))continue;await v.Promises.exists(I)&&(D.push(I),m++)}}D.reverse().forEach(R=>S.app.addRecentDocument(R)),c.reverse().forEach(R=>S.app.addRecentDocument(R))}};e.$O8b=r,e.$O8b=r=o=ve([te(0,b.$cj),te(1,E.$77b),te(2,w.$E7b),te(3,g.$O7b),te(4,i.$W7b)],r)}),define(ne[304],re([0,1,15,8,22,46,4,7,181,64,17,24,20,5,231,70,25,34,26,48,60,29,83]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$P8b=void 0;const r="menu";let t=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(m,D,R,k,I,F,U,T,x,Y,ce,oe){this.n=m,this.o=D,this.p=R,this.q=k,this.r=I,this.s=F,this.t=U,this.u=T,this.v=x,this.w=Y,this.x=ce,this.y=oe,this.m=Object.create(null),this.g=new A.$9g(()=>this.F(),0),this.h=new A.$9g(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.$j||(0,E.$rC)(this.o)==="native")&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const m=this.t.getItem(o.a);m&&(m.menus&&(this.k=m.menus),m.keybindings&&(this.l=m.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(F,U,T)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:U?.id})},this.m["workbench.action.newWindow"]=(F,U,T)=>this.p.openEmptyWindow({context:2,contextWindowId:U?.id}),this.m["workbench.action.files.openFileFolder"]=(F,U,T)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(F,U,T)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(F,U,T)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const m=this.x.youTubeUrl;m&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(m,"openYouTubeUrl"));const D=this.x.requestFeatureUrl;D&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(D,"openUserVoiceUrl"));const R=this.x.reportIssueUrl;R&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(R,"openReportIssues"));const k=this.x.licenseUrl;k&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.$w){const F=k.indexOf("?")>0?"&":"?";this.ab(`${k}${F}lang=${C.$w}`,"openLicenseUrl")}else this.ab(k,"openLicenseUrl")});const I=this.x.privacyStatementUrl;I&&k&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(I,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(m=>this.G(m)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const m=this.o.getValue("window.enableMenuBarMnemonics");return typeof m!="boolean"?!0:m}get D(){if(!C.$j)return!1;const m=this.o.getValue("window.nativeTabs");return typeof m!="boolean"?!1:m}updateMenu(m,D){this.k=m.menus,this.l=m.keybindings,this.t.setItem(o.a,m),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(m){C.$j&&(m.oldCount===0&&m.newCount>0||m.oldCount>0&&m.newCount===0)&&(this.d=m.newCount===0,this.E())}H(){if(!C.$j)return;const m=S.BrowserWindow.getFocusedWindow();this.f=!m||!!this.y.getWindowById(m.id),this.E()}I(){const m=S.Menu.getApplicationMenu();if(m&&this.j.push(m),Object.keys(this.k).length===0){this.J(C.$j?new S.Menu:null);return}const D=new S.Menu;let R;if(C.$j){const I=new S.Menu;R=new S.MenuItem({label:this.x.nameShort,submenu:I}),this.K(I),D.append(R)}if(C.$j&&!this.c){this.c=!0;const I=new S.Menu;I.append(new S.MenuItem({label:this.cb(d.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),S.app.dock.setMenu(I)}if(this.M("File")){const I=new S.Menu,F=new S.MenuItem({label:this.cb(d.localize(1,null)),submenu:I});this.O(I,"File"),D.append(F)}if(this.M("Edit")){const I=new S.Menu,F=new S.MenuItem({label:this.cb(d.localize(2,null)),submenu:I});this.O(I,"Edit"),D.append(F)}if(this.M("Selection")){const I=new S.Menu,F=new S.MenuItem({label:this.cb(d.localize(3,null)),submenu:I});this.O(I,"Selection"),D.append(F)}if(this.M("View")){const I=new S.Menu,F=new S.MenuItem({label:this.cb(d.localize(4,null)),submenu:I});this.O(I,"View"),D.append(F)}if(this.M("Go")){const I=new S.Menu,F=new S.MenuItem({label:this.cb(d.localize(5,null)),submenu:I});this.O(I,"Go"),D.append(F)}if(this.M("Run")){const I=new S.Menu,F=new S.MenuItem({label:this.cb(d.localize(6,null)),submenu:I});this.O(I,"Run"),D.append(F)}if(this.M("Terminal")){const I=new S.Menu,F=new S.MenuItem({label:this.cb(d.localize(7,null)),submenu:I});this.O(I,"Terminal"),D.append(F)}let k;if(this.M("Window")){const I=new S.Menu;k=new S.MenuItem({label:this.cb(d.localize(8,null)),submenu:I,role:"window"}),this.U(I)}if(k&&D.append(k),this.M("Help")){const I=new S.Menu,F=new S.MenuItem({label:this.cb(d.localize(9,null)),submenu:I,role:"help"});this.O(I,"Help"),D.append(F)}D.items&&D.items.length>0?this.J(D):this.J(null),this.h.schedule()}J(m){if(S.Menu.setApplicationMenu(m),m)for(const D of this.y.getWindows())D.win?.setMenu(null)}K(m){const D=this.W(d.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),R=this.V();let k;if(this.M("Preferences")){const oe=new S.Menu;this.O(oe,"Preferences"),k=new S.MenuItem({label:this.cb(d.localize(11,null)),submenu:oe})}const I=new S.Menu,F=new S.MenuItem({label:d.localize(12,null),role:"services",submenu:I}),U=new S.MenuItem({label:d.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),T=new S.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new S.MenuItem({label:d.localize(15,null),role:"unhide"}),Y=new S.MenuItem(this.$("workbench.action.quit",{label:d.localize(16,null,this.x.nameLong),click:async(oe,ae,Z)=>{const K=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||S.BrowserWindow.getFocusedWindow()||K?.win?.isMinimized())&&await this.L(Z)&&this.w.quit(void 0)}})),ce=[D];ce.push(...R),k&&ce.push(n(),k),ce.push(n(),F,n(),U,T,x,n(),Y),ce.forEach(oe=>m.append(oe))}async L(m){if(this.p.getWindowCount()===0)return!0;const D=this.o.getValue("window.confirmBeforeClose");if(D==="always"||D==="keyboardOnly"&&this.S(m)){const{response:R}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[d.localize(17,null),d.localize(18,null)],message:d.localize(19,null)});return R===0}return!0}M(m){if(!C.$j&&(0,E.$rC)(this.o)==="custom")return!1;switch(m){case"File":case"Help":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[m];case"Window":if(C.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[m]}}N(m,D){D.forEach(R=>{if((0,y.$K8b)(R))m.append(n());else if((0,y.$J8b)(R)){const k=new S.Menu,I=new S.MenuItem({label:this.cb(R.label),submenu:k});this.N(k,R.submenu.items),m.append(I)}else(0,y.$L8b)(R)?m.append(this.Q(R)):(0,y.$M8b)(R)&&(R.id==="workbench.action.showAboutDialog"&&this.P(m),C.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[R.id]?m.append(new S.MenuItem(this.$(R.id,{label:this.cb(R.label),click:this.m[R.id]}))):m.append(this.W(R.label,R.id,!1,R.checked)):m.append(this.W(R.label,R.id,R.enabled!==!1,!!R.checked)):m.append(this.W(R.label,R.id,R.enabled!==!1,!!R.checked)))})}O(m,D){this.k&&this.k[D]&&this.N(m,this.k[D].items)}P(m){const D=this.V();D.length&&(D.forEach(R=>m.append(R)),m.append(n()))}Q(m){const D=P.URI.revive(m.uri),R=m.id,k=R==="openRecentFile"?{fileUri:D}:R==="openRecentWorkspace"?{workspaceUri:D}:{folderUri:D};return new S.MenuItem(this.$(R,{label:m.label,click:async(I,F,U)=>{const T=this.R(U);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[k],forceNewWindow:T,gotoLineMode:!1,remoteAuthority:m.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([D])}},!1))}R(m){return!!(m&&(!C.$j&&(m.ctrlKey||m.shiftKey)||C.$j&&(m.metaKey||m.altKey)))}S(m){return!!(m.triggeredByAccelerator||m.altKey||m.ctrlKey||m.metaKey||m.shiftKey)}T(m,D,R){const k={label:this.cb(m),role:R,enabled:!0};return new S.MenuItem(this.Z(D,k))}U(m){const D=new S.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),R=new S.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),k=new S.MenuItem({label:d.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),I=this.W(d.localize(23,null),"workbench.action.switchWindow"),F=[];this.D&&(F.push(n()),F.push(this.W(d.localize(24,null),"workbench.action.newWindowTab")),F.push(this.T(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),F.push(this.T(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),F.push(this.T(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),F.push(this.T(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[D,R,n(),I,...F,n(),k].forEach(U=>m.append(U))}V(){switch(this.n.state.type){case"idle":return[new S.MenuItem({label:this.cb(d.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new S.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.cb(d.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.cb(d.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new S.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.cb(d.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(m,D,R,k){const I=this.cb(m),F=typeof D=="function"?D:(ce,oe,ae)=>{const Z=ce?ce.userSettingsLabel:null;let K=D;Array.isArray(D)&&(K=this.R(ae)?D[1]:D[0]),Z&&ae.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Z}):this.Y({type:"commandId",commandId:K})},U=typeof R=="boolean"?R:this.p.getWindowCount()>0,T=typeof k=="boolean"?k:!1,x={label:I,click:F,enabled:U};T&&(x.type="checkbox",x.checked=T);let Y;return typeof D=="string"?Y=D:Array.isArray(D)&&(Y=D[0]),C.$j&&(Y==="editor.action.clipboardCutAction"?x.role="cut":Y==="editor.action.clipboardCopyAction"?x.role="copy":Y==="editor.action.clipboardPasteAction"&&(x.role="paste"),Y==="undo"?x.click=this.X(F,{inDevTools:ce=>ce.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):Y==="redo"?x.click=this.X(F,{inDevTools:ce=>ce.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):Y==="editor.action.selectAll"&&(x.click=this.X(F,{inDevTools:ce=>ce.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.Z(Y,x))}X(m,D){return(R,k,I)=>{const F=S.BrowserWindow.getFocusedWindow();if(!F)return D.inNoWindow();if(F.webContents.isDevToolsFocused()&&F.webContents.devToolsWebContents)return D.inDevTools(F.webContents.devToolsWebContents);m(R,k||F,I)}}Y(m){let D=S.BrowserWindow.getFocusedWindow();if(D){const k=this.y.getWindowById(D.id);k&&(D=this.p.getWindowById(k.parentId)?.win??null)}if(!D){const k=this.p.getLastActiveWindow();k?.win?.isMinimized()&&(D=k.win)}const R=D?this.p.getWindowById(D.id):void 0;if(R){if(this.v.trace("menubar#runActionInRenderer",m),C.$j&&!this.q.isBuilt&&!R.isReady&&(m.type==="commandId"&&m.commandId==="workbench.action.toggleDevTools"||m.type!=="commandId"&&m.userSettingsLabel==="alt+cmd+i"))return!1;if(m.type==="commandId"){const k={id:m.commandId,from:"menu"};R.sendWhenReady("vscode:runAction",s.CancellationToken.None,k)}else{const k={userSettingsLabel:m.userSettingsLabel};R.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,k)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",m),!1}Z(m,D){const R=typeof m=="string"?this.l[m]:void 0;if(R?.label){if(R.isNative!==!1)D.accelerator=R.label,D.userSettingsLabel=R.userSettingsLabel;else if(typeof D.label=="string"){const k=D.label.indexOf("[");k>=0?D.label=`${D.label.substr(0,k)} [${R.label}]`:D.label=`${D.label} [${R.label}]`}}else D.accelerator=void 0;return D}$(m,D,R=!D.accelerator){R&&(D=this.Z(m,D));const k=D.click;return D.click=(I,F,U)=>{this.bb(m),k?.(I,F,U)},D}ab(m,D){this.w.openExternal(void 0,m),this.bb(D)}bb(m){this.r.publicLog2("workbenchActionExecuted",{id:m,from:r})}cb(m){return(0,M.$Dv)(m,!this.C)}};e.$P8b=t,e.$P8b=t=o=ve([te(0,l.$UU),te(1,$.$oi),te(2,u.$d8b),te(3,p.$C7b),te(4,h.$hl),te(5,i.$N8b),te(6,g.$QN),te(7,v.$E7b),te(8,f.$cj),te(9,w.$B8b),te(10,b.$uj),te(11,a.$b8b)],t);function n(){return new S.MenuItem({type:"separator"})}}),define(ne[305],re([0,1,6,20,5,304]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R8b=e.$Q8b=void 0,e.$Q8b=(0,S.$Uh)("menubarMainService");let C=class{constructor(d,a,$){this.b=d,this.c=a,this.d=$,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$P8b)}async updateMenubar(d,a){this.d.trace("menubarService#updateMenubar",d),(await this.a).updateMenu(a,d)}};e.$R8b=C,e.$R8b=C=ve([te(0,S.$Th),te(1,A.$E7b),te(2,s.$cj)],C)}),define(ne[306],re([0,1,15,21,131,28,23,22,3,33,46,2,13,9,67,4,35,19,12,7,191,65,17,52,24,16,6,20,5,79,80,59,34,60,133,29,130,298,30,98,83,54,69,39,53,68,64]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u,i,o,r,t,n,c,m,D,R,k,I,F,U,T,x,Y,ce,oe,ae,Z,K,G,z,N,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f9b=void 0;function q(Q){return(0,ce.$0h)(Q?.workspace)}function ee(Q){return(0,ce.$5h)(Q?.workspace)}let se=class extends p.$Rc{constructor(O,j,V,L,B,W,X,he,de,le,we,be,Ee,Se,Le,ke,pe,_,ue,ge){super(),this.m=O,this.n=j,this.r=V,this.s=L,this.t=B,this.u=W,this.w=X,this.z=he,this.C=de,this.D=le,this.F=we,this.G=be,this.H=Ee,this.I=Se,this.J=Le,this.L=ke,this.M=pe,this.N=_,this.O=ue,this.P=ge,this.a=this.B(new d.$Qd),this.onDidOpenWindow=this.a.event,this.b=this.B(new d.$Qd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new d.$Qd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new d.$Qd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new d.$Qd),this.onDidTriggerSystemContextMenu=this.g.event,this.h=new Map,this.j=this.B(new Y.$c9b(this,this.u,this.D,this.s,this.G)),this.Q()}Q(){this.B(this.I.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const j=new p.$Qc;if(j.add(d.Event.any(O.onDidClose,O.onDidDestroy)(()=>j.dispose())),O.config.extensionDevelopmentPath)for(const V of O.config.extensionDevelopmentPath)j.add(this.N.addValidFileRoot(V));O.config.extensionTestsPath&&j.add(this.N.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,j){const V=this.z.args,L=j?.remoteAuthority||void 0,B=!0,W=j?.forceReuseWindow,X=!W;return this.open({...O,cli:V,forceEmpty:B,forceNewWindow:X,forceReuseWindow:W,remoteAuthority:L})}openExistingWindow(O,j){O.focus(),this.R(j,[O])}async open(O){this.s.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const j=[],V=[],L=[],B=[],W=[];let X,he=0;const de=await this.$(O);this.s.trace("windowsManager#open pathsToOpen",de);for(const Se of de)ee(Se)?O.addMode?j.push(Se):V.push(Se):q(Se)?L.push(Se):Se.fileUri?(X||(X={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),X.filesToOpenOrCreate.push(Se)):Se.backupPath?W.push({backupFolder:(0,f.$mc)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):he++;O.diffMode&&X&&X.filesToOpenOrCreate.length>=2&&(X.filesToDiff=X.filesToOpenOrCreate.slice(0,2),X.filesToOpenOrCreate=[]),O.mergeMode&&X&&X.filesToOpenOrCreate.length===4&&(X.filesToMerge=X.filesToOpenOrCreate.slice(0,4),X.filesToOpenOrCreate=[],X.filesToDiff=[]),X&&O.waitMarkerFileURI&&(X.filesToWait={paths:(0,C.$Gb)([...X.filesToDiff,X.filesToMerge[3],...X.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(B.push(...this.I.getUntitledWorkspaces()),L.push(...B),W.push(...this.F.getEmptyWindowBackups())):W.length=0;const{windows:le,filesOpenedInWindow:we}=await this.S(O,L,V,W,he,X,j);if(this.s.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${L.length}, foldersToOpen: ${V.length}, emptyToRestore: ${W.length}, emptyToOpen: ${he})`),le.length>1)if(we)we.focus();else{const Se=this.j.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Le=!0,ke=!0;if(Se){const pe=le.filter(_=>this.j.state.lastActiveWindow&&_.backupPath===this.j.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,ke=!1)}if(Le)for(let pe=le.length-1;pe>=0;pe--){const _=le[pe];if(!(_.openedWorkspace&&B.some(ue=>_.openedWorkspace&&ue.workspace.id===_.openedWorkspace.id)||_.backupPath&&W.some(ue=>_.backupPath&&ue.backupFolder===(0,f.$mc)(_.backupPath)))){_.focus(),ke=!1;break}}ke&&le[le.length-1].focus()}const be=X&&X.filesToDiff.length>0,Ee=X&&X.filesToMerge.length>0;if(!le.some(Se=>Se.isExtensionDevelopmentHost)&&!be&&!Ee&&!O.noRecentEntry){const Se=[];for(const Le of de)q(Le)&&!Le.transient?Se.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):ee(Le)?Se.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Se.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.H.addRecentlyOpened(Se)}return this.R(O,le),le}R(O,j){const V=O.waitMarkerFileURI;O.context===0&&V&&j.length===1&&j[0]&&(async()=>{await j[0].whenClosedOrLoaded;try{await this.M.del(V)}catch{}})()}async S(O,j,V,L,B,W,X){const he=[];let de;function le(pe,_){he.push(pe),_&&(de=pe,W=void 0)}let{openFolderInNewWindow:we,openFilesInNewWindow:be}=this.lb(O);if(!O.initialStartup&&X.length>0){const pe=X[0].remoteAuthority,_=this.qb(pe);_&&le(this.X(_,X.map(ue=>ue.workspace.uri)))}const Ee=V.length+j.length+L.length;if(W&&Ee===0){const pe=W.filesToOpenOrCreate[0]||W.filesToDiff[0]||W.filesToMerge[3],_=this.getWindows().filter(ge=>W&&(0,g.$Dg)(ge.remoteAuthority,W.remoteAuthority));let ue;pe?.fileUri&&!be&&((O.context===4||O.context===0||O.context===1)&&(ue=await(0,x.$Z7b)(_,pe.fileUri,async ge=>ge.configPath.scheme===v.Schemas.file?this.I.resolveLocalWorkspace(ge.configPath):void 0)),ue||(ue=this.rb(_))),ue?(0,ce.$0h)(ue.openedWorkspace)?j.push({workspace:ue.openedWorkspace,remoteAuthority:ue.remoteAuthority}):(0,ce.$5h)(ue.openedWorkspace)?V.push({workspace:ue.openedWorkspace,remoteAuthority:ue.remoteAuthority}):le(this.U(O,ue,W),!0):le(await this.mb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:W,forceNewWindow:!0,remoteAuthority:W.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Se=(0,C.$Lb)(j,pe=>pe.workspace.id);if(Se.length>0){const pe=(0,C.$Gb)(Se.map(_=>(0,x.$17b)(this.getWindows(),_.workspace.configPath)));if(pe.length>0){const _=pe[0],ue=(0,g.$Dg)(W?.remoteAuthority,_.remoteAuthority)?W:void 0;le(this.U(O,_,ue),!!ue),we=!0}for(const _ of Se){if(pe.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===_.workspace.id))continue;const ue=_.remoteAuthority,ge=(0,g.$Dg)(W?.remoteAuthority,ue)?W:void 0;le(await this.Z(O,_,we,ge),!!ge),we=!0}}const Le=(0,C.$Lb)(V,pe=>g.$pg.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,C.$Gb)(Le.map(_=>(0,x.$17b)(this.getWindows(),_.workspace.uri)));if(pe.length>0){const _=pe[0],ue=(0,g.$Dg)(W?.remoteAuthority,_.remoteAuthority)?W:void 0;le(this.U(O,_,ue),!!ue),we=!0}for(const _ of Le){if(pe.some(Re=>(0,ce.$5h)(Re.openedWorkspace)&&g.$pg.isEqual(Re.openedWorkspace.uri,_.workspace.uri)))continue;const ue=_.remoteAuthority,ge=(0,g.$Dg)(W?.remoteAuthority,ue)?W:void 0;le(await this.Z(O,_,we,ge),!!ge),we=!0}}const ke=(0,C.$Lb)(L,pe=>pe.backupFolder);if(ke.length>0)for(const pe of ke){const _=pe.remoteAuthority,ue=(0,g.$Dg)(W?.remoteAuthority,_)?W:void 0;le(await this.Y(O,!0,_,ue,pe),!!ue),we=!0}if(he.length===0||W){W&&!B&&B++;const pe=W?W.remoteAuthority:O.remoteAuthority;for(let _=0;_<B;_++)le(await this.Y(O,we,pe,W),!!W),we=!0}return{windows:(0,C.$Lb)(he),filesOpenedInWindow:de}}U(O,j,V){this.s.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:V}),this.W(j);const L={filesToOpenOrCreate:V?.filesToOpenOrCreate,filesToDiff:V?.filesToDiff,filesToMerge:V?.filesToMerge,filesToWait:V?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return j.sendWhenReady("vscode:openFiles",P.CancellationToken.None,L),j}W(O){let j=O;const V=S.BrowserWindow.getFocusedWindow();if(V&&V.id!==O.id){const L=this.P.getWindowById(V.id);L&&L.parentId===O.id&&(j=L)}j.focus()}X(O,j){this.s.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:j}),O.focus();const V={foldersToAdd:j};return O.sendWhenReady("vscode:addFolders",P.CancellationToken.None,V),O}Y(O,j,V,L,B){this.s.trace("windowsManager#doOpenEmpty",{restore:!!B,remoteAuthority:V,filesToOpen:L,forceNewWindow:j});let W;return!j&&typeof O.contextWindowId=="number"&&(W=this.getWindowById(O.contextWindowId)),this.mb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:V,forceNewWindow:j,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:L,windowToUse:W,emptyWindowBackupInfo:B,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}Z(O,j,V,L,B){return this.s.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:j,filesToOpen:L}),!V&&!B&&typeof O.contextWindowId=="number"&&(B=this.getWindowById(O.contextWindowId)),this.mb({workspace:j.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:j.remoteAuthority,forceNewWindow:V,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:L,windowToUse:B,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async $(O){let j,V=!1,L=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(j=await this.ab(O),V=!0):O.forceEmpty?j=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(j=await this.bb(O.cli),j.length===0&&j.push(Object.create(null)),V=!0):(j=await this.db(),j.length===0&&j.push(Object.create(null)),L=!0),!O.addMode&&V){const B=j.filter(W=>ee(W));if(B.length>1){const W=B[0].remoteAuthority;if(B.every(X=>(0,g.$Dg)(X.remoteAuthority,W))){const X=await this.I.createUntitledWorkspace(B.map(he=>({uri:he.workspace.uri})));j.push({workspace:X,remoteAuthority:W}),j=j.filter(he=>!ee(he))}}}if(O.initialStartup&&!L&&this.G.getValue("window")?.restoreWindows==="preserve"){const B=await this.db();j.unshift(...B.filter(W=>q(W)||ee(W)||W.backupPath))}return j}async ab(O){const j={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},V=await Promise.all((0,C.$Gb)(O.urisToOpen||[]).map(async L=>{const B=await this.fb(L,j);if(B)return B.label=L.label,B;const W=this.hb(L);this.L.showMessageBox({type:"info",buttons:[(0,E.localize)(0,null)],message:W.scheme===v.Schemas.file?(0,E.localize)(1,null):(0,E.localize)(2,null),detail:W.scheme===v.Schemas.file?(0,E.localize)(3,null,(0,$.$xv)(W,{os:w.OS,tildify:this.z})):(0,E.localize)(4,null,W.toString(!0))},S.BrowserWindow.getFocusedWindow()??void 0)}));return(0,C.$Gb)(V)}async bb(O){const j=[],V={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},L=O["folder-uri"];if(L){const X=await Promise.all(L.map(he=>{const de=this.cb(he);if(de)return this.fb({folderUri:de},V)}));j.push(...(0,C.$Gb)(X))}const B=O["file-uri"];if(B){const X=await Promise.all(B.map(he=>{const de=this.cb(he);if(de)return this.fb((0,ce.$ni)(he)?{workspaceUri:de}:{fileUri:de},V)}));j.push(...(0,C.$Gb)(X))}const W=await Promise.all(O._.map(X=>V.remoteAuthority?this.kb(X,V):this.ib(X,V)));return j.push(...(0,C.$Gb)(W)),j}cb(O){try{const j=l.URI.parse(O);if(!j.scheme){this.s.error(`Invalid URI input string, scheme missing: ${O}`);return}return j.path?j:j.with({path:"/"})}catch(j){this.s.error(`Invalid URI input string: ${O}, ${j.message}`)}}async db(){const O=this.eb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const j=[];O!=="one"&&j.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&j.push(this.j.state.lastActiveWindow);const V=await Promise.all(j.map(async L=>{if(L.workspace){const B=await this.fb({workspaceUri:L.workspace.configPath},{remoteAuthority:L.remoteAuthority,rejectTransientWorkspaces:!0});if(q(B))return B}else if(L.folderUri){const B=await this.fb({folderUri:L.folderUri},{remoteAuthority:L.remoteAuthority});if(ee(B))return B}else if(O!=="folders"&&L.backupPath)return{backupPath:L.backupPath,remoteAuthority:L.remoteAuthority}}));return(0,C.$Gb)(V)}}}eb(){let O;return this.D.wasRestarted?O="all":(O=this.G.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async fb(O,j=Object.create(null)){const V=this.hb(O);return V.scheme===v.Schemas.file?((0,F.$pC)(O)&&(j={...j,forceOpenWorkspaceAsFile:!0}),this.ib(V.fsPath,j)):this.gb(O,j)}gb(O,j){let V=this.hb(O);const L=(0,k.$Zk)(V)||j.remoteAuthority;if(V=(0,g.$Fg)((0,g.$zg)(V)),(0,F.$pC)(O)){if(j.gotoLineMode){const{path:B,line:W,column:X}=(0,a.$8f)(V.path);return{fileUri:V.with({path:B}),options:{selection:W?{startLineNumber:W,startColumn:X||1}:void 0},remoteAuthority:L}}return{fileUri:V,remoteAuthority:L}}else if((0,F.$nC)(O))return{workspace:(0,oe.$47b)(V),remoteAuthority:L};return{workspace:(0,oe.$57b)(V),remoteAuthority:L}}hb(O){return(0,F.$nC)(O)?O.workspaceUri:(0,F.$oC)(O)?O.folderUri:O.fileUri}async ib(O,j,V){let L,B;j.gotoLineMode&&({path:O,line:L,column:B}=(0,a.$8f)(O)),O=(0,a.$3f)((0,f.$gc)(O),(0,b.cwd)());try{const W=await A.Promises.stat(O);if(W.isFile()){if(!j.forceOpenWorkspaceAsFile){const X=await this.I.resolveLocalWorkspace(l.URI.file(O));if(X)return X.transient&&j.rejectTransientWorkspaces?void 0:{workspace:{id:X.id,configPath:X.configPath},type:t.FileType.File,exists:!0,remoteAuthority:X.remoteAuthority,transient:X.transient}}return{fileUri:l.URI.file(O),type:t.FileType.File,exists:!0,options:{selection:L?{startLineNumber:L,startColumn:B||1}:void 0}}}else{if(W.isDirectory())return{workspace:(0,oe.$57b)(l.URI.file(O),W),type:t.FileType.Directory,exists:!0};if(!w.$i&&O==="/dev/null")return{fileUri:l.URI.file(O),type:t.FileType.File,exists:!0}}}catch(W){if(W.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!V)return this.jb(O,j);const X=l.URI.file(O);if(this.H.removeRecentlyOpened([X]),j.ignoreFileNotFound)return{fileUri:X,type:t.FileType.File,exists:!1}}}async jb(O,j){const V=l.URI.file(O),{response:L,checkboxChecked:B}=await this.L.showMessageBox({type:"warning",buttons:[(0,E.localize)(5,null),(0,E.localize)(6,null),(0,E.localize)(7,null)],message:(0,E.localize)(8,null,V.authority),detail:(0,E.localize)(9,null,(0,$.$xv)(V,{os:w.OS,tildify:this.z})),checkboxLabel:(0,E.localize)(10,null,V.authority),cancelId:1});if(L===0){if((0,s.addUNCHostToAllowlist)(V.authority),B){const W={channel:"vscode:configureAllowedUNCHost",args:V.authority};this.sendToFocused(W.channel,W.args),this.sendToOpeningWindow(W.channel,W.args)}return this.ib(O,j,!0)}if(L===2)return S.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.jb(O,j)}kb(O,j){const V=O.charCodeAt(0),L=j.remoteAuthority;let B,W;j.gotoLineMode&&({path:O,line:B,column:W}=(0,a.$8f)(O)),V!==47&&((0,a.$2f)(V)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,a.$Uf)(O)),O=`/${O}`);const X=l.URI.from({scheme:v.Schemas.vscodeRemote,authority:L,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,ce.$ni)(O))return j.forceOpenWorkspaceAsFile?{fileUri:X,options:{selection:B?{startLineNumber:B,startColumn:W||1}:void 0},remoteAuthority:j.remoteAuthority}:{workspace:(0,oe.$47b)(X),remoteAuthority:L};if(j.gotoLineMode||f.$fc.basename(O).indexOf(".")!==-1)return{fileUri:X,options:{selection:B?{startLineNumber:B,startColumn:W||1}:void 0},remoteAuthority:L}}return{workspace:(0,oe.$57b)(X),remoteAuthority:L}}lb(O){const j=this.G.getValue("window"),V=j?.openFoldersInNewWindow||"default",L=j?.openFilesInNewWindow||"off";let B=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(V==="on"||V==="off")&&(B=V==="on");let W=!1;return O.forceNewWindow||O.forceReuseWindow?W=!!O.forceNewWindow&&!O.forceReuseWindow:(w.$j?O.context===1&&(W=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(W=!0),!O.cli.extensionDevelopmentPath&&(L==="on"||L==="off")&&(W=L==="on")),{openFolderInNewWindow:!!B,openFilesInNewWindow:W}}async openExtensionDevelopmentHostWindow(O,j){const V=(0,x.$27b)(this.getWindows(),O);if(V)return this.D.reload(V,j.cli),V.focus(),[V];let L=j.cli["folder-uri"]||[],B=j.cli["file-uri"]||[],W=j.cli._;if(!W.length&&!L.length&&!B.length&&!j.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,le=de?.workspace??de?.folderUri;le&&(l.URI.isUri(le)?le.scheme===v.Schemas.file?W=[le.fsPath]:L=[le.toString()]:le.configPath.scheme===v.Schemas.file?W=[(0,g.$mg)(le.configPath)]:B=[le.configPath.toString()])}let X=j.remoteAuthority;for(const de of O)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=l.URI.parse(de),we=(0,k.$Zk)(le);we&&(X?(0,g.$Dg)(we,X)||this.s.error("more than one extension development path authority"):X=we)}W=W.filter(de=>{const le=l.URI.file(de);return(0,x.$17b)(this.getWindows(),le)?!1:(0,g.$Dg)((0,k.$Zk)(le),X)}),L=L.filter(de=>{const le=this.cb(de);return le&&(0,x.$17b)(this.getWindows(),le)?!1:le?(0,g.$Dg)((0,k.$Zk)(le),X):!1}),B=B.filter(de=>{const le=this.cb(de);return le&&(0,x.$17b)(this.getWindows(),le)?!1:le?(0,g.$Dg)((0,k.$Zk)(le),X):!1}),j.cli._=W,j.cli["folder-uri"]=L,j.cli["file-uri"]=B;const he={context:j.context,cli:j.cli,forceNewWindow:!0,forceEmpty:!W.length&&!L.length&&!B.length,userEnv:j.userEnv,noRecentEntry:!0,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:X,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile};return this.open(he)}async mb(O){const j=this.G.getValue("window"),V=this.getLastActiveWindow(),L=V?.profile??this.C.defaultProfile;let B;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(B=O.windowToUse||V,B&&B.focus());const W={...this.z.args,...O.cli,machineId:this.m,sqmId:this.n,windowId:-1,mainPid:process.pid,appRoot:this.z.appRoot,execPath:process.execPath,codeCachePath:this.z.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,f.$ic)(this.z.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.C.profilesHome,all:this.C.profiles,profile:L},homeDir:this.z.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.z.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.z.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.r,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.t.getLogLevel(),loggers:{window:[],global:this.t.getRegisteredLoggers()},logsPath:this.z.logsHome.with({scheme:v.Schemas.file}).fsPath,product:D.default,isInitialStartup:O.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof j?.zoomLevel=="number"?j.zoomLevel:void 0,autoDetectHighContrast:j?.autoDetectHighContrast??!0,autoDetectColorScheme:j?.autoDetectColorScheme??!1,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:this.O.getColorScheme(),policiesData:this.w.serialize(),continueOn:this.z.continueOn};if(B){const X=B.config;!W.extensionDevelopmentPath&&X?.extensionDevelopmentPath&&(W.extensionDevelopmentPath=X.extensionDevelopmentPath,W.extensionDevelopmentKind=X.extensionDevelopmentKind,W["enable-proposed-api"]=X["enable-proposed-api"],W.verbose=X.verbose,W["inspect-extensions"]=X["inspect-extensions"],W["inspect-brk-extensions"]=X["inspect-brk-extensions"],W.debugId=X.debugId,W.extensionEnvironment=X.extensionEnvironment,W["extensions-dir"]=X["extensions-dir"],W["disable-extensions"]=X["disable-extensions"]),W.loggers={global:W.loggers.global,window:X?.loggers.window??W.loggers.window}}else{const X=this.j.getNewWindowState(W);(0,y.mark)("code/willCreateCodeWindow");const he=B=this.J.createInstance(U.$_7b,{state:X,extensionDevelopmentPath:W.extensionDevelopmentPath,isExtensionTestHost:!!W.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(he),this.h.set(he.id,he),this.a.fire(he),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const de=new p.$Qc;de.add(he.onDidSignalReady(()=>this.b.fire(he))),de.add(d.Event.once(he.onDidClose)(()=>this.pb(he,de))),de.add(d.Event.once(he.onDidDestroy)(()=>this.c.fire(he))),de.add(he.onDidTriggerSystemContextMenu(({x:we,y:be})=>this.g.fire({window:he,x:we,y:be})));const le=(0,h.$Mf)(he.win?.webContents);le.removeAllListeners("devtools-reload-page"),le.on("devtools-reload-page",()=>this.D.reload(he)),this.D.registerWindow(he)}return W.windowId=B.id,B.isReady?this.D.unload(B,4).then(async X=>{X||await this.nb(B,W,O,L)}):await this.nb(B,W,O,L),B}async nb(O,j,V,L){if(j.extensionDevelopmentPath||((0,ce.$0h)(j.workspace)?j.backupPath=this.F.registerWorkspaceBackup({workspace:j.workspace,remoteAuthority:j.remoteAuthority}):(0,ce.$5h)(j.workspace)?j.backupPath=this.F.registerFolderBackup({folderUri:j.workspace.uri,remoteAuthority:j.remoteAuthority}):j.backupPath=this.F.registerEmptyWindowBackup({backupFolder:V.emptyWindowBackupInfo?.backupFolder??(0,oe.$67b)().id,remoteAuthority:j.remoteAuthority})),this.C.isEnabled()){const B=j.workspace??(0,ce.$9h)(j.backupPath,!1),W=this.ob(V,B,L),X=W instanceof Promise?await W:W;j.profiles.profile=X,j.extensionDevelopmentPath||await this.C.setProfileForWorkspace(B,X)}O.load(j)}ob(O,j,V){return O.forceProfile?this.C.profiles.find(L=>L.name===O.forceProfile)??this.C.createNamedProfile(O.forceProfile):O.forceTempProfile?this.C.createTransientProfile():this.C.getProfileForWorkspace(j)??V}pb(O,j){this.h.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),j.dispose()}getFocusedWindow(){const O=S.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.rb(this.getWindows())}qb(O){return this.rb(this.getWindows().filter(j=>(0,g.$Dg)(j.remoteAuthority,O)))}rb(O){return(0,T.$g8b)(O)}sendToFocused(O,...j){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,P.CancellationToken.None,...j)}sendToOpeningWindow(O,...j){this.B(d.Event.once(this.onDidSignalReadyWindow)(V=>{V.sendWhenReady(O,P.CancellationToken.None,...j)}))}sendToAll(O,j,V){for(const L of this.getWindows())V&&V.indexOf(L.id)>=0||L.sendWhenReady(O,P.CancellationToken.None,j)}getWindows(){return Array.from(this.h.values())}getWindowCount(){return this.h.size}getWindowById(O){return this.h.get(O)}getWindowByWebContents(O){const j=S.BrowserWindow.fromWebContents(O);if(j)return this.getWindowById(j.id)}};e.$f9b=se,e.$f9b=se=ve([te(3,m.$cj),te(4,N.$97b),te(5,I.$QN),te(6,G.$nn),te(7,r.$C7b),te(8,z.$K7b),te(9,c.$E7b),te(10,u.$V7b),te(11,i.$oi),te(12,ae.$N8b),te(13,Z.$77b),te(14,n.$Th),te(15,o.$W7b),te(16,t.$dk),te(17,R.$Y7b),te(18,K.$Q7b),te(19,H.$b8b)],se)}),define(ne[307],re([0,1,65,29,83,54]),function(J,e,S,A,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h9b=void 0;let C=class{constructor(d,a,$,p){this.a=d,this.b=a,this.c=$,this.d=p,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(d,a){const $=this.b.getWindowById(d);if($)return this.a.enterWorkspace($,this.b.getWindows(),a)}createUntitledWorkspace(d,a,$){return this.a.createUntitledWorkspace(a,$)}deleteUntitledWorkspace(d,a){return this.a.deleteUntitledWorkspace(a)}getWorkspaceIdentifier(d,a){return this.a.getWorkspaceIdentifier(a)}getRecentlyOpened(d){return this.c.getRecentlyOpened()}addRecentlyOpened(d,a){return this.c.addRecentlyOpened(a)}removeRecentlyOpened(d,a){return this.c.removeRecentlyOpened(a)}clearRecentlyOpened(d){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$h9b=C,e.$h9b=C=ve([te(0,M.$77b),te(1,A.$d8b),te(2,s.$N8b),te(3,S.$V7b)],C)}),define(ne[308],re([0,1,15,131,36,28,18,49,14,33,3,44,46,2,13,9,4,12,7,32,158,42,159,110,290,162,65,283,17,200,91,132,52,116,220,24,63,94,209,293,211,212,213,16,224,93,78,6,92,219,299,284,291,20,5,305,70,25,59,294,95,34,275,82,122,26,251,253,51,48,265,288,300,289,301,127,267,268,269,272,297,60,29,306,274,30,97,83,307,54,39,233,53,244,50,81,129,277,292,280,8,255,276,228,68,296,271,23,125,295,263,239,72,64,303]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u,i,o,r,t,n,c,m,D,R,k,I,F,U,T,x,Y,ce,oe,ae,Z,K,G,z,N,H,q,ee,se,Q,O,j,V,L,B,W,X,he,de,le,we,be,Ee,Se,Le,ke,pe,_,ue,ge,Re,De,Ue,Me,Ve,ze,ie,fe,me,ye,Ce,je,Fe,Te,qe,Ge,Qe,_e,Xe,it,st,rt,bt,pt,yt,vt,kt,Et,Pt,ot,dt,St,It,Rt,at,Ct,gt,ct,Dt,At,lt,Ot,ut,Mt){"use strict";var ht;Object.defineProperty(e,"__esModule",{value:!0}),e.$A9b=void 0;let ft=class extends f.$Rc{static{ht=this}static{this.a={[y.Schemas.file]:"security.promptForLocalFileProtocolHandling",[y.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Pe,Ie,Oe,$e,Ae,Be,He,Ke,Ne,We,Je,Ze){super(),this.g=Pe,this.h=Ie,this.j=Oe,this.m=$e,this.n=Ae,this.s=Be,this.t=He,this.u=Ke,this.w=Ne,this.y=We,this.z=Je,this.C=Ze,this.D(),this.F()}D(){const Pe=Ne=>Ne?.startsWith(`${y.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);S.session.defaultSession.setPermissionRequestHandler((Ne,We,Je,Ze)=>Pe(Ze.requestingUrl)?Je(Ie.has(We)):Je(!1)),S.session.defaultSession.setPermissionCheckHandler((Ne,We,Je,Ze)=>Pe(Ze.requestingUrl)?Ie.has(We):!1);const Oe=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),$e=Ne=>{for(let We=Ne;We;We=We.parent)if(We.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Ae=Ne=>Ne.resourceType==="xhr"||$e(Ne.frame),Be=Ne=>{const We=Ne.frame;if(!We||!this.b)return!1;const Je=S.BrowserWindow.getAllWindows();for(const Ze of Je)if(We.processId===Ze.webContents.mainFrame.processId)return!0;return!1},He=(Ne,We)=>{if(Ne.path!=="/index.html")return!0;const Je=We.frame;if(!Je||!this.b)return!1;for(const Ze of this.b.getWindows())if(Ze.win&&Je.processId===Ze.win.webContents.mainFrame.processId)return!0;return!1};S.session.defaultSession.webRequest.onBeforeRequest((Ne,We)=>{const Je=h.URI.parse(Ne.url);return Je.scheme===y.Schemas.vscodeWebview&&!He(Je,Ne)?(this.m.error("Blocked vscode-webview request",Ne.url),We({cancel:!0})):Je.scheme===y.Schemas.vscodeFileResource&&!Be(Ne)?(this.m.error("Blocked vscode-file request",Ne.url),We({cancel:!0})):Je.path.endsWith(".svg")&&!Oe.has(Je.scheme)?We({cancel:!Ae(Ne)}):We({cancel:!1})}),S.session.defaultSession.webRequest.onHeadersReceived((Ne,We)=>{const Je=Ne.responseHeaders,Ze=Je["content-type"]||Je["Content-Type"];if(Ze&&Array.isArray(Ze)){const Ye=h.URI.parse(Ne.url);if(Ye.path.endsWith(".svg")&&Oe.has(Ye.scheme))return Je["Content-Type"]=["image/svg+xml"],We({cancel:!1,responseHeaders:Je});if(!Ye.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ze.some(et=>et.toLowerCase().includes("image/svg")))return We({cancel:!Ae(Ne)})}return We({cancel:!1})});const Ke=S.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,w.$ic)(this.s.codeCachePath,"chrome")),b.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,A.disableUNCAccessRestrictions)():(0,A.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,d.setUnexpectedErrorHandler)(Oe=>this.H(Oe)),process.on("uncaughtException",Oe=>{(0,d.$Y)(Oe)||(0,d.$Z)(Oe)}),process.on("unhandledRejection",Oe=>(0,d.$Z)(Oe)),this.t.onWillShutdown(()=>this.dispose()),(0,E.$VT)(),S.app.on("accessibility-support-changed",(Oe,$e)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",$e)}),S.app.on("activate",async(Oe,$e)=>{this.m.trace("app#activate"),$e||await this.b?.openEmptyWindow({context:1})}),S.app.on("web-contents-created",(Oe,$e)=>{(0,ut.$c8b)($e)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow($e)),$e.on("will-navigate",Ae=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),$e.setWindowOpenHandler(Ae=>Ae.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ae.url}}`),this.f?.openExternal(void 0,Ae.url),{action:"deny"}))});let Pe=[],Ie;S.app.on("open-file",(Oe,$e)=>{this.m.trace("app#open-file: ",$e),Oe.preventDefault(),Pe.push((0,qe.$ni)($e)?{workspaceUri:h.URI.file($e)}:{fileUri:h.URI.file($e)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ie=void 0},100)}),S.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$UT.handle("vscode:fetchShellEnv",Oe=>{const $e=this.b?.getWindowByWebContents(Oe.sender);let Ae,Be;return $e?.config?(Ae=$e.config,Be={...process.env,...$e.config.userEnv}):(Ae=this.s.args,Be=process.env),this.X(Ae,Be,!1)}),s.$UT.handle("vscode:writeNlsFile",(Oe,$e,Ae)=>{const Be=this.G([$e]);if(!Be||typeof Ae!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Be,C.$ee.fromString(Ae))}),s.$UT.handle("vscode:readNlsFile",async(Oe,...$e)=>{const Ae=this.G($e);if(!Ae)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ae)).value.toString()}),s.$UT.on("vscode:toggleDevTools",Oe=>Oe.sender.toggleDevTools()),s.$UT.on("vscode:openDevTools",Oe=>Oe.sender.openDevTools()),s.$UT.on("vscode:reloadWindow",Oe=>Oe.sender.reload())}G(Pe){let Ie;for(const Oe of Pe)typeof Oe=="string"&&(typeof Ie!="string"?Ie=Oe:Ie=(0,w.$ic)(Ie,Oe));if(!(typeof Ie!="string"||!(0,w.$hc)(Ie)||!(0,a.$1f)(Ie,this.s.cachedLanguagesPath,!b.$k)))return h.URI.file(Ie)}H(Pe){if(Pe){const Ie={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.m.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.m.error(Pe.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Pe=this.z.win32AppUserModelId;b.$i&&Pe&&S.app.setAppUserModelId(Pe);try{b.$j&&this.u.getValue("window.nativeTabs")===!0&&!S.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&S.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(We){this.m.error(We)}const Ie=new i.$2T;this.t.onWillShutdown(We=>{We.reason===2&&Ie.dispose()}),this.m.trace("Resolving machine identifier...");const[Oe,$e]=await Promise.all([(0,dt.$p9b)(this.w,this.m),(0,dt.$q9b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Oe}`);const{sharedProcessReady:Ae,sharedProcessClient:Be}=this.P(Oe,$e),He=await this.Q(Oe,$e,Ae);this.B(He.createInstance(r.$h8b)),this.B(He.createInstance(Et.$l9b)),He.invokeFunction(We=>this.R(We,Ie,Be));const Ke=await He.invokeFunction(We=>this.I(We,Ie));this.J(Ie),this.t.phase=2,await He.invokeFunction(We=>this.S(We,Ke)),this.t.phase=3,this.U(),this.B(new ot.$9g(()=>{this.B((0,ot.$ah)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Pe,Ie){const Oe=this.b=Pe.get(je.$d8b),$e=Pe.get(Ve.$IU),Ae=this.f=Pe.get(W.$B8b),Be=Pe.get(I.$W7b),He=this;$e.registerHandler({async handleURL(Ye,et){return He.O(Oe,Be,$e,Ye,et)}});const Ke=this.B(new Te.$g9b({onDidOpenMainWindow:Ae.onDidOpenMainWindow,onDidFocusMainWindow:Ae.onDidFocusMainWindow,getActiveWindowId:()=>Ae.getActiveWindowId(-1)})),Ne=new u.$Ch(Ye=>Ke.getActiveClientId().then(et=>Ye===et)),We=new ze.$08b(Ne,this.m),Je=Ie.getChannel("urlHandler",We);$e.registerHandler(new ze.$98b(Je));const Ze=await this.L(Oe,Be);return this.B(new fe.$$8b(Ze?.urls,$e,Oe,this.s,this.z,this.m)),Ze}J(Pe){const Ie=()=>({statusCode:404,data:"Not found"}),Oe=new Ot.$U(()=>Pe.getChannel(lt.$x9b,new lt.$y9b));S.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,($e,Ae)=>{const Be=h.URI.parse($e.url);if(!Be.authority.startsWith("window:"))return Ae(Ie());Oe.value.call(lt.$w9b,[Be]).then(He=>Ae({...He,data:Buffer.from(He.body,"base64")}),He=>{this.m.warn("error dispatching remote resource call",He),Ae({statusCode:500,data:String(He)})})})}async L(Pe,Ie){const Oe=this.s.args["open-url"]?this.s.args._urls||[]:[];Oe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Oe);const $e=global.getOpenUrls()||[];if($e.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",$e),Oe.length+$e.length===0)return;const Ae=[...Oe,...$e].map(Ke=>{try{return{uri:h.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),Be=[],He=[];for(const Ke of Ae){if(!Ke)continue;const Ne=this.N(Ke.uri);if(Ne)if(await this.M(Ne,Pe,Ie)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Ne),Be.push(Ne);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),He.push(Ke)}return{urls:He,openables:Be}}async M(Pe,Ie,Oe){let $e,Ae;if((0,Ce.$nC)(Pe)?($e=Pe.workspaceUri,Ae=(0,t.localize)(0,null,$e.scheme===y.Schemas.file?(0,v.$xv)($e,{os:b.OS,tildify:this.s}):$e.toString(!0),this.z.nameShort)):(0,Ce.$oC)(Pe)?($e=Pe.folderUri,Ae=(0,t.localize)(1,null,$e.scheme===y.Schemas.file?(0,v.$xv)($e,{os:b.OS,tildify:this.s}):$e.toString(!0),this.z.nameShort)):($e=Pe.fileUri,Ae=(0,t.localize)(2,null,$e.scheme===y.Schemas.file?(0,v.$xv)($e,{os:b.OS,tildify:this.s}):$e.toString(!0),this.z.nameShort)),$e.scheme!==y.Schemas.file&&$e.scheme!==y.Schemas.vscodeRemote||this.u.getValue(ht.a[$e.scheme])===!1)return!1;const{response:He,checkboxChecked:Ke}=await Oe.showMessageBox({type:"warning",buttons:[(0,t.localize)(3,null),(0,t.localize)(4,null)],message:Ae,detail:(0,t.localize)(5,null),checkboxLabel:$e.scheme===y.Schemas.file?(0,t.localize)(6,null):(0,t.localize)(7,null),cancelId:1});if(He!==0)return!0;if(Ke){const Ne={channel:"vscode:disablePromptForProtocolHandling",args:$e.scheme===y.Schemas.file?"local":"remote"};Ie.sendToFocused(Ne.channel,Ne.args),Ie.sendToOpeningWindow(Ne.channel,Ne.args)}return!1}N(Pe){if(Pe.path){if(Pe.authority===y.Schemas.file){const Ie=h.URI.file(Pe.fsPath);return(0,qe.$ni)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Pe.authority===y.Schemas.vscodeRemote){const Ie=Pe.path.indexOf(w.$fc.sep,1);if(Ie!==-1){const Oe=Pe.path.substring(1,Ie),$e=Pe.path.substring(Ie);let Ae=Pe.query;const Be=new URLSearchParams(Pe.query);Be.get("windowId")==="_blank"&&(Be.delete("windowId"),Ae=Be.toString());const He=h.URI.from({scheme:y.Schemas.vscodeRemote,authority:Oe,path:$e,query:Ae,fragment:Pe.fragment});return(0,qe.$ni)($e)?{workspaceUri:He}:/:[\d]+$/.test($e)?{fileUri:He}:{folderUri:He}}}}}async O(Pe,Ie,Oe,$e,Ae){this.m.trace("app#handleProtocolUrl():",$e.toString(!0),Ae),$e.scheme===this.z.urlProtocol&&$e.path==="workspace"&&($e=$e.with({authority:"file",path:h.URI.parse($e.query).path,query:""}));let Be=!1;const He=new URLSearchParams($e.query);He.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",$e.toString(!0)),He.delete("windowId"),$e=$e.with({query:He.toString()}),Be=!0):b.$j&&Pe.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",$e.toString(!0)),Be=!0);const Ke=He.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",$e.toString(!0)),He.delete("continueOn"),$e=$e.with({query:He.toString()}),this.s.continueOn=Ke??void 0);const Ne=this.N($e);return Ne?await this.M(Ne,Pe,Ie)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",$e.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Ne,$e.toString(!0)),(0,gt.$Nb)(await Pe.open({context:5,cli:{...this.s.args},urisToOpen:[Ne],forceNewWindow:Be,gotoLineMode:!0}))?.focus(),!0):Be?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",$e.toString(!0)),await(0,gt.$Nb)(await Pe.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,he.$Zk)($e)}))?.ready(),Oe.open($e,Ae)):(this.m.trace("app#handleProtocolUrl(): not handled",$e.toString(!0),Ae),!1)}P(Pe,Ie){const Oe=this.B(this.j.createInstance(de.$V8b,Pe,Ie)),$e=(async()=>{this.m.trace("Main->SharedProcess#connect");const Be=await Oe.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$3T(Be,"main")})();return{sharedProcessReady:(async()=>(await Oe.whenReady(),$e))(),sharedProcessClient:$e}}async Q(Pe,Ie,Oe){const $e=new ee.$Sh;switch(process.platform){case"win32":$e.set(ue.$UU,new H.$Rh(Me.$78b));break;case"linux":b.$l?$e.set(ue.$UU,new H.$Rh(Ue.$68b,[process.env.SNAP,process.env.SNAP_REVISION])):$e.set(ue.$UU,new H.$Rh(De.$58b));break;case"darwin":$e.set(ue.$UU,new H.$Rh(Re.$48b));break}$e.set(je.$d8b,new H.$Rh(Fe.$f9b,[Pe,Ie,this.h],!1)),$e.set(ut.$b8b,new H.$Rh(Mt.$z9b,void 0,!1));const Ae=new I.$X7b(this.m,this.z);$e.set(I.$W7b,Ae),$e.set(j.$H8b,new H.$Rh(j.$I8b,void 0,!1)),$e.set(k.$n8b,new H.$Rh(k.$o8b,void 0,!1)),$e.set(R.$vm,u.ProxyChannel.toService((0,u.$Ah)(Oe.then(We=>We.getChannel("diagnostics"))))),$e.set(se.$Txb,new H.$Rh(Q.$D8b,[this.h])),$e.set(F.$CU,new H.$Rh(U.$p8b)),$e.set(O.$E8b,new H.$Rh(O.$F8b)),$e.set(W.$B8b,new H.$Rh(W.$C8b,void 0,!1)),$e.set(me.$_8b,new H.$Rh(ye.$b9b)),$e.set(B.$Q8b,new H.$Rh(B.$R8b)),$e.set(ce.$q8b,new H.$Rh(oe.$s8b)),$e.set(Ee.$M7b,new H.$Rh(Ee.$N7b)),$e.set(Ee.$O7b,new H.$Rh(Ee.$P7b));const Be=new Dt.$v9b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),He=new At.$Br(Be,this.u,this.m,this.n);$e.set(ct.$cr,He),b.$i?$e.set(ae.$t8b,new H.$Rh(Z.$u8b)):b.$j?$e.set(ae.$t8b,new H.$Rh(Z.$v8b)):b.$k&&$e.set(ae.$t8b,new H.$Rh(Z.$w8b));const Ke=new c.$i8b(this.s,this.u,this.m,this.w);$e.set(n.$V7b,Ke);const Ne=new Xe.$87b(this.s,this.m,this.C,Ke,Ae);if($e.set(Xe.$77b,Ne),$e.set(Ge.$fV,new H.$Rh(_e.$h9b,void 0,!1)),$e.set(Qe.$N8b,new H.$Rh(Qe.$O8b,void 0,!1)),$e.set(Ve.$IU,new H.$Rh(ie.$KU,void 0,!1)),(0,_.$wo)(this.z,this.s)){const We=(0,_.$Bo)(this.z,this.u),Je=(0,u.$Ah)(Oe.then(nt=>nt.getChannel("telemetryAppender"))),Ze=new ke.$Y8b(Je),Ye=(0,Se.$mo)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Pe,Ie,We),et=(0,_.$Co)(this.s),tt={appenders:[Ze],commonProperties:Ye,piiPaths:et,sendErrorTelemetry:!0};$e.set(Le.$hl,new H.$Rh(pe.$6q,[tt],!1))}else $e.set(Le.$hl,_.$qo);return $e.set(yt.$zp,new H.$Rh(St.$XN,void 0,!0)),$e.set(vt.$Dp,new H.$Rh(kt.$k9b,void 0,!0)),$e.set(at.$t9b,new H.$Rh(at.$u9b,void 0,!0)),await ot.Promises.settled([Ke.initialize(),Ne.initialize()]),this.j.createChild($e)}R(Pe,Ie,Oe){const $e=this.B(new f.$Qc),Ae=u.ProxyChannel.fromService(Pe.get(j.$H8b),$e,{disableMarshalling:!0});this.g.registerChannel("launch",Ae);const Be=u.ProxyChannel.fromService(Pe.get(k.$n8b),$e,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Be);const He=new st.$i9b(Pe.get(it.$nn));Ie.registerChannel("policy",He),Oe.then(xe=>xe.registerChannel("policy",He));const Ke=this.y.getProvider(y.Schemas.file);(0,g.$Lf)(Ke instanceof N.$fq);const Ne=new z.$x8b(Ke,this.m,this.s);Ie.registerChannel(K.$GN,Ne),Oe.then(xe=>xe.registerChannel(K.$GN,Ne));const We=u.ProxyChannel.fromService(Pe.get(rt.$K7b),$e);Ie.registerChannel("userDataProfiles",We),Oe.then(xe=>xe.registerChannel("userDataProfiles",We));const Je=new bt.$1q(Pe.get(pt.$Xo));Oe.then(xe=>xe.registerChannel("request",Je));const Ze=new ge.$Z8b(Pe.get(ue.$UU));Ie.registerChannel("update",Ze);const Ye=u.ProxyChannel.fromService(Pe.get(se.$Txb),$e);Ie.registerChannel("issue",Ye);const et=u.ProxyChannel.fromService(Pe.get(F.$CU),$e);Ie.registerChannel("encryption",et);const tt=u.ProxyChannel.fromService(Pe.get(le.$8k),$e);Ie.registerChannel("sign",tt);const nt=u.ProxyChannel.fromService(Pe.get(O.$E8b),$e);Ie.registerChannel("keyboardLayout",nt),this.f=Pe.get(W.$B8b);const mt=u.ProxyChannel.fromService(this.f,$e);Ie.registerChannel("nativeHost",mt),Oe.then(xe=>xe.registerChannel("nativeHost",mt));const Ft=u.ProxyChannel.fromService(Pe.get(Ge.$fV),$e);Ie.registerChannel("workspaces",Ft);const Lt=u.ProxyChannel.fromService(Pe.get(B.$Q8b),$e);Ie.registerChannel("menubar",Lt);const Ut=u.ProxyChannel.fromService(Pe.get(Ve.$IU),$e);Ie.registerChannel("url",Ut);const jt=u.ProxyChannel.fromService(Pe.get(me.$_8b),$e);Ie.registerChannel("webview",jt);const $t=this.B(new be.$W8b(this.m,Pe.get(Ee.$M7b)));Ie.registerChannel("storage",$t),Oe.then(xe=>xe.registerChannel("storage",$t));const Nt=this.B(new Pt.$m9b(Pe.get(Ee.$M7b),Pe.get(rt.$K7b),this.m));Oe.then(xe=>xe.registerChannel("profileStorageListener",Nt));const Tt=u.ProxyChannel.fromService(Pe.get(ct.$cr),$e);Ie.registerChannel(ct.TerminalIpcChannels.LocalPty,Tt);const Wt=u.ProxyChannel.fromService(Pe.get(ae.$t8b),$e);Ie.registerChannel("externalTerminal",Wt);const wt=new It.$r9b(Pe.get(Rt.$97b));Ie.registerChannel("logger",wt),Oe.then(xe=>xe.registerChannel("logger",wt));const zt=new D.$j8b(Pe.get(je.$d8b));Ie.registerChannel("extensionhostdebugservice",zt);const Bt=u.ProxyChannel.fromService(Pe.get(ce.$q8b),$e);Ie.registerChannel(ce.$r8b,Bt);const qt=u.ProxyChannel.fromService(Pe.get(at.$t9b),$e);Ie.registerChannel(Ct.$s9b,qt)}async S(Pe,Ie){const Oe=this.b=Pe.get(je.$d8b);this.c=Pe.get(ut.$b8b);const $e=(0,x.$Sl)(process.env)?0:4,Ae=this.s.args;if(Ie){if(Ie.openables.length>0)return Oe.open({context:$e,cli:Ae,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const tt of Ie.urls){const nt=new URLSearchParams(tt.uri.query);if(nt.get("windowId")==="_blank")return nt.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:nt.toString()}),Oe.open({context:$e,cli:Ae,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,He=Ae._.length,Ke=!!Ae["folder-uri"],Ne=!!Ae["file-uri"],We=Ae["skip-add-to-recently-opened"]===!0,Je=Ae.wait&&Ae.waitMarkerFilePath?h.URI.file(Ae.waitMarkerFilePath):void 0,Ze=Ae.remote||void 0,Ye=Ae.profile,et=Ae["profile-temp"];if(!He&&!Ke&&!Ne){if(Ae["new-window"]||Ye||et)return Oe.open({context:$e,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:We,waitMarkerFileURI:Je,initialStartup:!0,remoteAuthority:Ze,forceProfile:Ye,forceTempProfile:et});if(Be.length)return Oe.open({context:1,cli:Ae,urisToOpen:Be.map(tt=>(0,qe.$ni)(tt)?{workspaceUri:h.URI.file(tt)}:{fileUri:h.URI.file(tt)}),noRecentEntry:We,waitMarkerFileURI:Je,initialStartup:!0})}return Oe.open({context:$e,cli:Ae,forceNewWindow:Ae["new-window"]||!He&&Ae["unity-launch"],diffMode:Ae.diff,mergeMode:Ae.merge,noRecentEntry:We,waitMarkerFileURI:Je,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:Ze,forceProfile:Ye,forceTempProfile:et})}U(){this.W(),S.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Pe,Ie)=>{Ie({url:Pe.url.replace(/^vscode-remote-resource:/,"http:"),method:Pe.method})}),this.X(this.s.args,process.env,!0),this.Y(),b.$j&&S.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Pe=this.z.win32MutexName;if(b.$i&&Pe)try{const Ie=await new Promise(($e,Ae)=>{J(["@vscode/windows-mutex"],$e,Ae)}),Oe=new Ie.Mutex(Pe);$.Event.once(this.t.onWillShutdown)(()=>Oe.release())}catch(Ie){this.m.error(Ie)}}async X(Pe,Ie,Oe){try{return await(0,Y.$Yl)(this.u,this.m,Pe,Ie)}catch($e){const Ae=(0,P.$Fi)($e);Oe?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ae):this.m.error(Ae)}return{}}async Y(){try{const Ie=(await this.y.readFile(this.s.argvResource)).value.toString(),Oe=JSON.parse((0,p.$0m)(Ie)),Ae=(0,_.$yo)(this.u)>=1;if(Oe["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ae},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.$hg)()}"`,"}"],He=Ie.substring(0,Ie.length-2).concat(`,
`,Be.join(`
`));await this.y.writeFile(this.s.argvResource,C.$ee.fromString(He))}else{const Be=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ae},`);Be!==Ie&&await this.y.writeFile(this.s.argvResource,C.$ee.fromString(Be))}}catch(Pe){this.m.error(Pe)}}};e.$A9b=ft,e.$A9b=ft=ht=ve([te(2,q.$Th),te(3,L.$cj),te(4,L.$dj),te(5,T.$C7b),te(6,V.$E7b),te(7,m.$oi),te(8,we.$QN),te(9,G.$dk),te(10,X.$uj),te(11,rt.$K7b)],ft)}),define(ne[314],re([0,1,15,45,7,23,8,49,14,33,3,46,13,9,67,4,35,27,21,42,99,308,10,17,238,250,24,63,202,16,222,93,78,218,92,20,225,5,79,25,80,278,126,287,50,286,95,249,34,51,69,53,39,234,232,2,40,266,68,227,115,121,270,264]),function(J,e,S,A,s,M,C,P,d,a,$,p,v,f,y,w,b,g,h,l,E,u,i,o,r,t,n,c,m,D,R,k,I,F,U,T,x,Y,ce,oe,ae,Z,K,G,z,N,H,q,ee,se,Q,O,j,V,L,B,W,X,he,de,le,we,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ee{main(){try{this.a()}catch(ke){console.error(ke.message),S.app.exit(1)}}async a(){(0,d.setUnexpectedErrorHandler)(Me=>console.error(Me));const[ke,pe,_,ue,ge,Re,De,Ue]=this.b();try{try{await this.d(_,Ue,ue,ge,De)}catch(Me){throw this.f(_,De,Me),Me}await ke.invokeFunction(async Me=>{const Ve=Me.get(Y.$cj),ze=Me.get(T.$E7b),ie=Me.get(D.$dk),fe=Me.get(Y.$dj),me=await this.e(Ve,_,ze,ke,De,!0);return h.Promises.writeFile(_.mainLockfile,String(process.pid)).catch(ye=>{Ve.warn(`app#startup(): Error writing main lockfile: ${ye.stack}`)}),Re.logger=fe.createLogger("main",{name:(0,i.localize)(0,null)}),$.Event.once(ze.onWillShutdown)(ye=>{ie.dispose(),ue.dispose(),ye.join("instanceLockfile",h.Promises.unlink(_.mainLockfile).catch(()=>{}))}),ke.createInstance(u.$A9b,me,pe).startup()})}catch(Me){ke.invokeFunction(this.i,Me)}}b(){const ke=new U.$Sh,pe=new B.$Qc;process.once("exit",()=>pe.dispose());const _={_serviceBrand:void 0,...ce.default};ke.set(oe.$uj,_);const ue=new n.$D7b(this.j(),_),ge=this.c(ue);ke.set(n.$C7b,ue);const Re=new he.$07b((0,Y.$qj)(ue),ue.logsHome);ke.set(he.$97b,Re);const De=new x.$l5b(Re.getLogLevel()),Ue=pe.add(new de.$YN(De,[new Y.$jj(Re.getLogLevel())]));ke.set(Y.$cj,Ue);const Me=new R.$Sp(Ue);ke.set(D.$dk,Me);const Ve=new k.$fq(Ue);Me.registerProvider(v.Schemas.file,Ve);const ze=new X.$Fr(Me);ke.set(W.$Nk,ze);const ie=new we.$TN(1,ue,Ue,Me);ke.set(ee.$PN,ie),ke.set(ee.$QN,ie);const fe=new O.$L7b(ie,ze,ue,Me,Ue);ke.set(O.$K7b,fe),Me.registerProvider(v.Schemas.vscodeUserData,new be.$L9b(v.Schemas.file,Ve,v.Schemas.vscodeUserData,fe,ze,Ue));const me=w.$i&&_.win32RegValueName?pe.add(new V.$J9b(Ue,_.win32RegValueName)):ue.policyFile?pe.add(new L.$K9b(ue.policyFile,Me,Ue)):new j.$pn;ke.set(j.$nn,me);const ye=new r.$Pn(fe.defaultProfile.settingsResource,Me,me,Ue);return ke.set(o.$oi,ye),ke.set(T.$E7b,new I.$Rh(T.$F7b,void 0,!1)),ke.set(z.$Xo,new I.$Rh(N.$H9b,void 0,!0)),ke.set(Q.$Q7b,new I.$Rh(Q.$R7b)),ke.set(H.$8k,new I.$Rh(q.$I9b,void 0,!1)),ke.set(K.$dv,new I.$Rh(G.$F9b)),ke.set(ae.$Y7b,new Z.$C9b(ue,fe,Ue)),[new F.$iq(ke,!0),ge,ue,ye,ie,De,_,fe]}c(ke){const pe={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(_=>{const ue=process.env[_];typeof ue=="string"&&(pe[_]=ue)}),Object.assign(process.env,pe),pe}async d(ke,pe,_,ue,ge){await C.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:v.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:v.Schemas.file}).fsPath,ke.backupHome].map(Re=>Re?h.Promises.mkdir(Re,{recursive:!0}):void 0)),ue.init(),_.initialize()]),pe.init()}async e(ke,pe,_,ue,ge,Re){let De;try{(0,y.mark)("code/willStartMainServer"),De=await(0,E.$Ph)(pe.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),$.Event.once(_.onWillShutdown)(()=>De.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.f(pe,ge,Ue),Ue;let Me;try{Me=await(0,E.$Qh)(pe.mainIPCHandle,"main")}catch(fe){if(!Re||w.$i||fe.code!=="ECONNREFUSED")throw fe.code==="EPERM"&&this.g((0,i.localize)(1,null,ge.nameShort),(0,i.localize)(2,null),ge),fe;try{(0,A.unlinkSync)(pe.mainIPCHandle)}catch(me){throw ke.warn("Could not delete obsolete instance handle",me),me}return this.e(ke,pe,_,ue,ge,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const fe=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw ke.error(fe),Me.dispose(),new Error(fe)}let Ve;!pe.args.wait&&!pe.args.status&&(Ve=setTimeout(()=>{this.g((0,i.localize)(3,null,ge.nameShort),(0,i.localize)(4,null),ge)},1e4));const ze=l.ProxyChannel.toService(Me.getChannel("launch"),{disableMarshalling:!0}),ie=l.ProxyChannel.toService(Me.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ue.invokeFunction(async()=>{const fe=new t.$Mr(se.$qo,ge),me=await ie.getMainDiagnostics(),ye=await ie.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ce=await fe.getDiagnostics(me,ye);throw console.log(Ce),new d.$_});throw w.$i&&await this.h(ze,ke),ke.trace("Sending env to running instance..."),await ze.start(pe.args,process.env),Me.dispose(),Ve&&clearTimeout(Ve),new d.$_("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,i.localize)(5,null,ge.nameShort)),new d.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),De}f(ke,pe,_){if(_.code==="EACCES"||_.code==="EPERM"){const ue=(0,M.$Gb)([ke.userDataPath,ke.extensionsPath,E.$Lh]).map(ge=>(0,p.$xv)(s.URI.file(ge),{os:w.OS,tildify:ke}));this.g((0,i.localize)(6,null),(0,i.localize)(7,null,(0,P.$Fi)(_),ue.join(`
`)),pe)}}g(ke,pe,_){S.dialog.showMessageBoxSync((0,le.$Lv)({type:"warning",buttons:[(0,i.localize)(8,null)],message:ke,detail:pe},_).options)}async h(ke,pe){if(w.$i){const _=await ke.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",_);try{(await new Promise((ue,ge)=>{J(["windows-foreground-love"],ue,ge)})).allowSetForegroundWindow(_)}catch(ue){pe.error(ue)}}}i(ke,pe){const _=ke.get(Y.$cj),ue=ke.get(T.$E7b);let ge=0;pe&&(pe.isExpected?pe.message&&_.trace(pe.message):(ge=1,pe.stack?_.error(pe.stack):_.error(`Startup error: ${pe.toString()}`))),ue.kill(ge)}j(){const ke=this.k((0,c.$Pl)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const pe=(0,m.$B9b)(ke.verbose);pe&&((0,c.$Rl)(process.argv,"--waitMarkerFilePath",pe),ke.waitMarkerFilePath=pe)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const pe=this.l(ke._,ke.goto);ke._=pe}return ke}l(ke,pe){const _=(0,b.cwd)(),ue=ke.map(De=>{let Ue=String(De),Me;pe&&(Me=(0,a.$8f)(Ue),Ue=Me.path),Ue&&(Ue=this.m(_,Ue));const Ve=(0,a.$3f)(Ue,_),ze=(0,f.$mc)(Ve);return ze&&!(0,a.$Yf)(ze)?null:pe&&Me?(Me.path=Ve,this.n(Me)):Ve}),ge=w.$i||w.$j,Re=(0,M.$Lb)(ue,De=>De&&ge?De.toLowerCase():De||"");return(0,M.$Gb)(Re)}m(ke,pe){return w.$i&&(pe=(0,g.$Ne)(pe,'"')),pe=(0,g.$Le)((0,g.$Le)(pe," "),"	"),w.$i&&(pe=(0,f.$jc)(ke,pe),pe=(0,g.$Ne)(pe,".")),pe}n(ke){const pe=[ke.path];return typeof ke.line=="number"&&pe.push(String(ke.line)),typeof ke.column=="number"&&pe.push(String(ke.column)),pe.join(":")}}new Ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/60c8cddf1ae631ce52714d885adba2cdc889415b/core/vs/code/electron-main/main.js.map
