/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/window","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],we=function(ae){for(var t=[],v=0,T=ae.length;v<T;v++)t[v]=$e[ae[v]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:jt,setPrototypeOf:zt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:it,seal:ut,create:ri}=Object,{apply:Ft,construct:Nt}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,v,T){return t.apply(v,T)}),it||(it=function(t){return t}),ut||(ut=function(t){return t}),Nt||(Nt=function(t,v){return new t(...v)});const oi=at(Array.prototype.forEach),Ht=at(Array.prototype.pop),bt=at(Array.prototype.push),Dt=at(String.prototype.toLowerCase),Ot=at(String.prototype.toString),li=at(String.prototype.match),ct=at(String.prototype.replace),ai=at(String.prototype.indexOf),hi=at(String.prototype.trim),lt=at(RegExp.prototype.test),$t=ui(TypeError);function at(ae){return function(t){for(var v=arguments.length,T=new Array(v>1?v-1:0),i=1;i<v;i++)T[i-1]=arguments[i];return Ft(ae,t,T)}}function ui(ae){return function(){for(var t=arguments.length,v=new Array(t),T=0;T<t;T++)v[T]=arguments[T];return Nt(ae,v)}}function ze(ae,t,v){var T;v=(T=v)!==null&&T!==void 0?T:Dt,zt&&zt(ae,null);let i=t.length;for(;i--;){let H=t[i];if(typeof H=="string"){const w=v(H);w!==H&&(ii(t)||(t[i]=w),H=w)}ae[H]=!0}return ae}function gt(ae){const t=ri(null);for(const[v,T]of jt(ae))t[v]=T;return t}function yt(ae,t){for(;ae!==null;){const T=si(ae,t);if(T){if(T.get)return at(T.get);if(typeof T.value=="function")return at(T.value)}ae=ni(ae)}function v(T){return console.warn("fallback value for",T),null}return v}const Ut=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Tt=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=it(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Rt=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=it(["#text"]),Vt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Et=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ut(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ut(/<%[\w\W]*|[\w\W]*%>/gm),mi=ut(/\${[\w\W]*}/gm),bi=ut(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ut(/^aria-[\-\w]+$/),_t=ut(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ut(/^(?:\w+script|data):/i),wi=ut(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ut(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:_t,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Qt});const vi=()=>typeof window>"u"?null:window,Di=function(t,v){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let T=null;const i="data-tt-policy-suffix";v&&v.hasAttribute(i)&&(T=v.getAttribute(i));const H="dompurify"+(T?"#"+T:"");try{return t.createPolicy(H,{createHTML(w){return w},createScriptURL(w){return w}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function xt(){let ae=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Ie=>xt(Ie);if(t.version="3.0.5",t.removed=[],!ae||!ae.document||ae.document.nodeType!==9)return t.isSupported=!1,t;const v=ae.document,T=v.currentScript;let{document:i}=ae;const{DocumentFragment:H,HTMLTemplateElement:w,Node:D,Element:c,NodeFilter:d,NamedNodeMap:f=ae.NamedNodeMap||ae.MozNamedAttrMap,HTMLFormElement:R,DOMParser:s,trustedTypes:a}=ae,e=c.prototype,h=yt(e,"cloneNode"),l=yt(e,"nextSibling"),m=yt(e,"childNodes"),n=yt(e,"parentNode");if(typeof w=="function"){const Ie=i.createElement("template");Ie.content&&Ie.content.ownerDocument&&(i=Ie.content.ownerDocument)}let r,b="";const{implementation:u,createNodeIterator:o,createDocumentFragment:N,getElementsByTagName:j}=i,{importNode:L}=v;let g={};t.isSupported=typeof jt=="function"&&typeof n=="function"&&u&&u.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:y,ERB_EXPR:B,TMPLIT_EXPR:q,DATA_ATTR:x,ARIA_ATTR:P,IS_SCRIPT_OR_DATA:O,ATTR_WHITESPACE:K}=Kt;let{IS_ALLOWED_URI:te}=Kt,se=null;const fe=ze({},[...Ut,...Tt,...Lt,...Rt,...Wt]);let le=null;const oe=ze({},[...Vt,...It,...qt,...Et]);let be=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Se=null,Ae=null,Pe=!0,de=!0,ie=!1,ce=!0,Z=!1,W=!1,Y=!1,C=!1,V=!1,$=!1,U=!1,Q=!0,p=!1;const A="user-content-";let E=!0,M=!1,k={},I=null;const S=ze({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let F=null;const z=ze({},["audio","video","img","source","image","track"]);let G=null;const ee=ze({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),ne="http://www.w3.org/1998/Math/MathML",me="http://www.w3.org/2000/svg",ve="http://www.w3.org/1999/xhtml";let Ne=ve,Ce=!1,De=null;const Le=ze({},[ne,me,ve],Ot);let Te;const We=["application/xhtml+xml","text/html"],He="text/html";let Me,Ye=null;const J=i.createElement("form"),he=function(ue){return ue instanceof RegExp||ue instanceof Function},pe=function(ue){if(!(Ye&&Ye===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=gt(ue),Te=We.indexOf(ue.PARSER_MEDIA_TYPE)===-1?Te=He:Te=ue.PARSER_MEDIA_TYPE,Me=Te==="application/xhtml+xml"?Ot:Dt,se="ALLOWED_TAGS"in ue?ze({},ue.ALLOWED_TAGS,Me):fe,le="ALLOWED_ATTR"in ue?ze({},ue.ALLOWED_ATTR,Me):oe,De="ALLOWED_NAMESPACES"in ue?ze({},ue.ALLOWED_NAMESPACES,Ot):Le,G="ADD_URI_SAFE_ATTR"in ue?ze(gt(ee),ue.ADD_URI_SAFE_ATTR,Me):ee,F="ADD_DATA_URI_TAGS"in ue?ze(gt(z),ue.ADD_DATA_URI_TAGS,Me):z,I="FORBID_CONTENTS"in ue?ze({},ue.FORBID_CONTENTS,Me):S,Se="FORBID_TAGS"in ue?ze({},ue.FORBID_TAGS,Me):{},Ae="FORBID_ATTR"in ue?ze({},ue.FORBID_ATTR,Me):{},k="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Pe=ue.ALLOW_ARIA_ATTR!==!1,de=ue.ALLOW_DATA_ATTR!==!1,ie=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,ce=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,Z=ue.SAFE_FOR_TEMPLATES||!1,W=ue.WHOLE_DOCUMENT||!1,V=ue.RETURN_DOM||!1,$=ue.RETURN_DOM_FRAGMENT||!1,U=ue.RETURN_TRUSTED_TYPE||!1,C=ue.FORCE_BODY||!1,Q=ue.SANITIZE_DOM!==!1,p=ue.SANITIZE_NAMED_PROPS||!1,E=ue.KEEP_CONTENT!==!1,M=ue.IN_PLACE||!1,te=ue.ALLOWED_URI_REGEXP||_t,Ne=ue.NAMESPACE||ve,be=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&he(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(be.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&he(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(be.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(be.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),Z&&(de=!1),$&&(V=!0),k&&(se=ze({},[...Wt]),le=[],k.html===!0&&(ze(se,Ut),ze(le,Vt)),k.svg===!0&&(ze(se,Tt),ze(le,It),ze(le,Et)),k.svgFilters===!0&&(ze(se,Lt),ze(le,It),ze(le,Et)),k.mathMl===!0&&(ze(se,Rt),ze(le,qt),ze(le,Et))),ue.ADD_TAGS&&(se===fe&&(se=gt(se)),ze(se,ue.ADD_TAGS,Me)),ue.ADD_ATTR&&(le===oe&&(le=gt(le)),ze(le,ue.ADD_ATTR,Me)),ue.ADD_URI_SAFE_ATTR&&ze(G,ue.ADD_URI_SAFE_ATTR,Me),ue.FORBID_CONTENTS&&(I===S&&(I=gt(I)),ze(I,ue.FORBID_CONTENTS,Me)),E&&(se["#text"]=!0),W&&ze(se,["html","head","body"]),se.table&&(ze(se,["tbody"]),delete Se.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw $t('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=ue.TRUSTED_TYPES_POLICY,b=r.createHTML("")}else r===void 0&&(r=Di(a,T)),r!==null&&typeof b=="string"&&(b=r.createHTML(""));it&&it(ue),Ye=ue}},Ee=ze({},["mi","mo","mn","ms","mtext"]),Fe=ze({},["foreignobject","desc","title","annotation-xml"]),Be=ze({},["title","style","font","a","script"]),Ue=ze({},Tt);ze(Ue,Lt),ze(Ue,ci);const Ze=ze({},Rt);ze(Ze,fi);const Je=function(ue){let ke=n(ue);(!ke||!ke.tagName)&&(ke={namespaceURI:Ne,tagName:"template"});const Oe=Dt(ue.tagName),Ve=Dt(ke.tagName);return De[ue.namespaceURI]?ue.namespaceURI===me?ke.namespaceURI===ve?Oe==="svg":ke.namespaceURI===ne?Oe==="svg"&&(Ve==="annotation-xml"||Ee[Ve]):!!Ue[Oe]:ue.namespaceURI===ne?ke.namespaceURI===ve?Oe==="math":ke.namespaceURI===me?Oe==="math"&&Fe[Ve]:!!Ze[Oe]:ue.namespaceURI===ve?ke.namespaceURI===me&&!Fe[Ve]||ke.namespaceURI===ne&&!Ee[Ve]?!1:!Ze[Oe]&&(Be[Oe]||!Ue[Oe]):!!(Te==="application/xhtml+xml"&&De[ue.namespaceURI]):!1},Ke=function(ue){bt(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},qe=function(ue,ke){try{bt(t.removed,{attribute:ke.getAttributeNode(ue),from:ke})}catch{bt(t.removed,{attribute:null,from:ke})}if(ke.removeAttribute(ue),ue==="is"&&!le[ue])if(V||$)try{Ke(ke)}catch{}else try{ke.setAttribute(ue,"")}catch{}},tt=function(ue){let ke,Oe;if(C)ue="<remove></remove>"+ue;else{const st=li(ue,/^[\r\n\t ]+/);Oe=st&&st[0]}Te==="application/xhtml+xml"&&Ne===ve&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const Ve=r?r.createHTML(ue):ue;if(Ne===ve)try{ke=new s().parseFromString(Ve,Te)}catch{}if(!ke||!ke.documentElement){ke=u.createDocument(Ne,"template",null);try{ke.documentElement.innerHTML=Ce?b:Ve}catch{}}const et=ke.body||ke.documentElement;return ue&&Oe&&et.insertBefore(i.createTextNode(Oe),et.childNodes[0]||null),Ne===ve?j.call(ke,W?"html":"body")[0]:W?ke.documentElement:et},nt=function(ue){return o.call(ue.ownerDocument||ue,ue,d.SHOW_ELEMENT|d.SHOW_COMMENT|d.SHOW_TEXT,null,!1)},dt=function(ue){return ue instanceof R&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof f)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},ft=function(ue){return typeof D=="object"?ue instanceof D:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},ot=function(ue,ke,Oe){g[ue]&&oi(g[ue],Ve=>{Ve.call(t,ke,Oe,Ye)})},At=function(ue){let ke;if(ot("beforeSanitizeElements",ue,null),dt(ue))return Ke(ue),!0;const Oe=Me(ue.nodeName);if(ot("uponSanitizeElement",ue,{tagName:Oe,allowedTags:se}),ue.hasChildNodes()&&!ft(ue.firstElementChild)&&(!ft(ue.content)||!ft(ue.content.firstElementChild))&&lt(/<[/\w]/g,ue.innerHTML)&&lt(/<[/\w]/g,ue.textContent))return Ke(ue),!0;if(!se[Oe]||Se[Oe]){if(!Se[Oe]&&pt(Oe)&&(be.tagNameCheck instanceof RegExp&&lt(be.tagNameCheck,Oe)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Oe)))return!1;if(E&&!I[Oe]){const Ve=n(ue)||ue.parentNode,et=m(ue)||ue.childNodes;if(et&&Ve){const st=et.length;for(let Qe=st-1;Qe>=0;--Qe)Ve.insertBefore(h(et[Qe],!0),l(ue))}}return Ke(ue),!0}return ue instanceof c&&!Je(ue)||(Oe==="noscript"||Oe==="noembed"||Oe==="noframes")&&lt(/<\/no(script|embed|frames)/i,ue.innerHTML)?(Ke(ue),!0):(Z&&ue.nodeType===3&&(ke=ue.textContent,ke=ct(ke,y," "),ke=ct(ke,B," "),ke=ct(ke,q," "),ue.textContent!==ke&&(bt(t.removed,{element:ue.cloneNode()}),ue.textContent=ke)),ot("afterSanitizeElements",ue,null),!1)},kt=function(ue,ke,Oe){if(Q&&(ke==="id"||ke==="name")&&(Oe in i||Oe in J))return!1;if(!(de&&!Ae[ke]&&lt(x,ke))){if(!(Pe&&lt(P,ke))){if(!le[ke]||Ae[ke]){if(!(pt(ue)&&(be.tagNameCheck instanceof RegExp&&lt(be.tagNameCheck,ue)||be.tagNameCheck instanceof Function&&be.tagNameCheck(ue))&&(be.attributeNameCheck instanceof RegExp&&lt(be.attributeNameCheck,ke)||be.attributeNameCheck instanceof Function&&be.attributeNameCheck(ke))||ke==="is"&&be.allowCustomizedBuiltInElements&&(be.tagNameCheck instanceof RegExp&&lt(be.tagNameCheck,Oe)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Oe))))return!1}else if(!G[ke]){if(!lt(te,ct(Oe,K,""))){if(!((ke==="src"||ke==="xlink:href"||ke==="href")&&ue!=="script"&&ai(Oe,"data:")===0&&F[ue])){if(!(ie&&!lt(O,ct(Oe,K,"")))){if(Oe)return!1}}}}}}return!0},pt=function(ue){return ue.indexOf("-")>0},Ct=function(ue){let ke,Oe,Ve,et;ot("beforeSanitizeAttributes",ue,null);const{attributes:st}=ue;if(!st)return;const Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:le};for(et=st.length;et--;){ke=st[et];const{name:ht,namespaceURI:wt}=ke;if(Oe=ht==="value"?ke.value:hi(ke.value),Ve=Me(ht),Qe.attrName=Ve,Qe.attrValue=Oe,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,ot("uponSanitizeAttribute",ue,Qe),Oe=Qe.attrValue,Qe.forceKeepAttr||(qe(ht,ue),!Qe.keepAttr))continue;if(!ce&&lt(/\/>/i,Oe)){qe(ht,ue);continue}Z&&(Oe=ct(Oe,y," "),Oe=ct(Oe,B," "),Oe=ct(Oe,q," "));const St=Me(ue.nodeName);if(kt(St,Ve,Oe)){if(p&&(Ve==="id"||Ve==="name")&&(qe(ht,ue),Oe=A+Oe),r&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!wt)switch(a.getAttributeType(St,Ve)){case"TrustedHTML":{Oe=r.createHTML(Oe);break}case"TrustedScriptURL":{Oe=r.createScriptURL(Oe);break}}try{wt?ue.setAttributeNS(wt,ht,Oe):ue.setAttribute(ht,Oe),Ht(t.removed)}catch{}}}ot("afterSanitizeAttributes",ue,null)},Mt=function Ie(ue){let ke;const Oe=nt(ue);for(ot("beforeSanitizeShadowDOM",ue,null);ke=Oe.nextNode();)ot("uponSanitizeShadowNode",ke,null),!At(ke)&&(ke.content instanceof H&&Ie(ke.content),Ct(ke));ot("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Ie){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ke,Oe,Ve,et;if(Ce=!Ie,Ce&&(Ie="<!-->"),typeof Ie!="string"&&!ft(Ie))if(typeof Ie.toString=="function"){if(Ie=Ie.toString(),typeof Ie!="string")throw $t("dirty is not a string, aborting")}else throw $t("toString is not a function");if(!t.isSupported)return Ie;if(Y||pe(ue),t.removed=[],typeof Ie=="string"&&(M=!1),M){if(Ie.nodeName){const ht=Me(Ie.nodeName);if(!se[ht]||Se[ht])throw $t("root node is forbidden and cannot be sanitized in-place")}}else if(Ie instanceof D)ke=tt("<!---->"),Oe=ke.ownerDocument.importNode(Ie,!0),Oe.nodeType===1&&Oe.nodeName==="BODY"||Oe.nodeName==="HTML"?ke=Oe:ke.appendChild(Oe);else{if(!V&&!Z&&!W&&Ie.indexOf("<")===-1)return r&&U?r.createHTML(Ie):Ie;if(ke=tt(Ie),!ke)return V?null:U?b:""}ke&&C&&Ke(ke.firstChild);const st=nt(M?Ie:ke);for(;Ve=st.nextNode();)At(Ve)||(Ve.content instanceof H&&Mt(Ve.content),Ct(Ve));if(M)return Ie;if(V){if($)for(et=N.call(ke.ownerDocument);ke.firstChild;)et.appendChild(ke.firstChild);else et=ke;return(le.shadowroot||le.shadowrootmode)&&(et=L.call(v,et,!0)),et}let Qe=W?ke.outerHTML:ke.innerHTML;return W&&se["!doctype"]&&ke.ownerDocument&&ke.ownerDocument.doctype&&ke.ownerDocument.doctype.name&&lt(Qt,ke.ownerDocument.doctype.name)&&(Qe="<!DOCTYPE "+ke.ownerDocument.doctype.name+`>
`+Qe),Z&&(Qe=ct(Qe,y," "),Qe=ct(Qe,B," "),Qe=ct(Qe,q," ")),r&&U?r.createHTML(Qe):Qe},t.setConfig=function(Ie){pe(Ie),Y=!0},t.clearConfig=function(){Ye=null,Y=!1},t.isValidAttribute=function(Ie,ue,ke){Ye||pe({});const Oe=Me(Ie),Ve=Me(ue);return kt(Oe,Ve,ke)},t.addHook=function(Ie,ue){typeof ue=="function"&&(g[Ie]=g[Ie]||[],bt(g[Ie],ue))},t.removeHook=function(Ie){if(g[Ie])return Ht(g[Ie])},t.removeHooks=function(Ie){g[Ie]&&(g[Ie]=[])},t.removeAllHooks=function(){g={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define($e[41],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BQ=t.$AQ=void 0;class v{constructor(w){this.domNode=w,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(w){const D=T(w);this.a!==D&&(this.a=D,this.domNode.style.maxWidth=this.a)}setWidth(w){const D=T(w);this.b!==D&&(this.b=D,this.domNode.style.width=this.b)}setHeight(w){const D=T(w);this.c!==D&&(this.c=D,this.domNode.style.height=this.c)}setTop(w){const D=T(w);this.d!==D&&(this.d=D,this.domNode.style.top=this.d)}setLeft(w){const D=T(w);this.e!==D&&(this.e=D,this.domNode.style.left=this.e)}setBottom(w){const D=T(w);this.f!==D&&(this.f=D,this.domNode.style.bottom=this.f)}setRight(w){const D=T(w);this.g!==D&&(this.g=D,this.domNode.style.right=this.g)}setPaddingTop(w){const D=T(w);this.h!==D&&(this.h=D,this.domNode.style.paddingTop=this.h)}setPaddingLeft(w){const D=T(w);this.i!==D&&(this.i=D,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(w){const D=T(w);this.j!==D&&(this.j=D,this.domNode.style.paddingBottom=this.j)}setPaddingRight(w){const D=T(w);this.k!==D&&(this.k=D,this.domNode.style.paddingRight=this.k)}setFontFamily(w){this.l!==w&&(this.l=w,this.domNode.style.fontFamily=this.l)}setFontWeight(w){this.m!==w&&(this.m=w,this.domNode.style.fontWeight=this.m)}setFontSize(w){const D=T(w);this.n!==D&&(this.n=D,this.domNode.style.fontSize=this.n)}setFontStyle(w){this.o!==w&&(this.o=w,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(w){this.p!==w&&(this.p=w,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(w){this.q!==w&&(this.q=w,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(w){this.r!==w&&(this.r=w,this.domNode.style.textDecoration=this.r)}setLineHeight(w){const D=T(w);this.s!==D&&(this.s=D,this.domNode.style.lineHeight=this.s)}setLetterSpacing(w){const D=T(w);this.t!==D&&(this.t=D,this.domNode.style.letterSpacing=this.t)}setClassName(w){this.u!==w&&(this.u=w,this.domNode.className=this.u)}toggleClassName(w,D){this.domNode.classList.toggle(w,D),this.u=this.domNode.className}setDisplay(w){this.v!==w&&(this.v=w,this.domNode.style.display=this.v)}setPosition(w){this.w!==w&&(this.w=w,this.domNode.style.position=this.w)}setVisibility(w){this.x!==w&&(this.x=w,this.domNode.style.visibility=this.x)}setColor(w){this.y!==w&&(this.y=w,this.domNode.style.color=this.y)}setBackgroundColor(w){this.z!==w&&(this.z=w,this.domNode.style.backgroundColor=this.z)}setLayerHinting(w){this.A!==w&&(this.A=w,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(w){this.C!==w&&(this.C=w,this.domNode.style.boxShadow=w)}setContain(w){this.B!==w&&(this.B=w,this.domNode.style.contain=this.B)}setAttribute(w,D){this.domNode.setAttribute(w,D)}removeAttribute(w){this.domNode.removeAttribute(w)}appendChild(w){this.domNode.appendChild(w.domNode)}removeChild(w){this.domNode.removeChild(w.domNode)}}t.$AQ=v;function T(H){return typeof H=="number"?`${H}px`:H}function i(H){return new v(H)}t.$BQ=i}),define($e[69],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TO=t.$SO=void 0;const v=new WeakMap;function T(D){if(!D.parent||D.parent===D)return null;try{const c=D.location,d=D.parent.location;if(c.origin!=="null"&&d.origin!=="null"&&c.origin!==d.origin)return null}catch{return null}return D.parent}class i{static a(c){let d=v.get(c);if(!d){d=[],v.set(c,d);let f=c,R;do R=T(f),R?d.push({window:new WeakRef(f),iframeElement:f.frameElement||null}):d.push({window:new WeakRef(f),iframeElement:null}),f=R;while(f)}return d.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(c,d){if(!d||c===d)return{top:0,left:0};let f=0,R=0;const s=this.a(c);for(const a of s){const e=a.window.deref();if(f+=e?.scrollY??0,R+=e?.scrollX??0,e===d||!a.iframeElement)break;const h=a.iframeElement.getBoundingClientRect();f+=h.top,R+=h.left}return{top:f,left:R}}}t.$SO=i;async function H(D,c){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const d=JSON.stringify({parentOrigin:D,salt:c}),R=new TextEncoder().encode(d),s=await crypto.subtle.digest("sha-256",R);return w(s)}t.$TO=H;function w(D){const d=Array.from(new Uint8Array(D)).map(f=>f.toString(16).padStart(2,"0")).join("");return BigInt(`0x${d}`).toString(32).padStart(52,"0")}}),define($e[70],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$Q=t.$0Q=t.$9Q=t.ListDragOverEffect=void 0;var v;(function(H){H[H.Copy=0]="Copy",H[H.Move=1]="Move"})(v||(t.ListDragOverEffect=v={})),t.$9Q={reject(){return{accept:!1}},accept(){return{accept:!0}}};class T extends Error{constructor(w,D){super(`ListError [${w}] ${D}`)}}t.$0Q=T;class i{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,D){D>0&&this.c.set(w,D)}}t.$$Q=i}),define($e[71],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8Q=void 0;class v{constructor(i){this.a=i}splice(i,H,w){this.a.forEach(D=>D.splice(i,H,w))}}t.$8Q=v}),define($e[42],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GQ=void 0;const v=20;class T{constructor(H,w,D,c,d,f){this.a=Math.round(w),this.b=Math.round(D),this.c=Math.round(H),this.d=c,this.e=d,this.f=f,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new T(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const w=Math.round(H);return this.d!==w?(this.d=w,this.m(),!0):!1}setScrollSize(H){const w=Math.round(H);return this.e!==w?(this.e=w,this.m(),!0):!1}setScrollPosition(H){const w=Math.round(H);return this.f!==w?(this.f=w,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,w,D,c,d){const f=Math.max(0,D-H),R=Math.max(0,f-2*w),s=c>0&&c>D;if(!s)return{computedAvailableSize:Math.round(f),computedIsNeeded:s,computedSliderSize:Math.round(R),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(v,Math.floor(D*R/c))),e=(R-a)/(c-D),h=d*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:s,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(h)}}m(){const H=T.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const w=H-this.c-this.i/2;return Math.round(w/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const w=H-this.c;let D=this.f;return w<this.k?D-=this.d:D+=this.d,D}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const w=this.k+H;return Math.round(w/this.j)}}t.$GQ=T}),define($e[25],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5S=t.$4S=t.$3S=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var v;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(v||(t.TreeVisibility=v={}));var T;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(T||(t.ObjectTreeElementCollapseState=T={}));var i;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var H;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$3S={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(c=!1){return{accept:!0,bubble:0,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:0,effect:0,autoExpand:c}}};class w extends Error{constructor(d,f){super(`TreeError [${d}] ${f}`)}}t.$4S=w;class D{constructor(d){this.a=d,this.b=new WeakMap}map(d){let f=this.b.get(d);return f||(f=this.a(d),this.b.set(d,f)),f}}t.$5S=D}),define($e[16],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$window=t.$wO=void 0,t.$wO=window,t.$window=t.$wO}),define($e[72],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function v(h,l,m){const n=T(h,l);if(n!==-1)return h[n]}t.$eb=v;function T(h,l,m=h.length-1){for(let n=m;n>=0;n--){const r=h[n];if(l(r))return n}return-1}t.$fb=T;function i(h,l){const m=H(h,l);return m===-1?void 0:h[m]}t.$gb=i;function H(h,l,m=0,n=h.length){let r=m,b=n;for(;r<b;){const u=Math.floor((r+b)/2);l(h[u])?r=u+1:b=u}return r-1}t.$hb=H;function w(h,l){const m=D(h,l);return m===h.length?void 0:h[m]}t.$ib=w;function D(h,l,m=0,n=h.length){let r=m,b=n;for(;r<b;){const u=Math.floor((r+b)/2);l(h[u])?b=u:r=u+1}return r}t.$jb=D;function c(h,l,m=0,n=h.length){const r=D(h,l,m,n);return r===h.length?-1:r}t.$kb=c;class d{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(d.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!l(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const m=H(this.e,l,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$lb=d;function f(h,l){if(h.length===0)return;let m=h[0];for(let n=1;n<h.length;n++){const r=h[n];l(r,m)>0&&(m=r)}return m}t.$mb=f;function R(h,l){if(h.length===0)return;let m=h[0];for(let n=1;n<h.length;n++){const r=h[n];l(r,m)>=0&&(m=r)}return m}t.$nb=R;function s(h,l){return f(h,(m,n)=>-l(m,n))}t.$ob=s;function a(h,l){if(h.length===0)return-1;let m=0;for(let n=1;n<h.length;n++){const r=h[n];l(r,h[m])>0&&(m=n)}return m}t.$pb=a;function e(h,l){for(const m of h){const n=l(m);if(n!==void 0)return n}}t.$qb=e}),define($e[73],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function v(w,D){const c=Object.create(null);for(const d of w){const f=D(d);let R=c[f];R||(R=c[f]=[]),R.push(d)}return c}t.$J=v;function T(w,D){const c=[],d=[];for(const f of w)D.has(f)||c.push(f);for(const f of D)w.has(f)||d.push(f);return{removed:c,added:d}}t.$K=T;function i(w,D){const c=[],d=[];for(const[f,R]of w)D.has(f)||c.push(R);for(const[f,R]of D)w.has(f)||d.push(R);return{removed:c,added:d}}t.$L=i;function H(w,D){const c=new Set;for(const d of D)w.has(d)&&c.add(d);return c}t.$M=H}),define($e[74],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4s=t.$3s=t.$2s=t.$1s=void 0;function v(D,c){const d=Math.pow(10,c);return Math.round(D*d)/d}class T{constructor(c,d,f,R=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=v(Math.max(Math.min(1,R),0),3)}static equals(c,d){return c.r===d.r&&c.g===d.g&&c.b===d.b&&c.a===d.a}}t.$1s=T;class i{constructor(c,d,f,R){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=v(Math.max(Math.min(1,d),0),3),this.l=v(Math.max(Math.min(1,f),0),3),this.a=v(Math.max(Math.min(1,R),0),3)}static equals(c,d){return c.h===d.h&&c.s===d.s&&c.l===d.l&&c.a===d.a}static fromRGBA(c){const d=c.r/255,f=c.g/255,R=c.b/255,s=c.a,a=Math.max(d,f,R),e=Math.min(d,f,R);let h=0,l=0;const m=(e+a)/2,n=a-e;if(n>0){switch(l=Math.min(m<=.5?n/(2*m):n/(2-2*m),1),a){case d:h=(f-R)/n+(f<R?6:0);break;case f:h=(R-d)/n+2;break;case R:h=(d-f)/n+4;break}h*=60,h=Math.round(h)}return new i(h,l,m,s)}static i(c,d,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?c+(d-c)*6*f:f<1/2?d:f<2/3?c+(d-c)*(2/3-f)*6:c}static toRGBA(c){const d=c.h/360,{s:f,l:R,a:s}=c;let a,e,h;if(f===0)a=e=h=R;else{const l=R<.5?R*(1+f):R+f-R*f,m=2*R-l;a=i.i(m,l,d+1/3),e=i.i(m,l,d),h=i.i(m,l,d-1/3)}return new T(Math.round(a*255),Math.round(e*255),Math.round(h*255),s)}}t.$2s=i;class H{constructor(c,d,f,R){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=v(Math.max(Math.min(1,d),0),3),this.v=v(Math.max(Math.min(1,f),0),3),this.a=v(Math.max(Math.min(1,R),0),3)}static equals(c,d){return c.h===d.h&&c.s===d.s&&c.v===d.v&&c.a===d.a}static fromRGBA(c){const d=c.r/255,f=c.g/255,R=c.b/255,s=Math.max(d,f,R),a=Math.min(d,f,R),e=s-a,h=s===0?0:e/s;let l;return e===0?l=0:s===d?l=((f-R)/e%6+6)%6:s===f?l=(R-d)/e+2:l=(d-f)/e+4,new H(Math.round(l*60),h,s,c.a)}static toRGBA(c){const{h:d,s:f,v:R,a:s}=c,a=R*f,e=a*(1-Math.abs(d/60%2-1)),h=R-a;let[l,m,n]=[0,0,0];return d<60?(l=a,m=e):d<120?(l=e,m=a):d<180?(m=a,n=e):d<240?(m=e,n=a):d<300?(l=e,n=a):d<=360&&(l=a,n=e),l=Math.round((l+h)*255),m=Math.round((m+h)*255),n=Math.round((n+h)*255),new T(l,m,n,s)}}t.$3s=H;class w{static fromHex(c){return w.Format.CSS.parseHex(c)||w.red}static equals(c,d){return!c&&!d?!0:!c||!d?!1:c.equals(d)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof T)this.rgba=c;else if(c instanceof i)this.i=c,this.rgba=i.toRGBA(c);else if(c instanceof H)this.j=c,this.rgba=H.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&T.equals(this.rgba,c.rgba)&&i.equals(this.hsla,c.hsla)&&H.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=w.k(this.rgba.r),d=w.k(this.rgba.g),f=w.k(this.rgba.b),R=.2126*c+.7152*d+.0722*f;return v(R,4)}static k(c){const d=c/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(c){const d=this.getRelativeLuminance(),f=c.getRelativeLuminance();return d>f?(d+.05)/(f+.05):(f+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const d=this.getRelativeLuminance(),f=c.getRelativeLuminance();return d>f}isDarkerThan(c){const d=this.getRelativeLuminance(),f=c.getRelativeLuminance();return d<f}lighten(c){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:d,g:f,b:R,a:s}=this.rgba;return new w(new T(d,f,R,s*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const d=c.rgba,f=this.rgba.a,R=d.a,s=f+R*(1-f);if(s<1e-6)return w.transparent;const a=this.rgba.r*f/s+d.r*R*(1-f)/s,e=this.rgba.g*f/s+d.g*R*(1-f)/s,h=this.rgba.b*f/s+d.b*R*(1-f)/s;return new w(new T(a,e,h,s))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:d,g:f,b:R,a:s}=this.rgba;return new w(new T(c.rgba.r-s*(c.rgba.r-d),c.rgba.g-s*(c.rgba.g-f),c.rgba.b-s*(c.rgba.b-R),1))}flatten(...c){const d=c.reduceRight((f,R)=>w.o(R,f));return w.o(this,d)}static o(c,d){const f=1-c.rgba.a;return new w(new T(f*d.rgba.r+c.rgba.a*c.rgba.r,f*d.rgba.g+c.rgba.a*c.rgba.g,f*d.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(c,d,f){if(c.isLighterThan(d))return c;f=f||.5;const R=c.getRelativeLuminance(),s=d.getRelativeLuminance();return f=f*(s-R)/s,c.lighten(f)}static getDarkerColor(c,d,f){if(c.isDarkerThan(d))return c;f=f||.5;const R=c.getRelativeLuminance(),s=d.getRelativeLuminance();return f=f*(R-s)/R,c.darken(f)}static{this.white=new w(new T(255,255,255,1))}static{this.black=new w(new T(0,0,0,1))}static{this.red=new w(new T(255,0,0,1))}static{this.blue=new w(new T(0,0,255,1))}static{this.green=new w(new T(0,255,0,1))}static{this.cyan=new w(new T(0,255,255,1))}static{this.lightgrey=new w(new T(211,211,211,1))}static{this.transparent=new w(new T(0,0,0,0))}}t.$4s=w,function(D){let c;(function(d){let f;(function(R){function s(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:D.Format.CSS.formatRGBA(o)}R.formatRGB=s;function a(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}R.formatRGBA=a;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:D.Format.CSS.formatHSLA(o)}R.formatHSL=e;function h(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}R.formatHSLA=h;function l(o){const N=o.toString(16);return N.length!==2?"0"+N:N}function m(o){return`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}`}R.formatHex=m;function n(o,N=!1){return N&&o.rgba.a===1?D.Format.CSS.formatHex(o):`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}${l(Math.round(o.rgba.a*255))}`}R.formatHexA=n;function r(o){return o.isOpaque()?D.Format.CSS.formatHex(o):D.Format.CSS.formatRGBA(o)}R.format=r;function b(o){const N=o.length;if(N===0||o.charCodeAt(0)!==35)return null;if(N===7){const j=16*u(o.charCodeAt(1))+u(o.charCodeAt(2)),L=16*u(o.charCodeAt(3))+u(o.charCodeAt(4)),g=16*u(o.charCodeAt(5))+u(o.charCodeAt(6));return new D(new T(j,L,g,1))}if(N===9){const j=16*u(o.charCodeAt(1))+u(o.charCodeAt(2)),L=16*u(o.charCodeAt(3))+u(o.charCodeAt(4)),g=16*u(o.charCodeAt(5))+u(o.charCodeAt(6)),y=16*u(o.charCodeAt(7))+u(o.charCodeAt(8));return new D(new T(j,L,g,y/255))}if(N===4){const j=u(o.charCodeAt(1)),L=u(o.charCodeAt(2)),g=u(o.charCodeAt(3));return new D(new T(16*j+j,16*L+L,16*g+g))}if(N===5){const j=u(o.charCodeAt(1)),L=u(o.charCodeAt(2)),g=u(o.charCodeAt(3)),y=u(o.charCodeAt(4));return new D(new T(16*j+j,16*L+L,16*g+g,(16*y+y)/255))}return null}R.parseHex=b;function u(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=d.CSS||(d.CSS={}))})(c=D.Format||(D.Format={}))}(w||(t.$4s=w={}))}),define($e[26],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oh=t.$nh=t.$mh=void 0;function v(w){return(D,c,d)=>{let f=null,R=null;if(typeof d.value=="function"?(f="value",R=d.value):typeof d.get=="function"&&(f="get",R=d.get),!R)throw new Error("not supported");d[f]=w(R,c)}}function T(w,D,c){let d=null,f=null;if(typeof c.value=="function"?(d="value",f=c.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",f=c.get),!f)throw new Error("not supported");const R=`$memoize$${D}`;c[d]=function(...s){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,s)}),this[R]}}t.$mh=T;function i(w,D,c){return v((d,f)=>{const R=`$debounce$${f}`,s=`$debounce$result$${f}`;return function(...a){this[s]||(this[s]=c?c():void 0),clearTimeout(this[R]),D&&(this[s]=D(this[s],...a),a=[this[s]]),this[R]=setTimeout(()=>{d.apply(this,a),this[s]=c?c():void 0},w)}})}t.$nh=i;function H(w,D,c){return v((d,f)=>{const R=`$throttle$timer$${f}`,s=`$throttle$result$${f}`,a=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...h){if(this[s]||(this[s]=c?c():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),D&&(this[s]=D(this[s],...h)),this[e])return;const l=this[a]+w;l<=Date.now()?(this[a]=Date.now(),d.apply(this,[this[s]]),this[s]=c?c():void 0):(this[e]=!0,this[R]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),d.apply(this,[this[s]]),this[s]=c?c():void 0},l-Date.now()))}})}t.$oh=H}),define($e[75],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cs=void 0;class v{constructor(i,H,w,D){this.originalStart=i,this.originalLength=H,this.modifiedStart=w,this.modifiedLength=D}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Cs=v}),define($e[6],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class v{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?r.isErrorNoTelemetry(o)?new r(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(N=>{N(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}t.$V=v,t.$W=new v;function T(u){t.$W.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=T;function i(u){if(!u||typeof u!="object")return!1;const o=u;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}t.$Y=i;function H(u){d(u)||t.$W.onUnexpectedError(u)}t.$Z=H;function w(u){d(u)||t.$W.onUnexpectedExternalError(u)}t.$1=w;function D(u){if(u instanceof Error){const{name:o,message:N}=u,j=u.stacktrace||u.stack;return{$isError:!0,name:o,message:N,stack:j,noTelemetry:r.isErrorNoTelemetry(u)}}return u}t.$2=D;const c="Canceled";function d(u){return u instanceof f?!0:u instanceof Error&&u.name===c&&u.message===c}t.$3=d;class f extends Error{constructor(){super(c),this.name=this.message}}t.$4=f;function R(){const u=new Error(c);return u.name=u.message,u}t.$5=R;function s(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$6=s;function a(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$7=a;class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function h(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$9=h;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.$0=l;class m extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.$$=m;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=n;class r extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof r)return o;const N=new r;return N.message=o.message,N.stack=o.stack,N}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.$ab=r;class b extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$bb=b}),define($e[11],we([1,0,6,72]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function i(p,A=0){return p[p.length-(1+A)]}t.$rb=i;function H(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}t.$sb=H;function w(p,A,E=(M,k)=>M===k){if(p===A)return!0;if(!p||!A||p.length!==A.length)return!1;for(let M=0,k=p.length;M<k;M++)if(!E(p[M],A[M]))return!1;return!0}t.$tb=w;function D(p,A){const E=p.length-1;A<E&&(p[A]=p[E]),p.pop()}t.$ub=D;function c(p,A,E){return d(p.length,M=>E(p[M],A))}t.$vb=c;function d(p,A){let E=0,M=p-1;for(;E<=M;){const k=(E+M)/2|0,I=A(k);if(I<0)E=k+1;else if(I>0)M=k-1;else return k}return-(E+1)}t.$wb=d;function f(p,A,E){if(p=p|0,p>=A.length)throw new TypeError("invalid index");const M=A[Math.floor(A.length*Math.random())],k=[],I=[],S=[];for(const F of A){const z=E(F,M);z<0?k.push(F):z>0?I.push(F):S.push(F)}return p<k.length?f(p,k,E):p<k.length+S.length?S[0]:f(p-(k.length+S.length),I,E)}t.$xb=f;function R(p,A){const E=[];let M;for(const k of p.slice(0).sort(A))!M||A(M[0],k)!==0?(M=[k],E.push(M)):M.push(k);return E}t.$yb=R;function*s(p,A){let E,M;for(const k of p)M!==void 0&&A(M,k)?E.push(k):(E&&(yield E),E=[k]),M=k;E&&(yield E)}t.$zb=s;function a(p,A){for(let E=0;E<=p.length;E++)A(E===0?void 0:p[E-1],E===p.length?void 0:p[E])}t.$Ab=a;function e(p,A){for(let E=0;E<p.length;E++)A(E===0?void 0:p[E-1],p[E],E+1===p.length?void 0:p[E+1])}t.$Bb=e;function h(p,A,E){const M=[];function k(F,z,G){if(z===0&&G.length===0)return;const ee=M[M.length-1];ee&&ee.start+ee.deleteCount===F?(ee.deleteCount+=z,ee.toInsert.push(...G)):M.push({start:F,deleteCount:z,toInsert:G})}let I=0,S=0;for(;;){if(I===p.length){k(I,0,A.slice(S));break}if(S===A.length){k(I,p.length-I,[]);break}const F=p[I],z=A[S],G=E(F,z);G===0?(I+=1,S+=1):G<0?(k(I,1,[]),I+=1):G>0&&(k(I,0,[z]),S+=1)}return M}t.$Cb=h;function l(p,A,E){const M=h(p,A,E),k=[],I=[];for(const S of M)k.push(...p.slice(S.start,S.start+S.deleteCount)),I.push(...S.toInsert);return{removed:k,added:I}}t.$Db=l;function m(p,A,E){if(E===0)return[];const M=p.slice(0,E).sort(A);return r(p,A,M,E,p.length),M}t.top=m;function n(p,A,E,M,k){return E===0?Promise.resolve([]):new Promise((I,S)=>{(async()=>{const F=p.length,z=p.slice(0,E).sort(A);for(let G=E,ee=Math.min(E+M,F);G<F;G=ee,ee=Math.min(ee+M,F)){if(G>E&&await new Promise(ne=>setTimeout(ne)),k&&k.isCancellationRequested)throw new v.$4;r(p,A,z,G,ee)}return z})().then(I,S)})}t.$Fb=n;function r(p,A,E,M,k){for(const I=E.length;M<k;M++){const S=p[M];if(A(S,E[I-1])<0){E.pop();const F=(0,T.$jb)(E,z=>A(S,z)<0);E.splice(F,0,S)}}}function b(p){return p.filter(A=>!!A)}t.$Gb=b;function u(p){let A=0;for(let E=0;E<p.length;E++)p[E]&&(p[A]=p[E],A+=1);p.length=A}t.$Hb=u;function o(p,A,E){p.splice(E,0,p.splice(A,1)[0])}t.$Ib=o;function N(p){return!Array.isArray(p)||p.length===0}t.$Jb=N;function j(p){return Array.isArray(p)&&p.length>0}t.$Kb=j;function L(p,A=E=>E){const E=new Set;return p.filter(M=>{const k=A(M);return E.has(k)?!1:(E.add(k),!0)})}t.$Lb=L;function g(p){const A=new Set;return E=>{const M=p(E);return A.has(M)?!1:(A.add(M),!0)}}t.$Mb=g;function y(p,A){return p.length>0?p[0]:A}t.$Nb=y;function B(p,A){return p.length>0?p[p.length-1]:A}t.$Ob=B;function q(p,A,E=(M,k)=>M===k){let M=0;for(let k=0,I=Math.min(p.length,A.length);k<I&&E(p[k],A[k]);k++)M++;return M}t.$Pb=q;function x(p){return[].concat(...p)}t.$Qb=x;function P(p,A){let E=typeof A=="number"?p:0;typeof A=="number"?E=p:(E=0,A=p);const M=[];if(E<=A)for(let k=E;k<A;k++)M.push(k);else for(let k=E;k>A;k--)M.push(k);return M}t.$Rb=P;function O(p,A,E){return p.reduce((M,k)=>(M[A(k)]=E?E(k):k,M),Object.create(null))}t.$Sb=O;function K(p,A){return p.push(A),()=>te(p,A)}t.$Tb=K;function te(p,A){const E=p.indexOf(A);if(E>-1)return p.splice(E,1),A}t.$Ub=te;function se(p,A,E){const M=p.slice(0,A),k=p.slice(A);return M.concat(E,k)}t.$Vb=se;function fe(p,A){let E;if(typeof A=="number"){let M=A;E=()=>{const k=Math.sin(M++)*179426549;return k-Math.floor(k)}}else E=Math.random;for(let M=p.length-1;M>0;M-=1){const k=Math.floor(E()*(M+1)),I=p[M];p[M]=p[k],p[k]=I}}t.$Wb=fe;function le(p,A){const E=p.indexOf(A);E>-1&&(p.splice(E,1),p.unshift(A))}t.$Xb=le;function oe(p,A){const E=p.indexOf(A);E>-1&&(p.splice(E,1),p.push(A))}t.$Yb=oe;function be(p,A){for(const E of A)p.push(E)}t.$Zb=be;function Se(p,A){return Array.isArray(p)?p.map(A):A(p)}t.$1b=Se;function Ae(p){return Array.isArray(p)?p:[p]}t.$2b=Ae;function Pe(p){return p[Math.floor(Math.random()*p.length)]}t.$3b=Pe;function de(p,A,E){const M=ce(p,A),k=p.length,I=E.length;p.length=k+I;for(let S=k-1;S>=M;S--)p[S+I]=p[S];for(let S=0;S<I;S++)p[S+M]=E[S]}t.$4b=de;function ie(p,A,E,M){const k=ce(p,A);let I=p.splice(k,E);return I===void 0&&(I=[]),de(p,k,M),I}t.$5b=ie;function ce(p,A){return A<0?Math.max(A+p.length,0):Math.min(A,p.length)}var Z;(function(p){function A(I){return I<0}p.isLessThan=A;function E(I){return I<=0}p.isLessThanOrEqual=E;function M(I){return I>0}p.isGreaterThan=M;function k(I){return I===0}p.isNeitherLessOrGreaterThan=k,p.greaterThan=1,p.lessThan=-1,p.neitherLessOrGreaterThan=0})(Z||(t.CompareResult=Z={}));function W(p,A){return(E,M)=>A(p(E),p(M))}t.$6b=W;function Y(...p){return(A,E)=>{for(const M of p){const k=M(A,E);if(!Z.isNeitherLessOrGreaterThan(k))return k}return Z.neitherLessOrGreaterThan}}t.$7b=Y;const C=(p,A)=>p-A;t.$8b=C;const V=(p,A)=>(0,t.$8b)(p?1:0,A?1:0);t.$9b=V;function $(p){return(A,E)=>-p(A,E)}t.$0b=$;class U{constructor(A){this.g=A,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(A){let E=this.c;for(;E<this.g.length&&A(this.g[E]);)E++;const M=E===this.c?null:this.g.slice(this.c,E);return this.c=E,M}takeFromEndWhile(A){let E=this.d;for(;E>=0&&A(this.g[E]);)E--;const M=E===this.d?null:this.g.slice(E+1,this.d+1);return this.d=E,M}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const A=this.g[this.c];return this.c++,A}removeLast(){const A=this.g[this.d];return this.d--,A}takeCount(A){const E=this.g.slice(this.c,this.c+A);return this.c+=A,E}}t.$$b=U;class Q{static{this.empty=new Q(A=>{})}constructor(A){this.iterate=A}forEach(A){this.iterate(E=>(A(E),!0))}toArray(){const A=[];return this.iterate(E=>(A.push(E),!0)),A}filter(A){return new Q(E=>this.iterate(M=>A(M)?E(M):!0))}map(A){return new Q(E=>this.iterate(M=>E(A(M))))}some(A){let E=!1;return this.iterate(M=>(E=A(M),!E)),E}findFirst(A){let E;return this.iterate(M=>A(M)?(E=M,!1):!0),E}findLast(A){let E;return this.iterate(M=>(A(M)&&(E=M),!0)),E}findLastMaxBy(A){let E,M=!0;return this.iterate(k=>((M||Z.isGreaterThan(A(k,E)))&&(M=!1,E=k),!0)),E}}t.$_b=Q}),define($e[76],we([1,0,6]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$5c=t.$4c=t.$3c=t.ok=void 0;function T(c,d){if(!c)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}t.ok=T;function i(c,d="Unreachable"){throw new Error(d)}t.$3c=i;function H(c){if(!c)throw new v.$bb("Assertion Failed")}t.$4c=H;function w(c){if(!c()){debugger;c(),(0,v.$Z)(new v.$bb("Assertion Failed"))}}t.$5c=w;function D(c,d){let f=0;for(;f<c.length-1;){const R=c[f],s=c[f+1];if(!d(R,s))return!1;f++}return!0}t.$6c=D}),define($e[43],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function v(T){const i=this;let H=!1,w;return function(){return H||(H=!0,w=T.apply(i,arguments)),w}}t.$cb=v}),define($e[77],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HM=t.$GM=void 0;class v{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$GM=v,t.$HM=new v("id#")}),define($e[27],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(T){function i(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}T.is=i;const H=Object.freeze([]);function w(){return H}T.empty=w;function*D(u){yield u}T.single=D;function c(u){return i(u)?u:D(u)}T.wrap=c;function d(u){return u||H}T.from=d;function*f(u){for(let o=u.length-1;o>=0;o--)yield u[o]}T.reverse=f;function R(u){return!u||u[Symbol.iterator]().next().done===!0}T.isEmpty=R;function s(u){return u[Symbol.iterator]().next().value}T.first=s;function a(u,o){for(const N of u)if(o(N))return!0;return!1}T.some=a;function e(u,o){for(const N of u)if(o(N))return N}T.find=e;function*h(u,o){for(const N of u)o(N)&&(yield N)}T.filter=h;function*l(u,o){let N=0;for(const j of u)yield o(j,N++)}T.map=l;function*m(...u){for(const o of u)for(const N of o)yield N}T.concat=m;function n(u,o,N){let j=N;for(const L of u)j=o(j,L);return j}T.reduce=n;function*r(u,o,N=u.length){for(o<0&&(o+=u.length),N<0?N+=u.length:N>u.length&&(N=u.length);o<N;o++)yield u[o]}T.slice=r;function b(u,o=Number.POSITIVE_INFINITY){const N=[];if(o===0)return[N,u];const j=u[Symbol.iterator]();for(let L=0;L<o;L++){const g=j.next();if(g.done)return[N,T.empty()];N.push(g.value)}return[N,{[Symbol.iterator](){return j}}]}T.consume=b})(v||(t.Iterable=v={}))}),define($e[44],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kq=t.KeyMod=t.KeyCodeUtils=t.$Jq=t.$Iq=t.$Hq=t.$Gq=t.$Fq=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(v||(t.KeyCode=v={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T||(t.ScanCode=T={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,l){this._keyCodeToStr[h]=l,this._strToKeyCode[l.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const H=new i,w=new i,D=new i;t.$Fq=new Array(230),t.$Gq={};const c=[],d=Object.create(null),f=Object.create(null);t.$Hq={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>d[e]||0,toString:e=>c[e]||"None"},t.$Iq=[],t.$Jq=[];for(let e=0;e<=193;e++)t.$Iq[e]=-1;for(let e=0;e<=132;e++)t.$Jq[e]=-1;(function(){const e="",h=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],l=[],m=[];for(const n of h){const[r,b,u,o,N,j,L,g,y]=n;if(m[b]||(m[b]=!0,c[b]=u,d[u]=b,f[u.toLowerCase()]=b,r&&(t.$Iq[b]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.$Jq[o]=b))),!l[o]){if(l[o]=!0,!N)throw new Error(`String representation missing for key code ${o} around scan code ${u}`);H.define(o,N),w.define(o,g||N),D.define(o,y||g||N)}j&&(t.$Fq[j]=o),L&&(t.$Gq[L]=o)}t.$Jq[3]=46})();var R;(function(e){function h(u){return H.keyCodeToStr(u)}e.toString=h;function l(u){return H.strToKeyCode(u)}e.fromString=l;function m(u){return w.keyCodeToStr(u)}e.toUserSettingsUS=m;function n(u){return D.keyCodeToStr(u)}e.toUserSettingsGeneral=n;function r(u){return w.strToKeyCode(u)||D.strToKeyCode(u)}e.fromUserSettings=r;function b(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(u)}e.toElectronAccelerator=b})(R||(t.KeyCodeUtils=R={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function a(e,h){const l=(h&65535)<<16>>>0;return(e|l)>>>0}t.$Kq=a}),define($e[78],we([1,0,6]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rq=t.$Qq=t.$Pq=t.$Oq=t.$Nq=t.$Mq=t.$Lq=void 0;var T;(function(R){R[R.CtrlCmd=2048]="CtrlCmd",R[R.Shift=1024]="Shift",R[R.Alt=512]="Alt",R[R.WinCtrl=256]="WinCtrl",R[R.KeyCode=255]="KeyCode"})(T||(T={}));function i(R,s){if(typeof R=="number"){if(R===0)return null;const a=(R&65535)>>>0,e=(R&4294901760)>>>16;return e!==0?new c([H(a,s),H(e,s)]):new c([H(a,s)])}else{const a=[];for(let e=0;e<R.length;e++)a.push(H(R[e],s));return new c(a)}}t.$Lq=i;function H(R,s){const a=!!(R&2048),e=!!(R&256),h=s===2?e:a,l=!!(R&1024),m=!!(R&512),n=s===2?a:e,r=R&255;return new w(h,l,m,n,r)}t.$Mq=H;class w{constructor(s,a,e,h,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.keyCode=l}equals(s){return s instanceof w&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${s}${a}${e}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new c([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Nq=w;class D{constructor(s,a,e,h,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.scanCode=l}equals(s){return s instanceof D&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${s}${a}${e}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Oq=D;class c{constructor(s){if(s.length===0)throw(0,v.$6)("chords");this.chords=s}getHashCode(){let s="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(s+=";"),s+=this.chords[a].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(s.chords[a]))return!1;return!0}}t.$Pq=c;class d{constructor(s,a,e,h,l,m){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.keyLabel=l,this.keyAriaLabel=m}}t.$Qq=d;class f{}t.$Rq=f}),define($e[28],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class v{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=v}),define($e[45],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=void 0;class v{static{this.Undefined=new v(void 0)}constructor(H){this.element=H,this.next=v.Undefined,this.prev=v.Undefined}}class T{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let H=this.a;for(;H!==v.Undefined;){const w=H.next;H.prev=v.Undefined,H.next=v.Undefined,H=w}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,w){const D=new v(H);if(this.a===v.Undefined)this.a=D,this.b=D;else if(w){const d=this.b;this.b=D,D.prev=d,d.next=D}else{const d=this.a;this.a=D,D.next=d,d.prev=D}this.c+=1;let c=!1;return()=>{c||(c=!0,this.e(D))}}shift(){if(this.a!==v.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==v.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==v.Undefined&&H.next!==v.Undefined){const w=H.prev;w.next=H.next,H.next.prev=w}else H.prev===v.Undefined&&H.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):H.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):H.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==v.Undefined;)yield H.element,H=H.next}}t.$1c=T}),define($e[32],we([1,0]),function(ae,t){"use strict";var v,T,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function H(n,r,b){let u=n.get(r);return u===void 0&&(u=b,n.set(r,u)),u}t.$wc=H;function w(n){const r=[];return n.forEach((b,u)=>{r.push(`${u} => ${b}`)}),`Map(${n.size}) {${r.join(", ")}}`}t.$xc=w;function D(n){const r=[];return n.forEach(b=>{r.push(b)}),`Set(${n.size}) {${r.join(", ")}}`}t.$yc=D;class c{constructor(r,b){this.uri=r,this.value=b}}function d(n){return Array.isArray(n)}class f{static{this.a=r=>r.toString()}constructor(r,b){if(this[v]="ResourceMap",r instanceof f)this.b=new Map(r.b),this.c=b??f.a;else if(d(r)){this.b=new Map,this.c=b??f.a;for(const[u,o]of r)this.set(u,o)}else this.b=new Map,this.c=r??f.a}set(r,b){return this.b.set(this.c(r),new c(r,b)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,b){typeof b<"u"&&(r=r.bind(b));for(const[u,o]of this.b)r(o.value,o.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$zc=f;class R{constructor(r,b){this[T]="ResourceSet",!r||typeof r=="function"?this.a=new f(r):(this.a=new f(b),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,b){this.a.forEach((u,o)=>r.call(b,o,o,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=R;var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class a{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,b=0){const u=this.a.get(r);if(u)return b!==0&&this.j(u,b),u.value}set(r,b,u=0){let o=this.a.get(r);if(o)o.value=b,u!==0&&this.j(o,u);else{switch(o={key:r,value:b,next:void 0,previous:void 0},u){case 0:this.h(o);break;case 1:this.g(o);break;case 2:this.h(o);break;default:this.h(o);break}this.a.set(r,o),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const b=this.a.get(r);if(b)return this.a.delete(r),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,b){const u=this.e;let o=this.b;for(;o;){if(b?r.bind(b)(o.value,o.key,this):r(o.value,o.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const N={value:u.key,done:!1};return u=u.next,N}else return{value:void 0,done:!0}}};return o}values(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const N={value:u.value,done:!1};return u=u.next,N}else return{value:void 0,done:!0}}};return o}entries(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const N={value:[u.key,u.value],done:!1};return u=u.next,N}else return{value:void 0,done:!0}}};return o}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let b=this.b,u=this.size;for(;b&&u>r;)this.a.delete(b.key),b=b.next,u--;this.b=b,this.d=u,b&&(b.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const b=r.next,u=r.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}r.next=void 0,r.previous=void 0,this.e++}j(r,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(r===this.b)return;const u=r.next,o=r.previous;r===this.c?(o.next=void 0,this.c=o):(u.previous=o,o.next=u),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(b===2){if(r===this.c)return;const u=r.next,o=r.previous;r===this.b?(u.previous=void 0,this.b=u):(u.previous=o,o.next=u),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((b,u)=>{r.push([u,b])}),r}fromJSON(r){this.clear();for(const[b,u]of r)this.set(b,u)}}t.$Bc=a;class e extends a{constructor(r,b=1){super(),this.k=r,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,b=2){return super.get(r,b)}peek(r){return super.get(r,0)}set(r,b){return super.set(r,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class h{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let b=this.a.get(r)||0;return b===0?!1:(b--,b===0?this.a.delete(r):this.a.set(r,b),!0)}has(r){return this.a.has(r)}}t.$Dc=h;class l{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[b,u]of r)this.set(b,u)}clear(){this.a.clear(),this.b.clear()}set(r,b){this.a.set(r,b),this.b.set(b,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const b=this.a.get(r);return b===void 0?!1:(this.a.delete(r),this.b.delete(b),!0)}forEach(r,b){this.a.forEach((u,o)=>{r.call(b,u,o,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=l;class m{constructor(){this.a=new Map}add(r,b){let u=this.a.get(r);u||(u=new Set,this.a.set(r,u)),u.add(b)}delete(r,b){const u=this.a.get(r);u&&(u.delete(b),u.size===0&&this.a.delete(r))}forEach(r,b){const u=this.a.get(r);u&&u.forEach(b)}get(r){const b=this.a.get(r);return b||new Set}}t.$Fc=m}),define($e[2],we([1,0,11,73,32,43,27]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const D=!1;let c=null;class d{constructor(){this.b=new Map}static{this.a=0}c(O){let K=this.b.get(O);return K||(K={parent:null,source:null,isSingleton:!1,value:O,idx:d.a++},this.b.set(O,K)),K}trackDisposable(O){const K=this.c(O);K.source||(K.source=new Error().stack)}setParent(O,K){const te=this.c(O);te.parent=K}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,K){const te=K.get(O);if(te)return te;const se=O.parent?this.f(this.c(O.parent),K):O;return K.set(O,se),se}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,te])=>te.source!==null&&!this.f(te,O).isSingleton).flatMap(([te])=>te)}computeLeakingDisposables(O=10,K){let te;if(K)te=K;else{const be=new Map,Se=[...this.b.values()].filter(Pe=>Pe.source!==null&&!this.f(Pe,be).isSingleton);if(Se.length===0)return;const Ae=new Set(Se.map(Pe=>Pe.value));if(te=Se.filter(Pe=>!(Pe.parent&&Ae.has(Pe.parent))),te.length===0)throw new Error("There are cyclic diposable chains!")}if(!te)return;function se(be){function Se(Pe,de){for(;Pe.length>0&&de.some(ie=>typeof ie=="string"?ie===Pe[0]:Pe[0].match(ie));)Pe.shift()}const Ae=be.source.split(`
`).map(Pe=>Pe.trim().replace("at ","")).filter(Pe=>Pe!=="");return Se(Ae,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Ae.reverse()}const fe=new i.$Fc;for(const be of te){const Se=se(be);for(let Ae=0;Ae<=Se.length;Ae++)fe.add(Se.slice(0,Ae).join(`
`),be)}te.sort((0,v.$6b)(be=>be.idx,v.$8b));let le="",oe=0;for(const be of te.slice(0,O)){oe++;const Se=se(be),Ae=[];for(let Pe=0;Pe<Se.length;Pe++){let de=Se[Pe];de=`(shared with ${fe.get(Se.slice(0,Pe+1).join(`
`)).size}/${te.length} leaks) at ${de}`;const ce=fe.get(Se.slice(0,Pe).join(`
`)),Z=(0,T.$J)([...ce].map(W=>se(W)[Pe]),W=>W);delete Z[Se[Pe]];for(const[W,Y]of Object.entries(Z))Ae.unshift(`    - stacktraces of ${Y.length} other leaks continue with ${W}`);Ae.unshift(de)}le+=`


==================== Leaking disposable ${oe}/${te.length}: ${be.value.constructor.name} ====================
${Ae.join(`
`)}
============================================================

`}return te.length>O&&(le+=`


... and ${te.length-O} more leaking disposables

`),{leaks:te,details:le}}}t.$Gc=d;function f(P){c=P}if(t.$Hc=f,D){const P="__is_disposable_tracked__";f(new class{trackDisposable(O){const K=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[P]||console.log(K)},3e3)}setParent(O,K){if(O&&O!==o.None)try{O[P]=!0}catch{}}markAsDisposed(O){if(O&&O!==o.None)try{O[P]=!0}catch{}}markAsSingleton(O){}})}function R(P){return c?.trackDisposable(P),P}t.$Ic=R;function s(P){c?.markAsDisposed(P)}t.$Jc=s;function a(P,O){c?.setParent(P,O)}function e(P,O){if(c)for(const K of P)c.setParent(K,O)}function h(P){return c?.markAsSingleton(P),P}t.$Kc=h;function l(P){return typeof P.dispose=="function"&&P.dispose.length===0}t.$Lc=l;function m(P){if(w.Iterable.is(P)){const O=[];for(const K of P)if(K)try{K.dispose()}catch(te){O.push(te)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}t.$Mc=m;function n(P){for(const O of P)l(O)&&O.dispose();return[]}t.$Nc=n;function r(...P){const O=b(()=>m(P));return e(P,O),O}t.$Oc=r;function b(P){const O=R({dispose:(0,H.$cb)(()=>{s(O),P()})});return O}t.$Pc=b;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,R(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return a(O,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),a(O,null))}}t.$Qc=u;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,R(this),a(this.q,this)}dispose(){s(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}t.$Rc=o;class N{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&a(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&a(O,null),O}}t.$Sc=N;class j{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Tc=j;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(O){let K=O;return this.unset=()=>K=void 0,this.isset=()=>K!==void 0,this.dispose=()=>{K&&(K(),K=void 0,s(this))},this}}t.$Uc=L;class g{constructor(){this.a=new Map}acquire(O,...K){let te=this.a.get(O);te||(te={counter:0,object:this.b(O,...K)},this.a.set(O,te));const{object:se}=te,fe=(0,H.$cb)(()=>{--te.counter===0&&(this.c(O,te.object),this.a.delete(O))});return te.counter++,{object:se,dispose:fe}}}t.$Vc=g;class y{constructor(O){this.a=O}async acquire(O,...K){const te=this.a.acquire(O,...K);try{return{object:await te.object,dispose:()=>te.dispose()}}catch(se){throw te.dispose(),se}}}t.$Wc=y;class B{constructor(O){this.object=O}dispose(){}}t.$Xc=B;function q(P){const O=new u;try{P(O)}finally{O.dispose()}}t.$Yc=q;class x{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,K,te=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),te||this.a.get(O)?.dispose(),this.a.set(O,K)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Zc=x}),function(ae,t){typeof define=="function"&&define.amd?define($e[79],we([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ae=typeof globalThis<"u"?globalThis:ae||self,t(ae.marked={}))}(this,function(ae){"use strict";function t(A,E){for(var M=0;M<E.length;M++){var k=E[M];k.enumerable=k.enumerable||!1,k.configurable=!0,"value"in k&&(k.writable=!0),Object.defineProperty(A,k.key,k)}}function v(A,E,M){return E&&t(A.prototype,E),M&&t(A,M),Object.defineProperty(A,"prototype",{writable:!1}),A}function T(A,E){if(A){if(typeof A=="string")return i(A,E);var M=Object.prototype.toString.call(A).slice(8,-1);if(M==="Object"&&A.constructor&&(M=A.constructor.name),M==="Map"||M==="Set")return Array.from(A);if(M==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(M))return i(A,E)}}function i(A,E){(E==null||E>A.length)&&(E=A.length);for(var M=0,k=new Array(E);M<E;M++)k[M]=A[M];return k}function H(A,E){var M=typeof Symbol<"u"&&A[Symbol.iterator]||A["@@iterator"];if(M)return(M=M.call(A)).next.bind(M);if(Array.isArray(A)||(M=T(A))||E&&A&&typeof A.length=="number"){M&&(A=M);var k=0;return function(){return k>=A.length?{done:!0}:{done:!1,value:A[k++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=w();function D(A){ae.defaults=A}var c=/[&<>"']/,d=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,R=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(E){return s[E]};function e(A,E){if(E){if(c.test(A))return A.replace(d,a)}else if(f.test(A))return A.replace(R,a);return A}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(A){return A.replace(h,function(E,M){return M=M.toLowerCase(),M==="colon"?":":M.charAt(0)==="#"?M.charAt(1)==="x"?String.fromCharCode(parseInt(M.substring(2),16)):String.fromCharCode(+M.substring(1)):""})}var m=/(^|[^\[])\^/g;function n(A,E){A=typeof A=="string"?A:A.source,E=E||"";var M={replace:function(I,S){return S=S.source||S,S=S.replace(m,"$1"),A=A.replace(I,S),M},getRegex:function(){return new RegExp(A,E)}};return M}var r=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(A,E,M){if(A){var k;try{k=decodeURIComponent(l(M)).replace(r,"").toLowerCase()}catch{return null}if(k.indexOf("javascript:")===0||k.indexOf("vbscript:")===0||k.indexOf("data:")===0)return null}E&&!b.test(M)&&(M=g(E,M));try{M=encodeURI(M).replace(/%25/g,"%")}catch{return null}return M}var o={},N=/^[^:]+:\/*[^/]*$/,j=/^([^:]+:)[\s\S]*$/,L=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(A,E){o[" "+A]||(N.test(A)?o[" "+A]=A+"/":o[" "+A]=x(A,"/",!0)),A=o[" "+A];var M=A.indexOf(":")===-1;return E.substring(0,2)==="//"?M?E:A.replace(j,"$1")+E:E.charAt(0)==="/"?M?E:A.replace(L,"$1")+E:A+E}var y={exec:function(){}};function B(A){for(var E=1,M,k;E<arguments.length;E++){M=arguments[E];for(k in M)Object.prototype.hasOwnProperty.call(M,k)&&(A[k]=M[k])}return A}function q(A,E){var M=A.replace(/\|/g,function(S,F,z){for(var G=!1,ee=F;--ee>=0&&z[ee]==="\\";)G=!G;return G?"|":" |"}),k=M.split(/ \|/),I=0;if(k[0].trim()||k.shift(),k.length>0&&!k[k.length-1].trim()&&k.pop(),k.length>E)k.splice(E);else for(;k.length<E;)k.push("");for(;I<k.length;I++)k[I]=k[I].trim().replace(/\\\|/g,"|");return k}function x(A,E,M){var k=A.length;if(k===0)return"";for(var I=0;I<k;){var S=A.charAt(k-I-1);if(S===E&&!M)I++;else if(S!==E&&M)I++;else break}return A.slice(0,k-I)}function P(A,E){if(A.indexOf(E[1])===-1)return-1;for(var M=A.length,k=0,I=0;I<M;I++)if(A[I]==="\\")I++;else if(A[I]===E[0])k++;else if(A[I]===E[1]&&(k--,k<0))return I;return-1}function O(A){A&&A.sanitize&&!A.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function K(A,E){if(E<1)return"";for(var M="";E>1;)E&1&&(M+=A),E>>=1,A+=A;return M+A}function te(A,E,M,k){var I=E.href,S=E.title?e(E.title):null,F=A[1].replace(/\\([\[\]])/g,"$1");if(A[0].charAt(0)!=="!"){k.state.inLink=!0;var z={type:"link",raw:M,href:I,title:S,text:F,tokens:k.inlineTokens(F)};return k.state.inLink=!1,z}return{type:"image",raw:M,href:I,title:S,text:e(F)}}function se(A,E){var M=A.match(/^(\s+)(?:```)/);if(M===null)return E;var k=M[1];return E.split(`
`).map(function(I){var S=I.match(/^\s+/);if(S===null)return I;var F=S[0];return F.length>=k.length?I.slice(k.length):I}).join(`
`)}var fe=function(){function A(M){this.options=M||ae.defaults}var E=A.prototype;return E.space=function(k){var I=this.rules.block.newline.exec(k);if(I&&I[0].length>0)return{type:"space",raw:I[0]}},E.code=function(k){var I=this.rules.block.code.exec(k);if(I){var S=I[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:I[0],codeBlockStyle:"indented",text:this.options.pedantic?S:x(S,`
`)}}},E.fences=function(k){var I=this.rules.block.fences.exec(k);if(I){var S=I[0],F=se(S,I[3]||"");return{type:"code",raw:S,lang:I[2]?I[2].trim():I[2],text:F}}},E.heading=function(k){var I=this.rules.block.heading.exec(k);if(I){var S=I[2].trim();if(/#$/.test(S)){var F=x(S,"#");(this.options.pedantic||!F||/ $/.test(F))&&(S=F.trim())}return{type:"heading",raw:I[0],depth:I[1].length,text:S,tokens:this.lexer.inline(S)}}},E.hr=function(k){var I=this.rules.block.hr.exec(k);if(I)return{type:"hr",raw:I[0]}},E.blockquote=function(k){var I=this.rules.block.blockquote.exec(k);if(I){var S=I[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:I[0],tokens:this.lexer.blockTokens(S,[]),text:S}}},E.list=function(k){var I=this.rules.block.list.exec(k);if(I){var S,F,z,G,ee,ne,me,ve,Ne,Ce,De,Le,Te=I[1].trim(),We=Te.length>1,He={type:"list",raw:"",ordered:We,start:We?+Te.slice(0,-1):"",loose:!1,items:[]};Te=We?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=We?Te:"[*+-]");for(var Me=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");k&&(Le=!1,!(!(I=Me.exec(k))||this.rules.block.hr.test(k)));){if(S=I[0],k=k.substring(S.length),ve=I[2].split(`
`,1)[0],Ne=k.split(`
`,1)[0],this.options.pedantic?(G=2,De=ve.trimLeft()):(G=I[2].search(/[^ ]/),G=G>4?1:G,De=ve.slice(G),G+=I[1].length),ne=!1,!ve&&/^ *$/.test(Ne)&&(S+=Ne+`
`,k=k.substring(Ne.length+1),Le=!0),!Le)for(var Ye=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),J=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),he=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),pe=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");k&&(Ce=k.split(`
`,1)[0],ve=Ce,this.options.pedantic&&(ve=ve.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(he.test(ve)||pe.test(ve)||Ye.test(ve)||J.test(k)));){if(ve.search(/[^ ]/)>=G||!ve.trim())De+=`
`+ve.slice(G);else if(!ne)De+=`
`+ve;else break;!ne&&!ve.trim()&&(ne=!0),S+=Ce+`
`,k=k.substring(Ce.length+1)}He.loose||(me?He.loose=!0:/\n *\n *$/.test(S)&&(me=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(De),F&&(z=F[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:S,task:!!F,checked:z,loose:!1,text:De}),He.raw+=S}He.items[He.items.length-1].raw=S.trimRight(),He.items[He.items.length-1].text=De.trimRight(),He.raw=He.raw.trimRight();var Ee=He.items.length;for(ee=0;ee<Ee;ee++){this.lexer.state.top=!1,He.items[ee].tokens=this.lexer.blockTokens(He.items[ee].text,[]);var Fe=He.items[ee].tokens.filter(function(Ue){return Ue.type==="space"}),Be=Fe.every(function(Ue){for(var Ze=Ue.raw.split(""),Je=0,Ke=H(Ze),qe;!(qe=Ke()).done;){var tt=qe.value;if(tt===`
`&&(Je+=1),Je>1)return!0}return!1});!He.loose&&Fe.length&&Be&&(He.loose=!0,He.items[ee].loose=!0)}return He}},E.html=function(k){var I=this.rules.block.html.exec(k);if(I){var S={type:"html",raw:I[0],pre:!this.options.sanitizer&&(I[1]==="pre"||I[1]==="script"||I[1]==="style"),text:I[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]);S.type="paragraph",S.text=F,S.tokens=this.lexer.inline(F)}return S}},E.def=function(k){var I=this.rules.block.def.exec(k);if(I){I[3]&&(I[3]=I[3].substring(1,I[3].length-1));var S=I[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:S,raw:I[0],href:I[2],title:I[3]}}},E.table=function(k){var I=this.rules.block.table.exec(k);if(I){var S={type:"table",header:q(I[1]).map(function(me){return{text:me}}),align:I[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:I[3]&&I[3].trim()?I[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(S.header.length===S.align.length){S.raw=I[0];var F=S.align.length,z,G,ee,ne;for(z=0;z<F;z++)/^ *-+: *$/.test(S.align[z])?S.align[z]="right":/^ *:-+: *$/.test(S.align[z])?S.align[z]="center":/^ *:-+ *$/.test(S.align[z])?S.align[z]="left":S.align[z]=null;for(F=S.rows.length,z=0;z<F;z++)S.rows[z]=q(S.rows[z],S.header.length).map(function(me){return{text:me}});for(F=S.header.length,G=0;G<F;G++)S.header[G].tokens=this.lexer.inline(S.header[G].text);for(F=S.rows.length,G=0;G<F;G++)for(ne=S.rows[G],ee=0;ee<ne.length;ee++)ne[ee].tokens=this.lexer.inline(ne[ee].text);return S}}},E.lheading=function(k){var I=this.rules.block.lheading.exec(k);if(I)return{type:"heading",raw:I[0],depth:I[2].charAt(0)==="="?1:2,text:I[1],tokens:this.lexer.inline(I[1])}},E.paragraph=function(k){var I=this.rules.block.paragraph.exec(k);if(I){var S=I[1].charAt(I[1].length-1)===`
`?I[1].slice(0,-1):I[1];return{type:"paragraph",raw:I[0],text:S,tokens:this.lexer.inline(S)}}},E.text=function(k){var I=this.rules.block.text.exec(k);if(I)return{type:"text",raw:I[0],text:I[0],tokens:this.lexer.inline(I[0])}},E.escape=function(k){var I=this.rules.inline.escape.exec(k);if(I)return{type:"escape",raw:I[0],text:e(I[1])}},E.tag=function(k){var I=this.rules.inline.tag.exec(k);if(I)return!this.lexer.state.inLink&&/^<a /i.test(I[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(I[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(I[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(I[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:I[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]):I[0]}},E.link=function(k){var I=this.rules.inline.link.exec(k);if(I){var S=I[2].trim();if(!this.options.pedantic&&/^</.test(S)){if(!/>$/.test(S))return;var F=x(S.slice(0,-1),"\\");if((S.length-F.length)%2===0)return}else{var z=P(I[2],"()");if(z>-1){var G=I[0].indexOf("!")===0?5:4,ee=G+I[1].length+z;I[2]=I[2].substring(0,z),I[0]=I[0].substring(0,ee).trim(),I[3]=""}}var ne=I[2],me="";if(this.options.pedantic){var ve=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ne);ve&&(ne=ve[1],me=ve[3])}else me=I[3]?I[3].slice(1,-1):"";return ne=ne.trim(),/^</.test(ne)&&(this.options.pedantic&&!/>$/.test(S)?ne=ne.slice(1):ne=ne.slice(1,-1)),te(I,{href:ne&&ne.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},I[0],this.lexer)}},E.reflink=function(k,I){var S;if((S=this.rules.inline.reflink.exec(k))||(S=this.rules.inline.nolink.exec(k))){var F=(S[2]||S[1]).replace(/\s+/g," ");if(F=I[F.toLowerCase()],!F||!F.href){var z=S[0].charAt(0);return{type:"text",raw:z,text:z}}return te(S,F,S[0],this.lexer)}},E.emStrong=function(k,I,S){S===void 0&&(S="");var F=this.rules.inline.emStrong.lDelim.exec(k);if(F&&!(F[3]&&S.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=F[1]||F[2]||"";if(!z||z&&(S===""||this.rules.inline.punctuation.exec(S))){var G=F[0].length-1,ee,ne,me=G,ve=0,Ne=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,I=I.slice(-1*k.length+G);(F=Ne.exec(I))!=null;)if(ee=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!ee){if(ne=ee.length,F[3]||F[4]){me+=ne;continue}else if((F[5]||F[6])&&G%3&&!((G+ne)%3)){ve+=ne;continue}if(me-=ne,!(me>0)){if(ne=Math.min(ne,ne+me+ve),Math.min(G,ne)%2){var Ce=k.slice(1,G+F.index+ne);return{type:"em",raw:k.slice(0,G+F.index+ne+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var De=k.slice(2,G+F.index+ne-1);return{type:"strong",raw:k.slice(0,G+F.index+ne+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},E.codespan=function(k){var I=this.rules.inline.code.exec(k);if(I){var S=I[2].replace(/\n/g," "),F=/[^ ]/.test(S),z=/^ /.test(S)&&/ $/.test(S);return F&&z&&(S=S.substring(1,S.length-1)),S=e(S,!0),{type:"codespan",raw:I[0],text:S}}},E.br=function(k){var I=this.rules.inline.br.exec(k);if(I)return{type:"br",raw:I[0]}},E.del=function(k){var I=this.rules.inline.del.exec(k);if(I)return{type:"del",raw:I[0],text:I[2],tokens:this.lexer.inlineTokens(I[2])}},E.autolink=function(k,I){var S=this.rules.inline.autolink.exec(k);if(S){var F,z;return S[2]==="@"?(F=e(this.options.mangle?I(S[1]):S[1]),z="mailto:"+F):(F=e(S[1]),z=F),{type:"link",raw:S[0],text:F,href:z,tokens:[{type:"text",raw:F,text:F}]}}},E.url=function(k,I){var S;if(S=this.rules.inline.url.exec(k)){var F,z;if(S[2]==="@")F=e(this.options.mangle?I(S[0]):S[0]),z="mailto:"+F;else{var G;do G=S[0],S[0]=this.rules.inline._backpedal.exec(S[0])[0];while(G!==S[0]);F=e(S[0]),S[1]==="www."?z="http://"+F:z=F}return{type:"link",raw:S[0],text:F,href:z,tokens:[{type:"text",raw:F,text:F}]}}},E.inlineText=function(k,I){var S=this.rules.inline.text.exec(k);if(S){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(S[0]):e(S[0]):S[0]:F=e(this.options.smartypants?I(S[0]):S[0]),{type:"text",raw:S[0],text:F}}},A}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=n(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=n(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=n(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=n(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=n(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=B({},le),le.gfm=B({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=n(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=n(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=B({},le.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:n(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=n(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=n(le._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=n(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=n(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=n(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=n(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=n(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=n(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=n(oe.reflink).replace("label",oe._label).replace("ref",le._label).getRegex(),oe.nolink=n(oe.nolink).replace("ref",le._label).getRegex(),oe.reflinkSearch=n(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=B({},oe),oe.pedantic=B({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=B({},oe.normal,{escape:n(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=n(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=B({},oe.gfm,{br:n(oe.br).replace("{2,}","*").getRegex(),text:n(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function be(A){return A.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Se(A){var E="",M,k,I=A.length;for(M=0;M<I;M++)k=A.charCodeAt(M),Math.random()>.5&&(k="x"+k.toString(16)),E+="&#"+k+";";return E}var Ae=function(){function A(M){this.tokens=[],this.tokens.links=Object.create(null),this.options=M||ae.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var k={block:le.normal,inline:oe.normal};this.options.pedantic?(k.block=le.pedantic,k.inline=oe.pedantic):this.options.gfm&&(k.block=le.gfm,this.options.breaks?k.inline=oe.breaks:k.inline=oe.gfm),this.tokenizer.rules=k}A.lex=function(k,I){var S=new A(I);return S.lex(k)},A.lexInline=function(k,I){var S=new A(I);return S.inlineTokens(k)};var E=A.prototype;return E.lex=function(k){k=k.replace(/\r\n|\r/g,`
`),this.blockTokens(k,this.tokens);for(var I;I=this.inlineQueue.shift();)this.inlineTokens(I.src,I.tokens);return this.tokens},E.blockTokens=function(k,I){var S=this;I===void 0&&(I=[]),this.options.pedantic?k=k.replace(/\t/g,"    ").replace(/^ +$/gm,""):k=k.replace(/^( *)(\t+)/gm,function(me,ve,Ne){return ve+"    ".repeat(Ne.length)});for(var F,z,G,ee;k;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(F=me.call({lexer:S},k,I))?(k=k.substring(F.raw.length),I.push(F),!0):!1}))){if(F=this.tokenizer.space(k)){k=k.substring(F.raw.length),F.raw.length===1&&I.length>0?I[I.length-1].raw+=`
`:I.push(F);continue}if(F=this.tokenizer.code(k)){k=k.substring(F.raw.length),z=I[I.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+F.raw,z.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):I.push(F);continue}if(F=this.tokenizer.fences(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.heading(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.hr(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.blockquote(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.list(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.html(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.def(k)){k=k.substring(F.raw.length),z=I[I.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+F.raw,z.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.lheading(k)){k=k.substring(F.raw.length),I.push(F);continue}if(G=k,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,ve=k.slice(1),Ne=void 0;S.options.extensions.startBlock.forEach(function(Ce){Ne=Ce.call({lexer:this},ve),typeof Ne=="number"&&Ne>=0&&(me=Math.min(me,Ne))}),me<1/0&&me>=0&&(G=k.substring(0,me+1))}(),this.state.top&&(F=this.tokenizer.paragraph(G))){z=I[I.length-1],ee&&z.type==="paragraph"?(z.raw+=`
`+F.raw,z.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):I.push(F),ee=G.length!==k.length,k=k.substring(F.raw.length);continue}if(F=this.tokenizer.text(k)){k=k.substring(F.raw.length),z=I[I.length-1],z&&z.type==="text"?(z.raw+=`
`+F.raw,z.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):I.push(F);continue}if(k){var ne="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(ne);break}else throw new Error(ne)}}return this.state.top=!0,I},E.inline=function(k,I){return I===void 0&&(I=[]),this.inlineQueue.push({src:k,tokens:I}),I},E.inlineTokens=function(k,I){var S=this;I===void 0&&(I=[]);var F,z,G,ee=k,ne,me,ve;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(ne=this.tokenizer.rules.inline.reflinkSearch.exec(ee))!=null;)Ne.includes(ne[0].slice(ne[0].lastIndexOf("[")+1,-1))&&(ee=ee.slice(0,ne.index)+"["+K("a",ne[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ne=this.tokenizer.rules.inline.blockSkip.exec(ee))!=null;)ee=ee.slice(0,ne.index)+"["+K("a",ne[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ne=this.tokenizer.rules.inline.escapedEmSt.exec(ee))!=null;)ee=ee.slice(0,ne.index)+"++"+ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;k;)if(me||(ve=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(F=De.call({lexer:S},k,I))?(k=k.substring(F.raw.length),I.push(F),!0):!1}))){if(F=this.tokenizer.escape(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.tag(k)){k=k.substring(F.raw.length),z=I[I.length-1],z&&F.type==="text"&&z.type==="text"?(z.raw+=F.raw,z.text+=F.text):I.push(F);continue}if(F=this.tokenizer.link(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.reflink(k,this.tokens.links)){k=k.substring(F.raw.length),z=I[I.length-1],z&&F.type==="text"&&z.type==="text"?(z.raw+=F.raw,z.text+=F.text):I.push(F);continue}if(F=this.tokenizer.emStrong(k,ee,ve)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.codespan(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.br(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.del(k)){k=k.substring(F.raw.length),I.push(F);continue}if(F=this.tokenizer.autolink(k,Se)){k=k.substring(F.raw.length),I.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(k,Se))){k=k.substring(F.raw.length),I.push(F);continue}if(G=k,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Le=k.slice(1),Te=void 0;S.options.extensions.startInline.forEach(function(We){Te=We.call({lexer:this},Le),typeof Te=="number"&&Te>=0&&(De=Math.min(De,Te))}),De<1/0&&De>=0&&(G=k.substring(0,De+1))}(),F=this.tokenizer.inlineText(G,be)){k=k.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(ve=F.raw.slice(-1)),me=!0,z=I[I.length-1],z&&z.type==="text"?(z.raw+=F.raw,z.text+=F.text):I.push(F);continue}if(k){var Ce="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return I},v(A,null,[{key:"rules",get:function(){return{block:le,inline:oe}}}]),A}(),Pe=function(){function A(M){this.options=M||ae.defaults}var E=A.prototype;return E.code=function(k,I,S){var F=(I||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(k,F);z!=null&&z!==k&&(S=!0,k=z)}return k=k.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+e(F,!0)+'">'+(S?k:e(k,!0))+`</code></pre>
`:"<pre><code>"+(S?k:e(k,!0))+`</code></pre>
`},E.blockquote=function(k){return`<blockquote>
`+k+`</blockquote>
`},E.html=function(k){return k},E.heading=function(k,I,S,F){if(this.options.headerIds){var z=this.options.headerPrefix+F.slug(S);return"<h"+I+' id="'+z+'">'+k+"</h"+I+`>
`}return"<h"+I+">"+k+"</h"+I+`>
`},E.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},E.list=function(k,I,S){var F=I?"ol":"ul",z=I&&S!==1?' start="'+S+'"':"";return"<"+F+z+`>
`+k+"</"+F+`>
`},E.listitem=function(k){return"<li>"+k+`</li>
`},E.checkbox=function(k){return"<input "+(k?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},E.paragraph=function(k){return"<p>"+k+`</p>
`},E.table=function(k,I){return I&&(I="<tbody>"+I+"</tbody>"),`<table>
<thead>
`+k+`</thead>
`+I+`</table>
`},E.tablerow=function(k){return`<tr>
`+k+`</tr>
`},E.tablecell=function(k,I){var S=I.header?"th":"td",F=I.align?"<"+S+' align="'+I.align+'">':"<"+S+">";return F+k+("</"+S+`>
`)},E.strong=function(k){return"<strong>"+k+"</strong>"},E.em=function(k){return"<em>"+k+"</em>"},E.codespan=function(k){return"<code>"+k+"</code>"},E.br=function(){return this.options.xhtml?"<br/>":"<br>"},E.del=function(k){return"<del>"+k+"</del>"},E.link=function(k,I,S){if(k=u(this.options.sanitize,this.options.baseUrl,k),k===null)return S;var F='<a href="'+e(k)+'"';return I&&(F+=' title="'+I+'"'),F+=">"+S+"</a>",F},E.image=function(k,I,S){if(k=u(this.options.sanitize,this.options.baseUrl,k),k===null)return S;var F='<img src="'+k+'" alt="'+S+'"';return I&&(F+=' title="'+I+'"'),F+=this.options.xhtml?"/>":">",F},E.text=function(k){return k},A}(),de=function(){function A(){}var E=A.prototype;return E.strong=function(k){return k},E.em=function(k){return k},E.codespan=function(k){return k},E.del=function(k){return k},E.html=function(k){return k},E.text=function(k){return k},E.link=function(k,I,S){return""+S},E.image=function(k,I,S){return""+S},E.br=function(){return""},A}(),ie=function(){function A(){this.seen={}}var E=A.prototype;return E.serialize=function(k){return k.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},E.getNextSafeSlug=function(k,I){var S=k,F=0;if(this.seen.hasOwnProperty(S)){F=this.seen[k];do F++,S=k+"-"+F;while(this.seen.hasOwnProperty(S))}return I||(this.seen[k]=F,this.seen[S]=0),S},E.slug=function(k,I){I===void 0&&(I={});var S=this.serialize(k);return this.getNextSafeSlug(S,I.dryrun)},A}(),ce=function(){function A(M){this.options=M||ae.defaults,this.options.renderer=this.options.renderer||new Pe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ie}A.parse=function(k,I){var S=new A(I);return S.parse(k)},A.parseInline=function(k,I){var S=new A(I);return S.parseInline(k)};var E=A.prototype;return E.parse=function(k,I){I===void 0&&(I=!0);var S="",F,z,G,ee,ne,me,ve,Ne,Ce,De,Le,Te,We,He,Me,Ye,J,he,pe,Ee=k.length;for(F=0;F<Ee;F++){if(De=k[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(pe=this.options.extensions.renderers[De.type].call({parser:this},De),pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){S+=pe||"";continue}switch(De.type){case"space":continue;case"hr":{S+=this.renderer.hr();continue}case"heading":{S+=this.renderer.heading(this.parseInline(De.tokens),De.depth,l(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{S+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Ne="",ve="",ee=De.header.length,z=0;z<ee;z++)ve+=this.renderer.tablecell(this.parseInline(De.header[z].tokens),{header:!0,align:De.align[z]});for(Ne+=this.renderer.tablerow(ve),Ce="",ee=De.rows.length,z=0;z<ee;z++){for(me=De.rows[z],ve="",ne=me.length,G=0;G<ne;G++)ve+=this.renderer.tablecell(this.parseInline(me[G].tokens),{header:!1,align:De.align[G]});Ce+=this.renderer.tablerow(ve)}S+=this.renderer.table(Ne,Ce);continue}case"blockquote":{Ce=this.parse(De.tokens),S+=this.renderer.blockquote(Ce);continue}case"list":{for(Le=De.ordered,Te=De.start,We=De.loose,ee=De.items.length,Ce="",z=0;z<ee;z++)Me=De.items[z],Ye=Me.checked,J=Me.task,He="",Me.task&&(he=this.renderer.checkbox(Ye),We?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=he+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=he+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:he}):He+=he),He+=this.parse(Me.tokens,We),Ce+=this.renderer.listitem(He,J,Ye);S+=this.renderer.list(Ce,Le,Te);continue}case"html":{S+=this.renderer.html(De.text);continue}case"paragraph":{S+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ce=De.tokens?this.parseInline(De.tokens):De.text;F+1<Ee&&k[F+1].type==="text";)De=k[++F],Ce+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);S+=I?this.renderer.paragraph(Ce):Ce;continue}default:{var Fe='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}}return S},E.parseInline=function(k,I){I=I||this.renderer;var S="",F,z,G,ee=k.length;for(F=0;F<ee;F++){if(z=k[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(G=this.options.extensions.renderers[z.type].call({parser:this},z),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){S+=G||"";continue}switch(z.type){case"escape":{S+=I.text(z.text);break}case"html":{S+=I.html(z.text);break}case"link":{S+=I.link(z.href,z.title,this.parseInline(z.tokens,I));break}case"image":{S+=I.image(z.href,z.title,z.text);break}case"strong":{S+=I.strong(this.parseInline(z.tokens,I));break}case"em":{S+=I.em(this.parseInline(z.tokens,I));break}case"codespan":{S+=I.codespan(z.text);break}case"br":{S+=I.br();break}case"del":{S+=I.del(this.parseInline(z.tokens,I));break}case"text":{S+=I.text(z.text);break}default:{var ne='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return S},A}();function Z(A,E,M){if(typeof A>"u"||A===null)throw new Error("marked(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");if(typeof E=="function"&&(M=E,E=null),E=B({},Z.defaults,E||{}),O(E),M){var k=E.highlight,I;try{I=Ae.lex(A,E)}catch(ee){return M(ee)}var S=function(ne){var me;if(!ne)try{E.walkTokens&&Z.walkTokens(I,E.walkTokens),me=ce.parse(I,E)}catch(ve){ne=ve}return E.highlight=k,ne?M(ne):M(null,me)};if(!k||k.length<3||(delete E.highlight,!I.length))return S();var F=0;Z.walkTokens(I,function(ee){ee.type==="code"&&(F++,setTimeout(function(){k(ee.text,ee.lang,function(ne,me){if(ne)return S(ne);me!=null&&me!==ee.text&&(ee.text=me,ee.escaped=!0),F--,F===0&&S()})},0))}),F===0&&S();return}function z(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}try{var G=Ae.lex(A,E);if(E.walkTokens){if(E.async)return Promise.all(Z.walkTokens(G,E.walkTokens)).then(function(){return ce.parse(G,E)}).catch(z);Z.walkTokens(G,E.walkTokens)}return ce.parse(G,E)}catch(ee){z(ee)}}Z.options=Z.setOptions=function(A){return B(Z.defaults,A),D(Z.defaults),Z},Z.getDefaults=w,Z.defaults=ae.defaults,Z.use=function(){for(var A=arguments.length,E=new Array(A),M=0;M<A;M++)E[M]=arguments[M];var k=B.apply(void 0,[{}].concat(E)),I=Z.defaults.extensions||{renderers:{},childTokens:{}},S;E.forEach(function(F){if(F.extensions&&(S=!0,F.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var ee=I.renderers?I.renderers[G.name]:null;ee?I.renderers[G.name]=function(){for(var ne=arguments.length,me=new Array(ne),ve=0;ve<ne;ve++)me[ve]=arguments[ve];var Ne=G.renderer.apply(this,me);return Ne===!1&&(Ne=ee.apply(this,me)),Ne}:I.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");I[G.level]?I[G.level].unshift(G.tokenizer):I[G.level]=[G.tokenizer],G.start&&(G.level==="block"?I.startBlock?I.startBlock.push(G.start):I.startBlock=[G.start]:G.level==="inline"&&(I.startInline?I.startInline.push(G.start):I.startInline=[G.start]))}G.childTokens&&(I.childTokens[G.name]=G.childTokens)})),F.renderer&&function(){var G=Z.defaults.renderer||new Pe,ee=function(ve){var Ne=G[ve];G[ve]=function(){for(var Ce=arguments.length,De=new Array(Ce),Le=0;Le<Ce;Le++)De[Le]=arguments[Le];var Te=F.renderer[ve].apply(G,De);return Te===!1&&(Te=Ne.apply(G,De)),Te}};for(var ne in F.renderer)ee(ne);k.renderer=G}(),F.tokenizer&&function(){var G=Z.defaults.tokenizer||new fe,ee=function(ve){var Ne=G[ve];G[ve]=function(){for(var Ce=arguments.length,De=new Array(Ce),Le=0;Le<Ce;Le++)De[Le]=arguments[Le];var Te=F.tokenizer[ve].apply(G,De);return Te===!1&&(Te=Ne.apply(G,De)),Te}};for(var ne in F.tokenizer)ee(ne);k.tokenizer=G}(),F.walkTokens){var z=Z.defaults.walkTokens;k.walkTokens=function(G){var ee=[];return ee.push(F.walkTokens.call(this,G)),z&&(ee=ee.concat(z.call(this,G))),ee}}S&&(k.extensions=I),Z.setOptions(k)})},Z.walkTokens=function(A,E){for(var M=[],k=function(){var z=S.value;switch(M=M.concat(E.call(Z,z)),z.type){case"table":{for(var G=H(z.header),ee;!(ee=G()).done;){var ne=ee.value;M=M.concat(Z.walkTokens(ne.tokens,E))}for(var me=H(z.rows),ve;!(ve=me()).done;)for(var Ne=ve.value,Ce=H(Ne),De;!(De=Ce()).done;){var Le=De.value;M=M.concat(Z.walkTokens(Le.tokens,E))}break}case"list":{M=M.concat(Z.walkTokens(z.items,E));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[z.type]?Z.defaults.extensions.childTokens[z.type].forEach(function(Te){M=M.concat(Z.walkTokens(z[Te],E))}):z.tokens&&(M=M.concat(Z.walkTokens(z.tokens,E)))}},I=H(A),S;!(S=I()).done;)k();return M},Z.parseInline=function(A,E){if(typeof A>"u"||A===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");E=B({},Z.defaults,E||{}),O(E);try{var M=Ae.lexInline(A,E);return E.walkTokens&&Z.walkTokens(M,E.walkTokens),ce.parseInline(M,E)}catch(k){if(k.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(k.message+"",!0)+"</pre>";throw k}},Z.Parser=ce,Z.parser=ce.parse,Z.Renderer=Pe,Z.TextRenderer=de,Z.Lexer=Ae,Z.lexer=Ae.lex,Z.Tokenizer=fe,Z.Slugger=ie,Z.parse=Z;var W=Z.options,Y=Z.setOptions,C=Z.use,V=Z.walkTokens,$=Z.parseInline,U=Z,Q=ce.parse,p=Ae.lex;ae.Lexer=Ae,ae.Parser=ce,ae.Renderer=Pe,ae.Slugger=ie,ae.TextRenderer=de,ae.Tokenizer=fe,ae.getDefaults=w,ae.lexer=p,ae.marked=Z,ae.options=W,ae.parse=U,ae.parseInline=$,ae.parser=Q,ae.setOptions=Y,ae.use=C,ae.walkTokens=V,Object.defineProperty(ae,"__esModule",{value:!0})}),define($e[80],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jS=void 0;class v{constructor(i,H=0,w=i.length,D=H-1){this.a=i,this.b=H,this.c=w,this.d=D}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$jS=v}),define($e[81],we([1,0,80]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lS=t.$kS=void 0;class T{constructor(w=[],D=10){this.h(w),this.b=D,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new v.$jS(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const D of w)this.a.add(D)}get j(){const w=[];return this.a.forEach(D=>w.push(D)),w}}t.$kS=T;class i{get size(){return this.f}constructor(w,D=10){if(this.g=D,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new Set([w[0]]);for(let c=1;c<w.length;c++)this.add(w[c])}add(w){const D={value:w,previous:this.c,next:void 0};for(this.c.next=D,this.c=D,this.d=this.c,this.f++,this.a.has(w)?this.h(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.c.value===w)return w;const D=this.c.value;return this.a.delete(D),this.c.value=w,this.a.has(w)?this.h(w):this.a.add(w),D}prepend(w){if(this.f===this.g||this.a.has(w))return;const D={value:w,previous:void 0,next:this.b};this.b.previous=D,this.b=D,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}h(w){let D=this.b;for(;D!==this.c;)D.value===w&&(D===this.b?(this.b=this.b.next,this.b.previous=void 0):(D.previous.next=D.next,D.next.previous=D.previous),this.f--),D=D.next}}t.$lS=i}),define($e[46],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xl=t.$Wl=t.$Vl=t.rot=t.$Tl=void 0;function v(D,c,d){return Math.min(Math.max(D,c),d)}t.$Tl=v;function T(D,c){return(c+D%c)%c}t.rot=T;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Vl=i;class H{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Wl=H;class w{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const d=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Xl=w}),define($e[47],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(T){function i(c,d){if(c.start>=d.end||d.start>=c.end)return{start:0,end:0};const f=Math.max(c.start,d.start),R=Math.min(c.end,d.end);return R-f<=0?{start:0,end:0}:{start:f,end:R}}T.intersect=i;function H(c){return c.end-c.start<=0}T.isEmpty=H;function w(c,d){return!H(i(c,d))}T.intersects=w;function D(c,d){const f=[],R={start:c.start,end:Math.min(d.start,c.end)},s={start:Math.max(d.end,c.start),end:c.end};return H(R)||f.push(R),H(s)||f.push(s),f}T.relativeComplement=D})(v||(t.Range=v={}))}),define($e[82],we([1,0,47]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cR=t.$bR=t.$aR=t.$_Q=void 0;function T(c,d){const f=[];for(const R of d){if(c.start>=R.range.end)continue;if(c.end<R.range.start)break;const s=v.Range.intersect(c,R.range);v.Range.isEmpty(s)||f.push({range:s,size:R.size})}return f}t.$_Q=T;function i({start:c,end:d},f){return{start:c+f,end:d+f}}t.$aR=i;function H(c){const d=[];let f=null;for(const R of c){const s=R.range.start,a=R.range.end,e=R.size;if(f&&e===f.size){f.range.end=a;continue}f={range:{start:s,end:a},size:e},d.push(f)}return d}t.$bR=H;function w(...c){return H(c.reduce((d,f)=>d.concat(f),[]))}class D{get paddingTop(){return this.c}set paddingTop(d){this.b=this.b+d-this.c,this.c=d}constructor(d){this.a=[],this.b=0,this.c=0,this.c=d??0,this.b=this.c}splice(d,f,R=[]){const s=R.length-f,a=T({start:0,end:d},this.a),e=T({start:d+f,end:Number.POSITIVE_INFINITY},this.a).map(l=>({range:i(l.range,s),size:l.size})),h=R.map((l,m)=>({range:{start:d+m,end:d+m+1},size:l.size}));this.a=w(a,h,e),this.b=this.c+this.a.reduce((l,m)=>l+m.size*(m.range.end-m.range.start),0)}get count(){const d=this.a.length;return d?this.a[d-1].range.end:0}get size(){return this.b}indexAt(d){if(d<0)return-1;if(d<this.c)return 0;let f=0,R=this.c;for(const s of this.a){const a=s.range.end-s.range.start,e=R+a*s.size;if(d<e)return f+Math.floor((d-R)/s.size);f+=a,R=e}return f}indexAfter(d){return Math.min(this.indexAt(d)+1,this.count)}positionAt(d){if(d<0)return-1;let f=0,R=0;for(const s of this.a){const a=s.range.end-s.range.start,e=R+a;if(d<e)return this.c+f+(d-R)*s.size;f+=a*s.size,R=e}return-1}}t.$cR=D}),define($e[83],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Md=void 0;const v=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(H){return new T(H)}constructor(H){this.c=v&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Md=T}),define($e[4],we([1,0,6,43,2,45,83]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.Event=void 0;const D=!1,c=!1;var d;(function(x){x.None=()=>i.$Rc.None;function P(I){if(c){const{onDidAddListener:S}=I,F=e.create();let z=0;I.onDidAddListener=()=>{++z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),F.print()),S?.()}}}function O(I,S){return Pe(I,()=>{},0,void 0,!0,void 0,S)}x.defer=O;function K(I){return(S,F=null,z)=>{let G=!1,ee;return ee=I(ne=>{if(!G)return ee?ee.dispose():G=!0,S.call(F,ne)},null,z),G&&ee.dispose(),ee}}x.once=K;function te(I,S,F){return Se((z,G=null,ee)=>I(ne=>z.call(G,S(ne)),null,ee),F)}x.map=te;function se(I,S,F){return Se((z,G=null,ee)=>I(ne=>{S(ne),z.call(G,ne)},null,ee),F)}x.forEach=se;function fe(I,S,F){return Se((z,G=null,ee)=>I(ne=>S(ne)&&z.call(G,ne),null,ee),F)}x.filter=fe;function le(I){return I}x.signal=le;function oe(...I){return(S,F=null,z)=>{const G=(0,i.$Oc)(...I.map(ee=>ee(ne=>S.call(F,ne))));return Ae(G,z)}}x.any=oe;function be(I,S,F,z){let G=F;return te(I,ee=>(G=S(G,ee),G),z)}x.reduce=be;function Se(I,S){let F;const z={onWillAddFirstListener(){F=I(G.fire,G)},onDidRemoveLastListener(){F?.dispose()}};S||P(z);const G=new r(z);return S?.add(G),G.event}function Ae(I,S){return S instanceof Array?S.push(I):S&&S.add(I),I}function Pe(I,S,F=100,z=!1,G=!1,ee,ne){let me,ve,Ne,Ce=0,De;const Le={leakWarningThreshold:ee,onWillAddFirstListener(){me=I(We=>{Ce++,ve=S(ve,We),z&&!Ne&&(Te.fire(ve),ve=void 0),De=()=>{const He=ve;ve=void 0,Ne=void 0,(!z||Ce>1)&&Te.fire(He),Ce=0},typeof F=="number"?(clearTimeout(Ne),Ne=setTimeout(De,F)):Ne===void 0&&(Ne=0,queueMicrotask(De))})},onWillRemoveListener(){G&&Ce>0&&De?.()},onDidRemoveLastListener(){De=void 0,me.dispose()}};ne||P(Le);const Te=new r(Le);return ne?.add(Te),Te.event}x.debounce=Pe;function de(I,S=0,F){return x.debounce(I,(z,G)=>z?(z.push(G),z):[G],S,void 0,!0,void 0,F)}x.accumulate=de;function ie(I,S=(z,G)=>z===G,F){let z=!0,G;return fe(I,ee=>{const ne=z||!S(ee,G);return z=!1,G=ee,ne},F)}x.latch=ie;function ce(I,S,F){return[x.filter(I,S,F),x.filter(I,z=>!S(z),F)]}x.split=ce;function Z(I,S=!1,F=[],z){let G=F.slice(),ee=I(ve=>{G?G.push(ve):me.fire(ve)});z&&z.add(ee);const ne=()=>{G?.forEach(ve=>me.fire(ve)),G=null},me=new r({onWillAddFirstListener(){ee||(ee=I(ve=>me.fire(ve)),z&&z.add(ee))},onDidAddFirstListener(){G&&(S?setTimeout(ne):ne())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return z&&z.add(me),me.event}x.buffer=Z;function W(I,S){return(z,G,ee)=>{const ne=S(new C);return I(function(me){const ve=ne.evaluate(me);ve!==Y&&z.call(G,ve)},void 0,ee)}}x.chain=W;const Y=Symbol("HaltChainable");class C{constructor(){this.f=[]}map(S){return this.f.push(S),this}forEach(S){return this.f.push(F=>(S(F),F)),this}filter(S){return this.f.push(F=>S(F)?F:Y),this}reduce(S,F){let z=F;return this.f.push(G=>(z=S(z,G),z)),this}latch(S=(F,z)=>F===z){let F=!0,z;return this.f.push(G=>{const ee=F||!S(G,z);return F=!1,z=G,ee?G:Y}),this}evaluate(S){for(const F of this.f)if(S=F(S),S===Y)break;return S}}function V(I,S,F=z=>z){const z=(...me)=>ne.fire(F(...me)),G=()=>I.on(S,z),ee=()=>I.removeListener(S,z),ne=new r({onWillAddFirstListener:G,onDidRemoveLastListener:ee});return ne.event}x.fromNodeEventEmitter=V;function $(I,S,F=z=>z){const z=(...me)=>ne.fire(F(...me)),G=()=>I.addEventListener(S,z),ee=()=>I.removeEventListener(S,z),ne=new r({onWillAddFirstListener:G,onDidRemoveLastListener:ee});return ne.event}x.fromDOMEventEmitter=$;function U(I){return new Promise(S=>K(I)(S))}x.toPromise=U;function Q(I){const S=new r;return I.then(F=>{S.fire(F)},()=>{S.fire(void 0)}).finally(()=>{S.dispose()}),S.event}x.fromPromise=Q;function p(I,S,F){return S(F),I(z=>S(z))}x.runAndSubscribe=p;function A(I,S){let F=null;function z(ee){F?.dispose(),F=new i.$Qc,S(ee,F)}z(void 0);const G=I(ee=>z(ee));return(0,i.$Pc)(()=>{G.dispose(),F?.dispose()})}x.runAndSubscribeWithStore=A;class E{constructor(S,F){this._observable=S,this.f=0,this.g=!1;const z={onWillAddFirstListener:()=>{S.addObserver(this)},onDidRemoveLastListener:()=>{S.removeObserver(this)}};F||P(z),this.emitter=new r(z),F&&F.add(this.emitter)}beginUpdate(S){this.f++}handlePossibleChange(S){}handleChange(S,F){this.g=!0}endUpdate(S){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function M(I,S){return new E(I,S).emitter.event}x.fromObservable=M;function k(I){return S=>{let F=0,z=!1;const G={beginUpdate(){F++},endUpdate(){F--,F===0&&(I.reportChanges(),z&&(z=!1,S()))},handlePossibleChange(){},handleChange(){z=!0}};return I.addObserver(G),I.reportChanges(),{dispose(){I.removeObserver(G)}}}}x.fromObservableLight=k})(d||(t.Event=d={}));class f{static{this.all=new Set}static{this.f=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${f.f++}`,f.all.add(this)}start(P){this.g=new w.$Md,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}t.$Od=f;let R=-1;function s(x){const P=R;return R=x,{dispose(){R=P}}}t.$Pd=s;class a{constructor(P,O=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=O,this.g=0}dispose(){this.f?.clear()}check(P,O){const K=this.threshold;if(K<=0||O<K)return;this.f||(this.f=new Map);const te=this.f.get(P.value)||0;if(this.f.set(P.value,te+1),this.g-=1,this.g<=0){this.g=K*.5;let se,fe=0;for(const[le,oe]of this.f)(!se||fe<oe)&&(se=le,fe=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${O} listeners already. MOST frequent listener (${fe}):`),console.warn(se)}return()=>{const se=this.f.get(P.value)||0;this.f.set(P.value,se-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let h=0;class l{constructor(P){this.value=P,this.id=h++}}const m=2,n=(x,P)=>{if(x instanceof l)P(x);else for(let O=0;O<x.length;O++){const K=x[O];K&&P(K)}};class r{constructor(P){this.w=0,this.f=P,this.g=R>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??R):void 0,this.j=this.f?._profName?new f(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(D){const P=this.t;queueMicrotask(()=>{n(P,O=>O.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(P,O,K)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Rc.None;if(this.m)return i.$Rc.None;O&&(P=P.bind(O));const te=new l(P);let se,fe;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(te.stack=e.create(),se=this.g.check(te.stack,this.w+1)),D&&(te.stack=fe??e.create()),this.t?this.t instanceof l?(this.u??=new u,this.t=[this.t,te]):this.t.push(te):(this.f?.onWillAddFirstListener?.(this),this.t=te,this.f?.onDidAddFirstListener?.(this)),this.w++;const le=(0,i.$Pc)(()=>{se?.(),this.x(te)});return K instanceof i.$Qc?K.add(le):Array.isArray(K)&&K.push(le),le},this.q}x(P){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const O=this.t,K=O.indexOf(P);if(K===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,O[K]=void 0;const te=this.u.current===this;if(this.w*m<=O.length){let se=0;for(let fe=0;fe<O.length;fe++)O[fe]?O[se++]=O[fe]:te&&(this.u.end--,se<this.u.i&&this.u.i--);O.length=se}}y(P,O){if(!P)return;const K=this.f?.onListenerError||v.$Z;if(!K){P.value(O);return}try{P.value(O)}catch(te){K(te)}}z(P){const O=P.current.t;for(;P.i<P.end;)this.y(O[P.i++],P.value);P.reset()}fire(P){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,P);else{const O=this.u;O.enqueue(this,P,this.t.length),this.z(O)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Qd=r;const b=()=>new u;t.$Rd=b;class u{constructor(){this.i=-1,this.end=0}enqueue(P,O,K){this.i=0,this.end=K,this.current=P,this.value=O}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends r{async fireAsync(P,O,K){if(this.t)for(this.h||(this.h=new H.$1c),n(this.t,te=>this.h.push([te.value,P]));this.h.size>0&&!O.isCancellationRequested;){const[te,se]=this.h.shift(),fe=[],le={...se,token:O,waitUntil:oe=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");K&&(oe=K(oe,te)),fe.push(oe)}};try{te(le)}catch(oe){(0,v.$Z)(oe);continue}Object.freeze(fe),await Promise.allSettled(fe).then(oe=>{for(const be of oe)be.status==="rejected"&&(0,v.$Z)(be.reason)})}}}t.$Sd=o;class N extends r{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new H.$1c,this.A=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.A(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.w&&(this.h!==0?this.s.push(P):super.fire(P))}}t.$Td=N;class j extends N{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}t.$Ud=j;class L extends r{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(O=>super.fire(O)),this.h=[]}))}}t.$Vd=L;class g{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const O={event:P,listener:null};this.h.push(O),this.g&&this.m(O);const K=()=>{this.g&&this.o(O);const te=this.h.indexOf(O);this.h.splice(te,1)};return(0,i.$Pc)((0,T.$cb)(K))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(O=>this.f.fire(O))}o(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.f.dispose()}}t.$Wd=g;class y{constructor(P,O,K,te){this.f=new i.$Qc;const se=this.f.add(new g),fe=this.f.add(new i.$Zc);function le(oe){fe.set(oe,se.add(te(oe)))}for(const oe of P)le(oe);this.f.add(O(oe=>{le(oe)})),this.f.add(K(oe=>{fe.deleteAndDispose(oe)})),this.event=se.event}dispose(){this.f.dispose()}}t.$Xd=y;class B{constructor(){this.f=[]}wrapEvent(P){return(O,K,te)=>P(se=>{const fe=this.f[this.f.length-1];fe?fe.push(()=>O.call(K,se)):O.call(K,se)},void 0,te)}bufferEvents(P){const O=[];this.f.push(O);const K=P();return this.f.pop(),O.forEach(te=>te()),K}}t.$Yd=B;class q{constructor(){this.f=!1,this.g=d.None,this.h=i.$Rc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Zd=q}),define($e[17],we([1,0,16,4,2]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=void 0;class H{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new T.$Qd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new H}getZoomLevel(){return this.a}setZoomLevel(u){this.a!==u&&(this.a=u)}getZoomFactor(){return this.b}setZoomFactor(u){this.b=u}setFullscreen(u){this.c!==u&&(this.c=u,this.d.fire())}isFullscreen(){return this.c}}class w extends i.$Rc{constructor(){super(),this.a=this.B(new T.$Qd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(u){this.c?.removeEventListener("change",this.b),this.c=v.$window.matchMedia(`(resolution: ${v.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),u&&this.a.fire()}}class D extends i.$Rc{get value(){return this.b}constructor(){super(),this.a=this.B(new T.$Qd),this.onDidChange=this.a.event,this.b=this.c();const u=this.B(new w);this.B(u.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const u=document.createElement("canvas").getContext("2d"),o=v.$window.devicePixelRatio||1,N=u.webkitBackingStorePixelRatio||u.mozBackingStorePixelRatio||u.msBackingStorePixelRatio||u.oBackingStorePixelRatio||u.backingStorePixelRatio||1;return o/N}}class c{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.$Kc)(new D)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function d(b,u){typeof b=="string"&&(b=v.$window.matchMedia(b)),b.addEventListener("change",u)}t.$zO=d,t.$AO=new c;function f(b){H.INSTANCE.setZoomLevel(b)}t.$BO=f;function R(){return H.INSTANCE.getZoomLevel()}t.$CO=R;function s(){return H.INSTANCE.getZoomFactor()}t.$DO=s;function a(b){H.INSTANCE.setZoomFactor(b)}t.$EO=a;function e(b){H.INSTANCE.setFullscreen(b)}t.$FO=e;function h(){return H.INSTANCE.isFullscreen()}t.$GO=h,t.$HO=H.INSTANCE.onDidChangeFullscreen;const l=navigator.userAgent;t.$IO=l.indexOf("Firefox")>=0,t.$JO=l.indexOf("AppleWebKit")>=0,t.$KO=l.indexOf("Chrome")>=0,t.$LO=!t.$KO&&l.indexOf("Safari")>=0,t.$MO=!t.$KO&&!t.$LO&&t.$JO,t.$NO=l.indexOf("Electron/")>=0,t.$OO=l.indexOf("Android")>=0;let m=!1;if(v.$window.matchMedia){const b=v.$window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),u=v.$window.matchMedia("(display-mode: fullscreen)");m=b.matches,d(b,({matches:o})=>{m&&u.matches||(m=o)})}function n(){return m}t.$PO=n;function r(){return navigator?.windowControlsOverlay?.visible}t.$QO=r}),define($e[22],we([1,0,4]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Q=void 0;class T{get event(){return this.a.event}constructor(H,w,D){const c=d=>this.a.fire(d);this.a=new v.$Qd({onWillAddFirstListener:()=>H.addEventListener(w,c,D),onDidRemoveLastListener:()=>H.removeEventListener(w,c,D)})}dispose(){this.a.dispose()}}t.$4Q=T}),define($e[29],we([1,0,4]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1d=t.CancellationToken=void 0;const T=Object.freeze(function(D,c){const d=setTimeout(D.bind(c),0);return{dispose(){clearTimeout(d)}}});var i;(function(D){function c(d){return d===D.None||d===D.Cancelled||d instanceof H?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}D.isCancellationToken=c,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(i||(t.CancellationToken=i={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new v.$Qd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=i.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=i.None}}t.$1d=w}),define($e[84],we([1,0,29]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Be=t.$Ae=t.$ze=void 0;class T{constructor(D){this.b=D,this.a=null}get(){if(this.a)return this.a;const D=new v.$1d,c=this.b(D.token);return this.a={promise:c,dispose:()=>{this.a=null,D.cancel(),D.dispose()}},this.a}}t.$ze=T;class i{constructor(D){this.c=D,this.a=void 0,this.b=void 0}get(D){const c=JSON.stringify(D);return this.b!==c&&(this.b=c,this.a=this.c(D)),this.a}}t.$Ae=i;class H{get cachedValues(){return this.a}constructor(D){this.b=D,this.a=new Map}get(D){if(this.a.has(D))return this.a.get(D);const c=this.b(D);return this.a.set(D,c),c}}t.$Be=H}),define($e[48],we([1,0,4,2]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4r=t.$3r=t.$2r=t.$1r=t.ScrollbarVisibility=void 0;var i;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class H{constructor(e,h,l,m,n,r,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(h=h|0,l=l|0,m=m|0,n=n|0,r=r|0,b=b|0),this.rawScrollLeft=m,this.rawScrollTop=b,h<0&&(h=0),m+h>l&&(m=l-h),m<0&&(m=0),n<0&&(n=0),b+n>r&&(b=r-n),b<0&&(b=0),this.width=h,this.scrollWidth=l,this.scrollLeft=m,this.height=n,this.scrollHeight=r,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,h){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,h?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,h?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,h){const l=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,u=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:h,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:m,scrollLeftChanged:n,heightChanged:r,scrollHeightChanged:b,scrollTopChanged:u}}}t.$1r=H;class w extends T.$Rc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$Qd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,h){const l=this.g.withScrollDimensions(e,h);this.n(l,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const h=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(h,!1)}setScrollPositionSmooth(e,h){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const l=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let m;h?m=new f(this.h.from,l,this.h.startTime,this.h.duration):m=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=m}else{const l=this.g.withScrollPosition(e);this.h=f.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),h=this.g.withScrollPosition(e);if(this.n(h,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,h){const l=this.g;l.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(l,h)))}}t.$2r=w;class D{constructor(e,h,l){this.scrollLeft=e,this.scrollTop=h,this.isDone=l}}t.$3r=D;function c(a,e){const h=e-a;return function(l){return a+h*s(l)}}function d(a,e,h){return function(l){return l<h?a(l/h):e((l-h)/(1-h))}}class f{constructor(e,h,l,m){this.from=e,this.to=h,this.duration=m,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,h,l){if(Math.abs(e-h)>2.5*l){let n,r;return e<h?(n=e+.75*l,r=h-.75*l):(n=e-.75*l,r=h+.75*l),d(c(e,n),c(r,h),.33)}return c(e,h)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const h=(e-this.startTime)/this.duration;if(h<1){const l=this.c(h),m=this.d(h);return new D(l,m,!1)}return new D(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,h,l){return f.start(e,h,l)}static start(e,h,l){l=l+10;const m=Date.now()-10;return new f(e,h,m,l)}}t.$4r=f;function R(a){return Math.pow(a,3)}function s(a){return 1-R(1-a)}}),define($e[85],we([1,0,6,2]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=void 0;function i(b){const u=b;return u?typeof u.read=="function":!1}t.$2d=i;function H(b){const u=b;return u?[u.on,u.pause,u.resume,u.destroy].every(o=>typeof o=="function"):!1}t.$3d=H;function w(b){const u=b;return u?H(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}t.$4d=w;function D(b,u){return new c(b,u)}t.$5d=D;class c{constructor(u,o){this.e=u,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(o=>o(u))}h(u){this.c.error.length===0?(0,v.$Z)(u):this.c.error.slice(0).forEach(o=>o(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,o){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(u,o){if(this.a.destroyed)return;let N;switch(u){case"data":N=this.c.data;break;case"end":N=this.c.end;break;case"error":N=this.c.error;break}if(N){const j=N.indexOf(o);j>=0&&N.splice(j,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(N=>N())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(b,u){const o=[];let N;for(;(N=b.read())!==null;)o.push(N);return u(o)}t.$6d=d;function f(b,u,o){const N=[];let j;for(;(j=b.read())!==null&&N.length<o;)N.push(j);return j===null&&N.length>0?u(N):{read:()=>{if(N.length>0)return N.shift();if(typeof j<"u"){const L=j;return j=void 0,L}return b.read()}}}t.$7d=f;function R(b,u){return new Promise((o,N)=>{const j=[];s(b,{onData:L=>{u&&j.push(L)},onError:L=>{u?N(L):o(void 0)},onEnd:()=>{o(u?u(j):void 0)}})})}t.$8d=R;function s(b,u,o){b.on("error",N=>{o?.isCancellationRequested||u.onError(N)}),b.on("end",()=>{o?.isCancellationRequested||u.onEnd()}),b.on("data",N=>{o?.isCancellationRequested||u.onData(N)})}t.$9d=s;function a(b,u){return new Promise((o,N)=>{const j=new T.$Qc,L=[],g=q=>{if(L.push(q),L.length>u)return j.dispose(),b.pause(),o({stream:b,buffer:L,ended:!1})},y=q=>(j.dispose(),N(q)),B=()=>(j.dispose(),o({stream:b,buffer:L,ended:!0}));j.add((0,T.$Pc)(()=>b.removeListener("error",y))),b.on("error",y),j.add((0,T.$Pc)(()=>b.removeListener("end",B))),b.on("end",B),j.add((0,T.$Pc)(()=>b.removeListener("data",g))),b.on("data",g)})}t.$0d=a;function e(b,u){const o=D(u);return o.end(b),o}t.$$d=e;function h(){const b=D(()=>{throw new Error("not supported")});return b.end(),b}t.$_d=h;function l(b){let u=!1;return{read:()=>u?null:(u=!0,b)}}t.$ae=l;function m(b,u,o){const N=D(o);return s(b,{onData:j=>N.write(u.data(j)),onError:j=>N.error(u.error?u.error(j):j),onEnd:()=>N.end()}),N}t.$be=m;function n(b,u,o){let N=!1;return{read:()=>{const j=u.read();return N?j:(N=!0,j!==null?o([b,j]):b)}}}t.$ce=n;function r(b,u,o){let N=!1;const j=D(o);return s(u,{onData:L=>N?j.write(L):(N=!0,j.write(o([b,L]))),onError:L=>j.error(L),onEnd:()=>{N||(N=!0,j.write(b)),j.end()}}),j}t.$de=r}),define($e[33],we([1,0,28,85]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=void 0;const i=typeof Buffer<"u",H=new v.$U(()=>new Uint8Array(256));let w,D;class c{static alloc(O){return i?new c(Buffer.allocUnsafe(O)):new c(new Uint8Array(O))}static wrap(O){return i&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new c(O)}static fromString(O,K){return!(K?.dontUseNodeBuffer||!1)&&i?new c(Buffer.from(O)):(w||(w=new TextEncoder),new c(w.encode(O)))}static fromByteArray(O){const K=c.alloc(O.length);for(let te=0,se=O.length;te<se;te++)K.buffer[te]=O[te];return K}static concat(O,K){if(typeof K>"u"){K=0;for(let fe=0,le=O.length;fe<le;fe++)K+=O[fe].byteLength}const te=c.alloc(K);let se=0;for(let fe=0,le=O.length;fe<le;fe++){const oe=O[fe];te.set(oe,se),se+=oe.byteLength}return te}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=c.alloc(this.byteLength);return O.set(this),O}toString(){return i?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(O,K){return new c(this.buffer.subarray(O,K))}set(O,K){if(O instanceof c)this.buffer.set(O.buffer,K);else if(O instanceof Uint8Array)this.buffer.set(O,K);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),K);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),K);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return s(this.buffer,O)}writeUInt32BE(O,K){a(this.buffer,O,K)}readUInt32LE(O){return e(this.buffer,O)}writeUInt32LE(O,K){h(this.buffer,O,K)}readUInt8(O){return l(this.buffer,O)}writeUInt8(O,K){m(this.buffer,O,K)}indexOf(O,K=0){return d(this.buffer,O instanceof c?O.buffer:O,K)}}t.$ee=c;function d(P,O,K=0){const te=O.byteLength,se=P.byteLength;if(te===0)return 0;if(te===1)return P.indexOf(O[0]);if(te>se-K)return-1;const fe=H.value;fe.fill(O.length);for(let Se=0;Se<O.length;Se++)fe[O[Se]]=O.length-Se-1;let le=K+O.length-1,oe=le,be=-1;for(;le<se;)if(P[le]===O[oe]){if(oe===0){be=le;break}le--,oe--}else le+=Math.max(O.length-oe,fe[P[le]]),oe=O.length-1;return be}t.$fe=d;function f(P,O){return P[O+0]<<0>>>0|P[O+1]<<8>>>0}t.$ge=f;function R(P,O,K){P[K+0]=O&255,O=O>>>8,P[K+1]=O&255}t.$he=R;function s(P,O){return P[O]*2**24+P[O+1]*2**16+P[O+2]*2**8+P[O+3]}t.$ie=s;function a(P,O,K){P[K+3]=O,O=O>>>8,P[K+2]=O,O=O>>>8,P[K+1]=O,O=O>>>8,P[K]=O}t.$je=a;function e(P,O){return P[O+0]<<0>>>0|P[O+1]<<8>>>0|P[O+2]<<16>>>0|P[O+3]<<24>>>0}t.$ke=e;function h(P,O,K){P[K+0]=O&255,O=O>>>8,P[K+1]=O&255,O=O>>>8,P[K+2]=O&255,O=O>>>8,P[K+3]=O&255}t.$le=h;function l(P,O){return P[O]}t.$me=l;function m(P,O,K){P[K]=O}t.$ne=m;function n(P){return T.$6d(P,O=>c.concat(O))}t.$oe=n;function r(P){return T.$ae(P)}t.$pe=r;function b(P){return T.$8d(P,O=>c.concat(O))}t.$qe=b;async function u(P){return P.ended?c.concat(P.buffer):c.concat([...P.buffer,await b(P.stream)])}t.$re=u;function o(P){return T.$$d(P,O=>c.concat(O))}t.$se=o;function N(P){return T.$be(P,{data:O=>typeof O=="string"?c.fromString(O):c.wrap(O)},O=>c.concat(O))}t.$te=N;function j(P){return T.$5d(O=>c.concat(O),P)}t.$ue=j;function L(P,O){return T.$ce(P,O,K=>c.concat(K))}t.$ve=L;function g(P,O){return T.$de(P,O,K=>c.concat(K))}t.$we=g;function y(P){let O=0,K=0,te=0;const se=new Uint8Array(Math.floor(P.length/4*3)),fe=oe=>{switch(K){case 3:se[te++]=O|oe,K=0;break;case 2:se[te++]=O|oe>>>2,O=oe<<6,K=3;break;case 1:se[te++]=O|oe>>>4,O=oe<<4,K=2;break;default:O=oe<<2,K=1}};for(let oe=0;oe<P.length;oe++){const be=P.charCodeAt(oe);if(be>=65&&be<=90)fe(be-65);else if(be>=97&&be<=122)fe(be-97+26);else if(be>=48&&be<=57)fe(be-48+52);else if(be===43||be===45)fe(62);else if(be===47||be===95)fe(63);else{if(be===61)break;throw new SyntaxError(`Unexpected base64 character ${P[oe]}`)}}const le=te;for(;K>0;)fe(0);return c.wrap(se).slice(0,le)}t.$xe=y;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",q="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function x({buffer:P},O=!0,K=!1){const te=K?q:B;let se="";const fe=P.byteLength%3;let le=0;for(;le<P.byteLength-fe;le+=3){const oe=P[le+0],be=P[le+1],Se=P[le+2];se+=te[oe>>>2],se+=te[(oe<<4|be>>>4)&63],se+=te[(be<<2|Se>>>6)&63],se+=te[Se&63]}if(fe===1){const oe=P[le+0];se+=te[oe>>>2],se+=te[oe<<4&63],O&&(se+="==")}else if(fe===2){const oe=P[le+0],be=P[le+1];se+=te[oe>>>2],se+=te[(oe<<4|be>>>4)&63],se+=te[be<<2&63],O&&(se+="=")}return se}t.$ye=x}),define($e[12],we([1,0,84,28]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Af=t.$zf=t.$yf=t.$xf=t.GraphemeBreakType=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=void 0;function i(J){return!J||typeof J!="string"?!0:J.trim().length===0}t.$Ee=i;const H=/{(\d+)}/g;function w(J,...he){return he.length===0?J:J.replace(H,function(pe,Ee){const Fe=parseInt(Ee,10);return isNaN(Fe)||Fe<0||Fe>=he.length?pe:he[Fe]})}t.$Fe=w;const D=/{([^}]+)}/g;function c(J,he){return Object.keys(he).length===0?J:J.replace(D,(pe,Ee)=>he[Ee]??pe)}t.$Ge=c;function d(J){return J.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}t.$He=d;function f(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ie=f;function R(J,he){let pe=0;const Ee=he.charCodeAt(0);for(let Fe=J.length-1;Fe>=0;Fe--)J.charCodeAt(Fe)===Ee&&pe++;return pe}t.$Je=R;function s(J,he,pe="\u2026"){return J.length<=he?J:`${J.substr(0,he)}${pe}`}t.$Ke=s;function a(J,he=" "){const pe=e(J,he);return h(pe,he)}t.$Le=a;function e(J,he){if(!J||!he)return J;const pe=he.length;if(pe===0||J.length===0)return J;let Ee=0;for(;J.indexOf(he,Ee)===Ee;)Ee=Ee+pe;return J.substring(Ee)}t.$Me=e;function h(J,he){if(!J||!he)return J;const pe=he.length,Ee=J.length;if(pe===0||Ee===0)return J;let Fe=Ee,Be=-1;for(;Be=J.lastIndexOf(he,Fe-1),!(Be===-1||Be+pe!==Fe);){if(Be===0)return"";Fe=Be}return J.substring(0,Fe)}t.$Ne=h;function l(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Oe=l;function m(J){return J.replace(/\*/g,"")}t.$Pe=m;function n(J,he,pe={}){if(!J)throw new Error("Cannot create regex from empty string");he||(J=f(J)),pe.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Ee="";return pe.global&&(Ee+="g"),pe.matchCase||(Ee+="i"),pe.multiline&&(Ee+="m"),pe.unicode&&(Ee+="u"),new RegExp(J,Ee)}t.$Qe=n;function r(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}t.$Re=r;function b(J){return J.split(/\r\n|\r|\n/)}t.$Se=b;function u(J){for(let he=0,pe=J.length;he<pe;he++){const Ee=J.charCodeAt(he);if(Ee!==32&&Ee!==9)return he}return-1}t.$Te=u;function o(J,he=0,pe=J.length){for(let Ee=he;Ee<pe;Ee++){const Fe=J.charCodeAt(Ee);if(Fe!==32&&Fe!==9)return J.substring(he,Ee)}return J.substring(he,pe)}t.$Ue=o;function N(J,he=J.length-1){for(let pe=he;pe>=0;pe--){const Ee=J.charCodeAt(pe);if(Ee!==32&&Ee!==9)return pe}return-1}t.$Ve=N;function j(J,he,pe){const Ee=[];let Fe=0;for(const Be of J.matchAll(he)){if(Ee.push(J.slice(Fe,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Fe=Be.index+Be[0].length,Ee.push(pe(Be[0],...Be.slice(1),Be.index,J,Be.groups))}return Ee.push(J.slice(Fe)),Promise.all(Ee).then(Be=>Be.join(""))}t.$We=j;function L(J,he){return J<he?-1:J>he?1:0}t.$Xe=L;function g(J,he,pe=0,Ee=J.length,Fe=0,Be=he.length){for(;pe<Ee&&Fe<Be;pe++,Fe++){const Je=J.charCodeAt(pe),Ke=he.charCodeAt(Fe);if(Je<Ke)return-1;if(Je>Ke)return 1}const Ue=Ee-pe,Ze=Be-Fe;return Ue<Ze?-1:Ue>Ze?1:0}t.$Ye=g;function y(J,he){return B(J,he,0,J.length,0,he.length)}t.$Ze=y;function B(J,he,pe=0,Ee=J.length,Fe=0,Be=he.length){for(;pe<Ee&&Fe<Be;pe++,Fe++){let Je=J.charCodeAt(pe),Ke=he.charCodeAt(Fe);if(Je===Ke)continue;if(Je>=128||Ke>=128)return g(J.toLowerCase(),he.toLowerCase(),pe,Ee,Fe,Be);x(Je)&&(Je-=32),x(Ke)&&(Ke-=32);const qe=Je-Ke;if(qe!==0)return qe}const Ue=Ee-pe,Ze=Be-Fe;return Ue<Ze?-1:Ue>Ze?1:0}t.$1e=B;function q(J){return J>=48&&J<=57}t.$2e=q;function x(J){return J>=97&&J<=122}t.$3e=x;function P(J){return J>=65&&J<=90}t.$4e=P;function O(J,he){return J.length===he.length&&B(J,he)===0}t.$5e=O;function K(J,he){const pe=he.length;return he.length>J.length?!1:B(J,he,0,pe)===0}t.$6e=K;function te(J,he){const pe=Math.min(J.length,he.length);let Ee;for(Ee=0;Ee<pe;Ee++)if(J.charCodeAt(Ee)!==he.charCodeAt(Ee))return Ee;return pe}t.$7e=te;function se(J,he){const pe=Math.min(J.length,he.length);let Ee;const Fe=J.length-1,Be=he.length-1;for(Ee=0;Ee<pe;Ee++)if(J.charCodeAt(Fe-Ee)!==he.charCodeAt(Be-Ee))return Ee;return pe}t.$8e=se;function fe(J){return 55296<=J&&J<=56319}t.$9e=fe;function le(J){return 56320<=J&&J<=57343}t.$0e=le;function oe(J,he){return(J-55296<<10)+(he-56320)+65536}t.$$e=oe;function be(J,he,pe){const Ee=J.charCodeAt(pe);if(fe(Ee)&&pe+1<he){const Fe=J.charCodeAt(pe+1);if(le(Fe))return oe(Ee,Fe)}return Ee}t.$_e=be;function Se(J,he){const pe=J.charCodeAt(he-1);if(le(pe)&&he>1){const Ee=J.charCodeAt(he-2);if(fe(Ee))return oe(Ee,pe)}return pe}class Ae{get offset(){return this.e}constructor(he,pe=0){this.c=he,this.d=he.length,this.e=pe}setOffset(he){this.e=he}prevCodePoint(){const he=Se(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=be(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}t.$af=Ae;class Pe{get offset(){return this.c.offset}constructor(he,pe=0){this.c=new Ae(he,pe)}nextGraphemeLength(){const he=Ce.getInstance(),pe=this.c,Ee=pe.offset;let Fe=he.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Be=pe.offset,Ue=he.getGraphemeBreakType(pe.nextCodePoint());if(ve(Fe,Ue)){pe.setOffset(Be);break}Fe=Ue}return pe.offset-Ee}prevGraphemeLength(){const he=Ce.getInstance(),pe=this.c,Ee=pe.offset;let Fe=he.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Be=pe.offset,Ue=he.getGraphemeBreakType(pe.prevCodePoint());if(ve(Ue,Fe)){pe.setOffset(Be);break}Fe=Ue}return Ee-pe.offset}eol(){return this.c.eol()}}t.$bf=Pe;function de(J,he){return new Pe(J,he).nextGraphemeLength()}t.$cf=de;function ie(J,he){return new Pe(J,he).prevGraphemeLength()}t.$df=ie;function ce(J,he){he>0&&le(J.charCodeAt(he))&&he--;const pe=he+de(J,he);return[pe-ie(J,pe),pe]}t.$ef=ce;function Z(J){const he=new Pe(J);let pe=0;for(;!he.eol();)pe++,he.nextGraphemeLength();return pe}t.$ff=Z;let W;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function C(J){return W||(W=Y()),W.test(J)}t.$gf=C;const V=/^[\t\n\r\x20-\x7E]*$/;function $(J){return V.test(J)}t.$hf=$,t.$if=/[\u2028\u2029]/;function U(J){return t.$if.test(J)}t.$jf=U;function Q(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}t.$kf=Q;function p(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}t.$lf=p;function A(J,he){if(J.length<he)return J;const pe=/\b/g;let Ee=0;for(;pe.test(J)&&!(J.length-pe.lastIndex<he);)Ee=pe.lastIndex,pe.lastIndex+=1;return J.substring(Ee).replace(/^\s/,"")}t.$mf=A;const E=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,M=/\x1b\].*?\x07/g;function k(J){return J&&(J=J.replace(E,"").replace(M,"")),J}t.$nf=k,t.$of=String.fromCharCode(65279);function I(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}t.$pf=I;function S(J){return I(J)?J.substr(1):J}t.$qf=S;function F(J,he){if(!J||!he||J.length<he.length)return!1;const pe=he.length,Ee=J.toLowerCase();let Fe=0,Be=-1;for(;Fe<pe;){const Ue=Ee.indexOf(he[Fe],Be+1);if(Ue<0)return!1;Be=Ue,Fe++}return!0}t.$rf=F;function z(J,he=!1){return J?(he&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}t.$sf=z;function G(J){return J.charAt(0).toUpperCase()+J.slice(1)}t.$tf=G;function ee(J,he=1){if(he===0)return"";let pe=-1;do pe=J.indexOf(`
`,pe+1),he--;while(he>0&&pe>=0);return pe===-1?J:(J[pe-1]==="\r"&&pe--,J.substr(0,pe))}t.$uf=ee;function ne(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}t.$vf=ne;function me(J){return Ce.getInstance().getGraphemeBreakType(J)}t.$wf=me;function ve(J,he){return J===0?he!==5&&he!==7:J===2&&he===3?!1:J===4||J===2||J===3||he===4||he===2||he===3?!0:!(J===8&&(he===8||he===9||he===11||he===12)||(J===11||J===9)&&(he===9||he===10)||(J===12||J===10)&&he===10||he===5||he===13||he===7||J===1||J===13&&he===14||J===6&&he===6)}var Ne;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Ne||(t.GraphemeBreakType=Ne={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const pe=this.d,Ee=pe.length/3;let Fe=1;for(;Fe<=Ee;)if(he<pe[3*Fe])Fe=2*Fe;else if(he>pe[3*Fe+1])Fe=2*Fe+1;else return pe[3*Fe+2];return 0}}function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(J,he){if(J===0)return 0;const pe=Te(J,he);if(pe!==void 0)return pe;const Ee=new Ae(he,J);return Ee.prevCodePoint(),Ee.offset}t.$xf=Le;function Te(J,he){const pe=new Ae(he,J);let Ee=pe.prevCodePoint();for(;We(Ee)||Ee===65039||Ee===8419;){if(pe.offset===0)return;Ee=pe.prevCodePoint()}if(!p(Ee))return;let Fe=pe.offset;return Fe>0&&pe.prevCodePoint()===8205&&(Fe=pe.offset),Fe}function We(J){return 127995<=J&&J<=127999}var He;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),t.$yf="\xA0";class Me{static{this.c=new T.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new v.$Ae(he=>{function pe(qe){const tt=new Map;for(let nt=0;nt<qe.length;nt+=2)tt.set(qe[nt],qe[nt+1]);return tt}function Ee(qe,tt){const nt=new Map(qe);for(const[dt,ft]of tt)nt.set(dt,ft);return nt}function Fe(qe,tt){if(!qe)return tt;const nt=new Map;for(const[dt,ft]of qe)tt.has(dt)&&nt.set(dt,ft);return nt}const Be=this.c.value;let Ue=he.filter(qe=>!qe.startsWith("_")&&qe in Be);Ue.length===0&&(Ue=["_default"]);let Ze;for(const qe of Ue){const tt=pe(Be[qe]);Ze=Fe(Ze,tt)}const Je=pe(Be._common),Ke=Ee(Je,Ze);return new Me(Ke)})}static getInstance(he){return Me.d.get(Array.from(he))}static{this.e=new T.$U(()=>Object.keys(Me.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Me.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$zf=Me;class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(he){return Ye.e().has(he)}static get codePoints(){return Ye.e()}}t.$Af=Ye}),define($e[34],we([1,0,32,12]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wj=t.$Vj=t.$Uj=t.$Tj=t.FuzzyScore=t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.or=void 0;function i(...S){return function(F,z){for(let G=0,ee=S.length;G<ee;G++){const ne=S[G](F,z);if(ne)return ne}return null}}t.or=i,t.$Hj=H.bind(void 0,!1),t.$Ij=H.bind(void 0,!0);function H(S,F,z){if(!z||z.length<F.length)return null;let G;return S?G=T.$6e(z,F):G=z.indexOf(F)===0,G?F.length>0?[{start:0,end:F.length}]:[]:null}function w(S,F){const z=F.toLowerCase().indexOf(S.toLowerCase());return z===-1?null:[{start:z,end:z+S.length}]}t.$Jj=w;function D(S,F){return c(S.toLowerCase(),F.toLowerCase(),0,0)}t.$Kj=D;function c(S,F,z,G){if(z===S.length)return[];if(G===F.length)return null;if(S[z]===F[G]){let ee=null;return(ee=c(S,F,z+1,G+1))?m({start:G,end:G+1},ee):null}return c(S,F,z,G+1)}function d(S){return 97<=S&&S<=122}function f(S){return 65<=S&&S<=90}t.$Lj=f;function R(S){return 48<=S&&S<=57}function s(S){return S===32||S===9||S===10||S===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(S=>a.add(S.charCodeAt(0)));function e(S){return s(S)||a.has(S)}function h(S,F){return S===F||e(S)&&e(F)}function l(S){return d(S)||f(S)||R(S)}function m(S,F){return F.length===0?F=[S]:S.end===F[0].start?F[0].start=S.start:F.unshift(S),F}function n(S,F){for(let z=F;z<S.length;z++){const G=S.charCodeAt(z);if(f(G)||R(G)||z>0&&!l(S.charCodeAt(z-1)))return z}return S.length}function r(S,F,z,G){if(z===S.length)return[];if(G===F.length)return null;if(S[z]!==F[G].toLowerCase())return null;{let ee=null,ne=G+1;for(ee=r(S,F,z+1,G+1);!ee&&(ne=n(F,ne))<F.length;)ee=r(S,F,z+1,ne),ne++;return ee===null?null:m({start:G,end:G+1},ee)}}function b(S){let F=0,z=0,G=0,ee=0,ne=0;for(let De=0;De<S.length;De++)ne=S.charCodeAt(De),f(ne)&&F++,d(ne)&&z++,l(ne)&&G++,R(ne)&&ee++;const me=F/S.length,ve=z/S.length,Ne=G/S.length,Ce=ee/S.length;return{upperPercent:me,lowerPercent:ve,alphaPercent:Ne,numericPercent:Ce}}function u(S){const{upperPercent:F,lowerPercent:z}=S;return z===0&&F>.6}function o(S){const{upperPercent:F,lowerPercent:z,alphaPercent:G,numericPercent:ee}=S;return z>.2&&F<.8&&G>.6&&ee<.2}function N(S){let F=0,z=0,G=0,ee=0;for(let ne=0;ne<S.length;ne++)G=S.charCodeAt(ne),f(G)&&F++,d(G)&&z++,s(G)&&ee++;return(F===0||z===0)&&ee===0?S.length<=30:F<=5}function j(S,F){if(!F||(F=F.trim(),F.length===0)||!N(S)||F.length>60)return null;const z=b(F);if(!o(z)){if(!u(z))return null;F=F.toLowerCase()}let G=null,ee=0;for(S=S.toLowerCase();ee<F.length&&(G=r(S,F,0,ee))===null;)ee=n(F,ee+1);return G}t.$Mj=j;function L(S,F,z=!1){if(!F||F.length===0)return null;let G=null,ee=0;for(S=S.toLowerCase(),F=F.toLowerCase();ee<F.length&&(G=g(S,F,0,ee,z))===null;)ee=y(F,ee+1);return G}t.$Nj=L;function g(S,F,z,G,ee){if(z===S.length)return[];if(G===F.length)return null;if(h(S.charCodeAt(z),F.charCodeAt(G))){let ne=null,me=G+1;if(ne=g(S,F,z+1,G+1,ee),!ee)for(;!ne&&(me=y(F,me))<F.length;)ne=g(S,F,z+1,me,ee),me++;return ne?S.charCodeAt(z)!==F.charCodeAt(G)?ne:m({start:G,end:G+1},ne):null}else return null}function y(S,F){for(let z=F;z<S.length;z++)if(e(S.charCodeAt(z))||z>0&&e(S.charCodeAt(z-1)))return z;return S.length}const B=i(t.$Ij,j,w),q=i(t.$Ij,j,D),x=new v.$Cc(1e4);function P(S,F,z=!1){if(typeof S!="string"||typeof F!="string")return null;let G=x.get(S);G||(G=new RegExp(T.$Oe(S),"i"),x.set(S,G));const ee=G.exec(F);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:z?q(S,F):B(S,F)}t.$Oj=P;function O(S,F){const z=Q(S,S.toLowerCase(),0,F,F.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?te(z):null}t.$Pj=O;function K(S,F,z,G,ee,ne){const me=Math.min(13,S.length);for(;z<me;z++){const ve=Q(S,F,z,G,ee,ne,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ve)return ve}return[0,ne]}t.$Qj=K;function te(S){if(typeof S>"u")return[];const F=[],z=S[1];for(let G=S.length-1;G>1;G--){const ee=S[G]+z,ne=F[F.length-1];ne&&ne.end===ee?ne.end=ee+1:F.push({start:ee,end:ee+1})}return F}t.$Rj=te;const se=128;function fe(){const S=[],F=[];for(let z=0;z<=se;z++)F[z]=0;for(let z=0;z<=se;z++)S.push(F.slice(0));return S}function le(S){const F=[];for(let z=0;z<=S;z++)F[z]=0;return F}const oe=le(2*se),be=le(2*se),Se=fe(),Ae=fe(),Pe=fe(),de=!1;function ie(S,F,z,G,ee){function ne(ve,Ne,Ce=" "){for(;ve.length<Ne;)ve=Ce+ve;return ve}let me=` |   |${G.split("").map(ve=>ne(ve,3)).join("|")}
`;for(let ve=0;ve<=z;ve++)ve===0?me+=" |":me+=`${F[ve-1]}|`,me+=S[ve].slice(0,ee+1).map(Ne=>ne(Ne.toString(),3)).join("|")+`
`;return me}function ce(S,F,z,G){S=S.substr(F),z=z.substr(G),console.log(ie(Ae,S,S.length,z,z.length)),console.log(ie(Pe,S,S.length,z,z.length)),console.log(ie(Se,S,S.length,z,z.length))}function Z(S,F){if(F<0||F>=S.length)return!1;const z=S.codePointAt(F);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$lf(z)}}function W(S,F){if(F<0||F>=S.length)return!1;switch(S.charCodeAt(F)){case 32:case 9:return!0;default:return!1}}function Y(S,F,z){return F[S]!==z[S]}function C(S,F,z,G,ee,ne,me=!1){for(;F<z&&ee<ne;)S[F]===G[ee]&&(me&&(oe[F]=ee),F+=1),ee+=1;return F===z}t.$Sj=C;var V;(function(S){S[S.Diag=1]="Diag",S[S.Left=2]="Left",S[S.LeftLeft=3]="LeftLeft"})(V||(V={}));var $;(function(S){S.Default=[-100,0];function F(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}S.isDefault=F})($||(t.FuzzyScore=$={}));class U{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(F,z){this.firstMatchCanBeWeak=F,this.boostFullMatch=z}}t.$Tj=U;function Q(S,F,z,G,ee,ne,me=U.default){const ve=S.length>se?se:S.length,Ne=G.length>se?se:G.length;if(z>=ve||ne>=Ne||ve-z>Ne-ne||!C(F,z,ve,ee,ne,Ne,!0))return;p(ve,Ne,z,ne,F,ee);let Ce=1,De=1,Le=z,Te=ne;const We=[!1];for(Ce=1,Le=z;Le<ve;Ce++,Le++){const he=oe[Le],pe=be[Le],Ee=Le+1<ve?be[Le+1]:Ne;for(De=he-ne+1,Te=he;Te<Ee;De++,Te++){let Fe=Number.MIN_SAFE_INTEGER,Be=!1;Te<=pe&&(Fe=A(S,F,Le,z,G,ee,Te,Ne,ne,Se[Ce-1][De-1]===0,We));let Ue=0;Fe!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ue=Fe+Ae[Ce-1][De-1]);const Ze=Te>he,Je=Ze?Ae[Ce][De-1]+(Se[Ce][De-1]>0?-5:0):0,Ke=Te>he+1&&Se[Ce][De-1]>0,qe=Ke?Ae[Ce][De-2]+(Se[Ce][De-2]>0?-5:0):0;if(Ke&&(!Ze||qe>=Je)&&(!Be||qe>=Ue))Ae[Ce][De]=qe,Pe[Ce][De]=3,Se[Ce][De]=0;else if(Ze&&(!Be||Je>=Ue))Ae[Ce][De]=Je,Pe[Ce][De]=2,Se[Ce][De]=0;else if(Be)Ae[Ce][De]=Ue,Pe[Ce][De]=1,Se[Ce][De]=Se[Ce-1][De-1]+1;else throw new Error("not possible")}}if(de&&ce(S,z,G,ne),!We[0]&&!me.firstMatchCanBeWeak)return;Ce--,De--;const He=[Ae[Ce][De],ne];let Me=0,Ye=0;for(;Ce>=1;){let he=De;do{const pe=Pe[Ce][he];if(pe===3)he=he-2;else if(pe===2)he=he-1;else break}while(he>=1);Me>1&&F[z+Ce-1]===ee[ne+De-1]&&!Y(he+ne-1,G,ee)&&Me+1>Se[Ce][he]&&(he=De),he===De?Me++:Me=1,Ye||(Ye=he),Ce--,De=he-1,He.push(De)}Ne===ve&&me.boostFullMatch&&(He[0]+=2);const J=Ye-ve;return He[0]-=J,He}t.$Uj=Q;function p(S,F,z,G,ee,ne){let me=S-1,ve=F-1;for(;me>=z&&ve>=G;)ee[me]===ne[ve]&&(be[me]=ve,me--),ve--}function A(S,F,z,G,ee,ne,me,ve,Ne,Ce,De){if(F[z]!==ne[me])return Number.MIN_SAFE_INTEGER;let Le=1,Te=!1;return me===z-G?Le=S[z]===ee[me]?7:5:Y(me,ee,ne)&&(me===0||!Y(me-1,ee,ne))?(Le=S[z]===ee[me]?7:5,Te=!0):Z(ne,me)&&(me===0||!Z(ne,me-1))?Le=5:(Z(ne,me-1)||W(ne,me-1))&&(Le=5,Te=!0),Le>1&&z===G&&(De[0]=!0),Te||(Te=Y(me,ee,ne)||Z(ne,me-1)||W(ne,me-1)),z===G?me>Ne&&(Le-=Te?3:5):Ce?Le+=Te?2:0:Le+=Te?0:1,me+1===ve&&(Le-=Te?3:5),Le}function E(S,F,z,G,ee,ne,me){return k(S,F,z,G,ee,ne,!0,me)}t.$Vj=E;function M(S,F,z,G,ee,ne,me){return k(S,F,z,G,ee,ne,!1,me)}t.$Wj=M;function k(S,F,z,G,ee,ne,me,ve){let Ne=Q(S,F,z,G,ee,ne,ve);if(Ne&&!me)return Ne;if(S.length>=3){const Ce=Math.min(7,S.length-1);for(let De=z+1;De<Ce;De++){const Le=I(S,De);if(Le){const Te=Q(Le,Le.toLowerCase(),z,G,ee,ne,ve);Te&&(Te[0]-=3,(!Ne||Te[0]>Ne[0])&&(Ne=Te))}}}return Ne}function I(S,F){if(F+1>=S.length)return;const z=S[F],G=S[F+1];if(z!==G)return S.slice(0,F)+G+z+S.slice(F+2)}}),define($e[49],we([1,0,12]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oi=t.$Ni=t.$Mi=t.$Li=t.$Ki=t.$Ji=t.$Ii=void 0;function T(m){return i(m,0)}t.$Ii=T;function i(m,n){switch(typeof m){case"object":return m===null?H(349,n):Array.isArray(m)?c(m,n):d(m,n);case"string":return D(m,n);case"boolean":return w(m,n);case"number":return H(m,n);case"undefined":return H(937,n);default:return H(617,n)}}t.$Ji=i;function H(m,n){return(n<<5)-n+m|0}t.$Ki=H;function w(m,n){return H(m?433:863,n)}function D(m,n){n=H(149417,n);for(let r=0,b=m.length;r<b;r++)n=H(m.charCodeAt(r),n);return n}t.$Li=D;function c(m,n){return n=H(104579,n),m.reduce((r,b)=>i(b,r),n)}function d(m,n){return n=H(181387,n),Object.keys(m).sort().reduce((r,b)=>(r=D(b,r),i(m[b],r)),n)}class f{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$Mi=f;var R;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function s(m,n,r=32){const b=r-n,u=~((1<<b)-1);return(m<<n|(u&m)>>>b)>>>0}function a(m,n=0,r=m.byteLength,b=0){for(let u=0;u<r;u++)m[n+u]=b}function e(m,n,r="0"){for(;m.length<n;)m=r+m;return m}function h(m,n=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),n/4)}t.$Ni=h;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const r=n.length;if(r===0)return;const b=this.p;let u=this.r,o=this.u,N,j;for(o!==0?(N=o,j=-1,o=0):(N=n.charCodeAt(0),j=0);;){let L=N;if(v.$9e(N))if(j+1<r){const g=n.charCodeAt(j+1);v.$0e(g)?(j++,L=v.$$e(N,g)):L=65533}else{o=N;break}else v.$0e(N)&&(L=65533);if(u=this.w(b,u,L),j++,j<r)N=n.charCodeAt(j);else break}this.r=u,this.u=o}w(n,r,b){return b<128?n[r++]=b:b<2048?(n[r++]=192|(b&1984)>>>6,n[r++]=128|(b&63)>>>0):b<65536?(n[r++]=224|(b&61440)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0):(n[r++]=240|(b&1835008)>>>18,n[r++]=128|(b&258048)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=l.g,r=this.q;for(let B=0;B<64;B+=4)n.setUint32(B,r.getUint32(B,!1),!1);for(let B=64;B<320;B+=4)n.setUint32(B,s(n.getUint32(B-12,!1)^n.getUint32(B-32,!1)^n.getUint32(B-56,!1)^n.getUint32(B-64,!1),1),!1);let b=this.h,u=this.l,o=this.m,N=this.n,j=this.o,L,g,y;for(let B=0;B<80;B++)B<20?(L=u&o|~u&N,g=1518500249):B<40?(L=u^o^N,g=1859775393):B<60?(L=u&o|u&N|o&N,g=2400959708):(L=u^o^N,g=3395469782),y=s(b,5)+L+j+g+n.getUint32(B*4,!1)&4294967295,j=N,N=o,o=s(u,30),u=b,b=y;this.h=this.h+b&4294967295,this.l=this.l+u&4294967295,this.m=this.m+o&4294967295,this.n=this.n+N&4294967295,this.o=this.o+j&4294967295}}t.$Oi=l}),define($e[86],we([1,0,75,49]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fs=t.$Es=t.$Ds=void 0;class i{constructor(s){this.a=s}getElements(){const s=this.a,a=new Int32Array(s.length);for(let e=0,h=s.length;e<h;e++)a[e]=s.charCodeAt(e);return a}}t.$Ds=i;function H(R,s,a){return new f(new i(R),new i(s)).ComputeDiff(a).changes}t.$Es=H;class w{static Assert(s,a){if(!s)throw new Error(a)}}class D{static Copy(s,a,e,h,l){for(let m=0;m<l;m++)e[h+m]=s[a+m]}static Copy2(s,a,e,h,l){for(let m=0;m<l;m++)e[h+m]=s[a+m]}}var c;(function(R){R[R.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class d{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.$Cs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(s,a,e=null){this.a=e,this.b=s,this.c=a;const[h,l,m]=f.o(s),[n,r,b]=f.o(a);this.d=m&&b,this.e=h,this.f=l,this.g=n,this.h=r,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const a=s.getElements();if(f.n(a)){const e=new Int32Array(a.length);for(let h=0,l=a.length;h<l;h++)e[h]=(0,T.$Li)(a[h],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(s,a){return this.f[s]!==this.h[a]?!1:this.d?this.e[s]===this.g[a]:!0}q(s,a){if(!this.p(s,a))return!1;const e=f.r(this.b,s),h=f.r(this.c,a);return e===h}static r(s,a){return typeof s.getStrictElement=="function"?s.getStrictElement(a):null}s(s,a){return this.f[s]!==this.f[a]?!1:this.d?this.e[s]===this.e[a]:!0}u(s,a){return this.h[s]!==this.h[a]?!1:this.d?this.g[s]===this.g[a]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,a,e,h,l){const m=[!1];let n=this.w(s,a,e,h,m);return l&&(n=this.z(n)),{quitEarly:m[0],changes:n}}w(s,a,e,h,l){for(l[0]=!1;s<=a&&e<=h&&this.p(s,e);)s++,e++;for(;a>=s&&h>=e&&this.p(a,h);)a--,h--;if(s>a||e>h){let o;return e<=h?(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),o=[new v.$Cs(s,0,e,h-e+1)]):s<=a?(w.Assert(e===h+1,"modifiedStart should only be one more than modifiedEnd"),o=[new v.$Cs(s,a-s+1,e,0)]):(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),w.Assert(e===h+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const m=[0],n=[0],r=this.y(s,a,e,h,m,n,l),b=m[0],u=n[0];if(r!==null)return r;if(!l[0]){const o=this.w(s,b,e,u,l);let N=[];return l[0]?N=[new v.$Cs(b+1,a-(b+1)+1,u+1,h-(u+1)+1)]:N=this.w(b+1,a,u+1,h,l),this.H(o,N)}return[new v.$Cs(s,a-s+1,e,h-e+1)]}x(s,a,e,h,l,m,n,r,b,u,o,N,j,L,g,y,B,q){let x=null,P=null,O=new d,K=a,te=e,se=j[0]-y[0]-h,fe=-1073741824,le=this.k.length-1;do{const oe=se+s;oe===K||oe<te&&b[oe-1]<b[oe+1]?(o=b[oe+1],L=o-se-h,o<fe&&O.MarkNextChange(),fe=o,O.AddModifiedElement(o+1,L),se=oe+1-s):(o=b[oe-1]+1,L=o-se-h,o<fe&&O.MarkNextChange(),fe=o-1,O.AddOriginalElement(o,L+1),se=oe-1-s),le>=0&&(b=this.k[le],s=b[0],K=1,te=b.length-1)}while(--le>=-1);if(x=O.getReverseChanges(),q[0]){let oe=j[0]+1,be=y[0]+1;if(x!==null&&x.length>0){const Se=x[x.length-1];oe=Math.max(oe,Se.getOriginalEnd()),be=Math.max(be,Se.getModifiedEnd())}P=[new v.$Cs(oe,N-oe+1,be,g-be+1)]}else{O=new d,K=m,te=n,se=j[0]-y[0]-r,fe=1073741824,le=B?this.m.length-1:this.m.length-2;do{const oe=se+l;oe===K||oe<te&&u[oe-1]>=u[oe+1]?(o=u[oe+1]-1,L=o-se-r,o>fe&&O.MarkNextChange(),fe=o+1,O.AddOriginalElement(o+1,L+1),se=oe+1-l):(o=u[oe-1],L=o-se-r,o>fe&&O.MarkNextChange(),fe=o,O.AddModifiedElement(o+1,L+1),se=oe-1-l),le>=0&&(u=this.m[le],l=u[0],K=1,te=u.length-1)}while(--le>=-1);P=O.getChanges()}return this.H(x,P)}y(s,a,e,h,l,m,n){let r=0,b=0,u=0,o=0,N=0,j=0;s--,e--,l[0]=0,m[0]=0,this.k=[],this.m=[];const L=a-s+(h-e),g=L+1,y=new Int32Array(g),B=new Int32Array(g),q=h-e,x=a-s,P=s-e,O=a-h,te=(x-q)%2===0;y[q]=s,B[x]=a,n[0]=!1;for(let se=1;se<=L/2+1;se++){let fe=0,le=0;u=this.J(q-se,se,q,g),o=this.J(q+se,se,q,g);for(let be=u;be<=o;be+=2){be===u||be<o&&y[be-1]<y[be+1]?r=y[be+1]:r=y[be-1]+1,b=r-(be-q)-P;const Se=r;for(;r<a&&b<h&&this.p(r+1,b+1);)r++,b++;if(y[be]=r,r+b>fe+le&&(fe=r,le=b),!te&&Math.abs(be-x)<=se-1&&r>=B[be])return l[0]=r,m[0]=b,Se<=B[be]&&1447>0&&se<=1447+1?this.x(q,u,o,P,x,N,j,O,y,B,r,a,l,b,h,m,te,n):null}const oe=(fe-s+(le-e)-se)/2;if(this.a!==null&&!this.a(fe,oe))return n[0]=!0,l[0]=fe,m[0]=le,oe>0&&1447>0&&se<=1447+1?this.x(q,u,o,P,x,N,j,O,y,B,r,a,l,b,h,m,te,n):(s++,e++,[new v.$Cs(s,a-s+1,e,h-e+1)]);N=this.J(x-se,se,x,g),j=this.J(x+se,se,x,g);for(let be=N;be<=j;be+=2){be===N||be<j&&B[be-1]>=B[be+1]?r=B[be+1]-1:r=B[be-1],b=r-(be-x)-O;const Se=r;for(;r>s&&b>e&&this.p(r,b);)r--,b--;if(B[be]=r,te&&Math.abs(be-q)<=se&&r<=y[be])return l[0]=r,m[0]=b,Se>=y[be]&&1447>0&&se<=1447+1?this.x(q,u,o,P,x,N,j,O,y,B,r,a,l,b,h,m,te,n):null}if(se<=1447){let be=new Int32Array(o-u+2);be[0]=q-u+1,D.Copy2(y,u,be,1,o-u+1),this.k.push(be),be=new Int32Array(j-N+2),be[0]=x-N+1,D.Copy2(B,N,be,1,j-N+1),this.m.push(be)}}return this.x(q,u,o,P,x,N,j,O,y,B,r,a,l,b,h,m,te,n)}z(s){for(let a=0;a<s.length;a++){const e=s[a],h=a<s.length-1?s[a+1].originalStart:this.f.length,l=a<s.length-1?s[a+1].modifiedStart:this.h.length,m=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<h&&e.modifiedStart+e.modifiedLength<l&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const r=[null];if(a<s.length-1&&this.I(s[a],s[a+1],r)){s[a]=r[0],s.splice(a+1,1),a--;continue}}for(let a=s.length-1;a>=0;a--){const e=s[a];let h=0,l=0;if(a>0){const o=s[a-1];h=o.originalStart+o.originalLength,l=o.modifiedStart+o.modifiedLength}const m=e.originalLength>0,n=e.modifiedLength>0;let r=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const N=e.originalStart-o,j=e.modifiedStart-o;if(N<h||j<l||m&&!this.s(N,N+e.originalLength)||n&&!this.u(j,j+e.modifiedLength))break;const g=(N===h&&j===l?5:0)+this.G(N,e.originalLength,j,e.modifiedLength);g>b&&(b=g,r=o)}e.originalStart-=r,e.modifiedStart-=r;const u=[null];if(a>0&&this.I(s[a-1],s[a],u)){s[a-1]=u[0],s.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=s.length;a<e;a++){const h=s[a-1],l=s[a],m=l.originalStart-h.originalStart-h.originalLength,n=h.originalStart,r=l.originalStart+l.originalLength,b=r-n,u=h.modifiedStart,o=l.modifiedStart+l.modifiedLength,N=o-u;if(m<5&&b<20&&N<20){const j=this.A(n,b,u,N,m);if(j){const[L,g]=j;(L!==h.originalStart+h.originalLength||g!==h.modifiedStart+h.modifiedLength)&&(h.originalLength=L-h.originalStart,h.modifiedLength=g-h.modifiedStart,l.originalStart=L+m,l.modifiedStart=g+m,l.originalLength=r-l.originalStart,l.modifiedLength=o-l.modifiedStart)}}}return s}A(s,a,e,h,l){if(a<l||h<l)return null;const m=s+a-l+1,n=e+h-l+1;let r=0,b=0,u=0;for(let o=s;o<m;o++)for(let N=e;N<n;N++){const j=this.B(o,N,l);j>0&&j>r&&(r=j,b=o,u=N)}return r>0?[b,u]:null}B(s,a,e){let h=0;for(let l=0;l<e;l++){if(!this.p(s+l,a+l))return 0;h+=this.e[s+l].length}return h}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,a){if(this.C(s)||this.C(s-1))return!0;if(a>0){const e=s+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,a){if(this.E(s)||this.E(s-1))return!0;if(a>0){const e=s+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,a,e,h){const l=this.D(s,a)?1:0,m=this.F(e,h)?1:0;return l+m}H(s,a){const e=[];if(s.length===0||a.length===0)return a.length>0?a:s;if(this.I(s[s.length-1],a[0],e)){const h=new Array(s.length+a.length-1);return D.Copy(s,0,h,0,s.length-1),h[s.length-1]=e[0],D.Copy(a,1,h,s.length,a.length-1),h}else{const h=new Array(s.length+a.length);return D.Copy(s,0,h,0,s.length),D.Copy(a,0,h,s.length,a.length),h}}I(s,a,e){if(w.Assert(s.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),w.Assert(s.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=a.originalStart||s.modifiedStart+s.modifiedLength>=a.modifiedStart){const h=s.originalStart;let l=s.originalLength;const m=s.modifiedStart;let n=s.modifiedLength;return s.originalStart+s.originalLength>=a.originalStart&&(l=a.originalStart+a.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=a.modifiedStart&&(n=a.modifiedStart+a.modifiedLength-s.modifiedStart),e[0]=new v.$Cs(h,l,m,n),!0}else return e[0]=null,!1}J(s,a,e,h){if(s>=0&&s<h)return s;const l=e,m=h-e-1,n=a%2===0;if(s<0){const r=l%2===0;return n===r?0:1}else{const r=m%2===0;return n===r?h-1:h-2}}}t.$Fs=f}),define($e[50],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nd=void 0,t.$Nd=Symbol("MicrotaskDelay")}),define($e[87],we([1,0,11,12]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1h=t.$Zh=t.$Yh=t.$Xh=t.$Wh=void 0;class i{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),h=this.b.charCodeAt(this.c);return e-h}value(){return this.b[this.c]}}t.$Wh=i;class H{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,T.$Ye)(a,this.b,0,a.length,this.c,this.d):(0,T.$1e)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Xh=H;class w{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const h=this.b.charCodeAt(e);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,T.$Ye)(a,this.b,0,a.length,this.d,this.e):(0,T.$1e)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Yh=w;var D;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(D||(D={}));class c{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new w(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,T.$Ze)(a,this.c.scheme);if(this.d[this.e]===2)return(0,T.$Ze)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,T.$Xe)(a,this.c.query);if(this.d[this.e]===5)return(0,T.$Xe)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Zh=c;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(f||(f={}));class R{static forUris(a=()=>!1,e=()=>!1){return new R(new c(a,e))}static forPaths(a=!1){return new R(new w(void 0,!a))}static forStrings(){return new R(new i)}static forConfigKeys(){return new R(new H)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const h=e.slice(0);(0,v.$Wb)(h);for(const l of h)this.set(l,a)}else{const h=a.slice(0);(0,v.$Wb)(h);for(const l of h)this.set(l[0],l[1])}}set(a,e){const h=this.b.reset(a);let l;this.c||(this.c=new d,this.c.segment=h.value());const m=[];for(l=this.c;;){const r=h.cmp(l.segment);if(r>0)l.left||(l.left=new d,l.left.segment=h.value()),m.push([-1,l]),l=l.left;else if(r<0)l.right||(l.right=new d,l.right.segment=h.value()),m.push([1,l]),l=l.right;else if(h.hasNext())h.next(),l.mid||(l.mid=new d,l.mid.segment=h.value()),m.push([0,l]),l=l.mid;else break}const n=l.value;l.value=e,l.key=a;for(let r=m.length-1;r>=0;r--){const b=m[r][1];b.updateHeight();const u=b.balanceFactor();if(u<-1||u>1){const o=m[r][0],N=m[r+1][0];if(o===1&&N===1)m[r][1]=b.rotateLeft();else if(o===-1&&N===-1)m[r][1]=b.rotateRight();else if(o===1&&N===-1)b.right=m[r+1][1]=m[r+1][1].rotateRight(),m[r][1]=b.rotateLeft();else if(o===-1&&N===1)b.left=m[r+1][1]=m[r+1][1].rotateLeft(),m[r][1]=b.rotateRight();else throw new Error;if(r>0)switch(m[r-1][0]){case-1:m[r-1][1].left=m[r][1];break;case 1:m[r-1][1].right=m[r][1];break;case 0:m[r-1][1].mid=m[r][1];break}else this.c=m[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let h=this.c;for(;h;){const l=e.cmp(h.segment);if(l>0)h=h.left;else if(l<0)h=h.right;else if(e.hasNext())e.next(),h=h.mid;else break}return h}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const h=this.b.reset(a),l=[];let m=this.c;for(;m;){const n=h.cmp(m.segment);if(n>0)l.push([-1,m]),m=m.left;else if(n<0)l.push([1,m]),m=m.right;else if(h.hasNext())h.next(),l.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:r,value:b,segment:u}=n;this.e(n.key,!1),m.key=r,m.value=b,m.segment=u}}else{const n=m.left??m.right;if(l.length>0){const[r,b]=l[l.length-1];switch(r){case-1:b.left=n;break;case 0:b.mid=n;break;case 1:b.right=n;break}}else this.c=n}for(let n=l.length-1;n>=0;n--){const r=l[n][1];r.updateHeight();const b=r.balanceFactor();if(b>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),l[n][1]=r.rotateLeft()):b<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),l[n][1]=r.rotateRight()),n>0)switch(l[n-1][0]){case-1:l[n-1][1].left=l[n][1];break;case 1:l[n-1][1].right=l[n][1];break;case 0:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let h=this.c,l;for(;h;){const m=e.cmp(h.segment);if(m>0)h=h.left;else if(m<0)h=h.right;else if(e.hasNext())e.next(),l=h.value||l,h=h.mid;else break}return h&&h.value||l}findSuperstr(a){return this.g(a,!1)}g(a,e){const h=this.b.reset(a);let l=this.c;for(;l;){const m=h.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(h.hasNext())h.next(),l=l.mid;else return l.mid?this.h(l.mid):e?l.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,h]of this)a(h,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const h=e.balanceFactor();return h<-1||h>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$1h=R}),define($e[7],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=void 0;function v(u){return typeof u=="string"}t.$Bf=v;function T(u){return Array.isArray(u)&&u.every(o=>v(o))}t.$Cf=T;function i(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$Df=i;function H(u){const o=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof o}t.$Ef=H;function w(u){return typeof u=="number"&&!isNaN(u)}t.$Ff=w;function D(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Gf=D;function c(u){return u===!0||u===!1}t.$Hf=c;function d(u){return typeof u>"u"}t.$If=d;function f(u){return!R(u)}t.$Jf=f;function R(u){return d(u)||u===null}t.$Kf=R;function s(u,o){if(!u)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.$Lf=s;function a(u){if(R(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$Mf=a;function e(...u){const o=[];for(let N=0;N<u.length;N++){const j=u[N];if(R(j))throw new Error(`Assertion Failed: argument at index ${N} is undefined or null`);o.push(j)}return o}t.$Nf=e;const h=Object.prototype.hasOwnProperty;function l(u){if(!i(u))return!1;for(const o in u)if(h.call(u,o))return!1;return!0}t.$Of=l;function m(u){return typeof u=="function"}t.$Pf=m;function n(...u){return u.length>0&&u.every(m)}t.$Qf=n;function r(u,o){const N=Math.min(u.length,o.length);for(let j=0;j<N;j++)b(u[j],o[j])}t.$Rf=r;function b(u,o){if(v(o)){if(typeof u!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(m(o)){try{if(u instanceof o)return}catch{}if(!R(u)&&u.constructor===o||o.length===1&&o.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Sf=b}),define($e[18],we([1,0,7]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zj=t.$Yj=t.$Xj=void 0;const T=Object.create(null);function i(D,c){if((0,v.$Bf)(c)){const d=T[c];if(d===void 0)throw new Error(`${D} references an unknown codicon: ${c}`);c=d}return T[D]=c,{id:D}}function H(){return T}t.$Xj=H;function w(){return Object.values(t.$Zj)}t.$Yj=w,t.$Zj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),thumbsDownFilled:i("thumbsdown-filled",60435),thumbsUpFilled:i("thumbsup-filled",60436),coffee:i("coffee",60437),snake:i("snake",60438),game:i("game",60439),vr:i("vr",60440),chip:i("chip",60441),piano:i("piano",60442),music:i("music",60443),micFilled:i("mic-filled",60444),gitFetch:i("git-fetch",60445),copilot:i("copilot",60446),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define($e[51],we([1,0,7]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kn=t.$jn=t.$in=t.$hn=t.$gn=t.$fn=t.$en=t.$dn=t.$cn=t.$bn=t.$an=t.$_m=void 0;function T(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([r,b])=>{n[r]=b&&typeof b=="object"?T(b):b}),n}t.$_m=T;function i(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const r=n.shift();Object.freeze(r);for(const b in r)if(H.call(r,b)){const u=r[b];typeof u=="object"&&!Object.isFrozen(u)&&!(0,v.$Ef)(u)&&n.push(u)}}return m}t.$an=i;const H=Object.prototype.hasOwnProperty;function w(m,n){return D(m,n,new Set)}t.$bn=w;function D(m,n,r){if((0,v.$Kf)(m))return m;const b=n(m);if(typeof b<"u")return b;if(Array.isArray(m)){const u=[];for(const o of m)u.push(D(o,n,r));return u}if((0,v.$Df)(m)){if(r.has(m))throw new Error("Cannot clone recursive data-structure");r.add(m);const u={};for(const o in m)H.call(m,o)&&(u[o]=D(m[o],n,r));return r.delete(m),u}return m}function c(m,n,r=!0){return(0,v.$Df)(m)?((0,v.$Df)(n)&&Object.keys(n).forEach(b=>{b in m?r&&((0,v.$Df)(m[b])&&(0,v.$Df)(n[b])?c(m[b],n[b],r):m[b]=n[b]):m[b]=n[b]}),m):n}t.$cn=c;function d(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let r,b;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(r=0;r<m.length;r++)if(!d(m[r],n[r]))return!1}else{const u=[];for(b in m)u.push(b);u.sort();const o=[];for(b in n)o.push(b);if(o.sort(),!d(u,o))return!1;for(r=0;r<u.length;r++)if(!d(m[u[r]],n[u[r]]))return!1}return!0}t.$dn=d;function f(m){const n=new Set;return JSON.stringify(m,(r,b)=>{if((0,v.$Df)(b)||Array.isArray(b)){if(n.has(b))return"[Circular]";n.add(b)}return b})}t.$en=f;function R(m,n){const r=Object.create(null);return!m||!n||Object.keys(n).forEach(u=>{const o=m[u],N=n[u];d(o,N)||(r[u]=N)}),r}t.$fn=R;function s(m,n){const r=n.toLowerCase(),b=Object.keys(m).find(u=>u.toLowerCase()===r);return b?m[b]:m[n]}t.$gn=s;function a(m,n){const r=Object.create(null);for(const[b,u]of Object.entries(m))n(b,u)&&(r[b]=u);return r}t.$hn=a;function e(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}t.$in=e;function h(m){const n=[];for(const r of e(m))typeof m[r]=="function"&&n.push(r);return n}t.$jn=h;function l(m,n){const r=u=>function(){const o=Array.prototype.slice.call(arguments,0);return n(u,o)},b={};for(const u of m)b[u]=r(u);return b}t.$kn=l}),define($e[19],we([1,0,18]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$1j=t.ThemeColor=void 0;var T;(function(w){function D(c){return c&&typeof c=="object"&&typeof c.id=="string"}w.isThemeColor=D})(T||(t.ThemeColor=T={}));function i(w){return{id:w}}t.$1j=i;var H;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function c(n){const r=D.exec(n.id);if(!r)return c(v.$Zj.error);const[,b,u]=r,o=["codicon","codicon-"+b];return u&&o.push("codicon-modifier-"+u.substring(1)),o}w.asClassNameArray=c;function d(n){return c(n).join(" ")}w.asClassName=d;function f(n){return"."+c(n).join(".")}w.asCSSSelector=f;function R(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}w.isThemeIcon=R;const s=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function a(n){const r=s.exec(n);if(!r)return;const[,b]=r;return{id:b}}w.fromString=a;function e(n){return{id:n}}w.fromId=e;function h(n,r){let b=n.id;const u=b.lastIndexOf("~");return u!==-1&&(b=b.substring(0,u)),r&&(b=`${b}~${r}`),{id:b}}w.modify=h;function l(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}w.getModifier=l;function m(n,r){return n.id===r.id&&n.color?.id===r.color?.id}w.isEqual=m})(H||(t.ThemeIcon=H={}))}),define($e[35],we([1,0,34,12,19]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7j=t.$6j=t.$5j=t.$4j=t.$3j=t.$2j=void 0;const H="$(",w=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(`(\\\\)?${w.source}`,"g");function c(m){return m.replace(D,(n,r)=>r?n:`\\${n}`)}t.$2j=c;const d=new RegExp(`\\\\${w.source}`,"g");function f(m){return m.replace(d,n=>`\\${n}`)}t.$3j=f;const R=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function s(m){return m.indexOf(H)===-1?m:m.replace(R,(n,r,b,u)=>b?n:r||u||"")}t.$4j=s;function a(m){return m?m.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}t.$5j=a;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(m){e.lastIndex=0;let n="";const r=[];let b=0;for(;;){const u=e.lastIndex,o=e.exec(m),N=m.substring(u,o?.index);if(N.length>0){n+=N;for(let j=0;j<N.length;j++)r.push(b)}if(!o)break;b+=o[0].length}return{text:n,iconOffsets:r}}t.$6j=h;function l(m,n,r=!1){const{text:b,iconOffsets:u}=n;if(!u||u.length===0)return(0,v.$Oj)(m,b,r);const o=(0,T.$Me)(b," "),N=b.length-o.length,j=(0,v.$Oj)(m,o,r);if(j)for(const L of j){const g=u[L.start+N]+N;L.start+=g,L.end+=g}return j}t.$7j=l}),define($e[88],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TT=t.$ST=void 0,t.$ST="vscode:contextmenu",t.$TT="vscode:onCloseContextMenu"}),define($e[89],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1T=void 0;class v{constructor(i,H){this.a=i,this.onMessage=H}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$1T=v}),define($e[30],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$R=t.$Q=t.$P=t.$O=t.$N=void 0;const v=globalThis.vscode;t.$N=v.ipcRenderer,t.$O=v.ipcMessagePort,t.$P=v.webFrame,t.$Q=v.process,t.$R=v.context}),define($e[90],we([1,0,88,30]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WT=void 0;let i=0;function H(D,c,d){const f=[],R=i++,s=`vscode:onContextMenu${R}`,a=(e,h,l)=>{f[h].click?.(l)};T.$N.once(s,a),T.$N.once(v.$TT,(e,h)=>{h===R&&(T.$N.removeListener(s,a),d?.())}),T.$N.send(v.$ST,R,D.map(e=>w(e,f)),s,c)}t.$WT=H;function w(D,c){const d={id:c.length,label:D.label,type:D.type,accelerator:D.accelerator,checked:D.checked,enabled:typeof D.enabled=="boolean"?D.enabled:!0,visible:typeof D.visible=="boolean"?D.visible:!0};return c.push(D),Array.isArray(D.submenu)&&(d.submenu=D.submenu.map(f=>w(f,c))),d}}),define($e[52],we([8]),{}),define($e[91],we([8]),{}),define($e[92],we([8]),{}),define($e[93],we([8]),{}),define($e[94],we([1,0,92,93]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define($e[95],we([8]),{}),define($e[96],we([8]),{}),define($e[97],we([8]),{}),define($e[98],we([8]),{}),define($e[99],we([8]),{}),define($e[100],we([8]),{}),define($e[101],we([8]),{}),define($e[102],we([8]),{}),define($e[103],we([8]),{}),define($e[104],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define($e[105],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/findinput/findInput",t)}),define($e[106],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define($e[107],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define($e[108],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/inputbox/inputBox",t)}),define($e[109],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define($e[110],we([13,10]),function(ae,t){return ae.create("vs/base/browser/ui/tree/abstractTree",t)}),define($e[111],we([13,10]),function(ae,t){return ae.create("vs/base/common/actions",t)}),define($e[36],we([1,0,4,2,111]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ei=t.$Di=t.$Ci=t.$Bi=t.$Ai=t.$zi=void 0;class H extends T.$Rc{constructor(s,a="",e="",h=!0,l){super(),this.h=this.B(new v.$Qd),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=a,this.u=e,this.w=h,this.C=l}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,a){this.C&&await this.C(s)}}t.$zi=H;class w extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new v.$Qd),this.onWillRun=this.f.event,this.m=this.B(new v.$Qd),this.onDidRun=this.m.event}async run(s,a){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,a)}catch(h){e=h}this.m.fire({action:s,error:e})}async u(s,a){await s.run(a)}}t.$Ai=w;class D{constructor(){this.id=D.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let a=[];for(const e of s)e.length&&(a.length?a=[...a,new D,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$Bi=D;class c{get actions(){return this.a}constructor(s,a,e,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=a,this.class=h,this.a=e}async run(){}}t.$Ci=c;class d extends H{static{this.ID="vs.actions.empty"}constructor(){super(d.ID,i.localize(0,null),void 0,!1)}}t.$Di=d;function f(R){return{id:R.id,label:R.label,class:void 0,enabled:R.enabled??!0,checked:R.checked??!1,run:async(...s)=>R.run(...s),tooltip:R.label}}t.$Ei=f}),define($e[112],we([13,10]),function(ae,t){return ae.create("vs/base/common/platform",t)}),define($e[5],we([1,0,112]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let T=!1,i=!1,H=!1,w=!1,D=!1,c=!1,d=!1,f=!1,R=!1,s=!1,a,e=t.$g,h=t.$g,l,m;const n=globalThis;let r;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?r=n.vscode.process:typeof process<"u"&&(r=process);const b=typeof r?.versions?.electron=="string",u=b&&r?.type==="renderer";if(typeof navigator=="object"&&!u)m=navigator.userAgent,T=m.indexOf("Windows")>=0,i=m.indexOf("Macintosh")>=0,f=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=m.indexOf("Linux")>=0,s=m?.indexOf("Mobi")>=0,c=!0,a=v.getConfiguredDefaultLocale(v.localize(0,null))||t.$g,e=a,h=navigator.language;else if(typeof r=="object"){T=r.platform==="win32",i=r.platform==="darwin",H=r.platform==="linux",w=H&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,d=b,R=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$g,e=t.$g;const x=r.env.VSCODE_NLS_CONFIG;if(x)try{const P=JSON.parse(x),O=P.availableLanguages["*"];a=P.locale,h=P.osLocale,e=O||t.$g,l=P._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var o;(function(x){x[x.Web=0]="Web",x[x.Mac=1]="Mac",x[x.Linux=2]="Linux",x[x.Windows=3]="Windows"})(o||(t.Platform=o={}));function N(x){switch(x){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=N;let j=0;i?j=1:T?j=3:H&&(j=2),t.$i=T,t.$j=i,t.$k=H,t.$l=w,t.$m=D,t.$n=d,t.$o=c,t.$p=c&&typeof n.importScripts=="function",t.$q=t.$p?n.origin:void 0,t.$r=f,t.$s=s,t.$t=R,t.$u=j,t.$v=m,t.$w=e;var L;(function(x){function P(){return t.$w}x.value=P;function O(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}x.isDefaultVariant=O;function K(){return t.$w==="en"}x.isDefault=K})(L||(t.Language=L={})),t.$x=a,t.$y=h,t.$z=l,t.$A=typeof n.postMessage=="function"&&!n.importScripts,t.$B=(()=>{if(t.$A){const x=[];n.addEventListener("message",O=>{if(O.data&&O.data.vscodeScheduleAsyncWork)for(let K=0,te=x.length;K<te;K++){const se=x[K];if(se.id===O.data.vscodeScheduleAsyncWork){x.splice(K,1),se.callback();return}}});let P=0;return O=>{const K=++P;x.push({id:K,callback:O}),n.postMessage({vscodeScheduleAsyncWork:K},"*")}}return x=>setTimeout(x)})();var g;(function(x){x[x.Windows=1]="Windows",x[x.Macintosh=2]="Macintosh",x[x.Linux=3]="Linux"})(g||(t.OperatingSystem=g={})),t.OS=i||f?2:T?1:3;let y=!0,B=!1;function q(){if(!B){B=!0;const x=new Uint8Array(2);x[0]=1,x[1]=2,y=new Uint16Array(x.buffer)[0]===(2<<8)+1}return y}t.$D=q,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define($e[113],we([1,0,17,16,5]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RO=t.KeyboardSupport=void 0;var H;(function(w){w[w.Always=0]="Always",w[w.FullScreen=1]="FullScreen",w[w.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$RO={clipboard:{writeText:i.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.$m||v.$PO()?0:navigator.keyboard||v.$LO?1:2)(),touch:"ontouchstart"in T.$wO||navigator.maxTouchPoints>0,pointerEvents:T.$wO.PointerEvent&&("ontouchstart"in T.$wO||navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define($e[14],we([1,0,17,44,78,5]),function(ae,t,v,T,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZO=t.$YO=t.$XO=void 0;function w(e){if(e.charCode){const l=String.fromCharCode(e.charCode).toUpperCase();return T.KeyCodeUtils.fromString(l)}const h=e.keyCode;if(h===3)return 7;if(v.$IO)switch(h){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(v.$JO){if(H.$j&&h===93)return 57;if(!H.$j&&h===92)return 57}return T.$Fq[h]||0}const D=H.$j?256:2048,c=512,d=1024,f=H.$j?2048:256;function R(e){const h=[];return e.ctrlKey&&h.push("ctrl"),e.shiftKey&&h.push("shift"),e.altKey&&h.push("alt"),e.metaKey&&h.push("meta"),`modifiers: [${h.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$XO=R;function s(e){const h=[];return e.ctrlKey&&h.push("ctrl"),e.shiftKey&&h.push("shift"),e.altKey&&h.push("alt"),e.metaKey&&h.push("meta"),`modifiers: [${h.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${T.KeyCodeUtils.toString(e.keyCode)}')`}t.$YO=s;class a{constructor(h){this._standardKeyboardEventBrand=!0;const l=h;this.browserEvent=l,this.target=l.target,this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,this.altGraphKey=l.getModifierState("AltGraph"),this.keyCode=w(l),this.code=l.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(h){return this.a===h}c(){let h=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(h=this.keyCode);let l=0;return this.ctrlKey&&(l|=D),this.altKey&&(l|=c),this.shiftKey&&(l|=d),this.metaKey&&(l|=f),l|=h,l}d(){let h=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(h=this.keyCode),new i.$Nq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,h)}}t.$ZO=a}),define($e[20],we([1,0,17,69,16,5]),function(ae,t,v,T,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WO=t.$VO=t.$UO=void 0;class w{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=f.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const R=T.$SO.getPositionOfChildWindowRelativeToAncestorWindow(i.$window,f.view);this.posx-=R.left,this.posy-=R.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$UO=w;class D extends w{constructor(f){super(f),this.dataTransfer=f.dataTransfer}}t.$VO=D;class c{constructor(f,R=0,s=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=s,this.deltaX=R,f){const a=f,e=f;if(typeof a.wheelDeltaY<"u")this.deltaY=a.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(f.type==="wheel"){const h=f;h.deltaMode===h.DOM_DELTA_LINE?v.$IO&&!H.$j?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof a.wheelDeltaX<"u")v.$LO&&H.$i?this.deltaX=-(a.wheelDeltaX/120):this.deltaX=a.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const h=f;h.deltaMode===h.DOM_DELTA_LINE?v.$IO&&!H.$j?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$WO=c}),define($e[114],we([1,0,5]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let T;const i=globalThis.vscode;if(typeof i<"u"&&typeof i.process<"u"){const H=i.process;T={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return v.$i?"win32":v.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=T.cwd,t.env=T.env,t.$cc=T.platform,t.$dc=T.arch}),define($e[23],we([1,0,114]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const T=65,i=97,H=90,w=122,D=46,c=47,d=92,f=58,R=63;class s extends Error{constructor(N,j,L){let g;typeof j=="string"&&j.indexOf("not ")===0?(g="must not be",j=j.replace(/^not /,"")):g="must be";const y=N.indexOf(".")!==-1?"property":"argument";let B=`The "${N}" ${y} ${g} of type ${j}`;B+=`. Received type ${typeof L}`,super(B),this.code="ERR_INVALID_ARG_TYPE"}}function a(o,N){if(o===null||typeof o!="object")throw new s(N,"Object",o)}function e(o,N){if(typeof o!="string")throw new s(N,"string",o)}const h=v.$cc==="win32";function l(o){return o===c||o===d}function m(o){return o===c}function n(o){return o>=T&&o<=H||o>=i&&o<=w}function r(o,N,j,L){let g="",y=0,B=-1,q=0,x=0;for(let P=0;P<=o.length;++P){if(P<o.length)x=o.charCodeAt(P);else{if(L(x))break;x=c}if(L(x)){if(!(B===P-1||q===1))if(q===2){if(g.length<2||y!==2||g.charCodeAt(g.length-1)!==D||g.charCodeAt(g.length-2)!==D){if(g.length>2){const O=g.lastIndexOf(j);O===-1?(g="",y=0):(g=g.slice(0,O),y=g.length-1-g.lastIndexOf(j)),B=P,q=0;continue}else if(g.length!==0){g="",y=0,B=P,q=0;continue}}N&&(g+=g.length>0?`${j}..`:"..",y=2)}else g.length>0?g+=`${j}${o.slice(B+1,P)}`:g=o.slice(B+1,P),y=P-B-1;B=P,q=0}else x===D&&q!==-1?++q:q=-1}return g}function b(o,N){a(N,"pathObject");const j=N.dir||N.root,L=N.base||`${N.name||""}${N.ext||""}`;return j?j===N.root?`${j}${L}`:`${j}${o}${L}`:L}t.$ec={resolve(...o){let N="",j="",L=!1;for(let g=o.length-1;g>=-1;g--){let y;if(g>=0){if(y=o[g],e(y,"path"),y.length===0)continue}else N.length===0?y=v.cwd():(y=v.env[`=${N}`]||v.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==N.toLowerCase()&&y.charCodeAt(2)===d)&&(y=`${N}\\`));const B=y.length;let q=0,x="",P=!1;const O=y.charCodeAt(0);if(B===1)l(O)&&(q=1,P=!0);else if(l(O))if(P=!0,l(y.charCodeAt(1))){let K=2,te=K;for(;K<B&&!l(y.charCodeAt(K));)K++;if(K<B&&K!==te){const se=y.slice(te,K);for(te=K;K<B&&l(y.charCodeAt(K));)K++;if(K<B&&K!==te){for(te=K;K<B&&!l(y.charCodeAt(K));)K++;(K===B||K!==te)&&(x=`\\\\${se}\\${y.slice(te,K)}`,q=K)}}}else q=1;else n(O)&&y.charCodeAt(1)===f&&(x=y.slice(0,2),q=2,B>2&&l(y.charCodeAt(2))&&(P=!0,q=3));if(x.length>0)if(N.length>0){if(x.toLowerCase()!==N.toLowerCase())continue}else N=x;if(L){if(N.length>0)break}else if(j=`${y.slice(q)}\\${j}`,L=P,P&&N.length>0)break}return j=r(j,!L,"\\",l),L?`${N}\\${j}`:`${N}${j}`||"."},normalize(o){e(o,"path");const N=o.length;if(N===0)return".";let j=0,L,g=!1;const y=o.charCodeAt(0);if(N===1)return m(y)?"\\":o;if(l(y))if(g=!0,l(o.charCodeAt(1))){let q=2,x=q;for(;q<N&&!l(o.charCodeAt(q));)q++;if(q<N&&q!==x){const P=o.slice(x,q);for(x=q;q<N&&l(o.charCodeAt(q));)q++;if(q<N&&q!==x){for(x=q;q<N&&!l(o.charCodeAt(q));)q++;if(q===N)return`\\\\${P}\\${o.slice(x)}\\`;q!==x&&(L=`\\\\${P}\\${o.slice(x,q)}`,j=q)}}}else j=1;else n(y)&&o.charCodeAt(1)===f&&(L=o.slice(0,2),j=2,N>2&&l(o.charCodeAt(2))&&(g=!0,j=3));let B=j<N?r(o.slice(j),!g,"\\",l):"";return B.length===0&&!g&&(B="."),B.length>0&&l(o.charCodeAt(N-1))&&(B+="\\"),L===void 0?g?`\\${B}`:B:g?`${L}\\${B}`:`${L}${B}`},isAbsolute(o){e(o,"path");const N=o.length;if(N===0)return!1;const j=o.charCodeAt(0);return l(j)||N>2&&n(j)&&o.charCodeAt(1)===f&&l(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let N,j;for(let y=0;y<o.length;++y){const B=o[y];e(B,"path"),B.length>0&&(N===void 0?N=j=B:N+=`\\${B}`)}if(N===void 0)return".";let L=!0,g=0;if(typeof j=="string"&&l(j.charCodeAt(0))){++g;const y=j.length;y>1&&l(j.charCodeAt(1))&&(++g,y>2&&(l(j.charCodeAt(2))?++g:L=!1))}if(L){for(;g<N.length&&l(N.charCodeAt(g));)g++;g>=2&&(N=`\\${N.slice(g)}`)}return t.$ec.normalize(N)},relative(o,N){if(e(o,"from"),e(N,"to"),o===N)return"";const j=t.$ec.resolve(o),L=t.$ec.resolve(N);if(j===L||(o=j.toLowerCase(),N=L.toLowerCase(),o===N))return"";let g=0;for(;g<o.length&&o.charCodeAt(g)===d;)g++;let y=o.length;for(;y-1>g&&o.charCodeAt(y-1)===d;)y--;const B=y-g;let q=0;for(;q<N.length&&N.charCodeAt(q)===d;)q++;let x=N.length;for(;x-1>q&&N.charCodeAt(x-1)===d;)x--;const P=x-q,O=B<P?B:P;let K=-1,te=0;for(;te<O;te++){const fe=o.charCodeAt(g+te);if(fe!==N.charCodeAt(q+te))break;fe===d&&(K=te)}if(te!==O){if(K===-1)return L}else{if(P>O){if(N.charCodeAt(q+te)===d)return L.slice(q+te+1);if(te===2)return L.slice(q+te)}B>O&&(o.charCodeAt(g+te)===d?K=te:te===2&&(K=3)),K===-1&&(K=0)}let se="";for(te=g+K+1;te<=y;++te)(te===y||o.charCodeAt(te)===d)&&(se+=se.length===0?"..":"\\..");return q+=K,se.length>0?`${se}${L.slice(q,x)}`:(L.charCodeAt(q)===d&&++q,L.slice(q,x))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const N=t.$ec.resolve(o);if(N.length<=2)return o;if(N.charCodeAt(0)===d){if(N.charCodeAt(1)===d){const j=N.charCodeAt(2);if(j!==R&&j!==D)return`\\\\?\\UNC\\${N.slice(2)}`}}else if(n(N.charCodeAt(0))&&N.charCodeAt(1)===f&&N.charCodeAt(2)===d)return`\\\\?\\${N}`;return o},dirname(o){e(o,"path");const N=o.length;if(N===0)return".";let j=-1,L=0;const g=o.charCodeAt(0);if(N===1)return l(g)?o:".";if(l(g)){if(j=L=1,l(o.charCodeAt(1))){let q=2,x=q;for(;q<N&&!l(o.charCodeAt(q));)q++;if(q<N&&q!==x){for(x=q;q<N&&l(o.charCodeAt(q));)q++;if(q<N&&q!==x){for(x=q;q<N&&!l(o.charCodeAt(q));)q++;if(q===N)return o;q!==x&&(j=L=q+1)}}}}else n(g)&&o.charCodeAt(1)===f&&(j=N>2&&l(o.charCodeAt(2))?3:2,L=j);let y=-1,B=!0;for(let q=N-1;q>=L;--q)if(l(o.charCodeAt(q))){if(!B){y=q;break}}else B=!1;if(y===-1){if(j===-1)return".";y=j}return o.slice(0,y)},basename(o,N){N!==void 0&&e(N,"ext"),e(o,"path");let j=0,L=-1,g=!0,y;if(o.length>=2&&n(o.charCodeAt(0))&&o.charCodeAt(1)===f&&(j=2),N!==void 0&&N.length>0&&N.length<=o.length){if(N===o)return"";let B=N.length-1,q=-1;for(y=o.length-1;y>=j;--y){const x=o.charCodeAt(y);if(l(x)){if(!g){j=y+1;break}}else q===-1&&(g=!1,q=y+1),B>=0&&(x===N.charCodeAt(B)?--B===-1&&(L=y):(B=-1,L=q))}return j===L?L=q:L===-1&&(L=o.length),o.slice(j,L)}for(y=o.length-1;y>=j;--y)if(l(o.charCodeAt(y))){if(!g){j=y+1;break}}else L===-1&&(g=!1,L=y+1);return L===-1?"":o.slice(j,L)},extname(o){e(o,"path");let N=0,j=-1,L=0,g=-1,y=!0,B=0;o.length>=2&&o.charCodeAt(1)===f&&n(o.charCodeAt(0))&&(N=L=2);for(let q=o.length-1;q>=N;--q){const x=o.charCodeAt(q);if(l(x)){if(!y){L=q+1;break}continue}g===-1&&(y=!1,g=q+1),x===D?j===-1?j=q:B!==1&&(B=1):j!==-1&&(B=-1)}return j===-1||g===-1||B===0||B===1&&j===g-1&&j===L+1?"":o.slice(j,g)},format:b.bind(null,"\\"),parse(o){e(o,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return N;const j=o.length;let L=0,g=o.charCodeAt(0);if(j===1)return l(g)?(N.root=N.dir=o,N):(N.base=N.name=o,N);if(l(g)){if(L=1,l(o.charCodeAt(1))){let K=2,te=K;for(;K<j&&!l(o.charCodeAt(K));)K++;if(K<j&&K!==te){for(te=K;K<j&&l(o.charCodeAt(K));)K++;if(K<j&&K!==te){for(te=K;K<j&&!l(o.charCodeAt(K));)K++;K===j?L=K:K!==te&&(L=K+1)}}}}else if(n(g)&&o.charCodeAt(1)===f){if(j<=2)return N.root=N.dir=o,N;if(L=2,l(o.charCodeAt(2))){if(j===3)return N.root=N.dir=o,N;L=3}}L>0&&(N.root=o.slice(0,L));let y=-1,B=L,q=-1,x=!0,P=o.length-1,O=0;for(;P>=L;--P){if(g=o.charCodeAt(P),l(g)){if(!x){B=P+1;break}continue}q===-1&&(x=!1,q=P+1),g===D?y===-1?y=P:O!==1&&(O=1):y!==-1&&(O=-1)}return q!==-1&&(y===-1||O===0||O===1&&y===q-1&&y===B+1?N.base=N.name=o.slice(B,q):(N.name=o.slice(B,y),N.base=o.slice(B,q),N.ext=o.slice(y,q))),B>0&&B!==L?N.dir=o.slice(0,B-1):N.dir=N.root,N},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(h){const o=/\\/g;return()=>{const N=v.cwd().replace(o,"/");return N.slice(N.indexOf("/"))}}return()=>v.cwd()})();t.$fc={resolve(...o){let N="",j=!1;for(let L=o.length-1;L>=-1&&!j;L--){const g=L>=0?o[L]:u();e(g,"path"),g.length!==0&&(N=`${g}/${N}`,j=g.charCodeAt(0)===c)}return N=r(N,!j,"/",m),j?`/${N}`:N.length>0?N:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const N=o.charCodeAt(0)===c,j=o.charCodeAt(o.length-1)===c;return o=r(o,!N,"/",m),o.length===0?N?"/":j?"./":".":(j&&(o+="/"),N?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===c},join(...o){if(o.length===0)return".";let N;for(let j=0;j<o.length;++j){const L=o[j];e(L,"path"),L.length>0&&(N===void 0?N=L:N+=`/${L}`)}return N===void 0?".":t.$fc.normalize(N)},relative(o,N){if(e(o,"from"),e(N,"to"),o===N||(o=t.$fc.resolve(o),N=t.$fc.resolve(N),o===N))return"";const j=1,L=o.length,g=L-j,y=1,B=N.length-y,q=g<B?g:B;let x=-1,P=0;for(;P<q;P++){const K=o.charCodeAt(j+P);if(K!==N.charCodeAt(y+P))break;K===c&&(x=P)}if(P===q)if(B>q){if(N.charCodeAt(y+P)===c)return N.slice(y+P+1);if(P===0)return N.slice(y+P)}else g>q&&(o.charCodeAt(j+P)===c?x=P:P===0&&(x=0));let O="";for(P=j+x+1;P<=L;++P)(P===L||o.charCodeAt(P)===c)&&(O+=O.length===0?"..":"/..");return`${O}${N.slice(y+x)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const N=o.charCodeAt(0)===c;let j=-1,L=!0;for(let g=o.length-1;g>=1;--g)if(o.charCodeAt(g)===c){if(!L){j=g;break}}else L=!1;return j===-1?N?"/":".":N&&j===1?"//":o.slice(0,j)},basename(o,N){N!==void 0&&e(N,"ext"),e(o,"path");let j=0,L=-1,g=!0,y;if(N!==void 0&&N.length>0&&N.length<=o.length){if(N===o)return"";let B=N.length-1,q=-1;for(y=o.length-1;y>=0;--y){const x=o.charCodeAt(y);if(x===c){if(!g){j=y+1;break}}else q===-1&&(g=!1,q=y+1),B>=0&&(x===N.charCodeAt(B)?--B===-1&&(L=y):(B=-1,L=q))}return j===L?L=q:L===-1&&(L=o.length),o.slice(j,L)}for(y=o.length-1;y>=0;--y)if(o.charCodeAt(y)===c){if(!g){j=y+1;break}}else L===-1&&(g=!1,L=y+1);return L===-1?"":o.slice(j,L)},extname(o){e(o,"path");let N=-1,j=0,L=-1,g=!0,y=0;for(let B=o.length-1;B>=0;--B){const q=o.charCodeAt(B);if(q===c){if(!g){j=B+1;break}continue}L===-1&&(g=!1,L=B+1),q===D?N===-1?N=B:y!==1&&(y=1):N!==-1&&(y=-1)}return N===-1||L===-1||y===0||y===1&&N===L-1&&N===j+1?"":o.slice(N,L)},format:b.bind(null,"/"),parse(o){e(o,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return N;const j=o.charCodeAt(0)===c;let L;j?(N.root="/",L=1):L=0;let g=-1,y=0,B=-1,q=!0,x=o.length-1,P=0;for(;x>=L;--x){const O=o.charCodeAt(x);if(O===c){if(!q){y=x+1;break}continue}B===-1&&(q=!1,B=x+1),O===D?g===-1?g=x:P!==1&&(P=1):g!==-1&&(P=-1)}if(B!==-1){const O=y===0&&j?1:y;g===-1||P===0||P===1&&g===B-1&&g===y+1?N.base=N.name=o.slice(O,B):(N.name=o.slice(O,g),N.base=o.slice(O,B),N.ext=o.slice(g,B))}return y>0?N.dir=o.slice(0,y-1):j&&(N.dir="/"),N},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=h?t.$ec.normalize:t.$fc.normalize,t.$hc=h?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=h?t.$ec.join:t.$fc.join,t.$jc=h?t.$ec.resolve:t.$fc.resolve,t.$kc=h?t.$ec.relative:t.$fc.relative,t.$lc=h?t.$ec.dirname:t.$fc.dirname,t.$mc=h?t.$ec.basename:t.$fc.basename,t.$nc=h?t.$ec.extname:t.$fc.extname,t.$oc=h?t.$ec.format:t.$fc.format,t.$pc=h?t.$ec.parse:t.$fc.parse,t.$qc=h?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=h?t.$ec.sep:t.$fc.sep,t.$sc=h?t.$ec.delimiter:t.$fc.delimiter}),define($e[115],we([1,0,23,5,12,7]),function(ae,t,v,T,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=void 0;function w(y){return y===47||y===92}t.$Tf=w;function D(y){return y.replace(/[\\/]/g,v.$fc.sep)}t.$Uf=D;function c(y){return y.indexOf("/")===-1&&(y=D(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}t.$Vf=c;function d(y,B=v.$fc.sep){if(!y)return"";const q=y.length,x=y.charCodeAt(0);if(w(x)){if(w(y.charCodeAt(1))&&!w(y.charCodeAt(2))){let O=3;const K=O;for(;O<q&&!w(y.charCodeAt(O));O++);if(K!==O&&!w(y.charCodeAt(O+1))){for(O+=1;O<q;O++)if(w(y.charCodeAt(O)))return y.slice(0,O+1).replace(/[\\/]/g,B)}}return B}else if(m(x)&&y.charCodeAt(1)===58)return w(y.charCodeAt(2))?y.slice(0,2)+B:y.slice(0,2);let P=y.indexOf("://");if(P!==-1){for(P+=3;P<q;P++)if(w(y.charCodeAt(P)))return y.slice(0,P+1)}return""}t.$Wf=d;function f(y){if(!T.$i||!y||y.length<5)return!1;let B=y.charCodeAt(0);if(B!==92||(B=y.charCodeAt(1),B!==92))return!1;let q=2;const x=q;for(;q<y.length&&(B=y.charCodeAt(q),B!==92);q++);return!(x===q||(B=y.charCodeAt(q+1),isNaN(B)||B===92))}t.$Xf=f;const R=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(y,B=T.$i){const q=B?R:s;return!(!y||y.length===0||/^\s+$/.test(y)||(q.lastIndex=0,q.test(y))||B&&a.test(y)||y==="."||y===".."||B&&y[y.length-1]==="."||B&&y.length!==y.trim().length||y.length>255)}t.$Yf=e;function h(y,B,q){const x=y===B;return!q||x?x:!y||!B?!1:(0,i.$5e)(y,B)}t.$Zf=h;function l(y,B,q,x=v.sep){if(y===B)return!0;if(!y||!B||B.length>y.length)return!1;if(q){if(!(0,i.$6e)(y,B))return!1;if(B.length===y.length)return!0;let O=B.length;return B.charAt(B.length-1)===x&&O--,y.charAt(O)===x}return B.charAt(B.length-1)!==x&&(B+=x),y.indexOf(B)===0}t.$1f=l;function m(y){return y>=65&&y<=90||y>=97&&y<=122}t.$2f=m;function n(y,B){return T.$i&&y.endsWith(":")&&(y+=v.sep),(0,v.$hc)(y)||(y=(0,v.$ic)(B,y)),y=(0,v.$gc)(y),T.$i?(y=(0,i.$Ne)(y,v.sep),y.endsWith(":")&&(y+=v.sep)):(y=(0,i.$Ne)(y,v.sep),y||(y=v.sep)),y}t.$3f=n;function r(y){const B=(0,v.$gc)(y);return T.$i?y.length>3?!1:b(B)&&(y.length===2||B.charCodeAt(2)===92):B===v.$fc.sep}t.$4f=r;function b(y,B=T.$i){return B?m(y.charCodeAt(0))&&y.charCodeAt(1)===58:!1}t.$5f=b;function u(y,B=T.$i){return b(y,B)?y[0]:void 0}t.$6f=u;function o(y,B,q){return B.length>y.length?-1:y===B?0:(q&&(y=y.toLowerCase(),B=B.toLowerCase()),y.indexOf(B))}t.$7f=o;function N(y){const B=y.split(":");let q,x,P;for(const O of B){const K=Number(O);(0,H.$Ff)(K)?x===void 0?x=K:P===void 0&&(P=K):q=q?[q,O].join(":"):O}if(!q)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:q,line:x!==void 0?x:void 0,column:P!==void 0?P:x!==void 0?1:void 0}}t.$8f=N;const j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function g(y,B,q=8){let x="";for(let O=0;O<q;O++){let K;O===0&&T.$i&&!B&&(q===3||q===4)?K=L:K=j,x+=K.charAt(Math.floor(Math.random()*K.length))}let P;return B?P=`${B}-${x}`:P=x,y?(0,v.$ic)(y,P):P}t.$9f=g}),define($e[116],we([1,0,23]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zr=t.$Yr=t.$Xr=t.$Wr=t.$Vr=void 0,t.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(f){const R=(0,v.$nc)(f),s=T[R.toLowerCase()];return s!==void 0?s:w(f)}t.$Wr=H;function w(f){const R=(0,v.$nc)(f);return i[R.toLowerCase()]}t.$Xr=w;function D(f){for(const R in i)if(i[R]===f)return R}t.$Yr=D;const c=/^(.+)\/(.+?)(;.+)?$/;function d(f,R){const s=c.exec(f);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:R?void 0:f}t.$Zr=d}),define($e[15],we([1,0,23,5]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,H=/^\//,w=/^\/\//;function D(L,g){if(!L.scheme&&g)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!i.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!H.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(L,g){return!L&&!g?"file":L}function d(L,g){switch(L){case"https":case"http":case"file":g?g[0]!==R&&(g=R+g):g=R;break}return g}const f="",R="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(g){return g instanceof a?!0:g?typeof g.authority=="string"&&typeof g.fragment=="string"&&typeof g.path=="string"&&typeof g.query=="string"&&typeof g.scheme=="string"&&typeof g.fsPath=="string"&&typeof g.with=="function"&&typeof g.toString=="function":!1}constructor(g,y,B,q,x,P=!1){typeof g=="object"?(this.scheme=g.scheme||f,this.authority=g.authority||f,this.path=g.path||f,this.query=g.query||f,this.fragment=g.fragment||f):(this.scheme=c(g,P),this.authority=y||f,this.path=d(this.scheme,B||f),this.query=q||f,this.fragment=x||f,D(this,P))}get fsPath(){return b(this,!1)}with(g){if(!g)return this;let{scheme:y,authority:B,path:q,query:x,fragment:P}=g;return y===void 0?y=this.scheme:y===null&&(y=f),B===void 0?B=this.authority:B===null&&(B=f),q===void 0?q=this.path:q===null&&(q=f),x===void 0?x=this.query:x===null&&(x=f),P===void 0?P=this.fragment:P===null&&(P=f),y===this.scheme&&B===this.authority&&q===this.path&&x===this.query&&P===this.fragment?this:new l(y,B,q,x,P)}static parse(g,y=!1){const B=s.exec(g);return B?new l(B[2]||f,j(B[4]||f),j(B[5]||f),j(B[7]||f),j(B[9]||f),y):new l(f,f,f,f,f)}static file(g){let y=f;if(T.$i&&(g=g.replace(/\\/g,R)),g[0]===R&&g[1]===R){const B=g.indexOf(R,2);B===-1?(y=g.substring(2),g=R):(y=g.substring(2,B),g=g.substring(B)||R)}return new l("file",y,g,f,f)}static from(g,y){return new l(g.scheme,g.authority,g.path,g.query,g.fragment,y)}static joinPath(g,...y){if(!g.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let B;return T.$i&&g.scheme==="file"?B=a.file(v.$ec.join(b(g,!0),...y)).path:B=v.$fc.join(g.path,...y),g.with({path:B})}toString(g=!1){return u(this,g)}toJSON(){return this}static revive(g){if(g){if(g instanceof a)return g;{const y=new l(g);return y._formatted=g.external??null,y._fsPath=g._sep===h?g.fsPath??null:null,y}}else return g}}t.URI=a;function e(L){return!L||typeof L!="object"?!1:typeof L.scheme=="string"&&(typeof L.authority=="string"||typeof L.authority>"u")&&(typeof L.path=="string"||typeof L.path>"u")&&(typeof L.query=="string"||typeof L.query>"u")&&(typeof L.fragment=="string"||typeof L.fragment>"u")}t.$uc=e;const h=T.$i?1:void 0;class l extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(g=!1){return g?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const g={$mid:1};return this._fsPath&&(g.fsPath=this._fsPath,g._sep=h),this._formatted&&(g.external=this._formatted),this.path&&(g.path=this.path),this.scheme&&(g.scheme=this.scheme),this.authority&&(g.authority=this.authority),this.query&&(g.query=this.query),this.fragment&&(g.fragment=this.fragment),g}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(L,g,y){let B,q=-1;for(let x=0;x<L.length;x++){const P=L.charCodeAt(x);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||g&&P===47||y&&P===91||y&&P===93||y&&P===58)q!==-1&&(B+=encodeURIComponent(L.substring(q,x)),q=-1),B!==void 0&&(B+=L.charAt(x));else{B===void 0&&(B=L.substr(0,x));const O=m[P];O!==void 0?(q!==-1&&(B+=encodeURIComponent(L.substring(q,x)),q=-1),B+=O):q===-1&&(q=x)}}return q!==-1&&(B+=encodeURIComponent(L.substring(q))),B!==void 0?B:L}function r(L){let g;for(let y=0;y<L.length;y++){const B=L.charCodeAt(y);B===35||B===63?(g===void 0&&(g=L.substr(0,y)),g+=m[B]):g!==void 0&&(g+=L[y])}return g!==void 0?g:L}function b(L,g){let y;return L.authority&&L.path.length>1&&L.scheme==="file"?y=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?g?y=L.path.substr(1):y=L.path[1].toLowerCase()+L.path.substr(2):y=L.path,T.$i&&(y=y.replace(/\//g,"\\")),y}t.$vc=b;function u(L,g){const y=g?r:n;let B="",{scheme:q,authority:x,path:P,query:O,fragment:K}=L;if(q&&(B+=q,B+=":"),(x||q==="file")&&(B+=R,B+=R),x){let te=x.indexOf("@");if(te!==-1){const se=x.substr(0,te);x=x.substr(te+1),te=se.lastIndexOf(":"),te===-1?B+=y(se,!1,!1):(B+=y(se.substr(0,te),!1,!1),B+=":",B+=y(se.substr(te+1),!1,!0)),B+="@"}x=x.toLowerCase(),te=x.lastIndexOf(":"),te===-1?B+=y(x,!1,!0):(B+=y(x.substr(0,te),!1,!0),B+=x.substr(te))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const te=P.charCodeAt(1);te>=65&&te<=90&&(P=`/${String.fromCharCode(te+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const te=P.charCodeAt(0);te>=65&&te<=90&&(P=`${String.fromCharCode(te+32)}:${P.substr(2)}`)}B+=y(P,!0,!1)}return O&&(B+="?",B+=y(O,!1,!1)),K&&(B+="#",B+=g?K:n(K,!1,!1)),B}function o(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+o(L.substr(3)):L}}const N=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function j(L){return L.match(N)?L.replace(N,g=>o(g)):L}}),define($e[53],we([1,0,33,15]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rh=t.$qh=t.$ph=void 0;function i(c){return JSON.stringify(c,w)}t.$ph=i;function H(c){let d=JSON.parse(c);return d=D(d),d}t.$qh=H;function w(c,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function D(c,d=0){if(!c||d>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return T.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 17:return new Date(c.source)}if(c instanceof v.$ee||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let f=0;f<c.length;++f)c[f]=D(c[f],d+1);else for(const f in c)Object.hasOwnProperty.call(c,f)&&(c[f]=D(c[f],d+1))}return c}t.$rh=D}),define($e[31],we([1,0,6,5,15]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$fg=t.$eg=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.Schemas=void 0;var H;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(H||(t.Schemas=H={})),t.$0f="vscode-tkn",t.$$f="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${H.vscodeRemoteResource}`}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f){this.f=`${f}/${H.vscodeRemoteResource}`}set(f,R,s){this.a[f]=R,this.b[f]=s}setConnectionToken(f,R){this.c[f]=R}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(l){return v.$Z(l),f}const R=f.authority;let s=this.a[R];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[R],e=this.c[R];let h=`path=${encodeURIComponent(f.path)}`;return typeof e=="string"&&(h+=`&${t.$$f}=${encodeURIComponent(e)}`),i.URI.from({scheme:T.$o?this.d:H.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:h})}}t.$_f=new w,t.$ag="vs/../../extensions",t.$bg="vs/../../node_modules",t.$cg="vs/../../node_modules.asar",t.$dg="vs/../../node_modules.asar.unpacked",t.$eg="vscode-app";class D{static{this.a=t.$eg}asBrowserUri(f){const R=this.b(f,ae);return this.uriToBrowserUri(R)}uriToBrowserUri(f){return f.scheme===H.vscodeRemote?t.$_f.rewrite(f):f.scheme===H.file&&(T.$m||T.$q===`${H.vscodeFileResource}://${D.a}`)?f.with({scheme:H.vscodeFileResource,authority:f.authority||D.a,query:null,fragment:null}):f}asFileUri(f){const R=this.b(f,ae);return this.uriToFileUri(R)}uriToFileUri(f){return f.scheme===H.vscodeFileResource?f.with({scheme:H.file,authority:f.authority!==D.a?f.authority:null,query:null,fragment:null}):f}b(f,R){return i.URI.isUri(f)?f:i.URI.parse(R.toUrl(f))}}t.$fg=new D;var c;(function(d){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(f.get("3"));const R="vscode-coi";function s(e){let h;typeof e=="string"?h=new URL(e).searchParams:e instanceof URL?h=e.searchParams:i.URI.isUri(e)&&(h=new URL(e.toString(!0)).searchParams);const l=h?.get(R);if(l)return f.get(l)}d.getHeadersFromQuery=s;function a(e,h,l){if(!globalThis.crossOriginIsolated)return;const m=h&&l?"3":l?"2":"1";e instanceof URLSearchParams?e.set(R,m):e[R]=m}d.addSearchParam=a})(c||(t.COI=c={}))}),define($e[37],we([1,0,115,31,23,5,12,15]),function(ae,t,v,T,i,H,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ig=t.DataUri=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=void 0;function c(a){return(0,D.$vc)(a,!0)}t.$mg=c;class d{constructor(e){this.a=e}compare(e,h,l=!1){return e===h?0:(0,w.$Xe)(this.getComparisonKey(e,l),this.getComparisonKey(h,l))}isEqual(e,h,l=!1){return e===h?!0:!e||!h?!1:this.getComparisonKey(e,l)===this.getComparisonKey(h,l)}getComparisonKey(e,h=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,h,l=!1){if(e.scheme===h.scheme){if(e.scheme===T.Schemas.file)return v.$1f(c(e),c(h),this.a(e))&&e.query===h.query&&(l||e.fragment===h.fragment);if((0,t.$Dg)(e.authority,h.authority))return v.$1f(e.path,h.path,this.a(e),"/")&&e.query===h.query&&(l||e.fragment===h.fragment)}return!1}joinPath(e,...h){return D.URI.joinPath(e,...h)}basenameOrAuthority(e){return(0,t.$vg)(e)||e.authority}basename(e){return i.$fc.basename(e.path)}extname(e){return i.$fc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let h;return e.scheme===T.Schemas.file?h=D.URI.file(i.$lc(c(e))).path:(h=i.$fc.dirname(e.path),e.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),h="/")),e.with({path:h})}normalizePath(e){if(!e.path.length)return e;let h;return e.scheme===T.Schemas.file?h=D.URI.file(i.$gc(c(e))).path:h=i.$fc.normalize(e.path),e.with({path:h})}relativePath(e,h){if(e.scheme!==h.scheme||!(0,t.$Dg)(e.authority,h.authority))return;if(e.scheme===T.Schemas.file){const n=i.$kc(c(e),c(h));return H.$i?v.$Uf(n):n}let l=e.path||"/";const m=h.path||"/";if(this.a(e)){let n=0;for(const r=Math.min(l.length,m.length);n<r&&!(l.charCodeAt(n)!==m.charCodeAt(n)&&l.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);l=m.substr(0,n)+l.substr(n)}return i.$fc.relative(l,m)}resolvePath(e,h){if(e.scheme===T.Schemas.file){const l=D.URI.file(i.$jc(c(e),h));return e.with({authority:l.authority,path:l.path})}return h=v.$Vf(h),e.with({path:i.$fc.resolve(e.path,h)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,h){return e===h||e!==void 0&&h!==void 0&&(0,w.$5e)(e,h)}hasTrailingPathSeparator(e,h=i.sep){if(e.scheme===T.Schemas.file){const l=c(e);return l.length>v.$Wf(l).length&&l[l.length-1]===h}else{const l=e.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,h=i.sep){return(0,t.$Eg)(e,h)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,h=i.sep){let l=!1;if(e.scheme===T.Schemas.file){const m=c(e);l=m!==void 0&&m.length===v.$Wf(m).length&&m[m.length-1]===h}else{h="/";const m=e.path;l=m.length===1&&m.charCodeAt(m.length-1)===47}return!l&&!(0,t.$Eg)(e,h)?e.with({path:e.path+"/"}):e}}t.$ng=d,t.$og=new d(()=>!1),t.$pg=new d(a=>a.scheme===T.Schemas.file?!H.$k:!0),t.$qg=new d(a=>!0),t.$rg=t.$og.isEqual.bind(t.$og),t.$sg=t.$og.isEqualOrParent.bind(t.$og),t.$tg=t.$og.getComparisonKey.bind(t.$og),t.$ug=t.$og.basenameOrAuthority.bind(t.$og),t.$vg=t.$og.basename.bind(t.$og),t.$wg=t.$og.extname.bind(t.$og),t.$xg=t.$og.dirname.bind(t.$og),t.$yg=t.$og.joinPath.bind(t.$og),t.$zg=t.$og.normalizePath.bind(t.$og),t.$Ag=t.$og.relativePath.bind(t.$og),t.$Bg=t.$og.resolvePath.bind(t.$og),t.$Cg=t.$og.isAbsolutePath.bind(t.$og),t.$Dg=t.$og.isEqualAuthority.bind(t.$og),t.$Eg=t.$og.hasTrailingPathSeparator.bind(t.$og),t.$Fg=t.$og.removeTrailingPathSeparator.bind(t.$og),t.$Gg=t.$og.addTrailingPathSeparator.bind(t.$og);function f(a,e){const h=[];for(let l=0;l<a.length;l++){const m=e(a[l]);a.some((n,r)=>r===l?!1:(0,t.$sg)(m,e(n)))||h.push(a[l])}return h}t.$Hg=f;var R;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(h){const l=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(r=>{const[b,u]=r.split(":");b&&u&&l.set(b,u)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&l.set(a.META_DATA_MIME,n),l}a.parseMetaData=e})(R||(t.DataUri=R={}));function s(a,e,h){if(e){let l=a.path;return l&&l[0]!==i.$fc.sep&&(l=i.$fc.sep+l),a.with({scheme:h,authority:e,path:l})}return a.with({scheme:h})}t.$Ig=s}),define($e[9],we([1,0,29,6,4,2,37,5,50]),function(ae,t,v,T,i,H,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lh=t.$kh=t.$jh=t.$ih=t.Promises=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=void 0;function d(Q){return!!Q&&typeof Q.then=="function"}t.$Jg=d;function f(Q){const p=new v.$1d,A=Q(p.token),E=new Promise((M,k)=>{const I=p.token.onCancellationRequested(()=>{I.dispose(),p.dispose(),k(new T.$4)});Promise.resolve(A).then(S=>{I.dispose(),p.dispose(),M(S)},S=>{I.dispose(),p.dispose(),k(S)})});return new class{cancel(){p.cancel()}then(M,k){return E.then(M,k)}catch(M){return this.then(void 0,M)}finally(M){return E.finally(M)}}}t.$Kg=f;function R(Q,p,A){return new Promise((E,M)=>{const k=p.onCancellationRequested(()=>{k.dispose(),E(A)});Q.then(E,M).finally(()=>k.dispose())})}t.$Lg=R;function s(Q,p){return new Promise((A,E)=>{const M=p.onCancellationRequested(()=>{M.dispose(),E(new T.$4)});Q.then(A,E).finally(()=>M.dispose())})}t.$Mg=s;async function a(Q){let p=-1;const A=Q.map((E,M)=>E.then(k=>(p=M,k)));try{return await Promise.race(A)}finally{Q.forEach((E,M)=>{M!==p&&E.cancel()})}}t.$Ng=a;function e(Q,p,A){let E;const M=setTimeout(()=>{E?.(void 0),A?.()},p);return Promise.race([Q.finally(()=>clearTimeout(M)),new Promise(k=>E=k)])}t.$Og=e;function h(Q){return new Promise((p,A)=>{const E=Q();d(E)?E.then(p,A):p(E)})}t.$Pg=h;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const A=()=>{if(this.b=null,this.f)return;const E=this.queue(this.d);return this.d=null,E};this.b=new Promise(E=>{this.a.then(A,A).then(E)})}return new Promise((A,E)=>{this.b.then(A,E)})}return this.a=p(),new Promise((A,E)=>{this.a.then(M=>{this.a=null,A(M)},M=>{this.a=null,E(M)})})}dispose(){this.f=!0}}t.$Qg=l;class m{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$Rg=m;class n{constructor(){this.a=new Map}queue(p,A){const M=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.a.get(p)===M&&this.a.delete(p)});return this.a.set(p,M),M}}t.$Sg=n;const r=(Q,p)=>{let A=!0;const E=setTimeout(()=>{A=!1,p()},Q);return{isTriggered:()=>A,dispose:()=>{clearTimeout(E),A=!1}}},b=Q=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,Q())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class u{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,A=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((M,k)=>{this.d=M,this.f=k}).then(()=>{if(this.b=null,this.d=null,this.g){const M=this.g;return this.g=null,M()}}));const E=()=>{this.a=null,this.d?.(null)};return this.a=A===c.$Nd?b(E):r(A,E),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Tg=u;class o{constructor(p){this.a=new u(p),this.b=new l}trigger(p,A){return this.a.trigger(()=>this.b.queue(p),A)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Ug=o;class N{constructor(){this.a=!1,this.b=new Promise((p,A)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Vg=N;class j extends N{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$Wg=j;function L(Q,p){return p?new Promise((A,E)=>{const M=setTimeout(()=>{k.dispose(),A()},Q),k=p.onCancellationRequested(()=>{clearTimeout(M),k.dispose(),E(new T.$4)})}):f(A=>L(Q,A))}t.$Xg=L;function g(Q,p=0,A){const E=setTimeout(()=>{Q(),A&&M.dispose()},p),M=(0,H.$Pc)(()=>{clearTimeout(E),A?.deleteAndLeak(M)});return A?.add(M),M}t.$Yg=g;function y(Q){const p=[];let A=0;const E=Q.length;function M(){return A<E?Q[A++]():null}function k(I){I!=null&&p.push(I);const S=M();return S?S.then(k):Promise.resolve(p)}return Promise.resolve(null).then(k)}t.$Zg=y;function B(Q,p=E=>!!E,A=null){let E=0;const M=Q.length,k=()=>{if(E>=M)return Promise.resolve(A);const I=Q[E++];return Promise.resolve(I()).then(F=>p(F)?Promise.resolve(F):k())};return k()}t.$1g=B;function q(Q,p=E=>!!E,A=null){if(Q.length===0)return Promise.resolve(A);let E=Q.length;const M=()=>{E=-1;for(const k of Q)k.cancel?.()};return new Promise((k,I)=>{for(const S of Q)S.then(F=>{--E>=0&&p(F)?(M(),k(F)):E===0&&k(A)}).catch(F=>{--E>=0&&(M(),I(F))})})}t.$2g=q;class x{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new i.$Qd}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((A,E)=>{this.f.push({factory:p,c:A,e:E}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const A=p.factory();A.then(p.c,p.e),A.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$3g=x;class P extends x{constructor(){super(1)}}t.$4g=P;class O{constructor(){this.a=new de,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$5g=O;class K{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new Z;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,A=w.$og){const E=A.getComparisonKey(p);let M=this.a.get(E);if(!M){M=new P;const k=this.f++,I=i.Event.once(M.onDrained)(()=>{M?.dispose(),this.a.delete(E),this.h(),this.d?.deleteAndDispose(k),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$Zc),this.d.set(k,I),this.a.set(E,M)}return M}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$6g=K;class te{constructor(p,A){this.a=-1,typeof p=="function"&&typeof A=="number"&&this.setIfNotSet(p,A)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,A){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},A)}setIfNotSet(p,A){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},A))}}t.$7g=te;class se{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(p,A,E=globalThis){this.cancel();const M=E.setInterval(()=>{p()},A);this.d=(0,H.$Pc)(()=>{E.clearInterval(M),this.d=void 0})}dispose(){this.cancel()}}t.$8g=se;class fe{constructor(p,A){this.b=-1,this.a=p,this.d=A,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$9g=fe;class le{constructor(p,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.a=p,this.b=A,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$0g=le;class oe extends fe{constructor(p,A){super(p,A),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$$g=oe;class be extends H.$Rc{constructor(p,A){super(),this.g=p,this.h=A,this.a=[],this.b=this.B(new H.$Sc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const A of p)this.a.push(A);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new fe(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$_g=be,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$bh=(Q,p)=>{(0,D.$B)(()=>{if(A)return;const E=Date.now()+15;p(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:t.$bh=(Q,p,A)=>{const E=Q.requestIdleCallback(p,typeof A=="number"?{timeout:A}:void 0);let M=!1;return{dispose(){M||(M=!0,Q.cancelIdleCallback(E))}}},t.$ah=Q=>(0,t.$bh)(globalThis,Q)}();class Se{constructor(p,A){this.g=!1,this.d=()=>{try{this.j=A()}catch(E){this.l=E}finally{this.g=!0}},this.f=(0,t.$bh)(p,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$ch=Se;class Ae extends Se{constructor(p){super(globalThis,p)}}t.$dh=Ae;async function Pe(Q,p,A){let E;for(let M=0;M<A;M++)try{return await Q()}catch(k){E=k,await L(p)}throw E}t.$eh=Pe;class de{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,A,E){return this.a={taskId:p,cancel:()=>E?.(),promise:A},A.then(()=>this.d(p),()=>this.d(p)),A}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let A,E;const M=new Promise((k,I)=>{A=k,E=I});this.b={run:p,promise:M,promiseResolve:A,promiseReject:E}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$fh=de;class ie{constructor(p,A=()=>Date.now()){this.d=p,this.f=A,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$gh=ie;var ce;(function(Q){Q[Q.Resolved=0]="Resolved",Q[Q.Rejected=1]="Rejected"})(ce||(ce={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,A)=>{this.a=p,this.b=A})}complete(p){return new Promise(A=>{this.a(p),this.d={outcome:0,value:p},A()})}error(p){return new Promise(A=>{this.b(p),this.d={outcome:1,value:p},A()})}cancel(){return this.error(new T.$4)}}t.$hh=Z;var W;(function(Q){async function p(E){let M;const k=await Promise.all(E.map(I=>I.then(S=>S,S=>{M||(M=S)})));if(typeof M<"u")throw M;return k}Q.settled=p;function A(E){return new Promise(async(M,k)=>{try{await E(M,k)}catch(I){k(I)}})}Q.withAsyncBody=A})(W||(t.Promises=W={}));var Y;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(Y||(Y={}));class C{static fromArray(p){return new C(A=>{A.emitMany(p)})}static fromPromise(p){return new C(async A=>{A.emitMany(await p)})}static fromPromises(p){return new C(async A=>{await Promise.all(p.map(async E=>A.emitOne(await E)))})}static merge(p){return new C(async A=>{await Promise.all(p.map(async E=>{for await(const M of E)A.emitOne(M)}))})}static{this.EMPTY=C.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new i.$Qd,queueMicrotask(async()=>{const A={emitOne:E=>this.g(E),emitMany:E=>this.h(E),reject:E=>this.k(E)};try{await Promise.resolve(p(A)),this.j()}catch(E){this.k(E)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(p,A){return new C(async E=>{for await(const M of p)E.emitOne(A(M))})}map(p){return C.map(this,p)}static filter(p,A){return new C(async E=>{for await(const M of p)A(M)&&E.emitOne(M)})}filter(p){return C.filter(this,p)}static coalesce(p){return C.filter(p,A=>!!A)}coalesce(){return C.coalesce(this)}static async toPromise(p){const A=[];for await(const E of p)A.push(E);return A}toPromise(){return C.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$ih=C;class V extends C{constructor(p,A){super(A),this.l=p}cancel(){this.l.cancel()}}t.$jh=V;function $(Q){const p=new v.$1d,A=Q(p.token);return new V(p,async E=>{const M=p.token.onCancellationRequested(()=>{M.dispose(),p.dispose(),E.reject(new T.$4)});try{for await(const k of A){if(p.token.isCancellationRequested)return;E.emitOne(k)}M.dispose(),p.dispose()}catch(k){M.dispose(),p.dispose(),E.reject(k)}})}t.$kh=$;class U{constructor(){this.a=new Z,this.b=new C(E=>{if(p){E.reject(p);return}return A&&E.emitMany(A),this.d=M=>E.reject(M),this.f=M=>E.emitOne(M),this.a.p});let p,A;this.f=E=>{A||(A=[]),A.push(E)},this.d=E=>{p||(p=E)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(p){this.d(p),this.a.complete()}emitOne(p){this.f(p)}}t.$lh=U}),define($e[3],we([1,0,17,113,14,20,9,6,4,117,2,31,5,15,49,16]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s,a,e,h){"use strict";var l;Object.defineProperty(t,"__esModule",{value:!0}),t.$vQ=t.$uQ=t.h=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.DetectedFullscreenMode=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$=t.Namespace=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.getWindowId=t.getWindowsCount=t.getWindows=t.registerWindow=void 0,l=function(){const _=new Map;typeof h.$wO.vscodeWindowId!="number"&&Object.defineProperty(h.$wO,"vscodeWindowId",{get:()=>1}),_.set(h.$wO.vscodeWindowId,{window:h.$wO,disposables:new f.$Qc});const X=new c.$Qd,re=new c.$Qd,ge=new c.$Qd;return{onDidRegisterWindow:X.event,onWillUnregisterWindow:ge.event,onDidUnregisterWindow:re.event,registerWindow(ye){if(_.has(ye.vscodeWindowId))return f.$Rc.None;const Re=new f.$Qc,je={window:ye,disposables:Re.add(new f.$Qc)};return _.set(ye.vscodeWindowId,je),Re.add((0,f.$Pc)(()=>{_.delete(ye.vscodeWindowId),re.fire(ye)})),Re.add(r(ye,t.$VP.BEFORE_UNLOAD,()=>{ge.fire(ye)})),X.fire(je),Re},getWindows(){return _.values()},getWindowsCount(){return _.size},getWindowId(ye){return ye.vscodeWindowId}}}(),t.registerWindow=l.registerWindow,t.getWindows=l.getWindows,t.getWindowsCount=l.getWindowsCount,t.getWindowId=l.getWindowId,t.onDidRegisterWindow=l.onDidRegisterWindow,t.onWillUnregisterWindow=l.onWillUnregisterWindow,t.onDidUnregisterWindow=l.onDidUnregisterWindow;function m(_){for(;_.firstChild;)_.firstChild.remove()}t.$2O=m;class n{constructor(X,re,ge,ye){this.f=X,this.g=re,this.d=ge,this.j=ye||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function r(_,X,re,ge){return new n(_,X,re,ge)}t.$3O=r;function b(_){return function(X){return _(new H.$UO(X))}}function u(_){return function(X){return _(new i.$ZO(X))}}const o=function(X,re,ge,ye){let Re=ge;return re==="click"||re==="mousedown"?Re=b(ge):(re==="keydown"||re==="keypress"||re==="keyup")&&(Re=u(ge)),r(X,re,Re,ye)};t.$4O=o;const N=function(X,re,ge){const ye=b(re);return L(X,ye,ge)};t.$5O=N;const j=function(X,re,ge){const ye=b(re);return y(X,ye,ge)};t.$6O=j;function L(_,X,re){return r(_,s.$r&&T.$RO.pointerEvents?t.$VP.POINTER_DOWN:t.$VP.MOUSE_DOWN,X,re)}t.$7O=L;function g(_,X,re){return r(_,s.$r&&T.$RO.pointerEvents?t.$VP.POINTER_MOVE:t.$VP.MOUSE_MOVE,X,re)}t.$8O=g;function y(_,X,re){return r(_,s.$r&&T.$RO.pointerEvents?t.$VP.POINTER_UP:t.$VP.MOUSE_UP,X,re)}t.$9O=y;function B(_,X,re){return(0,w.$bh)(_,X,re)}t.$0O=B;class q extends w.$ch{constructor(X,re){super(X,re)}}t.$$O=q;function x(_,X,re,ge){let ye=0;const Re=_.setInterval(()=>{ye++,(typeof ge=="number"&&ye>=ge||X()===!0)&&je.dispose()},re),je=(0,f.$Pc)(()=>{_.clearInterval(Re)});return je}t.$bP=x;class P extends w.$8g{cancelAndSet(X,re,ge){return super.cancelAndSet(X,re,ge)}}t.$cP=P;class O{constructor(X,re=0){this.d=X,this.priority=re,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(X){(0,D.$Z)(X)}}static sort(X,re){return re.priority-X.priority}}(function(){const _=new Map,X=new Map,re=new Map,ge=new Map,ye=Re=>{re.set(Re,!1);const je=_.get(Re)??[];for(X.set(Re,je),_.set(Re,[]),ge.set(Re,!0);je.length>0;)je.sort(O.sort),je.shift().execute();ge.set(Re,!1)};t.$aP=(Re,je,xe=0)=>{const Ge=(0,t.getWindowId)(Re),_e=new O(je,xe);let rt=_.get(Ge);return rt||(rt=[],_.set(Ge,rt)),rt.push(_e),re.get(Ge)||(re.set(Ge,!0),Re.requestAnimationFrame(()=>ye(Ge))),_e},t.$_O=(Re,je,xe)=>{const Ge=(0,t.getWindowId)(Re);if(ge.get(Ge)){const _e=new O(je,xe);let rt=X.get(Ge);return rt||(rt=[],X.set(Ge,rt)),rt.push(_e),_e}else return(0,t.$aP)(Re,je,xe)}})();function K(_,X){return(0,t.$aP)(_,X,1e4)}t.$dP=K;function te(_,X){return(0,t.$aP)(_,X,-1e4)}t.$eP=te;const se=8,fe=function(_,X){return X};class le extends f.$Rc{constructor(X,re,ge,ye=fe,Re=se){super();let je=null,xe=0;const Ge=this.B(new w.$7g),_e=()=>{xe=new Date().getTime(),ge(je),je=null};this.B(r(X,re,rt=>{je=ye(je,rt);const Pt=new Date().getTime()-xe;Pt>=Re?(Ge.cancel(),_e()):Ge.setIfNotSet(_e,Re-Pt)}))}}function oe(_,X,re,ge,ye){return new le(_,X,re,ge,ye)}t.$fP=oe;function be(_){return _.ownerDocument.defaultView.getComputedStyle(_,null)}t.$gP=be;function Se(_){const X=_.ownerDocument,re=X.defaultView?.window;if(_!==X.body)return new Pe(_.clientWidth,_.clientHeight);if(s.$r&&re?.visualViewport)return new Pe(re.visualViewport.width,re.visualViewport.height);if(re?.innerWidth&&re.innerHeight)return new Pe(re.innerWidth,re.innerHeight);if(X.body&&X.body.clientWidth&&X.body.clientHeight)return new Pe(X.body.clientWidth,X.body.clientHeight);if(X.documentElement&&X.documentElement.clientWidth&&X.documentElement.clientHeight)return new Pe(X.documentElement.clientWidth,X.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$hP=Se;class Ae{static d(X,re){return parseFloat(re)||0}static f(X,re,ge){const ye=be(X),Re=ye?ye.getPropertyValue(re):"0";return Ae.d(X,Re)}static getBorderLeftWidth(X){return Ae.f(X,"border-left-width","borderLeftWidth")}static getBorderRightWidth(X){return Ae.f(X,"border-right-width","borderRightWidth")}static getBorderTopWidth(X){return Ae.f(X,"border-top-width","borderTopWidth")}static getBorderBottomWidth(X){return Ae.f(X,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(X){return Ae.f(X,"padding-left","paddingLeft")}static getPaddingRight(X){return Ae.f(X,"padding-right","paddingRight")}static getPaddingTop(X){return Ae.f(X,"padding-top","paddingTop")}static getPaddingBottom(X){return Ae.f(X,"padding-bottom","paddingBottom")}static getMarginLeft(X){return Ae.f(X,"margin-left","marginLeft")}static getMarginTop(X){return Ae.f(X,"margin-top","marginTop")}static getMarginRight(X){return Ae.f(X,"margin-right","marginRight")}static getMarginBottom(X){return Ae.f(X,"margin-bottom","marginBottom")}}class Pe{static{this.None=new Pe(0,0)}constructor(X,re){this.width=X,this.height=re}with(X=this.width,re=this.height){return X!==this.width||re!==this.height?new Pe(X,re):this}static is(X){return typeof X=="object"&&typeof X.height=="number"&&typeof X.width=="number"}static lift(X){return X instanceof Pe?X:new Pe(X.width,X.height)}static equals(X,re){return X===re?!0:!X||!re?!1:X.width===re.width&&X.height===re.height}}t.$iP=Pe;function de(_){let X=_.offsetParent,re=_.offsetTop,ge=_.offsetLeft;for(;(_=_.parentNode)!==null&&_!==_.ownerDocument.body&&_!==_.ownerDocument.documentElement;){re-=_.scrollTop;const ye=z(_)?null:be(_);ye&&(ge-=ye.direction!=="rtl"?_.scrollLeft:-_.scrollLeft),_===X&&(ge+=Ae.getBorderLeftWidth(_),re+=Ae.getBorderTopWidth(_),re+=_.offsetTop,ge+=_.offsetLeft,X=_.offsetParent)}return{left:ge,top:re}}t.$jP=de;function ie(_,X,re){typeof X=="number"&&(_.style.width=`${X}px`),typeof re=="number"&&(_.style.height=`${re}px`)}t.$kP=ie;function ce(_,X,re,ge,ye,Re="absolute"){typeof X=="number"&&(_.style.top=`${X}px`),typeof re=="number"&&(_.style.right=`${re}px`),typeof ge=="number"&&(_.style.bottom=`${ge}px`),typeof ye=="number"&&(_.style.left=`${ye}px`),_.style.position=Re}t.$lP=ce;function Z(_){const X=_.getBoundingClientRect();return{left:X.left+(_.ownerDocument.defaultView?.scrollX??0),top:X.top+(_.ownerDocument.defaultView?.scrollY??0),width:X.width,height:X.height}}t.$mP=Z;function W(_){let X=_,re=1;do{const ge=be(X).zoom;ge!=null&&ge!=="1"&&(re*=ge),X=X.parentElement}while(X!==null&&X!==X.ownerDocument.documentElement);return re}t.$nP=W;function Y(_){const X=Ae.getMarginLeft(_)+Ae.getMarginRight(_);return _.offsetWidth+X}t.$oP=Y;function C(_){const X=Ae.getBorderLeftWidth(_)+Ae.getBorderRightWidth(_),re=Ae.getPaddingLeft(_)+Ae.getPaddingRight(_);return _.offsetWidth-X-re}t.$pP=C;function V(_){const X=Ae.getMarginLeft(_)+Ae.getMarginRight(_);return _.scrollWidth+X}t.$qP=V;function $(_){const X=Ae.getBorderTopWidth(_)+Ae.getBorderBottomWidth(_),re=Ae.getPaddingTop(_)+Ae.getPaddingBottom(_);return _.offsetHeight-X-re}t.$rP=$;function U(_){const X=Ae.getMarginTop(_)+Ae.getMarginBottom(_);return _.offsetHeight+X}t.$sP=U;function Q(_,X){if(_===null)return 0;const re=de(_),ge=de(X);return re.left-ge.left}function p(_,X){const re=X.map(ye=>Math.max(V(ye),Y(ye))+Q(ye,_)||0);return Math.max(...re)}t.$tP=p;function A(_,X){return!!X?.contains(_)}t.$uP=A;const E="parentFlowToElementId";function M(_,X){_.dataset[E]=X.id}t.$vP=M;function k(_){const X=_.dataset[E];return typeof X=="string"?_.ownerDocument.getElementById(X):null}function I(_,X){let re=_;for(;re;){if(re===X)return!0;if(re instanceof HTMLElement){const ge=k(re);if(ge){re=ge;continue}}re=re.parentNode}return!1}t.$wP=I;function S(_,X,re){for(;_&&_.nodeType===_.ELEMENT_NODE;){if(_.classList.contains(X))return _;if(re){if(typeof re=="string"){if(_.classList.contains(re))return null}else if(_===re)return null}_=_.parentNode}return null}t.$xP=S;function F(_,X,re){return!!S(_,X,re)}t.$yP=F;function z(_){return _&&!!_.host&&!!_.mode}t.$zP=z;function G(_){return!!ee(_)}t.$AP=G;function ee(_){for(;_.parentNode;){if(_===_.ownerDocument?.body)return null;_=_.parentNode}return z(_)?_:null}t.$BP=ee;function ne(){let _=Ce().activeElement;for(;_?.shadowRoot;)_=_.shadowRoot.activeElement;return _}t.$CP=ne;function me(_){return _.ownerDocument.activeElement===_}t.$DP=me;function ve(_){return A(_.ownerDocument.activeElement,_)}t.$EP=ve;function Ne(_){return _.ownerDocument===Ce()}t.$FP=Ne;function Ce(){return(0,t.getWindowsCount)()<=1?document:Array.from((0,t.getWindows)()).map(({window:X})=>X.document).find(X=>X.hasFocus())??document}t.$GP=Ce;function De(){return Ce().defaultView?.window??h.$wO}t.$HP=De;function Le(_){const X=_;if(X?.ownerDocument?.defaultView)return X.ownerDocument.defaultView.window;const re=_;return re?.view?re.view.window:h.$wO}t.$IP=Le;function Te(_){const X=Le(_);X!==De()&&X.focus()}t.$JP=Te;const We=new Map;function He(_){return We.has(_)}t.$KP=He;function Me(_=h.$wO.document.head,X,re){const ge=document.createElement("style");if(ge.type="text/css",ge.media="screen",X?.(ge),_.appendChild(ge),re&&re.add((0,f.$Pc)(()=>_.removeChild(ge))),_===h.$wO.document.head){const ye=new Set;We.set(ge,ye);for(const{window:Re,disposables:je}of(0,t.getWindows)()){if(Re===h.$wO)continue;const xe=je.add(J(ge,ye,Re));re?.add(xe)}}return ge}t.$LP=Me;function Ye(_){const X=new f.$Qc;for(const[re,ge]of We)X.add(J(re,ge,_));return X}t.$MP=Ye;function J(_,X,re){const ge=new f.$Qc,ye=_.cloneNode(!0);re.document.head.appendChild(ye),ge.add((0,f.$Pc)(()=>re.document.head.removeChild(ye)));for(const Re of Fe(_))ye.sheet?.insertRule(Re.cssText,ye.sheet?.cssRules.length);return ge.add(t.$NP.observe(_,ge,{childList:!0})(()=>{ye.textContent=_.textContent})),X.add(ye),ge.add((0,f.$Pc)(()=>X.delete(ye))),ge}t.$NP=new class{constructor(){this.mutationObservers=new Map}observe(_,X,re){let ge=this.mutationObservers.get(_);ge||(ge=new Map,this.mutationObservers.set(_,ge));const ye=(0,e.$Ii)(re);let Re=ge.get(ye);if(Re)Re.users+=1;else{const je=new c.$Qd,xe=new MutationObserver(_e=>je.fire(_e));xe.observe(_,re);const Ge=Re={users:1,observer:xe,onDidMutate:je.event};X.add((0,f.$Pc)(()=>{Ge.users-=1,Ge.users===0&&(je.dispose(),xe.disconnect(),ge?.delete(ye),ge?.size===0&&this.mutationObservers.delete(_))})),ge.set(ye,Re)}return Re.onDidMutate}};function he(_=h.$wO.document.head){const X=document.createElement("meta");return _.appendChild(X),X}t.$OP=he;let pe=null;function Ee(){return pe||(pe=Me()),pe}function Fe(_){return _?.sheet?.rules?_.sheet.rules:_?.sheet?.cssRules?_.sheet.cssRules:[]}function Be(_,X,re=Ee()){if(!(!re||!X)){re.sheet?.insertRule(`${_} {${X}}`,0);for(const ge of We.get(re)??[])Be(_,X,ge)}}t.$PP=Be;function Ue(_,X=Ee()){if(!X)return;const re=Fe(X),ge=[];for(let ye=0;ye<re.length;ye++){const Re=re[ye];Ze(Re)&&Re.selectorText.indexOf(_)!==-1&&ge.push(ye)}for(let ye=ge.length-1;ye>=0;ye--)X.sheet?.deleteRule(ge[ye]);for(const ye of We.get(X)??[])Ue(_,ye)}t.$QP=Ue;function Ze(_){return typeof _.selectorText=="string"}function Je(_){return _ instanceof MouseEvent||_ instanceof Le(_).MouseEvent}t.$RP=Je;function Ke(_){return _ instanceof KeyboardEvent||_ instanceof Le(_).KeyboardEvent}t.$SP=Ke;function qe(_){return _ instanceof PointerEvent||_ instanceof Le(_).PointerEvent}t.$TP=qe;function tt(_){return _ instanceof DragEvent||_ instanceof Le(_).DragEvent}t.$UP=tt,t.$VP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.$JO?"webkitAnimationStart":"animationstart",ANIMATION_END:v.$JO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.$JO?"webkitAnimationIteration":"animationiteration"};function nt(_){const X=_;return!!(X&&typeof X.preventDefault=="function"&&typeof X.stopPropagation=="function")}t.$WP=nt,t.$XP={stop:(_,X)=>(_.preventDefault(),X&&_.stopPropagation(),_)};function dt(_){const X=[];for(let re=0;_&&_.nodeType===_.ELEMENT_NODE;re++)X[re]=_.scrollTop,_=_.parentNode;return X}t.$YP=dt;function ft(_,X){for(let re=0;_&&_.nodeType===_.ELEMENT_NODE;re++)_.scrollTop!==X[re]&&(_.scrollTop=X[re]),_=_.parentNode}t.$ZP=ft;class ot extends f.$Rc{static m(X){if(X instanceof HTMLElement){const re=ee(X),ge=re?re.activeElement:X.ownerDocument.activeElement;return A(ge,X)}else{const re=X;return A(re.document.activeElement,re.document)}}constructor(X){super(),this.f=this.B(new c.$Qd),this.onDidFocus=this.f.event,this.g=this.B(new c.$Qd),this.onDidBlur=this.g.event;let re=ot.m(X),ge=!1;const ye=()=>{ge=!1,re||(re=!0,this.f.fire())},Re=()=>{re&&(ge=!0,(X instanceof HTMLElement?Le(X):X).setTimeout(()=>{ge&&(ge=!1,re=!1,this.g.fire())},0))};this.j=()=>{ot.m(X)!==re&&(re?Re():ye())},this.B(r(X,t.$VP.FOCUS,ye,!0)),this.B(r(X,t.$VP.BLUR,Re,!0)),X instanceof HTMLElement&&(this.B(r(X,t.$VP.FOCUS_IN,()=>this.j())),this.B(r(X,t.$VP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function At(_){return new ot(_)}t.$1P=At;function kt(_,X){return _.after(X),X}t.$2P=kt;function pt(_,...X){if(_.append(...X),X.length===1&&typeof X[0]!="string")return X[0]}t.$3P=pt;function Ct(_,X){return _.insertBefore(X,_.firstChild),X}t.$4P=Ct;function Mt(_,...X){_.innerText="",pt(_,...X)}t.$5P=Mt;const Ie=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var ue;(function(_){_.HTML="http://www.w3.org/1999/xhtml",_.SVG="http://www.w3.org/2000/svg"})(ue||(t.Namespace=ue={}));function ke(_,X,re,...ge){const ye=Ie.exec(X);if(!ye)throw new Error("Bad use of emmet");const Re=ye[1]||"div";let je;return _!==ue.HTML?je=document.createElementNS(_,Re):je=document.createElement(Re),ye[3]&&(je.id=ye[3]),ye[4]&&(je.className=ye[4].replace(/\./g," ").trim()),re&&Object.entries(re).forEach(([xe,Ge])=>{typeof Ge>"u"||(/^on\w+$/.test(xe)?je[xe]=Ge:xe==="selected"?Ge&&je.setAttribute(xe,"true"):je.setAttribute(xe,Ge))}),je.append(...ge),je}function Oe(_,X,...re){return ke(ue.HTML,_,X,...re)}t.$=Oe,Oe.SVG=function(_,X,...re){return ke(ue.SVG,_,X,...re)};function Ve(_,X){const re=[];return _.forEach((ge,ye)=>{ye>0&&(X instanceof Node?re.push(X.cloneNode()):re.push(document.createTextNode(X))),re.push(ge)}),re}t.$7P=Ve;function et(_,...X){_?st(...X):Qe(...X)}t.$8P=et;function st(..._){for(const X of _)X.style.display="",X.removeAttribute("aria-hidden")}t.$9P=st;function Qe(..._){for(const X of _)X.style.display="none",X.setAttribute("aria-hidden","true")}t.$0P=Qe;function ht(_,X){for(;_&&_.nodeType===_.ELEMENT_NODE;){if(_ instanceof HTMLElement&&_.hasAttribute(X))return _;_=_.parentNode}return null}function wt(_){!_||!_.hasAttribute("tabIndex")||(_.ownerDocument.activeElement===_&&ht(_.parentElement,"tabIndex")?.focus(),_.removeAttribute("tabindex"))}t.$$P=wt;function St(_){return X=>{X.preventDefault(),X.stopPropagation(),_(X)}}t.$_P=St;function Gt(_){return new Promise(X=>{if(_.document.readyState==="complete"||_.document&&_.document.body!==null)X(void 0);else{const ge=()=>{_.window.removeEventListener("DOMContentLoaded",ge,!1),X()};_.window.addEventListener("DOMContentLoaded",ge,!1)}})}t.$aQ=Gt;function Ai(_,X){const re=_.devicePixelRatio*X;return Math.max(1,Math.floor(re))/_.devicePixelRatio}t.$bQ=Ai;function ki(_){h.$wO.open(_,"_blank","noopener")}t.$cQ=ki;const Xt=780,Yt=640;function Ci(_){const X=Math.floor(h.$wO.screenLeft+h.$wO.innerWidth/2-Xt/2),re=Math.floor(h.$wO.screenTop+h.$wO.innerHeight/2-Yt/2);h.$wO.open(_,"_blank",`width=${Xt},height=${Yt},top=${re},left=${X}`)}t.$dQ=Ci;function Si(_,X=!0){const re=h.$wO.open();return re?(X&&(re.opener=null),re.location.href=_,!0):!1}t.$eQ=Si;function Pi(_,X){const re=()=>{X(),ge=(0,t.$aP)(_,re)};let ge=(0,t.$aP)(_,re);return(0,f.$Pc)(()=>ge.dispose())}t.$fQ=Pi,R.$_f.setPreferredWebSchema(/^https:/.test(h.$wO.location.href)?"https":"http");function Fi(_){return _?`url('${R.$fg.uriToBrowserUri(_).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$gQ=Fi;function Ni(_){return`'${_.replace(/'/g,"%27")}'`}t.$hQ=Ni;function Zt(_,X){if(_!==void 0){const re=_.match(/^\s*var\((.+)\)$/);if(re){const ge=re[1].split(",",2);return ge.length===2&&(X=Zt(ge[1].trim(),X)),`var(${ge[0]}, ${X})`}return _}return X}t.$iQ=Zt;function Oi(_,X){let re;if(a.URI.isUri(_))re=_.toString(!0);else{const Re=new Blob([_]);re=URL.createObjectURL(Re),setTimeout(()=>URL.revokeObjectURL(re))}const ge=De(),ye=document.createElement("a");ge.document.body.appendChild(ye),ye.download=X,ye.href=re,ye.click(),setTimeout(()=>ge.document.body.removeChild(ye))}t.$jQ=Oi;function Ti(){return new Promise(_=>{const X=De(),re=document.createElement("input");X.document.body.appendChild(re),re.type="file",re.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(re,"input"))(()=>{_(re.files??void 0)}),re.click(),setTimeout(()=>X.document.body.removeChild(re))})}t.$kQ=Ti;var vt;(function(_){_[_.DOCUMENT=1]="DOCUMENT",_[_.BROWSER=2]="BROWSER"})(vt||(t.DetectedFullscreenMode=vt={}));function Li(_){return _.document.fullscreenElement||_.document.webkitFullscreenElement||_.document.webkitIsFullScreen?{mode:vt.DOCUMENT,guess:!1}:_.innerHeight===_.screen.height?{mode:vt.BROWSER,guess:!1}:(s.$j||s.$k)&&_.outerHeight===_.screen.height&&_.outerWidth===_.screen.width?{mode:vt.BROWSER,guess:!0}:null}t.$lQ=Li;function Jt(_,X=!1){const re=document.createElement("a");return d.addHook("afterSanitizeAttributes",ge=>{for(const ye of["href","src"])if(ge.hasAttribute(ye)){const Re=ge.getAttribute(ye);if(ye==="href"&&Re.startsWith("#"))continue;if(re.href=Re,!_.includes(re.protocol.replace(/:$/,""))){if(X&&ye==="src"&&re.href.startsWith("data:"))continue;ge.removeAttribute(ye)}}}),(0,f.$Pc)(()=>{d.removeHook("afterSanitizeAttributes")})}t.$mQ=Jt;const Ri=[R.Schemas.http,R.Schemas.https,R.Schemas.command];t.$nQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Ii=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Mi(_,X){const re=Jt(Ri);try{const ge=d.sanitize(X,Ii);_.innerHTML=ge}finally{re.dispose()}}t.$oQ=Mi;function Bi(_){const X=new Uint16Array(_.length);for(let ye=0;ye<X.length;ye++)X[ye]=_.charCodeAt(ye);let re="";const ge=new Uint8Array(X.buffer);for(let ye=0;ye<ge.length;ye++)re+=String.fromCharCode(ge[ye]);return re}function ji(_){return btoa(Bi(_))}t.$pQ=ji;class mt extends c.$Qd{constructor(){super(),this.o=new f.$Qc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(c.Event.runAndSubscribe(t.onDidRegisterWindow,({window:X,disposables:re})=>this.B(X,re),{window:h.$wO,disposables:this.o}))}B(X,re){re.add(r(X,"keydown",ge=>{if(ge.defaultPrevented)return;const ye=new i.$ZO(ge);if(!(ye.keyCode===6&&ge.repeat)){if(ge.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(ge.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(ge.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(ge.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ye.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=ge.altKey,this.s.ctrlKey=ge.ctrlKey,this.s.metaKey=ge.metaKey,this.s.shiftKey=ge.shiftKey,this.s.lastKeyPressed&&(this.s.event=ge,this.fire(this.s))}},!0)),re.add(r(X,"keyup",ge=>{ge.defaultPrevented||(!ge.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!ge.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!ge.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!ge.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=ge.altKey,this.s.ctrlKey=ge.ctrlKey,this.s.metaKey=ge.metaKey,this.s.shiftKey=ge.shiftKey,this.s.lastKeyReleased&&(this.s.event=ge,this.fire(this.s)))},!0)),re.add(r(X.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),re.add(r(X.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),re.add(r(X.document.body,"mousemove",ge=>{ge.buttons&&(this.s.lastKeyPressed=void 0)},!0)),re.add(r(X,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return mt.A||(mt.A=new mt),mt.A}dispose(){super.dispose(),this.o.dispose()}}t.$qQ=mt;function zi(_){const X=document.cookie.match("(^|[^;]+)\\s*"+_+"\\s*=\\s*([^;]+)");return X?X.pop():void 0}t.$rQ=zi;class Hi extends f.$Rc{constructor(X,re){super(),this.j=X,this.m=re,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(r(this.j,t.$VP.DRAG_START,X=>{this.m.onDragStart?.(X)})),this.m.onDrag&&this.B(r(this.j,t.$VP.DRAG,X=>{this.m.onDrag?.(X)})),this.B(r(this.j,t.$VP.DRAG_ENTER,X=>{this.f++,this.g=X.timeStamp,this.m.onDragEnter?.(X)})),this.B(r(this.j,t.$VP.DRAG_OVER,X=>{X.preventDefault(),this.m.onDragOver?.(X,X.timeStamp-this.g)})),this.B(r(this.j,t.$VP.DRAG_LEAVE,X=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(X))})),this.B(r(this.j,t.$VP.DRAG_END,X=>{this.f=0,this.g=0,this.m.onDragEnd?.(X)})),this.B(r(this.j,t.$VP.DROP,X=>{this.f=0,this.g=0,this.m.onDrop?.(X)}))}}t.$sQ=Hi;const Ui=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Wi(_,...X){let re,ge;Array.isArray(X[0])?(re={},ge=X[0]):(re=X[0]||{},ge=X[1]);const ye=Ui.exec(_);if(!ye||!ye.groups)throw new Error("Bad use of h");const Re=ye.groups.tag||"div",je=document.createElement(Re);ye.groups.id&&(je.id=ye.groups.id);const xe=[];if(ye.groups.class)for(const _e of ye.groups.class.split("."))_e!==""&&xe.push(_e);if(re.className!==void 0)for(const _e of re.className.split("."))_e!==""&&xe.push(_e);xe.length>0&&(je.className=xe.join(" "));const Ge={};if(ye.groups.name&&(Ge[ye.groups.name]=je),ge)for(const _e of ge)_e instanceof HTMLElement?je.appendChild(_e):typeof _e=="string"?je.append(_e):"root"in _e&&(Object.assign(Ge,_e),je.appendChild(_e.root));for(const[_e,rt]of Object.entries(re))if(_e!=="className")if(_e==="style")for(const[Pt,Bt]of Object.entries(rt))je.style.setProperty(ei(Pt),typeof Bt=="number"?Bt+"px":""+Bt);else _e==="tabIndex"?je.tabIndex=rt:je.setAttribute(ei(_e),rt.toString());return Ge.root=je,Ge}t.h=Wi;function ei(_){return _.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(_,X){for(const{name:re,value:ge}of _.attributes)X.setAttribute(re,ge)}t.$uQ=ti;function Vi(_,X,re){const ge=_.getAttribute(re);ge?X.setAttribute(re,ge):X.removeAttribute(re)}function qi(_,X,re){ti(_,X);const ge=new f.$Qc;return ge.add(t.$NP.observe(_,ge,{attributes:!0,attributeFilter:re})(ye=>{for(const Re of ye)Re.type==="attributes"&&Re.attributeName&&Vi(_,X,Re.attributeName)})),ge}t.$vQ=qi}),define($e[54],we([1,0,3,2,116]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yQ=t.$xQ=t.$wQ=void 0;class H extends T.$Rc{constructor(c,d){super(),this.B((0,v.$3O)(c,"dragover",f=>{f.preventDefault(),this.a||(this.a=setTimeout(()=>{d(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this.B((0,v.$3O)(c,f,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$wQ=H,t.$xQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Vr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function w(D,c,d,f,R){const s=document.createElement("div");if(s.className=d,s.textContent=c,R&&(s.style.color=R),f&&(s.style.background=f),D.dataTransfer){const a=(0,v.$IP)(D).document;a.body.appendChild(s),D.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>a.body.removeChild(s),0)}}t.$yQ=w}),define($e[55],we([1,0,3]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3Q=t.$2Q=t.$1Q=void 0;function T(s,a={}){const e=H(a);return e.textContent=s,e}t.$1Q=T;function i(s,a={}){const e=H(a);return c(e,d(s,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$2Q=i;function H(s){const a=s.inline?"span":"div",e=document.createElement(a);return s.className&&(e.className=s.className),e}t.$3Q=H;class w{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var D;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(D||(D={}));function c(s,a,e,h){let l;if(a.type===2)l=document.createTextNode(a.content||"");else if(a.type===3)l=document.createElement("b");else if(a.type===4)l=document.createElement("i");else if(a.type===7&&h)l=document.createElement("code");else if(a.type===5&&e){const m=document.createElement("a");e.disposables.add(v.$4O(m,"click",n=>{e.callback(String(a.index),n)})),l=m}else a.type===8?l=document.createElement("br"):a.type===1&&(l=s);l&&s!==l&&s.appendChild(l),l&&Array.isArray(a.children)&&a.children.forEach(m=>{c(l,m,e,h)})}function d(s,a){const e={type:1,children:[]};let h=0,l=e;const m=[],n=new w(s);for(;!n.eos();){let r=n.next();const b=r==="\\"&&R(n.peek(),a)!==0;if(b&&(r=n.next()),!b&&f(r,a)&&r===n.peek()){n.advance(),l.type===2&&(l=m.pop());const u=R(r,a);if(l.type===u||l.type===5&&u===6)l=m.pop();else{const o={type:u,children:[]};u===5&&(o.index=h,h++),l.children.push(o),m.push(l),l=o}}else if(r===`
`)l.type===2&&(l=m.pop()),l.children.push({type:8});else if(l.type!==2){const u={type:2,content:r};l.children.push(u),m.push(l),l=u}else l.content+=r}return l.type===2&&(l=m.pop()),m.length,e}function f(s,a){return R(s,a)!==0}function R(s,a){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define($e[56],we([1,0,3,2]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CQ=void 0;class i{constructor(){this.a=new T.$Qc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(w,D){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const c=this.c;this.c=null,w&&c&&c(D)}isMonitoring(){return!!this.b}startMonitoring(w,D,c,d,f){this.isMonitoring()&&this.stopMonitoring(!1),this.b=d,this.c=f;let R=w;try{w.setPointerCapture(D),this.a.add((0,T.$Pc)(()=>{try{w.releasePointerCapture(D)}catch{}}))}catch{R=v.$IP(w)}this.a.add(v.$3O(R,v.$VP.POINTER_MOVE,s=>{if(s.buttons!==c){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(v.$3O(R,v.$VP.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$CQ=i});var Xe=this&&this.__decorate||function(ae,t,v,T){var i=arguments.length,H=i<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,v):T,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(ae,t,v,T);else for(var D=ae.length-1;D>=0;D--)(w=ae[D])&&(H=(i<3?w(H):i>3?w(t,v,H):w(t,v))||H);return i>3&&H&&Object.defineProperty(t,v,H),H};define($e[24],we([1,0,3,16,11,26,4,2,45]),function(ae,t,v,T,i,H,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zQ=t.EventType=void 0;var d;(function(R){R.Tap="-monaco-gesturetap",R.Change="-monaco-gesturechange",R.Start="-monaco-gesturestart",R.End="-monaco-gesturesend",R.Contextmenu="-monaco-gesturecontextmenu"})(d||(t.EventType=d={}));class f extends D.$Rc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new c.$1c,this.h=new c.$1c,this.m={},this.j=null,this.n=0,this.B(w.Event.runAndSubscribe(v.onDidRegisterWindow,({window:s,disposables:a})=>{a.add(v.$3O(s.document,"touchstart",e=>this.s(e),{passive:!1})),a.add(v.$3O(s.document,"touchend",e=>this.u(s,e))),a.add(v.$3O(s.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:T.$wO,disposables:this.q}))}static addTarget(s){if(!f.isTouchDevice())return D.$Rc.None;f.b||(f.b=(0,D.$Kc)(new f));const a=f.b.g.push(s);return(0,D.$Pc)(a)}static ignoreTarget(s){if(!f.isTouchDevice())return D.$Rc.None;f.b||(f.b=(0,D.$Kc)(new f));const a=f.b.h.push(s);return(0,D.$Pc)(a)}static isTouchDevice(){return"ontouchstart"in T.$wO||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(s){const a=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,h=s.targetTouches.length;e<h;e++){const l=s.targetTouches.item(e);this.m[l.identifier]={id:l.identifier,initialTarget:l.target,initialTimeStamp:a,initialPageX:l.pageX,initialPageY:l.pageY,rollingTimestamps:[a],rollingPageX:[l.pageX],rollingPageY:[l.pageY]};const m=this.w(d.Start,l.target);m.pageX=l.pageX,m.pageY=l.pageY,this.z(m)}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}u(s,a){const e=Date.now(),h=Object.keys(this.m).length;for(let l=0,m=a.changedTouches.length;l<m;l++){const n=a.changedTouches.item(l);if(!this.m.hasOwnProperty(String(n.identifier))){console.warn("move of an UNKNOWN touch",n);continue}const r=this.m[n.identifier],b=Date.now()-r.initialTimeStamp;if(b<f.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(d.Tap,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(b>=f.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(d.Contextmenu,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(h===1){const u=i.$rb(r.rollingPageX),o=i.$rb(r.rollingPageY),N=i.$rb(r.rollingTimestamps)-r.rollingTimestamps[0],j=u-r.rollingPageX[0],L=o-r.rollingPageY[0],g=[...this.g].filter(y=>r.initialTarget instanceof Node&&y.contains(r.initialTarget));this.C(s,g,e,Math.abs(j)/N,j>0?1:-1,u,Math.abs(L)/N,L>0?1:-1,o)}this.z(this.w(d.End,r.initialTarget)),delete this.m[n.identifier]}this.f&&(a.preventDefault(),a.stopPropagation(),this.f=!1)}w(s,a){const e=document.createEvent("CustomEvent");return e.initEvent(s,!1,!0),e.initialTarget=a,e.tapCount=0,e}z(s){if(s.type===d.Tap){const a=new Date().getTime();let e=0;a-this.n>f.r?e=1:e=2,this.n=a,s.tapCount=e}else(s.type===d.Change||s.type===d.Contextmenu)&&(this.n=0);if(s.initialTarget instanceof Node){for(const a of this.h)if(a.contains(s.initialTarget))return;for(const a of this.g)a.contains(s.initialTarget)&&(a.dispatchEvent(s),this.f=!0)}}C(s,a,e,h,l,m,n,r,b){this.j=v.$aP(s,()=>{const u=Date.now(),o=u-e;let N=0,j=0,L=!0;h+=f.a*o,n+=f.a*o,h>0&&(L=!1,N=l*h*o),n>0&&(L=!1,j=r*n*o);const g=this.w(d.Change);g.translationX=N,g.translationY=j,a.forEach(y=>y.dispatchEvent(g)),L||this.C(s,a,u,h,l,m+N,n,r,b+j)})}D(s){const a=Date.now();for(let e=0,h=s.changedTouches.length;e<h;e++){const l=s.changedTouches.item(e);if(!this.m.hasOwnProperty(String(l.identifier))){console.warn("end of an UNKNOWN touch",l);continue}const m=this.m[l.identifier],n=this.w(d.Change,m.initialTarget);n.translationX=l.pageX-i.$rb(m.rollingPageX),n.translationY=l.pageY-i.$rb(m.rollingPageY),n.pageX=l.pageX,n.pageY=l.pageY,this.z(n),m.rollingPageX.length>3&&(m.rollingPageX.shift(),m.rollingPageY.shift(),m.rollingTimestamps.shift()),m.rollingPageX.push(l.pageX),m.rollingPageY.push(l.pageY),m.rollingTimestamps.push(a)}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}}t.$zQ=f,Xe([H.$mh],f,"isTouchDevice",null)}),define($e[57],we([1,0,3,91]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7Q=t.$6Q=t.$5Q=void 0;const T=2e4;let i,H,w,D,c;function d(a){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};H=e(),w=e();const h=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};D=h(),c=h(),a.appendChild(i)}t.$5Q=d;function f(a){i&&(H.textContent!==a?(v.$2O(w),s(H,a)):(v.$2O(H),s(w,a)))}t.$6Q=f;function R(a){i&&(D.textContent!==a?(v.$2O(c),s(D,a)):(v.$2O(D),s(c,a)))}t.$7Q=R;function s(a,e){v.$2O(a),e.length>T&&(e=e.substr(0,T)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define($e[118],we([1,0,3,19]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tR=t.$sR=void 0;const i=new RegExp(`(\\\\)?\\$\\((${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(D){const c=new Array;let d,f=0,R=0;for(;(d=i.exec(D))!==null;){R=d.index||0,f<R&&c.push(D.substring(f,R)),f=(d.index||0)+d[0].length;const[,s,a]=d;c.push(s?`$(${a})`:w({id:a}))}return f<D.length&&c.push(D.substring(f)),c}t.$sR=H;function w(D){const c=v.$("span");return c.classList.add(...T.ThemeIcon.asClassNameArray(D)),c}t.$tR=w}),define($e[119],we([1,0,3]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dR=void 0;function T(H){try{H.parentElement?.removeChild(H)}catch{}}class i{constructor(w){this.d=w,this.a=new Map,this.b=new Set,this.c=!1}alloc(w){let D=this.h(w).pop(),c=!1;if(D)c=this.b.has(D.domNode),c&&this.b.delete(D.domNode);else{const d=(0,v.$)(".monaco-list-row"),R=this.i(w).renderTemplate(d);D={domNode:d,templateId:w,templateData:R}}return{row:D,isReusingConnectedDomNode:c}}release(w){w&&this.f(w)}transact(w){if(this.c)throw new Error("Already in transaction");this.c=!0;try{w()}finally{for(const D of this.b)this.g(D);this.b.clear(),this.c=!1}}f(w){const{domNode:D,templateId:c}=w;D&&(this.c?this.b.add(D):this.g(D)),this.h(c).push(w)}g(w){w.classList.remove("scrolling"),T(w)}h(w){let D=this.a.get(w);return D||(D=[],this.a.set(w,D)),D}dispose(){this.a.forEach((w,D)=>{for(const c of w)this.i(D).disposeTemplate(c.templateData),c.templateData=null}),this.a.clear(),this.b.clear()}i(w){const D=this.d.get(w);if(!D)throw new Error(`No renderer found for ${w}`);return D}}t.$dR=i}),define($e[120],we([1,0,9,2]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HQ=void 0;class i extends T.$Rc{constructor(w,D,c){super(),this.a=w,this.b=D,this.c=c,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new v.$7g)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$HQ=i}),define($e[121],we([1,0,3,24,11,4,2,5]),function(ae,t,v,T,i,H,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AR=void 0;class c extends w.$Rc{constructor(f,R,s,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$Qd),this.h=s,this.j(),this.setOptions(f,R)}j(){this.B(T.$zQ.addTarget(this.a)),[T.EventType.Tap].forEach(f=>{this.B(v.$3O(this.a,f,R=>{this.a.focus()}))}),this.B(v.$4O(this.a,"click",f=>{v.$XP.stop(f,!0)})),this.B(v.$4O(this.a,"change",f=>{this.a.title=f.target.value,this.g.fire({index:f.target.selectedIndex,selected:f.target.value})})),this.B(v.$4O(this.a,"keydown",f=>{let R=!1;D.$j?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(R=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(R=!0),R&&f.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(f,R){(!this.c||!i.$tb(this.c,f))&&(this.c=f,this.a.options.length=0,this.c.forEach((s,a)=>{this.a.add(this.m(s.text,a,s.isDisabled))})),R!==void 0&&this.select(R)}select(f){this.c.length===0?this.f=0:f>=0&&f<this.c.length?this.f=f:f>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(f){this.b.ariaLabel=f,this.a.setAttribute("aria-label",f)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(f){this.a.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(f){this.h=f,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(f,R,s){const a=document.createElement("option");return a.value=f,a.text=f,a.disabled=!!s,a}}t.$AR=c}),define($e[58],we([1,0,25,11,9,50,86,4,27]),function(ae,t,v,T,i,H,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8S=t.$7S=t.$6S=void 0;function d(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$6S=d;function f(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$7S=f;function R(a){return typeof a.collapsible=="boolean"}class s{constructor(e,h,l,m={}){this.o=e,this.p=h,this.rootRef=[],this.d=new D.$Yd,this.f=new D.$Qd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new D.$Qd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new D.$Qd,this.onDidSplice=this.l.event,this.m=new i.$Tg(H.$Nd),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:l,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,h,l=c.Iterable.empty(),m={}){if(e.length===0)throw new v.$4S(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,h,l,m):this.s(e,h,l,m)}q(e,h,l,m=c.Iterable.empty(),n,r=n.diffDepth??0){const{parentNode:b}=this.G(h);if(!b.lastDiffIds)return this.s(h,l,m,n);const u=[...m],o=h[h.length-1],N=new w.$Fs({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,o),...u,...b.children.slice(o+l)].map(B=>e.getId(B.element).toString())}).ComputeDiff(!1);if(N.quitEarly)return b.lastDiffIds=void 0,this.s(h,l,u,n);const j=h.slice(0,-1),L=(B,q,x)=>{if(r>0)for(let P=0;P<x;P++)B--,q--,this.q(e,[...j,B,0],Number.MAX_SAFE_INTEGER,u[q].children,n,r-1)};let g=Math.min(b.children.length,o+l),y=u.length;for(const B of N.changes.sort((q,x)=>x.originalStart-q.originalStart))L(g,y,g-(B.originalStart+B.originalLength)),g=B.originalStart,y=B.modifiedStart-o,this.s([...j,g],B.originalLength,c.Iterable.slice(u,y,y+B.modifiedLength),n);L(g,y,g)}s(e,h,l=c.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:n,diffIdentityProvider:r}){const{parentNode:b,listIndex:u,revealed:o,visible:N}=this.G(e),j=[],L=c.Iterable.map(l,fe=>this.w(fe,b,b.visible?1:0,o,j,m)),g=e[e.length-1],y=b.children.length>0;let B=0;for(let fe=g;fe>=0&&fe<b.children.length;fe--){const le=b.children[fe];if(le.visible){B=le.visibleChildIndex;break}}const q=[];let x=0,P=0;for(const fe of L)q.push(fe),P+=fe.renderNodeCount,fe.visible&&(fe.visibleChildIndex=B+x++);const O=(0,T.$5b)(b.children,g,h,q);r?b.lastDiffIds?(0,T.$5b)(b.lastDiffIds,g,h,q.map(fe=>r.getId(fe.element).toString())):b.lastDiffIds=b.children.map(fe=>r.getId(fe.element).toString()):b.lastDiffIds=void 0;let K=0;for(const fe of O)fe.visible&&K++;if(K!==0)for(let fe=g+q.length;fe<b.children.length;fe++){const le=b.children[fe];le.visible&&(le.visibleChildIndex-=K)}if(b.visibleChildrenCount+=x-K,o&&N){const fe=O.reduce((le,oe)=>le+(oe.visible?oe.renderNodeCount:0),0);this.B(b,P-fe),this.p.splice(u,fe,j)}if(O.length>0&&n){const fe=le=>{n(le),le.children.forEach(fe)};O.forEach(fe)}this.l.fire({insertedNodes:q,deletedNodes:O});const te=b.children.length>0;y!==te&&this.setCollapsible(e.slice(0,-1),te);let se=b;for(;se;){if(se.visibility===2){this.m.trigger(()=>this.refilter());break}se=se.parent}}rerender(e){if(e.length===0)throw new v.$4S(this.o,"Invalid tree location");const{node:h,listIndex:l,revealed:m}=this.F(e);h.visible&&m&&this.p.splice(l,1,[h])}updateElementHeight(e,h){if(e.length===0)throw new v.$4S(this.o,"Invalid tree location");const{listIndex:l}=this.F(e);this.p.updateElementHeight(l,h)}has(e){return this.D(e)}getListIndex(e){const{listIndex:h,visible:l,revealed:m}=this.F(e);return l&&m?h:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,h){const l=this.E(e);typeof h>"u"&&(h=!l.collapsible);const m={collapsible:h};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,h,l){const m=this.E(e);typeof h>"u"&&(h=!m.collapsed);const n={collapsed:h,recursive:l||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,h){const{node:l,listIndex:m,revealed:n}=this.F(e),r=this.u(l,m,n,h);if(l!==this.c&&this.k&&r&&!R(h)&&l.collapsible&&!l.collapsed&&!h.recursive){let b=-1;for(let u=0;u<l.children.length;u++)if(l.children[u].visible)if(b>-1){b=-1;break}else b=u;b>-1&&this.t([...e,b],h)}return r}u(e,h,l,m){const n=this.v(e,m,!1);if(!l||!e.visible||!n)return n;const r=e.renderNodeCount,b=this.x(e),u=r-(h===-1?0:1);return this.p.splice(h+1,u,b.slice(1)),n}v(e,h,l){let m;if(e===this.c?m=!1:(R(h)?(m=e.collapsible!==h.collapsible,e.collapsible=h.collapsible):e.collapsible?(m=e.collapsed!==h.collapsed,e.collapsed=h.collapsed):m=!1,m&&this.f.fire({node:e,deep:l})),!R(h)&&h.recursive)for(const n of e.children)m=this.v(n,h,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let h=this.E(e);for(;h.parent;)h=h.parent,e=e.slice(0,e.length-1),h.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,h=this.z(this.c);this.p.splice(0,e,h),this.m.cancel()}w(e,h,l,m,n,r){const b={parent:h,element:e.element,children:[],depth:h.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},u=this.C(b,l);b.visibility=u,m&&n.push(b);const o=e.children||c.Iterable.empty(),N=m&&u!==0&&!b.collapsed;let j=0,L=1;for(const g of o){const y=this.w(g,b,u,N,n,r);b.children.push(y),L+=y.renderNodeCount,y.visible&&(y.visibleChildIndex=j++)}return b.collapsible=b.collapsible||b.children.length>0,b.visibleChildrenCount=j,b.visible=u===2?j>0:u===1,b.visible?b.collapsed||(b.renderNodeCount=L):(b.renderNodeCount=0,m&&n.pop()),r?.(b),b}x(e){const h=e.renderNodeCount,l=[];return this.y(e,l),this.B(e.parent,l.length-h),l}y(e,h){if(e.visible===!1)return 0;if(h.push(e),e.renderNodeCount=1,!e.collapsed)for(const l of e.children)e.renderNodeCount+=this.y(l,h);return this.g.fire(e),e.renderNodeCount}z(e){const h=e.renderNodeCount,l=[];return this.A(e,e.visible?1:0,l),this.B(e.parent,l.length-h),l}A(e,h,l,m=!0){let n;if(e!==this.c){if(n=this.C(e,h),n===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&l.push(e)}const r=l.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||n!==0){let u=0;for(const o of e.children)b=this.A(o,n,l,m&&!e.collapsed)||b,o.visible&&(o.visibleChildIndex=u++);e.visibleChildrenCount=u}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?b:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=l.length-r):(e.renderNodeCount=0,m&&l.pop()),this.g.fire(e),e.visible}B(e,h){if(h!==0)for(;e;)e.renderNodeCount+=h,this.g.fire(e),e=e.parent}C(e,h){const l=this.j?this.j.filter(e.element,h):1;return typeof l=="boolean"?(e.filterData=void 0,l?1:0):d(l)?(e.filterData=l.data,f(l.visibility)):(e.filterData=void 0,f(l))}D(e,h=this.c){if(!e||e.length===0)return!0;const[l,...m]=e;return l<0||l>h.children.length?!1:this.D(m,h.children[l])}E(e,h=this.c){if(!e||e.length===0)return h;const[l,...m]=e;if(l<0||l>h.children.length)throw new v.$4S(this.o,"Invalid tree location");return this.E(m,h.children[l])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:h,listIndex:l,revealed:m,visible:n}=this.G(e),r=e[e.length-1];if(r<0||r>h.children.length)throw new v.$4S(this.o,"Invalid tree location");const b=h.children[r];return{node:b,listIndex:l,revealed:m,visible:n&&b.visible}}G(e,h=this.c,l=0,m=!0,n=!0){const[r,...b]=e;if(r<0||r>h.children.length)throw new v.$4S(this.o,"Invalid tree location");for(let u=0;u<r;u++)l+=h.children[u].renderNodeCount;return m=m&&!h.collapsed,n=n&&h.visible,b.length===0?{parentNode:h,listIndex:l,revealed:m,visible:n}:this.G(b,h.children[r],l+1,m,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const h=[];let l=e;for(;l.parent;)h.push(l.parent.children.indexOf(l)),l=l.parent;return h.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,T.$sb)(e)[0]}getFirstElementChild(e){const h=this.E(e);if(h.children.length!==0)return h.children[0].element}getLastElementAncestor(e=[]){const h=this.E(e);if(h.children.length!==0)return this.H(h)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$8S=s}),define($e[122],we([1,0,58,25,27]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bT=void 0;class H{get size(){return this.d.size}constructor(D,c,d={}){this.k=D,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.$8S(D,c,null,d),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,d.sorter&&(this.j={compare(f,R){return d.sorter.compare(f.element,R.element)}}),this.h=d.identityProvider}setChildren(D,c=i.Iterable.empty(),d={}){const f=this.o(D);this.l(f,this.m(c),d)}l(D,c=i.Iterable.empty(),d){const f=new Set,R=new Set,s=e=>{if(e.element===null)return;const h=e;if(f.add(h.element),this.d.set(h.element,h),this.h){const l=this.h.getId(h.element).toString();R.add(l),this.f.set(l,h)}d.onDidCreateNode?.(h)},a=e=>{if(e.element===null)return;const h=e;if(f.has(h.element)||this.d.delete(h.element),this.h){const l=this.h.getId(h.element).toString();R.has(l)||this.f.delete(l)}d.onDidDeleteNode?.(h)};this.c.splice([...D,0],Number.MAX_VALUE,c,{...d,onDidCreateNode:s,onDidDeleteNode:a})}m(D=i.Iterable.empty()){return this.j&&(D=[...D].sort(this.j.compare.bind(this.j))),i.Iterable.map(D,c=>{let d=this.d.get(c.element);if(!d&&this.h){const s=this.h.getId(c.element).toString();d=this.f.get(s)}if(!d){let s;return typeof c.collapsed>"u"?s=void 0:c.collapsed===T.ObjectTreeElementCollapseState.Collapsed||c.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:c.collapsed===T.ObjectTreeElementCollapseState.Expanded||c.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!c.collapsed,{...c,children:this.m(c.children),collapsed:s}}const f=typeof c.collapsible=="boolean"?c.collapsible:d.collapsible;let R;return typeof c.collapsed>"u"||c.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed||c.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?R=d.collapsed:c.collapsed===T.ObjectTreeElementCollapseState.Collapsed?R=!0:c.collapsed===T.ObjectTreeElementCollapseState.Expanded?R=!1:R=!!c.collapsed,{...c,collapsible:f,collapsed:R,children:this.m(c.children)}})}rerender(D){const c=this.o(D);this.c.rerender(c)}updateElementHeight(D,c){const d=this.o(D);this.c.updateElementHeight(d,c)}resort(D=null,c=!0){if(!this.j)return;const d=this.o(D),f=this.c.getNode(d);this.l(d,this.n(f,c),{})}n(D,c,d=!0){let f=[...D.children];return(c||d)&&(f=f.sort(this.j.compare.bind(this.j))),i.Iterable.map(f,R=>({element:R.element,collapsible:R.collapsible,collapsed:R.collapsed,children:this.n(R,c,!1)}))}getFirstElementChild(D=null){const c=this.o(D);return this.c.getFirstElementChild(c)}getLastElementAncestor(D=null){const c=this.o(D);return this.c.getLastElementAncestor(c)}has(D){return this.d.has(D)}getListIndex(D){const c=this.o(D);return this.c.getListIndex(c)}getListRenderCount(D){const c=this.o(D);return this.c.getListRenderCount(c)}isCollapsible(D){const c=this.o(D);return this.c.isCollapsible(c)}setCollapsible(D,c){const d=this.o(D);return this.c.setCollapsible(d,c)}isCollapsed(D){const c=this.o(D);return this.c.isCollapsed(c)}setCollapsed(D,c,d){const f=this.o(D);return this.c.setCollapsed(f,c,d)}expandTo(D){const c=this.o(D);this.c.expandTo(c)}refilter(){this.c.refilter()}getNode(D=null){if(D===null)return this.c.getNode(this.c.rootRef);const c=this.d.get(D);if(!c)throw new T.$4S(this.k,`Tree element not found: ${D}`);return c}getNodeLocation(D){return D.element}getParentNodeLocation(D){if(D===null)throw new T.$4S(this.k,"Invalid getParentNodeLocation call");const c=this.d.get(D);if(!c)throw new T.$4S(this.k,`Tree element not found: ${D}`);const d=this.c.getNodeLocation(c),f=this.c.getParentNodeLocation(d);return this.c.getNode(f).element}o(D){if(D===null)return[];const c=this.d.get(D);if(!c)throw new T.$4S(this.k,`Tree element not found: ${D}`);return this.c.getNodeLocation(c)}}t.$bT=H}),define($e[21],we([1,0,3,14,20,24,2]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DQ=void 0;class D extends w.$Rc{f(d,f){this.B(v.$3O(d,v.$VP.CLICK,R=>f(new i.$UO(R))))}j(d,f){this.B(v.$3O(d,v.$VP.MOUSE_DOWN,R=>f(new i.$UO(R))))}m(d,f){this.B(v.$3O(d,v.$VP.MOUSE_OVER,R=>f(new i.$UO(R))))}u(d,f){this.B(v.$3O(d,v.$VP.MOUSE_LEAVE,R=>f(new i.$UO(R))))}z(d,f){this.B(v.$3O(d,v.$VP.KEY_DOWN,R=>f(new T.$ZO(R))))}C(d,f){this.B(v.$3O(d,v.$VP.KEY_UP,R=>f(new T.$ZO(R))))}D(d,f){this.B(v.$3O(d,v.$VP.INPUT,f))}F(d,f){this.B(v.$3O(d,v.$VP.BLUR,f))}G(d,f){this.B(v.$3O(d,v.$VP.FOCUS,f))}H(d,f){this.B(v.$3O(d,v.$VP.CHANGE,f))}I(d){return H.$zQ.ignoreTarget(d)}}t.$DQ=D}),define($e[38],we([1,0,56,21,9,19,3]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FQ=t.$EQ=void 0,t.$EQ=11;class D extends T.$DQ{constructor(d){super(),this.a=d.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=d.bgWidth+"px",this.bgDomNode.style.height=d.bgHeight+"px",typeof d.top<"u"&&(this.bgDomNode.style.top="0px"),typeof d.left<"u"&&(this.bgDomNode.style.left="0px"),typeof d.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof d.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=d.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(d.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$EQ+"px",this.domNode.style.height=t.$EQ+"px",typeof d.top<"u"&&(this.domNode.style.top=d.top+"px"),typeof d.left<"u"&&(this.domNode.style.left=d.left+"px"),typeof d.bottom<"u"&&(this.domNode.style.bottom=d.bottom+"px"),typeof d.right<"u"&&(this.domNode.style.right=d.right+"px"),this.g=this.B(new v.$CQ),this.B(w.$4O(this.bgDomNode,w.$VP.POINTER_DOWN,f=>this.h(f))),this.B(w.$4O(this.domNode,w.$VP.POINTER_DOWN,f=>this.h(f))),this.b=this.B(new w.$cP),this.c=this.B(new i.$7g)}h(d){if(!d.target||!(d.target instanceof Element))return;const f=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,w.$IP(d))};this.a(),this.b.cancel(),this.c.cancelAndSet(f,200),this.g.startMonitoring(d.target,d.pointerId,d.buttons,R=>{},()=>{this.b.cancel(),this.c.cancel()}),d.preventDefault()}}t.$FQ=D}),define($e[59],we([1,0,3,41,56,38,120,21,5]),function(ae,t,v,T,i,H,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IQ=void 0;const d=140;class f extends D.$DQ{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new w.$HQ(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$CQ),this.s=!0,this.domNode=(0,T.$BQ)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.$3O(this.domNode.domNode,v.$VP.POINTER_DOWN,a=>this.M(a)))}t(s){const a=this.B(new H.$FQ(s));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(s,a,e,h){this.slider=(0,T.$BQ)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof h=="number"&&this.slider.setHeight(h),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.$3O(this.slider.domNode,v.$VP.POINTER_DOWN,l=>{l.button===0&&(l.preventDefault(),this.O(l))})),this.f(this.slider.domNode,l=>{l.leftButton&&l.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),h=a+this.h.getSliderPosition()+this.h.getSliderSize(),l=this.U(s);e<=l&&l<=h?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let a,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")a=s.offsetX,e=s.offsetY;else{const l=v.$mP(this.domNode.domNode);a=s.pageX-l.left,e=s.pageY-l.top}const h=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(h):this.h.getDesiredScrollPositionFromOffset(h)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const a=this.U(s),e=this.W(s),h=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,l=>{const m=this.W(l),n=Math.abs(m-e);if(c.$i&&n>d){this.P(h.getScrollPosition());return}const b=this.U(l)-a;this.P(h.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const a={};this.writeScrollPosition(a,s),this.b.setScrollPositionNow(a)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$IQ=f}),define($e[123],we([1,0,20,59,38,42,18]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JQ=void 0;class D extends T.$IQ{constructor(d,f,R){const s=d.getScrollDimensions(),a=d.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:R,scrollbarState:new H.$GQ(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,s.width,s.scrollWidth,a.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:d,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-i.$EQ)/2,h=(f.horizontalScrollbarSize-i.$EQ)/2;this.t({className:"scra",icon:w.$Zj.scrollbarButtonLeft,top:h,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$WO(null,1,0))}),this.t({className:"scra",icon:w.$Zj.scrollbarButtonRight,top:h,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$WO(null,-1,0))})}this.w(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}R(d,f){this.slider.setWidth(d),this.slider.setLeft(f)}Q(d,f){this.domNode.setWidth(d),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(d){return this.s=this.J(d.scrollWidth)||this.s,this.s=this.L(d.scrollLeft)||this.s,this.s=this.y(d.width)||this.s,this.s}S(d,f){return d}U(d){return d.pageX}W(d){return d.pageY}X(d){this.slider.setHeight(d)}writeScrollPosition(d,f){d.scrollLeft=f}updateOptions(d){this.updateScrollbarSize(d.horizontal===2?0:d.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(d.vertical===2?0:d.verticalScrollbarSize),this.n.setVisibility(d.horizontal),this.c=d.scrollByPage}}t.$JQ=D}),define($e[124],we([1,0,20,59,38,42,18]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KQ=void 0;class D extends T.$IQ{constructor(d,f,R){const s=d.getScrollDimensions(),a=d.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:R,scrollbarState:new H.$GQ(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,s.height,s.scrollHeight,a.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:d,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-i.$EQ)/2,h=(f.verticalScrollbarSize-i.$EQ)/2;this.t({className:"scra",icon:w.$Zj.scrollbarButtonUp,top:e,left:h,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$WO(null,0,1))}),this.t({className:"scra",icon:w.$Zj.scrollbarButtonDown,top:void 0,left:h,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$WO(null,0,-1))})}this.w(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}R(d,f){this.slider.setHeight(d),this.slider.setTop(f)}Q(d,f){this.domNode.setWidth(f),this.domNode.setHeight(d),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(d){return this.s=this.J(d.scrollHeight)||this.s,this.s=this.L(d.scrollTop)||this.s,this.s=this.y(d.height)||this.s,this.s}S(d,f){return f}U(d){return d.pageY}W(d){return d.pageX}X(d){this.slider.setWidth(d)}writeScrollPosition(d,f){d.scrollTop=f}updateOptions(d){this.updateScrollbarSize(d.vertical===2?0:d.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(d.vertical),this.c=d.scrollByPage}}t.$KQ=D}),define($e[60],we([1,0,17,3,41,20,123,124,21,9,4,2,5,48,98]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$LQ=void 0;const e=500,h=50,l=!0;class m{constructor(L,g,y){this.timestamp=L,this.deltaX=g,this.deltaY=y,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let L=1,g=0,y=1,B=this.d;do{const q=B===this.c?L:Math.pow(2,-y);if(L-=q,g+=this.b[B].score*q,B===this.c)break;B=(this.a+B-1)%this.a,y++}while(!0);return g<=.5}acceptStandardWheelEvent(L){const g=T.$IP(L.browserEvent).devicePixelRatio/(0,v.$DO)();s.$i||s.$k?this.accept(Date.now(),L.deltaX/g,L.deltaY/g):this.accept(Date.now(),L.deltaX,L.deltaY)}accept(L,g,y){const B=new m(L,g,y);B.score=this.f(B),this.c===-1&&this.d===-1?(this.b[0]=B,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=B)}f(L){if(Math.abs(L.deltaX)>0&&Math.abs(L.deltaY)>0)return 1;let g=.5;const y=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(L.deltaX)||!this.g(L.deltaY))&&(g+=.25),Math.min(Math.max(g,0),1)}g(L){return Math.abs(Math.round(L)-L)<.01}}t.$LQ=n;class r extends c.$DQ{get options(){return this.a}constructor(L,g,y){super(),this.O=this.B(new f.$Qd),this.onScroll=this.O.event,this.P=this.B(new f.$Qd),this.onWillScroll=this.P.event,L.style.overflow="hidden",this.a=N(g),this.b=y,this.B(this.b.onScroll(q=>{this.P.fire(q),this.S(q),this.O.fire(q)}));const B={onMouseWheel:q=>this.R(q),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new D.$KQ(this.b,this.a,B)),this.g=this.B(new w.$JQ(this.b,this.a,B)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(L),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$BQ)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$BQ)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$BQ)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,q=>this.Z(q)),this.u(this.t,q=>this.Y(q)),this.L=this.B(new d.$7g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,R.$Mc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(L){this.c.delegatePointerDown(L)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(L){this.b.setScrollDimensions(L,!1)}updateClassName(L){this.a.className=L,s.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(L){typeof L.handleMouseWheel<"u"&&(this.a.handleMouseWheel=L.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof L.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=L.mouseWheelScrollSensitivity),typeof L.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=L.fastScrollSensitivity),typeof L.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=L.scrollPredominantAxis),typeof L.horizontal<"u"&&(this.a.horizontal=L.horizontal),typeof L.vertical<"u"&&(this.a.vertical=L.vertical),typeof L.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=L.horizontalScrollbarSize),typeof L.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=L.verticalScrollbarSize),typeof L.scrollByPage<"u"&&(this.a.scrollByPage=L.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(L){this.N=L}delegateScrollFromMouseWheelEvent(L){this.R(new H.$WO(L))}Q(L){if(this.w.length>0!==L&&(this.w=(0,R.$Mc)(this.w),L)){const y=B=>{this.R(new H.$WO(B))};this.w.push(T.$3O(this.t,T.$VP.MOUSE_WHEEL,y,{passive:!1}))}}R(L){if(L.browserEvent?.defaultPrevented)return;const g=n.INSTANCE;l&&g.acceptStandardWheelEvent(L);let y=!1;if(L.deltaY||L.deltaX){let q=L.deltaY*this.a.mouseWheelScrollSensitivity,x=L.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&x+q===0?x=q=0:Math.abs(q)>=Math.abs(x)?x=0:q=0),this.a.flipAxes&&([q,x]=[x,q]);const P=!s.$j&&L.browserEvent&&L.browserEvent.shiftKey;(this.a.scrollYToX||P)&&!x&&(x=q,q=0),L.browserEvent&&L.browserEvent.altKey&&(x=x*this.a.fastScrollSensitivity,q=q*this.a.fastScrollSensitivity);const O=this.b.getFutureScrollPosition();let K={};if(q){const te=h*q,se=O.scrollTop-(te<0?Math.floor(te):Math.ceil(te));this.c.writeScrollPosition(K,se)}if(x){const te=h*x,se=O.scrollLeft-(te<0?Math.floor(te):Math.ceil(te));this.g.writeScrollPosition(K,se)}K=this.b.validateScrollPosition(K),(O.scrollLeft!==K.scrollLeft||O.scrollTop!==K.scrollTop)&&(l&&this.a.mouseWheelSmoothScroll&&g.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(K):this.b.setScrollPositionNow(K),y=!0)}let B=y;!B&&this.a.alwaysConsumeMouseWheel&&(B=!0),!B&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(B=!0),B&&(L.preventDefault(),L.stopPropagation())}S(L){this.M=this.g.onDidScroll(L)||this.M,this.M=this.c.onDidScroll(L)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const L=this.b.getCurrentScrollPosition(),g=L.scrollTop>0,y=L.scrollLeft>0,B=y?" left":"",q=g?" top":"",x=y||g?" top-left-corner":"";this.n.setClassName(`shadow${B}`),this.r.setClassName(`shadow${q}`),this.s.setClassName(`shadow${x}${q}${B}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(L){this.J=!1,this.ab()}Z(L){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$MQ=r;class b extends r{constructor(L,g){g=g||{},g.mouseWheelSmoothScroll=!1;const y=new a.$2r({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>T.$aP(T.$IP(L),B)});super(L,g,y),this.B(y)}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$NQ=b;class u extends r{constructor(L,g,y){super(L,g,y)}setScrollPosition(L){L.reuseAnimation?this.b.setScrollPositionSmooth(L,L.reuseAnimation):this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$OQ=u;class o extends r{constructor(L,g){g=g||{},g.mouseWheelSmoothScroll=!1;const y=new a.$2r({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>T.$aP(T.$IP(L),B)});super(L,g,y),this.B(y),this.cb=L,this.B(this.onScroll(B=>{B.scrollTopChanged&&(this.cb.scrollTop=B.scrollTop),B.scrollLeftChanged&&(this.cb.scrollLeft=B.scrollLeft)})),this.scanDomNode()}setScrollPosition(L){this.b.setScrollPositionNow(L)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$PQ=o;function N(j){const L={lazyRender:typeof j.lazyRender<"u"?j.lazyRender:!1,className:typeof j.className<"u"?j.className:"",useShadows:typeof j.useShadows<"u"?j.useShadows:!0,handleMouseWheel:typeof j.handleMouseWheel<"u"?j.handleMouseWheel:!0,flipAxes:typeof j.flipAxes<"u"?j.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof j.consumeMouseWheelIfScrollbarIsNeeded<"u"?j.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof j.alwaysConsumeMouseWheel<"u"?j.alwaysConsumeMouseWheel:!1,scrollYToX:typeof j.scrollYToX<"u"?j.scrollYToX:!1,mouseWheelScrollSensitivity:typeof j.mouseWheelScrollSensitivity<"u"?j.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof j.fastScrollSensitivity<"u"?j.fastScrollSensitivity:5,scrollPredominantAxis:typeof j.scrollPredominantAxis<"u"?j.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof j.mouseWheelSmoothScroll<"u"?j.mouseWheelSmoothScroll:!0,arrowSize:typeof j.arrowSize<"u"?j.arrowSize:11,listenOnDomNode:typeof j.listenOnDomNode<"u"?j.listenOnDomNode:null,horizontal:typeof j.horizontal<"u"?j.horizontal:1,horizontalScrollbarSize:typeof j.horizontalScrollbarSize<"u"?j.horizontalScrollbarSize:10,horizontalSliderSize:typeof j.horizontalSliderSize<"u"?j.horizontalSliderSize:0,horizontalHasArrows:typeof j.horizontalHasArrows<"u"?j.horizontalHasArrows:!1,vertical:typeof j.vertical<"u"?j.vertical:1,verticalScrollbarSize:typeof j.verticalScrollbarSize<"u"?j.verticalScrollbarSize:10,verticalHasArrows:typeof j.verticalHasArrows<"u"?j.verticalHasArrows:!1,verticalSliderSize:typeof j.verticalSliderSize<"u"?j.verticalSliderSize:0,scrollByPage:typeof j.scrollByPage<"u"?j.scrollByPage:!1};return L.horizontalSliderSize=typeof j.horizontalSliderSize<"u"?j.horizontalSliderSize:L.horizontalScrollbarSize,L.verticalSliderSize=typeof j.verticalSliderSize<"u"?j.verticalSliderSize:L.verticalScrollbarSize,s.$j&&(L.className+=" mac"),L}}),define($e[61],we([1,0,54,3,22,24,60,11,9,26,4,2,47,48,82,119,6]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s,a,e,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hR=t.$gR=t.$fR=t.$eR=void 0;const m={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(L){return[L]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(g){this.d=g}constructor(g){this.elements=g}update(){}getData(){return this.elements}}t.$eR=r;class b{constructor(g){this.elements=g}update(){}getData(){return this.elements}}t.$fR=b;class u{constructor(){this.types=[],this.files=[]}update(g){if(g.types&&this.types.splice(0,this.types.length,...g.types),g.files){this.files.splice(0,this.files.length);for(let y=0;y<g.files.length;y++){const B=g.files.item(y);B&&(B.size||B.type)&&this.files.push(B)}}}getData(){return{types:this.types,files:this.files}}}t.$gR=u;function o(L,g){return Array.isArray(L)&&Array.isArray(g)?(0,D.$tb)(L,g):L===g}class N{constructor(g){g?.getSetSize?this.getSetSize=g.getSetSize.bind(g):this.getSetSize=(y,B,q)=>q,g?.getPosInSet?this.getPosInSet=g.getPosInSet.bind(g):this.getPosInSet=(y,B)=>B+1,g?.getRole?this.getRole=g.getRole.bind(g):this.getRole=y=>"listitem",g?.isChecked?this.isChecked=g.isChecked.bind(g):this.isChecked=y=>{}}}class j{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(g){if(g!==this.O){if(g&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=g,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const y of this.d)this.Y(y);this.V(),this.q.setScrollDimensions({width:(0,T.$pP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(g,y,B,q=n){if(this.Q=y,this.domId=`list_id_${++j.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new c.$Tg(50),this.v=!1,this.x=R.$Rc.None,this.y=0,this.G=!1,this.J=R.$Rc.None,this.K=R.$Rc.None,this.L=new R.$Qc,this.M=new f.$Qd,this.N=new f.$Qd,this.onDidChangeContentHeight=f.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=f.Event.latch(this.N.event,void 0,this.L),this.O=!1,q.horizontalScrolling&&q.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$cR(q.paddingTop??0);for(const P of B)this.j.set(P.templateId,P);this.h=this.L.add(new h.$dR(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof q.mouseSupport=="boolean"?q.mouseSupport:!0),this.O=q.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof q.paddingBottom>"u"?0:q.paddingBottom,this.D=new N(q.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(q.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(H.$zQ.addTarget(this.o)),this.p=this.L.add(new a.$2r({forceIntegerValues:!0,smoothScrollDuration:q.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:P=>(0,T.$aP)((0,T.$IP)(this.domNode),P)})),this.q=this.L.add(new w.$OQ(this.o,{alwaysConsumeMouseWheel:q.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:q.verticalScrollMode??n.verticalScrollMode,useShadows:q.useShadows??n.useShadows,mouseWheelScrollSensitivity:q.mouseWheelScrollSensitivity,fastScrollSensitivity:q.fastScrollSensitivity,scrollByPage:q.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),g.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,T.$3O)(this.o,H.EventType.Change,P=>this.hb(P))),this.L.add((0,T.$3O)(this.q.getDomNode(),"scroll",P=>P.target.scrollTop=0)),this.L.add((0,T.$3O)(this.domNode,"dragover",P=>this.jb(this.fb(P)))),this.L.add((0,T.$3O)(this.domNode,"drop",P=>this.lb(this.fb(P)))),this.L.add((0,T.$3O)(this.domNode,"dragleave",P=>this.kb(this.fb(P)))),this.L.add((0,T.$3O)(this.domNode,"dragend",P=>this.mb(P))),this.z=q.setRowLineHeight??n.setRowLineHeight,this.A=q.setRowHeight??n.setRowHeight,this.B=q.supportDynamicHeights??n.supportDynamicHeights,this.F=q.dnd??this.L.add(n.dnd),this.layout(q.initialSize?.height,q.initialSize?.width)}updateOptions(g){g.paddingBottom!==void 0&&(this.C=g.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),g.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(g.smoothScrolling?125:0),g.horizontalScrolling!==void 0&&(this.P=g.horizontalScrolling);let y;if(g.scrollByPage!==void 0&&(y={...y??{},scrollByPage:g.scrollByPage}),g.mouseWheelScrollSensitivity!==void 0&&(y={...y??{},mouseWheelScrollSensitivity:g.mouseWheelScrollSensitivity}),g.fastScrollSensitivity!==void 0&&(y={...y??{},fastScrollSensitivity:g.fastScrollSensitivity}),y&&this.q.updateOptions(y),g.paddingTop!==void 0&&g.paddingTop!==this.g.paddingTop){const B=this.sb(this.k,this.m),q=g.paddingTop-this.g.paddingTop;this.g.paddingTop=g.paddingTop,this.W(B,Math.max(0,this.k+q),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(g){this.q.delegateScrollFromMouseWheelEvent(g)}delegateVerticalScrollbarPointerDown(g){this.q.delegateVerticalScrollbarPointerDown(g)}updateElementHeight(g,y,B){if(g<0||g>=this.d.length)return;const q=this.d[g].size;if(typeof y>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[g].lastDynamicHeightWidth=void 0,y=q+this.ub(g)}if(q===y)return;const x=this.sb(this.k,this.m);let P=0;g<x.start||B!==null&&B>g&&B<x.end?P=y-q:P=0,this.g.splice(g,1,[{size:y}]),this.d[g].size=y,this.W(x,Math.max(0,this.k+P),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(g,y,B=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(g,y,B)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(g,y,B=[]){const q=this.sb(this.k,this.m),x={start:g,end:g+y},P=s.Range.intersect(q,x),O=new Map;for(let W=P.end-1;W>=P.start;W--){const Y=this.d[W];if(Y.dragStartDisposable.dispose(),Y.checkedDisposable.dispose(),Y.row){let C=O.get(Y.templateId);C||(C=[],O.set(Y.templateId,C));const V=this.j.get(Y.templateId);V&&V.disposeElement&&V.disposeElement(Y.element,W,Y.row.templateData,Y.size),C.push(Y.row)}Y.row=null}const K={start:g+y,end:this.d.length},te=s.Range.intersect(K,q),se=s.Range.relativeComplement(K,q),fe=B.map(W=>({id:String(this.f++),element:W,templateId:this.Q.getTemplateId(W),size:this.Q.getHeight(W),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(W),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:R.$Rc.None,checkedDisposable:R.$Rc.None}));let le;g===0&&y>=this.d.length?(this.g=new e.$cR(this.g.paddingTop),this.g.splice(0,0,fe),le=this.d,this.d=fe):(this.g.splice(g,y,fe),le=this.d.splice(g,y,...fe));const oe=B.length-y,be=this.sb(this.k,this.m),Se=(0,e.$aR)(te,oe),Ae=s.Range.intersect(be,Se);for(let W=Ae.start;W<Ae.end;W++)this.Z(this.d[W],W);const Pe=s.Range.relativeComplement(Se,be);for(const W of Pe)for(let Y=W.start;Y<W.end;Y++)this.ab(Y);const de=se.map(W=>(0,e.$aR)(W,oe)),ce=[{start:g,end:g+B.length},...de].map(W=>s.Range.intersect(be,W)),Z=this.vb(ce);for(const W of ce)for(let Y=W.start;Y<W.end;Y++){const C=this.d[Y],$=O.get(C.templateId)?.pop();this.X(Y,Z,$)}for(const W of O.values())for(const Y of W)this.h.release(Y);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),le.map(W=>W.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,T.$aP)((0,T.$IP)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let g=0;for(const y of this.d)typeof y.width<"u"&&(g=Math.max(g,y.width));this.E=g,this.q.setScrollDimensions({scrollWidth:g===0?0:g+10}),this.N.fire(this.E)}updateWidth(g){if(!this.P||typeof this.E>"u")return;const y=this.d[g];this.Y(y),typeof y.width<"u"&&y.width>this.E&&(this.E=y.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const g of this.d)g.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const g=this.sb(this.k,this.m),y=this.g.positionAt(g.start),B=this.g.positionAt(g.start+1);return B!==-1&&(B-y)/2+y<this.scrollTop?g.start+1:g.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(g){return this.d[g].element}indexOf(g){return this.d.findIndex(y=>y.element===g)}domElement(g){const y=this.d[g].row;return y&&y.domNode}elementHeight(g){return this.d[g].size}elementTop(g){return this.g.positionAt(g)}indexAt(g){return this.g.indexAt(g)}indexAfter(g){return this.g.indexAfter(g)}layout(g,y){const B={height:typeof g=="number"?g:(0,T.$rP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,B.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(B),typeof y<"u"&&(this.n=y,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof y=="number"?y:(0,T.$pP)(this.domNode)})}W(g,y,B,q,x,P=!1){const O=this.sb(y,B),K=s.Range.relativeComplement(O,g),te=s.Range.relativeComplement(g,O),se=this.vb(K);if(P){const fe=s.Range.intersect(g,O);for(let le=fe.start;le<fe.end;le++)this.Z(this.d[le],le)}this.h.transact(()=>{for(const fe of te)for(let le=fe.start;le<fe.end;le++)this.ab(le);for(const fe of K)for(let le=fe.start;le<fe.end;le++)this.X(le,se)}),q!==void 0&&(this.o.style.left=`-${q}px`),this.o.style.top=`-${y}px`,this.P&&x!==void 0&&(this.o.style.width=`${Math.max(x,this.n)}px`),this.k=y,this.m=B}X(g,y,B){const q=this.d[g];let x=!1;if(!q.row)if(B)q.row=B;else{const se=this.h.alloc(q.templateId);q.row=se.row,x=se.isReusingConnectedDomNode}const P=this.D.getRole(q.element)||"listitem";q.row.domNode.setAttribute("role",P);const O=this.D.isChecked(q.element);if(typeof O=="boolean")q.row.domNode.setAttribute("aria-checked",String(!!O));else if(O){const se=fe=>q.row.domNode.setAttribute("aria-checked",String(!!fe));se(O.value),q.checkedDisposable=O.onDidChange(se)}(x||!q.row.domNode.parentElement)&&(y?this.o.insertBefore(q.row.domNode,y):this.o.appendChild(q.row.domNode)),this.Z(q,g);const K=this.j.get(q.templateId);if(!K)throw new Error(`No renderer found for template id ${q.templateId}`);K?.renderElement(q.element,g,q.row.templateData,q.size);const te=this.F.getDragURI(q.element);q.dragStartDisposable.dispose(),q.row.domNode.draggable=!!te,te&&(q.dragStartDisposable=(0,T.$3O)(q.row.domNode,"dragstart",se=>this.ib(q.element,te,se))),this.P&&(this.Y(q),this.U())}Y(g){if(!g.row||!g.row.domNode)return;g.row.domNode.style.width="fit-content",g.width=(0,T.$pP)(g.row.domNode);const y=(0,T.$IP)(g.row.domNode).getComputedStyle(g.row.domNode);y.paddingLeft&&(g.width+=parseFloat(y.paddingLeft)),y.paddingRight&&(g.width+=parseFloat(y.paddingRight)),g.row.domNode.style.width=""}Z(g,y){g.row.domNode.style.top=`${this.elementTop(y)}px`,this.A&&(g.row.domNode.style.height=`${g.size}px`),this.z&&(g.row.domNode.style.lineHeight=`${g.size}px`),g.row.domNode.setAttribute("data-index",`${y}`),g.row.domNode.setAttribute("data-last-element",y===this.length-1?"true":"false"),g.row.domNode.setAttribute("data-parity",y%2===0?"even":"odd"),g.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(g.element,y,this.length))),g.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(g.element,y))),g.row.domNode.setAttribute("id",this.getElementDomId(y)),g.row.domNode.classList.toggle("drop-target",g.dropTarget)}ab(g){const y=this.d[g];if(y.dragStartDisposable.dispose(),y.checkedDisposable.dispose(),y.row){const B=this.j.get(y.templateId);B&&B.disposeElement&&B.disposeElement(y.element,g,y.row.templateData,y.size),this.h.release(y.row),y.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(g,y){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:g,reuseAnimation:y})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(g){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:g})}get scrollTop(){return this.getScrollTop()}set scrollTop(g){this.setScrollTop(g)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return f.Event.map(this.L.add(new i.$4Q(this.domNode,"click")).event,g=>this.bb(g),this.L)}get onMouseDblClick(){return f.Event.map(this.L.add(new i.$4Q(this.domNode,"dblclick")).event,g=>this.bb(g),this.L)}get onMouseMiddleClick(){return f.Event.filter(f.Event.map(this.L.add(new i.$4Q(this.domNode,"auxclick")).event,g=>this.bb(g),this.L),g=>g.browserEvent.button===1,this.L)}get onMouseUp(){return f.Event.map(this.L.add(new i.$4Q(this.domNode,"mouseup")).event,g=>this.bb(g),this.L)}get onMouseDown(){return f.Event.map(this.L.add(new i.$4Q(this.domNode,"mousedown")).event,g=>this.bb(g),this.L)}get onMouseOver(){return f.Event.map(this.L.add(new i.$4Q(this.domNode,"mouseover")).event,g=>this.bb(g),this.L)}get onMouseMove(){return f.Event.map(this.L.add(new i.$4Q(this.domNode,"mousemove")).event,g=>this.bb(g),this.L)}get onMouseOut(){return f.Event.map(this.L.add(new i.$4Q(this.domNode,"mouseout")).event,g=>this.bb(g),this.L)}get onContextMenu(){return f.Event.any(f.Event.map(this.L.add(new i.$4Q(this.domNode,"contextmenu")).event,g=>this.bb(g),this.L),f.Event.map(this.L.add(new i.$4Q(this.domNode,H.EventType.Contextmenu)).event,g=>this.eb(g),this.L))}get onTouchStart(){return f.Event.map(this.L.add(new i.$4Q(this.domNode,"touchstart")).event,g=>this.db(g),this.L)}get onTap(){return f.Event.map(this.L.add(new i.$4Q(this.o,H.EventType.Tap)).event,g=>this.eb(g),this.L)}bb(g){const y=this.rb(g.target||null),B=typeof y>"u"?void 0:this.d[y],q=B&&B.element;return{browserEvent:g,index:y,element:q}}db(g){const y=this.rb(g.target||null),B=typeof y>"u"?void 0:this.d[y],q=B&&B.element;return{browserEvent:g,index:y,element:q}}eb(g){const y=this.rb(g.initialTarget||null),B=typeof y>"u"?void 0:this.d[y],q=B&&B.element;return{browserEvent:g,index:y,element:q}}fb(g){const y=this.rb(g.target||null),B=typeof y>"u"?void 0:this.d[y],q=B&&B.element;return{browserEvent:g,index:y,element:q}}gb(g){try{const y=this.sb(this.k,this.m);this.W(y,g.scrollTop,g.height,g.scrollLeft,g.scrollWidth),this.B&&this.tb(g.scrollTop,g.height,g.inSmoothScrolling)}catch(y){throw console.error("Got bad scroll event:",g),y}}hb(g){g.preventDefault(),g.stopPropagation(),this.scrollTop-=g.translationY}ib(g,y,B){if(!B.dataTransfer)return;const q=this.F.getDragElements(g);if(B.dataTransfer.effectAllowed="copyMove",B.dataTransfer.setData(v.$xQ.TEXT,y),B.dataTransfer.setDragImage){let x;this.F.getDragLabel&&(x=this.F.getDragLabel(q,B)),typeof x>"u"&&(x=String(q.length));const P=(0,T.$)(".monaco-drag-image");P.textContent=x;const K=(te=>{for(;te&&!te.classList.contains("monaco-workbench");)te=te.parentElement;return te||this.domNode.ownerDocument})(this.domNode);K.appendChild(P),B.dataTransfer.setDragImage(P,-10,-10),setTimeout(()=>K.removeChild(P),0)}this.domNode.classList.add("dragging"),this.H=new r(q),m.CurrentDragAndDropData=new b(q),this.F.onDragStart?.(this.H,B)}jb(g){if(g.browserEvent.preventDefault(),this.K.dispose(),m.CurrentDragAndDropData&&m.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(g.browserEvent),!g.browserEvent.dataTransfer))return!1;if(!this.H)if(m.CurrentDragAndDropData)this.H=m.CurrentDragAndDropData;else{if(!g.browserEvent.dataTransfer.types)return!1;this.H=new u}const y=this.F.onDragOver(this.H,g.element,g.index,g.browserEvent);if(this.G=typeof y=="boolean"?y:y.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;g.browserEvent.dataTransfer.dropEffect=typeof y!="boolean"&&y.effect===0?"copy":"move";let B;if(typeof y!="boolean"&&y.feedback?B=y.feedback:typeof g.index>"u"?B=[-1]:B=[g.index],B=(0,D.$Lb)(B).filter(q=>q>=-1&&q<this.length).sort((q,x)=>q-x),B=B[0]===-1?[-1]:B,o(this.I,B))return!0;if(this.I=B,this.J.dispose(),B[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,R.$Pc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const q of B){const x=this.d[q];x.dropTarget=!0,x.row?.domNode.classList.add("drop-target")}this.J=(0,R.$Pc)(()=>{for(const q of B){const x=this.d[q];x.dropTarget=!1,x.row?.domNode.classList.remove("drop-target")}})}return!0}kb(g){this.K.dispose(),this.K=(0,c.$Yg)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,g.element,g.index,g.browserEvent)}lb(g){if(!this.G)return;const y=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,!(!y||!g.browserEvent.dataTransfer)&&(g.browserEvent.preventDefault(),y.update(g.browserEvent.dataTransfer),this.F.drop(y,g.element,g.index,g.browserEvent))}mb(g){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(g)}nb(){this.I=void 0,this.J.dispose(),this.J=R.$Rc.None}ob(g){if(!this.w){const y=(0,T.$jP)(this.domNode).top;this.w=(0,T.$fQ)((0,T.$IP)(this.domNode),this.pb.bind(this,y))}this.x.dispose(),this.x=(0,c.$Yg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=g.pageY}pb(g){if(this.y===void 0)return;const y=this.y-g,B=this.renderHeight-35;y<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(y-35))):y>B&&(this.scrollTop+=Math.min(14,Math.floor(.3*(y-B))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(g){const y=this.q.getDomNode();let B=g;for(;B instanceof HTMLElement&&B!==this.o&&y.contains(B);){const q=B.getAttribute("data-index");if(q){const x=Number(q);if(!isNaN(x))return x}B=B.parentElement}}sb(g,y){return{start:this.g.indexAt(g),end:this.g.indexAfter(g+y-1)}}tb(g,y,B){const q=this.sb(g,y);let x,P;g===this.elementTop(q.start)?(x=q.start,P=0):q.end-q.start>1&&(x=q.start+1,P=this.elementTop(x)-g);let O=0;for(;;){const K=this.sb(g,y);let te=!1;for(let se=K.start;se<K.end;se++){const fe=this.ub(se);fe!==0&&this.g.splice(se,1,[this.d[se]]),O+=fe,te=te||fe!==0}if(!te){O!==0&&this.S();const se=s.Range.relativeComplement(q,K);for(const le of se)for(let oe=le.start;oe<le.end;oe++)this.d[oe].row&&this.ab(oe);const fe=s.Range.relativeComplement(K,q);for(const le of fe)for(let oe=le.start;oe<le.end;oe++){const be=oe+1,Se=be<this.d.length?this.d[be].row:null,Ae=Se?Se.domNode:null;this.X(oe,Ae)}for(let le=K.start;le<K.end;le++)this.d[le].row&&this.Z(this.d[le],le);if(typeof x=="number"){const le=this.p.getFutureScrollPosition().scrollTop-g,oe=this.elementTop(x)-P+le;this.setScrollTop(oe,B)}this.M.fire(this.contentHeight);return}}}ub(g){const y=this.d[g];if(this.Q.getDynamicHeight){const P=this.Q.getDynamicHeight(y.element);if(P!==null){const O=y.size;return y.size=P,y.lastDynamicHeightWidth=this.n,P-O}}if(!y.hasDynamicHeight||y.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(y.element))return 0;const B=y.size;if(y.row)return y.row.domNode.style.height="",y.size=y.row.domNode.offsetHeight,y.lastDynamicHeightWidth=this.n,y.size-B;const{row:q}=this.h.alloc(y.templateId);q.domNode.style.height="",this.o.appendChild(q.domNode);const x=this.j.get(y.templateId);if(!x)throw new l.$bb("Missing renderer for templateId: "+y.templateId);return x.renderElement(y.element,g,q.templateData,void 0),y.size=q.domNode.offsetHeight,x.disposeElement?.(y.element,g,q.templateData,void 0),this.Q.setDynamicHeight?.(y.element,y.size),y.lastDynamicHeightWidth=this.n,this.o.removeChild(q.domNode),this.h.release(q),y.size-B}vb(g){const y=g[g.length-1];if(!y)return null;const B=this.d[y.end];return!B||!B.row?null:B.row.domNode}getElementDomId(g){return`${this.domId}_${g}`}dispose(){for(const g of this.d)if(g.dragStartDisposable.dispose(),g.checkedDisposable.dispose(),g.row){const y=this.j.get(g.row.templateId);y&&(y.disposeElement?.(g.element,-1,g.row.templateData,void 0),y.disposeTemplate(g.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$hR=j,Xe([d.$mh],j.prototype,"onMouseClick",null),Xe([d.$mh],j.prototype,"onMouseDblClick",null),Xe([d.$mh],j.prototype,"onMouseMiddleClick",null),Xe([d.$mh],j.prototype,"onMouseUp",null),Xe([d.$mh],j.prototype,"onMouseDown",null),Xe([d.$mh],j.prototype,"onMouseOver",null),Xe([d.$mh],j.prototype,"onMouseMove",null),Xe([d.$mh],j.prototype,"onMouseOut",null),Xe([d.$mh],j.prototype,"onContextMenu",null),Xe([d.$mh],j.prototype,"onTouchStart",null),Xe([d.$mh],j.prototype,"onTap",null)}),define($e[39],we([1,0,3,22,14,24,57,71,11,9,74,26,4,34,2,46,5,7,70,61,20,97]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s,a,e,h,l,m,n,r,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rR=t.$qR=t.$pR=t.$oR=t.$nR=t.$mR=t.$lR=t.TypeNavigationMode=t.$kR=t.$jR=t.$iR=void 0;class u{constructor(C){this.d=C,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(C){return C}renderElement(C,V,$){const U=this.c.findIndex(Q=>Q.templateData===$);if(U>=0){const Q=this.c[U];this.d.unrender($),Q.index=V}else{const Q={index:V,templateData:$};this.c.push(Q)}this.d.renderIndex(V,$)}splice(C,V,$){const U=[];for(const Q of this.c)Q.index<C?U.push(Q):Q.index>=C+V&&U.push({index:Q.index+$-V,templateData:Q.templateData});this.c=U}renderIndexes(C){for(const{index:V,templateData:$}of this.c)C.indexOf(V)>-1&&this.d.renderIndex(V,$)}disposeTemplate(C){const V=this.c.findIndex($=>$.templateData===C);V<0||this.c.splice(V,1)}}class o{get name(){return this.h}get renderer(){return new u(this)}constructor(C){this.h=C,this.c=0,this.d=[],this.f=[],this.g=new s.$Qd,this.onChange=this.g.event}splice(C,V,$){V=Math.max(0,Math.min(V,this.c-C));const U=$.length-V,Q=C+V,p=[];let A=0;for(;A<this.f.length&&this.f[A]<C;)p.push(this.f[A++]);for(let M=0;M<$.length;M++)$[M]&&p.push(M+C);for(;A<this.f.length&&this.f[A]>=Q;)p.push(this.f[A++]+U);const E=this.c+U;if(this.f.length>0&&p.length===0&&E>0){const M=this.f.find(k=>k>=C)??E-1;p.push(Math.min(M,E-1))}this.renderer.splice(C,V,$.length),this.k(p,p),this.c=E}renderIndex(C,V){V.classList.toggle(this.h,this.contains(C))}unrender(C){C.classList.remove(this.h)}set(C,V){return this.k(C,[...C].sort(de),V)}k(C,V,$){const U=this.d,Q=this.f;this.d=C,this.f=V;const p=Ae(Q,C);return this.renderer.renderIndexes(p),this.g.fire({indexes:C,browserEvent:$}),U}get(){return this.d}contains(C){return(0,c.$vb)(this.f,C,de)>=0}dispose(){(0,e.$Mc)(this.g)}}Xe([R.$mh],o.prototype,"renderer",null);class N extends o{constructor(C){super("selected"),this.l=C}renderIndex(C,V){super.renderIndex(C,V),this.l&&(this.contains(C)?V.setAttribute("aria-selected","true"):V.setAttribute("aria-selected","false"))}}class j{constructor(C,V,$){this.c=C,this.d=V,this.f=$}splice(C,V,$){if(!this.f)return this.c.splice(C,V,new Array($.length).fill(!1));const U=this.c.get().map(A=>this.f.getId(this.d.element(A)).toString());if(U.length===0)return this.c.splice(C,V,new Array($.length).fill(!1));const Q=new Set(U),p=$.map(A=>Q.has(this.f.getId(A).toString()));this.c.splice(C,V,p)}}function L(Y){return Y.tagName==="INPUT"||Y.tagName==="TEXTAREA"}t.$iR=L;function g(Y){return Y.classList.contains("monaco-editor")?!0:Y.classList.contains("monaco-list")||!Y.parentElement?!1:g(Y.parentElement)}t.$jR=g;function y(Y){return Y.tagName==="A"&&Y.classList.contains("monaco-button")||Y.tagName==="DIV"&&Y.classList.contains("monaco-button-dropdown")?!0:Y.classList.contains("monaco-list")||!Y.parentElement?!1:y(Y.parentElement)}t.$kR=y;class B{get g(){return s.Event.chain(this.c.add(new T.$4Q(this.k.domNode,"keydown")).event,C=>C.filter(V=>!L(V.target)).map(V=>new i.$ZO(V)))}constructor(C,V,$){this.h=C,this.k=V,this.c=new e.$Qc,this.d=new e.$Qc,this.f=$.multipleSelectionSupport,this.c.add(this.g(U=>{switch(U.keyCode){case 3:return this.l(U);case 16:return this.o(U);case 18:return this.p(U);case 11:return this.q(U);case 12:return this.s(U);case 9:return this.u(U);case 31:this.f&&(l.$j?U.metaKey:U.ctrlKey)&&this.t(U)}}))}updateOptions(C){C.multipleSelectionSupport!==void 0&&(this.f=C.multipleSelectionSupport)}l(C){C.preventDefault(),C.stopPropagation(),this.h.setSelection(this.h.getFocus(),C.browserEvent)}o(C){C.preventDefault(),C.stopPropagation(),this.h.focusPrevious(1,!1,C.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}p(C){C.preventDefault(),C.stopPropagation(),this.h.focusNext(1,!1,C.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}q(C){C.preventDefault(),C.stopPropagation(),this.h.focusPreviousPage(C.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}s(C){C.preventDefault(),C.stopPropagation(),this.h.focusNextPage(C.browserEvent);const V=this.h.getFocus()[0];this.h.setAnchor(V),this.h.reveal(V),this.k.domNode.focus()}t(C){C.preventDefault(),C.stopPropagation(),this.h.setSelection((0,c.$Rb)(this.h.length),C.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(C){this.h.getSelection().length&&(C.preventDefault(),C.stopPropagation(),this.h.setSelection([],C.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Xe([R.$mh],B.prototype,"g",null);var q;(function(Y){Y[Y.Automatic=0]="Automatic",Y[Y.Trigger=1]="Trigger"})(q||(t.TypeNavigationMode=q={}));var x;(function(Y){Y[Y.Idle=0]="Idle",Y[Y.Typing=1]="Typing"})(x||(x={})),t.$lR=new class{mightProducePrintableCharacter(Y){return Y.ctrlKey||Y.metaKey||Y.altKey?!1:Y.keyCode>=31&&Y.keyCode<=56||Y.keyCode>=21&&Y.keyCode<=30||Y.keyCode>=98&&Y.keyCode<=107||Y.keyCode>=85&&Y.keyCode<=95}};class P{constructor(C,V,$,U,Q){this.o=C,this.p=V,this.q=$,this.s=U,this.t=Q,this.c=!1,this.d=x.Idle,this.f=q.Automatic,this.g=!1,this.h=-1,this.k=new e.$Qc,this.l=new e.$Qc,this.updateOptions(C.options)}updateOptions(C){C.typeNavigationEnabled??!0?this.u():this.v(),this.f=C.typeNavigationMode??q.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let C=!1;const V=s.Event.chain(this.k.add(new T.$4Q(this.p.domNode,"keydown")).event,Q=>Q.filter(p=>!L(p.target)).filter(()=>this.f===q.Automatic||this.g).map(p=>new i.$ZO(p)).filter(p=>C||this.s(p)).filter(p=>this.t.mightProducePrintableCharacter(p)).forEach(p=>v.$XP.stop(p,!0)).map(p=>p.browserEvent.key)),$=s.Event.debounce(V,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(V,$),(Q,p)=>p===null?null:(Q||"")+p,void 0,this.k)(this.x,this,this.k),$(this.w,this,this.k),V(()=>C=!0,void 0,this.k),$(()=>C=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const C=this.o.getFocus();if(C.length>0&&C[0]===this.h){const V=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(C[0]));V&&(0,w.$6Q)(V)}this.h=-1}x(C){if(!C){this.d=x.Idle,this.g=!1;return}const V=this.o.getFocus(),$=V.length>0?V[0]:0,U=this.d===x.Idle?1:0;this.d=x.Typing;for(let Q=0;Q<this.o.length;Q++){const p=($+Q+U)%this.o.length,A=this.q.getKeyboardNavigationLabel(this.p.element(p)),E=A&&A.toString();if(this.o.options.typeNavigationEnabled){if(typeof E<"u"){if((0,a.$Ij)(C,E)){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}const M=(0,a.$Pj)(C,E);if(M&&M[0].end-M[0].start>1&&M.length===1){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}}}else if(typeof E>"u"||(0,a.$Ij)(C,E)){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class O{constructor(C,V){this.d=C,this.f=V,this.c=new e.$Qc;const $=s.Event.chain(this.c.add(new T.$4Q(V.domNode,"keydown")).event,Q=>Q.filter(p=>!L(p.target)).map(p=>new i.$ZO(p)));s.Event.chain($,Q=>Q.filter(p=>p.keyCode===2&&!p.ctrlKey&&!p.metaKey&&!p.shiftKey&&!p.altKey))(this.g,this,this.c)}g(C){if(C.target!==this.f.domNode)return;const V=this.d.getFocus();if(V.length===0)return;const $=this.f.domElement(V[0]);if(!$)return;const U=$.querySelector("[tabIndex]");if(!U||!(U instanceof HTMLElement)||U.tabIndex===-1)return;const Q=(0,v.$IP)(U).getComputedStyle(U);Q.visibility==="hidden"||Q.display==="none"||(C.preventDefault(),C.stopPropagation(),U.focus())}dispose(){this.c.dispose()}}function K(Y){return l.$j?Y.browserEvent.metaKey:Y.browserEvent.ctrlKey}t.$mR=K;function te(Y){return Y.browserEvent.shiftKey}t.$nR=te;function se(Y){return(0,v.$RP)(Y)&&Y.button===2}const fe={isSelectionSingleChangeEvent:K,isSelectionRangeChangeEvent:te};class le{constructor(C){this.k=C,this.f=new e.$Qc,this.g=new s.$Qd,this.onPointer=this.g.event,C.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||fe),this.d=typeof C.options.mouseSupport>"u"||!!C.options.mouseSupport,this.d&&(C.onMouseDown(this.s,this,this.f),C.onContextMenu(this.t,this,this.f),C.onMouseDblClick(this.v,this,this.f),C.onTouchStart(this.s,this,this.f),this.f.add(H.$zQ.addTarget(C.getHTMLElement()))),s.Event.any(C.onMouseClick,C.onMouseMiddleClick,C.onTap)(this.u,this,this.f)}updateOptions(C){C.multipleSelectionSupport!==void 0&&(this.c=void 0,C.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||fe))}o(C){return this.c?this.c.isSelectionSingleChangeEvent(C):!1}p(C){return this.c?this.c.isSelectionRangeChangeEvent(C):!1}q(C){return this.o(C)||this.p(C)}s(C){g(C.browserEvent.target)||(0,v.$CP)()!==C.browserEvent.target&&this.k.domFocus()}t(C){if(L(C.browserEvent.target)||g(C.browserEvent.target))return;const V=typeof C.index>"u"?[]:[C.index];this.k.setFocus(V,C.browserEvent)}u(C){if(!this.d||L(C.browserEvent.target)||g(C.browserEvent.target)||C.browserEvent.isHandledByList)return;C.browserEvent.isHandledByList=!0;const V=C.index;if(typeof V>"u"){this.k.setFocus([],C.browserEvent),this.k.setSelection([],C.browserEvent),this.k.setAnchor(void 0);return}if(this.q(C))return this.w(C);this.k.setFocus([V],C.browserEvent),this.k.setAnchor(V),se(C.browserEvent)||this.k.setSelection([V],C.browserEvent),this.g.fire(C)}v(C){if(L(C.browserEvent.target)||g(C.browserEvent.target)||this.q(C)||C.browserEvent.isHandledByList)return;C.browserEvent.isHandledByList=!0;const V=this.k.getFocus();this.k.setSelection(V,C.browserEvent)}w(C){const V=C.index;let $=this.k.getAnchor();if(this.p(C)){typeof $>"u"&&($=this.k.getFocus()[0]??V,this.k.setAnchor($));const U=Math.min($,V),Q=Math.max($,V),p=(0,c.$Rb)(U,Q+1),A=this.k.getSelection(),E=Se(Ae(A,[$]),$);if(E.length===0)return;const M=Ae(p,Pe(A,E));this.k.setSelection(M,C.browserEvent),this.k.setFocus([V],C.browserEvent)}else if(this.o(C)){const U=this.k.getSelection(),Q=U.filter(p=>p!==V);this.k.setFocus([V]),this.k.setAnchor(V),U.length===Q.length?this.k.setSelection([...Q,V],C.browserEvent):this.k.setSelection(Q,C.browserEvent)}}dispose(){this.f.dispose()}}t.$oR=le;class oe{constructor(C,V){this.c=C,this.d=V}style(C){const V=this.d&&`.${this.d}`,$=[];C.listBackground&&$.push(`.monaco-list${V} .monaco-list-rows { background: ${C.listBackground}; }`),C.listFocusBackground&&($.push(`.monaco-list${V}:focus .monaco-list-row.focused { background-color: ${C.listFocusBackground}; }`),$.push(`.monaco-list${V}:focus .monaco-list-row.focused:hover { background-color: ${C.listFocusBackground}; }`)),C.listFocusForeground&&$.push(`.monaco-list${V}:focus .monaco-list-row.focused { color: ${C.listFocusForeground}; }`),C.listActiveSelectionBackground&&($.push(`.monaco-list${V}:focus .monaco-list-row.selected { background-color: ${C.listActiveSelectionBackground}; }`),$.push(`.monaco-list${V}:focus .monaco-list-row.selected:hover { background-color: ${C.listActiveSelectionBackground}; }`)),C.listActiveSelectionForeground&&$.push(`.monaco-list${V}:focus .monaco-list-row.selected { color: ${C.listActiveSelectionForeground}; }`),C.listActiveSelectionIconForeground&&$.push(`.monaco-list${V}:focus .monaco-list-row.selected .codicon { color: ${C.listActiveSelectionIconForeground}; }`),C.listFocusAndSelectionBackground&&$.push(`
				.monaco-drag-image,
				.monaco-list${V}:focus .monaco-list-row.selected.focused { background-color: ${C.listFocusAndSelectionBackground}; }
			`),C.listFocusAndSelectionForeground&&$.push(`
				.monaco-drag-image,
				.monaco-list${V}:focus .monaco-list-row.selected.focused { color: ${C.listFocusAndSelectionForeground}; }
			`),C.listInactiveFocusForeground&&($.push(`.monaco-list${V} .monaco-list-row.focused { color:  ${C.listInactiveFocusForeground}; }`),$.push(`.monaco-list${V} .monaco-list-row.focused:hover { color:  ${C.listInactiveFocusForeground}; }`)),C.listInactiveSelectionIconForeground&&$.push(`.monaco-list${V} .monaco-list-row.focused .codicon { color:  ${C.listInactiveSelectionIconForeground}; }`),C.listInactiveFocusBackground&&($.push(`.monaco-list${V} .monaco-list-row.focused { background-color:  ${C.listInactiveFocusBackground}; }`),$.push(`.monaco-list${V} .monaco-list-row.focused:hover { background-color:  ${C.listInactiveFocusBackground}; }`)),C.listInactiveSelectionBackground&&($.push(`.monaco-list${V} .monaco-list-row.selected { background-color:  ${C.listInactiveSelectionBackground}; }`),$.push(`.monaco-list${V} .monaco-list-row.selected:hover { background-color:  ${C.listInactiveSelectionBackground}; }`)),C.listInactiveSelectionForeground&&$.push(`.monaco-list${V} .monaco-list-row.selected { color: ${C.listInactiveSelectionForeground}; }`),C.listHoverBackground&&$.push(`.monaco-list${V}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${C.listHoverBackground}; }`),C.listHoverForeground&&$.push(`.monaco-list${V}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${C.listHoverForeground}; }`);const U=(0,v.$iQ)(C.listFocusAndSelectionOutline,(0,v.$iQ)(C.listSelectionOutline,C.listFocusOutline??""));U&&$.push(`.monaco-list${V}:focus .monaco-list-row.focused.selected { outline: 1px solid ${U}; outline-offset: -1px;}`),C.listFocusOutline&&$.push(`
				.monaco-drag-image,
				.monaco-list${V}:focus .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${V}.last-focused .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }
			`);const Q=(0,v.$iQ)(C.listSelectionOutline,C.listInactiveFocusOutline??"");Q&&$.push(`.monaco-list${V} .monaco-list-row.focused.selected { outline: 1px dotted ${Q}; outline-offset: -1px; }`),C.listSelectionOutline&&$.push(`.monaco-list${V} .monaco-list-row.selected { outline: 1px dotted ${C.listSelectionOutline}; outline-offset: -1px; }`),C.listInactiveFocusOutline&&$.push(`.monaco-list${V} .monaco-list-row.focused { outline: 1px dotted ${C.listInactiveFocusOutline}; outline-offset: -1px; }`),C.listHoverOutline&&$.push(`.monaco-list${V} .monaco-list-row:hover { outline: 1px dashed ${C.listHoverOutline}; outline-offset: -1px; }`),C.listDropBackground&&$.push(`
				.monaco-list${V}.drop-target,
				.monaco-list${V} .monaco-list-rows.drop-target,
				.monaco-list${V} .monaco-list-row.drop-target { background-color: ${C.listDropBackground} !important; color: inherit !important; }
			`),C.tableColumnsBorder&&$.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${C.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),C.tableOddRowsBackgroundColor&&$.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${C.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=$.join(`
`)}}t.$pR=oe,t.$qR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:f.$4s.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:f.$4s.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:f.$4s.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const be={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Se(Y,C){const V=Y.indexOf(C);if(V===-1)return[];const $=[];let U=V-1;for(;U>=0&&Y[U]===C-(V-U);)$.push(Y[U--]);for($.reverse(),U=V;U<Y.length&&Y[U]===C+(U-V);)$.push(Y[U++]);return $}function Ae(Y,C){const V=[];let $=0,U=0;for(;$<Y.length||U<C.length;)if($>=Y.length)V.push(C[U++]);else if(U>=C.length)V.push(Y[$++]);else if(Y[$]===C[U]){V.push(Y[$]),$++,U++;continue}else Y[$]<C[U]?V.push(Y[$++]):V.push(C[U++]);return V}function Pe(Y,C){const V=[];let $=0,U=0;for(;$<Y.length||U<C.length;)if($>=Y.length)V.push(C[U++]);else if(U>=C.length)V.push(Y[$++]);else if(Y[$]===C[U]){$++,U++;continue}else Y[$]<C[U]?V.push(Y[$++]):U++;return V}const de=(Y,C)=>Y-C;class ie{constructor(C,V){this.c=C,this.d=V}get templateId(){return this.c}renderTemplate(C){return this.d.map(V=>V.renderTemplate(C))}renderElement(C,V,$,U){let Q=0;for(const p of this.d)p.renderElement(C,V,$[Q++],U)}disposeElement(C,V,$,U){let Q=0;for(const p of this.d)p.disposeElement?.(C,V,$[Q],U),Q+=1}disposeTemplate(C){let V=0;for(const $ of this.d)$.disposeTemplate(C[V++])}}class ce{constructor(C){this.c=C,this.templateId="a18n"}renderTemplate(C){return C}renderElement(C,V,$){const U=this.c.getAriaLabel(C);U?$.setAttribute("aria-label",U):$.removeAttribute("aria-label");const Q=this.c.getAriaLevel&&this.c.getAriaLevel(C);typeof Q=="number"?$.setAttribute("aria-level",`${Q}`):$.removeAttribute("aria-level")}disposeTemplate(C){}}class Z{constructor(C,V){this.c=C,this.d=V}getDragElements(C){const V=this.c.getSelectedElements();return V.indexOf(C)>-1?V:[C]}getDragURI(C){return this.d.getDragURI(C)}getDragLabel(C,V){if(this.d.getDragLabel)return this.d.getDragLabel(C,V)}onDragStart(C,V){this.d.onDragStart?.(C,V)}onDragOver(C,V,$,U){return this.d.onDragOver(C,V,$,U)}onDragLeave(C,V,$,U){this.d.onDragLeave?.(C,V,$,U)}onDragEnd(C){this.d.onDragEnd?.(C)}drop(C,V,$,U){this.d.drop(C,V,$,U)}dispose(){this.d.dispose()}}class W{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),C=>this.G(C),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),C=>this.G(C),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let C=!1;const V=s.Event.chain(this.y.add(new T.$4Q(this.k.domNode,"keydown")).event,Q=>Q.map(p=>new i.$ZO(p)).filter(p=>C=p.keyCode===58||p.shiftKey&&p.keyCode===68).map(p=>v.$XP.stop(p,!0)).filter(()=>!1)),$=s.Event.chain(this.y.add(new T.$4Q(this.k.domNode,"keyup")).event,Q=>Q.forEach(()=>C=!1).map(p=>new i.$ZO(p)).filter(p=>p.keyCode===58||p.shiftKey&&p.keyCode===68).map(p=>v.$XP.stop(p,!0)).map(({browserEvent:p})=>{const A=this.getFocus(),E=A.length?A[0]:void 0,M=typeof E<"u"?this.k.element(E):void 0,k=typeof E<"u"?this.k.domElement(E):this.k.domNode;return{index:E,element:M,anchor:k,browserEvent:p}})),U=s.Event.chain(this.k.onContextMenu,Q=>Q.filter(p=>!C).map(({element:p,index:A,browserEvent:E})=>({element:p,index:A,anchor:new b.$UO(E),browserEvent:E})));return s.Event.any(V,$,U)}get onKeyDown(){return this.y.add(new T.$4Q(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new T.$4Q(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new T.$4Q(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new T.$4Q(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new T.$4Q(this.k.domNode,"blur",!0)).event)}constructor(C,V,$,U,Q=be){this.A=C,this.B=Q,this.c=new o("focused"),this.f=new o("anchor"),this.g=new s.$Yd,this.x="",this.y=new e.$Qc,this.z=new s.$Qd,this.onDidDispose=this.z.event;const p=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(p!=="listbox");const A=[this.c.renderer,this.d.renderer];this.u=Q.accessibilityProvider,this.u&&(A.push(new ce(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),U=U.map(M=>new ie(M.templateId,[...A,M]));const E={...Q,dnd:Q.dnd&&new Z(this,Q.dnd)};if(this.k=this.C(V,$,U,E),this.k.domNode.setAttribute("role",p),Q.styleController)this.q=Q.styleController(this.k.domId);else{const M=(0,v.$LP)(this.k.domNode);this.q=new oe(M,this.k.domId)}if(this.o=new D.$8Q([new j(this.c,this.k,Q.identityProvider),new j(this.d,this.k,Q.identityProvider),new j(this.f,this.k,Q.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new O(this,this.k)),(typeof Q.keyboardSupport!="boolean"||Q.keyboardSupport)&&(this.v=new B(this,this.k,Q),this.y.add(this.v)),Q.keyboardNavigationLabelProvider){const M=Q.keyboardNavigationDelegate||t.$lR;this.t=new P(this,this.k,Q.keyboardNavigationLabelProvider,Q.keyboardNavigationEventFilter??(()=>!0),M),this.y.add(this.t)}this.w=this.D(Q),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(C,V,$,U){return new r.$hR(C,V,$,U)}D(C){return new le(this)}updateOptions(C={}){this.B={...this.B,...C},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(C),this.v?.updateOptions(C),this.k.updateOptions(C)}get options(){return this.B}splice(C,V,$=[]){if(C<0||C>this.k.length)throw new n.$0Q(this.A,`Invalid start index: ${C}`);if(V<0)throw new n.$0Q(this.A,`Invalid delete count: ${V}`);V===0&&$.length===0||this.g.bufferEvents(()=>this.o.splice(C,V,$))}updateWidth(C){this.k.updateWidth(C)}updateElementHeight(C,V){this.k.updateElementHeight(C,V,null)}rerender(){this.k.rerender()}element(C){return this.k.element(C)}indexOf(C){return this.k.indexOf(C)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(C){this.k.setScrollTop(C)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(C){this.k.setScrollLeft(C)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(C){this.x=C,this.k.domNode.setAttribute("aria-label",C)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(C,V){this.k.layout(C,V)}triggerTypeNavigation(){this.t?.trigger()}setSelection(C,V){for(const $ of C)if($<0||$>=this.length)throw new n.$0Q(this.A,`Invalid index ${$}`);this.d.set(C,V)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(C=>this.k.element(C))}setAnchor(C){if(typeof C>"u"){this.f.set([]);return}if(C<0||C>=this.length)throw new n.$0Q(this.A,`Invalid index ${C}`);this.f.set([C])}getAnchor(){return(0,c.$Nb)(this.f.get(),void 0)}getAnchorElement(){const C=this.getAnchor();return typeof C>"u"?void 0:this.element(C)}setFocus(C,V){for(const $ of C)if($<0||$>=this.length)throw new n.$0Q(this.A,`Invalid index ${$}`);this.c.set(C,V)}focusNext(C=1,V=!1,$,U){if(this.length===0)return;const Q=this.c.get(),p=this.E(Q.length>0?Q[0]+C:0,V,U);p>-1&&this.setFocus([p],$)}focusPrevious(C=1,V=!1,$,U){if(this.length===0)return;const Q=this.c.get(),p=this.F(Q.length>0?Q[0]-C:0,V,U);p>-1&&this.setFocus([p],$)}async focusNextPage(C,V){let $=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);$=$===0?0:$-1;const U=this.getFocus()[0];if(U!==$&&(U===void 0||$>U)){const Q=this.F($,!1,V);Q>-1&&U!==Q?this.setFocus([Q],C):this.setFocus([$],C)}else{const Q=this.k.getScrollTop();let p=Q+this.k.renderHeight;$>U&&(p-=this.k.elementHeight($)),this.k.setScrollTop(p),this.k.getScrollTop()!==Q&&(this.setFocus([]),await(0,d.$Xg)(0),await this.focusNextPage(C,V))}}async focusPreviousPage(C,V){let $;const U=this.k.getScrollTop();U===0?$=this.k.indexAt(U):$=this.k.indexAfter(U-1);const Q=this.getFocus()[0];if(Q!==$&&(Q===void 0||Q>=$)){const p=this.E($,!1,V);p>-1&&Q!==p?this.setFocus([p],C):this.setFocus([$],C)}else{const p=U;this.k.setScrollTop(U-this.k.renderHeight),this.k.getScrollTop()!==p&&(this.setFocus([]),await(0,d.$Xg)(0),await this.focusPreviousPage(C,V))}}focusLast(C,V){if(this.length===0)return;const $=this.F(this.length-1,!1,V);$>-1&&this.setFocus([$],C)}focusFirst(C,V){this.focusNth(0,C,V)}focusNth(C,V,$){if(this.length===0)return;const U=this.E(C,!1,$);U>-1&&this.setFocus([U],V)}E(C,V=!1,$){for(let U=0;U<this.length;U++){if(C>=this.length&&!V)return-1;if(C=C%this.length,!$||$(this.element(C)))return C;C++}return-1}F(C,V=!1,$){for(let U=0;U<this.length;U++){if(C<0&&!V)return-1;if(C=(this.length+C%this.length)%this.length,!$||$(this.element(C)))return C;C--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(C=>this.k.element(C))}reveal(C,V){if(C<0||C>=this.length)throw new n.$0Q(this.A,`Invalid index ${C}`);const $=this.k.getScrollTop(),U=this.k.elementTop(C),Q=this.k.elementHeight(C);if((0,m.$Ff)(V)){const p=Q-this.k.renderHeight;this.k.setScrollTop(p*(0,h.$Tl)(V,0,1)+U)}else{const p=U+Q,A=$+this.k.renderHeight;U<$&&p>=A||(U<$||p>=A&&Q>=this.k.renderHeight?this.k.setScrollTop(U):p>=A&&this.k.setScrollTop(p-this.k.renderHeight))}}getRelativeTop(C){if(C<0||C>=this.length)throw new n.$0Q(this.A,`Invalid index ${C}`);const V=this.k.getScrollTop(),$=this.k.elementTop(C),U=this.k.elementHeight(C);if($<V||$+U>V+this.k.renderHeight)return null;const Q=U-this.k.renderHeight;return Math.abs((V-$)/Q)}isDOMFocused(){return(0,v.$DP)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getElementID(C){return this.k.getElementDomId(C)}style(C){this.q.style(C)}G({indexes:C,browserEvent:V}){return{indexes:C,elements:C.map($=>this.k.element($)),browserEvent:V}}H(){const C=this.c.get();this.k.domNode.classList.toggle("element-focused",C.length>0),this.I()}I(){const C=this.c.get();if(C.length>0){let V;this.u?.getActiveDescendantId&&(V=this.u.getActiveDescendantId(this.k.element(C[0]))),this.k.domNode.setAttribute("aria-activedescendant",V||this.k.getElementDomId(C[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const C=this.d.get();this.k.domNode.classList.toggle("selection-none",C.length===0),this.k.domNode.classList.toggle("selection-single",C.length===1),this.k.domNode.classList.toggle("selection-multiple",C.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$rR=W,Xe([R.$mh],W.prototype,"onDidChangeFocus",null),Xe([R.$mh],W.prototype,"onDidChangeSelection",null),Xe([R.$mh],W.prototype,"onContextMenu",null),Xe([R.$mh],W.prototype,"onKeyDown",null),Xe([R.$mh],W.prototype,"onKeyUp",null),Xe([R.$mh],W.prototype,"onKeyPress",null),Xe([R.$mh],W.prototype,"onDidFocus",null),Xe([R.$mh],W.prototype,"onDidBlur",null)}),define($e[62],we([1,0,6,35,37,12,15]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ck=t.$bk=t.$ak=t.$_j=t.$$j=t.$0j=t.$9j=t.$8j=t.MarkdownStringTextNewlineStyle=void 0;var D;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(D||(t.MarkdownStringTextNewlineStyle=D={}));class c{constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,v.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=0){return this.value+=s(this.supportThemeIcons?(0,T.$2j)(m):m).replace(/([ \t]+)/g,(r,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(m,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(m,n){const r=new RegExp((0,H.$Ie)(n),"g");return m.replace(r,(b,u)=>m.charAt(u-1)!=="\\"?`\\${b}`:b)}}t.$8j=c;function d(l){return f(l)?!l.value:Array.isArray(l)?l.every(d):!0}t.$9j=d;function f(l){return l instanceof c?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}t.$0j=f;function R(l,m){return l===m?!0:!l||!m?!1:l.value===m.value&&l.isTrusted===m.isTrusted&&l.supportThemeIcons===m.supportThemeIcons&&l.supportHtml===m.supportHtml&&(l.baseUri===m.baseUri||!!l.baseUri&&!!m.baseUri&&(0,i.$rg)(w.URI.from(l.baseUri),w.URI.from(m.baseUri)))}t.$$j=R;function s(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$_j=s;function a(l){return l.replace(/"/g,"&quot;")}t.$ak=a;function e(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$bk=e;function h(l){const m=[],n=l.split("|").map(b=>b.trim());l=n[0];const r=n[1];if(r){const b=/height=(\d+)/.exec(r),u=/width=(\d+)/.exec(r),o=b?b[1]:"",N=u?u[1]:"",j=isFinite(parseInt(N)),L=isFinite(parseInt(o));j&&m.push(`width="${N}"`),L&&m.push(`height="${o}"`)}return{href:l,dimensions:m}}t.$ck=h}),define($e[125],we([1,0,3,117,22,55,14,20,118,6,4,62,35,77,28,2,79,53,31,51,37,12,15]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s,a,e,h,l,m,n,r,b,u,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yR=t.$xR=t.$wR=t.$vR=t.$uR=void 0;const N=Object.freeze({image:(Z,W,Y)=>{let C=[],V=[];return Z&&({href:Z,dimensions:C}=(0,R.$ck)(Z),V.push(`src="${(0,R.$ak)(Z)}"`)),Y&&V.push(`alt="${(0,R.$ak)(Y)}"`),W&&V.push(`title="${(0,R.$ak)(W)}"`),C.length&&(V=V.concat(C)),"<img "+V.join(" ")+">"},paragraph:Z=>`<p>${Z}</p>`,link:(Z,W,Y)=>typeof Z!="string"?"":(Z===Y&&(Y=(0,R.$bk)(Y)),W=typeof W=="string"?(0,R.$ak)((0,R.$bk)(W)):"",Z=(0,R.$bk)(Z),Z=Z.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Z}" title="${W||Z}">${Y}</a>`)});function j(Z,W={},Y={}){const C=new h.$Qc;let V=!1;const $=(0,H.$3Q)(W),U=function(F){let z;try{z=(0,m.$qh)(decodeURIComponent(F))}catch{}return z?(z=(0,r.$bn)(z,G=>{if(Z.uris&&Z.uris[G])return o.URI.revive(Z.uris[G])}),encodeURIComponent(JSON.stringify(z))):F},Q=function(F,z){const G=Z.uris&&Z.uris[F];let ee=o.URI.revive(G);return z?F.startsWith(n.Schemas.data+":")?F:(ee||(ee=o.URI.parse(F)),n.$fg.uriToBrowserUri(ee).toString(!0)):!ee||o.URI.parse(F).toString()===ee.toString()?F:(ee.query&&(ee=ee.with({query:U(ee.query)})),ee.toString())},p=new l.marked.Renderer;p.image=N.image,p.link=N.link,p.paragraph=N.paragraph;const A=[],E=[];if(W.codeBlockRendererSync?p.code=(F,z)=>{const G=a.$HM.nextId(),ee=W.codeBlockRendererSync(L(z),F);return E.push([G,ee]),`<div class="code" data-code="${G}">${(0,u.$He)(F)}</div>`}:W.codeBlockRenderer&&(p.code=(F,z)=>{const G=a.$HM.nextId(),ee=W.codeBlockRenderer(L(z),F);return A.push(ee.then(ne=>[G,ne])),`<div class="code" data-code="${G}">${(0,u.$He)(F)}</div>`}),W.actionHandler){const F=function(ee){let ne=ee.target;if(!(ne.tagName!=="A"&&(ne=ne.parentElement,!ne||ne.tagName!=="A")))try{let me=ne.dataset.href;me&&(Z.baseUri&&(me=g(o.URI.from(Z.baseUri),me)),W.actionHandler.callback(me,ee))}catch(me){(0,d.$Z)(me)}finally{ee.preventDefault()}},z=W.actionHandler.disposables.add(new i.$4Q($,"click")),G=W.actionHandler.disposables.add(new i.$4Q($,"auxclick"));W.actionHandler.disposables.add(f.Event.any(z.event,G.event)(ee=>{const ne=new D.$UO(ee);!ne.leftButton&&!ne.middleButton||F(ne)})),W.actionHandler.disposables.add(v.$3O($,"keydown",ee=>{const ne=new w.$ZO(ee);!ne.equals(10)&&!ne.equals(3)||F(ne)}))}Z.supportHtml||(Y.sanitizer=F=>(Z.isTrusted?F.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?F:"",Y.sanitize=!0,Y.silent=!0),Y.renderer=p;let M=Z.value??"";M.length>1e5&&(M=`${M.substr(0,1e5)}\u2026`),Z.supportThemeIcons&&(M=(0,s.$3j)(M));let k;if(W.fillInIncompleteTokens){const F={...l.marked.defaults,...Y},z=l.marked.lexer(M,F),G=se(z);k=l.marked.parser(G,F)}else k=l.marked.parse(M,Y);Z.supportThemeIcons&&(k=(0,c.$sR)(k).map(z=>typeof z=="string"?z:z.outerHTML).join(""));const S=new DOMParser().parseFromString(y(Z,k),"text/html");if(S.body.querySelectorAll("img").forEach(F=>{const z=F.getAttribute("src");if(z){let G=z;try{Z.baseUri&&(G=g(o.URI.from(Z.baseUri),G))}catch{}F.src=Q(G,!0)}}),S.body.querySelectorAll("a").forEach(F=>{const z=F.getAttribute("href");if(F.setAttribute("href",""),!z||/^data:|javascript:/i.test(z)||/^command:/i.test(z)&&!Z.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(z))F.replaceWith(...F.childNodes);else{let G=Q(z,!1);Z.baseUri&&(G=g(o.URI.from(Z.baseUri),z)),F.dataset.href=G}}),$.innerHTML=y(Z,S.body.innerHTML),A.length>0)Promise.all(A).then(F=>{if(V)return;const z=new Map(F),G=$.querySelectorAll("div[data-code]");for(const ee of G){const ne=z.get(ee.dataset.code??"");ne&&v.$5P(ee,ne)}W.asyncRenderCallback?.()});else if(E.length>0){const F=new Map(E),z=$.querySelectorAll("div[data-code]");for(const G of z){const ee=F.get(G.dataset.code??"");ee&&v.$5P(G,ee)}}if(W.asyncRenderCallback)for(const F of $.getElementsByTagName("img")){const z=C.add(v.$3O(F,"load",()=>{z.dispose(),W.asyncRenderCallback()}))}return{element:$,dispose:()=>{V=!0,C.dispose()}}}t.$uR=j;function L(Z){if(!Z)return"";const W=Z.split(/[\s+|:|,|\{|\?]/,1);return W.length?W[0]:Z}function g(Z,W){return/^\w[\w\d+.-]*:/.test(W)?W:Z.path.endsWith("/")?(0,b.$Bg)(Z,W).toString():(0,b.$Bg)((0,b.$xg)(Z),W).toString()}function y(Z,W){const{config:Y,allowedSchemes:C}=B(Z);T.addHook("uponSanitizeAttribute",($,U)=>{if(U.attrName==="style"||U.attrName==="class"){if($.tagName==="SPAN"){if(U.attrName==="style"){U.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(U.attrValue);return}else if(U.attrName==="class"){U.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(U.attrValue);return}}U.keepAttr=!1;return}});const V=v.$mQ(C);try{return T.sanitize(W,{...Y,RETURN_TRUSTED_TYPE:!0})}finally{T.removeHook("uponSanitizeAttribute"),V.dispose()}}t.$vR=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function B(Z){const W=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return Z.isTrusted&&W.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...v.$nQ],ALLOWED_ATTR:t.$vR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:W}}function q(Z){return typeof Z=="string"?Z:x(Z)}t.$wR=q;function x(Z){let W=Z.value??"";W.length>1e5&&(W=`${W.substr(0,1e5)}\u2026`);const Y=l.marked.parse(W,{renderer:O.value}).replace(/&(#\d+|[a-zA-Z]+);/g,C=>P.get(C)??C);return y({isTrusted:!1},Y).toString()}t.$xR=x;const P=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),O=new e.$U(()=>{const Z=new l.marked.Renderer;return Z.code=W=>W,Z.blockquote=W=>W,Z.html=W=>"",Z.heading=(W,Y,C)=>W+`
`,Z.hr=()=>"",Z.list=(W,Y)=>W,Z.listitem=W=>W+`
`,Z.paragraph=W=>W+`
`,Z.table=(W,Y)=>W+Y+`
`,Z.tablerow=W=>W,Z.tablecell=(W,Y)=>W+" ",Z.strong=W=>W,Z.em=W=>W,Z.codespan=W=>W,Z.br=()=>`
`,Z.del=W=>W,Z.image=(W,Y,C)=>"",Z.text=W=>W,Z.link=(W,Y,C)=>C,Z});function K(Z){let W="";return Z.forEach(Y=>{W+=Y.raw}),W}function te(Z){for(const W of Z.tokens)if(W.type==="text"){const Y=W.raw.split(`
`),C=Y[Y.length-1];if(C.includes("`"))return le(Z);if(C.includes("**"))return Pe(Z);if(C.match(/\*\w/))return oe(Z);if(C.match(/(^|\s)__\w/))return de(Z);if(C.match(/(^|\s)_\w/))return be(Z);if(C.match(/(^|\s)\[.*\]\(\w*/))return Se(Z);if(C.match(/(^|\s)\[\w/))return Ae(Z)}}function se(Z){let W,Y;for(W=0;W<Z.length;W++){const C=Z[W];if(C.type==="paragraph"&&C.raw.match(/(\n|^)```/)){Y=fe(Z.slice(W));break}if(C.type==="paragraph"&&C.raw.match(/(\n|^)\|/)){Y=ce(Z.slice(W));break}if(W===Z.length-1&&C.type==="paragraph"){const V=te(C);if(V){Y=[V];break}}}if(Y){const C=[...Z.slice(0,W),...Y];return C.links=Z.links,C}return Z}t.$yR=se;function fe(Z){const W=K(Z);return l.marked.lexer(W+"\n```")}function le(Z){return ie(Z,"`")}function oe(Z){return ie(Z,"*")}function be(Z){return ie(Z,"_")}function Se(Z){return ie(Z,")")}function Ae(Z){return ie(Z,"](about:blank)")}function Pe(Z){return ie(Z,"**")}function de(Z){return ie(Z,"__")}function ie(Z,W){const Y=K(Array.isArray(Z)?Z:[Z]);return l.marked.lexer(Y+W)[0]}function ce(Z){const W=K(Z),Y=W.split(`
`);let C,V=!1;for(let $=0;$<Y.length;$++){const U=Y[$].trim();if(typeof C>"u"&&U.match(/^\s*\|/)){const Q=U.match(/(\|[^\|]+)(?=\||$)/g);Q&&(C=Q.length)}else if(typeof C=="number")if(U.match(/^\s*\|/)){if($!==Y.length-1)return;V=!0}else return}if(typeof C=="number"&&C>0){const $=V?Y.slice(0,-1).join(`
`):W,U=!!$.match(/\|\s*$/),Q=$+(U?"":"|")+`
|${" --- |".repeat(C)}`;return l.marked.lexer(Q)}}}),define($e[126],we([1,0,3,9,29,62,35,2,7,107]),function(ae,t,v,T,i,H,w,D,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UQ=t.$TQ=void 0;function f(a,e){(0,c.$Bf)(e)?a.title=(0,w.$4j)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$TQ=f;class R{constructor(e,h,l){this.c=e,this.d=h,this.f=l}async update(e,h,l){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let m;if(e===void 0||(0,c.$Bf)(e)||e instanceof HTMLElement)m=e;else if(!(0,c.$Pf)(e.markdown))m=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,d.localize)(0,null),h),this.b=new i.$1d;const n=this.b.token;if(m=await e.markdown(n),m===void 0&&(m=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(m,h,l)}g(e,h,l){const m=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!m,...l};this.a=this.c.showHover(n,h)}m?.dispose()}h(e){return e?(0,H.$0j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(a,e,h,l){let m,n;const r=(j,L)=>{const g=n!==void 0;j&&(n?.dispose(),n=void 0),L&&(m?.dispose(),m=void 0),g&&a.onDidHideHover?.()},b=(j,L,g)=>new T.$7g(async()=>{(!n||n.isDisposed)&&(n=new R(a,g||e,j>0),await n.update(h,L,l))},j),u=()=>{if(m)return;const j=new D.$Qc,L=B=>r(!1,B.fromElement===e);j.add(v.$3O(e,v.$VP.MOUSE_LEAVE,L,!0));const g=()=>r(!0,!0);j.add(v.$3O(e,v.$VP.MOUSE_DOWN,g,!0));const y={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const B=q=>{y.x=q.x+10,q.target instanceof HTMLElement&&q.target.classList.contains("action-label")&&r(!0,!0)};j.add(v.$3O(e,v.$VP.MOUSE_MOVE,B,!0))}j.add(b(a.delay,!1,y)),m=j},o=v.$3O(e,v.$VP.MOUSE_OVER,u,!0);return{show:j=>{r(!1,!0),b(0,j)},hide:()=>{r(!0,!0)},update:async(j,L)=>{h=j,await n?.update(h,void 0,L)},dispose:()=>{o.dispose(),r(!0,!0)}}}t.$UQ=s}),define($e[127],we([1,0,3,22,14,125,39,11,4,44,2,5,109,100]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zR=void 0;const a=v.$,e="selectOption.entry.template";class h{get templateId(){return e}renderTemplate(n){const r=Object.create(null);return r.root=n,r.text=v.$3P(n,a(".option-text")),r.detail=v.$3P(n,a(".option-detail")),r.decoratorRight=v.$3P(n,a(".option-decorator-right")),r}renderElement(n,r,b){const u=b,o=n.text,N=n.detail,j=n.decoratorRight,L=n.isDisabled;u.text.textContent=o,u.detail.textContent=N||"",u.decoratorRight.innerText=j||"",L?u.root.classList.add("option-disabled"):u.root.classList.remove("option-disabled")}disposeTemplate(n){}}class l extends f.$Rc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,r,b,u,o){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=u,this.g=o||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=l.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new c.$Qd,this.B(this.r),this.O(),this.N(b),this.n=r||0,n&&this.setOptions(n,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=v.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=v.$3P(this.w,a(".select-box-details-pane"));const r=v.$3P(this.w,a(".select-box-dropdown-container-width-control")),b=v.$3P(r,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",v.$3P(b,this.D),this.G=0,this.y=v.$LP(this.w),this.w.setAttribute("draggable","true"),this.B(v.$3O(this.w,v.$VP.DRAG_START,u=>{v.$XP.stop(u,!0)}))}O(){this.B(v.$4O(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(v.$3O(this.h,v.$VP.CLICK,r=>{v.$XP.stop(r),this.f?this.X(!0):this.W()})),this.B(v.$3O(this.h,v.$VP.MOUSE_DOWN,r=>{v.$XP.stop(r)}));let n;this.B(v.$3O(this.h,"touchstart",r=>{n=this.f})),this.B(v.$3O(this.h,"touchend",r=>{v.$XP.stop(r),n?this.X(!0):this.W()})),this.B(v.$3O(this.h,v.$VP.KEY_DOWN,r=>{const b=new i.$ZO(r);let u=!1;R.$j?(b.keyCode===18||b.keyCode===16||b.keyCode===10||b.keyCode===3)&&(u=!0):(b.keyCode===18&&b.altKey||b.keyCode===16&&b.altKey||b.keyCode===10||b.keyCode===3)&&(u=!0),u&&(this.W(),v.$XP.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,r){D.$tb(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,u)=>{this.h.add(this.U(b.text,u,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",r=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=r,this.h.style.borderColor=b}S(){const n=this.s.selectBackground??"",r=v.$iQ(this.s.selectListBackground,n);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,r,b){const u=document.createElement("option");return u.value=n,u.text=n,u.disabled=!!b,u}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,r){return n.appendChild(this.w),this.ab(r),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((r,b)=>{this.hb(b),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=v.$IP(this.h),b=v.$mP(this.h),u=v.$IP(this.h).getComputedStyle(this.h),o=parseFloat(u.getPropertyValue("--dropdown-padding-top"))+parseFloat(u.getPropertyValue("--dropdown-padding-bottom")),N=r.innerHeight-b.top-b.height-(this.g.minBottomMargin||0),j=b.top-l.b,L=this.h.offsetWidth,g=this.bb(this.D),y=Math.max(g,Math.round(L)).toString()+"px";this.w.style.width=y,this.z.getHTMLElement().style.height="",this.z.layout();let B=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const q=this.H?this.L:0,x=B+o+q,P=Math.floor((N-o-q)/this.getHeight()),O=Math.floor((j-o-q)/this.getHeight());if(n)return b.top+b.height>r.innerHeight-22||b.top<l.b||P<1&&O<1?!1:(P<l.c&&O>P&&this.m.length>P?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(b.top+b.height>r.innerHeight-22||b.top<l.b||this.G===0&&P<1||this.G===1&&O<1)return this.X(!0),!1;if(this.G===0){if(this.f&&P+O<1)return this.X(!0),!1;x>N&&(B=P*this.getHeight())}else x>j&&(B=O*this.getHeight());return this.z.layout(B),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=B+o+"px",this.w.style.height=""):this.w.style.height=B+o+"px",this.hb(this.n),this.w.style.width=y,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let r=0;if(n){let b=0,u=0;this.m.forEach((o,N)=>{const j=o.detail?o.detail.length:0,L=o.decoratorRight?o.decoratorRight.length:0,g=o.text.length+j+L;g>u&&(b=N,u=g)}),n.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),r=v.$oP(n)}return r}cb(n){if(this.z)return;this.C=v.$3P(n,a(".select-box-dropdown-list-container")),this.t=new h,this.z=new w.$rR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:u=>{let o=u.text;return u.detail&&(o+=`. ${u.detail}`),u.decoratorRight&&(o+=`. ${u.decoratorRight}`),u.description&&(o+=`. ${u.description}`),o},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>R.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new T.$4Q(this.C,"keydown")),b=c.Event.chain(r.event,u=>u.filter(()=>this.z.length>0).map(o=>new i.$ZO(o)));this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===3))(this.jb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===2))(this.jb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===9))(this.ib,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===16))(this.lb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===18))(this.kb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===12))(this.nb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===11))(this.mb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===14))(this.ob,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===13))(this.pb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode>=21&&o.keyCode<=56||o.keyCode>=85&&o.keyCode<=113))(this.qb,this)),this.B(v.$3O(this.z.getHTMLElement(),v.$VP.POINTER_UP,u=>this.db(u))),this.B(this.z.onMouseOver(u=>typeof u.index<"u"&&this.z.setFocus([u.index]))),this.B(this.z.onDidChangeFocus(u=>this.gb(u))),this.B(v.$3O(this.w,v.$VP.FOCUS_OUT,u=>{!this.f||v.$uP(u.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;v.$XP.stop(n);const r=n.target;if(!r||r.classList.contains("slider"))return;const b=r.closest(".monaco-list-row");if(!b)return;const u=Number(b.getAttribute("data-index")),o=b.classList.contains("option-disabled");u>=0&&u<this.m.length&&!o&&(this.n=u,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,r){const b=o=>{for(let N=0;N<o.childNodes.length;N++){const j=o.childNodes.item(N);(j.tagName&&j.tagName.toLowerCase())==="img"?o.removeChild(j):b(j)}},u=(0,H.$uR)({value:n,supportThemeIcons:!0},{actionHandler:r});return u.element.classList.add("select-box-description-markdown"),b(u.element),u.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const r=this.m[n],b=r?.description??"",u=r?.descriptionIsMarkdown??!1;if(b){if(u){const o=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(b,o))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){v.$XP.stop(n),this.select(this.F),this.X(!0)}jb(n){v.$XP.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){v.$XP.stop(n,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(v.$XP.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){v.$XP.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){v.$XP.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){v.$XP.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){v.$XP.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const r=d.KeyCodeUtils.toString(n.keyCode);let b=-1;for(let u=0;u<this.m.length-1;u++)if(b=(u+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===r&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),v.$XP.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$zR=l}),define($e[128],we([1,0,39,127,121,21,5,99]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CR=t.$BR=void 0,t.$BR={...v.$qR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class D extends H.$DQ{constructor(d,f,R,s,a){super(),w.$j&&!a?.useCustomDrawn?this.a=new i.$AR(d,f,s,a):this.a=new T.$zR(d,f,R,s,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(d,f){this.a.setOptions(d,f)}select(d){this.a.select(d)}setAriaLabel(d){this.a.setAriaLabel(d)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(d){this.a.setFocusable(d)}render(d){this.a.render(d)}}t.$CR=D}),define($e[63],we([1,0,17,54,3,24,126,128,36,2,5,7,104,52]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JR=t.$IR=t.$HR=void 0;class a extends d.$Rc{get action(){return this._action}constructor(m,n,r={}){super(),this.m=r,this._context=m||this,this._action=n,n instanceof c.$zi&&this.B(n.onDidChange(b=>{this.element&&this.t(b)}))}t(m){m.enabled!==void 0&&this.u(),m.checked!==void 0&&this.G(),m.class!==void 0&&this.F(),m.label!==void 0&&(this.w(),this.C()),m.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new c.$Ai)),this.j}set actionRunner(m){this.j=m}isEnabled(){return this._action.enabled}setActionContext(m){this._context=m}render(m){const n=this.element=m;this.B(H.$zQ.addTarget(m));const r=this.m&&this.m.draggable;r&&(m.draggable=!0,v.$IO&&this.B((0,i.$3O)(m,i.$VP.DRAG_START,b=>b.dataTransfer?.setData(T.$xQ.TEXT,this._action.label)))),this.B((0,i.$3O)(n,H.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,i.$3O)(n,i.$VP.MOUSE_DOWN,b=>{r||i.$XP.stop(b,!0),this._action.enabled&&b.button===0&&n.classList.add("active")})),f.$j&&this.B((0,i.$3O)(n,i.$VP.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,i.$3O)(n,i.$VP.CLICK,b=>{i.$XP.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,i.$3O)(n,i.$VP.DBLCLICK,b=>{i.$XP.stop(b,!0)})),[i.$VP.MOUSE_UP,i.$VP.MOUSE_OUT].forEach(b=>{this.B((0,i.$3O)(n,b,u=>{i.$XP.stop(u),n.classList.remove("active")}))})}onClick(m,n=!1){i.$XP.stop(m,!0);const r=R.$Kf(this._context)?this.m?.useEventAsContext?m:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(m){this.element&&(this.element.tabIndex=m?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const m=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(m):(this.f=(0,w.$UQ)(this.m.hoverDelegate,this.element,m),this.q.add(this.f))):this.element.title=m}D(){if(this.element){const m=this.z()??"";this.element.setAttribute("aria-label",m)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$HR=a;class e extends a{constructor(m,n,r){super(m,n,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(m){super.render(m),R.$Lf(this.element);const n=document.createElement("a");if(n.classList.add("action-label"),n.setAttribute("role",this.L()),this.H=n,this.element.appendChild(n),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===c.$Bi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(m){this.H&&(this.H.tabIndex=m?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let m=null;return this.action.tooltip?m=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(m=this.action.label,this.m.keybinding&&(m=s.localize(0,null,m,this.m.keybinding))),m??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const m=this.z()??"";this.H.setAttribute("aria-label",m)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$IR=e;class h extends a{constructor(m,n,r,b,u,o,N){super(m,n),this.b=new D.$CR(r,b,u,o,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(m,n){this.b.setOptions(m,n)}select(m){this.b.select(m)}g(){this.B(this.b.onDidSelect(m=>this.n(m.selected,m.index)))}n(m,n){this.actionRunner.run(this._action,this.r(m,n))}r(m,n){return m}setFocusable(m){this.b.setFocusable(m)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(m){this.b.render(m)}}t.$JR=h}),define($e[64],we([1,0,3,14,63,36,4,2,7,52]),function(ae,t,v,T,i,H,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WQ=t.$VQ=t.ActionsOrientation=void 0;var d;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(d||(t.ActionsOrientation=d={}));class f extends D.$Rc{constructor(a,e={}){super(),this.g=this.B(new D.$Qc),this.r=this.B(new D.$Zc),this.w=!1,this.y=!0,this.C=this.B(new w.$Qd),this.onDidBlur=this.C.event,this.D=this.B(new w.$Qd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new w.$Qd),this.onDidRun=this.G.event,this.H=this.B(new w.$Qd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new H.$Ai,this.g.add(this.f)),this.g.add(this.f.onDidRun(m=>this.G.fire(m))),this.g.add(this.f.onWillRun(m=>this.H.fire(m))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let h,l;switch(this.m){case 0:h=[15],l=[17];break;case 1:h=[16],l=[18],this.domNode.className+=" vertical";break}this.B(v.$3O(this.domNode,v.$VP.KEY_DOWN,m=>{const n=new T.$ZO(m);let r=!0;const b=typeof this.t=="number"?this.viewItems[this.t]:void 0;h&&(n.equals(h[0])||n.equals(h[1]))?r=this.P():l&&(n.equals(l[0])||n.equals(l[1]))?r=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?r=this.M():n.equals(13)?r=this.N():n.equals(2)&&b instanceof i.$HR&&b.trapsArrowNavigation?r=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:r=!1,r&&(n.preventDefault(),n.stopPropagation())})),this.B(v.$3O(this.domNode,v.$VP.KEY_UP,m=>{const n=new T.$ZO(m);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(v.$1P(this.domNode)),this.B(this.u.onDidBlur(()=>{(v.$CP()===this.domNode||!v.$uP(v.$CP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(h=>h instanceof i.$HR&&h.isEnabled());e instanceof i.$HR&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$HR&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(h=>{e=e||a.equals(h)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(v.$uP(v.$CP(),e)){this.t=a,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const h=Array.isArray(a)?a:[a];let l=c.$Ff(e.index)?e.index:null;h.forEach(m=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let r;const b={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(m,b)),r||(r=new i.$IR(this.context,m,b)),this.b.allowContextMenu||this.r.set(r,v.$3O(n,v.$VP.CONTEXT_MENU,u=>{v.$XP.stop(u,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(n),this.y&&r instanceof i.$HR&&this.viewItems.length===0&&r.setFocusable(!0),l===null||l<0||l>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(r)):(this.z.insertBefore(n,this.z.children[l]),this.viewItems.splice(l,0,r),l++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,D.$Mc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,D.$Mc)(this.viewItems),this.r.clearAndDisposeAll(),v.$2O(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,h;if(a===void 0?e=!0:typeof a=="number"?h=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const l=this.viewItems.findIndex(m=>m.isEnabled());this.t=l===-1?void 0:l,this.Q(void 0,void 0,!0)}else h!==void 0&&(this.t=h),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let h;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,h=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===H.$Bi.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let h;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}h=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===H.$Bi.ID));return this.Q(!0),!0}Q(a,e,h=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const l=this.t!==void 0?this.viewItems[this.t]:void 0;if(l){let m=!0;c.$Pf(l.focus)||(m=!1),this.b.focusOnlyEnabledItems&&c.$Pf(l.isEnabled)&&!l.isEnabled()&&(m=!1),l.action.id===H.$Bi.ID&&(m=!1),m&&l.showHover?.(),m?(h||this.s!==this.t)&&(l.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$HR){const h=e._context===null||e._context===void 0?a:e._context;this.run(e._action,h)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,D.$Mc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$VQ=f;function R(s){if(!s.length)return s;let a=-1;for(let h=0;h<s.length;h++)if(s[h].id!==H.$Bi.ID){a=h;break}if(a===-1)return[];s=s.slice(a);for(let h=s.length-1;h>=0&&s[h].id===H.$Bi.ID;h--)s.splice(h,1);let e=!1;for(let h=s.length-1;h>=0;h--){const l=s[h].id===H.$Bi.ID;l&&!e?s.splice(h,1):l?l&&(e=!1):e=!0}return s}t.$WQ=R}),define($e[65],we([1,0,3,22,55,64,57,60,21,4,81,51,108,96]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oS=t.$nS=t.$mS=t.MessageType=void 0;const a=v.$;var e;(function(m){m[m.INFO=1]="INFO",m[m.WARNING=2]="WARNING",m[m.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$mS={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class h extends c.$DQ{constructor(n,r,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new d.$Qd),this.onDidChange=this.O.event,this.P=this.B(new d.$Qd),this.onDidHeightChange=this.P.event,this.a=r,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=v.$3P(n,a(".monaco-inputbox.idle"));const u=this.g.flexibleHeight?"textarea":"input",o=v.$3P(this.element,a(".ibwrapper"));if(this.b=v.$3P(o,a(u+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=v.$3P(o,a("div.mirror")),this.y.innerText="\xA0",this.N=new D.$NQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),v.$3P(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(L=>this.b.scrollTop=L.scrollTop));const N=this.B(new T.$4Q(n.ownerDocument,"selectionchange")),j=d.Event.filter(N.event,()=>n.ownerDocument.getSelection()?.anchorNode===o);this.B(j(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new H.$VQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:v.$sP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return v.$DP(this.b)}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return v.$oP(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,u=parseFloat(this.y.style.paddingRight||"")||0;r=b+u}this.b.style.width=n-r+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,r=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:r}),this.N.setScrollPosition({scrollTop:b})}showMessage(n,r){if(this.w==="open"&&(0,R.$dn)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${v.$iQ(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const r=this.g.inputBoxStyles;switch(n){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const r=()=>n.style.width=v.$oP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:u=>{if(!this.h)return null;n=v.$3P(u,a(".monaco-inputbox-container")),r();const o={inline:!0,className:"monaco-inputbox-message"},N=this.h.formatContent?(0,i.$2Q)(this.h.content,o):(0,i.$1Q)(this.h.content,o);N.classList.add(this.U(this.h.type));const j=this.stylesForType(this.h.type);return N.style.backgroundColor=j.background??"",N.style.color=j.foreground??"",N.style.border=j.border?`1px solid ${j.border}`:"",v.$3P(n,N),null},onHide:()=>{this.w="closed"},layout:r});let b;this.h.type===3?b=s.localize(0,null,this.h.content):this.h.type===2?b=s.localize(1,null,this.h.content):b=s.localize(2,null,this.h.content),w.$6Q(b),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,b=n.charCodeAt(n.length-1)===10?" ":"";(n+b).replace(/\u000c/g,"")?this.y.textContent=n+b:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,r=n.inputBackground??"",b=n.inputForeground??"",u=n.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${v.$iQ(u,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=v.$sP(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const r=this.inputElement,b=r.selectionStart,u=r.selectionEnd,o=r.value;b!==null&&u!==null&&(this.value=o.substr(0,b)+n+o.substr(u),r.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$nS=h;class l extends h{constructor(n,r,b){const u=s.localize(3,null,"\u21C5"),o=s.localize(4,null,"\u21C5");super(n,r,b),this.db=this.B(new d.$Qd),this.onDidFocus=this.db.event,this.eb=this.B(new d.$Qd),this.onDidBlur=this.eb.event,this.bb=new f.$kS(b.history,100);const N=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(u)&&!this.n.endsWith(o)&&this.bb.getHistory().length){const j=this.n.endsWith(")")?u:o,L=this.n+j;b.showPlaceholderOnFocus&&!v.$DP(this.b)?this.n=L:this.setPlaceHolder(L)}};this.cb=new MutationObserver((j,L)=>{j.forEach(g=>{g.target.textContent||N()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>N()),this.F(this.b,()=>{const j=L=>{if(this.n.endsWith(L)){const g=this.n.slice(0,this.n.length-L.length);return b.showPlaceholderOnFocus?this.n=g:this.setPlaceHolder(g),!0}else return!1};j(o)||j(u)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const r=this.getHistory();this.clearHistory(),n.forEach(b=>{this.bb.add(b)}),r.forEach(b=>{this.bb.add(b)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",w.$7Q(this.value?this.value:s.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,w.$7Q(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(n){super.setPlaceHolder(n),this.setTooltip(n)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$oS=l}),define($e[66],we([1,0,63,21,18,19,4,3,101]),function(ae,t,v,T,i,H,w,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GR=t.$FR=t.$ER=t.$DR=void 0,t.$DR={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class c extends v.$HR{constructor(s,a,e){super(s,a,e),this.a=this.B(new d({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:e.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:e.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:e.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}t.$ER=c;class d extends T.$DQ{constructor(s){super(),this.a=this.B(new w.$Qd),this.onChange=this.a.event,this.b=this.B(new w.$Qd),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const a=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,a.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&a.push(...this.c.actionClassName.split(" ")),this.s&&a.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...a),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,e=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),e.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this.s,this.a.fire(!0),e.preventDefault(),e.stopPropagation();return}this.b.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(s){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.domNode.title=s,this.domNode.setAttribute("aria-label",s)}}t.$FR=d;class f extends T.$DQ{constructor(s,a,e){super(),this.c=s,this.g=a,this.a=new d({title:this.c,isChecked:this.g,icon:i.$Zj.check,actionClassName:"monaco-checkbox",...t.$DR}),this.domNode=this.a.domNode,this.b=e,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(s){this.a.checked=s,this.h()}focus(){this.domNode.focus()}hasFocus(){return(0,D.$DP)(this.domNode)}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$GR=f}),define($e[129],we([1,0,66,18,106]),function(ae,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BS=t.$AS=t.$zS=void 0;const H=i.localize(0,null),w=i.localize(1,null),D=i.localize(2,null);class c extends v.$FR{constructor(s){super({icon:T.$Zj.caseSensitive,title:H+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$zS=c;class d extends v.$FR{constructor(s){super({icon:T.$Zj.wholeWord,title:w+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$AS=d;class f extends v.$FR{constructor(s){super({icon:T.$Zj.regex,title:D+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$BS=f}),define($e[130],we([1,0,3,129,65,21,4,105,2,95]),function(ae,t,v,T,i,H,w,D,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CS=void 0;const d=D.localize(0,null);class f extends H.$DQ{static{this.OPTION_CHANGE="optionChange"}constructor(s,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new c.$Sc),this.N=[],this.O=this.B(new w.$Qd),this.onDidOptionChange=this.O.event,this.P=this.B(new w.$Qd),this.onKeyDown=this.P.event,this.Q=this.B(new w.$Qd),this.onMouseDown=this.Q.event,this.R=this.B(new w.$Qd),this.onInput=this.R.event,this.S=this.B(new w.$Qd),this.onKeyUp=this.S.event,this.U=this.B(new w.$Qd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new w.$Qd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||d,this.h=!!e.showCommonFindToggles;const h=e.appendCaseSensitiveLabel||"",l=e.appendWholeWordsLabel||"",m=e.appendRegexLabel||"",n=e.history||[],r=!!e.flexibleHeight,b=!!e.flexibleWidth,u=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$oS(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:b,flexibleMaxHeight:u,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new T.$BS({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(N=>{this.W.fire(N)})),this.L=this.B(new T.$AS({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new T.$zS({appendTitle:h,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(N=>{this.U.fire(N)}));const o=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const j=o.indexOf(this.domNode.ownerDocument.activeElement);if(j>=0){let L=-1;N.equals(17)?L=(j+1)%o.length:N.equals(15)&&(j===0?L=o.length-1:L=j-1),N.equals(9)?(o[j].blur(),this.inputBox.focus()):L>=0&&o[L].focus(),v.$XP.stop(N,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(v.$3O(this.inputBox.inputElement,"compositionstart",o=>{this.s=!0})),this.B(v.$3O(this.inputBox.inputElement,"compositionend",o=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,o=>this.P.fire(o)),this.C(this.inputBox.inputElement,o=>this.S.fire(o)),this.D(this.inputBox.inputElement,o=>this.R.fire()),this.j(this.inputBox.inputElement,o=>this.Q.fire(o))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new c.$Qc;for(const a of s??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$CS=f}),define($e[131],we([1,0,3,22,14,64,130,65,61,39,66,58,25,36,11,9,18,19,32,4,34,2,46,7,110,102]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s,a,e,h,l,m,n,r,b,u,o,N,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aT=t.TreeFindMatchType=t.TreeFindMode=t.$_S=t.$$S=t.RenderIndentGuides=t.$0S=t.$9S=void 0;class L extends c.$eR{set context($){this.c.context=$}get context(){return this.c.context}constructor($){super($.elements.map(U=>U.element)),this.c=$}}function g(V){return V instanceof c.$eR?new L(V):V}class y{constructor($,U){this.d=$,this.f=U,this.b=u.$Rc.None,this.c=new u.$Qc}getDragURI($){return this.f.getDragURI($.element)}getDragLabel($,U){if(this.f.getDragLabel)return this.f.getDragLabel($.map(Q=>Q.element),U)}onDragStart($,U){this.f.onDragStart?.(g($),U)}onDragOver($,U,Q,p,A=!0){const E=this.f.onDragOver(g($),U&&U.element,Q,p),M=this.a!==U;if(M&&(this.b.dispose(),this.a=U),typeof U>"u")return E;if(M&&typeof E!="boolean"&&E.autoExpand&&(this.b=(0,h.$Yg)(()=>{const z=this.d(),G=z.getNodeLocation(U);z.isCollapsed(G)&&z.setCollapsed(G,!1),this.a=void 0},500,this.c)),typeof E=="boolean"||!E.accept||typeof E.bubble>"u"||E.feedback){if(!A){const z=typeof E=="boolean"?E:E.accept,G=typeof E=="boolean"?void 0:E.effect;return{accept:z,effect:G,feedback:[Q]}}return E}if(E.bubble===1){const z=this.d(),G=z.getNodeLocation(U),ee=z.getParentNodeLocation(G),ne=z.getNode(ee),me=ee&&z.getListIndex(ee);return this.onDragOver($,ne,me,p,!1)}const k=this.d(),I=k.getNodeLocation(U),S=k.getListIndex(I),F=k.getListRenderCount(I);return{...E,feedback:(0,e.$Rb)(S,S+F)}}drop($,U,Q,p){this.b.dispose(),this.a=void 0,this.f.drop(g($),U&&U.element,Q,p)}onDragEnd($){this.f.onDragEnd?.($)}dispose(){this.c.dispose(),this.f.dispose()}}function B(V,$){return $&&{...$,identityProvider:$.identityProvider&&{getId(U){return $.identityProvider.getId(U.element)}},dnd:$.dnd&&new y(V,$.dnd),multipleSelectionController:$.multipleSelectionController&&{isSelectionSingleChangeEvent(U){return $.multipleSelectionController.isSelectionSingleChangeEvent({...U,element:U.element})},isSelectionRangeChangeEvent(U){return $.multipleSelectionController.isSelectionRangeChangeEvent({...U,element:U.element})}},accessibilityProvider:$.accessibilityProvider&&{...$.accessibilityProvider,getSetSize(U){const Q=V(),p=Q.getNodeLocation(U),A=Q.getParentNodeLocation(p);return Q.getNode(A).visibleChildrenCount},getPosInSet(U){return U.visibleChildIndex+1},isChecked:$.accessibilityProvider&&$.accessibilityProvider.isChecked?U=>$.accessibilityProvider.isChecked(U.element):void 0,getRole:$.accessibilityProvider&&$.accessibilityProvider.getRole?U=>$.accessibilityProvider.getRole(U.element):()=>"treeitem",getAriaLabel(U){return $.accessibilityProvider.getAriaLabel(U.element)},getWidgetAriaLabel(){return $.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:$.accessibilityProvider&&$.accessibilityProvider.getWidgetRole?()=>$.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:$.accessibilityProvider&&$.accessibilityProvider.getAriaLevel?U=>$.accessibilityProvider.getAriaLevel(U.element):U=>U.depth,getActiveDescendantId:$.accessibilityProvider.getActiveDescendantId&&(U=>$.accessibilityProvider.getActiveDescendantId(U.element))},keyboardNavigationLabelProvider:$.keyboardNavigationLabelProvider&&{...$.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(U){return $.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(U.element)}}}}class q{constructor($){this.a=$}getHeight($){return this.a.getHeight($.element)}getTemplateId($){return this.a.getTemplateId($.element)}hasDynamicHeight($){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight($.element)}setDynamicHeight($,U){this.a.setDynamicHeight?.($.element,U)}}t.$9S=q;class x{static lift($){return $ instanceof x?$:new x($)}static empty($=0){return new x({focus:[],selection:[],expanded:Object.create(null),scrollTop:$})}constructor($){if(this.focus=new Set($.focus),this.selection=new Set($.selection),$.expanded instanceof Array){this.expanded=Object.create(null);for(const U of $.expanded)this.expanded[U]=1}else this.expanded=$.expanded;this.expanded=$.expanded,this.scrollTop=$.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$0S=x;var P;(function(V){V.None="none",V.OnHover="onHover",V.Always="always"})(P||(t.RenderIndentGuides=P={}));class O{get elements(){return this.b}constructor($,U=[]){this.b=U,this.a=new u.$Qc,this.onDidChange=r.Event.forEach($,Q=>this.b=Q,this.a)}dispose(){this.a.dispose()}}class K{static{this.a=8}constructor($,U,Q,p,A,E={}){this.o=$,this.p=U,this.q=p,this.s=A,this.b=new Map,this.c=new Map,this.d=K.a,this.f=!1,this.g=!1,this.j=new Set,this.k=u.$Rc.None,this.m=new u.$Qc,this.templateId=$.templateId,this.updateOptions(E),r.Event.map(Q,M=>M.node)(this.u,this,this.m),$.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions($={}){if(typeof $.indent<"u"){const U=(0,o.$Tl)($.indent,0,40);if(U!==this.d){this.d=U;for(const[Q,p]of this.c)this.v(Q,p)}}if(typeof $.renderIndentGuides<"u"){const U=$.renderIndentGuides!==P.None;if(U!==this.g){this.g=U;for(const[Q,p]of this.c)this.w(Q,p);if(this.k.dispose(),U){const Q=new u.$Qc;this.q.onDidChange(this.x,this,Q),this.k=Q,this.x(this.q.elements)}}}typeof $.hideTwistiesOfChildlessElements<"u"&&(this.f=$.hideTwistiesOfChildlessElements)}renderTemplate($){const U=(0,v.$3P)($,(0,v.$)(".monaco-tl-row")),Q=(0,v.$3P)(U,(0,v.$)(".monaco-tl-indent")),p=(0,v.$3P)(U,(0,v.$)(".monaco-tl-twistie")),A=(0,v.$3P)(U,(0,v.$)(".monaco-tl-contents")),E=this.o.renderTemplate(A);return{container:$,indent:Q,twistie:p,indentGuidesDisposable:u.$Rc.None,templateData:E}}renderElement($,U,Q,p){this.c.set($,Q),this.b.set($.element,$),this.v($,Q),this.o.renderElement($,U,Q.templateData,p)}disposeElement($,U,Q,p){Q.indentGuidesDisposable.dispose(),this.o.disposeElement?.($,U,Q.templateData,p),typeof p=="number"&&(this.c.delete($),this.b.delete($.element))}disposeTemplate($){this.o.disposeTemplate($.templateData)}t($){const U=this.b.get($);U&&this.u(U)}u($){const U=this.c.get($);U&&(this.x(this.q.elements),this.v($,U))}v($,U){const Q=K.a+($.depth-1)*this.d;U.twistie.style.paddingLeft=`${Q}px`,U.indent.style.width=`${Q+this.d-16}px`,$.collapsible?U.container.setAttribute("aria-expanded",String(!$.collapsed)):U.container.removeAttribute("aria-expanded"),U.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(l.$Zj.treeItemExpanded));let p=!1;this.o.renderTwistie&&(p=this.o.renderTwistie($.element,U.twistie)),$.collapsible&&(!this.f||$.visibleChildrenCount>0)?(p||U.twistie.classList.add(...m.ThemeIcon.asClassNameArray(l.$Zj.treeItemExpanded)),U.twistie.classList.add("collapsible"),U.twistie.classList.toggle("collapsed",$.collapsed)):U.twistie.classList.remove("collapsible","collapsed"),this.w($,U)}w($,U){if((0,v.$2O)(U.indent),U.indentGuidesDisposable.dispose(),!this.g)return;const Q=new u.$Qc,p=this.p();for(;;){const A=p.getNodeLocation($),E=p.getParentNodeLocation(A);if(!E)break;const M=p.getNode(E),k=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(M)&&k.classList.add("active"),U.indent.childElementCount===0?U.indent.appendChild(k):U.indent.insertBefore(k,U.indent.firstElementChild),this.s.add(M,k),Q.add((0,u.$Pc)(()=>this.s.delete(M,k))),$=M}U.indentGuidesDisposable=Q}x($){if(!this.g)return;const U=new Set,Q=this.p();$.forEach(p=>{const A=Q.getNodeLocation(p);try{const E=Q.getParentNodeLocation(A);p.collapsible&&p.children.length>0&&!p.collapsed?U.add(p):E&&U.add(Q.getNode(E))}catch{}}),this.j.forEach(p=>{U.has(p)||this.s.forEach(p,A=>A.classList.remove("active"))}),U.forEach(p=>{this.j.has(p)||this.s.forEach(p,A=>A.classList.add("active"))}),this.j=U}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,u.$Mc)(this.m)}}class te{get totalCount(){return this.a}get matchCount(){return this.b}set pattern($){this.c=$,this.d=$.toLowerCase()}constructor($,U,Q){this.g=$,this.j=U,this.k=Q,this.a=0,this.b=0,this.c="",this.d="",this.f=new u.$Qc,$.onWillRefilter(this.m,this,this.f)}filter($,U){let Q=1;if(this.k){const E=this.k.filter($,U);if(typeof E=="boolean"?Q=E?1:0:(0,R.$6S)(E)?Q=(0,R.$7S)(E.visibility):Q=E,Q===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:Q};const p=this.j.getKeyboardNavigationLabel($),A=Array.isArray(p)?p:[p];for(const E of A){const M=E&&E.toString();if(typeof M>"u")return{data:b.FuzzyScore.Default,visibility:Q};let k;if(this.g.findMatchType===be.Contiguous){const I=M.toLowerCase().indexOf(this.d);if(I>-1){k=[Number.MAX_SAFE_INTEGER,0];for(let S=this.d.length;S>0;S--)k.push(I+S-1)}}else k=(0,b.$Uj)(this.c,this.d,0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(k)return this.b++,A.length===1?{data:k,visibility:Q}:{data:{label:M,score:k},visibility:Q}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility($):2:{data:b.FuzzyScore.Default,visibility:Q}}m(){this.a=0,this.b=0}dispose(){(0,u.$Mc)(this.f)}}class se extends f.$FR{constructor($){super({icon:l.$Zj.listFilter,title:(0,j.localize)(0,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$$S=se;class fe extends f.$FR{constructor($){super({icon:l.$Zj.searchFuzzy,title:(0,j.localize)(1,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$_S=fe;const le={inputBoxStyles:D.$mS,toggleStyles:f.$DR,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(V){V[V.Highlight=0]="Highlight",V[V.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var be;(function(V){V[V.Fuzzy=0]="Fuzzy",V[V.Contiguous=1]="Contiguous"})(be||(t.TreeFindMatchType=be={}));class Se extends u.$Rc{set mode($){this.b.checked=$===oe.Filter,this.f.inputBox.setPlaceHolder($===oe.Filter?(0,j.localize)(2,null):(0,j.localize)(3,null))}set matchType($){this.c.checked=$===be.Fuzzy}get value(){return this.f.inputBox.value}set value($){this.f.inputBox.value=$}constructor($,U,Q,p,A,E){super(),this.t=U,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Qd,this.onDidDisable=this._onDidDisable.event,$.appendChild(this.a.root),this.B((0,u.$Pc)(()=>$.removeChild(this.a.root)));const M=E?.styles??le;M.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=M.listFilterWidgetBackground),M.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${M.listFilterWidgetShadow}`),this.b=this.B(new se({...M.toggleStyles,isChecked:p===oe.Filter})),this.c=this.B(new fe({...M.toggleStyles,isChecked:A===be.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?be.Fuzzy:be.Contiguous,this.q),this.f=this.B(new w.$CS(this.a.findInput,Q,{label:(0,j.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:M.inputBoxStyles,toggleStyles:M.toggleStyles,history:E?.history})),this.g=this.B(new H.$VQ(this.a.actionbar)),this.mode=p;const k=this.B(new T.$4Q(this.f.inputBox.inputElement,"keydown")),I=r.Event.chain(k.event,G=>G.map(ee=>new i.$ZO(ee)));this.B(I(G=>{if(G.equals(3)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(G.equals(18)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(G.equals(16)){G.preventDefault(),G.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const S=this.B(new a.$zi("close",(0,j.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(S,{icon:!0,label:!1});const F=this.B(new T.$4Q(this.a.grab,"mousedown"));this.B(F.event(G=>{const ee=new u.$Qc,ne=ee.add(new T.$4Q((0,v.$IP)(G),"mousemove")),me=ee.add(new T.$4Q((0,v.$IP)(G),"mouseup")),ve=this.m,Ne=G.pageX,Ce=this.s,De=G.pageY;this.a.grab.classList.add("grabbing");const Le=this.a.root.style.transition;this.a.root.style.transition="unset";const Te=We=>{const He=We.pageX-Ne;this.m=ve-He;const Me=We.pageY-De;this.s=Ce+Me,this.layout()};ee.add(ne.event(Te)),ee.add(me.event(We=>{Te(We),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Le,ee.dispose()}))}));const z=r.Event.chain(this.B(new T.$4Q(this.a.grab,"keydown")).event,G=>G.map(ee=>new i.$ZO(ee)));this.B(z(G=>{let ee,ne;if(G.keyCode===15?ee=Number.POSITIVE_INFINITY:G.keyCode===17?ee=0:G.keyCode===10&&(ee=this.m===0?Number.POSITIVE_INFINITY:0),G.keyCode===16?ne=0:G.keyCode===18&&(ne=Number.POSITIVE_INFINITY),ee!==void 0&&(G.preventDefault(),G.stopPropagation(),this.m=ee,this.layout()),ne!==void 0){G.preventDefault(),G.stopPropagation(),this.s=ne;const me=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=me},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout($=this.j){this.j=$,this.m=(0,o.$Tl)(this.m,0,Math.max(0,$-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,o.$Tl)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage($){this.f.showMessage($)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,h.$Xg)(300),super.dispose()}}class Ae{get pattern(){return this.b}get mode(){return this.d}set mode($){$!==this.d&&(this.d=$,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire($))}get matchType(){return this.f}set matchType($){$!==this.f&&(this.f=$,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire($))}constructor($,U,Q,p,A,E={}){this.t=$,this.u=Q,this.v=p,this.w=A,this.x=E,this.b="",this.c="",this.j=0,this.k=new r.$Qd,this.onDidChangeMode=this.k.event,this.m=new r.$Qd,this.onDidChangeMatchType=this.m.event,this.o=new r.$Qd,this.onDidChangePattern=this.o.event,this.p=new r.$Qd,this.onDidChangeOpenState=this.p.event,this.q=new u.$Qc,this.s=new u.$Qc,this.d=$.options.defaultFindMode??oe.Highlight,this.f=$.options.defaultFindMatchType??be.Fuzzy,U.onDidSplice(this.z,this,this.s)}updateOptions($={}){$.defaultFindMode!==void 0&&(this.mode=$.defaultFindMode),$.defaultFindMatchType!==void 0&&(this.matchType=$.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Se(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode($=>this.mode=$,void 0,this.q),this.g.onDidChangeMatchType($=>this.matchType=$,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y($){this.b=$,this.o.fire($),this.v.pattern=$,this.t.refilter(),$&&this.t.focusNext(0,!0,void 0,Q=>!b.FuzzyScore.isDefault(Q.filterData));const U=this.t.getFocus();if(U.length>0){const Q=U[0];this.t.getRelativeTop(Q)===null&&this.t.reveal(Q,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const $=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&$?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,j.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus($){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault($.filterData)}layout($){this.j=$,this.g?.layout($)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Pe(V){let $=s.TreeMouseEventTarget.Unknown;return(0,v.$yP)(V.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?$=s.TreeMouseEventTarget.Twistie:(0,v.$yP)(V.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?$=s.TreeMouseEventTarget.Element:(0,v.$yP)(V.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&($=s.TreeMouseEventTarget.Filter),{browserEvent:V.browserEvent,element:V.element?V.element.element:null,target:$}}function de(V){return{element:V.element?V.element.element:null,browserEvent:V.browserEvent,anchor:V.anchor}}function ie(V,$){$(V),V.children.forEach(U=>ie(U,$))}class ce{get f(){return this.d||(this.d=this.m()),this.d}constructor($,U){this.g=$,this.j=U,this.a=[],this.c=new r.$Qd,this.onDidChange=this.c.event}set($,U){!U?.__forceEvent&&(0,e.$tb)(this.a,$)||this.k($,!1,U)}k($,U,Q){if(this.a=[...$],this.b=void 0,this.d=void 0,!U){const p=this;this.c.fire({get elements(){return p.get()},browserEvent:Q})}}get(){return this.b||(this.b=this.a.map($=>$.element)),[...this.b]}getNodes(){return this.a}has($){return this.f.has($)}onDidModelSplice({insertedNodes:$,deletedNodes:U}){if(!this.j){const k=this.m(),I=S=>k.delete(S);U.forEach(S=>ie(S,I)),this.set([...k.values()]);return}const Q=new Set,p=k=>Q.add(this.j.getId(k.element).toString());U.forEach(k=>ie(k,p));const A=new Map,E=k=>A.set(this.j.getId(k.element).toString(),k);$.forEach(k=>ie(k,E));const M=[];for(const k of this.a){const I=this.j.getId(k.element).toString();if(!Q.has(I))M.push(k);else{const F=A.get(I);F&&F.visible&&M.push(F)}}if(this.a.length>0&&M.length===0){const k=this.g();k&&M.push(k)}this.k(M,!0)}m(){const $=new Set;for(const U of this.a)$.add(U);return $}}class Z extends d.$oR{constructor($,U){super($),this.x=U}u($){if((0,d.$kR)($.browserEvent.target)||(0,d.$iR)($.browserEvent.target)||(0,d.$jR)($.browserEvent.target)||$.browserEvent.isHandledByList)return;const U=$.element;if(!U)return super.u($);if(this.p($)||this.o($))return super.u($);const Q=$.browserEvent.target,p=Q.classList.contains("monaco-tl-twistie")||Q.classList.contains("monaco-icon-label")&&Q.classList.contains("folder-icon")&&$.browserEvent.offsetX<16;let A=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?A=this.x.expandOnlyOnTwistieClick(U.element):A=!!this.x.expandOnlyOnTwistieClick,A&&!p&&$.browserEvent.detail!==2)return super.u($);if(!this.x.expandOnDoubleClick&&$.browserEvent.detail===2)return super.u($);if(U.collapsible){const E=this.x.getNodeLocation(U),M=$.browserEvent.altKey;if(this.x.setFocus([E]),this.x.toggleCollapsed(E,M),A&&p){$.browserEvent.isHandledByList=!0;return}}super.u($)}v($){$.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||$.browserEvent.isHandledByList||super.v($)}}class W extends d.$rR{constructor($,U,Q,p,A,E,M,k){super($,U,Q,p,k),this.p=A,this.s=E,this.K=M}D($){return new Z(this,$.tree)}splice($,U,Q=[]){if(super.splice($,U,Q),Q.length===0)return;const p=[],A=[];let E;Q.forEach((M,k)=>{this.p.has(M)&&p.push($+k),this.s.has(M)&&A.push($+k),this.K.has(M)&&(E=$+k)}),p.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...p])),A.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...A])),typeof E=="number"&&super.setAnchor(E)}setFocus($,U,Q=!1){super.setFocus($,U),Q||this.p.set($.map(p=>this.element(p)),U)}setSelection($,U,Q=!1){super.setSelection($,U),Q||this.s.set($.map(p=>this.element(p)),U)}setAnchor($,U=!1){super.setAnchor($),U||(typeof $>"u"?this.K.set([]):this.K.set([this.element($)]))}}class Y{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Pe)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Pe),$=>$.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Pe)}get onPointer(){return r.Event.map(this.j.onPointer,Pe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode($){this.x&&(this.x.mode=$)}get findMatchType(){return this.x?.matchType??be.Fuzzy}set findMatchType($){this.x&&(this.x.matchType=$)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor($,U,Q,p,A={}){this.D=$,this.E=A,this.w=new r.$Yd,this.onDidChangeFindOpenState=r.Event.None,this.A=new u.$Qc,this.B=new r.$Qd,this.onWillRefilter=this.B.event,this.C=new r.$Qd,this.onDidUpdateOptions=this.C.event;const E=new q(Q),M=new r.$Zd,k=new r.$Zd,I=this.A.add(new O(k.event)),S=new n.$Fc;this.k=p.map(ne=>new K(ne,()=>this.o,M.event,I,S,A));for(const ne of this.k)this.A.add(ne);let F;A.keyboardNavigationLabelProvider&&(F=new te(this,A.keyboardNavigationLabelProvider,A.filter),A={...A,filter:F},this.A.add(F)),this.p=new ce(()=>this.j.getFocusedElements()[0],A.identityProvider),this.q=new ce(()=>this.j.getSelectedElements()[0],A.identityProvider),this.u=new ce(()=>this.j.getAnchorElement(),A.identityProvider),this.j=new W($,U,E,this.k,this.p,this.q,this.u,{...B(()=>this.o,A),tree:this}),this.o=this.I($,this.j,A),M.input=this.o.onDidChangeCollapseState;const z=r.Event.forEach(this.o.onDidSplice,ne=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(ne),this.q.onDidModelSplice(ne)})},this.A);z(()=>null,null,this.A);const G=this.A.add(new r.$Qd),ee=this.A.add(new h.$Tg(0));if(this.A.add(r.Event.any(z,this.p.onDidChange,this.q.onDidChange)(()=>{ee.trigger(()=>{const ne=new Set;for(const me of this.p.getNodes())ne.add(me);for(const me of this.q.getNodes())ne.add(me);G.fire([...ne.values()])})})),k.input=G.event,A.keyboardSupport!==!1){const ne=r.Event.chain(this.j.onKeyDown,me=>me.filter(ve=>!(0,d.$iR)(ve.target)).map(ve=>new i.$ZO(ve)));r.Event.chain(ne,me=>me.filter(ve=>ve.keyCode===15))(this.F,this,this.A),r.Event.chain(ne,me=>me.filter(ve=>ve.keyCode===17))(this.G,this,this.A),r.Event.chain(ne,me=>me.filter(ve=>ve.keyCode===10))(this.H,this,this.A)}if((A.findWidgetEnabled??!0)&&A.keyboardNavigationLabelProvider&&A.contextViewProvider){const ne=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Ae(this,this.o,this.j,F,A.contextViewProvider,ne),this.y=me=>this.x.shouldAllowFocus(me),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,v.$LP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===P.Always)}updateOptions($={}){this.E={...this.E,...$};for(const U of this.k)U.updateOptions($);this.j.updateOptions(this.E),this.x?.updateOptions($),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===P.Always)}get options(){return this.E}updateWidth($){const U=this.o.getListIndex($);U!==-1&&this.j.updateWidth(U)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop($){this.j.scrollTop=$}get scrollLeft(){return this.j.scrollLeft}set scrollLeft($){this.j.scrollLeft=$}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const $=this.j.firstVisibleIndex;return $<0||$>=this.j.length?void 0:this.j.element($).element}get lastVisibleElement(){const $=this.j.lastVisibleIndex;return this.j.element($).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel($){this.j.ariaLabel=$}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,v.$DP)(this.getHTMLElement())}layout($,U){this.j.layout($,U),(0,N.$Ff)(U)&&this.x?.layout(U)}style($){const U=`.${this.j.domId}`,Q=[];$.treeIndentGuidesStroke&&(Q.push(`.monaco-list${U}:hover .monaco-tl-indent > .indent-guide, .monaco-list${U}.always .monaco-tl-indent > .indent-guide  { border-color: ${$.treeInactiveIndentGuidesStroke}; }`),Q.push(`.monaco-list${U} .monaco-tl-indent > .indent-guide.active { border-color: ${$.treeIndentGuidesStroke}; }`)),this.z.textContent=Q.join(`
`),this.j.style($)}getParentElement($){const U=this.o.getParentNodeLocation($);return this.o.getNode(U).element}getFirstElementChild($){return this.o.getFirstElementChild($)}getNode($){return this.o.getNode($)}getNodeLocation($){return this.o.getNodeLocation($)}collapse($,U=!1){return this.o.setCollapsed($,!0,U)}expand($,U=!1){return this.o.setCollapsed($,!1,U)}toggleCollapsed($,U=!1){return this.o.setCollapsed($,void 0,U)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible($){return this.o.isCollapsible($)}setCollapsible($,U){return this.o.setCollapsible($,U)}isCollapsed($){return this.o.isCollapsed($)}expandTo($){this.o.expandTo($)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor($){if(typeof $>"u")return this.j.setAnchor(void 0);const U=this.o.getNode($);this.u.set([U]);const Q=this.o.getListIndex($);Q>-1&&this.j.setAnchor(Q,!0)}getAnchor(){return(0,e.$Nb)(this.u.get(),void 0)}setSelection($,U){const Q=$.map(A=>this.o.getNode(A));this.q.set(Q,U);const p=$.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setSelection(p,U,!0)}getSelection(){return this.q.get()}setFocus($,U){const Q=$.map(A=>this.o.getNode(A));this.p.set(Q,U);const p=$.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setFocus(p,U,!0)}focusNext($=1,U=!1,Q,p=this.y){this.j.focusNext($,U,Q,p)}focusPrevious($=1,U=!1,Q,p=this.y){this.j.focusPrevious($,U,Q,p)}focusNextPage($,U=this.y){return this.j.focusNextPage($,U)}focusPreviousPage($,U=this.y){return this.j.focusPreviousPage($,U)}focusLast($,U=this.y){this.j.focusLast($,U)}focusFirst($,U=this.y){this.j.focusFirst($,U)}getFocus(){return this.p.get()}reveal($,U){this.o.expandTo($);const Q=this.o.getListIndex($);Q!==-1&&this.j.reveal(Q,U)}getRelativeTop($){const U=this.o.getListIndex($);return U===-1?null:this.j.getRelativeTop(U)}getViewState($=this.options.identityProvider){if(!$)throw new s.$4S(this.D,"Can't get tree view state without an identity provider");const U=E=>$.getId(E).toString(),Q=x.empty(this.scrollTop);for(const E of this.getFocus())Q.focus.add(U(E));for(const E of this.getSelection())Q.selection.add(U(E));const p=this.o.getNode(),A=[p];for(;A.length>0;){const E=A.shift();E!==p&&E.collapsible&&(Q.expanded[U(E.element)]=E.collapsed?0:1),A.push(...E.children)}return Q}F($){$.preventDefault(),$.stopPropagation();const U=this.j.getFocusedElements();if(U.length===0)return;const Q=U[0],p=this.o.getNodeLocation(Q);if(!this.o.setCollapsed(p,!0)){const E=this.o.getParentNodeLocation(p);if(!E)return;const M=this.o.getListIndex(E);this.j.reveal(M),this.j.setFocus([M])}}G($){$.preventDefault(),$.stopPropagation();const U=this.j.getFocusedElements();if(U.length===0)return;const Q=U[0],p=this.o.getNodeLocation(Q);if(!this.o.setCollapsed(p,!1)){if(!Q.children.some(k=>k.visible))return;const[E]=this.j.getFocus(),M=E+1;this.j.reveal(M),this.j.setFocus([M])}}H($){$.preventDefault(),$.stopPropagation();const U=this.j.getFocusedElements();if(U.length===0)return;const Q=U[0],p=this.o.getNodeLocation(Q),A=$.browserEvent.altKey;this.o.setCollapsed(p,void 0,A)}navigate($){return new C(this.j,this.o,$)}dispose(){(0,u.$Mc)(this.A),this.j.dispose()}}t.$aT=Y;class C{constructor($,U,Q){this.b=$,this.c=U,Q?this.a=this.c.getListIndex(Q):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define($e[132],we([1,0,131,122,25,27]),function(ae,t,v,T,i,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=void 0;class w extends v.$aT{constructor(c,d,f,R,s,a={}){super(c,d,f,R,a),this.f=c,this.g=s,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(c,d){if(d&&!this.c)throw new i.$4S(this.f,"Can't restore tree view state without an identity provider");if(this.b=c,!c){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!d){this.m(c);return}const f=[],R=[],s=e=>{const h=this.c.getId(e).toString();return!d.expanded[h]},a=e=>{const h=this.c.getId(e.element).toString();d.focus.has(h)&&f.push(e.element),d.selection.has(h)&&R.push(e.element)};this.m(c,s,a),this.setFocus(f),this.setSelection(R),d&&typeof d.scrollTop=="number"&&(this.scrollTop=d.scrollTop)}updateChildren(c=this.b){if(typeof this.b>"u")throw new i.$4S(this.f,"Tree input not set");let d;this.c&&(d=f=>{const R=this.c.getId(f).toString(),s=this.d.get(R);if(s)return s.collapsed}),this.m(c,d)}resort(c=this.b,d=!0){this.o.resort(c===this.b?null:c,d)}refresh(c){if(c===void 0){this.j.rerender();return}this.o.rerender(c)}m(c,d,f){let R;if(this.c){const s=new Set,a=f;f=e=>{const h=this.c.getId(e.element).toString();s.add(h),this.d.set(h,e),a?.(e)},R=e=>{const h=this.c.getId(e.element).toString();s.has(h)||this.d.delete(h)}}this.o.setChildren(c===this.b?null:c,this.s(c,d).elements,{onDidCreateNode:f,onDidDeleteNode:R})}s(c,d){const f=[...this.g.getChildren(c)];return{elements:H.Iterable.map(f,s=>{const{elements:a,size:e}=this.s(s,d),h=this.g.hasChildren?this.g.hasChildren(s):void 0,l=e===0?void 0:d&&d(s);return{element:s,children:a,collapsible:h,collapsed:l}}),size:f.length}}I(c,d,f){return new T.$bT(c,d,f)}}t.$lT=w}),define($e[67],we([1,0,11,9,33,29,26,6,4,2,53,12,7]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dh=t.ProxyChannel=t.$Ch=t.$Bh=t.$Ah=t.$zh=t.$yh=t.$xh=t.RequestInitiator=t.$wh=t.$vh=t.$uh=t.$th=t.$sh=void 0;var a;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(a||(a={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(h||(h={}));function l(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(m||(m={}));function n(de){let ie=0;for(let ce=0;;ce+=7){const Z=de.read(1);if(ie|=(Z.buffer[0]&127)<<ce,!(Z.buffer[0]&128))return ie}}const r=j(0);function b(de,ie){if(ie===0){de.write(r);return}let ce=0;for(let W=ie;W!==0;W=W>>>7)ce++;const Z=i.$ee.alloc(ce);for(let W=0;ie!==0;W++)Z.buffer[W]=ie&127,ie=ie>>>7,ie>0&&(Z.buffer[W]|=128);de.write(Z)}class u{constructor(ie){this.b=ie,this.a=0}read(ie){const ce=this.b.slice(this.a,this.a+ie);return this.a+=ce.byteLength,ce}}t.$sh=u;class o{constructor(){this.a=[]}get buffer(){return i.$ee.concat(this.a)}write(ie){this.a.push(ie)}}t.$th=o;var N;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(N||(N={}));function j(de){const ie=i.$ee.alloc(1);return ie.writeUInt8(de,0),ie}const L={Undefined:j(N.Undefined),String:j(N.String),Buffer:j(N.Buffer),VSBuffer:j(N.VSBuffer),Array:j(N.Array),Object:j(N.Object),Uint:j(N.Int)},g=typeof Buffer<"u";function y(de,ie){if(typeof ie>"u")de.write(L.Undefined);else if(typeof ie=="string"){const ce=i.$ee.fromString(ie);de.write(L.String),b(de,ce.byteLength),de.write(ce)}else if(g&&Buffer.isBuffer(ie)){const ce=i.$ee.wrap(ie);de.write(L.Buffer),b(de,ce.byteLength),de.write(ce)}else if(ie instanceof i.$ee)de.write(L.VSBuffer),b(de,ie.byteLength),de.write(ie);else if(Array.isArray(ie)){de.write(L.Array),b(de,ie.length);for(const ce of ie)y(de,ce)}else if(typeof ie=="number"&&(ie|0)===ie)de.write(L.Uint),b(de,ie);else{const ce=i.$ee.fromString(JSON.stringify(ie));de.write(L.Object),b(de,ce.byteLength),de.write(ce)}}t.$uh=y;function B(de){switch(de.read(1).readUInt8(0)){case N.Undefined:return;case N.String:return de.read(n(de)).toString();case N.Buffer:return de.read(n(de)).buffer;case N.VSBuffer:return de.read(n(de));case N.Array:{const ce=n(de),Z=[];for(let W=0;W<ce;W++)Z.push(B(de));return Z}case N.Object:return JSON.parse(de.read(n(de)).toString());case N.Int:return n(de)}}t.$vh=B;class q{constructor(ie,ce,Z=null,W=1e3){this.h=ie,this.j=ce,this.k=Z,this.l=W,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(ie,ce){this.b.set(ie,ce),setTimeout(()=>this.w(ie),0)}m(ie){switch(ie.type){case 200:{const ce=this.o([ie.type]);this.k?.logOutgoing(ce,0,1,l(ie.type));return}case 201:case 202:case 204:case 203:{const ce=this.o([ie.type,ie.id],ie.data);this.k?.logOutgoing(ce,ie.id,1,l(ie.type),ie.data);return}}}o(ie,ce=void 0){const Z=new o;return y(Z,ie),y(Z,ce),this.p(Z.buffer)}p(ie){try{return this.h.send(ie),ie.byteLength}catch{return 0}}q(ie){const ce=new u(ie),Z=B(ce),W=B(ce),Y=Z[0];switch(Y){case 100:return this.k?.logIncoming(ie.byteLength,Z[1],1,`${e(Y)}: ${Z[2]}.${Z[3]}`,W),this.s({type:Y,id:Z[1],channelName:Z[2],name:Z[3],arg:W});case 102:return this.k?.logIncoming(ie.byteLength,Z[1],1,`${e(Y)}: ${Z[2]}.${Z[3]}`,W),this.t({type:Y,id:Z[1],channelName:Z[2],name:Z[3],arg:W});case 101:return this.k?.logIncoming(ie.byteLength,Z[1],1,`${e(Y)}`),this.u({type:Y,id:Z[1]});case 103:return this.k?.logIncoming(ie.byteLength,Z[1],1,`${e(Y)}`),this.u({type:Y,id:Z[1]})}}s(ie){const ce=this.b.get(ie.channelName);if(!ce){this.v(ie);return}const Z=new H.$1d;let W;try{W=ce.call(this.j,ie.name,ie.arg,Z.token)}catch(V){W=Promise.reject(V)}const Y=ie.id;W.then(V=>{this.m({id:Y,data:V,type:201})},V=>{V instanceof Error?this.m({id:Y,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.m({id:Y,data:V,type:203})}).finally(()=>{C.dispose(),this.d.delete(ie.id)});const C=(0,d.$Pc)(()=>Z.cancel());this.d.set(ie.id,C)}t(ie){const ce=this.b.get(ie.channelName);if(!ce){this.v(ie);return}const Z=ie.id,Y=ce.listen(this.j,ie.name,ie.arg)(C=>this.m({id:Z,data:C,type:204}));this.d.set(ie.id,Y)}u(ie){const ce=this.d.get(ie.id);ce&&(ce.dispose(),this.d.delete(ie.id))}v(ie){let ce=this.g.get(ie.channelName);ce||(ce=[],this.g.set(ie.channelName,ce));const Z=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.m({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ce.push({request:ie,timeoutTimer:Z})}w(ie){const ce=this.g.get(ie);if(ce){for(const Z of ce)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(ie)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}t.$wh=q;var x;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(x||(t.RequestInitiator=x={}));class P{constructor(ie,ce=null){this.l=ie,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new c.$Qd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=ce}getChannel(ie){const ce=this;return{call(Z,W,Y){return ce.a?Promise.reject(new D.$4):ce.m(ie,Z,W,Y)},listen(Z,W){return ce.a?c.Event.None:ce.o(ie,Z,W)}}}m(ie,ce,Z,W=H.CancellationToken.None){const Y=this.g++,V={id:Y,type:100,channelName:ie,name:ce,arg:Z};if(W.isCancellationRequested)return Promise.reject(new D.$4);let $;return new Promise((Q,p)=>{if(W.isCancellationRequested)return p(new D.$4);const A=()=>{const I=S=>{switch(S.type){case 201:this.f.delete(Y),Q(S.data);break;case 202:{this.f.delete(Y);const F=new Error(S.data.message);F.stack=Array.isArray(S.data.stack)?S.data.stack.join(`
`):S.data.stack,F.name=S.data.name,p(F);break}case 203:this.f.delete(Y),p(S.data);break}};this.f.set(Y,I),this.p(V)};let E=null;this.b===m.Idle?A():(E=(0,T.$Kg)(I=>this.u()),E.then(()=>{E=null,A()}));const M=()=>{E?(E.cancel(),E=null):this.p({id:Y,type:101}),p(new D.$4)},k=W.onCancellationRequested(M);$=(0,d.$Oc)((0,d.$Pc)(M),k),this.d.add($)}).finally(()=>{$.dispose(),this.d.delete($)})}o(ie,ce,Z){const W=this.g++,C={id:W,type:102,channelName:ie,name:ce,arg:Z};let V=null;const $=new c.$Qd({onWillAddFirstListener:()=>{V=(0,T.$Kg)(Q=>this.u()),V.then(()=>{V=null,this.d.add($),this.p(C)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete($),this.p({id:W,type:103}))}}),U=Q=>$.fire(Q.data);return this.f.set(W,U),$.event}p(ie){switch(ie.type){case 100:case 102:{const ce=this.q([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.j?.logOutgoing(ce,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const ce=this.q([ie.type,ie.id]);this.j?.logOutgoing(ce,ie.id,0,e(ie.type));return}}}q(ie,ce=void 0){const Z=new o;return y(Z,ie),y(Z,ce),this.r(Z.buffer)}r(ie){try{return this.l.send(ie),ie.byteLength}catch{return 0}}s(ie){const ce=new u(ie),Z=B(ce),W=B(ce),Y=Z[0];switch(Y){case 200:return this.j?.logIncoming(ie.byteLength,0,0,l(Y)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ie.byteLength,Z[1],0,l(Y),W),this.t({type:Z[0],id:Z[1],data:W})}}t(ie){if(ie.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(ie.id)?.(ie)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Mc)(this.d.values()),this.d.clear()}}t.$xh=P,Xe([w.$mh],P.prototype,"onDidInitializePromise",null);class O{get connections(){const ie=[];return this.f.forEach(ce=>ie.push(ce)),ie}constructor(ie){this.a=new Map,this.f=new Set,this.g=new c.$Qd,this.onDidAddConnection=this.g.event,this.h=new c.$Qd,this.onDidRemoveConnection=this.h.event,this.j=new d.$Qc,this.j.add(ie(({protocol:ce,onDidClientDisconnect:Z})=>{const W=c.Event.once(ce.onMessage);this.j.add(W(Y=>{const C=new u(Y),V=B(C),$=new q(ce,V),U=new P(ce);this.a.forEach((p,A)=>$.registerChannel(A,p));const Q={channelServer:$,channelClient:U,ctx:V};this.f.add(Q),this.g.fire(Q),this.j.add(Z(()=>{$.dispose(),U.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(ie,ce){const Z=this;return{call(W,Y,C){let V;if((0,s.$Pf)(ce)){const U=(0,v.$3b)(Z.connections.filter(ce));V=U?Promise.resolve(U):c.Event.toPromise(c.Event.filter(Z.onDidAddConnection,ce))}else V=ce.routeCall(Z,W,Y);const $=V.then(U=>U.channelClient.getChannel(ie));return te($).call(W,Y,C)},listen(W,Y){if((0,s.$Pf)(ce))return Z.k(ie,ce,W,Y);const C=ce.routeEvent(Z,W,Y).then(V=>V.channelClient.getChannel(ie));return te(C).listen(W,Y)}}}k(ie,ce,Z,W){const Y=this;let C;const V=new c.$Qd({onWillAddFirstListener:()=>{C=new d.$Qc;const $=new c.$Wd,U=new Map,Q=A=>{const M=A.channelClient.getChannel(ie).listen(Z,W),k=$.add(M);U.set(A,k)},p=A=>{const E=U.get(A);E&&(E.dispose(),U.delete(A))};Y.connections.filter(ce).forEach(Q),c.Event.filter(Y.onDidAddConnection,ce)(Q,void 0,C),Y.onDidRemoveConnection(p,void 0,C),$.event(V.fire,V,C),C.add($)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return V.event}registerChannel(ie,ce){this.a.set(ie,ce);for(const Z of this.f)Z.channelServer.registerChannel(ie,ce)}dispose(){this.j.dispose();for(const ie of this.f)ie.channelClient.dispose(),ie.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$yh=O;class K{constructor(ie,ce,Z=null){const W=new o;y(W,ce),ie.send(W.buffer),this.a=new P(ie,Z),this.d=new q(ie,ce,Z)}getChannel(ie){return this.a.getChannel(ie)}registerChannel(ie,ce){this.d.registerChannel(ie,ce)}dispose(){this.a.dispose(),this.d.dispose()}}t.$zh=K;function te(de){return{call(ie,ce,Z){return de.then(W=>W.call(ie,ce,Z))},listen(ie,ce){const Z=new c.$Zd;return de.then(W=>Z.input=W.listen(ie,ce)),Z.event}}}t.$Ah=te;function se(de){let ie=!1;return{call(ce,Z,W){return ie?de.call(ce,Z,W):(0,T.$Xg)(0).then(()=>ie=!0).then(()=>de.call(ce,Z,W))},listen(ce,Z){if(ie)return de.listen(ce,Z);const W=new c.$Zd;return(0,T.$Xg)(0).then(()=>ie=!0).then(()=>W.input=de.listen(ce,Z)),W.event}}}t.$Bh=se;class fe{constructor(ie){this.a=ie}routeCall(ie){return this.b(ie)}routeEvent(ie){return this.b(ie)}async b(ie){for(const ce of ie.connections)if(await Promise.resolve(this.a(ce.ctx)))return Promise.resolve(ce);return await c.Event.toPromise(ie.onDidAddConnection),await this.b(ie)}}t.$Ch=fe;var le;(function(de){function ie(Y,C,V){const $=Y,U=V&&V.disableMarshalling,Q=new Map;for(const p in $)Z(p)&&Q.set(p,c.Event.buffer($[p],!0,void 0,C));return new class{listen(p,A,E){const M=Q.get(A);if(M)return M;if(W(A)){const k=$[A];if(typeof k=="function")return k.call($,E)}throw new D.$ab(`Event not found: ${A}`)}call(p,A,E){const M=$[A];if(typeof M=="function"){if(!U&&Array.isArray(E))for(let I=0;I<E.length;I++)E[I]=(0,f.$rh)(E[I]);let k=M.apply($,E);return k instanceof Promise||(k=Promise.resolve(k)),k}throw new D.$ab(`Method not found: ${A}`)}}}de.fromService=ie;function ce(Y,C){const V=C&&C.disableMarshalling;return new Proxy({},{get($,U){if(typeof U=="string")return C?.properties?.has(U)?C.properties.get(U):W(U)?function(Q){return Y.listen(U,Q)}:Z(U)?Y.listen(U):async function(...Q){let p;C&&!(0,s.$Kf)(C.context)?p=[C.context,...Q]:p=Q;const A=await Y.call(U,p);return V?A:(0,f.$rh)(A)};throw new D.$ab(`Property not found: ${String(U)}`)}})}de.toService=ce;function Z(Y){return Y[0]==="o"&&Y[1]==="n"&&R.$4e(Y.charCodeAt(2))}function W(Y){return/^onDynamic/.test(Y)&&R.$4e(Y.charCodeAt(9))}})(le||(t.ProxyChannel=le={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function be(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ie=de.toString();if(ie!=="[object Object]")return ie}return de}function Se(de){return Array.isArray(de)?de.map(be):be(de)}function Ae(de,ie,ce,Z,W,Y,C){C=Se(C);const V=oe[W],$=V[Z%V.length];let U=[`%c[${de}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(Y)?(U=U.concat(C),U.push(")")):U.push(C),console.log.apply(console,U)}class Pe{constructor(ie,ce){this.d=ie,this.f=ce,this.a=0,this.b=0}logOutgoing(ie,ce,Z,W,Y){this.b+=ie,Ae(this.d,this.b,ie,ce,Z,W,Y)}logIncoming(ie,ce,Z,W,Y){this.a+=ie,Ae(this.f,this.a,ie,ce,Z,W,Y)}}t.$Dh=Pe}),define($e[133],we([1,0,33,4,67,89,30]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5T=void 0;class D extends i.$zh{static f(){const d=T.Event.fromNodeEventEmitter(w.$N,"vscode:message",(f,R)=>v.$ee.wrap(R));return w.$N.send("vscode:hello"),new H.$1T(w.$N,d)}constructor(d){const f=D.f();super(f,d),this.b=f}dispose(){this.b.disconnect()}}t.$5T=D}),define($e[134],we([13,10]),function(ae,t){return ae.create("vs/platform/files/common/files",t)}),define($e[135],we([13,10]),function(ae,t){return ae.create("vs/platform/theme/common/iconRegistry",t)}),define($e[40],we([1,0]),function(ae,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vh=t.$Uh=t.$Th=t._util=void 0;var v;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function D(c){return c[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=D})(v||(t._util=v={})),t.$Th=i("instantiationService");function T(w,D,c){D[v.DI_TARGET]===D?D[v.DI_DEPENDENCIES].push({id:w,index:c}):(D[v.DI_DEPENDENCIES]=[{id:w,index:c}],D[v.DI_TARGET]=D)}function i(w){if(v.serviceIds.has(w))return v.serviceIds.get(w);const D=function(c,d,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(D,c,f)};return D.toString=()=>w,v.serviceIds.set(w,D),D}t.$Uh=i;function H(w){return w}t.$Vh=H}),define($e[136],we([1,0,40]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xm=t.$wm=t.$vm=t.ID=void 0,t.ID="diagnosticsService",t.$vm=(0,v.$Uh)(t.ID);function T(H){return!!H.hostName&&!!H.errorMessage}t.$wm=T;class i{async getPerformanceInfo(w,D){return{}}async getSystemInfo(w,D){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(w,D){return""}async getWorkspaceFileExtensions(w){return{extensions:[]}}async reportWorkspaceStats(w){}}t.$xm=i}),define($e[137],we([1,0,87,23,12,7,15,134,40,5,31,28]),function(ae,t,v,T,i,H,w,D,c,d,f,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mk=t.$Lk=t.$Kk=t.$Jk=t.$Ik=t.FileKind=t.$Hk=t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.$Bk=t.FileOperationResult=t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.FileChangeType=t.$vk=t.FileOperation=t.$uk=t.$tk=t.$sk=t.$rk=t.$qk=t.$pk=t.FileSystemProviderErrorCode=t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.FileSystemProviderCapabilities=t.$fk=t.FilePermission=t.FileType=t.$ek=t.$dk=void 0,t.$dk=(0,c.$Uh)("fileService");function s(W){return W.create===!0}t.$ek=s;var a;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(a||(t.FileType=a={}));var e;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function h(W){const Y=W;return!!Y&&typeof Y.onDidChange=="function"}t.$fk=h;var l;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function m(W){return!!(W.capabilities&2)}t.$gk=m;function n(W){return!!(W.capabilities&8)}t.$hk=n;function r(W){return!!(W.capabilities&131072)}t.$ik=r;function b(W){return!!(W.capabilities&4)}t.$jk=b;function u(W){return!!(W.capabilities&16)}t.$kk=u;function o(W){return m(W)?!!(W.capabilities&16384):!1}t.$lk=o;function N(W){return m(W)?!!(W.capabilities&32768):!1}t.$mk=N;function j(W){return!!(W.capabilities&65536)}t.$nk=j;function L(W){return!!(W.capabilities&2048)}t.$ok=L;var g;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(g||(t.FileSystemProviderErrorCode=g={}));class y extends Error{static create(Y,C){const V=new y(Y.toString(),C);return x(V,C),V}constructor(Y,C){super(Y),this.code=C}}t.$pk=y;function B(W,Y){return y.create(W,Y)}t.$qk=B;function q(W){return W||B((0,D.localize)(0,null),g.Unknown)}t.$rk=q;function x(W,Y){return W.name=Y?`${Y} (FileSystemError)`:"FileSystemError",W}t.$sk=x;function P(W){if(!W)return g.Unknown;if(W instanceof y)return W.code;const Y=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Y)return g.Unknown;switch(Y[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}t.$tk=P;function O(W){if(W instanceof oe)return W.fileOperationResult;switch(P(W)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}t.$uk=O;var K;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(K||(t.FileOperation=K={}));class te{constructor(Y,C,V){this.resource=Y,this.operation=C,this.target=V}isOperation(Y){return this.operation===Y}}t.$vk=te;var se;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(se||(t.FileChangeType=se={}));class fe{static{this.a=null}constructor(Y,C){this.c=C,this.b=void 0,this.d=new R.$U(()=>{const V=v.$1h.forUris(()=>this.c);return V.fill(this.rawAdded.map($=>[$,!0])),V}),this.f=new R.$U(()=>{const V=v.$1h.forUris(()=>this.c);return V.fill(this.rawUpdated.map($=>[$,!0])),V}),this.g=new R.$U(()=>{const V=v.$1h.forUris(()=>this.c);return V.fill(this.rawDeleted.map($=>[$,!0])),V}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const V of Y){switch(V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}this.b!==fe.a&&(typeof V.cId=="number"?this.b===void 0?this.b=V.cId:this.b!==V.cId&&(this.b=fe.a):this.b!==void 0&&(this.b=fe.a))}}contains(Y,...C){return this.h(Y,{includeChildren:!1},...C)}affects(Y,...C){return this.h(Y,{includeChildren:!0},...C)}h(Y,C,...V){if(!Y)return!1;const $=V.length>0;return!!((!$||V.includes(1))&&(this.d.value.get(Y)||C.includeChildren&&this.d.value.findSuperstr(Y))||(!$||V.includes(0))&&(this.f.value.get(Y)||C.includeChildren&&this.f.value.findSuperstr(Y))||(!$||V.includes(2))&&(this.g.value.findSubstr(Y)||C.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}t.$wk=fe;function le(W,Y,C){return!W||!Y||W===Y||Y.length>W.length?!1:(Y.charAt(Y.length-1)!==T.sep&&(Y+=T.sep),C?(0,i.$6e)(W,Y):W.indexOf(Y)===0)}t.$xk=le;class oe extends Error{constructor(Y,C,V){super(Y),this.fileOperationResult=C,this.options=V}}t.$yk=oe;class be extends oe{constructor(Y,C,V,$){super(Y,C,$),this.fileOperationResult=C,this.size=V}}t.$zk=be;class Se extends oe{constructor(Y,C,V){super(Y,2,V),this.stat=C}}t.$Ak=Se;var Ae;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ae||(t.FileOperationResult=Ae={})),t.$Bk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Ck={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Dk="files.associations",t.$Ek="files.exclude",t.$Fk="files.readonlyInclude",t.$Gk="files.readonlyExclude",t.$Hk="files.readonlyFromPermissions";var Pe;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(Pe||(t.FileKind=Pe={})),t.$Ik="";function de(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}t.$Jk=de;async function ie(W,Y){if(!Y.hasProvider(w.URI.from({scheme:W.scheme})))return new Promise(C=>{const V=Y.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===W.scheme&&$.added&&(V.dispose(),C())})})}t.$Kk=ie;class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(Y){return(0,H.$Ff)(Y)||(Y=0),Y<ce.KB?(0,D.localize)(1,null,Y.toFixed(0)):Y<ce.MB?(0,D.localize)(2,null,(Y/ce.KB).toFixed(2)):Y<ce.GB?(0,D.localize)(3,null,(Y/ce.MB).toFixed(2)):Y<ce.TB?(0,D.localize)(4,null,(Y/ce.GB).toFixed(2)):(0,D.localize)(5,null,(Y/ce.TB).toFixed(2))}}t.$Lk=ce;function Z(W){const Y=typeof W=="string"||W?.scheme===f.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===f.Schemas.file?1024*ce.MB:Y?10*ce.MB:d.$o?50*ce.MB:1024*ce.MB}t.$Mk=Z}),define($e[138],we([1,0,40]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N9b=t.$M9b=void 0,t.$M9b=(0,v.$Uh)("mainProcessService");class T{constructor(H,w){this.a=H,this.b=w}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,w){this.a.registerChannel(H,w)}}t.$N9b=T}),define($e[139],we([1,0,2,133]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$O9b=void 0;class i extends v.$Rc{constructor(w){super(),this.a=this.B(new T.$5T(`window:${w}`))}getChannel(w){return this.a.getChannel(w)}registerChannel(w,D){this.a.registerChannel(w,D)}}t.$O9b=i});var Ei=this&&this.__param||function(ae,t){return function(v,T){t(v,T,ae)}};define($e[140],we([1,0,67,138]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S9b=void 0;let i=class{constructor(w,D){return this.windowId=w,v.ProxyChannel.toService(D.getChannel("nativeHost"),{context:w,properties:(()=>{const c=new Map;return c.set("windowId",w),c})()})}};t.$S9b=i,t.$S9b=i=Xe([Ei(1,T.$M9b)],i)}),define($e[68],we([1,0,76,7]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ln=void 0;class i{constructor(){this.a=new Map}add(w,D){v.ok(T.$Bf(w)),v.ok(T.$Df(D)),v.ok(!this.a.has(w),"There is already an extension with this id"),this.a.set(w,D)}knows(w){return this.a.has(w)}as(w){return this.a.get(w)||null}}t.$ln=new i}),define($e[141],we([1,0,4,68]),function(ae,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mn=void 0,t.$mn={JSONContribution:"base.contributions.json"};function i(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class H{constructor(){this.b=new v.$Qd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,d){this.a[i(c)]=d,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}}const w=new H;T.$ln.add(t.$mn.JSONContribution,w)}),define($e[142],we([1,0,9,18,19,4,7,15,135,141,68]),function(ae,t,v,T,i,H,w,D,c,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gw=t.$fw=t.$ew=t.$dw=t.$cw=t.$bw=t.$aw=t.$_v=t.IconFontDefinition=t.IconContribution=t.$$v=void 0,t.$$v={IconContribution:"base.contributions.icons"};var R;(function(b){function u(o,N){let j=o.defaults;for(;i.ThemeIcon.isThemeIcon(j);){const L=e.getIcon(j.id);if(!L)return;j=L.defaults}return j}b.getDefinition=u})(R||(t.IconContribution=R={}));var s;(function(b){function u(N){return{weight:N.weight,style:N.style,src:N.src.map(j=>({format:j.format,location:j.location.toString()}))}}b.toJSONObject=u;function o(N){const j=L=>(0,w.$Bf)(L)?L:void 0;if(N&&Array.isArray(N.src)&&N.src.every(L=>(0,w.$Bf)(L.format)&&(0,w.$Bf)(L.location)))return{weight:j(N.weight),style:j(N.style),src:N.src.map(L=>({format:L.format,location:D.URI.parse(L.location)}))}}b.fromJSONObject=o})(s||(t.IconFontDefinition=s={}));class a{constructor(){this.a=new H.$Qd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,o,N,j){const L=this.b[u];if(L){if(N&&!L.description){L.description=N,this.d.properties[u].markdownDescription=`${N} $(${u})`;const B=this.e.enum.indexOf(u);B!==-1&&(this.e.enumDescriptions[B]=N),this.a.fire()}return L}const g={id:u,description:N,defaults:o,deprecationMessage:j};this.b[u]=g;const y={$ref:"#/definitions/icons"};return j&&(y.deprecationMessage=j),N&&(y.markdownDescription=`${N}: $(${u})`),this.d.properties[u]=y,this.e.enum.push(u),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const o=this.e.enum.indexOf(u);o!==-1&&(this.e.enum.splice(o,1),this.e.enumDescriptions.splice(o,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,o){const N=this.f[u];return N||(this.f[u]=o,this.a.fire(),o)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(L,g)=>L.id.localeCompare(g.id),o=L=>{for(;i.ThemeIcon.isThemeIcon(L.defaults);)L=this.b[L.defaults.id];return`codicon codicon-${L?L.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const j=Object.keys(this.b).map(L=>this.b[L]);for(const L of j.filter(g=>!!g.description).sort(u))N.push(`|<i class="${o(L)}"></i>|${L.id}|${i.ThemeIcon.isThemeIcon(L.defaults)?L.defaults.id:L.id}|${L.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const L of j.filter(g=>!i.ThemeIcon.isThemeIcon(g.defaults)).sort(u))N.push(`|<i class="${o(L)}"></i>|${L.id}|`);return N.join(`
`)}}const e=new a;f.$ln.add(t.$$v.IconContribution,e);function h(b,u,o,N){return e.registerIcon(b,u,o,N)}t.$_v=h;function l(){return e}t.$aw=l;function m(){const b=(0,T.$Xj)();for(const u in b){const o="\\"+b[u].toString(16);e.registerIcon(u,{fontCharacter:o})}}m(),t.$bw="vscode://schemas/icons";const n=f.$ln.as(d.$mn.JSONContribution);n.registerSchema(t.$bw,e.getIconSchema());const r=new v.$9g(()=>n.notifySchemaChanged(t.$bw),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$cw=h("widget-close",T.$Zj.close,(0,c.localize)(2,null)),t.$dw=h("goto-previous-location",T.$Zj.arrowUp,(0,c.localize)(3,null)),t.$ew=h("goto-next-location",T.$Zj.arrowDown,(0,c.localize)(4,null)),t.$fw=i.ThemeIcon.modify(T.$Zj.sync,"spin"),t.$gw=i.ThemeIcon.modify(T.$Zj.loading,"spin")}),define($e[143],we([1,0,3,4,2,19,142]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uDb=t.$tDb=void 0;function D(d){const f=new i.$Qc,R=f.add(new T.$Qd),s=(0,w.$aw)();return f.add(s.onDidChange(()=>R.fire())),d&&f.add(d.onDidProductIconThemeChange(()=>R.fire())),{dispose:()=>f.dispose(),onDidChange:R.event,getCSS(){const a=d?d.getProductIconTheme():new c,e={},h=m=>{const n=a.getIcon(m);if(!n)return;const r=n.font;return r?(e[r.id]=r.definition,`.codicon-${m.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,v.$hQ)(r.id)}; }`):`.codicon-${m.id}:before { content: '${n.fontCharacter}'; }`},l=[];for(const m of s.getIcons()){const n=h(m);n&&l.push(n)}for(const m in e){const n=e[m],r=n.weight?`font-weight: ${n.weight};`:"",b=n.style?`font-style: ${n.style};`:"",u=n.src.map(o=>`${(0,v.$gQ)(o.location)} format('${o.format}')`).join(", ");l.push(`@font-face { src: ${u}; font-family: ${(0,v.$hQ)(m)};${r}${b} font-display: block; }`)}return l.join(`
`)}}}t.$tDb=D;class c{getIcon(f){const R=(0,w.$aw)();let s=f.defaults;for(;H.ThemeIcon.isThemeIcon(s);){const a=R.getIcon(s.id);if(!a)return;s=a.defaults}return s}}t.$uDb=c}),define($e[144],we([1,0,5]),function(ae,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tC=t.$sC=t.$rC=t.$qC=t.$pC=t.$oC=t.$nC=t.$mC=t.$lC=void 0,t.$lC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function T(R){return typeof R.parentId=="number"}t.$mC=T;function i(R){return!!R.workspaceUri}t.$nC=i;function H(R){return!!R.folderUri}t.$oC=H;function w(R){return!!R.fileUri}t.$pC=w;function D(R){const s=c(R),a=R.getValue("window.menuBarVisibility");return a==="default"||s==="native"&&a==="compact"||v.$j&&v.$m?"classic":a}t.$qC=D;function c(R){if(v.$o)return"custom";const s=R.getValue("window");if(s){if(v.$j&&s.nativeTabs===!0||v.$j&&s.nativeFullScreen===!1)return"native";const h=s.titleBarStyle;if(h==="native"||h==="custom")return h}return v.$k?"native":"custom"}t.$rC=c;function d(R){return!(!v.$i||v.$o||c(R)==="native")}t.$sC=d;function f(R=0){return Math.pow(1.2,R)}t.$tC=f}),define($e[145],we([1,0,17,3,16,30,144]),function(ae,t,v,T,i,H,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$W9b=t.$V9b=t.$U9b=void 0;function D(R){for(const{window:s}of(0,T.getWindows)())c(s)?.webFrame?.setZoomLevel(R);(0,v.$EO)((0,w.$tC)(R)),(0,v.$BO)(R)}t.$U9b=D;function c(R){if(R===i.$wO)return{ipcRenderer:H.$N,webFrame:H.$P};{const s=R;if(s?.vscode?.ipcRenderer&&s?.vscode?.webFrame)return s.vscode}}function d(){D((0,v.$CO)()+1)}t.$V9b=d;function f(){D((0,v.$CO)()-1)}t.$W9b=f}),define($e[146],we([1,0,10,3,132,9,90,30,136,137,139,140,143,145,14,16,103,94]),function(ae,t,v,T,i,H,w,D,c,d,f,R,s,a,e,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const l=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,m=/\s--inspect-port=(?<port>\d+)/;class n{getHeight(P){return 22}getTemplateId(P){return g(P)?"process":j(P)?"machine":(0,c.$wm)(P)?"error":L(P)?"header":""}}class r{hasChildren(P){return(0,c.$wm)(P)?!1:g(P)?!!P.children?.length:!0}getChildren(P){return g(P)?P.children?P.children:[]:(0,c.$wm)(P)?[]:L(P)?P.processRoots.length>1?P.processRoots:[P.processRoots[0].rootProcess]:j(P)?[P.rootProcess]:[P.processes]}}class b{constructor(){this.templateId="header"}renderTemplate(P){const O=(0,T.$3P)(P,(0,T.$)(".row")),K=(0,T.$3P)(O,(0,T.$)(".nameLabel")),te=(0,T.$3P)(O,(0,T.$)(".cpu")),se=(0,T.$3P)(O,(0,T.$)(".memory")),fe=(0,T.$3P)(O,(0,T.$)(".pid"));return{name:K,CPU:te,memory:se,PID:fe}}renderElement(P,O,K,te){K.name.textContent=(0,v.localize)(0,null),K.CPU.textContent=(0,v.localize)(1,null),K.PID.textContent=(0,v.localize)(2,null),K.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(P){}}class u{constructor(){this.templateId="machine"}renderTemplate(P){const O=Object.create(null),K=(0,T.$3P)(P,(0,T.$)(".row"));return O.name=(0,T.$3P)(K,(0,T.$)(".nameLabel")),O}renderElement(P,O,K,te){K.name.textContent=P.element.name}disposeTemplate(P){}}class o{constructor(){this.templateId="error"}renderTemplate(P){const O=Object.create(null),K=(0,T.$3P)(P,(0,T.$)(".row"));return O.name=(0,T.$3P)(K,(0,T.$)(".nameLabel")),O}renderElement(P,O,K,te){K.name.textContent=P.element.errorMessage}disposeTemplate(P){}}class N{constructor(P,O,K){this.a=P,this.b=O,this.c=K,this.templateId="process"}renderTemplate(P){const O=(0,T.$3P)(P,(0,T.$)(".row")),K=(0,T.$3P)(O,(0,T.$)(".nameLabel")),te=(0,T.$3P)(O,(0,T.$)(".cpu")),se=(0,T.$3P)(O,(0,T.$)(".memory")),fe=(0,T.$3P)(O,(0,T.$)(".pid"));return{name:K,CPU:te,PID:fe,memory:se}}renderElement(P,O,K,te){const{element:se}=P,fe=se.pid.toFixed(0);let le=se.name;this.c.has(se.pid)&&(le=this.c.get(se.pid)),K.name.textContent=le,K.name.title=se.cmd,K.CPU.textContent=se.load.toFixed(0),K.PID.textContent=fe,K.PID.parentElement.id=`pid-${fe}`;const oe=this.a==="win32"?se.mem:this.b*(se.mem/100);K.memory.textContent=(oe/d.$Lk.MB).toFixed(0)}disposeTemplate(P){}}function j(x){return!!x.name&&!!x.rootProcess}function L(x){return!!x.processRoots}function g(x){return!!x.pid}class y{constructor(P,O){this.f=O,this.b=new Map;const K=new f.$O9b(P);this.c=new R.$S9b(P,K),this.k(O.styles),this.g(O),D.$N.on("vscode:pidToNameResponse",(te,se)=>{this.b=new Map;for(const[fe,le]of se)this.b.set(fe,le)}),D.$N.on("vscode:listProcessesResponse",async(te,se)=>{se.forEach((fe,le)=>{g(fe.rootProcess)&&(fe.rootProcess.name=le===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:se}}),this.d.layout(h.$wO.innerHeight,h.$wO.innerWidth)):await this.h(se),this.m(0)}),this.a=Date.now(),D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")}g(P){h.$wO.document.onkeydown=O=>{const K=P.platform==="darwin"?O.metaKey:O.ctrlKey;K&&O.keyCode===87&&(O.stopPropagation(),O.preventDefault(),D.$N.send("vscode:closeProcessExplorer")),K&&O.keyCode===187&&(0,a.$V9b)(),K&&O.keyCode===189&&(0,a.$W9b)()}}async h(P){const O=h.$wO.document.getElementById("process-list");if(!O)return;const{totalmem:K}=await this.c.getOSStatistics(),te=[new N(this.f.platform,K,this.b),new b,new u,new o];this.d=new i.$lT("processExplorer",O,new n,te,new r,{identityProvider:{getId:se=>g(se)?se.pid.toString():(0,c.$wm)(se)?se.hostName:L(se)?"processes":j(se)?se.name:"header"}}),this.d.setInput({processes:{processRoots:P}}),this.d.layout(h.$wO.innerHeight,h.$wO.innerWidth),this.d.onKeyDown(se=>{const fe=new e.$ZO(se);if(fe.keyCode===35&&fe.altKey){const le=this.n();Promise.all(le.map(oe=>this.c.killProcess(oe,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(se=>{g(se.element)&&this.l(se.element,!0)}),O.style.height=`${h.$wO.innerHeight}px`,h.$wO.addEventListener("resize",()=>{O.style.height=`${h.$wO.innerHeight}px`,this.d?.layout(h.$wO.innerHeight,h.$wO.innerWidth)})}i(P){const O=l.exec(P);return O&&O.groups.port!=="0"||P.indexOf("node ")>=0||P.indexOf("node.exe")>=0}j(P){const O={type:"node",request:"attach",name:`process ${P.pid}`};let K=l.exec(P.cmd);K?O.port=Number(K.groups.port):O.processId=String(P.pid),K=m.exec(P.cmd),K&&(O.port=Number(K.groups.port)),D.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[O]})}k(P){const O=(0,T.$LP)(),K=[];P.listFocusBackground&&(K.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${P.listFocusBackground}; }`),K.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${P.listFocusBackground}; }`)),P.listFocusForeground&&K.push(`.monaco-list:focus .monaco-list-row.focused { color: ${P.listFocusForeground}; }`),P.listActiveSelectionBackground&&(K.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${P.listActiveSelectionBackground}; }`),K.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${P.listActiveSelectionBackground}; }`)),P.listActiveSelectionForeground&&K.push(`.monaco-list:focus .monaco-list-row.selected { color: ${P.listActiveSelectionForeground}; }`),P.listHoverBackground&&K.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${P.listHoverBackground}; }`),P.listHoverForeground&&K.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${P.listHoverForeground}; }`),P.listFocusOutline&&K.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${P.listFocusOutline}; outline-offset: -1px; }`),P.listHoverOutline&&K.push(`.monaco-list-row:hover { outline: 1px dashed ${P.listHoverOutline}; outline-offset: -1px; }`),P.scrollbarShadowColor&&K.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${P.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${P.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${P.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),P.scrollbarSliderBackgroundColor&&K.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${P.scrollbarSliderBackgroundColor};
				}
			`),P.scrollbarSliderHoverBackgroundColor&&K.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${P.scrollbarSliderHoverBackgroundColor};
				}
			`),P.scrollbarSliderActiveBackgroundColor&&K.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${P.scrollbarSliderActiveBackgroundColor};
				}
			`),O.textContent=K.join(`
`),P.color&&(h.$wO.document.body.style.color=P.color)}l(P,O){const K=[],te=Number(P.pid);O&&(K.push({accelerator:"Alt+E",label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(te,"SIGTERM")}}),K.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(te,"SIGKILL")}}),K.push({type:"separator"})),K.push({label:(0,v.localize)(6,null),click:()=>{const se=this.n();se?.includes(te)||(se.length=0,se.push(te));const fe=se?.map(le=>h.$wO.document.getElementById(`pid-${le}`)).filter(le=>!!le);if(fe){const le=fe.map(oe=>oe.innerText).filter(oe=>!!oe);this.c.writeClipboardText(le.join(`
`))}}}),K.push({label:(0,v.localize)(7,null),click:()=>{const se=h.$wO.document.getElementById("process-list");se&&this.c.writeClipboardText(se.innerText)}}),P&&O&&this.i(P.cmd)&&(K.push({type:"separator"}),K.push({label:(0,v.localize)(8,null),click:()=>{this.j(P)}})),(0,w.$WT)(K)}m(P){setTimeout(()=>{const O=Date.now(),K=P+O-this.a;this.a=O,K>1e3?(D.$N.send("vscode:pidToNameRequest"),D.$N.send("vscode:listProcesses")):this.m(K)},200)}n(){return this.d?.getSelection()?.map(P=>{if(!(!P||!("pid"in P)))return P.pid}).filter(P=>!!P)}}function B(){const x=(0,T.$LP)();x.id="codiconStyles";const P=(0,s.$tDb)(void 0);function O(){x.textContent=P.getCSS()}const K=new H.$9g(O,0);P.onDidChange(()=>K.schedule()),K.schedule()}function q(x){const P=x.data.platform==="win32"?"windows":x.data.platform==="linux"?"linux":"mac";h.$wO.document.body.classList.add(P),B(),(0,a.$U9b)(x.data.zoomLevel),new y(x.windowId,x.data)}t.startup=q})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/60c8cddf1ae631ce52714d885adba2cdc889415b/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
