/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/base/common/errors","vs/base/common/platform","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/base/common/stopwatch","vs/platform/registry/common/platform","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/editor/common/core/position","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],I=0,F=me.length;I<F;I++)e[I]=ke[me[I]];return e};define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class I{static get(){const m=new Map,L=new Map,R=new Map,p=new Map;function E(y,S){y.has(S.detail)||y.set(S.detail,-S.timestamp)}function g(y,S){const w=y.get(S.detail);w&&(w>=0||y.set(S.detail,w+S.timestamp))}let A=[];typeof me=="function"&&typeof me.getStats=="function"&&(A=me.getStats().slice(0).sort((y,S)=>y.timestamp-S.timestamp));for(const y of A)switch(y.type){case 10:E(m,y);break;case 11:case 12:g(m,y);break;case 21:E(L,y);break;case 22:g(L,y);break;case 33:E(R,y);break;case 34:g(R,y);break;case 31:E(p,y);break;case 32:g(p,y);break}let P=0;R.forEach(y=>P+=y);function f(y){const S=[];return y.forEach((w,c)=>S.push([c,w])),S}return{amdLoad:f(m),amdInvoke:f(L),nodeRequire:f(R),nodeEval:f(p),nodeRequireTotal:P}}static toMarkdownTable(m,L){let R="";const p=[];return m.forEach((E,g)=>{p[g]=E.length}),L.forEach(E=>{E.forEach((g,A)=>{typeof g>"u"&&(g=E[A]="-");const P=g.toString().length;p[A]=Math.max(P,p[A])})}),m.forEach((E,g)=>{R+=`| ${E+" ".repeat(p[g]-E.toString().length)} `}),R+=`|
`,m.forEach((E,g)=>{R+=`| ${"-".repeat(p[g])} `}),R+=`|
`,L.forEach(E=>{E.forEach((g,A)=>{typeof g<"u"&&(R+=`| ${g+" ".repeat(p[A]-g.toString().length)} `)}),R+=`|
`}),R}}e.$T=I}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function I(w,c,s){const i=F(w,c);if(i!==-1)return w[i]}e.$eb=I;function F(w,c,s=w.length-1){for(let i=s;i>=0;i--){const n=w[i];if(c(n))return i}return-1}e.$fb=F;function m(w,c){const s=L(w,c);return s===-1?void 0:w[s]}e.$gb=m;function L(w,c,s=0,i=w.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);c(w[a])?n=a+1:o=a}return n-1}e.$hb=L;function R(w,c){const s=p(w,c);return s===w.length?void 0:w[s]}e.$ib=R;function p(w,c,s=0,i=w.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);c(w[a])?o=a:n=a+1}return n}e.$jb=p;function E(w,c,s=0,i=w.length){const n=p(w,c,s,i);return n===w.length?-1:n}e.$kb=E;class g{static{this.assertInvariants=!1}constructor(c){this.e=c,this.c=0}findLastMonotonous(c){if(g.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!c(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=c}const s=L(this.e,c,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$lb=g;function A(w,c){if(w.length===0)return;let s=w[0];for(let i=1;i<w.length;i++){const n=w[i];c(n,s)>0&&(s=n)}return s}e.$mb=A;function P(w,c){if(w.length===0)return;let s=w[0];for(let i=1;i<w.length;i++){const n=w[i];c(n,s)>=0&&(s=n)}return s}e.$nb=P;function f(w,c){return A(w,(s,i)=>-c(s,i))}e.$ob=f;function y(w,c){if(w.length===0)return-1;let s=0;for(let i=1;i<w.length;i++){const n=w[i];c(n,w[s])>0&&(s=i)}return s}e.$pb=y;function S(w,c){for(const s of w){const i=c(s);if(i!==void 0)return i}}e.$qb=S}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function I(R,p){const E=Object.create(null);for(const g of R){const A=p(g);let P=E[A];P||(P=E[A]=[]),P.push(g)}return E}e.$J=I;function F(R,p){const E=[],g=[];for(const A of R)p.has(A)||E.push(A);for(const A of p)R.has(A)||g.push(A);return{removed:E,added:g}}e.$K=F;function m(R,p){const E=[],g=[];for(const[A,P]of R)p.has(A)||E.push(P);for(const[A,P]of p)R.has(A)||g.push(P);return{removed:E,added:g}}e.$L=m;function L(R,p){const E=new Set;for(const g of p)R.has(g)&&E.add(g);return E}e.$M=L}),define(ke[59],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=void 0;function I(R){return(p,E,g)=>{let A=null,P=null;if(typeof g.value=="function"?(A="value",P=g.value):typeof g.get=="function"&&(A="get",P=g.get),!P)throw new Error("not supported");g[A]=R(P,E)}}function F(R,p,E){let g=null,A=null;if(typeof E.value=="function"?(g="value",A=E.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(g="get",A=E.get),!A)throw new Error("not supported");const P=`$memoize$${p}`;E[g]=function(...f){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,f)}),this[P]}}e.$mh=F;function m(R,p,E){return I((g,A)=>{const P=`$debounce$${A}`,f=`$debounce$result$${A}`;return function(...y){this[f]||(this[f]=E?E():void 0),clearTimeout(this[P]),p&&(this[f]=p(this[f],...y),y=[this[f]]),this[P]=setTimeout(()=>{g.apply(this,y),this[f]=E?E():void 0},R)}})}e.$nh=m;function L(R,p,E){return I((g,A)=>{const P=`$throttle$timer$${A}`,f=`$throttle$result$${A}`,y=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...w){if(this[f]||(this[f]=E?E():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),p&&(this[f]=p(this[f],...w)),this[S])return;const c=this[y]+R;c<=Date.now()?(this[y]=Date.now(),g.apply(this,[this[f]]),this[f]=E?E():void 0):(this[S]=!0,this[P]=setTimeout(()=>{this[S]=!1,this[y]=Date.now(),g.apply(this,[this[f]]),this[f]=E?E():void 0},c-Date.now()))}})}e.$oh=L}),define(ke[11],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class I{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=I,e.$W=new I;function F(a){e.$W.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=F;function m(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=m;function L(a){g(a)||e.$W.onUnexpectedError(a)}e.$Z=L;function R(a){g(a)||e.$W.onUnexpectedExternalError(a)}e.$1=R;function p(a){if(a instanceof Error){const{name:t,message:r}=a,d=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:d,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$2=p;const E="Canceled";function g(a){return a instanceof A?!0:a instanceof Error&&a.name===E&&a.message===E}e.$3=g;class A extends Error{constructor(){super(E),this.name=this.message}}e.$4=A;function P(){const a=new Error(E);return a.name=a.message,a}e.$5=P;function f(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$6=f;function y(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$7=y;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=S;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$9=w;class c extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=c;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$bb=o}),define(ke[19],Se([1,0,11,121]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function m(G,Y=0){return G[G.length-(1+Y)]}e.$rb=m;function L(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.$sb=L;function R(G,Y,X=($e,re)=>$e===re){if(G===Y)return!0;if(!G||!Y||G.length!==Y.length)return!1;for(let $e=0,re=G.length;$e<re;$e++)if(!X(G[$e],Y[$e]))return!1;return!0}e.$tb=R;function p(G,Y){const X=G.length-1;Y<X&&(G[Y]=G[X]),G.pop()}e.$ub=p;function E(G,Y,X){return g(G.length,$e=>X(G[$e],Y))}e.$vb=E;function g(G,Y){let X=0,$e=G-1;for(;X<=$e;){const re=(X+$e)/2|0,fe=Y(re);if(fe<0)X=re+1;else if(fe>0)$e=re-1;else return re}return-(X+1)}e.$wb=g;function A(G,Y,X){if(G=G|0,G>=Y.length)throw new TypeError("invalid index");const $e=Y[Math.floor(Y.length*Math.random())],re=[],fe=[],te=[];for(const he of Y){const pe=X(he,$e);pe<0?re.push(he):pe>0?fe.push(he):te.push(he)}return G<re.length?A(G,re,X):G<re.length+te.length?te[0]:A(G-(re.length+te.length),fe,X)}e.$xb=A;function P(G,Y){const X=[];let $e;for(const re of G.slice(0).sort(Y))!$e||Y($e[0],re)!==0?($e=[re],X.push($e)):$e.push(re);return X}e.$yb=P;function*f(G,Y){let X,$e;for(const re of G)$e!==void 0&&Y($e,re)?X.push(re):(X&&(yield X),X=[re]),$e=re;X&&(yield X)}e.$zb=f;function y(G,Y){for(let X=0;X<=G.length;X++)Y(X===0?void 0:G[X-1],X===G.length?void 0:G[X])}e.$Ab=y;function S(G,Y){for(let X=0;X<G.length;X++)Y(X===0?void 0:G[X-1],G[X],X+1===G.length?void 0:G[X+1])}e.$Bb=S;function w(G,Y,X){const $e=[];function re(he,pe,Pe){if(pe===0&&Pe.length===0)return;const B=$e[$e.length-1];B&&B.start+B.deleteCount===he?(B.deleteCount+=pe,B.toInsert.push(...Pe)):$e.push({start:he,deleteCount:pe,toInsert:Pe})}let fe=0,te=0;for(;;){if(fe===G.length){re(fe,0,Y.slice(te));break}if(te===Y.length){re(fe,G.length-fe,[]);break}const he=G[fe],pe=Y[te],Pe=X(he,pe);Pe===0?(fe+=1,te+=1):Pe<0?(re(fe,1,[]),fe+=1):Pe>0&&(re(fe,0,[pe]),te+=1)}return $e}e.$Cb=w;function c(G,Y,X){const $e=w(G,Y,X),re=[],fe=[];for(const te of $e)re.push(...G.slice(te.start,te.start+te.deleteCount)),fe.push(...te.toInsert);return{removed:re,added:fe}}e.$Db=c;function s(G,Y,X){if(X===0)return[];const $e=G.slice(0,X).sort(Y);return n(G,Y,$e,X,G.length),$e}e.top=s;function i(G,Y,X,$e,re){return X===0?Promise.resolve([]):new Promise((fe,te)=>{(async()=>{const he=G.length,pe=G.slice(0,X).sort(Y);for(let Pe=X,B=Math.min(X+$e,he);Pe<he;Pe=B,B=Math.min(B+$e,he)){if(Pe>X&&await new Promise(Q=>setTimeout(Q)),re&&re.isCancellationRequested)throw new I.$4;n(G,Y,pe,Pe,B)}return pe})().then(fe,te)})}e.$Fb=i;function n(G,Y,X,$e,re){for(const fe=X.length;$e<re;$e++){const te=G[$e];if(Y(te,X[fe-1])<0){X.pop();const he=(0,F.$jb)(X,pe=>Y(te,pe)<0);X.splice(he,0,te)}}}function o(G){return G.filter(Y=>!!Y)}e.$Gb=o;function a(G){let Y=0;for(let X=0;X<G.length;X++)G[X]&&(G[Y]=G[X],Y+=1);G.length=Y}e.$Hb=a;function t(G,Y,X){G.splice(X,0,G.splice(Y,1)[0])}e.$Ib=t;function r(G){return!Array.isArray(G)||G.length===0}e.$Jb=r;function d(G){return Array.isArray(G)&&G.length>0}e.$Kb=d;function u(G,Y=X=>X){const X=new Set;return G.filter($e=>{const re=Y($e);return X.has(re)?!1:(X.add(re),!0)})}e.$Lb=u;function l(G){const Y=new Set;return X=>{const $e=G(X);return Y.has($e)?!1:(Y.add($e),!0)}}e.$Mb=l;function h(G,Y){return G.length>0?G[0]:Y}e.$Nb=h;function k(G,Y){return G.length>0?G[G.length-1]:Y}e.$Ob=k;function D(G,Y,X=($e,re)=>$e===re){let $e=0;for(let re=0,fe=Math.min(G.length,Y.length);re<fe&&X(G[re],Y[re]);re++)$e++;return $e}e.$Pb=D;function $(G){return[].concat(...G)}e.$Qb=$;function b(G,Y){let X=typeof Y=="number"?G:0;typeof Y=="number"?X=G:(X=0,Y=G);const $e=[];if(X<=Y)for(let re=X;re<Y;re++)$e.push(re);else for(let re=X;re>Y;re--)$e.push(re);return $e}e.$Rb=b;function v(G,Y,X){return G.reduce(($e,re)=>($e[Y(re)]=X?X(re):re,$e),Object.create(null))}e.$Sb=v;function C(G,Y){return G.push(Y),()=>N(G,Y)}e.$Tb=C;function N(G,Y){const X=G.indexOf(Y);if(X>-1)return G.splice(X,1),Y}e.$Ub=N;function j(G,Y,X){const $e=G.slice(0,Y),re=G.slice(Y);return $e.concat(X,re)}e.$Vb=j;function M(G,Y){let X;if(typeof Y=="number"){let $e=Y;X=()=>{const re=Math.sin($e++)*179426549;return re-Math.floor(re)}}else X=Math.random;for(let $e=G.length-1;$e>0;$e-=1){const re=Math.floor(X()*($e+1)),fe=G[$e];G[$e]=G[re],G[re]=fe}}e.$Wb=M;function O(G,Y){const X=G.indexOf(Y);X>-1&&(G.splice(X,1),G.unshift(Y))}e.$Xb=O;function z(G,Y){const X=G.indexOf(Y);X>-1&&(G.splice(X,1),G.push(Y))}e.$Yb=z;function T(G,Y){for(const X of Y)G.push(X)}e.$Zb=T;function W(G,Y){return Array.isArray(G)?G.map(Y):Y(G)}e.$1b=W;function V(G){return Array.isArray(G)?G:[G]}e.$2b=V;function de(G){return G[Math.floor(Math.random()*G.length)]}e.$3b=de;function ee(G,Y,X){const $e=J(G,Y),re=G.length,fe=X.length;G.length=re+fe;for(let te=re-1;te>=$e;te--)G[te+fe]=G[te];for(let te=0;te<fe;te++)G[te+$e]=X[te]}e.$4b=ee;function Z(G,Y,X,$e){const re=J(G,Y);let fe=G.splice(re,X);return fe===void 0&&(fe=[]),ee(G,re,$e),fe}e.$5b=Z;function J(G,Y){return Y<0?Math.max(Y+G.length,0):Math.min(Y,G.length)}var ae;(function(G){function Y(fe){return fe<0}G.isLessThan=Y;function X(fe){return fe<=0}G.isLessThanOrEqual=X;function $e(fe){return fe>0}G.isGreaterThan=$e;function re(fe){return fe===0}G.isNeitherLessOrGreaterThan=re,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function x(G,Y){return(X,$e)=>Y(G(X),G($e))}e.$6b=x;function Ee(...G){return(Y,X)=>{for(const $e of G){const re=$e(Y,X);if(!ae.isNeitherLessOrGreaterThan(re))return re}return ae.neitherLessOrGreaterThan}}e.$7b=Ee;const le=(G,Y)=>G-Y;e.$8b=le;const K=(G,Y)=>(0,e.$8b)(G?1:0,Y?1:0);e.$9b=K;function U(G){return(Y,X)=>-G(Y,X)}e.$0b=U;class ne{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let X=this.c;for(;X<this.g.length&&Y(this.g[X]);)X++;const $e=X===this.c?null:this.g.slice(this.c,X);return this.c=X,$e}takeFromEndWhile(Y){let X=this.d;for(;X>=0&&Y(this.g[X]);)X--;const $e=X===this.d?null:this.g.slice(X+1,this.d+1);return this.d=X,$e}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const X=this.g.slice(this.c,this.c+Y);return this.c+=Y,X}}e.$$b=ne;class be{static{this.empty=new be(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(X=>(Y(X),!0))}toArray(){const Y=[];return this.iterate(X=>(Y.push(X),!0)),Y}filter(Y){return new be(X=>this.iterate($e=>Y($e)?X($e):!0))}map(Y){return new be(X=>this.iterate($e=>X(Y($e))))}some(Y){let X=!1;return this.iterate($e=>(X=Y($e),!X)),X}findFirst(Y){let X;return this.iterate($e=>Y($e)?(X=$e,!1):!0),X}findLast(Y){let X;return this.iterate($e=>(Y($e)&&(X=$e),!0)),X}findLastMaxBy(Y){let X,$e=!0;return this.iterate(re=>(($e||ae.isGreaterThan(Y(re,X)))&&($e=!1,X=re),!0)),X}}e.$_b=be}),define(ke[60],Se([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$5c=e.$4c=e.$3c=e.ok=void 0;function F(E,g){if(!E)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=F;function m(E,g="Unreachable"){throw new Error(g)}e.$3c=m;function L(E){if(!E)throw new I.$bb("Assertion Failed")}e.$4c=L;function R(E){if(!E()){debugger;E(),(0,I.$Z)(new I.$bb("Assertion Failed"))}}e.$5c=R;function p(E,g){let A=0;for(;A<E.length-1;){const P=E[A],f=E[A+1];if(!g(P,f))return!1;A++}return!0}e.$6c=p}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function I(F){const m=this;let L=!1,R;return function(){return L||(L=!0,R=F.apply(m,arguments)),R}}e.$cb=I}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=void 0;class I{constructor(m){this.a=m,this.b=0}nextId(){return this.a+ ++this.b}}e.$GM=I,e.$HM=new I("id#")}),define(ke[51],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(F){function m(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}F.is=m;const L=Object.freeze([]);function R(){return L}F.empty=R;function*p(a){yield a}F.single=p;function E(a){return m(a)?a:p(a)}F.wrap=E;function g(a){return a||L}F.from=g;function*A(a){for(let t=a.length-1;t>=0;t--)yield a[t]}F.reverse=A;function P(a){return!a||a[Symbol.iterator]().next().done===!0}F.isEmpty=P;function f(a){return a[Symbol.iterator]().next().value}F.first=f;function y(a,t){for(const r of a)if(t(r))return!0;return!1}F.some=y;function S(a,t){for(const r of a)if(t(r))return r}F.find=S;function*w(a,t){for(const r of a)t(r)&&(yield r)}F.filter=w;function*c(a,t){let r=0;for(const d of a)yield t(d,r++)}F.map=c;function*s(...a){for(const t of a)for(const r of t)yield r}F.concat=s;function i(a,t,r){let d=r;for(const u of a)d=t(d,u);return d}F.reduce=i;function*n(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}F.slice=n;function o(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const d=a[Symbol.iterator]();for(let u=0;u<t;u++){const l=d.next();if(l.done)return[r,F.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return d}}]}F.consume=o})(I||(e.Iterable=I={}))}),define(ke[160],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var m;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(m||(e.ParseErrorCode=m={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,r=!1){let d=0;const u=t.length;let l="",h=0,k=16,D=0;function $(O){let z=0,T=0;for(;z<O;){const W=t.charCodeAt(d);if(W>=48&&W<=57)T=T*16+W-48;else if(W>=65&&W<=70)T=T*16+W-65+10;else if(W>=97&&W<=102)T=T*16+W-97+10;else break;d++,z++}return z<O&&(T=-1),T}function b(O){d=O,l="",h=0,k=16,D=0}function v(){const O=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&g(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&g(t.charCodeAt(d)))for(d++;d<t.length&&g(t.charCodeAt(d));)d++;else return D=3,t.substring(O,d);let z=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&g(t.charCodeAt(d))){for(d++;d<t.length&&g(t.charCodeAt(d));)d++;z=d}else D=3;return t.substring(O,z)}function C(){let O="",z=d;for(;;){if(d>=u){O+=t.substring(z,d),D=2;break}const T=t.charCodeAt(d);if(T===34){O+=t.substring(z,d),d++;break}if(T===92){if(O+=t.substring(z,d),d++,d>=u){D=2;break}switch(t.charCodeAt(d++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const V=$(4);V>=0?O+=String.fromCharCode(V):D=4;break}default:D=5}z=d;continue}if(T>=0&&T<=31)if(E(T)){O+=t.substring(z,d),D=2;break}else D=6;d++}return O}function N(){if(l="",D=0,h=d,d>=u)return h=u,k=17;let O=t.charCodeAt(d);if(p(O)){do d++,l+=String.fromCharCode(O),O=t.charCodeAt(d);while(p(O));return k=15}if(E(O))return d++,l+=String.fromCharCode(O),O===13&&t.charCodeAt(d)===10&&(d++,l+=`
`),k=14;switch(O){case 123:return d++,k=1;case 125:return d++,k=2;case 91:return d++,k=3;case 93:return d++,k=4;case 58:return d++,k=6;case 44:return d++,k=5;case 34:return d++,l=C(),k=10;case 47:{const z=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<u&&!E(t.charCodeAt(d));)d++;return l=t.substring(z,d),k=12}if(t.charCodeAt(d+1)===42){d+=2;const T=u-1;let W=!1;for(;d<T;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,W=!0;break}d++}return W||(d++,D=1),l=t.substring(z,d),k=13}return l+=String.fromCharCode(O),d++,k=16}case 45:if(l+=String.fromCharCode(O),d++,d===u||!g(t.charCodeAt(d)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=v(),k=11;default:for(;d<u&&j(O);)d++,O=t.charCodeAt(d);if(h!==d){switch(l=t.substring(h,d),l){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return l+=String.fromCharCode(O),d++,k=16}}function j(O){if(p(O)||E(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let O;do O=N();while(O>=12&&O<=15);return O}return{setPosition:b,getPosition:()=>d,scan:r?M:N,getToken:()=>k,getTokenValue:()=>l,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>D}}e.$Zm=R;function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function P(t,r){const d=[],u=new Object;let l;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function D($,b,v,C){h.value=$,h.offset=b,h.length=v,h.type=C,h.colonOffset=void 0,l=h}try{n(t,{onObjectBegin:($,b)=>{if(r<=$)throw u;l=void 0,k=r>$,d.push("")},onObjectProperty:($,b,v)=>{if(r<b||(D($,b,v,"property"),d[d.length-1]=$,r<=b+v))throw u},onObjectEnd:($,b)=>{if(r<=$)throw u;l=void 0,d.pop()},onArrayBegin:($,b)=>{if(r<=$)throw u;l=void 0,d.push(0)},onArrayEnd:($,b)=>{if(r<=$)throw u;l=void 0,d.pop()},onLiteralValue:($,b,v)=>{if(r<b||(D($,b,v,a($)),r<=b+v))throw u},onSeparator:($,b,v)=>{if(r<=b)throw u;if($===":"&&l&&l.type==="property")l.colonOffset=b,k=!1,l=void 0;else if($===","){const C=d[d.length-1];typeof C=="number"?d[d.length-1]=C+1:(k=!0,d[d.length-1]=""),l=void 0}}})}catch($){if($!==u)throw $}return{path:d,previousNode:l,isAtPropertyKey:k,matches:$=>{let b=0;for(let v=0;b<$.length&&v<d.length;v++)if($[b]===d[v]||$[b]==="*")b++;else if($[b]!=="**")return!1;return b===$.length}}}e.$1m=P;function f(t,r=[],d=L.DEFAULT){let u=null,l=[];const h=[];function k($){Array.isArray(l)?l.push($):u!==null&&(l[u]=$)}return n(t,{onObjectBegin:()=>{const $={};k($),h.push(l),l=$,u=null},onObjectProperty:$=>{u=$},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{const $=[];k($),h.push(l),l=$,u=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:k,onError:($,b,v)=>{r.push({error:$,offset:b,length:v})}},d),l[0]}e.$2m=f;function y(t,r=[],d=L.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l($){u.type==="property"&&(u.length=$-u.offset,u=u.parent)}function h($){return u.children.push($),$}n(t,{onObjectBegin:$=>{u=h({type:"object",offset:$,length:-1,parent:u,children:[]})},onObjectProperty:($,b,v)=>{u=h({type:"property",offset:b,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:$,offset:b,length:v,parent:u})},onObjectEnd:($,b)=>{u.length=$+b-u.offset,u=u.parent,l($+b)},onArrayBegin:($,b)=>{u=h({type:"array",offset:$,length:-1,parent:u,children:[]})},onArrayEnd:($,b)=>{u.length=$+b-u.offset,u=u.parent,l($+b)},onLiteralValue:($,b,v)=>{h({type:a($),offset:b,length:v,parent:u,value:$}),l(b+v)},onSeparator:($,b,v)=>{u.type==="property"&&($===":"?u.colonOffset=b:$===","&&l(b))},onError:($,b,v)=>{r.push({error:$,offset:b,length:v})}},d);const D=u.children[0];return D&&delete D.parent,D}e.$3m=y;function S(t,r){if(!t)return;let d=t;for(const u of r)if(typeof u=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let l=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===u){d=h.children[1],l=!0;break}if(!l)return}else{const l=u;if(d.type!=="array"||l<0||!Array.isArray(d.children)||l>=d.children.length)return;d=d.children[l]}return d}e.$4m=S;function w(t){if(!t.parent||!t.parent.children)return[];const r=w(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;r.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&r.push(d)}return r}e.$5m=w;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const r=Object.create(null);for(const d of t.children){const u=d.children[1];u&&(r[d.children[0].value]=c(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$6m=c;function s(t,r,d=!1){return r>=t.offset&&r<t.offset+t.length||d&&r===t.offset+t.length}e.$7m=s;function i(t,r,d=!1){if(s(t,r,d)){const u=t.children;if(Array.isArray(u))for(let l=0;l<u.length&&u[l].offset<=r;l++){const h=i(u[l],r,d);if(h)return h}return t}}e.$8m=i;function n(t,r,d=L.DEFAULT){const u=R(t,!1);function l(x){return x?()=>x(u.getTokenOffset(),u.getTokenLength()):()=>!0}function h(x){return x?Ee=>x(Ee,u.getTokenOffset(),u.getTokenLength()):()=>!0}const k=l(r.onObjectBegin),D=h(r.onObjectProperty),$=l(r.onObjectEnd),b=l(r.onArrayBegin),v=l(r.onArrayEnd),C=h(r.onLiteralValue),N=h(r.onSeparator),j=l(r.onComment),M=h(r.onError),O=d&&d.disallowComments,z=d&&d.allowTrailingComma;function T(){for(;;){const x=u.scan();switch(u.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:O||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(x){case 12:case 13:O?W(10):j();break;case 16:W(1);break;case 15:case 14:break;default:return x}}}function W(x,Ee=[],le=[]){if(M(x),Ee.length+le.length>0){let K=u.getToken();for(;K!==17;){if(Ee.indexOf(K)!==-1){T();break}else if(le.indexOf(K)!==-1)break;K=T()}}}function V(x){const Ee=u.getTokenValue();return x?C(Ee):D(Ee),T(),!0}function de(){switch(u.getToken()){case 11:{let x=0;try{x=JSON.parse(u.getTokenValue()),typeof x!="number"&&(W(2),x=0)}catch{W(2)}C(x);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return T(),!0}function ee(){return u.getToken()!==10?(W(3,[],[2,5]),!1):(V(!1),u.getToken()===6?(N(":"),T(),ae()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Z(){k(),T();let x=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(x||W(4,[],[]),N(","),T(),u.getToken()===2&&z)break}else x&&W(6,[],[]);ee()||W(4,[],[2,5]),x=!0}return $(),u.getToken()!==2?W(7,[2],[]):T(),!0}function J(){b(),T();let x=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(x||W(4,[],[]),N(","),T(),u.getToken()===4&&z)break}else x&&W(6,[],[]);ae()||W(4,[],[4,5]),x=!0}return v(),u.getToken()!==4?W(8,[4],[]):T(),!0}function ae(){switch(u.getToken()){case 3:return J();case 1:return Z();case 10:return V(!0);default:return de()}}return T(),u.getToken()===17?d.allowEmptyContent?!0:(W(4,[],[]),!1):ae()?(u.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$9m=n;function o(t,r){const d=R(t),u=[];let l,h=0,k;do switch(k=d.getPosition(),l=d.scan(),l){case 12:case 13:case 17:h!==k&&u.push(t.substring(h,k)),r!==void 0&&u.push(d.getTokenValue().replace(/[^\r\n]/g,r)),h=d.getPosition();break}while(l!==17);return u.join("")}e.$0m=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$$m=a}),define(ke[48],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class I{constructor(m){this.d=m,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(m){this.c=m}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=I}),define(ke[76],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(L){this.element=L,this.next=I.Undefined,this.prev=I.Undefined}}class F{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let L=this.a;for(;L!==I.Undefined;){const R=L.next;L.prev=I.Undefined,L.next=I.Undefined,L=R}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,R){const p=new I(L);if(this.a===I.Undefined)this.a=p,this.b=p;else if(R){const g=this.b;this.b=p,p.prev=g,g.next=p}else{const g=this.a;this.a=p,p.next=g,g.prev=p}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(p))}}shift(){if(this.a!==I.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==I.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==I.Undefined&&L.next!==I.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===I.Undefined&&L.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):L.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):L.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==I.Undefined;)yield L.element,L=L.next}}e.$1c=F}),define(ke[28],Se([1,0]),function(me,e){"use strict";var I,F,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function L(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.$wc=L;function R(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$xc=R;function p(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.$yc=p;class E{constructor(n,o){this.uri=n,this.value=o}}function g(i){return Array.isArray(i)}class A{static{this.a=n=>n.toString()}constructor(n,o){if(this[I]="ResourceMap",n instanceof A)this.b=new Map(n.b),this.c=o??A.a;else if(g(n)){this.b=new Map,this.c=o??A.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??A.a}set(n,o){return this.b.set(this.c(n),new E(n,o)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zc=A;class P{constructor(n,o){this[F]="ResourceSet",!n||typeof n=="function"?this.a=new A(n):(this.a=new A(o),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,o){this.a.forEach((a,t)=>n.call(o,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=P;var f;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class y{constructor(){this[m]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,o=0){const a=this.a.get(n);if(a)return o!==0&&this.j(a,o),a.value}set(n,o,a=0){let t=this.a.get(n);if(t)t.value=o,a!==0&&this.j(t,a);else{switch(t={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.a.get(n);if(o)return this.a.delete(n),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,o){const a=this.e;let t=this.b;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}[(m=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.b,a=this.size;for(;o&&a>n;)this.a.delete(o.key),o=o.next,a--;this.b=o,this.d=a,o&&(o.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this.e++}j(n,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(o===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.$Bc=y;class S extends y{constructor(n,o=1){super(),this.k=n,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=S;class w{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let o=this.a.get(n)||0;return o===0?!1:(o--,o===0?this.a.delete(n):this.a.set(n,o),!0)}has(n){return this.a.has(n)}}e.$Dc=w;class c{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[o,a]of n)this.set(o,a)}clear(){this.a.clear(),this.b.clear()}set(n,o){this.a.set(n,o),this.b.set(o,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const o=this.a.get(n);return o===void 0?!1:(this.a.delete(n),this.b.delete(o),!0)}forEach(n,o){this.a.forEach((a,t)=>{n.call(o,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=c;class s{constructor(){this.a=new Map}add(n,o){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(o)}delete(n,o){const a=this.a.get(n);a&&(a.delete(o),a.size===0&&this.a.delete(n))}forEach(n,o){const a=this.a.get(n);a&&a.forEach(o)}get(n){const o=this.a.get(n);return o||new Set}}e.$Fc=s}),define(ke[3],Se([1,0,19,74,28,75,51]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const p=!1;let E=null;class g{constructor(){this.b=new Map}static{this.a=0}c(v){let C=this.b.get(v);return C||(C={parent:null,source:null,isSingleton:!1,value:v,idx:g.a++},this.b.set(v,C)),C}trackDisposable(v){const C=this.c(v);C.source||(C.source=new Error().stack)}setParent(v,C){const N=this.c(v);N.parent=C}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,C){const N=C.get(v);if(N)return N;const j=v.parent?this.f(this.c(v.parent),C):v;return C.set(v,j),j}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,N])=>N.source!==null&&!this.f(N,v).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(v=10,C){let N;if(C)N=C;else{const T=new Map,W=[...this.b.values()].filter(de=>de.source!==null&&!this.f(de,T).isSingleton);if(W.length===0)return;const V=new Set(W.map(de=>de.value));if(N=W.filter(de=>!(de.parent&&V.has(de.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function j(T){function W(de,ee){for(;de.length>0&&ee.some(Z=>typeof Z=="string"?Z===de[0]:de[0].match(Z));)de.shift()}const V=T.source.split(`
`).map(de=>de.trim().replace("at ","")).filter(de=>de!=="");return W(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const M=new m.$Fc;for(const T of N){const W=j(T);for(let V=0;V<=W.length;V++)M.add(W.slice(0,V).join(`
`),T)}N.sort((0,I.$6b)(T=>T.idx,I.$8b));let O="",z=0;for(const T of N.slice(0,v)){z++;const W=j(T),V=[];for(let de=0;de<W.length;de++){let ee=W[de];ee=`(shared with ${M.get(W.slice(0,de+1).join(`
`)).size}/${N.length} leaks) at ${ee}`;const J=M.get(W.slice(0,de).join(`
`)),ae=(0,F.$J)([...J].map(x=>j(x)[de]),x=>x);delete ae[W[de]];for(const[x,Ee]of Object.entries(ae))V.unshift(`    - stacktraces of ${Ee.length} other leaks continue with ${x}`);V.unshift(ee)}O+=`


==================== Leaking disposable ${z}/${N.length}: ${T.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return N.length>v&&(O+=`


... and ${N.length-v} more leaking disposables

`),{leaks:N,details:O}}}e.$Gc=g;function A(b){E=b}if(e.$Hc=A,p){const b="__is_disposable_tracked__";A(new class{trackDisposable(v){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[b]||console.log(C)},3e3)}setParent(v,C){if(v&&v!==t.None)try{v[b]=!0}catch{}}markAsDisposed(v){if(v&&v!==t.None)try{v[b]=!0}catch{}}markAsSingleton(v){}})}function P(b){return E?.trackDisposable(b),b}e.$Ic=P;function f(b){E?.markAsDisposed(b)}e.$Jc=f;function y(b,v){E?.setParent(b,v)}function S(b,v){if(E)for(const C of b)E.setParent(C,v)}function w(b){return E?.markAsSingleton(b),b}e.$Kc=w;function c(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.$Lc=c;function s(b){if(R.Iterable.is(b)){const v=[];for(const C of b)if(C)try{C.dispose()}catch(N){v.push(N)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.$Mc=s;function i(b){for(const v of b)c(v)&&v.dispose();return[]}e.$Nc=i;function n(...b){const v=o(()=>s(b));return S(b,v),v}e.$Oc=n;function o(b){const v=P({dispose:(0,L.$cb)(()=>{f(v),b()})});return v}e.$Pc=o;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return y(v,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),y(v,null))}}e.$Qc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,P(this),y(this.q,this)}dispose(){f(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Rc=t;class r{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&y(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&y(v,null),v}}e.$Sc=r;class d{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Tc=d;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(v){let C=v;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,f(this))},this}}e.$Uc=u;class l{constructor(){this.a=new Map}acquire(v,...C){let N=this.a.get(v);N||(N={counter:0,object:this.b(v,...C)},this.a.set(v,N));const{object:j}=N,M=(0,L.$cb)(()=>{--N.counter===0&&(this.c(v,N.object),this.a.delete(v))});return N.counter++,{object:j,dispose:M}}}e.$Vc=l;class h{constructor(v){this.a=v}async acquire(v,...C){const N=this.a.acquire(v,...C);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(j){throw N.dispose(),j}}}e.$Wc=h;class k{constructor(v){this.object=v}dispose(){}}e.$Xc=k;function D(b){const v=new a;try{b(v)}finally{v.dispose()}}e.$Yc=D;class ${constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,C,N=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this.a.get(v)?.dispose(),this.a.set(v,C)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Zc=$}),function(me,e){typeof define=="function"&&define.amd?define(ke[161],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Y,X){for(var $e=0;$e<X.length;$e++){var re=X[$e];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(Y,re.key,re)}}function I(Y,X,$e){return X&&e(Y.prototype,X),$e&&e(Y,$e),Object.defineProperty(Y,"prototype",{writable:!1}),Y}function F(Y,X){if(Y){if(typeof Y=="string")return m(Y,X);var $e=Object.prototype.toString.call(Y).slice(8,-1);if($e==="Object"&&Y.constructor&&($e=Y.constructor.name),$e==="Map"||$e==="Set")return Array.from(Y);if($e==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test($e))return m(Y,X)}}function m(Y,X){(X==null||X>Y.length)&&(X=Y.length);for(var $e=0,re=new Array(X);$e<X;$e++)re[$e]=Y[$e];return re}function L(Y,X){var $e=typeof Symbol<"u"&&Y[Symbol.iterator]||Y["@@iterator"];if($e)return($e=$e.call(Y)).next.bind($e);if(Array.isArray(Y)||($e=F(Y))||X&&Y&&typeof Y.length=="number"){$e&&(Y=$e);var re=0;return function(){return re>=Y.length?{done:!0}:{done:!1,value:Y[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function p(Y){me.defaults=Y}var E=/[&<>"']/,g=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(X){return f[X]};function S(Y,X){if(X){if(E.test(Y))return Y.replace(g,y)}else if(A.test(Y))return Y.replace(P,y);return Y}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Y){return Y.replace(w,function(X,$e){return $e=$e.toLowerCase(),$e==="colon"?":":$e.charAt(0)==="#"?$e.charAt(1)==="x"?String.fromCharCode(parseInt($e.substring(2),16)):String.fromCharCode(+$e.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(Y,X){Y=typeof Y=="string"?Y:Y.source,X=X||"";var $e={replace:function(fe,te){return te=te.source||te,te=te.replace(s,"$1"),Y=Y.replace(fe,te),$e},getRegex:function(){return new RegExp(Y,X)}};return $e}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(Y,X,$e){if(Y){var re;try{re=decodeURIComponent(c($e)).replace(n,"").toLowerCase()}catch{return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}X&&!o.test($e)&&($e=l(X,$e));try{$e=encodeURI($e).replace(/%25/g,"%")}catch{return null}return $e}var t={},r=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(Y,X){t[" "+Y]||(r.test(Y)?t[" "+Y]=Y+"/":t[" "+Y]=$(Y,"/",!0)),Y=t[" "+Y];var $e=Y.indexOf(":")===-1;return X.substring(0,2)==="//"?$e?X:Y.replace(d,"$1")+X:X.charAt(0)==="/"?$e?X:Y.replace(u,"$1")+X:Y+X}var h={exec:function(){}};function k(Y){for(var X=1,$e,re;X<arguments.length;X++){$e=arguments[X];for(re in $e)Object.prototype.hasOwnProperty.call($e,re)&&(Y[re]=$e[re])}return Y}function D(Y,X){var $e=Y.replace(/\|/g,function(te,he,pe){for(var Pe=!1,B=he;--B>=0&&pe[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),re=$e.split(/ \|/),fe=0;if(re[0].trim()||re.shift(),re.length>0&&!re[re.length-1].trim()&&re.pop(),re.length>X)re.splice(X);else for(;re.length<X;)re.push("");for(;fe<re.length;fe++)re[fe]=re[fe].trim().replace(/\\\|/g,"|");return re}function $(Y,X,$e){var re=Y.length;if(re===0)return"";for(var fe=0;fe<re;){var te=Y.charAt(re-fe-1);if(te===X&&!$e)fe++;else if(te!==X&&$e)fe++;else break}return Y.slice(0,re-fe)}function b(Y,X){if(Y.indexOf(X[1])===-1)return-1;for(var $e=Y.length,re=0,fe=0;fe<$e;fe++)if(Y[fe]==="\\")fe++;else if(Y[fe]===X[0])re++;else if(Y[fe]===X[1]&&(re--,re<0))return fe;return-1}function v(Y){Y&&Y.sanitize&&!Y.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(Y,X){if(X<1)return"";for(var $e="";X>1;)X&1&&($e+=Y),X>>=1,Y+=Y;return $e+Y}function N(Y,X,$e,re){var fe=X.href,te=X.title?S(X.title):null,he=Y[1].replace(/\\([\[\]])/g,"$1");if(Y[0].charAt(0)!=="!"){re.state.inLink=!0;var pe={type:"link",raw:$e,href:fe,title:te,text:he,tokens:re.inlineTokens(he)};return re.state.inLink=!1,pe}return{type:"image",raw:$e,href:fe,title:te,text:S(he)}}function j(Y,X){var $e=Y.match(/^(\s+)(?:```)/);if($e===null)return X;var re=$e[1];return X.split(`
`).map(function(fe){var te=fe.match(/^\s+/);if(te===null)return fe;var he=te[0];return he.length>=re.length?fe.slice(re.length):fe}).join(`
`)}var M=function(){function Y($e){this.options=$e||me.defaults}var X=Y.prototype;return X.space=function(re){var fe=this.rules.block.newline.exec(re);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},X.code=function(re){var fe=this.rules.block.code.exec(re);if(fe){var te=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?te:$(te,`
`)}}},X.fences=function(re){var fe=this.rules.block.fences.exec(re);if(fe){var te=fe[0],he=j(te,fe[3]||"");return{type:"code",raw:te,lang:fe[2]?fe[2].trim():fe[2],text:he}}},X.heading=function(re){var fe=this.rules.block.heading.exec(re);if(fe){var te=fe[2].trim();if(/#$/.test(te)){var he=$(te,"#");(this.options.pedantic||!he||/ $/.test(he))&&(te=he.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:te,tokens:this.lexer.inline(te)}}},X.hr=function(re){var fe=this.rules.block.hr.exec(re);if(fe)return{type:"hr",raw:fe[0]}},X.blockquote=function(re){var fe=this.rules.block.blockquote.exec(re);if(fe){var te=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},X.list=function(re){var fe=this.rules.block.list.exec(re);if(fe){var te,he,pe,Pe,B,Q,se,oe,_,ge,ye,je,We=fe[1].trim(),_e=We.length>1,Ze={type:"list",raw:"",ordered:_e,start:_e?+We.slice(0,-1):"",loose:!1,items:[]};We=_e?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=_e?We:"[*+-]");for(var it=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");re&&(je=!1,!(!(fe=it.exec(re))||this.rules.block.hr.test(re)));){if(te=fe[0],re=re.substring(te.length),oe=fe[2].split(`
`,1)[0],_=re.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=oe.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=oe.slice(Pe),Pe+=fe[1].length),Q=!1,!oe&&/^ *$/.test(_)&&(te+=_+`
`,re=re.substring(_.length+1),je=!0),!je)for(var tt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");re&&(ge=re.split(`
`,1)[0],oe=ge,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(oe)||qe.test(oe)||tt.test(oe)||Ae.test(re)));){if(oe.search(/[^ ]/)>=Pe||!oe.trim())ye+=`
`+oe.slice(Pe);else if(!Q)ye+=`
`+oe;else break;!Q&&!oe.trim()&&(Q=!0),te+=ge+`
`,re=re.substring(ge.length+1)}Ze.loose||(se?Ze.loose=!0:/\n *\n *$/.test(te)&&(se=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(ye),he&&(pe=he[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ze.items.push({type:"list_item",raw:te,task:!!he,checked:pe,loose:!1,text:ye}),Ze.raw+=te}Ze.items[Ze.items.length-1].raw=te.trimRight(),Ze.items[Ze.items.length-1].text=ye.trimRight(),Ze.raw=Ze.raw.trimRight();var Re=Ze.items.length;for(B=0;B<Re;B++){this.lexer.state.top=!1,Ze.items[B].tokens=this.lexer.blockTokens(Ze.items[B].text,[]);var Xe=Ze.items[B].tokens.filter(function(ce){return ce.type==="space"}),ue=Xe.every(function(ce){for(var Ie=ce.raw.split(""),Ke=0,Ue=L(Ie),Ye;!(Ye=Ue()).done;){var nt=Ye.value;if(nt===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ze.loose&&Xe.length&&ue&&(Ze.loose=!0,Ze.items[B].loose=!0)}return Ze}},X.html=function(re){var fe=this.rules.block.html.exec(re);if(fe){var te={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var he=this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]);te.type="paragraph",te.text=he,te.tokens=this.lexer.inline(he)}return te}},X.def=function(re){var fe=this.rules.block.def.exec(re);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var te=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:fe[0],href:fe[2],title:fe[3]}}},X.table=function(re){var fe=this.rules.block.table.exec(re);if(fe){var te={type:"table",header:D(fe[1]).map(function(se){return{text:se}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=fe[0];var he=te.align.length,pe,Pe,B,Q;for(pe=0;pe<he;pe++)/^ *-+: *$/.test(te.align[pe])?te.align[pe]="right":/^ *:-+: *$/.test(te.align[pe])?te.align[pe]="center":/^ *:-+ *$/.test(te.align[pe])?te.align[pe]="left":te.align[pe]=null;for(he=te.rows.length,pe=0;pe<he;pe++)te.rows[pe]=D(te.rows[pe],te.header.length).map(function(se){return{text:se}});for(he=te.header.length,Pe=0;Pe<he;Pe++)te.header[Pe].tokens=this.lexer.inline(te.header[Pe].text);for(he=te.rows.length,Pe=0;Pe<he;Pe++)for(Q=te.rows[Pe],B=0;B<Q.length;B++)Q[B].tokens=this.lexer.inline(Q[B].text);return te}}},X.lheading=function(re){var fe=this.rules.block.lheading.exec(re);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},X.paragraph=function(re){var fe=this.rules.block.paragraph.exec(re);if(fe){var te=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:te,tokens:this.lexer.inline(te)}}},X.text=function(re){var fe=this.rules.block.text.exec(re);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},X.escape=function(re){var fe=this.rules.inline.escape.exec(re);if(fe)return{type:"escape",raw:fe[0],text:S(fe[1])}},X.tag=function(re){var fe=this.rules.inline.tag.exec(re);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]):fe[0]}},X.link=function(re){var fe=this.rules.inline.link.exec(re);if(fe){var te=fe[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var he=$(te.slice(0,-1),"\\");if((te.length-he.length)%2===0)return}else{var pe=b(fe[2],"()");if(pe>-1){var Pe=fe[0].indexOf("!")===0?5:4,B=Pe+fe[1].length+pe;fe[2]=fe[2].substring(0,pe),fe[0]=fe[0].substring(0,B).trim(),fe[3]=""}}var Q=fe[2],se="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Q);oe&&(Q=oe[1],se=oe[3])}else se=fe[3]?fe[3].slice(1,-1):"";return Q=Q.trim(),/^</.test(Q)&&(this.options.pedantic&&!/>$/.test(te)?Q=Q.slice(1):Q=Q.slice(1,-1)),N(fe,{href:Q&&Q.replace(this.rules.inline._escapes,"$1"),title:se&&se.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},X.reflink=function(re,fe){var te;if((te=this.rules.inline.reflink.exec(re))||(te=this.rules.inline.nolink.exec(re))){var he=(te[2]||te[1]).replace(/\s+/g," ");if(he=fe[he.toLowerCase()],!he||!he.href){var pe=te[0].charAt(0);return{type:"text",raw:pe,text:pe}}return N(te,he,te[0],this.lexer)}},X.emStrong=function(re,fe,te){te===void 0&&(te="");var he=this.rules.inline.emStrong.lDelim.exec(re);if(he&&!(he[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=he[1]||he[2]||"";if(!pe||pe&&(te===""||this.rules.inline.punctuation.exec(te))){var Pe=he[0].length-1,B,Q,se=Pe,oe=0,_=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(_.lastIndex=0,fe=fe.slice(-1*re.length+Pe);(he=_.exec(fe))!=null;)if(B=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!B){if(Q=B.length,he[3]||he[4]){se+=Q;continue}else if((he[5]||he[6])&&Pe%3&&!((Pe+Q)%3)){oe+=Q;continue}if(se-=Q,!(se>0)){if(Q=Math.min(Q,Q+se+oe),Math.min(Pe,Q)%2){var ge=re.slice(1,Pe+he.index+Q);return{type:"em",raw:re.slice(0,Pe+he.index+Q+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var ye=re.slice(2,Pe+he.index+Q-1);return{type:"strong",raw:re.slice(0,Pe+he.index+Q+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},X.codespan=function(re){var fe=this.rules.inline.code.exec(re);if(fe){var te=fe[2].replace(/\n/g," "),he=/[^ ]/.test(te),pe=/^ /.test(te)&&/ $/.test(te);return he&&pe&&(te=te.substring(1,te.length-1)),te=S(te,!0),{type:"codespan",raw:fe[0],text:te}}},X.br=function(re){var fe=this.rules.inline.br.exec(re);if(fe)return{type:"br",raw:fe[0]}},X.del=function(re){var fe=this.rules.inline.del.exec(re);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},X.autolink=function(re,fe){var te=this.rules.inline.autolink.exec(re);if(te){var he,pe;return te[2]==="@"?(he=S(this.options.mangle?fe(te[1]):te[1]),pe="mailto:"+he):(he=S(te[1]),pe=he),{type:"link",raw:te[0],text:he,href:pe,tokens:[{type:"text",raw:he,text:he}]}}},X.url=function(re,fe){var te;if(te=this.rules.inline.url.exec(re)){var he,pe;if(te[2]==="@")he=S(this.options.mangle?fe(te[0]):te[0]),pe="mailto:"+he;else{var Pe;do Pe=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Pe!==te[0]);he=S(te[0]),te[1]==="www."?pe="http://"+he:pe=he}return{type:"link",raw:te[0],text:he,href:pe,tokens:[{type:"text",raw:he,text:he}]}}},X.inlineText=function(re,fe){var te=this.rules.inline.text.exec(re);if(te){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):S(te[0]):te[0]:he=S(this.options.smartypants?fe(te[0]):te[0]),{type:"text",raw:te[0],text:he}}},Y}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=i(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=i(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=i(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=i(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=i(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=k({},O),O.gfm=k({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=i(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=k({},O.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=i(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=i(O._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=i(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=i(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=i(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=i(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=i(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=i(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=i(z.reflink).replace("label",z._label).replace("ref",O._label).getRegex(),z.nolink=i(z.nolink).replace("ref",O._label).getRegex(),z.reflinkSearch=i(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=k({},z),z.pedantic=k({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=k({},z.normal,{escape:i(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=i(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=k({},z.gfm,{br:i(z.br).replace("{2,}","*").getRegex(),text:i(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(Y){return Y.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Y){var X="",$e,re,fe=Y.length;for($e=0;$e<fe;$e++)re=Y.charCodeAt($e),Math.random()>.5&&(re="x"+re.toString(16)),X+="&#"+re+";";return X}var V=function(){function Y($e){this.tokens=[],this.tokens.links=Object.create(null),this.options=$e||me.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var re={block:O.normal,inline:z.normal};this.options.pedantic?(re.block=O.pedantic,re.inline=z.pedantic):this.options.gfm&&(re.block=O.gfm,this.options.breaks?re.inline=z.breaks:re.inline=z.gfm),this.tokenizer.rules=re}Y.lex=function(re,fe){var te=new Y(fe);return te.lex(re)},Y.lexInline=function(re,fe){var te=new Y(fe);return te.inlineTokens(re)};var X=Y.prototype;return X.lex=function(re){re=re.replace(/\r\n|\r/g,`
`),this.blockTokens(re,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},X.blockTokens=function(re,fe){var te=this;fe===void 0&&(fe=[]),this.options.pedantic?re=re.replace(/\t/g,"    ").replace(/^ +$/gm,""):re=re.replace(/^( *)(\t+)/gm,function(se,oe,_){return oe+"    ".repeat(_.length)});for(var he,pe,Pe,B;re;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(se){return(he=se.call({lexer:te},re,fe))?(re=re.substring(he.raw.length),fe.push(he),!0):!1}))){if(he=this.tokenizer.space(re)){re=re.substring(he.raw.length),he.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(he);continue}if(he=this.tokenizer.code(re)){re=re.substring(he.raw.length),pe=fe[fe.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+he.raw,pe.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(he);continue}if(he=this.tokenizer.fences(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.heading(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.hr(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.blockquote(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.list(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.html(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.def(re)){re=re.substring(he.raw.length),pe=fe[fe.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+he.raw,pe.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.lheading(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(Pe=re,this.options.extensions&&this.options.extensions.startBlock&&function(){var se=1/0,oe=re.slice(1),_=void 0;te.options.extensions.startBlock.forEach(function(ge){_=ge.call({lexer:this},oe),typeof _=="number"&&_>=0&&(se=Math.min(se,_))}),se<1/0&&se>=0&&(Pe=re.substring(0,se+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Pe))){pe=fe[fe.length-1],B&&pe.type==="paragraph"?(pe.raw+=`
`+he.raw,pe.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(he),B=Pe.length!==re.length,re=re.substring(he.raw.length);continue}if(he=this.tokenizer.text(re)){re=re.substring(he.raw.length),pe=fe[fe.length-1],pe&&pe.type==="text"?(pe.raw+=`
`+he.raw,pe.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(he);continue}if(re){var Q="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return this.state.top=!0,fe},X.inline=function(re,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:re,tokens:fe}),fe},X.inlineTokens=function(re,fe){var te=this;fe===void 0&&(fe=[]);var he,pe,Pe,B=re,Q,se,oe;if(this.tokens.links){var _=Object.keys(this.tokens.links);if(_.length>0)for(;(Q=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)_.includes(Q[0].slice(Q[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,Q.index)+"["+C("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Q=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,Q.index)+"["+C("a",Q[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Q=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,Q.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;)if(se||(oe=""),se=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(he=ye.call({lexer:te},re,fe))?(re=re.substring(he.raw.length),fe.push(he),!0):!1}))){if(he=this.tokenizer.escape(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.tag(re)){re=re.substring(he.raw.length),pe=fe[fe.length-1],pe&&he.type==="text"&&pe.type==="text"?(pe.raw+=he.raw,pe.text+=he.text):fe.push(he);continue}if(he=this.tokenizer.link(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(he.raw.length),pe=fe[fe.length-1],pe&&he.type==="text"&&pe.type==="text"?(pe.raw+=he.raw,pe.text+=he.text):fe.push(he);continue}if(he=this.tokenizer.emStrong(re,B,oe)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.codespan(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.br(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.del(re)){re=re.substring(he.raw.length),fe.push(he);continue}if(he=this.tokenizer.autolink(re,W)){re=re.substring(he.raw.length),fe.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(re,W))){re=re.substring(he.raw.length),fe.push(he);continue}if(Pe=re,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,je=re.slice(1),We=void 0;te.options.extensions.startInline.forEach(function(_e){We=_e.call({lexer:this},je),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=re.substring(0,ye+1))}(),he=this.tokenizer.inlineText(Pe,T)){re=re.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(oe=he.raw.slice(-1)),se=!0,pe=fe[fe.length-1],pe&&pe.type==="text"?(pe.raw+=he.raw,pe.text+=he.text):fe.push(he);continue}if(re){var ge="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return fe},I(Y,null,[{key:"rules",get:function(){return{block:O,inline:z}}}]),Y}(),de=function(){function Y($e){this.options=$e||me.defaults}var X=Y.prototype;return X.code=function(re,fe,te){var he=(fe||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(re,he);pe!=null&&pe!==re&&(te=!0,re=pe)}return re=re.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+S(he,!0)+'">'+(te?re:S(re,!0))+`</code></pre>
`:"<pre><code>"+(te?re:S(re,!0))+`</code></pre>
`},X.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},X.html=function(re){return re},X.heading=function(re,fe,te,he){if(this.options.headerIds){var pe=this.options.headerPrefix+he.slug(te);return"<h"+fe+' id="'+pe+'">'+re+"</h"+fe+`>
`}return"<h"+fe+">"+re+"</h"+fe+`>
`},X.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},X.list=function(re,fe,te){var he=fe?"ol":"ul",pe=fe&&te!==1?' start="'+te+'"':"";return"<"+he+pe+`>
`+re+"</"+he+`>
`},X.listitem=function(re){return"<li>"+re+`</li>
`},X.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},X.paragraph=function(re){return"<p>"+re+`</p>
`},X.table=function(re,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+fe+`</table>
`},X.tablerow=function(re){return`<tr>
`+re+`</tr>
`},X.tablecell=function(re,fe){var te=fe.header?"th":"td",he=fe.align?"<"+te+' align="'+fe.align+'">':"<"+te+">";return he+re+("</"+te+`>
`)},X.strong=function(re){return"<strong>"+re+"</strong>"},X.em=function(re){return"<em>"+re+"</em>"},X.codespan=function(re){return"<code>"+re+"</code>"},X.br=function(){return this.options.xhtml?"<br/>":"<br>"},X.del=function(re){return"<del>"+re+"</del>"},X.link=function(re,fe,te){if(re=a(this.options.sanitize,this.options.baseUrl,re),re===null)return te;var he='<a href="'+S(re)+'"';return fe&&(he+=' title="'+fe+'"'),he+=">"+te+"</a>",he},X.image=function(re,fe,te){if(re=a(this.options.sanitize,this.options.baseUrl,re),re===null)return te;var he='<img src="'+re+'" alt="'+te+'"';return fe&&(he+=' title="'+fe+'"'),he+=this.options.xhtml?"/>":">",he},X.text=function(re){return re},Y}(),ee=function(){function Y(){}var X=Y.prototype;return X.strong=function(re){return re},X.em=function(re){return re},X.codespan=function(re){return re},X.del=function(re){return re},X.html=function(re){return re},X.text=function(re){return re},X.link=function(re,fe,te){return""+te},X.image=function(re,fe,te){return""+te},X.br=function(){return""},Y}(),Z=function(){function Y(){this.seen={}}var X=Y.prototype;return X.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},X.getNextSafeSlug=function(re,fe){var te=re,he=0;if(this.seen.hasOwnProperty(te)){he=this.seen[re];do he++,te=re+"-"+he;while(this.seen.hasOwnProperty(te))}return fe||(this.seen[re]=he,this.seen[te]=0),te},X.slug=function(re,fe){fe===void 0&&(fe={});var te=this.serialize(re);return this.getNextSafeSlug(te,fe.dryrun)},Y}(),J=function(){function Y($e){this.options=$e||me.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new Z}Y.parse=function(re,fe){var te=new Y(fe);return te.parse(re)},Y.parseInline=function(re,fe){var te=new Y(fe);return te.parseInline(re)};var X=Y.prototype;return X.parse=function(re,fe){fe===void 0&&(fe=!0);var te="",he,pe,Pe,B,Q,se,oe,_,ge,ye,je,We,_e,Ze,it,tt,Ae,Oe,qe,Re=re.length;for(he=0;he<Re;he++){if(ye=re[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(qe=this.options.extensions.renderers[ye.type].call({parser:this},ye),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){te+=qe||"";continue}switch(ye.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,c(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(_="",oe="",B=ye.header.length,pe=0;pe<B;pe++)oe+=this.renderer.tablecell(this.parseInline(ye.header[pe].tokens),{header:!0,align:ye.align[pe]});for(_+=this.renderer.tablerow(oe),ge="",B=ye.rows.length,pe=0;pe<B;pe++){for(se=ye.rows[pe],oe="",Q=se.length,Pe=0;Pe<Q;Pe++)oe+=this.renderer.tablecell(this.parseInline(se[Pe].tokens),{header:!1,align:ye.align[Pe]});ge+=this.renderer.tablerow(oe)}te+=this.renderer.table(_,ge);continue}case"blockquote":{ge=this.parse(ye.tokens),te+=this.renderer.blockquote(ge);continue}case"list":{for(je=ye.ordered,We=ye.start,_e=ye.loose,B=ye.items.length,ge="",pe=0;pe<B;pe++)it=ye.items[pe],tt=it.checked,Ae=it.task,Ze="",it.task&&(Oe=this.renderer.checkbox(tt),_e?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Oe+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Oe+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Oe}):Ze+=Oe),Ze+=this.parse(it.tokens,_e),ge+=this.renderer.listitem(Ze,Ae,tt);te+=this.renderer.list(ge,je,We);continue}case"html":{te+=this.renderer.html(ye.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ge=ye.tokens?this.parseInline(ye.tokens):ye.text;he+1<Re&&re[he+1].type==="text";)ye=re[++he],ge+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);te+=fe?this.renderer.paragraph(ge):ge;continue}default:{var Xe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return te},X.parseInline=function(re,fe){fe=fe||this.renderer;var te="",he,pe,Pe,B=re.length;for(he=0;he<B;he++){if(pe=re[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Pe=this.options.extensions.renderers[pe.type].call({parser:this},pe),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(pe.type))){te+=Pe||"";continue}switch(pe.type){case"escape":{te+=fe.text(pe.text);break}case"html":{te+=fe.html(pe.text);break}case"link":{te+=fe.link(pe.href,pe.title,this.parseInline(pe.tokens,fe));break}case"image":{te+=fe.image(pe.href,pe.title,pe.text);break}case"strong":{te+=fe.strong(this.parseInline(pe.tokens,fe));break}case"em":{te+=fe.em(this.parseInline(pe.tokens,fe));break}case"codespan":{te+=fe.codespan(pe.text);break}case"br":{te+=fe.br();break}case"del":{te+=fe.del(this.parseInline(pe.tokens,fe));break}case"text":{te+=fe.text(pe.text);break}default:{var Q='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(Q);return}else throw new Error(Q)}}}return te},Y}();function ae(Y,X,$e){if(typeof Y>"u"||Y===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Y!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Y)+", string expected");if(typeof X=="function"&&($e=X,X=null),X=k({},ae.defaults,X||{}),v(X),$e){var re=X.highlight,fe;try{fe=V.lex(Y,X)}catch(B){return $e(B)}var te=function(Q){var se;if(!Q)try{X.walkTokens&&ae.walkTokens(fe,X.walkTokens),se=J.parse(fe,X)}catch(oe){Q=oe}return X.highlight=re,Q?$e(Q):$e(null,se)};if(!re||re.length<3||(delete X.highlight,!fe.length))return te();var he=0;ae.walkTokens(fe,function(B){B.type==="code"&&(he++,setTimeout(function(){re(B.text,B.lang,function(Q,se){if(Q)return te(Q);se!=null&&se!==B.text&&(B.text=se,B.escaped=!0),he--,he===0&&te()})},0))}),he===0&&te();return}function pe(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,X.silent)return"<p>An error occurred:</p><pre>"+S(B.message+"",!0)+"</pre>";throw B}try{var Pe=V.lex(Y,X);if(X.walkTokens){if(X.async)return Promise.all(ae.walkTokens(Pe,X.walkTokens)).then(function(){return J.parse(Pe,X)}).catch(pe);ae.walkTokens(Pe,X.walkTokens)}return J.parse(Pe,X)}catch(B){pe(B)}}ae.options=ae.setOptions=function(Y){return k(ae.defaults,Y),p(ae.defaults),ae},ae.getDefaults=R,ae.defaults=me.defaults,ae.use=function(){for(var Y=arguments.length,X=new Array(Y),$e=0;$e<Y;$e++)X[$e]=arguments[$e];var re=k.apply(void 0,[{}].concat(X)),fe=ae.defaults.extensions||{renderers:{},childTokens:{}},te;X.forEach(function(he){if(he.extensions&&(te=!0,he.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=fe.renderers?fe.renderers[Pe.name]:null;B?fe.renderers[Pe.name]=function(){for(var Q=arguments.length,se=new Array(Q),oe=0;oe<Q;oe++)se[oe]=arguments[oe];var _=Pe.renderer.apply(this,se);return _===!1&&(_=B.apply(this,se)),_}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),he.renderer&&function(){var Pe=ae.defaults.renderer||new de,B=function(oe){var _=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=he.renderer[oe].apply(Pe,ye);return We===!1&&(We=_.apply(Pe,ye)),We}};for(var Q in he.renderer)B(Q);re.renderer=Pe}(),he.tokenizer&&function(){var Pe=ae.defaults.tokenizer||new M,B=function(oe){var _=Pe[oe];Pe[oe]=function(){for(var ge=arguments.length,ye=new Array(ge),je=0;je<ge;je++)ye[je]=arguments[je];var We=he.tokenizer[oe].apply(Pe,ye);return We===!1&&(We=_.apply(Pe,ye)),We}};for(var Q in he.tokenizer)B(Q);re.tokenizer=Pe}(),he.walkTokens){var pe=ae.defaults.walkTokens;re.walkTokens=function(Pe){var B=[];return B.push(he.walkTokens.call(this,Pe)),pe&&(B=B.concat(pe.call(this,Pe))),B}}te&&(re.extensions=fe),ae.setOptions(re)})},ae.walkTokens=function(Y,X){for(var $e=[],re=function(){var pe=te.value;switch($e=$e.concat(X.call(ae,pe)),pe.type){case"table":{for(var Pe=L(pe.header),B;!(B=Pe()).done;){var Q=B.value;$e=$e.concat(ae.walkTokens(Q.tokens,X))}for(var se=L(pe.rows),oe;!(oe=se()).done;)for(var _=oe.value,ge=L(_),ye;!(ye=ge()).done;){var je=ye.value;$e=$e.concat(ae.walkTokens(je.tokens,X))}break}case"list":{$e=$e.concat(ae.walkTokens(pe.items,X));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[pe.type]?ae.defaults.extensions.childTokens[pe.type].forEach(function(We){$e=$e.concat(ae.walkTokens(pe[We],X))}):pe.tokens&&($e=$e.concat(ae.walkTokens(pe.tokens,X)))}},fe=L(Y),te;!(te=fe()).done;)re();return $e},ae.parseInline=function(Y,X){if(typeof Y>"u"||Y===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Y!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Y)+", string expected");X=k({},ae.defaults,X||{}),v(X);try{var $e=V.lexInline(Y,X);return X.walkTokens&&ae.walkTokens($e,X.walkTokens),J.parseInline($e,X)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,X.silent)return"<p>An error occurred:</p><pre>"+S(re.message+"",!0)+"</pre>";throw re}},ae.Parser=J,ae.parser=J.parse,ae.Renderer=de,ae.TextRenderer=ee,ae.Lexer=V,ae.lexer=V.lex,ae.Tokenizer=M,ae.Slugger=Z,ae.parse=ae;var x=ae.options,Ee=ae.setOptions,le=ae.use,K=ae.walkTokens,U=ae.parseInline,ne=ae,be=J.parse,G=V.lex;me.Lexer=V,me.Parser=J,me.Renderer=de,me.Slugger=Z,me.TextRenderer=ee,me.Tokenizer=M,me.getDefaults=R,me.lexer=G,me.marked=ae,me.options=x,me.parse=ne,me.parseInline=U,me.parser=be,me.setOptions=Ee,me.use=le,me.walkTokens=K,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[77],Se([1,0,28]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=void 0;const F=new I.$Cc(1e4);function m(g){return E(g,"NFC",F)}e.$tl=m;const L=new I.$Cc(1e4);function R(g){return E(g,"NFD",L)}e.$ul=R;const p=/[^\u0000-\u0080]/;function E(g,A,P){if(!g)return g;const f=P.get(g);if(f)return f;let y;return p.test(g)?y=g.normalize(A):y=g,P.set(g,y),y}e.$vl=function(){const g=/[\u0300-\u036f]/g;return function(A){return R(A).replace(g,"")}}()}),define(ke[123],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=e.rot=e.$Tl=void 0;function I(p,E,g){return Math.min(Math.max(p,E),g)}e.$Tl=I;function F(p,E){return(E+p%E)%E}e.rot=F;class m{constructor(){this.a=0}getNext(){return this.a++}}e.$Vl=m;class L{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Wl=L;class R{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const g=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Xl=R}),function(){function me(m){const L=[];typeof m=="number"&&L.push("code/timeOrigin",m);function R(E){L.push(E,Date.now())}function p(){const E=[];for(let g=0;g<L.length;g+=2)E.push({name:L[g],startTime:L[g+1]});return E}return{mark:R,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(m){performance.mark(m)},getMarks(){let m=performance.timeOrigin;typeof m!="number"&&(m=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(m)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(m+R.startTime)});return L}};if(typeof process=="object"){const m=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(m)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function I(m){return m.MonacoPerformanceMarks||(m.MonacoPerformanceMarks=e()),m.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=I(F))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var F in I)(typeof exports=="object"?exports:me)[F]=I[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function I(F){if(e[F])return e[F].exports;var m=e[F]={i:F,l:!1,exports:{}};return me[F].call(m.exports,m,m.exports,I),m.l=!0,m.exports}return I.m=me,I.c=e,I.d=function(F,m,L){I.o(F,m)||Object.defineProperty(F,m,{enumerable:!0,get:L})},I.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},I.t=function(F,m){if(1&m&&(F=I(F)),8&m||4&m&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(I.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&m&&typeof F!="string")for(var R in F)I.d(L,R,function(p){return F[p]}.bind(null,R));return L},I.n=function(F){var m=F&&F.__esModule?function(){return F.default}:function(){return F};return I.d(m,"a",m),m},I.o=function(F,m){return Object.prototype.hasOwnProperty.call(F,m)},I.p="",I(I.s=0)}([function(me,e,I){(function(F){var m;e=me.exports=le,m=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],E=e.src=[],g=0,A=g++;E[A]="0|[1-9]\\d*";var P=g++;E[P]="[0-9]+";var f=g++;E[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=g++;E[y]="("+E[A]+")\\.("+E[A]+")\\.("+E[A]+")";var S=g++;E[S]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var w=g++;E[w]="(?:"+E[A]+"|"+E[f]+")";var c=g++;E[c]="(?:"+E[P]+"|"+E[f]+")";var s=g++;E[s]="(?:-("+E[w]+"(?:\\."+E[w]+")*))";var i=g++;E[i]="(?:-?("+E[c]+"(?:\\."+E[c]+")*))";var n=g++;E[n]="[0-9A-Za-z-]+";var o=g++;E[o]="(?:\\+("+E[n]+"(?:\\."+E[n]+")*))";var a=g++,t="v?"+E[y]+E[s]+"?"+E[o]+"?";E[a]="^"+t+"$";var r="[v=\\s]*"+E[S]+E[i]+"?"+E[o]+"?",d=g++;E[d]="^"+r+"$";var u=g++;E[u]="((?:<|>)?=?)";var l=g++;E[l]=E[P]+"|x|X|\\*";var h=g++;E[h]=E[A]+"|x|X|\\*";var k=g++;E[k]="[v=\\s]*("+E[h]+")(?:\\.("+E[h]+")(?:\\.("+E[h]+")(?:"+E[s]+")?"+E[o]+"?)?)?";var D=g++;E[D]="[v=\\s]*("+E[l]+")(?:\\.("+E[l]+")(?:\\.("+E[l]+")(?:"+E[i]+")?"+E[o]+"?)?)?";var $=g++;E[$]="^"+E[u]+"\\s*"+E[k]+"$";var b=g++;E[b]="^"+E[u]+"\\s*"+E[D]+"$";var v=g++;E[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=g++;E[C]="(?:~>?)";var N=g++;E[N]="(\\s*)"+E[C]+"\\s+",p[N]=new RegExp(E[N],"g");var j=g++;E[j]="^"+E[C]+E[k]+"$";var M=g++;E[M]="^"+E[C]+E[D]+"$";var O=g++;E[O]="(?:\\^)";var z=g++;E[z]="(\\s*)"+E[O]+"\\s+",p[z]=new RegExp(E[z],"g");var T=g++;E[T]="^"+E[O]+E[k]+"$";var W=g++;E[W]="^"+E[O]+E[D]+"$";var V=g++;E[V]="^"+E[u]+"\\s*("+r+")$|^$";var de=g++;E[de]="^"+E[u]+"\\s*("+t+")$|^$";var ee=g++;E[ee]="(\\s*)"+E[u]+"\\s*("+r+"|"+E[k]+")",p[ee]=new RegExp(E[ee],"g");var Z=g++;E[Z]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var J=g++;E[J]="^\\s*("+E[D]+")\\s+-\\s+("+E[D]+")\\s*$";var ae=g++;E[ae]="(<|>)?=?\\s*\\*";for(var x=0;x<35;x++)m(x,E[x]),p[x]||(p[x]=new RegExp(E[x]));function Ee(_,ge){if(_ instanceof le)return _;if(typeof _!="string"||_.length>L||!(ge?p[d]:p[a]).test(_))return null;try{return new le(_,ge)}catch{return null}}function le(_,ge){if(_ instanceof le){if(_.loose===ge)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof le))return new le(_,ge);m("SemVer",_,ge),this.loose=ge;var ye=_.trim().match(ge?p[d]:p[a]);if(!ye)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var We=+je;if(We>=0&&We<R)return We}return je}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=Ee,e.valid=function(_,ge){var ye=Ee(_,ge);return ye?ye.version:null},e.clean=function(_,ge){var ye=Ee(_.trim().replace(/^[=v]+/,""),ge);return ye?ye.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(_){return m("SemVer.compare",this.version,this.loose,_),_ instanceof le||(_=new le(_,this.loose)),this.compareMain(_)||this.comparePre(_)},le.prototype.compareMain=function(_){return _ instanceof le||(_=new le(_,this.loose)),U(this.major,_.major)||U(this.minor,_.minor)||U(this.patch,_.patch)},le.prototype.comparePre=function(_){if(_ instanceof le||(_=new le(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var ge=0;do{var ye=this.prerelease[ge],je=_.prerelease[ge];if(m("prerelease compare",ge,ye,je),ye===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ye===void 0)return-1;if(ye!==je)return U(ye,je)}while(++ge)},le.prototype.inc=function(_,ge){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,ge,ye,je){typeof ye=="string"&&(je=ye,ye=void 0);try{return new le(_,ye).inc(ge,je).version}catch{return null}},e.diff=function(_,ge){if(Y(_,ge))return null;var ye=Ee(_),je=Ee(ge);if(ye.prerelease.length||je.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==je[We])return We},e.compareIdentifiers=U;var K=/^[0-9]+$/;function U(_,ge){var ye=K.test(_),je=K.test(ge);return ye&&je&&(_=+_,ge=+ge),ye&&!je?-1:je&&!ye?1:_<ge?-1:_>ge?1:0}function ne(_,ge,ye){return new le(_,ye).compare(new le(ge,ye))}function be(_,ge,ye){return ne(_,ge,ye)>0}function G(_,ge,ye){return ne(_,ge,ye)<0}function Y(_,ge,ye){return ne(_,ge,ye)===0}function X(_,ge,ye){return ne(_,ge,ye)!==0}function $e(_,ge,ye){return ne(_,ge,ye)>=0}function re(_,ge,ye){return ne(_,ge,ye)<=0}function fe(_,ge,ye,je){var We;switch(ge){case"===":typeof _=="object"&&(_=_.version),typeof ye=="object"&&(ye=ye.version),We=_===ye;break;case"!==":typeof _=="object"&&(_=_.version),typeof ye=="object"&&(ye=ye.version),We=_!==ye;break;case"":case"=":case"==":We=Y(_,ye,je);break;case"!=":We=X(_,ye,je);break;case">":We=be(_,ye,je);break;case">=":We=$e(_,ye,je);break;case"<":We=G(_,ye,je);break;case"<=":We=re(_,ye,je);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function te(_,ge){if(_ instanceof te){if(_.loose===ge)return _;_=_.value}if(!(this instanceof te))return new te(_,ge);m("comparator",_,ge),this.loose=ge,this.parse(_),this.semver===he?this.value="":this.value=this.operator+this.semver.version,m("comp",this)}e.rcompareIdentifiers=function(_,ge){return U(ge,_)},e.major=function(_,ge){return new le(_,ge).major},e.minor=function(_,ge){return new le(_,ge).minor},e.patch=function(_,ge){return new le(_,ge).patch},e.compare=ne,e.compareLoose=function(_,ge){return ne(_,ge,!0)},e.rcompare=function(_,ge,ye){return ne(ge,_,ye)},e.sort=function(_,ge){return _.sort(function(ye,je){return e.compare(ye,je,ge)})},e.rsort=function(_,ge){return _.sort(function(ye,je){return e.rcompare(ye,je,ge)})},e.gt=be,e.lt=G,e.eq=Y,e.neq=X,e.gte=$e,e.lte=re,e.cmp=fe,e.Comparator=te;var he={};function pe(_,ge){if(_ instanceof pe)return _.loose===ge?_:new pe(_.raw,ge);if(_ instanceof te)return new pe(_.value,ge);if(!(this instanceof pe))return new pe(_,ge);if(this.loose=ge,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Pe(_){return!_||_.toLowerCase()==="x"||_==="*"}function B(_,ge,ye,je,We,_e,Ze,it,tt,Ae,Oe,qe,Re){return((ge=Pe(ye)?"":Pe(je)?">="+ye+".0.0":Pe(We)?">="+ye+"."+je+".0":">="+ge)+" "+(it=Pe(tt)?"":Pe(Ae)?"<"+(+tt+1)+".0.0":Pe(Oe)?"<"+tt+"."+(+Ae+1)+".0":qe?"<="+tt+"."+Ae+"."+Oe+"-"+qe:"<="+it)).trim()}function Q(_,ge){for(var ye=0;ye<_.length;ye++)if(!_[ye].test(ge))return!1;if(ge.prerelease.length){for(ye=0;ye<_.length;ye++)if(m(_[ye].semver),_[ye].semver!==he&&_[ye].semver.prerelease.length>0){var je=_[ye].semver;if(je.major===ge.major&&je.minor===ge.minor&&je.patch===ge.patch)return!0}return!1}return!0}function se(_,ge,ye){try{ge=new pe(ge,ye)}catch{return!1}return ge.test(_)}function oe(_,ge,ye,je){var We,_e,Ze,it,tt;switch(_=new le(_,je),ge=new pe(ge,je),ye){case">":We=be,_e=re,Ze=G,it=">",tt=">=";break;case"<":We=G,_e=$e,Ze=be,it="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(se(_,ge,je))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Oe=ge.set[Ae],qe=null,Re=null;if(Oe.forEach(function(Xe){Xe.semver===he&&(Xe=new te(">=0.0.0")),qe=qe||Xe,Re=Re||Xe,We(Xe.semver,qe.semver,je)?qe=Xe:Ze(Xe.semver,Re.semver,je)&&(Re=Xe)}),qe.operator===it||qe.operator===tt||(!Re.operator||Re.operator===it)&&_e(_,Re.semver)||Re.operator===tt&&Ze(_,Re.semver))return!1}return!0}te.prototype.parse=function(_){var ge=this.loose?p[V]:p[de],ye=_.match(ge);if(!ye)throw new TypeError("Invalid comparator: "+_);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new le(ye[2],this.loose):this.semver=he},te.prototype.toString=function(){return this.value},te.prototype.test=function(_){return m("Comparator.test",_,this.loose),this.semver===he||(typeof _=="string"&&(_=new le(_,this.loose)),fe(_,this.operator,this.semver,this.loose))},te.prototype.intersects=function(_,ge){if(!(_ instanceof te))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new pe(_.value,ge),se(this.value,ye,ge);if(_.operator==="")return ye=new pe(this.value,ge),se(_.semver,ye,ge);var je=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),_e=this.semver.version===_.semver.version,Ze=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),it=fe(this.semver,"<",_.semver,ge)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),tt=fe(this.semver,">",_.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return je||We||_e&&Ze||it||tt},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(_){var ge=this.loose;_=_.trim(),m("range",_,ge);var ye=ge?p[J]:p[Z];_=_.replace(ye,B),m("hyphen replace",_),_=_.replace(p[ee],"$1$2$3"),m("comparator trim",_,p[ee]),_=(_=(_=_.replace(p[N],"$1~")).replace(p[z],"$1^")).split(/\s+/).join(" ");var je=ge?p[V]:p[de],We=_.split(" ").map(function(_e){return function(Ze,it){return m("comp",Ze),Ze=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Oe){return function(qe,Re){m("caret",qe,Re);var Xe=Re?p[W]:p[T];return qe.replace(Xe,function(ue,ce,Ie,Ke,Ue){var Ye;return m("caret",qe,ue,ce,Ie,Ke,Ue),Pe(ce)?Ye="":Pe(Ie)?Ye=">="+ce+".0.0 <"+(+ce+1)+".0.0":Pe(Ke)?Ye=ce==="0"?">="+ce+"."+Ie+".0 <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+".0 <"+(+ce+1)+".0.0":Ue?(m("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ye=ce==="0"?Ie==="0"?">="+ce+"."+Ie+"."+Ke+Ue+" <"+ce+"."+Ie+"."+(+Ke+1):">="+ce+"."+Ie+"."+Ke+Ue+" <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+"."+Ke+Ue+" <"+(+ce+1)+".0.0"):(m("no pr"),Ye=ce==="0"?Ie==="0"?">="+ce+"."+Ie+"."+Ke+" <"+ce+"."+Ie+"."+(+Ke+1):">="+ce+"."+Ie+"."+Ke+" <"+ce+"."+(+Ie+1)+".0":">="+ce+"."+Ie+"."+Ke+" <"+(+ce+1)+".0.0"),m("caret return",Ye),Ye})}(Oe,Ae)}).join(" ")}(Ze,it),m("caret",Ze),Ze=function(tt,Ae){return tt.trim().split(/\s+/).map(function(Oe){return function(qe,Re){var Xe=Re?p[M]:p[j];return qe.replace(Xe,function(ue,ce,Ie,Ke,Ue){var Ye;return m("tilde",qe,ue,ce,Ie,Ke,Ue),Pe(ce)?Ye="":Pe(Ie)?Ye=">="+ce+".0.0 <"+(+ce+1)+".0.0":Pe(Ke)?Ye=">="+ce+"."+Ie+".0 <"+ce+"."+(+Ie+1)+".0":Ue?(m("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ye=">="+ce+"."+Ie+"."+Ke+Ue+" <"+ce+"."+(+Ie+1)+".0"):Ye=">="+ce+"."+Ie+"."+Ke+" <"+ce+"."+(+Ie+1)+".0",m("tilde return",Ye),Ye})}(Oe,Ae)}).join(" ")}(Ze,it),m("tildes",Ze),Ze=function(tt,Ae){return m("replaceXRanges",tt,Ae),tt.split(/\s+/).map(function(Oe){return function(qe,Re){qe=qe.trim();var Xe=Re?p[b]:p[$];return qe.replace(Xe,function(ue,ce,Ie,Ke,Ue,Ye){m("xRange",qe,ue,ce,Ie,Ke,Ue,Ye);var nt=Pe(Ie),ct=nt||Pe(Ke),bt=ct||Pe(Ue);return ce==="="&&bt&&(ce=""),nt?ue=ce===">"||ce==="<"?"<0.0.0":"*":ce&&bt?(ct&&(Ke=0),bt&&(Ue=0),ce===">"?(ce=">=",ct?(Ie=+Ie+1,Ke=0,Ue=0):bt&&(Ke=+Ke+1,Ue=0)):ce==="<="&&(ce="<",ct?Ie=+Ie+1:Ke=+Ke+1),ue=ce+Ie+"."+Ke+"."+Ue):ct?ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":bt&&(ue=">="+Ie+"."+Ke+".0 <"+Ie+"."+(+Ke+1)+".0"),m("xRange return",ue),ue})}(Oe,Ae)}).join(" ")}(Ze,it),m("xrange",Ze),Ze=function(tt,Ae){return m("replaceStars",tt,Ae),tt.trim().replace(p[ae],"")}(Ze,it),m("stars",Ze),Ze}(_e,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(_e){return!!_e.match(je)})),We=We.map(function(_e){return new te(_e,ge)})},pe.prototype.intersects=function(_,ge){if(!(_ instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(je){return _.set.some(function(We){return We.every(function(_e){return je.intersects(_e,ge)})})})})},e.toComparators=function(_,ge){return new pe(_,ge).set.map(function(ye){return ye.map(function(je){return je.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new le(_,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Q(this.set[ge],_))return!0;return!1},e.satisfies=se,e.maxSatisfying=function(_,ge,ye){var je=null,We=null;try{var _e=new pe(ge,ye)}catch{return null}return _.forEach(function(Ze){_e.test(Ze)&&(je&&We.compare(Ze)!==-1||(We=new le(je=Ze,ye)))}),je},e.minSatisfying=function(_,ge,ye){var je=null,We=null;try{var _e=new pe(ge,ye)}catch{return null}return _.forEach(function(Ze){_e.test(Ze)&&(je&&We.compare(Ze)!==1||(We=new le(je=Ze,ye)))}),je},e.validRange=function(_,ge){try{return new pe(_,ge).range||"*"}catch{return null}},e.ltr=function(_,ge,ye){return oe(_,ge,"<",ye)},e.gtr=function(_,ge,ye){return oe(_,ge,">",ye)},e.outside=oe,e.prerelease=function(_,ge){var ye=Ee(_,ge);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(_,ge,ye){return _=new pe(_,ye),ge=new pe(ge,ye),_.intersects(ge)},e.coerce=function(_){if(_ instanceof le)return _;if(typeof _!="string")return null;var ge=_.match(p[v]);return ge==null?null:Ee((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,I(1))},function(me,e){var I,F,m=me.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function p(c){if(I===setTimeout)return setTimeout(c,0);if((I===L||!I)&&setTimeout)return I=setTimeout,setTimeout(c,0);try{return I(c,0)}catch{try{return I.call(null,c,0)}catch{return I.call(this,c,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:L}catch{I=L}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var E,g=[],A=!1,P=-1;function f(){A&&E&&(A=!1,E.length?g=E.concat(g):P=-1,g.length&&y())}function y(){if(!A){var c=p(f);A=!0;for(var s=g.length;s;){for(E=g,g=[];++P<s;)E&&E[P].run();P=-1,s=g.length}E=null,A=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(c)}}function S(c,s){this.fun=c,this.array=s}function w(){}m.nextTick=function(c){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];g.push(new S(c,s)),g.length!==1||A||p(y)},S.prototype.run=function(){this.fun.apply(null,this.array)},m.title="browser",m.browser=!0,m.env={},m.argv=[],m.version="",m.versions={},m.on=w,m.addListener=w,m.once=w,m.off=w,m.removeListener=w,m.removeAllListeners=w,m.emit=w,m.prependListener=w,m.prependOnceListener=w,m.listeners=function(c){return[]},m.binding=function(c){throw new Error("process.binding is not supported")},m.cwd=function(){return"/"},m.chdir=function(c){throw new Error("process.chdir is not supported")},m.umask=function(){return 0}}])}),define(ke[37],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=I&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Md=F}),define(ke[4],Se([1,0,11,75,3,76,37]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.Event=void 0;const p=!1,E=!1;var g;(function($){$.None=()=>m.$Rc.None;function b(fe){if(E){const{onDidAddListener:te}=fe,he=S.create();let pe=0;fe.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),te?.()}}}function v(fe,te){return de(fe,()=>{},0,void 0,!0,void 0,te)}$.defer=v;function C(fe){return(te,he=null,pe)=>{let Pe=!1,B;return B=fe(Q=>{if(!Pe)return B?B.dispose():Pe=!0,te.call(he,Q)},null,pe),Pe&&B.dispose(),B}}$.once=C;function N(fe,te,he){return W((pe,Pe=null,B)=>fe(Q=>pe.call(Pe,te(Q)),null,B),he)}$.map=N;function j(fe,te,he){return W((pe,Pe=null,B)=>fe(Q=>{te(Q),pe.call(Pe,Q)},null,B),he)}$.forEach=j;function M(fe,te,he){return W((pe,Pe=null,B)=>fe(Q=>te(Q)&&pe.call(Pe,Q),null,B),he)}$.filter=M;function O(fe){return fe}$.signal=O;function z(...fe){return(te,he=null,pe)=>{const Pe=(0,m.$Oc)(...fe.map(B=>B(Q=>te.call(he,Q))));return V(Pe,pe)}}$.any=z;function T(fe,te,he,pe){let Pe=he;return N(fe,B=>(Pe=te(Pe,B),Pe),pe)}$.reduce=T;function W(fe,te){let he;const pe={onWillAddFirstListener(){he=fe(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};te||b(pe);const Pe=new n(pe);return te?.add(Pe),Pe.event}function V(fe,te){return te instanceof Array?te.push(fe):te&&te.add(fe),fe}function de(fe,te,he=100,pe=!1,Pe=!1,B,Q){let se,oe,_,ge=0,ye;const je={leakWarningThreshold:B,onWillAddFirstListener(){se=fe(_e=>{ge++,oe=te(oe,_e),pe&&!_&&(We.fire(oe),oe=void 0),ye=()=>{const Ze=oe;oe=void 0,_=void 0,(!pe||ge>1)&&We.fire(Ze),ge=0},typeof he=="number"?(clearTimeout(_),_=setTimeout(ye,he)):_===void 0&&(_=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&ge>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,se.dispose()}};Q||b(je);const We=new n(je);return Q?.add(We),We.event}$.debounce=de;function ee(fe,te=0,he){return $.debounce(fe,(pe,Pe)=>pe?(pe.push(Pe),pe):[Pe],te,void 0,!0,void 0,he)}$.accumulate=ee;function Z(fe,te=(pe,Pe)=>pe===Pe,he){let pe=!0,Pe;return M(fe,B=>{const Q=pe||!te(B,Pe);return pe=!1,Pe=B,Q},he)}$.latch=Z;function J(fe,te,he){return[$.filter(fe,te,he),$.filter(fe,pe=>!te(pe),he)]}$.split=J;function ae(fe,te=!1,he=[],pe){let Pe=he.slice(),B=fe(oe=>{Pe?Pe.push(oe):se.fire(oe)});pe&&pe.add(B);const Q=()=>{Pe?.forEach(oe=>se.fire(oe)),Pe=null},se=new n({onWillAddFirstListener(){B||(B=fe(oe=>se.fire(oe)),pe&&pe.add(B))},onDidAddFirstListener(){Pe&&(te?setTimeout(Q):Q())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return pe&&pe.add(se),se.event}$.buffer=ae;function x(fe,te){return(pe,Pe,B)=>{const Q=te(new le);return fe(function(se){const oe=Q.evaluate(se);oe!==Ee&&pe.call(Pe,oe)},void 0,B)}}$.chain=x;const Ee=Symbol("HaltChainable");class le{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(he=>(te(he),he)),this}filter(te){return this.f.push(he=>te(he)?he:Ee),this}reduce(te,he){let pe=he;return this.f.push(Pe=>(pe=te(pe,Pe),pe)),this}latch(te=(he,pe)=>he===pe){let he=!0,pe;return this.f.push(Pe=>{const B=he||!te(Pe,pe);return he=!1,pe=Pe,B?Pe:Ee}),this}evaluate(te){for(const he of this.f)if(te=he(te),te===Ee)break;return te}}function K(fe,te,he=pe=>pe){const pe=(...se)=>Q.fire(he(...se)),Pe=()=>fe.on(te,pe),B=()=>fe.removeListener(te,pe),Q=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Q.event}$.fromNodeEventEmitter=K;function U(fe,te,he=pe=>pe){const pe=(...se)=>Q.fire(he(...se)),Pe=()=>fe.addEventListener(te,pe),B=()=>fe.removeEventListener(te,pe),Q=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Q.event}$.fromDOMEventEmitter=U;function ne(fe){return new Promise(te=>C(fe)(te))}$.toPromise=ne;function be(fe){const te=new n;return fe.then(he=>{te.fire(he)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}$.fromPromise=be;function G(fe,te,he){return te(he),fe(pe=>te(pe))}$.runAndSubscribe=G;function Y(fe,te){let he=null;function pe(B){he?.dispose(),he=new m.$Qc,te(B,he)}pe(void 0);const Pe=fe(B=>pe(B));return(0,m.$Pc)(()=>{Pe.dispose(),he?.dispose()})}$.runAndSubscribeWithStore=Y;class X{constructor(te,he){this._observable=te,this.f=0,this.g=!1;const pe={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};he||b(pe),this.emitter=new n(pe),he&&he.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,he){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(fe,te){return new X(fe,te).emitter.event}$.fromObservable=$e;function re(fe){return te=>{let he=0,pe=!1;const Pe={beginUpdate(){he++},endUpdate(){he--,he===0&&(fe.reportChanges(),pe&&(pe=!1,te()))},handlePossibleChange(){},handleChange(){pe=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}$.fromObservableLight=re})(g||(e.Event=g={}));class A{static{this.all=new Set}static{this.f=0}constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${A.f++}`,A.all.add(this)}start(b){this.g=new R.$Md,this.listenerCount=b}stop(){if(this.g){const b=this.g.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this.g=void 0}}}e.$Od=A;let P=-1;function f($){const b=P;return P=$,{dispose(){P=b}}}e.$Pd=f;class y{constructor(b,v=Math.random().toString(18).slice(2,5)){this.threshold=b,this.name=v,this.g=0}dispose(){this.f?.clear()}check(b,v){const C=this.threshold;if(C<=0||v<C)return;this.f||(this.f=new Map);const N=this.f.get(b.value)||0;if(this.f.set(b.value,N+1),this.g-=1,this.g<=0){this.g=C*.5;let j,M=0;for(const[O,z]of this.f)(!j||M<z)&&(j=O,M=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${M}):`),console.warn(j)}return()=>{const j=this.f.get(b.value)||0;this.f.set(b.value,j-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class c{constructor(b){this.value=b,this.id=w++}}const s=2,i=($,b)=>{if($ instanceof c)b($);else for(let v=0;v<$.length;v++){const C=$[v];C&&b(C)}};class n{constructor(b){this.w=0,this.f=b,this.g=P>0||this.f?.leakWarningThreshold?new y(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(p){const b=this.t;queueMicrotask(()=>{i(b,v=>v.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(b,v,C)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),m.$Rc.None;if(this.m)return m.$Rc.None;v&&(b=b.bind(v));const N=new c(b);let j,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=S.create(),j=this.g.check(N.stack,this.w+1)),p&&(N.stack=M??S.create()),this.t?this.t instanceof c?(this.u??=new a,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const O=(0,m.$Pc)(()=>{j?.(),this.x(N)});return C instanceof m.$Qc?C.add(O):Array.isArray(C)&&C.push(O),O},this.q}x(b){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const v=this.t,C=v.indexOf(b);if(C===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,v[C]=void 0;const N=this.u.current===this;if(this.w*s<=v.length){let j=0;for(let M=0;M<v.length;M++)v[M]?v[j++]=v[M]:N&&(this.u.end--,j<this.u.i&&this.u.i--);v.length=j}}y(b,v){if(!b)return;const C=this.f?.onListenerError||I.$Z;if(!C){b.value(v);return}try{b.value(v)}catch(N){C(N)}}z(b){const v=b.current.t;for(;b.i<b.end;)this.y(v[b.i++],b.value);b.reset()}fire(b){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof c)this.y(this.t,b);else{const v=this.u;v.enqueue(this,b,this.t.length),this.z(v)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Qd=n;const o=()=>new a;e.$Rd=o;class a{constructor(){this.i=-1,this.end=0}enqueue(b,v,C){this.i=0,this.end=C,this.current=b,this.value=v}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(b,v,C){if(this.t)for(this.h||(this.h=new L.$1c),i(this.t,N=>this.h.push([N.value,b]));this.h.size>0&&!v.isCancellationRequested;){const[N,j]=this.h.shift(),M=[],O={...j,token:v,waitUntil:z=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");C&&(z=C(z,N)),M.push(z)}};try{N(O)}catch(z){(0,I.$Z)(z);continue}Object.freeze(M),await Promise.allSettled(M).then(z=>{for(const T of z)T.status==="rejected"&&(0,I.$Z)(T.reason)})}}}e.$Sd=t;class r extends n{get isPaused(){return this.h!==0}constructor(b){super(b),this.h=0,this.s=new L.$1c,this.A=b?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const b=Array.from(this.s);this.s.clear(),super.fire(this.A(b))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(b){this.w&&(this.h!==0?this.s.push(b):super.fire(b))}}e.$Td=r;class d extends r{constructor(b){super(b),this.k=b.delay??100}fire(b){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(b)}}e.$Ud=d;class u extends n{constructor(b){super(b),this.h=[],this.k=b?.merge}fire(b){this.hasListeners()&&(this.h.push(b),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(v=>super.fire(v)),this.h=[]}))}}e.$Vd=u;class l{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(b){const v={event:b,listener:null};this.h.push(v),this.g&&this.m(v);const C=()=>{this.g&&this.o(v);const N=this.h.indexOf(v);this.h.splice(N,1)};return(0,m.$Pc)((0,F.$cb)(C))}j(){this.g=!0,this.h.forEach(b=>this.m(b))}k(){this.g=!1,this.h.forEach(b=>this.o(b))}m(b){b.listener=b.event(v=>this.f.fire(v))}o(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.f.dispose()}}e.$Wd=l;class h{constructor(b,v,C,N){this.f=new m.$Qc;const j=this.f.add(new l),M=this.f.add(new m.$Zc);function O(z){M.set(z,j.add(N(z)))}for(const z of b)O(z);this.f.add(v(z=>{O(z)})),this.f.add(C(z=>{M.deleteAndDispose(z)})),this.event=j.event}dispose(){this.f.dispose()}}e.$Xd=h;class k{constructor(){this.f=[]}wrapEvent(b){return(v,C,N)=>b(j=>{const M=this.f[this.f.length-1];M?M.push(()=>v.call(C,j)):v.call(C,j)},void 0,N)}bufferEvents(b){const v=[];this.f.push(v);const C=b();return this.f.pop(),v.forEach(N=>N()),C}}e.$Yd=k;class D{constructor(){this.f=!1,this.g=g.None,this.h=m.$Rc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(b){this.g=b,this.f&&(this.h.dispose(),this.h=b(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Zd=D}),define(ke[21],Se([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.CancellationToken=void 0;const F=Object.freeze(function(p,E){const g=setTimeout(p.bind(E),0);return{dispose(){clearTimeout(g)}}});var m;(function(p){function E(g){return g===p.None||g===p.Cancelled||g instanceof L?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}p.isCancellationToken=E,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(m||(e.CancellationToken=m={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new I.$Qd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(E){this.f=void 0,this.g=void 0,this.g=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=m.Cancelled}dispose(E=!1){E&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=m.None}}e.$1d=R}),define(ke[162],Se([1,0,21]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.$ze=void 0;class F{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new I.$1d,E=this.b(p.token);return this.a={promise:E,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$ze=F;class m{constructor(p){this.c=p,this.a=void 0,this.b=void 0}get(p){const E=JSON.stringify(p);return this.b!==E&&(this.b=E,this.a=this.c(p)),this.a}}e.$Ae=m;class L{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const E=this.b(p);return this.a.set(p,E),E}}e.$Be=L}),define(ke[98],Se([1,0,11,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=void 0;function m(o){const a=o;return a?typeof a.read=="function":!1}e.$2d=m;function L(o){const a=o;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$3d=L;function R(o){const a=o;return a?L(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$4d=R;function p(o,a){return new E(o,a)}e.$5d=p;class E{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,I.$Z)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const d=r.indexOf(t);d>=0&&r.splice(d,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(o,a){const t=[];let r;for(;(r=o.read())!==null;)t.push(r);return a(t)}e.$6d=g;function A(o,a,t){const r=[];let d;for(;(d=o.read())!==null&&r.length<t;)r.push(d);return d===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof d<"u"){const u=d;return d=void 0,u}return o.read()}}}e.$7d=A;function P(o,a){return new Promise((t,r)=>{const d=[];f(o,{onData:u=>{a&&d.push(u)},onError:u=>{a?r(u):t(void 0)},onEnd:()=>{t(a?a(d):void 0)}})})}e.$8d=P;function f(o,a,t){o.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),o.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),o.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}e.$9d=f;function y(o,a){return new Promise((t,r)=>{const d=new F.$Qc,u=[],l=D=>{if(u.push(D),u.length>a)return d.dispose(),o.pause(),t({stream:o,buffer:u,ended:!1})},h=D=>(d.dispose(),r(D)),k=()=>(d.dispose(),t({stream:o,buffer:u,ended:!0}));d.add((0,F.$Pc)(()=>o.removeListener("error",h))),o.on("error",h),d.add((0,F.$Pc)(()=>o.removeListener("end",k))),o.on("end",k),d.add((0,F.$Pc)(()=>o.removeListener("data",l))),o.on("data",l)})}e.$0d=y;function S(o,a){const t=p(a);return t.end(o),t}e.$$d=S;function w(){const o=p(()=>{throw new Error("not supported")});return o.end(),o}e.$_d=w;function c(o){let a=!1;return{read:()=>a?null:(a=!0,o)}}e.$ae=c;function s(o,a,t){const r=p(t);return f(o,{onData:d=>r.write(a.data(d)),onError:d=>r.error(a.error?a.error(d):d),onEnd:()=>r.end()}),r}e.$be=s;function i(o,a,t){let r=!1;return{read:()=>{const d=a.read();return r?d:(r=!0,d!==null?t([o,d]):o)}}}e.$ce=i;function n(o,a,t){let r=!1;const d=p(t);return f(a,{onData:u=>r?d.write(u):(r=!0,d.write(t([o,u]))),onError:u=>d.error(u),onEnd:()=>{r||(r=!0,d.write(o)),d.end()}}),d}e.$de=n}),define(ke[22],Se([1,0,48,98]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;const m=typeof Buffer<"u",L=new I.$U(()=>new Uint8Array(256));let R,p;class E{static alloc(v){return m?new E(Buffer.allocUnsafe(v)):new E(new Uint8Array(v))}static wrap(v){return m&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new E(v)}static fromString(v,C){return!(C?.dontUseNodeBuffer||!1)&&m?new E(Buffer.from(v)):(R||(R=new TextEncoder),new E(R.encode(v)))}static fromByteArray(v){const C=E.alloc(v.length);for(let N=0,j=v.length;N<j;N++)C.buffer[N]=v[N];return C}static concat(v,C){if(typeof C>"u"){C=0;for(let M=0,O=v.length;M<O;M++)C+=v[M].byteLength}const N=E.alloc(C);let j=0;for(let M=0,O=v.length;M<O;M++){const z=v[M];N.set(z,j),j+=z.byteLength}return N}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=E.alloc(this.byteLength);return v.set(this),v}toString(){return m?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(v,C){return new E(this.buffer.subarray(v,C))}set(v,C){if(v instanceof E)this.buffer.set(v.buffer,C);else if(v instanceof Uint8Array)this.buffer.set(v,C);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),C);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return f(this.buffer,v)}writeUInt32BE(v,C){y(this.buffer,v,C)}readUInt32LE(v){return S(this.buffer,v)}writeUInt32LE(v,C){w(this.buffer,v,C)}readUInt8(v){return c(this.buffer,v)}writeUInt8(v,C){s(this.buffer,v,C)}indexOf(v,C=0){return g(this.buffer,v instanceof E?v.buffer:v,C)}}e.$ee=E;function g(b,v,C=0){const N=v.byteLength,j=b.byteLength;if(N===0)return 0;if(N===1)return b.indexOf(v[0]);if(N>j-C)return-1;const M=L.value;M.fill(v.length);for(let W=0;W<v.length;W++)M[v[W]]=v.length-W-1;let O=C+v.length-1,z=O,T=-1;for(;O<j;)if(b[O]===v[z]){if(z===0){T=O;break}O--,z--}else O+=Math.max(v.length-z,M[b[O]]),z=v.length-1;return T}e.$fe=g;function A(b,v){return b[v+0]<<0>>>0|b[v+1]<<8>>>0}e.$ge=A;function P(b,v,C){b[C+0]=v&255,v=v>>>8,b[C+1]=v&255}e.$he=P;function f(b,v){return b[v]*2**24+b[v+1]*2**16+b[v+2]*2**8+b[v+3]}e.$ie=f;function y(b,v,C){b[C+3]=v,v=v>>>8,b[C+2]=v,v=v>>>8,b[C+1]=v,v=v>>>8,b[C]=v}e.$je=y;function S(b,v){return b[v+0]<<0>>>0|b[v+1]<<8>>>0|b[v+2]<<16>>>0|b[v+3]<<24>>>0}e.$ke=S;function w(b,v,C){b[C+0]=v&255,v=v>>>8,b[C+1]=v&255,v=v>>>8,b[C+2]=v&255,v=v>>>8,b[C+3]=v&255}e.$le=w;function c(b,v){return b[v]}e.$me=c;function s(b,v,C){b[C]=v}e.$ne=s;function i(b){return F.$6d(b,v=>E.concat(v))}e.$oe=i;function n(b){return F.$ae(b)}e.$pe=n;function o(b){return F.$8d(b,v=>E.concat(v))}e.$qe=o;async function a(b){return b.ended?E.concat(b.buffer):E.concat([...b.buffer,await o(b.stream)])}e.$re=a;function t(b){return F.$$d(b,v=>E.concat(v))}e.$se=t;function r(b){return F.$be(b,{data:v=>typeof v=="string"?E.fromString(v):E.wrap(v)},v=>E.concat(v))}e.$te=r;function d(b){return F.$5d(v=>E.concat(v),b)}e.$ue=d;function u(b,v){return F.$ce(b,v,C=>E.concat(C))}e.$ve=u;function l(b,v){return F.$de(b,v,C=>E.concat(C))}e.$we=l;function h(b){let v=0,C=0,N=0;const j=new Uint8Array(Math.floor(b.length/4*3)),M=z=>{switch(C){case 3:j[N++]=v|z,C=0;break;case 2:j[N++]=v|z>>>2,v=z<<6,C=3;break;case 1:j[N++]=v|z>>>4,v=z<<4,C=2;break;default:v=z<<2,C=1}};for(let z=0;z<b.length;z++){const T=b.charCodeAt(z);if(T>=65&&T<=90)M(T-65);else if(T>=97&&T<=122)M(T-97+26);else if(T>=48&&T<=57)M(T-48+52);else if(T===43||T===45)M(62);else if(T===47||T===95)M(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${b[z]}`)}}const O=N;for(;C>0;)M(0);return E.wrap(j).slice(0,O)}e.$xe=h;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:b},v=!0,C=!1){const N=C?D:k;let j="";const M=b.byteLength%3;let O=0;for(;O<b.byteLength-M;O+=3){const z=b[O+0],T=b[O+1],W=b[O+2];j+=N[z>>>2],j+=N[(z<<4|T>>>4)&63],j+=N[(T<<2|W>>>6)&63],j+=N[W&63]}if(M===1){const z=b[O+0];j+=N[z>>>2],j+=N[z<<4&63],v&&(j+="==")}else if(M===2){const z=b[O+0],T=b[O+1];j+=N[z>>>2],j+=N[(z<<4|T>>>4)&63],j+=N[T<<2&63],v&&(j+="=")}return j}e.$ye=$}),define(ke[13],Se([1,0,162,48]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Af=e.$zf=e.$yf=e.$xf=e.GraphemeBreakType=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=void 0;function m(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ee=m;const L=/{(\d+)}/g;function R(Ae,...Oe){return Oe.length===0?Ae:Ae.replace(L,function(qe,Re){const Xe=parseInt(Re,10);return isNaN(Xe)||Xe<0||Xe>=Oe.length?qe:Oe[Xe]})}e.$Fe=R;const p=/{([^}]+)}/g;function E(Ae,Oe){return Object.keys(Oe).length===0?Ae:Ae.replace(p,(qe,Re)=>Oe[Re]??qe)}e.$Ge=E;function g(Ae){return Ae.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$He=g;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ie=A;function P(Ae,Oe){let qe=0;const Re=Oe.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Re&&qe++;return qe}e.$Je=P;function f(Ae,Oe,qe="\u2026"){return Ae.length<=Oe?Ae:`${Ae.substr(0,Oe)}${qe}`}e.$Ke=f;function y(Ae,Oe=" "){const qe=S(Ae,Oe);return w(qe,Oe)}e.$Le=y;function S(Ae,Oe){if(!Ae||!Oe)return Ae;const qe=Oe.length;if(qe===0||Ae.length===0)return Ae;let Re=0;for(;Ae.indexOf(Oe,Re)===Re;)Re=Re+qe;return Ae.substring(Re)}e.$Me=S;function w(Ae,Oe){if(!Ae||!Oe)return Ae;const qe=Oe.length,Re=Ae.length;if(qe===0||Re===0)return Ae;let Xe=Re,ue=-1;for(;ue=Ae.lastIndexOf(Oe,Xe-1),!(ue===-1||ue+qe!==Xe);){if(ue===0)return"";Xe=ue}return Ae.substring(0,Xe)}e.$Ne=w;function c(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Oe=c;function s(Ae){return Ae.replace(/\*/g,"")}e.$Pe=s;function i(Ae,Oe,qe={}){if(!Ae)throw new Error("Cannot create regex from empty string");Oe||(Ae=A(Ae)),qe.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Re="";return qe.global&&(Re+="g"),qe.matchCase||(Re+="i"),qe.multiline&&(Re+="m"),qe.unicode&&(Re+="u"),new RegExp(Ae,Re)}e.$Qe=i;function n(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Re=n;function o(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Se=o;function a(Ae){for(let Oe=0,qe=Ae.length;Oe<qe;Oe++){const Re=Ae.charCodeAt(Oe);if(Re!==32&&Re!==9)return Oe}return-1}e.$Te=a;function t(Ae,Oe=0,qe=Ae.length){for(let Re=Oe;Re<qe;Re++){const Xe=Ae.charCodeAt(Re);if(Xe!==32&&Xe!==9)return Ae.substring(Oe,Re)}return Ae.substring(Oe,qe)}e.$Ue=t;function r(Ae,Oe=Ae.length-1){for(let qe=Oe;qe>=0;qe--){const Re=Ae.charCodeAt(qe);if(Re!==32&&Re!==9)return qe}return-1}e.$Ve=r;function d(Ae,Oe,qe){const Re=[];let Xe=0;for(const ue of Ae.matchAll(Oe)){if(Re.push(Ae.slice(Xe,ue.index)),ue.index===void 0)throw new Error("match.index should be defined");Xe=ue.index+ue[0].length,Re.push(qe(ue[0],...ue.slice(1),ue.index,Ae,ue.groups))}return Re.push(Ae.slice(Xe)),Promise.all(Re).then(ue=>ue.join(""))}e.$We=d;function u(Ae,Oe){return Ae<Oe?-1:Ae>Oe?1:0}e.$Xe=u;function l(Ae,Oe,qe=0,Re=Ae.length,Xe=0,ue=Oe.length){for(;qe<Re&&Xe<ue;qe++,Xe++){const Ke=Ae.charCodeAt(qe),Ue=Oe.charCodeAt(Xe);if(Ke<Ue)return-1;if(Ke>Ue)return 1}const ce=Re-qe,Ie=ue-Xe;return ce<Ie?-1:ce>Ie?1:0}e.$Ye=l;function h(Ae,Oe){return k(Ae,Oe,0,Ae.length,0,Oe.length)}e.$Ze=h;function k(Ae,Oe,qe=0,Re=Ae.length,Xe=0,ue=Oe.length){for(;qe<Re&&Xe<ue;qe++,Xe++){let Ke=Ae.charCodeAt(qe),Ue=Oe.charCodeAt(Xe);if(Ke===Ue)continue;if(Ke>=128||Ue>=128)return l(Ae.toLowerCase(),Oe.toLowerCase(),qe,Re,Xe,ue);$(Ke)&&(Ke-=32),$(Ue)&&(Ue-=32);const Ye=Ke-Ue;if(Ye!==0)return Ye}const ce=Re-qe,Ie=ue-Xe;return ce<Ie?-1:ce>Ie?1:0}e.$1e=k;function D(Ae){return Ae>=48&&Ae<=57}e.$2e=D;function $(Ae){return Ae>=97&&Ae<=122}e.$3e=$;function b(Ae){return Ae>=65&&Ae<=90}e.$4e=b;function v(Ae,Oe){return Ae.length===Oe.length&&k(Ae,Oe)===0}e.$5e=v;function C(Ae,Oe){const qe=Oe.length;return Oe.length>Ae.length?!1:k(Ae,Oe,0,qe)===0}e.$6e=C;function N(Ae,Oe){const qe=Math.min(Ae.length,Oe.length);let Re;for(Re=0;Re<qe;Re++)if(Ae.charCodeAt(Re)!==Oe.charCodeAt(Re))return Re;return qe}e.$7e=N;function j(Ae,Oe){const qe=Math.min(Ae.length,Oe.length);let Re;const Xe=Ae.length-1,ue=Oe.length-1;for(Re=0;Re<qe;Re++)if(Ae.charCodeAt(Xe-Re)!==Oe.charCodeAt(ue-Re))return Re;return qe}e.$8e=j;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$9e=M;function O(Ae){return 56320<=Ae&&Ae<=57343}e.$0e=O;function z(Ae,Oe){return(Ae-55296<<10)+(Oe-56320)+65536}e.$$e=z;function T(Ae,Oe,qe){const Re=Ae.charCodeAt(qe);if(M(Re)&&qe+1<Oe){const Xe=Ae.charCodeAt(qe+1);if(O(Xe))return z(Re,Xe)}return Re}e.$_e=T;function W(Ae,Oe){const qe=Ae.charCodeAt(Oe-1);if(O(qe)&&Oe>1){const Re=Ae.charCodeAt(Oe-2);if(M(Re))return z(Re,qe)}return qe}class V{get offset(){return this.e}constructor(Oe,qe=0){this.c=Oe,this.d=Oe.length,this.e=qe}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=W(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=T(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$af=V;class de{get offset(){return this.c.offset}constructor(Oe,qe=0){this.c=new V(Oe,qe)}nextGraphemeLength(){const Oe=ge.getInstance(),qe=this.c,Re=qe.offset;let Xe=Oe.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const ue=qe.offset,ce=Oe.getGraphemeBreakType(qe.nextCodePoint());if(oe(Xe,ce)){qe.setOffset(ue);break}Xe=ce}return qe.offset-Re}prevGraphemeLength(){const Oe=ge.getInstance(),qe=this.c,Re=qe.offset;let Xe=Oe.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const ue=qe.offset,ce=Oe.getGraphemeBreakType(qe.prevCodePoint());if(oe(ce,Xe)){qe.setOffset(ue);break}Xe=ce}return Re-qe.offset}eol(){return this.c.eol()}}e.$bf=de;function ee(Ae,Oe){return new de(Ae,Oe).nextGraphemeLength()}e.$cf=ee;function Z(Ae,Oe){return new de(Ae,Oe).prevGraphemeLength()}e.$df=Z;function J(Ae,Oe){Oe>0&&O(Ae.charCodeAt(Oe))&&Oe--;const qe=Oe+ee(Ae,Oe);return[qe-Z(Ae,qe),qe]}e.$ef=J;function ae(Ae){const Oe=new de(Ae);let qe=0;for(;!Oe.eol();)qe++,Oe.nextGraphemeLength();return qe}e.$ff=ae;let x;function Ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function le(Ae){return x||(x=Ee()),x.test(Ae)}e.$gf=le;const K=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return K.test(Ae)}e.$hf=U,e.$if=/[\u2028\u2029]/;function ne(Ae){return e.$if.test(Ae)}e.$jf=ne;function be(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$kf=be;function G(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$lf=G;function Y(Ae,Oe){if(Ae.length<Oe)return Ae;const qe=/\b/g;let Re=0;for(;qe.test(Ae)&&!(Ae.length-qe.lastIndex<Oe);)Re=qe.lastIndex,qe.lastIndex+=1;return Ae.substring(Re).replace(/^\s/,"")}e.$mf=Y;const X=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,$e=/\x1b\].*?\x07/g;function re(Ae){return Ae&&(Ae=Ae.replace(X,"").replace($e,"")),Ae}e.$nf=re,e.$of=String.fromCharCode(65279);function fe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$pf=fe;function te(Ae){return fe(Ae)?Ae.substr(1):Ae}e.$qf=te;function he(Ae,Oe){if(!Ae||!Oe||Ae.length<Oe.length)return!1;const qe=Oe.length,Re=Ae.toLowerCase();let Xe=0,ue=-1;for(;Xe<qe;){const ce=Re.indexOf(Oe[Xe],ue+1);if(ce<0)return!1;ue=ce,Xe++}return!0}e.$rf=he;function pe(Ae,Oe=!1){return Ae?(Oe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$sf=pe;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$tf=Pe;function B(Ae,Oe=1){if(Oe===0)return"";let qe=-1;do qe=Ae.indexOf(`
`,qe+1),Oe--;while(Oe>0&&qe>=0);return qe===-1?Ae:(Ae[qe-1]==="\r"&&qe--,Ae.substr(0,qe))}e.$uf=B;function Q(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$vf=Q;function se(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$wf=se;function oe(Ae,Oe){return Ae===0?Oe!==5&&Oe!==7:Ae===2&&Oe===3?!1:Ae===4||Ae===2||Ae===3||Oe===4||Oe===2||Oe===3?!0:!(Ae===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Ae===11||Ae===9)&&(Oe===9||Oe===10)||(Ae===12||Ae===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Ae===1||Ae===13&&Oe===14||Ae===6&&Oe===6)}var _;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(_||(e.GraphemeBreakType=_={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=ye()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const qe=this.d,Re=qe.length/3;let Xe=1;for(;Xe<=Re;)if(Oe<qe[3*Xe])Xe=2*Xe;else if(Oe>qe[3*Xe+1])Xe=2*Xe+1;else return qe[3*Xe+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ae,Oe){if(Ae===0)return 0;const qe=We(Ae,Oe);if(qe!==void 0)return qe;const Re=new V(Oe,Ae);return Re.prevCodePoint(),Re.offset}e.$xf=je;function We(Ae,Oe){const qe=new V(Oe,Ae);let Re=qe.prevCodePoint();for(;_e(Re)||Re===65039||Re===8419;){if(qe.offset===0)return;Re=qe.prevCodePoint()}if(!G(Re))return;let Xe=qe.offset;return Xe>0&&qe.prevCodePoint()===8205&&(Xe=qe.offset),Xe}function _e(Ae){return 127995<=Ae&&Ae<=127999}var Ze;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.$yf="\xA0";class it{static{this.c=new F.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$Ae(Oe=>{function qe(Ye){const nt=new Map;for(let ct=0;ct<Ye.length;ct+=2)nt.set(Ye[ct],Ye[ct+1]);return nt}function Re(Ye,nt){const ct=new Map(Ye);for(const[bt,Et]of nt)ct.set(bt,Et);return ct}function Xe(Ye,nt){if(!Ye)return nt;const ct=new Map;for(const[bt,Et]of Ye)nt.has(bt)&&ct.set(bt,Et);return ct}const ue=this.c.value;let ce=Oe.filter(Ye=>!Ye.startsWith("_")&&Ye in ue);ce.length===0&&(ce=["_default"]);let Ie;for(const Ye of ce){const nt=qe(ue[Ye]);Ie=Xe(Ie,nt)}const Ke=qe(ue._common),Ue=Re(Ke,Ie);return new it(Ue)})}static getInstance(Oe){return it.d.get(Array.from(Oe))}static{this.e=new F.$U(()=>Object.keys(it.c.value).filter(Oe=>!Oe.startsWith("_")))}static getLocales(){return it.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$zf=it;class tt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(tt.c())),this.d}static isInvisibleCharacter(Oe){return tt.e().has(Oe)}static get codePoints(){return tt.e()}}e.$Af=tt}),define(ke[124],Se([1,0,28,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.FuzzyScore=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.or=void 0;function m(...te){return function(he,pe){for(let Pe=0,B=te.length;Pe<B;Pe++){const Q=te[Pe](he,pe);if(Q)return Q}return null}}e.or=m,e.$Hj=L.bind(void 0,!1),e.$Ij=L.bind(void 0,!0);function L(te,he,pe){if(!pe||pe.length<he.length)return null;let Pe;return te?Pe=F.$6e(pe,he):Pe=pe.indexOf(he)===0,Pe?he.length>0?[{start:0,end:he.length}]:[]:null}function R(te,he){const pe=he.toLowerCase().indexOf(te.toLowerCase());return pe===-1?null:[{start:pe,end:pe+te.length}]}e.$Jj=R;function p(te,he){return E(te.toLowerCase(),he.toLowerCase(),0,0)}e.$Kj=p;function E(te,he,pe,Pe){if(pe===te.length)return[];if(Pe===he.length)return null;if(te[pe]===he[Pe]){let B=null;return(B=E(te,he,pe+1,Pe+1))?s({start:Pe,end:Pe+1},B):null}return E(te,he,pe,Pe+1)}function g(te){return 97<=te&&te<=122}function A(te){return 65<=te&&te<=90}e.$Lj=A;function P(te){return 48<=te&&te<=57}function f(te){return te===32||te===9||te===10||te===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>y.add(te.charCodeAt(0)));function S(te){return f(te)||y.has(te)}function w(te,he){return te===he||S(te)&&S(he)}function c(te){return g(te)||A(te)||P(te)}function s(te,he){return he.length===0?he=[te]:te.end===he[0].start?he[0].start=te.start:he.unshift(te),he}function i(te,he){for(let pe=he;pe<te.length;pe++){const Pe=te.charCodeAt(pe);if(A(Pe)||P(Pe)||pe>0&&!c(te.charCodeAt(pe-1)))return pe}return te.length}function n(te,he,pe,Pe){if(pe===te.length)return[];if(Pe===he.length)return null;if(te[pe]!==he[Pe].toLowerCase())return null;{let B=null,Q=Pe+1;for(B=n(te,he,pe+1,Pe+1);!B&&(Q=i(he,Q))<he.length;)B=n(te,he,pe+1,Q),Q++;return B===null?null:s({start:Pe,end:Pe+1},B)}}function o(te){let he=0,pe=0,Pe=0,B=0,Q=0;for(let ye=0;ye<te.length;ye++)Q=te.charCodeAt(ye),A(Q)&&he++,g(Q)&&pe++,c(Q)&&Pe++,P(Q)&&B++;const se=he/te.length,oe=pe/te.length,_=Pe/te.length,ge=B/te.length;return{upperPercent:se,lowerPercent:oe,alphaPercent:_,numericPercent:ge}}function a(te){const{upperPercent:he,lowerPercent:pe}=te;return pe===0&&he>.6}function t(te){const{upperPercent:he,lowerPercent:pe,alphaPercent:Pe,numericPercent:B}=te;return pe>.2&&he<.8&&Pe>.6&&B<.2}function r(te){let he=0,pe=0,Pe=0,B=0;for(let Q=0;Q<te.length;Q++)Pe=te.charCodeAt(Q),A(Pe)&&he++,g(Pe)&&pe++,f(Pe)&&B++;return(he===0||pe===0)&&B===0?te.length<=30:he<=5}function d(te,he){if(!he||(he=he.trim(),he.length===0)||!r(te)||he.length>60)return null;const pe=o(he);if(!t(pe)){if(!a(pe))return null;he=he.toLowerCase()}let Pe=null,B=0;for(te=te.toLowerCase();B<he.length&&(Pe=n(te,he,0,B))===null;)B=i(he,B+1);return Pe}e.$Mj=d;function u(te,he,pe=!1){if(!he||he.length===0)return null;let Pe=null,B=0;for(te=te.toLowerCase(),he=he.toLowerCase();B<he.length&&(Pe=l(te,he,0,B,pe))===null;)B=h(he,B+1);return Pe}e.$Nj=u;function l(te,he,pe,Pe,B){if(pe===te.length)return[];if(Pe===he.length)return null;if(w(te.charCodeAt(pe),he.charCodeAt(Pe))){let Q=null,se=Pe+1;if(Q=l(te,he,pe+1,Pe+1,B),!B)for(;!Q&&(se=h(he,se))<he.length;)Q=l(te,he,pe+1,se,B),se++;return Q?te.charCodeAt(pe)!==he.charCodeAt(Pe)?Q:s({start:Pe,end:Pe+1},Q):null}else return null}function h(te,he){for(let pe=he;pe<te.length;pe++)if(S(te.charCodeAt(pe))||pe>0&&S(te.charCodeAt(pe-1)))return pe;return te.length}const k=m(e.$Ij,d,R),D=m(e.$Ij,d,p),$=new I.$Cc(1e4);function b(te,he,pe=!1){if(typeof te!="string"||typeof he!="string")return null;let Pe=$.get(te);Pe||(Pe=new RegExp(F.$Oe(te),"i"),$.set(te,Pe));const B=Pe.exec(he);return B?[{start:B.index,end:B.index+B[0].length}]:pe?D(te,he):k(te,he)}e.$Oj=b;function v(te,he){const pe=be(te,te.toLowerCase(),0,he,he.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return pe?N(pe):null}e.$Pj=v;function C(te,he,pe,Pe,B,Q){const se=Math.min(13,te.length);for(;pe<se;pe++){const oe=be(te,he,pe,Pe,B,Q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,Q]}e.$Qj=C;function N(te){if(typeof te>"u")return[];const he=[],pe=te[1];for(let Pe=te.length-1;Pe>1;Pe--){const B=te[Pe]+pe,Q=he[he.length-1];Q&&Q.end===B?Q.end=B+1:he.push({start:B,end:B+1})}return he}e.$Rj=N;const j=128;function M(){const te=[],he=[];for(let pe=0;pe<=j;pe++)he[pe]=0;for(let pe=0;pe<=j;pe++)te.push(he.slice(0));return te}function O(te){const he=[];for(let pe=0;pe<=te;pe++)he[pe]=0;return he}const z=O(2*j),T=O(2*j),W=M(),V=M(),de=M(),ee=!1;function Z(te,he,pe,Pe,B){function Q(oe,_,ge=" "){for(;oe.length<_;)oe=ge+oe;return oe}let se=` |   |${Pe.split("").map(oe=>Q(oe,3)).join("|")}
`;for(let oe=0;oe<=pe;oe++)oe===0?se+=" |":se+=`${he[oe-1]}|`,se+=te[oe].slice(0,B+1).map(_=>Q(_.toString(),3)).join("|")+`
`;return se}function J(te,he,pe,Pe){te=te.substr(he),pe=pe.substr(Pe),console.log(Z(V,te,te.length,pe,pe.length)),console.log(Z(de,te,te.length,pe,pe.length)),console.log(Z(W,te,te.length,pe,pe.length))}function ae(te,he){if(he<0||he>=te.length)return!1;const pe=te.codePointAt(he);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$lf(pe)}}function x(te,he){if(he<0||he>=te.length)return!1;switch(te.charCodeAt(he)){case 32:case 9:return!0;default:return!1}}function Ee(te,he,pe){return he[te]!==pe[te]}function le(te,he,pe,Pe,B,Q,se=!1){for(;he<pe&&B<Q;)te[he]===Pe[B]&&(se&&(z[he]=B),he+=1),B+=1;return he===pe}e.$Sj=le;var K;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(K||(K={}));var U;(function(te){te.Default=[-100,0];function he(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}te.isDefault=he})(U||(e.FuzzyScore=U={}));class ne{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(he,pe){this.firstMatchCanBeWeak=he,this.boostFullMatch=pe}}e.$Tj=ne;function be(te,he,pe,Pe,B,Q,se=ne.default){const oe=te.length>j?j:te.length,_=Pe.length>j?j:Pe.length;if(pe>=oe||Q>=_||oe-pe>_-Q||!le(he,pe,oe,B,Q,_,!0))return;G(oe,_,pe,Q,he,B);let ge=1,ye=1,je=pe,We=Q;const _e=[!1];for(ge=1,je=pe;je<oe;ge++,je++){const Oe=z[je],qe=T[je],Re=je+1<oe?T[je+1]:_;for(ye=Oe-Q+1,We=Oe;We<Re;ye++,We++){let Xe=Number.MIN_SAFE_INTEGER,ue=!1;We<=qe&&(Xe=Y(te,he,je,pe,Pe,B,We,_,Q,W[ge-1][ye-1]===0,_e));let ce=0;Xe!==Number.MAX_SAFE_INTEGER&&(ue=!0,ce=Xe+V[ge-1][ye-1]);const Ie=We>Oe,Ke=Ie?V[ge][ye-1]+(W[ge][ye-1]>0?-5:0):0,Ue=We>Oe+1&&W[ge][ye-1]>0,Ye=Ue?V[ge][ye-2]+(W[ge][ye-2]>0?-5:0):0;if(Ue&&(!Ie||Ye>=Ke)&&(!ue||Ye>=ce))V[ge][ye]=Ye,de[ge][ye]=3,W[ge][ye]=0;else if(Ie&&(!ue||Ke>=ce))V[ge][ye]=Ke,de[ge][ye]=2,W[ge][ye]=0;else if(ue)V[ge][ye]=ce,de[ge][ye]=1,W[ge][ye]=W[ge-1][ye-1]+1;else throw new Error("not possible")}}if(ee&&J(te,pe,Pe,Q),!_e[0]&&!se.firstMatchCanBeWeak)return;ge--,ye--;const Ze=[V[ge][ye],Q];let it=0,tt=0;for(;ge>=1;){let Oe=ye;do{const qe=de[ge][Oe];if(qe===3)Oe=Oe-2;else if(qe===2)Oe=Oe-1;else break}while(Oe>=1);it>1&&he[pe+ge-1]===B[Q+ye-1]&&!Ee(Oe+Q-1,Pe,B)&&it+1>W[ge][Oe]&&(Oe=ye),Oe===ye?it++:it=1,tt||(tt=Oe),ge--,ye=Oe-1,Ze.push(ye)}_===oe&&se.boostFullMatch&&(Ze[0]+=2);const Ae=tt-oe;return Ze[0]-=Ae,Ze}e.$Uj=be;function G(te,he,pe,Pe,B,Q){let se=te-1,oe=he-1;for(;se>=pe&&oe>=Pe;)B[se]===Q[oe]&&(T[se]=oe,se--),oe--}function Y(te,he,pe,Pe,B,Q,se,oe,_,ge,ye){if(he[pe]!==Q[se])return Number.MIN_SAFE_INTEGER;let je=1,We=!1;return se===pe-Pe?je=te[pe]===B[se]?7:5:Ee(se,B,Q)&&(se===0||!Ee(se-1,B,Q))?(je=te[pe]===B[se]?7:5,We=!0):ae(Q,se)&&(se===0||!ae(Q,se-1))?je=5:(ae(Q,se-1)||x(Q,se-1))&&(je=5,We=!0),je>1&&pe===Pe&&(ye[0]=!0),We||(We=Ee(se,B,Q)||ae(Q,se-1)||x(Q,se-1)),pe===Pe?se>_&&(je-=We?3:5):ge?je+=We?2:0:je+=We?0:1,se+1===oe&&(je-=We?3:5),je}function X(te,he,pe,Pe,B,Q,se){return re(te,he,pe,Pe,B,Q,!0,se)}e.$Vj=X;function $e(te,he,pe,Pe,B,Q,se){return re(te,he,pe,Pe,B,Q,!1,se)}e.$Wj=$e;function re(te,he,pe,Pe,B,Q,se,oe){let _=be(te,he,pe,Pe,B,Q,oe);if(_&&!se)return _;if(te.length>=3){const ge=Math.min(7,te.length-1);for(let ye=pe+1;ye<ge;ye++){const je=fe(te,ye);if(je){const We=be(je,je.toLowerCase(),pe,Pe,B,Q,oe);We&&(We[0]-=3,(!_||We[0]>_[0])&&(_=We))}}}return _}function fe(te,he){if(he+1>=te.length)return;const pe=te[he],Pe=te[he+1];if(pe!==Pe)return te.slice(0,he)+Pe+pe+te.slice(he+2)}}),define(ke[52],Se([1,0,13]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=void 0;function F(s){return m(s,0)}e.$Ii=F;function m(s,i){switch(typeof s){case"object":return s===null?L(349,i):Array.isArray(s)?E(s,i):g(s,i);case"string":return p(s,i);case"boolean":return R(s,i);case"number":return L(s,i);case"undefined":return L(937,i);default:return L(617,i)}}e.$Ji=m;function L(s,i){return(i<<5)-i+s|0}e.$Ki=L;function R(s,i){return L(s?433:863,i)}function p(s,i){i=L(149417,i);for(let n=0,o=s.length;n<o;n++)i=L(s.charCodeAt(n),i);return i}e.$Li=p;function E(s,i){return i=L(104579,i),s.reduce((n,o)=>m(o,n),i)}function g(s,i){return i=L(181387,i),Object.keys(s).sort().reduce((n,o)=>(n=p(o,n),m(s[o],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=m(i,this.g),this.g}}e.$Mi=A;var P;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function f(s,i,n=32){const o=n-i,a=~((1<<o)-1);return(s<<i|(a&s)>>>o)>>>0}function y(s,i=0,n=s.byteLength,o=0){for(let a=0;a<n;a++)s[i+a]=o}function S(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function w(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):S((s>>>0).toString(16),i/4)}e.$Ni=w;class c{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const o=this.p;let a=this.r,t=this.u,r,d;for(t!==0?(r=t,d=-1,t=0):(r=i.charCodeAt(0),d=0);;){let u=r;if(I.$9e(r))if(d+1<n){const l=i.charCodeAt(d+1);I.$0e(l)?(d++,u=I.$$e(r,l)):u=65533}else{t=r;break}else I.$0e(r)&&(u=65533);if(a=this.w(o,a,u),d++,d<n)r=i.charCodeAt(d);else break}this.r=a,this.u=t}w(i,n,o){return o<128?i[n++]=o:o<2048?(i[n++]=192|(o&1984)>>>6,i[n++]=128|(o&63)>>>0):o<65536?(i[n++]=224|(o&61440)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0):(i[n++]=240|(o&1835008)>>>18,i[n++]=128|(o&258048)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=c.g,n=this.q;for(let k=0;k<64;k+=4)i.setUint32(k,n.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)i.setUint32(k,f(i.getUint32(k-12,!1)^i.getUint32(k-32,!1)^i.getUint32(k-56,!1)^i.getUint32(k-64,!1),1),!1);let o=this.h,a=this.l,t=this.m,r=this.n,d=this.o,u,l,h;for(let k=0;k<80;k++)k<20?(u=a&t|~a&r,l=1518500249):k<40?(u=a^t^r,l=1859775393):k<60?(u=a&t|a&r|t&r,l=2400959708):(u=a^t^r,l=3395469782),h=f(o,5)+u+d+l+i.getUint32(k*4,!1)&4294967295,d=r,r=t,t=f(a,30),a=o,o=h;this.h=this.h+o&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+d&4294967295}}e.$Oi=c}),define(ke[39],Se([1,0,13]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(m){m[m.Ignore=0]="Ignore",m[m.Info=1]="Info",m[m.Warning=2]="Warning",m[m.Error=3]="Error"})(F||(F={})),function(m){const L="error",R="warning",p="warn",E="info",g="ignore";function A(f){return f?I.$5e(L,f)?m.Error:I.$5e(R,f)||I.$5e(p,f)?m.Warning:I.$5e(E,f)?m.Info:m.Ignore:m.Ignore}m.fromValue=A;function P(f){switch(f){case m.Error:return L;case m.Warning:return R;case m.Info:return E;default:return g}}m.toString=P}(F||(F={})),e.default=F}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Nd=Symbol("MicrotaskDelay")}),define(ke[78],Se([1,0,19,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0;class m{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const S=y.charCodeAt(0),w=this.b.charCodeAt(this.c);return S-w}value(){return this.b[this.c]}}e.$Wh=m;class L{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,F.$Ye)(y,this.b,0,y.length,this.c,this.d):(0,F.$1e)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Xh=L;class R{constructor(y=!0,S=!0){this.f=y,this.g=S}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let S=y.length-1;S>=0;S--,this.c--){const w=this.b.charCodeAt(S);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,F.$Ye)(y,this.b,0,y.length,this.d,this.e):(0,F.$1e)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Yh=R;var p;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(p||(p={}));class E{constructor(y,S){this.f=y,this.g=S,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,F.$Ze)(y,this.c.scheme);if(this.d[this.e]===2)return(0,F.$Ze)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,F.$Xe)(y,this.c.query);if(this.d[this.e]===5)return(0,F.$Xe)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Zh=E;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(A||(A={}));class P{static forUris(y=()=>!1,S=()=>!1){return new P(new E(y,S))}static forPaths(y=!1){return new P(new R(void 0,!y))}static forStrings(){return new P(new m)}static forConfigKeys(){return new P(new L)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,S){if(S){const w=S.slice(0);(0,I.$Wb)(w);for(const c of w)this.set(c,y)}else{const w=y.slice(0);(0,I.$Wb)(w);for(const c of w)this.set(c[0],c[1])}}set(y,S){const w=this.b.reset(y);let c;this.c||(this.c=new g,this.c.segment=w.value());const s=[];for(c=this.c;;){const n=w.cmp(c.segment);if(n>0)c.left||(c.left=new g,c.left.segment=w.value()),s.push([-1,c]),c=c.left;else if(n<0)c.right||(c.right=new g,c.right.segment=w.value()),s.push([1,c]),c=c.right;else if(w.hasNext())w.next(),c.mid||(c.mid=new g,c.mid.segment=w.value()),s.push([0,c]),c=c.mid;else break}const i=c.value;c.value=S,c.key=y;for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const a=o.balanceFactor();if(a<-1||a>1){const t=s[n][0],r=s[n+1][0];if(t===1&&r===1)s[n][1]=o.rotateLeft();else if(t===-1&&r===-1)s[n][1]=o.rotateRight();else if(t===1&&r===-1)o.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=o.rotateLeft();else if(t===-1&&r===1)o.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(y){return this.d(y)?.value}d(y){const S=this.b.reset(y);let w=this.c;for(;w;){const c=S.cmp(w.segment);if(c>0)w=w.left;else if(c<0)w=w.right;else if(S.hasNext())S.next(),w=w.mid;else break}return w}has(y){const S=this.d(y);return!(S?.value===void 0&&S?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,S){const w=this.b.reset(y),c=[];let s=this.c;for(;s;){const i=w.cmp(s.segment);if(i>0)c.push([-1,s]),s=s.left;else if(i<0)c.push([1,s]),s=s.right;else if(w.hasNext())w.next(),c.push([0,s]),s=s.mid;else break}if(s){if(S?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:o,segment:a}=i;this.e(i.key,!1),s.key=n,s.value=o,s.segment=a}}else{const i=s.left??s.right;if(c.length>0){const[n,o]=c[c.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const n=c[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),c[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),c[i][1]=n.rotateRight()),i>0)switch(c[i-1][0]){case-1:c[i-1][1].left=c[i][1];break;case 1:c[i-1][1].right=c[i][1];break;case 0:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const S=this.b.reset(y);let w=this.c,c;for(;w;){const s=S.cmp(w.segment);if(s>0)w=w.left;else if(s<0)w=w.right;else if(S.hasNext())S.next(),c=w.value||c,w=w.mid;else break}return w&&w.value||c}findSuperstr(y){return this.g(y,!1)}g(y,S){const w=this.b.reset(y);let c=this.c;for(;c;){const s=w.cmp(c.segment);if(s>0)c=c.left;else if(s<0)c=c.right;else if(w.hasNext())w.next(),c=c.mid;else return c.mid?this.h(c.mid):S?c.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[S,w]of this)y(w,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const S=[];return this.j(y,S),S[Symbol.iterator]()}j(y,S){y&&(y.left&&this.j(y.left,S),y.value&&S.push([y.key,y.value]),y.mid&&this.j(y.mid,S),y.right&&this.j(y.right,S))}_isBalanced(){const y=S=>{if(!S)return!0;const w=S.balanceFactor();return w<-1||w>1?!1:y(S.left)&&y(S.right)};return y(this.c)}}e.$1h=P}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function I(a){return typeof a=="string"}e.$Bf=I;function F(a){return Array.isArray(a)&&a.every(t=>I(t))}e.$Cf=F;function m(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Df=m;function L(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Ef=L;function R(a){return typeof a=="number"&&!isNaN(a)}e.$Ff=R;function p(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Gf=p;function E(a){return a===!0||a===!1}e.$Hf=E;function g(a){return typeof a>"u"}e.$If=g;function A(a){return!P(a)}e.$Jf=A;function P(a){return g(a)||a===null}e.$Kf=P;function f(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Lf=f;function y(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Mf=y;function S(...a){const t=[];for(let r=0;r<a.length;r++){const d=a[r];if(P(d))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(d)}return t}e.$Nf=S;const w=Object.prototype.hasOwnProperty;function c(a){if(!m(a))return!1;for(const t in a)if(w.call(a,t))return!1;return!0}e.$Of=c;function s(a){return typeof a=="function"}e.$Pf=s;function i(...a){return a.length>0&&a.every(s)}e.$Qf=i;function n(a,t){const r=Math.min(a.length,t.length);for(let d=0;d<r;d++)o(a[d],t[d])}e.$Rf=n;function o(a,t){if(I(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(a instanceof t)return}catch{}if(!P(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Sf=o}),define(ke[79],Se([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=void 0;const F=Object.create(null);function m(p,E){if((0,I.$Bf)(E)){const g=F[E];if(g===void 0)throw new Error(`${p} references an unknown codicon: ${E}`);E=g}return F[p]=E,{id:p}}function L(){return F}e.$Xj=L;function R(){return Object.values(e.$Zj)}e.$Yj=R,e.$Zj={add:m("add",6e4),plus:m("plus",6e4),gistNew:m("gist-new",6e4),repoCreate:m("repo-create",6e4),lightbulb:m("lightbulb",60001),lightBulb:m("light-bulb",60001),repo:m("repo",60002),repoDelete:m("repo-delete",60002),gistFork:m("gist-fork",60003),repoForked:m("repo-forked",60003),gitPullRequest:m("git-pull-request",60004),gitPullRequestAbandoned:m("git-pull-request-abandoned",60004),recordKeys:m("record-keys",60005),keyboard:m("keyboard",60005),tag:m("tag",60006),tagAdd:m("tag-add",60006),tagRemove:m("tag-remove",60006),gitPullRequestLabel:m("git-pull-request-label",60006),person:m("person",60007),personFollow:m("person-follow",60007),personOutline:m("person-outline",60007),personFilled:m("person-filled",60007),gitBranch:m("git-branch",60008),gitBranchCreate:m("git-branch-create",60008),gitBranchDelete:m("git-branch-delete",60008),sourceControl:m("source-control",60008),mirror:m("mirror",60009),mirrorPublic:m("mirror-public",60009),star:m("star",60010),starAdd:m("star-add",60010),starDelete:m("star-delete",60010),starEmpty:m("star-empty",60010),comment:m("comment",60011),commentAdd:m("comment-add",60011),alert:m("alert",60012),warning:m("warning",60012),search:m("search",60013),searchSave:m("search-save",60013),logOut:m("log-out",60014),signOut:m("sign-out",60014),logIn:m("log-in",60015),signIn:m("sign-in",60015),eye:m("eye",60016),eyeUnwatch:m("eye-unwatch",60016),eyeWatch:m("eye-watch",60016),circleFilled:m("circle-filled",60017),primitiveDot:m("primitive-dot",60017),closeDirty:m("close-dirty",60017),debugBreakpoint:m("debug-breakpoint",60017),debugBreakpointDisabled:m("debug-breakpoint-disabled",60017),debugHint:m("debug-hint",60017),primitiveSquare:m("primitive-square",60018),edit:m("edit",60019),pencil:m("pencil",60019),info:m("info",60020),issueOpened:m("issue-opened",60020),gistPrivate:m("gist-private",60021),gitForkPrivate:m("git-fork-private",60021),lock:m("lock",60021),mirrorPrivate:m("mirror-private",60021),close:m("close",60022),removeClose:m("remove-close",60022),x:m("x",60022),repoSync:m("repo-sync",60023),sync:m("sync",60023),clone:m("clone",60024),desktopDownload:m("desktop-download",60024),beaker:m("beaker",60025),microscope:m("microscope",60025),vm:m("vm",60026),deviceDesktop:m("device-desktop",60026),file:m("file",60027),fileText:m("file-text",60027),more:m("more",60028),ellipsis:m("ellipsis",60028),kebabHorizontal:m("kebab-horizontal",60028),mailReply:m("mail-reply",60029),reply:m("reply",60029),organization:m("organization",60030),organizationFilled:m("organization-filled",60030),organizationOutline:m("organization-outline",60030),newFile:m("new-file",60031),fileAdd:m("file-add",60031),newFolder:m("new-folder",60032),fileDirectoryCreate:m("file-directory-create",60032),trash:m("trash",60033),trashcan:m("trashcan",60033),history:m("history",60034),clock:m("clock",60034),folder:m("folder",60035),fileDirectory:m("file-directory",60035),symbolFolder:m("symbol-folder",60035),logoGithub:m("logo-github",60036),markGithub:m("mark-github",60036),github:m("github",60036),terminal:m("terminal",60037),console:m("console",60037),repl:m("repl",60037),zap:m("zap",60038),symbolEvent:m("symbol-event",60038),error:m("error",60039),stop:m("stop",60039),variable:m("variable",60040),symbolVariable:m("symbol-variable",60040),array:m("array",60042),symbolArray:m("symbol-array",60042),symbolModule:m("symbol-module",60043),symbolPackage:m("symbol-package",60043),symbolNamespace:m("symbol-namespace",60043),symbolObject:m("symbol-object",60043),symbolMethod:m("symbol-method",60044),symbolFunction:m("symbol-function",60044),symbolConstructor:m("symbol-constructor",60044),symbolBoolean:m("symbol-boolean",60047),symbolNull:m("symbol-null",60047),symbolNumeric:m("symbol-numeric",60048),symbolNumber:m("symbol-number",60048),symbolStructure:m("symbol-structure",60049),symbolStruct:m("symbol-struct",60049),symbolParameter:m("symbol-parameter",60050),symbolTypeParameter:m("symbol-type-parameter",60050),symbolKey:m("symbol-key",60051),symbolText:m("symbol-text",60051),symbolReference:m("symbol-reference",60052),goToFile:m("go-to-file",60052),symbolEnum:m("symbol-enum",60053),symbolValue:m("symbol-value",60053),symbolRuler:m("symbol-ruler",60054),symbolUnit:m("symbol-unit",60054),activateBreakpoints:m("activate-breakpoints",60055),archive:m("archive",60056),arrowBoth:m("arrow-both",60057),arrowDown:m("arrow-down",60058),arrowLeft:m("arrow-left",60059),arrowRight:m("arrow-right",60060),arrowSmallDown:m("arrow-small-down",60061),arrowSmallLeft:m("arrow-small-left",60062),arrowSmallRight:m("arrow-small-right",60063),arrowSmallUp:m("arrow-small-up",60064),arrowUp:m("arrow-up",60065),bell:m("bell",60066),bold:m("bold",60067),book:m("book",60068),bookmark:m("bookmark",60069),debugBreakpointConditionalUnverified:m("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:m("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:m("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:m("debug-breakpoint-data-unverified",60072),debugBreakpointData:m("debug-breakpoint-data",60073),debugBreakpointDataDisabled:m("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:m("debug-breakpoint-log-unverified",60074),debugBreakpointLog:m("debug-breakpoint-log",60075),debugBreakpointLogDisabled:m("debug-breakpoint-log-disabled",60075),briefcase:m("briefcase",60076),broadcast:m("broadcast",60077),browser:m("browser",60078),bug:m("bug",60079),calendar:m("calendar",60080),caseSensitive:m("case-sensitive",60081),check:m("check",60082),checklist:m("checklist",60083),chevronDown:m("chevron-down",60084),dropDownButton:m("drop-down-button",60084),chevronLeft:m("chevron-left",60085),chevronRight:m("chevron-right",60086),chevronUp:m("chevron-up",60087),chromeClose:m("chrome-close",60088),chromeMaximize:m("chrome-maximize",60089),chromeMinimize:m("chrome-minimize",60090),chromeRestore:m("chrome-restore",60091),circle:m("circle",60092),circleOutline:m("circle-outline",60092),debugBreakpointUnverified:m("debug-breakpoint-unverified",60092),circleSlash:m("circle-slash",60093),circuitBoard:m("circuit-board",60094),clearAll:m("clear-all",60095),clippy:m("clippy",60096),closeAll:m("close-all",60097),cloudDownload:m("cloud-download",60098),cloudUpload:m("cloud-upload",60099),code:m("code",60100),collapseAll:m("collapse-all",60101),colorMode:m("color-mode",60102),commentDiscussion:m("comment-discussion",60103),compareChanges:m("compare-changes",60157),creditCard:m("credit-card",60105),dash:m("dash",60108),dashboard:m("dashboard",60109),database:m("database",60110),debugContinue:m("debug-continue",60111),debugDisconnect:m("debug-disconnect",60112),debugPause:m("debug-pause",60113),debugRestart:m("debug-restart",60114),debugStart:m("debug-start",60115),debugStepInto:m("debug-step-into",60116),debugStepOut:m("debug-step-out",60117),debugStepOver:m("debug-step-over",60118),debugStop:m("debug-stop",60119),debug:m("debug",60120),deviceCameraVideo:m("device-camera-video",60121),deviceCamera:m("device-camera",60122),deviceMobile:m("device-mobile",60123),diffAdded:m("diff-added",60124),diffIgnored:m("diff-ignored",60125),diffModified:m("diff-modified",60126),diffRemoved:m("diff-removed",60127),diffRenamed:m("diff-renamed",60128),diff:m("diff",60129),discard:m("discard",60130),editorLayout:m("editor-layout",60131),emptyWindow:m("empty-window",60132),exclude:m("exclude",60133),extensions:m("extensions",60134),eyeClosed:m("eye-closed",60135),fileBinary:m("file-binary",60136),fileCode:m("file-code",60137),fileMedia:m("file-media",60138),filePdf:m("file-pdf",60139),fileSubmodule:m("file-submodule",60140),fileSymlinkDirectory:m("file-symlink-directory",60141),fileSymlinkFile:m("file-symlink-file",60142),fileZip:m("file-zip",60143),files:m("files",60144),filter:m("filter",60145),flame:m("flame",60146),foldDown:m("fold-down",60147),foldUp:m("fold-up",60148),fold:m("fold",60149),folderActive:m("folder-active",60150),folderOpened:m("folder-opened",60151),gear:m("gear",60152),gift:m("gift",60153),gistSecret:m("gist-secret",60154),gist:m("gist",60155),gitCommit:m("git-commit",60156),gitCompare:m("git-compare",60157),gitMerge:m("git-merge",60158),githubAction:m("github-action",60159),githubAlt:m("github-alt",60160),globe:m("globe",60161),grabber:m("grabber",60162),graph:m("graph",60163),gripper:m("gripper",60164),heart:m("heart",60165),home:m("home",60166),horizontalRule:m("horizontal-rule",60167),hubot:m("hubot",60168),inbox:m("inbox",60169),issueClosed:m("issue-closed",60324),issueReopened:m("issue-reopened",60171),issues:m("issues",60172),italic:m("italic",60173),jersey:m("jersey",60174),json:m("json",60175),bracket:m("bracket",60175),kebabVertical:m("kebab-vertical",60176),key:m("key",60177),law:m("law",60178),lightbulbAutofix:m("lightbulb-autofix",60179),linkExternal:m("link-external",60180),link:m("link",60181),listOrdered:m("list-ordered",60182),listUnordered:m("list-unordered",60183),liveShare:m("live-share",60184),loading:m("loading",60185),location:m("location",60186),mailRead:m("mail-read",60187),mail:m("mail",60188),markdown:m("markdown",60189),megaphone:m("megaphone",60190),mention:m("mention",60191),milestone:m("milestone",60192),gitPullRequestMilestone:m("git-pull-request-milestone",60192),mortarBoard:m("mortar-board",60193),move:m("move",60194),multipleWindows:m("multiple-windows",60195),mute:m("mute",60196),noNewline:m("no-newline",60197),note:m("note",60198),octoface:m("octoface",60199),openPreview:m("open-preview",60200),package:m("package",60201),paintcan:m("paintcan",60202),pin:m("pin",60203),play:m("play",60204),run:m("run",60204),plug:m("plug",60205),preserveCase:m("preserve-case",60206),preview:m("preview",60207),project:m("project",60208),pulse:m("pulse",60209),question:m("question",60210),quote:m("quote",60211),radioTower:m("radio-tower",60212),reactions:m("reactions",60213),references:m("references",60214),refresh:m("refresh",60215),regex:m("regex",60216),remoteExplorer:m("remote-explorer",60217),remote:m("remote",60218),remove:m("remove",60219),replaceAll:m("replace-all",60220),replace:m("replace",60221),repoClone:m("repo-clone",60222),repoForcePush:m("repo-force-push",60223),repoPull:m("repo-pull",60224),repoPush:m("repo-push",60225),report:m("report",60226),requestChanges:m("request-changes",60227),rocket:m("rocket",60228),rootFolderOpened:m("root-folder-opened",60229),rootFolder:m("root-folder",60230),rss:m("rss",60231),ruby:m("ruby",60232),saveAll:m("save-all",60233),saveAs:m("save-as",60234),save:m("save",60235),screenFull:m("screen-full",60236),screenNormal:m("screen-normal",60237),searchStop:m("search-stop",60238),server:m("server",60240),settingsGear:m("settings-gear",60241),settings:m("settings",60242),shield:m("shield",60243),smiley:m("smiley",60244),sortPrecedence:m("sort-precedence",60245),splitHorizontal:m("split-horizontal",60246),splitVertical:m("split-vertical",60247),squirrel:m("squirrel",60248),starFull:m("star-full",60249),starHalf:m("star-half",60250),symbolClass:m("symbol-class",60251),symbolColor:m("symbol-color",60252),symbolCustomColor:m("symbol-customcolor",60252),symbolConstant:m("symbol-constant",60253),symbolEnumMember:m("symbol-enum-member",60254),symbolField:m("symbol-field",60255),symbolFile:m("symbol-file",60256),symbolInterface:m("symbol-interface",60257),symbolKeyword:m("symbol-keyword",60258),symbolMisc:m("symbol-misc",60259),symbolOperator:m("symbol-operator",60260),symbolProperty:m("symbol-property",60261),wrench:m("wrench",60261),wrenchSubaction:m("wrench-subaction",60261),symbolSnippet:m("symbol-snippet",60262),tasklist:m("tasklist",60263),telescope:m("telescope",60264),textSize:m("text-size",60265),threeBars:m("three-bars",60266),thumbsdown:m("thumbsdown",60267),thumbsup:m("thumbsup",60268),tools:m("tools",60269),triangleDown:m("triangle-down",60270),triangleLeft:m("triangle-left",60271),triangleRight:m("triangle-right",60272),triangleUp:m("triangle-up",60273),twitter:m("twitter",60274),unfold:m("unfold",60275),unlock:m("unlock",60276),unmute:m("unmute",60277),unverified:m("unverified",60278),verified:m("verified",60279),versions:m("versions",60280),vmActive:m("vm-active",60281),vmOutline:m("vm-outline",60282),vmRunning:m("vm-running",60283),watch:m("watch",60284),whitespace:m("whitespace",60285),wholeWord:m("whole-word",60286),window:m("window",60287),wordWrap:m("word-wrap",60288),zoomIn:m("zoom-in",60289),zoomOut:m("zoom-out",60290),listFilter:m("list-filter",60291),listFlat:m("list-flat",60292),listSelection:m("list-selection",60293),selection:m("selection",60293),listTree:m("list-tree",60294),debugBreakpointFunctionUnverified:m("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:m("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:m("debug-breakpoint-function-disabled",60296),debugStackframeActive:m("debug-stackframe-active",60297),circleSmallFilled:m("circle-small-filled",60298),debugStackframeDot:m("debug-stackframe-dot",60298),debugStackframe:m("debug-stackframe",60299),debugStackframeFocused:m("debug-stackframe-focused",60299),debugBreakpointUnsupported:m("debug-breakpoint-unsupported",60300),symbolString:m("symbol-string",60301),debugReverseContinue:m("debug-reverse-continue",60302),debugStepBack:m("debug-step-back",60303),debugRestartFrame:m("debug-restart-frame",60304),callIncoming:m("call-incoming",60306),callOutgoing:m("call-outgoing",60307),menu:m("menu",60308),expandAll:m("expand-all",60309),feedback:m("feedback",60310),gitPullRequestReviewer:m("git-pull-request-reviewer",60310),groupByRefType:m("group-by-ref-type",60311),ungroupByRefType:m("ungroup-by-ref-type",60312),account:m("account",60313),gitPullRequestAssignee:m("git-pull-request-assignee",60313),bellDot:m("bell-dot",60314),debugConsole:m("debug-console",60315),library:m("library",60316),output:m("output",60317),runAll:m("run-all",60318),syncIgnored:m("sync-ignored",60319),pinned:m("pinned",60320),githubInverted:m("github-inverted",60321),debugAlt:m("debug-alt",60305),serverProcess:m("server-process",60322),serverEnvironment:m("server-environment",60323),pass:m("pass",60324),stopCircle:m("stop-circle",60325),playCircle:m("play-circle",60326),record:m("record",60327),debugAltSmall:m("debug-alt-small",60328),vmConnect:m("vm-connect",60329),cloud:m("cloud",60330),merge:m("merge",60331),exportIcon:m("export",60332),graphLeft:m("graph-left",60333),magnet:m("magnet",60334),notebook:m("notebook",60335),redo:m("redo",60336),checkAll:m("check-all",60337),pinnedDirty:m("pinned-dirty",60338),passFilled:m("pass-filled",60339),circleLargeFilled:m("circle-large-filled",60340),circleLarge:m("circle-large",60341),circleLargeOutline:m("circle-large-outline",60341),combine:m("combine",60342),gather:m("gather",60342),table:m("table",60343),variableGroup:m("variable-group",60344),typeHierarchy:m("type-hierarchy",60345),typeHierarchySub:m("type-hierarchy-sub",60346),typeHierarchySuper:m("type-hierarchy-super",60347),gitPullRequestCreate:m("git-pull-request-create",60348),runAbove:m("run-above",60349),runBelow:m("run-below",60350),notebookTemplate:m("notebook-template",60351),debugRerun:m("debug-rerun",60352),workspaceTrusted:m("workspace-trusted",60353),workspaceUntrusted:m("workspace-untrusted",60354),workspaceUnspecified:m("workspace-unspecified",60355),terminalCmd:m("terminal-cmd",60356),terminalDebian:m("terminal-debian",60357),terminalLinux:m("terminal-linux",60358),terminalPowershell:m("terminal-powershell",60359),terminalTmux:m("terminal-tmux",60360),terminalUbuntu:m("terminal-ubuntu",60361),terminalBash:m("terminal-bash",60362),arrowSwap:m("arrow-swap",60363),copy:m("copy",60364),personAdd:m("person-add",60365),filterFilled:m("filter-filled",60366),wand:m("wand",60367),debugLineByLine:m("debug-line-by-line",60368),inspect:m("inspect",60369),layers:m("layers",60370),layersDot:m("layers-dot",60371),layersActive:m("layers-active",60372),compass:m("compass",60373),compassDot:m("compass-dot",60374),compassActive:m("compass-active",60375),azure:m("azure",60376),issueDraft:m("issue-draft",60377),gitPullRequestClosed:m("git-pull-request-closed",60378),gitPullRequestDraft:m("git-pull-request-draft",60379),debugAll:m("debug-all",60380),debugCoverage:m("debug-coverage",60381),runErrors:m("run-errors",60382),folderLibrary:m("folder-library",60383),debugContinueSmall:m("debug-continue-small",60384),beakerStop:m("beaker-stop",60385),graphLine:m("graph-line",60386),graphScatter:m("graph-scatter",60387),pieChart:m("pie-chart",60388),bracketDot:m("bracket-dot",60389),bracketError:m("bracket-error",60390),lockSmall:m("lock-small",60391),azureDevops:m("azure-devops",60392),verifiedFilled:m("verified-filled",60393),newLine:m("newline",60394),layout:m("layout",60395),layoutActivitybarLeft:m("layout-activitybar-left",60396),layoutActivitybarRight:m("layout-activitybar-right",60397),layoutPanelLeft:m("layout-panel-left",60398),layoutPanelCenter:m("layout-panel-center",60399),layoutPanelJustify:m("layout-panel-justify",60400),layoutPanelRight:m("layout-panel-right",60401),layoutPanel:m("layout-panel",60402),layoutSidebarLeft:m("layout-sidebar-left",60403),layoutSidebarRight:m("layout-sidebar-right",60404),layoutStatusbar:m("layout-statusbar",60405),layoutMenubar:m("layout-menubar",60406),layoutCentered:m("layout-centered",60407),layoutSidebarRightOff:m("layout-sidebar-right-off",60416),layoutPanelOff:m("layout-panel-off",60417),layoutSidebarLeftOff:m("layout-sidebar-left-off",60418),target:m("target",60408),indent:m("indent",60409),recordSmall:m("record-small",60410),errorSmall:m("error-small",60411),arrowCircleDown:m("arrow-circle-down",60412),arrowCircleLeft:m("arrow-circle-left",60413),arrowCircleRight:m("arrow-circle-right",60414),arrowCircleUp:m("arrow-circle-up",60415),heartFilled:m("heart-filled",60420),map:m("map",60421),mapFilled:m("map-filled",60422),circleSmall:m("circle-small",60423),bellSlash:m("bell-slash",60424),bellSlashDot:m("bell-slash-dot",60425),commentUnresolved:m("comment-unresolved",60426),gitPullRequestGoToChanges:m("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:m("git-pull-request-new-changes",60428),searchFuzzy:m("search-fuzzy",60429),commentDraft:m("comment-draft",60430),send:m("send",60431),sparkle:m("sparkle",60432),insert:m("insert",60433),mic:m("mic",60434),thumbsDownFilled:m("thumbsdown-filled",60435),thumbsUpFilled:m("thumbsup-filled",60436),coffee:m("coffee",60437),snake:m("snake",60438),game:m("game",60439),vr:m("vr",60440),chip:m("chip",60441),piano:m("piano",60442),music:m("music",60443),micFilled:m("mic-filled",60444),gitFetch:m("git-fetch",60445),copilot:m("copilot",60446),dialogError:m("dialog-error","error"),dialogWarning:m("dialog-warning","warning"),dialogInfo:m("dialog-info","info"),dialogClose:m("dialog-close","close"),treeItemExpanded:m("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:m("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:m("tree-filter-on-type-off","list-selection"),treeFilterClear:m("tree-filter-clear","close"),treeItemLoading:m("tree-item-loading","loading"),menuSelection:m("menu-selection","check"),menuSubmenu:m("menu-submenu","chevron-right"),menuBarMore:m("menubar-more","more"),scrollbarButtonLeft:m("scrollbar-button-left","triangle-left"),scrollbarButtonRight:m("scrollbar-button-right","triangle-right"),scrollbarButtonUp:m("scrollbar-button-up","triangle-up"),scrollbarButtonDown:m("scrollbar-button-down","triangle-down"),toolBarMore:m("toolbar-more","more"),quickInputBack:m("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=void 0;function F(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,o])=>{i[n]=o&&typeof o=="object"?F(o):o}),i}e.$_m=F;function m(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const o in n)if(L.call(n,o)){const a=n[o];typeof a=="object"&&!Object.isFrozen(a)&&!(0,I.$Ef)(a)&&i.push(a)}}return s}e.$an=m;const L=Object.prototype.hasOwnProperty;function R(s,i){return p(s,i,new Set)}e.$bn=R;function p(s,i,n){if((0,I.$Kf)(s))return s;const o=i(s);if(typeof o<"u")return o;if(Array.isArray(s)){const a=[];for(const t of s)a.push(p(t,i,n));return a}if((0,I.$Df)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const a={};for(const t in s)L.call(s,t)&&(a[t]=p(s[t],i,n));return n.delete(s),a}return s}function E(s,i,n=!0){return(0,I.$Df)(s)?((0,I.$Df)(i)&&Object.keys(i).forEach(o=>{o in s?n&&((0,I.$Df)(s[o])&&(0,I.$Df)(i[o])?E(s[o],i[o],n):s[o]=i[o]):s[o]=i[o]}),s):i}e.$cn=E;function g(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,o;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!g(s[n],i[n]))return!1}else{const a=[];for(o in s)a.push(o);a.sort();const t=[];for(o in i)t.push(o);if(t.sort(),!g(a,t))return!1;for(n=0;n<a.length;n++)if(!g(s[a[n]],i[a[n]]))return!1}return!0}e.$dn=g;function A(s){const i=new Set;return JSON.stringify(s,(n,o)=>{if((0,I.$Df)(o)||Array.isArray(o)){if(i.has(o))return"[Circular]";i.add(o)}return o})}e.$en=A;function P(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(a=>{const t=s[a],r=i[a];g(t,r)||(n[a]=r)}),n}e.$fn=P;function f(s,i){const n=i.toLowerCase(),o=Object.keys(s).find(a=>a.toLowerCase()===n);return o?s[o]:s[i]}e.$gn=f;function y(s,i){const n=Object.create(null);for(const[o,a]of Object.entries(s))i(o,a)&&(n[o]=a);return n}e.$hn=y;function S(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.$in=S;function w(s){const i=[];for(const n of S(s))typeof s[n]=="function"&&i.push(n);return i}e.$jn=w;function c(s,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},o={};for(const a of s)o[a]=n(a);return o}e.$kn=c}),define(ke[61],Se([1,0,79]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$1j=e.ThemeColor=void 0;var F;(function(R){function p(E){return E&&typeof E=="object"&&typeof E.id=="string"}R.isThemeColor=p})(F||(e.ThemeColor=F={}));function m(R){return{id:R}}e.$1j=m;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function E(i){const n=p.exec(i.id);if(!n)return E(I.$Zj.error);const[,o,a]=n,t=["codicon","codicon-"+o];return a&&t.push("codicon-modifier-"+a.substring(1)),t}R.asClassNameArray=E;function g(i){return E(i).join(" ")}R.asClassName=g;function A(i){return"."+E(i).join(".")}R.asCSSSelector=A;function P(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}R.isThemeIcon=P;const f=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function y(i){const n=f.exec(i);if(!n)return;const[,o]=n;return{id:o}}R.fromString=y;function S(i){return{id:i}}R.fromId=S;function w(i,n){let o=i.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),n&&(o=`${o}~${n}`),{id:o}}R.modify=w;function c(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=c;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=s})(L||(e.ThemeIcon=L={}))}),define(ke[164],Se([1,0,124,13,61]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=void 0;const L="$(",R=new RegExp(`\\$\\(${m.ThemeIcon.iconNameExpression}(?:${m.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${R.source}`,"g");function E(s){return s.replace(p,(i,n)=>n?i:`\\${i}`)}e.$2j=E;const g=new RegExp(`\\\\${R.source}`,"g");function A(s){return s.replace(g,i=>`\\${i}`)}e.$3j=A;const P=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function f(s){return s.indexOf(L)===-1?s:s.replace(P,(i,n,o,a)=>o?i:n||a||"")}e.$4j=f;function y(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$5j=y;const S=new RegExp(`\\$\\(${m.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(s){S.lastIndex=0;let i="";const n=[];let o=0;for(;;){const a=S.lastIndex,t=S.exec(s),r=s.substring(a,t?.index);if(r.length>0){i+=r;for(let d=0;d<r.length;d++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$6j=w;function c(s,i,n=!1){const{text:o,iconOffsets:a}=i;if(!a||a.length===0)return(0,I.$Oj)(s,o,n);const t=(0,F.$Me)(o," "),r=o.length-t.length,d=(0,I.$Oj)(s,t,n);if(d)for(const u of d){const l=a[u.start+r]+r;u.start+=l,u.end+=l}return d}e.$7j=c}),define(ke[125],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.Constants=void 0;var I;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function F(L){return L<0?0:L>255?255:L|0}e.$Ce=F;function m(L){return L<0?0:L>4294967295?4294967295:L|0}e.$De=m}),define(ke[32],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(m){return I.test(m)}e.$gg=F,e.$hg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let m;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?m=crypto.getRandomValues.bind(crypto):m=function(p){for(let E=0;E<p.length;E++)p[E]=Math.floor(Math.random()*256);return p};const L=new Uint8Array(16),R=[];for(let p=0;p<256;p++)R.push(p.toString(16).padStart(2,"0"));return function(){m(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,g="";return g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g+="-",g+=R[L[E++]],g+=R[L[E++]],g+="-",g+=R[L[E++]],g+=R[L[E++]],g+="-",g+=R[L[E++]],g+=R[L[E++]],g+="-",g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g+=R[L[E++]],g}}()}),define(ke[165],Se([1,0,19,51,32]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.$7s=e.$6s=e.$5s=void 0;function L(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.$5s=L;function R(P,f,y){const S={id:(0,m.$hg)(),name:P,uri:f,data:y};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$6s=R;class p{constructor(){this.a=new Map}get size(){let f=0;for(const y of this.a)f++;return f}has(f){return this.a.has(this.b(f))}matches(f){const y=[...this.a.keys()];return F.Iterable.some(this,([S,w])=>w.asFile())&&y.push("files"),A(E(f),y)}get(f){return this.a.get(this.b(f))?.[0]}append(f,y){const S=this.a.get(f);S?S.push(y):this.a.set(this.b(f),[y])}replace(f,y){this.a.set(this.b(f),[y])}delete(f){this.a.delete(this.b(f))}*[Symbol.iterator](){for(const[f,y]of this.a)for(const S of y)yield[f,S]}b(f){return E(f)}}e.$7s=p;function E(P){return P.toLowerCase()}function g(P,f){return A(E(P),f.map(E))}e.$8s=g;function A(P,f){if(P==="*/*")return f.length>0;if(f.includes(P))return!0;const y=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[S,w,c]=y;return c==="*"?f.some(s=>s.startsWith(w+"/")):!1}e.$9s=Object.freeze({create:P=>(0,I.$Lb)(P.map(f=>f.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$9s.split(P).filter(f=>!f.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=e.$jg=void 0;function F(p,E,g,A=1){let P=!1;return new Promise(f=>{const y=setTimeout(()=>{if(!P)return P=!0,f(0)},g);m(p,E,A,S=>{if(!P)return P=!0,clearTimeout(y),f(S)})})}e.$jg=F;function m(p,E,g,A){if(E===0)return A(0);const P=new I.Socket;P.once("connect",()=>(R(P),m(p+g,E-1,g,A))),P.once("data",()=>{}),P.once("error",f=>(R(P),f.code!=="ECONNREFUSED"?m(p+g,E-1,g,A):A(p))),P.connect(p,"127.0.0.1")}e.$kg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(p,E,g,A="127.0.0.1"){let P=!1,f,y=1;const S=I.createServer({pauseOnConnect:!0});function w(c,s){P||(P=!0,S.removeAllListeners(),S.close(),f&&clearTimeout(f),s(c))}return new Promise(c=>{f=setTimeout(()=>{w(0,c)},g),S.on("listening",()=>{w(p,c)}),S.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&y<E?(p++,y++,S.listen(p,A)):w(0,c)}),S.on("close",()=>{w(0,c)}),S.listen(p,A)})}e.$lg=L;function R(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch(E){console.error(E)}}}),define(ke[126],Se([1,0,125]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=void 0;class F{constructor(p){const E=(0,I.$Ce)(p);this.c=E,this.a=F.d(E),this.b=new Map}static d(p){const E=new Uint8Array(256);return E.fill(p),E}set(p,E){const g=(0,I.$Ce)(E);p>=0&&p<256?this.a[p]=g:this.b.set(p,g)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ws=F;var m;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(m||(m={}));class L{constructor(){this.a=new F(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$Xs=L}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var I;(function(m){m[m.Unknown=0]="Unknown",m[m.Invalid=3]="Invalid",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function F(m){let L=0,R=0,p=0,E=0;for(let g=0,A=m.length;g<A;g++){const P=m.charCodeAt(g);P===13?(L===0&&(R=g),L++,g+1<A&&m.charCodeAt(g+1)===10?(E|=2,g++):E|=3,p=g+1):P===10&&(E|=1,L===0&&(R=g),L++,p=g+1)}return L===0&&(R=m.length),[L,R,m.length-p,E]}e.$_s=F}),define(ke[53],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class I{constructor(m,L){this.lineNumber=m,this.column=L}with(m=this.lineNumber,L=this.column){return m===this.lineNumber&&L===this.column?this:new I(m,L)}delta(m=0,L=0){return this.with(this.lineNumber+m,this.column+L)}equals(m){return I.equals(this,m)}static equals(m,L){return!m&&!L?!0:!!m&&!!L&&m.lineNumber===L.lineNumber&&m.column===L.column}isBefore(m){return I.isBefore(this,m)}static isBefore(m,L){return m.lineNumber<L.lineNumber?!0:L.lineNumber<m.lineNumber?!1:m.column<L.column}isBeforeOrEqual(m){return I.isBeforeOrEqual(this,m)}static isBeforeOrEqual(m,L){return m.lineNumber<L.lineNumber?!0:L.lineNumber<m.lineNumber?!1:m.column<=L.column}static compare(m,L){const R=m.lineNumber|0,p=L.lineNumber|0;if(R===p){const E=m.column|0,g=L.column|0;return E-g}return R-p}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(m){return new I(m.lineNumber,m.column)}static isIPosition(m){return m&&typeof m.lineNumber=="number"&&typeof m.column=="number"}}e.$ys=I}),define(ke[29],Se([1,0,53]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class F{constructor(L,R,p,E){L>p||L===p&&R>E?(this.startLineNumber=p,this.startColumn=E,this.endLineNumber=L,this.endColumn=R):(this.startLineNumber=L,this.startColumn=R,this.endLineNumber=p,this.endColumn=E)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<L.startColumn||R.lineNumber===L.endLineNumber&&R.column>L.endColumn)}static strictContainsPosition(L,R){return!(R.lineNumber<L.startLineNumber||R.lineNumber>L.endLineNumber||R.lineNumber===L.startLineNumber&&R.column<=L.startColumn||R.lineNumber===L.endLineNumber&&R.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,R){return!(R.startLineNumber<L.startLineNumber||R.endLineNumber<L.startLineNumber||R.startLineNumber>L.endLineNumber||R.endLineNumber>L.endLineNumber||R.startLineNumber===L.startLineNumber&&R.startColumn<=L.startColumn||R.endLineNumber===L.endLineNumber&&R.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,R){let p,E,g,A;return R.startLineNumber<L.startLineNumber?(p=R.startLineNumber,E=R.startColumn):R.startLineNumber===L.startLineNumber?(p=R.startLineNumber,E=Math.min(R.startColumn,L.startColumn)):(p=L.startLineNumber,E=L.startColumn),R.endLineNumber>L.endLineNumber?(g=R.endLineNumber,A=R.endColumn):R.endLineNumber===L.endLineNumber?(g=R.endLineNumber,A=Math.max(R.endColumn,L.endColumn)):(g=L.endLineNumber,A=L.endColumn),new F(p,E,g,A)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,R){let p=L.startLineNumber,E=L.startColumn,g=L.endLineNumber,A=L.endColumn;const P=R.startLineNumber,f=R.startColumn,y=R.endLineNumber,S=R.endColumn;return p<P?(p=P,E=f):p===P&&(E=Math.max(E,f)),g>y?(g=y,A=S):g===y&&(A=Math.min(A,S)),p>g||p===g&&E>A?null:new F(p,E,g,A)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,R){return!L&&!R?!0:!!L&&!!R&&L.startLineNumber===R.startLineNumber&&L.startColumn===R.startColumn&&L.endLineNumber===R.endLineNumber&&L.endColumn===R.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new I.$ys(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new I.$ys(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,R){return new F(this.startLineNumber,this.startColumn,L,R)}setStartPosition(L,R){return new F(L,R,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,R=L){return new F(L.lineNumber,L.column,R.lineNumber,R.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn)}static areIntersecting(L,R){return!(L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn||R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,R){if(L&&R){const g=L.startLineNumber|0,A=R.startLineNumber|0;if(g===A){const P=L.startColumn|0,f=R.startColumn|0;if(P===f){const y=L.endLineNumber|0,S=R.endLineNumber|0;if(y===S){const w=L.endColumn|0,c=R.endColumn|0;return w-c}return y-S}return P-f}return g-A}return(L?1:0)-(R?1:0)}static compareRangesUsingEnds(L,R){return L.endLineNumber===R.endLineNumber?L.endColumn===R.endColumn?L.startLineNumber===R.startLineNumber?L.startColumn-R.startColumn:L.startLineNumber-R.startLineNumber:L.endColumn-R.endColumn:L.endLineNumber-R.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$zs=F}),define(ke[168],Se([1,0,29]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class F{static insert(L,R){return{range:new I.$zs(L.lineNumber,L.column,L.lineNumber,L.column),text:R,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,R){return{range:L,text:R}}static replaceMove(L,R){return{range:L,text:R,forceMoveMarkers:!0}}}e.$As=F}),define(ke[169],Se([1,0,53,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=e.SelectionDirection=void 0;var m;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(m||(e.SelectionDirection=m={}));class L extends F.$zs{constructor(p,E,g,A){super(p,E,g,A),this.selectionStartLineNumber=p,this.selectionStartColumn=E,this.positionLineNumber=g,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return L.selectionsEqual(this,p)}static selectionsEqual(p,E){return p.selectionStartLineNumber===E.selectionStartLineNumber&&p.selectionStartColumn===E.selectionStartColumn&&p.positionLineNumber===E.positionLineNumber&&p.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,E){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,p,E):new L(p,E,this.startLineNumber,this.startColumn)}getPosition(){return new I.$ys(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new I.$ys(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,E){return this.getDirection()===0?new L(p,E,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,p,E)}static fromPositions(p,E=p){return new L(p.lineNumber,p.column,E.lineNumber,E.column)}static fromRange(p,E){return E===0?new L(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new L(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new L(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,E){if(p&&!E||!p&&E)return!1;if(!p&&!E)return!0;if(p.length!==E.length)return!1;for(let g=0,A=p.length;g<A;g++)if(!this.selectionsEqual(p[g],E[g]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,E,g,A,P){return P===0?new L(p,E,g,A):new L(g,A,p,E)}}e.$Bs=L}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0,e.$9r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,126]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=e.WordCharacterClass=void 0;var F;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class m extends I.$Ws{constructor(p){super(0);for(let E=0,g=p.length;E<g;E++)this.set(p.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$Ys=m;function L(R){const p={};return E=>(p.hasOwnProperty(E)||(p[E]=R(E)),p[E])}e.$Zs=L(R=>new m(R))}),define(ke[127],Se([1,0,51,3,76]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=e.$$r=e.$0r=void 0,e.$0r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(P=""){let f="(-?\\d*\\.\\d\\w*)|([^";for(const y of e.$0r)P.indexOf(y)>=0||(f+="\\"+y);return f+="\\s]+)",new RegExp(f,"g")}e.$$r=L();function R(P){let f=e.$$r;if(P&&P instanceof RegExp)if(P.global)f=P;else{let y="g";P.ignoreCase&&(y+="i"),P.multiline&&(y+="m"),P.unicode&&(y+="u"),f=new RegExp(P.source,y)}return f.lastIndex=0,f}e.$_r=R;const p=new m.$1c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(P){const f=p.unshift(P);return(0,F.$Pc)(f)}e.$as=E;function g(P,f,y,S,w){if(w||(w=I.Iterable.first(p)),y.length>w.maxLen){let o=P-w.maxLen/2;return o<0?o=0:S+=o,y=y.substring(o,P+w.maxLen/2),g(P,f,y,S,w)}const c=Date.now(),s=P-1-S;let i=-1,n=null;for(let o=1;!(Date.now()-c>=w.timeBudget);o++){const a=s-w.windowSize*o;f.lastIndex=Math.max(0,a);const t=A(f,y,s,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const o={word:n[0],startColumn:S+1+n.index,endColumn:S+1+n.index+n[0].length};return f.lastIndex=0,o}return null}e.$bs=g;function A(P,f,y,S){let w;for(;w=P.exec(f);){const c=w.index||0;if(c<=y&&P.lastIndex>=y)return w;if(S>0&&c>S)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.IndentAction=void 0;var I;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class F{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let E=0,g=p.notIn.length;E<g;E++)switch(p.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,E){if(p.getTokenCount()===0)return!0;const g=p.findTokenIndexAtOffset(E-2),A=p.getStandardTokenType(g);return this.isOK(A)}g(p,E){for(let g=p;g<=E;g++){const A=String.fromCharCode(g);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$vt=F;class m{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of p)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$wt=m;function L(R,p,E){R.has(p)?R.get(p).push(E):R.set(p,[E])}}),define(ke[173],Se([1,0,126]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IZ=e.$HZ=e.$GZ=e.State=void 0;var F;(function(y){y[y.Invalid=0]="Invalid",y[y.Start=1]="Start",y[y.H=2]="H",y[y.HT=3]="HT",y[y.HTT=4]="HTT",y[y.HTTP=5]="HTTP",y[y.F=6]="F",y[y.FI=7]="FI",y[y.FIL=8]="FIL",y[y.BeforeColon=9]="BeforeColon",y[y.AfterColon=10]="AfterColon",y[y.AlmostThere=11]="AlmostThere",y[y.End=12]="End",y[y.Accept=13]="Accept",y[y.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class m{constructor(S,w,c){const s=new Uint8Array(S*w);for(let i=0,n=S*w;i<n;i++)s[i]=c;this.a=s,this.rows=S,this.cols=w}get(S,w){return this.a[S*this.cols+w]}set(S,w,c){this.a[S*this.cols+w]=c}}class L{constructor(S){let w=0,c=0;for(let i=0,n=S.length;i<n;i++){const[o,a,t]=S[i];a>w&&(w=a),o>c&&(c=o),t>c&&(c=t)}w++,c++;const s=new m(c,w,0);for(let i=0,n=S.length;i<n;i++){const[o,a,t]=S[i];s.set(o,a,t)}this.a=s,this.b=w}nextState(S,w){return w<0||w>=this.b?0:this.a.get(S,w)}}e.$GZ=L;let R=null;function p(){return R===null&&(R=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var E;(function(y){y[y.None=0]="None",y[y.ForceTermination=1]="ForceTermination",y[y.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let g=null;function A(){if(g===null){g=new I.$Ws(0);const y=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<y.length;w++)g.set(y.charCodeAt(w),1);const S=".,;:";for(let w=0;w<S.length;w++)g.set(S.charCodeAt(w),2)}return g}class P{static a(S,w,c,s,i){let n=i-1;do{const o=w.charCodeAt(n);if(S.get(o)!==2)break;n--}while(n>s);if(s>0){const o=w.charCodeAt(s-1),a=w.charCodeAt(n);(o===40&&a===41||o===91&&a===93||o===123&&a===125)&&n--}return{range:{startLineNumber:c,startColumn:s+1,endLineNumber:c,endColumn:n+2},url:w.substring(s,n+1)}}static computeLinks(S,w=p()){const c=A(),s=[];for(let i=1,n=S.getLineCount();i<=n;i++){const o=S.getLineContent(i),a=o.length;let t=0,r=0,d=0,u=1,l=!1,h=!1,k=!1,D=!1;for(;t<a;){let $=!1;const b=o.charCodeAt(t);if(u===13){let v;switch(b){case 40:l=!0,v=0;break;case 41:v=l?0:1;break;case 91:k=!0,h=!0,v=0;break;case 93:k=!1,v=h?0:1;break;case 123:D=!0,v=0;break;case 125:v=D?0:1;break;case 39:case 34:case 96:d===b?v=1:d===39||d===34||d===96?v=0:v=1;break;case 42:v=d===42?1:0;break;case 124:v=d===124?1:0;break;case 32:v=k?0:1;break;default:v=c.get(b)}v===1&&(s.push(P.a(c,o,i,r,t)),$=!0)}else if(u===12){let v;b===91?(h=!0,v=0):v=c.get(b),v===1?$=!0:u=13}else u=w.nextState(u,b),u===0&&($=!0);$&&(u=1,l=!1,h=!1,D=!1,r=t+1,d=b),t++}u===13&&s.push(P.a(c,o,i,r,a))}return s}}e.$HZ=P;function f(y){return!y||typeof y.getLineCount!="function"||typeof y.getLineContent!="function"?[]:P.computeLinks(y)}e.$IZ=f}),define(ke[80],Se([1,0,24]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=e.$Uu=e.$Tu=e.$Su=e.ModelConstants=e.PositionAffinity=e.$Ru=e.TrackedRangeStickiness=e.$Qu=e.$Pu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var m;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(m||(e.GlyphMarginLane=m={}));var L;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var R;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var p;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var E;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var g;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,I.$dn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Pu=A;class P{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Qu=P;var f;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(f||(e.TrackedRangeStickiness=f={}));function y(o){return o&&typeof o.read=="function"}e.$Ru=y;var S;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var w;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(e.ModelConstants=w={}));class c{constructor(a,t,r,d,u,l){this.identifier=a,this.range=t,this.text=r,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=u,this._isTracked=l}}e.$Su=c;class s{constructor(a,t,r){this.regex=a,this.wordSeparators=t,this.simpleSearch=r}}e.$Tu=s;class i{constructor(a,t,r){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$Uu=i;function n(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}e.$Vu=n}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.$rB=e.NodeColor=e.$qB=void 0;class I{constructor(c,s){this.piece=c,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rB)return m(this.right);let c=this;for(;c.parent!==e.$rB&&c.parent.left!==c;)c=c.parent;return c.parent===e.$rB?e.$rB:c.parent}prev(){if(this.left!==e.$rB)return L(this.left);let c=this;for(;c.parent!==e.$rB&&c.parent.right!==c;)c=c.parent;return c.parent===e.$rB?e.$rB:c.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qB=I;var F;(function(w){w[w.Black=0]="Black",w[w.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$rB=new I(null,0),e.$rB.parent=e.$rB,e.$rB.left=e.$rB,e.$rB.right=e.$rB,e.$rB.color=0;function m(w){for(;w.left!==e.$rB;)w=w.left;return w}e.$sB=m;function L(w){for(;w.right!==e.$rB;)w=w.right;return w}e.$tB=L;function R(w){return w===e.$rB?0:w.size_left+w.piece.length+R(w.right)}function p(w){return w===e.$rB?0:w.lf_left+w.piece.lineFeedCnt+p(w.right)}function E(){e.$rB.parent=e.$rB}function g(w,c){const s=c.right;s.size_left+=c.size_left+(c.piece?c.piece.length:0),s.lf_left+=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),c.right=s.left,s.left!==e.$rB&&(s.left.parent=c),s.parent=c.parent,c.parent===e.$rB?w.root=s:c.parent.left===c?c.parent.left=s:c.parent.right=s,s.left=c,c.parent=s}e.$uB=g;function A(w,c){const s=c.left;c.left=s.right,s.right!==e.$rB&&(s.right.parent=c),s.parent=c.parent,c.size_left-=s.size_left+(s.piece?s.piece.length:0),c.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),c.parent===e.$rB?w.root=s:c===c.parent.right?c.parent.right=s:c.parent.left=s,s.right=c,c.parent=s}e.$vB=A;function P(w,c){let s,i;if(c.left===e.$rB?(i=c,s=i.right):c.right===e.$rB?(i=c,s=i.left):(i=m(c.right),s=i.right),i===w.root){w.root=s,s.color=0,c.detach(),E(),w.root.parent=e.$rB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===c?(s.parent=i.parent,S(w,s)):(i.parent===c?s.parent=i:s.parent=i.parent,S(w,s),i.left=c.left,i.right=c.right,i.parent=c.parent,i.color=c.color,c===w.root?w.root=i:c===c.parent.left?c.parent.left=i:c.parent.right=i,i.left!==e.$rB&&(i.left.parent=i),i.right!==e.$rB&&(i.right.parent=i),i.size_left=c.size_left,i.lf_left=c.lf_left,S(w,i)),c.detach(),s.parent.left===s){const a=R(s),t=p(s);if(a!==s.parent.size_left||t!==s.parent.lf_left){const r=a-s.parent.size_left,d=t-s.parent.lf_left;s.parent.size_left=a,s.parent.lf_left=t,y(w,s.parent,r,d)}}if(S(w,s.parent),n){E();return}let o;for(;s!==w.root&&s.color===0;)s===s.parent.left?(o=s.parent.right,o.color===1&&(o.color=0,s.parent.color=1,g(w,s.parent),o=s.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.right.color===0&&(o.left.color=0,o.color=1,A(w,o),o=s.parent.right),o.color=s.parent.color,s.parent.color=0,o.right.color=0,g(w,s.parent),s=w.root)):(o=s.parent.left,o.color===1&&(o.color=0,s.parent.color=1,A(w,s.parent),o=s.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.left.color===0&&(o.right.color=0,o.color=1,g(w,o),o=s.parent.left),o.color=s.parent.color,s.parent.color=0,o.left.color=0,A(w,s.parent),s=w.root));s.color=0,E()}e.$wB=P;function f(w,c){for(S(w,c);c!==w.root&&c.parent.color===1;)if(c.parent===c.parent.parent.left){const s=c.parent.parent.right;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.right&&(c=c.parent,g(w,c)),c.parent.color=0,c.parent.parent.color=1,A(w,c.parent.parent))}else{const s=c.parent.parent.left;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.left&&(c=c.parent,A(w,c)),c.parent.color=0,c.parent.parent.color=1,g(w,c.parent.parent))}w.root.color=0}e.$xB=f;function y(w,c,s,i){for(;c!==w.root&&c!==e.$rB;)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}e.$yB=y;function S(w,c){let s=0,i=0;if(c!==w.root){for(;c!==w.root&&c===c.parent.right;)c=c.parent;if(c!==w.root)for(c=c.parent,s=R(c.left)-c.size_left,i=p(c.left)-c.lf_left,c.size_left+=s,c.lf_left+=i;c!==w.root&&(s!==0||i!==0);)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}}e.$zB=S}),define(ke[175],Se([1,0,19,125]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=e.$Yu=void 0;class m{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,g){E=(0,F.$De)(E);const A=this.a,P=this.b,f=g.length;return f===0?!1:(this.a=new Uint32Array(A.length+f),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E),E+f),this.a.set(g,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(E,g){return E=(0,F.$De)(E),g=(0,F.$De)(g),this.a[E]===g?!1:(this.a[E]=g,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,g){E=(0,F.$De)(E),g=(0,F.$De)(g);const A=this.a,P=this.b;if(E>=A.length)return!1;const f=A.length-E;return g>=f&&(g=f),g===0?!1:(this.a=new Uint32Array(A.length-g),this.a.set(A.subarray(0,E),0),this.a.set(A.subarray(E+g),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,F.$De)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),E>=this.a.length&&(E=this.a.length-1);for(let A=g;A<=E;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let g=0,A=this.a.length-1,P=0,f=0,y=0;for(;g<=A;)if(P=g+(A-g)/2|0,f=this.b[P],y=f-this.a[P],E<y)A=P-1;else if(E>=f)g=P+1;else break;return new R(P,E-y)}}e.$Yu=m;class L{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const g=this.e[E],A=g>0?this.d[g-1]:0;return new R(g,E-A)}removeValues(E,g){this.a.splice(E,g),this.f(E)}insertValues(E,g){this.a=(0,I.$Vb)(this.a,E,g),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,g=this.a.length;E<g;E++){const A=this.a[E],P=E>0?this.d[E-1]:0;this.d[E]=P+A;for(let f=0;f<A;f++)this.e[P+f]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,g){this.a[E]!==g&&(this.a[E]=g,this.f(E))}}e.$Zu=L;class R{constructor(E,g){this.index=E,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=g}}e.$1u=R}),define(ke[176],Se([1,0,13,53,175]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=void 0;class L{constructor(p,E,g,A){this.d=p,this.f=E,this.g=g,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const E=p.changes;for(const g of E)this.o(g.range),this.p(new F.$ys(g.range.startLineNumber,g.range.startColumn),g.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,E=this.f.length,g=new Uint32Array(E);for(let A=0;A<E;A++)g[A]=this.f[A].length+p;this.j=new m.$Yu(g)}}n(p,E){this.f[p]=E,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,E){if(E.length===0)return;const g=(0,I.$Se)(E);if(g.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+g[0]+this.f[p.lineNumber-1].substring(p.column-1));return}g[g.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+g[0]);const A=new Uint32Array(g.length-1);for(let P=1;P<g.length;P++)this.f.splice(p.lineNumber+P-1,0,g[P]),A[P-1]=g[P].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,A)}}e.$2u=L}),define(ke[99],Se([1,0,13,171,53,29,80]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=void 0;const p=999;class E{constructor(i,n,o,a){this.searchString=i,this.isRegex=n,this.matchCase=o,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=g(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=I.$Qe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let o=!this.isRegex&&!i;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new R.$Tu(n,this.wordSeparators?(0,F.$Zs)(this.wordSeparators):null,o?this.searchString:null)}}e.$AB=E;function g(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const o=s.charCodeAt(i);if(o===10)return!0;if(o===92){if(i++,i>=n)break;const a=s.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$BB=g;function A(s,i,n){if(!n)return new R.$Qu(s,null);const o=[];for(let a=0,t=i.length;a<t;a++)o[a]=i[a];return new R.$Qu(s,o)}e.$CB=A;class P{constructor(i){const n=[];let o=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[o++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let o=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;o<a;){const t=o+((a-o)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(o=t,a=t):o=t+1}return o+1}}class f{static findMatches(i,n,o,a,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this.b(i,o,new c(r.wordSeparators,r.regex),a,t):this.c(i,o,r,a,t):[]}static a(i,n,o,a,t,r){let d,u=0;a?(u=a.findLineFeedCountBeforeOffset(t),d=n+t+u):d=n+t;let l;if(a){const $=a.findLineFeedCountBeforeOffset(t+r.length)-u;l=d+r.length+$}else l=d+r.length;const h=i.getPositionAt(d),k=i.getPositionAt(l);return new L.$zs(h.lineNumber,h.column,k.lineNumber,k.column)}static b(i,n,o,a,t){const r=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new P(d):null,l=[];let h=0,k;for(o.reset(0);k=o.next(d);)if(l[h++]=A(this.a(i,r,d,u,k.index,k[0]),k,a),h>=t)return l;return l}static c(i,n,o,a,t){const r=[];let d=0;if(n.startLineNumber===n.endLineNumber){const l=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(o,l,n.startLineNumber,n.startColumn-1,d,r,a,t),r}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(o,u,n.startLineNumber,n.startColumn-1,d,r,a,t);for(let l=n.startLineNumber+1;l<n.endLineNumber&&d<t;l++)d=this.d(o,i.getLineContent(l),l,0,d,r,a,t);if(d<t){const l=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(o,l,n.endLineNumber,0,d,r,a,t)}return r}static d(i,n,o,a,t,r,d,u){const l=i.wordSeparators;if(!d&&i.simpleSearch){const D=i.simpleSearch,$=D.length,b=n.length;let v=-$;for(;(v=n.indexOf(D,v+$))!==-1;)if((!l||w(l,n,b,v,$))&&(r[t++]=new R.$Qu(new L.$zs(o,v+1+a,o,v+1+$+a),null),t>=u))return t;return t}const h=new c(i.wordSeparators,i.regex);let k;h.reset(0);do if(k=h.next(n),k&&(r[t++]=A(new L.$zs(o,k.index+1+a,o,k.index+1+k[0].length+a),k,d),t>=u))return t;while(k);return t}static findNextMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new c(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,o,r,a):this.f(i,o,r,a)}static e(i,n,o,a){const t=new m.$ys(n.lineNumber,1),r=i.getOffsetAt(t),d=i.getLineCount(),u=i.getValueInRange(new L.$zs(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),l=i.getEOL()===`\r
`?new P(u):null;o.reset(n.column-1);const h=o.next(u);return h?A(this.a(i,r,u,l,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new m.$ys(1,1),o,a):null}static f(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r),u=this.g(o,d,r,n.column,a);if(u)return u;for(let l=1;l<=t;l++){const h=(r+l-1)%t,k=i.getLineContent(h+1),D=this.g(o,k,h+1,1,a);if(D)return D}return null}static g(i,n,o,a,t){i.reset(a-1);const r=i.next(n);return r?A(new L.$zs(o,r.index+1,o,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new c(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,o,r,a):this.j(i,o,r,a)}static h(i,n,o,a){const t=this.b(i,new L.$zs(1,1,n.lineNumber,n.column),o,a,10*p);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this.h(i,new m.$ys(r,i.getLineMaxColumn(r)),o,a):null}static j(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r).substring(0,n.column-1),u=this.k(o,d,r,a);if(u)return u;for(let l=1;l<=t;l++){const h=(t+r-l-1)%t,k=i.getLineContent(h+1),D=this.k(o,k,h+1,a);if(D)return D}return null}static k(i,n,o,a){let t=null,r;for(i.reset(0);r=i.next(n);)t=A(new L.$zs(o,r.index+1,o,r.index+1+r[0].length),r,a);return t}}e.$DB=f;function y(s,i,n,o,a){if(o===0)return!0;const t=i.charCodeAt(o-1);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o);if(s.get(r)!==0)return!0}return!1}function S(s,i,n,o,a){if(o+a===n)return!0;const t=i.charCodeAt(o+a);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o+a-1);if(s.get(r)!==0)return!0}return!1}function w(s,i,n,o,a){return y(s,i,n,o,a)&&S(s,i,n,o,a)}e.$EB=w;class c{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let o;do{if(this.b+this.c===n||(o=this.a.exec(i),!o))return null;const a=o.index,t=o[0].length;if(a===this.b&&t===this.c){if(t===0){I.$_e(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||w(this._wordSeparators,i,n,a,t))return o}while(o);return null}}e.$FB=c}),define(ke[128],Se([1,0,53,29,80,174,99]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=void 0;const p=65535;function E(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class g{constructor(i,n,o,a,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=a,this.isBasicASCII=t}}function A(s,i=!0){const n=[0];let o=1;for(let a=0,t=s.length;a<t;a++){const r=s.charCodeAt(a);r===13?a+1<t&&s.charCodeAt(a+1)===10?(n[o++]=a+2,a++):n[o++]=a+1:r===10&&(n[o++]=a+1)}return i?E(n):n}e.$GB=A;function P(s,i){s.length=0,s[0]=0;let n=1,o=0,a=0,t=0,r=!0;for(let u=0,l=i.length;u<l;u++){const h=i.charCodeAt(u);h===13?u+1<l&&i.charCodeAt(u+1)===10?(t++,s[n++]=u+2,u++):(o++,s[n++]=u+1):h===10?(a++,s[n++]=u+1):r&&h!==9&&(h<32||h>126)&&(r=!1)}const d=new g(E(s),o,a,t,r);return s.length=0,d}e.$HB=P;class f{constructor(i,n,o,a,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=a,this.length=t}}e.$IB=f;class y{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$JB=y;class S{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==L.$rB&&i.iterate(i.root,o=>(o!==L.$rB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class w{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let a=0;a<o.length;a++){const t=o[a];if(t.node.parent===null||t.nodeStartOffset>=i){o[a]=null,n=!0;continue}}if(n){const a=[];for(const t of o)t!==null&&a.push(t);this.b=a}}}class c{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new y("",[0])],this.g={line:0,column:0},this.root=L.$rB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let a=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new f(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,d)}this.h=new w(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,o=n-Math.floor(n/3),a=o*2;let t="",r=0;const d=[];if(this.iterate(this.root,u=>{const l=this.R(u),h=l.length;if(r<=o||r+h<a)return t+=l,r+=h,!0;const k=t.replace(/\r\n|\r|\n/g,i);return d.push(new y(k,A(k))),t=l,r=h,!0}),r>0){const u=t.replace(/\r\n|\r|\n/g,i);d.push(new y(u,A(u)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===L.$rB)return!0;const t=this.R(a),r=t.length,d=i.G(n),u=i.G(n+r),l=i.getValueInRange2(d,u);return n+=r,t===l})}getOffsetAt(i,n){let o=0,a=this.root;for(;a!==L.$rB;)if(a.left!==L.$rB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){o+=a.size_left;const t=this.B(a,i-a.lf_left-2);return o+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,o+=a.size_left+a.piece.length,a=a.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const a=i;for(;n!==L.$rB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(o+1,1),d=a-r;return new I.$ys(o+1,d+1)}return new I.$ys(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===L.$rB){const t=this.getOffsetAt(o+1,1),r=a-i-t;return new I.$ys(o+1,r+1)}else n=n.right;return new I.$ys(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,u=this.a[d.piece.bufferIndex].buffer,l=this.u(d.piece.bufferIndex,d.piece.start);return u.substring(l+i.remainder,l+n.remainder)}let o=i.node;const a=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let r=a.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==L.$rB;){const d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){r+=d.substring(u,u+n.remainder);break}else r+=d.substr(u,o.piece.length);o=o.next()}return r}getLinesContent(){const i=[];let n=0,o="",a=!1;return this.iterate(this.root,t=>{if(t===L.$rB)return!0;const r=t.piece;let d=r.length;if(d===0)return!0;const u=this.a[r.bufferIndex].buffer,l=this.a[r.bufferIndex].lineStarts,h=r.start.line,k=r.end.line;let D=l[h]+r.start.column;if(a&&(u.charCodeAt(D)===10&&(D++,d--),i[n++]=o,o="",a=!1,d===0))return!0;if(h===k)return!this.f&&u.charCodeAt(D+d-1)===13?(a=!0,o+=u.substr(D,d-1)):o+=u.substr(D,d),!0;o+=this.f?u.substring(D,Math.max(D,l[h+1]-this.e)):u.substring(D,l[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let $=h+1;$<k;$++)o=this.f?u.substring(l[$],l[$+1]-this.e):u.substring(l[$],l[$+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&u.charCodeAt(l[k]+r.end.column-1)===13?(a=!0,r.end.column===0?n--:o=u.substr(l[k],r.end.column-1)):o=u.substr(l[k],r.end.column),!0}),a&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,a,t,r,d,u,l,h,k){const D=this.a[i.piece.bufferIndex],$=this.u(i.piece.bufferIndex,i.piece.start),b=this.u(i.piece.bufferIndex,t),v=this.u(i.piece.bufferIndex,r);let C;const N={line:0,column:0};let j,M;n._wordSeparators?(j=D.buffer.substring(b,v),M=O=>O+b,n.reset(0)):(j=D.buffer,M=O=>O,n.reset(b));do if(C=n.next(j),C){if(M(C.index)>=v)return h;this.s(i,M(C.index)-$,N);const O=this.t(i.piece.bufferIndex,t,N),z=N.line===t.line?N.column-t.column+a:N.column+1,T=z+C[0].length;if(k[h++]=(0,R.$CB)(new F.$zs(o+O,z,o+O,T),C,u),M(C.index)+C[0].length>=v||h>=l)return h}while(C);return h}findMatchesLineByLine(i,n,o,a){const t=[];let r=0;const d=new R.$FB(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const l=this.H(i.endLineNumber,i.endColumn);if(l===null)return[];let h=this.s(u.node,u.remainder);const k=this.s(l.node,l.remainder);if(u.node===l.node)return this.findMatchesInNode(u.node,d,i.startLineNumber,i.startColumn,h,k,n,o,a,r,t),t;let D=i.startLineNumber,$=u.node;for(;$!==l.node;){const v=this.t($.piece.bufferIndex,h,$.piece.end);if(v>=1){const N=this.a[$.piece.bufferIndex].lineStarts,j=this.u($.piece.bufferIndex,$.piece.start),M=N[h.line+v],O=D===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode($,d,D,O,h,this.s($,M-j),n,o,a,r,t),r>=a)return t;D+=v}const C=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const N=this.getLineContent(D).substring(C,i.endColumn-1);return r=this.n(n,d,N,i.endLineNumber,C,r,t,o,a),t}if(r=this.n(n,d,this.getLineContent(D).substr(C),D,C,r,t,o,a),r>=a)return t;D++,u=this.H(D,1),$=u.node,h=this.s(u.node,u.remainder)}if(D===i.endLineNumber){const v=D===i.startLineNumber?i.startColumn-1:0,C=this.getLineContent(D).substring(v,i.endColumn-1);return r=this.n(n,d,C,i.endLineNumber,v,r,t,o,a),t}const b=D===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(l.node,d,D,b,h,k,n,o,a,r,t),t}n(i,n,o,a,t,r,d,u,l){const h=i.wordSeparators;if(!u&&i.simpleSearch){const D=i.simpleSearch,$=D.length,b=o.length;let v=-$;for(;(v=o.indexOf(D,v+$))!==-1;)if((!h||(0,R.$EB)(h,o,b,v,$))&&(d[r++]=new m.$Qu(new F.$zs(a,v+1+t,a,v+1+$+t),null),r>=l))return r;return r}let k;n.reset(0);do if(k=n.next(o),k&&(d[r++]=(0,R.$CB)(new F.$zs(a,k.index+1+t,a,k.index+1+k[0].length+t),k,u),r>=l))return r;while(k);return r}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==L.$rB){const{node:a,remainder:t,nodeStartOffset:r}=this.G(i),d=a.piece,u=d.bufferIndex,l=this.s(a,t);if(a.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&r+d.length===i&&n.length<p){this.F(a,n),this.y();return}if(r===i)this.o(n,a),this.h.validate(i);else if(r+a.piece.length>i){const h=[];let k=new f(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),this.u(u,d.end)-this.u(u,l));if(this.K()&&this.M(n)&&this.I(a,t)===10){const v={line:k.start.line+1,column:0};k=new f(k.bufferIndex,v,k.end,this.t(k.bufferIndex,v,k.end),k.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const v=this.s(a,t-1);this.C(a,v),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,l);else this.C(a,l);const D=this.w(n);k.length>0&&this.S(a,k);let $=a;for(let b=0;b<D.length;b++)$=this.S($,D[b]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let r=1;r<a.length;r++)t=this.S(t,a[r])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===L.$rB)return;const o=this.G(i),a=this.G(i+n),t=o.node,r=a.node;if(t===r){const D=this.s(t,o.remainder),$=this.s(t,a.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const b=t.next();(0,L.$wB)(this,t),this.N(b),this.y();return}this.D(t,$),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,D),this.O(t),this.y();return}this.E(t,D,$),this.y();return}const d=[],u=this.s(t,o.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&d.push(t);const l=this.s(r,a.remainder);this.D(r,l),r.piece.length===0&&d.push(r);const h=t.next();for(let D=h;D!==L.$rB&&D!==r;D=D.next())d.push(D);const k=t.piece.length===0?t.prev():t;this.v(d),this.O(k),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const r=n.piece,d={line:r.start.line+1,column:0},u=new f(r.bufferIndex,d,r.end,this.t(r.bufferIndex,d,r.end),r.length-1);n.piece=u,i+=`
`,(0,L.$yB)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let r=a.length-2;r>=0;r--)t=this.T(t,a[r]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),a=this.S(n,o[0]);let t=a;for(let r=1;r<o.length;r++)t=this.S(t,o[r]);this.N(a)}s(i,n,o){const a=i.piece,t=i.piece.bufferIndex,r=this.a[t].lineStarts,u=r[a.start.line]+a.start.column+n;let l=a.start.line,h=a.end.line,k=0,D=0,$=0;for(;l<=h&&(k=l+(h-l)/2|0,$=r[k],k!==h);)if(D=r[k+1],u<$)h=k-1;else if(u>=D)l=k+1;else break;return o?(o.line=k,o.column=u-$,null):{line:k,column:u-$}}t(i,n,o){if(o.column===0)return o.line-n.line;const a=this.a[i].lineStarts;if(o.line===a.length-1)return o.line-n.line;const t=a[o.line+1],r=a[o.line]+o.column;if(t>r+1)return o.line-n.line;const d=r-1;return this.a[i].buffer.charCodeAt(d)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,L.$wB)(this,i[n])}w(i){if(i.length>p){const h=[];for(;i.length>p;){const D=i.charCodeAt(p-1);let $;D===13||D>=55296&&D<=56319?($=i.substring(0,p-1),i=i.substring(p-1)):($=i.substring(0,p),i=i.substring(p));const b=A($);h.push(new f(this.a.length,{line:0,column:0},{line:b.length-1,column:$.length-b[b.length-1]},b.length-1,$.length)),this.a.push(new y($,b))}const k=A(i);return h.push(new f(this.a.length,{line:0,column:0},{line:k.length-1,column:i.length-k[k.length-1]},k.length-1,i.length)),this.a.push(new y(i,k)),h}let n=this.a[0].buffer.length;const o=A(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<o.length;h++)o[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<o.length;h++)o[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[r],u={line:r,column:d},l=new f(0,a,u,this.t(0,a,u),t-n);return this.g=u,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,a="";const t=this.h.get2(i);if(t){o=t.node;const r=this.B(o,i-t.nodeStartLineNumber-1),d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)a=d.substring(u+r,u+o.piece.length);else{const l=this.B(o,i-t.nodeStartLineNumber);return d.substring(u+r,u+l-n)}}else{let r=0;const d=i;for(;o!==L.$rB;)if(o.left!==L.$rB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const u=this.B(o,i-o.lf_left-2),l=this.B(o,i-o.lf_left-1),h=this.a[o.piece.bufferIndex].buffer,k=this.u(o.piece.bufferIndex,o.piece.start);return r+=o.size_left,this.h.set({node:o,nodeStartOffset:r,nodeStartLineNumber:d-(i-1-o.lf_left)}),h.substring(k+u,k+l-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const u=this.B(o,i-o.lf_left-2),l=this.a[o.piece.bufferIndex].buffer,h=this.u(o.piece.bufferIndex,o.piece.start);a=l.substring(h+u,h+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==L.$rB;){const r=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const d=this.B(o,0),u=this.u(o.piece.bufferIndex,o.piece.start);return a+=r.substring(u,u+d-n),a}else{const d=this.u(o.piece.bufferIndex,o.piece.start);a+=r.substr(d,o.piece.length)}o=o.next()}return a}y(){let i=this.root,n=1,o=0;for(;i!==L.$rB;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,a=this.s(i,n),t=a.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const r=this.t(i.piece.bufferIndex,o.start,a);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const o=i.piece,a=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?a[o.end.line]+o.end.column-a[o.start.line]-o.start.column:a[t]-a[o.start.line]-o.start.column}C(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),r=n,d=this.u(o.bufferIndex,r),u=this.t(o.bufferIndex,o.start,r),l=u-a,h=d-t,k=o.length+h;i.piece=new f(o.bufferIndex,o.start,r,u,k),(0,L.$yB)(this,i,h,l)}D(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),r=n,d=this.t(o.bufferIndex,r,o.end),u=this.u(o.bufferIndex,r),l=d-a,h=t-u,k=o.length+h;i.piece=new f(o.bufferIndex,r,o.end,d,k),(0,L.$yB)(this,i,h,l)}E(i,n,o){const a=i.piece,t=a.start,r=a.end,d=a.length,u=a.lineFeedCnt,l=n,h=this.t(a.bufferIndex,a.start,l),k=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new f(a.bufferIndex,a.start,l,h,k),(0,L.$yB)(this,i,k-d,h-u);const D=new f(a.bufferIndex,o,r,this.t(a.bufferIndex,o,r),this.u(a.bufferIndex,r)-this.u(a.bufferIndex,o)),$=this.S(i,D);this.N($)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let $=0;$<t.length;$++)t[$]+=a;if(o){const $=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-$}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[r],u={line:r,column:d},l=i.piece.length+n.length,h=i.piece.lineFeedCnt,k=this.t(0,i.piece.start,u),D=k-h;i.piece=new f(i.piece.bufferIndex,i.piece.start,u,k,l),this.g=u,(0,L.$yB)(this,i,n.length,D)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let a=0;for(;n!==L.$rB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,a=0;for(;o!==L.$rB;)if(o.left!==L.$rB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),r=this.B(o,i-o.lf_left-1);return a+=o.size_left,{node:o,remainder:Math.min(t+n-1,r),nodeStartOffset:a}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:a};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,a+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==L.$rB;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),r=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$rB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=o[a]+n.start.column;return a===o.length-1||o[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$rB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new f(i.piece.bufferIndex,i.piece.start,t,d,r),(0,L.$yB)(this,i,-1,-1),i.piece.length===0&&o.push(i);const u={line:n.piece.start.line+1,column:0},l=n.piece.length-1,h=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new f(n.piece.bufferIndex,u,n.piece.end,h,l),(0,L.$yB)(this,n,-1,-1),n.piece.length===0&&o.push(n);const k=this.w(`\r
`);this.S(i,k[0]);for(let D=0;D<o.length;D++)(0,L.$wB)(this,o[D])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,L.$wB)(this,o);else{const a=o.piece,t={line:a.start.line+1,column:0},r=a.length-1,d=this.t(a.bufferIndex,t,a.end);o.piece=new f(a.bufferIndex,t,a.end,d,r),(0,L.$yB)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===L.$rB)return n(L.$rB);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===L.$rB)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,a=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,a)}S(i,n){const o=new L.$qB(n,1);if(o.left=L.$rB,o.right=L.$rB,o.parent=L.$rB,o.size_left=0,o.lf_left=0,this.root===L.$rB)this.root=o,o.color=0;else if(i.right===L.$rB)i.right=o,o.parent=i;else{const t=(0,L.$sB)(i.right);t.left=o,o.parent=t}return(0,L.$xB)(this,o),o}T(i,n){const o=new L.$qB(n,1);if(o.left=L.$rB,o.right=L.$rB,o.parent=L.$rB,o.size_left=0,o.lf_left=0,this.root===L.$rB)this.root=o,o.color=0;else if(i.left===L.$rB)i.left=o,o.parent=i;else{const a=(0,L.$tB)(i.left);a.right=o,o.parent=a}return(0,L.$xB)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$KB=c}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8=e.$v8=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$v8=I;class F{constructor(L){this.identifier=L}}e.$w8=F}),define(ke[178],Se([1,0,4,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0;class m{constructor(){this.a=new Map,this.b=new Map,this.c=new I.$Qd,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,E){return this.a.set(p,E),this.handleChange([p]),(0,F.$Pc)(()=>{this.a.get(p)===E&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,E){this.b.get(p)?.dispose();const g=new L(this,p,E);return this.b.set(p,g),(0,F.$Pc)(()=>{const A=this.b.get(p);!A||A!==g||(this.b.delete(p),A.dispose())})}async getOrCreate(p){const E=this.get(p);if(E)return E;const g=this.b.get(p);return!g||g.isResolved?null:(await g.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const g=this.b.get(p);return!!(!g||g.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$$s=m;class L extends F.$Rc{get isResolved(){return this.c}constructor(p,E,g){super(),this.f=p,this.g=E,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(ke[179],Se([8,9]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=void 0;class L extends F.$Rc{constructor(f,y="",S="",w=!0,c){super(),this.h=this.B(new I.$Qd),this.onDidChange=this.h.event,this.w=!0,this.j=f,this.m=y,this.u=S,this.w=w,this.C=c}get id(){return this.j}get label(){return this.m}set label(f){this.D(f)}D(f){this.m!==f&&(this.m=f,this.h.fire({label:f}))}get tooltip(){return this.n||""}set tooltip(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.h.fire({tooltip:f}))}get class(){return this.u}set class(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.h.fire({class:f}))}get enabled(){return this.w}set enabled(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.h.fire({enabled:f}))}get checked(){return this.z}set checked(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.h.fire({checked:f}))}async run(f,y){this.C&&await this.C(f)}}e.$zi=L;class R extends F.$Rc{constructor(){super(...arguments),this.f=this.B(new I.$Qd),this.onWillRun=this.f.event,this.m=this.B(new I.$Qd),this.onDidRun=this.m.event}async run(f,y){if(!f.enabled)return;this.f.fire({action:f});let S;try{await this.u(f,y)}catch(w){S=w}this.m.fire({action:f,error:S})}async u(f,y){await f.run(y)}}e.$Ai=R;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let y=[];for(const S of f)S.length&&(y.length?y=[...y,new p,...S]:y=S);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$Bi=p;class E{get actions(){return this.a}constructor(f,y,S,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=y,this.class=w,this.a=S}async run(){}}e.$Ci=E;class g extends L{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,m.localize(0,null),void 0,!1)}}e.$Di=g;function A(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async(...f)=>P.run(...f),tooltip:P.label}}e.$Ei=A}),define(ke[181],Se([8,9]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=void 0;const F=60,m=F*60,L=m*24,R=L*7,p=L*30,E=L*365;function g(P,f,y,S){typeof P!="number"&&(P=P.getTime());const w=Math.round((new Date().getTime()-P)/1e3);if(w<-30)return(0,I.localize)(0,null,g(new Date().getTime()+w*1e3,!1));if(!S&&w<30)return(0,I.localize)(1,null);let c;return w<F?(c=w,f?c===1?y?(0,I.localize)(2,null,c):(0,I.localize)(3,null,c):y?(0,I.localize)(4,null,c):(0,I.localize)(5,null,c):c===1?y?(0,I.localize)(6,null,c):(0,I.localize)(7,null,c):y?(0,I.localize)(8,null,c):(0,I.localize)(9,null,c)):w<m?(c=Math.floor(w/F),f?c===1?y?(0,I.localize)(10,null,c):(0,I.localize)(11,null,c):y?(0,I.localize)(12,null,c):(0,I.localize)(13,null,c):c===1?y?(0,I.localize)(14,null,c):(0,I.localize)(15,null,c):y?(0,I.localize)(16,null,c):(0,I.localize)(17,null,c)):w<L?(c=Math.floor(w/m),f?c===1?y?(0,I.localize)(18,null,c):(0,I.localize)(19,null,c):y?(0,I.localize)(20,null,c):(0,I.localize)(21,null,c):c===1?y?(0,I.localize)(22,null,c):(0,I.localize)(23,null,c):y?(0,I.localize)(24,null,c):(0,I.localize)(25,null,c)):w<R?(c=Math.floor(w/L),f?c===1?(0,I.localize)(26,null,c):(0,I.localize)(27,null,c):c===1?(0,I.localize)(28,null,c):(0,I.localize)(29,null,c)):w<p?(c=Math.floor(w/R),f?c===1?y?(0,I.localize)(30,null,c):(0,I.localize)(31,null,c):y?(0,I.localize)(32,null,c):(0,I.localize)(33,null,c):c===1?y?(0,I.localize)(34,null,c):(0,I.localize)(35,null,c):y?(0,I.localize)(36,null,c):(0,I.localize)(37,null,c)):w<E?(c=Math.floor(w/p),f?c===1?y?(0,I.localize)(38,null,c):(0,I.localize)(39,null,c):y?(0,I.localize)(40,null,c):(0,I.localize)(41,null,c):c===1?y?(0,I.localize)(42,null,c):(0,I.localize)(43,null,c):y?(0,I.localize)(44,null,c):(0,I.localize)(45,null,c)):(c=Math.floor(w/E),f?c===1?y?(0,I.localize)(46,null,c):(0,I.localize)(47,null,c):y?(0,I.localize)(48,null,c):(0,I.localize)(49,null,c):c===1?y?(0,I.localize)(50,null,c):(0,I.localize)(51,null,c):y?(0,I.localize)(52,null,c):(0,I.localize)(53,null,c))}e.$im=g;function A(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$jm=A}),define(ke[183],Se([8,9]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[43],Se([1,0,19,18,183]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=void 0;function L(P,f){return f&&(P.stack||P.stacktrace)?m.localize(0,null,p(P),R(P.stack)||R(P.stacktrace)):p(P)}function R(P){return Array.isArray(P)?P.join(`
`):P}function p(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?m.localize(1,null,P.message):P.message||m.localize(2,null)}function E(P=null,f=!1){if(!P)return m.localize(3,null);if(Array.isArray(P)){const y=I.$Gb(P),S=E(y[0],f);return y.length>1?m.localize(4,null,S,y.length):S}if(F.$Bf(P))return P;if(P.detail){const y=P.detail;if(y.error)return L(y.error,f);if(y.exception)return L(y.exception,f)}return P.stack?L(P,f):P.message?P.message:m.localize(5,null)}e.$Fi=E;function g(P){const f=P;return f instanceof Error&&Array.isArray(f.actions)}e.$Gi=g;function A(P,f){let y;return typeof P=="string"?y=new Error(P):y=P,y.actions=f,y}e.$Hi=A}),define(ke[184],Se([8,9]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[12],Se([1,0,184]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let F=!1,m=!1,L=!1,R=!1,p=!1,E=!1,g=!1,A=!1,P=!1,f=!1,y,S=e.$g,w=e.$g,c,s;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const o=typeof n?.versions?.electron=="string",a=o&&n?.type==="renderer";if(typeof navigator=="object"&&!a)s=navigator.userAgent,F=s.indexOf("Windows")>=0,m=s.indexOf("Macintosh")>=0,A=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=s.indexOf("Linux")>=0,f=s?.indexOf("Mobi")>=0,E=!0,y=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,S=y,w=navigator.language;else if(typeof n=="object"){F=n.platform==="win32",m=n.platform==="darwin",L=n.platform==="linux",R=L&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,g=o,P=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=e.$g,S=e.$g;const $=n.env.VSCODE_NLS_CONFIG;if($)try{const b=JSON.parse($),v=b.availableLanguages["*"];y=b.locale,w=b.osLocale,S=v||e.$g,c=b._translationsConfigFile}catch{}p=!0}else console.error("Unable to resolve platform.");var t;(function($){$[$.Web=0]="Web",$[$.Mac=1]="Mac",$[$.Linux=2]="Linux",$[$.Windows=3]="Windows"})(t||(e.Platform=t={}));function r($){switch($){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=r;let d=0;m?d=1:F?d=3:L&&(d=2),e.$i=F,e.$j=m,e.$k=L,e.$l=R,e.$m=p,e.$n=g,e.$o=E,e.$p=E&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=A,e.$s=f,e.$t=P,e.$u=d,e.$v=s,e.$w=S;var u;(function($){function b(){return e.$w}$.value=b;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}$.isDefaultVariant=v;function C(){return e.$w==="en"}$.isDefault=C})(u||(e.Language=u={})),e.$x=y,e.$y=w,e.$z=c,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const $=[];i.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let C=0,N=$.length;C<N;C++){const j=$[C];if(j.id===v.data.vscodeScheduleAsyncWork){$.splice(C,1),j.callback();return}}});let b=0;return v=>{const C=++b;$.push({id:C,callback:v}),i.postMessage({vscodeScheduleAsyncWork:C},"*")}}return $=>setTimeout($)})();var l;(function($){$[$.Windows=1]="Windows",$[$.Macintosh=2]="Macintosh",$[$.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=m||A?2:F?1:3;let h=!0,k=!1;function D(){if(!k){k=!0;const $=new Uint8Array(2);$[0]=1,$[1]=2,h=new Uint16Array($.buffer)[0]===(2<<8)+1}return h}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ke[49],Se([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let F;const m=globalThis.vscode;if(typeof m<"u"&&typeof m.process<"u"){const L=m.process;F={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$cc=F.platform,e.$dc=F.arch}),define(ke[16],Se([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const F=65,m=97,L=90,R=122,p=46,E=47,g=92,A=58,P=63;class f extends Error{constructor(r,d,u){let l;typeof d=="string"&&d.indexOf("not ")===0?(l="must not be",d=d.replace(/^not /,"")):l="must be";const h=r.indexOf(".")!==-1?"property":"argument";let k=`The "${r}" ${h} ${l} of type ${d}`;k+=`. Received type ${typeof u}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function y(t,r){if(t===null||typeof t!="object")throw new f(r,"Object",t)}function S(t,r){if(typeof t!="string")throw new f(r,"string",t)}const w=I.$cc==="win32";function c(t){return t===E||t===g}function s(t){return t===E}function i(t){return t>=F&&t<=L||t>=m&&t<=R}function n(t,r,d,u){let l="",h=0,k=-1,D=0,$=0;for(let b=0;b<=t.length;++b){if(b<t.length)$=t.charCodeAt(b);else{if(u($))break;$=E}if(u($)){if(!(k===b-1||D===1))if(D===2){if(l.length<2||h!==2||l.charCodeAt(l.length-1)!==p||l.charCodeAt(l.length-2)!==p){if(l.length>2){const v=l.lastIndexOf(d);v===-1?(l="",h=0):(l=l.slice(0,v),h=l.length-1-l.lastIndexOf(d)),k=b,D=0;continue}else if(l.length!==0){l="",h=0,k=b,D=0;continue}}r&&(l+=l.length>0?`${d}..`:"..",h=2)}else l.length>0?l+=`${d}${t.slice(k+1,b)}`:l=t.slice(k+1,b),h=b-k-1;k=b,D=0}else $===p&&D!==-1?++D:D=-1}return l}function o(t,r){y(r,"pathObject");const d=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return d?d===r.root?`${d}${u}`:`${d}${t}${u}`:u}e.$ec={resolve(...t){let r="",d="",u=!1;for(let l=t.length-1;l>=-1;l--){let h;if(l>=0){if(h=t[l],S(h,"path"),h.length===0)continue}else r.length===0?h=I.cwd():(h=I.env[`=${r}`]||I.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==r.toLowerCase()&&h.charCodeAt(2)===g)&&(h=`${r}\\`));const k=h.length;let D=0,$="",b=!1;const v=h.charCodeAt(0);if(k===1)c(v)&&(D=1,b=!0);else if(c(v))if(b=!0,c(h.charCodeAt(1))){let C=2,N=C;for(;C<k&&!c(h.charCodeAt(C));)C++;if(C<k&&C!==N){const j=h.slice(N,C);for(N=C;C<k&&c(h.charCodeAt(C));)C++;if(C<k&&C!==N){for(N=C;C<k&&!c(h.charCodeAt(C));)C++;(C===k||C!==N)&&($=`\\\\${j}\\${h.slice(N,C)}`,D=C)}}}else D=1;else i(v)&&h.charCodeAt(1)===A&&($=h.slice(0,2),D=2,k>2&&c(h.charCodeAt(2))&&(b=!0,D=3));if($.length>0)if(r.length>0){if($.toLowerCase()!==r.toLowerCase())continue}else r=$;if(u){if(r.length>0)break}else if(d=`${h.slice(D)}\\${d}`,u=b,b&&r.length>0)break}return d=n(d,!u,"\\",c),u?`${r}\\${d}`:`${r}${d}`||"."},normalize(t){S(t,"path");const r=t.length;if(r===0)return".";let d=0,u,l=!1;const h=t.charCodeAt(0);if(r===1)return s(h)?"\\":t;if(c(h))if(l=!0,c(t.charCodeAt(1))){let D=2,$=D;for(;D<r&&!c(t.charCodeAt(D));)D++;if(D<r&&D!==$){const b=t.slice($,D);for($=D;D<r&&c(t.charCodeAt(D));)D++;if(D<r&&D!==$){for($=D;D<r&&!c(t.charCodeAt(D));)D++;if(D===r)return`\\\\${b}\\${t.slice($)}\\`;D!==$&&(u=`\\\\${b}\\${t.slice($,D)}`,d=D)}}}else d=1;else i(h)&&t.charCodeAt(1)===A&&(u=t.slice(0,2),d=2,r>2&&c(t.charCodeAt(2))&&(l=!0,d=3));let k=d<r?n(t.slice(d),!l,"\\",c):"";return k.length===0&&!l&&(k="."),k.length>0&&c(t.charCodeAt(r-1))&&(k+="\\"),u===void 0?l?`\\${k}`:k:l?`${u}\\${k}`:`${u}${k}`},isAbsolute(t){S(t,"path");const r=t.length;if(r===0)return!1;const d=t.charCodeAt(0);return c(d)||r>2&&i(d)&&t.charCodeAt(1)===A&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,d;for(let h=0;h<t.length;++h){const k=t[h];S(k,"path"),k.length>0&&(r===void 0?r=d=k:r+=`\\${k}`)}if(r===void 0)return".";let u=!0,l=0;if(typeof d=="string"&&c(d.charCodeAt(0))){++l;const h=d.length;h>1&&c(d.charCodeAt(1))&&(++l,h>2&&(c(d.charCodeAt(2))?++l:u=!1))}if(u){for(;l<r.length&&c(r.charCodeAt(l));)l++;l>=2&&(r=`\\${r.slice(l)}`)}return e.$ec.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r)return"";const d=e.$ec.resolve(t),u=e.$ec.resolve(r);if(d===u||(t=d.toLowerCase(),r=u.toLowerCase(),t===r))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===g;)l++;let h=t.length;for(;h-1>l&&t.charCodeAt(h-1)===g;)h--;const k=h-l;let D=0;for(;D<r.length&&r.charCodeAt(D)===g;)D++;let $=r.length;for(;$-1>D&&r.charCodeAt($-1)===g;)$--;const b=$-D,v=k<b?k:b;let C=-1,N=0;for(;N<v;N++){const M=t.charCodeAt(l+N);if(M!==r.charCodeAt(D+N))break;M===g&&(C=N)}if(N!==v){if(C===-1)return u}else{if(b>v){if(r.charCodeAt(D+N)===g)return u.slice(D+N+1);if(N===2)return u.slice(D+N)}k>v&&(t.charCodeAt(l+N)===g?C=N:N===2&&(C=3)),C===-1&&(C=0)}let j="";for(N=l+C+1;N<=h;++N)(N===h||t.charCodeAt(N)===g)&&(j+=j.length===0?"..":"\\..");return D+=C,j.length>0?`${j}${u.slice(D,$)}`:(u.charCodeAt(D)===g&&++D,u.slice(D,$))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$ec.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===g){if(r.charCodeAt(1)===g){const d=r.charCodeAt(2);if(d!==P&&d!==p)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===A&&r.charCodeAt(2)===g)return`\\\\?\\${r}`;return t},dirname(t){S(t,"path");const r=t.length;if(r===0)return".";let d=-1,u=0;const l=t.charCodeAt(0);if(r===1)return c(l)?t:".";if(c(l)){if(d=u=1,c(t.charCodeAt(1))){let D=2,$=D;for(;D<r&&!c(t.charCodeAt(D));)D++;if(D<r&&D!==$){for($=D;D<r&&c(t.charCodeAt(D));)D++;if(D<r&&D!==$){for($=D;D<r&&!c(t.charCodeAt(D));)D++;if(D===r)return t;D!==$&&(d=u=D+1)}}}}else i(l)&&t.charCodeAt(1)===A&&(d=r>2&&c(t.charCodeAt(2))?3:2,u=d);let h=-1,k=!0;for(let D=r-1;D>=u;--D)if(c(t.charCodeAt(D))){if(!k){h=D;break}}else k=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let d=0,u=-1,l=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let k=r.length-1,D=-1;for(h=t.length-1;h>=d;--h){const $=t.charCodeAt(h);if(c($)){if(!l){d=h+1;break}}else D===-1&&(l=!1,D=h+1),k>=0&&($===r.charCodeAt(k)?--k===-1&&(u=h):(k=-1,u=D))}return d===u?u=D:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=d;--h)if(c(t.charCodeAt(h))){if(!l){d=h+1;break}}else u===-1&&(l=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){S(t,"path");let r=0,d=-1,u=0,l=-1,h=!0,k=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(r=u=2);for(let D=t.length-1;D>=r;--D){const $=t.charCodeAt(D);if(c($)){if(!h){u=D+1;break}continue}l===-1&&(h=!1,l=D+1),$===p?d===-1?d=D:k!==1&&(k=1):d!==-1&&(k=-1)}return d===-1||l===-1||k===0||k===1&&d===l-1&&d===u+1?"":t.slice(d,l)},format:o.bind(null,"\\"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.length;let u=0,l=t.charCodeAt(0);if(d===1)return c(l)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(c(l)){if(u=1,c(t.charCodeAt(1))){let C=2,N=C;for(;C<d&&!c(t.charCodeAt(C));)C++;if(C<d&&C!==N){for(N=C;C<d&&c(t.charCodeAt(C));)C++;if(C<d&&C!==N){for(N=C;C<d&&!c(t.charCodeAt(C));)C++;C===d?u=C:C!==N&&(u=C+1)}}}}else if(i(l)&&t.charCodeAt(1)===A){if(d<=2)return r.root=r.dir=t,r;if(u=2,c(t.charCodeAt(2))){if(d===3)return r.root=r.dir=t,r;u=3}}u>0&&(r.root=t.slice(0,u));let h=-1,k=u,D=-1,$=!0,b=t.length-1,v=0;for(;b>=u;--b){if(l=t.charCodeAt(b),c(l)){if(!$){k=b+1;break}continue}D===-1&&($=!1,D=b+1),l===p?h===-1?h=b:v!==1&&(v=1):h!==-1&&(v=-1)}return D!==-1&&(h===-1||v===0||v===1&&h===D-1&&h===k+1?r.base=r.name=t.slice(k,D):(r.name=t.slice(k,h),r.base=t.slice(k,D),r.ext=t.slice(h,D))),k>0&&k!==u?r.dir=t.slice(0,k-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(w){const t=/\\/g;return()=>{const r=I.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>I.cwd()})();e.$fc={resolve(...t){let r="",d=!1;for(let u=t.length-1;u>=-1&&!d;u--){const l=u>=0?t[u]:a();S(l,"path"),l.length!==0&&(r=`${l}/${r}`,d=l.charCodeAt(0)===E)}return r=n(r,!d,"/",s),d?`/${r}`:r.length>0?r:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===E,d=t.charCodeAt(t.length-1)===E;return t=n(t,!r,"/",s),t.length===0?r?"/":d?"./":".":(d&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===E},join(...t){if(t.length===0)return".";let r;for(let d=0;d<t.length;++d){const u=t[d];S(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.$fc.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r||(t=e.$fc.resolve(t),r=e.$fc.resolve(r),t===r))return"";const d=1,u=t.length,l=u-d,h=1,k=r.length-h,D=l<k?l:k;let $=-1,b=0;for(;b<D;b++){const C=t.charCodeAt(d+b);if(C!==r.charCodeAt(h+b))break;C===E&&($=b)}if(b===D)if(k>D){if(r.charCodeAt(h+b)===E)return r.slice(h+b+1);if(b===0)return r.slice(h+b)}else l>D&&(t.charCodeAt(d+b)===E?$=b:b===0&&($=0));let v="";for(b=d+$+1;b<=u;++b)(b===u||t.charCodeAt(b)===E)&&(v+=v.length===0?"..":"/..");return`${v}${r.slice(h+$)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===E;let d=-1,u=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===E){if(!u){d=l;break}}else u=!1;return d===-1?r?"/":".":r&&d===1?"//":t.slice(0,d)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let d=0,u=-1,l=!0,h;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let k=r.length-1,D=-1;for(h=t.length-1;h>=0;--h){const $=t.charCodeAt(h);if($===E){if(!l){d=h+1;break}}else D===-1&&(l=!1,D=h+1),k>=0&&($===r.charCodeAt(k)?--k===-1&&(u=h):(k=-1,u=D))}return d===u?u=D:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===E){if(!l){d=h+1;break}}else u===-1&&(l=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){S(t,"path");let r=-1,d=0,u=-1,l=!0,h=0;for(let k=t.length-1;k>=0;--k){const D=t.charCodeAt(k);if(D===E){if(!l){d=k+1;break}continue}u===-1&&(l=!1,u=k+1),D===p?r===-1?r=k:h!==1&&(h=1):r!==-1&&(h=-1)}return r===-1||u===-1||h===0||h===1&&r===u-1&&r===d+1?"":t.slice(r,u)},format:o.bind(null,"/"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.charCodeAt(0)===E;let u;d?(r.root="/",u=1):u=0;let l=-1,h=0,k=-1,D=!0,$=t.length-1,b=0;for(;$>=u;--$){const v=t.charCodeAt($);if(v===E){if(!D){h=$+1;break}continue}k===-1&&(D=!1,k=$+1),v===p?l===-1?l=$:b!==1&&(b=1):l!==-1&&(b=-1)}if(k!==-1){const v=h===0&&d?1:h;l===-1||b===0||b===1&&l===k-1&&l===h+1?r.base=r.name=t.slice(v,k):(r.name=t.slice(v,l),r.base=t.slice(v,k),r.ext=t.slice(l,k))}return h>0?r.dir=t.slice(0,h-1):d&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=w?e.$ec.normalize:e.$fc.normalize,e.$hc=w?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=w?e.$ec.join:e.$fc.join,e.$jc=w?e.$ec.resolve:e.$fc.resolve,e.$kc=w?e.$ec.relative:e.$fc.relative,e.$lc=w?e.$ec.dirname:e.$fc.dirname,e.$mc=w?e.$ec.basename:e.$fc.basename,e.$nc=w?e.$ec.extname:e.$fc.extname,e.$oc=w?e.$ec.format:e.$fc.format,e.$pc=w?e.$ec.parse:e.$fc.parse,e.$qc=w?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=w?e.$ec.sep:e.$fc.sep,e.$sc=w?e.$ec.delimiter:e.$fc.delimiter}),define(ke[129],Se([1,0,48,16]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=void 0;const m=new I.$U(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),L=new I.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new I.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(D,$,b=!1){const v=D||"",C=$||"",N=m.value.collator.compare(v,C);return m.value.collatorIsNumeric&&N===0&&v!==C?v<C?-1:1:N}e.$mq=p;function E(D,$){const b=L.value.collator;return D=D||"",$=$||"",o(b,D,$)}e.$nq=E;function g(D,$){const b=L.value.collator;return D=D||"",$=$||"",d(D,$)||o(b,D,$)}e.$oq=g;function A(D,$){const b=L.value.collator;return D=D||"",$=$||"",r(D,$)||o(b,D,$)}e.$pq=A;function P(D,$){return D=D||"",$=$||"",D===$?0:D<$?-1:1}e.$qq=P;function f(D,$){const[b,v]=i(D),[C,N]=i($);let j=m.value.collator.compare(v,N);if(j===0){if(m.value.collatorIsNumeric&&v!==N)return v<N?-1:1;if(j=m.value.collator.compare(b,C),m.value.collatorIsNumeric&&j===0&&b!==C)return b<C?-1:1}return j}e.$rq=f;function y(D,$){D=D||"",$=$||"";const b=n(D),v=n($),C=L.value.collator,N=R.value.collator;return o(N,b,v)||o(C,D,$)}e.$sq=y;function S(D,$){D=D||"",$=$||"";const b=n(D),v=n($),C=L.value.collator,N=R.value.collator;return o(N,b,v)||d(D,$)||o(C,D,$)}e.$tq=S;function w(D,$){D=D||"",$=$||"";const b=n(D),v=n($),C=L.value.collator,N=R.value.collator;return o(N,b,v)||r(D,$)||o(C,D,$)}e.$uq=w;function c(D,$){D=D||"",$=$||"";const b=n(D).toLowerCase(),v=n($).toLowerCase();return b!==v?b<v?-1:1:D!==$?D<$?-1:1:0}e.$vq=c;const s=/^(.*?)(\.([^.]*))?$/;function i(D,$=!1){const b=D?s.exec(D):[];let v=[b&&b[1]||"",b&&b[3]||""];return $&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function n(D){const $=D?s.exec(D):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function o(D,$,b){const v=D.compare($,b);return v!==0?v:$.length!==b.length?$.length<b.length?-1:1:0}function a(D){const $=D.charAt(0);return $.toLocaleUpperCase()!==$}function t(D){const $=D.charAt(0);return $.toLocaleLowerCase()!==$}function r(D,$){return a(D)&&t($)?-1:t(D)&&a($)?1:0}function d(D,$){return t(D)&&a($)?-1:a(D)&&t($)?1:0}function u(D,$,b=!1){return b||(D=D&&D.toLowerCase(),$=$&&$.toLowerCase()),D===$?0:D<$?-1:1}function l(D,$,b=!1){const v=D.split(F.sep),C=$.split(F.sep),N=v.length-1,j=C.length-1;let M,O;for(let z=0;;z++){if(M=N===z,O=j===z,M&&O)return p(v[z],C[z],b);if(M)return-1;if(O)return 1;const T=u(v[z],C[z],b);if(T!==0)return T}}e.$wq=l;function h(D,$,b){const v=D.toLowerCase(),C=$.toLowerCase(),N=k(D,$,b);if(N)return N;const j=v.endsWith(b),M=C.endsWith(b);if(j!==M)return j?-1:1;const O=p(v,C);return O!==0?O:v.localeCompare(C)}e.$xq=h;function k(D,$,b){const v=D.toLowerCase(),C=$.toLowerCase(),N=v.startsWith(b),j=C.startsWith(b);if(N!==j)return N?-1:1;if(N&&j){if(v.length<C.length)return-1;if(v.length>C.length)return 1}return 0}e.$yq=k}),define(ke[33],Se([1,0,16,12,13,18]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function R(h){return h===47||h===92}e.$Tf=R;function p(h){return h.replace(/[\\/]/g,I.$fc.sep)}e.$Uf=p;function E(h){return h.indexOf("/")===-1&&(h=p(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Vf=E;function g(h,k=I.$fc.sep){if(!h)return"";const D=h.length,$=h.charCodeAt(0);if(R($)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let v=3;const C=v;for(;v<D&&!R(h.charCodeAt(v));v++);if(C!==v&&!R(h.charCodeAt(v+1))){for(v+=1;v<D;v++)if(R(h.charCodeAt(v)))return h.slice(0,v+1).replace(/[\\/]/g,k)}}return k}else if(s($)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+k:h.slice(0,2);let b=h.indexOf("://");if(b!==-1){for(b+=3;b<D;b++)if(R(h.charCodeAt(b)))return h.slice(0,b+1)}return""}e.$Wf=g;function A(h){if(!F.$i||!h||h.length<5)return!1;let k=h.charCodeAt(0);if(k!==92||(k=h.charCodeAt(1),k!==92))return!1;let D=2;const $=D;for(;D<h.length&&(k=h.charCodeAt(D),k!==92);D++);return!($===D||(k=h.charCodeAt(D+1),isNaN(k)||k===92))}e.$Xf=A;const P=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(h,k=F.$i){const D=k?P:f;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||k&&y.test(h)||h==="."||h===".."||k&&h[h.length-1]==="."||k&&h.length!==h.trim().length||h.length>255)}e.$Yf=S;function w(h,k,D){const $=h===k;return!D||$?$:!h||!k?!1:(0,m.$5e)(h,k)}e.$Zf=w;function c(h,k,D,$=I.sep){if(h===k)return!0;if(!h||!k||k.length>h.length)return!1;if(D){if(!(0,m.$6e)(h,k))return!1;if(k.length===h.length)return!0;let v=k.length;return k.charAt(k.length-1)===$&&v--,h.charAt(v)===$}return k.charAt(k.length-1)!==$&&(k+=$),h.indexOf(k)===0}e.$1f=c;function s(h){return h>=65&&h<=90||h>=97&&h<=122}e.$2f=s;function i(h,k){return F.$i&&h.endsWith(":")&&(h+=I.sep),(0,I.$hc)(h)||(h=(0,I.$ic)(k,h)),h=(0,I.$gc)(h),F.$i?(h=(0,m.$Ne)(h,I.sep),h.endsWith(":")&&(h+=I.sep)):(h=(0,m.$Ne)(h,I.sep),h||(h=I.sep)),h}e.$3f=i;function n(h){const k=(0,I.$gc)(h);return F.$i?h.length>3?!1:o(k)&&(h.length===2||k.charCodeAt(2)===92):k===I.$fc.sep}e.$4f=n;function o(h,k=F.$i){return k?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$5f=o;function a(h,k=F.$i){return o(h,k)?h[0]:void 0}e.$6f=a;function t(h,k,D){return k.length>h.length?-1:h===k?0:(D&&(h=h.toLowerCase(),k=k.toLowerCase()),h.indexOf(k))}e.$7f=t;function r(h){const k=h.split(":");let D,$,b;for(const v of k){const C=Number(v);(0,L.$Ff)(C)?$===void 0?$=C:b===void 0&&(b=C):D=D?[D,v].join(":"):v}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:$!==void 0?$:void 0,column:b!==void 0?b:$!==void 0?1:void 0}}e.$8f=r;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(h,k,D=8){let $="";for(let v=0;v<D;v++){let C;v===0&&F.$i&&!k&&(D===3||D===4)?C=u:C=d,$+=C.charAt(Math.floor(Math.random()*C.length))}let b;return k?b=`${k}-${$}`:b=$,h?(0,I.$ic)(h,b):b}e.$9f=l}),define(ke[130],Se([1,0,129,124,52,16,12,13]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=void 0;const E=0,g=[E,[]];function A(W,V,de,ee){if(!W||!V)return g;const Z=W.length,J=V.length;if(Z<J)return g;const ae=W.toLowerCase();return P(V,de,J,W,ae,Z,ee)}e.$zq=A;function P(W,V,de,ee,Z,J,ae){const x=[],Ee=[];for(let ne=0;ne<de;ne++){const be=ne*J,G=be-J,Y=ne>0,X=W[ne],$e=V[ne];for(let re=0;re<J;re++){const fe=re>0,te=be+re,he=te-1,pe=G+re-1,Pe=fe?x[he]:0,B=Y&&fe?x[pe]:0,Q=Y&&fe?Ee[pe]:0;let se;!B&&Y?se=0:se=f(X,$e,ee,Z,re,Q),se&&B+se>=Pe&&(ae||Y||Z.startsWith(V,re))?(Ee[te]=Q+1,x[te]=B+se):(Ee[te]=E,x[te]=Pe)}}const le=[];let K=de-1,U=J-1;for(;K>=0&&U>=0;){const ne=K*J+U;Ee[ne]===E||(le.push(U),K--),U--}return[x[de*J-1],le.reverse()]}function f(W,V,de,ee,Z,J){let ae=0;if(!y(V,ee[Z]))return ae;if(ae+=1,J>0&&(ae+=J*5),W===de[Z]&&(ae+=1),Z===0)ae+=8;else{const x=S(de.charCodeAt(Z-1));x?ae+=x:(0,F.$Lj)(de.charCodeAt(Z))&&J===0&&(ae+=2)}return ae}function y(W,V){return W===V?!0:W==="/"||W==="\\"?V==="/"||V==="\\":!1}function S(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function c(W,V,de=0,ee=0){const Z=V;return Z.values&&Z.values.length>1?s(W,Z.values,de,ee):i(W,V,de,ee)}e.$Aq=c;function s(W,V,de,ee){let Z=0;const J=[];for(const ae of V){const[x,Ee]=i(W,ae,de,ee);if(typeof x!="number")return w;Z+=x,J.push(...Ee)}return[Z,D(J)]}function i(W,V,de,ee){const Z=(0,F.$Uj)(V.original,V.originalLowercase,de,W,W.toLowerCase(),ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,F.$Rj)(Z)]:w}const n=Object.freeze({score:0}),o=1<<18,a=1<<17,t=1<<16;function r(W,V,de,ee){const Z=ee.values?ee.values:[ee];return(0,m.$Ii)({[ee.normalized]:{values:Z.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:W,description:V,allowNonContiguousMatches:de}})}function d(W,V,de,ee,Z){if(!W||!V.normalized)return n;const J=ee.getItemLabel(W);if(!J)return n;const ae=ee.getItemDescription(W),x=r(J,ae,de,V),Ee=Z[x];if(Ee)return Ee;const le=u(J,ae,ee.getItemPath(W),V,de);return Z[x]=le,le}e.$Bq=d;function u(W,V,de,ee,Z){const J=!de||!ee.containsPathSeparator;return de&&(R.$k?ee.pathNormalized===de:(0,p.$5e)(ee.pathNormalized,de))?{score:o,labelMatch:[{start:0,end:W.length}],descriptionMatch:V?[{start:0,end:V.length}]:void 0}:ee.values&&ee.values.length>1?l(W,V,de,ee.values,J,Z):h(W,V,de,ee,J,Z)}function l(W,V,de,ee,Z,J){let ae=0;const x=[],Ee=[];for(const le of ee){const{score:K,labelMatch:U,descriptionMatch:ne}=h(W,V,de,le,Z,J);if(K===E)return n;ae+=K,U&&x.push(...U),ne&&Ee.push(...ne)}return{score:ae,labelMatch:D(x),descriptionMatch:D(Ee)}}function h(W,V,de,ee,Z,J){if(Z||!V){const[ae,x]=A(W,ee.normalized,ee.normalizedLowercase,J&&!ee.expectContiguousMatch);if(ae){const Ee=(0,F.$Ij)(ee.normalized,W);let le;if(Ee){le=a;const K=Math.round(ee.normalized.length/W.length*100);le+=K}else le=t;return{score:le+ae,labelMatch:Ee||k(x)}}}if(V){let ae=V;de&&(ae=`${V}${L.sep}`);const x=ae.length,Ee=`${ae}${W}`,[le,K]=A(Ee,ee.normalized,ee.normalizedLowercase,J&&!ee.expectContiguousMatch);if(le){const U=k(K),ne=[],be=[];return U.forEach(G=>{G.start<x&&G.end>x?(ne.push({start:0,end:G.end-x}),be.push({start:G.start,end:x})):G.start>=x?ne.push({start:G.start-x,end:G.end-x}):be.push(G)}),{score:le,labelMatch:ne,descriptionMatch:be}}}return n}function k(W){const V=[];if(!W)return V;let de;for(const ee of W)de&&de.end===ee?de.end+=1:(de={start:ee,end:ee+1},V.push(de));return V}function D(W){const V=W.sort((Z,J)=>Z.start-J.start),de=[];let ee;for(const Z of V)!ee||!$(ee,Z)?(ee=Z,de.push(Z)):(ee.start=Math.min(ee.start,Z.start),ee.end=Math.max(ee.end,Z.end));return de}function $(W,V){return!(W.end<V.start||V.end<W.start)}function b(W,V,de,ee,Z,J){const ae=d(W,de,ee,Z,J),x=d(V,de,ee,Z,J),Ee=ae.score,le=x.score;if((Ee===o||le===o)&&Ee!==le)return Ee===o?-1:1;if(Ee>t||le>t){if(Ee!==le)return Ee>le?-1:1;if(Ee<a&&le<a){const X=C(ae.labelMatch,x.labelMatch);if(X!==0)return X}const G=Z.getItemLabel(W)||"",Y=Z.getItemLabel(V)||"";if(G.length!==Y.length)return G.length-Y.length}if(Ee!==le)return Ee>le?-1:1;const K=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,U=Array.isArray(x.labelMatch)&&x.labelMatch.length>0;if(K&&!U)return-1;if(U&&!K)return 1;const ne=v(W,ae,Z),be=v(V,x,Z);return ne&&be&&ne!==be?be>ne?-1:1:N(W,V,de,Z)}e.$Cq=b;function v(W,V,de){let ee=-1,Z=-1;if(V.descriptionMatch&&V.descriptionMatch.length?ee=V.descriptionMatch[0].start:V.labelMatch&&V.labelMatch.length&&(ee=V.labelMatch[0].start),V.labelMatch&&V.labelMatch.length){if(Z=V.labelMatch[V.labelMatch.length-1].end,V.descriptionMatch&&V.descriptionMatch.length){const J=de.getItemDescription(W);J&&(Z+=J.length)}}else V.descriptionMatch&&V.descriptionMatch.length&&(Z=V.descriptionMatch[V.descriptionMatch.length-1].end);return Z-ee}function C(W,V){if(!W&&!V||(!W||!W.length)&&(!V||!V.length))return 0;if(!V||!V.length)return-1;if(!W||!W.length)return 1;const de=W[0].start,Z=W[W.length-1].end-de,J=V[0].start,x=V[V.length-1].end-J;return Z===x?0:x<Z?1:-1}function N(W,V,de,ee){const Z=ee.getItemLabel(W)||"",J=ee.getItemLabel(V)||"",ae=ee.getItemDescription(W),x=ee.getItemDescription(V),Ee=Z.length+(ae?ae.length:0),le=J.length+(x?x.length:0);if(Ee!==le)return Ee-le;const K=ee.getItemPath(W),U=ee.getItemPath(V);return K&&U&&K.length!==U.length?K.length-U.length:Z!==J?(0,I.$xq)(Z,J,de.normalized):ae&&x&&ae!==x?(0,I.$xq)(ae,x,de.normalized):K&&U&&K!==U?(0,I.$xq)(K,U,de.normalized):0}function j(W){return W.startsWith('"')&&W.endsWith('"')}const M=" ";function O(W){typeof W!="string"&&(W="");const V=W.toLowerCase(),{pathNormalized:de,normalized:ee,normalizedLowercase:Z}=z(W),J=de.indexOf(L.sep)>=0,ae=j(W);let x;const Ee=W.split(M);if(Ee.length>1)for(const le of Ee){const K=j(le),{pathNormalized:U,normalized:ne,normalizedLowercase:be}=z(le);ne&&(x||(x=[]),x.push({original:le,originalLowercase:le.toLowerCase(),pathNormalized:U,normalized:ne,normalizedLowercase:be,expectContiguousMatch:K}))}return{original:W,originalLowercase:V,pathNormalized:de,normalized:ee,normalizedLowercase:Z,values:x,containsPathSeparator:J,expectContiguousMatch:ae}}e.$Dq=O;function z(W){let V;R.$i?V=W.replace(/\//g,L.sep):V=W.replace(/\\/g,L.sep);const de=(0,p.$Pe)(V).replace(/\s|"/g,"");return{pathNormalized:V,normalized:de,normalizedLowercase:de.toLowerCase()}}function T(W){return Array.isArray(W)?O(W.map(V=>V.original).join(M)):O(W.original)}e.$Eq=T}),define(ke[100],Se([1,0,16]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},m={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const P=(0,I.$nc)(A),f=F[P.toLowerCase()];return f!==void 0?f:R(A)}e.$Wr=L;function R(A){const P=(0,I.$nc)(A);return m[P.toLowerCase()]}e.$Xr=R;function p(A){for(const P in m)if(m[P]===A)return P}e.$Yr=p;const E=/^(.+)\/(.+?)(;.+)?$/;function g(A,P){const f=E.exec(A);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:P?void 0:A}e.$Zr=g}),define(ke[101],Se([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.TerminateResponseCode=e.Source=void 0;var F;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(F||(e.Source=F={}));var m;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(m||(e.TerminateResponseCode=m={}));function L(p,...E){const g=E.reduce((f,y)=>(f[y]=!0,f),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(f=>!g[f]).forEach(f=>{for(let y=0;y<A.length;y++)if(f.search(A[y])!==-1){delete p[f];break}})}e.$El=L;function R(p){p&&(delete p.DEBUG,I.$j&&delete p.DYLD_LIBRARY_PATH,I.$k&&delete p.LD_PRELOAD)}e.$Fl=R}),define(ke[2],Se([1,0,16,12]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const m=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function p(u,l){if(!u.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!m.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!L.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(u,l){return!u&&!l?"file":u}function g(u,l){switch(u){case"https":case"http":case"file":l?l[0]!==P&&(l=P+l):l=P;break}return l}const A="",P="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{static isUri(l){return l instanceof y?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,h,k,D,$,b=!1){typeof l=="object"?(this.scheme=l.scheme||A,this.authority=l.authority||A,this.path=l.path||A,this.query=l.query||A,this.fragment=l.fragment||A):(this.scheme=E(l,b),this.authority=h||A,this.path=g(this.scheme,k||A),this.query=D||A,this.fragment=$||A,p(this,b))}get fsPath(){return o(this,!1)}with(l){if(!l)return this;let{scheme:h,authority:k,path:D,query:$,fragment:b}=l;return h===void 0?h=this.scheme:h===null&&(h=A),k===void 0?k=this.authority:k===null&&(k=A),D===void 0?D=this.path:D===null&&(D=A),$===void 0?$=this.query:$===null&&($=A),b===void 0?b=this.fragment:b===null&&(b=A),h===this.scheme&&k===this.authority&&D===this.path&&$===this.query&&b===this.fragment?this:new c(h,k,D,$,b)}static parse(l,h=!1){const k=f.exec(l);return k?new c(k[2]||A,d(k[4]||A),d(k[5]||A),d(k[7]||A),d(k[9]||A),h):new c(A,A,A,A,A)}static file(l){let h=A;if(F.$i&&(l=l.replace(/\\/g,P)),l[0]===P&&l[1]===P){const k=l.indexOf(P,2);k===-1?(h=l.substring(2),l=P):(h=l.substring(2,k),l=l.substring(k)||P)}return new c("file",h,l,A,A)}static from(l,h){return new c(l.scheme,l.authority,l.path,l.query,l.fragment,h)}static joinPath(l,...h){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return F.$i&&l.scheme==="file"?k=y.file(I.$ec.join(o(l,!0),...h)).path:k=I.$fc.join(l.path,...h),l.with({path:k})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof y)return l;{const h=new c(l);return h._formatted=l.external??null,h._fsPath=l._sep===w?l.fsPath??null:null,h}}else return l}}e.URI=y;function S(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}e.$uc=S;const w=F.$i?1:void 0;class c extends y{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=w),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(u,l,h){let k,D=-1;for(let $=0;$<u.length;$++){const b=u.charCodeAt($);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||l&&b===47||h&&b===91||h&&b===93||h&&b===58)D!==-1&&(k+=encodeURIComponent(u.substring(D,$)),D=-1),k!==void 0&&(k+=u.charAt($));else{k===void 0&&(k=u.substr(0,$));const v=s[b];v!==void 0?(D!==-1&&(k+=encodeURIComponent(u.substring(D,$)),D=-1),k+=v):D===-1&&(D=$)}}return D!==-1&&(k+=encodeURIComponent(u.substring(D))),k!==void 0?k:u}function n(u){let l;for(let h=0;h<u.length;h++){const k=u.charCodeAt(h);k===35||k===63?(l===void 0&&(l=u.substr(0,h)),l+=s[k]):l!==void 0&&(l+=u[h])}return l!==void 0?l:u}function o(u,l){let h;return u.authority&&u.path.length>1&&u.scheme==="file"?h=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?l?h=u.path.substr(1):h=u.path[1].toLowerCase()+u.path.substr(2):h=u.path,F.$i&&(h=h.replace(/\//g,"\\")),h}e.$vc=o;function a(u,l){const h=l?n:i;let k="",{scheme:D,authority:$,path:b,query:v,fragment:C}=u;if(D&&(k+=D,k+=":"),($||D==="file")&&(k+=P,k+=P),$){let N=$.indexOf("@");if(N!==-1){const j=$.substr(0,N);$=$.substr(N+1),N=j.lastIndexOf(":"),N===-1?k+=h(j,!1,!1):(k+=h(j.substr(0,N),!1,!1),k+=":",k+=h(j.substr(N+1),!1,!0)),k+="@"}$=$.toLowerCase(),N=$.lastIndexOf(":"),N===-1?k+=h($,!1,!0):(k+=h($.substr(0,N),!1,!0),k+=$.substr(N))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const N=b.charCodeAt(1);N>=65&&N<=90&&(b=`/${String.fromCharCode(N+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const N=b.charCodeAt(0);N>=65&&N<=90&&(b=`${String.fromCharCode(N+32)}:${b.substr(2)}`)}k+=h(b,!0,!1)}return v&&(k+="?",k+=h(v,!1,!1)),C&&(k+="#",k+=l?C:i(C,!1,!1)),k}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(u){return u.match(r)?u.replace(r,l=>t(l)):u}}),define(ke[185],Se([1,0,2]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$5p=e.$4p=e.$3p=void 0;function F(g){const A=g;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$3p=F;function m(g){const A=[];let P;try{const f=JSON.parse(g.arguments),y=f[f.length-1];y&&y.__$stack&&(f.pop(),P=y.__$stack),A.push(...f)}catch{A.push("Unable to log remote console arguments",g.arguments)}return{args:A,stack:P}}e.$4p=m;function L(g){if(typeof g!="string")return L(m(g).stack);const A=g;if(A){const P=R(A),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(f&&f.length===4)return{uri:I.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.$5p=L;function R(g){if(!g)return g;const A=g.indexOf(`
`);return A===-1?g:g.substring(0,A)}function p(g,A){const{args:P,stack:f}=m(g),y=typeof P[0]=="string"&&P.length===1;let S=R(f);S&&(S=`(${S.trim()})`);let w=[];if(typeof P[0]=="string"?S&&y?w=[`%c[${A}] %c${P[0]} %c${S}`,E("blue"),E(""),E("grey")]:w=[`%c[${A}] %c${P[0]}`,E("blue"),E(""),...P.slice(1)]:w=[`%c[${A}]%`,E("blue"),...P],S&&!y&&w.push(S),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,w)}e.log=p;function E(g){return`color: ${g}`}}),define(ke[54],Se([1,0,22,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=void 0;function m(E){return JSON.stringify(E,R)}e.$ph=m;function L(E){let g=JSON.parse(E);return g=p(g),g}e.$qh=L;function R(E,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function p(E,g=0){if(!E||g>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return F.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof I.$ee||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let A=0;A<E.length;++A)E[A]=p(E[A],g+1);else for(const A in E)Object.hasOwnProperty.call(E,A)&&(E[A]=p(E[A],g+1))}return E}e.$rh=p}),define(ke[17],Se([1,0,11,12,2]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.Schemas=void 0;var L;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$0f="vscode-tkn",e.$$f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${L.vscodeRemoteResource}`}set(A,P,f){this.a[A]=P,this.b[A]=f}setConnectionToken(A,P){this.c[A]=P}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(c){return I.$Z(c),A}const P=A.authority;let f=this.a[P];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const y=this.b[P],S=this.c[P];let w=`path=${encodeURIComponent(A.path)}`;return typeof S=="string"&&(w+=`&${e.$$f}=${encodeURIComponent(S)}`),m.URI.from({scheme:F.$o?this.d:L.vscodeRemoteResource,authority:`${f}:${y}`,path:this.f,query:w})}}e.$_f=new R,e.$ag="vs/../../extensions",e.$bg="vs/../../node_modules",e.$cg="vs/../../node_modules.asar",e.$dg="vs/../../node_modules.asar.unpacked",e.$eg="vscode-app";class p{static{this.a=e.$eg}asBrowserUri(A){const P=this.b(A,me);return this.uriToBrowserUri(P)}uriToBrowserUri(A){return A.scheme===L.vscodeRemote?e.$_f.rewrite(A):A.scheme===L.file&&(F.$m||F.$q===`${L.vscodeFileResource}://${p.a}`)?A.with({scheme:L.vscodeFileResource,authority:A.authority||p.a,query:null,fragment:null}):A}asFileUri(A){const P=this.b(A,me);return this.uriToFileUri(P)}uriToFileUri(A){return A.scheme===L.vscodeFileResource?A.with({scheme:L.file,authority:A.authority!==p.a?A.authority:null,query:null,fragment:null}):A}b(A,P){return m.URI.isUri(A)?A:m.URI.parse(P.toUrl(A))}}e.$fg=new p;var E;(function(g){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(A.get("3"));const P="vscode-coi";function f(S){let w;typeof S=="string"?w=new URL(S).searchParams:S instanceof URL?w=S.searchParams:m.URI.isUri(S)&&(w=new URL(S.toString(!0)).searchParams);const c=w?.get(P);if(c)return A.get(c)}g.getHeadersFromQuery=f;function y(S,w,c){if(!globalThis.crossOriginIsolated)return;const s=w&&c?"3":c?"2":"1";S instanceof URLSearchParams?S.set(P,s):S[P]=s}g.addSearchParam=y})(E||(e.COI=E={}))}),define(ke[186],Se([1,0,159,17,12,2]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=void 0;class R{constructor(f,y,S){this.id=f,this.dependencies=y,this.callback=S}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,y,S)=>{typeof f!="string"&&(S=y,y=f,f=null),(typeof y!="object"||!Array.isArray(y))&&(S=y,y=null),this.c.push(new R(f,y,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const y=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!y)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(f){return new Promise((y,S)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const c=()=>{w.removeEventListener("load",s),w.removeEventListener("error",i)},s=n=>{c(),y(this.c.pop())},i=n=>{c(),S(n)};w.addEventListener("load",s),w.addEventListener("error",i),this.f&&(f=this.f.createScriptURL(f)),w.setAttribute("src",f),window.document.getElementsByTagName("head")[0].appendChild(w)})}i(f){return new Promise((y,S)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),y(this.c.pop())}catch(w){S(w)}})}async j(f){try{const y=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,c=L.URI.parse(f).fsPath,s=y.readFileSync(c).toString(),i=w.wrap(s.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const E=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function A(P,f,y){if(I.$S){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[P]&&(P=g[P]);const S=`${P}/${f}`;if(E.has(S))return E.get(S);let w;if(/^\w[\w\d+.-]*:\/\//.test(S))w=S;else{const n=`${y&&!m.$o?F.$cg:F.$bg}/${S}`;w=F.$fg.asBrowserUri(n).toString(!0)}const c=p.INSTANCE.load(w);return E.set(S,c),c}else return await new Promise((S,w)=>{me([P],S,w)})}e.$NC=A}),define(ke[23],Se([1,0,33,17,16,12,13,2]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ig=e.DataUri=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=void 0;function E(y){return(0,p.$vc)(y,!0)}e.$mg=E;class g{constructor(S){this.a=S}compare(S,w,c=!1){return S===w?0:(0,R.$Xe)(this.getComparisonKey(S,c),this.getComparisonKey(w,c))}isEqual(S,w,c=!1){return S===w?!0:!S||!w?!1:this.getComparisonKey(S,c)===this.getComparisonKey(w,c)}getComparisonKey(S,w=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,w,c=!1){if(S.scheme===w.scheme){if(S.scheme===F.Schemas.file)return I.$1f(E(S),E(w),this.a(S))&&S.query===w.query&&(c||S.fragment===w.fragment);if((0,e.$Dg)(S.authority,w.authority))return I.$1f(S.path,w.path,this.a(S),"/")&&S.query===w.query&&(c||S.fragment===w.fragment)}return!1}joinPath(S,...w){return p.URI.joinPath(S,...w)}basenameOrAuthority(S){return(0,e.$vg)(S)||S.authority}basename(S){return m.$fc.basename(S.path)}extname(S){return m.$fc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let w;return S.scheme===F.Schemas.file?w=p.URI.file(m.$lc(E(S))).path:(w=m.$fc.dirname(S.path),S.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),w="/")),S.with({path:w})}normalizePath(S){if(!S.path.length)return S;let w;return S.scheme===F.Schemas.file?w=p.URI.file(m.$gc(E(S))).path:w=m.$fc.normalize(S.path),S.with({path:w})}relativePath(S,w){if(S.scheme!==w.scheme||!(0,e.$Dg)(S.authority,w.authority))return;if(S.scheme===F.Schemas.file){const i=m.$kc(E(S),E(w));return L.$i?I.$Uf(i):i}let c=S.path||"/";const s=w.path||"/";if(this.a(S)){let i=0;for(const n=Math.min(c.length,s.length);i<n&&!(c.charCodeAt(i)!==s.charCodeAt(i)&&c.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);c=s.substr(0,i)+c.substr(i)}return m.$fc.relative(c,s)}resolvePath(S,w){if(S.scheme===F.Schemas.file){const c=p.URI.file(m.$jc(E(S),w));return S.with({authority:c.authority,path:c.path})}return w=I.$Vf(w),S.with({path:m.$fc.resolve(S.path,w)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,w){return S===w||S!==void 0&&w!==void 0&&(0,R.$5e)(S,w)}hasTrailingPathSeparator(S,w=m.sep){if(S.scheme===F.Schemas.file){const c=E(S);return c.length>I.$Wf(c).length&&c[c.length-1]===w}else{const c=S.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,w=m.sep){return(0,e.$Eg)(S,w)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,w=m.sep){let c=!1;if(S.scheme===F.Schemas.file){const s=E(S);c=s!==void 0&&s.length===I.$Wf(s).length&&s[s.length-1]===w}else{w="/";const s=S.path;c=s.length===1&&s.charCodeAt(s.length-1)===47}return!c&&!(0,e.$Eg)(S,w)?S.with({path:S.path+"/"}):S}}e.$ng=g,e.$og=new g(()=>!1),e.$pg=new g(y=>y.scheme===F.Schemas.file?!L.$k:!0),e.$qg=new g(y=>!0),e.$rg=e.$og.isEqual.bind(e.$og),e.$sg=e.$og.isEqualOrParent.bind(e.$og),e.$tg=e.$og.getComparisonKey.bind(e.$og),e.$ug=e.$og.basenameOrAuthority.bind(e.$og),e.$vg=e.$og.basename.bind(e.$og),e.$wg=e.$og.extname.bind(e.$og),e.$xg=e.$og.dirname.bind(e.$og),e.$yg=e.$og.joinPath.bind(e.$og),e.$zg=e.$og.normalizePath.bind(e.$og),e.$Ag=e.$og.relativePath.bind(e.$og),e.$Bg=e.$og.resolvePath.bind(e.$og),e.$Cg=e.$og.isAbsolutePath.bind(e.$og),e.$Dg=e.$og.isEqualAuthority.bind(e.$og),e.$Eg=e.$og.hasTrailingPathSeparator.bind(e.$og),e.$Fg=e.$og.removeTrailingPathSeparator.bind(e.$og),e.$Gg=e.$og.addTrailingPathSeparator.bind(e.$og);function A(y,S){const w=[];for(let c=0;c<y.length;c++){const s=S(y[c]);y.some((i,n)=>n===c?!1:(0,e.$sg)(s,S(i)))||w.push(y[c])}return w}e.$Hg=A;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function S(w){const c=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,a]=n.split(":");o&&a&&c.set(o,a)});const i=w.path.substring(0,w.path.indexOf(";"));return i&&c.set(y.META_DATA_MIME,i),c}y.parseMetaData=S})(P||(e.DataUri=P={}));function f(y,S,w){if(S){let c=y.path;return c&&c[0]!==m.$fc.sep&&(c=m.$fc.sep+c),y.with({scheme:w,authority:S,path:c})}return y.with({scheme:w})}e.$Ig=f}),define(ke[10],Se([1,0,21,11,4,3,23,12,163]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.Promises=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0;function g(be){return!!be&&typeof be.then=="function"}e.$Jg=g;function A(be){const G=new I.$1d,Y=be(G.token),X=new Promise(($e,re)=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),G.dispose(),re(new F.$4)});Promise.resolve(Y).then(te=>{fe.dispose(),G.dispose(),$e(te)},te=>{fe.dispose(),G.dispose(),re(te)})});return new class{cancel(){G.cancel()}then($e,re){return X.then($e,re)}catch($e){return this.then(void 0,$e)}finally($e){return X.finally($e)}}}e.$Kg=A;function P(be,G,Y){return new Promise((X,$e)=>{const re=G.onCancellationRequested(()=>{re.dispose(),X(Y)});be.then(X,$e).finally(()=>re.dispose())})}e.$Lg=P;function f(be,G){return new Promise((Y,X)=>{const $e=G.onCancellationRequested(()=>{$e.dispose(),X(new F.$4)});be.then(Y,X).finally(()=>$e.dispose())})}e.$Mg=f;async function y(be){let G=-1;const Y=be.map((X,$e)=>X.then(re=>(G=$e,re)));try{return await Promise.race(Y)}finally{be.forEach((X,$e)=>{$e!==G&&X.cancel()})}}e.$Ng=y;function S(be,G,Y){let X;const $e=setTimeout(()=>{X?.(void 0),Y?.()},G);return Promise.race([be.finally(()=>clearTimeout($e)),new Promise(re=>X=re)])}e.$Og=S;function w(be){return new Promise((G,Y)=>{const X=be();g(X)?X.then(G,Y):G(X)})}e.$Pg=w;class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const Y=()=>{if(this.b=null,this.f)return;const X=this.queue(this.d);return this.d=null,X};this.b=new Promise(X=>{this.a.then(Y,Y).then(X)})}return new Promise((Y,X)=>{this.b.then(Y,X)})}return this.a=G(),new Promise((Y,X)=>{this.a.then($e=>{this.a=null,Y($e)},$e=>{this.a=null,X($e)})})}dispose(){this.f=!0}}e.$Qg=c;class s{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$Rg=s;class i{constructor(){this.a=new Map}queue(G,Y){const $e=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(G)===$e&&this.a.delete(G)});return this.a.set(G,$e),$e}}e.$Sg=i;const n=(be,G)=>{let Y=!0;const X=setTimeout(()=>{Y=!1,G()},be);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(X),Y=!1}}},o=be=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,be())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class a{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,Y=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise(($e,re)=>{this.d=$e,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const X=()=>{this.a=null,this.d?.(null)};return this.a=Y===E.$Nd?o(X):n(Y,X),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Tg=a;class t{constructor(G){this.a=new a(G),this.b=new c}trigger(G,Y){return this.a.trigger(()=>this.b.queue(G),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ug=t;class r{constructor(){this.a=!1,this.b=new Promise((G,Y)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Vg=r;class d extends r{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$Wg=d;function u(be,G){return G?new Promise((Y,X)=>{const $e=setTimeout(()=>{re.dispose(),Y()},be),re=G.onCancellationRequested(()=>{clearTimeout($e),re.dispose(),X(new F.$4)})}):A(Y=>u(be,Y))}e.$Xg=u;function l(be,G=0,Y){const X=setTimeout(()=>{be(),Y&&$e.dispose()},G),$e=(0,L.$Pc)(()=>{clearTimeout(X),Y?.deleteAndLeak($e)});return Y?.add($e),$e}e.$Yg=l;function h(be){const G=[];let Y=0;const X=be.length;function $e(){return Y<X?be[Y++]():null}function re(fe){fe!=null&&G.push(fe);const te=$e();return te?te.then(re):Promise.resolve(G)}return Promise.resolve(null).then(re)}e.$Zg=h;function k(be,G=X=>!!X,Y=null){let X=0;const $e=be.length,re=()=>{if(X>=$e)return Promise.resolve(Y);const fe=be[X++];return Promise.resolve(fe()).then(he=>G(he)?Promise.resolve(he):re())};return re()}e.$1g=k;function D(be,G=X=>!!X,Y=null){if(be.length===0)return Promise.resolve(Y);let X=be.length;const $e=()=>{X=-1;for(const re of be)re.cancel?.()};return new Promise((re,fe)=>{for(const te of be)te.then(he=>{--X>=0&&G(he)?($e(),re(he)):X===0&&re(Y)}).catch(he=>{--X>=0&&($e(),fe(he))})})}e.$2g=D;class ${constructor(G){this.a=0,this.d=G,this.f=[],this.b=0,this.g=new m.$Qd}get onDrained(){return this.g.event}get size(){return this.a}queue(G){return this.a++,new Promise((Y,X)=>{this.f.push({factory:G,c:Y,e:X}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const G=this.f.shift();this.b++;const Y=G.factory();Y.then(G.c,G.e),Y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$3g=$;class b extends ${constructor(){super(1)}}e.$4g=b;class v{constructor(){this.a=new ee,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$5g=v;class C{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new ae;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueFor(G,Y=R.$og){const X=Y.getComparisonKey(G);let $e=this.a.get(X);if(!$e){$e=new b;const re=this.f++,fe=m.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(X),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$Zc),this.d.set(re,fe),this.a.set(X,$e)}return $e}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$6g=C;class N{constructor(G,Y){this.a=-1,typeof G=="function"&&typeof Y=="number"&&this.setIfNotSet(G,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},Y)}setIfNotSet(G,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},Y))}}e.$7g=N;class j{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,Y,X=globalThis){this.cancel();const $e=X.setInterval(()=>{G()},Y);this.d=(0,L.$Pc)(()=>{X.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$8g=j;class M{constructor(G,Y){this.b=-1,this.a=G,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$9g=M;class O{constructor(G,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=G,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$0g=O;class z extends M{constructor(G,Y){super(G,Y),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$$g=z;class T extends L.$Rc{constructor(G,Y){super(),this.g=G,this.h=Y,this.a=[],this.b=this.B(new L.$Sc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of G)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$_g=T,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$bh=(be,G)=>{(0,p.$B)(()=>{if(Y)return;const X=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,X-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$bh=(be,G,Y)=>{const X=be.requestIdleCallback(G,typeof Y=="number"?{timeout:Y}:void 0);let $e=!1;return{dispose(){$e||($e=!0,be.cancelIdleCallback(X))}}},e.$ah=be=>(0,e.$bh)(globalThis,be)}();class W{constructor(G,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(X){this.l=X}finally{this.g=!0}},this.f=(0,e.$bh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$ch=W;class V extends W{constructor(G){super(globalThis,G)}}e.$dh=V;async function de(be,G,Y){let X;for(let $e=0;$e<Y;$e++)try{return await be()}catch(re){X=re,await u(G)}throw X}e.$eh=de;class ee{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,Y,X){return this.a={taskId:G,cancel:()=>X?.(),promise:Y},Y.then(()=>this.d(G),()=>this.d(G)),Y}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{let Y,X;const $e=new Promise((re,fe)=>{Y=re,X=fe});this.b={run:G,promise:$e,promiseResolve:Y,promiseReject:X}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$fh=ee;class Z{constructor(G,Y=()=>Date.now()){this.d=G,this.f=Y,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$gh=Z;var J;(function(be){be[be.Resolved=0]="Resolved",be[be.Rejected=1]="Rejected"})(J||(J={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,Y)=>{this.a=G,this.b=Y})}complete(G){return new Promise(Y=>{this.a(G),this.d={outcome:0,value:G},Y()})}error(G){return new Promise(Y=>{this.b(G),this.d={outcome:1,value:G},Y()})}cancel(){return this.error(new F.$4)}}e.$hh=ae;var x;(function(be){async function G(X){let $e;const re=await Promise.all(X.map(fe=>fe.then(te=>te,te=>{$e||($e=te)})));if(typeof $e<"u")throw $e;return re}be.settled=G;function Y(X){return new Promise(async($e,re)=>{try{await X($e,re)}catch(fe){re(fe)}})}be.withAsyncBody=Y})(x||(e.Promises=x={}));var Ee;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(Ee||(Ee={}));class le{static fromArray(G){return new le(Y=>{Y.emitMany(G)})}static fromPromise(G){return new le(async Y=>{Y.emitMany(await G)})}static fromPromises(G){return new le(async Y=>{await Promise.all(G.map(async X=>Y.emitOne(await X)))})}static merge(G){return new le(async Y=>{await Promise.all(G.map(async X=>{for await(const $e of X)Y.emitOne($e)}))})}static{this.EMPTY=le.fromArray([])}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new m.$Qd,queueMicrotask(async()=>{const Y={emitOne:X=>this.g(X),emitMany:X=>this.h(X),reject:X=>this.k(X)};try{await Promise.resolve(G(Y)),this.j()}catch(X){this.k(X)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await m.Event.toPromise(this.f.event)}while(!0)}}}static map(G,Y){return new le(async X=>{for await(const $e of G)X.emitOne(Y($e))})}map(G){return le.map(this,G)}static filter(G,Y){return new le(async X=>{for await(const $e of G)Y($e)&&X.emitOne($e)})}filter(G){return le.filter(this,G)}static coalesce(G){return le.filter(G,Y=>!!Y)}coalesce(){return le.coalesce(this)}static async toPromise(G){const Y=[];for await(const X of G)Y.push(X);return Y}toPromise(){return le.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.$ih=le;class K extends le{constructor(G,Y){super(Y),this.l=G}cancel(){this.l.cancel()}}e.$jh=K;function U(be){const G=new I.$1d,Y=be(G.token);return new K(G,async X=>{const $e=G.token.onCancellationRequested(()=>{$e.dispose(),G.dispose(),X.reject(new F.$4)});try{for await(const re of Y){if(G.token.isCancellationRequested)return;X.emitOne(re)}$e.dispose(),G.dispose()}catch(re){$e.dispose(),G.dispose(),X.reject(re)}})}e.$kh=U;class ne{constructor(){this.a=new ae,this.b=new le(X=>{if(G){X.reject(G);return}return Y&&X.emitMany(Y),this.d=$e=>X.reject($e),this.f=$e=>X.emitOne($e),this.a.p});let G,Y;this.f=X=>{Y||(Y=[]),Y.push(X)},this.d=X=>{G||(G=X)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$lh=ne}),define(ke[34],Se([1,0,19,10,33,28,16,12,13]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=void 0;function g(){return Object.create(null)}e.$wj=g,e.$xj="**",e.$yj="/";const A="[/\\\\]",P="[^/\\\\]",f=/\//g;function y(de,ee){switch(de){case 0:return"";case 1:return`${P}*?`;default:return`(?:${A}|${P}+${A}${ee?`|${A}${P}+`:""})*?`}}function S(de,ee){if(!de)return[];const Z=[];let J=!1,ae=!1,x="";for(const Ee of de){switch(Ee){case ee:if(!J&&!ae){Z.push(x),x="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}x+=Ee}return x&&Z.push(x),Z}e.$zj=S;function w(de){if(!de)return"";let ee="";const Z=S(de,e.$yj);if(Z.every(J=>J===e.$xj))ee=".*";else{let J=!1;Z.forEach((ae,x)=>{if(ae===e.$xj){if(J)return;ee+=y(2,x===Z.length-1)}else{let Ee=!1,le="",K=!1,U="";for(const ne of ae){if(ne!=="}"&&Ee){le+=ne;continue}if(K&&(ne!=="]"||!U)){let be;ne==="-"?be=ne:(ne==="^"||ne==="!")&&!U?be="^":ne===e.$yj?be="":be=(0,E.$Ie)(ne),U+=be;continue}switch(ne){case"{":Ee=!0;continue;case"[":K=!0;continue;case"}":{const G=`(?:${S(le,",").map(Y=>w(Y)).join("|")})`;ee+=G,Ee=!1,le="";break}case"]":{ee+="["+U+"]",K=!1,U="";break}case"?":ee+=P;continue;case"*":ee+=y(1);continue;default:ee+=(0,E.$Ie)(ne)}}x<Z.length-1&&(Z[x+1]!==e.$xj||x+2<Z.length)&&(ee+=A)}J=ae===e.$xj})}return ee}const c=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Cc(1e4),r=function(){return!1},d=function(){return null};function u(de,ee){if(!de)return d;let Z;typeof de!="string"?Z=de.pattern:Z=de,Z=Z.trim();const J=`${Z}_${!!ee.trimForExclusions}`;let ae=t.get(J);if(ae)return l(ae,de);let x;return c.test(Z)?ae=k(Z.substr(4),Z):(x=s.exec(h(Z,ee)))?ae=D(x[1],Z):(ee.trimForExclusions?n:i).test(Z)?ae=$(Z,ee):(x=o.exec(h(Z,ee)))?ae=b(x[1].substr(1),Z,!0):(x=a.exec(h(Z,ee)))?ae=b(x[1],Z,!1):ae=v(Z),t.set(J,ae),l(ae,de)}function l(de,ee){if(typeof ee=="string")return de;const Z=function(J,ae){return(0,m.$1f)(J,ee.base,!p.$k)?de((0,E.$Me)(J.substr(ee.base.length),R.sep),ae):null};return Z.allBasenames=de.allBasenames,Z.allPaths=de.allPaths,Z.basenames=de.basenames,Z.patterns=de.patterns,Z}function h(de,ee){return ee.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function k(de,ee){return function(Z,J){return typeof Z=="string"&&Z.endsWith(de)?ee:null}}function D(de,ee){const Z=`/${de}`,J=`\\${de}`,ae=function(Ee,le){return typeof Ee!="string"?null:le?le===de?ee:null:Ee===de||Ee.endsWith(Z)||Ee.endsWith(J)?ee:null},x=[de];return ae.basenames=x,ae.patterns=[ee],ae.allBasenames=x,ae}function $(de,ee){const Z=W(de.slice(1,-1).split(",").map(le=>u(le,ee)).filter(le=>le!==d),de),J=Z.length;if(!J)return d;if(J===1)return Z[0];const ae=function(le,K){for(let U=0,ne=Z.length;U<ne;U++)if(Z[U](le,K))return de;return null},x=Z.find(le=>!!le.allBasenames);x&&(ae.allBasenames=x.allBasenames);const Ee=Z.reduce((le,K)=>K.allPaths?le.concat(K.allPaths):le,[]);return Ee.length&&(ae.allPaths=Ee),ae}function b(de,ee,Z){const J=R.sep===R.$fc.sep,ae=J?de:de.replace(f,R.sep),x=R.sep+ae,Ee=R.$fc.sep+de;let le;return Z?le=function(K,U){return typeof K=="string"&&(K===ae||K.endsWith(x)||!J&&(K===de||K.endsWith(Ee)))?ee:null}:le=function(K,U){return typeof K=="string"&&(K===ae||!J&&K===de)?ee:null},le.allPaths=[(Z?"*/":"./")+de],le}function v(de){try{const ee=new RegExp(`^${w(de)}$`);return function(Z){return ee.lastIndex=0,typeof Z=="string"&&ee.test(Z)?de:null}}catch{return d}}function C(de,ee,Z){return!de||typeof ee!="string"?!1:N(de)(ee,void 0,Z)}e.$Aj=C;function N(de,ee={}){if(!de)return r;if(typeof de=="string"||j(de)){const Z=u(de,ee);if(Z===d)return r;const J=function(ae,x){return!!Z(ae,x)};return Z.allBasenames&&(J.allBasenames=Z.allBasenames),Z.allPaths&&(J.allPaths=Z.allPaths),J}return z(de,ee)}e.$Bj=N;function j(de){const ee=de;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.$Cj=j;function M(de){return de.allBasenames||[]}e.$Dj=M;function O(de){return de.allPaths||[]}e.$Ej=O;function z(de,ee){const Z=W(Object.getOwnPropertyNames(de).map(le=>T(le,de[le],ee)).filter(le=>le!==d)),J=Z.length;if(!J)return d;if(!Z.some(le=>!!le.requiresSiblings)){if(J===1)return Z[0];const le=function(ne,be){let G;for(let Y=0,X=Z.length;Y<X;Y++){const $e=Z[Y](ne,be);if(typeof $e=="string")return $e;(0,F.$Jg)($e)&&(G||(G=[]),G.push($e))}return G?(async()=>{for(const Y of G){const X=await Y;if(typeof X=="string")return X}return null})():null},K=Z.find(ne=>!!ne.allBasenames);K&&(le.allBasenames=K.allBasenames);const U=Z.reduce((ne,be)=>be.allPaths?ne.concat(be.allPaths):ne,[]);return U.length&&(le.allPaths=U),le}const ae=function(le,K,U){let ne,be;for(let G=0,Y=Z.length;G<Y;G++){const X=Z[G];X.requiresSiblings&&U&&(K||(K=(0,R.$mc)(le)),ne||(ne=K.substr(0,K.length-(0,R.$nc)(le).length)));const $e=X(le,K,ne,U);if(typeof $e=="string")return $e;(0,F.$Jg)($e)&&(be||(be=[]),be.push($e))}return be?(async()=>{for(const G of be){const Y=await G;if(typeof Y=="string")return Y}return null})():null},x=Z.find(le=>!!le.allBasenames);x&&(ae.allBasenames=x.allBasenames);const Ee=Z.reduce((le,K)=>K.allPaths?le.concat(K.allPaths):le,[]);return Ee.length&&(ae.allPaths=Ee),ae}function T(de,ee,Z){if(ee===!1)return d;const J=u(de,Z);if(J===d)return d;if(typeof ee=="boolean")return J;if(ee){const ae=ee.when;if(typeof ae=="string"){const x=(Ee,le,K,U)=>{if(!U||!J(Ee,le))return null;const ne=ae.replace("$(basename)",()=>K),be=U(ne);return(0,F.$Jg)(be)?be.then(G=>G?de:null):be?de:null};return x.requiresSiblings=!0,x}}return J}function W(de,ee){const Z=de.filter(le=>!!le.basenames);if(Z.length<2)return de;const J=Z.reduce((le,K)=>{const U=K.basenames;return U?le.concat(U):le},[]);let ae;if(ee){ae=[];for(let le=0,K=J.length;le<K;le++)ae.push(ee)}else ae=Z.reduce((le,K)=>{const U=K.patterns;return U?le.concat(U):le},[]);const x=function(le,K){if(typeof le!="string")return null;if(!K){let ne;for(ne=le.length;ne>0;ne--){const be=le.charCodeAt(ne-1);if(be===47||be===92)break}K=le.substr(ne)}const U=J.indexOf(K);return U!==-1?ae[U]:null};x.basenames=J,x.patterns=ae,x.allBasenames=J;const Ee=de.filter(le=>!le.basenames);return Ee.push(x),Ee}function V(de,ee){return(0,I.$tb)(de,ee,(Z,J)=>typeof Z=="string"&&typeof J=="string"?Z===J:typeof Z!="string"&&typeof J!="string"?Z.base===J.base&&Z.pattern===J.pattern:!1)}e.$Fj=V}),define(ke[81],Se([1,0,11,164,23,13,2]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.MarkdownStringTextNewlineStyle=void 0;var p;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class E{constructor(s="",i=!1){if(this.value=s,typeof this.value!="string")throw(0,I.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(s,i=0){return this.value+=f(this.supportThemeIcons?(0,F.$2j)(s):s).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,i){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(s,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(s),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(s,i){const n=new RegExp((0,L.$Ie)(i),"g");return s.replace(n,(o,a)=>s.charAt(a-1)!=="\\"?`\\${o}`:o)}}e.$8j=E;function g(c){return A(c)?!c.value:Array.isArray(c)?c.every(g):!0}e.$9j=g;function A(c){return c instanceof E?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.$0j=A;function P(c,s){return c===s?!0:!c||!s?!1:c.value===s.value&&c.isTrusted===s.isTrusted&&c.supportThemeIcons===s.supportThemeIcons&&c.supportHtml===s.supportHtml&&(c.baseUri===s.baseUri||!!c.baseUri&&!!s.baseUri&&(0,m.$rg)(R.URI.from(c.baseUri),R.URI.from(s.baseUri)))}e.$$j=P;function f(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$_j=f;function y(c){return c.replace(/"/g,"&quot;")}e.$ak=y;function S(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$bk=S;function w(c){const s=[],i=c.split("|").map(o=>o.trim());c=i[0];const n=i[1];if(n){const o=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=o?o[1]:"",r=a?a[1]:"",d=isFinite(parseInt(r)),u=isFinite(parseInt(t));d&&s.push(`width="${r}"`),u&&s.push(`height="${t}"`)}return{href:c,dimensions:s}}e.$ck=w}),define(ke[102],Se([1,0,19,33,16,12,23,13]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=void 0;function E(u,l){const{os:h,tildify:k,relative:D}=l;if(D){const v=g(u,D,h);if(typeof v=="string")return v}let $=u.fsPath;if(h===1&&!L.$i?$=$.replace(/\//g,"\\"):h!==1&&L.$i&&($=$.replace(/\\/g,"/")),h!==1&&k?.userHome){const v=k.userHome.fsPath;let C;u.scheme!==k.userHome.scheme&&u.path[0]===m.$fc.sep&&u.path[1]!==m.$fc.sep?C=k.userHome.with({path:u.path}).fsPath:C=$,$=f(C,v,h)}return(h===1?m.$ec:m.$fc).normalize(A($,h===1))}e.$xv=E;function g(u,l,h){const k=h===1?m.$ec:m.$fc,D=h===3?R.$og:R.$qg,$=l.getWorkspace(),b=(0,I.$Nb)($.folders);if(!b)return;u.scheme!==b.uri.scheme&&u.path[0]===m.$fc.sep&&u.path[1]!==m.$fc.sep&&(u=b.uri.with({path:u.path}));const v=l.getWorkspaceFolder(u);if(!v)return;let C;if(D.isEqual(v.uri,u)?C="":C=D.relativePath(v.uri,u)??"",C&&(C=k.normalize(C)),$.folders.length>1&&!l.noPrefix){const N=v.name?v.name:D.basenameOrAuthority(v.uri);C=C?`${N} \u2022 ${C}`:N}return C}function A(u,l=L.$i){return(0,F.$5f)(u,l)?u.charAt(0).toUpperCase()+u.slice(1):u}e.$yv=A;let P=Object.create(null);function f(u,l,h=L.OS){if(h===1||!u||!l)return u;let k=P.original===l?P.normalized:void 0;k||(k=l,L.$i&&(k=(0,F.$Uf)(k)),k=`${(0,p.$Ne)(k,m.$fc.sep)}${m.$fc.sep}`,P={original:l,normalized:k});let D=u;return L.$i&&(D=(0,F.$Uf)(D)),(h===3?D.startsWith(k):(0,p.$6e)(D,k))?`~/${D.substr(k.length)}`:u}e.$zv=f;function y(u,l){return u.replace(/^~($|\/|\\)/,`${l}$1`)}e.$Av=y;const S="\u2026",w="\\\\",c="~";function s(u,l=m.sep){const h=new Array(u.length);let k=!1;for(let D=0;D<u.length;D++){const $=u[D];if($===""){h[D]=`.${l}`;continue}if(!$){h[D]=$;continue}k=!0;let b="",v=$;v.indexOf(w)===0?(b=v.substr(0,v.indexOf(w)+w.length),v=v.substr(v.indexOf(w)+w.length)):v.indexOf(l)===0?(b=v.substr(0,v.indexOf(l)+l.length),v=v.substr(v.indexOf(l)+l.length)):v.indexOf(c)===0&&(b=v.substr(0,v.indexOf(c)+c.length),v=v.substr(v.indexOf(c)+c.length));const C=v.split(l);for(let N=1;k&&N<=C.length;N++)for(let j=C.length-N;k&&j>=0;j--){k=!1;let M=C.slice(j,j+N).join(l);for(let O=0;!k&&O<u.length;O++)if(O!==D&&u[O]&&u[O].indexOf(M)>-1){const z=j+N===C.length,T=j>0&&u[O].indexOf(l)>-1?l+M:M,W=u[O].endsWith(T);k=!z||W}if(!k){let O="";(C[0].endsWith(":")||b!=="")&&(j===1&&(j=0,N++,M=C[0]+l+M),j>0&&(O=C[0]+l),O=b+O),j>0&&(O=O+S+l),O=O+M,j+N<C.length&&(O=O+l+S),h[D]=O}}k&&(h[D]=$)}return h}e.$Bv=s;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,l=Object.create(null)){const h=[];let k=!1,D="";for(const $ of u)if($==="$"||k&&$==="{")D&&h.push({value:D,type:i.TEXT}),D="",k=!0;else if($==="}"&&k){const b=l[D];if(typeof b=="string")b.length&&h.push({value:b,type:i.VARIABLE});else if(b){const v=h[h.length-1];(!v||v.type!==i.SEPARATOR)&&h.push({value:b.label,type:i.SEPARATOR})}D="",k=!1}else D+=$;return D&&!k&&h.push({value:D,type:i.TEXT}),h.filter(($,b)=>{if($.type===i.SEPARATOR){const v=h[b-1],C=h[b+1];return[v,C].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map($=>$.value).join("")}e.$Cv=n;function o(u,l){return L.$j||l?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):u.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Dv=o;function a(u,l){return L.$j||l?u.replace(/\(&&\w\)|&&/g,""):L.$i?u.replace(/&&|&/g,h=>h==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.$Ev=a;function t(u){return u.replace(/&/g,"&&")}e.$Fv=t;function r(u){if(u.endsWith("]")){const l=u.lastIndexOf(" [",u.length-2);if(l!==-1){const h=d(u.substring(0,l));return{name:h.name,parentPath:h.parentPath+u.substring(l)}}}return d(u)}e.$Gv=r;function d(u){const l=u.indexOf("/")!==-1?m.$fc:m.$ec,h=l.basename(u),k=l.dirname(u);return h.length?{name:h,parentPath:k}:{name:k,parentPath:""}}}),define(ke[131],Se([1,0,22,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=void 0;function m(P){return P.toJSON()}class L{constructor(f){this.a=f}transformIncoming(f){const y=this.a.transformIncoming(f);return y===f?f:m(F.URI.from(y))}transformOutgoing(f){const y=this.a.transformOutgoing(f);return y===f?f:m(F.URI.from(y))}transformOutgoingURI(f){const y=this.a.transformOutgoing(f);return y===f?f:F.URI.from(y)}transformOutgoingScheme(f){return this.a.transformOutgoingScheme(f)}}e.$Qm=L,e.$Rm=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function R(P,f,y){if(!P||y>200)return null;if(typeof P=="object"){if(P instanceof F.URI)return f.transformOutgoing(P);for(const S in P)if(Object.hasOwnProperty.call(P,S)){const w=R(P[S],f,y+1);w!==null&&(P[S]=w)}}return null}function p(P,f){const y=R(P,f,0);return y===null?P:y}e.$Sm=p;function E(P,f,y,S){if(!P||S>200)return null;if(typeof P=="object"){if(P.$mid===1)return y?F.URI.revive(f.transformIncoming(P)):f.transformIncoming(P);if(P instanceof I.$ee)return null;for(const w in P)if(Object.hasOwnProperty.call(P,w)){const c=E(P[w],f,y,S+1);c!==null&&(P[w]=c)}}return null}function g(P,f){const y=E(P,f,!1,0);return y===null?P:y}e.$Tm=g;function A(P,f){const y=E(P,f,!0,0);return y===null?P:y}e.$Um=A}),define(ke[30],Se([1,0,55,63,387,10,33,77,16,12,23,2]),function(me,e,I,F,m,L,R,p,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function y(T,W=f.UNLINK,V){if((0,R.$4f)(T))throw new Error("rimraf - will refuse to recursively delete root");return W===f.UNLINK?w(T):S(T,V)}async function S(T,W=(0,R.$9f)((0,F.tmpdir)())){try{try{await I.promises.rename(T,W)}catch(V){return V.code==="ENOENT"?void 0:w(T)}w(W).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function w(T){return(0,m.promisify)(I.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function c(T){if((0,R.$4f)(T))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function s(T,W){return o(await(W?i(T):(0,m.promisify)(I.readdir)(T)))}async function i(T){try{return await(0,m.promisify)(I.readdir)(T,{withFileTypes:!0})}catch(de){console.warn("[node.js fs] readdir with filetypes failed with error: ",de)}const W=[],V=await s(T);for(const de of V){let ee=!1,Z=!1,J=!1;try{const ae=await e.Promises.lstat((0,E.$ic)(T,de));ee=ae.isFile(),Z=ae.isDirectory(),J=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}W.push({name:de,isFile:()=>ee,isDirectory:()=>Z,isSymbolicLink:()=>J})}return W}function n(T){return o(I.readdirSync(T))}e.readdirSync=n;function o(T){return T.map(W=>typeof W=="string"?g.$j?(0,p.$tl)(W):W:(W.name=g.$j?(0,p.$tl)(W.name):W.name,W))}async function a(T){const W=await s(T),V=[];for(const de of W)await r.existsDirectory((0,E.$ic)(T,de))&&V.push(de);return V}function t(T,W=1e3){return new Promise(V=>{let de=!1;const ee=setInterval(()=>{de||(de=!0,I.access(T,Z=>{de=!1,Z&&(clearInterval(ee),V(void 0))}))},W)})}e.whenDeleted=t;var r;(function(T){async function W(ee){let Z;try{if(Z=await e.Promises.lstat(ee),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(g.$i&&J.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw ae}throw J}}T.stat=W;async function V(ee){try{const{stat:Z,symbolicLink:J}=await T.stat(ee);return Z.isFile()&&J?.dangling!==!0}catch{}return!1}T.existsFile=V;async function de(ee){try{const{stat:Z,symbolicLink:J}=await T.stat(ee);return Z.isDirectory()&&J?.dangling!==!0}catch{}return!1}T.existsDirectory=de})(r||(e.SymlinkSupport=r={}));const d=new L.$6g;function u(T,W,V){return d.queueFor(P.URI.file(T),A.$pg).queue(()=>{const de=$(V);return new Promise((ee,Z)=>k(T,W,de,J=>J?Z(J):ee()))})}let l=!0;function h(T){l=T}e.configureFlushOnWrite=h;function k(T,W,V,de){if(!l)return I.writeFile(T,W,{mode:V.mode,flag:V.flag},de);I.open(T,V.flag,V.mode,(ee,Z)=>{if(ee)return de(ee);I.writeFile(Z,W,J=>{if(J)return I.close(Z,()=>de(J));I.fdatasync(Z,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),h(!1)),I.close(Z,x=>de(x))))})})}function D(T,W,V){const de=$(V);if(!l)return I.writeFileSync(T,W,{mode:de.mode,flag:de.flag});const ee=I.openSync(T,de.flag,de.mode);try{I.writeFileSync(ee,W);try{I.fdatasyncSync(ee)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),h(!1)}}finally{I.closeSync(ee)}}e.writeFileSync=D;function $(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function b(T,W,V=6e4){if(T!==W)try{g.$i&&typeof V=="number"?await v(T,W,Date.now(),V):await(0,m.promisify)(I.rename)(T,W)}catch(de){if(T.toLowerCase()!==W.toLowerCase()&&de.code==="EXDEV"||T.endsWith("."))await C(T,W,{preserveSymlinks:!1}),await y(T,f.MOVE);else throw de}}async function v(T,W,V,de,ee=0){try{return await(0,m.promisify)(I.rename)(T,W)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-V>=de)throw console.error(`[node.js fs] rename failed after ${ee} retries with error: ${Z}`),Z;if(ee===0){let J=!1;try{const{stat:ae}=await r.stat(W);ae.isFile()||(J=!0)}catch{}if(J)throw Z}return await(0,L.$Xg)(Math.min(100,ee*10)),v(T,W,V,de,ee+1)}}async function C(T,W,V){return j(T,W,{root:{source:T,target:W},options:V,handledSourcePaths:new Set})}const N=511;async function j(T,W,V){if(V.handledSourcePaths.has(T))return;V.handledSourcePaths.add(T);const{stat:de,symbolicLink:ee}=await r.stat(T);if(ee){if(V.options.preserveSymlinks)try{return await z(T,W,V)}catch(Z){console.warn("[node.js fs] copy of symlink failed: ",Z)}if(ee.dangling)return}return de.isDirectory()?M(T,W,de.mode&N,V):O(T,W,de.mode&N)}async function M(T,W,V,de){await e.Promises.mkdir(W,{recursive:!0,mode:V});const ee=await s(T);for(const Z of ee)await j((0,E.$ic)(T,Z),(0,E.$ic)(W,Z),de)}async function O(T,W,V){await e.Promises.copyFile(T,W),await e.Promises.chmod(W,V)}async function z(T,W,V){let de=await e.Promises.readlink(T);(0,R.$1f)(de,V.root.source,!g.$k)&&(de=(0,E.$ic)(V.root.target,de.substr(V.root.source.length+1))),await e.Promises.symlink(de,W)}e.Promises=new class{get access(){return(0,m.promisify)(I.access)}get stat(){return(0,m.promisify)(I.stat)}get lstat(){return(0,m.promisify)(I.lstat)}get utimes(){return(0,m.promisify)(I.utimes)}get read(){return(T,W,V,de,ee)=>new Promise((Z,J)=>{I.read(T,W,V,de,ee,(ae,x,Ee)=>ae?J(ae):Z({bytesRead:x,buffer:Ee}))})}get readFile(){return(0,m.promisify)(I.readFile)}get write(){return(T,W,V,de,ee)=>new Promise((Z,J)=>{I.write(T,W,V,de,ee,(ae,x,Ee)=>ae?J(ae):Z({bytesWritten:x,buffer:Ee}))})}get appendFile(){return(0,m.promisify)(I.appendFile)}get fdatasync(){return(0,m.promisify)(I.fdatasync)}get truncate(){return(0,m.promisify)(I.truncate)}get copyFile(){return(0,m.promisify)(I.copyFile)}get open(){return(0,m.promisify)(I.open)}get close(){return(0,m.promisify)(I.close)}get symlink(){return(0,m.promisify)(I.symlink)}get readlink(){return(0,m.promisify)(I.readlink)}get chmod(){return(0,m.promisify)(I.chmod)}get mkdir(){return(0,m.promisify)(I.mkdir)}get unlink(){return(0,m.promisify)(I.unlink)}get rmdir(){return(0,m.promisify)(I.rmdir)}get realpath(){return(0,m.promisify)(I.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return a}get writeFile(){return u}get rm(){return y}get rename(){return b}get copy(){return C}}}),define(ke[103],Se([1,0,55,16,12,13,30]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.$0p=void 0;function p(f){if(m.$k)return f;const y=(0,F.$lc)(f);if(f===y)return f;const S=((0,F.$mc)(f)||f).toLowerCase();try{const c=(0,R.readdirSync)(y).filter(s=>s.toLowerCase()===S);if(c.length===1){const s=p(y);if(s)return(0,F.$ic)(s,c[0])}else if(c.length>1){const s=c.indexOf(S);if(s>=0){const i=p(y);if(i)return(0,F.$ic)(i,c[s])}}}catch{}return null}e.$0p=p;async function E(f){if(m.$k)return f;const y=(0,F.$lc)(f);if(f===y)return f;const S=((0,F.$mc)(f)||f).toLowerCase();try{const c=(await R.Promises.readdir(y)).filter(s=>s.toLowerCase()===S);if(c.length===1){const s=await E(y);if(s)return(0,F.$ic)(s,c[0])}else if(c.length>1){const s=c.indexOf(S);if(s>=0){const i=await E(y);if(i)return(0,F.$ic)(i,c[s])}}}catch{}return null}e.$$p=E;async function g(f){try{return await R.Promises.realpath(f)}catch{const S=P(f);return await R.Promises.access(S,I.constants.R_OK),S}}e.$_p=g;function A(f){try{return I.realpathSync(f)}catch{const S=P(f);return I.accessSync(S,I.constants.R_OK),S}}e.$aq=A;function P(f){return(0,L.$Ne)((0,F.$gc)(f),F.sep)}}),define(ke[104],Se([1,0,16,12,49,101,18,30]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Hl=e.$Gl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(P=m.env){return P.comspec||"cmd.exe"}e.$Gl=E;function g(P){let f=[],y=!1;const S=function(w){if(y){f.push(w);return}(!P.send(w,s=>{if(s&&console.error(s),y=!1,f.length>0){const i=f.slice(0);f=[],i.forEach(n=>S(n))}})||F.$i)&&(y=!0)};return{send:S}}e.$Hl=g;var A;(function(P){async function f(y,S,w){if(I.$hc(y))return y;if(S===void 0&&(S=m.cwd()),I.$lc(y)!=="."||(w===void 0&&R.$Bf(m.env.PATH)&&(w=m.env.PATH.split(I.$sc)),w===void 0||w.length===0))return I.$ic(S,y);async function s(i){if(await p.Promises.exists(i)){let n;try{n=await p.Promises.stat(i)}catch(o){o.message.startsWith("EACCES")&&(n=await p.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of w){let n;if(I.$hc(i)?n=I.$ic(i,y):n=I.$ic(S,i,y),await s(n))return n;let o=n+".com";if(await s(o)||(o=n+".exe",await s(o)))return o}return I.$ic(S,y)}P.findExecutable=f})(A||(e.win32=A={}))});var He=this&&this.__decorate||function(me,e,I,F){var m=arguments.length,L=m<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,I):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(me,e,I,F);else for(var p=me.length-1;p>=0;p--)(R=me[p])&&(L=(m<3?R(L):m>3?R(e,I,L):R(e,I))||L);return m>3&&L&&Object.defineProperty(e,I,L),L};define(ke[82],Se([1,0,19,10,22,21,59,11,4,3,54,13,18]),function(me,e,I,F,m,L,R,p,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dh=e.ProxyChannel=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.RequestInitiator=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0;var y;(function(ee){ee[ee.Promise=100]="Promise",ee[ee.PromiseCancel=101]="PromiseCancel",ee[ee.EventListen=102]="EventListen",ee[ee.EventDispose=103]="EventDispose"})(y||(y={}));function S(ee){switch(ee){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(ee){ee[ee.Initialize=200]="Initialize",ee[ee.PromiseSuccess=201]="PromiseSuccess",ee[ee.PromiseError=202]="PromiseError",ee[ee.PromiseErrorObj=203]="PromiseErrorObj",ee[ee.EventFire=204]="EventFire"})(w||(w={}));function c(ee){switch(ee){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(ee){ee[ee.Uninitialized=0]="Uninitialized",ee[ee.Idle=1]="Idle"})(s||(s={}));function i(ee){let Z=0;for(let J=0;;J+=7){const ae=ee.read(1);if(Z|=(ae.buffer[0]&127)<<J,!(ae.buffer[0]&128))return Z}}const n=d(0);function o(ee,Z){if(Z===0){ee.write(n);return}let J=0;for(let x=Z;x!==0;x=x>>>7)J++;const ae=m.$ee.alloc(J);for(let x=0;Z!==0;x++)ae.buffer[x]=Z&127,Z=Z>>>7,Z>0&&(ae.buffer[x]|=128);ee.write(ae)}class a{constructor(Z){this.b=Z,this.a=0}read(Z){const J=this.b.slice(this.a,this.a+Z);return this.a+=J.byteLength,J}}e.$sh=a;class t{constructor(){this.a=[]}get buffer(){return m.$ee.concat(this.a)}write(Z){this.a.push(Z)}}e.$th=t;var r;(function(ee){ee[ee.Undefined=0]="Undefined",ee[ee.String=1]="String",ee[ee.Buffer=2]="Buffer",ee[ee.VSBuffer=3]="VSBuffer",ee[ee.Array=4]="Array",ee[ee.Object=5]="Object",ee[ee.Int=6]="Int"})(r||(r={}));function d(ee){const Z=m.$ee.alloc(1);return Z.writeUInt8(ee,0),Z}const u={Undefined:d(r.Undefined),String:d(r.String),Buffer:d(r.Buffer),VSBuffer:d(r.VSBuffer),Array:d(r.Array),Object:d(r.Object),Uint:d(r.Int)},l=typeof Buffer<"u";function h(ee,Z){if(typeof Z>"u")ee.write(u.Undefined);else if(typeof Z=="string"){const J=m.$ee.fromString(Z);ee.write(u.String),o(ee,J.byteLength),ee.write(J)}else if(l&&Buffer.isBuffer(Z)){const J=m.$ee.wrap(Z);ee.write(u.Buffer),o(ee,J.byteLength),ee.write(J)}else if(Z instanceof m.$ee)ee.write(u.VSBuffer),o(ee,Z.byteLength),ee.write(Z);else if(Array.isArray(Z)){ee.write(u.Array),o(ee,Z.length);for(const J of Z)h(ee,J)}else if(typeof Z=="number"&&(Z|0)===Z)ee.write(u.Uint),o(ee,Z);else{const J=m.$ee.fromString(JSON.stringify(Z));ee.write(u.Object),o(ee,J.byteLength),ee.write(J)}}e.$uh=h;function k(ee){switch(ee.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return ee.read(i(ee)).toString();case r.Buffer:return ee.read(i(ee)).buffer;case r.VSBuffer:return ee.read(i(ee));case r.Array:{const J=i(ee),ae=[];for(let x=0;x<J;x++)ae.push(k(ee));return ae}case r.Object:return JSON.parse(ee.read(i(ee)).toString());case r.Int:return i(ee)}}e.$vh=k;class D{constructor(Z,J,ae=null,x=1e3){this.h=Z,this.j=J,this.k=ae,this.l=x,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Ee=>this.q(Ee)),this.m({type:200})}registerChannel(Z,J){this.b.set(Z,J),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const J=this.o([Z.type]);this.k?.logOutgoing(J,0,1,c(Z.type));return}case 201:case 202:case 204:case 203:{const J=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(J,Z.id,1,c(Z.type),Z.data);return}}}o(Z,J=void 0){const ae=new t;return h(ae,Z),h(ae,J),this.p(ae.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const J=new a(Z),ae=k(J),x=k(J),Ee=ae[0];switch(Ee){case 100:return this.k?.logIncoming(Z.byteLength,ae[1],1,`${S(Ee)}: ${ae[2]}.${ae[3]}`,x),this.s({type:Ee,id:ae[1],channelName:ae[2],name:ae[3],arg:x});case 102:return this.k?.logIncoming(Z.byteLength,ae[1],1,`${S(Ee)}: ${ae[2]}.${ae[3]}`,x),this.t({type:Ee,id:ae[1],channelName:ae[2],name:ae[3],arg:x});case 101:return this.k?.logIncoming(Z.byteLength,ae[1],1,`${S(Ee)}`),this.u({type:Ee,id:ae[1]});case 103:return this.k?.logIncoming(Z.byteLength,ae[1],1,`${S(Ee)}`),this.u({type:Ee,id:ae[1]})}}s(Z){const J=this.b.get(Z.channelName);if(!J){this.v(Z);return}const ae=new L.$1d;let x;try{x=J.call(this.j,Z.name,Z.arg,ae.token)}catch(K){x=Promise.reject(K)}const Ee=Z.id;x.then(K=>{this.m({id:Ee,data:K,type:201})},K=>{K instanceof Error?this.m({id:Ee,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:Ee,data:K,type:203})}).finally(()=>{le.dispose(),this.d.delete(Z.id)});const le=(0,g.$Pc)(()=>ae.cancel());this.d.set(Z.id,le)}t(Z){const J=this.b.get(Z.channelName);if(!J){this.v(Z);return}const ae=Z.id,Ee=J.listen(this.j,Z.name,Z.arg)(le=>this.m({id:ae,data:le,type:204}));this.d.set(Z.id,Ee)}u(Z){const J=this.d.get(Z.id);J&&(J.dispose(),this.d.delete(Z.id))}v(Z){let J=this.g.get(Z.channelName);J||(J=[],this.g.set(Z.channelName,J));const ae=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:Z,timeoutTimer:ae})}w(Z){const J=this.g.get(Z);if(J){for(const ae of J)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$wh=D;var $;(function(ee){ee[ee.LocalSide=0]="LocalSide",ee[ee.OtherSide=1]="OtherSide"})($||(e.RequestInitiator=$={}));class b{constructor(Z,J=null){this.l=Z,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$Qd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=J}getChannel(Z){const J=this;return{call(ae,x,Ee){return J.a?Promise.reject(new p.$4):J.m(Z,ae,x,Ee)},listen(ae,x){return J.a?E.Event.None:J.o(Z,ae,x)}}}m(Z,J,ae,x=L.CancellationToken.None){const Ee=this.g++,K={id:Ee,type:100,channelName:Z,name:J,arg:ae};if(x.isCancellationRequested)return Promise.reject(new p.$4);let U;return new Promise((be,G)=>{if(x.isCancellationRequested)return G(new p.$4);const Y=()=>{const fe=te=>{switch(te.type){case 201:this.f.delete(Ee),be(te.data);break;case 202:{this.f.delete(Ee);const he=new Error(te.data.message);he.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,he.name=te.data.name,G(he);break}case 203:this.f.delete(Ee),G(te.data);break}};this.f.set(Ee,fe),this.p(K)};let X=null;this.b===s.Idle?Y():(X=(0,F.$Kg)(fe=>this.u()),X.then(()=>{X=null,Y()}));const $e=()=>{X?(X.cancel(),X=null):this.p({id:Ee,type:101}),G(new p.$4)},re=x.onCancellationRequested($e);U=(0,g.$Oc)((0,g.$Pc)($e),re),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Z,J,ae){const x=this.g++,le={id:x,type:102,channelName:Z,name:J,arg:ae};let K=null;const U=new E.$Qd({onWillAddFirstListener:()=>{K=(0,F.$Kg)(be=>this.u()),K.then(()=>{K=null,this.d.add(U),this.p(le)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(U),this.p({id:x,type:103}))}}),ne=be=>U.fire(be.data);return this.f.set(x,ne),U.event}p(Z){switch(Z.type){case 100:case 102:{const J=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(J,Z.id,0,`${S(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const J=this.q([Z.type,Z.id]);this.j?.logOutgoing(J,Z.id,0,S(Z.type));return}}}q(Z,J=void 0){const ae=new t;return h(ae,Z),h(ae,J),this.r(ae.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const J=new a(Z),ae=k(J),x=k(J),Ee=ae[0];switch(Ee){case 200:return this.j?.logIncoming(Z.byteLength,0,0,c(Ee)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,ae[1],0,c(Ee),x),this.t({type:ae[0],id:ae[1],data:x})}}t(Z){if(Z.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$xh=b,He([R.$mh],b.prototype,"onDidInitializePromise",null);class v{get connections(){const Z=[];return this.f.forEach(J=>Z.push(J)),Z}constructor(Z){this.a=new Map,this.f=new Set,this.g=new E.$Qd,this.onDidAddConnection=this.g.event,this.h=new E.$Qd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Qc,this.j.add(Z(({protocol:J,onDidClientDisconnect:ae})=>{const x=E.Event.once(J.onMessage);this.j.add(x(Ee=>{const le=new a(Ee),K=k(le),U=new D(J,K),ne=new b(J);this.a.forEach((G,Y)=>U.registerChannel(Y,G));const be={channelServer:U,channelClient:ne,ctx:K};this.f.add(be),this.g.fire(be),this.j.add(ae(()=>{U.dispose(),ne.dispose(),this.f.delete(be),this.h.fire(be)}))}))}))}getChannel(Z,J){const ae=this;return{call(x,Ee,le){let K;if((0,f.$Pf)(J)){const ne=(0,I.$3b)(ae.connections.filter(J));K=ne?Promise.resolve(ne):E.Event.toPromise(E.Event.filter(ae.onDidAddConnection,J))}else K=J.routeCall(ae,x,Ee);const U=K.then(ne=>ne.channelClient.getChannel(Z));return N(U).call(x,Ee,le)},listen(x,Ee){if((0,f.$Pf)(J))return ae.k(Z,J,x,Ee);const le=J.routeEvent(ae,x,Ee).then(K=>K.channelClient.getChannel(Z));return N(le).listen(x,Ee)}}}k(Z,J,ae,x){const Ee=this;let le;const K=new E.$Qd({onWillAddFirstListener:()=>{le=new g.$Qc;const U=new E.$Wd,ne=new Map,be=Y=>{const $e=Y.channelClient.getChannel(Z).listen(ae,x),re=U.add($e);ne.set(Y,re)},G=Y=>{const X=ne.get(Y);X&&(X.dispose(),ne.delete(Y))};Ee.connections.filter(J).forEach(be),E.Event.filter(Ee.onDidAddConnection,J)(be,void 0,le),Ee.onDidRemoveConnection(G,void 0,le),U.event(K.fire,K,le),le.add(U)},onDidRemoveLastListener:()=>{le?.dispose(),le=void 0}});return K.event}registerChannel(Z,J){this.a.set(Z,J);for(const ae of this.f)ae.channelServer.registerChannel(Z,J)}dispose(){this.j.dispose();for(const Z of this.f)Z.channelClient.dispose(),Z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$yh=v;class C{constructor(Z,J,ae=null){const x=new t;h(x,J),Z.send(x.buffer),this.a=new b(Z,ae),this.d=new D(Z,J,ae)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,J){this.d.registerChannel(Z,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$zh=C;function N(ee){return{call(Z,J,ae){return ee.then(x=>x.call(Z,J,ae))},listen(Z,J){const ae=new E.$Zd;return ee.then(x=>ae.input=x.listen(Z,J)),ae.event}}}e.$Ah=N;function j(ee){let Z=!1;return{call(J,ae,x){return Z?ee.call(J,ae,x):(0,F.$Xg)(0).then(()=>Z=!0).then(()=>ee.call(J,ae,x))},listen(J,ae){if(Z)return ee.listen(J,ae);const x=new E.$Zd;return(0,F.$Xg)(0).then(()=>Z=!0).then(()=>x.input=ee.listen(J,ae)),x.event}}}e.$Bh=j;class M{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const J of Z.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await E.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}e.$Ch=M;var O;(function(ee){function Z(Ee,le,K){const U=Ee,ne=K&&K.disableMarshalling,be=new Map;for(const G in U)ae(G)&&be.set(G,E.Event.buffer(U[G],!0,void 0,le));return new class{listen(G,Y,X){const $e=be.get(Y);if($e)return $e;if(x(Y)){const re=U[Y];if(typeof re=="function")return re.call(U,X)}throw new p.$ab(`Event not found: ${Y}`)}call(G,Y,X){const $e=U[Y];if(typeof $e=="function"){if(!ne&&Array.isArray(X))for(let fe=0;fe<X.length;fe++)X[fe]=(0,A.$rh)(X[fe]);let re=$e.apply(U,X);return re instanceof Promise||(re=Promise.resolve(re)),re}throw new p.$ab(`Method not found: ${Y}`)}}}ee.fromService=Z;function J(Ee,le){const K=le&&le.disableMarshalling;return new Proxy({},{get(U,ne){if(typeof ne=="string")return le?.properties?.has(ne)?le.properties.get(ne):x(ne)?function(be){return Ee.listen(ne,be)}:ae(ne)?Ee.listen(ne):async function(...be){let G;le&&!(0,f.$Kf)(le.context)?G=[le.context,...be]:G=be;const Y=await Ee.call(ne,G);return K?Y:(0,A.$rh)(Y)};throw new p.$ab(`Property not found: ${String(ne)}`)}})}ee.toService=J;function ae(Ee){return Ee[0]==="o"&&Ee[1]==="n"&&P.$4e(Ee.charCodeAt(2))}function x(Ee){return/^onDynamic/.test(Ee)&&P.$4e(Ee.charCodeAt(9))}})(O||(e.ProxyChannel=O={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(ee){if(Array.isArray(ee))return ee;if(ee&&typeof ee=="object"&&typeof ee.toString=="function"){const Z=ee.toString();if(Z!=="[object Object]")return Z}return ee}function W(ee){return Array.isArray(ee)?ee.map(T):T(ee)}function V(ee,Z,J,ae,x,Ee,le){le=W(le);const K=z[x],U=K[ae%K.length];let ne=[`%c[${ee}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${Ee}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(Ee)?(ne=ne.concat(le),ne.push(")")):ne.push(le),console.log.apply(console,ne)}class de{constructor(Z,J){this.d=Z,this.f=J,this.a=0,this.b=0}logOutgoing(Z,J,ae,x,Ee){this.b+=Z,V(this.d,this.b,Z,J,ae,x,Ee)}logIncoming(Z,J,ae,x,Ee){this.a+=Z,V(this.f,this.a,Z,J,ae,x,Ee)}}e.$Dh=de}),define(ke[83],Se([1,0,22,4,3,82]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.ProtocolConstants=e.$Eh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var p;(function(u){u.enableDiagnostics=!1,u.records=[];const l=new WeakMap;let h=0;function k($,b){if(!l.has($)){const v=String(++h);l.set($,v)}return l.get($)}function D($,b,v,C){if(!u.enableDiagnostics)return;const N=k($,b);if(C instanceof I.$ee||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const j=I.$ee.alloc(C.byteLength);j.set(C),u.records.push({timestamp:Date.now(),id:N,label:b,type:v,buff:j})}else u.records.push({timestamp:Date.now(),id:N,label:b,type:v,data:C})}u.traceSocketEvent=D})(p||(e.SocketDiagnostics=p={}));var E;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let g=null;function A(){return g||(g=I.$ee.alloc(0)),g}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,h){if(l===0)return A();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const b=this.a[0];return h&&(this.a.shift(),this.b-=l),b}if(this.a[0].byteLength>l){const b=this.a[0].slice(0,l);return h&&(this.a[0]=this.a[0].slice(l),this.b-=l),b}const k=I.$ee.alloc(l);let D=0,$=0;for(;l>0;){const b=this.a[$];if(b.byteLength>l){const v=b.slice(0,l);k.set(v,D),D+=l,h&&(this.a[$]=b.slice(l),this.b-=l),l-=l}else k.set(b,D),D+=b.byteLength,h?(this.a.shift(),this.b-=b.byteLength):$++,l-=b.byteLength}return k}}e.$Eh=P;var f;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(f||(f={}));function y(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class w{constructor(l,h,k,D){this.type=l,this.id=h,this.ack=k,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends m.$Rc{constructor(l){super(),this.f=this.B(new F.$Qd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=l,this.b=!1,this.c=new P,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,D=this.g.id,$=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new w(k,D,$,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=I.$ee.alloc(13);h.writeUInt8(l.type,0),h.writeUInt32BE(l.id,1),h.writeUInt32BE(l.ack,5),h.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",l.data),this.j(h,l.data)}g(l,h){const k=this.f===0;return this.d.push(l,h),this.f+=l.byteLength+h.byteLength,k}h(){const l=I.$ee.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,h){this.g(l,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this.c.write(l)}}class i extends m.$Rc{constructor(l){super(),this.f=new F.$Qd,this.onMessage=this.f.event,this.g=new F.$Qd,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new s(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new w(1,0,0,l))}}e.$Fh=i;class n extends L.$zh{static fromSocket(l,h){return new n(new i(l),h)}get onDidDispose(){return this.b.onDidDispose}constructor(l,h,k=null){super(l,h,k),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$Gh=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Qd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$Hh=o;class a{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,h=this.a;for(;h;)h=h.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let h=0,k=this.a;for(;k;)l[h++]=k.data,k=k.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const h=new a(l);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const l=Date.now();for(let h=0;h<r.a;h++)this.c[h]=l-1e3*h;setInterval(()=>{for(let h=r.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),h=(1+r.a)*1e3;let k=0;for(let D=0;D<r.a;D++)l-this.c[D]<=h&&k++;return 1-k/r.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??r.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new m.$Qc,this.o=l.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new w(5,0,0,A());this.p.write(l),this.p.flush()}sendPause(){const l=new w(7,0,0,A());this.p.write(l)}sendResume(){const l=new w(8,0,0,A());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,h){this.a=!0,this.r.dispose(),this.r=new m.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new w(3,0,this.h,A());this.p.write(l);const h=this.b.toArray();for(let k=0,D=h.length;k<D;k++)this.p.write(h[k]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const h=this.b.peek();if(h&&h.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this.g)if(l.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new w(6,0,0,A())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case 2:{this.u.fire(l.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let k=0,D=h.length;k<D;k++)this.p.write(h[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const h=++this.c;this.h=this.g;const k=new w(1,h,this.h,l);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(l){const h=new w(2,0,0,l);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),h=Date.now()-l.writtenTime,k=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&k>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:k});return}const $=Math.max(2e4-h,2e4-k,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},$)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new w(3,0,this.h,A());this.p.write(l)}D(){this.h=this.g;const l=new w(9,0,this.h,A());this.p.write(l)}}e.$Ih=d}),define(ke[187],Se([1,0,50,10,22,21,185,11,4,3,24,104,101,82]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;class S extends y.$wh{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",i=>m.$ee.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$7p=S;class w{constructor(s,i){this.i=s,this.j=i,this.c=new Set,this.g=new Map,this.h=new E.$Qd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new F.$Tg(n),this.d=null,this.f=null}getChannel(s){const i=this;return{call(n,o,a){return i.k(s,n,o,a)},listen(n,o){return i.l(s,n,o)}}}k(s,i,n,o=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(p.$5());this.b.cancel();const a=this.n(s),t=(0,F.$Kg)(u=>a.call(i,n,u)),r=o.onCancellationRequested(()=>t.cancel()),d=(0,g.$Pc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{r.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,i,n){if(!this.b)return E.Event.None;this.b.cancel();let o;const a=new E.$Qd({onWillAddFirstListener:()=>{o=this.n(s).listen(i,n)(a.fire,a),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$_m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,f.$Fl)(i.env),this.d=(0,I.fork)(this.i,s,i);const n=new E.$Qd;E.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,R.$3p)(l)){(0,R.log)(l,`IPC Library: ${this.j.serverName}`);return}n.fire(m.$ee.wrap(Buffer.from(l,"base64")))});const a=this.j.useQueue?(0,P.$Hl)(this.d):this.d,t=l=>this.d&&this.d.connected&&a.send(l.buffer.toString("base64")),r=n.event,d={send:t,onMessage:r};this.f=new y.$xh(d);const u=()=>this.o();process.once("exit",u),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,h)=>{process.removeListener("exit",u),this.c.forEach(k=>(0,g.$Mc)(k)),this.c.clear(),l!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:h})})}return this.f}n(s){let i=this.g.get(s);return i||(i=this.m.getChannel(s),this.g.set(s,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$8p=w}),define(ke[188],Se([1,0,10,4,3,54,18]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.StorageState=e.$6o=e.StorageHint=void 0;var p;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function E(f){const y=f;return y?.changed instanceof Map||y?.deleted instanceof Set}e.$6o=E;var g;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(g||(e.StorageState=g={}));class A extends m.$Rc{static{this.a=100}constructor(y,S=Object.create(null)){super(),this.r=y,this.s=S,this.b=this.B(new F.$Td),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new I.$Ug(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((S,w)=>this.w(w,S)),y.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(y,S){if(this.c===g.Closed)return;let w=!1;(0,R.$Kf)(S)?w=this.f.delete(y):this.f.get(y)!==S&&(this.f.set(y,S),w=!0),w&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,S){const w=this.f.get(y);return(0,R.$Kf)(w)?S:w}getBoolean(y,S){const w=this.get(y);return(0,R.$Kf)(w)?S:w==="true"}getNumber(y,S){const w=this.get(y);return(0,R.$Kf)(w)?S:parseInt(w,10)}getObject(y,S){const w=this.get(y);return(0,R.$Kf)(w)?S:(0,L.$qh)(w)}async set(y,S,w=!1){if(this.c===g.Closed)return;if((0,R.$Kf)(S))return this.delete(y,w);const c=(0,R.$Df)(S)||Array.isArray(S)?(0,L.$ph)(S):String(S);if(this.f.get(y)!==c)return this.f.set(y,c),this.j.set(y,c),this.h.delete(y),this.b.fire({key:y,external:w}),this.D()}async delete(y,S=!1){if(!(this.c===g.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:S}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(this.z)return this.D(y)}async D(y){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$7o=A;class P{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((S,w)=>this.a.set(w,S)),y.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$8o=P}),define(ke[189],Se([1,0,13,12,22]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=void 0;let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let p;function E(){return p||(p=new TextDecoder("UTF-16BE")),p}let g;function A(){return g||(g=F.$D()?R():E()),g}e.$Rs=A;function P(S,w,c){const s=new Uint16Array(S.buffer,w,c);return c>0&&(s[0]===65279||s[0]===65534)?f(S,w,c):R().decode(s)}e.$Ss=P;function f(S,w,c){const s=[];let i=0;for(let n=0;n<c;n++){const o=m.$ge(S,w);w+=2,s[i++]=String.fromCharCode(o)}return s.join("")}class y{constructor(w){this.a=w|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const w=new Uint16Array(this.b.buffer,0,this.d);return A().decode(w)}f(){const w=this.e();this.d=0,this.c===null?this.c=[w]:this.c[this.c.length]=w}appendCharCode(w){const c=this.a-this.d;c<=1&&(c===0||I.$9e(w))&&this.f(),this.b[this.d++]=w}appendASCIICharCode(w){this.d===this.a&&this.f(),this.b[this.d++]=w}appendString(w){const c=w.length;if(this.d+c>=this.a){this.f(),this.c[this.c.length]=w;return}for(let s=0;s<c;s++)this.b[this.d++]=w.charCodeAt(s)}}e.$Ts=y}),define(ke[190],Se([1,0,22,189]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;function m(E){return E.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(g,A,P,f){this.oldPosition=g,this.oldText=A,this.newPosition=P,this.newText=f}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${m(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${m(this.oldText)}")`:`(replace@${this.oldPosition} "${m(this.oldText)}" with "${m(this.newText)}")`}static a(g){return 4+2*g.length}static c(g,A,P){const f=A.length;I.$je(g,f,P),P+=4;for(let y=0;y<f;y++)I.$he(g,A.charCodeAt(y),P),P+=2;return P}static d(g,A){const P=I.$ie(g,A);return A+=4,(0,F.$Ss)(g,A,P)}writeSize(){return 4+4+L.a(this.oldText)+L.a(this.newText)}write(g,A){return I.$je(g,this.oldPosition,A),A+=4,I.$je(g,this.newPosition,A),A+=4,A=L.c(g,this.oldText,A),A=L.c(g,this.newText,A),A}static read(g,A,P){const f=I.$ie(g,A);A+=4;const y=I.$ie(g,A);A+=4;const S=L.d(g,A);A+=L.a(S);const w=L.d(g,A);return A+=L.a(w),P.push(new L(f,S,y,w)),A}}e.$Us=L;function R(E,g){return E===null||E.length===0?g:new p(E,g).compress()}e.$Vs=R;class p{constructor(g,A){this.a=g,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let g=0,A=0,P=this.n(g),f=this.l(A);for(;g<this.f||A<this.h;){if(P===null){this.k(f),f=this.l(++A);continue}if(f===null){this.m(P),P=this.n(++g);continue}if(f.oldEnd<=P.newPosition){this.k(f),f=this.l(++A);continue}if(P.newEnd<=f.oldPosition){this.m(P),P=this.n(++g);continue}if(f.oldPosition<P.newPosition){const[s,i]=p.r(f,P.newPosition-f.oldPosition);this.k(s),f=i;continue}if(P.newPosition<f.oldPosition){const[s,i]=p.q(P,f.oldPosition-P.newPosition);this.m(s),P=i;continue}let w,c;if(f.oldEnd===P.newEnd)w=P,c=f,P=this.n(++g),f=this.l(++A);else if(f.oldEnd<P.newEnd){const[s,i]=p.q(P,f.oldLength);w=s,c=f,P=i,f=this.l(++A)}else{const[s,i]=p.r(f,P.newLength);w=P,c=s,P=this.n(++g),f=i}this.d[this.e++]=new L(w.oldPosition,w.oldText,c.newPosition,c.newText),this.g+=w.newLength-w.oldLength,this.j+=c.newLength-c.oldLength}const y=p.s(this.d);return p.t(y)}k(g){this.d[this.e++]=p.o(this.g,g),this.j+=g.newLength-g.oldLength}l(g){return g<this.h?this.c[g]:null}m(g){this.d[this.e++]=p.p(this.j,g),this.g+=g.newLength-g.oldLength}n(g){return g<this.f?this.a[g]:null}static o(g,A){return new L(A.oldPosition-g,A.oldText,A.newPosition,A.newText)}static p(g,A){return new L(A.oldPosition,A.oldText,A.newPosition+g,A.newText)}static q(g,A){const P=g.newText.substr(0,A),f=g.newText.substr(A);return[new L(g.oldPosition,g.oldText,g.newPosition,P),new L(g.oldEnd,"",g.newPosition+A,f)]}static r(g,A){const P=g.oldText.substr(0,A),f=g.oldText.substr(A);return[new L(g.oldPosition,P,g.newPosition,g.newText),new L(g.oldPosition+A,f,g.newEnd,"")]}static s(g){if(g.length===0)return g;const A=[];let P=0,f=g[0];for(let y=1;y<g.length;y++){const S=g[y];f.oldEnd===S.oldPosition?f=new L(f.oldPosition,f.oldText+S.oldText,f.newPosition,f.newText+S.newText):(A[P++]=f,f=S)}return A[P++]=f,A}static t(g){if(g.length===0)return g;const A=[];let P=0;for(let f=0;f<g.length;f++){const y=g[f];y.oldText!==y.newText&&(A[P++]=y)}return A}}}),define(ke[191],Se([1,0,34,16]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=void 0;function m(L,R,p,E,g,A){if(Array.isArray(L)){let P=0;for(const f of L){const y=m(f,R,p,E,g,A);if(y===10)return y;y>P&&(P=y)}return P}else{if(typeof L=="string")return E?L==="*"?5:L===p?10:0:0;if(L){const{language:P,pattern:f,scheme:y,hasAccessToAllModels:S,notebookType:w}=L;if(!E&&!S)return 0;w&&g&&(R=g);let c=0;if(y)if(y===R.scheme)c=10;else if(y==="*")c=5;else return 0;if(P)if(P===p)c=10;else if(P==="*")c=Math.max(c,5);else return 0;if(w)if(w===A)c=10;else if(w==="*"&&A!==void 0)c=Math.max(c,5);else return 0;if(f){let s;if(typeof f=="string"?s=f:s={...f,base:(0,F.$gc)(f.base)},s===R.fsPath||(0,I.$Aj)(s,R.fsPath))c=10;else return 0}return c}else return 0}}e.$KE=m}),define(ke[192],Se([1,0,4,13,29,80,128,167,190,3]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=void 0;class A extends g.$Rc{constructor(f,y,S,w,c,s,i){super(),this.m=this.B(new I.$Qd),this.onDidChangeContent=this.m.event,this.f=y,this.j=!s,this.g=w,this.h=c,this.c=new R.$KB(f,S,i)}equals(f){return!(f instanceof A)||this.f!==f.f||this.getEOL()!==f.getEOL()?!1:this.c.equal(f.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(f){return this.c.createSnapshot(f?this.f:"")}getOffsetAt(f,y){return this.c.getOffsetAt(f,y)}getPositionAt(f){return this.c.getPositionAt(f)}getRangeAt(f,y){const S=f+y,w=this.getPositionAt(f),c=this.getPositionAt(S);return new m.$zs(w.lineNumber,w.column,c.lineNumber,c.column)}getValueInRange(f,y=0){if(f.isEmpty())return"";const S=this.n(y);return this.c.getValueInRange(f,S)}getValueLengthInRange(f,y=0){if(f.isEmpty())return 0;if(f.startLineNumber===f.endLineNumber)return f.endColumn-f.startColumn;const S=this.getOffsetAt(f.startLineNumber,f.startColumn),w=this.getOffsetAt(f.endLineNumber,f.endColumn);let c=0;const s=this.n(y),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,o=f.endLineNumber-f.startLineNumber;c=n*o}return w-S+c}getCharacterCountInRange(f,y=0){if(this.j){let S=0;const w=f.startLineNumber,c=f.endLineNumber;for(let s=w;s<=c;s++){const i=this.getLineContent(s),n=s===w?f.startColumn-1:0,o=s===c?f.endColumn-1:i.length;for(let a=n;a<o;a++)F.$9e(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(y).length*(c-w),S}return this.getValueLengthInRange(f,y)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(f){return this.c.getLineContent(f)}getLineCharCode(f,y){return this.c.getLineCharCode(f,y)}getCharCode(f){return this.c.getCharCode(f)}getLineLength(f){return this.c.getLineLength(f)}getLineMinColumn(f){return 1}getLineMaxColumn(f){return this.getLineLength(f)+1}getLineFirstNonWhitespaceColumn(f){const y=F.$Te(this.getLineContent(f));return y===-1?0:y+1}getLineLastNonWhitespaceColumn(f){const y=F.$Ve(this.getLineContent(f));return y===-1?0:y+2}n(f){switch(f){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(f){this.c.setEOL(f)}applyEdits(f,y,S){let w=this.g,c=this.h,s=this.j,i=!0,n=[];for(let l=0;l<f.length;l++){const h=f[l];i&&h._isTracked&&(i=!1);const k=h.range;if(h.text){let C=!0;s||(C=!F.$hf(h.text),s=C),!w&&C&&(w=F.$gf(h.text)),!c&&C&&(c=F.$jf(h.text))}let D="",$=0,b=0,v=0;if(h.text){let C;[$,b,v,C]=(0,p.$_s)(h.text);const N=this.getEOL();C===0||C===(N===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,N)}n[l]={sortIndex:l,identifier:h.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:D,eolCount:$,firstLineLength:b,lastLineLength:v,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(A.u);let o=!1;for(let l=0,h=n.length-1;l<h;l++){const k=n[l].range.getEndPosition(),D=n[l+1].range.getStartPosition();if(D.isBeforeOrEqual(k)){if(D.isBefore(k))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const a=S||y?A._getInverseEditRanges(n):[],t=[];if(y)for(let l=0;l<n.length;l++){const h=n[l],k=a[l];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=k.startLineNumber;D<=k.endLineNumber;D++){let $="";D===k.startLineNumber&&($=this.getLineContent(h.range.startLineNumber),F.$Te($)!==-1)||t.push({lineNumber:D,oldContent:$})}}let r=null;if(S){let l=0;r=[];for(let h=0;h<n.length;h++){const k=n[h],D=a[h],$=this.getValueInRange(k.range),b=k.rangeOffset+l;l+=k.text.length-$.length,r[h]={sortIndex:k.sortIndex,identifier:k.identifier,range:D,text:$,textChange:new E.$Us(k.rangeOffset,$,b,k.text)}}o||r.sort((h,k)=>h.sortIndex-k.sortIndex)}this.g=w,this.h=c,this.j=s;const d=this.t(n);let u=null;if(y&&t.length>0){t.sort((l,h)=>h.lineNumber-l.lineNumber),u=[];for(let l=0,h=t.length;l<h;l++){const k=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===k)continue;const D=t[l].oldContent,$=this.getLineContent(k);$.length===0||$===D||F.$Te($)!==-1||u.push(k)}}return this.m.fire(),new L.$Uu(r,d,u)}s(f){return f.length<1e3?f:[this._toSingleEditOperation(f)]}_toSingleEditOperation(f){let y=!1;const S=f[0].range,w=f[f.length-1].range,c=new m.$zs(S.startLineNumber,S.startColumn,w.endLineNumber,w.endColumn);let s=S.startLineNumber,i=S.startColumn;const n=[];for(let d=0,u=f.length;d<u;d++){const l=f[d],h=l.range;y=y||l.forceMoveMarkers,n.push(this.getValueInRange(new m.$zs(s,i,h.startLineNumber,h.startColumn))),l.text.length>0&&n.push(l.text),s=h.endLineNumber,i=h.endColumn}const o=n.join(""),[a,t,r]=(0,p.$_s)(o);return{sortIndex:0,identifier:f[0].identifier,range:c,rangeOffset:this.getOffsetAt(c.startLineNumber,c.startColumn),rangeLength:this.getValueLengthInRange(c,0),text:o,eolCount:a,firstLineLength:t,lastLineLength:r,forceMoveMarkers:y,isAutoWhitespaceEdit:!1}}t(f){f.sort(A.w);const y=[];for(let S=0;S<f.length;S++){const w=f[S],c=w.range.startLineNumber,s=w.range.startColumn,i=w.range.endLineNumber,n=w.range.endColumn;if(c===i&&s===n&&w.text.length===0)continue;w.text?(this.c.delete(w.rangeOffset,w.rangeLength),this.c.insert(w.rangeOffset,w.text,!0)):this.c.delete(w.rangeOffset,w.rangeLength);const o=new m.$zs(c,s,i,n);y.push({range:o,rangeLength:w.rangeLength,text:w.text,rangeOffset:w.rangeOffset,forceMoveMarkers:w.forceMoveMarkers})}return y}findMatchesLineByLine(f,y,S,w){return this.c.findMatchesLineByLine(f,y,S,w)}getPieceTree(){return this.c}static _getInverseEditRange(f,y){const S=f.startLineNumber,w=f.startColumn,[c,s,i]=(0,p.$_s)(y);let n;if(y.length>0){const o=c+1;o===1?n=new m.$zs(S,w,S,w+s):n=new m.$zs(S,w,S+o-1,i+1)}else n=new m.$zs(S,w,S,w);return n}static _getInverseEditRanges(f){const y=[];let S=0,w=0,c=null;for(let s=0,i=f.length;s<i;s++){const n=f[s];let o,a;c?c.range.endLineNumber===n.range.startLineNumber?(o=S,a=w+(n.range.startColumn-c.range.endColumn)):(o=S+(n.range.startLineNumber-c.range.endLineNumber),a=n.range.startColumn):(o=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new m.$zs(o,a,o,a+n.firstLineLength):t=new m.$zs(o,a,o+r-1,n.lastLineLength+1)}else t=new m.$zs(o,a,o,a);S=t.endLineNumber,w=t.endColumn,y.push(t),c=n}return y}static u(f,y){const S=m.$zs.compareRangesUsingEnds(f.range,y.range);return S===0?f.sortIndex-y.sortIndex:S}static w(f,y){const S=m.$zs.compareRangesUsingEnds(f.range,y.range);return S===0?y.sortIndex-f.sortIndex:-S}}e.$LB=A}),define(ke[193],Se([1,0,13,128,192]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class L{constructor(E,g,A,P,f,y,S,w,c){this.a=E,this.b=g,this.c=A,this.d=P,this.e=f,this.f=y,this.g=S,this.h=w,this.j=c}k(E){const g=this.c+this.d+this.e,A=this.c+this.e;return g===0?E===1?`
`:`\r
`:A>g/2?`\r
`:`
`}create(E){const g=this.k(E),A=this.a;if(this.j&&(g===`\r
`&&(this.c>0||this.d>0)||g===`
`&&(this.c>0||this.e>0)))for(let f=0,y=A.length;f<y;f++){const S=A[f].buffer.replace(/\r\n|\r|\n/g,g),w=(0,F.$GB)(S);A[f]=new F.$JB(S,w)}const P=new m.$LB(A,this.b,g,this.f,this.g,this.h,this.j);return{textBuffer:P,disposable:P}}getFirstLineText(E){return this.a[0].buffer.substr(0,E).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(E){if(E.length===0)return;this.a.length===0&&I.$pf(E)&&(this.b=I.$of,E=E.substr(1));const g=E.charCodeAt(E.length-1);g===13||g>=55296&&g<=56319?(this.m(E.substr(0,E.length-1),!1),this.c=!0,this.d=g):(this.m(E,!1),this.c=!1,this.d=g)}m(E,g){!g&&E.length===0||(this.c?this.n(String.fromCharCode(this.d)+E):this.n(E))}n(E){const g=(0,F.$HB)(this.e,E);this.a.push(new F.$JB(E,g.lineStarts)),this.f+=g.cr,this.g+=g.lf,this.h+=g.crlf,g.isBasicASCII||(this.l=!1,this.j||(this.j=I.$gf(E)),this.k||(this.k=I.$jf(E)))}finish(E=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,E)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const E=this.a[this.a.length-1];E.buffer+=String.fromCharCode(this.d);const g=(0,F.$GB)(E.buffer);E.lineStarts=g,this.d===13&&this.f++}}}e.$MB=R}),define(ke[132],Se([1,0,22,12]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$=e.$E$=void 0;var m;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(m||(m={}));function L(P){for(let f=0,y=P.length;f<y;f+=4){const S=P[f+0],w=P[f+1],c=P[f+2],s=P[f+3];P[f+0]=s,P[f+1]=c,P[f+2]=w,P[f+3]=S}}function R(P){const f=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return F.$D()||L(f),I.$ee.wrap(f)}function p(P){const f=P.buffer;if(F.$D()||L(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const y=new Uint8Array(f.byteLength);return y.set(f),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function E(P){const f=new Uint32Array(g(P));let y=0;if(f[y++]=P.id,P.type==="full")f[y++]=1,f[y++]=P.data.length,f.set(P.data,y),y+=P.data.length;else{f[y++]=2,f[y++]=P.deltas.length;for(const S of P.deltas)f[y++]=S.start,f[y++]=S.deleteCount,S.data?(f[y++]=S.data.length,f.set(S.data,y),y+=S.data.length):f[y++]=0}return R(f)}e.$E$=E;function g(P){let f=0;if(f+=1+1,P.type==="full")f+=1+P.data.length;else{f+=1,f+=(1+1+1)*P.deltas.length;for(const y of P.deltas)y.data&&(f+=y.data.length)}return f}function A(P){const f=p(P);let y=0;const S=f[y++];if(f[y++]===1){const i=f[y++],n=f.subarray(y,y+i);return y+=i,{id:S,type:"full",data:n}}const c=f[y++],s=[];for(let i=0;i<c;i++){const n=f[y++],o=f[y++],a=f[y++];let t;a>0&&(t=f.subarray(y,y+a),y+=a),s[i]={start:n,deleteCount:o,data:t}}return{id:S,type:"delta",deltas:s}}e.$F$=A}),define(ke[194],Se([8,9]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[133],Se([1,0,19,24,12,170,127,194]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(ce){this.c=ce}hasChanged(ce){return this.c[ce]}}e.ConfigurationChangedEvent=g;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class P{constructor(ce,Ie,Ke,Ue){this.id=ce,this.name=Ie,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ce,Ie){return y(ce,Ie)}compute(ce,Ie,Ke){return Ke}}class f{constructor(ce,Ie){this.newValue=ce,this.didChange=Ie}}e.ApplyUpdateResult=f;function y(ue,ce){if(typeof ue!="object"||typeof ce!="object"||!ue||!ce)return new f(ce,ue!==ce);if(Array.isArray(ue)||Array.isArray(ce)){const Ke=Array.isArray(ue)&&Array.isArray(ce)&&I.$tb(ue,ce);return new f(ce,!Ke)}let Ie=!1;for(const Ke in ce)if(ce.hasOwnProperty(Ke)){const Ue=y(ue[Ke],ce[Ke]);Ue.didChange&&(ue[Ke]=Ue.newValue,Ie=!0)}return new f(ue,Ie)}class S{constructor(ce){this.schema=void 0,this.id=ce,this.name="_never_",this.defaultValue=void 0}applyUpdate(ce,Ie){return y(ce,Ie)}validate(ce){return this.defaultValue}}class w{constructor(ce,Ie,Ke,Ue){this.id=ce,this.name=Ie,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ce,Ie){return y(ce,Ie)}validate(ce){return typeof ce>"u"?this.defaultValue:ce}compute(ce,Ie,Ke){return Ke}}function c(ue,ce){return typeof ue>"u"?ce:ue==="false"?!1:!!ue}e.boolean=c;class s extends w{constructor(ce,Ie,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=Ke),super(ce,Ie,Ke,Ue)}validate(ce){return c(ce,this.defaultValue)}}function i(ue,ce,Ie,Ke){if(typeof ue>"u")return ce;let Ue=parseInt(ue,10);return isNaN(Ue)?ce:(Ue=Math.max(Ie,Ue),Ue=Math.min(Ke,Ue),Ue|0)}e.clampedInt=i;class n extends w{static clampedInt(ce,Ie,Ke,Ue){return i(ce,Ie,Ke,Ue)}constructor(ce,Ie,Ke,Ue,Ye,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ke,nt.minimum=Ue,nt.maximum=Ye),super(ce,Ie,Ke,nt),this.minimum=Ue,this.maximum=Ye}validate(ce){return n.clampedInt(ce,this.defaultValue,this.minimum,this.maximum)}}function o(ue,ce,Ie,Ke){if(typeof ue>"u")return ce;const Ue=a.float(ue,ce);return a.clamp(Ue,Ie,Ke)}e.clampedFloat=o;class a extends w{static clamp(ce,Ie,Ke){return ce<Ie?Ie:ce>Ke?Ke:ce}static float(ce,Ie){if(typeof ce=="number")return ce;if(typeof ce>"u")return Ie;const Ke=parseFloat(ce);return isNaN(Ke)?Ie:Ke}constructor(ce,Ie,Ke,Ue,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=Ke),super(ce,Ie,Ke,Ye),this.validationFn=Ue}validate(ce){return this.validationFn(a.float(ce,this.defaultValue))}}class t extends w{static string(ce,Ie){return typeof ce!="string"?Ie:ce}constructor(ce,Ie,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=Ke),super(ce,Ie,Ke,Ue)}validate(ce){return t.string(ce,this.defaultValue)}}function r(ue,ce,Ie,Ke){return typeof ue!="string"?ce:Ke&&ue in Ke?Ke[ue]:Ie.indexOf(ue)===-1?ce:ue}e.stringSet=r;class d extends w{constructor(ce,Ie,Ke,Ue,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Ue,Ye.default=Ke),super(ce,Ie,Ke,Ye),this.c=Ue}validate(ce){return r(ce,this.defaultValue,this.c)}}class u extends P{constructor(ce,Ie,Ke,Ue,Ye,nt,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=Ye,ct.default=Ue),super(ce,Ie,Ke,ct),this.c=Ye,this.d=nt}validate(ce){return typeof ce!="string"?this.defaultValue:this.c.indexOf(ce)===-1?this.defaultValue:this.d(ce)}}function l(ue){switch(ue){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(ce){switch(ce){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ce,Ie,Ke){return Ke===0?ce.accessibilitySupport:Ke}}class k extends P{constructor(){const ce={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ce,{"editor.comments.insertSpace":{type:"boolean",default:ce.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ce.ignoreEmptyLines,description:p.localize(5,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertSpace:c(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function $(ue){switch(ue){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(b||(e.TextEditorCursorStyle=b={}));function v(ue){switch(ue){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function C(ue){switch(ue){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class N extends S{constructor(){super(141)}compute(ce,Ie,Ke){const Ue=["monaco-editor"];return Ie.get(39)&&Ue.push(Ie.get(39)),ce.extraEditorClassName&&Ue.push(ce.extraEditorClassName),Ie.get(73)==="default"?Ue.push("mouse-default"):Ie.get(73)==="copy"&&Ue.push("mouse-copy"),Ie.get(111)&&Ue.push("showUnused"),Ie.get(139)&&Ue.push("showDeprecated"),Ue.join(" ")}}class j extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(ce,Ie,Ke){return Ke&&ce.emptySelectionClipboard}}class M extends P{constructor(){const ce={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ce,{"editor.find.cursorMoveOnType":{type:"boolean",default:ce.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ce.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ce.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ce.globalFindClipboard,description:p.localize(16,null),included:m.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ce.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:ce.loop,description:p.localize(18,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{cursorMoveOnType:c(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ce.seedSearchStringFromSelection=="boolean"?ce.seedSearchStringFromSelection?"always":"never":r(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ce.autoFindInSelection=="boolean"?ce.autoFindInSelection?"always":"never":r(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(Ie.loop,this.defaultValue.loop)}}}class O extends P{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?O.OFF:ce==="true"?O.ON:ce:ce?O.ON:O.OFF}}e.EditorFontLigatures=O;class z extends P{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(ce){return typeof ce>"u"?this.defaultValue:typeof ce=="string"?ce==="false"?z.OFF:ce==="true"?z.TRANSLATE:ce:ce?z.TRANSLATE:z.OFF}compute(ce,Ie,Ke){return ce.fontInfo.fontVariationSettings}}e.EditorFontVariations=z;class T extends S{constructor(){super(50)}compute(ce,Ie,Ke){return ce.fontInfo}}class W extends w{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(ce){const Ie=a.float(ce,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(ce,Ie,Ke){return ce.fontInfo.fontSize}}class V extends P{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.d,maximum:V.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(ce){return ce==="normal"||ce==="bold"?ce:String(n.clampedInt(ce,e.EDITOR_FONT_DEFAULTS.fontWeight,V.d,V.e))}}class de extends P{constructor(){const ce={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ce.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ce,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ce.alternativeDefinitionCommand,enum:Ke,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ce.alternativeTypeDefinitionCommand,enum:Ke,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ce.alternativeDeclarationCommand,enum:Ke,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ce.alternativeImplementationCommand,enum:Ke,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ce.alternativeReferenceCommand,enum:Ke,description:p.localize(41,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{multiple:r(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??r(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??r(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??r(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??r(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??r(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends P{constructor(){const ce={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ce,{"editor.hover.enabled":{type:"boolean",default:ce.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:ce.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ce.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ce.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:ce.above,description:p.localize(46,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:c(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:c(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:c(Ie.above,this.defaultValue.above)}}}var Z;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(Z||(e.RenderMinimap=Z={}));class J extends S{constructor(){super(144)}compute(ce,Ie,Ke){return J.computeLayout(Ie,{memory:ce.memory,outerWidth:ce.outerWidth,outerHeight:ce.outerHeight,isDominatedByLongLines:ce.isDominatedByLongLines,lineHeight:ce.fontInfo.lineHeight,viewLineCount:ce.viewLineCount,lineNumbersDigitCount:ce.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ce.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ce.fontInfo.maxDigitWidth,pixelRatio:ce.pixelRatio,glyphMarginDecorationLaneCount:ce.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ce){const Ie=ce.height/ce.lineHeight,Ke=Math.floor(ce.paddingTop/ce.lineHeight);let Ue=Math.floor(ce.paddingBottom/ce.lineHeight);ce.scrollBeyondLastLine&&(Ue=Math.max(Ue,Ie-1));const Ye=(Ke+ce.viewLineCount+Ue)/(ce.pixelRatio*ce.height),nt=Math.floor(ce.viewLineCount/Ye);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ue,desiredRatio:Ye,minimapLineCount:nt}}static c(ce,Ie){const Ke=ce.outerWidth,Ue=ce.outerHeight,Ye=ce.pixelRatio;if(!ce.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const nt=Ie.stableMinimapLayoutInput,ct=nt&&ce.outerHeight===nt.outerHeight&&ce.lineHeight===nt.lineHeight&&ce.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&ce.pixelRatio===nt.pixelRatio&&ce.scrollBeyondLastLine===nt.scrollBeyondLastLine&&ce.paddingTop===nt.paddingTop&&ce.paddingBottom===nt.paddingBottom&&ce.minimap.enabled===nt.minimap.enabled&&ce.minimap.side===nt.minimap.side&&ce.minimap.size===nt.minimap.size&&ce.minimap.showSlider===nt.minimap.showSlider&&ce.minimap.renderCharacters===nt.minimap.renderCharacters&&ce.minimap.maxColumn===nt.minimap.maxColumn&&ce.minimap.scale===nt.minimap.scale&&ce.verticalScrollbarWidth===nt.verticalScrollbarWidth&&ce.isViewportWrapping===nt.isViewportWrapping,bt=ce.lineHeight,Et=ce.typicalHalfwidthCharacterWidth,Kt=ce.scrollBeyondLastLine,Ht=ce.minimap.renderCharacters;let wt=Ye>=2?Math.round(ce.minimap.scale*2):ce.minimap.scale;const jt=ce.minimap.maxColumn,Ot=ce.minimap.size,Gt=ce.minimap.side,Ut=ce.verticalScrollbarWidth,Dt=ce.viewLineCount,Ft=ce.remainingWidth,Bt=ce.isViewportWrapping,Qt=Ht?2:3;let Wt=Math.floor(Ye*Ue);const qt=Wt/Ye;let Nt=!1,ut=!1,ft=Qt*wt,At=wt/Ye,Vt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Te,desiredRatio:Ce,minimapLineCount:ie}=J.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Kt,paddingTop:ce.paddingTop,paddingBottom:ce.paddingBottom,height:Ue,lineHeight:bt,pixelRatio:Ye});if(Dt/ie>1)Nt=!0,ut=!0,wt=1,ft=1,At=wt/Ye;else{let Ve=!1,xe=wt+1;if(Ot==="fit"){const Qe=Math.ceil((Me+Dt+Te)*ft);Bt&&ct&&Ft<=Ie.stableFitRemainingWidth?(Ve=!0,xe=Ie.stableFitMaxMinimapScale):Ve=Qe>Wt}if(Ot==="fill"||Ve){Nt=!0;const Qe=wt;ft=Math.min(bt*Ye,Math.max(1,Math.floor(1/Ce))),Bt&&ct&&Ft<=Ie.stableFitRemainingWidth&&(xe=Ie.stableFitMaxMinimapScale),wt=Math.min(xe,Math.max(1,Math.floor(ft/Qt))),wt>Qe&&(Vt=Math.min(2,wt/Qe)),At=wt/Ye/Vt,Wt=Math.ceil(Math.max(Jt,Me+Dt+Te)*ft),Bt?(Ie.stableMinimapLayoutInput=ce,Ie.stableFitRemainingWidth=Ft,Ie.stableFitMaxMinimapScale=wt):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const Lt=Math.floor(jt*At),at=Math.min(Lt,Math.max(0,Math.floor((Ft-Ut-2)*At/(Et+At)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(Ye*at);const Tt=vt/Ye;vt=Math.floor(vt*Vt);const Pt=Ht?1:2,Ge=Gt==="left"?0:Ke-at-Ut;return{renderMinimap:Pt,minimapLeft:Ge,minimapWidth:at,minimapHeightIsEditorHeight:Nt,minimapIsSampling:ut,minimapScale:wt,minimapLineHeight:ft,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:qt}}static computeLayout(ce,Ie){const Ke=Ie.outerWidth|0,Ue=Ie.outerHeight|0,Ye=Ie.lineHeight|0,nt=Ie.lineNumbersDigitCount|0,ct=Ie.typicalHalfwidthCharacterWidth,bt=Ie.maxDigitWidth,Et=Ie.pixelRatio,Kt=Ie.viewLineCount,Ht=ce.get(136),wt=Ht==="inherit"?ce.get(135):Ht,jt=wt==="inherit"?ce.get(131):wt,Ot=ce.get(134),Gt=Ie.isDominatedByLongLines,Ut=ce.get(57),Dt=ce.get(67).renderType!==0,Ft=ce.get(68),Bt=ce.get(105),Qt=ce.get(84),Wt=ce.get(72),qt=ce.get(103),Nt=qt.verticalScrollbarSize,ut=qt.verticalHasArrows,ft=qt.arrowSize,At=qt.horizontalScrollbarSize,Vt=ce.get(43),Lt=ce.get(110)!=="never";let at=ce.get(65);Vt&&Lt&&(at+=16);let vt=0;if(Dt){const kt=Math.max(nt,Ft);vt=Math.round(kt*bt)}let Tt=0;Ut&&(Tt=Ye*Ie.glyphMarginDecorationLaneCount);let Pt=0,Ge=Pt+Tt,Jt=Ge+vt,Me=Jt+at;const Te=Ke-Tt-vt-at;let Ce=!1,ie=!1,Fe=-1;wt==="inherit"&&Gt?(Ce=!0,ie=!0):jt==="on"||jt==="bounded"?ie=!0:jt==="wordWrapColumn"&&(Fe=Ot);const Ve=J.c({outerWidth:Ke,outerHeight:Ue,lineHeight:Ye,typicalHalfwidthCharacterWidth:ct,pixelRatio:Et,scrollBeyondLastLine:Bt,paddingTop:Qt.top,paddingBottom:Qt.bottom,minimap:Wt,verticalScrollbarWidth:Nt,viewLineCount:Kt,remainingWidth:Te,isViewportWrapping:ie},Ie.memory||new A);Ve.renderMinimap!==0&&Ve.minimapLeft===0&&(Pt+=Ve.minimapWidth,Ge+=Ve.minimapWidth,Jt+=Ve.minimapWidth,Me+=Ve.minimapWidth);const xe=Te-Ve.minimapWidth,Qe=Math.max(1,Math.floor((xe-Nt-2)/ct)),rt=ut?ft:0;return ie&&(Fe=Math.max(1,Qe),jt==="bounded"&&(Fe=Math.min(Fe,Ot))),{width:Ke,height:Ue,glyphMarginLeft:Pt,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:Ge,lineNumbersWidth:vt,decorationsLeft:Jt,decorationsWidth:at,contentLeft:Me,contentWidth:xe,minimap:Ve,viewportColumn:Qe,isWordWrapMinified:Ce,isViewportWrapping:ie,wrappingColumn:Fe,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:At,overviewRuler:{top:rt,width:Nt,height:Ue-2*rt,right:0}}}}e.EditorLayoutInfoComputer=J;class ae extends P{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(ce){return r(ce,"simple",["simple","advanced"])}compute(ce,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}class x extends P{constructor(){const ce={enabled:!0};super(64,"lightbulb",ce,{"editor.lightbulb.enabled":{type:"boolean",default:ce.enabled,description:p.localize(50,null)}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{enabled:c(ce.enabled,this.defaultValue.enabled)}}}class Ee extends P{constructor(){const ce={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ce,{"editor.stickyScroll.enabled":{type:"boolean",default:ce.enabled,description:p.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ce.maxLineCount,minimum:1,maximum:10,description:p.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ce.defaultModel,description:p.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ce.scrollWithEditor,description:p.localize(54,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:c(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:c(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class le extends P{constructor(){const ce={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",ce,{"editor.inlayHints.enabled":{type:"string",default:ce.enabled,description:p.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(56,null),p.localize(57,null,m.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(58,null,m.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ce.fontSize,markdownDescription:p.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ce.fontFamily,markdownDescription:p.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ce.padding,description:p.localize(62,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:r(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:c(Ie.padding,this.defaultValue.padding)}}}class K extends P{constructor(){super(65,"lineDecorationsWidth",10)}validate(ce){return typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)?-parseFloat(ce.substring(0,ce.length-2)):n.clampedInt(ce,this.defaultValue,0,1e3)}compute(ce,Ie,Ke){return Ke<0?n.clampedInt(-Ke*ce.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class U extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ce=>a.clamp(ce,0,150),{markdownDescription:p.localize(63,null)})}compute(ce,Ie,Ke){return ce.fontInfo.lineHeight}}class ne extends P{constructor(){const ce={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ce,{"editor.minimap.enabled":{type:"boolean",default:ce.enabled,description:p.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ce.autohide,description:p.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(66,null),p.localize(67,null),p.localize(68,null)],default:ce.size,description:p.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ce.side,description:p.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ce.showSlider,description:p.localize(71,null)},"editor.minimap.scale":{type:"number",default:ce.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ce.renderCharacters,description:p.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ce.maxColumn,description:p.localize(74,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:c(Ie.enabled,this.defaultValue.enabled),autohide:c(Ie.autohide,this.defaultValue.autohide),size:r(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ie.side,this.defaultValue.side,["right","left"]),showSlider:r(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(ue){return ue==="ctrlCmd"?m.$j?"metaKey":"ctrlKey":"altKey"}class G extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(76,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class Y extends P{constructor(){const ce={enabled:!0,cycle:!0};super(86,"parameterHints",ce,{"editor.parameterHints.enabled":{type:"boolean",default:ce.enabled,description:p.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ce.cycle,description:p.localize(78,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:c(Ie.enabled,this.defaultValue.enabled),cycle:c(Ie.cycle,this.defaultValue.cycle)}}}class X extends S{constructor(){super(142)}compute(ce,Ie,Ke){return ce.pixelRatio}}class $e extends P{constructor(){const ce={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(79,null),p.localize(80,null),p.localize(81,null)]}];super(89,"quickSuggestions",ce,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ce.strings,description:p.localize(82,null)},comments:{anyOf:Ie,default:ce.comments,description:p.localize(83,null)},other:{anyOf:Ie,default:ce.other,description:p.localize(84,null)}},default:ce,markdownDescription:p.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ce}validate(ce){if(typeof ce=="boolean"){const Et=ce?"on":"off";return{comments:Et,strings:Et,other:Et}}if(!ce||typeof ce!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Ue}=ce,Ye=["on","inline","off"];let nt,ct,bt;return typeof Ie=="boolean"?nt=Ie?"on":"off":nt=r(Ie,this.defaultValue.other,Ye),typeof Ke=="boolean"?ct=Ke?"on":"off":ct=r(Ke,this.defaultValue.comments,Ye),typeof Ue=="boolean"?bt=Ue?"on":"off":bt=r(Ue,this.defaultValue.strings,Ye),{other:nt,comments:ct,strings:bt}}}var re;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(re||(e.RenderLineNumbersType=re={}));class fe extends P{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(86,null),p.localize(87,null),p.localize(88,null),p.localize(89,null)],default:"on",description:p.localize(90,null)})}validate(ce){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ce<"u"&&(typeof ce=="function"?(Ie=4,Ke=ce):ce==="interval"?Ie=3:ce==="relative"?Ie=2:ce==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function te(ue){const ce=ue.get(98);return ce==="editable"?ue.get(91):ce!=="on"}e.filterValidationDecorations=te;class he extends P{constructor(){const ce=[],Ie={type:"number",description:p.localize(91,null)};super(102,"rulers",ce,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:p.localize(92,null),format:"color-hex"}}}]},default:ce,description:p.localize(93,null)})}validate(ce){if(Array.isArray(ce)){const Ie=[];for(const Ke of ce)if(typeof Ke=="number")Ie.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ue=Ke;Ie.push({column:n.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Ie.sort((Ke,Ue)=>Ke.column-Ue.column),Ie}return this.defaultValue}}class pe extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:ce}}function Pe(ue,ce){if(typeof ue!="string")return ce;switch(ue){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends P{constructor(){const ce={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ce,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(94,null),p.localize(95,null),p.localize(96,null)],default:"auto",description:p.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(98,null),p.localize(99,null),p.localize(100,null)],default:"auto",description:p.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ce.verticalScrollbarSize,description:p.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ce.horizontalScrollbarSize,description:p.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ce.scrollByPage,description:p.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ce.ignoreHorizontalScrollbarInContentHeight,description:p.localize(105,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce,Ke=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:c(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Ue,0,1e3),scrollByPage:c(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:c(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends P{constructor(){const ce={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ce,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.nonBasicASCII,description:p.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ce.invisibleCharacters,description:p.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ce.ambiguousCharacters,description:p.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeComments,description:p.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ce.includeStrings,description:p.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ce.allowedCharacters,description:p.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ce.allowedLocales,description:p.localize(112,null)}})}applyUpdate(ce,Ie){let Ke=!1;Ie.allowedCharacters&&ce&&(F.$dn(ce.allowedCharacters,Ie.allowedCharacters)||(ce={...ce,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ce&&(F.$dn(ce.allowedLocales,Ie.allowedLocales)||(ce={...ce,allowedLocales:Ie.allowedLocales},Ke=!0));const Ue=super.applyUpdate(ce,Ie);return Ke?new f(Ue.newValue,!0):Ue}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ce.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ce.allowedLocales,this.defaultValue.allowedLocales)}}c(ce,Ie){if(typeof ce!="object"||!ce)return Ie;const Ke={};for(const[Ue,Ye]of Object.entries(ce))Ye===!0&&(Ke[Ue]=!0);return Ke}}class se extends P{constructor(){const ce={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ce,{"editor.inlineSuggest.enabled":{type:"boolean",default:ce.enabled,description:p.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ce.showToolbar,enum:["always","onHover"],enumDescriptions:[p.localize(114,null),p.localize(115,null)],description:p.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ce.suppressSuggestions,description:p.localize(117,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:c(Ie.enabled,this.defaultValue.enabled),mode:r(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:c(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:c(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends P{constructor(){const ce={enabled:L.$9r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$9r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ce,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ce.enabled,markdownDescription:p.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ce.independentColorPoolPerBracketType,description:p.localize(119,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:c(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class _ extends P{constructor(){const ce={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ce,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],default:ce.bracketPairs,description:p.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(124,null),p.localize(125,null),p.localize(126,null)],default:ce.bracketPairsHorizontal,description:p.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ce.highlightActiveBracketPair,description:p.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:ce.indentation,description:p.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(130,null),p.localize(131,null),p.localize(132,null)],default:ce.highlightActiveIndentation,description:p.localize(133,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(ue,ce,Ie){const Ke=Ie.indexOf(ue);return Ke===-1?ce:Ie[Ke]}class ye extends P{constructor(){const ce={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ce,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(134,null),p.localize(135,null)],default:ce.insertMode,description:p.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ce.filterGraceful,description:p.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:ce.localityBonus,description:p.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ce.shareSuggestSelections,markdownDescription:p.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(140,null),p.localize(141,null),p.localize(142,null),p.localize(143,null)],default:ce.selectionMode,markdownDescription:p.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ce.snippetsPreventQuickSuggestions,description:p.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:ce.showIcons,description:p.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ce.showStatusBar,description:p.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:ce.preview,description:p.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ce.showInlineDetails,description:p.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{insertMode:r(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:c(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:c(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:c(Ie.preview,this.defaultValue.preview),previewMode:r(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(Ie.showMethods,this.defaultValue.showMethods),showFunctions:c(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:c(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(Ie.showFields,this.defaultValue.showFields),showVariables:c(Ie.showVariables,this.defaultValue.showVariables),showClasses:c(Ie.showClasses,this.defaultValue.showClasses),showStructs:c(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:c(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:c(Ie.showModules,this.defaultValue.showModules),showProperties:c(Ie.showProperties,this.defaultValue.showProperties),showEvents:c(Ie.showEvents,this.defaultValue.showEvents),showOperators:c(Ie.showOperators,this.defaultValue.showOperators),showUnits:c(Ie.showUnits,this.defaultValue.showUnits),showValues:c(Ie.showValues,this.defaultValue.showValues),showConstants:c(Ie.showConstants,this.defaultValue.showConstants),showEnums:c(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:c(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(Ie.showKeywords,this.defaultValue.showKeywords),showWords:c(Ie.showWords,this.defaultValue.showWords),showColors:c(Ie.showColors,this.defaultValue.showColors),showFiles:c(Ie.showFiles,this.defaultValue.showFiles),showReferences:c(Ie.showReferences,this.defaultValue.showReferences),showFolders:c(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:c(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:c(Ie.showUsers,this.defaultValue.showUsers),showIssues:c(Ie.showIssues,this.defaultValue.showIssues)}}}class je extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(183,null),default:!0,type:"boolean"}})}validate(ce){return!ce||typeof ce!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(ce.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:c(ce.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class _e extends P{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(184,null),p.localize(185,null),p.localize(186,null),p.localize(187,null)],description:p.localize(188,null),default:"same"}})}validate(ce){switch(ce){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ce,Ie,Ke){return Ie.get(2)===2?0:Ke}}class Ze extends S{constructor(){super(145)}compute(ce,Ie,Ke){const Ue=Ie.get(144);return{isDominatedByLongLines:ce.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class it extends P{constructor(){const ce={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ce,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ce.enabled,markdownDescription:p.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(191,null),p.localize(192,null)],default:"afterDrop"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:c(Ie.enabled,this.defaultValue.enabled),showDropSelector:r(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends P{constructor(){const ce={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ce,{"editor.pasteAs.enabled":{type:"boolean",default:ce.enabled,markdownDescription:p.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(195,null),p.localize(196,null)],default:"afterPaste"}})}validate(ce){if(!ce||typeof ce!="object")return this.defaultValue;const Ie=ce;return{enabled:c(Ie.enabled,this.defaultValue.enabled),showPasteSelector:r(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Oe="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:m.$j?Oe:m.$k?qe:Ae,fontWeight:"normal",fontSize:m.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var Xe;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.letterSpacing=63]="letterSpacing",ue[ue.lightbulb=64]="lightbulb",ue[ue.lineDecorationsWidth=65]="lineDecorationsWidth",ue[ue.lineHeight=66]="lineHeight",ue[ue.lineNumbers=67]="lineNumbers",ue[ue.lineNumbersMinChars=68]="lineNumbersMinChars",ue[ue.linkedEditing=69]="linkedEditing",ue[ue.links=70]="links",ue[ue.matchBrackets=71]="matchBrackets",ue[ue.minimap=72]="minimap",ue[ue.mouseStyle=73]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=75]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=77]="multiCursorModifier",ue[ue.multiCursorPaste=78]="multiCursorPaste",ue[ue.multiCursorLimit=79]="multiCursorLimit",ue[ue.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",ue[ue.occurrencesHighlight=81]="occurrencesHighlight",ue[ue.overviewRulerBorder=82]="overviewRulerBorder",ue[ue.overviewRulerLanes=83]="overviewRulerLanes",ue[ue.padding=84]="padding",ue[ue.pasteAs=85]="pasteAs",ue[ue.parameterHints=86]="parameterHints",ue[ue.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ue[ue.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=89]="quickSuggestions",ue[ue.quickSuggestionsDelay=90]="quickSuggestionsDelay",ue[ue.readOnly=91]="readOnly",ue[ue.readOnlyMessage=92]="readOnlyMessage",ue[ue.renameOnType=93]="renameOnType",ue[ue.renderControlCharacters=94]="renderControlCharacters",ue[ue.renderFinalNewline=95]="renderFinalNewline",ue[ue.renderLineHighlight=96]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=98]="renderValidationDecorations",ue[ue.renderWhitespace=99]="renderWhitespace",ue[ue.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ue[ue.roundedSelection=101]="roundedSelection",ue[ue.rulers=102]="rulers",ue[ue.scrollbar=103]="scrollbar",ue[ue.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=105]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=106]="scrollPredominantAxis",ue[ue.selectionClipboard=107]="selectionClipboard",ue[ue.selectionHighlight=108]="selectionHighlight",ue[ue.selectOnLineNumbers=109]="selectOnLineNumbers",ue[ue.showFoldingControls=110]="showFoldingControls",ue[ue.showUnused=111]="showUnused",ue[ue.snippetSuggestions=112]="snippetSuggestions",ue[ue.smartSelect=113]="smartSelect",ue[ue.smoothScrolling=114]="smoothScrolling",ue[ue.stickyScroll=115]="stickyScroll",ue[ue.stickyTabStops=116]="stickyTabStops",ue[ue.stopRenderingLineAfter=117]="stopRenderingLineAfter",ue[ue.suggest=118]="suggest",ue[ue.suggestFontSize=119]="suggestFontSize",ue[ue.suggestLineHeight=120]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ue[ue.suggestSelection=122]="suggestSelection",ue[ue.tabCompletion=123]="tabCompletion",ue[ue.tabIndex=124]="tabIndex",ue[ue.unicodeHighlighting=125]="unicodeHighlighting",ue[ue.unusualLineTerminators=126]="unusualLineTerminators",ue[ue.useShadowDOM=127]="useShadowDOM",ue[ue.useTabStops=128]="useTabStops",ue[ue.wordBreak=129]="wordBreak",ue[ue.wordSeparators=130]="wordSeparators",ue[ue.wordWrap=131]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=134]="wordWrapColumn",ue[ue.wordWrapOverride1=135]="wordWrapOverride1",ue[ue.wordWrapOverride2=136]="wordWrapOverride2",ue[ue.wrappingIndent=137]="wrappingIndent",ue[ue.wrappingStrategy=138]="wrappingStrategy",ue[ue.showDeprecated=139]="showDeprecated",ue[ue.inlayHints=140]="inlayHints",ue[ue.editorClassName=141]="editorClassName",ue[ue.pixelRatio=142]="pixelRatio",ue[ue.tabFocusMode=143]="tabFocusMode",ue[ue.layoutInfo=144]="layoutInfo",ue[ue.wrappingInfo=145]="wrappingInfo",ue[ue.defaultColorDecorators=146]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(197,null)})),acceptSuggestionOnEnter:Re(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(198,null),""],markdownDescription:p.localize(199,null)})),accessibilitySupport:Re(new h),accessibilityPageSize:Re(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(200,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",p.localize(201,null))),ariaRequired:Re(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Re(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(203,null),p.localize(204,null),""],description:p.localize(205,null)})),autoClosingComments:Re(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(206,null),p.localize(207,null),""],description:p.localize(208,null)})),autoClosingDelete:Re(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(209,null),""],description:p.localize(210,null)})),autoClosingOvertype:Re(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(211,null),""],description:p.localize(212,null)})),autoClosingQuotes:Re(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(213,null),p.localize(214,null),""],description:p.localize(215,null)})),autoIndent:Re(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[p.localize(216,null),p.localize(217,null),p.localize(218,null),p.localize(219,null),p.localize(220,null)],description:p.localize(221,null)})),automaticLayout:Re(new s(13,"automaticLayout",!1)),autoSurround:Re(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(222,null),p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),bracketPairColorization:Re(new oe),bracketPairGuides:Re(new _),stickyTabStops:Re(new s(116,"stickyTabStops",!1,{description:p.localize(226,null)})),codeLens:Re(new s(17,"codeLens",!0,{description:p.localize(227,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:p.localize(228,null)})),codeLensFontSize:Re(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(229,null)})),colorDecorators:Re(new s(20,"colorDecorators",!0,{description:p.localize(230,null)})),colorDecoratorActivatedOn:Re(new d(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(231,null),p.localize(232,null),p.localize(233,null)],description:p.localize(234,null)})),colorDecoratorsLimit:Re(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(235,null)})),columnSelection:Re(new s(22,"columnSelection",!1,{description:p.localize(236,null)})),comments:Re(new k),contextmenu:Re(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new s(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(237,null)})),cursorBlinking:Re(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:p.localize(238,null)})),cursorSmoothCaretAnimation:Re(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null)],description:p.localize(242,null)})),cursorStyle:Re(new u(28,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:p.localize(243,null)})),cursorSurroundingLines:Re(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(244,null)})),cursorSurroundingLinesStyle:Re(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(245,null),p.localize(246,null)],markdownDescription:p.localize(247,null)})),cursorWidth:Re(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(248,null)})),disableLayerHinting:Re(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new s(34,"domReadOnly",!1)),dragAndDrop:Re(new s(35,"dragAndDrop",!0,{description:p.localize(249,null)})),emptySelectionClipboard:Re(new j),dropIntoEditor:Re(new it),stickyScroll:Re(new Ee),experimentalWhitespaceRendering:Re(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(250,null),p.localize(251,null),p.localize(252,null)],description:p.localize(253,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new a(40,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:p.localize(254,null)})),find:Re(new M),fixedOverflowWidgets:Re(new s(42,"fixedOverflowWidgets",!1)),folding:Re(new s(43,"folding",!0,{description:p.localize(255,null)})),foldingStrategy:Re(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(256,null),p.localize(257,null)],description:p.localize(258,null)})),foldingHighlight:Re(new s(45,"foldingHighlight",!0,{description:p.localize(259,null)})),foldingImportsByDefault:Re(new s(46,"foldingImportsByDefault",!1,{description:p.localize(260,null)})),foldingMaximumRegions:Re(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(261,null)})),unfoldOnClickAfterEndOfLine:Re(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(262,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(263,null)})),fontInfo:Re(new T),fontLigatures2:Re(new O),fontSize:Re(new W),fontWeight:Re(new V),fontVariations:Re(new z),formatOnPaste:Re(new s(55,"formatOnPaste",!1,{description:p.localize(264,null)})),formatOnType:Re(new s(56,"formatOnType",!1,{description:p.localize(265,null)})),glyphMargin:Re(new s(57,"glyphMargin",!0,{description:p.localize(266,null)})),gotoLocation:Re(new de),hideCursorInOverviewRuler:Re(new s(59,"hideCursorInOverviewRuler",!1,{description:p.localize(267,null)})),hover:Re(new ee),inDiffEditor:Re(new s(61,"inDiffEditor",!1)),letterSpacing:Re(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>a.clamp(ue,-5,20),{description:p.localize(268,null)})),lightbulb:Re(new x),lineDecorationsWidth:Re(new K),lineHeight:Re(new U),lineNumbers:Re(new fe),lineNumbersMinChars:Re(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new s(69,"linkedEditing",!1,{description:p.localize(269,null)})),links:Re(new s(70,"links",!0,{description:p.localize(270,null)})),matchBrackets:Re(new d(71,"matchBrackets","always",["always","near","never"],{description:p.localize(271,null)})),minimap:Re(new ne),mouseStyle:Re(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new a(74,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:p.localize(272,null)})),mouseWheelZoom:Re(new s(75,"mouseWheelZoom",!1,{markdownDescription:p.localize(273,null)})),multiCursorMergeOverlapping:Re(new s(76,"multiCursorMergeOverlapping",!0,{description:p.localize(274,null)})),multiCursorModifier:Re(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[p.localize(275,null),p.localize(276,null)],markdownDescription:p.localize(277,null)})),multiCursorPaste:Re(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(278,null),p.localize(279,null)],markdownDescription:p.localize(280,null)})),multiCursorLimit:Re(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(281,null)})),occurrencesHighlight:Re(new s(81,"occurrencesHighlight",!0,{description:p.localize(282,null)})),multiDocumentOccurrencesHighlight:Re(new s(80,"multiDocumentOccurrencesHighlight",!1,{description:p.localize(283,null)})),overviewRulerBorder:Re(new s(82,"overviewRulerBorder",!0,{description:p.localize(284,null)})),overviewRulerLanes:Re(new n(83,"overviewRulerLanes",3,0,3)),padding:Re(new G),pasteAs:Re(new tt),parameterHints:Re(new Y),peekWidgetDefaultFocus:Re(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(285,null),p.localize(286,null)],description:p.localize(287,null)})),definitionLinkOpensInPeek:Re(new s(88,"definitionLinkOpensInPeek",!1,{description:p.localize(288,null)})),quickSuggestions:Re(new $e),quickSuggestionsDelay:Re(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(289,null)})),readOnly:Re(new s(91,"readOnly",!1)),readOnlyMessage:Re(new pe),renameOnType:Re(new s(93,"renameOnType",!1,{description:p.localize(290,null),markdownDeprecationMessage:p.localize(291,null)})),renderControlCharacters:Re(new s(94,"renderControlCharacters",!0,{description:p.localize(292,null),restricted:!0})),renderFinalNewline:Re(new d(95,"renderFinalNewline",m.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(293,null)})),renderLineHighlight:Re(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(294,null)],description:p.localize(295,null)})),renderLineHighlightOnlyWhenFocus:Re(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(296,null)})),renderValidationDecorations:Re(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(297,null),p.localize(298,null),p.localize(299,null),""],description:p.localize(300,null)})),revealHorizontalRightPadding:Re(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new s(101,"roundedSelection",!0,{description:p.localize(301,null)})),rulers:Re(new he),scrollbar:Re(new B),scrollBeyondLastColumn:Re(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(302,null)})),scrollBeyondLastLine:Re(new s(105,"scrollBeyondLastLine",!0,{description:p.localize(303,null)})),scrollPredominantAxis:Re(new s(106,"scrollPredominantAxis",!0,{description:p.localize(304,null)})),selectionClipboard:Re(new s(107,"selectionClipboard",!0,{description:p.localize(305,null),included:m.$k})),selectionHighlight:Re(new s(108,"selectionHighlight",!0,{description:p.localize(306,null)})),selectOnLineNumbers:Re(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Re(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(307,null),p.localize(308,null),p.localize(309,null)],description:p.localize(310,null)})),showUnused:Re(new s(111,"showUnused",!0,{description:p.localize(311,null)})),showDeprecated:Re(new s(139,"showDeprecated",!0,{description:p.localize(312,null)})),inlayHints:Re(new le),snippetSuggestions:Re(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(313,null),p.localize(314,null),p.localize(315,null),p.localize(316,null)],description:p.localize(317,null)})),smartSelect:Re(new je),smoothScrolling:Re(new s(114,"smoothScrolling",!1,{description:p.localize(318,null)})),stopRenderingLineAfter:Re(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new ye),inlineSuggest:Re(new se),inlineCompletionsAccessibilityVerbose:Re(new s(148,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(319,null)})),suggestFontSize:Re(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new s(121,"suggestOnTriggerCharacters",!0,{description:p.localize(322,null)})),suggestSelection:Re(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(323,null),p.localize(324,null),p.localize(325,null)],description:p.localize(326,null)})),tabCompletion:Re(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),tabIndex:Re(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new Q),unusualLineTerminators:Re(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(331,null),p.localize(332,null),p.localize(333,null)],description:p.localize(334,null)})),useShadowDOM:Re(new s(127,"useShadowDOM",!0)),useTabStops:Re(new s(128,"useTabStops",!0,{description:p.localize(335,null)})),wordBreak:Re(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(336,null),p.localize(337,null)],description:p.localize(338,null)})),wordSeparators:Re(new t(130,"wordSeparators",R.$0r,{description:p.localize(339,null)})),wordWrap:Re(new d(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(340,null),p.localize(341,null),p.localize(342,null),p.localize(343,null)],description:p.localize(344,null)})),wordWrapBreakAfterCharacters:Re(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new n(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(345,null)})),wordWrapOverride1:Re(new d(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new d(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new N),defaultColorDecorators:Re(new s(146,"defaultColorDecorators",!1,{markdownDescription:p.localize(346,null)})),pixelRatio:Re(new X),tabFocusMode:Re(new s(143,"tabFocusMode",!1,{markdownDescription:p.localize(347,null)})),layoutInfo:Re(new J),wrappingInfo:Re(new Ze),wrappingIndent:Re(new _e),wrappingStrategy:Re(new ae)}}),define(ke[195],Se([8,9]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[84],Se([1,0,79,2,168,29,178,195]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$qt=e.$pt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$ot=e.$nt=e.SymbolKinds=e.SymbolTag=e.$mt=e.$lt=e.SymbolKind=e.$kt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$jt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$it=e.$ht=e.$gt=void 0;class E{constructor(O,z,T){this.offset=O,this.type=z,this.language=T,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$gt=E;class g{constructor(O,z){this.tokens=O,this.endState=z,this._tokenizationResultBrand=void 0}}e.$ht=g;class A{constructor(O,z){this.tokens=O,this.endState=z,this._encodedTokenizationResultBrand=void 0}}e.$it=A;var P;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var f;(function(M){const O=new Map;O.set(0,I.$Zj.symbolMethod),O.set(1,I.$Zj.symbolFunction),O.set(2,I.$Zj.symbolConstructor),O.set(3,I.$Zj.symbolField),O.set(4,I.$Zj.symbolVariable),O.set(5,I.$Zj.symbolClass),O.set(6,I.$Zj.symbolStruct),O.set(7,I.$Zj.symbolInterface),O.set(8,I.$Zj.symbolModule),O.set(9,I.$Zj.symbolProperty),O.set(10,I.$Zj.symbolEvent),O.set(11,I.$Zj.symbolOperator),O.set(12,I.$Zj.symbolUnit),O.set(13,I.$Zj.symbolValue),O.set(15,I.$Zj.symbolEnum),O.set(14,I.$Zj.symbolConstant),O.set(15,I.$Zj.symbolEnum),O.set(16,I.$Zj.symbolEnumMember),O.set(17,I.$Zj.symbolKeyword),O.set(27,I.$Zj.symbolSnippet),O.set(18,I.$Zj.symbolText),O.set(19,I.$Zj.symbolColor),O.set(20,I.$Zj.symbolFile),O.set(21,I.$Zj.symbolReference),O.set(22,I.$Zj.symbolCustomColor),O.set(23,I.$Zj.symbolFolder),O.set(24,I.$Zj.symbolTypeParameter),O.set(25,I.$Zj.account),O.set(26,I.$Zj.issues);function z(V){let de=O.get(V);return de||(console.info("No codicon found for CompletionItemKind "+V),de=I.$Zj.symbolProperty),de}M.toIcon=z;const T=new Map;T.set("method",0),T.set("function",1),T.set("constructor",2),T.set("field",3),T.set("variable",4),T.set("class",5),T.set("struct",6),T.set("interface",7),T.set("module",8),T.set("property",9),T.set("event",10),T.set("operator",11),T.set("unit",12),T.set("value",13),T.set("constant",14),T.set("enum",15),T.set("enum-member",16),T.set("enumMember",16),T.set("keyword",17),T.set("snippet",27),T.set("text",18),T.set("color",19),T.set("file",20),T.set("reference",21),T.set("customcolor",22),T.set("folder",23),T.set("type-parameter",24),T.set("typeParameter",24),T.set("account",25),T.set("issue",26);function W(V,de){let ee=T.get(V);return typeof ee>"u"&&!de&&(ee=9),ee}M.fromString=W})(f||(e.CompletionItemKinds=f={}));var y;(function(M){M[M.Deprecated=1]="Deprecated"})(y||(e.CompletionItemTag=y={}));var S;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var w;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(e.CompletionTriggerKind=w={}));var c;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(c||(e.InlineCompletionTriggerKind=c={}));class s{constructor(O,z,T,W){this.range=O,this.text=z,this.completionKind=T,this.isSnippetText=W}equals(O){return L.$zs.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.$jt=s;var i;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var o;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function a(M){return M&&F.URI.isUri(M.uri)&&L.$zs.isIRange(M.range)&&(L.$zs.isIRange(M.originSelectionRange)||L.$zs.isIRange(M.targetSelectionRange))}e.$kt=a;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$lt={[17]:(0,p.localize)(0,null),[16]:(0,p.localize)(1,null),[4]:(0,p.localize)(2,null),[13]:(0,p.localize)(3,null),[8]:(0,p.localize)(4,null),[9]:(0,p.localize)(5,null),[21]:(0,p.localize)(6,null),[23]:(0,p.localize)(7,null),[7]:(0,p.localize)(8,null),[0]:(0,p.localize)(9,null),[11]:(0,p.localize)(10,null),[10]:(0,p.localize)(11,null),[19]:(0,p.localize)(12,null),[5]:(0,p.localize)(13,null),[1]:(0,p.localize)(14,null),[2]:(0,p.localize)(15,null),[20]:(0,p.localize)(16,null),[15]:(0,p.localize)(17,null),[18]:(0,p.localize)(18,null),[24]:(0,p.localize)(19,null),[3]:(0,p.localize)(20,null),[6]:(0,p.localize)(21,null),[14]:(0,p.localize)(22,null),[22]:(0,p.localize)(23,null),[25]:(0,p.localize)(24,null),[12]:(0,p.localize)(25,null)};function r(M,O){return(0,p.localize)(26,null,M,e.$lt[O])}e.$mt=r;var d;(function(M){M[M.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var u;(function(M){const O=new Map;O.set(0,I.$Zj.symbolFile),O.set(1,I.$Zj.symbolModule),O.set(2,I.$Zj.symbolNamespace),O.set(3,I.$Zj.symbolPackage),O.set(4,I.$Zj.symbolClass),O.set(5,I.$Zj.symbolMethod),O.set(6,I.$Zj.symbolProperty),O.set(7,I.$Zj.symbolField),O.set(8,I.$Zj.symbolConstructor),O.set(9,I.$Zj.symbolEnum),O.set(10,I.$Zj.symbolInterface),O.set(11,I.$Zj.symbolFunction),O.set(12,I.$Zj.symbolVariable),O.set(13,I.$Zj.symbolConstant),O.set(14,I.$Zj.symbolString),O.set(15,I.$Zj.symbolNumber),O.set(16,I.$Zj.symbolBoolean),O.set(17,I.$Zj.symbolArray),O.set(18,I.$Zj.symbolObject),O.set(19,I.$Zj.symbolKey),O.set(20,I.$Zj.symbolNull),O.set(21,I.$Zj.symbolEnumMember),O.set(22,I.$Zj.symbolStruct),O.set(23,I.$Zj.symbolEvent),O.set(24,I.$Zj.symbolOperator),O.set(25,I.$Zj.symbolTypeParameter);function z(T){let W=O.get(T);return W||(console.info("No codicon found for SymbolKind "+T),W=I.$Zj.symbolProperty),W}M.toIcon=z})(u||(e.SymbolKinds=u={}));class l{static asEditOperation(O){return m.$As.replace(L.$zs.lift(O.range),O.text)}}e.$nt=l;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(O){switch(O){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(O)}constructor(O){this.value=O}}e.$ot=h;var k;(function(M){function O(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}M.is=O})(k||(e.Command=k={}));var D;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(D||(e.CommentThreadCollapsibleState=D={}));var $;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})($||(e.CommentThreadState=$={}));var b;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(b||(e.CommentMode=b={}));var v;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(v||(e.CommentState=v={}));var C;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(C||(e.InlayHintKind=C={}));class N{constructor(O){this.b=O,this.a=null}dispose(){this.a&&this.a.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$pt=N,e.$qt=new R.$$s;var j;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}))}),define(ke[196],Se([8,9]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([8,9]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([8,9]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([8,9]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([8,9]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([8,9]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([8,9]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([8,9]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([8,9]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([8,9]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([8,9]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([8,9]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChat",e)}),define(ke[211],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[212],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[213],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[214],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[215],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[216],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[217],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[218],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[219],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[220],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[221],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[222],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[223],Se([8,9]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[224],Se([8,9]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[225],Se([8,9]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[226],Se([8,9]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[227],Se([8,9]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[228],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[229],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[230],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[231],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[232],Se([8,9]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[233],Se([8,9]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[234],Se([8,9]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[235],Se([8,9]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[236],Se([8,9]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[237],Se([8,9]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[238],Se([1,0,11,198]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.TokenType=void 0;var m;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(m||(e.TokenType=m={}));function L(...g){switch(g.length){case 1:return(0,F.localize)(0,null,g[0]);case 2:return(0,F.localize)(1,null,g[0],g[1]);case 3:return(0,F.localize)(2,null,g[0],g[1],g[2]);default:return}}const R=(0,F.localize)(3,null),p=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,I.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const P=this.d,f=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:f};this.g.push({offset:P,lexeme:f,additionalInfo:A}),this.f.push(y)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const P=this.c.substring(this.d,this.e),f=E.b.get(P);f?this.k(f):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,P=!1,f=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(p);return}const S=this.c.charCodeAt(A);if(P)P=!1;else if(S===47&&!f){A++;break}else S===91?f=!0:S===92?P=!0:S===93&&(f=!1);A++}for(;A<this.c.length&&E.a.has(this.c.charCodeAt(A));)A++;this.e=A;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$Pi=E}),define(ke[239],Se([1,0,23,39,201,388]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function E(s){return s=s.trim(),s==="*"||R.test(s)}e.$Qo=E;function g(s){if(!E(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$Ro=g;function A(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,o=s.minorBase;let a=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(i===0||(a=!1),r=!1);let d=0;if(s.preRelease){const u=p.exec(s.preRelease);if(u){const[,l,h,k]=u;d=Date.UTC(Number(l),Number(h)-1,Number(k))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:d}}e.$So=A;function P(s,i,n){let o;typeof s=="string"?o=A(g(s)):o=s;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=A(g(n)):t=n,!o||!t)return!1;const r=o.majorBase,d=o.minorBase,u=o.patchBase;let l=t.majorBase,h=t.minorBase,k=t.patchBase;const D=t.notBefore;let $=t.majorMustEqual,b=t.minorMustEqual,v=t.patchMustEqual;return t.isMinimum?r>l?!0:r<l?!1:d>h?!0:d<h||a&&a<D?!1:u>=k:(r===1&&l===0&&(!$||!b||!v)&&(l=1,h=0,k=0,$=!0,b=!1,v=!1),r<l?!1:r>l?!$:d<h?!1:d>h?!b:u<k?!1:u>k?!v:!(a&&a<D))}e.$To=P;function f(s,i,n,o,a){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([F.default.Error,m.localize(0,null)]),t;if(typeof o.name!="string")return t.push([F.default.Error,m.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([F.default.Error,m.localize(2,null,"version")]),t;if(!o.engines)return t.push([F.default.Error,m.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([F.default.Error,m.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!c(o.extensionDependencies))return t.push([F.default.Error,m.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!c(o.activationEvents))return t.push([F.default.Error,m.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([F.default.Error,m.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([F.default.Warning,m.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([F.default.Error,m.localize(9,null,"main")]),t;{const u=(0,I.$yg)(n,o.main);(0,I.$sg)(u,n)||t.push([F.default.Warning,m.localize(10,null,u.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([F.default.Error,m.localize(11,null,"browser")]),t;{const u=(0,I.$yg)(n,o.browser);(0,I.$sg)(u,n)||t.push([F.default.Warning,m.localize(12,null,u.path,n.path)])}}if(!L.valid(o.version))return t.push([F.default.Error,m.localize(13,null)]),t;const r=[];if(!y(s,i,o,a,r))for(const u of r)t.push([F.default.Error,u]);return t}e.$Uo=f;function y(s,i,n,o,a){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:w(s,i,n.engines.vscode,a)}e.$Vo=y;function S(s,i,n){return s==="*"||w(i,n,s)}e.$Wo=S;function w(s,i,n,o=[]){const a=A(g(n));if(!a)return o.push(m.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return o.push(m.localize(15,null,n)),!1}else if(!a.majorMustEqual)return o.push(m.localize(16,null,n)),!1;return P(s,i,a)?!0:(o.push(m.localize(17,null,s,n)),!1)}function c(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=void 0;class I{constructor(m,L=[],R=!1){this.ctor=m,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$Rh=I}),define(ke[106],Se([1,0,105]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const F=[];var m;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(m||(e.InstantiationType=m={}));function L(p,E,g){E instanceof I.$Rh||(E=new I.$Rh(E,[],!!g)),F.push([p,E])}e.$Cr=L;function R(){return F}e.$Dr=R}),define(ke[240],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;class I{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$gq=I;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const p=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(R);p.outgoing.set(E.key,E),E.incoming.set(p.key,p)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const p of this.a.values())p.outgoing.delete(R),p.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let p=this.a.get(R);return p||(p=new I(R,L),this.a.set(R,p)),p}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,p]of this.a)L.push(`${R}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const p=new Set([L]),E=this.c(R,p);if(E)return E}}c(L,R){for(const[p,E]of L.outgoing){if(R.has(p))return[...R,p].join(" -> ");R.add(p);const g=this.c(E,R);if(g)return g;R.delete(p)}}}e.$hq=F}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e._util=void 0;var I;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function p(E){return E[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=p})(I||(e._util=I={})),e.$Th=m("instantiationService");function F(R,p,E){p[I.DI_TARGET]===p?p[I.DI_DEPENDENCIES].push({id:R,index:E}):(p[I.DI_DEPENDENCIES]=[{id:R,index:E}],p[I.DI_TARGET]=p)}function m(R){if(I.serviceIds.has(R))return I.serviceIds.get(R);const p=function(E,g,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(p,E,A)};return p.toString=()=>R,I.serviceIds.set(R,p),p}e.$Uh=m;function L(R){return R}e.$Vh=L}),define(ke[44],Se([1,0,18,2,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.ConfigurationTarget=e.$qi=e.$pi=e.$oi=void 0,e.$oi=(0,m.$Uh)("configurationService");function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof F.URI)}e.$pi=L;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof F.URI)}e.$qi=R;var p;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function E(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ri=E;function g(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$si=g;function A(s,i){const n=Object.create(null);for(const o in s)P(n,o,s[o],i);return n}e.$ti=A;function P(s,i,n,o){const a=i.split("."),t=a.pop();let r=s;for(let d=0;d<a.length;d++){const u=a[d];let l=r[u];switch(typeof l){case"undefined":l=r[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(l)}`);return}r=l}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.$ui=P;function f(s,i){const n=i.split(".");y(s,n)}e.$vi=f;function y(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(y(o,i),Object.keys(o).length===0&&delete s[n])}}function S(s,i,n){function o(r,d){let u=r;for(const l of d){if(typeof u!="object"||u===null)return;u=u[l]}return u}const a=i.split("."),t=o(s,a);return typeof t>"u"?n:t}e.$wi=S;function w(s,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?I.$Df(s[o])&&I.$Df(i[o])?w(s[o],i[o],n):n&&(s[o]=i[o]):s[o]=i[o])})}e.$xi=w;function c(s){return s.replace(/[\[\]]/g,"")}e.$yi=c}),define(ke[45],Se([1,0,12,13,238,5,197,11]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.ContextKeyExprType=e.$Qi=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",I.$j),E.set("isLinux",I.$k),E.set("isWindows",I.$i),E.set("isWeb",I.$o),E.set("isMacNative",I.$j&&!I.$o),E.set("isEdge",I.$H),E.set("isFirefox",I.$F),E.set("isChrome",I.$E),E.set("isSafari",I.$G);function g(K,U){if(E.get(K)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(K,U)}e.$Qi=g;const A=Object.prototype.hasOwnProperty;var P;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const f={regexParsingWithErrorRecovery:!0},y=(0,R.localize)(0,null),S=(0,R.localize)(1,null),w=(0,R.localize)(2,null),c=(0,R.localize)(3,null),s=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=f){this.k=U,this.d=new m.$Pi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const be=this.D(),G=be.type===17?i:void 0;throw this.h.push({message:s,offset:be.offset,lexeme:m.$Pi.getLexeme(be),additionalInfo:G}),a.c}return ne}catch(ne){if(ne!==a.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,c),ne?.negate()}case 17:return this.z(),C.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,c),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const G=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),G.type!==10)throw this.B("REGEX",G);const Y=G.lexeme,X=Y.lastIndexOf("/"),$e=X===Y.length-1?void 0:this.w(Y.substring(X+1));let re;try{re=new RegExp(Y.substring(1,X),$e)}catch{throw this.B("REGEX",G)}return T.create(ne,re)}switch(G.type){case 10:case 19:{const Y=[G.lexeme];this.z();let X=this.D(),$e=0;for(let pe=0;pe<G.lexeme.length;pe++)G.lexeme.charCodeAt(pe)===40?$e++:G.lexeme.charCodeAt(pe)===41&&$e--;for(;!this.E()&&X.type!==15&&X.type!==16;){switch(X.type){case 0:$e++;break;case 1:$e--;break;case 10:case 18:for(let pe=0;pe<X.lexeme.length;pe++)X.lexeme.charCodeAt(pe)===40?$e++:G.lexeme.charCodeAt(pe)===41&&$e--}if($e<0)break;Y.push(m.$Pi.getLexeme(X)),this.z(),X=this.D()}const re=Y.join(""),fe=re.lastIndexOf("/"),te=fe===re.length-1?void 0:this.w(re.substring(fe+1));let he;try{he=new RegExp(re.substring(1,fe),te)}catch{throw this.B("REGEX",G)}return t.regex(ne,he)}case 18:{const Y=G.lexeme;this.z();let X=null;if(!(0,F.$Ee)(Y)){const $e=Y.indexOf("/"),re=Y.lastIndexOf("/");if($e!==re&&$e>=0){const fe=Y.slice($e+1,re),te=Y[re+1]==="i"?"i":"";try{X=new RegExp(fe,te)}catch{throw this.B("REGEX",G)}}}if(X===null)throw this.B("REGEX",G);return T.create(ne,X)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const G=this.u();return t.notIn(ne,G)}switch(this.D().type){case 3:{this.z();const G=this.u();if(this.x().type===18)return t.equals(ne,G);switch(G){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,G)}}case 4:{this.z();const G=this.u();if(this.x().type===18)return t.notEquals(ne,G);switch(G){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,G)}}case 5:return this.z(),O.create(ne,this.u());case 6:return this.z(),z.create(ne,this.u());case 7:return this.z(),j.create(ne,this.u());case 8:return this.z(),M.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:o}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,be){const G=(0,R.localize)(8,null,U,m.$Pi.getLexeme(ne)),Y=ne.offset,X=m.$Pi.getLexeme(ne);return this.h.push({message:G,offset:Y,lexeme:X,additionalInfo:be}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ri=a;class t{static false(){return l.INSTANCE}static true(){return h.INSTANCE}static has(U){return k.create(U)}static equals(U,ne){return D.create(U,ne)}static notEquals(U,ne){return v.create(U,ne)}static regex(U,ne){return T.create(U,ne)}static in(U,ne){return $.create(U,ne)}static notIn(U,ne){return b.create(U,ne)}static not(U){return C.create(U)}static and(...U){return de.create(U,null,!0)}static or(...U){return ee.create(U,null,!0)}static greater(U,ne){return j.create(U,ne)}static greaterEquals(U,ne){return M.create(U,ne)}static smaller(U,ne){return O.create(U,ne)}static smallerEquals(U,ne){return z.create(U,ne)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Si=t;function r(K){const U=new a({regexParsingWithErrorRecovery:!1});return K.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,R.localize)(9,null,be.additionalInfo):(0,R.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}e.$Ti=r;function d(K,U){const ne=K?K.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ne&&!be?!0:!ne||!be?!1:ne.equals(be)}e.$Ui=d;function u(K,U){return K.cmp(U)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Vi=l;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$Wi=h;class k{static create(U,ne=null){const be=E.get(U);return typeof be=="boolean"?be?h.INSTANCE:l.INSTANCE:new k(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:J(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=E.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:l.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Xi=k;class D{static create(U,ne,be=null){if(typeof ne=="boolean")return ne?k.create(U,be):C.create(U,be);const G=E.get(U);return typeof G=="boolean"?ne===(G?"true":"false")?h.INSTANCE:l.INSTANCE:new D(U,ne,be)}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?h.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Yi=D;class ${static create(U,ne){return new $(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ne)?ne.includes(be):typeof be=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$Zi=$;class b{static create(U,ne){return new b(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=$.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$1i=b;class v{static create(U,ne,be=null){if(typeof ne=="boolean")return ne?C.create(U,be):k.create(U,be);const G=E.get(U);return typeof G=="boolean"?ne===(G?"true":"false")?l.INSTANCE:h.INSTANCE:new v(U,ne,be)}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=E.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?l.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$2i=v;class C{static create(U,ne=null){const be=E.get(U);return typeof be=="boolean"?be?l.INSTANCE:h.INSTANCE:new C(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:J(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=E.get(this.c);return typeof U=="boolean"?U?l.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$3i=C;function N(K,U){if(typeof K=="string"){const ne=parseFloat(K);isNaN(ne)||(K=ne)}return typeof K=="string"||typeof K=="number"?U(K):l.INSTANCE}class j{static create(U,ne,be=null){return N(ne,G=>new j(U,G,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$4i=j;class M{static create(U,ne,be=null){return N(ne,G=>new M(U,G,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$5i=M;class O{static create(U,ne,be=null){return N(ne,G=>new O(U,G,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$6i=O;class z{static create(U,ne,be=null){return N(ne,G=>new z(U,G,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ae(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$7i=z;class T{static create(U,ne){return new T(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",be=U.f?U.f.source:"";return ne<be?-1:ne>be?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ne===be}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$8i=T;class W{static create(U){return new W(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new W(this.c.map(U))}negate(){return this.c}}e.$9i=W;function V(K){let U=null;for(let ne=0,be=K.length;ne<be;ne++){const G=K[ne].substituteConstants();if(K[ne]!==G&&U===null){U=[];for(let Y=0;Y<ne;Y++)U[Y]=K[Y]}U!==null&&(U[ne]=G)}return U===null?K:U}class de{static create(U,ne,be){return de.d(U,ne,be)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const G=u(this.expr[ne],U.expr[ne]);if(G!==0)return G}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=V(this.expr);return U===this.expr?this:de.create(U,this.c,!1)}evaluate(U){for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,be){const G=[];let Y=!1;for(const X of U)if(X){if(X.type===1){Y=!0;continue}if(X.type===0)return l.INSTANCE;if(X.type===6){G.push(...X.expr);continue}G.push(X)}if(G.length===0&&Y)return h.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(u);for(let X=1;X<G.length;X++)G[X-1].equals(G[X])&&(G.splice(X,1),X--);if(G.length===1)return G[0];for(;G.length>1;){const X=G[G.length-1];if(X.type!==9)break;G.pop();const $e=G.pop(),re=G.length===0,fe=ee.create(X.expr.map(te=>de.create([te,$e],null,be)),null,re);fe&&(G.push(fe),G.sort(u))}if(G.length===1)return G[0];if(be){for(let X=0;X<G.length;X++)for(let $e=X+1;$e<G.length;$e++)if(G[X].negate().equals(G[$e]))return l.INSTANCE;if(G.length===1)return G[0]}return new de(G,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new de(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=ee.create(U,this,!0)}return this.c}}e.$0i=de;class ee{static create(U,ne,be){return ee.d(U,ne,be)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const G=u(this.expr[ne],U.expr[ne]);if(G!==0)return G}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=V(this.expr);return U===this.expr?this:ee.create(U,this.c,!1)}evaluate(U){for(let ne=0,be=this.expr.length;ne<be;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,be){let G=[],Y=!1;if(U){for(let X=0,$e=U.length;X<$e;X++){const re=U[X];if(re){if(re.type===0){Y=!0;continue}if(re.type===1)return h.INSTANCE;if(re.type===9){G=G.concat(re.expr);continue}G.push(re)}}if(G.length===0&&Y)return l.INSTANCE;G.sort(u)}if(G.length!==0){if(G.length===1)return G[0];for(let X=1;X<G.length;X++)G[X-1].equals(G[X])&&(G.splice(X,1),X--);if(G.length===1)return G[0];if(be){for(let X=0;X<G.length;X++)for(let $e=X+1;$e<G.length;$e++)if(G[X].negate().equals(G[$e]))return h.INSTANCE;if(G.length===1)return G[0]}return new ee(G,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new ee(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),be=U.shift(),G=[];for(const Y of le(ne))for(const X of le(be))G.push(de.create([Y,X],null,!1));U.unshift(ee.create(G,null,!1))}this.c=ee.create(U,this,!0)}return this.c}}e.$$i=ee;class Z extends k{static{this.d=[]}static all(){return Z.d.values()}constructor(U,ne,be){super(U,null),this.f=ne,typeof be=="object"?Z.d.push({...be,key:U}):be!==!0&&Z.d.push({key:U,description:be,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return v.create(this.key,U)}}e.$_i=Z,e.$aj=(0,L.$Uh)("contextKeyService");function J(K,U){return K<U?-1:K>U?1:0}function ae(K,U,ne,be){return K<ne?-1:K>ne?1:U<be?-1:U>be?1:0}function x(K,U){if(K.type===0||U.type===1)return!0;if(K.type===9)return U.type===9?Ee(K.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(x(K,ne))return!0;return!1}if(K.type===6){if(U.type===6)return Ee(U.expr,K.expr);for(const ne of K.expr)if(x(ne,U))return!0;return!1}return K.equals(U)}e.$bj=x;function Ee(K,U){let ne=0,be=0;for(;ne<K.length&&be<U.length;){const G=K[ne].cmp(U[be]);if(G<0)return!1;G===0&&ne++,be++}return ne===K.length}function le(K){return K.type===9?K.expr:[K]}}),define(ke[241],Se([1,0,23,39,199,5,102,12,24]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lv=e.$Kv=e.ConfirmResult=e.$Jv=e.$Iv=e.$Hv=void 0,e.$Hv=(0,L.$Uh)("dialogService");var g;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(g||(g={}));class A{a(c){return this.d(c,g.Confirmation)}b(c){return this.d(c,g.Prompt)}c(c){return this.d(c,g.Input)}d(c,s){const i=[];switch(s){case g.Confirmation:{const n=c;n.primaryButton?i.push(n.primaryButton):i.push((0,m.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,m.localize)(1,null));break}case g.Prompt:{const n=c;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,m.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,m.localize)(3,null))),i.length===0&&i.push((0,m.localize)(4,null));break}case g.Input:{const n=c;n.primaryButton?i.push(n.primaryButton):i.push((0,m.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,m.localize)(6,null));break}}return i}e(c){if(typeof c=="string")return c;if(typeof c=="number")return c===F.default.Info?"info":c===F.default.Error?"error":c===F.default.Warning?"warning":"none"}f(c,s,i){const n=[...c.buttons??[]];c.cancelButton&&typeof c.cancelButton!="string"&&typeof c.cancelButton!="boolean"&&n.push(c.cancelButton);let o=n[s]?.run({checkboxChecked:i});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:i}}}e.$Iv=A,e.$Jv=(0,L.$Uh)("fileDialogService");var P;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const f=10;function y(w){const c=[];return c.push(...w.slice(0,f).map(s=>typeof s=="string"?s:(0,I.$vg)(s))),w.length>f&&(w.length-f===1?c.push((0,m.localize)(7,null)):c.push((0,m.localize)(8,null,w.length-f))),c.push(""),c.join(`
`)}e.$Kv=y;function S(w,c){const s=(0,E.$_m)(w);let i=(s.buttons??[]).map(t=>(0,R.$Ev)(t)),n=(w.buttons||[]).map((t,r)=>r),o=0,a=s.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(p.$k||p.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const r=n[a];n.splice(a,1),n.splice(1,0,r),a=1}p.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),o=i.length-1,typeof t=="string"&&(a=o-1))}else if(p.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const r=n[a];n.splice(a,1),n.push(r),a=i.length-1}}return s.buttons=i,s.defaultId=o,s.cancelId=a,s.noLink=!0,s.title=s.title||c.nameLong,{options:s,buttonIndeces:n}}e.$Lv=S}),define(ke[134],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=void 0,e.$2h=(0,I.$Uh)("environmentService"),e.$3h=(0,I.$Vh)(e.$2h)}),define(ke[135],Se([1,0,200,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$co=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0,e.$3n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$4n=new RegExp(e.$3n),e.$5n="__web_extension",e.$6n="skipWalkthrough",e.$7n="extensionsSync",e.$8n="dependecyOrPackExtensionInstall";function m(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$9n=m;function L(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$0n=L;function R(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$$n=R;function p(s,i){return i==="web"&&!s.includes("web")}e.$_n=p;function E(s,i,n){return p(i,n)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===n}e.$ao=E;function g(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$bo=g;var A;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var P;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var f;(function(s){s.Install="install",s.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var y;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$co=(0,F.$Uh)("extensionGalleryService");var S;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var w;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class c extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$do=c,e.$eo=(0,F.$Uh)("extensionManagementService"),e.$fo="extensionsIdentifiers/disabled",e.$go="extensionsIdentifiers/enabled",e.$ho=(0,F.$Uh)("IGlobalExtensionEnablementService"),e.$io=(0,F.$Uh)("IExtensionTipsService"),e.$jo=(0,I.localize)(0,null),e.$ko={value:e.$jo,original:"Extensions"},e.$lo={value:(0,I.localize)(1,null),original:"Preferences"}}),define(ke[242],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yZb=e.$xZb=void 0,e.$xZb=(0,I.$Uh)("externalTerminal"),e.$yZb="Terminal.app"}),define(ke[243],Se([1,0,50,17,16,12,101,30,104,202,242]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8b=e.$v8b=e.$u8b=void 0;const P=g.localize(0,null);class f{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends f{static{this.b="cmd.exe"}openTerminal(o,a){return this.spawnTerminal(I,o,E.$Gl(),a)}spawnTerminal(o,a,t,r){const d=a.windowsExec||y.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=m.$mc(d,".exe").toLowerCase();if(u==="cmder")return o.spawn(d,r?[r]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return d.indexOf(" ")>=0&&l.push('""'),l.push(d),u==="wt"&&l.push("-d ."),new Promise((h,k)=>{const D=c(process),$=o.spawn(t,l,{cwd:r,env:D});$.on("error",k),$.on("exit",()=>h())})}runInTerminal(o,a,t,r,d){const u="windowsExec"in d&&d.windowsExec?d.windowsExec:y.getDefaultTerminalWindows();return new Promise((l,h)=>{const k=`"${a} - ${P}"`,D=`""${t.join('" "')}" & pause"`,$=Object.assign({},c(process),r);Object.keys($).filter(j=>$[j]===null).forEach(j=>delete $[j]);const b={cwd:a,env:$,windowsVerbatimArguments:!0};let v,C;m.$mc(u,".exe")==="wt"?(v=u,C=["-d",".",y.b,"/c",D]):(v=y.b,C=["/c","start",k,"/wait",u,"/c",D]),I.spawn(v,C,b).on("error",j=>{h(s(j))}),l(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return y.d}}e.$u8b=y;class S extends f{static{this.b="/usr/bin/osascript"}openTerminal(o,a){return this.spawnTerminal(I,o,a)}runInTerminal(o,a,t,r,d){const u=d.osxExec||A.$yZb;return new Promise((l,h)=>{if(u===A.$yZb||u==="iTerm.app"){const k=u===A.$yZb?"TerminalHelper":"iTermHelper",$=[F.$fg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",o||P,"-w",a];for(const C of t)$.push("-a"),$.push(C);if(r){const C=Object.assign({},c(process),r);for(const N in C){const j=C[N];j===null?($.push("-u"),$.push(N)):($.push("-e"),$.push(`${N}=${j}`))}}let b="";const v=I.spawn(S.b,$);v.on("error",C=>{h(s(C))}),v.stderr.on("data",C=>{b+=C.toString()}),v.on("exit",C=>{if(C===0)l(void 0);else if(b){const N=b.split(`
`,1);h(new Error(N[0]))}else h(new Error(g.localize(1,null,k,C)))})}else h(new Error(g.localize(2,null,u)))})}spawnTerminal(o,a,t){const r=a.osxExec||A.$yZb;return new Promise((d,u)=>{const l=["-a",r];t&&l.push(t);const h=c(process),k=o.spawn("/usr/bin/open",l,{cwd:t,env:h});k.on("error",u),k.on("exit",()=>d())})}}e.$v8b=S;class w extends f{static{this.b=g.localize(3,null)}openTerminal(o,a){return this.spawnTerminal(I,o,a)}runInTerminal(o,a,t,r,d){const u=d.linuxExec?Promise.resolve(d.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,h)=>{const k=[];u.then(D=>{D.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const $=`${i(t)}; echo; read -p "${w.b}" -n1;`;k.push(`''${$}''`);const b=Object.assign({},c(process),r);Object.keys(b).filter(j=>b[j]===null).forEach(j=>delete b[j]);const v={cwd:a,env:b};let C="";const N=I.spawn(D,k,v);N.on("error",j=>{h(s(j))}),N.stderr.on("data",j=>{C+=j.toString()}),N.on("exit",j=>{if(j===0)l(void 0);else if(C){const M=C.split(`
`,1);h(new Error(M[0]))}else h(new Error(g.localize(4,null,D,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!L.$k)w.d=Promise.resolve("xterm");else{const o=await p.Promises.exists("/etc/debian_version");w.d=new Promise(a=>{o?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return w.d}spawnTerminal(o,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,u)=>{r.then(l=>{const h=c(process),k=o.spawn(l,[],{cwd:t,env:h});k.on("error",u),k.on("exit",()=>d())})})}}e.$w8b=w;function c(n){const o={...n.env};return(0,R.$El)(o),o}function s(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(g.localize(5,null,n.path)):n}function i(n){let o="";for(const a of n)a.indexOf(" ")>=0?o+='"'+a+'"':o+=a,o+=" ";return o}}),define(ke[31],Se([1,0,78,16,13,18,2,203,5,12,17,48]),function(me,e,I,F,m,L,R,p,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileKind=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileOperationResult=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileChangeType=e.$vk=e.FileOperation=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileSystemProviderErrorCode=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileSystemProviderCapabilities=e.$fk=e.FilePermission=e.FileType=e.$ek=e.$dk=void 0,e.$dk=(0,E.$Uh)("fileService");function f(x){return x.create===!0}e.$ek=f;var y;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var S;(function(x){x[x.Readonly=1]="Readonly",x[x.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function w(x){const Ee=x;return!!Ee&&typeof Ee.onDidChange=="function"}e.$fk=w;var c;(function(x){x[x.None=0]="None",x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock",x[x.FileAtomicRead=16384]="FileAtomicRead",x[x.FileAtomicWrite=32768]="FileAtomicWrite",x[x.FileAtomicDelete=65536]="FileAtomicDelete",x[x.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function s(x){return!!(x.capabilities&2)}e.$gk=s;function i(x){return!!(x.capabilities&8)}e.$hk=i;function n(x){return!!(x.capabilities&131072)}e.$ik=n;function o(x){return!!(x.capabilities&4)}e.$jk=o;function a(x){return!!(x.capabilities&16)}e.$kk=a;function t(x){return s(x)?!!(x.capabilities&16384):!1}e.$lk=t;function r(x){return s(x)?!!(x.capabilities&32768):!1}e.$mk=r;function d(x){return!!(x.capabilities&65536)}e.$nk=d;function u(x){return!!(x.capabilities&2048)}e.$ok=u;var l;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsStorageQuota="EntryExceedsStorageQuota",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class h extends Error{static create(Ee,le){const K=new h(Ee.toString(),le);return $(K,le),K}constructor(Ee,le){super(Ee),this.code=le}}e.$pk=h;function k(x,Ee){return h.create(x,Ee)}e.$qk=k;function D(x){return x||k((0,p.localize)(0,null),l.Unknown)}e.$rk=D;function $(x,Ee){return x.name=Ee?`${Ee} (FileSystemError)`:"FileSystemError",x}e.$sk=$;function b(x){if(!x)return l.Unknown;if(x instanceof h)return x.code;const Ee=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!Ee)return l.Unknown;switch(Ee[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.$tk=b;function v(x){if(x instanceof z)return x.fileOperationResult;switch(b(x)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.$uk=v;var C;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY",x[x.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class N{constructor(Ee,le,K){this.resource=Ee,this.operation=le,this.target=K}isOperation(Ee){return this.operation===Ee}}e.$vk=N;var j;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class M{static{this.a=null}constructor(Ee,le){this.c=le,this.b=void 0,this.d=new P.$U(()=>{const K=I.$1h.forUris(()=>this.c);return K.fill(this.rawAdded.map(U=>[U,!0])),K}),this.f=new P.$U(()=>{const K=I.$1h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(U=>[U,!0])),K}),this.g=new P.$U(()=>{const K=I.$1h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(U=>[U,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of Ee){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==M.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Ee,...le){return this.h(Ee,{includeChildren:!1},...le)}affects(Ee,...le){return this.h(Ee,{includeChildren:!0},...le)}h(Ee,le,...K){if(!Ee)return!1;const U=K.length>0;return!!((!U||K.includes(1))&&(this.d.value.get(Ee)||le.includeChildren&&this.d.value.findSuperstr(Ee))||(!U||K.includes(0))&&(this.f.value.get(Ee)||le.includeChildren&&this.f.value.findSuperstr(Ee))||(!U||K.includes(2))&&(this.g.value.findSubstr(Ee)||le.includeChildren&&this.g.value.findSuperstr(Ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ee){return this.b===Ee}hasCorrelation(){return typeof this.b=="number"}}e.$wk=M;function O(x,Ee,le){return!x||!Ee||x===Ee||Ee.length>x.length?!1:(Ee.charAt(Ee.length-1)!==F.sep&&(Ee+=F.sep),le?(0,m.$6e)(x,Ee):x.indexOf(Ee)===0)}e.$xk=O;class z extends Error{constructor(Ee,le,K){super(Ee),this.fileOperationResult=le,this.options=K}}e.$yk=z;class T extends z{constructor(Ee,le,K,U){super(Ee,le,U),this.fileOperationResult=le,this.size=K}}e.$zk=T;class W extends z{constructor(Ee,le,K){super(Ee,2,K),this.stat=le}}e.$Ak=W;var V;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$Bk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ck={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dk="files.associations",e.$Ek="files.exclude",e.$Fk="files.readonlyInclude",e.$Gk="files.readonlyExclude",e.$Hk="files.readonlyFromPermissions";var de;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(e.FileKind=de={})),e.$Ik="";function ee(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.$Jk=ee;async function Z(x,Ee){if(!Ee.hasProvider(R.URI.from({scheme:x.scheme})))return new Promise(le=>{const K=Ee.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===x.scheme&&U.added&&(K.dispose(),le())})})}e.$Kk=Z;class J{static{this.KB=1024}static{this.MB=J.KB*J.KB}static{this.GB=J.MB*J.KB}static{this.TB=J.GB*J.KB}static formatSize(Ee){return(0,L.$Ff)(Ee)||(Ee=0),Ee<J.KB?(0,p.localize)(1,null,Ee.toFixed(0)):Ee<J.MB?(0,p.localize)(2,null,(Ee/J.KB).toFixed(2)):Ee<J.GB?(0,p.localize)(3,null,(Ee/J.MB).toFixed(2)):Ee<J.TB?(0,p.localize)(4,null,(Ee/J.GB).toFixed(2)):(0,p.localize)(5,null,(Ee/J.TB).toFixed(2))}}e.$Lk=J;function ae(x){const Ee=typeof x=="string"||x?.scheme===A.Schemas.vscodeRemote;return typeof x!="string"&&x?.scheme===A.Schemas.file?1024*J.MB:Ee?10*J.MB:g.$o?50*J.MB:1024*J.MB}e.$Mk=ae}),define(ke[244],Se([1,0,22,11,204,31]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;async function R(A,P,f,y,S,w){let c;try{await p(A,P,f,y,S,w)}catch(s){c=s}finally{c&&S.errorTransformer&&(c=S.errorTransformer(c)),typeof c<"u"&&f.error(c),f.end()}}e.$Rp=R;async function p(A,P,f,y,S,w){E(w);const c=await A.open(P,{create:!1});try{E(w);let s=0,i=0,n=S&&typeof S.length=="number"?S.length:void 0,o=I.$ee.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await A.read(c,a,o.buffer,t,o.byteLength-t),a+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===o.byteLength&&(await f.write(y(o)),o=I.$ee.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&E(w)&&g(s,S));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),f.write(y(o.slice(0,r)))}}catch(s){throw(0,L.$rk)(s)}finally{await A.close(c)}}function E(A){if(A.isCancellationRequested)throw(0,F.$5)();return!0}function g(A,P){if(typeof P?.limits?.size=="number"&&A>P.limits.size)throw(0,L.$qk)((0,m.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[85],Se([1,0,34,3,16,12,2,31]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=void 0;function E(s){return s.recursive===!0}e.$Tp=E;class g extends F.$Rc{static{this.a=5}constructor(i,n,o,a){super(),this.h=i,this.j=n,this.m=o,this.n=a,this.c=this.B(new F.$Sc),this.f=void 0,this.g=0}s(){const i=new F.$Qc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Up=g;class A extends g{constructor(i,n,o){super(i,n,o,{type:"node.js",restartOnError:!1})}}e.$Vp=A;class P extends g{constructor(i,n,o){super(i,n,o,{type:"universal",restartOnError:!0})}}e.$Wp=P;function f(s){return s.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$Xp=f;function y(s){const i=new c;for(const n of s)i.processEvent(n);return i.coalesce()}e.$Yp=y;function S(s,i){return typeof i=="string"&&!i.startsWith(I.$xj)&&!(0,m.$hc)(i)?{base:s,pattern:i}:i}e.$Zp=S;function w(s,i){const n=[];for(const o of i)n.push((0,I.$Bj)(S(s,o)));return n}e.$1p=w;class c{constructor(){this.a=new Set,this.b=new Map}c(i){return L.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let o=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,a)=>o.resource.fsPath.length-a.resource.fsPath.length).filter(o=>n.some(a=>(0,p.$xk)(o.resource.fsPath,a,!L.$k))?!1:(n.push(o.resource.fsPath),!0)).concat(i)}}}),define(ke[245],Se([1,0,55,10,21,33,3,77,16,12,23,2,103,30,85]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class w extends R.$Rc{static{this.a=100}static{this.b=75}constructor(i,n,o,a){super(),this.m=i,this.n=n,this.r=o,this.s=a,this.c=this.B(new F.$_g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$$g(t=>this.z(t),w.b)),this.g=(0,S.$1p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$1p)(this.m.path,this.m.includes):void 0,this.j=new m.$1d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await y.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await y.Promises.realpath(i.path),i.path===n&&(n=await(0,f.$$p)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(g.$j&&(0,L.$1f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Rc.None;const o=new m.$1d(this.j.token),a=new R.$Qc;try{const t=P.URI.file(this.m.path),r=(0,E.$mc)(i),d=(0,I.watch)(i);a.add((0,R.$Pc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const h of await y.Promises.readdir(i))u.add(h)}catch(h){this.D(h)}const l=new Map;a.add((0,R.$Pc)(()=>{for(const[,h]of l)h.dispose();l.clear()})),d.on("error",(h,k)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${k})`),this.dispose()}),d.on("change",(h,k)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${k}`);let D="";if(k&&(D=k.toString(),g.$j&&(D=(0,p.$tl)(D))),!(!D||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){l.get(D)?.dispose();const $=setTimeout(async()=>{if(l.delete(D),D===r&&!await y.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.C((0,E.$ic)(i,D));if(o.token.isCancellationRequested)return;let v;b?u.has(D)?v=0:(v=1,u.add(D)):(u.delete(D),v=2),this.y({resource:(0,A.$yg)(t,D),type:v,cId:this.m.correlationId})},w.a);l.set(D,(0,R.$Pc)(()=>clearTimeout($)))}else{let $;u.has(D)?$=0:($=1,u.add(D)),this.y({resource:(0,A.$yg)(t,D),type:$,cId:this.m.correlationId})}else if(h==="rename"||D!==r){const $=setTimeout(async()=>{const b=await y.Promises.exists(i);o.token.isCancellationRequested||(b?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);a.clear(),a.add((0,R.$Pc)(()=>clearTimeout($)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await y.Promises.exists(i)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Pc)(()=>{o.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,S.$Yp)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(g.$k)return y.Promises.exists(i);try{const n=(0,E.$mc)(i);return(await y.Promises.readdir((0,E.$lc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$bq=w;async function c(s,i,n,o,a=512){const t=await y.Promises.open(s,"r"),r=Buffer.allocUnsafe(a),d=new m.$1d(o);let u,l=!1;const h={path:s,excludes:[],recursive:!1},k=new w(h,D=>{(async()=>{for(const{type:$}of D)if($===0){if(l)return;l=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:b}=await y.Promises.read(t,r,0,a,null);if(!b||d.token.isCancellationRequested)break;i(r.slice(0,b))}}catch(b){u=new Error(b),d.dispose(!0)}finally{l=!1}}})()});return await k.ready,n(),new Promise((D,$)=>{d.token.onCancellationRequested(async()=>{k.dispose();try{await y.Promises.close(t)}catch(b){u=new Error(b)}u?$(u):D()})})}e.$cq=c}),define(ke[246],Se([1,0,4,34,3,12,245]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class p extends m.$Rc{constructor(){super(...arguments),this.a=this.B(new I.$Qd),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Qd),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(g){const A=this.j(g),P=A.filter(y=>{const S=this.c.get(y.path);return S?!(0,F.$Fj)(S.request.excludes,y.excludes)||!(0,F.$Fj)(S.request.includes,y.includes):!0}),f=Array.from(this.c.values()).filter(({request:y})=>!A.find(S=>S.path===y.path&&(0,F.$Fj)(S.excludes,y.excludes)&&(0,F.$Fj)(S.includes,y.includes))).map(({request:y})=>y.path);P.length&&this.m(`Request to start watching: ${P.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`).join(",")}`),f.length&&this.m(`Request to stop watching: ${f.join(",")}`);for(const y of f)this.h(y);for(const y of P)this.g(y)}g(g){const A=new R.$bq(g,f=>this.a.fire(f),f=>this.b.fire(f),this.f),P={request:g,instance:A};this.c.set(g.path,P)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const A=this.c.get(g);A&&(this.c.delete(g),A.instance.dispose())}j(g){const A=new Map;for(const P of g){const f=L.$k?P.path:P.path.toLowerCase();let y=A.get(P.correlationId);y||(y=new Map,A.set(P.correlationId,y)),y.set(f,P)}return Array.from(A.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,A]of this.c)A.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,A){return A?`[File Watcher (node.js)] ${g} (path: ${A.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$dq=p}),define(ke[247],Se([1,0,85,246]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class m extends I.$Vp{constructor(R,p,E){super(R,p,E),this.s()}r(R){return R.add(new F.$dq)}}e.$eq=m}),define(ke[248],Se([1,0,17,82,187,85]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class R extends L.$Wp{constructor(E,g,A){super(E,g,A),this.s()}r(E){const g=E.add(new m.$8p(I.$fg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(g.onDidProcessExit(({code:A,signal:P})=>this.t(`terminated by itself with code ${A}, signal: ${P}`))),F.ProxyChannel.toService((0,F.$Bh)(g.getChannel("watcher")))}}e.$9p=R}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class I{constructor(...m){this.a=new Map;for(const[L,R]of m)this.set(L,R)}set(m,L){const R=this.a.get(m);return this.a.set(m,L),R}has(m){return this.a.has(m)}get(m){return this.a.get(m)}}e.$Sh=I}),define(ke[249],Se([1,0,10,11,3,105,240,5,107,76]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=void 0;const A=!1;class P extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class f{constructor(c=new E.$Sh,s=!1,i,n=A){this.f=c,this.g=s,this.h=i,this.i=n,this.o=new Set,this.f.set(p.$Th,this),this._globalGraph=n?i?._globalGraph??new R.$hq(o=>o):void 0}createChild(c){return new f(c,this.g,this,this.i)}invokeFunction(c,...s){const i=S.traceInvocation(this.i,c);let n=!1;try{return c({get:a=>{if(n)throw(0,F.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(c,...s){let i,n;return c instanceof L.$Rh?(i=S.traceCreation(this.i,c.ctor),n=this.j(c.ctor,c.staticArguments.concat(s),i)):(i=S.traceCreation(this.i,c),n=this.j(c,s,i)),i.stop(),n}j(c,s=[],i){const n=p._util.getServiceDependencies(c).sort((t,r)=>t.index-r.index),o=[];for(const t of n){const r=this.m(t.id,i);r||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(r)}const a=n.length>0?n[0].index:s.length;if(s.length!==a){console.trace(`[createInstance] First service dependency of ${c.name} at position ${a+1} conflicts with ${s.length} static arguments`);const t=a-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,a)}return Reflect.construct(c,s.concat(o))}k(c,s){if(this.f.get(c)instanceof L.$Rh)this.f.set(c,s);else if(this.h)this.h.k(c,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const s=this.f.get(c);return!s&&this.h?this.h.l(c):s}m(c,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const i=this.l(c);return i instanceof L.$Rh?this.q(c,i,s.branch(c,!0)):(s.branch(c,!1),i)}q(c,s,i){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,s,i)}finally{this.o.delete(c)}}r(c,s,i){const n=new R.$hq(t=>t.id.toString());let o=0;const a=[{id:c,desc:s,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new P(n);for(const r of p._util.getServiceDependencies(t.desc.ctor)){const d=this.l(r.id);if(d||this.u(`[createInstance] ${c} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),d instanceof L.$Rh){const u={id:r.id,desc:d,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,u),a.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new P(n);break}for(const{data:r}of t){if(this.l(r.id)instanceof L.$Rh){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}n.removeNode(r)}}return this.l(c)}s(c,s,i=[],n,o){if(this.f.get(c)instanceof L.$Rh)return this.t(c,s,i,n,o);if(this.h)return this.h.s(c,s,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(c,s,i=[],n,o){if(n){const a=new f(void 0,this.g,this,this.i);a.c=String(c);const t=new Map,r=new I.$dh(()=>{const d=a.j(s,i,o);for(const[u,l]of t){const h=d[u];if(typeof h=="function")for(const k of l)h.apply(d,k)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let k=t.get(u);return k||(k=new g.$1c,t.set(u,k)),($,b,v)=>{const C=k.push([$,b,v]);return(0,m.$Pc)(C)}}if(u in d)return d[u];const l=r.value;let h=l[u];return typeof h!="function"||(h=h.bind(l),d[u]=h),h},set(d,u,l){return r.value[u]=l,!0},getPrototypeOf(d){return s.prototype}})}else return this.j(s,i,o)}u(c,s){if(s&&console.warn(c),this.g)throw new Error(c)}}e.$iq=f;var y;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(y||(y={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,s){return c?new S(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(c,s){return c?new S(1,s.name):S.c}static{this.f=0}constructor(c,s){this.type=c,this.name=s,this.g=Date.now(),this.h=[]}branch(c,s){const i=new S(3,c.toString());return this.h.push([c,s,i]),i}stop(){const c=Date.now()-this.g;S.f+=c;let s=!1;function i(o,a){const t=[],r=new Array(o+1).join("	");for(const[d,u,l]of a.h)if(u&&l){s=!0,t.push(`${r}CREATES -> ${d}`);const h=i(o+1,l);h&&t.push(h)}else t.push(`${r}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(c>2||s)&&S.all.add(n.join(`
`))}}e.$jq=S}),define(ke[15],Se([1,0,43,4,52,3,28,12,23,18,2,45,5]),function(me,e,I,F,m,L,R,p,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.log=e.$fj=e.LogLevel=e.$ej=e.$dj=e.$cj=void 0,e.$cj=(0,f.$Uh)("logService"),e.$dj=(0,f.$Uh)("loggerService");function y(){return new Date().toISOString()}function S($){return(0,g.$Ff)($)}e.$ej=S;var w;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$fj=w.Info;function c($,b,v){switch(b){case w.Trace:$.trace(v);break;case w.Debug:$.debug(v);break;case w.Info:$.info(v);break;case w.Warning:$.warn(v);break;case w.Error:$.error(v);break;case w.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=c;function s($,b=!1){let v="";for(let C=0;C<$.length;C++){let N=$[C];if(N instanceof Error&&(N=(0,I.$Fi)(N,b)),typeof N=="object")try{N=JSON.stringify(N)}catch{}v+=(C>0?" ":"")+N}return v}class i extends L.$Rc{constructor(){super(...arguments),this.b=e.$fj,this.c=this.B(new F.$Qd),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==w.Off&&this.b<=b}}e.$hj=i;class n extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...v){this.f(w.Trace)&&this.g(w.Trace,s([b,...v],!0))}debug(b,...v){this.f(w.Debug)&&this.g(w.Debug,s([b,...v]))}info(b,...v){this.f(w.Info)&&this.g(w.Info,s([b,...v]))}warn(b,...v){this.f(w.Warning)&&this.g(w.Warning,s([b,...v]))}error(b,...v){if(this.f(w.Error))if(b instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=b.stack,this.g(w.Error,s(C))}else this.g(w.Error,s([b,...v]))}flush(){}}e.$ij=n;class o extends i{constructor(b=e.$fj){super(),this.setLevel(b),this.g=!p.$i}trace(b,...v){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}debug(b,...v){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}info(b,...v){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,b,...v):console.log(`[main ${y()}]`,b,...v))}warn(b,...v){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,b,...v):console.warn(`[main ${y()}]`,b,...v))}error(b,...v){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,b,...v):console.error(`[main ${y()}]`,b,...v))}dispose(){}flush(){}}e.$jj=o;class a extends i{constructor(b=e.$fj,v=!0){super(),this.g=v,this.setLevel(b)}trace(b,...v){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...v):console.log(b,...v))}debug(b,...v){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...v):console.log(b,...v))}info(b,...v){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...v):console.log(b,...v))}warn(b,...v){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...v):console.log(b,...v))}error(b,...v){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...v):console.error(b,...v))}dispose(){}flush(){}}e.$kj=a;class t extends i{constructor(b,v=e.$fj){super(),this.g=b,this.setLevel(v)}trace(b,...v){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(b),...v])}debug(b,...v){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(b),...v])}info(b,...v){this.f(w.Info)&&this.g.log(w.Info,[this.h(b),...v])}warn(b,...v){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(b),...v])}error(b,...v){this.f(w.Error)&&this.g.log(w.Error,[this.h(b),...v])}h(b){return typeof b=="string"?b:(0,I.$Fi)(b,this.f(w.Trace))}dispose(){}flush(){}}e.$lj=t;class r extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const v of this.g)v.setLevel(b);super.setLevel(b)}trace(b,...v){for(const C of this.g)C.trace(b,...v)}debug(b,...v){for(const C of this.g)C.debug(b,...v)}info(b,...v){for(const C of this.g)C.info(b,...v)}warn(b,...v){for(const C of this.g)C.warn(b,...v)}error(b,...v){for(const C of this.g)C.error(b,...v)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.$mj=r;class d extends L.$Rc{constructor(b,v,C){if(super(),this.h=b,this.j=v,this.b=new R.$zc,this.c=this.B(new F.$Qd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Qd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Qd),this.onDidChangeVisibility=this.g.event,C)for(const N of C)this.b.set(N.resource,{logger:void 0,info:N})}m(b){return(0,g.$Bf)(b)?[...this.b.values()].find(v=>v.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,v){const C=this.n(b),N=(0,g.$Bf)(b)?b:v?.id??(0,m.$Ii)(C.toString()).toString(16);let j=this.b.get(C)?.logger;const M=v?.logLevel==="always"?w.Trace:v?.logLevel;j||(j=this.s(C,M??this.getLogLevel(C)??this.h,{...v,id:N}));const O={logger:j,info:{resource:C,id:N,logLevel:M,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(O.info),this.b.set(C,O),j}n(b){return(0,g.$Bf)(b)?(0,E.$yg)(this.j,`${b}.log`):b}setLogLevel(b,v){if(A.URI.isUri(b)){const C=b,N=v,j=this.b.get(C);j&&N!==j.info.logLevel&&(j.info.logLevel=N===this.h?void 0:N,j.logger?.setLevel(N),this.b.set(j.info.resource,j),this.f.fire([C,N]))}else{this.h=b;for(const[C,N]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,v){const C=this.m(b);C&&v!==!C.info.hidden&&(C.info.hidden=!v,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,v]))}getLogLevel(b){let v;return b&&(v=this.b.get(b)?.info.logLevel),v??this.h}registerLogger(b){const v=this.b.get(b.resource);v?v.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const v=this.b.get(b);v&&(v.logger&&v.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$nj=d;class u{constructor(){this.onDidChangeLogLevel=new F.$Qd().event}setLevel(b){}getLevel(){return w.Info}trace(b,...v){}debug(b,...v){}info(b,...v){}warn(b,...v){}error(b,...v){}critical(b,...v){}dispose(){}flush(){}}e.$oj=u;class l extends u{}e.$pj=l;function h($){if($.verbose)return w.Trace;if(typeof $.logLevel=="string"){const b=D($.logLevel.toLowerCase());if(b!==void 0)return b}return e.$fj}e.$qj=h;function k($){switch($){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$rj=k;function D($){switch($){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$sj=D,e.$tj=new P.$_i("logLevel",k(w.Info))}),define(ke[250],Se([1,0,19,10,11,4,3,16,85,15]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class A extends R.$Rc{constructor(f,y){super(),this.a=f,this.b=y,this.c=this.B(new L.$Qd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Qd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$Ug(0)),this.w=[],this.y=this.B(new F.$Ug(0))}watch(f,y){return y.recursive||this.b?.watcher?.forceUniversal?this.n(f,y):this.z(f,y)}n(f,y){const S={path:this.H(f),excludes:y.excludes,includes:y.includes,recursive:y.recursive,correlationId:y.correlationId},w=(0,I.$Tb)(this.j,S);return this.r(),(0,R.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(f=>(0,m.$Z)(f))}s(){this.h||(this.h=this.B(this.t(y=>this.c.fire((0,E.$Xp)(y)),y=>this.G(y),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const f=this.b?.watcher?.recursive?.usePolling;if(f===!0)for(const y of this.j)(0,E.$Tp)(y)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const y of this.j)(0,E.$Tp)(y)&&f.includes(y.path)&&(y.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(f,y){const S={path:this.H(f),excludes:y.excludes,includes:y.includes,recursive:!1,correlationId:y.correlationId},w=(0,I.$Tb)(this.w,S);return this.C(),(0,R.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(f=>(0,m.$Z)(f))}D(){return this.u||(this.u=this.B(this.F(f=>this.c.fire((0,E.$Xp)(f)),f=>this.G(f),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(f){f.type==="error"&&this.g.fire(f.message),this.a[f.type](f.message)}H(f){return(0,p.$gc)(f.fsPath)}}e.$2p=A}),define(ke[251],Se([1,0,55,389,10,28,22,4,33,3,16,12,23,98,30,205,31,244,250,43,248,247]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0,(()=>{try{(0,F.gracefulify)(I)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.$Fi)(r)}`)}})();class t extends i.$2p{static{this.I=!1}constructor(d,u){super(d,u),this.onDidChangeCapabilities=p.Event.None,this.N=new L.$zc(l=>f.$pg.getComparisonKey(l)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:u,symbolicLink:l}=await S.SymlinkSupport.stat(this.H(d));return{type:this.M(u,l),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:c.FilePermission.Locked}}catch(u){throw this.fb(u)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const u=await S.Promises.readdir(this.H(d),{withFileTypes:!0}),l=[];return await Promise.all(u.map(async h=>{try{let k;h.isSymbolicLink()?k=(await this.stat((0,f.$yg)(d,h.name))).type:k=this.M(h),l.push([h.name,k])}catch(k){this.a.trace(k)}})),l}catch(u){throw this.fb(u)}}M(d,u){let l;return u?.dangling?l=c.FileType.Unknown:d.isFile()?l=c.FileType.File:d.isDirectory()?l=c.FileType.Directory:l=c.FileType.Unknown,u&&(l|=c.FileType.SymbolicLink),l}async O(d){const u=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let l;for(;l=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await l.wait();const h=new m.$Vg;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,g.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),h.open()})}async readFile(d,u){let l;try{u?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),l=await this.O(d));const h=this.H(d);return await S.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{l?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,u,l){const h=(0,y.$5d)(k=>R.$ee.concat(k.map(D=>R.$ee.wrap(D))).buffer);return(0,s.$Rp)(this,d,h,k=>k.buffer,{...u,bufferSize:256*1024},l),h}async writeFile(d,u,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,f.$yg)((0,f.$xg)(d),`${(0,f.$vg)(d)}${l.atomic.postfix}`),u,l):this.S(d,u,l)}async Q(d){try{const u=this.H(d),{symbolicLink:l}=await S.SymlinkSupport.stat(u);if(l)return!1}catch{}return!0}async R(d,u,l,h){const k=new g.$Qc;try{k.add(await this.O(d)),k.add(await this.O(u)),await this.S(u,l,h,!0);try{await this.rename(u,d,{overwrite:!0})}catch(D){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{k.dispose()}}async S(d,u,l,h){let k;try{const D=this.H(d);if(!l.create||!l.overwrite){if(await S.Promises.exists(D)){if(!l.overwrite)throw(0,c.$qk)((0,w.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,c.$qk)((0,w.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(d,{create:!0,unlock:l.unlock},h),await this.write(k,0,u,0,u.byteLength)}catch(D){throw await this.gb(d,D)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,u,l){const h=this.H(d);let k;(0,c.$ek)(u)&&!l&&(k=await this.O(d));let D;try{if((0,c.$ek)(u)&&u.unlock)try{const{stat:b}=await S.SymlinkSupport.stat(h);b.mode&128||await S.Promises.chmod(h,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}let $;if((0,c.$ek)(u)){if(P.$i)try{await S.Promises.truncate(h,0),$="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}$||($="w")}else $="r";D=await S.Promises.open(h,$)}catch($){throw k?.dispose(),(0,c.$ek)(u)?await this.gb(d,$):this.fb($)}if(this.U.set(D,0),(0,c.$ek)(u)&&this.X.set(D,d),k){const $=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.W.set(D,k),$&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),$.dispose())}return D}async close(d){const u=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await S.Promises.fdatasync(d)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await S.Promises.close(d)}catch(l){throw this.fb(l)}finally{u&&(this.W.get(d)===u&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),u.dispose())}}async read(d,u,l,h,k){const D=this.Z(d,u);let $=null;try{$=(await S.Promises.read(d,l,h,k,D)).bytesRead}catch(b){throw this.fb(b)}finally{this.$(d,D,$)}return $}Z(d,u){return u===this.U.get(d)?null:u}$(d,u,l){const h=this.U.get(d);typeof h=="number"&&(typeof u=="number"||(typeof l=="number"?this.U.set(d,h+l):this.U.delete(d)))}async write(d,u,l,h,k){return(0,m.$eh)(()=>this.ab(d,u,l,h,k),100,3)}async ab(d,u,l,h,k){const D=this.Z(d,u);let $=null;try{$=(await S.Promises.write(d,l,h,k,D)).bytesWritten}catch(b){throw await this.gb(this.X.get(d),b)}finally{this.$(d,D,$)}return $}async mkdir(d){try{await S.Promises.mkdir(this.H(d))}catch(u){throw this.fb(u)}}async delete(d,u){try{const l=this.H(d);if(u.recursive){let h;u?.atomic!==!1&&u.atomic.postfix&&(h=(0,A.$ic)((0,A.$lc)(l),`${(0,A.$mc)(l)}${u.atomic.postfix}`)),await S.Promises.rm(l,S.RimRafMode.MOVE,h)}else try{await S.Promises.unlink(l)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let k=!1;try{const{stat:D,symbolicLink:$}=await S.SymlinkSupport.stat(l);k=D.isDirectory()&&!$}catch{}if(k)await S.Promises.rmdir(l);else throw h}else throw h}}catch(l){throw this.fb(l)}}async rename(d,u,l){const h=this.H(d),k=this.H(u);if(h!==k)try{await this.bb(d,u,"move",l.overwrite),await S.Promises.rename(h,k)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(2,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(k)),D.toString()))),this.fb(D)}}async copy(d,u,l){const h=this.H(d),k=this.H(u);if(h!==k)try{await this.bb(d,u,"copy",l.overwrite),await S.Promises.copy(h,k,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(3,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(k)),D.toString()))),this.fb(D)}}async bb(d,u,l,h){const k=this.H(d),D=this.H(u);let $=!1;if(!!(this.capabilities&1024)||($=(0,E.$Zf)(k,D,!0)),$){if(l==="copy")throw(0,c.$qk)((0,w.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const v=await this.L(d);if(!v)throw(0,c.$qk)((0,w.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const C=await this.L(u);if(C){if(!h)throw(0,c.$qk)((0,w.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);v.type&c.FileType.File&&C.type&c.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,u){return this.cb(d,u,!1)}async cb(d,u,l){const h=this.H(d),k=this.H(u),D=!!(this.capabilities&1024);if((0,E.$Zf)(h,k,!D))return;const $=new g.$Qc;try{$.add(await this.O(d)),$.add(await this.O(u)),l&&await S.Promises.mkdir((0,A.$lc)(k),{recursive:!0}),await S.Promises.copyFile(h,k)}catch(b){if(b.code==="ENOENT"&&!l)return this.cb(d,u,!0);throw this.fb(b)}finally{$.dispose()}}t(d,u,l){return new o.$9p(h=>d(h),h=>u(h),l)}F(d,u,l){return new a.$eq(h=>d(h),h=>u(h),l)}fb(d){if(d instanceof c.$pk)return d;let u=d,l;switch(d.code){case"ENOENT":l=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=c.FileSystemProviderErrorCode.Unknown;break;default:l=c.FileSystemProviderErrorCode.Unknown}return(0,c.$qk)(u,l)}async gb(d,u){let l=this.fb(u);if(d&&l.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await S.SymlinkSupport.stat(this.H(d));h.mode&128||(l=(0,c.$qk)(u,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return l}}e.$fq=t}),define(ke[252],Se([1,0,3,15]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=void 0;class m extends I.$Rc{constructor(R,p=[]){super(),this.a=new F.$mj([R,...p]),this.B(R.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...p){this.a.trace(R,...p)}debug(R,...p){this.a.debug(R,...p)}info(R,...p){this.a.info(R,...p)}warn(R,...p){this.a.warn(R,...p)}error(R,...p){this.a.error(R,...p)}flush(){this.a.flush()}}e.$YN=m}),define(ke[253],Se([1,0,31,15]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;var m;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(m||(m={}));async function L(g,A,P,f,y){try{const S=await new Promise((c,s)=>{me(["@vscode/spdlog"],c,s)});S.setFlushOn(m.Trace);const w=await S.createAsyncRotatingLogger(g,A,P,f);return y?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function R(g,A,P){switch(A){case F.LogLevel.Trace:g.trace(P);break;case F.LogLevel.Debug:g.debug(P);break;case F.LogLevel.Info:g.info(P);break;case F.LogLevel.Warning:g.warn(P);break;case F.LogLevel.Error:g.error(P);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function p(g,A){switch(A){case F.LogLevel.Trace:g.setLevel(m.Trace);break;case F.LogLevel.Debug:g.setLevel(m.Debug);break;case F.LogLevel.Info:g.setLevel(m.Info);break;case F.LogLevel.Warning:g.setLevel(m.Warning);break;case F.LogLevel.Error:g.setLevel(m.Error);break;case F.LogLevel.Off:g.setLevel(m.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class E extends F.$ij{constructor(A,P,f,y,S){super(),this.m=[],this.setLevel(S),this.n=this.s(A,P,f,y),this.B(this.onDidChangeLogLevel(w=>{this.r&&p(this.r,w)}))}async s(A,P,f,y){const S=f?6:1,w=30/S*I.$Lk.MB,c=await L(A,P,w,S,y);if(c){this.r=c,p(this.r,this.getLevel());for(const{level:s,message:i}of this.m)R(this.r,s,i);this.m=[]}}g(A,P){this.r?R(this.r,A,P):this.getLevel()<=A&&this.m.push({level:A,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$NN=E}),define(ke[136],Se([1,0,39,206,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(E){function g(S,w){return w-S}E.compare=g;const A=Object.create(null);A[E.Error]=(0,F.localize)(0,null),A[E.Warning]=(0,F.localize)(1,null),A[E.Info]=(0,F.localize)(2,null);function P(S){return A[S]||""}E.toString=P;function f(S){switch(S){case I.default.Error:return E.Error;case I.default.Warning:return E.Warning;case I.default.Info:return E.Info;case I.default.Ignore:return E.Hint}}E.fromSeverity=f;function y(S){switch(S){case E.Error:return I.default.Error;case E.Warning:return I.default.Warning;case E.Info:return I.default.Info;case E.Hint:return I.default.Ignore}}E.toSeverity=y}(R||(e.MarkerSeverity=R={}));var p;(function(E){const g="";function A(f){return P(f,!0)}E.makeKey=A;function P(f,y){const S=[g];return f.source?S.push(f.source.replace("\xA6","\\\xA6")):S.push(g),f.code?typeof f.code=="string"?S.push(f.code.replace("\xA6","\\\xA6")):S.push(f.code.value.replace("\xA6","\\\xA6")):S.push(g),f.severity!==void 0&&f.severity!==null?S.push(R.toString(f.severity)):S.push(g),f.message&&y?S.push(f.message.replace("\xA6","\\\xA6")):S.push(g),f.startLineNumber!==void 0&&f.startLineNumber!==null?S.push(f.startLineNumber.toString()):S.push(g),f.startColumn!==void 0&&f.startColumn!==null?S.push(f.startColumn.toString()):S.push(g),f.endLineNumber!==void 0&&f.endLineNumber!==null?S.push(f.endLineNumber.toString()):S.push(g),f.endColumn!==void 0&&f.endColumn!==null?S.push(f.endColumn.toString()):S.push(g),S.push(g),S.join("\xA6")}E.makeKeyOptionalMessage=P})(p||(e.IMarkerData=p={})),e.$ft=(0,m.$Uh)("markerService")}),define(ke[254],Se([1,0,4,39,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$6u=e.Severity=void 0,e.Severity=F.default,e.$6u=(0,m.$Uh)("notificationService");var L;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var p;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(p||(e.NotificationsFilter=p={}));class E{constructor(){this.progress=new g,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.$7u=E;class g{infinite(){}done(){}total(P){}worked(P){}}e.$8u=g}),define(ke[137],Se([1,0,13,2,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RU=e.$QU=e.$PU=e.$OU=e.$NU=void 0,e.$NU=(0,m.$Uh)("openerService");function L(g,A){return F.URI.isUri(g)?(0,I.$5e)(g.scheme,A):(0,I.$6e)(g,A+":")}e.$OU=L;function R(g,...A){return A.some(P=>L(g,P))}e.$PU=R;function p(g,A){return g.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$QU=p;function E(g){let A;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return P&&(A={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},g=g.with({fragment:""})),{selection:A,uri:g}}e.$RU=E}),define(ke[255],Se([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let F;const m=globalThis.vscode;if(typeof m<"u"&&typeof m.context<"u"){const L=m.context.configuration();if(L)F=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(F=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(F,{nameShort:`${F.nameShort} Dev`,nameLong:`${F.nameLong} Dev`,dataFolderName:`${F.dataFolderName}-dev`,serverDataFolderName:F.serverDataFolderName?`${F.serverDataFolderName}-dev`:void 0}),!F.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(F,{version:L.version})}}else F={},Object.keys(F).length===0&&Object.assign(F,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=F}),define(ke[138],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=void 0,e.$uj=(0,I.$Uh)("productService"),e.$vj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(me,e){return function(I,F){e(I,F,me)}};define(ke[64],Se([1,0,10,21,3,5]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.ProgressLocation=e.$9u=void 0,e.$9u=(0,L.$Uh)("progressService");var R;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$0u=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(f){this.b=f}report(f){this.a=f,this.b(this.a)}}e.$$u=p;class E{get value(){return this.a}constructor(f){this.e=f}report(f){this.b?this.b.push(f):this.b=[f],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const f=this.b.shift();this.a=f,await this.e(this.a)}}finally{this.c=!1;const f=this.d;this.d=void 0,f?.()}}drain(){return this.c?new Promise(f=>{const y=this.d;this.d=()=>{y?.(),f()}}):Promise.resolve()}}e.$_u=E;let g=class extends m.$Rc{constructor(f,y){super(),this.a=new I.$hh,y.withProgress(f,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,m.$Pc)(()=>this.a.complete()))}report(f){this.b?this.b.report(f):this.c=f}};e.$av=g,e.$av=g=He([Be(1,e.$9u)],g);class A extends m.$Rc{constructor(f){super(),this.g=f,this.a=0,this.b=this.B(new m.$Qc)}start(f){this.stop();const y=++this.a,S=new F.$1d;return this.f=setTimeout(()=>{y===this.a&&(this.c=this.g.show(!0))},f),this.b.add((0,m.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,m.$Pc)(()=>S.cancel())),this.b.add((0,m.$Pc)(()=>this.c?this.c.done():void 0)),{id:y,token:S.token,stop:()=>this.h(y),isCurrent:()=>this.a===y}}stop(){this.h(this.a)}h(f){this.a===f&&this.b.clear()}}e.$bv=A,e.$cv=(0,L.$Uh)("editorProgressService")}),define(ke[38],Se([1,0,60,18]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;class m{constructor(){this.a=new Map}add(R,p){I.ok(F.$Bf(R)),I.ok(F.$Df(p)),I.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,p)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$ln=new m}),define(ke[108],Se([1,0,4,38]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0,e.$mn={JSONContribution:"base.contributions.json"};function m(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class L{constructor(){this.b=new I.$Qd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,g){this.a[m(E)]=g,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;F.$ln.add(e.$mn.JSONContribution,R)}),define(ke[86],Se([1,0,19,4,18,196,44,108,38]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.ConfigurationScope=e.$qn=e.EditPresentationTypes=void 0;var g;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$qn={Configuration:"base.contributions.configuration"};var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn="vscode://schemas/settings/resourceLanguage",e.$yn="vscode://schemas/settings/configurationDefaults";const P=E.$ln.as(p.$mn.JSONContribution);class f{constructor(){this.h=new Set,this.i=new F.$Qd,this.onDidSchemaChange=this.i.event,this.j=new F.$Qd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$xn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const d=new Set;this.n(t,r,d),P.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const r=new Set;this.o(t,r),P.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const d=new Set;this.o(r,d),this.n(t,!1,d),P.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const d=[];for(const{overrides:u,source:l}of t)for(const h in u)if(r.add(h),e.$An.test(h)){const k=this.a.get(h),D=k?.valuesSources??new Map;if(l)for(const C of Object.keys(u[h]))D.set(C,l);const $={...k?.value||{},...u[h]};this.a.set(h,{source:l,value:$,valuesSources:D});const b=(0,R.$yi)(h),v={type:"object",default:$,description:L.localize(1,null,b),$ref:e.$xn,defaultDefaultValue:$,source:m.$Bf(l)?void 0:l,defaultValueSource:l};d.push(...w(h)),this.d[h]=v,this.b.properties[h]=v}else{this.a.set(h,{value:u[h],source:l});const k=this.d[h];k&&(this.w(h,k),this.r(h,k))}this.m(d)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:d,source:u}of t)for(const l in d){const h=this.a.get(l),k=m.$Bf(u)?u:u?.id,D=m.$Bf(h?.source)?h?.source:h?.source?.id;if(k===D)if(r.add(l),this.a.delete(l),e.$An.test(l))delete this.d[l],delete this.b.properties[l];else{const $=this.d[l];$&&(this.w(l,$),this.r(l,$))}}this.u()}deltaConfiguration(t){let r=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,d){t.forEach(u=>{this.p(u,r,u.extensionInfo,u.restrictedProperties,void 0,d),this.c.push(u),this.q(u)})}o(t,r){const d=u=>{if(u.properties)for(const l in u.properties){r.add(l);const h=this.d[l];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[l],this.s(l,u.properties[l])}u.allOf?.forEach(l=>d(l))};for(const u of t){d(u);const l=this.c.indexOf(u);l!==-1&&this.c.splice(l,1)}}p(t,r=!0,d,u,l=3,h){l=m.$Kf(t.scope)?l:t.scope;const k=t.properties;if(k)for(const $ in k){const b=k[$];if(r&&n($,b)){delete k[$];continue}if(b.source=d,b.defaultDefaultValue=k[$].default,this.w($,b),e.$An.test($)?b.scope=void 0:(b.scope=m.$Kf(b.scope)?l:b.scope,b.restricted=m.$Kf(b.restricted)?!!u?.includes($):b.restricted),k[$].hasOwnProperty("included")&&!k[$].included){this.f[$]=k[$],delete k[$];continue}else this.d[$]=k[$],k[$].policy?.name&&this.e.set(k[$].policy.name,$);!k[$].deprecationMessage&&k[$].markdownDeprecationMessage&&(k[$].deprecationMessage=k[$].markdownDeprecationMessage),h.add($)}const D=t.allOf;if(D)for(const $ of D)this.p($,r,d,u,l,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=d=>{const u=d.properties;if(u)for(const h in u)this.r(h,u[h]);d.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$rn.properties[t]=r,r.scope){case 1:e.$sn.properties[t]=r;break;case 2:e.$tn.properties[t]=r;break;case 6:e.$un.properties[t]=r;break;case 3:e.$vn.properties[t]=r;break;case 4:e.$wn.properties[t]=r;break;case 5:e.$wn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$rn.properties[t],r.scope){case 1:delete e.$sn.properties[t];break;case 2:delete e.$tn.properties[t];break;case 6:delete e.$un.properties[t];break;case 3:delete e.$vn.properties[t];break;case 4:case 5:delete e.$wn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,d={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$xn};this.w(r,d),e.$rn.properties[r]=d,e.$sn.properties[r]=d,e.$tn.properties[r]=d,e.$un.properties[r]=d,e.$vn.properties[r]=d,e.$wn.properties[r]=d}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$xn};e.$rn.patternProperties[e.$zn]=t,e.$sn.patternProperties[e.$zn]=t,e.$tn.patternProperties[e.$zn]=t,e.$un.patternProperties[e.$zn]=t,e.$vn.patternProperties[e.$zn]=t,e.$wn.patternProperties[e.$zn]=t,this.i.fire()}w(t,r){const d=this.a.get(t);let u=d?.value,l=d?.source;m.$If(u)&&(u=r.defaultDefaultValue,l=void 0),m.$If(u)&&(u=s(r.type)),r.default=u,r.defaultValueSource=l}}const y="\\[([^\\]]+)\\]",S=new RegExp(y,"g");e.$zn=`^(${y})+$`,e.$An=new RegExp(e.$zn);function w(a){const t=[];if(e.$An.test(a)){let r=S.exec(a);for(;r?.length;){const d=r[1].trim();d&&t.push(d),r=S.exec(a)}}return(0,I.$Lb)(t)}e.$Bn=w;function c(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}e.$Cn=c;function s(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Dn=s;const i=new f;E.$ln.add(e.$qn.Configuration,i);function n(a,t){return a.trim()?e.$An.test(a)?L.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?L.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$En=n;function o(){const a=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Fn=o}),define(ke[256],Se([1,0,19,4,160,3,28,24,18,2,44,86,38]),function(me,e,I,F,m,L,R,p,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=void 0;function y(r){return Object.isFrozen(r)?r:p.$an(r)}class S{constructor(d={},u=[],l=[],h){this.b=d,this.c=u,this.d=l,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(u=>{if(u instanceof S)return u;const l=new w("");return l.parseRaw(u),l.configurationModel});this.f=d.reduce((u,l)=>l===u?l:u.merge(l),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$wi)(this.contents,d):this.contents}inspect(d,u){const l=this.rawConfiguration.getValue(d),h=u?this.rawConfiguration.getOverrideValue(d,u):void 0,k=u?this.rawConfiguration.override(u).getValue(d):l;return{value:l,override:h,merged:k}}getOverrideValue(d,u){const l=this.i(u);return l?d?(0,A.$wi)(l,d):l:void 0}getKeysForOverrideIdentifier(d){const u=[];for(const l of this.overrides)l.identifiers.includes(d)&&u.push(...l.keys);return I.$Lb(u)}getAllOverrideIdentifiers(){const d=[];for(const u of this.overrides)d.push(...u.identifiers);return I.$Lb(d)}override(d){let u=this.a.get(d);return u||(u=this.g(d),this.a.set(d,u)),u}merge(...d){const u=p.$_m(this.contents),l=p.$_m(this.overrides),h=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const D of d)if(k.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(u,D.contents);for(const $ of D.overrides){const[b]=l.filter(v=>I.$tb(v.identifiers,$.identifiers));b?(this.h(b.contents,$.contents),b.keys.push(...$.keys),b.keys=I.$Lb(b.keys)):l.push(p.$_m($))}for(const $ of D.keys)h.indexOf($)===-1&&h.push($)}return new S(u,h,l,k.every(D=>D instanceof S)?void 0:k)}g(d){const u=this.i(d);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const l={};for(const h of I.$Lb([...Object.keys(this.contents),...Object.keys(u)])){let k=this.contents[h];const D=u[h];D&&(typeof k=="object"&&typeof D=="object"?(k=p.$_m(k),this.h(k,D)):k=D),l[h]=k}return new S(l,this.keys,this.overrides)}h(d,u){for(const l of Object.keys(u)){if(l in d&&E.$Df(d[l])&&E.$Df(u[l])){this.h(d[l],u[l]);continue}d[l]=p.$_m(u[l])}}i(d){let u=null,l=null;const h=k=>{k&&(l?this.h(l,k):l=p.$_m(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===d?u=k.contents:k.identifiers.includes(d)&&h(k.contents);return h(u),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,u){this.j(d,u,!0)}setValue(d,u){this.j(d,u,!1)}removeValue(d){const u=this.keys.indexOf(d);u!==-1&&(this.keys.splice(u,1),(0,A.$vi)(this.contents,d),P.$An.test(d)&&this.overrides.splice(this.overrides.findIndex(l=>I.$tb(l.identifiers,(0,P.$Bn)(d))),1))}j(d,u,l){(0,A.$ui)(this.contents,d,u,h=>console.error(h)),l=l||this.keys.indexOf(d)===-1,l&&this.keys.push(d),P.$An.test(d)&&this.overrides.push({identifiers:(0,P.$Bn)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$ti)(this.contents[d],h=>console.error(h))})}}e.$Gn=S;class w{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,u){if(!E.$Kf(d)){const l=this.g(d);this.parseRaw(l,u)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,u){this.a=d;const{contents:l,keys:h,overrides:k,restricted:D,hasExcludedProperties:$}=this.h(d,u);this.b=new S(l,h,k,$?[d]:void 0),this.c=D||[]}g(d){let u={},l=null,h=[];const k=[],D=[];function $(v){Array.isArray(h)?h.push(v):l!==null&&(h[l]=v)}const b={onObjectBegin:()=>{const v={};$(v),k.push(h),h=v,l=null},onObjectProperty:v=>{l=v},onObjectEnd:()=>{h=k.pop()},onArrayBegin:()=>{const v=[];$(v),k.push(h),h=v,l=null},onArrayEnd:()=>{h=k.pop()},onLiteralValue:$,onError:(v,C,N)=>{D.push({error:v,offset:C,length:N})}};if(d)try{m.$9m(d,b),u=h[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return u}h(d,u){const l=f.$ln.as(P.$qn.Configuration).getConfigurationProperties(),h=this.i(d,l,!0,u);d=h.raw;const k=(0,A.$ti)(d,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),D=Object.keys(d),$=this.j(d,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:k,keys:D,overrides:$,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,u,l,h){let k=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:k};const D={},$=[];for(const b in d)if(P.$An.test(b)&&l){const v=this.i(d[b],u,!1,h);D[b]=v.raw,k=k||v.hasExcludedProperties,$.push(...v.restricted)}else{const v=u[b],C=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&$.push(b),!h.exclude?.includes(b)&&(h.include?.includes(b)||(C===void 0||h.scopes===void 0||h.scopes.includes(C))&&!(h.skipRestricted&&v?.restricted))?D[b]=d[b]:k=!0}return{raw:D,restricted:$,hasExcludedProperties:k}}j(d,u){const l=[];for(const h of Object.keys(d))if(P.$An.test(h)){const k={};for(const D in d[h])k[D]=d[h][D];l.push({identifiers:(0,P.$Bn)(h),keys:Object.keys(k),contents:(0,A.$ti)(k,u)})}return l}}e.$Hn=w;class c extends L.$Rc{constructor(d,u,l,h){super(),this.c=d,this.f=u,this.g=h,this.b=this.B(new F.$Qd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&l.isEqual(k.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$In=c;class s{constructor(d,u,l,h,k,D,$,b,v,C,N,j,M){this.a=d,this.b=u,this.c=l,this.overrideIdentifiers=h,this.d=k,this.f=D,this.g=$,this.h=b,this.i=v,this.j=C,this.k=N,this.l=j,this.m=M}get value(){return y(this.c)}n(d,u,l){const h=d.inspect(u,l);return{get value(){return y(h.value)},get override(){return y(h.override)},get merged(){return y(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,u,l,h,k=new S,D=new S,$=new R.$zc,b=new S,v=new R.$zc){this.c=d,this.d=u,this.f=l,this.g=h,this.h=k,this.i=D,this.j=$,this.l=b,this.m=v,this.a=null,this.b=new R.$zc,this.n=null}getValue(d,u,l){return this.q(d,u,l).getValue(d)}updateValue(d,u,l={}){let h;l.resource?(h=this.m.get(l.resource),h||(h=new S,this.m.set(l.resource,h))):h=this.l,u===void 0?h.removeValue(d):h.setValue(d,u),l.resource||(this.a=null)}inspect(d,u,l){const h=this.q(d,u,l),k=this.u(u.resource,l),D=u.resource?this.m.get(u.resource)||this.l:this.l,$=new Set;for(const b of h.overrides)for(const v of b.identifiers)h.getOverrideValue(d,v)!==void 0&&$.add(v);return new s(d,u,h.getValue(d),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,k||void 0,D)}keys(d){const u=this.u(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,u){this.j.set(d,u),this.b.delete(d)}deleteFolderConfiguration(d){this.p.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,u){const l=[];if(!u){const{added:h,updated:k,removed:D}=a(this.c,d);u=[...h,...k,...D]}for(const h of u)for(const k of(0,P.$Bn)(h)){const D=this.c.getKeysForOverrideIdentifier(k),$=d.getKeysForOverrideIdentifier(k),b=[...$.filter(v=>D.indexOf(v)===-1),...D.filter(v=>$.indexOf(v)===-1),...D.filter(v=>!p.$dn(this.c.override(k).getValue(v),d.override(k).getValue(v)))];l.push([k,b])}return this.updateDefaultConfiguration(d),{keys:u,overrides:l}}compareAndUpdatePolicyConfiguration(d){const{added:u,updated:l,removed:h}=a(this.d,d),k=[...u,...l,...h];return k.length&&this.updatePolicyConfiguration(d),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.applicationConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateApplicationConfiguration(d),{keys:D,overrides:k}}compareAndUpdateLocalUserConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.localUserConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateLocalUserConfiguration(d),{keys:D,overrides:k}}compareAndUpdateRemoteUserConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.remoteUserConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateRemoteUserConfiguration(d),{keys:D,overrides:k}}compareAndUpdateWorkspaceConfiguration(d){const{added:u,updated:l,removed:h,overrides:k}=a(this.workspaceConfiguration,d),D=[...u,...l,...h];return D.length&&this.updateWorkspaceConfiguration(d),{keys:D,overrides:k}}compareAndUpdateFolderConfiguration(d,u){const l=this.p.get(d),{added:h,updated:k,removed:D,overrides:$}=a(l,u),b=[...h,...k,...D];return(b.length||!l)&&this.updateFolderConfiguration(d,u),{keys:b,overrides:$}}compareAndDeleteFolderConfiguration(d){const u=this.p.get(d);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:l,updated:h,removed:k,overrides:D}=a(u,void 0);return{keys:[...l,...h,...k],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(d,u,l){let h=this.r(u,l);return u.overrideIdentifier&&(h=h.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}r({resource:d},u){let l=this.s();if(u&&d){const h=u.getFolder(d);h&&(l=this.t(h.uri)||l);const k=this.m.get(d);k&&(l=l.merge(k))}return l}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(d){let u=this.b.get(d);if(!u){const l=this.s(),h=this.j.get(d);h?(u=l.merge(h),this.b.set(d,u)):u=l}return u}u(d,u){if(u&&d){const l=u.getFolder(d);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,u)=>{const{contents:l,overrides:h,keys:k}=this.j.get(u);return d.push([u,{contents:l,overrides:h,keys:k}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(u=>d.add(u)),this.userConfiguration.keys.forEach(u=>d.add(u)),this.i.keys.forEach(u=>d.add(u)),this.j.forEach(u=>u.keys.forEach(l=>d.add(l))),[...d.values()]}v(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(l=>d.add(l))),[...d.values()]}w(d){const u=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(l=>u.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(l=>u.add(l)),this.i.getKeysForOverrideIdentifier(d).forEach(l=>u.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(d).forEach(h=>u.add(h))),[...u.values()]}static parse(d){const u=this.x(d.defaults),l=this.x(d.policy),h=this.x(d.application),k=this.x(d.user),D=this.x(d.workspace),$=d.folders.reduce((b,v)=>(b.set(g.URI.revive(v[0]),this.x(v[1])),b),new R.$zc);return new i(u,l,h,k,new S,D,$,new S,new R.$zc)}static x(d){return new S(d.contents,d.keys,d.overrides)}}e.$Jn=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const d=new Set,u=new Map;for(const h of r)h.keys.forEach(k=>d.add(k)),h.overrides.forEach(([k,D])=>{const $=(0,R.$wc)(u,k,new Set);D.forEach(b=>$.add(b))});const l=[];return u.forEach((h,k)=>l.push([k,[...h.values()]])),{keys:[...d.values()],overrides:l}}e.$Kn=n;class o{constructor(d,u,l,h){this.change=d,this.f=u,this.g=l,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of d.keys)this.affectedKeys.add(k);for(const[,k]of d.overrides)for(const D of k)this.affectedKeys.add(D);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,u){const l=this.a+d,h=this.d.indexOf(l);if(h<0)return!1;const k=h+l.length;if(k>=this.d.length)return!1;const D=this.d.charCodeAt(k);if(D!==this.b&&D!==this.c)return!1;if(u){const $=this.previousConfiguration?this.previousConfiguration.getValue(d,u,this.f?.workspace):void 0,b=this.g.getValue(d,u,this.h);return!p.$dn($,b)}return!0}}e.$Ln=o;function a(r,d){const{added:u,removed:l,updated:h}=t(d?.rawConfiguration,r?.rawConfiguration),k=[],D=r?.getAllOverrideIdentifiers()||[],$=d?.getAllOverrideIdentifiers()||[];if(d){const b=$.filter(v=>!D.includes(v));for(const v of b)k.push([v,d.getKeysForOverrideIdentifier(v)])}if(r){const b=D.filter(v=>!$.includes(v));for(const v of b)k.push([v,r.getKeysForOverrideIdentifier(v)])}if(d&&r){for(const b of D)if($.includes(b)){const v=t({contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)},{contents:d.getOverrideValue(void 0,b)||{},keys:d.getKeysForOverrideIdentifier(b)});k.push([b,[...v.added,...v.removed,...v.updated]])}}return{added:u,removed:l,updated:h,overrides:k}}function t(r,d){const u=r?d?r.keys.filter(k=>d.keys.indexOf(k)===-1):[...r.keys]:[],l=d?r?d.keys.filter(k=>r.keys.indexOf(k)===-1):[...d.keys]:[],h=[];if(r&&d){for(const k of d.keys)if(r.keys.indexOf(k)!==-1){const D=(0,A.$wi)(d.contents,k),$=(0,A.$wi)(r.contents,k);p.$dn(D,$)||h.push(k)}}return{added:u,removed:l,updated:h}}}),define(ke[257],Se([1,0,22,4,3,83]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_pb=e.$$pb=e.$0pb=e.$9pb=void 0;const R=(g,A,P)=>{const f=new Uint8Array(16);for(let w=0;w<16;w++)f[w]=Math.round(Math.random()*256);const y=(0,I.$ye)(I.$ee.wrap(f));return[`GET ws://localhost${g}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`].join(`\r
`)+`\r
\r
`};e.$9pb=R,e.$0pb=I.$ee.fromString(`\r
\r
`);async function p(g,A,P,f,y){g.write(I.$ee.fromString((0,e.$9pb)(A,P,f)));const S=new m.$Qc;try{return await new Promise((w,c)=>{let s;S.add(g.onData(i=>{s?s=I.$ee.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.$0pb);if(n===-1)return;w(g),g.pauseData();const o=s.slice(n+e.$0pb.byteLength);o.byteLength&&y.onData.fire(o)})),S.add(g.onClose(i=>c(i??new Error("socket closed")))),S.add(g.onEnd(()=>c(new Error("socket ended"))))})}catch(w){throw g.dispose(),w}finally{S.dispose()}}e.$$pb=p;class E extends m.$Rc{constructor(A,P){super(),this.g=A,this.a=this.B(new F.$Td),this.onData=(...f)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...f)),this.b=this.B(new F.$Qd),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(f=>this.a.fire(f))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,P){L.SocketDiagnostics.traceSocketEvent(this,this.g,A,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$_pb=E}),define(ke[65],Se([1,0,11,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.RemoteAuthorityResolverErrorCode=e.$Wk=e.$Vk=e.RemoteConnectionType=e.$Uk=void 0,e.$Uk=(0,F.$Uh)("remoteAuthorityResolverService");var m;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(m||(e.RemoteConnectionType=m={}));class L{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Vk=L;class R{constructor(P,f){this.host=P,this.port=f,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Wk=R;var p;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class E extends I.$ab{static isNotAvailable(P){return P instanceof E&&P._code===p.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof E&&P._code===p.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof E&&P._code===p.NoResolverFound}static isInvalidAuthority(P){return P instanceof E&&P._code===p.InvalidAuthority}static isHandled(P){return P instanceof E&&P.isHandled}constructor(P,f=p.Unknown,y){super(P),this._message=P,this._code=f,this._detail=y,this.isHandled=f===p.NotAvailable&&y===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Xk=E;function g(A){const P=A.indexOf("+");return P===-1?A:A.substring(0,P)}e.$Yk=g}),define(ke[66],Se([1,0,17]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=void 0;function F(g){return g.scheme===I.Schemas.vscodeRemote?g.authority:void 0}e.$Zk=F;function m(g){if(!g)return;const A=g.indexOf("+");return A<0?g:g.substr(0,A)}e.$1k=m;function L(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$2k=L;function R(g){const{host:A,port:P}=E(g);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:P}}e.$3k=R;function p(g,A){let{host:P,port:f}=E(g);return typeof f>"u"&&(f=A),{host:P,port:f}}e.$4k=p;function E(g){const A=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const P=g.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const f=g.match(/(.*):(\d+)$/);return f?{host:f[1],port:parseInt(f[2],10)}:{host:g,port:void 0}}}),define(ke[26],Se([1,0,13,5,66]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.TargetPlatform=e.ExtensionType=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=void 0,e.$5l="extensions.user.cache",e.$6l="extensions.builtin.cache",e.$7l="undefined_publisher",e.$8l=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$9l=L,e.$0l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(R||(e.ExtensionType=R={}));var p;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class E{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,s){if(typeof c>"u"||c===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof c=="string"||typeof s=="string"){const i=typeof c=="string"?c:c.value,n=typeof s=="string"?s:s.value;return I.$5e(i,n)}return c._lower===s._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$$l=E;class g{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const s of c)this.add(s)}add(c){this.c.add(E.toKey(c))}delete(c){return this.c.delete(E.toKey(c))}has(c){return this.c.has(E.toKey(c))}}e.$_l=g;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(E.toKey(c))}get(c){return this.c.get(E.toKey(c))}has(c){return this.c.has(E.toKey(c))}set(c,s){this.c.set(E.toKey(c),s)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$am=A;function P(w){return f(w)}e.$bm=P;function f(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$cm=f;function y(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$dm=y;function S(w,c){if(c){const s=`onResolveRemoteAuthority:${(0,m.$1k)(c)}`;return!!w.activationEvents?.includes(s)}return!1}e.$em=S,e.$fm=(0,F.$Uh)("IBuiltinExtensionsScannerService")}),define(ke[139],Se([1,0,11,26]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.$cF=void 0;class m{constructor(){this.a=new Map,this.b=new WeakMap}register(R,p){this.a.set(R,p)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const p=Object.create(null);for(const E of R){const g=this.readActivationEvents(E);g.length>0&&(p[F.$$l.toKey(E.identifier)]=g)}return p}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const p=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let E=0;E<p.length;E++)p[E]==="onUri"&&(p[E]=`onUri:${F.$$l.toKey(R.identifier)}`);if(!R.contributes)return p;for(const E in R.contributes){const g=this.a.get(E);if(!g)continue;const A=R.contributes[E],P=Array.isArray(A)?A:[A];try{g(P,p)}catch(f){(0,I.$Z)(f)}}return p}}e.$cF=m,e.$dF=new m}),define(ke[258],Se([1,0,10,22,21,11,4,3,56,37,32,83,65,66]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.PersistentConnectionEventType=e.$$k=e.$0k=e.$9k=e.ConnectionType=void 0;const S=30*1e3;var w;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function c(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(K){const U=new m.$1d;return setTimeout(()=>U.cancel(),K),U.token}function i(K,U){if(K.isCancellationRequested||U.isCancellationRequested)return m.CancellationToken.Cancelled;const ne=new m.$1d;return K.onCancellationRequested(()=>ne.cancel()),U.onCancellationRequested(()=>ne.cancel()),ne.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new p.$Qc,this.promise=new Promise((ne,be)=>{this.f=ne,this.g=be}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function o(K,U){const ne=new n(U);return ne.registerDisposable(K.onControlMessage(be=>{const G=JSON.parse(be.toString()),Y=Z(G);Y?ne.reject(Y):ne.resolve(G)})),ne.promise}function a(K,U,ne,be,G,Y,X,$e){const re=new n($e),fe=g.$Md.create(!1);return K.info(`Creating a socket (${X})...`),E.mark(`code/willCreateSocket/${Y}`),U.connect(ne,be,G,X).then(te=>{re.didTimeout?(E.mark(`code/didCreateSocketError/${Y}`),K.info(`Creating a socket (${X}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(E.mark(`code/didCreateSocketOK/${Y}`),K.info(`Creating a socket (${X}) was successful after ${fe.elapsed()} ms.`),re.resolve(te))},te=>{E.mark(`code/didCreateSocketError/${Y}`),K.info(`Creating a socket (${X}) returned an error after ${fe.elapsed()} ms.`),K.error(te),re.reject(te)}),re.promise}function t(K,U){const ne=new n(U);return K.then(be=>{ne.didTimeout||ne.resolve(be)},be=>{ne.didTimeout||ne.reject(be)}),ne.promise}async function r(K,U,ne,be){const G=Ee(K,U);K.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,y.$2k)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,c(U),`renderer-${c(U)}-${K.reconnectionToken}`,be)}catch(te){throw K.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),K.logService.error(te),te}K.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let X,$e;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(Y,null),X=K.reconnectionProtocol,$e=!1):(X=new P.$Ih({socket:Y}),$e=!0),K.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const re=await t(K.signService.createNewMessage((0,A.$hg)()),be),fe={type:"auth",auth:K.connectionToken||"00000000000000000000",data:re.data};X.sendControl(F.$ee.fromString(JSON.stringify(fe)));try{const te=await o(X,i(be,s(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(K.logService.trace(`${G} 4/6. received SignRequest control message.`),!await t(K.signService.validate(re,te.signedData),be)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const pe=await t(K.signService.sign(te.data),be),Pe={type:"connectionType",commit:K.commit,signedData:pe,desiredConnectionType:U};return ne&&(Pe.args=ne),K.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(F.$ee.fromString(JSON.stringify(Pe))),{protocol:X,ownsProtocol:$e}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(K.logService.error(`${G} the handshake timed out. Error:`),K.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${G} received error control message when negotiating connection. Error:`),K.logService.error(te)),$e&&ee(X),te}}async function d(K,U,ne,be){const G=Date.now(),Y=Ee(K,U),{protocol:X,ownsProtocol:$e}=await r(K,U,ne,be),re=new n(be);return re.registerDisposable(X.onControlMessage(fe=>{const te=JSON.parse(fe.toString()),he=Z(te);he?(K.logService.error(`${Y} received error control message when negotiating connection. Error:`),K.logService.error(he),$e&&ee(X),re.reject(he)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${le(G)}!`),re.resolve({protocol:X,firstMessage:te}))})),re.promise}async function u(K,U){const{protocol:ne}=await d(K,1,void 0,U);return{protocol:ne}}async function l(K,U,ne){const{protocol:be,firstMessage:G}=await d(K,2,U,ne),Y=G&&G.debugPort;return{protocol:be,debugPort:Y}}async function h(K,U,ne){const be=Date.now(),G=Ee(K,3),{protocol:Y}=await r(K,3,U,ne);return K.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${le(be)}!`),Y}async function k(K,U,ne){const{connectTo:be,connectionToken:G}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:be,connectionToken:G,reconnectionToken:U,reconnectionProtocol:ne,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function D(K,U,ne){return b(K,async be=>{const{protocol:G}=await u(be,m.CancellationToken.None);return new V(K,U,ne,be.reconnectionToken,G)})}e.$9k=D;async function $(K,U){return b(K,async ne=>{const{protocol:be,debugPort:G}=await l(ne,U,m.CancellationToken.None);return new de(K,U,ne.reconnectionToken,be,G)})}e.$0k=$;async function b(K,U){for(let be=1;;be++)try{const G=(0,A.$hg)(),Y=await k(K,G,null);return await U(Y)}catch(G){if(be<5)K.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(G);else throw K.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(G),W.triggerPermanentFailure(0,0,f.$Xk.isHandled(G)),G}}async function v(K,U,ne){const be=await k(K,(0,A.$hg)(),null);return await h(be,{host:U,port:ne},m.CancellationToken.None)}e.$$k=v;function C(K){return(0,I.$Kg)(U=>new Promise((ne,be)=>{const G=setTimeout(ne,K*1e3);U.onCancellationRequested(()=>{clearTimeout(G),ne()})}))}var N;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class j{constructor(U,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.type=0}}e.$_k=j;class M{constructor(U,ne,be,G){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.durationSeconds=be,this.c=G,this.type=1}skipWait(){this.c.cancel()}}e.$al=M;class O{constructor(U,ne,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.type=2}}e.$bl=O;class z{constructor(U,ne,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.type=4}}e.$cl=z;class T{constructor(U,ne,be,G){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.handled=G,this.type=3}}e.$dl=T;class W extends p.$Rc{static triggerPermanentFailure(U,ne,be){this._permanentFailure=!0,this.f=U,this.g=ne,this.h=be,this.j.forEach(G=>G.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(U,ne,be,G,Y){super(),this.t=U,this.u=ne,this.reconnectionToken=be,this.protocol=G,this.w=Y,this.m=this.B(new R.$Qd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(G.onSocketClose(X=>{const $e=x(this.t,this.reconnectionToken,!0);X?X.type===0?(this.u.logService.info(`${$e} received socket close event (hadError: ${X.hadError}).`),X.error&&this.u.logService.error(X.error)):(this.u.logService.info(`${$e} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this.u.logService.error(X.event)):this.u.logService.info(`${$e} received socket close event.`),this.y()})),this.B(G.onSocketTimeout(X=>{const $e=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${$e} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,p.$Pc)(()=>{const X=W.j.indexOf(this);X>=0&&W.j.splice(X,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=x(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const G=be<ne.length?ne[be]:ne[ne.length-1];try{if(G>0){const X=C(G);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G,X)),this.u.logService.info(`${U} waiting for ${G} seconds before reconnecting...`);try{await X}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const Y=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${Y.connectTo}...`),await this.G(Y,s(S)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(f.$Xk.isTemporarilyNotAvailable(Y)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((0,L.$3)(Y)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if(Y instanceof f.$Xk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,f.$Xk.isHandled(Y));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ne,be){this.w?W.triggerPermanentFailure(U,ne,be):this.D(U,ne,be)}D(U,ne,be){this.m.fire(new T(this.reconnectionToken,U,ne,be)),ee(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$el=W;class V extends W{constructor(U,ne,be,G,Y){super(1,U,G,Y,!0),this.client=this.B(new P.$Gh(Y,{remoteAuthority:ne,clientId:be},U.ipcLogger))}async G(U,ne){await u(U,ne)}}e.$fl=V;class de extends W{constructor(U,ne,be,G,Y){super(2,U,be,G,!1),this.H=ne,this.debugPort=Y}async G(U,ne){await l(U,this.H,ne)}}e.$gl=de;function ee(K){try{K.acceptDisconnect();const U=K.getSocket();K.dispose(),U.dispose()}catch(U){(0,L.$Z)(U)}}function Z(K){if(K&&K.type==="error"){const U=new Error(`Connection error: ${K.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function J(K,U){for(;K.length<U;)K+=" ";return K}function ae(K,U){return`[remote-connection][${J(c(K),13)}][${U.substr(0,5)}\u2026]`}function x(K,U,ne){return`${ae(K,U)}[${ne?"reconnect":"initial"}]`}function Ee(K,U){return`${x(U,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function le(K){return`${Date.now()-K} ms`}}),define(ke[259],Se([1,0,3,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=e.$5k=void 0,e.$5k=(0,F.$Uh)("remoteSocketFactoryService");class m{constructor(){this.a={}}register(R,p){return this.a[R]??=[],this.a[R].push(p),(0,I.$Pc)(()=>{const E=this.a[R]?.indexOf(p);typeof E=="number"&&E>=0&&this.a[R]?.splice(E,1)})}b(R){return(this.a[R.type]||[]).find(E=>E.supports(R))}connect(R,p,E,g){const A=this.b(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,p,E,g)}}e.$6k=m}),define(ke[260],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M4b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(m){try{const L=await this.c();if(L){const R=String(I.a++);return this.b.set(R,L),{id:R,data:L.createNewMessage(m)}}}catch{}return{id:"",data:m}}async validate(m,L){if(!m.id)return!0;const R=this.b.get(m.id);if(!R)return!1;this.b.delete(m.id);try{return R.validate(L)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(m){try{return await this.d(m)}catch{}return m}}e.$M4b=I}),define(ke[109],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=void 0,e.$7k="signService",e.$8k=(0,I.$Uh)(e.$7k)}),define(ke[140],Se([1,0,260]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I9b=void 0;class F extends I.$M4b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(R=>new R.signer().sign(L))}h(){return new Promise((L,R)=>me(["vsda"],L,R))}}e.$I9b=F}),define(ke[261],Se([1,0,12,49,32]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=void 0;function L(E){if(I.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function R(E,g,A,P,f,y,S,w,c){const s=Object.create(null);s["common.machineId"]=y,s["common.sqmId"]=S,s.sessionID=(0,m.$hg)()+Date.now(),s.commitHash=P,s.version=f,s["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=F.$cc,s["common.nodeArch"]=A,s["common.product"]=c||"desktop",w&&(s["common.msftInternal"]=w);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const o=L(g);return o&&(s["common.platformDetail"]=o),s}e.$mo=R;function p(E){const g=F.env.USERDNSDOMAIN;if(!g)return!1;const A=g.toLowerCase();return E.some(P=>A===P)}e.$no=p}),define(ke[262],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=void 0,e.$hl=(0,I.$Uh)("telemetryService"),e.$il=(0,I.$Uh)("customEndpointTelemetryService"),e.$jl="telemetry.currentSessionDate",e.$kl="telemetry.firstSessionDate",e.$ll="telemetry.lastSessionDate",e.$ml="telemetry.machineId",e.$nl="telemetry.sqmId",e.$ol="telemetry",e.$pl="telemetry.telemetryLevel",e.$ql="telemetry.enableCrashReporter",e.$rl="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var m;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(m||(e.TelemetryConfiguration=m={}))}),define(ke[87],Se([1,0,24,18,4,44,66,261,262]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;class g{constructor(l){this.value=l,this.isTrustedTelemetryValue=!0}}e.$oo=g;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$po=A,e.$qo=new A;class P{async publicLog(l,h,k){}async publicLogError(l,h,k){}}e.$ro=P,e.$so="telemetry",e.$to="extensionTelemetryLog",e.$uo={log:()=>null,flush:()=>Promise.resolve(null)};function f(u,l){return m.Event.debounce(l.onDidChangeConfiguration,(k,D)=>{const $=k?new Set([...k.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:$}},1e3,!0)(k=>{k.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,L.$ri)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$vo=f;function y(u,l){return!l.isBuilt&&!l.disableTelemetry?!0:!(l.disableTelemetry||!u.enableTelemetry)}e.$wo=y;function S(u,l){return l.extensionTestsLocationURI?!0:!(l.isBuilt||l.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.$xo=S;function w(u){const l=u.getValue(E.$pl),h=u.getValue(E.$ql);if(u.getValue(E.$rl)===!1||h===!1)return 0;switch(l??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$yo=w;function c(u){const l={},h={},k={};n(u,k);for(let D in k){D=D.length>150?D.substr(D.length-149):D;const $=k[D];typeof $=="number"?h[D]=$:typeof $=="boolean"?h[D]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${$.length}`),l[D]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(l[D]=$)}return{properties:l,measurements:h}}e.$zo=c;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(u){if(!u)return"none";const l=(0,R.$1k)(u);return s.has(l)?l:"other"}e.$Ao=i;function n(u,l,h=0,k){if(u)for(const D of Object.getOwnPropertyNames(u)){const $=u[D],b=k?k+D:D;Array.isArray($)?l[b]=(0,I.$en)($):$ instanceof Date?l[b]=$.toISOString():(0,F.$Df)($)?h<2?n($,l,h+1,b+"."):l[b]=(0,I.$en)($):l[b]=$}}function o(u,l){const h=u.msftInternalDomains||[],k=l.getValue("telemetry.internalTesting");return(0,p.$no)(h)||k}e.$Bo=o;function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.$Co=a;function t(u,l){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let h=u;const k=[];for(const v of l)for(;;){const C=v.exec(u);if(!C)break;k.push([C.index,v.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(h="";;){const v=$.exec(u);if(!v)break;const C=k.some(([N,j])=>v.index<j&&N<$.lastIndex);!D.test(v[0])&&!C&&(h+=u.substring(b,v.index)+"<REDACTED: user-file-path>",b=$.lastIndex)}return b<u.length&&(h+=u.substr(b)),h}function r(u){if(!u)return u;const l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return u}function d(u,l){return(0,I.$bn)(u,h=>{if(h instanceof g||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let k=h.replaceAll("%20"," ");k=t(k,l);for(const D of l)k=k.replace(D,"");return k=r(k),k}})}e.$Do=d}),define(ke[263],Se([1,0,13,135,26,12,2,11,49,87]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0;function A(d,u){return d.uuid&&u.uuid?d.uuid===u.uuid:d.id===u.id?!0:(0,I.$Ze)(d.id,u.id)===0}e.$Eo=A;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(u){const l=u.manifest?u.manifest.version:u.version,h=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new f(u.identifier,l,h)}static parse(u){const l=P.exec(u);return l&&l[1]&&l[2]?new f({id:l[1]},l[2],l[4]||void 0):null}constructor(u,l,h="undefined"){this.version=l,this.targetPlatform=h,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof f?A(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Fo=f;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(d){const u=y.exec(d);return u&&u[1]?[c(u[1]),u[2]]:[c(d),void 0]}e.$Go=S;function w(d,u){return`${d}.${u}`}e.$Ho=w;function c(d){return d.toLowerCase()}e.$Io=c;function s(d,u){return c(w(d??m.$7l,u))}e.$Jo=s;function i(d,u){const l=[],h=k=>{for(const D of l)if(D.some($=>A(u($),u(k))))return D;return null};for(const k of d){const D=h(k);D?D.push(k):l.push([k])}return l}e.$Ko=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Lo=n;function o(d){return{id:new g.$oo(d.identifier.id),name:new g.$oo(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Mo=o,e.$No=new m.$$l("pprice.better-merge");function a(d,u){const l=[],h=u.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const k=h.shift();if(k&&l.every(D=>!A(D.identifier,{id:k}))){const D=d.filter($=>A($.identifier,{id:k}));D.length===1&&(l.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.$Oo=a;async function t(d,u){if(!L.$k)return!1;let l;try{l=(await d.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await d.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){u.debug("Error while getting the os-release file.",(0,p.$9)(k))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(d,u){const l=await t(d,u),h=(0,F.$$n)(l?"alpine":L.$u,E.$dc);return u.debug("ComputeTargetPlatform:",h),h}e.$Po=r}),define(ke[264],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function I(E){return[...E.entries()]}e.$qr=I;function F(E){return E?[...E.entries()]:[]}e.$rr=F;function m(E){return new Map(E)}e.$sr=m;function L(E){return new Map(E??[])}e.$tr=L;function R(E){return Array.from(E.entries()).map(g=>[g[0],I(g[1].map),F(g[1].descriptionMap)])}e.$ur=R;function p(E){return new Map(E.map(g=>[g[0],{map:m(g[1]),descriptionMap:L(g[2])}]))}e.$vr=p}),define(ke[265],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qqb=void 0;class I{constructor(m){this.b=m,this.a=new Map}dispose(){for(const m of this.a.values())m.dispose()}startBuffering(m,L,R=5){const p=L(E=>{const g=typeof E=="string"?E:E.data;let A=this.a.get(m);if(A){A.data.push(g);return}const P=setTimeout(()=>this.flushBuffer(m),R);A={data:[g],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(m),p.dispose()}},this.a.set(m,A)});return p}stopBuffering(m){this.a.get(m)?.dispose()}flushBuffer(m){const L=this.a.get(m);L&&(this.a.delete(m),this.b(m,L.data.join("")))}}e.$qqb=I}),define(ke[266],Se([1,0,10,79,61,4,18,2,207,108,38]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.IconFontDefinition=e.IconContribution=e.$$v=void 0,e.$$v={IconContribution:"base.contributions.icons"};var P;(function(o){function a(t,r){let d=t.defaults;for(;m.ThemeIcon.isThemeIcon(d);){const u=S.getIcon(d.id);if(!u)return;d=u.defaults}return d}o.getDefinition=a})(P||(e.IconContribution=P={}));var f;(function(o){function a(r){return{weight:r.weight,style:r.style,src:r.src.map(d=>({format:d.format,location:d.location.toString()}))}}o.toJSONObject=a;function t(r){const d=u=>(0,R.$Bf)(u)?u:void 0;if(r&&Array.isArray(r.src)&&r.src.every(u=>(0,R.$Bf)(u.format)&&(0,R.$Bf)(u.location)))return{weight:d(r.weight),style:d(r.style),src:r.src.map(u=>({format:u.format,location:p.URI.parse(u.location)}))}}o.fromJSONObject=t})(f||(e.IconFontDefinition=f={}));class y{constructor(){this.a=new L.$Qd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${m.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,r,d){const u=this.b[a];if(u){if(r&&!u.description){u.description=r,this.d.properties[a].markdownDescription=`${r} $(${a})`;const k=this.e.enum.indexOf(a);k!==-1&&(this.e.enumDescriptions[k]=r),this.a.fire()}return u}const l={id:a,description:r,defaults:t,deprecationMessage:d};this.b[a]=l;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),r&&(h.markdownDescription=`${r}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const r=this.f[a];return r||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(u,l)=>u.id.localeCompare(l.id),t=u=>{for(;m.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(u=>this.b[u]);for(const u of d.filter(l=>!!l.description).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|${m.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const u of d.filter(l=>!m.ThemeIcon.isThemeIcon(l.defaults)).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|`);return r.join(`
`)}}const S=new y;A.$ln.add(e.$$v.IconContribution,S);function w(o,a,t,r){return S.registerIcon(o,a,t,r)}e.$_v=w;function c(){return S}e.$aw=c;function s(){const o=(0,F.$Xj)();for(const a in o){const t="\\"+o[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}s(),e.$bw="vscode://schemas/icons";const i=A.$ln.as(g.$mn.JSONContribution);i.registerSchema(e.$bw,S.getIconSchema());const n=new I.$9g(()=>i.notifySchemaChanged(e.$bw),200);S.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$cw=w("widget-close",F.$Zj.close,(0,E.localize)(2,null)),e.$dw=w("goto-previous-location",F.$Zj.arrowUp,(0,E.localize)(3,null)),e.$ew=w("goto-next-location",F.$Zj.arrowDown,(0,E.localize)(4,null)),e.$fw=m.ThemeIcon.modify(F.$Zj.sync,"spin"),e.$gw=m.ThemeIcon.modify(F.$Zj.loading,"spin")}),define(ke[88],Se([1,0,4,44,5,15]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,m.$Uh)("tunnelService"),e.$ev=(0,m.$Uh)("sharedTunnelsService");var R;(function(c){c.Http="http",c.Https="https"})(R||(e.TunnelProtocol=R={}));var p;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(p||(e.TunnelPrivacyId=p={}));function E(c){return!!c.forwardPort}e.$fv=E;var g;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function A(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(s)return{address:s[1],port:+s[2]}}e.$gv=A,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(c){return e.$hv.indexOf(c)>=0}e.$iv=P,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(c){return e.$jv.indexOf(c)>=0}e.$kv=f;function y(c,s,i,n){if(i===1)return!1;if(i===2&&f(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return c<1024}e.$lv=y;class S{constructor(s,i,n){this.remoteAddress=s,this.localAddress=i,this.b=n,this.a=new I.$Qd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=S;let w=class{constructor(s,i){this.j=s,this.k=i,this.a=new I.$Qd,this.onTunnelOpened=this.a.event,this.b=new I.$Qd,this.onTunnelClosed=this.b.event,this.c=new I.$Qd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],i=Array.from(this.e.values());for(const n of i){const o=Array.from(n.values());for(const a of o){const t=await a.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:i}of s.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,i,n,o,a){this.p(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:n,privacy:o,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(f(s)||P(s))&&(s=e.$hv[0]);const n=this.r(s,i);if(n)return++n.refcount,n.value}openTunnel(s,i,n,o,a,t=!1,r,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const u=this.f??s;if(!u)return;if(i||(i="localhost"),o||(o=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const l=this.s(u,i,n,o,a,t,r,d);return l?l.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&h.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this.e.get(s.tunnelRemoteHost);if(i){const n=i.get(s.tunnelRemotePort);n&&(n.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,n))}}}}async o(s,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const o=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(i),o}}async closeTunnel(s,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const n=this.e.get(s);if(n&&n.has(i)){const o=n.get(i);o.refcount=0,await this.o(s,i,o)}}p(s,i,n){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(i,{refcount:1,value:n})}async q(s,i){const n=this.e.get(s);if(n){const o=n.get(i),a=o?await o.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(s)}}r(s,i){const n=[s];P(s)?(n.push(...e.$hv),n.push(...e.$jv)):f(s)&&n.push(...e.$jv);const o=n.map(a=>this.e.get(a));for(const a of o){const t=a?.get(i);if(t)return t}}canTunnel(s){return!!A(s)}t(s,i,n,o,a,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${o}.`);const d=n;this.i.add(d);const u=o===void 0?n:o,l={elevationRequired:a?this.isPortPrivileged(u):!1},h={remoteAddress:{host:i,port:n},localAddressPort:o,privacy:t,public:t?t!==p.Private:void 0,protocol:r},k=s.forwardPort(h,l);return k?(this.p(i,n,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),k}};e.$nv=w,e.$nv=w=He([Be(0,L.$cj),Be(1,F.$oi)],w)}),define(ke[267],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=void 0,e.$Nk=(0,I.$Uh)("IUriIdentityService")}),define(ke[268],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ov=void 0,e.$ov=(0,I.$Uh)("editSessionIdentityService");var F;(function(m){m[m.Complete=100]="Complete",m[m.Partial=50]="Partial",m[m.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(ke[269],Se([1,0,17]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=void 0;function F(E){return E.scheme!==I.Schemas.file&&E.scheme!==I.Schemas.vscodeRemote}e.$6J=F;function m(E){if(E.folders.length)return E.folders.every(g=>F(g.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$7J=m;function L(E){return m(E)?.scheme}e.$8J=L;function R(E){return m(E)?.authority}e.$9J=R;function p(E){return m(E)!==void 0}e.$0J=p}),define(ke[40],Se([1,0,209,16,78,23,2,5,17]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.WorkbenchState=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0,e.$4h=(0,p.$Uh)("contextService");function g(u){const l=u;return typeof l?.id=="string"&&R.URI.isUri(l.uri)}e.$5h=g;function A(u){return typeof u?.id=="string"&&!g(u)&&!f(u)}e.$6h=A,e.$7h={id:"ext-dev"},e.$8h={id:"empty-window"};function P(u,l){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,F.$mc)(u)}:l?e.$7h:e.$8h;const h=u;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$9h=P;function f(u){const l=u;return typeof l?.id=="string"&&R.URI.isUri(l.configPath)}e.$0h=f;function y(u){const l=u;if(l?.uri)return{id:l.id,uri:R.URI.revive(l.uri)};const h=u;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(u?.id)return{id:u.id}}e.$$h=y;var S;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function w(u){const l=u;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.$_h=w;function c(u){const l=u;return!!(l&&typeof l=="object"&&R.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.$ai=c;class s{constructor(l,h,k,D,$){this.h=l,this.j=k,this.k=D,this.l=$,this.c=m.$1h.forUris(this.l,()=>!0),this.folders=h}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=m.$1h.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$bi=s;class i{constructor(l,h){this.raw=h,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,L.$yg)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ci=i;function n(u){return new i({uri:u,index:0,name:(0,L.$ug)(u)},{uri:u.toString()})}e.$di=n,e.$ei="code-workspace",e.$fi=`.${e.$ei}`,e.$gi=[{name:(0,I.localize)(0,null),extensions:[e.$ei]}],e.$hi="workspace.json";function o(u,l){return L.$pg.isEqualOrParent(u,l.untitledWorkspacesHome)}e.$ii=o;function a(u){let l;return R.URI.isUri(u)?l=u:l=u.configuration,l?.scheme===E.Schemas.tmp}e.$ji=a,e.$ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$ki}e.$li=t;function r(u,l){return!o(u,l)&&!a(u)}e.$mi=r;function d(u){return(typeof u=="string"?(0,F.$nc)(u):(0,L.$wg)(u))===e.$fi}e.$ni=d}),define(ke[270],Se([1,0,52,4,3,23,2,208,134,31,5,15,40,28,267,10,32,13,18]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.ProfileResourceType=void 0;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const l=u;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&R.URI.isUri(l.location)&&R.URI.isUri(l.globalStorageHome)&&R.URI.isUri(l.settingsResource)&&R.URI.isUri(l.keybindingsResource)&&R.URI.isUri(l.tasksResource)&&R.URI.isUri(l.snippetsHome)&&R.URI.isUri(l.extensionsResource))}e.$Ok=o,e.$Pk=(0,A.$Uh)("IUserDataProfilesService");function a(u,l){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:R.URI.revive(u.location).with({scheme:l}),globalStorageHome:R.URI.revive(u.globalStorageHome).with({scheme:l}),settingsResource:R.URI.revive(u.settingsResource).with({scheme:l}),keybindingsResource:R.URI.revive(u.keybindingsResource).with({scheme:l}),tasksResource:R.URI.revive(u.tasksResource).with({scheme:l}),snippetsHome:R.URI.revive(u.snippetsHome).with({scheme:l}),extensionsResource:R.URI.revive(u.extensionsResource).with({scheme:l}),cacheHome:R.URI.revive(u.cacheHome).with({scheme:l}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}e.$Qk=a;function t(u,l,h,k,D,$){return{id:u,name:l,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:$&&D?.useDefaultFlags?.globalState?$.globalStorageHome:(0,L.$yg)(h,"globalStorage"),settingsResource:$&&D?.useDefaultFlags?.settings?$.settingsResource:(0,L.$yg)(h,"settings.json"),keybindingsResource:$&&D?.useDefaultFlags?.keybindings?$.keybindingsResource:(0,L.$yg)(h,"keybindings.json"),tasksResource:$&&D?.useDefaultFlags?.tasks?$.tasksResource:(0,L.$yg)(h,"tasks.json"),snippetsHome:$&&D?.useDefaultFlags?.snippets?$.snippetsHome:(0,L.$yg)(h,"snippets"),extensionsResource:$&&D?.useDefaultFlags?.extensions?$.extensionsResource:(0,L.$yg)(h,"extensions.json"),cacheHome:(0,L.$yg)(k,u),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$Rk=t;let r=class extends m.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,h,k,D){super(),this.t=l,this.u=h,this.w=k,this.y=D,this.f=!0,this.h=this.B(new F.$Qd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Qd),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Qd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Qd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$zc,emptyWindows:new Map},this.profilesHome=(0,L.$yg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$yg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),h=[l];if(this.f)try{for(const $ of this.O()){if(!$.name||!(0,i.$Bf)($.name)||!$.location){this.y.warn("Skipping the invalid stored profile",$.location||$.name);continue}h.push(t((0,L.$vg)($.location),$.name,$.location,this.g,{shortName:$.shortName,icon:$.icon,useDefaultFlags:$.useDefaultFlags},l))}}catch($){this.y.error($)}const k=new y.$zc,D=new Map;if(h.length)try{const $=this.Q();if($.workspaces)for(const[b,v]of Object.entries($.workspaces)){const C=R.URI.parse(b),N=h.find(j=>j.id===v);N&&k.set(C,N)}if($.emptyWindows)for(const[b,v]of Object.entries($.emptyWindows)){const C=h.find(N=>N.id===v);C&&D.set(b,C)}}catch($){this.y.error($)}this.z={profiles:h,workspaces:k,emptyWindows:D}}return this.z}D(){const l=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const h="Temp",k=new RegExp(`${(0,s.$Ie)(h)}\\s(\\d+)`);let D=0;for(const b of this.profiles){const v=k.exec(b.name),C=v?parseInt(v[1]):0;D=C>D?C:D}const $=`${h} ${D+1}`;return this.createProfile((0,I.$Ii)((0,c.$hg)()).toString(16),$,{transient:!0},l)}async createNamedProfile(l,h,k){return this.createProfile((0,I.$Ii)((0,c.$hg)()).toString(16),l,h,k)}async createProfile(l,h,k,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=await this.F(l,h,k);return D&&await this.setProfileForWorkspace(D,$),$}async F(l,h,k){if(!(0,i.$Bf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{const $=this.profiles.find(C=>C.name===h||C.id===l);if($)return $;const b=t(l,h,(0,L.$yg)(this.profilesHome,l),this.g,k,this.defaultProfile);await this.u.createFolder(b.location);const v=[];return this.j.fire({profile:b,join(C){v.push(C)}}),await w.Promises.settled(v),this.I([b],[],[]),b}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(D=>D.id===l.id);if(!k)throw new Error(`Profile '${l.name}' does not exist`);return k=t(k.id,h.name??k.name,k.location,this.g,{shortName:h.shortName??k.shortName,icon:h.icon===null?void 0:h.icon??k.icon,transient:h.transient??k.isTransient,useDefaultFlags:h.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===l.id);if(!h)throw new Error(`Profile '${l.name}' does not exist`);const k=[];this.m.fire({profile:h,join(D){k.push(D)}});try{await Promise.allSettled(k)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,g.$uk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(D=>D.id===h.id);if(!k)throw new Error(`Profile '${h.name}' does not exist`);this.L(l,k)}unsetWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(h=>h.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(l.map(h=>this.removeProfile(h)))}getProfileForWorkspace(l){const h=this.G(l);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(l){return(0,f.$5h)(l)?l.uri:(0,f.$0h)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location)))}I(l,h,k){const D=[...this.profiles,...l],$=[];this.s.profiles=[];for(let b of D)b.isDefault||h.some(v=>b.id===v.id)||(b=k.find(v=>b.id===v.id)??b,b.isTransient?this.s.profiles.push(b):$.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags}));this.P($),this.z=void 0,this.J(l,h,k)}J(l,h,k){this.h.fire({added:l,removed:h,updated:k,all:this.profiles})}L(l,h,k){k=h?.isTransient?!0:k,k||this.L(l,void 0,!0);const D=this.G(l),$=k?this.s:this.C;R.URI.isUri(D)?($.workspaces.delete(D),h&&$.workspaces.set(D,h)):($.emptyWindows.delete(D),h&&$.emptyWindows.set(D,h)),k||this.M()}M(){const l={};for(const[k,D]of this.C.workspaces.entries())l[k.toString()]=D.id;const h={};for(const[k,D]of this.C.emptyWindows.entries())h[k.toString()]=D.id;this.R({workspaces:l,emptyWindows:h}),this.z=void 0}N(l){const h={},k=this.D();if(l.workspaces)for(const[$,b]of Object.entries(l.workspaces)){const v=R.URI.parse(b);h[$]=this.w.extUri.isEqual(v,k.location)?k.id:this.w.extUri.basename(v)}const D={};if(l.emptyWindows)for(const[$,b]of Object.entries(l.emptyWindows)){const v=R.URI.parse(b);D[$]=this.w.extUri.isEqual(v,k.location)?k.id:this.w.extUri.basename(v)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$Sk=r,e.$Sk=r=He([Be(0,E.$2h),Be(1,g.$dk),Be(2,S.$Nk),Be(3,P.$cj)],r);class d extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$Tk=d}),define(ke[271],Se([1,0,10,4,3,56,18,188,5,270]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$$o=e.$0o=e.$9o=void 0,e.$9o="__$__isNewStorageMarker",e.$0o="__$__targetStorageMarker",e.$$o=(0,E.$Uh)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var P;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var f;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(f||(e.StorageTarget=f={}));function y(i){const n=i.get(e.$0o);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$_o=y;class S extends m.$Rc{static{this.a=60*1e3}constructor(n={flushInterval:S.a}){super(),this.m=n,this.b=this.B(new F.$Td),this.c=this.B(new F.$Td),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Qd),this.onWillSaveState=this.f.event,this.h=this.B(new I.$9g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new m.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,a){return F.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),a)}n(){this.j.value=(0,I.$ah)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,m.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:a,external:t}=o;if(a===e.$0o){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,o,a){return this.P(o)?.get(n,a)}getBoolean(n,o,a){return this.P(o)?.getBoolean(n,a)}getNumber(n,o,a){return this.P(o)?.getNumber(n,a)}getObject(n,o,a){return this.P(o)?.getObject(n,a)}storeAll(n,o){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,o)})}store(n,o,a,t,r=!1){if((0,R.$Kf)(o)){this.remove(n,a,r);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,o,r)})}remove(n,o,a=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const a=[],t=this.J(n);for(const r of Object.keys(t))t[r]===o&&a.push(r);return a}z(n,o,a,t=!1){const r=this.J(o);typeof a=="number"?r[n]!==a&&(r[n]=a,this.P(o)?.set(e.$0o,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.P(o)?.set(e.$0o,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?y(o):Object.create(null)}isNew(n){return this.getBoolean(e.$9o,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const o=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case A.NONE:await I.Promises.settled([o?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await I.Promises.settled([o?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,o=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return s(n,o,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(A.NONE),(0,g.$Ok)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||w(o)&&w(n))}N(n,o,a){this.y(()=>{const t=new Set;for(const[r,d]of n)t.add(r),o.get(r)!==d&&this.u(a,{key:r,external:!0});for(const[r]of o.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$ap=S;function w(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$bp=w;class c extends S{constructor(){super(),this.U=this.B(new p.$7o(new p.$8o,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$7o(new p.$8o,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$7o(new p.$8o,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$cp=c;async function s(i,n,o,a,t,r){const d=C=>{try{return JSON.parse(C)}catch{return C}},u=new Map,l=new Map;i.forEach((C,N)=>{u.set(N,C),l.set(N,d(C))});const h=new Map,k=new Map;n.forEach((C,N)=>{h.set(N,C),k.set(N,d(C))});const D=new Map,$=new Map;o.forEach((C,N)=>{D.set(N,C),$.set(N,d(C))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const b=[];if(u.forEach((C,N)=>{b.push({key:N,value:C})}),console.table(b),console.groupEnd(),console.log(l),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];h.forEach((N,j)=>{C.push({key:j,value:N})}),console.table(C),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${r})`);const v=[];D.forEach((C,N)=>{v.push({key:N,value:C})}),console.table(v),console.groupEnd(),console.log($)}e.$dp=s}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class I{static{this.a=!1}constructor(m){this.d=m,this.b=new Map,this.c=1}add(m){const L=this.c++;return this.b.set(L,m),this.e(),L}get(m,L){return this.b.has(m)?this.b.get(m)[L]:void 0}delete(m){this.b.delete(m),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$wdc=I}),define(ke[57],Se([1,0,17,23,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=e.$ydc=void 0;class L{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new F.$ng(p=>{const E=this.b.get(p.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(p,E){E===null?this.b.delete(p.scheme):this.b.set(p.scheme,E)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$ydc=L,e.$zdc=(0,m.$Uh)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0,e.$RM=(0,I.$Uh)("IExtHostInitDataService")}),define(ke[272],Se([1,0,215,15,252,27]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;let R=class extends m.$YN{constructor(E,g,A){const P=A.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",f=A.remote.isRemote?(0,I.localize)(0,null):E?(0,I.localize)(1,null):(0,I.localize)(2,null);super(g.createLogger(P,{name:f}))}};e.$Hfc=R,e.$Hfc=R=He([Be(1,F.$dj),Be(2,L.$RM)],R)}),define(ke[273],Se([1,0,10]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=void 0;class F{constructor(R,p,E){this.h=new Map,this.a=R,this.b=p,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new I.$9g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of g.values())A.complete()}catch(A){for(const P of g.values())P.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,p){let E=this.f[R];return typeof E>"u"&&(E=p),E}update(R,p){this.f[R]=p;const E=this.h.get(R);if(E!==void 0)return E.p;const g=new I.$hh;return this.h.set(R,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$2dc=F;class m extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,p){super(R.identifier.value,!0,p),this.j=R}}e.$3dc=m}),define(ke[274],Se([1,0,4,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class m{constructor(R){this.c=R,this.a=new I.$Qd,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$Qd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,p,E,g){const P=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(p.value,E,g);this.b.fire(P)}$acceptDirtyStateChanged(R,p){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty(p)}$acceptModelSaved(R){const p=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire(p.apiNotebook)}}e.$ofc=m}),define(ke[20],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=void 0,e.$BM=(0,I.$Uh)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$CM=F}),define(ke[275],Se([1,0,26,4]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class m{#e;constructor(R,p){this.b=new F.$Qd,this.onDidChange=this.b.event,this.a=I.$$l.toKey(R.identifier),this.#e=p,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(R){return this.#e.get(this.a,R)}store(R,p){return this.#e.store(this.a,R,p)}delete(R){return this.#e.delete(this.a,R)}}e.$bec=m}),define(ke[67],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=e.$Jdc=void 0,e.$Jdc=(0,I.$Uh)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Kdc=F}),define(ke[276],Se([1,0,22]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdb=e.$idb=void 0;class F{constructor(){this.buffers=[]}add(E){let g=this.buffers.indexOf(E);return g<0&&(g=this.buffers.length,this.buffers.push(E)),g}}function m(p,E){if(E.serializeBuffersForPostMessage){const g=new F,P=JSON.stringify(p,(y,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(S)};if(ArrayBuffer.isView(S)){const w=L(S);if(w)return{$$vscode_array_buffer_reference$$:!0,index:g.add(S.buffer),view:{type:w,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),f=g.buffers.map(y=>{const S=new Uint8Array(y);return I.$ee.wrap(S)});return{message:P,buffers:f}}else return{message:JSON.stringify(p),buffers:[]}}e.$idb=m;function L(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(p,E){const g=E.map(f=>{const y=new ArrayBuffer(f.byteLength);return new Uint8Array(y).set(f.buffer),y}),A=E.length?(f,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const S=y,{index:w}=S,c=g[w];if(S.view)switch(S.view.type){case 1:return new Int8Array(c,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return y}:void 0;return{message:JSON.parse(p,A),arrayBuffers:g}}e.$jdb=R}),define(ke[277],Se([1,0,278,390,391,62,2,15,392]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;const g=!1;function A(n,o,a,t,r,d){const u=d.environment.useHostProxy,l=typeof u=="boolean"?u:!d.remote.isRemote,h={resolveProxy:$=>n.resolveProxy($),lookupProxyAuthorization:c.bind(void 0,t,r,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>f(o),getSystemCertificatesV2:()=>y(o),log:($,b,...v)=>{switch($){case E.LogLevel.Trace:t.trace(b,...v);break;case E.LogLevel.Debug:t.debug(b,...v);break;case E.LogLevel.Info:t.info(b,...v);break;case E.LogLevel.Warning:t.warn(b,...v);break;case E.LogLevel.Error:t.error(b,...v);break;case E.LogLevel.Critical:t.error(b,...v);break;case E.LogLevel.Off:break;default:C($,b,v);break}function C(N,j,...M){t.error("Unknown log level",N),t.error(j,...M)}},getLogLevel:()=>{const $=t.getLevel();switch($){case p.LogLevel.Trace:return E.LogLevel.Trace;case p.LogLevel.Debug:return E.LogLevel.Debug;case p.LogLevel.Info:return E.LogLevel.Info;case p.LogLevel.Warning:return E.LogLevel.Warning;case p.LogLevel.Error:return E.LogLevel.Error;case p.LogLevel.Off:return E.LogLevel.Off;default:return b($)}function b(v){return t.error("Unknown log level",v),E.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,addCertificates:[],env:process.env},k=(0,E.createProxyResolver)(h),D=P(h,k);return w(a,D)}e.$dgc=A;function P(n,o){return{http:Object.assign(I,(0,E.createHttpPatch)(n,I,o)),https:Object.assign(F,(0,E.createHttpPatch)(n,F,o)),net:Object.assign(L,(0,E.createNetPatch)(n,L)),tls:Object.assign(m,(0,E.createTlsPatch)(n,m))}}function f(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",g)&&!!o.get("systemCertificates")}function y(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",g)&&!!o.get("systemCertificates")}const S=new Map;function w(n,o){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(u,l,h){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const k=a.findSubstr(R.URI.file(l.filename));let D=S.get(k);if(D||S.set(k,D={}),!D[u]){const $=o[u];D[u]={...$}}return D[u]}})}async function c(n,o,a,t,r,d,u,l){const h=t[d];u&&(t[d]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${h}`);const k=u||h,D=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(i(o,D,r),D.some($=>/^(Negotiate|Kerberos)( |$)/i.test($))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const $=await new Promise((j,M)=>{me(["kerberos"],j,M)}),b=new URL(d),v=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${b.hostname}`:`HTTP@${b.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${v}`),"Negotiate "+await(await $.initializeClient(v)).step("")}catch($){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",$)}}let s=!1;function i(n,o,a){s||!o.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ke[279],Se([1,0,131]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;function F(L){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:L,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function m(L){return new I.$Qm(F(L))}e.$Gr=m}),define(ke[141],Se([1,0,226,18,2,3,5,38,31,17,43,180,39]),function(me,e,I,F,m,L,R,p,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AE=e.$zE=e.$yE=e.EditorsOrder=e.$xE=e.CloseDirection=e.$wE=e.$vE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.EditorInputCapabilities=e.$mE=e.SaveReason=e.Verbosity=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=void 0,e.$_D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$aE={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$bE="workbench.editor.sidebysideEditor",e.$cE="workbench.editors.textDiffEditor",e.$dE="workbench.editors.binaryResourceDiffEditor";var y;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var S;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function w(le){const K=le;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$eE=w;function c(le,K,U){for(const ne of U.visibleEditorPanes)if(ne.group.id===K&&le.matches(ne.input))return ne.getViewState()}e.$fE=c;function s(le){if(k(le))return!1;const K=le;return m.URI.isUri(K?.resource)}e.$gE=s;function i(le){if(k(le))return!1;const K=le;return K?.original!==void 0&&K.modified!==void 0}e.$hE=i;function n(le){if(k(le))return!1;const K=le;return Array.isArray(K?.resources)}e.$iE=n;function o(le){if(k(le)||i(le))return!1;const K=le;return K?.primary!==void 0&&K.secondary!==void 0}e.$jE=o;function a(le){if(k(le))return!1;const K=le;return K?K.resource===void 0||K.resource.scheme===g.Schemas.untitled||K.forceUntitled===!0:!1}e.$kE=a;function t(le){if(k(le))return!1;const K=le;return m.URI.isUri(K?.base?.resource)&&m.URI.isUri(K?.input1?.resource)&&m.URI.isUri(K?.input2?.resource)&&m.URI.isUri(K?.result?.resource)}e.$lE=t;var r;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var d;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class u{constructor(){this.a=new Map}registerSource(K,U){let ne=this.a.get(K);return ne||(ne={source:K,label:U},this.a.set(K,ne)),ne.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$mE=new u;var l;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors",le[le.Scratchpad=512]="Scratchpad",le[le.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(l||(e.EditorInputCapabilities=l={}));class h extends L.$Rc{}e.$nE=h;function k(le){return le instanceof h}e.$oE=k;function D(le){const K=le;return m.URI.isUri(K?.preferredResource)}function $(le){const K=le;return k(K?.primary)&&k(K?.secondary)}e.$pE=$;function b(le){const K=le;return k(K?.modified)&&k(K?.original)}e.$qE=b;function v(le,K,U,ne,be){return Ee(ne,[(0,P.$Ei)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const G={...U,limits:{size:Number.MAX_VALUE}};le.openEditor(K,G)}}),(0,P.$Ei)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>be.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}e.$rE=v;function C(le){return k(le?.editor)}e.$sE=C;function N(le){const K=le;return C(le)&&K?.group!==void 0}e.$tE=N;function j(le){const K=le;return typeof K?.groupId=="number"&&k(K.editor)}e.$uE=j;var M;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var O;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LABEL=2]="GROUP_LABEL",le[le.GROUP_LOCKED=3]="GROUP_LOCKED",le[le.EDITOR_OPEN=4]="EDITOR_OPEN",le[le.EDITOR_CLOSE=5]="EDITOR_CLOSE",le[le.EDITOR_MOVE=6]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=8]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=10]="EDITOR_PIN",le[le.EDITOR_STICKY=11]="EDITOR_STICKY",le[le.EDITOR_DIRTY=12]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var z;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class T{getOriginalUri(K,U){if(!K)return;if(t(K))return e.$wE.getOriginalUri(K.result,U);if(U?.supportSideBySide){const{primary:be,secondary:G}=this.a(K);if(be&&G){if(U?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===z.ANY)return this.getOriginalUri(be,{filterByScheme:U.filterByScheme})??this.getOriginalUri(G,{filterByScheme:U.filterByScheme});K=U.supportSideBySide===z.PRIMARY?be:G}}if(i(K)||n(K)||o(K)||t(K))return;const ne=D(K)?K.preferredResource:K.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}a(K){return $(K)||o(K)?{primary:K.primary,secondary:K.secondary}:b(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,U){if(!K)return;if(t(K))return e.$wE.getCanonicalUri(K.result,U);if(U?.supportSideBySide){const{primary:be,secondary:G}=this.a(K);if(be&&G){if(U?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===z.ANY)return this.getCanonicalUri(be,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:U.filterByScheme});K=U.supportSideBySide===z.PRIMARY?be:G}}if(i(K)||n(K)||o(K)||t(K))return;const ne=K.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}b(K,U){if(Array.isArray(U)){if(U.some(ne=>K.scheme===ne))return K}else if(U===K.scheme)return K}}var W;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.KEYBOARD=1]="KEYBOARD",le[le.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function V(le,K,U,ne){if(!le.isSticky(K))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return U===W.MOUSE||U===W.KEYBOARD;case"mouse":return U===W.MOUSE;case"keyboard":return U===W.KEYBOARD}return!1}e.$vE=V,e.$wE=new T;var de;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(de||(e.CloseDirection=de={}));class ee{constructor(){this.c=new Map,this.d=new Map}start(K){const U=this.a=K.get(R.$Th);for(const[ne,be]of this.c)this.e(ne,be,U);this.c.clear()}e(K,U,ne){const be=ne.createInstance(U);this.d.set(K,be)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,F.$Mf)(this.b)}registerEditorSerializer(K,U){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,U,this.a):this.c.set(K,U),(0,L.$Pc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}p.$ln.add(e.$_D.EditorFactory,new ee);async function Z(le,K,U){return!le||!le.length?[]:await Promise.all(le.map(async ne=>{const be=m.URI.revive(ne.fileUri);if(!be){U.info("Cannot resolve the path because it is not valid.",ne);return}if(!await K.canHandleResource(be)){U.info("Cannot resolve the path because it cannot be handled",ne);return}let Y=ne.exists,X=ne.type;if(typeof Y!="boolean"||typeof X!="number")try{X=(await K.stat(be)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Y=!0}catch(re){U.error(re),Y=!1}if(!Y&&ne.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ne);return}if(X===E.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ne);return}const $e={...ne.options,pinned:!0};return Y?{resource:be,options:$e}:{resource:be,options:$e,forceUntitled:!0}}))}e.$xE=Z;var J;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(J||(e.EditorsOrder=J={}));function ae(le){const K=le;if(!K)return!1;const U=K;if(U.modified)return ae(U.modified);const ne=K;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$yE=ae;function x(le){return(0,A.$Gi)(le)}e.$zE=x;function Ee(le,K,U){const ne=(0,A.$Hi)(le,K);return ne.forceMessage=U?.forceMessage,ne.forceSeverity=U?.forceSeverity,ne.allowDialog=U?.allowDialog,ne}e.$AE=Ee}),define(ke[280],Se([1,0,4,227,5,3,28,38,19,24,79,266]),function(me,e,I,F,m,L,R,p,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JE=e.$IE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$HE=e.$GE=e.ViewContentGroups=e.$FE=e.$EE=e.ViewContainerLocation=e.Extensions=e.$DE=e.$CE=e.$BE=void 0,e.$BE="views",e.$CE=(0,F.localize)(0,null),e.$DE=(0,P.$_v)("default-view-icon",A.$Zj.window,(0,F.localize)(1,null));var f;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(f||(e.Extensions=f={}));var y;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(y||(e.ViewContainerLocation=y={})),e.$EE=[0,1,2];function S(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$FE=S;class w extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new I.$Qd),this.onDidRegister=this.c.event,this.f=this.B(new I.$Qd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(d,u,l){const h=this.get(d.id);if(h)return h;const k=d;return k.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,R.$wc)(this.g,u,[]).push(k),l?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:u}),k}deregisterViewContainer(d){for(const u of this.g.keys()){const l=this.g.get(u),h=l?.indexOf(d);if(h!==-1){l?.splice(h,1),l.length===0&&this.g.delete(u),this.f.fire({viewContainer:d,viewContainerLocation:u});return}}}get(d){return this.all.filter(u=>u.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(l=>l?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(u=>this.getViewContainerLocation(u)===d)}}p.$ln.add(f.ViewContainersRegistry,new w);var c;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(c||(e.ViewContentGroups=c={}));function s(r,d){const u=r.group??c.More,l=d.group??c.More;return u!==l?u.localeCompare(l):(r.order??5)-(d.order??5)}class i extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new I.$Qd),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$Qd),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$Qd),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$Qd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(d,u){this.registerViews2([{views:d,viewContainer:u}])}registerViews2(d){d.forEach(({views:u,viewContainer:l})=>this.r(u,l)),this.c.fire(d)}deregisterViews(d,u){const l=this.s(d,u);l.length&&this.f.fire({views:l,viewContainer:u})}moveViews(d,u){for(const l of this.m.keys())if(l!==u){const h=this.s(d,l);h.length&&(this.r(h,u),this.g.fire({views:h,from:l,to:u}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const u of this.j){const l=(this.m.get(u)||[]).filter(h=>h.id===d)[0];if(l)return l}return null}getViewContainer(d){for(const u of this.j)if((this.m.get(u)||[]).filter(h=>h.id===d)[0])return u;return null}registerViewWelcomeContent(d,u){return this.n.add(d,u),this.h.fire(d),(0,L.$Pc)(()=>{this.n.delete(d,u),this.h.fire(d)})}registerViewWelcomeContent2(d,u){const l=new Map;for(const[h,k]of u)this.n.add(d,k),l.set(h,(0,L.$Pc)(()=>{this.n.delete(d,k),this.h.fire(d)}));return this.h.fire(d),l}getViewWelcomeContent(d){const u=[];return this.n.forEach(d,l=>u.push(l)),u.sort(s)}r(d,u){let l=this.m.get(u);l||(l=[],this.m.set(u,l),this.j.push(u));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,F.localize)(2,null,h.id));l.push(h)}}s(d,u){const l=this.m.get(u);if(!l)return[];const h=[],k=[];for(const D of l)d.includes(D)?h.push(D):k.push(D);return h.length&&(k.length?this.m.set(u,k):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),h}}p.$ln.add(f.ViewsRegistry,new i),e.$GE=(0,m.$Uh)("viewsService"),e.$HE=(0,m.$Uh)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class a{constructor(d,u){this.c=!1,this.d=!1,(0,g.$cn)(this,d),this.d=!!u,this.resolve=async l=>{if(u&&!this.c){const h=await u(l);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$IE=a;class t extends Error{constructor(d){super((0,F.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$JE=t}),define(ke[281],Se([1,0,2,29,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$$E=e.$0E=void 0;function L(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof I.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(F.$zs.isIRange)}e.$0E=L;function R(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(L)}e.$$E=R;var p;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var E;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$_E=(0,m.$Uh)("IChatService")}),define(ke[142],Se([1,0,4,10,228]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new I.$Qd,this.n=new I.$Qd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(p){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=p}onEvent(p){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=p}onRequest(p){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.s("response",p)}sendRequest(p,E,g,A){const P={command:p};if(E&&Object.keys(E).length>0&&(P.arguments=E),this.s("request",P),typeof A=="number"){const f=setTimeout(()=>{clearTimeout(f);const y=this.f.get(P.seq);if(y){this.f.delete(P.seq);const S={type:"response",seq:0,request_seq:P.seq,success:!1,command:p,message:(0,m.localize)(0,null,A,p)};y(S)}},A)}return g&&this.f.set(P.seq,g),P.seq}acceptMessage(p){this.j?this.j(p):(this.k.push(p),this.k.length===1&&this.q())}o(p,E){return p.type!=="event"||E.type!=="event"}async q(){let p;for(;this.k.length;){if((!p||this.o(this.k[0],p))&&await(0,F.$Xg)(0),p=this.k.shift(),!p)return;switch(p.type){case"event":this.i?.(p);break;case"request":this.g?.(p);break;case"response":{const E=p,g=this.f.get(E.request_seq);g&&(this.f.delete(E.request_seq),g(E));break}}}}s(p,E){E.type=p,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((E,g)=>p.set(g,E)),await(0,F.$Xg)(500),p.forEach((E,g)=>{E({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Odb=L}),define(ke[282],Se([1,0,229,45,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$mH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$lH=e.MemoryRangeType=e.$kH=e.State=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=void 0,e.$hG="workbench.view.debug",e.$iG="workbench.debug.variablesView",e.$jG="workbench.debug.watchExpressionsView",e.$kG="workbench.debug.callStackView",e.$lG="workbench.debug.loadedScriptsView",e.$mG="workbench.debug.breakPointsView",e.$nG="workbench.debug.disassemblyView",e.$oG="workbench.panel.repl",e.$pG="workbench.panel.repl.view",e.$qG=new F.$_i("debugType",void 0,{type:"string",description:I.localize(0,null)}),e.$rG=new F.$_i("debugConfigurationType",void 0,{type:"string",description:I.localize(1,null)}),e.$sG=new F.$_i("debugState","inactive",{type:"string",description:I.localize(2,null)}),e.$tG="debugUx",e.$uG=new F.$_i(e.$tG,"default",{type:"string",description:I.localize(3,null)}),e.$vG=new F.$_i("hasDebugged",!1,{type:"boolean",description:I.localize(4,null)}),e.$wG=new F.$_i("inDebugMode",!1,{type:"boolean",description:I.localize(5,null)}),e.$xG=new F.$_i("inDebugRepl",!1,{type:"boolean",description:I.localize(6,null)}),e.$yG=new F.$_i("breakpointWidgetVisible",!1,{type:"boolean",description:I.localize(7,null)}),e.$zG=new F.$_i("inBreakpointWidget",!1,{type:"boolean",description:I.localize(8,null)}),e.$AG=new F.$_i("breakpointsFocused",!0,{type:"boolean",description:I.localize(9,null)}),e.$BG=new F.$_i("watchExpressionsFocused",!0,{type:"boolean",description:I.localize(10,null)}),e.$CG=new F.$_i("watchExpressionsExist",!1,{type:"boolean",description:I.localize(11,null)}),e.$DG=new F.$_i("variablesFocused",!0,{type:"boolean",description:I.localize(12,null)}),e.$EG=new F.$_i("expressionSelected",!1,{type:"boolean",description:I.localize(13,null)}),e.$FG=new F.$_i("breakpointInputFocused",!1,{type:"boolean",description:I.localize(14,null)}),e.$GG=new F.$_i("callStackItemType",void 0,{type:"string",description:I.localize(15,null)}),e.$HG=new F.$_i("callStackSessionIsAttach",!1,{type:"boolean",description:I.localize(16,null)}),e.$IG=new F.$_i("callStackItemStopped",!1,{type:"boolean",description:I.localize(17,null)}),e.$JG=new F.$_i("callStackSessionHasOneThread",!1,{type:"boolean",description:I.localize(18,null)}),e.$KG=new F.$_i("watchItemType",void 0,{type:"string",description:I.localize(19,null)}),e.$LG=new F.$_i("canViewMemory",void 0,{type:"boolean",description:I.localize(20,null)}),e.$MG=new F.$_i("breakpointItemType",void 0,{type:"string",description:I.localize(21,null)}),e.$NG=new F.$_i("breakpointSupportsCondition",!1,{type:"boolean",description:I.localize(22,null)}),e.$OG=new F.$_i("loadedScriptsSupported",!1,{type:"boolean",description:I.localize(23,null)}),e.$PG=new F.$_i("loadedScriptsItemType",void 0,{type:"string",description:I.localize(24,null)}),e.$QG=new F.$_i("focusedSessionIsAttach",!1,{type:"boolean",description:I.localize(25,null)}),e.$RG=new F.$_i("focusedSessionIsNoDebug",!1,{type:"boolean",description:I.localize(26,null)}),e.$SG=new F.$_i("stepBackSupported",!1,{type:"boolean",description:I.localize(27,null)}),e.$TG=new F.$_i("restartFrameSupported",!1,{type:"boolean",description:I.localize(28,null)}),e.$UG=new F.$_i("stackFrameSupportsRestart",!1,{type:"boolean",description:I.localize(29,null)}),e.$VG=new F.$_i("jumpToCursorSupported",!1,{type:"boolean",description:I.localize(30,null)}),e.$WG=new F.$_i("stepIntoTargetsSupported",!1,{type:"boolean",description:I.localize(31,null)}),e.$XG=new F.$_i("breakpointsExist",!1,{type:"boolean",description:I.localize(32,null)}),e.$YG=new F.$_i("debuggersAvailable",!1,{type:"boolean",description:I.localize(33,null)}),e.$ZG=new F.$_i("debugExtensionAvailable",!0,{type:"boolean",description:I.localize(34,null)}),e.$1G=new F.$_i("debugProtocolVariableMenuContext",void 0,{type:"string",description:I.localize(35,null)}),e.$2G=new F.$_i("debugSetVariableSupported",!1,{type:"boolean",description:I.localize(36,null)}),e.$3G=new F.$_i("debugSetExpressionSupported",!1,{type:"boolean",description:I.localize(37,null)}),e.$4G=new F.$_i("breakWhenValueChangesSupported",!1,{type:"boolean",description:I.localize(38,null)}),e.$5G=new F.$_i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:I.localize(39,null)}),e.$6G=new F.$_i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:I.localize(40,null)}),e.$7G=new F.$_i("terminateDebuggeeSupported",!1,{type:"boolean",description:I.localize(41,null)}),e.$8G=new F.$_i("suspendDebuggeeSupported",!1,{type:"boolean",description:I.localize(42,null)}),e.$9G=new F.$_i("variableEvaluateNamePresent",!1,{type:"boolean",description:I.localize(43,null)}),e.$0G=new F.$_i("variableIsReadonly",!1,{type:"boolean",description:I.localize(44,null)}),e.$$G=new F.$_i("exceptionWidgetVisible",!1,{type:"boolean",description:I.localize(45,null)}),e.$_G=new F.$_i("multiSessionRepl",!1,{type:"boolean",description:I.localize(46,null)}),e.$aH=new F.$_i("multiSessionDebug",!1,{type:"boolean",description:I.localize(47,null)}),e.$bH=new F.$_i("disassembleRequestSupported",!1,{type:"boolean",description:I.localize(48,null)}),e.$cH=new F.$_i("disassemblyViewFocus",!1,{type:"boolean",description:I.localize(49,null)}),e.$dH=new F.$_i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:I.localize(50,null)}),e.$eH=new F.$_i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:I.localize(51,null)});const L=f=>I.localize(52,null,f);e.$fH=L,e.$gH="editor.contrib.debug",e.$hH="editor.contrib.breakpoint",e.$iH="debug",e.$jH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:I.localize(53,null)};var R;(function(f){f[f.Inactive=0]="Inactive",f[f.Initializing=1]="Initializing",f[f.Stopped=2]="Stopped",f[f.Running=3]="Running"})(R||(e.State=R={}));function p(f){switch(f){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$kH=p;var E;(function(f){f[f.Valid=0]="Valid",f[f.Unreadable=1]="Unreadable",f[f.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$lH="vscode-debug-memory";var g;(function(f){f[f.Initial=1]="Initial",f[f.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var A;(function(f){f.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$mH=(0,m.$Uh)("debugService");var P;(function(f){f[f.CONDITION=0]="CONDITION",f[f.HIT_COUNT=1]="HIT_COUNT",f[f.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(ke[283],Se([1,0,13,2,16,24,17,29,21,19]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=void 0;const A=/{([^}]+)}/g;function P(D,$,b){return D.replace(A,function(v,C){return $&&C.length>0&&C[0]!=="_"?v:b&&b.hasOwnProperty(C)?b[C]:v})}e.$IF=P;function f(D){const $={};for(const b of Object.keys(D))b.startsWith("!")||($[b]=D[b]);return $}e.$JF=f;function y(D){return D.configuration.request==="attach"&&!S(D)&&(!D.parentSession||y(D.parentSession))}e.$KF=y;function S(D){let $=D.configuration.type;if($)return $==="vslsShare"&&($=D.configuration.adapterProxy.configuration.type),(0,I.$5e)($,"extensionhost")||(0,I.$5e)($,"pwa-extensionhost")?D:D.parentSession?S(D.parentSession):void 0}e.$LF=S;function w(D){return D.type&&(D.label||D.program||D.runtime)}e.$MF=w;function c(D,$,b){let v,C=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=N.exec(D);){const M=j.index+1,O=M+j[0].length;if(M<=$&&O>=b){v=j[0],C=M;break}}if(v){const M=/\w+/g;let O=null;for(;(O=M.exec(v))&&!(O.index+1+C+O[0].length>=b););O&&(v=v.substring(0,M.lastIndex))}return v?{start:C,end:C+v.length-1}:{start:0,end:0}}e.$NF=c;async function s(D,$,b,v){if(D.evaluatableExpressionProvider.has($)){const C=D.evaluatableExpressionProvider.ordered($),N=(0,g.$Gb)(await Promise.all(C.map(async j=>{try{return await j.provideEvaluatableExpression($,b,v??E.CancellationToken.None)}catch{return}})));if(N.length>0){let j=N[0].expression;const M=N[0].range;return j||(j=$.getLineContent(b.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:j}}}else{const C=$.getLineContent(b.lineNumber),{start:N,end:j}=c(C,b.column,b.column),M=C.substring(N-1,j);return{matchingExpression:M,range:new p.$zs(b.lineNumber,N,b.lineNumber,N+M.length)}}return null}e.$OF=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}e.$PF=n;function o(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return F.URI.parse(D.path);if((0,m.$hc)(D.path))return F.URI.file(D.path)}return D.path}function a(D){if(typeof D.path=="object"){const $=F.URI.revive(D.path);if($)return $.scheme===R.Schemas.file?$.fsPath:$.toString()}return D.path}function t(D,$){const b=$?o:a,v=(0,L.$_m)(D);return d(v,(C,N)=>{C&&N&&(N.path=b(N))}),v}e.$QF=t;function r(D,$){const b=$?o:a,v=(0,L.$_m)(D);return d(v,(C,N)=>{!C&&N&&(N.path=b(N))}),v}e.$RF=r;function d(D,$){switch(D.type){case"event":{const b=D;switch(b.event){case"output":$(!1,b.body.source);break;case"loadedSource":$(!1,b.body.source);break;case"breakpoint":$(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=D;switch(b.command){case"setBreakpoints":$(!0,b.arguments.source);break;case"breakpointLocations":$(!0,b.arguments.source);break;case"source":$(!0,b.arguments.source);break;case"gotoTargets":$(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(v=>$(!1,v));break;default:break}break}case"response":{const b=D;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(v=>$(!1,v.source));break;case"loadedSources":b.body.sources.forEach(v=>$(!1,v));break;case"scopes":b.body.scopes.forEach(v=>$(!1,v.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(v=>$(!1,v.source));break;case"setBreakpoints":b.body.breakpoints.forEach(v=>$(!1,v.source));break;case"disassemble":b.body?.instructions.forEach(C=>$(!1,C.location));break;default:break}break}}}function u(D){return D.filter($=>!$.presentation?.hidden).sort(($,b)=>$.presentation?b.presentation?$.presentation.group?b.presentation.group?$.presentation.group!==b.presentation.group?$.presentation.group.localeCompare(b.presentation.group):l($.presentation.order,b.presentation.order):-1:b.presentation.group?1:l($.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.$SF=u;function l(D,$){return typeof D!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:D-$}async function h(D,$){const b=D.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(b!=="none"&&(await $.saveAll(),b==="allEditorsInActiveGroup")){const v=$.activeEditorPane;v&&v.input.resource?.scheme===R.Schemas.untitled&&await $.save({editor:v.input,groupId:v.group.id})}await D.reloadConfiguration()}e.$TF=h;const k=(D,$)=>!D||!$?D===$:D.name===$.name&&D.path===$.path&&D.sourceReference===$.sourceReference;e.$UF=k}),define(ke[284],Se([1,0,50,62,24,16,12,13,30,230,142]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=e.$Qfc=e.$Pfc=e.$Ofc=e.$Nfc=void 0;class P extends A.$Odb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",n=>this.w(n))}sendMessage(s){if(this.p){const i=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${P.a}${i}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(P.a);if(i!==-1){const o=this.r.toString("utf8",0,i).split(P.b);for(const a of o){const t=a.split(P.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+P.a.length);continue}}break}}}e.$Nfc=P;class f extends P{startSession(){return new Promise((s,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",o=>{n?this.m.fire(o):i(o)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Ofc=f;class y extends f{constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$Pfc=y;class S extends f{constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.path,s)}}e.$Qfc=S;class w extends P{constructor(s,i){super(),this.y=s,this.z=i}async startSession(){const s=this.y.command,i=this.y.args,n=this.y.options||{};try{if(s)if(L.$hc(s)){if(!await E.Promises.exists(s))throw new Error(g.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=m.$cn(m.$_m(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=I.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(g.localize(2,null,i[0]));this.x=r}else throw new Error(g.localize(3,null));else{const a={env:o};n.cwd&&(a.cwd=n.cwd),this.x=I.spawn(s,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(o){this.m.fire(o)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((s,i)=>{const n=I.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,a,t){if(o)return i(o)});n.on("exit",s),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=L.$ic(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(L.$hc(s.program)?n.program=s.program:n.program=L.$ic(i,s.program)),s.args&&(n.args=s.args);const o=s;return o.win&&(n.win=w.A(o.win,i)),o.winx86&&(n.winx86=w.A(o.winx86,i)),o.windows&&(n.windows=w.A(o.windows,i)),o.osx&&(n.osx=w.A(o.osx,i)),o.linux&&(n.linux=w.A(o.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const u of s)if(u.contributes){const l=u.contributes.debuggers;l&&l.length>0&&l.filter(h=>typeof h.type=="string"&&p.$5e(h.type,i)).forEach(h=>{const k=w.A(h,u.extensionLocation.fsPath);n=m.$cn(n,k,u.isBuiltin)})}let o;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:R.$i?o=n.win||n.windows:R.$j?o=n.osx:R.$k&&(o=n.linux),o=o||n;const a=o.program||n.program,t=o.args||n.args,r=o.runtime||n.runtime,d=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(d||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$Rfc=w}),define(ke[285],Se([1,0,50,33,12]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tfc=e.$Sfc=void 0;function L(g,A){return new Promise((P,f)=>{let y="";const S=I.spawn(g,A);S.pid&&S.stdout.on("data",w=>{y+=w.toString()}),S.on("error",w=>{f(w)}),S.on("close",w=>{P(y)})})}async function R(g){if(g)if(m.$i){const A=await new Promise((P,f)=>{me(["@vscode/windows-process-tree"],P,f)});return new Promise(P=>{A.getProcessTree(g,f=>{P(!!f&&f.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(g)]).then(A=>{const P=A.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$Sfc=R;var p;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(p||(p={}));function E(g,A,P,f,y){g=g.trim().toLowerCase();let S;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?S=1:g.indexOf("cmd.exe")>=0?S=0:g.indexOf("bash")>=0?S=2:m.$i?S=0:S=2;let w,c=" ";switch(S){case 1:if(w=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),f){const s=(0,F.$6f)(f);s&&(c+=`${s}:; `),c+=`cd ${w(f)}; `}if(y)for(const s in y){const i=y[s];i===null?c+=`Remove-Item env:${s}; `:c+=`\${env:${s}}='${i}'; `}if(A.length>0){const s=A.shift(),i=P?s:w(s);c+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of A)c+=n==="<"||n===">"||P?n:w(n),c+=" "}break;case 0:if(w=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),f){const s=(0,F.$6f)(f);s&&(c+=`${s}: && `),c+=`cd ${w(f)} && `}if(y){c+='cmd /C "';for(const s in y){let i=y[s];i===null?c+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),c+=`set "${s}=${i}" && `)}}for(const s of A)c+=s==="<"||s===">"||P?s:w(s),c+=" ";y&&(c+='"');break;case 2:{w=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(f&&(c+=`cd ${w(f)} ; `),y){c+="/usr/bin/env";for(const i in y){const n=y[i];n===null?c+=` -u ${s(i)}`:c+=` ${s(`${i}=${n}`)}`}c+=" "}for(const i of A)c+=i==="<"||i===">"||P?i:w(i),c+=" ";break}}return c}e.$Tfc=E}),define(ke[111],Se([1,0,22,34,51,100,17,16,12,45]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=e.$EI=e.$DI=e.$CI=e.CellStatusbarAlignment=e.$BI=e.$AI=e.$zI=e.NotebookEditorPriority=e.$yI=e.$xI=e.$wI=e.$vI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$uI=e.$tI=e.$sI=e.$rI=e.CellKind=e.$qI=e.$pI=e.$oI=void 0,e.$oI="workbench.editor.notebook",e.$pI="workbench.editor.notebookTextDiffEditor",e.$qI="workbench.editor.interactive";var A;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(A||(e.CellKind=A={})),e.$rI=["application/json","application/javascript","text/html","image/svg+xml",L.$Vr.latex,L.$Vr.markdown,"image/png","image/jpeg",L.$Vr.text],e.$sI=[L.$Vr.latex,L.$Vr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Vr.text],e.$tI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$uI="_notAvailable";var P;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var f;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(f||(e.NotebookCellExecutionState=f={}));var y;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var S;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var w;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var c;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var s;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var i;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(T){T.scheme=R.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${W.join("")}]+`),de=7;function ee(le,K){const U=K.toString(de),be=`${U.length<W.length?W[U.length-1]:"z"}${U}s${(0,I.$ye)(I.$ee.fromString(le.scheme),!0,!0)}`;return le.with({scheme:T.scheme,fragment:be})}T.generate=ee;function Z(le){if(le.scheme!==T.scheme)return;const K=le.fragment.indexOf("s");if(K<0)return;const U=parseInt(le.fragment.substring(0,K).replace(V,""),de),ne=(0,I.$xe)(le.fragment.substring(K+1)).toString();if(!isNaN(U))return{handle:U,notebook:le.with({scheme:ne,fragment:null})}}T.parse=Z;function J(le,K){return le.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${le.scheme!==R.Schemas.file?le.scheme:""}`})}T.generateCellOutputUri=J;function ae(le){if(le.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(le.fragment);if(!K)return;const U=K[1]&&K[1]!==""?K[1]:void 0,ne=K[2];return{outputId:U,notebook:le.with({scheme:ne||R.Schemas.file,fragment:null})}}T.parseCellOutputUri=ae;function x(le,K,U){return T.generate(le,K).with({scheme:U})}T.generateCellPropertyUri=x;function Ee(le,K){if(le.scheme===K)return T.parse(le.with({scheme:T.scheme}))}T.parseCellPropertyUri=Ee})(n||(e.CellUri=n={}));const o=T=>E.$i?T.replace(/\//g,"\\"):T;class a{constructor(W=[],V=e.$rI){this.e=V,this.d=[...new Set(W)].map(de=>({pattern:de,matches:F.$Bj(o(de))}))}sort(W){const V=new Map(m.Iterable.map(W,ee=>[ee,o(ee)]));let de=[];for(const{matches:ee}of this.d)for(const[Z,J]of V)if(ee(J)){de.push(Z),V.delete(Z);break}return V.size&&(de=de.concat([...V.keys()].sort((ee,Z)=>this.e.indexOf(ee)-this.e.indexOf(Z)))),de}prioritize(W,V){const de=this.f(W);if(de===-1){this.d.unshift({pattern:W,matches:F.$Bj(o(W))});return}const ee=new Set(V.map(J=>this.f(J,de)));ee.delete(-1);const Z=Array.from(ee).sort();this.d.splice(de+1,0,...Z.map(J=>this.d[J]));for(let J=Z.length-1;J>=0;J--)this.d.splice(Z[J],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,V=this.d.length){const de=o(W);for(let ee=0;ee<V;ee++)if(this.d[ee].matches(de))return ee;return-1}}e.$vI=a;function t(T,W,V,de=(ee,Z)=>ee===Z){const ee=[];function Z(x,Ee,le){if(Ee===0&&le.length===0)return;const K=ee[ee.length-1];K&&K.start+K.deleteCount===x?(K.deleteCount+=Ee,K.toInsert.push(...le)):ee.push({start:x,deleteCount:Ee,toInsert:le})}let J=0,ae=0;for(;;){if(J===T.length){Z(J,0,W.slice(ae));break}if(ae===W.length){Z(J,T.length-J,[]);break}const x=T[J],Ee=W[ae];if(de(x,Ee)){J+=1,ae+=1;continue}V(Ee)?(Z(J,1,[]),J+=1):(Z(J,0,[Ee]),ae+=1)}return ee}e.$wI=t,e.$xI=new g.$_i("notebookEditorCursorAtBoundary","none"),e.$yI=new g.$_i("notebookEditorCursorAtLineBoundary","none");var r;(function(T){T.default="default",T.option="option"})(r||(e.NotebookEditorPriority=r={}));function d(T){const W=T;return!!((typeof W.include=="string"||F.$Cj(W.include))&&(typeof W.exclude=="string"||F.$Cj(W.exclude)))}e.$zI=d;function u(T,W,V){if(Array.isArray(T.viewType)&&T.viewType.indexOf(W)>=0||T.viewType===W)return!0;if(T.filenamePattern){const de=d(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,ee=d(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(F.$Aj(de,(0,p.$mc)(V.fsPath).toLowerCase()))return!(ee&&F.$Aj(ee,(0,p.$mc)(V.fsPath).toLowerCase()))}return!1}e.$AI=u,e.$BI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var l;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class h{static{this.d="notebook/"}static create(W){return`${h.d}${W}`}static parse(W){if(W.startsWith(h.d))return W.substring(h.d.length)}}e.$CI=h;function k(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.$DI=k;const D=new TextDecoder;function $(T){const W=[];let V=!1;for(const J of T)(W.length===0||V)&&(W.push(J),V=!0);let de=C(W);const ee=I.$ee.concat(W.map(J=>I.$ee.wrap(J))),Z=z(ee);return de=de||Z.byteLength!==ee.byteLength,{data:Z,didCompression:de}}e.$EI=$,e.$FI=`${String.fromCharCode(27)}[A`;const b=e.$FI.split("").map(T=>T.charCodeAt(0)),v=10;function C(T){let W=!1;return T.forEach((V,de)=>{if(de===0||V.length<e.$FI.length)return;const ee=T[de-1],Z=V.subarray(0,e.$FI.length);if(Z[0]===b[0]&&Z[1]===b[1]&&Z[2]===b[2]){const J=ee.lastIndexOf(v);if(J===-1)return;W=!0,T[de-1]=ee.subarray(0,J),T[de]=V.subarray(e.$FI.length)}}),W}function N(T){let W=T;do T=W,W=T.replace(/[^\n]\x08/gm,"");while(W.length<T.length);return T}function j(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const W=T.match(/^(.*)\r+/m)[1];let V=T.match(/\r+(.*)$/m)[1];V=V+W.slice(V.length,W.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return T}const M="\b".charCodeAt(0),O="\r".charCodeAt(0);function z(T){return!T.buffer.includes(M)&&!T.buffer.includes(O)?T:I.$ee.fromString(j(N(D.decode(T.buffer))))}}),define(ke[7],Se([1,0,19,11,81,28,100,13,18,2,32,26,31,65,111]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S){"use strict";var w,c,s,i,n,o,a,t,r,d,u,l,h,k,D,$,b,v;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$qM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.TestRunProfileKind=e.TestResultState=e.$9L=e.$8L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7L=e.$6L=e.$5L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.ColorThemeKind=e.$XL=e.$WL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VL=e.DebugConsoleMode=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PL=e.$OL=e.FileChangeType=e.$NL=e.$ML=e.$LL=e.$KL=e.InlineCompletionTriggerKind=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.ConfigurationTarget=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$nL=e.ViewBadge=e.ProgressLocation=e.$mL=e.$lL=e.TaskScope=e.ShellQuoting=e.$kL=e.$jL=e.$iL=e.TaskPanelKind=e.TaskRevealKind=e.$hL=e.TerminalLocation=e.$gL=e.$fL=e.$eL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$dL=e.$cL=e.$bL=e.$aL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$_K=e.StatusBarAlignment=e.ViewColumn=e.$$K=e.$0K=e.$9K=e.$8K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$7K=e.$6K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.LanguageStatusSeverity=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.CodeActionTriggerKind=e.$TK=e.$SK=e.SymbolTag=e.SymbolKind=e.$RK=e.DocumentHighlightKind=e.$QK=e.$PK=e.$OK=e.$NK=e.DiagnosticSeverity=e.DiagnosticTag=e.$MK=e.$LK=e.FileEditType=e.$KK=e.$JK=e.$IK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(H){return Object.assign(H,{apply:function(...ve){if(ve.length===0)return Reflect.construct(H,[]);{const Le=ve.length===1?[]:ve[1];return Reflect.construct(H,Le,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(H,[]);{const[Le,...Je]=ve;return Reflect.construct(H,Je,Le.constructor)}}})}var N;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var j;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(j||(e.TerminalQuickFixType=j={}));let M=w=class{static from(...q){let ve=q;return new w(function(){if(ve){for(const Le of ve)Le&&typeof Le.dispose=="function"&&Le.dispose();ve=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$BK=M,e.$BK=M=w=He([C],M);let O=c=class{static Min(...q){if(q.length===0)throw new TypeError;let ve=q[0];for(let Le=1;Le<q.length;Le++){const Je=q[Le];Je.isBefore(ve)&&(ve=Je)}return ve}static Max(...q){if(q.length===0)throw new TypeError;let ve=q[0];for(let Le=1;Le<q.length;Le++){const Je=q[Le];Je.isAfter(ve)&&(ve=Je)}return ve}static isPosition(q){if(!q)return!1;if(q instanceof c)return!0;const{line:ve,character:Le}=q;return typeof ve=="number"&&typeof Le=="number"}static of(q){if(q instanceof c)return q;if(this.isPosition(q))return new c(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,ve){if(q<0)throw(0,F.$6)("line must be non-negative");if(ve<0)throw(0,F.$6)("character must be non-negative");this.c=q,this.e=ve}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,ve=0){if(q===null||ve===null)throw(0,F.$6)();let Le;return typeof q>"u"?Le=0:typeof q=="number"?Le=q:(Le=typeof q.lineDelta=="number"?q.lineDelta:0,ve=typeof q.characterDelta=="number"?q.characterDelta:0),Le===0&&ve===0?this:new c(this.line+Le,this.character+ve)}with(q,ve=this.character){if(q===null||ve===null)throw(0,F.$6)();let Le;return typeof q>"u"?Le=this.line:typeof q=="number"?Le=q:(Le=typeof q.line=="number"?q.line:this.line,ve=typeof q.character=="number"?q.character:this.character),Le===this.line&&ve===this.character?this:new c(Le,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$CK=O,e.$CK=O=c=He([C],O);let z=s=class{static isRange(q){return q instanceof s?!0:q?O.isPosition(q.start)&&O.isPosition(q.end):!1}static of(q){if(q instanceof s)return q;if(this.isRange(q))return new s(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,ve,Le,Je){let et,ot;if(typeof q=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Je=="number"?(et=new O(q,ve),ot=new O(Le,Je)):O.isPosition(q)&&O.isPosition(ve)&&(et=O.of(q),ot=O.of(ve)),!et||!ot)throw new Error("Invalid arguments");et.isBefore(ot)?(this.c=et,this.e=ot):(this.c=ot,this.e=et)}contains(q){return s.isRange(q)?this.contains(q.start)&&this.contains(q.end):O.isPosition(q)?!(O.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const ve=O.Max(q.start,this.c),Le=O.Min(q.end,this.e);if(!ve.isAfter(Le))return new s(ve,Le)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const ve=O.Min(q.start,this.c),Le=O.Max(q.end,this.end);return new s(ve,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,ve=this.end){if(q===null||ve===null)throw(0,F.$6)();let Le;return q?O.isPosition(q)?Le=q:(Le=q.start||this.start,ve=q.end||this.end):Le=this.start,Le.isEqual(this.c)&&ve.isEqual(this.end)?this:new s(Le,ve)}toJSON(){return[this.start,this.end]}};e.$DK=z,e.$DK=z=s=He([C],z);let T=i=class extends z{static isSelection(q){return q instanceof i?!0:q?z.isRange(q)&&O.isPosition(q.anchor)&&O.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,ve,Le,Je){let et,ot;if(typeof q=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Je=="number"?(et=new O(q,ve),ot=new O(Le,Je)):O.isPosition(q)&&O.isPosition(ve)&&(et=O.of(q),ot=O.of(ve)),!et||!ot)throw new Error("Invalid arguments");super(et,ot),this.f=et,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$EK=T,e.$EK=T=i=He([C],T);const W=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,F.$6)("connectionToken")};class V{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,ve,Le){if(typeof q!="string"||q.length===0)throw(0,F.$6)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,F.$6)("port");typeof Le<"u"&&W(Le),this.host=q,this.port=Math.round(ve),this.connectionToken=Le}}e.$FK=V;class de{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,ve){this.makeConnection=q,this.connectionToken=ve,typeof ve<"u"&&W(ve)}}e.$GK=de;class ee extends Error{static NotAvailable(q,ve){return new ee(q,y.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(q){return new ee(q,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,ve=y.RemoteAuthorityResolverErrorCode.Unknown,Le){super(q),this._message=q,this._code=ve,this._detail=Le,Object.setPrototypeOf(this,ee.prototype)}}e.$HK=ee;var Z;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var J;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let ae=n=class{static isTextEdit(q){return q instanceof n?!0:q?z.isRange(q)&&typeof q.newText=="string":!1}static replace(q,ve){return new n(q,ve)}static insert(q,ve){return n.replace(new z(q,q),ve)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const ve=new n(new z(new O(0,0),new O(0,0)),"");return ve.newEol=q,ve}get range(){return this.c}set range(q){if(q&&!z.isRange(q))throw(0,F.$6)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,F.$6)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,F.$6)("newEol");this.f=q}constructor(q,ve){this.c=q,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$IK=ae,e.$IK=ae=n=He([C],ae);let x=o=class{static isNotebookCellEdit(q){return q instanceof o?!0:q?xt.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,ve){return new o(q,ve)}static insertCells(q,ve){return new o(new xt(q,q),ve)}static deleteCells(q){return new o(q,[])}static updateCellMetadata(q,ve){const Le=new o(new xt(q,q),[]);return Le.newCellMetadata=ve,Le}static updateNotebookMetadata(q){const ve=new o(new xt(0,0),[]);return ve.newNotebookMetadata=q,ve}constructor(q,ve){this.range=q,this.newCells=ve}};e.$JK=x,e.$JK=x=o=He([C],x);class Ee{static isSnippetTextEdit(q){return q instanceof Ee?!0:q?z.isRange(q.range)&&U.isSnippetString(q.snippet):!1}static replace(q,ve){return new Ee(q,ve)}static insert(q,ve){return Ee.replace(new z(q,q),ve)}constructor(q,ve){this.range=q,this.snippet=ve}}e.$KK=Ee;var le;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(le||(e.FileEditType=le={}));let K=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,ve,Le,Je){this.c.push({_type:1,from:q,to:ve,options:Le,metadata:Je})}createFile(q,ve,Le){this.c.push({_type:1,from:void 0,to:q,options:ve,metadata:Le})}deleteFile(q,ve,Le){this.c.push({_type:1,from:q,to:void 0,options:ve,metadata:Le})}e(q,ve,Le){this.c.push({_type:3,metadata:Le,uri:q,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(q,ve,Le,Je){const et=ve.start,ot=ve.end;(et!==ot||Le.length>0)&&this.c.push({_type:5,uri:q,index:et,count:ot-et,cells:Le,metadata:Je})}g(q,ve,Le,Je){this.c.push({_type:3,metadata:Je,uri:q,edit:{editType:3,index:ve,metadata:Le}})}replace(q,ve,Le,Je){this.c.push({_type:2,uri:q,edit:new ae(ve,Le),metadata:Je})}insert(q,ve,Le,Je){this.replace(q,new z(ve,ve),Le,Je)}delete(q,ve,Le){this.replace(q,ve,"",Le)}has(q){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===q.toString())}set(q,ve){if(ve)for(const Le of ve){if(!Le)continue;let Je,et;Array.isArray(Le)?(Je=Le[0],et=Le[1]):Je=Le,x.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(q,Je.range.start,Je.newCellMetadata,et):Je.newNotebookMetadata?this.e(q,Je.newNotebookMetadata,et):this.f(q,Je.range,Je.newCells,et):Ee.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:q,range:Je.range,edit:Je.snippet,metadata:et}):this.c.push({_type:2,uri:q,edit:Je,metadata:et})}else{for(let Le=0;Le<this.c.length;Le++){const Je=this.c[Le];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===q.toString()&&(this.c[Le]=void 0);break}}(0,I.$Hb)(this.c)}}get(q){const ve=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===q.toString()&&ve.push(Le.edit);return ve}entries(){const q=new L.$zc;for(const ve of this.c)if(ve._type===2){let Le=q.get(ve.uri);Le||(Le=[ve.uri,[]],q.set(ve.uri,Le)),Le[1].push(ve.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$LK=K,e.$LK=K=He([C],K);let U=a=class{static isSnippetString(q){return q instanceof a?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=a.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,ve=this.e++){if(typeof q=="function"){const Le=new a;Le.e=this.e,q(Le),this.e=Le.e,q=Le.value}else q=a.c(q);return this.value+="${",this.value+=ve,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,ve=this.e++){const Le=q.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(q,ve){if(typeof ve=="function"){const Le=new a;Le.e=this.e,ve(Le),this.e=Le.e,ve=Le.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$MK=U,e.$MK=U=a=He([C],U);var ne;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var be;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let G=t=class{static isLocation(q){return q instanceof t?!0:q?z.isRange(q.range)&&g.URI.isUri(q.uri):!1}constructor(q,ve){if(this.uri=q,ve)if(z.isRange(ve))this.range=z.of(ve);else if(O.isPosition(ve))this.range=new z(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$NK=G,e.$NK=G=t=He([C],G);let Y=class{static is(q){return q?typeof q.message=="string"&&q.location&&z.isRange(q.location.range)&&g.URI.isUri(q.location.uri):!1}constructor(q,ve){this.location=q,this.message=ve}static isEqual(q,ve){return q===ve?!0:!q||!ve?!1:q.message===ve.message&&q.location.range.isEqual(ve.location.range)&&q.location.uri.toString()===ve.location.uri.toString()}};e.$OK=Y,e.$OK=Y=He([C],Y);let X=class{constructor(q,ve,Le=be.Error){if(!z.isRange(q))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=q,this.message=ve,this.severity=Le}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,ve){return q===ve?!0:!q||!ve?!1:q.message===ve.message&&q.severity===ve.severity&&q.code===ve.code&&q.severity===ve.severity&&q.source===ve.source&&q.range.isEqual(ve.range)&&(0,I.$tb)(q.tags,ve.tags)&&(0,I.$tb)(q.relatedInformation,ve.relatedInformation,Y.isEqual)}};e.$PK=X,e.$PK=X=He([C],X);let $e=class{constructor(q,ve){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=ve}};e.$QK=$e,e.$QK=$e=He([C],$e);var re;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(re||(e.DocumentHighlightKind=re={}));let fe=class{constructor(q,ve=re.Text){this.range=q,this.kind=ve}toJSON(){return{range:this.range,kind:re[this.kind]}}};e.$RK=fe,e.$RK=fe=He([C],fe);var te;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var he;(function(H){H[H.Deprecated=1]="Deprecated"})(he||(e.SymbolTag=he={}));let pe=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,ve,Le,Je,et){this.name=q,this.kind=ve,this.containerName=et,typeof Le=="string"&&(this.containerName=Le),Je instanceof G?this.location=Je:Le instanceof z&&(this.location=new G(Je,Le)),r.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$SK=pe,e.$SK=pe=r=He([C],pe);let Pe=d=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(d.validate)}constructor(q,ve,Le,Je,et){this.name=q,this.detail=ve,this.kind=Le,this.range=Je,this.selectionRange=et,this.children=[],d.validate(this)}};e.$TK=Pe,e.$TK=Pe=d=He([C],Pe);var B;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Q=class{constructor(q,ve){this.title=q,this.kind=ve}};e.$UK=Q,e.$UK=Q=He([C],Q);let se=class{static{u=this}static{this.c="."}constructor(q){this.value=q}append(q){return new u(this.value?this.value+u.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+u.c)}};e.$VK=se,e.$VK=se=u=He([C],se),se.Empty=new se(""),se.QuickFix=se.Empty.append("quickfix"),se.Refactor=se.Empty.append("refactor"),se.RefactorExtract=se.Refactor.append("extract"),se.RefactorInline=se.Refactor.append("inline"),se.RefactorMove=se.Refactor.append("move"),se.RefactorRewrite=se.Refactor.append("rewrite"),se.Source=se.Empty.append("source"),se.SourceOrganizeImports=se.Source.append("organizeImports"),se.SourceFixAll=se.Source.append("fixAll"),se.Notebook=se.Empty.append("notebook");let oe=class{constructor(q,ve){if(this.range=q,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$WK=oe,e.$WK=oe=He([C],oe);class _{constructor(q,ve,Le,Je,et,ot){this.kind=q,this.name=ve,this.detail=Le,this.uri=Je,this.range=et,this.selectionRange=ot}}e.$XK=_;class ge{constructor(q,ve){this.fromRanges=ve,this.from=q}}e.$YK=ge;class ye{constructor(q,ve){this.fromRanges=ve,this.to=q}}e.$ZK=ye;var je;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let We=class{constructor(q,ve){this.range=q,this.command=ve}get isResolved(){return!!this.command}};e.$1K=We,e.$1K=We=He([C],We);let _e=l=class{#e;static isMarkdownString(q){return q instanceof l?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,ve=!1){this.#e=new m.$8j(q,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,ve){return this.#e.appendCodeblock(ve??"",q),this}};e.$2K=_e,e.$2K=_e=l=He([C],_e);let Ze=class{constructor(q,ve){this.label=q,this.documentation=ve}};e.$3K=Ze,e.$3K=Ze=He([C],Ze);let it=class{constructor(q,ve){this.label=q,this.documentation=ve,this.parameters=[]}};e.$4K=it,e.$4K=it=He([C],it);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$5K=tt,e.$5K=tt=He([C],tt);var Ae;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Oe;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(Oe||(e.InlayHintKind=Oe={}));let qe=class{constructor(q){this.value=q}};e.$6K=qe,e.$6K=qe=He([C],qe);let Re=class{constructor(q,ve,Le){this.position=q,this.label=ve,this.kind=Le}};e.$7K=Re,e.$7K=Re=He([C],Re);var Xe;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var ue;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(ue||(e.CompletionItemKind=ue={}));var ce;(function(H){H[H.Deprecated=1]="Deprecated"})(ce||(e.CompletionItemTag=ce={}));let Ie=class{constructor(q,ve){this.label=q,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$8K=Ie,e.$8K=Ie=He([C],Ie);let Ke=class{constructor(q=[],ve=!1){this.items=q,this.isIncomplete=ve}};e.$9K=Ke,e.$9K=Ke=He([C],Ke);let Ue=class{constructor(q,ve,Le){this.insertText=q,this.range=ve,this.command=Le}};e.$0K=Ue,e.$0K=Ue=He([C],Ue);let Ye=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$$K=Ye,e.$$K=Ye=He([C],Ye);var nt;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var ct;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(ct||(e.StatusBarAlignment=ct={}));function bt(H,q){return`${P.$$l.toKey(H)}.${q}`}e.$_K=bt;var Et;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var Kt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var wt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(wt||(e.TextEditorSelectionChangeKind=wt={}));var jt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Ot;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(H){function q(ve){switch(ve){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=q}(wt||(e.TextEditorSelectionChangeKind=wt={}));var Gt;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(H){function q(ve){switch(ve){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=q}(Gt||(e.SyntaxTokenType=Gt={}));let Ut=class{constructor(q,ve){if(ve&&!g.URI.isUri(ve))throw(0,F.$6)("target");if(!z.isRange(q)||q.isEmpty)throw(0,F.$6)("range");this.range=q,this.target=ve}};e.$aL=Ut,e.$aL=Ut=He([C],Ut);let Dt=class{constructor(q,ve,Le,Je){this.red=q,this.green=ve,this.blue=Le,this.alpha=Je}};e.$bL=Dt,e.$bL=Dt=He([C],Dt);let Ft=class{constructor(q,ve){if(ve&&!(ve instanceof Dt))throw(0,F.$6)("color");if(!z.isRange(q)||q.isEmpty)throw(0,F.$6)("range");this.range=q,this.color=ve}};e.$cL=Ft,e.$cL=Ft=He([C],Ft);let Bt=class{constructor(q){if(!q||typeof q!="string")throw(0,F.$6)("label");this.label=q}};e.$dL=Bt,e.$dL=Bt=He([C],Bt);var Qt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Qt||(e.ColorFormat=Qt={}));var Wt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var qt;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class Nt{constructor(q,ve,Le){if(this.startIndex=q,this.length=ve,this.tooltip=Le,typeof q!="number"||q<0)throw(0,F.$6)("startIndex");if(typeof ve!="number"||ve<1)throw(0,F.$6)("length");if(Le!==void 0&&typeof Le!="string")throw(0,F.$6)("tooltip")}}e.$eL=Nt;class ut{constructor(q){this.uri=q}}e.$fL=ut;class ft{constructor(q){this.terminalCommand=q}}e.$gL=ft;var At;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class Vt{constructor(q){if(this.options=q,typeof q!="object")throw(0,F.$6)("options")}}e.$hL=Vt;var Lt;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(Lt||(e.TaskRevealKind=Lt={}));var at;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(at||(e.TaskPanelKind=at={}));let vt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(q){switch(q){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(q,ve){if(this.label=ve,typeof q!="string"||typeof ve!="string")throw(0,F.$6)("name");this.c=q}get id(){return this.c}};e.$iL=vt,e.$iL=vt=h=He([C],vt);function Tt(H){let q="";for(let ve=0;ve<H.length;ve++)q+=H[ve].replace(/,/g,",,")+",";return q}let Pt=class{constructor(q,ve,Le){if(typeof q!="string")throw(0,F.$6)("process");this.e=[],this.c=q,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Le):this.f=ve)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,F.$6)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)q.push(ve);return Tt(q)}};e.$jL=Pt,e.$jL=Pt=He([C],Pt);let Ge=class{constructor(q,ve,Le){if(this.f=[],Array.isArray(ve)){if(!q)throw(0,F.$6)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,F.$6)("command");this.e=q,this.f=ve,this.g=Le}else{if(typeof q!="string")throw(0,F.$6)("commandLine");this.c=q,this.g=ve}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,F.$6)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,F.$6)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)q.push(typeof ve=="string"?ve:ve.value);return Tt(q)}};e.$kL=Ge,e.$kL=Ge=He([C],Ge);var Jt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Me;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class Te{constructor(q){this.c=q}computeId(){return"customExecution"+(0,A.$hg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$lL=Te;let Ce=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,ve,Le,Je,et,ot){this.j=!1,this.k=this.definition=q;let ht;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Le,this.execution=Je,ht=et,this.j=!0):ve===Me.Global||ve===Me.Workspace?(this.target=ve,this.m=this.name=Le,this.t=this.source=Je,this.execution=et,ht=ot):(this.target=ve,this.m=this.name=Le,this.t=this.source=Je,this.execution=et,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(q){this.h=q}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Pt?this.k={type:k.e,id:this.n.computeId()}:this.n instanceof Ge?this.k={type:k.f,id:this.n.computeId()}:this.n instanceof Te?this.k={type:k.c,id:this.n.computeId()}:this.k={type:k.g,id:(0,A.$hg)()}}get definition(){return this.k}set definition(q){if(q==null)throw(0,F.$6)("Kind can't be undefined or null");this.z(),this.k=q}get scope(){return this.l}set target(q){this.z(),this.l=q}get name(){return this.m}set name(q){if(typeof q!="string")throw(0,F.$6)("name");this.z(),this.m=q}get execution(){return this.n}set execution(q){q===null&&(q=void 0),this.z(),this.n=q;const ve=this.k.type;(k.g===ve||k.e===ve||k.f===ve||k.c===ve)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(q){if(Array.isArray(q))this.z(),this.o=q,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.z(),this.r=q}get source(){return this.t}set source(q){if(typeof q!="string"||q.length===0)throw(0,F.$6)("source must be a string of length > 0");this.z(),this.t=q}get group(){return this.u}set group(q){q===null&&(q=void 0),this.z(),this.u=q}get detail(){return this.y}set detail(q){q===null&&(q=void 0),this.y=q}get presentationOptions(){return this.w}set presentationOptions(q){q==null&&(q=Object.create(null)),this.z(),this.w=q}get runOptions(){return this.x}set runOptions(q){q==null&&(q=Object.create(null)),this.z(),this.x=q}};e.$mL=Ce,e.$mL=Ce=k=He([C],Ce);var ie;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(ie||(e.ProgressLocation=ie={}));var Fe;(function(H){function q(ve){const Le=ve;return(0,E.$Ff)(Le.value)?Le.tooltip&&!(0,E.$Bf)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}H.isViewBadge=q})(Fe||(e.ViewBadge=Fe={}));let Ve=D=class{static isTreeItem(q,ve){const Le=q;if(Le.checkboxState!==void 0){const Je=(0,E.$Ff)(Le.checkboxState)?Le.checkboxState:(0,E.$Df)(Le.checkboxState)&&(0,E.$Ff)(Le.checkboxState.state)?Le.checkboxState.state:void 0,et=!(0,E.$Ff)(Le.checkboxState)&&(0,E.$Df)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Qe.Checked&&Je!==Qe.Unchecked||et!==void 0&&!(0,E.$Bf)(et))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(q instanceof D)return!0;if(Le.label!==void 0&&!(0,E.$Bf)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,E.$Bf)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,E.$Bf)(Le.iconPath)&&!g.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,E.$Bf)(Le.iconPath.id))){const Je=Le.iconPath;if(!Je||!(0,E.$Bf)(Je.light)&&!g.URI.isUri(Je.light)&&!(0,E.$Bf)(Je.dark)&&!g.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,E.$Bf)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!g.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,E.$Bf)(Le.tooltip)&&!(Le.tooltip instanceof _e)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<xe.None&&Le.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,E.$Bf)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(q,ve=xe.None){this.collapsibleState=ve,g.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$nL=Ve,e.$nL=Ve=D=He([C],Ve);var xe;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var Qe;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(Qe||(e.TreeItemCheckboxState=Qe={}));let rt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$oL=rt,e.$oL=rt=He([C],rt);class kt extends rt{}e.$pL=kt;class St extends kt{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$qL=St;class mt{constructor(q,ve,Le,Je){this.name=q,this.uri=ve,this._itemId=Le,this.c=Je}data(){return this.c()}}e.$rL=mt;let dt=class{#e=new Map;constructor(q){for(const[ve,Le]of q??[]){const Je=this.#e.get(this.#t(ve));Je?Je.push(Le):this.#e.set(this.#t(ve),[Le])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,ve){this.#e.set(this.#t(q),[ve])}forEach(q,ve){for(const[Le,Je]of this.#e)for(const et of Je)q.call(ve,et,Le,this)}*[Symbol.iterator](){for(const[q,ve]of this.#e)for(const Le of ve)yield[q,Le]}#t(q){return q.toLowerCase()}};e.$sL=dt,e.$sL=dt=He([C],dt);let gt=class{constructor(q){this.insertText=q}};e.$tL=gt,e.$tL=gt=He([C],gt);let ui=class{constructor(q,ve){this.label=ve,this.insertText=q}};e.$uL=ui,e.$uL=ui=He([C],ui);let Ct=class{constructor(q,ve){this.id=q,this.color=ve}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$vL=Ct,e.$vL=Ct=He([C],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Di=class{constructor(q){this.id=q}};e.$wL=Di,e.$wL=Di=He([C],Di);var li;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let $i=class{get base(){return this.c}set base(q){this.c=q,this.e=g.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,ve){if(typeof q!="string"&&(!q||!g.URI.isUri(q)&&!g.URI.isUri(q.uri)))throw(0,F.$6)("base");if(typeof ve!="string")throw(0,F.$6)("pattern");typeof q=="string"?this.baseUri=g.URI.file(q):g.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$xL=$i,e.$xL=$i=He([C],$i);const It=new WeakMap;function gn(H,q){It.set(H,q)}e.$yL=gn;let ri=class{constructor(q,ve,Le,Je){this.enabled=typeof q=="boolean"?q:!0,typeof ve=="string"&&(this.condition=ve),typeof Le=="string"&&(this.hitCondition=Le),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=It.get(this)??(0,A.$hg)()),this.c}};e.$zL=ri,e.$zL=ri=He([C],ri);let yt=class extends ri{constructor(q,ve,Le,Je,et){if(super(ve,Le,Je,et),q===null)throw(0,F.$6)("location");this.location=q}};e.$AL=yt,e.$AL=yt=He([C],yt);let bi=class extends ri{constructor(q,ve,Le,Je,et){super(ve,Le,Je,et),this.functionName=q}};e.$BL=bi,e.$BL=bi=He([C],bi);let pi=class extends ri{constructor(q,ve,Le,Je,et,ot,ht){if(super(Je,et,ot,ht),!ve)throw(0,F.$6)("dataId");this.label=q,this.dataId=ve,this.canPersist=Le}};e.$CL=pi,e.$CL=pi=He([C],pi);let si=class{constructor(q,ve,Le){this.command=q,this.args=ve||[],this.options=Le}};e.$DL=si,e.$DL=si=He([C],si);let Ci=class{constructor(q,ve){this.port=q,this.host=ve}};e.$EL=Ci,e.$EL=Ci=He([C],Ci);let Ii=class{constructor(q){this.path=q}};e.$FL=Ii,e.$FL=Ii=He([C],Ii);let Rt=class{constructor(q){this.implementation=q}};e.$GL=Rt,e.$GL=Rt=He([C],Rt);let wi=class{constructor(q,ve,Le){this.session=q,this.threadId=ve,this.frameId=Le}};e.$HL=wi,e.$HL=wi=He([C],wi);let Pi=class{constructor(q,ve){this.session=q,this.threadId=ve}};e.$IL=Pi,e.$IL=Pi=He([C],Pi);let oi=class{constructor(q,ve){this.range=q,this.expression=ve}};e.$JL=oi,e.$JL=oi=He([C],oi);var hi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(hi||(e.InlineCompletionTriggerKind=hi={}));let lt=class{constructor(q,ve){this.range=q,this.text=ve}};e.$KL=lt,e.$KL=lt=He([C],lt);let Ai=class{constructor(q,ve,Le=!0){this.range=q,this.variableName=ve,this.caseSensitiveLookup=Le}};e.$LL=Ai,e.$LL=Ai=He([C],Ai);let Yt=class{constructor(q,ve){this.range=q,this.expression=ve}};e.$ML=Yt,e.$ML=Yt=He([C],Yt);let ii=class{constructor(q,ve){this.frameId=q,this.stoppedLocation=ve}};e.$NL=ii,e.$NL=ii=He([C],ii);var Li;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Ri=$=class extends Error{static FileExists(q){return new $(q,f.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(q){return new $(q,f.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(q){return new $(q,f.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(q){return new $(q,f.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(q){return new $(q,f.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(q){return new $(q,f.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(q,ve=f.FileSystemProviderErrorCode.Unknown,Le){super(g.URI.isUri(q)?q.toString(!0):q),this.code=Le?.name??"Unknown",(0,f.$sk)(this,ve),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$OL=Ri,e.$OL=Ri=$=He([C],Ri);let Mi=class{constructor(q,ve,Le){this.start=q,this.end=ve,this.kind=Le}};e.$PL=Mi,e.$PL=Mi=He([C],Mi);var Zi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Zi||(e.FoldingRangeKind=Zi={}));var Fi;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Xi;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(Xi||(e.CommentMode=Xi={}));var Ti;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class mn{constructor(q,ve=[]){this.tokenTypes=q,this.tokenModifiers=ve}}e.$QL=mn;function Oi(H){return typeof H>"u"||(0,E.$Cf)(H)}class di{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,q){this.l=!0;for(let ve=0,Le=q.tokenTypes.length;ve<Le;ve++)this.j.set(q.tokenTypes[ve],ve);for(let ve=0,Le=q.tokenModifiers.length;ve<Le;ve++)this.k.set(q.tokenModifiers[ve],ve)}}push(q,ve,Le,Je,et){if(typeof q=="number"&&typeof ve=="number"&&typeof Le=="number"&&typeof Je=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.n(q,ve,Le,Je,et);if(z.isRange(q)&&typeof ve=="string"&&Oi(Le))return this.m(q,ve,Le);throw(0,F.$6)()}m(q,ve,Le){if(!this.l)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Je=q.start.line,et=q.start.character,ot=q.end.character-q.start.character,ht=this.j.get(ve);let zt=0;if(Le)for(const Xt of Le){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);zt|=1<<ei>>>0}this.n(Je,et,ot,ht,zt)}n(q,ve,Le,Je,et){if(this.f&&(q<this.c||q===this.c&&ve<this.e)){this.f=!1;const zt=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<zt;ti++){let ni=this.g[5*ti],Qi=this.g[5*ti+1];ni===0?(ni=Xt,Qi+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Qi,Xt=ni,ei=Qi}}let ot=q,ht=ve;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=Le,this.g[this.h++]=Je,this.g[this.h++]=et,this.c=q,this.e=ve}static o(q){const ve=[],Le=q.length/5|0;for(let ht=0;ht<Le;ht++)ve[ht]=ht;ve.sort((ht,zt)=>{const Xt=q[5*ht],ei=q[5*zt];if(Xt===ei){const ti=q[5*ht+1],ni=q[5*zt+1];return ti-ni}return Xt-ei});const Je=new Uint32Array(q.length);let et=0,ot=0;for(let ht=0;ht<Le;ht++){const zt=5*ve[ht],Xt=q[zt+0],ei=q[zt+1],ti=q[zt+2],ni=q[zt+3],Qi=q[zt+4],In=Xt-et,Tn=In===0?ei-ot:ei,Ji=5*ht;Je[Ji+0]=In,Je[Ji+1]=Tn,Je[Ji+2]=ti,Je[Ji+3]=ni,Je[Ji+4]=Qi,et=Xt,ot=ei}return Je}build(q){return this.f?new Ni(new Uint32Array(this.g),q):new Ni(di.o(this.g),q)}}e.$RL=di;class Ni{constructor(q,ve){this.resultId=ve,this.data=q}}e.$SL=Ni;class $n{constructor(q,ve,Le){this.start=q,this.deleteCount=ve,this.data=Le}}e.$TL=$n;class fi{constructor(q,ve){this.resultId=ve,this.edits=q}}e.$UL=fi;var Yi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let zi=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$VL=zi,e.$VL=zi=He([C],zi);var xi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var gi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var _i;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class bn{static validate(q){if(typeof q.badge=="string"){let ve=(0,p.$cf)(q.badge,0);if(ve<q.badge.length&&(ve+=(0,p.$cf)(q.badge,ve)),q.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!Ct.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,ve,Le){this.badge=q,this.tooltip=ve,this.color=Le}}e.$WL=bn;let ji=class{constructor(q){this.kind=q}};e.$XL=ji,e.$XL=ji=He([C],ji);var mi;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class xt{static isNotebookRange(q){return q instanceof xt?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,ve){if(q<0)throw(0,F.$6)("start must be positive");if(ve<0)throw(0,F.$6)("end must be positive");q<=ve?(this.c=q,this.e=ve):(this.c=ve,this.e=q)}with(q){let ve=this.c,Le=this.e;return q.start!==void 0&&(ve=q.start),q.end!==void 0&&(Le=q.end),ve===this.c&&Le===this.e?this:new xt(ve,Le)}}e.$YL=xt;class vi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(ve=>vi.isNotebookCellData(ve))}static isNotebookCellData(q){return!0}constructor(q,ve,Le,Je,et,ot,ht){this.kind=q,this.value=ve,this.languageId=Le,this.mime=Je,this.outputs=et??[],this.metadata=ot,this.executionSummary=ht,vi.validate(this)}}e.$ZL=vi;class en{constructor(q){this.cells=q}}e.$1L=en;class Zt{static isNotebookCellOutputItem(q){return q instanceof Zt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const ve={name:q.name,message:q.message,stack:q.stack};return Zt.json(ve,"application/vnd.code.notebook.error")}static stdout(q){return Zt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Zt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,ve="application/octet-stream"){return new Zt(q,ve)}static#e=new TextEncoder;static text(q,ve=R.$Vr.text){const Le=Zt.#e.encode(String(q));return new Zt(Le,ve)}static json(q,ve="text/x-json"){const Le=JSON.stringify(q,void 0,"	");return Zt.text(Le,ve)}constructor(q,ve){this.data=q,this.mime=ve;const Le=(0,R.$Zr)(ve,!0);if(!Le)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$2L=Zt;class yi{static isNotebookCellOutput(q){return q instanceof yi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,ve=!1){const Le=new Set,Je=new Set;for(let et=0;et<q.length;et++){const ot=q[et],ht=(0,R.$Zr)(ot.mime);if(!Le.has(ht)||(0,S.$DI)(ht)){Le.add(ht);continue}Je.add(et),ve&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Je.size===0?q:q.filter((et,ot)=>!Je.has(ot))}constructor(q,ve,Le){this.items=yi.ensureUniqueMimeTypes(q,!0),typeof ve=="string"?(this.id=ve,this.metadata=Le):(this.id=(0,A.$hg)(),this.metadata=ve??Le)}}e.$3L=yi;var tn;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var Ei;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class sn{constructor(q,ve){this.text=q,this.alignment=ve}}e.$4L=sn;var ze;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(ze||(e.NotebookControllerAffinity=ze={}));var _t;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class on{constructor(q,ve=[]){this.uri=q,this.provides=(0,I.$2b)(ve)}}e.$5L=on;class $t{constructor(q){this.label=q}}e.$6L=$t;let Ui=class{constructor(q,ve){this.label=q,this.timestamp=ve}};e.$7L=Ui,e.$7L=Ui=He([C],Ui);var an;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Bi;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(Bi||(e.ExtensionRuntime=Bi={}));var cn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class ki{constructor(q,ve){this.ranges=q,this.wordPattern=ve}}e.$8L=ki;class pn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$9L=pn;var un;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Si=class{constructor(q=void 0,ve=void 0,Le=void 0,Je=!1){this.include=q,this.exclude=ve,this.profile=Le,this.continuous=Je}};e.$0L=Si,e.$0L=Si=He([C],Si);let Wi=b=class{static diff(q,ve,Le){const Je=new b(q);return Je.expectedOutput=ve,Je.actualOutput=Le,Je}constructor(q){this.message=q}};e.$$L=Wi,e.$$L=Wi=b=He([C],Wi);let qi=class{constructor(q){this.id=q}};e.$_L=qi,e.$_L=qi=He([C],qi);let ci=class{constructor(q,ve){this.covered=q,this.total=ve}};e.$aM=ci,e.$aM=ci=He([C],ci);let Vi=v=class{static fromDetails(q,ve){const Le=new ci(0,0),Je=new ci(0,0),et=new ci(0,0);for(const ht of ve)if("branches"in ht){Le.total+=1,Le.covered+=ht.executionCount>0?1:0;for(const zt of ht.branches)Je.total+=1,Je.covered+=zt.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const ot=new v(q,Le,Je.total>0?Je:void 0,et.total>0?et:void 0);return ot.detailedCoverage=ve,ot}constructor(q,ve,Le,Je){this.uri=q,this.statementCoverage=ve,this.branchCoverage=Le,this.functionCoverage=Je}};e.$bM=Vi,e.$bM=Vi=v=He([C],Vi);let Ki=class{constructor(q,ve,Le=[]){this.executionCount=q,this.location=ve,this.branches=Le}};e.$cM=Ki,e.$cM=Ki=He([C],Ki);let Hi=class{constructor(q,ve){this.executionCount=q,this.location=ve}};e.$dM=Hi,e.$dM=Hi=He([C],Hi);let Gi=class{constructor(q,ve){this.executionCount=q,this.location=ve}};e.$eM=Gi,e.$eM=Gi=He([C],Gi);var hn;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var dn;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var fn;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class we{constructor(q,ve,Le,Je,et,ot){this.kind=q,this.name=ve,this.detail=Le,this.uri=Je,this.range=et,this.selectionRange=ot}}e.$fM=we;class De{constructor(q){this.uri=q}}e.$gM=De;class Ne{constructor(q,ve){this.original=q,this.modified=ve}}e.$hM=Ne;class st{constructor(q,ve,Le,Je){this.base=q,this.input1=ve,this.input2=Le,this.result=Je}}e.$iM=st;class pt{constructor(q,ve){this.uri=q,this.viewType=ve}}e.$jM=pt;class Mt{constructor(q){this.viewType=q}}e.$kM=Mt;class Pn{constructor(q,ve){this.uri=q,this.notebookType=ve}}e.$lM=Pn;class An{constructor(q,ve,Le){this.original=q,this.modified=ve,this.notebookType=Le}}e.$mM=An;class Ln{constructor(){}}e.$nM=Ln;class Rn{constructor(q,ve){this.uri=q,this.inputBoxUri=ve}}e.$oM=Rn;class Mn{constructor(q){this.providerId=q}}e.$pM=Mn;var wn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var vn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var kn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Fn{constructor(q,ve){this.role=q,this.content=ve}}e.$qM=Fn;var Sn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(Sn||(e.ChatAgentResultFeedbackKind=Sn={}));var Dn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Cn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(Cn||(e.SpeechToTextStatus=Cn={}))}),define(ke[143],Se([1,0,60,17,13,176,127,7,19]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.$DM=void 0;const g=new Map;function A(S,w){w?g.set(S,w):g.delete(S)}e.$DM=A;function P(S){return g.get(S)}class f extends L.$2u{constructor(w,c,s,i,n,o,a,t){super(c,s,i,n),this.c=w,this.m=o,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(w){return(0,E.$tb)(this.f,w)}get document(){if(!this.a){const w=this;this.a={get uri(){return w.d},get fileName(){return w.d.fsPath},get isUntitled(){return w.d.scheme===F.Schemas.untitled},get languageId(){return w.m},get version(){return w.h},get isClosed(){return w.b},get isDirty(){return w.q},save(){return w.r()},getText(c){return c?w.s(c):w.getText()},get eol(){return w.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return w.f.length},lineAt(c){return w.t(c)},offsetAt(c){return w.u(c)},positionAt(c){return w.v(c)},validateRange(c){return w.w(c)},validatePosition(c){return w.x(c)},getWordRangeAtPosition(c,s){return w.y(c,s)}}}return Object.freeze(this.a)}_acceptLanguageId(w){(0,I.ok)(!this.b),this.m=w}_acceptIsDirty(w){(0,I.ok)(!this.b),this.q=w}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(w){const c=this.w(w);if(c.isEmpty)return"";if(c.isSingleLine)return this.f[c.start.line].substring(c.start.character,c.end.character);const s=this.g,i=c.start.line,n=c.end.line,o=[];o.push(this.f[i].substring(c.start.character));for(let a=i+1;a<n;a++)o.push(this.f[a]);return o.push(this.f[n].substring(0,c.end.character)),o.join(s)}t(w){let c;if(w instanceof p.$CK?c=w.line:typeof w=="number"&&(c=w),typeof c!="number"||c<0||c>=this.f.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new y(c,this.f[c],c===this.f.length-1)}u(w){return w=this.x(w),this.l(),this.j.getPrefixSum(w.line-1)+w.character}v(w){w=Math.floor(w),w=Math.max(0,w),this.l();const c=this.j.getIndexOf(w),s=this.f[c.index].length;return new p.$CK(c.index,Math.min(c.remainder,s))}w(w){if(!(w instanceof p.$DK))throw new Error("Invalid argument");const c=this.x(w.start),s=this.x(w.end);return c===w.start&&s===w.end?w:new p.$DK(c.line,c.character,s.line,s.character)}x(w){if(!(w instanceof p.$CK))throw new Error("Invalid argument");if(this.f.length===0)return w.with(0,0);let{line:c,character:s}=w,i=!1;if(c<0)c=0,s=0,i=!0;else if(c>=this.f.length)c=this.f.length-1,s=this.f[c].length,i=!0;else{const n=this.f[c].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new p.$CK(c,s):w}y(w,c){const s=this.x(w);if(!c)c=P(this.m);else if((0,m.$Re)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const i=(0,R.$bs)(s.character+1,(0,R.$_r)(c),this.f[s.line],0);if(i)return new p.$DK(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$EM=f;class y{constructor(w,c,s){this.a=w,this.b=c,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$DK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$DK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$FM=y}),define(ke[286],Se([1,0,7,20,4]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;let L=class{constructor(p){this.a=new I.$XL(I.ColorThemeKind.Dark),this.b=new m.$Qd}get activeColorTheme(){return this.a}$onColorThemeChange(p){let E;switch(p){case"light":E=I.ColorThemeKind.Light;break;case"hcDark":E=I.ColorThemeKind.HighContrast;break;case"hcLight":E=I.ColorThemeKind.HighContrastLight;break;default:E=I.ColorThemeKind.Dark}this.a=new I.$XL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$0ec=L,e.$0ec=L=He([Be(0,F.$BM)],L)}),define(ke[287],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=e.CellExecutionUpdateType=void 0;var F;(function(m){m[m.Output=1]="Output",m[m.OutputItems=2]="OutputItems",m[m.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$HI=(0,I.$Uh)("INotebookExecutionService")}),define(ke[288],Se([1,0,3,29,193,99]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LOb=void 0;class R extends I.$Rc{constructor(E,g,A){super(),this._source=E,this.b=g,this.c=A,this.a=void 0}f(E){const g=E.getLineCount();return new F.$zs(1,1,g,this.g(E,g))}g(E,g){if(g<1||g>E.getLineCount())throw new Error("Illegal value for lineNumber");return E.getLineLength(g)+1}get inputTextBuffer(){if(!this.b){const E=new m.$MB;E.acceptChunk(this._source);const g=E.finish(!0),{textBuffer:A,disposable:P}=g.create(1);this.b=A,this.B(P)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(E=>{const g=new m.$MB;g.acceptChunk(E);const A=g.finish(!0),{textBuffer:P,disposable:f}=A.create(1);return this.B(f),P})),this.a}findInInputs(E){const A=new L.$AB(E,!1,!1,null).parseSearchRequest();if(!A)return[];const P=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(P,A,!0,5e3)}findInOutputs(E){const A=new L.$AB(E,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(P=>{const f=P.findMatchesLineByLine(this.f(P),A,!0,5e3);if(f.length!==0)return{textBuffer:P,matches:f}}).filter(P=>!!P):[]}}e.$LOb=R}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(L){L.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class m{static fromExtHostTestItem(R,p,E=R.parent){if(R._isRoot)return new m([p]);const g=[R.id];for(let A=E;A&&A.id!==p;A=A.parent)g.push(A.id);return g.push(p),new m(g.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const p=R.indexOf("\0");return p===-1?R:R.slice(0,p)}static fromString(R){return new m(R.split("\0"))}static join(R,p){return new m([...R.path,p])}static joinToString(R,p){return R.toString()+"\0"+p}static parentId(R){const p=R.lastIndexOf("\0");return p===-1?void 0:R.slice(0,p)}static localId(R){const p=R.lastIndexOf("\0");return p===-1?R:R.slice(p+1)}static isChild(R,p){return p.startsWith(R)&&p[R.length]==="\0"}static compare(R,p){return R===p?0:m.isChild(R,p)?2:m.isChild(p,R)?3:1}constructor(R,p=R.length){if(this.path=R,this.d=p,R.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new m(this.path,1)}get parentId(){return this.d>1?new m(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new m(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new m(this.path,R)}compare(R){if(typeof R=="string")return m.compare(this.toString(),R);for(let p=0;p<R.d&&p<this.d;p++)if(R.path[p]!==this.path[p])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$pJ=m}),define(ke[89],Se([1,0,2,29,68]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$vJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$uJ=e.$tJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$sJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$rJ=e.$qJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(D){D[D.Unset=0]="Unset",D[D.Queued=1]="Queued",D[D.Running=2]="Running",D[D.Passed=3]="Passed",D[D.Failed=4]="Failed",D[D.Skipped=5]="Skipped",D[D.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(D){D[D.Run=1]="Run",D[D.Debug=2]="Debug",D[D.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var p;(function(D){D[D.Run=2]="Run",D[D.Debug=4]="Debug",D[D.Coverage=8]="Coverage",D[D.HasNonDefaultProfile=16]="HasNonDefaultProfile",D[D.HasConfigurable=32]="HasConfigurable",D[D.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$qJ=[2,4,8,16,32,64];const E=D=>"runId"in D;e.$rJ=E;var g;(function(D){D.serialize=$=>({range:$.range.toJSON(),uri:$.uri.toJSON()}),D.deserialize=$=>({range:F.$zs.lift($.range),uri:I.URI.revive($.uri)})})(g||(e.IRichLocation=g={}));var A;(function(D){D[D.Error=0]="Error",D[D.Output=1]="Output"})(A||(e.TestMessageType=A={}));var P;(function(D){D.serialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&g.serialize($.location)}),D.deserialize=$=>({message:$.message,type:0,expected:$.expected,actual:$.actual,contextValue:$.contextValue,location:$.location&&g.deserialize($.location)})})(P||(e.ITestErrorMessage=P={}));const f=(D,$)=>`${$?"s":"e"}${D}`;e.$sJ=f;var y;(function(D){D.serialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&g.serialize($.location)}),D.deserialize=$=>({message:$.message,type:1,offset:$.offset,length:$.length,location:$.location&&g.deserialize($.location)})})(y||(e.ITestOutputMessage=y={}));var S;(function(D){D.serialize=$=>$.type===0?P.serialize($):y.serialize($),D.deserialize=$=>$.type===0?P.deserialize($):y.deserialize($)})(S||(e.ITestMessage=S={}));var w;(function(D){D.serializeWithoutMessages=$=>({state:$.state,duration:$.duration,messages:[]}),D.serialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(S.serialize)}),D.deserialize=$=>({state:$.state,duration:$.duration,messages:$.messages.map(S.deserialize)})})(w||(e.ITestTaskState=w={}));const c="\0",s=(D,$)=>D+c+$;e.$tJ=s;const i=D=>{const $=D.indexOf(c);return{ctrlId:D.slice(0,$),tagId:D.slice($+1)}};e.$uJ=i;var n;(function(D){D.serialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?.toJSON(),range:$.range?.toJSON()||null,description:$.description,error:$.error,sortText:$.sortText}),D.deserialize=$=>({extId:$.extId,label:$.label,tags:$.tags,busy:$.busy,children:void 0,uri:$.uri?I.URI.revive($.uri):void 0,range:$.range?F.$zs.lift($.range):null,description:$.description,error:$.error,sortText:$.sortText})})(n||(e.ITestItem=n={}));var o;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var a;(function(D){D.serialize=$=>({expand:$.expand,item:n.serialize($.item)}),D.deserialize=$=>({controllerId:m.$pJ.root($.item.extId),expand:$.expand,item:n.deserialize($.item)})})(a||(e.InternalTestItem=a={}));var t;(function(D){D.serialize=$=>{let b;return $.item&&(b={},$.item.label!==void 0&&(b.label=$.item.label),$.item.tags!==void 0&&(b.tags=$.item.tags),$.item.busy!==void 0&&(b.busy=$.item.busy),$.item.uri!==void 0&&(b.uri=$.item.uri?.toJSON()),$.item.range!==void 0&&(b.range=$.item.range?.toJSON()),$.item.description!==void 0&&(b.description=$.item.description),$.item.error!==void 0&&(b.error=$.item.error),$.item.sortText!==void 0&&(b.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:b}},D.deserialize=$=>{let b;return $.item&&(b={},$.item.label!==void 0&&(b.label=$.item.label),$.item.tags!==void 0&&(b.tags=$.item.tags),$.item.busy!==void 0&&(b.busy=$.item.busy),$.item.range!==void 0&&(b.range=$.item.range?F.$zs.lift($.item.range):null),$.item.description!==void 0&&(b.description=$.item.description),$.item.error!==void 0&&(b.error=$.item.error),$.item.sortText!==void 0&&(b.sortText=$.item.sortText)),{extId:$.extId,expand:$.expand,item:b}}})(t||(e.ITestItemUpdate=t={}));const r=(D,$)=>{$.expand!==void 0&&(D.expand=$.expand),$.item!==void 0&&(D.item=D.item?Object.assign(D.item,$.item):$.item)};e.$vJ=r;var d;(function(D){D.serializeWithoutMessages=$=>({...a.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(w.serializeWithoutMessages)}),D.serialize=$=>({...a.serialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(w.serialize)}),D.deserialize=$=>({...a.deserialize($),ownComputedState:$.ownComputedState,computedState:$.computedState,tasks:$.tasks.map(w.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var u;(function(D){D[D.Function=0]="Function",D[D.Statement=1]="Statement"})(u||(e.DetailType=u={}));var l;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.DocumentSynced=2]="DocumentSynced",D[D.Remove=3]="Remove",D[D.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",D[D.Retire=5]="Retire",D[D.AddTag=6]="AddTag",D[D.RemoveTag=7]="RemoveTag"})(l||(e.TestDiffOpType=l={}));var h;(function(D){D.deserialize=$=>$.op===0?{op:$.op,item:a.deserialize($.item)}:$.op===1?{op:$.op,item:t.deserialize($.item)}:$.op===2?{op:$.op,uri:I.URI.revive($.uri),docv:$.docv}:$,D.serialize=$=>$.op===0?{op:$.op,item:a.serialize($.item)}:$.op===1?{op:$.op,item:t.serialize($.item)}:$})(h||(e.TestsDiffOp=h={}));class k{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply($){const b=this.o();for(const v of $)switch(v.op){case 0:this.j(a.deserialize(v.item),b);break;case 1:this.k(t.deserialize(v.item),b);break;case 3:this.l(v.itemId,b);break;case 5:this.m(v.itemId);break;case 4:this.updatePendingRoots(v.amount);break;case 6:this.c.set(v.tag.id,v.tag);break;case 7:this.c.delete(v.id);break}b.complete?.()}j($,b){const v=m.$pJ.parentId($.item.extId)?.toString();let C;if(!v)C=this.p($),this.f.add(C),this.d.set($.item.extId,C);else if(this.d.has(v)){const N=this.d.get(v);N.children.add($.item.extId),C=this.p($,N),this.d.set($.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify($)}`);return}return b.add?.(C),$.expand===2&&this.g++,C}k($,b){const v=this.d.get($.extId);if(v)return $.expand!==void 0&&(v.expand===2&&this.g--,$.expand===2&&this.g++),(0,e.$vJ)(v,$),b.update?.(v),v}l($,b){const v=this.d.get($);if(!v)return;const C=m.$pJ.parentId(v.item.extId)?.toString();C?this.d.get(C).children.delete(v.item.extId):this.f.delete(v);const N=[[$]];for(;N.length;)for(const j of N.pop()){const M=this.d.get(j);M&&(N.push(M.children),this.d.delete(j),b.remove?.(M,M!==v),M.expand===2&&this.g--)}}m($){}updatePendingRoots($){this.h+=$}o(){return{}}}e.$wJ=k}),define(ke[112],Se([1,0,10,4,3,60,89,68]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.TestItemEventOp=void 0;var E;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const g=(i,n)=>i===n,P=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:g,label:g,description:g,error:g,sortText:g,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),f=(i,n)=>{let o;for(const[a,t]of P)t(i[a],n[a])||(o?o[a]=n[a]:o={[a]:n[a]});return o};class y extends m.$Rc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new I.$9g(()=>this.flushDiff(),200)),this.g=this.B(new F.$Qd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,R.$vJ)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,R.$vJ)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||o>a.expandLevels)&&(a.expandLevels=o),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,o-1):t.wait().then(()=>this.J(a,o-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,o-1)):this.J(a,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,o){switch(o.op){case 3:this.N(p.$pJ.joinToString(n.fullId,o.id));break;case 0:this.y(o.item,n);break;case 5:for(const a of o.ops)this.u(n,a);break;case 1:this.z(o.new,o.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.w(n.actual.uri);break;default:(0,L.$3c)(o)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,o){const a=p.$pJ.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.H(n,r,o);return}if(r.actual===n){this.G(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,o);const d=this.s.getChildren(r.actual),u=r.actual,l=f(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,r.actual=n,r.expand=0,l&&(l.hasOwnProperty("tags")&&(this.z(n.tags,u.tags,a.toString()),delete l.tags),this.u(r,{op:4,update:l})),this.H(n,r,o);for(const[h,k]of d)this.s.getChildren(n).get(k.id)||this.N(p.$pJ.joinToString(a,k.id));this.w(r.actual.uri)}z(n,o,a){const t=new Set(o.map(r=>r.id));for(const r of n)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(r=>(0,R.$tJ)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$tJ)(this.s.controllerId,n.id)}}))}D(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$tJ)(this.s.controllerId,n)}))}F(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}G(n,o,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=r=>this.u(o,r),this.I(o)}H(n,o,a){this.G(n,o,a);for(const[t,r]of this.s.getChildren(n))this.y(r,o)}I(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.L(n))}J(n,o){if(o<0)return;const a=[];for(const[t,r]of this.s.getChildren(n.actual)){const d=this.expand(p.$pJ.joinToString(n.fullId,r.id),o);(0,I.$Jg)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new I.$Vg;return r.open(),r}n.expand=2,this.M(n);const o=n.resolveBarrier=new I.$Vg,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(r){a(r)}return(0,I.$Jg)(t)?t.catch(a).then(()=>{o.open(),this.I(n)}):(o.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[o];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,d]of this.s.getChildren(t.actual))a.push(this.tree.get(p.$pJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$rM=y;class S extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$sM=S;class w extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$tM=w;class c extends Error{constructor(n,o,a){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${a}".`)}}e.$uM=c;const s=(i,n,o)=>{let a=new Map;return{get size(){return a.size},forEach(t,r){for(const d of a.values())t.call(r,d,this)},[Symbol.iterator](){return a.entries()},replace(t){const r=new Map,d=new Set(a.keys()),u={op:5,ops:[]};for(const l of t){if(!(l instanceof o))throw new w(l.id);const h=n(l).controllerId;if(h!==i.controllerId)throw new c(l.id,h,i.controllerId);if(r.has(l.id))throw new S(l.id);r.set(l.id,l),d.delete(l.id),u.ops.push({op:0,item:l})}for(const l of d.keys())u.ops.push({op:3,id:l});i.listener?.(u),a=r},add(t){if(!(t instanceof o))throw new w(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$vM=s}),define(ke[144],Se([1,0,112]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0;const F=new WeakMap,m=(R,p)=>{const E={controllerId:p};return F.set(R,E),E};e.$wM=m;const L=R=>{const p=F.get(R);if(!p)throw new I.$tM(R?.id||"<unknown>");return p};e.$xM=L}),define(ke[113],Se([1,0,17,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cub=e.$bub=e.$aub=e.$_tb=e.$$tb=void 0,e.$$tb="vscode-cdn.net",e.$_tb=`vscode-resource.${e.$$tb}`,e.$aub=`'self' https://*.${e.$$tb}`;function m(p,E){return p.scheme===I.Schemas.http||p.scheme===I.Schemas.https?p:(E&&E.authority&&E.isRemote&&p.scheme===I.Schemas.file&&(p=F.URI.from({scheme:I.Schemas.vscodeRemote,authority:E.authority,path:p.path})),F.URI.from({scheme:I.Schemas.https,authority:`${p.scheme}+${L(p.authority)}.${e.$_tb}`,path:p.path,fragment:p.fragment,query:p.query}))}e.$bub=m;function L(p){return p.replace(/./g,E=>{const g=E.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?E:"-"+g.toString(16).padStart(4,"0")})}function R(p){return p.replace(/-([0-9a-f]{4})/g,(E,g)=>String.fromCharCode(parseInt(g,16)))}e.$cub=R}),define(ke[289],Se([1,0,4,3,113]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;class L{constructor(p,E,g){this.d=p,this.e=E,this.f=g,this.a=0,this.b=new F.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const A=E.getVisibleTextEditors();for(const P of this.c.values())A.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,E,g,A,P){let f;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){f=n;break}if(!f)throw new Error("not a visible editor");const y=this,S=this.a++,w=new I.$Qd,c=new I.$Qd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,m.$bub)(n,y.f)}get cspSource(){return m.$aub}set options(n){this.b=n,y.d.$setOptions(S,n)}get options(){return this.b}set html(n){this.a=n,y.d.$setHtml(S,n)}get html(){return this.a}get onDidReceiveMessage(){return w.event}postMessage(n){return y.d.$postMessage(S,n)}},i=new class{constructor(){this.editor=p,this.line=E,this.height=g,this.webview=s,this.onDidDispose=c.event}dispose(){y.c.has(S)&&(y.c.delete(S),y.d.$disposeEditorInset(S),c.fire(),c.dispose(),w.dispose())}};return this.d.$createEditorInset(S,f.id,f.value.document.uri,E+1,g,A||{},P.identifier,P.extensionLocation),this.c.set(S,{editor:p,inset:i,onDidReceiveMessage:w}),i}$onDidDispose(p){const E=this.c.get(p);E&&E.inset.dispose()}$onDidReceiveMessage(p,E){this.c.get(p)?.onDidReceiveMessage.fire(E)}}e.$Hec=L}),define(ke[290],Se([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=e.VariableKind=e.$nN=void 0,e.$nN=(0,I.$Uh)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class m extends Error{constructor(R,p){super(p),this.variable=R}}e.$oN=m}),define(ke[291],Se([1,0,16,49,18,24,12,102,233,290,13]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;class P{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,S,w,c){this.h=new Map,this.a=y,this.b=S,this.g=w,c&&(this.c=c.then(s=>this.i(s)))}i(y){if(R.$i){const S=Object.create(null);return Object.keys(y).forEach(w=>{S[w.toLowerCase()]=y[w]}),S}return y}resolveWithEnvironment(y,S,w){return this.l({env:this.i(y),userHome:void 0},S?S.uri:void 0,w)}async resolveAsync(y,S){const w={env:await this.c,userHome:await this.g};return this.l(w,y?y.uri:void 0,S)}async j(y,S,w,c){const s=L.$_m(S);R.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):R.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):R.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,y?y.uri:void 0,s,w,c)}async resolveAnyAsync(y,S,w){return this.j(y,S,w)}async resolveAnyMap(y,S,w){const c=new Map;return{newConfig:await this.j(y,S,w,c),resolvedVariables:c}}resolveWithInteractionReplace(y,S,w,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,S,w,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,S){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,S)}async l(y,S,w,c,s){if(m.$Bf(w))return this.m(y,S,w,c,s);if(Array.isArray(w))return Promise.all(w.map(i=>this.l(y,S,i,c,s)));if(m.$Df(w)){const i=Object.create(null),n=await Promise.all(Object.keys(w).map(async o=>[await this.m(y,S,o,c,s),await this.l(y,S,w[o],c,s)]));for(const[o,a]of n)i[o]=a;return i}return w}m(y,S,w,c,s){return(0,A.$We)(w,P.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(P.VARIABLE_LHS))return i;let o=await this.o(y,i,n,S,c);return s?.set(n,o),o!==i&&m.$Bf(o)&&o.match(P.VARIABLE_REGEXP)&&(o=await this.m(y,S,o,c,s)),o})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,S,w,c,s){let i;const n=w.split(":");n.length>1&&(w=n[0],i=n[1]);const o=r=>{const d=this.a.getFilePath();if(d)return(0,p.$yv)(d);throw new g.$oN(r,(0,E.localize)(0,null,S))},a=r=>{const d=o(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,p.$yv)(u)}throw new g.$oN(r,(0,E.localize)(1,null,S,I.$mc(d)))},t=r=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new g.$oN(r,(0,E.localize)(2,null,S,i))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new g.$oN(r,(0,E.localize)(3,null,S)):new g.$oN(r,(0,E.localize)(4,null,S))};switch(w){case"env":if(i){if(y.env){const r=y.env[R.$i?i.toLowerCase():i];if(m.$Bf(r))return r}return""}throw new g.$oN(g.VariableKind.Env,(0,E.localize)(5,null,S));case"config":if(i){const r=this.a.getConfigurationValue(c,i);if(m.$Kf(r))throw new g.$oN(g.VariableKind.Config,(0,E.localize)(6,null,S,i));if(m.$Df(r))throw new g.$oN(g.VariableKind.Config,(0,E.localize)(7,null,S,i));return r}throw new g.$oN(g.VariableKind.Config,(0,E.localize)(8,null,S));case"command":return this.p(g.VariableKind.Command,S,i,s,"command");case"input":return this.p(g.VariableKind.Input,S,i,s,"input");case"extensionInstallFolder":if(i){const r=await this.a.getExtension(i);if(!r)throw new g.$oN(g.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,S,i));return this.n(r.extensionLocation)}throw new g.$oN(g.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,S));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,p.$yv)(this.n(t(g.VariableKind.WorkspaceFolder)));case"cwd":return c||i?(0,p.$yv)(this.n(t(g.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$yv)(I.$mc(this.n(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new g.$oN(g.VariableKind.UserHome,(0,E.localize)(11,null,S))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new g.$oN(g.VariableKind.LineNumber,(0,E.localize)(12,null,S))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new g.$oN(g.VariableKind.SelectedText,(0,E.localize)(13,null,S))}case"file":return o(g.VariableKind.File);case"fileWorkspaceFolder":return a(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return c||i?I.$kc(this.n(t(g.VariableKind.RelativeFile)),o(g.VariableKind.RelativeFile)):o(g.VariableKind.RelativeFile);case"relativeFileDirname":{const r=I.$lc(o(g.VariableKind.RelativeFileDirname));if(c||i){const d=I.$kc(this.n(t(g.VariableKind.RelativeFileDirname)),r);return d.length===0?".":d}return r}case"fileDirname":return I.$lc(o(g.VariableKind.FileDirname));case"fileExtname":return I.$nc(o(g.VariableKind.FileExtname));case"fileBasename":return I.$mc(o(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=I.$mc(o(g.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-I.$nc(r).length)}case"fileDirnameBasename":return I.$mc(I.$lc(o(g.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||S}case"execInstallFolder":{const r=this.a.getAppRoot();return r||S}case"pathSeparator":return I.sep;default:try{const r=i?`${w}:${i}`:w;return this.p(g.VariableKind.Unknown,S,r,s,void 0)}catch{return S}}}}p(y,S,w,c,s){if(w&&c){const i=s===void 0?c[w]:c[s+":"+w];if(typeof i=="string")return i;throw new g.$oN(y,(0,E.localize)(14,null,S))}return S}}e.$CN=P}),define(ke[145],Se([1,0,5,141]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=e.$HC=e.OpenEditorContext=e.GroupsOrder=e.$GC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$FC=void 0,e.$FC=(0,I.$Uh)("editorGroupsService");var m;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(m||(e.GroupDirection=m={}));var L;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var p;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var E;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function g(S){const w=S;return(0,F.$oE)(w?.editor)&&(0,F.$oE)(w?.replacement)}e.$GC=g;var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var P;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function f(S){const w=S;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.$HC=f;function y(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$IC=y}),define(ke[292],Se([1,0,5,145]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.$LC=e.$KC=e.$JC=void 0,e.$JC=(0,I.$Uh)("editorService"),e.$KC=-1,e.$LC=-2;function m(L){const R=L;return typeof L=="number"||(0,F.$HC)(R)}e.$MC=m}),define(ke[146],Se([1,0,5,134]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=void 0,e.$TJ=(0,I.$Vh)(F.$2h)}),define(ke[147],Se([1,0,26,4,16,3]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q5b=e.$P5b=e.$O5b=e.$N5b=e.$M5b=void 0;class R{constructor(s,i){this.versionId=s,this.removedDueToLooping=i}}e.$M5b=R;class p{static isHostExtension(s,i,n){if(i.getExtensionDescription(s))return!1;const o=n.getExtensionDescription(s);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(s,i){this.j=s,this.c=new F.$Qd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new I.$am,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const i=this.j.readActivationEvents(s);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,i){this.e=w(this.e,i),this.e=this.e.concat(s);const n=p.l(this.e);return this.e=w(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,n)}static l(s){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,d){this.addNode(r),this.addNode(d),this.c.has(r)?this.c.get(r).push(d):this.c.set(r,[d])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,d){const u=i.getArcs(r);for(let l=0;l<u.length;l++)if(!d.has(u[l]))return!1;return!0}getNodes(){return this.e}},n=new I.$am;for(const r of s)if(n.set(r.identifier,r),r.extensionDependencies)for(const d of r.extensionDependencies)i.addArc(I.$$l.toKey(r.identifier),I.$$l.toKey(d));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const a=i.getNodes().filter(r=>!o.has(r));let t;do{t=!1;for(let r=0;r<a.length;r++){const d=a[r];i.hasOnlyGoodArcs(d,o)&&(a.splice(r,1),r--,o.add(d),t=!0)}}while(t);return a.map(r=>n.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const i=this.h.get(s);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const i=this.f.get(s);return i||void 0}getExtensionDescriptionByUUID(s){for(const i of this.g)if(i.uuid===s)return i}getExtensionDescriptionByIdOrUUID(s,i){return this.getExtensionDescription(s)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$N5b=p;class E{constructor(s,i){this.versionId=s,this.extensions=i}}e.$O5b=E;class g{constructor(s){this.d=new f,this.c=new p(s,[])}async acquireLock(s){const i=await this.d.acquire(s);return new A(this,i)}deltaExtensions(s,i,n){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,i){return this.c.getExtensionDescriptionByIdOrUUID(s,i)}}e.$P5b=g;class A extends L.$Rc{constructor(s,i){super(),this.f=s,this.c=!1,this.B(i)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$Q5b=A;class P{constructor(s){this.name=s,this.promise=new Promise((i,n)=>{this.c=i})}resolve(s){this.c(s)}}class f{constructor(){this.c=[],this.d=!1}async acquire(s){const i=new P(s);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};s.resolve((0,L.$Pc)(o))}}var y;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(y||(y={}));function S(c,s){const i=c.isBuiltin?0:c.isUnderDevelopment?2:1,n=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=m.$fc.basename(c.extensionLocation.path),a=m.$fc.basename(s.extensionLocation.path);return o<a?-1:o>a?1:0}function w(c,s){const i=new I.$_l(s);return c.filter(n=>!i.has(n.identifier))}}),define(ke[293],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.ExtHostConnectionType=void 0;var I;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(I||(e.ExtHostConnectionType=I={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(P){this.pipeName=P,this.type=1}serialize(P){P[F.ENV_KEY]=this.pipeName}}e.$Cm=F;class m{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(P){P[m.ENV_KEY]="1"}}e.$Dm=m;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(P){P[L.ENV_KEY]="1"}}e.$Em=L;function R(A){delete A[F.ENV_KEY],delete A[m.ENV_KEY],delete A[L.ENV_KEY]}function p(A,P){R(P),A.serialize(P)}e.$Fm=p;function E(A){if(A[F.ENV_KEY])return g(A,new F(A[F.ENV_KEY]));if(A[m.ENV_KEY])return g(A,new m);if(A[L.ENV_KEY])return g(A,new L);throw new Error("No connection information defined in environment!")}e.$Gm=E;function g(A,P){return R(A),P}}),define(ke[114],Se([1,0,22]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$hm=e.$gm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(F||(e.UIKind=F={}));var m;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(m||(e.ExtensionHostExitCode=m={}));var L;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(g){const A=I.$ee.alloc(1);switch(g){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$gm=R;function p(g,A){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$hm=p;var E;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(ke[90],Se([1,0,5,4,15,27,114,66,87,24,2,3,219]),function(me,e,I,F,m,L,R,p,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.$TM=e.$SM=void 0;let y=class extends P.$Rc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new F.$Qd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Qd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:E.$to,name:(0,f.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,m.$ej)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===m.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const o=this.getTelemetryDetails(),a=new S(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=w(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$1k)((0,E.$Ao)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(o):this.r.set(o,a)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const o=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(s.value),!1;let a=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$SM=y,e.$SM=y=He([Be(0,L.$RM),Be(1,m.$dj)],y);class S{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,o,a,t,r){this.g=n,this.h=o,this.i=a,this.j=t,this.a=new F.$Qd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,E.$Do)(i,[]),this.c&&(i=(0,g.$cn)(i,this.c)),this.b||(i=(0,g.$cn)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},o=(0,E.$Do)(n,[]),a=new Error(o.message,{cause:o.cause});a.stack=o.stack,a.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$TM=S;function w(c){const s=Date.now()-new Date(c).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$UM=w,e.$VM=(0,I.$Uh)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,263,139,26,5]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=e.$BF=e.ActivationKind=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.ExtensionHostStartup=e.$vF=e.$uF=e.$tF=e.$sF=void 0,e.$sF=Object.freeze({identifier:new R.$$l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$tF="extensions.webWorker",e.$uF=(0,p.$Uh)("extensionService");class E{constructor(a){this.dependency=a}}e.$vF=E;var g;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,r){this.c=a,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$dF.createActivationEventsMap(this.d)}}set(a,t,r){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const d=[],u=[],l=[],h=[],k=P(this.d),D=P(t),$=(j,M)=>j.extensionLocation.toString()===M.extensionLocation.toString()||j.isBuiltin===M.isBuiltin||j.isUserBuiltin===M.isUserBuiltin||j.isUnderDevelopment===M.isUnderDevelopment;for(const j of this.d){const M=D.get(j.identifier);if(!M){d.push(j.identifier),k.delete(j.identifier);continue}if(!$(j,M)){d.push(j.identifier),k.delete(j.identifier);continue}}for(const j of t){const M=k.get(j.identifier);if(!M){u.push(j);continue}if(!$(M,j)){d.push(M.identifier),k.delete(M.identifier);continue}}const b=new R.$_l(this.e),v=new R.$_l(r);for(const j of this.e)v.has(j)||l.push(j);for(const j of r)b.has(j)||h.push(j);const C=L.$dF.createActivationEventsMap(u),N={versionId:a,toRemove:d,toAdd:u,addActivationEvents:C,myToRemove:l,myToAdd:h};return this.delta(N),N}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:d,myToAdd:u}=a,l=new R.$_l(t),h=new R.$_l(d);for(let k=0;k<this.d.length;k++)l.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)h.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of r)this.d.push(k);for(const k of u)this.e.push(k);return this.f=null,a}containsExtension(a){for(const t of this.e)if(R.$$l.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=L.$dF.readActivationEvents(t);for(const d of r)a.add(d)}return a}}e.$wF=A;function P(o){const a=new R.$am;for(const t of o)a.set(t.identifier,t);return a}function f(o,a){return o.enabledApiProposals?o.enabledApiProposals.includes(a):!1}e.$xF=f;function y(o,a){if(!f(o,a))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$yF=y;class S{constructor(a,t,r,d){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=d}}e.$zF=S;class w{constructor(a,t){this.description=a,this.value=t}}e.$AF=w;var c;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,m.$Jo)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$BF=s;function i(o,a){return{identifier:new R.$$l((0,m.$Ho)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$CF=i;class n{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$DF=n}),define(ke[294],Se([1,0,11,147,26,25,15,10]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=e.$Xdc=e.$Wdc=e.$Vdc=e.$Udc=e.$Tdc=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(s,i,n,o){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$Tdc=E;class g{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Udc=g;class A{constructor(s,i,n,o,a,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=a,this.subscriptions=t}}e.$Vdc=A;class P extends A{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wdc=P;class f extends A{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xdc=f;class y extends A{constructor(s){super(!0,s,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(s,i,n,o){this.g=o,this.a=s,this.b=i,this.c=n,this.d=new m.$am,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const a=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new y(a));return this.c.onExtensionActivationError(s.id,a,new L.$vF(s.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of o){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:s.reason}));continue}const d=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),l=this.k(s,i.displayName,[],new y(u));return this.c.onExtensionActivationError(i.identifier,u,new L.$vF(a)),l}return this.k(s,i.displayName,n,null)}k(s,i,n,o){const a=new w(s.id,i,s.reason,n,o,this.c,this.g);return this.d.set(s.id,a),a}l(s){return F.$N5b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$Ydc=S,e.$Ydc=S=He([Be(3,R.$cj)],S);let w=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,o,a,t,r){this.c=s,this.d=i,this.f=n,this.g=o,this.h=a,this.j=t,this.k=r,this.a=new p.$Vg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new y(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new y(i),this.b&&I.$3(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};w=He([Be(6,R.$cj)],w)}),define(ke[14],Se([1,0,19,22,165,75,81,28,161,54,100,24,18,2,29,84,136,144,141,111,68,89,292,7,25]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$AM=e.$zM=e.MarkdownString=e.$yM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Me){function Te(ie){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:xe,positionColumn:Qe}=ie,rt=new r.$CK(Fe-1,Ve-1),kt=new r.$CK(xe-1,Qe-1);return new r.$EK(rt,kt)}Me.to=Te;function Ce(ie){const{anchor:Fe,active:Ve}=ie;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Me.from=Ce})(u||(e.Selection=u={}));var l;(function(Me){function Te(ie){if(!ie)return;const{start:Fe,end:Ve}=ie;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Me.from=Te;function Ce(ie){if(!ie)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:xe,endColumn:Qe}=ie;return new r.$DK(Fe-1,Ve-1,xe-1,Qe-1)}Me.to=Ce})(l||(e.Range=l={}));var h;(function(Me){function Te(Ce){switch(Ce){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Me.to=Te})(h||(e.TokenType=h={}));var k;(function(Me){function Te(ie){return new r.$CK(ie.lineNumber-1,ie.column-1)}Me.to=Te;function Ce(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Me.from=Ce})(k||(e.Position=k={}));var D;(function(Me){function Te(Fe,Ve,xe){return(0,I.$Gb)((0,I.$2b)(Fe).map(Qe=>Ce(Qe,Ve,xe)))}Me.from=Te;function Ce(Fe,Ve,xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:xe?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ie(Fe.scheme,Ve),pattern:ue.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:xe?.isBuiltin}}function ie(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(D||(e.DocumentSelector=D={}));var $;(function(Me){function Te(ie){switch(ie){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Ce(ie){switch(ie){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Me.to=Ce})($||(e.DiagnosticTag=$={}));var b;(function(Me){function Te(ie){let Fe;return ie.code&&((0,f.$Bf)(ie.code)||(0,f.$Ff)(ie.code)?Fe=String(ie.code):Fe={value:String(ie.code.value),target:ie.code.target}),{...l.from(ie.range),message:ie.message,source:ie.source,code:Fe,severity:C.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(v.from),tags:Array.isArray(ie.tags)?(0,I.$Gb)(ie.tags.map($.from)):void 0}}Me.from=Te;function Ce(ie){const Fe=new r.$PK(l.to(ie),ie.message,C.to(ie.severity));return Fe.source=ie.source,Fe.code=(0,f.$Bf)(ie.code)?ie.code:ie.code?.value,Fe.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(v.to),Fe.tags=ie.tags&&(0,I.$Gb)(ie.tags.map($.to)),Fe}Me.to=Ce})(b||(e.Diagnostic=b={}));var v;(function(Me){function Te(ie){return{...l.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Me.from=Te;function Ce(ie){return new r.$OK(new r.$NK(ie.resource,l.to(ie)),ie.message)}Me.to=Ce})(v||(e.DiagnosticRelatedInformation=v={}));var C;(function(Me){function Te(ie){switch(ie){case r.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}Me.from=Te;function Ce(ie){switch(ie){case c.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Me.to=Ce})(C||(e.DiagnosticSeverity=C={}));var N;(function(Me){function Te(ie){return typeof ie=="number"&&ie>=r.ViewColumn.One?ie-1:ie===r.ViewColumn.Beside?t.$LC:t.$KC}Me.from=Te;function Ce(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ce})(N||(e.ViewColumn=N={}));function j(Me){return typeof Me.range<"u"}function M(Me){return Me.length===0?!0:!!j(Me[0])}e.$yM=M;var O;(function(Me){function Te(Qe){return Qe.map(Me.from)}Me.fromMany=Te;function Ce(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ie(Qe){let rt;if(Ce(Qe)){const{language:dt,value:gt}=Qe;rt={value:"```"+dt+`
`+gt+"\n```\n"}}else r.$2K.isMarkdownString(Qe)?rt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?rt={value:Qe}:rt={value:""};const kt=Object.create(null);rt.uris=kt;const St=dt=>{try{let gt=y.URI.parse(dt,!0);gt=gt.with({query:Fe(gt.query,kt)}),kt[dt]=gt}catch{}return""},mt=new E.marked.Renderer;return mt.link=St,mt.image=dt=>typeof dt=="string"?St(R.$ck(dt).href):"",(0,E.marked)(rt.value,{renderer:mt}),rt}Me.from=ie;function Fe(Qe,rt){if(!Qe)return Qe;let kt;try{kt=(0,g.$qh)(Qe)}catch{}if(!kt)return Qe;let St=!1;return kt=(0,P.$bn)(kt,mt=>{if(y.URI.isUri(mt)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[dt]=mt,St=!0,dt}else return}),St?JSON.stringify(kt):Qe}function Ve(Qe){const rt=new r.$2K(Qe.value,Qe.supportThemeIcons);return rt.isTrusted=Qe.isTrusted,rt.supportHtml=Qe.supportHtml,rt.baseUri=Qe.baseUri?y.URI.from(Qe.baseUri):void 0,rt}Me.to=Ve;function xe(Qe){if(Qe)return typeof Qe=="string"?Qe:Me.from(Qe)}Me.fromStrict=xe})(O||(e.MarkdownString=O={}));function z(Me){return M(Me)?Me.map(Te=>({range:l.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?O.fromMany(Te.hoverMessage):Te.hoverMessage?O.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:l.from(Te)}))}e.$zM=z;function T(Me){return typeof Me>"u"?Me:typeof Me=="string"?y.URI.file(Me):Me}e.$AM=T;var W;(function(Me){function Te(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?T(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Me.from=Te})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var V;(function(Me){function Te(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?T(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Te})(V||(e.ThemableDecorationRenderOptions=V={}));var de;(function(Me){function Te(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(de||(e.DecorationRangeBehavior=de={}));var ee;(function(Me){function Te(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?de.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?V.from(Ce.light):void 0,dark:Ce.dark?V.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?T(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Te})(ee||(e.DecorationRenderOptions=ee={}));var Z;(function(Me){function Te(ie){return{text:ie.newText,eol:ie.newEol&&Ae.from(ie.newEol),range:l.from(ie.range)}}Me.from=Te;function Ce(ie){const Fe=new r.$IK(l.to(ie.range),ie.text);return Fe.newEol=typeof ie.eol>"u"?void 0:Ae.to(ie.eol),Fe}Me.to=Ce})(Z||(e.TextEdit=Z={}));var J;(function(Me){function Te(ie,Fe){const Ve={edits:[]};if(ie instanceof r.$LK){const xe=new p.$Ac;for(const Qe of ie._allEntries())Qe._type===1&&y.URI.isUri(Qe.to)&&Qe.from===void 0&&xe.add(Qe.to);for(const Qe of ie._allEntries())if(Qe._type===1){let rt;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?rt={type:"base64",value:(0,F.$ye)(F.$ee.wrap(Qe.options.contents))}:rt={type:"dataTransferItem",id:Qe.options.contents._itemId}),Ve.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:rt},metadata:Qe.metadata})}else Qe._type===2?Ve.edits.push({resource:Qe.uri,textEdit:Z.from(Qe.edit),versionId:xe.has(Qe.uri)?void 0:Fe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Ve.edits.push({resource:Qe.uri,textEdit:{range:l.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:xe.has(Qe.uri)?void 0:Fe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Ve.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Ve.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(bt.from)}})}return Ve}Me.from=Te;function Ce(ie){const Fe=new r.$LK,Ve=new p.$zc;for(const xe of ie.edits)if(xe.textEdit){const Qe=xe,rt=y.URI.revive(Qe.resource),kt=l.to(Qe.textEdit.range),St=Qe.textEdit.text,mt=Qe.textEdit.insertAsSnippet;let dt;mt?dt=r.$KK.replace(kt,new r.$MK(St)):dt=r.$IK.replace(kt,St);const gt=Ve.get(rt);gt?gt.push(dt):Ve.set(rt,[dt])}else Fe.renameFile(y.URI.revive(xe.oldResource),y.URI.revive(xe.newResource),xe.options);for(const[xe,Qe]of Ve)Fe.set(xe,Qe);return Fe}Me.to=Ce})(J||(e.WorkspaceEdit=J={}));var ae;(function(Me){const Te=Object.create(null);Te[r.SymbolKind.File]=0,Te[r.SymbolKind.Module]=1,Te[r.SymbolKind.Namespace]=2,Te[r.SymbolKind.Package]=3,Te[r.SymbolKind.Class]=4,Te[r.SymbolKind.Method]=5,Te[r.SymbolKind.Property]=6,Te[r.SymbolKind.Field]=7,Te[r.SymbolKind.Constructor]=8,Te[r.SymbolKind.Enum]=9,Te[r.SymbolKind.Interface]=10,Te[r.SymbolKind.Function]=11,Te[r.SymbolKind.Variable]=12,Te[r.SymbolKind.Constant]=13,Te[r.SymbolKind.String]=14,Te[r.SymbolKind.Number]=15,Te[r.SymbolKind.Boolean]=16,Te[r.SymbolKind.Array]=17,Te[r.SymbolKind.Object]=18,Te[r.SymbolKind.Key]=19,Te[r.SymbolKind.Null]=20,Te[r.SymbolKind.EnumMember]=21,Te[r.SymbolKind.Struct]=22,Te[r.SymbolKind.Event]=23,Te[r.SymbolKind.Operator]=24,Te[r.SymbolKind.TypeParameter]=25;function Ce(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=Ce;function ie(Fe){for(const Ve in Te)if(Te[Ve]===Fe)return Number(Ve);return r.SymbolKind.Property}Me.to=ie})(ae||(e.SymbolKind=ae={}));var x;(function(Me){function Te(ie){switch(ie){case r.SymbolTag.Deprecated:return 1}}Me.from=Te;function Ce(ie){switch(ie){case 1:return r.SymbolTag.Deprecated}}Me.to=Ce})(x||(e.SymbolTag=x={}));var Ee;(function(Me){function Te(ie){return{name:ie.name,kind:ae.from(ie.kind),tags:ie.tags&&ie.tags.map(x.from),containerName:ie.containerName,location:be.from(ie.location)}}Me.from=Te;function Ce(ie){const Fe=new r.$SK(ie.name,ae.to(ie.kind),ie.containerName,be.to(ie.location));return Fe.tags=ie.tags&&ie.tags.map(x.to),Fe}Me.to=Ce})(Ee||(e.WorkspaceSymbol=Ee={}));var le;(function(Me){function Te(ie){const Fe={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),kind:ae.from(ie.kind),tags:ie.tags?.map(x.from)??[]};return ie.children&&(Fe.children=ie.children.map(Te)),Fe}Me.from=Te;function Ce(ie){const Fe=new r.$TK(ie.name,ie.detail,ae.to(ie.kind),l.to(ie.range),l.to(ie.selectionRange));return(0,I.$Kb)(ie.tags)&&(Fe.tags=ie.tags.map(x.to)),ie.children&&(Fe.children=ie.children.map(Ce)),Fe}Me.to=Ce})(le||(e.DocumentSymbol=le={}));var K;(function(Me){function Te(ie){const Fe=new r.$XK(ae.to(ie.kind),ie.name,ie.detail||"",y.URI.revive(ie.uri),l.to(ie.range),l.to(ie.selectionRange));return Fe._sessionId=ie._sessionId,Fe._itemId=ie._itemId,Fe}Me.to=Te;function Ce(ie,Fe,Ve){if(Fe=Fe??ie._sessionId,Ve=Ve??ie._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:ie.name,detail:ie.detail,kind:ae.from(ie.kind),uri:ie.uri,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),tags:ie.tags?.map(x.from)}}Me.from=Ce})(K||(e.CallHierarchyItem=K={}));var U;(function(Me){function Te(Ce){return new r.$YK(K.to(Ce.from),Ce.fromRanges.map(ie=>l.to(ie)))}Me.to=Te})(U||(e.CallHierarchyIncomingCall=U={}));var ne;(function(Me){function Te(Ce){return new r.$ZK(K.to(Ce.to),Ce.fromRanges.map(ie=>l.to(ie)))}Me.to=Te})(ne||(e.CallHierarchyOutgoingCall=ne={}));var be;(function(Me){function Te(ie){return{range:ie.range&&l.from(ie.range),uri:ie.uri}}Me.from=Te;function Ce(ie){return new r.$NK(y.URI.revive(ie.uri),l.to(ie.range))}Me.to=Ce})(be||(e.location=be={}));var G;(function(Me){function Te(ie){const Fe=ie,Ve=ie;return{originSelectionRange:Fe.originSelectionRange?l.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:l.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?l.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function Ce(ie){return{targetUri:y.URI.revive(ie.uri),targetRange:l.to(ie.range),targetSelectionRange:ie.targetSelectionRange?l.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?l.to(ie.originSelectionRange):void 0}}Me.to=Ce})(G||(e.DefinitionLink=G={}));var Y;(function(Me){function Te(ie){return{range:l.from(ie.range),contents:O.fromMany(ie.contents)}}Me.from=Te;function Ce(ie){return new r.$QK(ie.contents.map(O.to),l.to(ie.range))}Me.to=Ce})(Y||(e.Hover=Y={}));var X;(function(Me){function Te(ie){return{range:l.from(ie.range),expression:ie.expression}}Me.from=Te;function Ce(ie){return new r.$JL(l.to(ie.range),ie.expression)}Me.to=Ce})(X||(e.EvaluatableExpression=X={}));var $e;(function(Me){function Te(ie){if(ie instanceof r.$KL)return{type:"text",range:l.from(ie.range),text:ie.text};if(ie instanceof r.$LL)return{type:"variable",range:l.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof r.$ML)return{type:"expression",range:l.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Ce(ie){switch(ie.type){case"text":return{range:l.to(ie.range),text:ie.text};case"variable":return{range:l.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:l.to(ie.range),expression:ie.expression}}}Me.to=Ce})($e||(e.InlineValue=$e={}));var re;(function(Me){function Te(ie){return{frameId:ie.frameId,stoppedLocation:l.from(ie.stoppedLocation)}}Me.from=Te;function Ce(ie){return new r.$NL(ie.frameId,l.to(ie.stoppedLocation))}Me.to=Ce})(re||(e.InlineValueContext=re={}));var fe;(function(Me){function Te(ie){return{range:l.from(ie.range),kind:ie.kind}}Me.from=Te;function Ce(ie){return new r.$RK(l.to(ie.range),ie.kind)}Me.to=Ce})(fe||(e.DocumentHighlight=fe={}));var te;(function(Me){function Te(Ce){switch(Ce){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Me.to=Te})(te||(e.CompletionTriggerKind=te={}));var he;(function(Me){function Te(Ce){return{triggerKind:te.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Me.to=Te})(he||(e.CompletionContext=he={}));var pe;(function(Me){function Te(ie){switch(ie){case r.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Ce(ie){switch(ie){case 1:return r.CompletionItemTag.Deprecated}}Me.to=Ce})(pe||(e.CompletionItemTag=pe={}));var Pe;(function(Me){const Te=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ce(Ve){return Te.get(Ve)??9}Me.from=Ce;const ie=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Fe(Ve){return ie.get(Ve)??r.CompletionItemKind.Property}Me.to=Fe})(Pe||(e.CompletionItemKind=Pe={}));var B;(function(Me){function Te(Ce,ie){const Fe=new r.$8K(Ce.label);return Fe.insertText=Ce.insertText,Fe.kind=Pe.to(Ce.kind),Fe.tags=Ce.tags?.map(pe.to),Fe.detail=Ce.detail,Fe.documentation=R.$0j(Ce.documentation)?O.to(Ce.documentation):Ce.documentation,Fe.sortText=Ce.sortText,Fe.filterText=Ce.filterText,Fe.preselect=Ce.preselect,Fe.commitCharacters=Ce.commitCharacters,S.$zs.isIRange(Ce.range)?Fe.range=l.to(Ce.range):typeof Ce.range=="object"&&(Fe.range={inserting:l.to(Ce.range.insert),replacing:l.to(Ce.range.replace)}),Fe.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Fe.insertText=new r.$MK(Ce.insertText):(Fe.insertText=Ce.insertText,Fe.textEdit=Fe.range instanceof r.$DK?new r.$IK(Fe.range,Fe.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Ce.additionalTextEdits.map(Ve=>Z.to(Ve))),Fe.command=ie&&Ce.command?ie.fromInternal(Ce.command):void 0,Fe}Me.to=Te})(B||(e.CompletionItem=B={}));var Q;(function(Me){function Te(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:O.fromStrict(ie.documentation)}}Me.from=Te;function Ce(ie){return{label:ie.label,documentation:R.$0j(ie.documentation)?O.to(ie.documentation):ie.documentation}}Me.to=Ce})(Q||(e.ParameterInformation=Q={}));var se;(function(Me){function Te(ie){return{label:ie.label,documentation:O.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(Q.from):[],activeParameter:ie.activeParameter}}Me.from=Te;function Ce(ie){return{label:ie.label,documentation:R.$0j(ie.documentation)?O.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(Q.to):[],activeParameter:ie.activeParameter}}Me.to=Ce})(se||(e.SignatureInformation=se={}));var oe;(function(Me){function Te(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(se.from):[]}}Me.from=Te;function Ce(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(se.to):[]}}Me.to=Ce})(oe||(e.SignatureHelp=oe={}));var _;(function(Me){function Te(Ce,ie){const Fe=new r.$7K(k.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(ge.to.bind(void 0,Ce)),ie.kind&&ye.to(ie.kind));return Fe.textEdits=ie.textEdits&&ie.textEdits.map(Z.to),Fe.tooltip=R.$0j(ie.tooltip)?O.to(ie.tooltip):ie.tooltip,Fe.paddingLeft=ie.paddingLeft,Fe.paddingRight=ie.paddingRight,Fe}Me.to=Te})(_||(e.InlayHint=_={}));var ge;(function(Me){function Te(Ce,ie){const Fe=new r.$6K(ie.label);return Fe.tooltip=R.$0j(ie.tooltip)?O.to(ie.tooltip):ie.tooltip,w.Command.is(ie.command)&&(Fe.command=Ce.fromInternal(ie.command)),ie.location&&(Fe.location=be.to(ie.location)),Fe}Me.to=Te})(ge||(e.InlayHintLabelPart=ge={}));var ye;(function(Me){function Te(ie){return ie}Me.from=Te;function Ce(ie){return ie}Me.to=Ce})(ye||(e.InlayHintKind=ye={}));var je;(function(Me){function Te(ie){return{range:l.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Me.from=Te;function Ce(ie){let Fe;if(ie.url)try{Fe=typeof ie.url=="string"?y.URI.parse(ie.url,!0):y.URI.revive(ie.url)}catch{}return new r.$aL(l.to(ie.range),Fe)}Me.to=Ce})(je||(e.DocumentLink=je={}));var We;(function(Me){function Te(ie){const Fe=new r.$dL(ie.label);return ie.textEdit&&(Fe.textEdit=Z.to(ie.textEdit)),ie.additionalTextEdits&&(Fe.additionalTextEdits=ie.additionalTextEdits.map(Ve=>Z.to(Ve))),Fe}Me.to=Te;function Ce(ie){return{label:ie.label,textEdit:ie.textEdit?Z.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Fe=>Z.from(Fe)):void 0}}Me.from=Ce})(We||(e.ColorPresentation=We={}));var _e;(function(Me){function Te(ie){return new r.$bL(ie[0],ie[1],ie[2],ie[3])}Me.to=Te;function Ce(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Me.from=Ce})(_e||(e.Color=_e={}));var Ze;(function(Me){function Te(ie){return{range:l.from(ie.range)}}Me.from=Te;function Ce(ie){return new r.$WK(l.to(ie.range))}Me.to=Ce})(Ze||(e.SelectionRange=Ze={}));var it;(function(Me){function Te(Ce){switch(Ce){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Me.to=Te})(it||(e.TextDocumentSaveReason=it={}));var tt;(function(Me){function Te(ie){switch(ie){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Ce(ie){switch(ie){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Me.to=Ce})(tt||(e.TextEditorLineNumbersStyle=tt={}));var Ae;(function(Me){function Te(ie){if(ie===r.EndOfLine.CRLF)return 1;if(ie===r.EndOfLine.LF)return 0}Me.from=Te;function Ce(ie){if(ie===1)return r.EndOfLine.CRLF;if(ie===0)return r.EndOfLine.LF}Me.to=Ce})(Ae||(e.EndOfLine=Ae={}));var Oe;(function(Me){function Te(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Oe||(e.ProgressLocation=Oe={}));var qe;(function(Me){function Te(ie){const Fe={start:ie.start+1,end:ie.end+1};return ie.kind&&(Fe.kind=Re.from(ie.kind)),Fe}Me.from=Te;function Ce(ie){const Fe={start:ie.start-1,end:ie.end-1};return ie.kind&&(Fe.kind=Re.to(ie.kind)),Fe}Me.to=Ce})(qe||(e.FoldingRange=qe={}));var Re;(function(Me){function Te(ie){if(ie)switch(ie){case r.FoldingRangeKind.Comment:return w.$ot.Comment;case r.FoldingRangeKind.Imports:return w.$ot.Imports;case r.FoldingRangeKind.Region:return w.$ot.Region}}Me.from=Te;function Ce(ie){if(ie)switch(ie.value){case w.$ot.Comment.value:return r.FoldingRangeKind.Comment;case w.$ot.Imports.value:return r.FoldingRangeKind.Imports;case w.$ot.Region.value:return r.FoldingRangeKind.Region}}Me.to=Ce})(Re||(e.FoldingRangeKind=Re={}));var Xe;(function(Me){function Te(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?l.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$aE.id:void 0}}Me.from=Te})(Xe||(e.TextEditorOpenOptions=Xe={}));var ue;(function(Me){function Te(Ve){return Ve instanceof r.$xL?Ve.toJSON():typeof Ve=="string"?Ve:Ce(Ve)||ie(Ve)?new r.$xL(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Me.from=Te;function Ce(Ve){const xe=Ve;return xe?y.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ie(Ve){const xe=Ve;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new r.$xL(y.URI.revive(Ve.baseUri),Ve.pattern)}Me.to=Fe})(ue||(e.GlobPattern=ue={}));var ce;(function(Me){function Te(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Te);if(typeof Ce=="string")return Ce;{const ie=Ce;return{language:ie.language,scheme:ie.scheme,pattern:ue.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Me.from=Te})(ce||(e.LanguageSelector=ce={}));var Ie;(function(Me){function Te(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&y.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(xe=>xe instanceof r.$DK)))}Me.is=Te;function Ce(ie){return{documents:ie.documents.map(Fe=>Fe.map(Ve=>({uri:y.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(xe=>l.from(xe))})))}}Me.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Me){function Te(ie){return{start:ie.start,end:ie.end}}Me.from=Te;function Ce(ie){return new r.$YL(ie.start,ie.end)}Me.to=Ce})(Ke||(e.NotebookRange=Ke={}));var Ue;(function(Me){function Te(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Me.to=Te;function Ce(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Me.from=Ce})(Ue||(e.NotebookCellExecutionSummary=Ue={}));var Ye;(function(Me){function Te(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Me.to=Te})(Ye||(e.NotebookCellExecutionState=Ye={}));var nt;(function(Me){function Te(ie){switch(ie){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Te;function Ce(ie){switch(ie){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Me.to=Ce})(nt||(e.NotebookCellKind=nt={}));var ct;(function(Me){function Te(ie){const Fe={metadata:ie.metadata??Object.create(null),cells:[]};for(const Ve of ie.cells)r.$ZL.validate(Ve),Fe.cells.push(bt.from(Ve));return Fe}Me.from=Te;function Ce(ie){const Fe=new r.$1L(ie.cells.map(bt.to));return(0,f.$Of)(ie.metadata)||(Fe.metadata=ie.metadata),Fe}Me.to=Ce})(ct||(e.NotebookData=ct={}));var bt;(function(Me){function Te(ie){return{cellKind:nt.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Ue.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(Kt.from):[]}}Me.from=Te;function Ce(ie){return new r.$ZL(nt.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(Kt.to):void 0,ie.metadata,ie.internalMetadata?Ue.to(ie.internalMetadata):void 0)}Me.to=Ce})(bt||(e.NotebookCellData=bt={}));var Et;(function(Me){function Te(ie){return{mime:ie.mime,valueBytes:F.$ee.wrap(ie.data)}}Me.from=Te;function Ce(ie){return new r.$2L(ie.valueBytes.buffer,ie.mime)}Me.to=Ce})(Et||(e.NotebookCellOutputItem=Et={}));var Kt;(function(Me){function Te(ie){return{outputId:ie.id,items:ie.items.map(Et.from),metadata:ie.metadata}}Me.from=Te;function Ce(ie){const Fe=ie.items.map(Et.to);return new r.$3L(Fe,ie.outputId,ie.metadata)}Me.to=Ce})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Me){function Te(Fe){return ie(Fe)?{include:ue.from(Fe.include)??void 0,exclude:ue.from(Fe.exclude)??void 0}:ue.from(Fe)??void 0}Me.from=Te;function Ce(Fe){return ie(Fe)?{include:ue.to(Fe.include),exclude:ue.to(Fe.exclude)}:ue.to(Fe)}Me.to=Ce;function ie(Fe){const Ve=Fe;return Ve?!(0,f.$Kf)(Ve.include)&&!(0,f.$Kf)(Ve.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var wt;(function(Me){function Te(Ce,ie,Fe){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:ie.toInternal(Ve,Fe),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Me.from=Te})(wt||(e.NotebookStatusBarItem=wt={}));var jt;(function(Me){function Te(Ce,ie,Fe){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:ie.toInternal(Ve,Fe),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Te})(jt||(e.NotebookKernelSourceAction=jt={}));var Ot;(function(Me){function Te(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Me.from=Te})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Me){function Te(ie){return{uri:ie.uri,provides:ie.provides}}Me.from=Te;function Ce(ie){return new r.$5L(y.URI.revive(ie.uri),ie.provides)}Me.to=Ce})(Gt||(e.NotebookRendererScript=Gt={}));var Ut;(function(Me){function Te(ie){return{message:O.fromStrict(ie.message)||"",type:0,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:l.from(ie.location.range),uri:ie.location.uri}}}Me.from=Te;function Ce(ie){const Fe=new r.$$L(typeof ie.message=="string"?ie.message:O.to(ie.message));return Fe.actualOutput=ie.actual,Fe.expectedOutput=ie.expected,Fe.contextValue=ie.contextValue,Fe.location=ie.location?be.to(ie.location):void 0,Fe}Me.to=Ce})(Ut||(e.TestMessage=Ut={}));var Dt;(function(Me){Me.namespace=a.$tJ,Me.denamespace=a.$uJ})(Dt||(e.TestTag=Dt={}));var Ft;(function(Me){function Te(ie){const Fe=(0,s.$xM)(ie).controllerId;return{extId:o.$pJ.fromExtHostTestItem(ie,Fe).toString(),label:ie.label,uri:y.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(Ve=>Dt.namespace(Fe,Ve.id)),range:S.$zs.lift(l.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&O.fromStrict(ie.error)||null}}Me.from=Te;function Ce(ie){return{parent:void 0,error:void 0,id:o.$pJ.fromString(ie.extId).localId,label:ie.label,uri:y.URI.revive(ie.uri),tags:(ie.tags||[]).map(Fe=>{const{tagId:Ve}=Dt.denamespace(Fe);return new r.$_L(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:l.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Me.toPlain=Ce})(Ft||(e.TestItem=Ft={})),function(Me){function Te(ie){return{id:ie.id}}Me.from=Te;function Ce(ie){return new r.$_L(ie.id)}Me.to=Ce}(Dt||(e.TestTag=Dt={}));var Bt;(function(Me){const Te=(ie,Fe)=>{const Ve=[];for(const[Qe,rt]of Fe)o.$pJ.compare(rt.item.extId,Qe)===2&&(Fe.delete(Qe),Ve.push(rt));const xe={...Ft.toPlain(ie.item),parent:void 0,taskStates:ie.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(rt=>rt.type===0).map(Ut.to)})),children:Ve.map(Qe=>Te(Qe,Fe))};for(const Qe of xe.children)Qe.parent=xe;return xe};function Ce(ie){const Fe=[],Ve=new Map;for(const xe of ie.items){Ve.set(xe.item.extId,xe);const Qe=o.$pJ.root(xe.item.extId);ie.request.targets.some(rt=>rt.controllerId===Qe&&rt.testIds.includes(xe.item.extId))&&Fe.push(xe)}return{completedAt:ie.completedAt,results:Fe.map(xe=>Te(xe,Ve))}}Me.to=Ce})(Bt||(e.TestResults=Bt={}));var Qt;(function(Me){function Te(Ve){return{covered:Ve.covered,total:Ve.covered}}function Ce(Ve){return"line"in Ve?k.from(Ve):l.from(Ve)}function ie(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ce(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,count:Ve.executionCount,location:Ce(Ve.location)}}Me.fromDetailed=ie;function Fe(Ve){return{uri:Ve.uri,statement:Te(Ve.statementCoverage),branch:Ve.branchCoverage&&Te(Ve.branchCoverage),function:Ve.functionCoverage&&Te(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ie)}}Me.fromFile=Fe})(Qt||(e.TestCoverage=Qt={}));var Wt;(function(Me){function Te(Ce){switch(Ce){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Me.to=Te})(Wt||(e.CodeActionTriggerKind=Wt={}));var qt;(function(Me){function Te(ie){const Fe=new r.$fM(ae.to(ie.kind),ie.name,ie.detail||"",y.URI.revive(ie.uri),l.to(ie.range),l.to(ie.selectionRange));return Fe._sessionId=ie._sessionId,Fe._itemId=ie._itemId,Fe}Me.to=Te;function Ce(ie,Fe,Ve){if(Fe=Fe??ie._sessionId,Ve=Ve??ie._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:ae.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:l.from(ie.range),selectionRange:l.from(ie.selectionRange),tags:ie.tags?.map(x.from)}}Me.from=Ce})(qt||(e.TypeHierarchyItem=qt={}));var Nt;(function(Me){function Te(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Me.from=Te})(Nt||(e.ViewBadge=Nt={}));var ut;(function(Me){function Te(Ve,xe,Qe){const rt=xe.fileData;return rt?new r.$qL(new r.$rL(rt.name,y.URI.revive(rt.uri),rt.id,(0,L.$cb)(()=>Qe(rt.id)))):Ve===A.$Vr.uriList&&xe.uriListData?new r.$pL(Fe(xe.uriListData)):new r.$pL(xe.asString)}Me.to=Te;async function Ce(Ve,xe){const Qe=await xe.asString();if(Ve===A.$Vr.uriList)return{asString:Qe,fileData:void 0,uriListData:ie(Qe)};const rt=xe.asFile();return{asString:Qe,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=Ce;function ie(Ve){return m.$9s.split(Ve).map(xe=>{if(xe.startsWith("#"))return xe;try{return y.URI.parse(xe)}catch{}return xe})}function Fe(Ve){return m.$9s.create(Ve.map(xe=>typeof xe=="string"?xe:y.URI.revive(xe)))}})(ut||(e.DataTransferItem=ut={}));var ft;(function(Me){function Te(ie,Fe){const Ve=ie.items.map(([xe,Qe])=>[xe,ut.to(xe,Qe,Fe)]);return new r.$sL(Ve)}Me.toDataTransfer=Te;async function Ce(ie){const Fe={items:[]},Ve=[];for(const[xe,Qe]of ie)Ve.push((async()=>{Fe.items.push([xe,await ut.from(xe,Qe)])})());return await Promise.all(Ve),Fe}Me.from=Ce})(ft||(e.DataTransfer=ft={}));var At;(function(Me){function Te(ie){return{message:ie.message,metadata:ie.metadata,title:ie.title,tooltip:ie.tooltip}}Me.to=Te;function Ce(ie){return{kind:"reply",message:ie.message,metadata:ie.metadata,title:ie.title,tooltip:ie.tooltip}}Me.from=Ce})(At||(e.ChatReplyFollowup=At={}));var Vt;(function(Me){function Te(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:At.from(Ce)}Me.from=Te})(Vt||(e.ChatFollowup=Vt={}));var Lt;(function(Me){function Te(ie){const Fe=new r.$qM(at.to(ie.role),ie.content);return Fe.name=ie.name,Fe}Me.to=Te;function Ce(ie){return{role:at.from(ie.role),content:ie.content,name:ie.name}}Me.from=Ce})(Lt||(e.ChatMessage=Lt={}));var at;(function(Me){function Te(ie){switch(ie){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Me.to=Te;function Ce(ie){switch(ie){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Me.from=Ce})(at||(e.ChatMessageRole=at={}));var vt;(function(Me){function Te(Fe){const Ve={};for(const xe of Object.keys(Fe))Ve[xe]=Fe[xe].map(Me.to);return Ve}Me.objectTo=Te;function Ce(Fe){return{level:Tt.to(Fe.level),value:Fe.value,description:Fe.description}}Me.to=Ce;function ie(Fe){return{level:Tt.from(Fe.level),value:Fe.value,description:Fe.description}}Me.from=ie})(vt||(e.ChatVariable=vt={}));var Tt;(function(Me){function Te(ie){switch(ie){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Me.to=Te;function Ce(ie){switch(ie){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Me.from=Ce})(Tt||(e.ChatVariableLevel=Tt={}));var Pt;(function(Me){function Te(Ce){switch(Ce){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Pt||(e.InteractiveEditorResponseFeedbackKind=Pt={}));var Ge;(function(Me){function Te(Ce,ie){return"placeholder"in ie&&"resolvedContent"in ie?{placeholder:ie.placeholder}:"responseId"in ie?{requestId:ie.responseId}:"markdownContent"in ie?((0,d.$yF)(Ce,"chatAgents2Additions"),{content:O.from(ie.markdownContent)}):"content"in ie?typeof ie.content=="string"?ie:((0,d.$yF)(Ce,"chatAgents2Additions"),{content:O.from(ie.content)}):"documents"in ie?{documents:ie.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(Ve=>l.from(Ve))}))}:"reference"in ie?{reference:"uri"in ie.reference?{uri:ie.reference.uri,range:l.from(ie.reference.range)}:ie.reference}:"inlineReference"in ie?{inlineReference:"uri"in ie.inlineReference?{uri:ie.inlineReference.uri,range:l.from(ie.inlineReference.range)}:ie.inlineReference,title:ie.title}:("agentName"in ie&&(0,d.$yF)(Ce,"chatAgents2Additions"),ie)}Me.from=Te})(Ge||(e.ChatResponseProgress=Ge={}));var Jt;(function(Me){function Te(Ce,ie,Fe){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand}:"uri"in Ce?{uri:Ce.uri}:ie.toInternal(Ce,Fe)}Me.from=Te})(Jt||(e.TerminalQuickFix=Jt={}))}),define(ke[295],Se([1,0,2,11,7,14,76]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class p{constructor(g,A,P,f={timeout:1500,errors:3}){this.c=g,this.d=A,this.f=P,this.g=f,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(A,P,f)=>{const S={dispose:this.a.push([A,P,g])};return Array.isArray(f)&&f.push(S),S}}async $participateInSave(g,A){const P=I.URI.revive(g);let f=!1;const y=setTimeout(()=>f=!0,this.g.timeout),S=[];try{for(const w of[...this.a]){if(f)break;const c=this.d.getDocument(P),s=await this.h(w,{document:c,reason:L.TextDocumentSaveReason.to(A)});S.push(s)}}finally{clearTimeout(y)}return S}h([g,A,P],f){const y=this.b.get(g);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(P,g,A,f).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const w=this.b.get(g);this.b.set(g,w?w+1:1),typeof w=="number"&&w>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,A,P,f){const y=[],S=Date.now(),{document:w,reason:c}=f,{version:s}=w,i=Object.freeze({document:w,reason:c,waitUntil(n){if(Object.isFrozen(y))throw(0,F.$7)("waitUntil can not be called async");y.push(Promise.resolve(n))}});try{A.apply(P,[i])}catch(n){return Promise.reject(n)}return Object.freeze(y),new Promise((n,o)=>{const a=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(y).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),o(t)})}).then(n=>{const o={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof m.$IK))for(const{newText:t,newEol:r,range:d}of a)o.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:d&&L.Range.from(d),text:t,eol:r&&L.EndOfLine.from(r)}});if(o.edits.length!==0)return s===w.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$Sdc=p}),define(ke[296],Se([1,0,17,2,14,7,111]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=e.$6ec=void 0;class p{constructor(P,f,y,S){this.start=P,this.deletedCount=f,this.deletedItems=y,this.items=S}asApiEvent(){return{range:new L.$YL(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(P,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,f,y){this.notebook=P,this.h=f,this.j=y,this.handle=y.handle,this.uri=F.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(m.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(m.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:m.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return P.g},set mime(S){P.g=S},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(y)}return this.f}setOutputs(P){this.a=P.map(m.NotebookCellOutput.to)}setOutputItems(P,f,y){const S=y.map(m.NotebookCellOutputItem.to),w=this.a.find(c=>c.id===P);if(w&&(f||(w.items.length=0),w.items.push(...S),w.items.length>1&&w.items.every(c=>R.$DI(c.mime)))){const c=new Map,s=[];w.items.forEach(i=>{let n;c.has(i.mime)?n=c.get(i.mime):(n=[],c.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),w.items.length=0,s.forEach(i=>{const n=R.$EI(c.get(i));w.items.push({mime:i,data:n.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(m.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$6ec=E;class g{static{this.a=0}constructor(P,f,y,S,w){this.k=P,this.l=f,this.m=y,this.uri=S,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=w.viewType,this.f=Object.freeze(w.metadata??Object.create(null)),this.r([[0,0,w.cells]],!0,void 0),this.g=w.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,f={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===I.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(y){return y=P.n(y),P.b[y].apiCell},getCells(y){return(y?P.p(y):P.b).map(w=>w.apiCell)},save(){return P.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,f,y){this.g=P.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:y});const S={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},w=[];for(const s of P.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,S.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,S.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),w.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),w.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),w.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),w.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),w.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const c=new Map;for(let s=0;s<w.length;s++){const i=w[s],n=c.get(i.cell);if(n===void 0){const o=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});c.set(i.cell,o-1)}else S.cellChanges[n]={...S.cellChanges[n],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let f=P.start|0,y=P.end|0;return f<0&&(f=0),y>this.b.length&&(y=this.b.length),P.with({start:f,end:y})}p(P){P=this.o(P);const f=[];for(let y=P.start;y<P.end;y++)f.push(this.b[y]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,f,y){if(this.j)return;const S=[],w=[],c=[];if(P.reverse().forEach(s=>{const n=s[2].map(t=>{const r=new E(this,this.l,t);return f||w.push(E.asModelAddData(this.apiNotebook,t)),r}),o=new p(s[0],s[1],[],n),a=this.b.splice(s[0],s[1],...n);for(const t of a)c.push(t.uri),o.deletedItems.push(t.apiCell);S.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:c}),y)for(const s of S)y.push(s.asApiEvent())}s(P,f,y,S){const w=this.b.splice(P,f);this.b.splice(y,0,...w);const c=[new p(P,f,w.map(s=>s.apiCell),[]),new p(y,0,[],w)];for(const s of c)S.push(s.asApiEvent())}t(P,f){this.b[P].setOutputs(f)}u(P,f,y,S){this.b[P].setOutputItems(f,y,S)}v(P,f){const y=this.b[P];y.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(y.uri,f)}w(P,f){const y=this.b[P];y.apiCell.mime=f}x(P,f){this.b[P].setMetadata(f)}y(P,f){this.b[P].setInternalMetadata(f)}getCellFromApiCell(P){return this.b.find(f=>f.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(f=>f.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$7ec=g}),define(ke[297],Se([1,0,4,2,14,7]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;class R{constructor(E,g,A,P={timeout:1500,errors:3}){this.b=E,this.c=g,this.d=A,this.f=P,this.a=new I.$Sd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(g,A,P)=>{const f=function(S){g.call(A,S)};return f.extension=E,this.a.event(f,void 0,P)}}async $participateInSave(E,g,A){const P=F.URI.revive(E),f=this.c.getNotebookDocument(P);if(!f)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:f.apiNotebook,reason:m.TextDocumentSaveReason.to(g)},A,async(w,c)=>{const s=Date.now(),i=await await Promise.resolve(w);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof L.$LK?y.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(y.length===0)return!0;const S={edits:[]};for(const w of y){const{edits:c}=m.WorkspaceEdit.from(w);S.edits=S.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$ufc=R}),define(ke[148],Se([1,0,11,14,7]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,E,g,A,P,f){this.id=p,this.f=E,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=A,this.c=f}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(E){this.selections=[E]},get selections(){return p.a},set selections(E){if(!Array.isArray(E)||!E.every(m.$YL.isNotebookRange))throw(0,I.$6)("selections");p.a=E,p.g(E)},get visibleRanges(){return p.b},revealRange(E,g){p.f.$tryRevealRange(p.id,F.NotebookRange.from(E),g??m.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(F.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$8ec=L}),define(ke[298],Se([1,0,11,4,15,14]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;let R=class{constructor(E,g){this.c=E,this.d=g,this.a=new F.$Qd({onListenerError:I.$1}),this.b=new F.$Qd({onListenerError:I.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,g);const A=this.d.getEditorById(E);g.visibleRanges&&A._acceptVisibleRanges(g.visibleRanges.ranges.map(L.NotebookRange.to)),g.selections&&A._acceptSelections(g.selections.selections.map(L.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const g in E)this.d.getEditorById(g)._acceptViewColumn(L.ViewColumn.to(E[g]))}};e.$nfc=R,e.$nfc=R=He([Be(0,m.$cj)],R)}),define(ke[299],Se([1,0,14,64,217,21,59,11]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;class E{constructor(f){this.b=0,this.c=new Map,this.a=f}async withProgress(f,y,S){const w=this.b++,{title:c,location:s,cancellable:i}=y,n={label:(0,m.localize)(0,null,f.displayName||f.name),id:f.identifier.value};return this.a.$startProgress(w,{location:I.ProgressLocation.from(s),title:c,source:n,cancellable:i},f.isUnderDevelopment?void 0:f.identifier.value).catch(p.$1),this.d(w,S,!!i)}d(f,y,S){let w;S&&(w=new L.$1d,this.c.set(f,w));const c=i=>{this.a.$progressEnd(i),this.c.delete(i),w?.dispose()};let s;try{s=y(new A(this.a,f),S&&w?w.token:L.CancellationToken.None)}catch(i){throw c(f),i}return s.then(i=>c(f),i=>c(f)),s}$acceptProgressCanceled(f){const y=this.c.get(f);y&&(y.cancel(),this.c.delete(f))}}e.$rec=E;function g(P,f){return P.message=f.message,typeof f.increment=="number"&&(typeof P.increment=="number"?P.increment+=f.increment:P.increment=f.increment),P}class A extends F.$$u{constructor(f,y){super(S=>this.throttledReport(S)),this.c=f,this.d=y}throttledReport(f){this.c.$progressReport(this.d,f)}}He([(0,R.$oh)(100,(P,f)=>g(P,f),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(ke[149],Se([1,0,29,144,68,112,89,14,2]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=e.$NM=void 0;const g=(n,o,a,t)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(d){if(!a(r,d)){const u=r;r=d,n.listener?.(t(d,u))}}}},A=(n,o)=>n===o,P={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,o)=>!(n.length!==o.length||n.some(a=>!o.find(t=>a.id===t.id)))},f=n=>o=>({op:4,update:n(o)}),y=(n,o)=>({range:(()=>{let a;const t=f(r=>({range:I.$zs.lift(p.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return a},set(r){n.listener?.({op:6}),P.range(a,r)||(a=r,n.listener?.(t(r)))}}})(),label:g(n,o,P.label,f(a=>({label:a}))),description:g(n,void 0,P.description,f(a=>({description:a}))),sortText:g(n,void 0,P.sortText,f(a=>({sortText:a}))),canResolveChildren:g(n,!1,P.canResolveChildren,a=>({op:2,state:a})),busy:g(n,!1,P.busy,f(a=>({busy:a}))),error:g(n,void 0,P.error,f(a=>({error:p.MarkdownString.fromStrict(a)||null}))),tags:g(n,[],P.tags,(a,t)=>({op:1,new:a.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),S=n=>{const o=m.$pJ.fromString(n.extId),a=new c(o.controllerId,o.localId,n.label,E.URI.revive(n.uri)||void 0);return a.range=p.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>p.TestTag.to({id:(0,R.$uJ)(t).tagId})),a},w=n=>{let o;for(const a of n.tests){const t=S(a.item);(0,F.$xM)(t).parent=o,o=t}return o};e.$NM=w;class c{constructor(o,a,t,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const d=(0,F.$wM)(this,o);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof s?void 0:d.parent}},children:{value:(0,L.$vM)(d,F.$xM,c),enumerable:!0,writable:!1},...y(d,t)})}}e.$OM=c;class s extends c{constructor(o,a){super(o,o,a,void 0),this._isRoot=!0}}e.$PM=s;class i extends L.$rM{constructor(o,a,t){super({controllerId:o,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:F.$xM,getChildren:r=>r.children,root:new s(o,a),toITestItem:p.TestItem.from})}}e.$QM=i}),define(ke[150],Se([1,0,60,11,122,14,7]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=e.$IM=void 0;class p{static{this.c=new m.$GM("TextEditorDecorationType")}constructor(f,y,S){const w=p.c.nextId();f.$registerTextEditorDecorationType(y.identifier,w,L.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:w,dispose(){f.$removeTextEditorDecorationType(w)}})}}e.$IM=p;class E{constructor(f,y){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,y){this.k();let S=null;if(f instanceof R.$CK)S=new R.$DK(f,f);else if(f instanceof R.$DK)S=f;else throw new Error("Unrecognized location");this.l(S,y,!1)}insert(f,y){this.k(),this.l(new R.$DK(f,f),y,!0)}delete(f){this.k();let y=null;if(f instanceof R.$DK)y=f;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(f,y,S){const w=this.c.validateRange(f);this.g.push({range:w,text:y,forceMoveMarkers:S})}setEndOfLine(f){if(this.k(),f!==R.EndOfLine.LF&&f!==R.EndOfLine.CRLF)throw(0,F.$6)("endOfLine");this.h=f}}class g{constructor(f,y,S,w){this.c=f,this.d=y,this._accept(S),this.e=w;const c=this;this.value={get tabSize(){return c.f},set tabSize(s){c.m(s)},get indentSize(){return c.g},set indentSize(s){c.o(s)},get insertSpaces(){return c.h},set insertSpaces(s){c.q(s)},get cursorStyle(){return c.j},set cursorStyle(s){c.s(s)},get lineNumbers(){return c.k},set lineNumbers(s){c.t(s)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.insertSpaces,this.j=f.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(f.lineNumbers)}l(f){if(f==="auto")return"auto";if(typeof f=="number"){const y=Math.floor(f);return y>0?y:null}if(typeof f=="string"){const y=parseInt(f,10);return isNaN(y)?null:y>0?y:null}return null}m(f){const y=this.l(f);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const y=Math.floor(f);return y>0?y:null}if(typeof f=="string"){const y=parseInt(f,10);return isNaN(y)?null:y>0?y:null}return null}o(f){const y=this.n(f);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(f){return f==="auto"?"auto":f==="false"?!1:!!f}q(f){const y=this.p(f);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(f){this.j!==f&&(this.j=f,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}t(f){this.k!==f&&(this.k=f,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(f)})))}assign(f){const y={};let S=!1;if(typeof f.tabSize<"u"){const w=this.l(f.tabSize);w==="auto"?(S=!0,y.tabSize=w):typeof w=="number"&&this.f!==w&&(this.f=w,S=!0,y.tabSize=w)}if(typeof f.indentSize<"u"){const w=this.n(f.indentSize);w==="tabSize"?(S=!0,y.indentSize=w):typeof w=="number"&&this.g!==w&&(this.g=w,S=!0,y.indentSize=w)}if(typeof f.insertSpaces<"u"){const w=this.p(f.insertSpaces);w==="auto"?(S=!0,y.insertSpaces=w):this.h!==w&&(this.h=w,S=!0,y.insertSpaces=w)}typeof f.cursorStyle<"u"&&this.j!==f.cursorStyle&&(this.j=f.cursorStyle,S=!0,y.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.k!==f.lineNumbers&&(this.k=f.lineNumbers,S=!0,y.lineNumbers=L.TextEditorLineNumbersStyle.from(f.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(f,y){y.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(S)})}}e.$JM=g;class A{constructor(f,y,S,w,c,s,i,n){this.id=f,this.j=y,this.k=S,this.g=!1,this.h=new Set,this.c=c,this.d=new g(this.j,this.id,s,S),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return w.value},set document(a){throw new F.$8("document")},get selection(){return o.c&&o.c[0]},set selection(a){if(!(a instanceof R.$EK))throw(0,F.$6)("selection");o.c=[a],o.l()},get selections(){return o.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof R.$EK)))throw(0,F.$6)("selections");o.c=a,o.l()},get visibleRanges(){return o.e},set visibleRanges(a){throw new F.$8("visibleRanges")},get options(){return o.d.value},set options(a){o.g||o.d.assign(a)},get viewColumn(){return o.f},set viewColumn(a){throw new F.$8("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new E(w.value,t);return a(r),o.m(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=o.c.map(u=>L.Range.from(u));else if(t instanceof R.$CK){const{lineNumber:u,column:l}=L.Position.from(t);d=[{startLineNumber:u,startColumn:l,endLineNumber:u,endColumn:l}]}else if(t instanceof R.$DK)d=[L.Range.from(t)];else{d=[];for(const u of t)if(u instanceof R.$DK)d.push(L.Range.from(u));else{const{lineNumber:l,column:h}=L.Position.from(u);d.push({startLineNumber:l,startColumn:h,endLineNumber:l,endColumn:h})}}return y.$tryInsertSnippet(f,w.value.version,a.value,d,r)},setDecorations(a,t){const r=t.length===0;r&&!o.h.has(a.key)||(r?o.h.delete(a.key):o.h.add(a.key),o.n(()=>{if(L.$yM(t))return y.$trySetDecorations(f,a.key,L.$zM(t));{const d=new Array(4*t.length);for(let u=0,l=t.length;u<l;u++){const h=t[u];d[4*u]=h.start.line+1,d[4*u+1]=h.start.character+1,d[4*u+2]=h.end.line+1,d[4*u+3]=h.end.character+1}return y.$trySetDecorationsFast(f,a.key,d)}}))},revealRange(a,t){o.n(()=>y.$tryRevealRange(f,L.Range.from(a),t||R.TextEditorRevealType.Default))},show(a){y.$tryShowEditor(f,L.ViewColumn.from(a))},hide(){y.$tryHideEditor(f)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,I.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,I.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,I.ok)(!this.g),this.f=f}_acceptSelections(f){(0,I.ok)(!this.g),this.c=f}async l(){const f=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const y=f.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const S=y.edits.map(c=>c.range);S.sort((c,s)=>c.end.line===s.end.line?c.end.character===s.end.character?c.start.line===s.start.line?c.start.character-s.start.character:c.start.line-s.start.line:c.end.character-s.end.character:c.end.line-s.end.line);for(let c=0,s=S.length-1;c<s;c++){const i=S[c].end;if(S[c+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=y.edits.map(c=>({range:L.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,w,{setEndOfLine:typeof y.setEndOfLine=="number"?L.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$KM=A}),define(ke[300],Se([1,0,221,23,2,4,3,280,10,7,18,19,14,81,21,177,25]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;function s(o,a){if((0,A.$Bf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends R.$Rc{constructor(a,t,r){super(),this.f=a,this.g=t,this.h=r,this.a=new Map,this.b=new w.$v8;function d(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>d(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(l=>d(l)?this.r(l):l):u})}registerTreeDataProvider(a,t,r){const d=this.createTreeView(a,{treeDataProvider:t},r);return{dispose:()=>d.dispose()}}createTreeView(a,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,k=this.m(a,t,r),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:u,hasHandleDrag:l,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(a,D),b={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,c.$yF)(r,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,c.$yF)(r,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(v){(0,y.$0j)(v)&&(0,c.$yF)(r,"treeViewMarkdownMessage"),k.message=v},get title(){return k.title},set title(v){k.title=v},get description(){return k.description},set description(v){k.description=v},get badge(){return k.badge},set badge(v){v!==void 0&&g.ViewBadge.isViewBadge(v)?k.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(k.badge=void 0)},reveal:(v,C)=>k.reveal(v,C),dispose:async()=>{await $,this.a.delete(a),k.dispose()}};return this.B(b),b}$getChildren(a,t){const r=this.a.get(a);return r?r.getChildren(t):Promise.reject(new p.$JE(a))}async $handleDrop(a,t,r,d,u,l,h,k){const D=this.a.get(a);if(!D)return Promise.reject(new p.$JE(a));const $=f.DataTransfer.toDataTransfer(r,async b=>(await this.f.$resolveDropFileData(a,t,b)).buffer);return h===a&&k&&await this.j($,D,k,u,l),D.onDrop($,d,u)}async j(a,t,r,d,u){const l=this.b.removeDragOperationTransfer(u);if(l)(await l)?.forEach((h,k)=>{h&&a.set(k,h)});else if(u&&t.handleDrag){const h=t.handleDrag(r,a,d);this.b.addDragOperationTransfer(u,h),await h}return a}async $handleDrag(a,t,r,d){const u=this.a.get(a);if(!u)return Promise.reject(new p.$JE(a));const l=await this.j(new g.$sL,u,t,d,r);if(!(!l||d.isCancellationRequested))return f.DataTransfer.from(l)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new p.$JE(a);return t.hasResolve}$resolve(a,t,r){const d=this.a.get(a);if(!d)throw new p.$JE(a);return d.resolveTreeItem(t,r)}$setExpanded(a,t,r){const d=this.a.get(a);if(!d)throw new p.$JE(a);d.setExpanded(t,r)}$setSelectionAndFocus(a,t,r){const d=this.a.get(a);if(!d)throw new p.$JE(a);d.setSelectionAndFocus(t,r)}$setVisible(a,t){const r=this.a.get(a);if(!r){if(!t)return;throw new p.$JE(a)}r.setVisible(t)}$changeCheckboxState(a,t){const r=this.a.get(a);if(!r)throw new p.$JE(a);r.setCheckboxState(t)}m(a,t,r){const d=this.B(new n(a,t,this.f,this.g.converter,this.h,r));return this.a.set(a,d),d}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$yec=i;class n extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,A.$Kf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,r,d,u,l){if(super(),this.I=a,this.J=r,this.L=d,this.M=u,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Qd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Qd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Qd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Qd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Qd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Qd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Qd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$1d,l.contributes&&l.contributes.views)for(const $ in l.contributes.views)for(const b of l.contributes.views[$])b.id===a&&(this.P=b.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let h,k;const D=L.Event.debounce(this.F.event,($,b)=>($||($={message:!1,elements:[]}),b.element!==!1&&(h||(h=new Promise(v=>k=v),this.G=this.G.then(()=>h)),Array.isArray(b.element)?$.elements.push(...b.element):$.elements.push(b.element)),b.message&&($.message=!0),$),200,!0);this.B(D(({message:$,elements:b})=>{b.length&&(this.H=this.H.then(()=>{const v=k;return h=null,this.$(b).then(()=>v())})),$&&this.J.$setMessage(this.I,f.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.X(a);return r||(r=await this.Y(t)),r?r.map(d=>d.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const r=(0,A.$Kf)(t.select)?!0:t.select,d=(0,A.$Kf)(t.focus)?!1:t.focus,u=(0,A.$Kf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(l=>this.W(a,l[l.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:l.map(k=>k.item)},{select:r,focus:d,expand:u})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:r,focus:d,expand:u})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=f.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const r=this.getExtensionElement(a);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(a,t){const r=!(0,P.$tb)(this.s,a);this.s=a;const d=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async r=>{const d=this.getExtensionElement(r.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:r.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(a,t,r){const d=[];for(const u of a){const l=this.getExtensionElement(u);l&&d.push(l)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,r){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,E.$Pg)(()=>this.g?.handleDrop?this.g.handleDrop(d,a,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(a);if(r){const d=this.m.get(r);if(d){const u=await this.f.resolveTreeItem(d.extensionItem,r,t)??d.extensionItem;return this.hb(u),d.item.tooltip=this.eb(u.tooltip),d.item.command=this.fb(d.disposableStore,u.command),d.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,E.$Pg)(()=>this.f.getParent(a))}W(a,t){const r=this.m.get(a);return r?Promise.resolve(r):(0,E.$Pg)(()=>this.f.getTreeItem(a)).then(d=>this.kb(a,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(d);if(u){const l=this.m.get(u);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const r=this.getExtensionElement(a);t=r?this.m.get(r):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$1d(this.Z.token);try{const r=a?this.m.get(a):void 0,d=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,P.$Gb)(d||[]).map(async l=>{const h=await this.f.getTreeItem(l);return h&&!t.token.isCancellationRequested?this.db(l,h,r):null}));return t.token.isCancellationRequested?void 0:(0,P.$Gb)(u)}finally{t.dispose()}}$(a){if(a.some(r=>!r))return this.Z.dispose(!0),this.Z=new S.$1d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(a);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(a){const t=new Set,r=a.map(u=>this.m.get(u));for(const u of r)if(u&&!t.has(u.item.handle)){let l=u;for(;l&&l.parent&&r.findIndex(h=>l&&l.parent&&h&&h.item.handle===l.parent.item.handle)===-1;){const h=this.j.get(l.parent.item.handle);l=h?this.m.get(h):void 0}l&&!l.parent&&t.add(u.item.handle)}const d=[];return t.forEach(u=>{const l=this.j.get(u);if(l){const h=this.m.get(l);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(u)}}),d}bb(a){const t={};return Promise.all(a.map(r=>this.cb(r).then(d=>{d&&(t[r]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,E.$Pg)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const u=this.ib(t,d,r.parent);return this.pb(t,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}db(a,t,r){const d=this.ib(a,t,r);if(t.id&&this.j.has(d.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(a,d),this.qb(d,r),d}eb(a){return g.$2K.isMarkdownString(a)?f.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,r,d;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,r=a.checkboxState.tooltip,d=a.checkboxState.accessibilityInformation),{isChecked:t===g.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:d}}hb(a){if(!g.$nL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,r){this.hb(t);const d=this.B(new R.$Qc),u=this.kb(a,t,r),l=this.lb(t);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:l,iconDark:this.mb(t)||l,themeIcon:this.jb(t),collapsibleState:(0,A.$Kf)(t.collapsibleState)?g.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(a){return a.iconPath instanceof g.$vL?a.iconPath:void 0}kb(a,{id:t,label:r,resourceUri:d},u,l){if(t)return`${n.b}/${t}`;const h=s(r,this.N),k=u?u.item.handle:n.a;let D=h?h.label:d?(0,F.$vg)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const $=this.m.has(a)?this.m.get(a).item.handle:void 0,b=this.X(u)||[];let v,C=0;do{if(v=`${k}/${C}:${D}`,l||!this.j.has(v)||$===v)break;C++}while(C<=b.length);return v}lb(a){if(a.iconPath&&!(a.iconPath instanceof g.$vL))return typeof a.iconPath=="string"||m.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof g.$vL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return m.URI.isUri(a)?a:m.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,r,d){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(a,t);const u=this.X(d)||[],l=u.filter(h=>h.item.handle===r.item.handle)[0];l&&u.splice(u.indexOf(l),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[301],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[302],Se([1,0,235,11,39,135,108,38,26,301,138,139]),function(me,e,I,F,m,L,R,p,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=void 0;const f=p.$ln.as(R.$mn.JSONContribution);class y{constructor(a,t,r){this.a=a,this.b=t,this.c=r}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(m.default.Error,a)}warn(a){this.d(m.default.Warning,a)}info(a){this.d(m.default.Info,a)}}e.$mF=y;class S{static a(a){const t=new E.$_l;for(let r=0,d=a.length;r<d;r++)t.add(a[r].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const r=this.a(a),d=this.a(t),u=t.filter(h=>!r.has(h.description.identifier)),l=a.filter(h=>!d.has(h.description.identifier));return new S(u,l)}constructor(a,t){this.added=a,this.removed=t}}e.$nF=S;class w{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,F.$Z)(a)}}}e.$oF=w;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$pF={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$0l},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"*",description:I.localize(42,null),body:"*"}]}},badges:{type:"array",description:I.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(44,null)},href:{type:"string",description:I.localize(45,null)},description:{type:"string",description:I.localize(46,null)}}}},markdown:{type:"string",description:I.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$3n}},extensionPack:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$3n}},extensionKind:{description:I.localize(51,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(52,null)},{body:["workspace"],description:I.localize(53,null)},{body:["ui","workspace"],description:I.localize(54,null)},{body:["workspace","ui"],description:I.localize(55,null)},{body:[],description:I.localize(56,null)}]},capabilities:{description:I.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(60,null),I.localize(61,null),I.localize(62,null)]},description:{type:"string",markdownDescription:I.localize(63,null)}}},untrustedWorkspaces:{description:I.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(66,null),I.localize(67,null),I.localize(68,null)]},restrictedConfigurations:{description:I.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(70,null)}}}}},sponsor:{description:I.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(73,null),type:"string"},"vscode:uninstall":{description:I.localize(74,null),type:"string"}}},icon:{type:"string",description:I.localize(75,null)},l10n:{type:"string",description:I.localize(76,null)},pricing:{type:"string",markdownDescription:I.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new w(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&P.$dF.register(a.extensionPoint,a.activationEventsGenerator),e.$pF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,f.registerSchema(s,e.$pF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$qF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$ln.add(n.ExtensionsRegistry,new i),e.$rF=p.$ln.as(n.ExtensionsRegistry),f.registerSchema(s,e.$pF),f.registerSchema(A.$vj,{properties:{extensionEnabledApiProposals:{description:I.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(ke[303],Se([1,0,231,18,24,302,45,4]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var g;(function(f){function y(S,w,c){if(!S)return;const s=F.$Bf(S.type)?S.type:void 0;if(!s||s.length===0){c.error(I.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const n of S.required)F.$Bf(n)&&i.push(n);return{extensionId:w.value,taskType:s,required:i,properties:S.properties?m.$_m(S.properties):{},when:S.when?R.$Si.deserialize(S.when):void 0}}f.from=y})(g||(g={}));const A=L.$rF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(f,y)=>{for(const S of f)S.type&&y.push(`onTaskType:${S.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:E}});class P{constructor(){this.d=new p.$Qd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,S)=>{A.setHandler((w,c)=>{this.c=void 0;try{for(const s of c.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of c.added){const i=s.value;for(const n of i){const o=g.from(n,s.description.identifier,s.collector);o&&(this.a[o.taskType]=o)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const S of this.all()){const w={type:"object",additionalProperties:!1};S.required.length>0&&(w.required=S.required.slice(0)),S.properties!==void 0?w.properties=m.$_m(S.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[S.taskType]},y.push(w)}this.c={oneOf:y}}return this.c}}e.$9F=new P}),define(ke[304],Se([1,0,232,18,23,24,45,303]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$gG=e.JsonSchemaVersion=e.ExecutionEngine=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$aG=e.ShellQuoting=e.$_F=e.$$F=e.$0F=void 0,e.$0F="settings",e.$$F=new R.$_i("taskRunning",!1,I.localize(0,null)),e.$_F={value:I.localize(1,null),original:"Tasks"};var E;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$aG="$customized",function(z){function T(W){if(!W)return z.Strong;switch(W.toLowerCase()){case"escape":return z.Escape;case"strong":return z.Strong;case"weak":return z.Weak;default:return z.Strong}}z.from=T}(E||(e.ShellQuoting=E={}));var g;(function(z){z.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var A;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(A||(e.RevealKind=A={})),function(z){function T(W){switch(W.toLowerCase()){case"always":return z.Always;case"silent":return z.Silent;case"never":return z.Never;default:return z.Always}}z.fromString=T}(A||(e.RevealKind=A={}));var P;(function(z){z[z.Never=1]="Never",z[z.OnProblem=2]="OnProblem",z[z.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(z){function T(W){switch(W.toLowerCase()){case"always":return z.Always;case"never":return z.Never;case"onproblem":return z.OnProblem;default:return z.OnProblem}}z.fromString=T}(P||(e.RevealProblemKind=P={}));var f;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(f||(e.PanelKind=f={})),function(z){function T(W){switch(W.toLowerCase()){case"shared":return z.Shared;case"dedicated":return z.Dedicated;case"new":return z.New;default:return z.Shared}}z.fromString=T}(f||(e.PanelKind=f={}));var y;(function(z){z.defaults={echo:!0,reveal:A.Always,revealProblems:P.Never,focus:!1,panel:f.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var S;(function(z){z[z.Shell=1]="Shell",z[z.Process=2]="Process",z[z.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(z){function T(V){switch(V.toLowerCase()){case"shell":return z.Shell;case"process":return z.Process;case"customExecution":return z.CustomExecution;default:return z.Process}}z.fromString=T;function W(V){switch(V){case z.Shell:return"shell";case z.Process:return"process";case z.CustomExecution:return"customExecution";default:return"process"}}z.toString=W}(S||(e.RuntimeType=S={}));var w;(function(z){function T(W){return F.$Bf(W)?W:W.value}z.value=T})(w||(e.CommandString=w={}));var c;(function(z){z.Clean={_id:"clean",isDefault:!1},z.Build={_id:"build",isDefault:!1},z.Rebuild={_id:"rebuild",isDefault:!1},z.Test={_id:"test",isDefault:!1};function T(V){return V===z.Clean._id||V===z.Build._id||V===z.Rebuild._id||V===z.Test._id}z.is=T;function W(V){if(V!==void 0)return F.$Bf(V)?T(V)?{_id:V,isDefault:!1}:void 0:V}z.from=W})(c||(e.TaskGroup=c={}));var s;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(z){z.Workspace="workspace",z.Extension="extension",z.InMemory="inMemory",z.WorkspaceFile="workspaceFile",z.User="user";function T(W){switch(W){case z.User:return 2;case z.WorkspaceFile:return 5;default:return 6}}z.toConfigurationTarget=T})(i||(e.TaskSourceKind=i={}));var n;(function(z){z.parallel="parallel",z.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(z){z[z.default=1]="default",z[z.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var a;(function(z){z.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(T,W,V,de,ee,Z){this._label="",this._id=T,W&&(this._label=W),V&&(this.type=V),this.runOptions=de,this.configurationProperties=ee,this._source=Z}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,W=!1){if(T===void 0)return!1;if(F.$Bf(T))return T===this._label||T===this.configurationProperties.identifier||W&&T===this._id;const V=this.getDefinition(!0);return V!==void 0&&V._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$bG=t;class r extends t{constructor(T,W,V,de,ee,Z,J,ae){super(T,V,void 0,J,ae,W),this.command={},this._source=W,this.hasDefinedMatchers=Z,ee&&(this.command=ee)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case S.Shell:W="shell";break;case S.Process:W="process";break;case S.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(T){return T instanceof r}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$0F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const V={type:e.$aG,folder:T,id:W};return JSON.stringify(V)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?m.$vg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new r(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$cG=r;class d extends t{constructor(T,W,V,de,ee,Z,J){super(T,V,de,Z,J,W),this._source=W,this.configures=ee}static is(T){return T instanceof d}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?m.$vg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$0F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const V={type:e.$aG,folder:T,id:W};return JSON.stringify(V)}}e.$dG=d;class u extends t{constructor(T,W,V,de,ee,Z,J,ae,x){super(T,V,de,ae,x,W),this.defines=ee,this.hasDefinedMatchers=J,this.command=Z,this.icon=x.icon,this.hide=x.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof u}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new u(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$eG=u;class l extends t{constructor(T,W,V,de,ee,Z){super(T,V,de,ee,Z,W),this._source=W}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new l(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$fG=l;var h;(function(z){z[z.Process=1]="Process",z[z.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(z){z._default=z.Terminal}(h||(e.ExecutionEngine=h={}));var k;(function(z){z[z.V0_1_0=1]="V0_1_0",z[z.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class D{constructor(T){this.c=new Map;for(let W=0;W<T.length;W++)this.c.set(T[W].uri.toString(),W)}compare(T,W){const V=T.getWorkspaceFolder(),de=W.getWorkspaceFolder();if(V&&de){let ee=this.c.get(V.uri.toString());ee=ee===void 0?0:ee+1;let Z=this.c.get(de.uri.toString());return Z=Z===void 0?0:Z+1,ee===Z?T._label.localeCompare(W._label):ee-Z}else return!V&&de?-1:V&&!de?1:0}}e.$gG=D;var $;(function(z){z.DependsOnStarted="dependsOnStarted",z.AcquiredInput="acquiredInput",z.Start="start",z.ProcessStarted="processStarted",z.Active="active",z.Inactive="inactive",z.Changed="changed",z.Terminated="terminated",z.ProcessEnded="processEnded",z.End="end"})($||(e.TaskEventKind=$={}));var b;(function(z){z.SingleRun="singleRun",z.Background="background"})(b||(e.TaskRunType=b={}));var v;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.FolderOpen=2]="FolderOpen",z[z.ConfigurationChange=3]="ConfigurationChange",z[z.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var C;(function(z){function T(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function W(ae,x,Ee){return{...T(ae),kind:"start",terminalId:x,resolvedVariables:Ee}}z.start=W;function V(ae,x,Ee){return{...T(ae),kind:"processStarted",terminalId:x,processId:Ee}}z.processStarted=V;function de(ae,x,Ee){return{...T(ae),kind:"processEnded",terminalId:x,exitCode:Ee}}z.processEnded=de;function ee(ae,x,Ee){return{...T(ae),kind:"terminated",exitReason:Ee,terminalId:x}}z.terminated=ee;function Z(ae,x,Ee){return{...T(x),kind:ae,terminalId:Ee}}z.general=Z;function J(){return{kind:"changed"}}z.changed=J})(C||(e.TaskEvent=C={}));var N;(function(z){function T(V){const de=Object.keys(V).sort();let ee="";for(const Z of de){let J=V[Z];J instanceof Object?J=T(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),ee+=Z+","+J+","}return ee}function W(V){const ee={_key:T(V),type:V.taskType};return Object.assign(ee,V),ee}z.create=W})(N||(e.KeyedTaskIdentifier=N={}));var j;(function(z){z.AutoDetect="task.autoDetect",z.SaveBeforeRun="task.saveBeforeRun",z.ShowDecorations="task.showDecorations",z.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",z.SlowProviderWarning="task.slowProviderWarning",z.QuickOpenHistory="task.quickOpen.history",z.QuickOpenDetail="task.quickOpen.detail",z.QuickOpenSkip="task.quickOpen.skip",z.QuickOpenShowAll="task.quickOpen.showAll",z.AllowAutomaticTasks="task.allowAutomaticTasks",z.Reconnection="task.reconnection",z.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var M;(function(z){z.Tasks="tasks",z.SuppressTaskName="tasks.suppressTaskName",z.Windows="tasks.windows",z.Osx="tasks.osx",z.Linux="tasks.linux",z.ShowOutput="tasks.showOutput",z.IsShellCommand="tasks.isShellCommand",z.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var O;(function(z){function T(W,V){const de=p.$9F.get(W.type);if(de===void 0){const ae=L.$_m(W);return delete ae._key,N.create(ae)}const ee=Object.create(null);ee.type=de.taskType;const Z=new Set;de.required.forEach(ae=>Z.add(ae));const J=de.properties;for(const ae of Object.keys(J)){const x=W[ae];if(x!=null)ee[ae]=x;else if(Z.has(ae)){const Ee=J[ae];if(Ee.default!==void 0)ee[ae]=L.$_m(Ee.default);else switch(Ee.type){case"boolean":ee[ae]=!1;break;case"number":case"integer":ee[ae]=0;break;case"string":ee[ae]="";break;default:V.error(I.localize(2,null,JSON.stringify(W,void 0,0),ae));return}}}return N.create(ee)}z.createTaskIdentifier=T})(O||(e.TaskDefinition=O={}))}),define(ke[305],Se([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S5b=e.$R5b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,p)=>{this.b=R,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,I.$Z)(R))}then(R,p){return this.j().then(R,p)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$R5b=F;class m extends F{constructor(){super(),this.h=!0,this.i=new I.$4}}e.$S5b=m}),define(ke[69],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=void 0;class I{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++I.count}}e.$tv=I;const F=[];function m(p){const E=new I(p);return F[E.nid]=E,E}e.$uv=m;function L(p){return F[p].sid}e.$vv=L;class R{constructor(E){this.value=E}}e.$wv=R}),define(ke[6],Se([1,0,69]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AK=e.$zK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$yK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var m;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput",w[w.ChatEditorInput=10]="ChatEditorInput"})(m||(e.TabInputKind=m={}));var L;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var p;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var E;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var g;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var A;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class P{static{this.a=0}static mixin(c){return c._id=P.a++,c}}e.$yK=P;var f;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})(f||(e.ISuggestDataDtoField=f={}));var y;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var S;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$zK={MainThreadAuthentication:(0,I.$uv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$uv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.$uv)("MainThreadChatProvider"),MainThreadChatAgents:(0,I.$uv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,I.$uv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$uv)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$uv)("MainThreadClipboard"),MainThreadCommands:(0,I.$uv)("MainThreadCommands"),MainThreadComments:(0,I.$uv)("MainThreadComments"),MainThreadConfiguration:(0,I.$uv)("MainThreadConfiguration"),MainThreadConsole:(0,I.$uv)("MainThreadConsole"),MainThreadDebugService:(0,I.$uv)("MainThreadDebugService"),MainThreadDecorations:(0,I.$uv)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$uv)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$uv)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$uv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$uv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$uv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$uv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$uv)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$uv)("MainThreadErrors"),MainThreadTreeViews:(0,I.$uv)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$uv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$uv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$uv)("MainThreadLanguages"),MainThreadLogger:(0,I.$uv)("MainThreadLogger"),MainThreadMessageService:(0,I.$uv)("MainThreadMessageService"),MainThreadOutputService:(0,I.$uv)("MainThreadOutputService"),MainThreadProgress:(0,I.$uv)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$uv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$uv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$uv)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$uv)("MainThreadSecretState"),MainThreadStorage:(0,I.$uv)("MainThreadStorage"),MainThreadSpeech:(0,I.$uv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$uv)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$uv)("MainThreadTerminalService"),MainThreadWebviews:(0,I.$uv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$uv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$uv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$uv)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$uv)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$uv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$uv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$uv)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$uv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$uv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$uv)("MainThreadExtensionService"),MainThreadSCM:(0,I.$uv)("MainThreadSCM"),MainThreadSearch:(0,I.$uv)("MainThreadSearch"),MainThreadShare:(0,I.$uv)("MainThreadShare"),MainThreadTask:(0,I.$uv)("MainThreadTask"),MainThreadWindow:(0,I.$uv)("MainThreadWindow"),MainThreadLabelService:(0,I.$uv)("MainThreadLabelService"),MainThreadNotebook:(0,I.$uv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$uv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$uv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$uv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$uv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$uv)("MainThreadInteractive"),MainThreadChat:(0,I.$uv)("MainThreadChat"),MainThreadInlineChat:(0,I.$uv)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$uv)("MainThreadTheming"),MainThreadTunnelService:(0,I.$uv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$uv)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$uv)("MainThreadTimeline"),MainThreadTesting:(0,I.$uv)("MainThreadTesting"),MainThreadLocalization:(0,I.$uv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$uv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$uv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$uv)("MainThreadIssueReporter")},e.$AK={ExtHostCommands:(0,I.$uv)("ExtHostCommands"),ExtHostConfiguration:(0,I.$uv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$uv)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$uv)("ExtHostDebugService"),ExtHostDecorations:(0,I.$uv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$uv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$uv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$uv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$uv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$uv)("ExtHostEditors"),ExtHostTreeViews:(0,I.$uv)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$uv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$uv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$uv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$uv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$uv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$uv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$uv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$uv)("ExtHostStatusBar"),ExtHostShare:(0,I.$uv)("ExtHostShare"),ExtHostExtensionService:(0,I.$uv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$uv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$uv)("ExtHostTerminalService"),ExtHostSCM:(0,I.$uv)("ExtHostSCM"),ExtHostSearch:(0,I.$uv)("ExtHostSearch"),ExtHostTask:(0,I.$uv)("ExtHostTask"),ExtHostWorkspace:(0,I.$uv)("ExtHostWorkspace"),ExtHostWindow:(0,I.$uv)("ExtHostWindow"),ExtHostWebviews:(0,I.$uv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$uv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$uv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$uv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$uv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$uv)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$uv)("ExtHostProgress"),ExtHostComments:(0,I.$uv)("ExtHostComments"),ExtHostSecretState:(0,I.$uv)("ExtHostSecretState"),ExtHostStorage:(0,I.$uv)("ExtHostStorage"),ExtHostUrls:(0,I.$uv)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$uv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$uv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$uv)("ExtHostOutputService"),ExtHosLabelService:(0,I.$uv)("ExtHostLabelService"),ExtHostNotebook:(0,I.$uv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$uv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$uv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$uv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$uv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$uv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$uv)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$uv)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$uv)("ExtHostChat"),ExtHostChatAgents:(0,I.$uv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,I.$uv)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$uv)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$uv)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$uv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$uv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$uv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$uv)("ExtHostTheming"),ExtHostTunnelService:(0,I.$uv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$uv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$uv)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$uv)("ExtHostTimeline"),ExtHostTesting:(0,I.$uv)("ExtHostTesting"),ExtHostTelemetry:(0,I.$uv)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$uv)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$uv)("ExtHostIssueReporter")}}),define(ke[306],Se([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0;class m{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$zK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,p,E){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(R);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(p,E)??[]}getRelatedInformation(R,p,E){return this.c.$getAiRelatedInformation(p,E)}registerRelatedInformationProvider(R,p,E){const g=this.b;return this.b++,this.a.set(g,E),this.c.$registerAiRelatedInformationProvider(g,p),new F.$BK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Afc=m}),define(ke[91],Se([1,0,5,15,6,20]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=e.$Ddc=e.$Cdc=void 0,e.$Cdc=(0,I.$Uh)("IExtHostApiDeprecationService");let R=class{constructor(E,g){this.c=g,this.a=new Set,this.b=E.getProxy(m.$zK.MainThreadTelemetry)}report(E,g,A){const P=this.d(E,g);this.a.has(P)||(this.a.add(P),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:E}))}d(E,g){return`${E}-${g.identifier.value}`}};e.$Ddc=R,e.$Ddc=R=He([Be(0,L.$BM),Be(1,F.$cj)],R),e.$Edc=Object.freeze(new class{report(p,E,g){}})}),define(ke[307],Se([1,0,4,6,7,26]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class R{constructor(g){this.b=new Map,this.c=[],this.d=new I.$Qd,this.onDidChangeSessions=this.d.event,this.f=new p,this.g=new p,this.a=g.getProxy(F.$zK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,A,P,f={}){const y=L.$$l.toKey(g.identifier),S=[...P].sort().join(" ");return await this.f.getOrCreate(`${y} ${A} ${S}`,async()=>{await this.a.$ensureProvider(A);const w=g.displayName||g.name;return this.a.$getSession(A,P,y,w,f)})}async getSessions(g,A,P){const f=L.$$l.toKey(g.identifier),y=[...P].sort().join(" ");return await this.g.getOrCreate(`${f} ${y}`,async()=>{await this.a.$ensureProvider(A);const S=g.displayName||g.name;return this.a.$getSessions(A,P,f,S)})}async removeSession(g,A){const P=this.b.get(g);return P?P.provider.removeSession(A):this.a.$removeSession(g,A)}registerAuthenticationProvider(g,A,P,f){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:A,provider:P,options:f??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===g)||this.c.push({id:g,label:A});const y=P.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(g,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(g,A,f?.supportsMultipleAccounts??!1),new m.$BK(()=>{y.dispose(),this.b.delete(g);const S=this.c.findIndex(w=>w.id===g);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,A,P){const f=this.b.get(g);if(f)return Promise.resolve(f.provider.createSession(A,P));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,A){const P=this.b.get(g);if(P)return Promise.resolve(P.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,A){const P=this.b.get(g);if(P)return Promise.resolve(P.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,A){return this.d.fire({provider:{id:g,label:A}}),Promise.resolve()}}e.$$ec=R;class p{constructor(){this.a=new Map}getOrCreate(g,A){const P=this.a.get(g);if(P)return P;const f=A().finally(()=>this.a.delete(g));return this.a.set(g,f),f}}}),define(ke[308],Se([1,0,6,20,14]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;let L=class{constructor(p,E){this.a=p.getProxy(I.$zK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>E.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,E,g){const A=m.WorkspaceEdit.from(p,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,g?.isRefactoring??!1)}};e.$efc=L,e.$efc=L=He([Be(0,F.$BM)],L)}),define(ke[309],Se([1,0,10,4,51,3,37,210,6,14]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class A{static{this.a=0}constructor(y,S){this.extension=y,this.provider=S,this.handle=A.a++}}class P{static{this.a=0}constructor(y,S){this.h=S,this.b=new Map,this.d=new Map,this.e=new F.$Qd,this.onDidPerformUserAction=this.e.event,this.g=y.getProxy(E.$zK.MainThreadChat)}registerChatProvider(y,S,w){const c=new A(y,w);return this.b.set(c.handle,c),this.g.$registerChatProvider(c.handle,S),(0,L.$Pc)(()=>{this.g.$unregisterChatProvider(c.handle),this.b.delete(c.handle)})}transferChatSession(y,S){const w=m.Iterable.find(this.d.keys(),c=>this.d.get(c)===y)??0;typeof w=="number"&&this.g.$transferChatSession(w,S)}sendInteractiveRequestToProvider(y,S){this.g.$sendRequestToProvider(y,S)}async $prepareChat(y,S,w){const c=this.b.get(y);if(!c)return;const s=await c.provider.prepareSession(S,w);if(!s)return;const i=P.a++;return this.d.set(i,s),{id:i,requesterUsername:s.requester?.name,requesterAvatarIconUri:s.requester?.icon,responderUsername:s.responder?.name,responderAvatarIconUri:s.responder?.icon,inputPlaceholder:s.inputPlaceholder}}async $provideWelcomeMessage(y,S){const w=this.b.get(y);if(!w||!w.provider.provideWelcomeMessage)return;const c=await w.provider.provideWelcomeMessage(S);if(c)return c.map(s=>typeof s=="string"?s:Array.isArray(s)?s.map(i=>g.ChatReplyFollowup.from(i)):g.MarkdownString.from(s))}async $provideFollowups(y,S,w){const c=this.b.get(y);if(!c)return;const s=this.d.get(S);return!s||!c.provider.provideFollowups?void 0:(await c.provider.provideFollowups(s,w))?.map(n=>g.ChatFollowup.from(n))}async $provideSampleQuestions(y,S){const w=this.b.get(y);if(!w||!w.provider.provideSampleQuestions)return;const c=await w.provider.provideSampleQuestions(S);if(c)return c?.map(s=>g.ChatReplyFollowup.from(s))}$removeRequest(y,S,w){const c=this.b.get(y);if(!c)return;const s=this.d.get(S);s&&c.provider.removeRequest&&c.provider.removeRequest(s,w)}async $provideReply(y,S,w,c){const s=this.b.get(y);if(!s)return;const i=this.d.get(S);if(!i)return;const n={session:i,message:w.message,variables:{}};if(w.variables)for(const u of Object.keys(w.variables))n.variables[u]=w.variables[u].map(g.ChatVariable.to);const o=R.$Md.create(!1);let a;const t={report:u=>{if(c.isCancellationRequested)return;typeof a>"u"&&(a=o.elapsed());const l=g.ChatResponseProgress.from(s.extension,u);if("placeholder"in u&&"resolvedContent"in u){const h=Promise.all([this.g.$acceptResponseProgress(y,S,l),u.resolvedContent]);(0,I.$Lg)(h,c).then(k=>{if(!k)return;const[D,$]=k;this.g.$acceptResponseProgress(y,S,$,D??void 0)})}else this.g.$acceptResponseProgress(y,S,l)}};let r;try{r=await s.provider.provideResponseWithProgress(n,t,c),r||(r={errorDetails:{message:(0,p.localize)(0,null)}})}catch(u){r={errorDetails:{message:(0,p.localize)(1,null,u.message),responseIsIncomplete:!0}},this.h.error(u)}try{if(i.saveState&&this.d.has(S)){const u=i.saveState();this.g.$acceptChatState(S,u)}}catch(u){this.h.warn(u)}const d={firstProgress:a??0,totalElapsed:o.elapsed()};return{errorDetails:r.errorDetails,timings:d}}async $provideSlashCommands(y,S,w){const c=this.b.get(y);if(!c)return;const s=this.d.get(S);return!s||!c.provider.provideSlashCommands?void 0:(await c.provider.provideSlashCommands(s,w))?.map(n=>({...n,kind:g.CompletionItemKind.from(n.kind)}))}$releaseSession(y){this.d.delete(y)}async $onDidPerformUserAction(y){this.e.fire(y)}}e.$sfc=P}),define(ke[310],Se([1,0,10,3,64,6,14,7]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;class E{static{this.a=0}constructor(P,f,y){this.d=f,this.e=y,this.b=new Map,this.c=P.getProxy(L.$zK.MainThreadChatAgents)}registerAgent(P,f,y,S){const w=E.a++;return this.b.set(w,{extension:P,agent:y}),this.c.$registerAgent(w,f,S),(0,F.$Pc)(()=>{this.c.$unregisterAgent(w),this.b.delete(w)})}async $invokeAgent(P,f,y,S,w){const c=this.b.get(P);if(!c){this.e.warn(`[CHAT](${P}) CANNOT invoke agent because the agent is not registered`);return}let s=!1;function i(){if(s)throw new Error("Only valid while executing the command")}const n=new I.$hh;w.onCancellationRequested(()=>n.complete()),setTimeout(()=>n.complete(),10*1e3),this.d.allowListExtensionWhile(c.extension,n.p);const o=c.agent({role:p.ChatMessageRole.User,content:y},{history:S.history.map(R.ChatMessage.to)},new m.$$u(a=>{i(),this.c.$handleProgressChunk(f,{content:g(a.message)?a.message:a.message.value})}),w);try{return await(0,I.$Lg)(Promise.resolve(o).then(a=>{if(a&&"followUp"in a)return{followUp:a?.followUp?.map(r=>R.ChatFollowup.from(r))}}),w)}finally{s=!0,n.complete()}}}e.$Cfc=E;function g(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(ke[311],Se([1,0,10,21,43,4,37,18,2,211,64,6,14,7,281,25]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;class c{static{this.a=0}constructor(n,o,a){this.i=o,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(P.$zK.MainThreadChatAgents2)}createChatAgent(n,o,a){const t=c.a++,r=new s(n,o,this.d,t,a);return this.b.set(t,r),this.d.$registerAgent(t,o,{}),r.apiAgent}async $invokeAgent(n,o,a,t,r,d){this.g.delete(o);const u=this.b.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let l=!1;function h(){if(l)throw new Error("Only valid while executing the command")}const k=new I.$hh;d.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this.i.allowListExtensionWhile(u.extension.identifier,k.p);const D=t.command?await u.validateSlashCommand(t.command):void 0,$=R.$Md.create(!1);let b;try{const v=u.invoke({prompt:t.message,variables:f.ChatVariable.objectTo(t.variables),slashCommand:D},{history:r.history.map(f.ChatMessage.to)},new A.$$u(C=>{h(),typeof b>"u"&&"content"in C&&(b=$.elapsed());const N=f.ChatResponseProgress.from(u.extension,C);if("placeholder"in C&&"resolvedContent"in C){const j=Promise.all([this.d.$handleProgressChunk(a,N),C.resolvedContent]);(0,I.$Lg)(j,d).then(M=>{if(!M)return;const[O,z]=M;this.d.$handleProgressChunk(a,z,O??void 0)})}else this.d.$handleProgressChunk(a,N)}),d);return await(0,I.$Lg)(Promise.resolve(v).then(C=>{if(C){this.g.set(o,C);let N=this.h.get(o);N||(N=new Map,this.h.set(o,N)),N.set(a,C);const j={firstProgress:b,totalElapsed:$.elapsed()};return{errorDetails:C.errorDetails,timings:j}}else this.g.delete(o)}),d)}catch(v){return this.j.error(v,u.extension),{errorDetails:{message:(0,g.localize)(0,null,(0,m.$Fi)(v)),responseIsIncomplete:!0}}}finally{l=!0,k.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,o){const a=this.b.get(n);return a?a.provideSlashCommand(o):[]}$provideFollowups(n,o,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const r=this.g.get(o);return r?t.provideFollowups(r,a):Promise.resolve([])}$acceptFeedback(n,o,a,t){const r=this.b.get(n);if(!r)return;const d=this.h.get(o)?.get(a);if(!d)return;let u;switch(t){case S.InteractiveSessionVoteDirection.Down:u=y.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:u=y.ChatAgentResultFeedbackKind.Helpful;break}r.acceptFeedback(Object.freeze({result:d,kind:u}))}$acceptAction(n,o,a,t){const r=this.b.get(n);if(!r)return;const d=this.h.get(o)?.get(a);d&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:d}))}}e.$Dfc=c;class s{constructor(n,o,a,t,r){this.extension=n,this.n=o,this.o=a,this.q=t,this.r=r,this.l=new L.$Qd,this.m=new L.$Qd}acceptFeedback(n){this.l.fire(n)}acceptAction(n){this.m.fire(n)}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(F.CancellationToken.None),(0,p.$Lf)(this.b));const o=this.b.find(a=>a.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this.a)return[];const o=await this.a.provideSlashCommands(n);return o?(this.b=o,o.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate}))):[]}async provideFollowups(n,o){if(!this.d)return[];const a=await this.d.provideFollowups(n,o);return a?a.map(t=>f.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const a=()=>{n||o||(o=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof y.$vL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),o=!1}))},t=this;return{get name(){return t.n},get description(){return t.g??""},set description(r){t.g=r,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,a()},get iconPath(){return t.i},set iconPath(r){t.i=r,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,a()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,a()},get isDefault(){return(0,w.$yF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,w.$yF)(t.extension,"defaultChatAgent"),t.j=r,a()},get isSecondary(){return(0,w.$yF)(t.extension,"defaultChatAgent"),t.k},set isSecondary(r){(0,w.$yF)(t.extension,"defaultChatAgent"),t.k=r,a()},get onDidReceiveFeedback(){return t.l.event},onDidPerformAction:(0,w.$xF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.l.dispose(),t.o.$unregisterAgent(t.q)}}}invoke(n,o,a,t){return this.r(n,o,a,t)}}}),define(ke[312],Se([1,0,21,3,6,14,64,26,10,4]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class A{constructor(S,w){this.stream=new E.$lh,this.stream=w??new E.$lh;const c=this;this.apiObj={option:S,response:c.stream.asyncIterable}}}class P{constructor(S,w){this.a=new g.$Qd,this.b=new Map,this.c=new E.$lh,this.d=!1;const c=this;this.apiObject={result:S,response:c.c.asyncIterable,onDidStartResponseStream:c.a.event,cancel(){w.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let w=this.b.get(S.index);w||(this.b.size===0?w=new A(S.index,this.c):w=new A(S.index),this.b.set(S.index,w),this.a.fire(w.apiObj)),w.stream.emitOne(S.part)}}class f{static{this.a=1}constructor(S,w){this.d=w,this.c=new Map,this.e=new Map,this.f=new p.$am,this.b=S.getProxy(m.$zK.MainThreadChatProvider)}registerProvider(S,w,c,s){const i=f.a++;return this.c.set(i,{extension:S,provider:c}),this.b.$registerProvider(i,w,{extension:S,displayName:s.name??S.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,w,c,s,i){const n=this.c.get(S);if(!n)return;const o=new R.$$u(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(w,{index:a.index,part:a.part})});return n.provider.provideChatResponse(c.map(L.ChatMessage.to),s,o,i)}allowListExtensionWhile(S,w){this.f.set(S,w),w.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,w){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const c=this;return{get isRevoked(){return!c.f.has(S)},makeRequest(s,i,n){if(!c.f.has(S))throw new Error("Access to chat has been revoked");const o=new I.$1d(n),a=Math.random()*1e6|0,t=c.b.$fetchResponse(S,w,a,s.map(L.ChatMessage.from),i??{},o.token),r=new P(t,o);return c.e.set(a,{res:r}),t.finally(()=>{c.e.delete(a)}),r.apiObject}}}async $handleResponseFragment(S,w){const c=this.e.get(S);c&&c.res.handleFragment(w)}}e.$xfc=f}),define(ke[313],Se([1,0,3,6,11,14]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=void 0;class R{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(F.$zK.MainThreadChatVariables)}async $resolveVariable(E,g,A){const P=this.b.get(E);if(P)try{const f=await P.resolver.resolve(P.data.name,{message:g},A);if(f)return f.map(L.ChatVariable.from)}catch(f){(0,m.$1)(f)}}registerVariableResolver(E,g,A,P){const f=R.a++;return this.b.set(f,{extension:E.identifier,data:{name:g,description:A},resolver:P}),this.c.$registerVariable(f,{name:g,description:A}),(0,I.$Pc)(()=>{this.b.delete(f),this.c.$unregisterVariable(f)})}}e.$zfc=R}),define(ke[314],Se([1,0,6]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class F{constructor(L){const R=L.getProxy(I.$zK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(p){return R.$writeText(p)}})}}e.$Hdc=F}),define(ke[35],Se([1,0,18,7,14,24,6,19,15,54,29,53,2,3,5,20,149,22,69,43,37,87,90]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=void 0;let r=class{#e;#t;#i;constructor(D,$,b){this.b=new Map,this.c=new Map,this.#e=D.getProxy(R.$zK.MainThreadCommands),this.d=$,this.#i=b,this.#t=D.getProxy(R.$zK.MainThreadTelemetry),this.converter=new d(this,v=>{const C=this.c.get(v);return C?.result===l.Void?C:void 0},$),this.f=[{processArgument(v){return(0,g.$rh)(v)}},{processArgument(v){return(0,L.$bn)(v,function(C){if(A.$zs.isIRange(C))return m.Range.to(C);if(P.$ys.isIPosition(C))return m.Position.to(C);if(A.$zs.isIRange(C.range)&&f.URI.isUri(C.uri))return m.location.to(C);if(C instanceof s.$ee)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(D){this.f.push(D)}registerApiCommand(D){const $=this.registerCommand(!1,D.id,async(...b)=>{const v=D.args.map((N,j)=>{if(!N.validate(b[j]))throw new Error(`Invalid argument '${N.name}' when running '${D.id}', received: ${typeof b[j]=="object"?JSON.stringify(b[j],null,"	"):b[j]} `);return N.convert(b[j])}),C=await this.executeCommand(D.internalId,...v);return D.result.convert(C,b,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this.c.set(D.id,D),new F.$BK(()=>{$.dispose(),this.c.delete(D.id)})}registerCommand(D,$,b,v,C,N){if(this.d.trace("ExtHostCommands#registerCommand",$),!$.trim().length)throw new Error("invalid id");if(this.b.has($))throw new Error(`command '${$}' already exists`);return this.b.set($,{callback:b,thisArg:v,metadata:C,extension:N}),D&&this.#e.$registerCommand($),new F.$BK(()=>{this.b.delete($)&&D&&this.#e.$unregisterCommand($)})}executeCommand(D,...$){return this.d.trace("ExtHostCommands#executeCommand",D),this.g(D,$,!0)}async g(D,$,b){if(this.b.has(D))return this.#e.$fireCommandActivationEvent(D),this.h(D,$,!1);{let v=!1;const C=(0,L.$bn)($,function(N){if(N instanceof F.$CK)return m.Position.from(N);if(N instanceof F.$DK)return m.Range.from(N);if(N instanceof F.$NK)return m.location.from(N);if(F.$YL.isNotebookRange(N))return m.NotebookRange.from(N);if(N instanceof ArrayBuffer)return v=!0,s.$ee.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return v=!0,s.$ee.wrap(N);if(N instanceof s.$ee)return v=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(D,v?new i.$wv(C):C,b);return(0,g.$rh)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(D,$,!1);throw N}}}async h(D,$,b){const v=this.b.get(D);if(!v)throw new Error("Unknown command");const{callback:C,thisArg:N,metadata:j}=v;if(j?.args)for(let O=0;O<j.args.length;O++)try{(0,I.$Sf)($[O],j.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${j.args[O].name}' - ${j.args[O].description}`)}const M=o.$Md.create();try{return await C.apply(N,$)}catch(O){if(D===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...$);z&&(D=z.command)}if(this.d.error(O,D,v.extension?.identifier),!b)throw O;if(v.extension?.identifier){const z=this.#i.onExtensionError(v.extension.identifier,O);this.d.trace("forwarded error to extension?",z,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Fi)(O)),this.id=D,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,D,M.elapsed())}}j(D,$,b){D.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new a.$oo($),duration:b})}$executeContributedCommand(D,...$){this.d.trace("ExtHostCommands#$executeContributedCommand",D);const b=this.b.get(D);return b?($=$.map(v=>this.f.reduce((C,N)=>N.processArgument(C,b.extension?.identifier),v)),this.h(D,$,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this.d.trace("ExtHostCommands#getCommands",D),this.#e.$getCommands().then($=>(D&&($=$.filter(b=>b[0]!=="_")),$))}$getContributedCommandMetadata(){const D=Object.create(null);for(const[$,b]of this.b){const{metadata:v}=b;v&&(D[$]=v)}return Promise.resolve(D)}};e.$WM=r,e.$WM=r=He([Be(0,w.$BM),Be(1,E.$cj),Be(2,t.$VM)],r),e.$XM=(0,S.$Uh)("IExtHostCommands");class d{constructor(D,$,b){this.d=D,this.f=$,this.g=b,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(D,$){if(!D)return;const b={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return b;const v=this.f(D.command);if(v)b.id=v.internalId,b.arguments=v.args.map((C,N)=>C.convert(D.arguments&&D.arguments[N]));else if((0,p.$Kb)(D.arguments)){const C=`${D.command} /${++this.c}`;this.b.set(C,D),$.add((0,y.$Pc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),b.$ident=C,b.id=this.delegatingCommandId,b.arguments=[C],this.g.trace("CommandsConverter#CREATE",D.command,C)}return b}fromInternal(D){return typeof D.$ident=="string"?this.b.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this.b.get(D[0])}h(...D){const $=this.getActualCommand(...D);return this.g.trace("CommandsConverter#EXECUTE",D[0],$?$.command:"MISSING"),$?this.d.executeCommand($.command,...$.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.$YM=d;class u{static{this.Uri=new u("uri","Uri of a text document",D=>f.URI.isUri(D),D=>D)}static{this.Position=new u("position","A position in a text document",D=>F.$CK.isPosition(D),m.Position.from)}static{this.Range=new u("range","A range in a text document",D=>F.$DK.isRange(D),m.Range.from)}static{this.Selection=new u("selection","A selection in a text document",D=>F.$EK.isSelection(D),m.Selection.from)}static{this.Number=new u("number","",D=>typeof D=="number",D=>D)}static{this.String=new u("string","",D=>typeof D=="string",D=>D)}static{this.StringArray=u.Arr(u.String)}static Arr(D){return new u(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,$=>Array.isArray($)&&$.every(b=>D.validate(b)),$=>$.map(b=>D.convert(b)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",D=>D instanceof F.$XK,m.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",D=>D instanceof F.$fM,m.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",D=>D instanceof c.$OM,m.TestItem.from)}constructor(D,$,b,v){this.name=D,this.description=$,this.validate=b,this.convert=v}optional(){return new u(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,$){return new u(D??this.name,$??this.description,this.validate,this.convert)}}e.$ZM=u;class l{static{this.Void=new l("no result",D=>D)}constructor(D,$){this.description=D,this.convert=$}}e.$1M=l;class h{constructor(D,$,b,v,C){this.id=D,this.internalId=$,this.description=b,this.args=v,this.result=C}}e.$2M=h}),define(ke[315],Se([1,0,19,17,2,84,132,45,137,35,14,7]),function(me,e,I,F,m,L,R,p,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;const f=[new g.$2M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of DocumentHighlight-instances.",S(A.DocumentHighlight.to))),new g.$2M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$ZM.Uri],new g.$1M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,s)=>{if((0,I.$Jb)(c))return;class i extends P.$SK{static to(o){const a=new i(o.name,A.SymbolKind.to(o.kind),o.containerName||"",new P.$NK(s[0],A.Range.to(o.range)));return a.detail=o.detail,a.range=a.location.range,a.selectionRange=A.Range.to(o.selectionRange),a.children=o.children?o.children.map(i.to):[],a}}return c.map(i.to)})),new g.$2M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$ZM.Uri,new g.$ZM("options","Formatting options",c=>!0,c=>c)],new g.$1M("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new g.$2M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$ZM.Uri,g.$ZM.Range,new g.$ZM("options","Formatting options",c=>!0,c=>c)],new g.$1M("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new g.$2M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$ZM.Uri,g.$ZM.Position,new g.$ZM("ch","Trigger character",c=>typeof c=="string",c=>c),new g.$ZM("options","Formatting options",c=>!0,c=>c)],new g.$1M("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new g.$2M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$2M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$2M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$2M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$2M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location-instances.",S(A.location.to))),new g.$2M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Hover-instances.",S(A.Hover.to))),new g.$2M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$ZM.Uri,new g.$ZM("position","A position in a text document",c=>Array.isArray(c)&&c.every(s=>P.$CK.isPosition(s)),c=>c.map(A.Position.from))],new g.$1M("A promise that resolves to an array of ranges.",c=>c.map(s=>{let i;for(const n of s.reverse())i=new P.$WK(A.Range.to(n),i);return i}))),new g.$2M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$ZM.String.with("query","Search string")],new g.$1M("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(A.WorkspaceSymbol.to))),new g.$2M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(A.CallHierarchyItem.to))),new g.$2M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$ZM.CallHierarchyItem],new g.$1M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(A.CallHierarchyIncomingCall.to))),new g.$2M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$ZM.CallHierarchyItem],new g.$1M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(A.CallHierarchyOutgoingCall.to))),new g.$2M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:A.Range.to(c.range),placeholder:c.text}})),new g.$2M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$ZM.Uri,g.$ZM.Position,g.$ZM.String.with("newName","The new symbol name")],new g.$1M("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return A.WorkspaceEdit.to(c)}})),new g.$2M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$ZM.Uri,g.$ZM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$1M("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(A.DocumentLink.to))),new g.$2M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$ZM.Uri],new g.$1M("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new P.$QL(c.tokenTypes,c.tokenModifiers)})),new g.$2M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$ZM.Uri],new g.$1M("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const s=(0,R.$F$)(c);if(s.type==="full")return new P.$SL(s.data,void 0)})),new g.$2M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$ZM.Uri,g.$ZM.Range.optional()],new g.$1M("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new P.$QL(c.tokenTypes,c.tokenModifiers)})),new g.$2M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$ZM.Uri,g.$ZM.Range],new g.$1M("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const s=(0,R.$F$)(c);if(s.type==="full")return new P.$SL(s.data,void 0)})),new g.$2M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$ZM.Uri,g.$ZM.Position,g.$ZM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$ZM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$1M("A promise that resolves to a CompletionList-instance.",(c,s,i)=>{if(!c)return new P.$9K([]);const n=c.suggestions.map(o=>A.CompletionItem.to(o,i));return new P.$9K(n,c.incomplete)})),new g.$2M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$ZM.Uri,g.$ZM.Position,g.$ZM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$1M("A promise that resolves to SignatureHelp.",c=>{if(c)return A.SignatureHelp.to(c)})),new g.$2M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$ZM.Uri,g.$ZM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$1M("A promise that resolves to an array of CodeLens-instances.",(c,s,i)=>S(n=>new P.$1K(A.Range.to(n.range),n.command&&i.fromInternal(n.command)))(c))),new g.$2M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$ZM.Uri,new g.$ZM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>P.$DK.isRange(c),c=>P.$EK.isSelection(c)?A.Selection.from(c):A.Range.from(c)),g.$ZM.String.with("kind","Code action kind to return code actions for").optional(),g.$ZM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$1M("A promise that resolves to an array of Command-instances.",(c,s,i)=>S(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(n.command)}else{const o=new P.$UK(n.title,n.kind?new P.$VK(n.kind):void 0);return n.edit&&(o.edit=A.WorkspaceEdit.to(n.edit)),n.command&&(o.command=i.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(c))),new g.$2M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$ZM.Uri],new g.$1M("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(s=>new P.$cL(A.Range.to(s.range),A.Color.to(s.color))):[])),new g.$2M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$ZM("color","The color to show and insert",c=>c instanceof P.$bL,A.Color.from),new g.$ZM("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:A.Range.from(c.range)}))],new g.$1M("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(A.ColorPresentation.to):[])),new g.$2M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$ZM.Uri,g.$ZM.Range],new g.$1M("A promise that resolves to an array of Inlay objects",(c,s,i)=>c.map(A.InlayHint.to.bind(void 0,i)))),new g.$2M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$ZM.Uri],new g.$1M("A promise that resolves to an array of FoldingRange objects",(c,s)=>{if(c)return c.map(A.FoldingRange.to)})),new g.$2M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$1M("A promise that resolves to an array of NotebookContentProvider static info objects.",S(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(s=>A.NotebookExclusiveDocumentPattern.to(s))})))),new g.$2M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$ZM.Uri,g.$ZM.Range,new g.$ZM("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof P.$DK,c=>A.InlineValueContext.from(c))],new g.$1M("A promise that resolves to an array of InlineValue objects",c=>c.map(A.InlineValue.to))),new g.$2M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$ZM("uriOrString","Uri-instance or string (only http/https)",c=>m.URI.isUri(c)||typeof c=="string"&&(0,E.$PU)(c,F.Schemas.http,F.Schemas.https),c=>c),new g.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[A.ViewColumn.from(c),void 0]:[A.ViewColumn.from(c.viewColumn),A.TextEditorOpenOptions.from(c)])).optional(),g.$ZM.String.with("label","").optional()],g.$1M.Void),new g.$2M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$ZM.Uri.with("resource","Resource to open"),g.$ZM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[A.ViewColumn.from(c),void 0]:[A.ViewColumn.from(c.viewColumn),A.TextEditorOpenOptions.from(c)])).optional()],g.$1M.Void),new g.$2M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$ZM.Uri.with("left","Left-hand side resource of the diff editor"),g.$ZM.Uri.with("right","Right-hand side resource of the diff editor"),g.$ZM.String.with("title","Human readable title for the diff editor").optional(),new g.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[A.ViewColumn.from(c.viewColumn),A.TextEditorOpenOptions.from(c)]).optional()],g.$1M.Void),new g.$2M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$ZM.String.with("title","Human readable title for the changes editor"),new g.$ZM("resourceList","List of resources to compare",c=>{for(const s of c){if(s.length!==3)return!1;const[i,n,o]=s;if(!m.URI.isUri(i)||!m.URI.isUri(n)&&n!==void 0&&n!==null||!m.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},c=>c)],g.$1M.Void),new g.$2M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(A.TypeHierarchyItem.to))),new g.$2M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$ZM.TypeHierarchyItem],new g.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(A.TypeHierarchyItem.to))),new g.$2M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$ZM.TypeHierarchyItem],new g.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(A.TypeHierarchyItem.to))),new g.$2M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$ZM.TestItem],g.$1M.Void),new g.$2M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$ZM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$1M.Void),new g.$2M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$ZM.String.with("name","The context key name"),new g.$ZM("value","The context key value",()=>!0,c=>c)],g.$1M.Void),new g.$2M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$ZM.Uri,g.$ZM.StringArray,new g.$ZM("MappedEditsContext","Mapped Edits Context",c=>A.MappedEditsContext.is(c),c=>A.MappedEditsContext.from(c))],new g.$1M("A promise that resolves to a workspace edit or null",c=>c?A.WorkspaceEdit.to(c):null))];class y{static register(s){f.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",p.$Ti)}}e.$Gdc=y;function S(c){return s=>{if(Array.isArray(s))return s.map(c)}}function w(c){if(!Array.isArray(c))return;const s=[];for(const i of c)L.$kt(i)?s.push(A.DefinitionLink.to(i)):s.push(A.location.to(i));return s}}),define(ke[316],Se([1,0,10,59,4,3,2,84,26,14,7,6,25]),function(me,e,I,F,m,L,R,p,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;function y(S,w,c){const s=S.getProxy(P.$zK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$am,w.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const k=this.b.get(h.handle);return k?k.value:h}else if(h&&h.$mid===7){const k=this.b.get(h.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.commentThreadHandle);return D?D.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.thread.commentThreadHandle);return D?h.$mid===8?D.value:{thread:D.value,text:h.text}:h}else if(h&&h.$mid===10){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const $=h.commentUniqueId,b=D.getCommentByUniqueId($);return b||h}else if(h&&h.$mid===11){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const D=k.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const $=h.text,b=h.commentUniqueId,v=D.getCommentByUniqueId(b);return v?(typeof v.body=="string"?v.body=$:v.body=new A.$2K($),v):h}return h}})}createCommentController(h,k,D){const $=i.a++,b=new o(h,$,k,D);this.b.set(b.handle,b);const v=this.c.get(h.identifier)||[];return v.push(b),this.c.set(h.identifier,v),b.value}async $createCommentThreadTemplate(h,k,D){const $=this.b.get(h);$&&$.$createCommentThreadTemplate(k,D)}async $updateCommentThreadTemplate(h,k,D){const $=this.b.get(h);$&&$.$updateCommentThreadTemplate(k,D)}$deleteCommentThread(h,k){this.b.get(h)?.$deleteCommentThread(k)}$provideCommentingRanges(h,k,D){const $=this.b.get(h);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const b=c.getDocument(R.URI.revive(k));return(0,I.$Pg)(async()=>{const v=await $.commentingRangeProvider.provideCommentingRanges(b,D);let C;return Array.isArray(v)?C={ranges:v,fileComments:!1}:v?C={ranges:v.ranges||[],fileComments:v.fileComments||!1}:C=v??void 0,C}).then(v=>{let C;return v&&(C={ranges:v.ranges.map(N=>g.Range.from(N)),fileComments:v.fileComments}),C})}$toggleReaction(h,k,D,$,b){const v=this.b.get(h);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,I.$Pg)(()=>{const C=v.getCommentThread(k);if(C){const N=C.getCommentByUniqueId($.uniqueIdInThread);if(v!==void 0&&N&&v.reactionHandler)return v.reactionHandler(N,r(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,k,D,$,b,v,C,N){this.m=k,this.n=D,this.o=$,this.p=b,this.q=v,this.extensionDescription=C,this.r=N,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new m.$Qd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Sc,this.l.value=new L.$Qc,this.n===void 0&&(this.n=`${h}.${this.handle}`),s.$createCommentThread(k,this.handle,this.n,this.o,g.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this.i.push({dispose:()=>{s.$deleteCommentThread(k,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(M){j.range=M},get comments(){return j.comments},set comments(M){j.comments=M},get collapsibleState(){return j.collapsibleState},set collapsibleState(M){j.collapsibleState=M},get canReply(){return j.canReply},set canReply(M){j.canReply=M},get contextValue(){return j.contextValue},set contextValue(M){j.contextValue=M},get label(){return j.label},set label(M){j.label=M},get state(){return j.state},set state(M){j.state=M},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Qc);const h=D=>Object.prototype.hasOwnProperty.call(this.b,D),k={};h("range")&&(k.range=g.Range.from(this.p)),h("label")&&(k.label=this.label),h("contextValue")&&(k.contextValue=this.contextValue??null),h("comments")&&(k.comments=this.q.map(D=>a(this,D,this.k,this.extensionDescription))),h("collapsibleState")&&(k.collapseState=d(this.g)),h("canReply")&&(k.canReply=this.canReply),h("state")&&(k.state=u(this.h)),h("isTemplate")&&(k.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(h){for(const k of this.k){const D=k[0],$=k[1];if(h===$)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}He([(0,F.$nh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,k,D,$){this.f=h,this.g=k,this.h=D,this.i=$,this.a=new Map,s.$registerCommentController(this.handle,D,$,this.f.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(v){b.options=v},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(v){b.commentingRangeProvider=v},get reactionHandler(){return b.reactionHandler},set reactionHandler(v){b.reactionHandler=v},createCommentThread(v,C,N){return b.createCommentThread(v,C,N).value},dispose:()=>{b.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(h,k,D){k===void 0&&(0,f.$yF)(this.f,"fileComments");const $=new n(this.id,this.handle,void 0,h,k,D,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(h,k){const D=new n(this.id,this.handle,void 0,R.URI.revive(h),g.Range.to(k),[],this.f,!0);return D.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(h,k){const D=this.a.get(h);D&&(D.range=g.Range.to(k))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function a(l,h,k,D){let $=k.get(h);return $||($=++l.commentHandle,k.set(h,$)),h.state!==void 0&&(0,f.$yF)(D,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:$,body:typeof h.body=="string"?h.body:g.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(b=>t(b)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?g.$AM(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function r(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?R.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function d(l){if(l!==void 0)switch(l){case A.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function u(l){if(l!==void 0)switch(l){case A.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}return new i}e.$Idc=y}),define(ke[317],Se([1,0,24,6,27,20]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;let R=class{constructor(A,P){this.a=A.getProxy(F.$zK.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,P){const f=this,y=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){f.e(A,P,y,arguments)}})}e(A,P,f,y){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:E(y,this.b)}),this.c&&this.f(A,f,y)}};e.$Gfc=R,e.$Gfc=R=He([Be(0,L.$BM),Be(1,m.$RM)],R);const p=1e5;function E(g,A){const P=[];if(g.length)for(let f=0;f<g.length;f++){let y=g[f];if(typeof y>"u")y="undefined";else if(y instanceof Error){const S=y;S.stack?y=S.stack:y=S.toString()}P.push(y)}if(A){const f=new Error().stack;f&&P.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,I.$en)(P);return f.length>p?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(ke[151],Se([1,0,2,6,7,5,20,15,19,13,16,25]),function(me,e,I,F,m,L,R,p,E,g,A,P){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=void 0;let y=class{static{f=this}static{this.c=0}static{this.d=250}constructor(w,c){this.h=c,this.f=new Map,this.g=w.getProxy(F.$zK.MainThreadDecorations)}registerFileDecorationProvider(w,c){const s=f.c++;this.f.set(s,{provider:w,extensionDescription:c}),this.g.$registerDecorationProvider(s,c.identifier.value);const i=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const o=(0,E.$2b)(n);if(o.length<=f.d){this.g.$onDidChange(s,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",c.identifier.value,o.length);const a=o.map(d=>({uri:d,rank:(0,g.$Je)(d.path,"/")})),t=(0,E.$yb)(a,(d,u)=>d.rank-u.rank||(0,g.$Xe)(d.uri.path,u.uri.path)),r=[];e:for(const d of t){let u;for(const l of d){const h=(0,A.$lc)(l.uri.path);if(u!==h&&(u=h,r.push(l.uri)>=f.d))break e}}this.g.$onDidChange(s,r)});return new m.$BK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(w,c,s){if(!this.f.has(w))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(w);return await Promise.all(c.map(async a=>{try{const{uri:t,id:r}=a,d=await Promise.resolve(n.provideFileDecoration(I.URI.revive(t),s));if(!d)return;try{m.$WL.validate(d),d.badge&&typeof d.badge!="string"&&(0,P.$yF)(o,"codiconDecoration"),i[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$Jec=y,e.$Jec=y=f=He([Be(0,R.$BM),Be(1,p.$cj)],y),e.$Kec=(0,L.$Uh)("IExtHostDecorations")}),define(ke[318],Se([1,0,212,136,2,6,7,14,4,15,28,57]),function(me,e,I,F,m,L,R,p,E,g,A,P){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=void 0;class y{#e;#t;#i;constructor(c,s,i,n,o,a,t,r){this.d=c,this.e=s,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$zc(d=>a.getComparisonKey(d)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(c,s){if(!c){this.clear();return}this.j();let i=[];if(m.URI.isUri(c)){if(!s){this.delete(c);return}this.#i.set(c,s.slice()),i=[c]}else if(Array.isArray(c)){i=[];let a;c=[...c].sort(y.k);for(const t of c){const[r,d]=t;if((!a||r.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=r,i.push(r),this.#i.set(r,[])),d)this.#i.get(r)?.push(...d);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const a of i){let t=[];const r=this.#i.get(a);if(r)if(r.length>this.g){t=[];const d=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const l of r)if(l.severity===d[u]&&t.push({...p.Diagnostic.from(l),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,I.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(d=>({...p.Diagnostic.from(d),modelVersionId:this.h(a)}));if(n.push([a,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(c){this.j(),this.#t.fire([c]),this.#i.delete(c),this.#e?.$changeMany(this.e,[[c,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(c,s){this.j();for(const[i,n]of this)c.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const c of this.#i.keys())yield[c,this.get(c)]}get(c){this.j();const s=this.#i.get(c);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(c){return this.j(),Array.isArray(this.#i.get(c))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(c,s){return c[0].toString()<s[0].toString()?-1:c[0].toString()>s[0].toString()?1:0}}e.$Adc=y;let S=class{static{f=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*f.d}static _mapper(c){const s=new A.$zc;for(const i of c)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(c,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new E.$Ud({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,f._mapper),this.f=c.getProxy(L.$zK.MainThreadDiagnostics)}createDiagnosticCollection(c,s){const{g:i,f:n,h:o,j:a,k:t,l:r}=this,d=new class{$changeMany(h,k){n.$changeMany(h,k),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,h,k.length===0?"CLEARING":k)}$clear(h){n.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,h)}dispose(){n.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+f.c++,u=s;else if(!i.has(s))u=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+f.c++;while(i.has(u))}return new class extends y{constructor(){super(s,u,f.e,f.d,h=>r.getDocument(h)?.version,t.extUri,d,o),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(c){if(c)return this.m(c);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((o,a)=>{let t=s.get(o.toString());typeof t>"u"&&(t=i.length,s.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(c){let s=[];for(const i of this.g.values())i.has(c)&&(s=s.concat(i.get(c)));return s}$acceptMarkersChange(c){if(!this.n){const s="_generated_mirror",i=new y(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of c)this.n.set(m.URI.revive(s),i.map(p.Diagnostic.to))}};e.$Bdc=S,e.$Bdc=S=f=He([Be(1,g.$cj),Be(2,P.$zdc)],S)}),define(ke[319],Se([1,0,2,6,25]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class L{constructor(p){this.a=p.getProxy(F.$zK.MainThreadDialogs)}showOpenDialog(p,E){return E?.allowUIResources&&(0,m.$yF)(p,"showLocal"),this.a.$showOpenDialog(E).then(g=>g?g.map(A=>I.URI.revive(A)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(E=>E?I.URI.revive(E):void 0)}}e.$Qdc=L}),define(ke[320],Se([1,0,11,2,7,6,17,21,13]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class g{static{this.a=0}constructor(P,f,y){this.d=f,this.e=y,this.b=new Map,this.c=P.getProxy(L.$zK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,f){if(Object.keys(R.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const y=g.a++;this.b.set(y,f),this.c.$registerTextContentProvider(y,P);let S;return typeof f.onDidChange=="function"&&(S=f.onDidChange(w=>{if(w.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this.d.getDocument(w)&&this.$provideTextDocumentContent(y,w).then(c=>{if(!c&&typeof c!="string")return;const s=this.d.getDocument(w);if(!s)return;const i=(0,E.$Se)(c);if(!s.equalLines(i))return this.c.$onVirtualDocumentChange(w,c)},I.$Z)})),new m.$BK(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(P,f){const y=this.b.get(P);return y?Promise.resolve(y.provideTextDocumentContent(F.URI.revive(f),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.$Rdc=g}),define(ke[321],Se([1,0,4,3,2,6,143,14,18,24,7,11]),function(me,e,I,F,m,L,R,p,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class f{constructor(S,w){this.a=new I.$Qd({onListenerError:P.$1}),this.b=new I.$Qd({onListenerError:P.$1}),this.c=new I.$Qd({onListenerError:P.$1}),this.d=new I.$Qd({onListenerError:P.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Qc,this.h=new Map,this.f=S.getProxy(L.$zK.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(c=>{for(const s of c)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const s of c)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const w=this.g.getDocument(S);if(w)return w}getDocument(S){const w=this.getDocumentData(S);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return w.document}ensureDocumentData(S){const w=this.g.getDocument(S);if(w)return Promise.resolve(w);let c=this.h.get(S.toString());return c||(c=this.f.$tryOpenDocument(S).then(s=>{this.h.delete(S.toString());const i=m.URI.revive(s);return(0,E.$Mf)(this.g.getDocument(i))},s=>(this.h.delete(S.toString()),Promise.reject(s))),this.h.set(S.toString(),c)),c}createDocumentData(S){return this.f.$tryCreateDocument(S).then(w=>m.URI.revive(w))}$acceptModelLanguageChanged(S,w){const c=m.URI.revive(S),s=this.g.getDocument(c);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(w),this.a.fire(s.document)}$acceptModelSaved(S){const w=m.URI.revive(S),c=this.g.getDocument(w);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(S,w){const c=m.URI.revive(S),s=this.g.getDocument(c);if(!s)throw new Error("unknown document");s._acceptIsDirty(w),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,w,c){const s=m.URI.revive(S),i=this.g.getDocument(s);if(!i)throw new Error("unknown document");i._acceptIsDirty(c),i.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,g.$an)({document:i.document,contentChanges:w.changes.map(o=>({range:p.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(S,w){(0,R.$DM)(S,w)}}e.$xdc=f}),define(ke[70],Se([1,0,60,4,3,2,5,6,143,20,150,14,15,28,17,51,48]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=void 0;class s{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,a){this.h=o,this.i=a,this.a=null,this.b=new Map,this.c=new y.$zc,this.d=new F.$Qd,this.e=new F.$Qd,this.f=new F.$Qd,this.g=new F.$Qd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const a=[],t=[],r=[];if(o.removedDocuments)for(const d of o.removedDocuments){const u=L.URI.revive(d),l=this.c.get(u);l?.unref()&&(this.c.delete(u),a.push(l.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const u=L.URI.revive(d.uri);let l=this.c.get(u);if(l&&u.scheme!==S.Schemas.vscodeNotebookCell&&u.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);l||(l=new s(new E.$EM(this.h.getProxy(p.$zK.MainThreadDocuments),u,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(u,l),t.push(l.value)),l.ref()}if(o.removedEditors)for(const d of o.removedEditors){const u=this.b.get(d);this.b.delete(d),u&&r.push(u)}if(o.addedEditors)for(const d of o.addedEditors){const u=L.URI.revive(d.documentUri);I.ok(this.c.has(u),`document '${u}' does not exist`),I.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const l=this.c.get(u).value,h=new A.$KM(d.id,this.h.getProxy(p.$zK.MainThreadTextEditors),this.i,new c.$U(()=>l.document),d.selections.map(P.Selection.to),d.options,d.visibleRanges.map(k=>P.Range.to(k)),typeof d.editorPosition=="number"?P.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}o.newActiveEditor!==void 0&&(I.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,m.$Mc)(a),(0,m.$Mc)(r),o.removedDocuments&&this.e.fire(a),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return w.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const a=this.b.get(this.a);return o?a:a?.value}allEditors(){return[...this.b.values()]}};e.$LM=i,e.$LM=i=He([Be(0,g.$BM),Be(1,f.$cj)],i),e.$MM=(0,R.$Uh)("IExtHostDocumentsAndEditors")}),define(ke[71],Se([1,0,74,4,18,2,5,6,20,14,7]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=e.$Oec=void 0,e.$Oec=(0,R.$Uh)("IExtHostEditorTabs");class P{constructor(c,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$gM(L.URI.revive(this.b.input.uri));case 2:return new A.$hM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new A.$iM(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new A.$jM(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$kM(this.b.input.viewType);case 4:return new A.$lM(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$mM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$nM;case 9:return new A.$oM(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$pM(this.b.input.providerId);default:return}}}class f{constructor(c,s){this.c=[],this.d="",this.b=c,this.e=s;for(const i of c.tabs)i.isActive&&(this.d=i.id),this.c.push(new P(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return g.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(i=>i.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const i=new P(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,i),c.tabDto.isActive&&(this.d=i.tabId),i}else if(c.kind===1){const i=this.c.splice(c.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(c.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,i),i}const s=this.c.find(i=>i.tabId===c.tabDto.id);if(!s)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(c.tabDto),s}activeTabId(){return this.d}}let y=class{constructor(c){this.b=new F.$Qd,this.c=new F.$Qd,this.e=[],this.a=c.getProxy(p.$zK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,s={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(i=>i.apiObject))},get activeTabGroup(){const i=c.d;return(0,m.$Mf)(c.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?S(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(c){const s=new Set(this.e.map(d=>d.groupId)),i=new Set(c.map(d=>d.groupId)),n=(0,I.$K)(s,i),o=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),a=[],t=[];this.e=c.map(d=>{const u=new f(d,()=>this.d);return n.added.includes(u.groupId)?a.push(u.apiObject):t.push(u.apiObject),u});const r=(0,m.$Mf)(c.find(d=>d.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:a,closed:o,changed:t}))}$acceptTabGroupUpdate(c){const s=this.e.find(i=>i.groupId===c.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const s=this.e.find(n=>n.groupId===c.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(c){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===c)return i}h(c){return this.e.find(s=>s.apiObject===c)}async i(c,s){const i=[];for(const n of c){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,s)}async j(c,s){const i=[];for(const n of c){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,s)}};e.$Pec=y,e.$Pec=y=He([Be(0,E.$BM)],y);function S(w){return w.tabs!==void 0}}),define(ke[322],Se([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;class m{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$zK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,p,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(R);if(!g)throw new Error("Embedding vector provider not found");const A=await g.provideEmbeddingVector(p,E);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,p,E){const g=this.b;return this.b++,this.a.set(g,E),this.c.$registerAiEmbeddingVectorProvider(p,g),new F.$BK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Bfc=m}),define(ke[323],Se([1,0,2,6,3,7,14,173,13,22,25,81]),function(me,e,I,F,m,L,R,p,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class f{constructor(){this.a=[]}add(w){this.b=void 0,this.a.push(w)}delete(w){const c=this.a.indexOf(w);c>=0&&(this.a.splice(c,1),this.b=void 0)}c(){if(!this.b){const w=this.a.sort(),c=[];let s,i,n=14,o=14;for(const a of w){let t=s?(0,E.$7e)(s,a):0;for(t===0?i=1:i=o;t<a.length;t++)t+1===a.length?(n=o,o=9):o+=1,c.push([i,a.toUpperCase().charCodeAt(t),o]),c.push([i,a.toLowerCase().charCodeAt(t),o]),i=o;s=a,o=n}c.push([9,58,10]),c.push([10,47,12]),this.b=new p.$GZ(c)}}provideDocumentLinks(w){this.c();const c=[],s=p.$HZ.computeLinks({getLineContent(i){return w.lineAt(i-1).text},getLineCount(){return w.lineCount}},this.b);for(const i of s){const n=R.DocumentLink.to(i);n.target&&c.push(n)}return c}}class y{constructor(w,c){this.i=c,this.b=new f,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=w.getProxy(F.$zK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(w,c,s,i={}){if(y.j(s),this.d.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(w,"*",this.b));const n=this.h++;this.b.add(c),this.d.add(c),this.c.set(n,s);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof s.copy=="function"&&(o+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,A.$yF)(w,"fsChunks"),o+=4);let a;i.isReadonly&&(0,P.$0j)(i.isReadonly)&&((0,A.$yF)(w,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,c,o,a).catch(r=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${c}`),console.error(r)});const t=s.onDidChangeFile(r=>{const d=[];for(const u of r){const{uri:l,type:h}=u;if(l.scheme!==c)continue;let k;switch(h){case L.FileChangeType.Changed:k=0;break;case L.FileChangeType.Created:k=1;break;case L.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:l,type:k})}this.a.$onFileSystemChange(n,d)});return(0,m.$Pc)(()=>{t.dispose(),this.b.delete(c),this.d.delete(c),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(w){if(!w)throw new Error("MISSING provider");if(typeof w.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof w.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof w.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof w.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof w.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof w.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof w.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof w.rename!="function")throw new Error("Provider does NOT implement rename")}static k(w){const{type:c,ctime:s,mtime:i,size:n,permissions:o}=w;return{type:c,ctime:s,mtime:i,size:n,permissions:o}}$stat(w,c){return Promise.resolve(this.l(w).stat(I.URI.revive(c))).then(s=>y.k(s))}$readdir(w,c){return Promise.resolve(this.l(w).readDirectory(I.URI.revive(c)))}$readFile(w,c){return Promise.resolve(this.l(w).readFile(I.URI.revive(c))).then(s=>g.$ee.wrap(s))}$writeFile(w,c,s,i){return Promise.resolve(this.l(w).writeFile(I.URI.revive(c),s.buffer,i))}$delete(w,c,s){return Promise.resolve(this.l(w).delete(I.URI.revive(c),s))}$rename(w,c,s,i){return Promise.resolve(this.l(w).rename(I.URI.revive(c),I.URI.revive(s),i))}$copy(w,c,s,i){const n=this.l(w);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(I.URI.revive(c),I.URI.revive(s),i))}$mkdir(w,c){return Promise.resolve(this.l(w).createDirectory(I.URI.revive(c)))}$watch(w,c,s,i){const n=this.l(w).watch(I.URI.revive(s),i);this.f.set(c,n)}$unwatch(w,c){const s=this.f.get(c);s&&(s.dispose(),this.f.delete(c))}$open(w,c,s){const i=this.l(w);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(c),s))}$close(w,c){const s=this.l(w);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(c))}$read(w,c,s,i){const n=this.l(w);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=g.$ee.alloc(i);return Promise.resolve(n.read(c,s,o.buffer,0,i)).then(a=>o.slice(0,a))}$write(w,c,s,i){const n=this.l(w);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(c,s,i.buffer,0,i.byteLength))}l(w){const c=this.c.get(w);if(!c){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return c}}e.$lec=y}),define(ke[72],Se([1,0,6,31,7,22,5,20,57,3,10,23,17]),function(me,e,I,F,m,L,R,p,E,g,A,P,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=void 0;let S=y=class{constructor(c,s){this.b=new Map,this.c=new A.$6g,this.a=c.getProxy(I.$zK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),o=await a.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===F.FilePermission.Readonly?1:void 0}}catch(o){y.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return y.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return y.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return y.e(o)}},async writeFile(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,L.$ee.wrap(o))}catch(a){return y.e(a)}},async delete(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(a){return y.e(a)}},async rename(n,o,a){try{return await i.a.$rename(n,o,{overwrite:!1,...a})}catch(t){return y.e(t)}},async copy(n,o,a){try{return await i.a.$copy(n,o,{overwrite:!1,...a})}catch(t){return y.e(t)}},isWritableFileSystem(n){const o=s.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(c,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await c.stat(i)).type&F.FileType.Directory))throw m.$OL.FileExists(`Unable to create folder '${i.scheme===f.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(F.$tk(o)!==F.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(i)),i=s.dirname(i)}for(let o=n.length-1;o>=0;o--){i=s.joinPath(i,n[o]);try{await c.createDirectory(i)}catch(a){if(F.$tk(a)!==F.FileSystemProviderErrorCode.FileExists)throw a}}}static e(c){if(c instanceof m.$OL)throw c;if(c instanceof F.$pk)switch(c.code){case F.FileSystemProviderErrorCode.FileExists:throw m.$OL.FileExists(c.message);case F.FileSystemProviderErrorCode.FileNotFound:throw m.$OL.FileNotFound(c.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw m.$OL.FileNotADirectory(c.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw m.$OL.FileIsADirectory(c.message);case F.FileSystemProviderErrorCode.NoPermissions:throw m.$OL.NoPermissions(c.message);case F.FileSystemProviderErrorCode.Unavailable:throw m.$OL.Unavailable(c.message);default:throw new m.$OL(c.message,c.name)}if(!(c instanceof Error))throw new m.$OL(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw m.$OL.Unavailable(c.message);switch(c.name){case F.FileSystemProviderErrorCode.FileExists:throw m.$OL.FileExists(c.message);case F.FileSystemProviderErrorCode.FileNotFound:throw m.$OL.FileNotFound(c.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw m.$OL.FileNotADirectory(c.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw m.$OL.FileIsADirectory(c.message);case F.FileSystemProviderErrorCode.NoPermissions:throw m.$OL.NoPermissions(c.message);case F.FileSystemProviderErrorCode.Unavailable:throw m.$OL.Unavailable(c.message);default:throw new m.$OL(c.message,c.name)}}addFileSystemProvider(c,s,i){return this.b.set(c,{impl:s,extUri:i?.isCaseSensitive?P.$og:P.$qg,isReadonly:!!i?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(c))}getFileSystemProviderExtUri(c){return this.b.get(c)?.extUri??P.$og}};e.$4dc=S,e.$4dc=S=y=He([Be(0,p.$BM),Be(1,E.$zdc)],S),e.$5dc=(0,R.$Uh)("IExtHostConsumerFileSystem")}),define(ke[324],Se([1,0,4,34,2,6,14,7,48]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(y,S,w,c,s,i){this.a=Math.random(),this.b=new I.$Qd,this.c=new I.$Qd,this.d=new I.$Qd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,F.$Bj)(s),o=typeof s=="string",a=i?.correlate,t=c(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(a&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const d of r.created){const u=m.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const d of r.changed){const u=m.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const d of r.deleted){const u=m.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=p.$BK.from(this.i(y,w,s,i,i?.correlate),this.b,this.c,this.d,t)}i(y,S,w,c,s){const i=p.$BK.from();if(typeof w=="string")return i;const n=y.getProxy(L.$zK.MainThreadFileSystemEventService);let o=!1;return(w.pattern.includes(F.$xj)||w.pattern.includes(F.$yj))&&(o=!0),n.$watch(S.identifier.value,this.a,w.baseUri,{recursive:o,excludes:c?.excludes??[]},!!s),p.$BK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(y){this.a=y,this.session=this.a.session,this.b=new E.$U(()=>this.a.created.map(m.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(m.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(m.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(y,S,w){this.j=y,this.k=S,this.l=w,this.a=new I.$Qd,this.b=new I.$Qd,this.c=new I.$Qd,this.d=new I.$Qd,this.g=new I.$Sd,this.h=new I.$Sd,this.i=new I.$Sd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(y,S,w,c){return new g(this.j,y,S,this.a.event,R.GlobPattern.from(w),c)}$onFileEvent(y){this.a.fire(new A(y))}$onDidRunFileOperation(y,S){switch(y){case 2:this.b.fire(Object.freeze({files:S.map(w=>({oldUri:m.URI.revive(w.source),newUri:m.URI.revive(w.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(w=>m.URI.revive(w.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(w=>m.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(y){return this.m(y,this.g)}getOnWillCreateFileEvent(y){return this.m(y,this.h)}getOnWillDeleteFileEvent(y){return this.m(y,this.i)}m(y,S){return(w,c,s)=>{const i=function(o){w.call(c,o)};return i.extension=y,S.event(i,void 0,s)}}async $onWillRunFileOperation(y,S,w,c){switch(y){case 2:return await this.n(this.g,{files:S.map(s=>({oldUri:m.URI.revive(s.source),newUri:m.URI.revive(s.target)}))},w,c);case 1:return await this.n(this.i,{files:S.map(s=>m.URI.revive(s.target))},w,c);case 0:case 3:return await this.n(this.h,{files:S.map(s=>m.URI.revive(s.target))},w,c)}}async n(y,S,w,c){const s=new Set,i=[];if(await y.fireAsync(S,c,async(o,a)=>{const t=Date.now(),r=await Promise.resolve(o);r instanceof p.$LK&&(i.push([a.extension,r]),s.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>w&&this.k.warn("SLOW file-participant",a.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:a}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(s)}}}e.$mec=P}),define(ke[325],Se([1,0,3,2,6,14,7,35,10]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;class g{static{this.a=0}constructor(y,S){this.extension=y,this.provider=S,this.handle=g.a++}}class A{constructor(y){this.session=y,this.responses=[]}}class P{static{this.a=0}constructor(y,S,w,c){this.f=w,this.g=c,this.b=new Map,this.d=new Map,this.e=y.getProxy(m.$zK.MainThreadInlineChat),S.registerApiCommand(new p.$2M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$ZM("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?L.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?L.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?L.Position.from(s.position):void 0}})],p.$1M.Void))}registerProvider(y,S,w){const c=new g(y,S);return this.b.set(c.handle,c),this.e.$registerInteractiveEditorProvider(c.handle,w.label,y.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function"),(0,I.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(c.handle),this.b.delete(c.handle)})}async $prepareSession(y,S,w,c){const s=this.b.get(y);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(F.URI.revive(S)),n=L.Selection.to(w),o=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},c);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=P.a++;return this.d.set(a,new A(o)),{id:a,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:L.Range.from(o.wholeRange),message:o.message}}async $provideResponse(y,S,w,c){const s=this.b.get(y);if(!s)return;const i=this.d.get(S.id);if(!i)return;const n={prompt:w.prompt,selection:L.Selection.to(w.selection),wholeRange:L.Range.to(w.wholeRange),attempt:w.attempt,live:w.live};let o=!1;const a={report:async l=>{if(!w.live&&l.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||c.isCancellationRequested||await this.e.$handleProgressChunk(w.requestId,{message:l.message,edits:l.edits?.map(L.TextEdit.from),editsShouldBeInstant:l.editsShouldBeInstant,slashCommand:l.slashCommand?.command,markdownFragment:R.$2K.isMarkdownString(l.content)?l.content.value:l.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,a,c));let r;try{r=await(0,E.$Lg)(t,c)}finally{o=!0}if(!r)return;const d=i.responses.push(r)-1,u={wholeRange:L.Range.from(r.wholeRange),placeholder:r.placeholder};if(P.h(r)){const{edits:l,contents:h}=r,k=h!==void 0?L.MarkdownString.from(h):void 0;return l instanceof R.$LK?{...u,id:d,type:"bulkEdit",edits:L.WorkspaceEdit.from(l),message:k}:{...u,id:d,type:"editorEdit",edits:l.map(L.TextEdit.from),message:k}}return{...u,id:d,type:"message",message:L.MarkdownString.from(r.contents)}}$handleFeedback(y,S,w,c){const s=this.b.get(y),i=this.d.get(S),n=i?.responses[w];if(s&&n){const o=L.InteractiveEditorResponseFeedbackKind.to(c);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(y,S){}static h(y){return typeof y=="object"&&typeof y.edits=="object"}}e.$tfc=P}),define(ke[326],Se([1,0,2,35]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class m{constructor(R,p,E,g,A){this.a=p,this.b=E,this.c=g;const P=new F.$2M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$ZM("showOptions","Show Options",f=>!0,f=>f),new F.$ZM("resource","Interactive resource Uri",f=>!0,f=>f),new F.$ZM("controllerId","Notebook controller Id",f=>!0,f=>f),new F.$ZM("title","Interactive editor title",f=>!0,f=>f)],new F.$1M("Notebook and input URI",f=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const y=this.a.getEditorById(f.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:I.URI.revive(f.notebookUri),inputUri:I.URI.revive(f.inputUri),notebookEditor:y.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:I.URI.revive(f.notebookUri),inputUri:I.URI.revive(f.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(R,p,E,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:E,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(I.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$pfc=m}),define(ke[327],Se([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;class m{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(I.$zK.MainThreadIssueReporter)}async $getIssueReporterUri(R,p){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(R);if(!E)throw new Error("Issue request handler not found");const g=await E.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}async $getIssueReporterData(R,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(R);if(!E)throw new Error("Issue data provider not found");const g=await E.provideIssueData(p);if(!g)throw new Error("Issue data provider returned no result");return g}async $getIssueReporterTemplate(R,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(R);if(!E)throw new Error("Issue data provider not found");const g=await E.provideIssueTemplate(p);if(!g)throw new Error("Issue template provider returned no result");return g}registerIssueUriRequestHandler(R,p){const E=R.identifier.value;return this.a.set(E,p),this.c.$registerIssueUriRequestHandler(E),new F.$BK(()=>{this.c.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}registerIssueDataProvider(R,p){const E=R.identifier.value;return this.b.set(E,p),this.c.$registerIssueDataProvider(E),new F.$BK(()=>{this.c.$unregisterIssueDataProvider(E),this.b.delete(E)})}}e.$vfc=m}),define(ke[328],Se([1,0,3,6]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;class m{constructor(R){this.b=0,this.a=R.getProxy(F.$zK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,R),(0,I.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Iec=m}),define(ke[329],Se([1,0,2,24,14,7,84,6,13,29,19,18,169,21,26,3,132,122,110,37,11,10,25,214]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class d{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentSymbols(B,Q){const se=this.d.getDocument(B),oe=await this.e.provideDocumentSymbols(se,Q);if(!(0,A.$Jb)(oe))return oe[0]instanceof L.$TK?oe.map(m.DocumentSymbol.from):d.f(oe)}static f(B){B=B.slice(0).sort((oe,_)=>{let ge=oe.location.range.start.compareTo(_.location.range.start);return ge===0&&(ge=_.location.range.end.compareTo(oe.location.range.end)),ge});const Q=[],se=[];for(const oe of B){const _={name:oe.name||"!!MISSING: name!!",kind:m.SymbolKind.from(oe.kind),tags:oe.tags?.map(m.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:m.Range.from(oe.location.range),selectionRange:m.Range.from(oe.location.range),children:[]};for(;;){if(se.length===0){se.push(_),Q.push(_);break}const ge=se[se.length-1];if(g.$zs.containsRange(ge.range,_.range)&&!g.$zs.equalsRange(ge.range,_.range)){ge.children?.push(_),se.push(_);break}se.pop()}}return Q}}class u{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,Q,se){this.g=B,this.h=Q,this.j=se,this.e=new i.$wdc("CodeLens"),this.f=new Map}async provideCodeLenses(B,Q){const se=this.g.getDocument(B),oe=await this.j.provideCodeLenses(se,Q);if(!oe||Q.isCancellationRequested)return;const _=this.e.add(oe),ge=new w.$Qc;this.f.set(_,ge);const ye={cacheId:_,lenses:[]};for(let je=0;je<oe.length;je++)ye.lenses.push({cacheId:[_,je],range:m.Range.from(oe[je].range),command:this.h.toInternal(oe[je].command,ge)});return ye}async resolveCodeLens(B,Q){const se=B.cacheId&&this.e.get(...B.cacheId);if(!se)return;let oe;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?oe=se:oe=await this.j.resolveCodeLens(se,Q),oe||(oe=se),Q.isCancellationRequested)return;const _=B.cacheId&&this.f.get(B.cacheId[0]);if(_)return B.command=this.h.toInternal(oe.command??u.d,_),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function l(Pe){return Array.isArray(Pe)?Pe.map(m.DefinitionLink.from):Pe?[m.DefinitionLink.from(Pe)]:[]}class h{constructor(B,Q){this.d=B,this.e=Q}async provideDefinition(B,Q,se){const oe=this.d.getDocument(B),_=m.Position.to(Q),ge=await this.e.provideDefinition(oe,_,se);return l(ge)}}class k{constructor(B,Q){this.d=B,this.e=Q}async provideDeclaration(B,Q,se){const oe=this.d.getDocument(B),_=m.Position.to(Q),ge=await this.e.provideDeclaration(oe,_,se);return l(ge)}}class D{constructor(B,Q){this.d=B,this.e=Q}async provideImplementation(B,Q,se){const oe=this.d.getDocument(B),_=m.Position.to(Q),ge=await this.e.provideImplementation(oe,_,se);return l(ge)}}class ${constructor(B,Q){this.d=B,this.e=Q}async provideTypeDefinition(B,Q,se){const oe=this.d.getDocument(B),_=m.Position.to(Q),ge=await this.e.provideTypeDefinition(oe,_,se);return l(ge)}}class b{constructor(B,Q){this.d=B,this.e=Q}async provideHover(B,Q,se){const oe=this.d.getDocument(B),_=m.Position.to(Q),ge=await this.e.provideHover(oe,_,se);if(!(!ge||(0,A.$Jb)(ge.contents)))return ge.range||(ge.range=oe.getWordRangeAtPosition(_)),ge.range||(ge.range=new L.$DK(_,_)),m.Hover.from(ge)}}class v{constructor(B,Q){this.d=B,this.e=Q}async provideEvaluatableExpression(B,Q,se){const oe=this.d.getDocument(B),_=m.Position.to(Q),ge=await this.e.provideEvaluatableExpression(oe,_,se);if(ge)return m.EvaluatableExpression.from(ge)}}class C{constructor(B,Q){this.d=B,this.e=Q}async provideInlineValues(B,Q,se,oe){const _=this.d.getDocument(B),ge=await this.e.provideInlineValues(_,m.Range.to(Q),m.InlineValueContext.to(se),oe);if(Array.isArray(ge))return ge.map(ye=>m.InlineValue.from(ye))}}class N{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentHighlights(B,Q,se){const oe=this.d.getDocument(B),_=m.Position.to(Q),ge=await this.e.provideDocumentHighlights(oe,_,se);if(Array.isArray(ge))return ge.map(m.DocumentHighlight.from)}}class j{constructor(B,Q){this.d=B,this.e=Q}async provideLinkedEditingRanges(B,Q,se){const oe=this.d.getDocument(B),_=m.Position.to(Q),ge=await this.e.provideLinkedEditingRanges(oe,_,se);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,A.$Gb)(ge.ranges.map(m.Range.from)),wordPattern:ge.wordPattern}}}class M{constructor(B,Q){this.d=B,this.e=Q}async provideReferences(B,Q,se,oe){const _=this.d.getDocument(B),ge=m.Position.to(Q),ye=await this.e.provideReferences(_,ge,se,oe);if(Array.isArray(ye))return ye.map(m.location.from)}}class O{static{this.d=1e3}constructor(B,Q,se,oe,_,ge,ye){this.g=B,this.h=Q,this.j=se,this.k=oe,this.l=_,this.m=ge,this.n=ye,this.e=new i.$wdc("CodeAction"),this.f=new Map}async provideCodeActions(B,Q,se,oe){const _=this.g.getDocument(B),ge=f.$Bs.isISelection(Q)?m.Selection.to(Q):m.Range.to(Q),ye=[];for(const tt of this.j.getDiagnostics(B))if(ge.intersection(tt.range)&&ye.push(tt)>O.d)break;const je={diagnostics:ye,only:se.only?new L.$VK(se.only):void 0,triggerKind:m.CodeActionTriggerKind.to(se.trigger)},We=await this.k.provideCodeActions(_,ge,je,oe);if(!(0,A.$Kb)(We)||oe.isCancellationRequested)return;const _e=this.e.add(We),Ze=new w.$Qc;this.f.set(_e,Ze);const it=[];for(let tt=0;tt<We.length;tt++){const Ae=We[tt];Ae&&(O.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ze)})):(je.only&&(Ae.kind?je.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[_e,tt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ze),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(m.Diagnostic.from),edit:Ae.edit&&m.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$xF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:_e,actions:it}}async resolveCodeAction(B,Q){const[se,oe]=B,_=this.e.get(se,oe);if(!_||O.o(_))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(_,Q)??_;let ye;ge.edit&&(ye=m.WorkspaceEdit.from(ge.edit,void 0));let je;if(ge.command){const We=this.f.get(se);We&&(je=this.h.toInternal(ge.command,We))}return{edit:ye,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,se,oe,_){this.d=B,this.e=Q,this.f=se,this.g=oe,this.h=_}async prepareDocumentPaste(B,Q,se,oe){if(!this.f.prepareDocumentPaste)return;const _=this.e.getDocument(B),ge=Q.map(We=>m.Range.to(We)),ye=m.DataTransfer.toDataTransfer(se,()=>{throw new o.$0});if(await this.f.prepareDocumentPaste(_,ge,ye,oe),oe.isCancellationRequested)return;const je=Array.from(ye).filter(([,We])=>!(We instanceof L.$pL));return m.DataTransfer.from(je)}async providePasteEdits(B,Q,se,oe,_){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(Q),ye=se.map(_e=>m.Range.to(_e)),je=m.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolvePasteFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentPasteEdits(ge,ye,je,_);if(We)return{label:We.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:z.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?m.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class T{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentFormattingEdits(B,Q,se){const oe=this.d.getDocument(B),_=await this.e.provideDocumentFormattingEdits(oe,Q,se);if(Array.isArray(_))return _.map(m.TextEdit.from)}}class W{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeFormattingEdits(B,Q,se,oe){const _=this.d.getDocument(B),ge=m.Range.to(Q),ye=await this.e.provideDocumentRangeFormattingEdits(_,ge,se,oe);if(Array.isArray(ye))return ye.map(m.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Q,se,oe){(0,P.$Lf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const _=this.d.getDocument(B),ge=Q.map(m.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(_,ge,se,oe);if(Array.isArray(ye))return ye.map(m.TextEdit.from)}}class V{constructor(B,Q){this.d=B,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Q,se,oe,_){const ge=this.d.getDocument(B),ye=m.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(ge,ye,se,oe,_);if(Array.isArray(je))return je.map(m.TextEdit.from)}}class de{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$wdc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Q){const se=await this.e.provideWorkspaceSymbols(B,Q);if(!(0,A.$Kb)(se))return{symbols:[]};const oe=this.d.add(se),_={cacheId:oe,symbols:[]};for(let ge=0;ge<se.length;ge++){const ye=se[ge];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}_.symbols.push({...m.WorkspaceSymbol.from(ye),cacheId:[oe,ge]})}return _}async resolveWorkspaceSymbol(B,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const se=this.d.get(...B.cacheId);if(se){const oe=await this.e.resolveWorkspaceSymbol(se,Q);return oe&&(0,F.$cn)(B,m.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class ee{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Q,se){this.d=B,this.e=Q,this.f=se}async provideRenameEdits(B,Q,se,oe){const _=this.d.getDocument(B),ge=m.Position.to(Q);try{const ye=await this.e.provideRenameEdits(_,ge,se,oe);return ye?m.WorkspaceEdit.from(ye):void 0}catch(ye){const je=ee.g(ye);return je?{rejectReason:je,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,Q,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const oe=this.d.getDocument(B),_=m.Position.to(Q);try{const ge=await this.e.prepareRename(oe,_,se);let ye,je;if(L.$DK.isRange(ge)?(ye=ge,je=oe.getText(ge)):(0,P.$Df)(ge)&&(ye=ge.range,je=ge.placeholder),!ye||!je)return;if(ye.start.line>_.line||ye.end.line<_.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:m.Range.from(ye),text:je}}catch(ge){const ye=ee.g(ge);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Z{constructor(B,Q){this.resultId=B,this.tokens=Q}}class J{constructor(B,Q){this.f=B,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Q,se){const oe=this.f.getDocument(B),_=Q!==0?this.d.get(Q):null;let ge=typeof _?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(oe,_.resultId,se):await this.g.provideDocumentSemanticTokens(oe,se);return _&&this.d.delete(Q),ge?(ge=J.h(ge),this.o(J.n(_,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return J.j(B)?J.k(B)?B:new L.$SL(new Uint32Array(B.data),B.resultId):J.l(B)?J.m(B)?B:new L.$UL(B.edits.map(Q=>new L.$TL(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Q of B.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(B,Q){if(!J.j(Q)||!B||!B.tokens)return Q;const se=B.tokens,oe=se.length,_=Q.data,ge=_.length;let ye=0;const je=Math.min(oe,ge);for(;ye<je&&se[ye]===_[ye];)ye++;if(ye===oe&&ye===ge)return new L.$UL([],Q.resultId);let We=0;const _e=je-ye;for(;We<_e&&se[oe-We-1]===_[ge-We-1];)We++;return new L.$UL([{start:ye,deleteCount:oe-ye-We,data:_.subarray(ye,ge-We)}],Q.resultId)}o(B,Q){if(J.j(B)){const se=this.e++;return this.d.set(se,new Z(B.resultId,B.data)),(0,c.$E$)({id:se,type:"full",data:B.data})}if(J.l(B)){const se=this.e++;return J.j(Q)?this.d.set(se,new Z(Q.resultId,Q.data)):this.d.set(se,new Z(B.resultId)),(0,c.$E$)({id:se,type:"delta",deltas:(B.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}class ae{constructor(B,Q){this.d=B,this.e=Q}async provideDocumentRangeSemanticTokens(B,Q,se){const oe=this.d.getDocument(B),_=await this.e.provideDocumentRangeSemanticTokens(oe,m.Range.to(Q),se);return _?this.f(_):null}f(B){return(0,c.$E$)({id:0,type:"full",data:B.data})}}class x{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Q,se,oe,_){this.f=B,this.g=Q,this.h=se,this.j=oe,this.k=_,this.d=new i.$wdc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Q,se,oe){const _=this.f.getDocument(B),ge=m.Position.to(Q),ye=_.getWordRangeAtPosition(ge)||new L.$DK(ge,ge),je=ye.with({end:ge}),We=new n.$Md,_e=await this.h.provideCompletionItems(_,ge,oe,m.CompletionContext.to(se));if(!_e||oe.isCancellationRequested)return;const Ze=Array.isArray(_e)?new L.$9K(_e):_e,it=x.supportsResolving(this.h)?this.d.add(Ze.items):this.d.add([]),tt=new w.$Qc;this.e.set(it,tt);const Ae=[],Oe={x:it,b:Ae,a:{replace:m.Range.from(ye),insert:m.Range.from(je)},c:Ze.isIncomplete||void 0,d:We.elapsed()};for(let qe=0;qe<Ze.items.length;qe++){const Re=Ze.items[qe],Xe=this.l(Re,[it,qe],je,ye);Ae.push(Xe)}return Oe}async resolveCompletionItem(B,Q){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...B);if(!se)return;const oe=this.l(se,B),_=await this.h.resolveCompletionItem(se,Q);if(!_)return;const ge=this.l(_,B);return(oe.h!==ge.h||oe.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(oe.n!==ge.n||oe.o!==ge.o||!(0,F.$dn)(oe.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...oe,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q,se,oe){const _=this.e.get(Q[0]);if(!_)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,_),ye={x:Q,a:B.label,b:B.kind!==void 0?m.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(m.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:m.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(m.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof L.$MK&&(ye.h=B.insertText.value,ye.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),L.$DK.isRange(je)?ye.j=m.Range.from(je):je&&(!se?.isEqual(je.inserting)||!oe?.isEqual(je.replacing))&&(ye.j={insert:m.Range.from(je.inserting),replace:m.Range.from(je.replacing)}),ye}}class Ee{async provideInlineCompletions(B,Q,se,oe){}disposeCompletions(B){}handleDidShowCompletionItem(B,Q,se){}handlePartialAccept(B,Q,se){}}class le extends Ee{constructor(B,Q,se,oe){super(),this.f=B,this.g=Q,this.h=se,this.j=oe,this.d=new K,this.e=(0,t.$xF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$xF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Q,se,oe){const _=this.g.getDocument(B),ge=m.Position.to(Q),ye=await this.h.provideInlineCompletionItems(_,ge,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:m.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},oe);if(!ye||oe.isCancellationRequested)return;const je=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],_e=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ze;return{pid:this.d.createReferenceId({dispose(){Ze?.dispose()},items:je}),items:je.map((tt,Ae)=>{let Oe;tt.command&&(Ze||(Ze=new w.$Qc),Oe=this.j.toInternal(tt.command,Ze));const qe=tt.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:tt.filterText,range:tt.range?m.Range.from(tt.range):void 0,command:Oe,idx:Ae,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:We.map(tt=>(Ze||(Ze=new w.$Qc),this.j.toInternal(tt,Ze))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Q,se){const oe=this.d.get(B)?.items[Q];oe&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(oe,se)}handlePartialAccept(B,Q,se){const oe=this.d.get(B)?.items[Q];oe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(oe,se)}}class K{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Q=this.e++;return this.d.set(Q,B),Q}disposeReferenceId(B){const Q=this.d.get(B);return this.d.delete(B),Q}get(B){return this.d.get(B)}}class U{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$wdc("SignatureHelp")}async provideSignatureHelp(B,Q,se,oe){const _=this.e.getDocument(B),ge=m.Position.to(Q),ye=this.g(se),je=await this.f.provideSignatureHelp(_,ge,oe,ye);if(je){const We=this.d.add([je]);return{...m.SignatureHelp.from(je),id:We}}}g(B){let Q;if(B.activeSignatureHelp){const se=m.SignatureHelp.to(B.activeSignatureHelp),oe=this.d.get(B.activeSignatureHelp.id,0);oe?(Q=oe,Q.activeSignature=se.activeSignature,Q.activeParameter=se.activeParameter):Q=se}return{...B,activeSignatureHelp:Q}}releaseSignatureHelp(B){this.d.delete(B)}}class ne{constructor(B,Q,se,oe,_){this.f=B,this.g=Q,this.h=se,this.j=oe,this.k=_,this.d=new i.$wdc("InlayHints"),this.e=new Map}async provideInlayHints(B,Q,se){const oe=this.f.getDocument(B),_=m.Range.to(Q),ge=await this.h.provideInlayHints(oe,_,se);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Q}`);return}if(se.isCancellationRequested)return;const ye=this.d.add(ge);this.e.set(ye,new w.$Qc);const je={hints:[],cacheId:ye};for(let We=0;We<ge.length;We++)this.l(ge[We],_)&&je.hints.push(this.m(ge[We],[ye,We]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for ${Q}`),je}async resolveInlayHint(B,Q){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...B);if(!se)return;const oe=await this.h.resolveInlayHint(se,Q);if(oe&&this.l(oe))return this.m(oe,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Q&&!Q.contains(B.position))}m(B,Q){const se=this.e.get(Q[0]);if(!se)throw Error("DisposableStore is missing...");const oe={label:"",cacheId:Q,tooltip:m.MarkdownString.fromStrict(B.tooltip),position:m.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(m.TextEdit.from),kind:B.kind&&m.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?oe.label=B.label:oe.label=B.label.map(_=>{const ge={label:_.value};return ge.tooltip=m.MarkdownString.fromStrict(_.tooltip),L.$NK.isLocation(_.location)&&(ge.location=m.location.from(_.location)),_.command&&(ge.command=this.g.toInternal(_.command,se)),ge}),oe}}class be{constructor(B,Q){this.e=B,this.f=Q,this.d=new i.$wdc("DocumentLink")}async provideLinks(B,Q){const se=this.e.getDocument(B),oe=await this.f.provideDocumentLinks(se,Q);if(!(!Array.isArray(oe)||oe.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:oe.filter(be.g).map(m.DocumentLink.from)};{const _=this.d.add(oe),ge={links:[],cacheId:_};for(let ye=0;ye<oe.length;ye++){if(!be.g(oe[ye]))continue;const je=m.DocumentLink.from(oe[ye]);je.cacheId=[_,ye],ge.links.push(je)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Q){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...B);if(!se)return;const oe=await this.f.resolveDocumentLink(se,Q);if(!(!oe||!be.g(oe)))return m.DocumentLink.from(oe)}releaseLinks(B){this.d.delete(B)}}class G{constructor(B,Q){this.d=B,this.e=Q}async provideColors(B,Q){const se=this.d.getDocument(B),oe=await this.e.provideDocumentColors(se,Q);return Array.isArray(oe)?oe.map(ge=>({color:m.Color.from(ge.color),range:m.Range.from(ge.range)})):[]}async provideColorPresentations(B,Q,se){const oe=this.d.getDocument(B),_=m.Range.to(Q.range),ge=m.Color.to(Q.color),ye=await this.e.provideColorPresentations(ge,{document:oe,range:_},se);if(Array.isArray(ye))return ye.map(m.ColorPresentation.from)}}class Y{constructor(B,Q){this.d=B,this.e=Q}async provideFoldingRanges(B,Q,se){const oe=this.d.getDocument(B),_=await this.e.provideFoldingRanges(oe,Q,se);if(Array.isArray(_))return _.map(m.FoldingRange.from)}}class X{constructor(B,Q,se){this.d=B,this.e=Q,this.f=se}async provideSelectionRanges(B,Q,se){const oe=this.d.getDocument(B),_=Q.map(m.Position.to),ge=await this.e.provideSelectionRanges(oe,_,se);if(!(0,A.$Kb)(ge))return[];if(ge.length!==_.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let je=0;je<_.length;je++){const We=[];ye.push(We);let _e=_[je],Ze=ge[je];for(;;){if(!Ze.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(We.push(m.SelectionRange.from(Ze)),!Ze.parent)break;_e=Ze.range,Ze=Ze.parent}}return ye}}class $e{constructor(B,Q){this.f=B,this.g=Q,this.d=new s.$GM(""),this.e=new Map}async prepareSession(B,Q,se){const oe=this.f.getDocument(B),_=m.Position.to(Q),ge=await this.g.prepareCallHierarchy(oe,_,se);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideCallsTo(B,Q,se){const oe=this.j(B,Q);if(!oe)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyIncomingCalls(oe,se);if(_)return _.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(ye=>m.Range.from(ye))}))}async provideCallsFrom(B,Q,se){const oe=this.j(B,Q);if(!oe)throw new Error("missing call hierarchy item");const _=await this.g.provideCallHierarchyOutgoingCalls(oe,se);if(_)return _.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(ye=>m.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,Q){const se=this.e.get(B),oe=m.CallHierarchyItem.from(Q,B,se.size.toString(36));return se.set(oe._itemId,Q),oe}j(B,Q){return this.e.get(B)?.get(Q)}}class re{constructor(B,Q){this.f=B,this.g=Q,this.d=new s.$GM(""),this.e=new Map}async prepareSession(B,Q,se){const oe=this.f.getDocument(B),_=m.Position.to(Q),ge=await this.g.prepareTypeHierarchy(oe,_,se);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(je=>this.h(ye,je)):[this.h(ye,ge)]}async provideSupertypes(B,Q,se){const oe=this.j(B,Q);if(!oe)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySupertypes(oe,se);if(_)return _.map(ge=>this.h(B,ge))}async provideSubtypes(B,Q,se){const oe=this.j(B,Q);if(!oe)throw new Error("missing type hierarchy item");const _=await this.g.provideTypeHierarchySubtypes(oe,se);if(_)return _.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,Q){const se=this.e.get(B),oe=m.TypeHierarchyItem.from(Q,B,se.size.toString(36));return se.set(oe._itemId,Q),oe}j(B,Q){return this.e.get(B)?.get(Q)}}class fe{static toInternalProviderId(B,Q){return B+"."+Q}constructor(B,Q,se,oe,_){this.d=B,this.e=Q,this.f=se,this.g=oe,this.h=_}async provideDocumentOnDropEdits(B,Q,se,oe,_){const ge=this.e.getDocument(Q),ye=m.Position.to(se),je=m.DataTransfer.toDataTransfer(oe,async _e=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,_e)).buffer),We=await this.f.provideDocumentDropEdits(ge,ye,je,_);if(We)return{label:We.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(_e=>"mimeType"in _e?_e:{providerId:fe.toInternalProviderId(_e.extensionId,_e.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?m.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class te{constructor(B,Q){this.d=B,this.e=Q}async provideMappedEdits(B,Q,se,oe){const _=I.URI.revive(B),ge=this.d.getDocument(_),ye=se.documents.map(_e=>_e.map(Ze=>({uri:I.URI.revive(Ze.uri),version:Ze.version,ranges:Ze.ranges.map(it=>m.Range.to(it))}))),je={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,Q,je,oe);return We?m.WorkspaceEdit.from(We):null}}class he{constructor(B,Q){this.adapter=B,this.extension=Q}}class pe{static{this.d=0}constructor(B,Q,se,oe,_,ge,ye,je){this.g=Q,this.h=se,this.j=oe,this.k=_,this.l=ge,this.m=ye,this.n=je,this.f=new Map,this.e=B.getProxy(p.$zK.MainThreadLanguageFeatures)}o(B,Q){return m.DocumentSelector.from(B,this.g,Q)}p(B){return new L.$BK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return pe.d++}async s(B,Q,se,oe,_,ge=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof Q))return oe;const je=Date.now();ge||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const We=se(ye.adapter,ye.extension);return Promise.resolve(We).catch(_e=>{(0,o.$3)(_e)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(ye.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),y.CancellationToken.isCancellationToken(_)?(0,a.$Mg)(We,_):We}t(B,Q){const se=this.q();return this.f.set(se,new he(B,Q)),se}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Q,se,oe){const _=this.t(new d(this.h,se),B),ge=oe&&oe.label||pe.u(B);return this.e.$registerDocumentSymbolProvider(_,this.o(Q,B),ge),this.p(_)}$provideDocumentSymbols(B,Q,se){return this.s(B,d,oe=>oe.provideDocumentSymbols(I.URI.revive(Q),se),void 0,se)}registerCodeLensProvider(B,Q,se){const oe=this.q(),_=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(oe,new he(new u(this.h,this.j.converter,se),B)),this.e.$registerCodeLensSupport(oe,this.o(Q,B),_);let ge=this.p(oe);if(_!==void 0){const ye=se.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(_));ge=L.$BK.from(ge,ye)}return ge}$provideCodeLenses(B,Q,se){return this.s(B,u,oe=>oe.provideCodeLenses(I.URI.revive(Q),se),void 0,se)}$resolveCodeLens(B,Q,se){return this.s(B,u,oe=>oe.resolveCodeLens(Q,se),void 0,void 0)}$releaseCodeLenses(B,Q){this.s(B,u,se=>Promise.resolve(se.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(B,Q,se){const oe=this.t(new h(this.h,se),B);return this.e.$registerDefinitionSupport(oe,this.o(Q,B)),this.p(oe)}$provideDefinition(B,Q,se,oe){return this.s(B,h,_=>_.provideDefinition(I.URI.revive(Q),se,oe),[],oe)}registerDeclarationProvider(B,Q,se){const oe=this.t(new k(this.h,se),B);return this.e.$registerDeclarationSupport(oe,this.o(Q,B)),this.p(oe)}$provideDeclaration(B,Q,se,oe){return this.s(B,k,_=>_.provideDeclaration(I.URI.revive(Q),se,oe),[],oe)}registerImplementationProvider(B,Q,se){const oe=this.t(new D(this.h,se),B);return this.e.$registerImplementationSupport(oe,this.o(Q,B)),this.p(oe)}$provideImplementation(B,Q,se,oe){return this.s(B,D,_=>_.provideImplementation(I.URI.revive(Q),se,oe),[],oe)}registerTypeDefinitionProvider(B,Q,se){const oe=this.t(new $(this.h,se),B);return this.e.$registerTypeDefinitionSupport(oe,this.o(Q,B)),this.p(oe)}$provideTypeDefinition(B,Q,se,oe){return this.s(B,$,_=>_.provideTypeDefinition(I.URI.revive(Q),se,oe),[],oe)}registerHoverProvider(B,Q,se,oe){const _=this.t(new b(this.h,se),B);return this.e.$registerHoverProvider(_,this.o(Q,B)),this.p(_)}$provideHover(B,Q,se,oe){return this.s(B,b,_=>_.provideHover(I.URI.revive(Q),se,oe),void 0,oe)}registerEvaluatableExpressionProvider(B,Q,se,oe){const _=this.t(new v(this.h,se),B);return this.e.$registerEvaluatableExpressionProvider(_,this.o(Q,B)),this.p(_)}$provideEvaluatableExpression(B,Q,se,oe){return this.s(B,v,_=>_.provideEvaluatableExpression(I.URI.revive(Q),se,oe),void 0,oe)}registerInlineValuesProvider(B,Q,se,oe){const _=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new C(this.h,se),B);this.e.$registerInlineValuesProvider(ge,this.o(Q,B),_);let ye=this.p(ge);if(_!==void 0){const je=se.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(_));ye=L.$BK.from(ye,je)}return ye}$provideInlineValues(B,Q,se,oe,_){return this.s(B,C,ge=>ge.provideInlineValues(I.URI.revive(Q),se,oe,_),void 0,_)}registerDocumentHighlightProvider(B,Q,se){const oe=this.t(new N(this.h,se),B);return this.e.$registerDocumentHighlightProvider(oe,this.o(Q,B)),this.p(oe)}$provideDocumentHighlights(B,Q,se,oe){return this.s(B,N,_=>_.provideDocumentHighlights(I.URI.revive(Q),se,oe),void 0,oe)}registerLinkedEditingRangeProvider(B,Q,se){const oe=this.t(new j(this.h,se),B);return this.e.$registerLinkedEditingRangeProvider(oe,this.o(Q,B)),this.p(oe)}$provideLinkedEditingRanges(B,Q,se,oe){return this.s(B,j,async _=>{const ge=await _.provideLinkedEditingRanges(I.URI.revive(Q),se,oe);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?pe.w(ge.wordPattern):void 0}},void 0,oe)}registerReferenceProvider(B,Q,se){const oe=this.t(new M(this.h,se),B);return this.e.$registerReferenceSupport(oe,this.o(Q,B)),this.p(oe)}$provideReferences(B,Q,se,oe,_){return this.s(B,M,ge=>ge.provideReferences(I.URI.revive(Q),se,oe,_),void 0,_)}registerCodeActionProvider(B,Q,se,oe){const _=new w.$Qc,ge=this.t(new O(this.h,this.j.converter,this.k,se,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(ge,this.o(Q,B),{providedKinds:oe?.providedCodeActionKinds?.map(ye=>ye.value),documentation:oe?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,_)}))},pe.u(B),!!se.resolveCodeAction),_.add(this.p(ge)),_}$provideCodeActions(B,Q,se,oe,_){return this.s(B,O,ge=>ge.provideCodeActions(I.URI.revive(Q),se,oe,_),void 0,_)}$resolveCodeAction(B,Q,se){return this.s(B,O,oe=>oe.resolveCodeAction(Q,se),{},void 0)}$releaseCodeActions(B,Q){this.s(B,O,se=>Promise.resolve(se.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Q,se){const oe=this.t(new T(this.h,se),B);return this.e.$registerDocumentFormattingSupport(oe,this.o(Q,B),B.identifier,B.displayName||B.name),this.p(oe)}$provideDocumentFormattingEdits(B,Q,se,oe){return this.s(B,T,_=>_.provideDocumentFormattingEdits(I.URI.revive(Q),se,oe),void 0,oe)}registerDocumentRangeFormattingEditProvider(B,Q,se){const oe=typeof se.provideDocumentRangesFormattingEdits=="function",_=this.t(new W(this.h,se),B);return this.e.$registerRangeFormattingSupport(_,this.o(Q,B),B.identifier,B.displayName||B.name,oe),this.p(_)}$provideDocumentRangeFormattingEdits(B,Q,se,oe,_){return this.s(B,W,ge=>ge.provideDocumentRangeFormattingEdits(I.URI.revive(Q),se,oe,_),void 0,_)}$provideDocumentRangesFormattingEdits(B,Q,se,oe,_){return this.s(B,W,ge=>ge.provideDocumentRangesFormattingEdits(I.URI.revive(Q),se,oe,_),void 0,_)}registerOnTypeFormattingEditProvider(B,Q,se,oe){const _=this.t(new V(this.h,se),B);return this.e.$registerOnTypeFormattingSupport(_,this.o(Q,B),oe,B.identifier),this.p(_)}$provideOnTypeFormattingEdits(B,Q,se,oe,_,ge){return this.s(B,V,ye=>ye.provideOnTypeFormattingEdits(I.URI.revive(Q),se,oe,_,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,Q){const se=this.t(new de(Q,this.l),B);return this.e.$registerNavigateTypeSupport(se,typeof Q.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(B,Q,se){return this.s(B,de,oe=>oe.provideWorkspaceSymbols(Q,se),{symbols:[]},se)}$resolveWorkspaceSymbol(B,Q,se){return this.s(B,de,oe=>oe.resolveWorkspaceSymbol(Q,se),void 0,void 0)}$releaseWorkspaceSymbols(B,Q){this.s(B,de,se=>se.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(B,Q,se){const oe=this.t(new ee(this.h,se,this.l),B);return this.e.$registerRenameSupport(oe,this.o(Q,B),ee.supportsResolving(se)),this.p(oe)}$provideRenameEdits(B,Q,se,oe,_){return this.s(B,ee,ge=>ge.provideRenameEdits(I.URI.revive(Q),se,oe,_),void 0,_)}$resolveRenameLocation(B,Q,se,oe){return this.s(B,ee,_=>_.resolveRenameLocation(I.URI.revive(Q),se,oe),void 0,oe)}registerDocumentSemanticTokensProvider(B,Q,se,oe){const _=this.t(new J(this.h,se),B),ge=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(_,this.o(Q,B),oe,ge);let ye=this.p(_);if(ge){const je=se.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));ye=L.$BK.from(ye,je)}return ye}$provideDocumentSemanticTokens(B,Q,se,oe){return this.s(B,J,_=>_.provideDocumentSemanticTokens(I.URI.revive(Q),se,oe),null,oe)}$releaseDocumentSemanticTokens(B,Q){this.s(B,J,se=>se.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Q,se,oe){const _=this.t(new ae(this.h,se),B);return this.e.$registerDocumentRangeSemanticTokensProvider(_,this.o(Q,B),oe),this.p(_)}$provideDocumentRangeSemanticTokens(B,Q,se,oe){return this.s(B,ae,_=>_.provideDocumentRangeSemanticTokens(I.URI.revive(Q),se,oe),null,oe)}registerCompletionItemProvider(B,Q,se,oe){const _=this.t(new x(this.h,this.j.converter,se,this.m,B),B);return this.e.$registerCompletionsProvider(_,this.o(Q,B),oe,x.supportsResolving(se),B.identifier),this.p(_)}$provideCompletionItems(B,Q,se,oe,_){return this.s(B,x,ge=>ge.provideCompletionItems(I.URI.revive(Q),se,oe,_),void 0,_)}$resolveCompletionItem(B,Q,se){return this.s(B,x,oe=>oe.resolveCompletionItem(Q,se),void 0,se)}$releaseCompletionItems(B,Q){this.s(B,x,se=>se.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(B,Q,se,oe){const _=new le(B,this.h,se,this.j.converter),ge=this.t(_,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(Q,B),_.supportsHandleEvents,S.$$l.toKey(B.identifier.value),oe?.yieldTo?.map(ye=>S.$$l.toKey(ye))||[]),this.p(ge)}$provideInlineCompletions(B,Q,se,oe,_){return this.s(B,Ee,ge=>ge.provideInlineCompletions(I.URI.revive(Q),se,oe,_),void 0,_)}$handleInlineCompletionDidShow(B,Q,se,oe){this.s(B,Ee,async _=>{_.handleDidShowCompletionItem(Q,se,oe)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Q,se,oe){this.s(B,Ee,async _=>{_.handlePartialAccept(Q,se,oe)},void 0,void 0)}$freeInlineCompletionsList(B,Q){this.s(B,Ee,async se=>{se.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(B,Q,se,oe){const _=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ge=this.t(new U(this.h,se),B);return this.e.$registerSignatureHelpProvider(ge,this.o(Q,B),_),this.p(ge)}$provideSignatureHelp(B,Q,se,oe,_){return this.s(B,U,ge=>ge.provideSignatureHelp(I.URI.revive(Q),se,oe,_),void 0,_)}$releaseSignatureHelp(B,Q){this.s(B,U,se=>se.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(B,Q,se){const oe=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,_=this.t(new ne(this.h,this.j.converter,se,this.l,B),B);this.e.$registerInlayHintsProvider(_,this.o(Q,B),typeof se.resolveInlayHint=="function",oe,pe.u(B));let ge=this.p(_);if(oe!==void 0){const ye=se.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(oe));ge=L.$BK.from(ge,ye)}return ge}$provideInlayHints(B,Q,se,oe){return this.s(B,ne,_=>_.provideInlayHints(I.URI.revive(Q),se,oe),void 0,oe)}$resolveInlayHint(B,Q,se){return this.s(B,ne,oe=>oe.resolveInlayHint(Q,se),void 0,se)}$releaseInlayHints(B,Q){this.s(B,ne,se=>se.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(B,Q,se){const oe=this.t(new be(this.h,se),B);return this.e.$registerDocumentLinkProvider(oe,this.o(Q,B),typeof se.resolveDocumentLink=="function"),this.p(oe)}$provideDocumentLinks(B,Q,se){return this.s(B,be,oe=>oe.provideLinks(I.URI.revive(Q),se),void 0,se,Q.scheme==="output")}$resolveDocumentLink(B,Q,se){return this.s(B,be,oe=>oe.resolveLink(Q,se),void 0,void 0,!0)}$releaseDocumentLinks(B,Q){this.s(B,be,se=>se.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(B,Q,se){const oe=this.t(new G(this.h,se),B);return this.e.$registerDocumentColorProvider(oe,this.o(Q,B)),this.p(oe)}$provideDocumentColors(B,Q,se){return this.s(B,G,oe=>oe.provideColors(I.URI.revive(Q),se),[],se)}$provideColorPresentations(B,Q,se,oe){return this.s(B,G,_=>_.provideColorPresentations(I.URI.revive(Q),se,oe),void 0,oe)}registerFoldingRangeProvider(B,Q,se){const oe=this.q(),_=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(oe,new he(new Y(this.h,se),B)),this.e.$registerFoldingRangeProvider(oe,this.o(Q,B),B.identifier,_);let ge=this.p(oe);if(_!==void 0){const ye=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(_));ge=L.$BK.from(ge,ye)}return ge}$provideFoldingRanges(B,Q,se,oe){return this.s(B,Y,_=>_.provideFoldingRanges(I.URI.revive(Q),se,oe),void 0,oe)}registerSelectionRangeProvider(B,Q,se){const oe=this.t(new X(this.h,se,this.l),B);return this.e.$registerSelectionRangeProvider(oe,this.o(Q,B)),this.p(oe)}$provideSelectionRanges(B,Q,se,oe){return this.s(B,X,_=>_.provideSelectionRanges(I.URI.revive(Q),se,oe),[],oe)}registerCallHierarchyProvider(B,Q,se){const oe=this.t(new $e(this.h,se),B);return this.e.$registerCallHierarchyProvider(oe,this.o(Q,B)),this.p(oe)}$prepareCallHierarchy(B,Q,se,oe){return this.s(B,$e,_=>Promise.resolve(_.prepareSession(I.URI.revive(Q),se,oe)),void 0,oe)}$provideCallHierarchyIncomingCalls(B,Q,se,oe){return this.s(B,$e,_=>_.provideCallsTo(Q,se,oe),void 0,oe)}$provideCallHierarchyOutgoingCalls(B,Q,se,oe){return this.s(B,$e,_=>_.provideCallsFrom(Q,se,oe),void 0,oe)}$releaseCallHierarchy(B,Q){this.s(B,$e,se=>Promise.resolve(se.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(B,Q,se){const oe=this.t(new re(this.h,se),B);return this.e.$registerTypeHierarchyProvider(oe,this.o(Q,B)),this.p(oe)}$prepareTypeHierarchy(B,Q,se,oe){return this.s(B,re,_=>Promise.resolve(_.prepareSession(I.URI.revive(Q),se,oe)),void 0,oe)}$provideTypeHierarchySupertypes(B,Q,se,oe){return this.s(B,re,_=>_.provideSupertypes(Q,se,oe),void 0,oe)}$provideTypeHierarchySubtypes(B,Q,se,oe){return this.s(B,re,_=>_.provideSubtypes(Q,se,oe),void 0,oe)}$releaseTypeHierarchy(B,Q){this.s(B,re,se=>Promise.resolve(se.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Q,se,oe){const _=this.q();this.f.set(_,new he(new fe(this.e,this.h,se,_,B),B));const ge=(0,t.$xF)(B,"dropMetadata")&&oe?fe.toInternalProviderId(B.identifier.value,oe.id):void 0;return this.e.$registerDocumentOnDropEditProvider(_,this.o(Q,B),ge,(0,t.$xF)(B,"dropMetadata")?oe:void 0),this.p(_)}$provideDocumentOnDropEdits(B,Q,se,oe,_,ge){return this.s(B,fe,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(Q,I.URI.revive(se),oe,_,ge)),void 0,void 0)}registerMappedEditsProvider(B,Q,se){const oe=this.t(new te(this.h,se),B);return this.e.$registerMappedEditsProvider(oe,this.o(Q,B)),this.p(oe)}$provideMappedEdits(B,Q,se,oe,_){return this.s(B,te,ge=>Promise.resolve(ge.provideMappedEdits(Q,se,oe,_)),null,_)}registerDocumentPasteEditProvider(B,Q,se,oe){const _=this.q();this.f.set(_,new he(new z(this.e,this.h,se,_,B),B));const ge=z.toInternalProviderId(B.identifier.value,oe.id);return this.e.$registerPasteEditProvider(_,this.o(Q,B),ge,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:oe.copyMimeTypes,pasteMimeTypes:oe.pasteMimeTypes}),this.p(_)}$prepareDocumentPaste(B,Q,se,oe,_){return this.s(B,z,ge=>ge.prepareDocumentPaste(I.URI.revive(Q),se,oe,_),void 0,_)}$providePasteEdits(B,Q,se,oe,_,ge){return this.s(B,z,ye=>ye.providePasteEdits(Q,I.URI.revive(se),oe,_,ge),void 0,ge)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:pe.w(B.decreaseIndentPattern),increaseIndentPattern:pe.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?pe.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?pe.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:pe.w(B.beforeText),afterText:B.afterText?pe.w(B.afterText):void 0,previousLineText:B.previousLineText?pe.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(pe.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Q=>L.SyntaxTokenType.toString(Q)):void 0}}static D(B){return B.map(pe.C)}setLanguageConfiguration(B,Q,se){const{wordPattern:oe}=se;if(oe&&(0,E.$Re)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this.h.setWordDefinitionFor(Q,oe):this.h.setWordDefinitionFor(Q,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const _=this.q(),ge={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?pe.w(se.wordPattern):void 0,indentationRules:se.indentationRules?pe.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?pe.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?pe.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(_,Q,ge),this.p(_)}$setWordDefinitions(B){for(const Q of B)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$Fdc=pe}),define(ke[330],Se([1,0,6,14,7,39,10,3,25]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;class g{constructor(P,f,y,S){this.c=f,this.d=y,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(I.$zK.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,f){await this.a.$changeLanguage(P,f);const y=this.c.getDocumentData(P);if(!y)throw new Error(`document '${P.toString()}' NOT found`);return y.document}async tokenAtPosition(P,f){const y=P.version,S=F.Position.from(f),w=await this.a.$tokensAtPosition(P.uri,S),c={type:m.StandardTokenType.Other,range:P.getWordRangeAtPosition(f)??new m.$DK(f.line,f.character,f.line,f.character)};if(!w)return c;const s={range:F.Range.to(w.range),type:F.TokenType.to(w.type)};return!s.range.contains(f)||y!==P.version?c:s}createLanguageStatusItem(P,f,y){const S=this.f++,w=this.a,c=this.g,s=`${P.identifier.value}/${f}`;if(c.has(s))throw new Error(`LanguageStatusItem with id '${f}' ALREADY exists`);c.add(s);const i={selector:y,id:f,name:P.displayName??P.name,severity:m.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new p.$Qc,a=()=>{if(n?.dispose(),!c.has(s)){console.warn(`LanguageStatusItem (${f}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$Yg)(()=>{o.clear(),this.a.$setLanguageStatus(S,{id:s,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===m.LanguageStatusSeverity.Error?L.default.Error:i.severity===m.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),w.$removeLanguageStatus(S),c.delete(s)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,a()},get selector(){return i.selector},set selector(r){i.selector=r,a()},get text(){return i.text},set text(r){i.text=r,a()},set text2(r){(0,E.$yF)(P,"languageStatusText"),i.text=r,a()},get text2(){return(0,E.$yF)(P,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,a()},get severity(){return i.severity},set severity(r){i.severity=r,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,a()},get command(){return i.command},set command(r){i.command=r,a()},get busy(){return i.busy},set busy(r){i.busy=r,a()}};return a(),t}}e.$nec=g}),define(ke[115],Se([1,0,12,13,2,5,15,6,27,20]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=e.$cec=void 0;let A=class{constructor(f,y,S){this.f=S,this.d=new Map,this.a=y.getProxy(p.$zK.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===I.$g}getMessage(f,y){const{message:S,args:w,comment:c}=y;if(this.c)return(0,F.$Ge)(S,w??{});let s=S;c&&c.length>0&&(s+=`/${Array.isArray(c)?c.join(""):c}`);const i=this.d.get(f)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,F.$Ge)(i??S,w??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let y;const S=await this.g(f);if(!S){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const w=await this.a.$fetchBundleContents(S),c=JSON.parse(w);y=f.isBuiltin?c.contents?.bundle:c}catch(w){this.f.error(`Failed to load translations for ${f.identifier.value} from ${S}: ${w.message}`);return}y&&this.d.set(f.identifier.value,{contents:y,uri:S})}async g(f){if(f.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(f.identifier.value,this.b);return m.URI.revive(y)}return f.l10n?m.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$cec=A,e.$cec=A=He([Be(0,E.$RM),Be(1,g.$BM),Be(2,R.$cj)],A),e.$dec=(0,L.$Uh)("IExtHostLocalizationService")}),define(ke[152],Se([1,0,15,6,27,20,2,54]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;let E=class extends I.$nj{constructor(P,f){super(f.logLevel,f.logsLocation,f.loggers.map(y=>(0,p.$rh)(y))),this.r=P.getProxy(F.$zK.MainThreadLogger)}$setLogLevel(P,f){f?this.setLogLevel(R.URI.revive(f),P):this.setLogLevel(P)}setVisibility(P,f){super.setVisibility(P,f),this.r.$setVisibility(P,f)}s(P,f,y){return new g(this.r,P,f,y)}};e.$Ffc=E,e.$Ffc=E=He([Be(0,L.$BM),Be(1,m.$RM)],E);class g extends I.$ij{constructor(P,f,y,S){super(S?.logLevel==="always"),this.r=P,this.s=f,this.m=!1,this.n=[],this.setLevel(y),this.r.$createLogger(f,S).then(()=>{this.u(this.n),this.m=!0})}g(P,f){const y=[[P,f]];this.m?this.u(y):this.n.push(...y)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=e.$eec=void 0,e.$eec=(0,F.$Uh)("IExtHostManagedSockets");let p=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(I.$zK.MainThreadManagedSockets)}setFactory(P,f){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(P,f),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const f=++this.b,y=await this.c.makeConnection(),S=new m.$Qc;return this.d.set(f,new g(f,y,S)),S.add((0,m.$Pc)(()=>this.d.delete(f))),S.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(f),S.dispose()})),S.add(y.onDidClose(w=>{this.a.$onDidManagedSocketClose(f,w?.stack??w?.message),S.dispose()})),S.add(y.onDidReceiveMessage(w=>this.a.$onDidManagedSocketHaveData(f,R.$ee.wrap(w)))),f}$remoteSocketWrite(P,f){this.d.get(P)?.actual.send(f.buffer)}$remoteSocketEnd(P){const f=this.d.get(P);f&&(f.actual.end(),f.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$fec=p,e.$fec=p=He([Be(0,L.$BM)],p);class E{constructor(P,f){this.socketFactoryId=P,this.makeConnection=f}}class g extends m.$Rc{constructor(P,f,y){super(),this.socketId=P,this.actual=f,this.B(y)}}}),define(ke[331],Se([1,0,6,15,25]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;function L(p){return p&&p.title}let R=class{constructor(E,g){this.b=g,this.a=E.getProxy(I.$zK.MainThreadMessageService)}showMessage(E,g,A,P,f){const y={source:{identifier:E.identifier,label:E.displayName||E.name}};let S;typeof P=="string"||L(P)?S=[P,...f]:(y.modal=P?.modal,y.useCustom=P?.useCustom,y.detail=P?.detail,S=f),y.useCustom&&(0,m.$yF)(E,"resolvers");const w=[];for(let c=0;c<S.length;c++){const s=S[c];if(typeof s=="string")w.push({title:s,handle:c,isCloseAffordance:!1});else if(typeof s=="object"){const{title:i,isCloseAffordance:n}=s;w.push({title:i,isCloseAffordance:!!n,handle:c})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(g,A,y,w).then(c=>{if(typeof c=="number")return S[c]})}};e.$oec=R,e.$oec=R=He([Be(1,F.$cj)],R)}),define(ke[332],Se([1,0,19,10,21,4,3,28,2,26,15,6,35,14,7,113,287,25,69]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=e.$kfc=void 0;let n=class{constructor(h,k,D,$,b){this.l=k,this.m=D,this.n=$,this.o=b,this.b=new p.$zc,this.c=new p.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new L.$Qd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=h.getProxy(P.$zK.MainThreadNotebookKernels);const v=new f.$2M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new f.$ZM("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const N=this.m.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:N}}else if(C&&"notebookEditor"in C){const N=this.m.getIdByEditor(C.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return C})],f.$1M.Void);this.n.registerApiCommand(v)}createNotebookController(h,k,D,$,b,v){for(const ae of this.i.values())if(ae.controller.id===k&&g.$$l.equals(h.identifier,ae.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const C=this.j++,N=this;this.o.trace(`NotebookController[${C}], CREATED by ${h.identifier.value}, ${k}`);const j=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${h.identifier}'`);let M=!1;const O=new L.$Qd,z=new L.$Qd,T={id:u(h.identifier,k),notebookType:D,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:$||h.identifier.value,preloads:v?v.map(y.NotebookRendererScript.from):[]};let W=b??j,V;this.a.$addKernel(C,T).catch(ae=>{console.log(ae),M=!0});let de=0;const ee=()=>{if(M)return;const ae=++de;Promise.resolve().then(()=>{ae===de&&this.a.$updateKernel(C,T)})},Z=new p.$zc,J={get id(){return k},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return T.label},set label(ae){T.label=ae??h.displayName??h.name,ee()},get detail(){return T.detail??""},set detail(ae){T.detail=ae,ee()},get description(){return T.description??""},set description(ae){T.description=ae,ee()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(ae){T.supportedLanguages=ae,ee()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){T.supportsExecutionOrder=ae,ee()},get rendererScripts(){return T.preloads?T.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(ae){W=ae??j},get interruptHandler(){return V},set interruptHandler(ae){V=ae,T.supportsInterrupt=!!ae,ee()},createNotebookCellExecution(ae){if(M)throw new Error("notebook controller is DISPOSED");if(!Z.has(ae.notebook.uri))throw N.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return N._createNotebookCellExecution(ae,u(h.identifier,this.id))},createNotebookExecution(ae){if((0,s.$yF)(h,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!Z.has(ae.uri))throw N.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(x=>x.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return N._createNotebookExecution(ae,u(h.identifier,this.id))},dispose:()=>{M||(this.o.trace(`NotebookController[${C}], DISPOSED`),M=!0,this.i.delete(C),O.dispose(),z.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(ae,x){x===S.NotebookControllerAffinity2.Hidden&&(0,s.$yF)(h,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(C,ae.uri,x)},onDidReceiveMessage:z.event,postMessage(ae,x){return(0,s.$yF)(h,"notebookMessaging"),N.a.$postMessage(C,x&&N.m.getIdByEditor(x),ae)},asWebviewUri(ae){return(0,s.$yF)(h,"notebookMessaging"),(0,w.$bub)(ae,N.l.remote)}};return this.i.set(C,{extensionId:h.identifier,controller:J,onDidReceiveMessage:z,onDidChangeSelection:O,associatedNotebooks:Z}),J}getIdByController(h){for(const[k,D]of this.i)if(D.controller===h)return u(D.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,k){const D=this.f++,$=this;this.o.trace(`NotebookControllerDetectionTask[${D}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(D,k);const b={dispose:()=>{this.e.delete(D),$.a.$removeKernelDetectionTask(D)}};return this.e.set(D,b),b}registerKernelSourceActionProvider(h,k,D){const $=this.h++,b=typeof D.onDidChangeNotebookKernelSourceActions=="function"?$:void 0,v=this;this.g.set($,D),this.o.trace(`NotebookKernelSourceActionProvider[${$}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider($,$,k);let C;return b!==void 0&&(C=D.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.g.delete($),v.a.$removeKernelSourceActionProvider($,$),C?.dispose()}}}async $provideKernelSourceActions(h,k){const D=this.g.get(h);if(D){const $=new R.$Qc;return(await D.provideNotebookKernelSourceActions(k)??[]).map(v=>y.NotebookKernelSourceAction.from(v,this.n.converter,$))}return[]}$acceptNotebookAssociation(h,k,D){const $=this.i.get(h);if($){const b=this.m.getNotebookDocument(E.URI.revive(k));D?$.associatedNotebooks.set(b.uri,!0):$.associatedNotebooks.delete(b.uri),this.o.trace(`NotebookController[${h}] ASSOCIATE notebook`,b.uri.toString(),D),$.onDidChangeSelection.fire({selected:D,notebook:b.apiNotebook})}}async $executeCells(h,k,D){const $=this.i.get(h);if(!$)return;const b=this.m.getNotebookDocument(E.URI.revive(k)),v=[];for(const C of D){const N=b.getCell(C);N&&v.push(N.apiCell)}try{this.o.trace(`NotebookController[${h}] EXECUTE cells`,b.uri.toString(),v.length),await $.controller.executeHandler.call($.controller,v,b.apiNotebook,$.controller)}catch(C){this.o.error(`NotebookController[${h}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(h,k,D){const $=this.i.get(h);if(!$)return;const b=this.m.getNotebookDocument(E.URI.revive(k));if($.controller.interruptHandler)await $.controller.interruptHandler.call($.controller,b.apiNotebook);else for(const v of D){const C=b.getCell(v);C&&this.b.get(C.uri)?.cancel()}if($.controller.interruptHandler){const v=this.c.get(b.uri);D.length&&Array.isArray(v)&&v.length&&v.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(h,k,D){const $=this.i.get(h);if(!$)return;const b=this.m.getEditorById(k);$.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:D}))}$cellExecutionChanged(h,k,D){const b=this.m.getNotebookDocument(E.URI.revive(h)).getCell(k);if(b){const v=D?y.NotebookCellExecutionState.to(D):S.NotebookCellExecutionState.Idle;v!==void 0&&this.k.fire({cell:b.apiCell,state:v})}}_createNotebookCellExecution(h,k){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const $=this.m.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!$)throw new Error("invalid cell");if(this.b.has($.uri))throw new Error(`duplicate execution for ${$.uri}`);const b=new a(k,$,this.a);this.b.set($.uri,b);const v=b.onDidChangeState(()=>{b.state===o.Resolved&&(b.dispose(),v.dispose(),this.b.delete($.uri))});return b.asApiObject()}_createNotebookExecution(h,k){const D=this.m.getNotebookDocument(h.uri),$=h.getCells().find(C=>{const N=D.getCellFromApiCell(C);return N&&this.b.has(N.uri)});if($)throw new Error(`duplicate cell execution for ${$.document.uri}`);if(this.c.has(D.uri))throw new Error(`duplicate notebook execution for ${D.uri}`);const b=new r(k,D,this.a),v=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),v.dispose(),this.c.delete(D.uri))});return this.c.set(D.uri,[b,v]),b.asApiObject()}};e.$kfc=n,e.$kfc=n=He([Be(4,A.$cj)],n);var o;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(o||(o={}));class a extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(h,k,D){super(),this.m=k,this.n=D,this.b=a.a++,this.c=new L.$Qd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new m.$1d),this.h=new d(10,$=>this.s($)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const k=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$wv(k))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let k=this.m;if(h&&(k=this.m.notebook.getCellFromApiCell(h)),!k)throw new Error("INVALID cell");return k.handle}y(h){return h.map(k=>{const D=S.$3L.ensureUniqueMimeTypes(k.items,!0);return D===k.items?y.NotebookCellOutput.from(k):y.NotebookCellOutput.from({items:D,id:k.id,metadata:k.metadata})})}async z(h,k,D){const $=this.w(k),b=this.y((0,I.$2b)(h));return this.r({editType:c.CellExecutionUpdateType.Output,cellHandle:$,append:D,outputs:b})}async C(h,k,D){return h=S.$3L.ensureUniqueMimeTypes((0,I.$2b)(h),!0),this.r({editType:c.CellExecutionUpdateType.OutputItems,items:h.map(y.NotebookCellOutputItem.from),outputId:k.id,append:D})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(D){h.j=D,h.s([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(D){if(h.f===o.Resolved||h.f===o.Started)throw new Error("Cannot call start again");h.f=o.Started,h.c.fire(),h.s({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:D})},end(D,$){if(h.f===o.Resolved)throw new Error("Cannot call resolve twice");h.f=o.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$wv({runEndTime:$,lastRunSuccess:D}))},clearOutput(D){return h.t(),h.z([],D,!1)},appendOutput(D,$){return h.t(),h.z(D,$,!0)},replaceOutput(D,$){return h.t(),h.z(D,$,!1)},appendOutputItems(D,$){return h.t(),h.C(D,$,!0)},replaceOutputItems(D,$){return h.t(),h.C(D,$,!1)}})}}var t;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(t||(t={}));class r extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(h,k,D){super(),this.h=k,this.j=D,this.b=r.a++,this.c=new L.$Qd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new m.$1d),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,k){this.e=h,this.f=k,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new F.$hh,this.b=Date.now(),(0,F.$Xg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>h.complete())}}function u(l,h){return`${l.value}/${h}`}e.$lfc=u}),define(ke[333],Se([1,0,4,6,148]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class L{constructor(p,E){this.c=E,this.a=new Map,this.b=p.getProxy(F.$zK.MainThreadNotebookRenderers)}$postRendererMessage(p,E,g){const A=this.c.getEditorById(p);this.a.get(E)?.fire({editor:A.apiEditor,message:g})}createRendererMessaging(p,E){if(!p.contributes?.notebookRenderer?.some(A=>A.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(A,P,f)=>this.d(E).event(A,P,f),postMessage:(A,P)=>{m.$8ec.apiEditorsToExtHost.has(A)&&([A,P]=[P,A]);const f=P&&m.$8ec.apiEditorsToExtHost.get(P);return this.b.$postMessage(f?.id,E,A)}}}d(p){let E=this.a.get(p);return E||(E=new I.$Qd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(p)}}),this.a.set(p,E),E)}}e.$mfc=L}),define(ke[334],Se([1,0,3,18,2,25,6]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class p{constructor(g){this.b=new Map,this.a=g.getProxy(R.$zK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,A,P){if((0,L.$yF)(g,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,P),this.a.$registerProfileContentHandler(A,P.name,P.description,g.identifier.value),(0,I.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(g,A,P,f){const y=this.b.get(g);if(!y)throw new Error(`Unknown handler with id: ${g}`);return y.saveProfile(A,P,f)}async $readProfile(g,A,P){const f=this.b.get(g);if(!f)throw new Error(`Unknown handler with id: ${g}`);return f.readProfile((0,F.$Bf)(A)?A:m.URI.revive(A),P)}}e.$qfc=p}),define(ke[335],Se([1,0,2,6,10,14]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class R{static{this.a=0}constructor(E,g){this.d=g,this.c=new Map,this.b=E.getProxy(F.$zK.MainThreadQuickDiff)}$provideOriginalResource(E,g,A){const P=I.URI.revive(g),f=this.c.get(E);return f?(0,m.$Pg)(()=>f.provideOriginalResource(P,A)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(E,g,A,P){const f=R.a++;return this.c.set(f,g),this.b.$registerQuickDiffProvider(f,L.DocumentSelector.from(E,this.d),A,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(f),this.c.delete(f)}}}}e.$rfc=R}),define(ke[336],Se([1,0,21,4,3,6,2,7,11,19,39,61,25,14]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;function S(w,c,s){const i=w.getProxy(L.$zK.MainThreadQuickOpen);class n{constructor(k,D){this.e=new Map,this.f=0,this.a=k,this.b=D}showQuickPick(k,D,$,b=I.CancellationToken.None){this.c=void 0;const v=Promise.resolve(D),C=++this.f,N=i.$show(C,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},b),j={},M=N.then(()=>j);return Promise.race([M,v]).then(O=>{if(O===j)return;const z=(0,f.$xF)(k,"quickPickItemTooltip");return v.then(T=>{const W=[];for(let V=0;V<T.length;V++){const de=T[V];if(typeof de=="string")W.push({label:de,handle:V});else if(de.kind===p.QuickPickItemKind.Separator)W.push({type:"separator",label:de.label});else{de.tooltip&&!z&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const ee=de.iconPath?d(de.iconPath):void 0;W.push({label:de.label,iconPath:ee?.iconPath,iconClass:ee?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:z?y.MarkdownString.fromStrict(de.tooltip):void 0,handle:V})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=V=>{$.onDidSelectItem(T[V])}),i.$setItems(C,W),N.then(V=>{if(typeof V=="number")return T[V];if(Array.isArray(V))return V.map(de=>T[de])})})}).then(void 0,O=>{if(!(0,E.$3)(O))return i.$setError(C,O),Promise.reject(O)})}$onItemSelected(k){this.c?.(k)}showInput(k,D=I.CancellationToken.None){return this.d=k?.validateInput,i.$input(k,typeof this.d=="function",D).then(void 0,$=>{if(!(0,E.$3)($))return Promise.reject($)})}async $validateInput(k){if(!this.d)return;const D=await this.d(k);if(!D||typeof D=="string")return D;let $;switch(D.severity){case p.InputBoxValidationSeverity.Info:$=A.default.Info;break;case p.InputBoxValidationSeverity.Warning:$=A.default.Warning;break;case p.InputBoxValidationSeverity.Error:$=A.default.Error;break;default:$=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:$}}async showWorkspaceFolderPick(k,D=I.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!$)return;const b=await this.a.getWorkspaceFolders2();if(b)return b.find(v=>v.uri.toString()===$.uri.toString())}createQuickPick(k){const D=new u(k,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(k){const D=new l(k,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(k,D){this.e.get(k)?._fireDidChangeValue(D)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,D){const $=this.e.get(k);$ instanceof u&&$._fireDidChangeActive(D)}$onDidChangeSelection(k,D){const $=this.e.get(k);$ instanceof u&&$._fireDidChangeSelection(D)}$onDidTriggerButton(k,D){this.e.get(k)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(k,D,$){const b=this.e.get(k);b instanceof u&&b._fireDidTriggerItemButton(D,$)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class o{static{this.a=1}constructor(k,D){this.x=k,this.y=D,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Qd,this.q=new F.$Qd,this.r=new F.$Qd,this.s=new F.$Qd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((D,$)=>{const b=D===p.$VL.Back?-1:$;this.o.set(b,D)}),this.z({buttons:k.map((D,$)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===p.$VL.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const D=this.o.get(k);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,m.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(k){if(!this.v){for(const D of Object.keys(k)){const $=k[D];this.u[D]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(h){if(h instanceof p.$vL)return{id:h.id};const k=r(h),D=t(h);return{dark:typeof k=="string"?R.URI.file(k):k,light:typeof D=="string"?R.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function r(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const k=a(h);let D,$;return"id"in k?$=P.ThemeIcon.asClassName(k):D=k,{iconPath:D,iconClass:$}}class u extends o{constructor(k,D){super(k.identifier,D),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Qd,this.L=[],this.M=new F.$Qd,this.N=new F.$Qd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((b,v)=>{this.C.set(v,b),this.D.set(b,v)});const D=(0,f.$xF)(this.O,"quickPickItemTooltip"),$=[];for(let b=0;b<k.length;b++){const v=k[b];if(v.kind===p.QuickPickItemKind.Separator)$.push({type:"separator",label:v.label});else{v.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=v.iconPath?d(v.iconPath):void 0;$.push({handle:b,label:v.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:D?y.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((N,j)=>({...d(N.iconPath),tooltip:N.tooltip,handle:j}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(k){const D=(0,g.$Gb)(k.map($=>this.C.get($)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(k){const D=(0,g.$Gb)(k.map($=>this.C.get($)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(k,D){const $=this.C.get(k);if(!$||!$.buttons||!$.buttons.length)return;const b=$.buttons[D];b&&this.N.fire({button:b,item:$})}}class l extends o{constructor(k,D){super(k.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:A.default.Error}):this.z({validationMessage:k.message,severity:k.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(c,s)}e.$sec=S}),define(ke[337],Se([1,0,2,4,59,3,10,6,19,129,15,26,61,14,25,17]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=void 0;function s(v){if(v)return typeof v.iconPath=="string"?I.URI.file(v.iconPath):I.URI.isUri(v.iconPath)||f.ThemeIcon.isThemeIcon(v.iconPath)?v.iconPath:void 0}function i(v){if(v?.icon){if(I.URI.isUri(v.icon))return v.icon;if(f.ThemeIcon.isThemeIcon(v.icon))return v.icon;{const C=v.icon;return{light:C.light,dark:C.dark}}}else return}function n(v){if(v.icon){if(I.URI.isUri(v.icon))return v.icon;if(f.ThemeIcon.isThemeIcon(v.icon))return v.icon;{const C=v.icon;return{light:C.light,dark:C.dark}}}else return}function o(v,C){if(!v.iconPath&&!C.iconPath)return 0;if(v.iconPath){if(!C.iconPath)return 1}else return-1;const N=typeof v.iconPath=="string"?v.iconPath:I.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id,j=typeof C.iconPath=="string"?C.iconPath:I.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,g.$wq)(N,j)}function a(v,C){let N=0;if(v.strikeThrough!==C.strikeThrough)return v.strikeThrough?1:-1;if(v.faded!==C.faded)return v.faded?1:-1;if(v.tooltip!==C.tooltip)return(v.tooltip||"").localeCompare(C.tooltip||"");if(N=o(v,C),N!==0)return N;if(v.light&&C.light)N=o(v.light,C.light);else{if(v.light)return 1;if(C.light)return-1}if(N!==0)return N;if(v.dark&&C.dark)N=o(v.dark,C.dark);else{if(v.dark)return 1;if(C.dark)return-1}return N}function t(v,C){if(v.command!==C.command)return v.command<C.command?-1:1;if(v.title!==C.title)return v.title<C.title?-1:1;if(v.tooltip!==C.tooltip){if(v.tooltip!==void 0&&C.tooltip!==void 0)return v.tooltip<C.tooltip?-1:1;if(v.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(v.arguments===C.arguments)return 0;if(v.arguments)if(C.arguments){if(v.arguments.length!==C.arguments.length)return v.arguments.length-C.arguments.length}else return 1;else return-1;for(let N=0;N<v.arguments.length;N++){const j=v.arguments[N],M=C.arguments[N];if(j!==M)return j<M?-1:1}return 0}function r(v,C){let N=(0,g.$wq)(v.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(N!==0)return N;if(v.command&&C.command)N=t(v.command,C.command);else{if(v.command)return 1;if(C.command)return-1}if(N!==0)return N;if(v.decorations&&C.decorations)N=a(v.decorations,C.decorations);else{if(v.decorations)return 1;if(C.decorations)return-1}return N}function d(v,C){for(let N=0;N<v.length;N++)if(v[N]!==C[N])return!1;return!0}function u(v,C){return v.command===C.command&&v.title===C.title&&v.tooltip===C.tooltip&&(v.arguments&&C.arguments?d(v.arguments,C.arguments):v.arguments===C.arguments)}function l(v,C){return(0,E.$tb)(v,C,u)}function h(v,C){return v===C?!0:!v||!C?!1:v.id===C.id&&v.label===C.label&&v.upstream?.id===C.upstream?.id&&v.upstream?.label===C.upstream?.label}class k{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,S.$yF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,S.$yF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,S.$yF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,S.$yF)(this.m,"scmInputBoxActionButton"),this.l.value=new L.$Qc,this.k=C;const N=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:i(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,N??null)}get document(){return(0,S.$yF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,N,j,M,O,z){this.m=C,this.n=N,this.o=O,this.p=z,this.d="",this.e=new F.$Qd,this.f="",this.h=!0,this.j=!0,this.l=new L.$Sc,this.#t=j,this.#e=M}showValidationMessage(C,N){(0,S.$yF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,N)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$tec=k;class D{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,N,j,M,O){this.q=C,this.s=N,this.t=j,this.u=M,this.v=O,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Qd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Qd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=D.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,N){const j=this.h.get(C);return j?(0,R.$Pg)(()=>this.s.executeCommand(j.command,...j.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(r),j=(0,E.$Cb)(this.o,C,r).map(z=>{const T=z.toInsert.map(W=>{const V=this.e++;this.g.set(V,W);const de=W.resourceUri;let ee;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const be=new L.$Qc;ee=this.s.converter.toInternal(W.command,be),this.j.set(V,be)}else this.h.set(V,W.command);const Z=s(W.decorations),J=W.decorations&&s(W.decorations.light)||Z,ae=W.decorations&&s(W.decorations.dark)||Z,x=[J,ae],Ee=W.decorations&&W.decorations.tooltip||"",le=W.decorations&&!!W.decorations.strikeThrough,K=W.decorations&&!!W.decorations.faded,U=W.contextValue||"";return{rawResource:[V,de,x,Ee,le,K,U,ee],handle:V}});return{start:z.start,deleteCount:z.deleteCount,toInsert:T}}),M=j.map(({start:z,deleteCount:T,toInsert:W})=>[z,T,W.map(V=>V.rawResource)]),O=j.reverse();for(const{start:z,deleteCount:T,toInsert:W}of O){const V=W.map(ee=>ee.handle),de=this.n.splice(z,T,...V);for(const ee of de)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=C,M}dispose(){this.l=!0,this.m.fire()}}class ${static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let N;(0,S.$xF)(this.y,"quickDiffProvider")&&(N=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:N})}get historyProvider(){return(0,S.$yF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,S.$yF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new L.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{h(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,S.$yF)(this.y,"scmActionButton"),this.m.value=new L.$Qc;const N=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,N??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new L.$Qc,this.p=C;const N=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:N})}get actionButton(){return(0,S.$yF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,S.$yF)(this.y,"scmActionButton"),this.q.value=new L.$Qc,this.s=C;const N=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(j=>j.map(M=>this.z.converter.toInternal(M,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:N??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&l(this.u,C))return;this.t.value=new L.$Qc,this.u=C;const N=(C||[]).map(j=>this.z.converter.toInternal(j,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:N})}get selected(){return this.v}constructor(C,N,j,M,O,z,T){this.y=C,this.z=M,this.A=O,this.B=z,this.C=T,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Sc,this.m=new L.$Sc,this.n=void 0,this.o=new L.$Sc,this.p=void 0,this.q=new L.$Sc,this.t=new L.$Sc,this.u=void 0,this.v=!1,this.w=new F.$Qd,this.onDidChangeSelection=this.w.event,this.x=$.d++,this.D=new Map,this.E=new Set,this.#e=j;const W=I.URI.from({scheme:w.Schemas.vscodeSourceControl,path:`${O}/scm${this.x}/input`,query:T?`rootUri=${encodeURIComponent(T.toString())}`:void 0});this.f=new k(C,M,N,this.#e,this.x,W),this.#e.$registerSourceControl(this.x,O,z,T,W)}createResourceGroup(C,N){const j=new D(this.#e,this.z,this.x,C,N),M=F.Event.once(j.onDidDispose)(()=>this.D.delete(j));return this.D.set(j,M),this.eventuallyAddResourceGroups(),j}eventuallyAddResourceGroups(){const C=[],N=[];for(const[j,M]of this.D){M.dispose();const O=j.onDidUpdateResourceStates(()=>{this.E.add(j),this.eventuallyUpdateResourceStates()});F.Event.once(j.onDidDispose)(()=>{this.E.delete(j),O.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.x,j.handle)}),C.push([j.handle,j.id,j.label,j.features]);const z=j._takeResourceStateSnapshot();z.length>0&&N.push([j.handle,z]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.x,C,N),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(N=>{const j=N._takeResourceStateSnapshot();j.length!==0&&C.push([N.handle,j])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,m.$nh)(100)],$.prototype,"eventuallyAddResourceGroups",null),He([(0,m.$nh)(100)],$.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{c=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,N,j,M){this.l=N,this.m=j,this.n=M,this.g=new Map,this.h=new P.$am,this.j=new F.$Qd,this.e=C.getProxy(p.$zK.MainThreadSCM),this.f=C.getProxy(p.$zK.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===3){const z=this.g.get(O.sourceControlHandle);if(!z)return O;const T=z.getResourceGroup(O.groupHandle);return T?T.getResourceState(O.handle):O}else if(O&&O.$mid===4){const z=this.g.get(O.sourceControlHandle);return z?z.getResourceGroup(O.groupHandle):O}else if(O&&O.$mid===5){const z=this.g.get(O.handle);return z||O}return O}})}createSourceControl(C,N,j,M){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,N,j,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const O=c.d++,z=new $(C,this.m,this.e,this.l,N,j,M);this.g.set(O,z);const T=this.h.get(C.identifier)||[];return T.push(z),this.h.set(C.identifier,T),z}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const N=this.h.get(C.identifier),j=N&&N[N.length-1];return j&&j.inputBox}$provideOriginalResource(C,N,j){const M=I.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",C,M.toString());const O=this.g.get(C);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Pg)(()=>O.quickDiffProvider.provideOriginalResource(M,j)).then(z=>z||null)}$onInputBoxValueChange(C,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const j=this.g.get(C);return j&&j.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(C,N,j,M){this.n.trace("ExtHostSCM#$executeResourceCommand",C,N,j);const O=this.g.get(C);if(!O)return Promise.resolve(void 0);const z=O.getResourceGroup(N);return z?z.$executeResourceCommand(j,M):Promise.resolve(void 0)}$validateInput(C,N,j){this.n.trace("ExtHostSCM#$validateInput",C);const M=this.g.get(C);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Pg)(()=>M.inputBox.validateInput(N,j)).then(O=>{if(!O)return Promise.resolve(void 0);const z=y.MarkdownString.fromStrict(O.message);return z?Promise.resolve([z,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,N,j){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupBase(N,j)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,N,j,M){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,j,M)??void 0}async $provideHistoryItems(C,N,j,M){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(N,j,M))?.map(T=>({...T,icon:n(T)}))??void 0}async $provideHistoryItemChanges(C,N,j){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(N,j)??void 0}};e.$uec=b,e.$uec=b=c=He([Be(3,A.$cj)],b)}),define(ke[117],Se([1,0,6,4,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=void 0;class L{constructor(p){this.b=new F.$Qd,this.onDidChangePassword=this.b.event,this.a=p.getProxy(I.$zK.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,E){return this.a.$getPassword(p,E)}store(p,E,g){return this.a.$setPassword(p,E,g)}delete(p,E){return this.a.$deletePassword(p,E)}}e.$_dc=L,e.$aec=(0,m.$Uh)("IExtHostSecretState")}),define(ke[338],Se([1,0,6,14,2]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class L{static{this.a=0}constructor(p,E){this.d=E,this.c=new Map,this.b=p.getProxy(I.$zK.MainThreadShare)}async $provideShare(p,E,g){return await this.c.get(p)?.provideShare({selection:F.Range.to(E.selection),resourceUri:m.URI.revive(E.resourceUri)},g)??void 0}registerShareProvider(p,E){const g=L.a++;return this.c.set(g,E),this.b.$registerShareProvider(g,F.DocumentSelector.from(p,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$wfc=L}),define(ke[339],Se([1,0,21,3,6]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;class L{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(m.$zK.MainThreadSpeech)}async $createSpeechToTextSession(p,E){const g=this.c.get(p);if(!g)return;const A=new F.$Qc,P=new I.$1d;this.d.set(E,P);const f=A.add(g.provideSpeechToTextSession(P.token));A.add(f.onDidChange(y=>{P.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,y)})),A.add(P.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,E,g){const A=L.a++;return this.c.set(A,g),this.b.$registerProvider(A,E,{extension:p,displayName:p.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$yfc=L}),define(ke[340],Se([1,0,7,6,218,3,14,18]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$wL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$wL("statusBarItem.warningForeground")]])}#e;#t;constructor(f,y,S,w,c,s=I.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new L.$Qc,this.#e=f,this.#t=y,c&&w){this.c=(0,I.$_K)(w.identifier,c);const n=S.get(this.c);n&&(s=n.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(E.a++);this.e=w,this.f=c,this.g=s,this.h=this.u(i)}u(f){if((0,p.$Ff)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(f){this.k=f,this.v()}set name(f){this.m=f,this.v()}set tooltip(f){this.l=f,this.v()}set color(f){this.n=f,this.v()}set backgroundColor(f){f&&!E.b.has(f.id)&&(f=void 0),this.o=f,this.v()}set command(f){this.r?.fromApi!==f&&(this.p&&this.q.add(this.p),this.p=new L.$Qc,typeof f=="string"?this.r={fromApi:f,internal:this.#t.toInternal({title:"",command:f},this.p)}:f?this.r={fromApi:f,internal:this.#t.toInternal(f,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(f){this.t=f,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let f;this.e?this.f?f=`${this.e.identifier.value}.${this.f}`:f=this.e.identifier.value:f=this.f;let y;this.m?y=this.m:y=(0,m.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=E.b.get(this.o.id));const w=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,f,this.e?.identifier.value,y,this.k,w,this.r?.internal,S,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$vec=E;class g{constructor(f){this.b=[],this.a=f.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,m.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(f){const y={message:f};return this.b.unshift(y),this.c(),new I.$BK(()=>{const S=this.b.indexOf(y);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(f,y){this.e=new Map,this.a=f.getProxy(F.$zK.MainThreadStatusBar),this.b=y,this.c=new g(this)}$acceptStaticEntries(f){for(const y of f)this.e.set(y.entryId,y)}createStatusBarEntry(f,y,S,w){return new E(this.a,this.b,this.e,f,y,S,w)}setStatusBarMessage(f,y){const S=this.c.setMessage(f);let w;return typeof y=="number"?w=setTimeout(()=>S.dispose(),y):typeof y<"u"&&y.then(()=>S.dispose(),()=>S.dispose()),new I.$BK(()=>{S.dispose(),clearTimeout(w)})}}e.$wec=A}),define(ke[118],Se([1,0,6,4,5]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=void 0;class L{constructor(p,E){this.c=E,this.b=new F.$Qd,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(I.$zK.MainThreadStorage)}registerExtensionStorageKeysToSync(p,E){this.a.$registerExtensionStorageKeysToSync(p,E)}async initializeExtensionStorage(p,E,g){const A=await this.a.$initializeExtensionStorage(p,E);let P;return A&&(P=this.d(p,E,A)),P||g}setValue(p,E,g){return this.a.$setValue(p,E,g)}$acceptValue(p,E,g){const A=this.d(p,E,g);A&&this.b.fire({shared:p,key:E,value:A})}d(p,E,g){try{return JSON.parse(g)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${p}): ${A}`)}}}e.$Zdc=L,e.$1dc=(0,m.$Uh)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,15,72,2]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=void 0,e.$6dc=(0,I.$Uh)("IExtensionStoragePaths");let p=class{constructor(g,A,P){this.d=A,this.f=P,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(g){return R.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,A=await this.g(g);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(g){if(this.c)return R.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return R.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$7dc=p,e.$7dc=p=He([Be(0,F.$RM),Be(1,m.$cj),Be(2,L.$5dc)],p)}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,220,11,264,21,32,265,61,10,14,35]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=e.$0dc=e.$9dc=e.$8dc=void 0,e.$8dc=(0,m.$Uh)("IExtHostTerminalService");class n{constructor($,b,v,C){this.l=$,this._id=b,this.m=v,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(j=>this.f=j);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(j,M=!0){N.q(),N.l.$sendText(N._id,j,M)},show(j){N.q(),N.l.$show(N._id,j)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create($,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??b?.cwd??void 0,env:$.env??void 0,icon:l($.iconPath)??void 0,color:w.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.o($.location,b?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,b,v,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:v,color:w.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o($,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,b){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in $?{viewColumn:s.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,b){this.h=Object.freeze({code:$,reason:b})}setDimensions($,b){return $===this.d&&b===this.g||$===0||b===0?!1:(this.d=$,this.g=b,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(b=>{b!==$&&(this.b=Promise.resolve($))})}}e.$9dc=n;class o{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new I.$Qd,this.onProcessData=this.a.event,this.b=new I.$Qd,this.d=new I.$Qd,this.onDidChangeProperty=this.d.event,this.f=new I.$Qd,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,b){this.g.setDimensions?.({columns:$,rows:b})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:"overrideDimensions",value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:"title",value:b})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends p.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,b,v){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$Qd,this.onDidCloseTerminal=this.H.event,this.I=new I.$Qd,this.onDidOpenTerminal=this.I.event,this.J=new I.$Qd,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$Qd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$Qd,this.onDidChangeTerminalState=this.M.event,this.N=new I.$Qd,this.onDidChangeShell=this.N.event,this.O=new I.$Qd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$Qd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=v.getProxy(F.$zK.MainThreadTerminalService),this.y=new S.$qqb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:C=>{const N=j=>{const M=j;return this.W(M.instanceId)?.value};switch(C?.$mid){case 15:return N(C);default:{if(Array.isArray(C))for(let j=0;j<C.length&&C[j].$mid===15;j++)C[j]=N(C[j]);return C}}}}),this.B({dispose:()=>{for(const[C,N]of this.g)N.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,b){const v=new n(this.a,(0,y.$hg)(),$,$.name),C=new o($.pty);return v.createExtensionTerminal($.location,this.R($,b).resolvedExtHostIdentifier,l($.iconPath),h($.color)).then(N=>{const j=this.S(N,C);this.h[N]=j}),this.f.push(v),v.value}R($,b){if(b=b||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const v=$.location.parentTerminal;if(v){const C=this.f.find(N=>N.value===v);C&&(b.resolvedExtHostIdentifier=C._id)}}else $.location&&typeof $.location!="object"?b.location=$.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal($,b){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const C=new o(b),N=this.S($,C);this.h[$]=N}async $acceptActiveTerminalChanged($){const b=this.b;if($===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const v=this.W($);v&&(this.b=v,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,b){const v=this.W($);v&&this.O.fire({terminal:v.value,data:b})}async $acceptTerminalDimensions($,b,v){const C=this.W($);C&&C.setDimensions(b,v)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand($,b){const v=this.W($);v&&this.P.fire({terminal:v.value,...b})}async $acceptTerminalMaximumDimensions($,b,v){this.g.get($)?.resize(b,v)}async $acceptTerminalTitleChange($,b){const v=this.W($);v&&(v.name=b)}async $acceptTerminalClosed($,b,v){const C=this.Y(this.f,$);if(C!==null){const N=this.f.splice(C,1)[0];N.setExitStatus(b,v),this.H.fire(N.value)}}$acceptTerminalOpened($,b,v,C){if(b){const M=this.Y(this.f,b);if(M!==null){this.f[M]._id=$,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const N={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:L.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},j=new n(this.a,$,N,v);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId($,b){this.W($)?._setProcessId(b)}async $startExtensionTerminal($,b){const v=this.W($);if(!v)return{message:(0,g.localize)(0,null,$)};v.isOpen||await new Promise(N=>{const j=this.onDidOpenTerminal(async M=>{M===v.value&&(j.dispose(),N())})});const C=this.g.get($);C?C.startSendingEvents(b):this.j[$]={initialDimensions:b}}S($,b){const v=new p.$Qc;v.add(b.onProcessReady(N=>this.a.$sendProcessReady($,N.pid,N.cwd,N.windowsPty))),v.add(b.onDidChangeProperty(N=>this.a.$sendProcessProperty($,N))),this.y.startBuffering($,b.onProcessData),v.add(b.onProcessExit(N=>this.U($,N))),this.g.set($,b);const C=this.j[$];return C&&b instanceof o&&(b.startSendingEvents(C.initialDimensions),delete this.j[$]),v}$acceptProcessAckDataEvent($,b){this.g.get($)?.acknowledgeDataEvent(b)}$acceptProcessInput($,b){this.g.get($)?.input(b)}$acceptTerminalInteraction($){const b=this.W($);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection($,b){this.W($)?.setSelection(b)}$acceptProcessResize($,b,v){try{this.g.get($)?.resize(b,v)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown($,b){this.g.get($)?.shutdown(b)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(b=>this.a.$sendProcessProperty($,{type:"initialCwd",value:b}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(b=>this.a.$sendProcessProperty($,{type:"cwd",value:b}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new E.$BK(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,b,v){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,v),this.a.$registerProfileProvider(b,$.identifier.value),new E.$BK(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider($,b,v){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,v),this.a.$registerQuickFixProvider($,b),new E.$BK(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,b){const v=new f.$1d().token;if(v.isCancellationRequested)return;const C=this.D.get($);if(!C)return;const N=await C.provideTerminalQuickFixes(b,v);if(N===null||Array.isArray(N)&&N.length===0)return;const j=new p.$Qc;if(this.w.value=j,!Array.isArray(N))return N?s.TerminalQuickFix.from(N,this.Q.converter,j):void 0;const M=[];for(const O of N){const z=s.TerminalQuickFix.from(O,this.Q.converter,j);z&&M.push(z)}return M}async $createContributedProfileTerminal($,b){const v=new f.$1d().token;let C=await this.C.get($)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,b);return}this.createTerminalFromOptions(C.options,b)}}async $provideLinks($,b){const v=this.W($);if(!v)return[];this.F.delete($),this.G.get($)?.dispose(!0);const N=new f.$1d;this.G.set($,N);const j=[],M={terminal:v.value,line:b},O=[];for(const W of this.z)O.push(c.Promises.withAsyncBody(async V=>{N.token.onCancellationRequested(()=>V({provider:W,links:[]}));const de=await W.provideTerminalLinks(M,N.token)||[];N.token.isCancellationRequested||V({provider:W,links:de})}));const z=await Promise.all(O);if(N.token.isCancellationRequested)return[];const T=new Map;for(const W of z)W&&W.links.length>0&&j.push(...W.links.map(V=>{const de={id:a++,startIndex:V.startIndex,length:V.length,label:V.tooltip};return T.set(de.id,{provider:W.provider,link:V}),de}));return this.F.set($,T),j}$activateLink($,b){const v=this.F.get($)?.get(b);v&&v.provider.handleTerminalLink(v.link)}U($,b){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const v=this.h[$];v&&(v.dispose(),delete this.h[$]),this.a.$sendProcessExit($,b)}W($){return this.X(this.f,$)}X($,b){const v=this.Y($,b);return v!==null?$[v]:null}Y($,b){const v=$.findIndex(C=>C._id===b);return v===-1?null:v}getEnvironmentVariableCollection($){let b=this.n.get($.identifier.value);return b||(b=new r,this.$($.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Z($,b){const v=(0,P.$qr)(b.map),C=(0,P.$rr)(b.descriptionMap);this.a.$setEnvironmentVariableCollection($,b.persistent,v.length===0?void 0:v,C)}$initEnvironmentVariableCollections($){$.forEach(b=>{const v=b[0],C=new r(b[1]);this.$(v,C)})}$acceptDefaultProfile($,b){const v=this.s;this.s=$,this.u=b,v?.path!==$.path&&this.N.fire($.path)}$($,b){this.n.set($,b),b.onDidChangeCollection(()=>{this.Z($,b)})}};e.$0dc=t,e.$0dc=t=He([Be(1,i.$XM),Be(2,R.$BM)],t);class r{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$Qd,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const b=this.h($);let v=this.a.get(b);return v||(v=new d(this,$),this.a.set(b,v),v.onDidChangeCollection(()=>this.d.fire())),v}replace($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Replace,options:v??{applyAtProcessCreation:!0},scope:C})}append($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Append,options:v??{applyAtProcessCreation:!0},scope:C})}prepend($,b,v,C){this.f($,{value:b,type:E.EnvironmentVariableMutatorType.Prepend,options:v??{applyAtProcessCreation:!0},scope:C})}f($,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const v=this.g($,b.scope),C=this.map.get(v),N=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==b.value||C.type!==b.type||C.options?.applyAtProcessCreation!==N.applyAtProcessCreation||C.options?.applyAtShellIntegration!==N.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const j=this.g($,b.scope),M={variable:$,...b,options:N};this.map.set(j,M),this.d.fire()}}get($,b){const v=this.g($,b),C=this.map.get(v);return C?k(C):void 0}g($,b){const v=this.h(b);return v.length?`${$}:::${v}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const b=new Map;for(const[v,C]of this.map)this.h(C.scope)===this.h($)&&b.set(C.variable,k(C));return b}delete($,b){const v=this.g($,b);this.map.delete(v),this.d.fire()}clear($){if($?.workspaceFolder){for(const[b,v]of this.map)v.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(b);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,b){const v=this.h(b),C=this.descriptionMap.get(v);if(!C||C.description!==$){let N;typeof $=="string"?N=$:N=$?.value.split(`

`)[0];const j={description:N,scope:b};this.descriptionMap.set(v,j),this.d.fire()}}getDescription($){const b=this.h($);return this.descriptionMap.get(b)?.description}k($){const b=this.h($);this.descriptionMap.delete(b)}}class d{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,b){this.b=$,this.d=b,this.a=new I.$Qd}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,b,v){this.b.replace($,b,v,this.d)}append($,b,v){this.b.append($,b,v,this.d)}prepend($,b,v){this.b.prepend($,b,v,this.d)}get($){return this.b.get($,this.d)}forEach($,b){this.b.getVariableMap(this.d).forEach((v,C)=>$.call(b,C,v,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor($,b){super(!1,$,b)}createTerminal($,b,v){throw new A.$$}createTerminalFromOptions($,b){throw new A.$$}};e.$$dc=u,e.$$dc=u=He([Be(0,i.$XM),Be(1,R.$BM)],u);function l(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return w.ThemeColor.isThemeColor(D)?D:void 0}function k(D){const $={...D};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(ke[341],Se([1,0,121,10,22,21,4,75,52,3,24,18,32,6,20,149,14,7,68,112,89,25]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.$hfc=e.$gfc=e.$ffc=void 0;let t=class extends g.$Rc{constructor(M,O,z){super(),this.u=z,this.f=this.B(new R.$Qd),this.g=new Map,this.s=this.B(new R.$Qd),this.onResultsChanged=this.f.event,this.results=[],this.h=M.getProxy(y.$zK.MainThreadTesting),this.m=new v(this.h),this.j=new l(this.h),O.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const W=T,V=W.tests[W.tests.length-1].item.extId;return this.g.get(i.$pJ.root(V))?.collection.tree.get(V)?.actual??(0,w.$NM)(T)}case 18:{const{extId:W,message:V}=T;return{test:this.g.get(i.$pJ.root(W))?.collection.tree.get(W)?.actual,message:c.TestMessage.to(V)}}default:return T}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await O.executeCommand("_testing.getExplorerSelection"),W=V=>{const de=this.g.get(i.$pJ.root(V));if(de)return i.$pJ.isRoot(V)?de.controller:de.collection.tree.get(V)?.actual};return{include:T?.include.map(W).filter(P.$Jf)||[],exclude:T?.exclude.map(W).filter(P.$Jf)||[]}})}createTestController(M,O,z,T){if(this.g.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const W=new g.$Qc,V=W.add(new w.$QM(O,z,this.u));V.root.label=z;const de=new Map,ee=new Set,Z=this.h,J={items:V.root.children,get label(){return z},set label(x){z=x,V.root.label=x,Z.$updateController(O,{label:z})},get refreshHandler(){return T},set refreshHandler(x){T=x,Z.$updateController(O,{canRefresh:!!x})},get id(){return O},createRunProfile:(x,Ee,le,K,U,ne)=>{let be=(0,E.$Ii)(x);for(;de.has(be);)be++;return new C(this.h,de,M,ee,this.s.event,O,be,x,Ee,le,K,U,ne)},createTestItem(x,Ee,le){return new w.$OM(O,x,Ee,le)},createTestRun:(x,Ee,le=!0)=>this.j.createTestRun(M,O,V,x,Ee,le),invalidateTestResults:x=>{if(x===void 0)this.h.$markTestRetired(void 0);else{const Ee=x instanceof Array?x:[x];this.h.$markTestRetired(Ee.map(le=>i.$pJ.fromExtHostTestItem(le,O).toString()))}},set resolveHandler(x){V.resolveHandler=x},get resolveHandler(){return V.resolveHandler},dispose:()=>{W.dispose()}};Z.$registerTestController(O,z,!!T),W.add((0,g.$Pc)(()=>Z.$unregisterTestController(O)));const ae={controller:J,collection:V,profiles:de,extension:M,activeProfiles:ee};return this.g.set(O,ae),W.add((0,g.$Pc)(()=>this.g.delete(O))),W.add(V.onDidGenerateDiff(x=>Z.$publishDiff(O,x.map(o.TestsDiffOp.serialize)))),J}createTestObserver(){return this.m.checkout()}async runTests(M,O=L.CancellationToken.None){const z=h(M);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.g.get(z.controllerId);if(!T)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(W=>i.$pJ.fromExtHostTestItem(W,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:N[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:M.exclude?.map(W=>W.id)},O)}$syncTests(){for(const{collection:M}of this.g.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,O,z){return(0,I.$qb)(this.j.trackers,W=>W.id===M?W.getCoverage(O):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(M,O,z,T){return(0,I.$qb)(this.j.trackers,V=>V.id===M?V.getCoverage(O):void 0)?.resolveFileCoverage(z,T)??Promise.resolve([])}$configureRunProfile(M,O){this.g.get(M)?.profiles.get(O)?.configureHandler?.()}$setActiveRunProfiles(M){const O=new Map;for(const[z,T]of Object.entries(M)){const W=this.g.get(z);if(!W)continue;const V=new Map,de=T.filter(Z=>!W.activeProfiles.has(Z)),ee=[...W.activeProfiles].filter(Z=>!T.includes(Z));for(const Z of de)V.set(Z,!0),W.activeProfiles.add(Z);for(const Z of ee)V.set(Z,!1),W.activeProfiles.delete(Z);V.size&&O.set(z,V)}this.s.fire(O)}async $refreshTests(M,O){await this.g.get(M)?.controller.refreshHandler?.(O)}$publishTestResults(M){this.results=Object.freeze(M.map(O=>(0,A.$an)(c.TestResults.to(O))).concat(this.results).sort((O,z)=>z.completedAt-O.completedAt).slice(0,32)),this.f.fire()}async $expandTest(M,O){const z=this.g.get(i.$pJ.fromString(M).controllerId)?.collection;z&&(await z.expand(M,O<0?1/0:O),z.flushDiff())}$acceptDiff(M){this.m.applyDiff(M.map(o.TestsDiffOp.deserialize))}async $runControllerTests(M,O){return Promise.all(M.map(z=>this.w(z,!1,O)))}async $startContinuousRun(M,O){const z=new L.$1d(O),T=await Promise.all(M.map(W=>this.w(W,!0,z.token)));return!O.isCancellationRequested&&!T.some(W=>W.error)&&await new Promise(W=>O.onCancellationRequested(W)),z.dispose(!0),T}async w(M,O,z){const T=this.g.get(M.controllerId);if(!T)return{};const{collection:W,profiles:V,extension:de}=T,ee=V.get(M.profileId);if(!ee)return{};const Z=M.testIds.map(Ee=>W.tree.get(Ee)).filter(P.$Jf),J=M.excludeExtIds.map(Ee=>T.collection.tree.get(Ee)).filter(P.$Jf).filter(Ee=>Z.some(le=>le.fullId.compare(Ee.fullId)===2));if(!Z.length)return{};const ae=new s.$0L(Z.some(Ee=>Ee.actual instanceof w.$PM)?void 0:Z.map(Ee=>Ee.actual),J.map(Ee=>Ee.actual),ee,O),x=(0,o.$rJ)(M)&&this.j.prepareForMainThreadTestRun(ae,k.fromInternal(M,T.collection),de,z);try{return await ee.runHandler(ae,z),{}}catch(Ee){return{error:String(Ee)}}finally{x&&(x.hasRunningTasks&&!z.isCancellationRequested&&await R.Event.toPromise(x.onEnd),x.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.j.cancelAllRuns():this.j.cancelRunById(M)}};e.$ffc=t,e.$ffc=t=He([Be(0,S.$BM)],t);const r=1e4;var d;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(d||(d={}));class u extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(M,O,z){super(),this.m=M,this.s=O,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Qd),this.onEnd=this.j.event,this.h=this.B(new L.$1d(z));const T=this.B(new F.$9g(()=>this.u(),r));this.B(this.h.token.onCancellationRequested(()=>T.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const O=this.m.id,z=this.m.controllerId,T=(0,f.$hg)(),W=new D(this.s,O,T),V=J=>(ae,...x)=>{if(ee){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}this.m.isIncluded(ae)&&(this.y(ae),J(ae,...x))},de=(J,ae)=>{const x=ae instanceof Array?ae.map(c.TestMessage.from):[c.TestMessage.from(ae)];if(J.uri&&J.range){const Ee={range:c.Range.from(J.range),uri:J.uri};for(const le of x)le.location=le.location||Ee}this.s.$appendTestMessagesInRun(O,T,i.$pJ.fromExtHostTestItem(J,z).toString(),x)};let ee=!1;const Z={isPersisted:this.m.isPersisted,token:this.h.token,name:M,get coverageProvider(){return W.coverageProvider},set coverageProvider(J){W.coverageProvider=J},enqueued:V(J=>{this.s.$updateTestStateInRun(O,T,i.$pJ.fromExtHostTestItem(J,z).toString(),1)}),skipped:V(J=>{this.s.$updateTestStateInRun(O,T,i.$pJ.fromExtHostTestItem(J,z).toString(),5)}),started:V(J=>{this.s.$updateTestStateInRun(O,T,i.$pJ.fromExtHostTestItem(J,z).toString(),2)}),errored:V((J,ae,x)=>{de(J,ae),this.s.$updateTestStateInRun(O,T,i.$pJ.fromExtHostTestItem(J,z).toString(),6,x)}),failed:V((J,ae,x)=>{de(J,ae),this.s.$updateTestStateInRun(O,T,i.$pJ.fromExtHostTestItem(J,z).toString(),4,x)}),passed:V((J,ae)=>{this.s.$updateTestStateInRun(O,T,i.$pJ.fromExtHostTestItem(J,this.m.controllerId).toString(),3,ae)}),appendOutput:(J,ae,x)=>{ee||(x&&(this.m.isIncluded(x)?this.y(x):x=void 0),this.s.$appendOutputToRun(O,T,m.$ee.fromString(J),ae&&c.location.from(ae),x&&i.$pJ.fromExtHostTestItem(x,z).toString()))},end:()=>{ee||(ee=!0,this.s.$finishedTestRunTask(O,T),this.f.delete(T),this.f.size||this.w())}};return this.f.set(T,{run:Z,coverage:W}),this.s.$startedTestRunTask(O,{id:T,name:M,running:!0}),Z}u(){for(const{run:M}of this.f.values())M.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(M){if(!(M instanceof w.$OM))throw new n.$tM(M.id);if(this.g.has(i.$pJ.fromExtHostTestItem(M,this.m.controllerId).toString()))return;const O=[],z=this.m.colllection.root;for(;;){const T=c.TestItem.from(M);if(O.unshift(T),this.g.has(T.extId)||(this.g.add(T.extId),M===z))break;M=M.parent||z}this.s.$addTestsToRun(this.m.controllerId,this.m.id,O)}dispose(){this.w(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,O,z,T){return this.f(M,O,z,T)}cancelRunById(M){for(const O of this.c.values())if(O.id===M){O.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,O,z,T,W,V){const de=this.c.get(T);if(de)return de.createRun(W);const ee=k.fromPublic(O,z,T,V),Z=h(T);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!T.continuous,profile:Z&&{group:N[Z.kind],id:Z.profileId},exclude:T.exclude?.map(ae=>i.$pJ.fromExtHostTestItem(ae,z.root.id).toString())??[],id:ee.id,include:T.include?.map(ae=>i.$pJ.fromExtHostTestItem(ae,z.root.id).toString())??[z.root.id],persist:V});const J=this.f(T,ee,M);return R.Event.once(J.onEnd)(()=>{this.d.$finishedExtensionTestRun(ee.id),J.dispose()}),J.createRun(W)}f(M,O,z,T){const W=new u(O,this.d,T);return this.c.set(M,W),R.Event.once(W.onEnd)(()=>this.c.delete(M)),W}}e.$gfc=l;const h=j=>{if(j.profile){if(!(j.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class k{static fromPublic(M,O,z,T){return new k(M,(0,f.$hg)(),z.include?.map(W=>i.$pJ.fromExtHostTestItem(W,M).toString())??[M],z.exclude?.map(W=>i.$pJ.fromExtHostTestItem(W,M).toString())??[],T,O)}static fromInternal(M,O){return new k(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,O)}constructor(M,O,z,T,W,V){this.controllerId=M,this.id=O,this.isPersisted=W,this.colllection=V,this.c=z.map(de=>de+"\0"),this.d=T.map(de=>de+"\0")}isIncluded(M){const O=i.$pJ.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const z of this.d)if(O===z||O.startsWith(z))return!1;for(const z of this.c)if(O===z||O.startsWith(z))return!0;return!1}}e.$hfc=k;class D{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,O,z){this.f=M,this.g=O,this.h=z}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(c.TestCoverage.fromFile)??[]}catch(O){throw this.d=void 0,O}}async resolveFileCoverage(M,O){const z=await this.d;let T=z?.[M];return!this.c||!z||!T?[]:(T.detailedCoverage||(T=z[M]=await this.c.resolveFileCoverage?.(T,O)??T),T.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class ${get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,c.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const O=i.$pJ.parentId(M.item.extId);if(O&&this.g.has(O.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:O,f:z}=this;return{get added(){return[...M].map(T=>T.revived)},get updated(){return[...O].map(T=>T.revived)},get removed(){return[...z].map(T=>T.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class b extends o.$wJ{constructor(){super(...arguments),this.q=new R.$Qd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,O){return{...M,revived:c.TestItem.toPlain(M.item),depth:O?O.depth+1:0,children:new Set}}o(){return new $(this.q)}}class v{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(O=>O.revived)},dispose:(0,p.$cb)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new b;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class C{#e;#t;#i;#o;#r;get label(){return this.d}set label(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?c.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}get isSelected(){return(0,a.$yF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,a.$yF)(this.#t,"testingActiveProfile"),R.Event.chain(this.#o,M=>M.map(O=>O.get(this.controllerId)?.get(this.profileId)).filter(P.$Jf))}constructor(M,O,z,T,W,V,de,ee,Z,J,ae=!1,x=void 0,Ee=!1){this.controllerId=V,this.profileId=de,this.d=ee,this.kind=Z,this.runHandler=J,this.f=ae,this._tag=x,this.g=Ee,this.#e=M,this.#r=O,this.#t=z,this.#i=T,this.#o=W,O.set(de,this);const le=N[Z];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);this.#e.$publishTestRunProfile({profileId:de,controllerId:V,tag:x?c.TestTag.namespace(this.controllerId,x.id):null,label:ee,group:le,isDefault:ae,hasConfigurationHandler:!1,supportsContinuousRun:Ee})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$ifc=C;const N={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(ke[342],Se([1,0,19,11,4,6,150,14,7]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class g{constructor(P,f){this.i=f,this.a=new m.$Qd({onListenerError:F.$1}),this.b=new m.$Qd({onListenerError:F.$1}),this.c=new m.$Qd({onListenerError:F.$1}),this.d=new m.$Qd({onListenerError:F.$1}),this.f=new m.$Qd({onListenerError:F.$1}),this.g=new m.$Qd({onListenerError:F.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(L.$zK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const f=this.i.allEditors();return P?f:f.map(y=>y.value)}async showTextDocument(P,f,y){let S;typeof f=="number"?S={position:p.ViewColumn.from(f),preserveFocus:y}:typeof f=="object"?S={position:p.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selection:typeof f.selection=="object"?p.Range.from(f.selection):void 0,pinned:typeof f.preview=="boolean"?!f.preview:void 0}:S={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(P.uri,S),c=w&&this.i.getEditor(w);if(c)return c.value;throw w?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,f){return new R.$IM(this.h,P,f).value}$acceptEditorPropertiesChanged(P,f){const y=this.i.getEditor(P);if(!y)throw new Error("unknown text editor");if(f.options&&y._acceptOptions(f.options),f.selections){const S=f.selections.selections.map(p.Selection.to);y._acceptSelections(S)}if(f.visibleRanges){const S=I.$Gb(f.visibleRanges.map(p.Range.to));y._acceptVisibleRanges(S)}if(f.options&&this.b.fire({textEditor:y.value,options:{...f.options,lineNumbers:p.TextEditorLineNumbersStyle.to(f.options.lineNumbers)}}),f.selections){const S=E.TextEditorSelectionChangeKind.fromValue(f.selections.source),w=f.selections.selections.map(p.Selection.to);this.a.fire({textEditor:y.value,selections:w,kind:S})}if(f.visibleRanges){const S=I.$Gb(f.visibleRanges.map(p.Range.to));this.c.fire({textEditor:y.value,visibleRanges:S})}}$acceptEditorPositionData(P){for(const f in P){const y=this.i.getEditor(f);if(!y)throw new Error("Unknown text editor");const S=p.ViewColumn.to(P[f]);y.value.viewColumn!==S&&(y._acceptViewColumn(S),this.d.fire({textEditor:y.value,viewColumn:S}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.$xec=g}),define(ke[343],Se([1,0,2,5,6,3,7,14,26,18]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=e.$_ec=void 0,e.$_ec=(0,F.$Uh)("IExtHostTimeline");class A{constructor(y,S){this.b=new Map,this.c=new Map,this.a=y.getProxy(m.$zK.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(w,c)=>{if(w&&w.$mid===12)if(this.b.get(w.source)&&E.$$l.equals(c,this.b.get(w.source)?.extension)){const s=w.uri===void 0?void 0:I.URI.revive(w.uri);return this.c.get(w.source)?.get(P(s))?.get(w.handle)}else return;return w}})}async $getTimeline(y,S,w,c){return this.b.get(y)?.provider.provideTimeline(I.URI.revive(S),w,c)}registerTimelineProvider(y,S,w,c){const s=new L.$Qc,i=this.d(S.id,c,s).bind(this);let n;S.onDidChange&&(n=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const o=this.c;return this.f({...S,scheme:y,onDidChange:void 0,async provideTimeline(a,t,r){t?.resetCache&&(s.clear(),o.get(S.id)?.clear());const d=await S.provideTimeline(a,t,r);if(d==null)return;const u=i(a,t);return{...d,source:S.id,items:d.items.map(u)}},dispose(){for(const a of o.values())a.get(S.id)?.clear();n?.dispose(),s.dispose()}},w)}d(y,S,w){return(c,s)=>{let i;if(s?.cacheResults){let n=this.c.get(y);n===void 0&&(n=new Map,this.c.set(y,n));const o=P(c);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...a}=n,t=`${y}|${n.id??n.timestamp}`;i?.set(t,n);let r,d,u;n.iconPath&&(o instanceof R.$vL?u={id:o.id,color:o.color}:I.URI.isUri(o)?(r=o,d=o):{light:r,dark:d}=o);let l;return R.$2K.isMarkdownString(a.tooltip)?l=p.MarkdownString.from(a.tooltip):(0,g.$Bf)(a.tooltip)?l=a.tooltip:R.$2K.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=p.MarkdownString.from(a.detail)):(0,g.$Bf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=a.detail),{...a,id:a.id??void 0,handle:t,source:y,command:n.command?S.toInternal(n.command,w):void 0,icon:r,iconDark:d,themeIcon:u,tooltip:l,accessibilityInformation:n.accessibilityInformation}}}}f(y,S){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:S}),(0,L.$Pc)(()=>{for(const c of this.c.values())c.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$afc=A;function P(f){return f?.toString()}}),define(ke[73],Se([1,0,21,4,3,222,5,15,88,6,27,20,7]),function(me,e,I,F,m,L,R,p,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vwb=e.$Uwb=e.TunnelDtoConverter=void 0;class y extends E.$mv{}var S;(function(c){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:n.protocol}}c.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==E.TunnelPrivacyId.ConstantPrivate&&n.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}c.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$Uwb=(0,R.$Uh)("IExtHostTunnelService");let w=class extends m.$Rc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Qd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(g.$zK.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const o=new y(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new f.$BK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,o,a){const t=[];for(const d of s){const u=this.r.get(d);if(!u)return[];t.push(...await Promise.all(i.map(async l=>{let h;try{h=await u.provider.providePortAttributes({port:l,pid:n,commandLine:o},a)}catch{h=await u.provider.providePortAttributes(l,n,o,a)}return{providedAttributes:h,port:l}})))}const r=t.filter(d=>!!d.providedAttributes);return r.length>0?r.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,a)=>await s.provideTunnel(o,a,new I.$1d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,m.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,m.$Pc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const a=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:o,disposeListener:a}),S.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(o=>this.f(o.host,o.port,o.detail??""))),n=s.filter((o,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$Vwb=w,e.$Vwb=w=He([Be(0,P.$BM),Be(1,A.$RM),Be(2,p.$cj)],w)}),define(ke[344],Se([1,0,3,17,2,6]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(L.$zK.MainThreadUriOpeners)}registerExternalUriOpener(E,g,A,P){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const f=P.schemes.find(y=>!R.a.has(y));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(g,A),this.b.$registerUriOpener(g,P.schemes,E,P.label),(0,I.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(E,g,A){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener with id: ${E}`);const f=m.URI.revive(g);return P.canOpenExternalUri(f,A)}async $openUri(E,g,A){const P=this.c.get(E);if(!P)throw new Error(`Unknown opener id: '${E}'`);return P.openExternalUri(m.URI.revive(g.resolvedUri),{sourceUri:m.URI.revive(g.sourceUri)},A)}}e.$jfc=R}),define(ke[345],Se([1,0,6,2,3,11,26]),function(me,e,I,F,m,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class p{static{this.a=0}constructor(g){this.c=new R.$_l,this.d=new Map,this.b=g.getProxy(I.$zK.MainThreadUrls)}registerUriHandler(g,A){const P=g.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const f=p.a++;return this.c.add(P),this.d.set(f,A),this.b.$registerUriHandler(f,P,g.displayName||g.name),(0,m.$Pc)(()=>{this.c.delete(P),this.d.delete(f),this.b.$unregisterUriHandler(f)})}$handleExternalUri(g,A){const P=this.d.get(g);if(!P)return Promise.resolve(void 0);try{P.handleUri(F.URI.revive(A))}catch(f){(0,L.$Z)(f)}return Promise.resolve(void 0)}async createAppUri(g){return F.URI.revive(await this.b.$createAppUri(g))}}e.$zec=p}),define(ke[93],Se([1,0,4,3,17,24,2,239,276,113,6]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=e.$Dec=e.$Cec=e.$Bec=e.$Aec=void 0;class P{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,a,t,r,d,u,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$Qd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$Qd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=a,this.#s=t,this.#o=r,this.#r=d,this.#n=u,this.#l=f(u),this.#d=y(u),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,g.$bub)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===m.Schemas.https||o.scheme===m.Schemas.http){let a=o.toString();return a.endsWith("/")||(a+="/"),a+" "+g.$aub}return g.$aub}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),L.$dn(this.#s,o)||this.#t.$setOptions(this.#e,c(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const a=(0,E.$idb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const a=this.#n.extensionLocation?.scheme===m.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===m.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,l,h,k)=>{const D=R.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),$=(0,g.$bub)(D,{isRemote:a,authority:t}).toString();return`${d}${$}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,l,h,k)=>{const D=R.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),$=(0,g.$bub)(D,{isRemote:a,authority:t}).toString();return`${d}${$}${k}`})}}e.$Aec=P;function f(n){try{const o=(0,p.$So)((0,p.$Ro)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$Bec=f;function y(n){try{const o=(0,p.$So)((0,p.$Ro)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class S extends F.$Rc{constructor(o,a,t,r,d){super(),this.c=a,this.f=t,this.g=r,this.h=d,this.b=new Map,this.a=o.getProxy(A.$zK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,a,t){const r=this.j(o);if(r){const{message:d}=(0,E.$jdb)(a,t.value);r._onMessageEmitter.fire(d)}}$onMissingCsp(o,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,a,t){const r=new P(o,this.a,s(a),this.c,this.f,t,this.h);this.b.set(o,r);const d=r._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Cec=S;function w(n){return{id:n.identifier,location:n.extensionLocation}}e.$Dec=w;function c(n,o,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,o)}}e.$Eec=c;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>R.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(ke[346],Se([1,0,21,52,3,17,23,2,14,93,110,6,7]),function(me,e,I,F,m,L,R,p,E,g,A,P,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class y{constructor(r,d){this.document=r,this.b=d,this.a=1,this.c=new A.$wdc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,d){await this.f(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.f(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this.a++;return(0,R.$yg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const d=this.c.get(r,0);if(!d)throw new Error("No edit found");return d}}class S{constructor(){this.a=new Map}get(r,d){return this.a.get(this.b(r,d))}add(r,d,u){const l=this.b(r,d.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const h=new y(d,u);return this.a.set(l,h),h}delete(r,d){const u=this.b(r,d.uri);this.a.delete(u)}b(r,d){return`${r}@@@${d}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class c{constructor(){this.a=new Map}addTextProvider(r,d,u){return this.b(0,r,d,u)}addCustomProvider(r,d,u){return this.b(1,r,d,u)}get(r){return this.a.get(r)}b(r,d,u,l){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:r,extension:u,provider:l}),new f.$BK(()=>this.a.delete(d))}}class s{constructor(r,d,u,l,h){this.d=d,this.f=u,this.g=l,this.h=h,this.b=new c,this.c=new S,this.a=r.getProxy(P.$zK.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,u,l){const h=new m.$Qc;return n(u)?(h.add(this.b.addTextProvider(d,r,u)),this.a.$registerTextEditorProvider((0,g.$Dec)(r),d,l.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,g.$Bec)(r))):(h.add(this.b.addCustomProvider(d,r,u)),i(u)&&h.add(u.onDidChangeCustomDocument(k=>{const D=this.i(d,k.document.uri);if(o(k)){const $=D.addEdit(k);this.a.$onDidEdit(k.document.uri,d,$,k.label)}else this.a.$onContentChange(k.document.uri,d)})),this.a.$registerCustomEditorProvider((0,g.$Dec)(r),d,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,g.$Bec)(r))),f.$BK.from(h,new f.$BK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,u,l,h){const k=this.b.get(d);if(!k)throw new Error(`No provider found for '${d}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${d}'`);const D=p.URI.revive(r),$=await k.provider.openCustomDocument(D,{backupId:u,untitledDocumentData:l?.buffer},h);let b;return i(k.provider)&&this.f&&(b=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(d,$,b),{editable:i(k.provider)}}async $disposeCustomDocument(r,d){const u=this.b.get(d);if(!u)throw new Error(`No provider found for '${d}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${d}'`);const l=p.URI.revive(r),{document:h}=this.i(d,l);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(r,d,u,l,h,k){const D=this.b.get(u);if(!D)throw new Error(`No provider found for '${u}'`);const $=E.ViewColumn.to(h),b=this.g.createNewWebview(d,l.contentOptions,D.extension),v=this.h.createNewWebviewPanel(d,u,l.title,$,l.options,b,l.active),C=p.URI.revive(r);switch(D.type){case 1:{const{document:N}=this.i(u,C);return D.provider.resolveCustomEditor(N,v,k)}case 0:{const N=this.d.getDocument(C);return D.provider.resolveCustomTextEditor(N,v,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,u){this.i(d,r).disposeEdits(u)}async $onMoveCustomEditor(r,d,u){const l=this.b.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const h=this.h.getWebviewPanel(r);if(!h)throw new Error("No webview found");const k=p.URI.revive(d),D=this.d.getDocument(k);await l.provider.moveCustomTextEditor(D,h,I.CancellationToken.None)}async $undo(r,d,u,l){return this.i(d,r).undo(u,l)}async $redo(r,d,u,l){return this.i(d,r).redo(u,l)}async $revert(r,d,u){const l=this.i(d,r);await this.j(d).revertCustomDocument(l.document,u),l.disposeBackup()}async $onSave(r,d,u){const l=this.i(d,r);await this.j(d).saveCustomDocument(l.document,u),l.disposeBackup()}async $onSaveAs(r,d,u,l){const h=this.i(d,r);return this.j(d).saveCustomDocumentAs(h.document,p.URI.revive(u),l)}async $backup(r,d,u){const l=this.i(d,r),k=await this.j(d).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},u);return l.updateBackup(k),k.id}i(r,d){const u=this.c.get(r,p.URI.revive(d));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$dfc=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const r=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Ii)(r)+""}}),define(ke[347],Se([1,0,4,3,2,32,14,93,6,7]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class A extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(S,w,c,s){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$Qd),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$Qd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=w,this.#o=c,this.#i=s.viewType,this.#r=s.panelOptions,this.#s=s.viewColumn,this.#n=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,m.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,w){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!w})}c(){if(this.#l)throw new Error("Webview is disposed")}}class P extends F.$Rc{static c(){return(0,L.$hg)()}constructor(S,w,c){super(),this.j=w,this.m=c,this.g=new Map,this.h=new Map,this.f=S.getProxy(E.$zK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,w,c,s,i={}){const n=typeof s=="object"?s.viewColumn:s,o={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},a=(0,p.$Bec)(S),t=P.c();this.f.$createWebviewPanel((0,p.$Dec)(S),t,w,{title:c,panelOptions:f(i),webviewOptions:(0,p.$Eec)(S,this.m,i),serializeBuffersForPostMessage:a},o);const r=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,w,c,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(S){const w=Object.keys(S);w.sort((c,s)=>{const i=S[c],n=S[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const c of w){const s=this.getWebviewPanel(c);if(!s)continue;const i=S[c];s._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,w,c){if(this.h.has(w))throw new Error(`Serializer for '${w}' already registered`);return this.h.set(w,{serializer:c,extension:S}),this.f.$registerSerializer(w,{serializeBuffersForPostMessage:(0,p.$Bec)(S)}),new g.$BK(()=>{this.h.delete(w),this.f.$unregisterSerializer(w)})}async $deserializeWebviewPanel(S,w,c,s){const i=this.h.get(w);if(!i)throw new Error(`No serializer found for '${w}'`);const{serializer:n,extension:o}=i,a=this.j.createNewWebview(S,c.webviewOptions,o),t=this.createNewWebviewPanel(S,w,c.title,s,c.panelOptions,a,c.active);await n.deserializeWebviewPanel(t,c.state)}createNewWebviewPanel(S,w,c,s,i,n,o){const a=new A(S,this.f,n,{viewType:w,title:c,viewColumn:s,panelOptions:i,active:o});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$cfc=P;function f(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(ke[348],Se([1,0,4,3,93,14,6,7]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class E extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(P,f,y,S,w,c){super(),this.#r=!1,this.#u=this.B(new I.$Qd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$Qd),this.onDidDispose=this.#l.event,this.#i=y,this.#a=S,this.#e=P,this.#t=f,this.#o=w,this.#n=c}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(P){this.a(),this.#a!==P&&(this.#a=P,this.#t.$setWebviewViewTitle(this.#e,P))}get description(){return this.a(),this.#s}set description(P){this.a(),this.#s!==P&&(this.#s=P,this.#t.$setWebviewViewDescription(this.#e,P))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(P){P===this.#n||this.#r||(this.#n=P,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(P){this.a(),!(P?.value===this.#c?.value&&P?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(P),this.#t.$setWebviewViewBadge(this.#e,P))}show(P){this.a(),this.#t.$show(this.#e,!!P)}a(){if(this.#r)throw new Error("Webview is disposed")}}class g{constructor(P,f){this.d=f,this.b=new Map,this.c=new Map,this.a=P.getProxy(R.$zK.MainThreadWebviewViews)}registerWebviewViewProvider(P,f,y,S){if(this.b.has(f))throw new Error(`View provider for '${f}' already registered`);return this.b.set(f,{provider:y,extension:P}),this.a.$registerWebviewViewProvider((0,m.$Dec)(P),f,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,m.$Bec)(P)}),new p.$BK(()=>{this.b.delete(f),this.a.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(P,f,y,S,w){const c=this.b.get(f);if(!c)throw new Error(`No view provider found for '${f}'`);const{provider:s,extension:i}=c,n=this.d.createNewWebview(P,{},i),o=new E(P,this.a,f,y,n,!0);this.c.set(P,o),await s.resolveWebviewView(o,{state:S},w)}async $onDidChangeWebviewViewVisibility(P,f){this.e(P)._setVisible(f)}async $disposeWebviewView(P){const f=this.e(P);this.c.delete(P),f.dispose(),this.d.deleteWebview(P)}e(P){const f=this.c.get(P);if(!f)throw new Error("No webview found");return f}}e.$bfc=g}),define(ke[153],Se([1,0,4,6,2,17,13,5,20,25]),function(me,e,I,F,m,L,R,p,E,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=e.$Fec=void 0;let P=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(y){const S=this.d;return{get focused(){return S.focused},get active(){return(0,g.$yF)(y,"windowActivity"),S.active}}}constructor(y){this.c=new I.$Qd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=y.getProxy(F.$zK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:w})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(y){this.onDidChangeWindowProperty("focused",y)}$onDidChangeWindowActive(y){this.onDidChangeWindowProperty("active",y)}onDidChangeWindowProperty(y,S){S!==this.d[y]&&(this.d={...this.d,[y]:S},this.c.fire(this.d))}openUri(y,S){let w;if(typeof y=="string"){w=y;try{y=m.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,R.$Ee)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this.b.$openUri(y,w,S)}async asExternalUri(y,S){if((0,R.$Ee)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(y,S);return m.URI.from(w)}};e.$Fec=P,e.$Fec=P=A=He([Be(0,E.$BM)],P),e.$Gec=(0,p.$Uh)("IExtHostWindow")}),define(ke[349],Se([1,0,317,27,20]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;const L=1024*1024;let R=class extends I.$Gfc{constructor(E,g){super(E,g),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,g,A){const P=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),g.apply(console,A),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,g){const A=process[E],P=A.write;let f="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(y,S,w)=>{if(!this.g){f+=y.toString(S);const c=f.length>L?f.length:f.lastIndexOf(`
`);c!==-1&&(console[g](f.slice(0,c)),f=f.slice(c+1))}P.call(A,y,S,w)}})}};e.$fgc=R,e.$fgc=R=He([Be(0,m.$BM),Be(1,F.$RM)],R)}),define(ke[350],Se([1,0,72,17,15,251,31,12]),function(me,e,I,F,m,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;let E=class{constructor(P,f){P.addFileSystemProvider(F.Schemas.file,new g(f),{isCaseSensitive:p.$k})}};e.$ggc=E,e.$ggc=E=He([Be(0,I.$5dc),Be(1,m.$cj)],E);class g{constructor(P){this.b=P,this.a=new L.$fq(this.b)}async stat(P){const f=await this.a.stat(P);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,f,y){return this.a.writeFile(P,f,{...y,unlock:!1,atomic:!1})}delete(P,f){return this.a.delete(P,{...f,useTrash:!1,atomic:!1})}rename(P,f,y){return this.a.rename(P,f,y)}copy(P,f,y){return this.a.copy(P,f,y)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,f){throw new Error("Method not implemented.")}}}),define(ke[351],Se([1,0,16,63,32,35,3,6,2,20]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;let A=class extends R.$Rc{constructor(f,y){super();const S=f.getProxy(p.$zK.MainThreadDownloadService);y.registerCommand(!1,"_workbench.downloadResource",async w=>{const c=E.URI.file((0,I.$ic)((0,F.tmpdir)(),(0,m.$hg)()));return await S.$download(w,c),c})}};e.$egc=A,e.$egc=A=He([Be(0,g.$BM),Be(1,L.$XM)],A)}),define(ke[352],Se([1,0,152,17,253,32]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class R extends I.$Ffc{s(E,g,A){return E.scheme===F.Schemas.file?new m.$NN(A?.name||(0,L.$hg)(),E.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,g):super.s(E,g,A)}registerLogger(E){super.registerLogger(E),this.r.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.r.$deregisterLogger(E)}}e.$rgc=R}),define(ke[353],Se([1,0,55,16,2,92,3,17,10,30]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class A extends L.$7dc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==p.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const d=r.fsPath;let u=0;do{let l;u===0?l=d:l=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${u}`:`${d}-${u}`,await P(l);const h=F.$ic(l,"vscode.lock"),k=await w(this.d,h,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),m.URI.file(l);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$qgc=A;async function P(a){try{await g.Promises.stat(a);return}catch{}try{await g.Promises.mkdir(a,{recursive:!0})}catch{}}const f=1e3,y=10*60*1e3;class S extends R.$Rc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new E.$8g),this.a.cancelAndSet(async()=>{const d=await c(t,r);(!d||d.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await g.Promises.utimes(r,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${r}': Could not update mtime.`)}},f)}dispose(){super.dispose();try{I.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function w(a,t,r){try{const u={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){a.error(u)}const d=await c(a,t);return!d||d.pid!==process.pid?r?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function c(a,t){let r;try{r=await g.Promises.readFile(t)}catch(d){return a.error(d),null}try{return JSON.parse(String(r))}catch(d){return a.error(d),null}}async function s(a,t){let r;try{r=await g.Promises.stat(t)}catch(d){return a.error(d),0}return r.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const r=await c(a,t);if(!r)return a.info(`Lock '${t}': Could not read pid of lock holder.`),o(a,t);if(r.willReleaseAt){let k=r.willReleaseAt-Date.now();if(k<5e3){for(k>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,E.$Xg)(Math.min(100,k)),await s(a,t)===0)return o(a,t);k=r.willReleaseAt-Date.now()}return o(a,t)}}if(!i(r.pid))return a.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),o(a,t);const d=await s(a,t),u=Date.now()-d;if(u<=y)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,E.$Xg)(2e3);const l=await s(a,t),h=Date.now()-l;return h<=y?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(a,t))}async function o(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return w(a,t,!0)}}),define(ke[354],Se([1,0,32,20,46,35]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;let R=class extends m.$0dc{constructor(E,g){super(!0,E,g)}createTerminal(E,g,A){return this.createTerminalFromOptions({name:E,shellPath:g,shellArgs:A})}createTerminalFromOptions(E,g){const A=new m.$9dc(this.a,(0,I.$hg)(),E,E.name);return this.f.push(A),A.create(E,this.R(E,g)),A.value}};e.$Lfc=R,e.$Lfc=R=He([Be(0,L.$XM),Be(1,F.$BM)],R)}),define(ke[355],Se([1,0,10,22,21,11,4,3,131,305,69]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=e.ResponsiveState=e.RequestInitiator=e.$U5b=e.$T5b=void 0;function f(v,C){try{return JSON.stringify(v,C)}catch{return"null"}}const y="$$ref$$",S={[y]:-1};class w{constructor(C,N){this.jsonString=C,this.referencedBuffers=N}}function c(v,C=null,N=!1){const j=[];return{jsonString:(N?f:JSON.stringify)(v,(O,z)=>{if(typeof z>"u")return S;if(typeof z=="object"){if(z instanceof F.$ee){const T=j.push(z)-1;return{[y]:T}}if(C)return C(O,z)}return z}),referencedBuffers:j}}e.$T5b=c;function s(v,C,N){return JSON.parse(v,(j,M)=>{if(M){const O=M[y];if(typeof O=="number")return C[O];if(N&&M.$mid===1)return N.transformIncoming(M)}return M})}e.$U5b=s;function i(v,C){return JSON.stringify(v,C)}function n(v){return v?(C,N)=>N&&N.$mid===1?v.transformOutgoing(N):N:null}var o;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var a;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},r=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends p.$Rc{static{P=r}static{this.a=3*1e3}constructor(C,N=null,j=null){super(),this[P]=!0,this.b=this.B(new R.$Qd),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=N,this.g=j,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,O=A.$tv.count;M<O;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$9g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const N=this.w[C];delete this.w[C],N.resolveErr(L.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,E.$Tm)(C,this.g):C}getProxy(C){const{nid:N,sid:j}=C;return this.s[N]||(this.s[N]=this.J(N,j)),this.s[N]}J(C,N){const j={get:(M,O)=>(typeof O=="string"&&!M[O]&&O.charCodeAt(0)===36&&(M[O]=(...z)=>this.U(C,O,z)),O===d?N:M[O])};return new Proxy(Object.create(null),j)}set(C,N){return this.m[C.nid]=N,N}assertRegistered(C){for(let N=0,j=C.length;N<j;N++){const M=C[N];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(C){if(this.j)return;const N=C.byteLength,j=h.read(C,0),M=j.readUInt8(),O=j.readUInt32();switch(M){case 1:case 2:{let{rpcId:z,method:T,args:W}=D.deserializeRequestJSONArgs(j);this.g&&(W=(0,E.$Tm)(W,this.g)),this.M(N,O,z,T,W,M===2);break}case 3:case 4:{let{rpcId:z,method:T,args:W}=D.deserializeRequestMixedArgs(j);this.g&&(W=(0,E.$Tm)(W,this.g)),this.M(N,O,z,T,W,M===4);break}case 5:{this.f?.logIncoming(N,O,0,"ack"),this.G(O);break}case 6:{this.N(N,O);break}case 7:{this.O(N,O,void 0);break}case 9:{let z=D.deserializeReplyOKJSON(j);this.g&&(z=(0,E.$Tm)(z,this.g)),this.O(N,O,z);break}case 10:{const z=D.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(N,O,z);break}case 8:{const z=D.deserializeReplyOKVSBuffer(j);this.O(N,O,z);break}case 11:{let z=D.deserializeReplyErrError(j);this.g&&(z=(0,E.$Tm)(z,this.g)),this.P(N,O,z);break}case 12:{this.P(N,O,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,N,j,M,O,z){this.f?.logIncoming(C,N,1,`receiveRequest ${(0,A.$vv)(j)}.${M}(`,O);const T=String(N);let W,V;if(z){const ee=new m.$1d;O.push(ee.token),W=this.Q(j,M,O),V=()=>ee.cancel()}else W=this.Q(j,M,O),V=t;this.u[T]=V;const de=D.serializeAcknowledged(N);this.f?.logOutgoing(de.byteLength,N,1,"ack"),this.c.send(de),W.then(ee=>{delete this.u[T];const Z=D.serializeReplyOK(N,ee,this.h);this.f?.logOutgoing(Z.byteLength,N,1,"reply:",ee),this.c.send(Z)},ee=>{delete this.u[T];const Z=D.serializeReplyErr(N,ee);this.f?.logOutgoing(Z.byteLength,N,1,"replyErr:",ee),this.c.send(Z)})}N(C,N){this.f?.logIncoming(C,N,1,"receiveCancel");const j=String(N);this.u[j]?.()}O(C,N,j){this.f?.logIncoming(C,N,0,"receiveReply:",j);const M=String(N);if(!this.w.hasOwnProperty(M))return;const O=this.w[M];delete this.w[M],O.resolveOk(j)}P(C,N,j){this.f?.logIncoming(C,N,0,"receiveReplyErr:",j);const M=String(N);if(!this.w.hasOwnProperty(M))return;const O=this.w[M];delete this.w[M];let z;j&&(j.$isError?(z=new Error,z.name=j.name,z.message=j.message,z.stack=j.stack):z=j),O.resolveErr(z)}Q(C,N,j){try{return Promise.resolve(this.S(C,N,j))}catch(M){return Promise.reject(M)}}S(C,N,j){const M=this.m[C];if(!M)throw new Error("Unknown actor "+(0,A.$vv)(C));const O=M[N];if(typeof O!="function")throw new Error("Unknown method "+N+" on actor "+(0,A.$vv)(C));return O.apply(M,j)}U(C,N,j){if(this.j)return new g.$S5b;let M=null;if(j.length>0&&m.CancellationToken.isCancellationToken(j[j.length-1])&&(M=j.pop()),M&&M.isCancellationRequested)return Promise.reject(L.$5());const O=D.serializeRequestArguments(j,this.h),z=++this.t,T=String(z),W=new g.$R5b,V=new p.$Qc;M&&V.add(M.onCancellationRequested(()=>{const ee=D.serializeCancel(z);this.f?.logOutgoing(ee.byteLength,z,0,"cancel"),this.c.send(D.serializeCancel(z))})),this.w[T]=new l(W,V),this.F(z);const de=D.serializeRequest(z,C,N,O,!!M);return this.f?.logOutgoing(de.byteLength,z,0,`request: ${(0,A.$vv)(C)}.${N}(`,j),this.c.send(de),W}}e.$V5b=u;class l{constructor(C,N){this.a=C,this.b=N}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class h{static alloc(C,N,j){const M=new h(F.$ee.alloc(j+1+4),0);return M.writeUInt8(C),M.writeUInt32(N),M}static read(C,N){return new h(C,N)}get buffer(){return this.a}constructor(C,N){this.a=C,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+C).toString();return this.b+=C,j}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+C).toString();return this.b+=C,j}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+C);return this.b+=C,N}static sizeMixedArray(C){let N=0;N+=1;for(let j=0,M=C.length;j<M;j++){const O=C[j];switch(N+=1,O.type){case 1:N+=this.sizeLongString(O.value);break;case 2:N+=this.sizeVSBuffer(O.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(O.value);for(let z=0;z<O.buffers.length;++z)N+=this.sizeVSBuffer(O.buffers[z]);break;case 4:break}}return N}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let N=0,j=C.length;N<j;N++){const M=C[N];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let O=0;O<M.buffers.length;++O)this.writeBuffer(M.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const N=new Array(C);for(let j=0;j<C;j++)switch(this.readUInt8()){case 1:N[j]=this.readLongString();break;case 2:N[j]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),z=this.readLongString(),T=[];for(let W=0;W<O;++W)T.push(this.readVSBuffer());N[j]=new A.$wv(s(z,T,null));break}case 4:N[j]=void 0;break}return N}}var k;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(k||(k={}));class D{static a(C){for(let N=0,j=C.length;N<j;N++)if(C[N]instanceof F.$ee||C[N]instanceof A.$wv||typeof C[N]>"u")return!0;return!1}static serializeRequestArguments(C,N){if(this.a(C)){const j=[];for(let M=0,O=C.length;M<O;M++){const z=C[M];if(z instanceof F.$ee)j[M]={type:2,value:z};else if(typeof z>"u")j[M]={type:4};else if(z instanceof A.$wv){const{jsonString:T,referencedBuffers:W}=c(z.value,N);j[M]={type:3,value:F.$ee.fromString(T),buffers:W}}else j[M]={type:1,value:F.$ee.fromString(i(z,N))}}return{type:1,args:j}}return{type:0,args:i(C,N)}}static serializeRequest(C,N,j,M,O){switch(M.type){case 0:return this.b(C,N,j,M.args,O);case 1:return this.c(C,N,j,M.args,O)}}static b(C,N,j,M,O){const z=F.$ee.fromString(j),T=F.$ee.fromString(M);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(z),W+=h.sizeLongString(T);const V=h.alloc(O?2:1,C,W);return V.writeUInt8(N),V.writeShortString(z),V.writeLongString(T),V.buffer}static deserializeRequestJSONArgs(C){const N=C.readUInt8(),j=C.readShortString(),M=C.readLongString();return{rpcId:N,method:j,args:JSON.parse(M)}}static c(C,N,j,M,O){const z=F.$ee.fromString(j);let T=0;T+=h.sizeUInt8(),T+=h.sizeShortString(z),T+=h.sizeMixedArray(M);const W=h.alloc(O?4:3,C,T);return W.writeUInt8(N),W.writeShortString(z),W.writeMixedArray(M),W.buffer}static deserializeRequestMixedArgs(C){const N=C.readUInt8(),j=C.readShortString(),M=C.readMixedArray(),O=new Array(M.length);for(let z=0,T=M.length;z<T;z++){const W=M[z];typeof W=="string"?O[z]=JSON.parse(W):O[z]=W}return{rpcId:N,method:j,args:O}}static serializeAcknowledged(C){return h.alloc(5,C,0).buffer}static serializeCancel(C){return h.alloc(6,C,0).buffer}static serializeReplyOK(C,N,j){if(typeof N>"u")return this.d(C);if(N instanceof F.$ee)return this.e(C,N);if(N instanceof A.$wv){const{jsonString:M,referencedBuffers:O}=c(N.value,j,!0);return this.g(C,M,O)}else return this.f(C,f(N,j))}static d(C){return h.alloc(7,C,0).buffer}static e(C,N){let j=0;j+=h.sizeVSBuffer(N);const M=h.alloc(8,C,j);return M.writeVSBuffer(N),M.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,N){const j=F.$ee.fromString(N);let M=0;M+=h.sizeLongString(j);const O=h.alloc(9,C,M);return O.writeLongString(j),O.buffer}static g(C,N,j){const M=F.$ee.fromString(N);let O=0;O+=h.sizeUInt32,O+=h.sizeLongString(M);for(const T of j)O+=h.sizeVSBuffer(T);const z=h.alloc(10,C,O);z.writeUInt32(j.length),z.writeLongString(M);for(const T of j)z.writeBuffer(T);return z.buffer}static deserializeReplyOKJSON(C){const N=C.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(C,N){const j=C.readUInt32(),M=C.readLongString(),O=[];for(let z=0;z<j;++z)O.push(C.readVSBuffer());return new A.$wv(s(M,O,N))}static serializeReplyErr(C,N){const j=N?f(L.$2(N),null):void 0;if(typeof j!="string")return this.h(C);const M=F.$ee.fromString(j);let O=0;O+=h.sizeLongString(M);const z=h.alloc(11,C,O);return z.writeLongString(M),z.buffer}static deserializeReplyErrError(C){const N=C.readLongString();return JSON.parse(N)}static h(C){return h.alloc(12,C,0).buffer}}var $;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var b;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(b||(b={}))}),define(ke[356],Se([1,0,4,38,45,5]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SJ=e.$RJ=e.OutputChannelUpdateMode=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=void 0,e.$HJ="text/x-code-output",e.$IJ="output",e.$JJ="Log",e.$KJ="text/x-code-log-output",e.$LJ="log",e.$MJ="workbench.panel.output",e.$NJ=new m.$_i("inOutput",!1),e.$OJ=new m.$_i("activeLogOutput",!1),e.$PJ=new m.$_i("outputView.scrollLock",!1),e.$QJ=(0,L.$Uh)("outputService");var R;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$RJ={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new I.$Qd,this.onDidRegisterChannel=this.b.event,this.c=new I.$Qd,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(A=>g.push(A)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}F.$ln.add(e.$RJ.OutputChannels,new p),e.$SJ=new m.$_i("activeOutputChannel","")}),define(ke[154],Se([1,0,6,5,20,26,15,356,72,27,57,182,22,18,31,4,3]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=void 0;class s extends R.$ij{get disposed(){return this.n}constructor(a,t,r,d,u){super(),this.id=a,this.name=t,this.r=r,this.s=d,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=f.$ee.fromString(t).byteLength,(0,R.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(a){this.append(a)}}let n=class{constructor(a,t,r,d,u,l){this.i=t,this.j=r,this.k=d,this.l=u,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(I.$zK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$jm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(a,t,r){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,u=(0,y.$Bf)(t)?t:void 0;if((0,y.$Bf)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const h=this.i.environment.extensionLogLevel?.find(([D])=>L.$$l.equals(r.identifier,D))?.[1];h&&(l=(0,R.$sj)(h));const k=d?this.o(a,l,r):this.n(a,u,r);return k.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(a,l??this.m.getLevel(),k):this.q(a,k)}async n(a,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,u=this.k.extUri.joinPath(d,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,u,t,r.identifier.value);return new s(h,a,l,this.a,r)}async o(a,t,r){const d=await this.p(r),u=a.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(d,`${u}.log`),h=`${r.identifier.value}.${u}`,k=this.l.createLogger(l,{id:h,name:a,logLevel:t,extensionId:r.identifier.value});return new i(h,a,k,this.a,r)}p(a){let t=this.d.get(a.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(d){if((0,S.$tk)(d)!==S.FileSystemProviderErrorCode.FileExists)throw d}return r})())}return t}q(a,t){let r=!1;const d=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return a},append(u){d(),t.then(l=>l.append(u))},appendLine(u){d(),t.then(l=>l.appendLine(u))},clear(){d(),t.then(u=>u.clear())},replace(u){d(),t.then(l=>l.replace(u))},show(u,l){d(),t.then(h=>h.show(u,l))},hide(){d(),t.then(u=>u.hide())},dispose(){r=!0,t.then(u=>u.dispose())}}}r(a,t,r){const d=new c.$Qc,u=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},l=d.add(new w.$Qd);function h(k){t=k,l.fire(k)}return r.then(k=>{d.add(k),k.logLevel!==t&&h(k.logLevel),d.add(k.onDidChangeLogLevel(D=>h(D)))}),{...this.q(a,r),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(k,...D){u(),r.then($=>$.trace(k,...D))},debug(k,...D){u(),r.then($=>$.debug(k,...D))},info(k,...D){u(),r.then($=>$.info(k,...D))},warn(k,...D){u(),r.then($=>$.warn(k,...D))},error(k,...D){u(),r.then($=>$.error(k,...D))},dispose(){d.dispose()}}}};e.$pec=n,e.$pec=n=He([Be(0,m.$BM),Be(1,g.$RM),Be(2,E.$5dc),Be(3,A.$zdc),Be(4,R.$dj),Be(5,R.$cj)],n),e.$qec=(0,F.$Uh)("IExtHostOutputService")}),define(ke[155],Se([1,0,5,10]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=void 0,e.$ym=(0,I.$Uh)("remoteAgentService"),e.$zm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(m){let L=1/0;for(let p=0;p<this.maxSampleCount;p++){const E=await m.getRoundTripTime();if(E===void 0)return;L=Math.min(L,E/2),await(0,F.$Xg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((p,E)=>p+E,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((p,E)=>p+E,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[357],Se([1,0,225,86,38,40,44,3,4,155,12]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=void 0,e.$qH=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$rH=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$sH=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$tH={ConfigurationMigration:"base.contributions.configuration.migration"};class P{constructor(){this.migrations=[],this.a=new E.$Qd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(c){this.migrations.push(...c)}}const f=new P;m.$ln.add(e.$tH.ConfigurationMigration,f);let y=class extends p.$Rc{constructor(c,s){super(),this.a=c,this.b=s,this.B(this.b.onDidChangeWorkspaceFolders(async i=>{for(const n of i.added)await this.f(n,f.migrations)})),this.c(f.migrations),this.B(f.onDidRegisterConfigurationMigration(i=>this.c(i)))}async c(c){await this.f(void 0,c);for(const s of this.b.getWorkspace().folders)await this.f(s,c)}async f(c,s){await Promise.all(s.map(i=>this.g(i,{resource:c?.uri})))}async g(c,s){const i=this.a.inspect(c.key,s);if(await this.h(c,s,i,"userValue",2),await this.h(c,s,i,"userLocalValue",3),await this.h(c,s,i,"userRemoteValue",4),await this.h(c,s,i,"workspaceFolderValue",6),await this.h(c,s,i,"workspaceValue",5),typeof s.overrideIdentifier>"u"&&typeof i.overrideIdentifiers<"u")for(const n of i.overrideIdentifiers)await this.g(c,{resource:s.resource,overrideIdentifier:n})}async h(c,s,i,n,o){const a=i[n];if(typeof a>"u")return;const t=u=>this.a.inspect(u,s)[n],r=await c.migrateFn(a,t),d=Array.isArray(r)?r:[[c.key,r]];await Promise.allSettled(d.map(async([u,l])=>this.a.updateValue(u,l.value,s,o)))}};e.$uH=y,e.$uH=y=He([Be(0,R.$oi),Be(1,L.$4h)],y);let S=class extends p.$Rc{constructor(c){super(),(async()=>{if(!A.$i&&(await c.getEnvironment())?.os!==1)return;m.$ln.as(F.$qn.Configuration).registerConfiguration({...e.$sH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(3,null)},default:[],markdownDescription:(0,I.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(5,null),scope:2}}})})()}};e.$vH=S,e.$vH=S=He([Be(0,g.$ym)],S)}),define(ke[358],Se([1,0,34,17,16,23,234,357,86,5,38]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccb=e.$Bcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Acb=e.$zcb=void 0,e.$zcb=(0,g.$Uh)("editorResolverService"),e.$Acb="workbench.editorAssociations";const P=A.$ln.as(E.$qn.Configuration),f={...p.$rH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};P.registerConfiguration(f);var y;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(y||(e.RegisteredEditorPriority=y={}));var S;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function w(s){switch(s){case y.exclusive:return 5;case y.default:return 4;case y.builtin:return 3;case y.option:default:return 1}}e.$Bcb=w;function c(s,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof s=="string"&&s.indexOf(m.$fc.sep)>=0?`${i.scheme}:${i.path}`:(0,L.$vg)(i);return I.$Aj(typeof s=="string"?s.toLowerCase():s,a.toLowerCase())}e.$Ccb=c}),define(ke[359],Se([1,0,33,17,16,12,23,2,5,269,40,146,155]),function(me,e,I,F,m,L,R,p,E,g,A,P,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.$$J=void 0,e.$$J=(0,E.$Uh)("pathService");let S=y=class{constructor(c,s,i,n){this.d=c,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??c})()}hasValidBasename(c,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(c,n,s)):this.h(c,s,i)}h(c,s,i){return c.scheme===F.Schemas.file||c.scheme===F.Schemas.vscodeRemote?(0,I.$Yf)(i??(0,R.$vg)(c),s===1):!0}get defaultUriScheme(){return y.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(c,s){if(c.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,g.$8J)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=s.getWorkspace().configuration;return o?o.scheme:F.Schemas.file}userHome(c){return c?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(c=>c===1?m.$ec:m.$fc)}async fileURI(c){let s="";if(await this.a===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const n=c.indexOf("/",2);n===-1?(s=c.substring(2),c="/"):(s=c.substring(2,n),c=c.substring(n)||"/")}return p.URI.from({scheme:F.Schemas.file,authority:s,path:c,query:"",fragment:""})}};e.$_J=S,e.$_J=S=y=He([Be(1,f.$ym),Be(2,P.$TJ),Be(3,A.$4h)],S)}),define(ke[360],Se([1,0,236,19,59,4,52,3,2,44,241,15,65,271,88,40,146,25,21,18,24,45]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.$4J=e.$3J=e.OnPortForward=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.TunnelSource=e.TunnelCloseReason=e.$WJ=e.$VJ=e.$UJ=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$UJ="onTunnel",e.$VJ=new a.$_i("forwardedPortsViewEnabled",!1,I.localize(0,null));function d(N){const j=N.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(j)return{host:j[1]?.substring(0,j[1].length-1)||"localhost",port:Number(j[2])}}e.$WJ=d;var u;(function(N){N.Other="Other",N.User="User",N.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var l;(function(N){N[N.User=0]="User",N[N.Auto=1]="Auto",N[N.Extension=2]="Extension"})(l||(e.TunnelSource=l={})),e.$XJ={source:l.User,description:I.localize(1,null)},e.$YJ={source:l.Auto,description:I.localize(2,null)};function h(N,j,M){const O=N.get(D(j,M));if(O)return O;if((0,S.$iv)(j))for(const z of S.$hv){const T=D(z,M);if(N.has(T))return N.get(T)}else if((0,S.$kv)(j))for(const z of S.$jv){const T=D(z,M);if(N.has(T))return N.get(T)}}e.$ZJ=h;function k(N,j,M){const O=h(N,j,M);if(O)return O;const z=(0,S.$kv)(j)?"localhost":(0,S.$iv)(j)?"0.0.0.0":void 0;if(z)return h(N,z,M)}e.$1J=k;function D(N,j){return N+":"+j}e.$2J=D;var $;(function(N){N.Notify="notify",N.OpenBrowser="openBrowser",N.OpenBrowserOnce="openBrowserOnce",N.OpenPreview="openPreview",N.Silent="silent",N.Ignore="ignore"})($||(e.OnPortForward=$={}));function b(N){return N&&"host"in N&&typeof N.host=="string"&&"port"in N&&typeof N.port=="number"&&(!("detail"in N)||typeof N.detail=="string")&&(!("pid"in N)||typeof N.pid=="string")}e.$3J=b;class v extends p.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(j){super(),this.r=j,this.j=[],this.n=new L.$Qd,this.onDidChangeAttributes=this.n.event,this.B(j.onDidChangeConfiguration(M=>{(M.affectsConfiguration(v.c)||M.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(j,M,O){let z=this.w(j,M,O,this.j,0);const T={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;z>=0;){const W=this.j[z];W.key===j?(T.onAutoForward=W.onAutoForward??T.onAutoForward,T.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:T.elevateIfNeeded,T.label=W.label??T.label,T.requireLocalPort=W.requireLocalPort,T.protocol=W.protocol):(T.onAutoForward=T.onAutoForward??W.onAutoForward,T.elevateIfNeeded=T.elevateIfNeeded!==void 0?T.elevateIfNeeded:W.elevateIfNeeded,T.label=T.label??W.label,T.requireLocalPort=T.requireLocalPort!==void 0?T.requireLocalPort:void 0,T.protocol=T.protocol??W.protocol),z=this.w(j,M,O,this.j,z+1)}return T.onAutoForward!==void 0||T.elevateIfNeeded!==void 0||T.label!==void 0||T.requireLocalPort!==void 0||T.protocol!==void 0?T:this.C()}t(j){return j.start!==void 0&&j.end!==void 0}u(j){return j.host!==void 0&&j.port!==void 0&&(0,n.$Bf)(j.host)&&(0,n.$Ff)(j.port)}w(j,M,O,z,T){if(T>=z.length)return-1;const W=!(0,S.$iv)(M)&&!(0,S.$kv)(M),de=z.slice(T).findIndex(ee=>(0,n.$Ff)(ee.key)?W?!1:ee.key===j:this.t(ee.key)?W?!1:j>=ee.key.start&&j<=ee.key.end:this.u(ee.key)?j===ee.key.port&&M===ee.key.host:O?ee.key.test(O):!1);return de>=0?de+T:-1}y(){const j=this.r.getValue(v.c);if(!j||!(0,n.$Df)(j))return[];const M=[];for(const z in j){if(z===void 0)continue;const T=j[z];let W;if(Number(z))W=Number(z);else if((0,n.$Bf)(z))if(v.g.test(z)){const V=z.match(v.g);W={start:Number(V[1]),end:Number(V[2])}}else if(v.h.test(z)){const V=z.match(v.h);W={host:V[1],port:Number(V[2])}}else{let V;try{V=RegExp(z)}catch{}V&&(W=V)}W&&M.push({key:W,elevateIfNeeded:T.elevateIfNeeded,onAutoForward:T.onAutoForward,label:T.label,requireLocalPort:T.requireLocalPort,protocol:T.protocol})}const O=this.r.getValue(v.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(M)}z(j){function M(O,z){return(0,n.$Ff)(O.key)?O.key:z.t(O.key)?O.key.start:z.u(O.key)?O.key.port:Number.MAX_VALUE}return j.sort((O,z)=>M(O,this)-M(z,this))}C(){return this.m}static providedActionToAction(j){switch(j){case S.ProvidedOnAutoForward.Notify:return $.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return $.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return $.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return $.OpenPreview;case S.ProvidedOnAutoForward.Silent:return $.Silent;case S.ProvidedOnAutoForward.Ignore:return $.Ignore;default:return}}async addAttributes(j,M,O){const T=this.r.inspect(v.c).userRemoteValue;let W;!T||!(0,n.$Df)(T)?W={}:W=(0,o.$_m)(T),W[`${j}`]||(W[`${j}`]={});for(const V in M)W[`${j}`][V]=M[V];return this.r.updateValue(v.c,W,O)}}e.$4J=v;let C=class extends p.$Rc{constructor(j,M,O,z,T,W,V,de,ee,Z){super(),this.H=j,this.I=M,this.J=O,this.L=z,this.M=T,this.N=W,this.O=V,this.P=de,this.Q=ee,this.R=Z,this.c=new Map,this.g=new L.$Qd,this.onForwardPort=this.g.event,this.h=new L.$Qd,this.onClosePort=this.h.event,this.j=new L.$Qd,this.onPortName=this.j.event,this.n=new L.$Qd,this.onCandidatesChanged=this.n.event,this.t=new L.$Qd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Qd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new v(O),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async J=>{const ae=await this.getAttributes(J.map(x=>({port:x.tunnelRemotePort,host:x.tunnelRemoteHost})));for(const x of J)if(x.localAddress){const Ee=D(x.tunnelRemoteHost,x.tunnelRemotePort),le=k(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort);this.forwarded.set(Ee,{remotePort:x.tunnelRemotePort,remoteHost:x.tunnelRemoteHost,localAddress:x.localAddress,protocol:ae?.get(x.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(x.localAddress,ae?.get(x.tunnelRemotePort)),localPort:x.tunnelLocalPort,runningProcess:le?.detail,hasRunningProcess:!!le,pid:le?.pid,privacy:x.privacy,source:e.$XJ}),this.f.set(Ee,x)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async J=>{const ae=D(J.tunnelRemoteHost,J.tunnelRemotePort);if(!k(this.forwarded,J.tunnelRemoteHost,J.tunnelRemotePort)&&!k(this.detected,J.tunnelRemoteHost,J.tunnelRemotePort)&&!k(this.c,J.tunnelRemoteHost,J.tunnelRemotePort)&&J.localAddress){const x=k(this.m??new Map,J.tunnelRemoteHost,J.tunnelRemotePort),Ee=(await this.getAttributes([{port:J.tunnelRemotePort,host:J.tunnelRemoteHost}]))?.get(J.tunnelRemotePort);this.forwarded.set(ae,{remoteHost:J.tunnelRemoteHost,remotePort:J.tunnelRemotePort,localAddress:J.localAddress,protocol:Ee?.protocol??S.TunnelProtocol.Http,localUri:await this.X(J.localAddress,Ee),localPort:J.tunnelLocalPort,closeable:!0,runningProcess:x?.detail,hasRunningProcess:!!x,pid:x?.pid,privacy:J.privacy,source:e.$XJ})}await this.$(),this.f.set(ae,J),this.g.fire(this.forwarded.get(ae))})),this.B(this.H.onTunnelClosed(J=>this.W(J,u.Other))),this.U()}S(){return this.Q.extensions.find(j=>j.activationEvents?.includes(e.$UJ))?(this.R.createKey(e.$VJ.key,!0),!0):!1}U(){if(this.S())return;const j=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&j.dispose()}))}async W(j,M){const O=D(j.host,j.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.$(),this.h.fire(j))}X(j,M){if(j.startsWith("http"))return E.URI.parse(j);const O=M?.protocol??"http";return E.URI.parse(`${O}://${j}`)}async Y(){const j=this.N.getWorkspace(),M=j.configuration?(0,R.$Ii)(j.configuration.path):j.folders.length>0?(0,R.$Ii)(j.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${M}`}async Z(){const j=this.I.get(r,1);if(j)return this.I.remove(r,1),await this.$(),j;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=await this.s;if(j&&j!==this.y){const M=JSON.parse(j)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(O=>O.remotePort).join(", ")}`);for(const O of M){const z=k(this.detected,O.remoteHost,O.remotePort);O.source.source!==l.Extension&&!z||O.source.source===l.Extension&&z?await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,privacy:O.privacy,elevateIfNeeded:!0,source:O.source}):O.source.source===l.Extension&&!z&&this.D.set(D(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const j=await this.Y();this.w=this.B(new p.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===j&&(this.s=Promise.resolve(this.I.get(j,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=JSON.stringify(Array.from(this.forwarded.values()));if(j!==this.y){this.y=j;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(j,M,O){if(!j.tunnelLocalPort||!O?.requireLocalPort||j.tunnelLocalPort===M)return;const z=new Date;if(this.ab.getTime()+t>z.getTime())return;this.ab=z;const T=I.localize(3,null,M,j.tunnelRemotePort,j.tunnelLocalPort);return this.P.info(T)}async forward(j,M){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(j,M)}async cb(j,M){await this.Q.activateByEvent(e.$UJ);const O=k(this.forwarded,j.remote.host,j.remote.port);M=M??(M!==null?(await this.getAttributes([j.remote]))?.get(j.remote.port):void 0);const z=j.local!==void 0?j.local:j.remote.port;let T;if(O)return this.eb(O,j,M);{const W=this.L.remoteAuthority,V=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,de=D(j.remote.host,j.remote.port);this.c.set(de,!0),j=this.db(de,j);const ee=await this.H.openTunnel(V,j.remote.host,j.remote.port,void 0,z,j.elevateIfNeeded?j.elevateIfNeeded:M?.elevateIfNeeded,j.privacy,M?.protocol);if(typeof ee=="string")T=ee;else if(ee&&ee.localAddress){const Z=k(this.m??new Map,j.remote.host,j.remote.port),J=ee.protocol?ee.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:M?.protocol??S.TunnelProtocol.Http,ae={remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localPort:ee.tunnelLocalPort,name:M?.label??j.name,closeable:!0,localAddress:ee.localAddress,protocol:J,localUri:await this.X(ee.localAddress,M),runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,source:j.source??e.$XJ,privacy:ee.privacy};return this.forwarded.set(de,ae),this.f.set(de,ee),this.c.delete(de),await this.$(),await this.bb(ee,z,M),this.g.fire(ae),ee}this.c.delete(de)}return T}db(j,M){const O=this.D.has(j)?this.D:this.F.has(j)?this.F:void 0;if(O){const z=O.get(j);O.delete(j),z&&(M.name=z.name??M.name,M.local=("local"in z?z.local:"localPort"in z?z.localPort:void 0)??M.local,M.privacy=z.privacy??M.privacy)}return M}async eb(j,M,O){const z=O?.label??M.name;let T;(function(V){V[V.None=0]="None",V[V.Fire=1]="Fire",V[V.Reopen=2]="Reopen"})(T||(T={}));let W=T.None;switch(z!==j.name&&(j.name=z,W=T.Fire),(O?.protocol||j.protocol!==S.TunnelProtocol.Http)&&O?.protocol!==j.protocol&&(M.source=j.source,W=T.Reopen),M.privacy&&j.privacy!==M.privacy&&(W=T.Reopen),W){case T.Fire:{this.g.fire();break}case T.Reopen:await this.close(j.remoteHost,j.remotePort,u.User),await this.cb(M,O)}return k(this.f,M.remote.host,M.remote.port)}async name(j,M,O){const z=k(this.forwarded,j,M),T=D(j,M);if(z){z.name=O,await this.$(),this.j.fire({host:j,port:M});return}else this.detected.has(T)&&(this.detected.get(T).name=O,this.j.fire({host:j,port:M}))}async close(j,M,O){const z=D(j,M),T=this.forwarded.get(z);return O===u.AutoForwardEnd&&T&&T.source.source===l.Auto&&this.F.set(z,{local:T.localPort,name:T.name,privacy:T.privacy}),await this.H.closeTunnel(j,M),this.W({host:j,port:M},O)}address(j,M){const O=D(j,M);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(j){if(j)for(const M of j){const O=k(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),z=typeof M.localAddress=="string"?M.localAddress:D(M.localAddress.host,M.localAddress.port);this.detected.set(D(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:z,protocol:S.TunnelProtocol.Http,localUri:this.X(z),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:l.Extension,description:I.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,z,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(j){this.r=j}async setCandidates(j){let M=j;this.r&&(M=await this.r(j));const O=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(z=>z.port).join(", ")}`),this.n.fire(O)}fb(j){const M=this.m??new Map,O=new Map;return this.m=O,j.forEach(z=>{const T=D(z.host,z.port);O.set(T,{host:z.host,port:z.port,detail:z.detail,pid:z.pid}),M.has(T)&&M.delete(T);const W=k(this.forwarded,z.host,z.port);W&&(W.runningProcess=z.detail,W.hasRunningProcess=!0,W.pid=z.pid)}),M.forEach((z,T)=>{const W=d(T);if(!W)return;const V=k(this.forwarded,W.host,W.port);V&&(V.runningProcess=void 0,V.hasRunningProcess=!1,V.pid=void 0);const de=k(this.detected,W.host,W.port);de&&(de.runningProcess=void 0,de.hasRunningProcess=!1,de.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const j=Array.from(this.forwarded.values()),M=await this.getAttributes(j.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(M)for(const O of j){const z=M.get(O.remotePort);(z?.protocol||O.protocol!==S.TunnelProtocol.Http)&&z?.protocol!==O.protocol&&await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},z),z&&z.label&&z.label!==O.name&&await this.name(O.remoteHost,O.remotePort,z.label)}}async getAttributes(j,M=!0){const O=new Map,z=new Map;j.forEach(ee=>{const Z=k(this.m??new Map,S.$hv[0],ee.port)??ee;if(Z){O.set(ee.port,Z);const J=b(Z)?Z.pid:void 0;z.has(J)||z.set(J,[]),z.get(J)?.push(ee.port)}});const T=new Map;if(j.forEach(ee=>{const Z=this.configPortsAttributes.getAttributes(ee.port,ee.host,O.get(ee.port)?.detail);Z&&T.set(ee.port,Z)}),this.G.length===0||!M)return T.size>0?T:void 0;const W=await Promise.all((0,F.$Qb)(this.G.map(ee=>Array.from(z.entries()).map(Z=>{const J=Z[1],ae=O.get(J[0]);return ee.providePortAttributes(J,ae?.pid,ae?.detail,new i.$1d().token)})))),V=new Map;if(W.forEach(ee=>ee.forEach(Z=>{Z&&V.set(Z.port,Z)})),!T&&!V)return;const de=new Map;return j.forEach(ee=>{const Z=T.get(ee.port),J=V.get(ee.port);de.set(ee.port,{elevateIfNeeded:Z?.elevateIfNeeded,label:Z?.label,onAutoForward:Z?.onAutoForward??v.providedActionToAction(J?.autoForwardAction),requireLocalPort:Z?.requireLocalPort,protocol:Z?.protocol})}),de}addAttributesProvider(j){this.G.push(j)}};e.$5J=C,He([(0,m.$nh)(1e3)],C.prototype,"$",null),e.$5J=C=He([Be(0,S.$dv),Be(1,y.$$o),Be(2,g.$oi),Be(3,c.$TJ),Be(4,f.$Uk),Be(5,w.$4h),Be(6,P.$cj),Be(7,A.$Hv),Be(8,s.$uF),Be(9,a.$aj)],C)}),define(ke[94],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$RI=e.$QI=void 0;class I{constructor(R,p){this.line=R,this.character=p}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,p){return new I(0,0)}with(R){return new I(0,0)}}e.$QI=I;class F{constructor(R,p,E,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(R,p),this.end=new I(E,g)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$RI=F;var m;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(m||(e.TextSearchCompleteMessageType=m={}))}),define(ke[36],Se([1,0,19,34,24,33,13,5,16,11,94,10]),function(me,e,I,F,m,L,R,p,E,g,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.SearchErrorCode=e.$7I=e.$6I=e.SearchSortOrder=e.ViewMode=e.$5I=e.$4I=e.$3I=e.$2I=e.SearchCompletionExitCode=e.$1I=e.$ZI=e.$YI=e.QueryType=e.SearchProviderType=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$SI="workbench.view.search",e.$TI="workbench.panel.search",e.$UI="workbench.view.search",e.$VI="search-result",e.$WI="search.exclude";const f="\u27EA ",y=" characters skipped \u27EB",S=(f.length+y.length+5)*2;e.$XI=(0,p.$Uh)("searchService");var w;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(w||(e.SearchProviderType=w={}));var c;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(c||(e.QueryType=c={}));function s(J){return!!J.preview}e.$YI=s;function i(J){return!!J.resource}e.$ZI=i;function n(J){return!!J.message}e.$1I=n;var o;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class a{constructor(ae){this.resource=ae,this.results=[]}}e.$2I=a;class t{constructor(ae,x,Ee,le){this.ranges=x,this.webviewIndex=le;const K=Array.isArray(x)?x:[x];if(Ee&&Ee.matchLines===1&&r(K)){ae=(0,R.$uf)(ae,Ee.matchLines);let U="",ne=0,be=0;const G=Math.floor(Ee.charsPerLine/5),Y=[];for(const X of K){const $e=Math.max(X.startColumn-G,0),re=X.startColumn+Ee.charsPerLine;if($e>be+G+S){const fe=f+($e-be)+y;U+=fe+ae.slice($e,re),ne+=$e-(be+fe.length)}else U+=ae.slice(be,re);Y.push(new u(0,X.startColumn-ne,X.endColumn-ne)),be=re}this.preview={text:U,matches:Array.isArray(this.ranges)?Y:Y[0]}}else{const U=Array.isArray(x)?x[0].startLineNumber:x.startLineNumber;this.preview={text:ae,matches:(0,I.$1b)(x,ne=>new d(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$3I=t;function r(J){const ae=J[0].startLineNumber;for(const x of J)if(x.startLineNumber!==ae||x.endLineNumber!==ae)return!1;return!0}class d{constructor(ae,x,Ee,le){this.startLineNumber=ae,this.startColumn=x,this.endLineNumber=Ee,this.endColumn=le}}e.$4I=d;class u extends d{constructor(ae,x,Ee){super(ae,x,ae,Ee)}}e.$5I=u;var l;(function(J){J.List="list",J.Tree="tree"})(l||(e.ViewMode=l={}));var h;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function k(J,ae=!0){const x=J&&J.files&&J.files.exclude,Ee=ae&&J&&J.search&&J.search.exclude;if(!x&&!Ee)return;if(!x||!Ee)return x||Ee;let le=Object.create(null);return le=m.$cn(le,m.$_m(x)),le=m.$cn(le,m.$_m(Ee),!0),le}e.$6I=k;function D(J,ae){return J.excludePattern&&F.$Aj(J.excludePattern,ae)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&F.$Aj(J.includePattern,ae)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(x=>{const Ee=x.folder.fsPath;if(L.$1f(ae,Ee)){const le=E.$kc(Ee,ae);return!x.includePattern||!!F.$Aj(x.includePattern,le)}else return!1}):!1:!0}e.$7I=D;var $;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class b extends Error{constructor(ae,x){super(ae),this.code=x}}e.$8I=b;function v(J){const ae=J.message;if((0,g.$3)(J))return new b(ae,$.canceled);try{const x=JSON.parse(ae);return new b(x.message,x.code)}catch{return new b(ae,$.other)}}e.$9I=v;function C(J){const ae={message:J.message,code:J.code};return new Error(JSON.stringify(ae))}e.$0I=C;function N(J){return J.type==="error"?!0:J.type==="success"}e.$$I=N;function j(J){return J.type==="success"}e.$_I=j;function M(J){return!!J.path}e.$aJ=M;function O(J,ae){const x=J.searchPath?J.searchPath:J.relativePath;return(0,R.$rf)(x,ae)}e.$bJ=O;class z{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$cJ=z;function T(J,ae){const x={...J||{},...ae||{}};return Object.keys(x).filter(Ee=>{const le=x[Ee];return typeof le=="boolean"&&le})}e.$dJ=T;class W{constructor(ae,x){this.c=null,this.a={...ae.excludePattern||{},...x.excludePattern||{}},this.b=F.$Bj(this.a);let Ee=ae.includePattern;x.includePattern&&(Ee?Ee={...Ee,...x.includePattern}:Ee=x.includePattern),Ee&&(this.c=F.$Bj(Ee))}matchesExcludesSync(ae,x,Ee){return!!(this.b&&this.b(ae,x,Ee))}includedInQuerySync(ae,x,Ee){return!(this.b&&this.b(ae,x,Ee)||this.c&&!this.c(ae,x,Ee))}includedInQuery(ae,x,Ee){const le=this.b(ae,x,Ee),K=()=>this.c?!!this.c(ae,x,Ee):!0;return(0,P.$Jg)(le)?le.then(U=>U?!1:K()):K()}hasSiblingExcludeClauses(){return V(this.a)}}e.$eJ=W;function V(J){for(const ae in J)if(typeof J[ae]!="boolean")return!0;return!1}function de(J){if(!J)return;let ae;return x=>(ae||(ae=(J()||Promise.resolve([])).then(Ee=>Ee?Z(Ee):{})),ae.then(Ee=>!!Ee[x]))}e.$fJ=de;function ee(J){if(!J)return;let ae;return x=>{if(!ae){const Ee=J();ae=Ee?Z(Ee):{}}return!!ae[x]}}e.$gJ=ee;function Z(J){const ae={};for(const x of J)ae[x]=!0;return ae}}),define(ke[41],Se([1,0,19,10,21,4,3,78,17,123,23,13,2,223,5,15,254,40,57,27,20,14,7,67,36,6,54]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a,t,r,d,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=void 0;function h(j,M,O){return new A.$ng(z=>b(z,O)).isEqual(j,M)}function k(j,M,O){return h(j.uri,M.uri,O)?0:(0,P.$Xe)(j.uri.toString(),M.uri.toString())}function D(j,M,O){return j.index!==M.index?j.index<M.index?-1:1:h(j.uri,M.uri,O)?(0,P.$Xe)(j.name,M.name):(0,P.$Xe)(j.uri.toString(),M.uri.toString())}function $(j,M,O,z){const T=j.slice(0).sort((V,de)=>O(V,de,z)),W=M.slice(0).sort((V,de)=>O(V,de,z));return(0,I.$Db)(T,W,(V,de)=>O(V,de,z))}function b(j,M){const O=M.getCapabilities(j.scheme);return!(O&&O&1024)}class v extends s.$bi{static toExtHostWorkspace(M,O,z,T){if(!M)return{workspace:null,added:[],removed:[]};const{id:W,name:V,folders:de,configuration:ee,transient:Z,isUntitled:J}=M,ae=[],x=O;O?de.forEach((U,ne)=>{const be=f.URI.revive(U.uri),G=v.o(z||O,be,T);G?(G.name=U.name,G.index=U.index,ae.push(G)):ae.push({uri:be,name:U.name,index:ne})}):ae.push(...de.map(({uri:U,name:ne,index:be})=>({uri:f.URI.revive(U),name:ne,index:be}))),ae.sort((U,ne)=>U.index<ne.index?-1:1);const Ee=new v(W,V,ae,!!Z,ee?f.URI.revive(ee):null,!!J,U=>b(U,T)),{added:le,removed:K}=$(x?x.workspaceFolders:[],Ee.workspaceFolders,k,T);return{workspace:Ee,added:le,removed:K}}static o(M,O,z){for(let T=0;T<M.folders.length;T++){const W=M.workspaceFolders[T];if(h(W.uri,O,z))return W}}constructor(M,O,z,T,W,V,de){super(M,z.map(ee=>new s.$ci(ee)),T,W,de),this.t=O,this.u=V,this.q=[],this.s=p.$1h.forUris(de),z.forEach(ee=>{this.q.push(ee),this.s.set(ee.uri,ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,O){return O&&this.s.get(M)&&(M=(0,A.$xg)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let C=class{constructor(M,O,z,T,W){this.c=new L.$Qd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Qd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Sd,this.B=new Map,this.h=T,this.s=z,this.t=W,this.j=new g.$Vl,this.k=new F.$Vg,this.o=M.getProxy(u.$zK.MainThreadWorkspace),this.q=M.getProxy(u.$zK.MainThreadMessageService);const V=O.workspace;this.l=V?new v(V.id,V.name,[],!!V.transient,V.configuration?f.URI.revive(V.configuration):null,!!V.isUntitled,de=>b(de,z)):void 0}$initializeWorkspace(M,O){this.v=O,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?f.URI.from({scheme:E.Schemas.untitled,path:(0,A.$vg)((0,A.$xg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,O,z,...T){const W=[];if(Array.isArray(T)&&T.forEach(J=>{f.URI.isUri(J.uri)&&!W.some(ae=>h(ae.uri,J.uri,this.s))&&W.push({uri:J.uri,name:J.name||(0,A.$ug)(J.uri)})}),this.n||[O,z].some(J=>typeof J!="number"||J<0)||z===0&&W.length===0)return!1;const V=this.x?this.x.workspaceFolders:[];if(O+z>V.length)return!1;const de=V.slice(0);de.splice(O,z,...W.map(J=>({uri:J.uri,name:J.name||(0,A.$ug)(J.uri),index:void 0})));for(let J=0;J<de.length;J++){const ae=de[J];if(de.some((x,Ee)=>Ee!==J&&h(ae.uri,x.uri,this.s)))return!1}de.forEach((J,ae)=>J.index=ae);const{added:ee,removed:Z}=$(V,de,D,this.s);if(ee.length===0&&Z.length===0)return!1;if(this.o){const J=M.displayName||M.name;this.o.$updateWorkspaceFolders(J,O,z,W).then(void 0,ae=>{this.n=void 0;const x={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(c.Severity.Error,(0,y.localize)(0,null,J,ae.toString()),x,[])})}return this.y(de),!0}getWorkspaceFolder(M,O){if(this.x)return this.x.getWorkspaceFolder(M,O)}async getWorkspaceFolder2(M,O){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,O)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,O){let z,T="";if(typeof M=="string"?(z=f.URI.file(M),T=M):typeof M<"u"&&(z=M,T=M.fsPath),!z)return T;const W=this.getWorkspaceFolder(z,!0);if(!W)return T;typeof O>"u"&&this.x&&(O=this.x.folders.length>1);let V=(0,A.$Ag)(W.uri,z);return O&&W.name&&(V=`${W.name}/${V}`),V}y(M){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:O,added:z,removed:T}=v.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=O||void 0,this.n=void 0,this.c.fire(Object.freeze({added:z,removed:T}))}findFiles(M,O,z,T,W=m.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let V;if(O===null?V=!1:O&&(typeof O=="string"?V=O:V=O.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:ee}=N(a.GlobPattern.from(M));return this.o.$startFileSearch(de??null,ee??null,V??null,z??null,W).then(Z=>Array.isArray(Z)?Z.map(J=>f.URI.revive(J)):[])}async findTextInFiles(M,O,z,T,W=m.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const V=this.j.getNext(),de=typeof O.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:ee,folder:Z}=N(a.GlobPattern.from(O.include)),J=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,ae={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:de,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:ee,excludePattern:J},x=!1;if(this.u[V]=Ee=>{if(x)return;const le=f.URI.revive(Ee.resource);Ee.results.forEach(K=>{const U=(0,l.$rh)(K);(0,d.$YI)(U)?z({uri:le,preview:{text:U.preview.text,matches:(0,I.$1b)(U.preview.matches,ne=>new t.$DK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,I.$1b)(U.ranges,ne=>new t.$DK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):z({uri:le,text:U.text,lineNumber:U.lineNumber})})},W.isCancellationRequested)return{};try{const Ee=await this.o.$startTextSearch(M,Z??null,ae,V,W);return delete this.u[V],Ee||{}}catch(Ee){throw delete this.u[V],Ee}}$handleTextSearchResult(M,O){this.u[O]?.(M)}async save(M){const O=await this.o.$save(M,{saveAs:!1});return f.URI.revive(O)}async saveAs(M){const O=await this.o.$save(M,{saveAs:!0});return f.URI.revive(O)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,O){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,O);const z=this.t.transformOutgoingScheme(M),T=this.z++;return this.o.$registerEditSessionIdentityProvider(T,z),(0,R.$Pc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(M,O){this.h.info("Getting edit session identifier for workspaceFolder",M);const z=await this.resolveWorkspaceFolder(f.URI.revive(M));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const T=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!T),!T)return;const W=await T.provideEditSessionIdentity(z,O);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(M,O,z,T){this.h.info("Getting edit session identifier for workspaceFolder",M);const W=await this.resolveWorkspaceFolder(f.URI.revive(M));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const V=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!V),!V)return;const de=await V.provideEditSessionIdentityMatch?.(O,z,T);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(M){return(O,z,T)=>{const W=function(de){O.call(z,de)};return W.extension=M,this.A.event(W,void 0,T)}}async $onWillCreateEditSessionIdentity(M,O,z){const T=await this.resolveWorkspaceFolder(f.URI.revive(M));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:T},O,async(W,V)=>{const de=Date.now();await Promise.resolve(W),Date.now()-de>z&&this.h.warn("SLOW edit session create-participant",V.extension.identifier)}),O.isCancellationRequested}registerCanonicalUriProvider(M,O){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,O);const z=this.t.transformOutgoingScheme(M),T=this.z++;return this.o.$registerCanonicalUriProvider(T,z),(0,R.$Pc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(M,O,z){const T=this.B.get(M.scheme);if(!T)return;const W=await T.provideCanonicalUri?.(f.URI.revive(M),O,z);if(W)return W}async $provideCanonicalUri(M,O,z){return this.provideCanonicalUri(f.URI.revive(M),{targetScheme:O},z)}};e.$Ldc=C,e.$Ldc=C=He([Be(0,o.$BM),Be(1,n.$RM),Be(2,i.$zdc),Be(3,w.$cj),Be(4,r.$Jdc)],C),e.$Mdc=(0,S.$Uh)("IExtHostWorkspace");function N(j){let M,O;return j&&(typeof j=="string"?M=j:(M=j.pattern,O=f.URI.revive(j.baseUri))),{includePattern:M,folder:O}}}),define(ke[42],Se([1,0,24,4,41,6,7,256,86,18,10,5,20,15,2]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.$Odc=e.$Ndc=void 0;function w(r,d){if(d){const u=d.split(".");let l=r;for(let h=0;l&&h<u.length;h++)l=l[u[h]];return l}}function c(r){return r instanceof S.URI}function s(r){return r&&r.uri instanceof S.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof S.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function o(r){if(c(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(d,u,l){this.a=d.getProxy(L.$zK.MainThreadConfiguration),this.c=u,this.b=l,this.d=new A.$Vg,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,u){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(d,u))}};e.$Ndc=a,e.$Ndc=a=He([Be(0,f.$BM),Be(1,m.$Mdc),Be(2,y.$cj)],a);class t{constructor(d,u,l,h){this.a=new F.$Qd,this.b=d,this.f=h,this.c=u,this.e=p.$Jn.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,u){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Jn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(u,l))}getConfiguration(d,u,l){const h=o(u)||{},k=this.g(d?w(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,l?.identifier);function D(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(b){return typeof w(k,b)<"u"},get:(b,v)=>{this.h(d?`${d}.${b}`:b,h,l?.identifier);let C=w(k,b);if(typeof C>"u")C=v;else{let N;const j=(M,O)=>{if((0,g.$Df)(M)){let z;const T=()=>{N=N||(0,I.$_m)(k),z=z||w(N,O)};return new Proxy(M,{get:(W,V)=>{if(typeof V=="string"&&V.toLowerCase()==="tojson")return T(),()=>z;if(N)return z=z||w(N,O),z[V];const de=W[V];return typeof V=="string"?j(de,`${O}.${V}`):de},set:(W,V,de)=>(T(),z&&(z[V]=de),!0),deleteProperty:(W,V)=>(T(),z&&delete z[V],!0),defineProperty:(W,V,de)=>(T(),z&&Object.defineProperty(z,V,de),!0)})}return Array.isArray(M)?(0,I.$_m)(M):M};C=j(C,b)}return C},update:(b,v,C,N)=>{b=d?`${d}.${b}`:b;const j=D(C);return v!==void 0?this.b.$updateConfigurationOption(j,b,v,h,N):this.b.$removeConfigurationOption(j,b,h,N)},inspect:b=>{b=d?`${d}.${b}`:b;const v=this.e.inspect(b,h,this.c.workspace);if(v)return{key:b,defaultValue:(0,I.$_m)(v.policy?.value??v.default?.value),globalValue:(0,I.$_m)(v.user?.value??v.application?.value),workspaceValue:(0,I.$_m)(v.workspace?.value),workspaceFolderValue:(0,I.$_m)(v.workspaceFolder?.value),defaultLanguageValue:(0,I.$_m)(v.default?.override),globalLanguageValue:(0,I.$_m)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,I.$_m)(v.workspace?.override),workspaceFolderLanguageValue:(0,I.$_m)(v.workspaceFolder?.override),languageIds:(0,I.$_m)(v.overrideIdentifiers)}}};return typeof k=="object"&&(0,I.$cn)($,k,!1),Object.freeze($)}g(d){const u=l=>(0,g.$Df)(l)?new Proxy(l,{get:(h,k)=>u(h[k]),set:(h,k,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(h,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(h,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return u(d)}h(d,u,l){const h=E.$An.test(d)?4:this.d.get(d),k=l?`[${l.value}] `:"";if(h===4){typeof u?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){u?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,u){const l=new p.$Ln(d,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,k)=>l.affectsConfiguration(h,o(k))})}k(d){return d.reduce((u,l)=>(u.set(l[0],l[1]),u),new Map)}}e.$Odc=t,e.$Pdc=(0,P.$Uh)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,10,4,6,7,41,70,42,21,46,20,27,5,17,12,15,91,304,11]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=e.$Lec=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(j){function M(z){if(z!=null)return z}j.from=M;function O(z){if(z!=null)return z}j.to=O})(a||(a={}));var t;(function(j){function M(z){if(z!=null)return z}j.from=M;function O(z){if(z!=null)return z}j.to=O})(t||(t={}));var r;(function(j){function M(z){if(z!=null)return z}j.from=M;function O(z){if(z!=null)return z}j.to=O})(r||(r={}));var d;(function(j){function M(T){if(T){const W=T;return W&&!!W.process}else return!1}j.is=M;function O(T){if(T==null)return;const W={process:T.process,args:T.args};return T.options&&(W.options=r.from(T.options)),W}j.from=O;function z(T){if(T!=null)return new R.$jL(T.process,T.args,T.options)}j.to=z})(d||(d={}));var u;(function(j){function M(z){if(z!=null)return z}j.from=M;function O(z){if(z!=null)return z}j.to=O})(u||(u={}));var l;(function(j){function M(T){if(T){const W=T;return W&&(!!W.commandLine||!!W.command)}else return!1}j.is=M;function O(T){if(T==null)return;const W={};return T.commandLine!==void 0?W.commandLine=T.commandLine:(W.command=T.command,W.args=T.args),T.options&&(W.options=u.from(T.options)),W}j.from=O;function z(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new R.$kL(T.commandLine,T.options):new R.$kL(T.command,T.args?T.args:[],T.options)}j.to=z})(l||(l={}));var h;(function(j){function M(T){if(T){const W=T;return W&&W.customExecution==="customExecution"}else return!1}j.is=M;function O(T){return{customExecution:"customExecution"}}j.from=O;function z(T,W){return W.get(T)}j.to=z})(h||(e.CustomExecutionDTO=h={}));var k;(function(j){function M(O,z){let T;return O.scope!==void 0&&typeof O.scope!="number"?T=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===R.TaskScope.Workspace&&z&&z.workspaceFile?T=z.workspaceFile:T=n.$0F),{id:O._id,workspaceFolder:T}}j.from=M})(k||(e.TaskHandleDTO=k={}));var D;(function(j){function M(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}j.from=M})(D||(D={}));var $;(function(j){function M(T,W){if(T==null)return[];const V=[];for(const de of T){const ee=O(de,W);ee&&V.push(ee)}return V}j.fromMany=M;function O(T,W){if(T==null)return;let V;T.execution instanceof R.$jL?V=d.from(T.execution):T.execution instanceof R.$kL?V=l.from(T.execution):T.execution&&T.execution instanceof R.$lL&&(V=h.from(T.execution));const de=a.from(T.definition);let ee;return T.scope?typeof T.scope=="number"?ee=T.scope:ee=T.scope.uri:ee=R.TaskScope.Workspace,!de||!ee?void 0:{_id:T._id,definition:de,name:T.name,source:{extensionId:W.identifier.value,label:T.source,scope:ee},execution:V,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}j.from=O;async function z(T,W,V){if(T==null)return;let de;d.is(T.execution)?de=d.to(T.execution):l.is(T.execution)?de=l.to(T.execution):h.is(T.execution)&&(de=h.to(T._id,V));const ee=a.to(T.definition);let Z;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Z=T.source.scope:Z=await W.resolveWorkspaceFolder(I.URI.revive(T.source.scope)):Z=R.TaskScope.Workspace),!ee||!Z)return;const J=new R.$mL(ee,Z,T.name,T.source.label,de,T.problemMatchers);return T.isBackground!==void 0&&(J.isBackground=T.isBackground),T.group!==void 0&&(J.group=R.$iL.from(T.group._id),J.group&&T.group.isDefault&&(J.group=new R.$iL(J.group.id,J.group.label),T.group.isDefault===!0&&(J.group.isDefault=T.group.isDefault))),T.presentationOptions&&(J.presentationOptions=t.to(T.presentationOptions)),T._id&&(J._id=T._id),T.detail&&(J.detail=T.detail),J}j.to=z})($||(e.TaskDTO=$={}));var b;(function(j){function M(z){return z}j.from=M;function O(z){if(z)return Object.assign(Object.create(null),z)}j.to=O})(b||(b={}));class v{#e;constructor(M,O,z){this._id=O,this.a=z,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let C=class{constructor(M,O,z,T,W,V,de,ee){this.q=new m.$Qd,this.r=new m.$Qd,this.s=new m.$Qd,this.t=new m.$Qd,this.a=M.getProxy(L.$zK.MainThreadTask),this.b=z,this.c=T,this.d=W,this.e=V,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,O,z){if(!z)return new R.$BK(()=>{});const T=this.w();return this.j.set(T,{type:O,provider:z,extension:M}),this.a.$registerTaskProvider(T,O),new R.$BK(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(M,O){this.a.$registerTaskSystem(M,O)}fetchTasks(M){return this.a.$fetchTasks(b.from(M)).then(async O=>{const z=[];for(const T of O){const W=await $.to(T,this.b,this.m);W&&z.push(W)}return z})}get taskExecutions(){const M=[];return this.k.forEach(O=>M.push(O)),M}terminateTask(M){if(!(M instanceof v))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,O,z){const T=this.m.get(M.id);T&&(this.o.set(M.id,T),this.e.attachPtyToTerminal(O,await T.callback(z))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const O=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const O=await this.y(M.id);this.s.fire({execution:O,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const O=await this.y(M.id);this.t.fire({execution:O,exitCode:M.exitCode})}$provideTasks(M,O){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));const T=[],W=(0,F.$Pg)(()=>z.provider.provideTasks(A.CancellationToken.None)).then(V=>this.u(O,T,z,V));return new Promise(V=>{W.then(de=>{Promise.all(T).then(()=>{V(de)})})})}async $resolveTask(M,O){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));if(O.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${z.type}].`);const T=await $.to(O,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const W=await z.provider.resolveTask(T,A.CancellationToken.None);if(!W)return;this.z(W,z);const V=$.from(W,z.extension);if(!V)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(V.execution)&&await this.x(V,W,!0),await this.v(V)}w(){return this.h++}async x(M,O,z){const T=await this.a.$createTaskId(M);!z&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,O.execution)),this.m.set(T,O.execution)}async y(M,O){if(typeof M=="string"){const W=this.l.get(M);if(!W)throw new o.$ab("Unexpected: The specified task is missing an execution");return W}const z=this.l.get(M.id);if(z)return z;const T=new Promise((W,V)=>{function de(ee,Z,J){J?W(new v(ee,Z.id,J)):V("Unexpected: Task does not exist.")}O?de(this,M,O):$.to(M.task,this.b,this.m).then(ee=>de(this,M,ee))});return this.l.set(M.id,T),T.then(W=>(this.k.set(M.id,W),W),W=>Promise.reject(W))}z(M,O){M._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const z=this.n.values();let T=z.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=z.next()}};e.$Lec=C,e.$Lec=C=He([Be(0,f.$BM),Be(1,y.$RM),Be(2,p.$Mdc),Be(3,E.$MM),Be(4,g.$Pdc),Be(5,P.$8dc),Be(6,s.$cj),Be(7,i.$Cdc)],C);let N=class extends C{constructor(M,O,z,T,W,V,de,ee){super(M,O,z,T,W,V,de,ee),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:c.$h(0)})}async executeTask(M,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const z=$.from(O,M);if(z===void 0)throw new Error("Task is not valid");if(h.is(z.execution))await this.x(z,O,!1);else throw new o.$$;const T=await this.y(await this.a.$getTaskExecution(z),O);return this.a.$executeTask(z).catch(W=>{throw new Error(W)}),T}u(M,O,z,T){const W=[];if(T)for(const V of T){if(this.z(V,z),!V.definition||!M[V.definition.type]){const ee=V.source?V.source:"No task source";this.f.warn(`The task [${ee}, ${V.name}] uses an undefined task type. The task will be ignored in the future.`)}const de=$.from(V,z.extension);de&&h.is(de.execution)?(W.push(de),O.push(this.x(de,V,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:z.extension}}async v(M){if(h.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,O,z){}};e.$Mec=N,e.$Mec=N=He([Be(0,f.$BM),Be(1,y.$RM),Be(2,p.$Mdc),Be(3,E.$MM),Be(4,g.$Pdc),Be(5,P.$8dc),Be(6,s.$cj),Be(7,i.$Cdc)],N),e.$Nec=(0,S.$Uh)("IExtHostTask")}),define(ke[361],Se([1,0,36,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xK=e.$wK=e.$vK=void 0;function m(R){return"cellResults"in R}e.$vK=m,e.$wK="rawCell#";function L(R,p){let E=-1;const g=[];let A=[];return R.forEach(f=>{f.range.startLineNumber!==E&&A.length>0&&(g.push([...A]),A=[]),A.push(f),E=f.range.endLineNumber}),A.length>0&&g.push([...A]),g.map(f=>{const y=[],S=f[0].range.startLineNumber,w=f[f.length-1].range.endLineNumber;for(let c=S;c<=w;c++)y.push(p.getLineContent(c));return new I.$3I(y.join(`
`)+`
`,f.map(c=>new F.$zs(c.range.startLineNumber-1,c.range.startColumn-1,c.range.endLineNumber-1,c.range.endColumn-1)))})}e.$xK=L}),define(ke[362],Se([1,0,216,22,4,3,28,13,18,2,31,110,6,35,14,7,69,296,148,11,24,17,288,361,358]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,k,D,$,b,v){this.q=D,this.r=$,this.s=b,this.t=v,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new m.$Qd({onListenerError:n.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new m.$Qd({onListenerError:n.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new m.$Qd({onListenerError:n.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new m.$Qd({onListenerError:n.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$wdc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy(f.$zK.MainThreadNotebook),this.c=h.getProxy(f.$zK.MainThreadNotebookDocuments),this.d=h.getProxy(f.$zK.MainThreadNotebookEditors),this.i=k.converter,k.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const N=C.notebookEditor?.notebookUri,j=C.cell.handle,O=this.g.get(N)?.getCell(j);if(O)return O.apiCell}if(C&&C.$mid===14){const N=C.uri,j=this.g.get(N);if(j)return j.apiNotebook}return C}}),u.B(k)}getEditorById(h){const k=this.h.get(h);if(!k)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return k}getIdByEditor(h){for(const[k,D]of this.h)if(D.apiEditor===h)return k}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,k){const D=this.g.get(h);if(!D&&!k)throw new Error(`NO notebook document for '${h}'`);return D}static u(h,k){if(!k)return;const D=k.filenamePattern.map($=>S.NotebookExclusiveDocumentPattern.from($)).filter($=>$!==void 0);if(k.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${k.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:k.displayName,filenamePattern:D,exclusive:k.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,k,D){const $=u.a++,b=typeof D.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set($,D),this.b.$registerNotebookCellStatusBarItemProvider($,b,k);let v;return b!==void 0&&(v=D.onDidChangeCellStatusBarItems(C=>this.b.$emitCellStatusBarEvent(b))),new w.$BK(()=>{this.f.delete($),this.b.$unregisterNotebookCellStatusBarItemProvider($,b),v?.dispose()})}async createNotebookDocument(h){const k=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&S.NotebookData.from(h.content)});return g.URI.revive(k)}async openNotebookDocument(h){const k=this.g.get(h);if(k)return k.apiNotebook;const D=await this.c.$tryOpenNotebook(h),$=this.g.get(g.URI.revive(D));return(0,E.$Mf)($?.apiNotebook)}async showNotebookDocument(h,k){g.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let D;typeof k=="object"?D={position:S.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selections:k.selections&&k.selections.map(S.NotebookRange.from),pinned:typeof k.preview=="boolean"?!k.preview:void 0}:D={preserveFocus:!1};const $=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,D),b=$&&this.h.get($)?.apiEditor;if(b)return b;throw $?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,k,D,$){const b=this.f.get(h),v=g.URI.revive(k),C=this.g.get(v);if(!C||!b)return;const N=C.getCellFromIndex(D);if(!N)return;const j=await b.provideCellStatusBarItems(N.apiCell,$);if(!j)return;const M=new L.$Qc,O=this.p.add([M]),T=(Array.isArray(j)?j:[j]).map(W=>S.NotebookStatusBarItem.from(W,this.i,M));return{cacheId:O,items:T}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,k,D,$,b){if((0,p.$Ee)(k))throw new Error("viewType cannot be empty or just whitespace");const v=this.w++;return this.x.set(v,{viewType:k,serializer:D,options:$}),this.b.$registerNotebookSerializer(v,{id:h.identifier,location:h.extensionLocation},k,S.NotebookDocumentContentOptions.from($),u.u(h,b)),(0,L.$Pc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(h,k,D){const $=this.x.get(h);if(!$)throw new Error("NO serializer found");const b=await $.serializer.deserializeNotebook(k.buffer,D);return new c.$wv(S.NotebookData.from(b))}async $notebookToData(h,k,D){const $=this.x.get(h);if(!$)throw new Error("NO serializer found");const b=await $.serializer.serializeNotebook(S.NotebookData.to(k.value),D);return F.$ee.wrap(b)}async $saveNotebook(h,k,D,$,b){const v=g.URI.revive(k),C=this.x.get(h);if(!C)throw new Error("NO serializer found");const N=this.g.get(v);if(!N)throw new Error("Document NOT found");if(N.versionId!==D)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new A.$yk((0,I.localize)(0,null,this.z(v)),6);await this.y(v,$);const j={metadata:(0,o.$hn)(N.apiNotebook.metadata,W=>!(C.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of N.apiNotebook.getCells()){const V=new w.$ZL(W.kind,W.document.getText(),W.document.languageId,W.mime,C.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);V.metadata=(0,o.$hn)(W.metadata,de=>!(C.options?.transientCellMetadata??{})[de]),j.cells.push(V)}const M=await C.serializer.serializeNotebook(j,b);await this.s.value.writeFile(v,M);const O=this.s.getFileSystemProviderExtUri(v.scheme),z=await this.s.value.stat(v);return{name:O.basename(v),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$Jk({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(h,k,D,$,b){const v=this.x.get(h)?.serializer;if(!v)return{limitHit:!1,results:[]};const C=new R.$Ac;await(async(z,T,W)=>{await Promise.all(z.map(async V=>await Promise.all(V.filenamePatterns.map(de=>{const ee={...W,type:1,filePattern:de};return this.t.doInternalFileSearchWithCustomCallback(ee,T,Z=>{Z.forEach(J=>{C.has(J)||$.some(x=>V.isFromSettings&&!x.isFromSettings?!1:x.filenamePatterns.some(Ee=>(0,d.$Ccb)(Ee,J)))||C.add(J)})})}))))})(D,b,k);const j=new R.$zc;let M=!1;const O=Array.from(C).map(async z=>{const T=[];try{if(b.isCancellationRequested)return;if(k.maxResults&&[...j.values()].reduce((ee,Z)=>ee+Z.cellResults.length,0)>k.maxResults){M=!0;return}const W=[],V=this.g.get(z);if(V)V.apiNotebook.getCells().forEach(Z=>W.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(J=>J.items.map(ae=>ae.data.toString()))}));else{const ee=await this.s.value.readFile(z),Z=F.$ee.fromString(ee.toString()),J=await v.deserializeNotebook(Z.buffer,b);if(b.isCancellationRequested)return;S.NotebookData.from(J).cells.forEach(x=>W.push({input:x.source,outputs:x.outputs.flatMap(Ee=>Ee.items.map(le=>le.valueBytes.toString()))}))}if(b.isCancellationRequested)return;W.forEach((ee,Z)=>{const J=k.contentPattern.pattern,ae=new t.$LOb(ee.input,void 0,ee.outputs),x=ae.findInInputs(J),Ee=ae.findInOutputs(J),le=Ee.flatMap(K=>(0,r.$xK)(K.matches,K.textBuffer)).map((K,U)=>(K.webviewIndex=U,K));if(x.length>0||Ee.length>0){const K={index:Z,contentResults:(0,r.$xK)(x,ae.inputTextBuffer),webviewResults:le};T.push(K)}});const de={resource:z,cellResults:T};j.set(z,de);return}catch{return}});return await Promise.all(O),{limitHit:M,results:[...j.values()]}}async y(h,k){const D=await this.s.value.stat(h);if(typeof k?.mtime=="number"&&typeof k.etag=="string"&&k.etag!==A.$Ik&&typeof D.mtime=="number"&&typeof D.size=="number"&&k.mtime<D.mtime&&k.etag!==A.$Jk({mtime:k.mtime,size:D.size}))throw new A.$yk((0,I.localize)(1,null),3,k)}z(h){return h.scheme===a.Schemas.file?h.fsPath:h.toString()}A(h,k,D){if(this.h.has(k))throw new Error(`editor with id ALREADY EXSIST: ${k}`);const $=new i.$8ec(k,this.d,h,D.visibleRanges.map(S.NotebookRange.to),D.selections.map(S.NotebookRange.to),typeof D.viewColumn=="number"?S.ViewColumn.to(D.viewColumn):void 0);this.h.set(k,$)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const D of h.value.removedDocuments){const $=g.URI.revive(D),b=this.g.get($);b&&(b.dispose(),this.g.delete($),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(b.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===$.toString()&&this.h.delete(v.id)}if(h.value.addedDocuments){const D=[];for(const $ of h.value.addedDocuments){const b=g.URI.revive($.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const v=new s.$7ec(this.c,this.q,this.r,b,$);D.push(...$.cells.map(C=>s.$6ec.asModelAddData(v.apiNotebook,C))),this.g.get(b)?.dispose(),this.g.set(b,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this.m.fire(v.apiNotebook)}}if(h.value.addedEditors)for(const D of h.value.addedEditors){if(this.h.has(D.id))return;const $=g.URI.revive(D.documentUri),b=this.g.get($);b&&this.A(b,D.id,D)}const k=[];if(h.value.removedEditors)for(const D of h.value.removedEditors){const $=this.h.get(D);$&&(this.h.delete(D),this.k?.id===$.id&&(this.k=void 0),k.push($))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map($=>this.h.get($)).filter($=>!!$);const D=new Set;this.l.forEach($=>D.add($.id));for(const $ of this.h.values()){const b=D.has($.id);$._acceptVisibility(b)}this.l=[...this.h.values()].map($=>$).filter($=>$.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const k=y.$ZM.String.with("notebookType","A notebook type"),D=new y.$2M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[k,new y.$ZM("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>F.$ee.wrap(b))],new y.$1M("Notebook Data",b=>S.NotebookData.to(b.value))),$=new y.$2M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[k,new y.$ZM("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new c.$wv(S.NotebookData.from(b)))],new y.$1M("Bytes",b=>b.buffer));h.registerApiCommand(D),h.registerApiCommand($)}}e.$9ec=u}),define(ke[363],Se([1,0,16,21,43,34,23,37,36]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class g{constructor(f,y,S){this.k=f,this.l=y,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&L.$Bj(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&L.$Bj(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const y=this.k.folderQueries||[];return new Promise((S,w)=>{const c=s=>{this.f++,f(s)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=I.$mc(i);this.j&&this.j(i,n)||this.v(c,{base:s,basename:n})}),Promise.all(y.map(s=>this.p(s,c))).then(s=>{S({limitHit:this.e,stats:s[0]||void 0})},s=>{w(new Error((0,m.$Fi)(s)))})})}async p(f,y){const S=new F.$1d,w=this.q(f),c=this.r(),s=new E.$eJ(this.k,f),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(S),n=p.$Md.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},w,S.token),a=n.elapsed(),t=p.$Md.create();return this.g&&!this.e||(o&&o.forEach(r=>{const d=I.$fc.relative(f.folder.path,r.path);if(i){const u=I.$mc(r.path);this.v(y,{base:f.folder,relativePath:d,basename:u});return}this.s(c,f.folder,d,y)}),this.g&&!this.e)?null:(this.u(c,s,y),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(f){const y=(0,E.$dJ)(this.k.includePattern,f.includePattern),S=(0,E.$dJ)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:S,includes:y,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},y,S,w){if(S===this.a){const s=I.$mc(this.a);this.v(w,{base:y,relativePath:this.a,basename:s})}function c(s){const i=I.$mc(s),n=I.$lc(s);let o=f[n];o||(o=f[n]=[],c(n)),o.push({base:y,relativePath:s,basename:i})}c(S)}u({rootEntries:f,pathToEntries:y},S,w){const c=this,s=this.a;function i(n){const o=(0,E.$gJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const r=n[a],{relativePath:d,basename:u}=r;if(S.matchesExcludesSync(d,u,s!==u?o:void 0))continue;const l=y[d];if(l)i(l);else{if(d===s)continue;c.v(w,r)}if(c.e)break}}i(f)}v(f,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(y))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(f,y,S,w){const c=this.c(f.cacheKey),s=new g(f,y,c&&c.token);let i=0;const n=o=>{i+=o.length,S(o.map(a=>this.d(a)))};return this.e(s,A.a,n,w).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(f){this.c(f)?.cancel()}c(f){if(f)return this.b.has(f)||this.b.set(f,new F.$1d),this.b.get(f)}d(f){return f.relativePath?{resource:R.$yg(f.base,f.relativePath)}:{resource:f.base}}e(f,y,S,w){const c=w.onCancellationRequested(()=>{f.cancel()}),s=n=>{n&&(i.push(n),y>0&&i.length>=y&&(S(i),i=[]))};let i=[];return f.search(s).then(n=>(i.length&&S(i),c.dispose(),n),n=>(i.length&&S(i),c.dispose(),Promise.reject(n)))}}e.$Xec=A}),define(ke[364],Se([1,0,19,74,34,102,28,17,16,23,13,18,2,99,237,44,15,40,145,359,36]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$aK=void 0;let a=class{constructor(b,v,C,N,j){this.a=b,this.b=v,this.c=C,this.d=N,this.e=j}text(b,v,C={}){b=this.f(b,C);const N=this.a.getValue(),j=v&&v.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(v?.map(s.$di),C),type:2,contentPattern:b,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:N.search.usePCRE2||j||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(b,v){const C=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const N={...b,wordSeparators:C.editor.wordSeparators};return this.j(b,v)&&(N.isCaseSensitive=!0),this.k(b)&&(N.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),N}file(b,v={}){return{...this.h(b,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}g(b,v){return b?(b=Array.isArray(b)?b.map(l):l(b),v?this.parseSearchPaths(b):{pattern:r(...Array.isArray(b)?b:[b])}):{}}h(b=[],v={}){const C=this.g(v.includePattern,v.expandPatterns),N=this.g(v.excludePattern,v.expandPatterns),j=b.length>1,M=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(T=>this.q(T,v,N)):b.map(T=>this.r(T,v,N,j))).filter(T=>!!T),O={_reason:v._reason,folderQueries:M,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:N.pattern,includePattern:C.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const T=I.$Gb(I.$Qb(this.c.groups.map(de=>de.editors.map(ee=>ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const W=T.filter(de=>(0,o.$7I)(O,de.fsPath)),V=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...O,...V}}const z=v.extraFileResources&&v.extraFileResources.filter(T=>(0,o.$7I)(O,T.fsPath));return O.extraFileResources=z&&z.length?z:void 0,O}i(b){const v=[],C=new R.$zc,N={};let j=!1;return b.forEach(M=>{if(M.scheme===p.Schemas.walkThrough)return;if((0,g.$Cg)(M)){const z=this.b.getWorkspaceFolder(M)?.uri??M.with({path:E.$lc(M.fsPath)});let T=C.get(z);T||(j=!0,T={folder:z,includePattern:{}},v.push(T),C.set(z,T));const W=E.$kc(z.fsPath,M.fsPath);(0,P.$Mf)(T.includePattern)[W.replace(/\\/g,"/")]=!0}else M.fsPath&&(j=!0,N[M.fsPath]=!0)}),{folderQueries:v,includePattern:N,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(b,v){if(v.isSmartCase){if(b.isRegExp){if(A.$sf(b.pattern,!0))return!0}else if(A.$sf(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,y.$BB)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const v=V=>E.$hc(V)||/^\.\.?([\/\\]|$)/.test(V),N=(Array.isArray(b)?b:d(b)).map(V=>{const de=this.e.resolvedUserHome;return de?(0,L.$Av)(V,de.scheme===p.Schemas.file?de.fsPath:de.path):V}),j=F.$J(N,V=>v(V)?"searchPaths":"exprSegments"),M=(j.exprSegments||[]).map(V=>A.$Ne(V,"/")).map(V=>A.$Ne(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),u(V))),O={},z=this.m(j.searchPaths||[]);z&&z.length&&(O.searchPaths=z);const T=I.$Qb(M),W=r(...T);return W&&(O.pattern=W),O}l(b,v){return v.disregardExcludeSettings?void 0:(0,o.$6I)(b,!v.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const v=b.flatMap(N=>{let{pathPortion:j,globPortion:M}=t(N);return M&&(M=h(M)),this.n(j).flatMap(z=>this.o(z,M))}),C=new Map;return v.forEach(N=>{const j=N.searchPath.toString(),M=C.get(j);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):C.set(j,{searchPath:N.searchPath,pattern:N.pattern?r(N.pattern):void 0})}),Array.from(C.values())}n(b){if(E.$hc(b)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==p.Schemas.file?[{searchPath:v[0].uri.with({path:b})}]:[{searchPath:f.URI.file(E.$gc(b))}]}if(this.b.getWorkbenchState()===2){const v=this.b.getWorkspace().folders[0].uri;if(b=l(b),b.startsWith("../")||b===".."){const N=E.$fc.resolve(v.path,b);return[{searchPath:v.with({path:N})}]}const C=h(b);return[{searchPath:v,pattern:C}]}else{if(b==="./"||b===".\\")return[];{const v=b.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(j=>{const M=v.match(new RegExp(`^${A.$Ie(j.name)}(?:/(.*)|$)`));return M?{match:M,folder:j}:null}).filter(P.$Jf);if(N.length)return N.map(j=>{const M=j.match[1];return{searchPath:j.folder.uri,pattern:M&&h(M)}});{const j=b.match(/\.[\/\\](.+)[\/\\]?/),M=j?j[1]:b,O=S.localize(0,null,M);throw new Error(O)}}}}o(b,v){const C=b.pattern&&v?`${b.pattern}/${v}`:b.pattern||v,N=[{searchPath:b.searchPath,pattern:C}];return C&&!C.endsWith("**")&&N.push({searchPath:b.searchPath,pattern:C+"/**"}),N}q(b,v,C){const N=this.r((0,s.$di)(b.searchPath),v,C,!1);return N?{...N,includePattern:b.pattern}:null}r(b,v,C,N){let j;const M=f.URI.isUri(b)?b:b.uri;if(C.searchPaths){const V=C.searchPaths.filter(de=>(0,g.$rg)(de.searchPath,M))[0];if(V&&!V.pattern)return null;V&&(j=V.pattern)}const O=this.a.getValue({resource:M}),T={...this.l(O,v)||{},...j||{}},W=f.URI.isUri(b)?(0,g.$vg)(b):b.name;return{folder:M,folderName:N?W:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!O.search.followSymlinks}}};e.$aK=a,e.$aK=a=He([Be(0,w.$oi),Be(1,s.$4h),Be(2,i.$FC),Be(3,c.$cj),Be(4,n.$$J)],a);function t($){const b=$.match(/[\*\{\}\(\)\[\]\?]/);if(b){const v=b.index,C=$.substr(0,v).match(/[/|\\][^/\\]*$/);if(C){let N=$.substr(0,C.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:$.substr((C.index||0)+1)}}}return{pathPortion:$}}function r(...$){return $.length?$.reduce((b,v)=>(b[v]=!0,b),Object.create(null)):void 0}function d($){return m.$zj($,",").map(b=>b.trim()).filter(b=>!!b.length)}function u($){return[`**/${$}/**`,`**/${$}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function l($){return $.replace(/\\/g,"/")}function h($){return l($).replace(/^\.\//,"").replace(/\/+$/g,"")}function k($){return $.replace(/([?*[\]])/g,"[$1]")}function D($,b){$=I.$Lb($,N=>N.toString());const v=[],C=b.getWorkspace();return $&&$.forEach(N=>{let j;if(b.getWorkbenchState()===2)j=(0,g.$Ag)(C.folders[0].uri,N),j&&j!=="."&&(j="./"+j);else{const M=b.getWorkspaceFolder(N);if(M){const O=M.name;if(C.folders.filter(T=>T.name===O).length===1){const T=(0,g.$Ag)(M.uri,N);T===""?j=`./${M.name}`:j=`./${M.name}/${T}`}else j=N.fsPath}}j&&v.push(k(j))}),v}e.$bK=D}),define(ke[365],Se([1,0,23,2,21,11,5,364,36,40]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qb=e.$9qb=void 0;const A=7e3;function P(w,c){const s=c.activationEvents;if(!s)return Promise.resolve(void 0);const i=[],n=[];for(const u of s)if(/^workspaceContains:/.test(u)){const l=u.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||w.forceUsingSearch?n.push(l):i.push(l)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let o;const a=new Promise((u,l)=>{o=u}),t=u=>o({activationEvent:u}),r=Promise.all(i.map(u=>f(w,u,t))).then(()=>{}),d=y(w,c.identifier,n,t);return Promise.all([r,d]).then(()=>{o(void 0)}),a}e.$9qb=P;async function f(w,c,s){for(const i of w.folders)if(await w.exists(I.$yg(F.URI.revive(i),c))){s(`workspaceContains:${c}`);return}}async function y(w,c,s,i){if(s.length===0)return Promise.resolve(void 0);const n=new m.$1d,o=w.checkExists(w.folders,s,n.token),a=setTimeout(async()=>{n.cancel(),w.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},A);let t=!1;try{t=await o}catch(r){L.$3(r)||L.$Z(r)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${s.join(",")}`)}function S(w,c,s,i){const n=w.get(R.$Th),o=w.get(E.$XI),t=n.createInstance(p.$aK).file(c.map(r=>(0,g.$di)(F.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return o.fileSearch(t,i).then(r=>!!r.limitHit,r=>L.$3(r)?!1:Promise.reject(r))}e.$0qb=S}),define(ke[47],Se([1,0,213,16,56,23,10,3,78,2,15,6,42,294,118,41,25,147,11,26,22,273,7,65,5,27,92,20,107,73,46,4,365,117,275,17,115,37,12,116]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a,t,r,d,u,l,h,k,D,$,b,v,C,N,j,M,O,z,T){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=e.$jec=e.$iec=e.$hec=e.$gec=void 0,e.$gec=(0,d.$Uh)("IHostUtils");let V=W=class extends p.$Rc{constructor(K,U,ne,be,G,Y,X,$e,re,fe,te,he){super(),this.X=he,this.a=this.B(new b.$Qd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ne,this.f=X,this.j=be,this.m=G,this.s=Y,this.t=re,this.u=fe,this.w=te,this.y=this.g.getProxy(P.$zK.MainThreadWorkspace),this.z=this.g.getProxy(P.$zK.MainThreadTelemetry),this.C=this.g.getProxy(P.$zK.MainThreadExtensionService),this.D=new R.$Vg,this.F=new R.$Vg,this.G=new R.$Vg,this.H=new R.$Vg,this.I=new Ee(this.f.extensions.activationEvents),this.L=new s.$N5b(this.I,this.f.extensions.allExtensions);const pe=new n.$_l(this.f.extensions.myExtensions);this.J=new s.$N5b(this.I,ae(this.L,pe)),z.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new S.$Zdc(this.g,this.s),this.N=new C.$_dc(this.g),this.O=$e,this.h=K.createChild(new k.$Sh([S.$1dc,this.M],[C.$aec,this.N])),this.P=this.B(new y.$Ydc(this.J,this.L,{onExtensionActivationError:(Pe,B,Q)=>{this.C.$onExtensionActivationError(Pe,i.$2(B),Q)},actualActivateExtension:async(Pe,B)=>{if(s.$N5b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new y.$Xdc;const Q=this.J.getExtensionDescription(Pe);return this.db(Q,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),m.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$Z(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this.cb(G))}catch{}await Promise.all(K)}terminate(K,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$Xg)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const U=await this.C.$getExtension(K);return U&&{...U,identifier:new n.$$l(U.identifier.value),extensionLocation:g.URI.revive(U.extensionLocation)}}Z(K,U){return this.P.activateByEvent(K,U)}$(K,U){return this.P.activateById(K,U)}activateByIdWithErrors(K,U){return this.$(K,U).then(()=>{const ne=this.P.getActivatedExtension(K);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===j.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(K.fsPath);return g.URI.file(U)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new x(K))),this.Q}async bb(K){const U=E.$1h.forUris(ne=>L.$pg.ignorePathCasing(ne));return await Promise.all(K.map(async ne=>{if(this.ub(ne)){const be=await this.ab(ne.extensionLocation);U.set(be,ne)}})),U}cb(K){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return U;const ne=this.P.getActivatedExtension(K);if(!ne)return U;try{typeof ne.module.deactivate=="function"&&(U=Promise.resolve(ne.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(be)}try{(0,p.$Mc)(ne.subscriptions)}catch(be){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(be)}return U}async db(K,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,U).then(ne=>{const be=ne.activationTimes;return this.C.$onDidActivateExtension(K.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,U),this.eb(K,U,"success",be),ne},ne=>{throw this.eb(K,U,"failure"),ne})}eb(K,U,ne,be){const G=ee(K,U);this.z.$publicLog2("extensionActivationTimes",{...G,...be||{},outcome:ne})}fb(K,U){const ne=ee(K,U);this.z.$publicLog2("activatePlugin",ne);const be=this.ub(K);if(!be)return Promise.resolve(new y.$Wdc(y.$Tdc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${K.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const G=new y.$Udc(U.startup);return Promise.all([this.vb(K,(0,L.$yg)(K.extensionLocation,be),G),this.gb(K)]).then(Y=>(m.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),W.hb(this.s,K.identifier,Y[0],Y[1],G))).then(Y=>(m.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),Y))}gb(K){const U=new a.$3dc(K,this.M),ne=new a.$2dc(K.identifier.value,!1,this.M),be=new N.$bec(K,this.N),G=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Y=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([U.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const X=this;let $e,re;const fe=(0,c.$xF)(K,"ipc")?this.f.messagePorts?.get(n.$$l.toKey(K.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ne,secrets:be,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(te){return F.$ic(K.extensionLocation.fsPath,te)},get storagePath(){return X.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return X.O.globalValue(K).fsPath},get logPath(){return F.$ic(X.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return g.URI.joinPath(X.f.logsLocation,K.identifier.value)},get storageUri(){return X.O.workspaceValue(K)},get globalStorageUri(){return X.O.globalValue(K)},get extensionMode(){return G},get extension(){return $e===void 0&&($e=new J(X,K.identifier,K,Y,!1)),$e},get extensionRuntime(){return(0,c.$yF)(K,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!re){if(!fe)return;const te=b.Event.buffer(b.Event.fromDOMEventEmitter(fe,"message",he=>he.data));fe.start(),re={onDidReceiveMessage:te,postMessage:fe.postMessage.bind(fe)}}return re}})})}static hb(K,U,ne,be,G){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(K,U,ne,be,G).then(Y=>new y.$Vdc(!1,null,G.build(),ne,Y,be.subscriptions))}static ib(K,U,ne,be,G){if(typeof ne.activate=="function")try{G.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${U.value}`);const Y=typeof global=="object"?global:self,X=ne.activate.apply(Y,[be]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(X).then($e=>(G.activateResolveStop(),$e))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(ne)}jb(K,U){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:U}).then(void 0,ne=>{this.s.error(ne)})}kb(K,U=0){const be=Date.now();(0,z.$B)(()=>{for(let G=U;G<K.length;G+=1){const Y=K[G];for(const X of Y.activationEvents??[])if(X==="onStartupFinished")if(Date.now()-be>50){this.kb(K,G);break}else this.jb(Y,X)}})}lb(){this.C.$setPerformanceMarks(m.getMarks()),this.m.getConfigProvider().then(K=>{const U=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(U)this.kb(ne);else for(const be of ne)if(be.activationEvents)for(const G of be.activationEvents)G==="onStartupFinished"&&this.jb(be,G)})}mb(){const K=this.Z("*",!0).then(void 0,Y=>{this.s.error(Y)});this.B(this.j.onDidChangeWorkspace(Y=>this.nb(Y.added)));const U=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(U),be=this.pb(),G=Promise.all([be,K,ne]).then(()=>{});return Promise.race([G,(0,R.$Xg)(1e4)]).then(()=>{this.lb()}),G}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(K,U))).then(()=>{})}async ob(K,U){if(this.isActivated(U.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:K.map(Y=>Y.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Y=>this.c.fsExists(Y.fsPath),checkExists:(Y,X,$e)=>this.y.$checkExists(Y,X,$e)},G=await(0,v.$9qb)(be,U);if(G)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:G.activationEvent}).then(void 0,Y=>this.s.error(Y))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:U}=this.f.environment;if(!K||!U)throw new Error(I.localize(0,null));const ne=await this.vb(null,U,new y.$Udc(!1));if(!ne||typeof ne.run!="function")throw new Error(I.localize(1,null,U.toString()));return new Promise((be,G)=>{const Y=(re,fe)=>{re?(z.$t&&this.s.error("Test runner called back with error",re),G(re)):(z.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof fe=="number"&&fe>0?1:0))},X=(0,L.$mg)(U),$e=ne.run(X,Y);$e&&$e.then&&$e.then(()=>{z.$t&&this.s.info("Test runner finished successfully."),be(0)}).catch(re=>{z.$t&&this.s.error("Test runner finished with error",re),G(re instanceof Error&&re.stack?re.stack:String(re))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Xg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,U){return this.R[K]=U,(0,p.$Pc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:U}=await this.sb(K);return U?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const U=K.indexOf("+");if(U===-1)throw new t.$HK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=K.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(K,U){const ne=O.$Md.create(!1),be=()=>`[resolveAuthority(${(0,r.$Yk)(K)},${U})][${ne.elapsed()}ms] `,G=oe=>this.s.info(`${be()}${oe}`),Y=oe=>this.s.warn(`${be()}${oe}`),X=(oe,_=void 0)=>this.s.error(`${be()}${oe}`,_),$e=oe=>{if(oe instanceof t.$HK)return{type:"error",error:{code:oe._code,message:oe._message,detail:oe._detail}};throw oe},re=async oe=>{G(`activating resolver for ${oe}...`);const{resolver:_,authorityPrefix:ge}=await this.sb(oe);if(!_)throw X(`no resolver for ${ge}`),new t.$HK(`No remote extension installed to resolve ${ge}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:_,authorityPrefix:ge,remoteAuthority:oe}},fe=K.split(/@|%40/g).reverse();G(`activating remote resolvers ${fe.join(" -> ")}`);let te;try{te=await Promise.all(fe.map(re)).catch(async oe=>{if(!(oe instanceof t.$HK)||oe._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw oe;return Y(`resolving nested authorities failed: ${oe.message}`),[await re(K)]})}catch(oe){return $e(oe)}const he=new R.$8g;he.cancelAndSet(()=>G("waiting..."),1e3);let pe,Pe;for(const[oe,{authorityPrefix:_,resolver:ge,remoteAuthority:ye}]of te.entries())try{if(oe===te.length-1)G("invoking final resolve()..."),m.mark(`code/extHost/willResolveAuthority/${_}`),pe=await ge.resolve(ye,{resolveAttempt:U,execServer:Pe}),m.mark(`code/extHost/didResolveAuthorityOK/${_}`),G("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$GK.isManagedResolvedAuthority(pe)?pe:void 0));else{if(G(`invoking resolveExecServer() for ${ye}`),m.mark(`code/extHost/willResolveExecServer/${_}`),Pe=await ge.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$HK(`Exec server was not available for ${ye}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);m.mark(`code/extHost/didResolveExecServerOK/${_}`)}}catch(je){return m.mark(`code/extHost/didResolveAuthorityError/${_}`),X("returned an error",je),he.dispose(),$e(je)}he.dispose();const B={environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures},Q={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};G(`returned ${t.$GK.isManagedResolvedAuthority(pe)?"managed authority":`${pe.host}:${pe.port}`}`);let se;if(t.$GK.isManagedResolvedAuthority(pe)){const oe=U;this.X.setFactory(oe,pe.makeConnection),se={authority:K,connectTo:new r.$Vk(oe),connectionToken:pe.connectionToken}}else se={authority:K,connectTo:new r.$Wk(pe.host,pe.port),connectionToken:pe.connectionToken};return{type:"ok",value:{authority:se,options:Q,tunnelInformation:B}}}async $getCanonicalURI(K,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Yk)(K)})`);const{resolver:ne}=await this.sb(K);if(!ne)return null;const be=g.URI.revive(U);if(typeof ne.getCanonicalURI>"u")return be;const G=await(0,R.$Pg)(()=>ne.getCanonicalURI(be));return G||be}$startExtensionHost(K){K.toAdd.forEach(be=>be.extensionLocation=g.URI.revive(be.extensionLocation));const{globalRegistry:U,myExtensions:ne}=de(this.I,this.L,this.J,K);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),z.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.rb()}$activateByEvent(K,U){return U===1?this.D.wait().then(ne=>this.Z(K,!1)):this.G.wait().then(ne=>this.Z(K,!1))}async $activate(K,U){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,U),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(Y=>Y.extensionLocation=g.URI.revive(Y.extensionLocation));const{globalRegistry:U,myExtensions:ne}=de(this.I,this.L,this.J,K),be=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),z.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const U=o.$ee.alloc(K),ne=Math.random()%256;for(let be=0;be<K;be++)U.writeUInt8(ne,be);return U}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$hec=V,e.$hec=V=W=He([Be(0,d.$Th),Be(1,e.$gec),Be(2,h.$BM),Be(3,w.$Mdc),Be(4,f.$Pdc),Be(5,A.$cj),Be(6,u.$RM),Be(7,l.$6dc),Be(8,D.$Uwb),Be(9,$.$8dc),Be(10,M.$dec),Be(11,T.$eec)],V);function de(le,K,U,ne){le.addActivationEvents(ne.addActivationEvents);const be=new s.$N5b(le,K.getAllExtensionDescriptions());be.deltaExtensions(ne.toAdd,ne.toRemove);const G=new n.$_l(U.getAllExtensionDescriptions().map(X=>X.identifier));for(const X of ne.myToRemove)G.delete(X);for(const X of ne.myToAdd)G.add(X);const Y=ae(be,G);return{globalRegistry:be,myExtensions:Y}}function ee(le,K){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function Z(le){return le.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$iec=(0,d.$Uh)("IExtHostExtensionService");class J{#e;#t;#i;constructor(K,U,ne,be,G){this.#e=K,this.#t=U,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=F.$gc((0,L.$mg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=be,this.isFromDifferentExtensionHost=G}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$jec=J;function ae(le,K){return le.getAllExtensionDescriptions().filter(U=>K.has(U.identifier))}class x{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$kec=x;class Ee{constructor(K){this.a=new n.$am,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const U of Object.keys(K))this.a.set(U,K[U])}}}),define(ke[366],Se([1,0,56,2,6,42,25,26,20,27,5,47,15,13]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;let w=class{constructor(o,a,t,r,d,u,l){this.c=o,this.d=a,this.e=t,this.f=r,this.g=d,this.h=u,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new s(this.c,a,this.d,o,this.i)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const a of o.nodeModuleName)this.a.set(a,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(a=>o.alternativeModuleName(a))}};e.$Ifc=w,e.$Ifc=w=He([Be(2,A.$Th),Be(3,L.$Pdc),Be(4,P.$iec),Be(5,g.$RM),Be(6,f.$cj)],w);let c=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&S.a.size){const a=(0,y.$Ie)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${d}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const a=this.b.exec(this.c(o));if(!a)return;const[,t,r,d]=a,u=S.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),t+u+d}c(o){return o.replace(/\\/g,"/")}};c=S=He([Be(0,g.$RM)],c);class s{constructor(o,a,t,r,d){this.c=o,this.d=a,this.e=t,this.f=r,this.g=d,this.nodeModuleName="vscode",this.a=new p.$am}load(o,a){const t=this.d.findSubstr(a);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((d,u)=>r+=`	${u} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$sF,this.e,this.f)}return this.b}}let i=class{constructor(o,a,t){this.e=o,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(m.$zK.MainThreadTelemetry);const r=t.getProxy(m.$zK.MainThreadWindow);this.c=(d,u)=>{const l=F.URI.parse(d);return u?this.g(d,u):l.scheme==="http"||l.scheme==="https"?r.$openUri(l,d,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?r.$openUri(l,d,{}):this.g(d,u)}}load(o,a,t){const r=this.e.findSubstr(a);return r&&(this.a=r.identifier.value,this.h()),this.b=t(o),this.c}g(o,a){return this.i(),this.b(o,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=He([Be(2,E.$BM)],i)}),define(ke[58],Se([1,0,48,3,16,49,5,70,71,47,7,41,291,42]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=void 0,e.$Qec=(0,R.$Uh)("IExtHostVariableResolverProvider");class S extends f.$CN{constructor(s,i,n,o,a,t,r){function d(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const l=o.tabGroups.all.find(h=>h.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof A.$hM||l.input instanceof A.$mM)return l.input.modified;if(l.input instanceof A.$gM||l.input instanceof A.$lM||l.input instanceof A.$jM)return l.input.uri}}}super({getFolderUri:u=>{const l=t.folders.filter(h=>h.name===u);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,l)=>a.getConfiguration(void 0,u).get(l),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=d();if(u)return m.$gc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=d();if(u){const l=i.getWorkspaceFolder(u);if(l)return m.$gc(l.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>s.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(L.env))}}let w=class extends F.$Rc{constructor(s,i,n,o,a){super(),this.b=s,this.c=i,this.g=n,this.h=o,this.j=a,this.a=new I.$U(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Rec=w,e.$Rec=w=He([Be(0,g.$iec),Be(1,P.$Mdc),Be(2,p.$MM),Be(3,y.$Pdc),Be(4,E.$Oec)],w)}),define(ke[96],Se([1,0,10,4,2,5,6,71,47,20,7,41,142,283,42,58]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.$Vec=e.$Uec=e.$Tec=e.$Sec=void 0,e.$Sec=(0,L.$Uh)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,d,u,l,h,k){this.E=d,this.F=u,this.G=l,this.H=h,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Qd,this.n=new F.$Qd,this.o=new F.$Qd,this.u=new F.$Qd,this.k=r.getProxy(R.$zK.MainThreadDebugService),this.y=new F.$Qd,this.A=new F.$Qd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(D=>{D.onDidChange($=>{this.J(D)}),this.J(D)})}asDebugSourceUri(r,d){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let l=`debug:${encodeURIComponent(u.path||"")}`,h="?";return d&&(l+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),l+=`${h}ref=${u.sourceReference}`,m.URI.parse(l)}else{if(u.path)return m.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const d=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const l=u.contributes.debuggers;if(l&&l.length>0)for(const h of l)(0,y.$MF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(d=>r.push(d)),r}addBreakpoints(r){const d=r.filter(h=>{const k=h.id;return this.w.has(k)?!1:(this.w.set(k,h),!0)});this.U(d,[],[]);const u=[],l=new Map;for(const h of d)if(h instanceof A.$AL){let k=l.get(h.location.uri.toString());k||(k={type:"sourceMulti",uri:h.location.uri,lines:[]},l.set(h.location.uri.toString(),k),u.push(k)),k.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof A.$BL&&u.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(u)}removeBreakpoints(r){const d=r.filter(k=>this.w.delete(k.id));this.U([],d,[]);const u=d.filter(k=>k instanceof A.$AL).map(k=>k.id),l=d.filter(k=>k instanceof A.$BL).map(k=>k.id),h=d.filter(k=>k instanceof A.$CL).map(k=>k.id);return this.k.$unregisterBreakpoints(u,l,h)}startDebugging(r,d,u){return this.k.$startDebugging(r?r.uri:void 0,d,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,d,u){if(!d)return new A.$BK(()=>{});const l=this.d++;return this.f.push({type:r,handle:l,provider:d}),this.k.$registerDebugConfigurationProvider(r,u,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,l),new A.$BK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(l)})}registerDebugAdapterDescriptorFactory(r,d,u){if(!u)return new A.$BK(()=>{});if(!this.Q(r,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const l=this.g++;return this.h.push({type:d,handle:l,factory:u}),this.k.$registerDebugAdapterDescriptorFactory(d,l),new A.$BK(()=>{this.h=this.h.filter(h=>h.factory!==u),this.k.$unregisterDebugAdapterDescriptorFactory(l)})}registerDebugAdapterTrackerFactory(r,d){if(!d)return new A.$BK(()=>{});const u=this.i++;return this.j.push({type:r,handle:u,factory:d}),new A.$BK(()=>{this.j=this.j.filter(l=>l.factory!==d)})}async $runInTerminal(r,d){return Promise.resolve(void 0)}async $substituteVariables(r,d){let u;const l=await this.W(r);return l&&(u={uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(u,d)}K(r,d){if(r.type==="implementation")return new o(r.implementation)}L(){}async $startDASession(r,d){const u=this,l=await this.V(d);return this.S(this.N(l.type),l).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}' (extension might have failed to activate)`);const k=this.M(h),D=this.K(k,l);if(!D)throw new Error(`Couldn't create a debug adapter for type '${l.type}'.`);const $=D;return this.B.set(r,$),this.R(l).then(b=>(b&&this.C.set(r,b),$.onMessage(async v=>{if(v.type==="request"&&v.command==="handshake"){const C=v,N={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const j=await this.D.sign(C.arguments.value);N.body={signature:j},$.sendResponse(N)}else throw new Error("no signer")}catch(j){N.success=!1,N.message=j.message,$.sendResponse(N)}}else b&&b.onDidSendMessage&&b.onDidSendMessage(v),v=(0,y.$RF)(v,!0),u.k.$acceptDAMessage(r,v)}),$.onError(v=>{b&&b.onError&&b.onError(v),this.k.$acceptDAError(r,v.name,v.message,v.stack)}),$.onExit(v=>{b&&b.onExit&&b.onExit(v??void 0,void 0),this.k.$acceptDAExit(r,v??void 0,void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),$.startSession()))})}$sendDAMessage(r,d){d=(0,y.$QF)(d,!1);const u=this.C.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(d),this.B.get(r)?.sendMessage(d)}$stopDASession(r){const d=this.C.get(r);this.C.delete(r),d&&d.onWillStopSession&&d.onWillStopSession();const u=this.B.get(r);return this.B.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const d=[],u=[],l=[];if(r.added)for(const h of r.added){const k=h.id;if(k&&!this.w.has(k)){let D;if(h.type==="function")D=new A.$BL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")D=new A.$CL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const $=m.URI.revive(h.uri);D=new A.$AL(new A.$NK($,new A.$CK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,A.$yL)(D,k),this.w.set(k,D),d.push(D)}}if(r.removed)for(const h of r.removed){const k=this.w.get(h);k&&(this.w.delete(h),u.push(k))}if(r.changed){for(const h of r.changed)if(h.id){const k=this.w.get(h.id);if(k){if(k instanceof A.$BL&&h.type==="function"){const D=k;D.enabled=h.enabled,D.condition=h.condition,D.hitCondition=h.hitCondition,D.logMessage=h.logMessage,D.functionName=h.functionName}else if(k instanceof A.$AL&&h.type==="source"){const D=k;D.enabled=h.enabled,D.condition=h.condition,D.hitCondition=h.hitCondition,D.logMessage=h.logMessage,D.location=new A.$NK(m.URI.revive(h.uri),new A.$CK(h.line,h.character))}l.push(k)}}}this.U(d,u,l)}async $acceptStackFrameFocus(r){let d;const u=r.sessionId?await this.V(r.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?d=new A.$IL(u,r.threadId):d=new A.$HL(u,r.threadId,r.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(r,d,u){return(0,I.$Pg)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return l.provideDebugConfigurations(h,u)}).then(l=>{if(!l)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return l})}$resolveDebugConfiguration(r,d,u,l){return(0,I.$Pg)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(d);return h.resolveDebugConfiguration(k,u,l)})}$resolveDebugConfigurationWithSubstitutedVariables(r,d,u,l){return(0,I.$Pg)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(k,u,l)})}async $provideDebugAdapter(r,d){const u=this.O(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const l=await this.V(d);return this.S(u,l).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${l.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(r){const d=await this.V(r);this.m.fire(d)}async $acceptDebugSessionTerminated(r){const d=await this.V(r);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,d){(await this.V(r))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(r,d){const l={session:await this.V(r),event:d.event,body:d.body};this.u.fire(l)}M(r){if(r instanceof A.$DL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.$EL)return{type:"server",port:r.port,host:r.host};if(r instanceof A.$FL)return{type:"pipeServer",path:r.path};if(r instanceof A.$GL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const d=this.h.filter(u=>u.type===r);if(d.length>0)return d[0].factory}O(r){const d=this.h.filter(u=>u.handle===r);if(d.length>0)return d[0].factory}P(r){const d=this.f.filter(u=>u.handle===r);if(d.length>0)return d[0].provider}Q(r,d){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const l of u)if(l.label&&l.type&&l.type===d)return!0}}return!1}R(r){const u=r.configuration.type,l=this.j.filter(h=>h.type===u||h.type==="*").map(h=>(0,I.$Pg)(()=>h.factory.createDebugAdapterTracker(r)).then(k=>k,k=>null));return Promise.race([Promise.all(l).then(h=>{const k=h.filter(D=>!!D);if(k.length>0)return new n(k)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(r,d){const u=d.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new A.$EL(u));if(r){const h=await this.F.getExtensionRegistry();return(0,I.$Pg)(()=>r.createDebugAdapterDescriptor(d,this.T(d,h))).then(k=>{if(k)return k})}const l=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,l))}T(r,d){}U(r,d,u){(r.length>0||d.length>0||u.length>0)&&this.y.fire(Object.freeze({added:r,removed:d,changed:u}))}async V(r){if(r)if(typeof r=="string"){const d=this.l.get(r);if(d)return d}else{let d=this.l.get(r.id);if(!d){const u=await this.W(r.folderUri),l=r.parent?this.l.get(r.parent):void 0;d=new s(this.k,r.id,r.type,r.name,u,r.configuration,l),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(r){if(r){const d=m.URI.revive(r);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$Tec=c,e.$Tec=c=He([Be(0,g.$BM),Be(1,P.$Mdc),Be(2,E.$iec),Be(3,S.$Pdc),Be(4,p.$Oec),Be(5,w.$Qec)],c);class s{constructor(r,d,u,l,h,k,D){this.d=r,this.f=d,this.g=u,this.h=l,this.i=h,this.j=k,this.k=D}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,d){return this.d.$customDebugAdapterRequest(this.f,r,d)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$Uec=s;class i{constructor(r){this.value=Object.freeze({append(d){r.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$Vec=i;class n{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(d=>d.onError?d.onError(r):void 0)}onExit(r,d){this.d.forEach(u=>u.onExit?u.onExit(r,d):void 0)}}class o extends f.$Odb{constructor(r){super(),this.h=r,r.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends c{constructor(r,d,u,l,h,k){super(r,d,u,l,h,k)}};e.$Wec=a,e.$Wec=a=He([Be(0,g.$BM),Be(1,P.$Mdc),Be(2,E.$iec),Be(3,S.$Pdc),Be(4,p.$Oec),Be(5,w.$Qec)],a)}),define(ke[367],Se([1,0,11,56,2,6,355,15,106,107,27,249,20,67,47,90]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=e.$Jfc=void 0;class c{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(p.$cj),t=n.get(f.$BM).getProxy(L.$zK.MainThreadErrors);I.setUnexpectedErrorHandler(r=>{o.error(r);const d=I.$2(r);t.$onUnexpectedError(d)})}static async installFullHandler(n){const o=n.get(p.$cj),a=n.get(f.$BM),t=n.get(S.$iec),r=n.get(w.$VM),d=a.getProxy(L.$zK.MainThreadExtensionService),u=a.getProxy(L.$zK.MainThreadErrors),l=await t.getExtensionPathIndex(),h=new WeakMap;function k(b,v){if(h.has(b))return h.get(b).stack;let C="",N,j;for(const O of v)C+=`
	at ${O.toString()}`,j=O.getFileName(),!N&&j&&(N=l.findSubstr(m.URI.file(j)));const M=`${b.name||"Error"}: ${b.message||""}${C}`;return h.set(b,{extensionIdentifier:N?.identifier,stack:M}),M}const D=Symbol("prepareStackTrace wrapped");let $=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(b){if(b===k||!b||b[D]){$=b||k;return}$=function(v,C){return k(v,C),b.call(Error,v,C)},Object.assign($,{[D]:!0})}}),I.setUnexpectedErrorHandler(b=>{o.error(b);const v=I.$2(b),C=h.get(b);if(!C?.extensionIdentifier){u.$onUnexpectedError(v);return}d.$onExtensionRuntimeError(C.extensionIdentifier,v);const N=r.onExtensionError(C.extensionIdentifier,b);o.trace("forwarded error to extension?",N,C)})}}e.$Jfc=c;class s{constructor(n,o,a,t,r){this.a=a,this.b=new R.$V5b(n,null,t),o=s.e(o,this.b);const d=new g.$Sh(...(0,E.$Dr)());d.set(A.$RM,{_serviceBrand:void 0,...o,messagePorts:r}),d.set(f.$BM,new f.$CM(this.b)),d.set(y.$Jdc,new y.$Kdc(t)),d.set(S.$gec,a);const u=new P.$iq(d,!0);u.invokeFunction(c.installEarlyHandler),this.d=u.invokeFunction(l=>l.get(p.$cj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(l=>l.get(S.$iec)),this.c.initialize(),u.invokeFunction(c.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(L.$zK.MainThreadExtensionService);return m.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=m.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=m.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>m.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=m.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=m.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=m.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=m.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=m.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=m.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$Kfc=s}),define(ke[368],Se([1,0,10,12,224,243,140,96,71,47,20,46,7,58,41,284,285,42]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=void 0;let i=class extends p.$Tec{constructor(r,d,u,l,h,k,D){super(r,d,u,l,k,D),this.Z=h,this.X=new a}K(r,d){switch(r.type){case"server":return new w.$Pfc(r);case"pipeServer":return new w.$Qfc(r);case"executable":return new w.$Rfc(r,d.type)}return super.K(r,d)}T(r,d){const u=w.$Rfc.platformAdapterExecutable(d.getAllExtensionDescriptions(),r.type);if(u)return new f.$DL(u.command,u.args,u.options)}L(){return new R.$I9b}async $runInTerminal(r,d){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const u=await this.G.getConfigProvider(),l=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),k=r.title||m.localize(0,null),D=JSON.stringify({shell:l,shellArgs:h});let $=await this.X.checkout(D,k),b,v=!1;if($)b=r.cwd;else{const M={shellPath:l,shellArgs:h,cwd:r.cwd,name:k,iconPath:new f.$vL("debug")};v=!0,$=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert($,D)}$.show(!0);const C=await $.processId;v?await new Promise(M=>setTimeout(M,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?$.sendText("cls"):l.indexOf("bash")>=0?$.sendText("clear"):F.$i?$.sendText("cls"):$.sendText("clear"));const N=(0,c.$Tfc)(l,r.args,!!r.argsCanBeInterpretedByShell,b,r.env);$.sendText(N);const j=this.onDidTerminateDebugSession(M=>{M.id===d&&(this.X.free($),j.dispose())});return C}else if(r.kind==="external")return o(r,await this.G.getConfigProvider());return super.$runInTerminal(r,d)}};e.$Ufc=i,e.$Ufc=i=He([Be(0,A.$BM),Be(1,S.$Mdc),Be(2,g.$iec),Be(3,s.$Pdc),Be(4,P.$8dc),Be(5,E.$Oec),Be(6,y.$Qec)],i);let n;function o(t,r){if(!n)if(F.$i)n=new L.$u8b;else if(F.$j)n=new L.$v8b;else if(F.$k)n=new L.$w8b;else throw new Error("external terminals not supported on this platform");const d=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,d){const l=[...this.b.entries()].map(([h,k])=>(0,I.$Kg)(async D=>{if(h.name!==d||k.lastUsedAt!==-1&&await(0,c.$Sfc)(await h.processId))return null;const $=Date.now();return k.lastUsedAt+a.a>$||D.isCancellationRequested||k.config!==r?null:(k.lastUsedAt=$,h)}));return await(0,I.$2g)(l,h=>!!h)}insert(r,d){this.b.set(r,{lastUsedAt:Date.now(),config:d})}free(r){const d=this.b.get(r);d&&(d.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(ke[369],Se([1,0,16,2,104,41,70,42,40,46,20,27,95,17,15,91,23,63,58]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;let n=class extends f.$Lec{constructor(a,t,r,d,u,l,h,k,D){super(a,t,r,d,u,l,h,k),this.B=r,this.C=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(y.Schemas.vscodeRemote,{scheme:y.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(y.Schemas.file,{scheme:y.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const d=f.TaskHandleDTO.from(r,this.B),u=await this.a.$getTaskExecution(d);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(u,t);return this.a.$executeTask(d).catch(()=>{}),l}else{const d=f.TaskDTO.from(t,a);if(d===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const u=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),u}}u(a,t,r,d){const u=[];if(d)for(const l of d){this.z(l,r),(!l.definition||!a[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const h=f.TaskDTO.from(l,r.extension);h&&(u.push(h),f.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,l,!0)))}return{tasks:u,extension:r.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const r=F.URI.file((0,s.homedir)());t=new E.$ci({uri:r,name:c.$vg(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const r=F.URI.revive(a),d={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),l=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),k=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const D of t.variables)d.variables[D]=await h.resolveAsync(k,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(I.$sc);for(let $=0;$<D.length;$++)D[$]=await h.resolveAsync(k,D[$])}d.process=await m.win32.findExecutable(await h.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(k,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,r){return m.win32.findExecutable(a,t,r)}};e.$Mfc=n,e.$Mfc=n=He([Be(0,A.$BM),Be(1,P.$RM),Be(2,L.$Mdc),Be(3,R.$MM),Be(4,p.$Pdc),Be(5,g.$8dc),Be(6,S.$cj),Be(7,w.$Cdc),Be(8,i.$Qec)],n)}),define(ke[370],Se([1,0,63,58]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class m extends F.$Rec{m(){return(0,I.homedir)()}}e.$sgc=m}),define(ke[156],Se([1,0,19,10,21,43,17,16,23,2,36]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=e.$1ec=e.$Zec=e.$Yec=void 0;class P{constructor(i,n,o,a){this.d=i,this.e=n,this.f=o,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],a=new m.$1d(n);return new Promise((t,r)=>{this.a=new y(i);let d=!1;const u=(l,h)=>{if(!d&&!this.b){const k=this.h(l);w(l)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,d=!0,a.cancel(),l=this.j(l,this.d.maxResults-this.c));const D=this.h(l);this.c+=D,(D>0||!w(l))&&this.a.add(l,h)}};Promise.all(o.map((l,h)=>this.k(l,k=>u(k,h),a.token))).then(l=>{a.dispose(),this.a.flush();const h=l.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||h,messages:(0,I.$Qb)(l.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},l=>{a.dispose();const h=(0,L.$Fi)(l);r(new Error(h))})})}h(i){return w(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const a=new A.$eJ(this.d,i),t=[],r={report:l=>{if(!this.l(l))return;const h=i.folder.scheme===R.Schemas.file?(0,A.$fJ)(()=>this.f.readdir(E.$xg(l.uri))):void 0,k=E.$Ag(i.folder,l.uri);if(k){const D=a.includedInQuery(k,p.$mc(k),h);(0,F.$Jg)(D)?t.push(D.then($=>{$&&n(l)})):D&&n(l)}}},d=this.n(i),u=await this.e.provideTextSearchResults(f(this.d.contentPattern),d,r,o);return t.length&&await Promise.all(t),u}l(i){if(w(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$dJ)(this.d.includePattern,i.includePattern),o=(0,A.$dJ)(this.d.excludePattern,i.excludePattern),a={folder:g.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$Yec=P;function f(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class y{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new c(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!E.$rg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Zec=y;function S(s){return w(s)?{preview:{matches:(0,I.$1b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,I.$1b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function w(s){return!!s.preview}e.$1ec=w;class c{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$2ec=c}),define(ke[97],Se([1,0,3,6,5,363,20,67,15,2,156]),function(me,e,I,F,m,L,R,p,E,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=e.$4ec=e.$3ec=void 0,e.$3ec=(0,m.$Uh)("IExtHostSearch");let P=class{constructor(w,c,s){this.k=w,this.l=c,this.n=s,this.c=this.k.getProxy(F.$zK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$Xec}o(w){return this.l.transformOutgoingScheme(w)}registerTextSearchProvider(w,c){if(this.g.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this.g.add(w);const s=this.d++;return this.e.set(s,c),this.c.$registerTextSearchProvider(s,this.o(w)),(0,I.$Pc)(()=>{this.g.delete(w),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(w,c){if(this.i.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this.i.add(w);const s=this.d++;return this.h.set(s,c),this.c.$registerFileSearchProvider(s,this.o(w)),(0,I.$Pc)(()=>{this.i.delete(w),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(w,c,s,i){const n=f(s),o=this.h.get(w);if(o)return this.j.fileSearch(n,o,a=>{this.c.$handleFileMatch(w,c,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+w)}async doInternalFileSearchWithCustomCallback(w,c,s){return{messages:[]}}$clearCache(w){return this.j.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,c,s,i){const n=this.e.get(w);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const o=f(s);return this.q(o,n).search(t=>this.c.$handleTextMatch(w,c,t),i)}$enableExtensionHostSearch(){}q(w,c){return new A.$Yec(w,c,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$4ec=P,e.$4ec=P=He([Be(0,R.$BM),Be(1,p.$Jdc),Be(2,E.$cj)],P);function f(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(y),extraFileResources:S.extraFileResources&&S.extraFileResources.map(w=>g.URI.revive(w))}}e.$5ec=f;function y(S){return{...S,folder:g.URI.revive(S.folder)}}}),define(ke[371],Se([1,0,21,11,4,39,2,133,80,172,191,31,6,114,315,314,35,316,42,318,319,320,295,321,70,47,323,324,329,330,331,154,299,336,337,340,118,46,342,300,14,7,87,345,93,153,41,26,289,328,66,151,95,96,97,15,67,20,27,362,286,73,91,307,343,92,72,348,346,347,308,57,341,344,117,71,90,332,94,333,17,137,298,274,326,3,25,282,115,268,334,335,309,325,297,327,116,338,312,339,313,306,322,310,311]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a,t,r,d,u,l,h,k,D,$,b,v,C,N,j,M,O,z,T,W,V,de,ee,Z,J,ae,x,Ee,le,K,U,ne,be,G,Y,X,$e,re,fe,te,he,pe,Pe,B,Q,se,oe,_,ge,ye,je,We,_e,Ze,it,tt,Ae,Oe,qe,Re,Xe,ue,ce,Ie,Ke,Ue,Ye,nt,ct,bt,Et,Kt,Ht,wt,jt,Ot,Gt,Ut,Dt,Ft,Bt,Qt,Wt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;function Nt(ut){const ft=ut.get(re.$RM),At=ut.get(je.$zdc),Vt=ut.get(se.$5dc),Lt=ut.get(u.$iec),at=ut.get(ae.$Mdc),vt=ut.get(tt.$VM),Tt=ut.get(i.$Pdc),Pt=ut.get(X.$Jdc),Ge=ut.get($e.$BM),Jt=ut.get(M.$1dc),Me=ut.get(Q.$6dc),Te=ut.get(Y.$dj),Ce=ut.get(Y.$cj),ie=ut.get(he.$Uwb),Fe=ut.get(pe.$Cdc),Ve=ut.get(J.$Gec),xe=ut.get(Ze.$aec),Qe=ut.get(it.$Oec),rt=ut.get(Ot.$eec);Ge.set(f.$AK.ExtHostFileSystemInfo,At),Ge.set(f.$AK.ExtHostLogLevelServiceShape,Te),Ge.set(f.$AK.ExtHostWorkspace,at),Ge.set(f.$AK.ExtHostConfiguration,Tt),Ge.set(f.$AK.ExtHostExtensionService,Lt),Ge.set(f.$AK.ExtHostStorage,Jt),Ge.set(f.$AK.ExtHostTunnelService,ie),Ge.set(f.$AK.ExtHostWindow,Ve),Ge.set(f.$AK.ExtHostSecretState,xe),Ge.set(f.$AK.ExtHostTelemetry,vt),Ge.set(f.$AK.ExtHostEditorTabs,Qe),Ge.set(f.$AK.ExtHostManagedSockets,rt);const kt=Ge.set(f.$AK.ExtHostDecorations,ut.get(U.$Kec)),St=Ge.set(f.$AK.ExtHostDocumentsAndEditors,ut.get(d.$MM)),mt=Ge.set(f.$AK.ExtHostCommands,ut.get(c.$XM)),dt=Ge.set(f.$AK.ExtHostTerminalService,ut.get(O.$8dc)),gt=Ge.set(f.$AK.ExtHostDebugService,ut.get(be.$Sec)),ui=Ge.set(f.$AK.ExtHostSearch,ut.get(G.$3ec)),Ct=Ge.set(f.$AK.ExtHostTask,ut.get(ne.$Nec)),Di=Ge.set(f.$AK.ExtHostOutputService,ut.get(b.$qec)),li=Ge.set(f.$AK.ExtHostLocalization,ut.get(nt.$dec)),$i=Ge.set(f.$AK.ExtHostUrls,new ee.$zec(Ge)),It=Ge.set(f.$AK.ExtHostDocuments,new r.$xdc(Ge,St)),gn=Ge.set(f.$AK.ExtHostDocumentContentProviders,new a.$Rdc(Ge,St,Ce)),ri=Ge.set(f.$AK.ExtHostDocumentSaveParticipant,new t.$Sdc(Ce,It,Ge.getProxy(f.$zK.MainThreadBulkEdits))),yt=Ge.set(f.$AK.ExtHostNotebook,new fe.$9ec(Ge,mt,St,It,Vt,ui)),bi=Ge.set(f.$AK.ExtHostNotebookDocuments,new ce.$ofc(yt)),pi=Ge.set(f.$AK.ExtHostNotebookEditors,new ue.$nfc(Ce,yt)),si=Ge.set(f.$AK.ExtHostNotebookKernels,new Ae.$kfc(Ge,ft,yt,mt,Ce)),Ci=Ge.set(f.$AK.ExtHostNotebookRenderers,new qe.$mfc(Ge,yt)),Ii=Ge.set(f.$AK.ExtHostNotebookDocumentSaveParticipant,new wt.$ufc(Ce,yt,Ge.getProxy(f.$zK.MainThreadBulkEdits))),Rt=Ge.set(f.$AK.ExtHostEditors,new z.$xec(Ge,St)),wi=Ge.set(f.$AK.ExtHostTreeViews,new T.$yec(Ge.getProxy(f.$zK.MainThreadTreeViews),mt,Ce)),Pi=Ge.set(f.$AK.ExtHostEditorInsets,new Ee.$Hec(Ge.getProxy(f.$zK.MainThreadEditorInsets),Rt,ft.remote)),oi=Ge.set(f.$AK.ExtHostDiagnostics,new n.$Bdc(Ge,Ce,At,St)),hi=Ge.set(f.$AK.ExtHostLanguages,new D.$nec(Ge,It,mt.converter,Pt)),lt=Ge.set(f.$AK.ExtHostLanguageFeatures,new k.$Fdc(Ge,Pt,It,mt,oi,Ce,Fe,vt)),Ai=Ge.set(f.$AK.ExtHostFileSystem,new l.$lec(Ge,lt)),Yt=Ge.set(f.$AK.ExtHostFileSystemEventService,new h.$mec(Ge,Ce,St)),ii=Ge.set(f.$AK.ExtHostQuickOpen,(0,C.$sec)(Ge,at,mt)),Li=Ge.set(f.$AK.ExtHostSCM,new N.$uec(Ge,mt,It,Ce)),Ri=Ge.set(f.$AK.ExtHostQuickDiff,new Et.$rfc(Ge,Pt)),Mi=Ge.set(f.$AK.ExtHostShare,new Gt.$wfc(Ge,Pt)),Zi=Ge.set(f.$AK.ExtHostComments,(0,s.$Idc)(Ge,mt,It)),Fi=Ge.set(f.$AK.ExtHostProgress,new v.$rec(Ge.getProxy(f.$zK.MainThreadProgress))),Xi=Ge.set(f.$AK.ExtHosLabelService,new le.$Iec(Ge)),Ti=Ge.set(f.$AK.ExtHostTheming,new te.$0ec(Ge)),ai=Ge.set(f.$AK.ExtHostAuthentication,new Pe.$$ec(Ge)),mn=Ge.set(f.$AK.ExtHostTimeline,new B.$afc(Ge,mt)),Oi=Ge.set(f.$AK.ExtHostWebviews,new Z.$Cec(Ge,ft.remote,at,Ce,Fe)),di=Ge.set(f.$AK.ExtHostWebviewPanels,new ge.$cfc(Ge,Oi,at)),Ni=Ge.set(f.$AK.ExtHostCustomEditors,new _.$dfc(Ge,It,Me,Oi,di)),$n=Ge.set(f.$AK.ExtHostWebviewViews,new oe.$bfc(Ge,Oi)),fi=Ge.set(f.$AK.ExtHostTesting,new We.$ffc(Ge,mt,St)),Yi=Ge.set(f.$AK.ExtHostUriOpeners,new _e.$jfc(Ge)),zi=Ge.set(f.$AK.ExtHostProfileContentHandlers,new bt.$qfc(Ge));Ge.set(f.$AK.ExtHostInteractive,new Ie.$pfc(Ge,yt,St,mt,Ce));const xi=Ge.set(f.$AK.ExtHostInlineChat,new Ht.$tfc(Ge,mt,It,Ce)),gi=Ge.set(f.$AK.ExtHostChatProvider,new Ut.$xfc(Ge,Ce)),_i=Ge.set(f.$AK.ExtHostChatAgents,new Wt.$Cfc(Ge,gi,Ce)),bn=Ge.set(f.$AK.ExtHostChatAgents2,new qt.$Dfc(Ge,gi,Ce)),ji=Ge.set(f.$AK.ExtHostChatVariables,new Ft.$zfc(Ge)),mi=Ge.set(f.$AK.ExtHostChat,new Kt.$sfc(Ge,Ce)),xt=Ge.set(f.$AK.ExtHostAiRelatedInformation,new Bt.$Afc(Ge)),vi=Ge.set(f.$AK.ExtHostAiEmbeddingVector,new Qt.$Bfc(Ge)),en=Ge.set(f.$AK.ExtHostIssueReporter,new jt.$vfc(Ge)),Zt=Ge.set(f.$AK.ExtHostStatusBar,new j.$wec(Ge,mt.converter)),yi=Ge.set(f.$AK.ExtHostSpeech,new Dt.$yfc(Ge)),tn=Object.values(f.$AK);Ge.assertRegistered(tn);const nn=new ye.$efc(Ge,St),rn=new w.$Hdc(Ge),Ei=new $.$oec(Ge,Ce),sn=new o.$Qdc(Ge);return S.$Gdc.register(mt),function(ze,_t,on){const $t=function(){let we=!ze.isUnderDevelopment;function De(){we||(Ce.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Ne(st){if(Array.isArray(st))st.forEach(Ne);else if(typeof st=="string")De();else{const pt=st;typeof pt.scheme>"u"&&De(),typeof pt.exclusive=="boolean"&&(0,Ue.$yF)(ze,"documentFiltersExclusive")}return st}}(),Ui={getSession(we,De,Ne){return ai.getSession(ze,we,De,Ne)},getSessions(we,De){return(0,Ue.$yF)(ze,"authGetSessions"),ai.getSessions(ze,we,De)},async hasSession(we,De){return(0,Ue.$yF)(ze,"authSession"),!!await ai.getSession(ze,we,De,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(we,De,Ne,st){return ai.registerAuthenticationProvider(we,De,Ne,st)}},an={registerCommand(we,De,Ne){return mt.registerCommand(!0,we,De,Ne,void 0,ze)},registerTextEditorCommand(we,De,Ne){return mt.registerCommand(!0,we,(...st)=>{const pt=Rt.getActiveTextEditor();if(!pt){Ce.warn("Cannot execute "+we+" because there is no active text editor.");return}return pt.edit(Mt=>{De.apply(Ne,[pt,Mt,...st])}).then(Mt=>{Mt||Ce.warn("Edits from command "+we+" were not applied.")},Mt=>{Ce.warn("An error occurred while running command "+we,Mt)})},void 0,void 0,ze)},registerDiffInformationCommand:(we,De,Ne)=>((0,Ue.$yF)(ze,"diffCommand"),mt.registerCommand(!0,we,async(...st)=>{const pt=St.activeEditor(!0);if(!pt){Ce.warn("Cannot execute "+we+" because there is no active text editor.");return}const Mt=await Rt.getDiffInformation(pt.id);De.apply(Ne,[Mt,...st])},void 0,void 0,ze)),executeCommand(we,...De){return mt.executeCommand(we,...De)},getCommands(we=!1){return mt.getCommands(we)}},Bi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return dt.getDefaultShell(!1)},get onDidChangeShell(){return dt.onDidChangeShell},get isTelemetryEnabled(){return vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return vt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.$yF)(ze,"telemetry"),vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.$yF)(ze,"telemetry"),vt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.$UM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,De){return tt.$TM.validateSender(we),vt.instantiateLogger(ze,we,De)},openExternal(we,De){return Ve.openUri(we,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:De?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===ft.environment.appUriScheme)return $i.createAppUri(we);try{return await Ve.asExternalUri(we,{allowTunneling:!!ft.remote.authority})}catch(De){if((0,Xe.$OU)(we,Re.Schemas.http)||(0,Xe.$OU)(we,Re.Schemas.https))return we;throw De}},get remoteName(){return(0,K.$1k)(ft.remote.authority)},get remoteAuthority(){return(0,Ue.$yF)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Ce.getLevel()},get onDidChangeLogLevel(){return Ce.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,Ue.$yF)(ze,"handleIssueUri"),en.registerIssueUriRequestHandler(ze,we)},registerIssueDataProvider(we){return(0,Ue.$yF)(ze,"handleIssueUri"),en.registerIssueDataProvider(ze,we)},get appQuality(){return(0,Ue.$yF)(ze,"resolvers"),ft.quality},get appCommit(){return(0,Ue.$yF)(ze,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(Bi);const cn={createTestController(we,De,Ne){return fi.createTestController(ze,we,De,Ne)},createTestObserver(){return(0,Ue.$yF)(ze,"testObserver"),fi.createTestObserver()},runTests(we){return(0,Ue.$yF)(ze,"testObserver"),fi.runTests(we)},get onDidChangeTestResults(){return(0,Ue.$yF)(ze,"testObserver"),fi.onResultsChanged},get testResults(){return(0,Ue.$yF)(ze,"testObserver"),fi.results}},ki=ft.remote.isRemote?V.ExtensionKind.Workspace:V.ExtensionKind.UI,pn={getExtension(we,De){(0,Ue.$xF)(ze,"extensionsAny")||(De=!1);const Ne=_t.mine.getExtensionDescription(we);if(Ne)return new u.$jec(Lt,ze.identifier,Ne,ki,!1);if(De){const st=_t.all.getExtensionDescription(we);if(st)return new u.$jec(Lt,ze.identifier,st,ki,!0)}},get all(){const we=[];for(const De of _t.mine.getAllExtensionDescriptions())we.push(new u.$jec(Lt,ze.identifier,De,ki,!1));return we},get allAcrossExtensionHosts(){(0,Ue.$yF)(ze,"extensionsAny");const we=new x.$_l(_t.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),De=[];for(const Ne of _t.all.getAllExtensionDescriptions()){const st=!we.has(Ne.identifier);De.push(new u.$jec(Lt,ze.identifier,Ne,ki,st))}return De},get onDidChange(){return(0,Ue.$xF)(ze,"extensionsAny")?m.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},un={createDiagnosticCollection(we){return oi.createDiagnosticCollection(ze.identifier,we)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:we=>oi.getDiagnostics(we),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(we,De){return hi.changeLanguage(we.uri,De)},match(we,De){const Ne=It.getDocumentData(De.uri)?.notebook;return(0,A.$KE)(W.LanguageSelector.from(we),De.uri,De.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider(we,De,Ne){return lt.registerCodeActionProvider(ze,$t(we),De,Ne)},registerDocumentPasteEditProvider(we,De,Ne){return(0,Ue.$yF)(ze,"documentPaste"),lt.registerDocumentPasteEditProvider(ze,$t(we),De,Ne)},registerCodeLensProvider(we,De){return lt.registerCodeLensProvider(ze,$t(we),De)},registerDefinitionProvider(we,De){return lt.registerDefinitionProvider(ze,$t(we),De)},registerDeclarationProvider(we,De){return lt.registerDeclarationProvider(ze,$t(we),De)},registerImplementationProvider(we,De){return lt.registerImplementationProvider(ze,$t(we),De)},registerTypeDefinitionProvider(we,De){return lt.registerTypeDefinitionProvider(ze,$t(we),De)},registerHoverProvider(we,De){return lt.registerHoverProvider(ze,$t(we),De,ze.identifier)},registerEvaluatableExpressionProvider(we,De){return lt.registerEvaluatableExpressionProvider(ze,$t(we),De,ze.identifier)},registerInlineValuesProvider(we,De){return lt.registerInlineValuesProvider(ze,$t(we),De,ze.identifier)},registerDocumentHighlightProvider(we,De){return lt.registerDocumentHighlightProvider(ze,$t(we),De)},registerLinkedEditingRangeProvider(we,De){return lt.registerLinkedEditingRangeProvider(ze,$t(we),De)},registerReferenceProvider(we,De){return lt.registerReferenceProvider(ze,$t(we),De)},registerRenameProvider(we,De){return lt.registerRenameProvider(ze,$t(we),De)},registerDocumentSymbolProvider(we,De,Ne){return lt.registerDocumentSymbolProvider(ze,$t(we),De,Ne)},registerWorkspaceSymbolProvider(we){return lt.registerWorkspaceSymbolProvider(ze,we)},registerDocumentFormattingEditProvider(we,De){return lt.registerDocumentFormattingEditProvider(ze,$t(we),De)},registerDocumentRangeFormattingEditProvider(we,De){return lt.registerDocumentRangeFormattingEditProvider(ze,$t(we),De)},registerOnTypeFormattingEditProvider(we,De,Ne,...st){return lt.registerOnTypeFormattingEditProvider(ze,$t(we),De,[Ne].concat(st))},registerDocumentSemanticTokensProvider(we,De,Ne){return lt.registerDocumentSemanticTokensProvider(ze,$t(we),De,Ne)},registerDocumentRangeSemanticTokensProvider(we,De,Ne){return lt.registerDocumentRangeSemanticTokensProvider(ze,$t(we),De,Ne)},registerSignatureHelpProvider(we,De,Ne,...st){return typeof Ne=="object"?lt.registerSignatureHelpProvider(ze,$t(we),De,Ne):lt.registerSignatureHelpProvider(ze,$t(we),De,typeof Ne>"u"?[]:[Ne,...st])},registerCompletionItemProvider(we,De,...Ne){return lt.registerCompletionItemProvider(ze,$t(we),De,Ne)},registerInlineCompletionItemProvider(we,De,Ne){return De.handleDidShowCompletionItem&&(0,Ue.$yF)(ze,"inlineCompletionsAdditions"),De.handleDidPartiallyAcceptCompletionItem&&(0,Ue.$yF)(ze,"inlineCompletionsAdditions"),Ne&&(0,Ue.$yF)(ze,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(ze,$t(we),De,Ne)},registerDocumentLinkProvider(we,De){return lt.registerDocumentLinkProvider(ze,$t(we),De)},registerColorProvider(we,De){return lt.registerColorProvider(ze,$t(we),De)},registerFoldingRangeProvider(we,De){return lt.registerFoldingRangeProvider(ze,$t(we),De)},registerSelectionRangeProvider(we,De){return lt.registerSelectionRangeProvider(ze,we,De)},registerCallHierarchyProvider(we,De){return lt.registerCallHierarchyProvider(ze,we,De)},registerTypeHierarchyProvider(we,De){return lt.registerTypeHierarchyProvider(ze,we,De)},setLanguageConfiguration:(we,De)=>lt.setLanguageConfiguration(ze,we,De),getTokenInformationAtPosition(we,De){return(0,Ue.$yF)(ze,"tokenInformation"),hi.tokenAtPosition(we,De)},registerInlayHintsProvider(we,De){return lt.registerInlayHintsProvider(ze,we,De)},createLanguageStatusItem(we,De){return hi.createLanguageStatusItem(ze,we,De)},registerDocumentDropEditProvider(we,De,Ne){return lt.registerDocumentOnDropEditProvider(ze,we,De,(0,Ue.$xF)(ze,"dropMetadata")?Ne:void 0)}},ln={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(we,De,Ne){const st=await(R.URI.isUri(we)?Promise.resolve(Si.openTextDocument(we)):Promise.resolve(we));return Rt.showTextDocument(st,De,Ne)},createTextEditorDecorationType(we){return Rt.createTextEditorDecorationType(ze,we)},onDidChangeActiveTextEditor(we,De,Ne){return Rt.onDidChangeActiveTextEditor(we,De,Ne)},onDidChangeVisibleTextEditors(we,De,Ne){return Rt.onDidChangeVisibleTextEditors(we,De,Ne)},onDidChangeTextEditorSelection(we,De,Ne){return Rt.onDidChangeTextEditorSelection(we,De,Ne)},onDidChangeTextEditorOptions(we,De,Ne){return Rt.onDidChangeTextEditorOptions(we,De,Ne)},onDidChangeTextEditorVisibleRanges(we,De,Ne){return Rt.onDidChangeTextEditorVisibleRanges(we,De,Ne)},onDidChangeTextEditorViewColumn(we,De,Ne){return Rt.onDidChangeTextEditorViewColumn(we,De,Ne)},onDidCloseTerminal(we,De,Ne){return dt.onDidCloseTerminal(we,De,Ne)},onDidOpenTerminal(we,De,Ne){return dt.onDidOpenTerminal(we,De,Ne)},onDidChangeActiveTerminal(we,De,Ne){return dt.onDidChangeActiveTerminal(we,De,Ne)},onDidChangeTerminalDimensions(we,De,Ne){return(0,Ue.$yF)(ze,"terminalDimensions"),dt.onDidChangeTerminalDimensions(we,De,Ne)},onDidChangeTerminalState(we,De,Ne){return dt.onDidChangeTerminalState(we,De,Ne)},onDidWriteTerminalData(we,De,Ne){return(0,Ue.$yF)(ze,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(we,De,Ne)},onDidExecuteTerminalCommand(we,De,Ne){return(0,Ue.$yF)(ze,"terminalExecuteCommandEvent"),dt.onDidExecuteTerminalCommand(we,De,Ne)},get state(){return Ve.getState(ze)},onDidChangeWindowState(we,De,Ne){return Ve.onDidChangeWindowState(we,De,Ne)},showInformationMessage(we,...De){return Ei.showMessage(ze,L.default.Info,we,De[0],De.slice(1))},showWarningMessage(we,...De){return Ei.showMessage(ze,L.default.Warning,we,De[0],De.slice(1))},showErrorMessage(we,...De){return Ei.showMessage(ze,L.default.Error,we,De[0],De.slice(1))},showQuickPick(we,De,Ne){return ii.showQuickPick(ze,we,De,Ne)},showWorkspaceFolderPick(we){return ii.showWorkspaceFolderPick(we)},showInputBox(we,De){return ii.showInput(we,De)},showOpenDialog(we){return sn.showOpenDialog(ze,we)},showSaveDialog(we){return sn.showSaveDialog(we)},createStatusBarItem(we,De,Ne){let st,pt,Mt;return typeof we=="string"?(st=we,pt=De,Mt=Ne):(pt=we,Mt=De),Zt.createStatusBarEntry(ze,st,pt,Mt)},setStatusBarMessage(we,De){return Zt.setStatusBarMessage(we,De)},withScmProgress(we){return Fe.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Fi.withProgress(ze,{location:V.ProgressLocation.SourceControl},(De,Ne)=>we({report(st){}}))},withProgress(we,De){return Fi.withProgress(ze,we,De)},createOutputChannel(we,De){return Di.createOutputChannel(we,De,ze)},createWebviewPanel(we,De,Ne,st){return di.createWebviewPanel(ze,we,De,Ne,st)},createWebviewTextEditorInset(we,De,Ne,st){return(0,Ue.$yF)(ze,"editorInsets"),Pi.createWebviewEditorInset(we,De,Ne,st,ze)},createTerminal(we,De,Ne){return typeof we=="object"?"pty"in we?dt.createExtensionTerminal(we):dt.createTerminalFromOptions(we):dt.createTerminal(we,De,Ne)},registerTerminalLinkProvider(we){return dt.registerLinkProvider(we)},registerTerminalProfileProvider(we,De){return dt.registerProfileProvider(ze,we,De)},registerTerminalQuickFixProvider(we,De){return(0,Ue.$yF)(ze,"terminalQuickFixProvider"),dt.registerTerminalQuickFixProvider(we,ze.identifier.value,De)},registerTreeDataProvider(we,De){return wi.registerTreeDataProvider(we,De,ze)},createTreeView(we,De){return wi.createTreeView(we,De,ze)},registerWebviewPanelSerializer:(we,De)=>di.registerWebviewPanelSerializer(ze,we,De),registerCustomEditorProvider:(we,De,Ne={})=>Ni.registerCustomEditorProvider(ze,we,De,Ne),registerFileDecorationProvider(we){return kt.registerFileDecorationProvider(we,ze)},registerUriHandler(we){return $i.registerUriHandler(ze,we)},createQuickPick(){return ii.createQuickPick(ze)},createInputBox(){return ii.createInputBox(ze)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(we,De,Ne){return Ti.onDidChangeActiveColorTheme(we,De,Ne)},registerWebviewViewProvider(we,De,Ne){return $n.registerWebviewViewProvider(ze,we,De,Ne?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,De,Ne){return yt.onDidChangeActiveNotebookEditor(we,De,Ne)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,De,Ne){return pi.onDidChangeNotebookEditorSelection(we,De,Ne)},onDidChangeNotebookEditorVisibleRanges(we,De,Ne){return pi.onDidChangeNotebookEditorVisibleRanges(we,De,Ne)},showNotebookDocument(we,De){return yt.showNotebookDocument(we,De)},registerExternalUriOpener(we,De,Ne){return(0,Ue.$yF)(ze,"externalUriOpener"),Yi.registerExternalUriOpener(ze.identifier,we,De,Ne)},registerProfileContentHandler(we,De){return(0,Ue.$yF)(ze,"profileContentHandlers"),zi.registrProfileContentHandler(ze,we,De)},registerQuickDiffProvider(we,De,Ne,st){return(0,Ue.$yF)(ze,"quickDiffProvider"),Ri.registerQuickDiffProvider($t(we),De,Ne,st)},get tabGroups(){return Qe.tabGroups},registerShareProvider(we,De){return(0,Ue.$yF)(ze,"shareProvider"),Mi.registerShareProvider($t(we),De)}},Si={get rootPath(){return Fe.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),at.getPath()},set rootPath(we){throw new F.$8("rootPath")},getWorkspaceFolder(we){return at.getWorkspaceFolder(we)},get workspaceFolders(){return at.getWorkspaceFolders()},get name(){return at.name},set name(we){throw new F.$8("name")},get workspaceFile(){return at.workspaceFile},set workspaceFile(we){throw new F.$8("workspaceFile")},updateWorkspaceFolders:(we,De,...Ne)=>at.updateWorkspaceFolders(ze,we,De||0,...Ne),onDidChangeWorkspaceFolders:function(we,De,Ne){return at.onDidChangeWorkspace(we,De,Ne)},asRelativePath:(we,De)=>at.getRelativePath(we,De),findFiles:(we,De,Ne,st)=>at.findFiles(we,De,Ne,ze.identifier,st),findTextInFiles:(we,De,Ne,st)=>{(0,Ue.$yF)(ze,"findTextInFiles");let pt,Mt;return typeof De=="object"?(pt=De,Mt=Ne):(pt={},Mt=De,st=Ne),at.findTextInFiles(we,pt||{},Mt,ze.identifier,st)},save:we=>((0,Ue.$yF)(ze,"saveEditor"),at.save(we)),saveAs:we=>((0,Ue.$yF)(ze,"saveEditor"),at.saveAs(we)),saveAll:we=>at.saveAll(we),applyEdit(we,De){return nn.applyWorkspaceEdit(we,ze,De)},createFileSystemWatcher:(we,De,Ne,st)=>{let pt;return typeof De=="boolean"?pt={ignoreCreateEvents:!!De,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!st,correlate:!1}:De&&((0,Ue.$yF)(ze,"createFileSystemWatcher"),pt={...De,correlate:!0}),Yt.createFileSystemWatcher(at,ze,we,pt)},get textDocuments(){return It.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new F.$8("textDocuments")},openTextDocument(we){let De;const Ne=we;if(typeof we=="string")De=Promise.resolve(R.URI.file(we));else if(R.URI.isUri(we))De=Promise.resolve(we);else if(!Ne||typeof Ne=="object")De=It.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return De.then(st=>It.ensureDocumentData(st).then(pt=>pt.document))},onDidOpenTextDocument:(we,De,Ne)=>It.onDidAddDocument(we,De,Ne),onDidCloseTextDocument:(we,De,Ne)=>It.onDidRemoveDocument(we,De,Ne),onDidChangeTextDocument:(we,De,Ne)=>It.onDidChangeDocument(we,De,Ne),onDidSaveTextDocument:(we,De,Ne)=>It.onDidSaveDocument(we,De,Ne),onWillSaveTextDocument:(we,De,Ne)=>ri.getOnWillSaveTextDocumentEvent(ze)(we,De,Ne),get notebookDocuments(){return yt.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,De){let Ne;if(R.URI.isUri(we))Ne=we,await yt.openNotebookDocument(we);else if(typeof we=="string")Ne=R.URI.revive(await yt.createNotebookDocument({viewType:we,content:De}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(we,De,Ne){return bi.onDidSaveNotebookDocument(we,De,Ne)},onDidChangeNotebookDocument(we,De,Ne){return bi.onDidChangeNotebookDocument(we,De,Ne)},onWillSaveNotebookDocument(we,De,Ne){return Ii.getOnWillSaveNotebookDocumentEvent(ze)(we,De,Ne)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(we,De,Ne,st){return yt.registerNotebookSerializer(ze,we,De,Ne,(0,Ue.$xF)(ze,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(we,De,Ne)=>on.onDidChangeConfiguration(we,De,Ne),getConfiguration(we,De){return De=arguments.length===1?void 0:De,on.getConfiguration(we,De,ze)},registerTextDocumentContentProvider(we,De){return gn.registerTextDocumentContentProvider(we,De)},registerTaskProvider:(we,De)=>(Fe.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(ze,we,De)),registerFileSystemProvider(we,De,Ne){return(0,Ke.$Oc)(Ai.registerFileSystemProvider(ze,we,De,Ne),Vt.addFileSystemProvider(we,De,Ne))},get fs(){return Vt.value},registerFileSearchProvider:(we,De)=>((0,Ue.$yF)(ze,"fileSearchProvider"),ui.registerFileSearchProvider(we,De)),registerTextSearchProvider:(we,De)=>((0,Ue.$yF)(ze,"textSearchProvider"),ui.registerTextSearchProvider(we,De)),registerRemoteAuthorityResolver:(we,De)=>((0,Ue.$yF)(ze,"resolvers"),Lt.registerRemoteAuthorityResolver(we,De)),registerResourceLabelFormatter:we=>((0,Ue.$yF)(ze,"resolvers"),Xi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,Ue.$yF)(ze,"resolvers"),Lt.getRemoteExecServer(we)),onDidCreateFiles:(we,De,Ne)=>Yt.onDidCreateFile(we,De,Ne),onDidDeleteFiles:(we,De,Ne)=>Yt.onDidDeleteFile(we,De,Ne),onDidRenameFiles:(we,De,Ne)=>Yt.onDidRenameFile(we,De,Ne),onWillCreateFiles:(we,De,Ne)=>Yt.getOnWillCreateFileEvent(ze)(we,De,Ne),onWillDeleteFiles:(we,De,Ne)=>Yt.getOnWillDeleteFileEvent(ze)(we,De,Ne),onWillRenameFiles:(we,De,Ne)=>Yt.getOnWillRenameFileEvent(ze)(we,De,Ne),openTunnel:we=>((0,Ue.$yF)(ze,"tunnels"),ie.openTunnel(ze,we).then(De=>{if(!De)throw new Error("cannot open tunnel");return De})),get tunnels(){return(0,Ue.$yF)(ze,"tunnels"),ie.getTunnels()},onDidChangeTunnels:(we,De,Ne)=>((0,Ue.$yF)(ze,"tunnels"),ie.onDidChangeTunnels(we,De,Ne)),registerPortAttributesProvider:(we,De)=>((0,Ue.$yF)(ze,"portsAttributes"),ie.registerPortsAttributesProvider(we,De)),registerTunnelProvider:(we,De)=>((0,Ue.$yF)(ze,"tunnelFactory"),ie.registerTunnelProvider(we,De)),registerTimelineProvider:(we,De)=>((0,Ue.$yF)(ze,"timeline"),mn.registerTimelineProvider(we,De,ze.identifier,mt.converter)),get isTrusted(){return at.trusted},requestWorkspaceTrust:we=>((0,Ue.$yF)(ze,"workspaceTrust"),at.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,De,Ne)=>at.onDidGrantWorkspaceTrust(we,De,Ne),registerEditSessionIdentityProvider:(we,De)=>((0,Ue.$yF)(ze,"editSessionIdentityProvider"),at.registerEditSessionIdentityProvider(we,De)),onWillCreateEditSessionIdentity:(we,De,Ne)=>((0,Ue.$yF)(ze,"editSessionIdentityProvider"),at.getOnWillCreateEditSessionIdentityEvent(ze)(we,De,Ne)),registerCanonicalUriProvider:(we,De)=>((0,Ue.$yF)(ze,"canonicalUriProvider"),at.registerCanonicalUriProvider(we,De)),getCanonicalUri:(we,De,Ne)=>((0,Ue.$yF)(ze,"canonicalUriProvider"),at.provideCanonicalUri(we,De,Ne))},Wi={get inputBox(){return Fe.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Li.getLastInputBox(ze)},createSourceControl(we,De,Ne){return Li.createSourceControl(ze,we,De,Ne)}},qi={createCommentController(we,De){return Zi.createCommentController(ze,we,De)}},ci={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(we,De,Ne){return gt.onDidStartDebugSession(we,De,Ne)},onDidTerminateDebugSession(we,De,Ne){return gt.onDidTerminateDebugSession(we,De,Ne)},onDidChangeActiveDebugSession(we,De,Ne){return gt.onDidChangeActiveDebugSession(we,De,Ne)},onDidReceiveDebugSessionCustomEvent(we,De,Ne){return gt.onDidReceiveDebugSessionCustomEvent(we,De,Ne)},onDidChangeBreakpoints(we,De,Ne){return gt.onDidChangeBreakpoints(we,De,Ne)},onDidChangeStackFrameFocus(we,De,Ne){return(0,Ue.$yF)(ze,"debugFocus"),gt.onDidChangeStackFrameFocus(we,De,Ne)},registerDebugConfigurationProvider(we,De,Ne){return gt.registerDebugConfigurationProvider(we,De,Ne||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,De){return gt.registerDebugAdapterDescriptorFactory(ze,we,De)},registerDebugAdapterTrackerFactory(we,De){return gt.registerDebugAdapterTrackerFactory(we,De)},startDebugging(we,De,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?gt.startDebugging(we,De,{parentSession:Ne}):gt.startDebugging(we,De,Ne||{})},stopDebugging(we){return gt.stopDebugging(we)},addBreakpoints(we){return gt.addBreakpoints(we)},removeBreakpoints(we){return gt.removeBreakpoints(we)},asDebugSourceUri(we,De){return gt.asDebugSourceUri(we,De)}},Vi={registerTaskProvider:(we,De)=>Ct.registerTaskProvider(ze,we,De),fetchTasks:we=>Ct.fetchTasks(we),executeTask:we=>Ct.executeTask(ze,we),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(we,De,Ne)=>Ct.onDidStartTask(we,De,Ne),onDidEndTask:(we,De,Ne)=>Ct.onDidEndTask(we,De,Ne),onDidStartTaskProcess:(we,De,Ne)=>Ct.onDidStartTaskProcess(we,De,Ne),onDidEndTaskProcess:(we,De,Ne)=>Ct.onDidEndTaskProcess(we,De,Ne)},Ki={createNotebookController(we,De,Ne,st,pt){return si.createNotebookController(ze,we,De,Ne,st,(0,Ue.$xF)(ze,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(we,De)=>yt.registerNotebookCellStatusBarItemProvider(ze,we,De),createRendererMessaging(we){return Ci.createRendererMessaging(ze,we)},createNotebookControllerDetectionTask(we){return(0,Ue.$yF)(ze,"notebookKernelSource"),si.createNotebookControllerDetectionTask(ze,we)},registerKernelSourceActionProvider(we,De){return(0,Ue.$yF)(ze,"notebookKernelSource"),si.registerKernelSourceActionProvider(ze,we,De)},onDidChangeNotebookCellExecutionState(we,De,Ne){return(0,Ue.$yF)(ze,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(we,De,Ne)}},Hi={t(...we){if(typeof we[0]=="string"){const De=we.shift(),Ne=!we||typeof we[0]!="object"?we:we[0];return li.getMessage(ze.identifier.value,{message:De,args:Ne})}return li.getMessage(ze.identifier.value,we[0])},get bundle(){return li.getBundle(ze.identifier.value)},get uri(){return li.getBundleUri(ze.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(we,De){return(0,Ue.$yF)(ze,"interactive"),xi.registerProvider(ze,we,De={label:De?.label??ze.displayName??ze.name})},registerInteractiveSessionProvider(we,De){return(0,Ue.$yF)(ze,"interactive"),mi.registerChatProvider(ze,we,De)},sendInteractiveRequestToProvider(we,De){return(0,Ue.$yF)(ze,"interactive"),mi.sendInteractiveRequestToProvider(we,De)},get onDidPerformUserAction(){return(0,Ue.$yF)(ze,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(we,De){return(0,Ue.$yF)(ze,"interactive"),mi.transferChatSession(we,De)}},hn={getRelatedInformation(we,De){return(0,Ue.$yF)(ze,"aiRelatedInformation"),xt.getRelatedInformation(ze,we,De)},registerRelatedInformationProvider(we,De){return(0,Ue.$yF)(ze,"aiRelatedInformation"),xt.registerRelatedInformationProvider(ze,we,De)},registerEmbeddingVectorProvider(we,De){return(0,Ue.$yF)(ze,"aiRelatedInformation"),vi.registerEmbeddingVectorProvider(ze,we,De)}},dn={registerChatResponseProvider(we,De,Ne){return(0,Ue.$yF)(ze,"chatProvider"),gi.registerProvider(ze.identifier,we,De,Ne)},requestChatAccess(we){return(0,Ue.$yF)(ze,"chatRequestAccess"),gi.requestChatResponseProvider(ze.identifier,we)},registerVariable(we,De,Ne){return(0,Ue.$yF)(ze,"chatVariables"),ji.registerVariableResolver(ze,we,De,Ne)},registerMappedEditsProvider(we,De){return(0,Ue.$yF)(ze,"mappedEditsProvider"),lt.registerMappedEditsProvider(ze,we,De)},createChatAgent(we,De){return(0,Ue.$yF)(ze,"chatAgents2"),bn.createChatAgent(ze,we,De)},registerAgent(we,De,Ne){return(0,Ue.$yF)(ze,"chatAgents"),_i.registerAgent(ze.identifier,we,De,Ne)}},fn={registerSpeechProvider(we,De){return(0,Ue.$yF)(ze,"speech"),yi.registerProvider(ze.identifier,we,De)}};return{version:ft.version,ai:hn,authentication:Ui,commands:an,comments:qi,chat:dn,debug:ci,env:Bi,extensions:pn,interactive:Gi,l10n:Hi,languages:un,notebooks:Ki,scm:Wi,speech:fn,tasks:Vi,tests:cn,window:ln,workspace:Si,Breakpoint:V.$zL,TerminalOutputAnchor:V.TerminalOutputAnchor,ChatAgentResultFeedbackKind:V.ChatAgentResultFeedbackKind,ChatMessage:V.$qM,ChatMessageRole:V.ChatMessageRole,ChatVariableLevel:V.ChatVariableLevel,CallHierarchyIncomingCall:V.$YK,CallHierarchyItem:V.$XK,CallHierarchyOutgoingCall:V.$ZK,CancellationError:F.$4,CancellationTokenSource:I.$1d,CandidatePortSource:f.CandidatePortSource,CodeAction:V.$UK,CodeActionKind:V.$VK,CodeActionTriggerKind:V.CodeActionTriggerKind,CodeLens:V.$1K,Color:V.$bL,ColorInformation:V.$cL,ColorPresentation:V.$dL,ColorThemeKind:V.ColorThemeKind,CommentMode:V.CommentMode,CommentState:V.CommentState,CommentThreadCollapsibleState:V.CommentThreadCollapsibleState,CommentThreadState:V.CommentThreadState,CompletionItem:V.$8K,CompletionItemKind:V.CompletionItemKind,CompletionItemTag:V.CompletionItemTag,CompletionList:V.$9K,CompletionTriggerKind:V.CompletionTriggerKind,ConfigurationTarget:V.ConfigurationTarget,CustomExecution:V.$lL,DebugAdapterExecutable:V.$DL,DebugAdapterInlineImplementation:V.$GL,DebugAdapterNamedPipeServer:V.$FL,DebugAdapterServer:V.$EL,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:V.DebugConsoleMode,DecorationRangeBehavior:V.DecorationRangeBehavior,Diagnostic:V.$PK,DiagnosticRelatedInformation:V.$OK,DiagnosticSeverity:V.DiagnosticSeverity,DiagnosticTag:V.DiagnosticTag,Disposable:V.$BK,DocumentHighlight:V.$RK,DocumentHighlightKind:V.DocumentHighlightKind,DocumentLink:V.$aL,DocumentSymbol:V.$TK,EndOfLine:V.EndOfLine,EnvironmentVariableMutatorType:V.EnvironmentVariableMutatorType,EvaluatableExpression:V.$JL,InlineValueText:V.$KL,InlineValueVariableLookup:V.$LL,InlineValueEvaluatableExpression:V.$ML,InlineCompletionTriggerKind:V.InlineCompletionTriggerKind,EventEmitter:m.$Qd,ExtensionKind:V.ExtensionKind,ExtensionMode:V.ExtensionMode,ExternalUriOpenerPriority:V.ExternalUriOpenerPriority,FileChangeType:V.FileChangeType,FileDecoration:V.$WL,FileDecoration2:V.$WL,FileSystemError:V.$OL,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:V.$PL,FoldingRangeKind:V.FoldingRangeKind,FunctionBreakpoint:V.$BL,InlineCompletionItem:V.$0K,InlineCompletionList:V.$$K,Hover:V.$QK,IndentAction:g.IndentAction,Location:V.$NK,MarkdownString:V.$2K,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:V.$3K,PortAutoForwardAction:V.PortAutoForwardAction,Position:V.$CK,ProcessExecution:V.$jL,ProgressLocation:V.ProgressLocation,QuickInputButtons:V.$VL,Range:V.$DK,RelativePattern:V.$xL,Selection:V.$EK,SelectionRange:V.$WK,SemanticTokens:V.$SL,SemanticTokensBuilder:V.$RL,SemanticTokensEdit:V.$TL,SemanticTokensEdits:V.$UL,SemanticTokensLegend:V.$QL,ShellExecution:V.$kL,ShellQuoting:V.ShellQuoting,SignatureHelp:V.$5K,SignatureHelpTriggerKind:V.SignatureHelpTriggerKind,SignatureInformation:V.$4K,SnippetString:V.$MK,SourceBreakpoint:V.$AL,StandardTokenType:V.StandardTokenType,StatusBarAlignment:V.StatusBarAlignment,SymbolInformation:V.$SK,SymbolKind:V.SymbolKind,SymbolTag:V.SymbolTag,Task:V.$mL,TaskGroup:V.$iL,TaskPanelKind:V.TaskPanelKind,TaskRevealKind:V.TaskRevealKind,TaskScope:V.TaskScope,TerminalLink:V.$eL,TerminalQuickFixExecuteTerminalCommand:V.$gL,TerminalQuickFixOpener:V.$fL,TerminalLocation:V.TerminalLocation,TerminalProfile:V.$hL,TerminalExitReason:V.TerminalExitReason,TextDocumentSaveReason:V.TextDocumentSaveReason,TextEdit:V.$IK,SnippetTextEdit:V.$KK,TextEditorCursorStyle:p.TextEditorCursorStyle,TextEditorLineNumbersStyle:V.TextEditorLineNumbersStyle,TextEditorRevealType:V.TextEditorRevealType,TextEditorSelectionChangeKind:V.TextEditorSelectionChangeKind,SyntaxTokenType:V.SyntaxTokenType,TextDocumentChangeReason:V.TextDocumentChangeReason,ThemeColor:V.$wL,ThemeIcon:V.$vL,TreeItem:V.$nL,TreeItemCheckboxState:V.TreeItemCheckboxState,TreeItemCollapsibleState:V.TreeItemCollapsibleState,TypeHierarchyItem:V.$fM,UIKind:y.UIKind,Uri:R.URI,ViewColumn:V.ViewColumn,WorkspaceEdit:V.$LK,DocumentDropEdit:V.$tL,DocumentPasteEdit:V.$uL,InlayHint:V.$7K,InlayHintLabelPart:V.$6K,InlayHintKind:V.InlayHintKind,RemoteAuthorityResolverError:V.$HK,ResolvedAuthority:V.$FK,ManagedResolvedAuthority:V.$GK,SourceControlInputBoxValidationType:V.SourceControlInputBoxValidationType,ExtensionRuntime:V.ExtensionRuntime,TimelineItem:V.$7L,NotebookRange:V.$YL,NotebookCellKind:V.NotebookCellKind,NotebookCellExecutionState:V.NotebookCellExecutionState,NotebookCellData:V.$ZL,NotebookData:V.$1L,NotebookRendererScript:V.$5L,NotebookCellStatusBarAlignment:V.NotebookCellStatusBarAlignment,NotebookEditorRevealType:V.NotebookEditorRevealType,NotebookCellOutput:V.$3L,NotebookCellOutputItem:V.$2L,NotebookCellStatusBarItem:V.$4L,NotebookControllerAffinity:V.NotebookControllerAffinity,NotebookControllerAffinity2:V.NotebookControllerAffinity2,NotebookEdit:V.$JK,NotebookKernelSourceAction:V.$6L,PortAttributes:V.$9L,LinkedEditingRanges:V.$8L,TestResultState:V.TestResultState,TestRunRequest:V.$0L,TestMessage:V.$$L,TestMessage2:V.$$L,TestTag:V.$_L,TestRunProfileKind:V.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,DataTransfer:V.$sL,DataTransferItem:V.$oL,CoveredCount:V.$aM,FileCoverage:V.$bM,StatementCoverage:V.$cM,BranchCoverage:V.$dM,FunctionCoverage:V.$eM,WorkspaceTrustState:V.WorkspaceTrustState,LanguageStatusSeverity:V.LanguageStatusSeverity,QuickPickItemKind:V.QuickPickItemKind,InputBoxValidationSeverity:V.InputBoxValidationSeverity,TabInputText:V.$gM,TabInputTextDiff:V.$hM,TabInputTextMerge:V.$iM,TabInputCustom:V.$jM,TabInputNotebook:V.$lM,TabInputNotebookDiff:V.$mM,TabInputWebview:V.$kM,TabInputTerminal:V.$nM,TabInputInteractiveWindow:V.$oM,TabInputChat:V.$pM,TelemetryTrustedValue:de.$oo,LogLevel:Y.LogLevel,EditSessionIdentityMatch:ct.EditSessionIdentityMatch,InteractiveSessionVoteDirection:V.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:V.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:V.InteractiveEditorResponseFeedbackKind,StackFrameFocus:V.$HL,ThreadFocus:V.$IL,RelatedInformationType:V.RelatedInformationType,SpeechToTextStatus:V.SpeechToTextStatus}}}e.$Efc=Nt}),define(ke[372],Se([1,0,106,154,41,151,42,35,70,46,95,96,97,118,73,91,153,72,57,117,90,71,152,15,58,115,116]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a,t,r,d,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$Cr)(u.$dec,u.$cec,1),(0,I.$Cr)(r.$dj,t.$Ffc,1),(0,I.$Cr)(w.$Cdc,w.$Ddc,1),(0,I.$Cr)(p.$XM,p.$WM,0),(0,I.$Cr)(R.$Pdc,R.$Ndc,0),(0,I.$Cr)(s.$5dc,s.$4dc,0),(0,I.$Cr)(P.$Sec,P.$Wec,0),(0,I.$Cr)(L.$Kec,L.$Jec,0),(0,I.$Cr)(E.$MM,E.$LM,0),(0,I.$Cr)(l.$eec,l.$fec,0),(0,I.$Cr)(i.$zdc,i.$ydc,0),(0,I.$Cr)(F.$qec,F.$pec,1),(0,I.$Cr)(f.$3ec,f.$4ec,0),(0,I.$Cr)(y.$1dc,y.$Zdc,0),(0,I.$Cr)(A.$Nec,A.$Mec,0),(0,I.$Cr)(g.$8dc,g.$$dc,0),(0,I.$Cr)(S.$Uwb,S.$Vwb,0),(0,I.$Cr)(c.$Gec,c.$Fec,0),(0,I.$Cr)(m.$Mdc,m.$Ldc,0),(0,I.$Cr)(n.$aec,n.$_dc,0),(0,I.$Cr)(o.$VM,o.$SM,0),(0,I.$Cr)(a.$Oec,a.$Pec,0),(0,I.$Cr)(d.$Qec,d.$Rec,0)}),define(ke[119],Se([1,0,19,15,36,94]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=e.$Vfc=void 0;function R(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.$Vfc=R;function p(P,f,y,S){const w=(0,I.$1b)(y,E),c=new m.$3I(f,w,S),s=c.preview.matches;return{ranges:(0,I.$1b)(w,g),uri:P,preview:{text:c.preview.text,matches:(0,I.$1b)(s,g)}}}e.$Wfc=p;function E(P){return new m.$4I(P.start.line,P.start.character,P.end.line,P.end.character)}function g(P){return new L.$RI(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let A=class{constructor(f,y){this.a=f,this.b=y}appendLine(f){this.b.debug(`${this.a}#search`,f)}};e.$Xfc=A,e.$Xfc=A=He([Be(1,F.$cj)],A)}),define(ke[373],Se([1,0,50,16,77,33,12,13,119,374]),function(me,e,I,F,m,L,R,p,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=e.$Yfc=void 0;const A=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(n,o,a,t){const r=f(n,o,a,t),d=o.folder.fsPath;return{cmd:I.spawn(A,r.args,{cwd:d}),rgDiskPath:A,siblingClauses:r.siblingClauses,rgArgs:r,cwd:d}}e.$Yfc=P;function f(n,o,a,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];S([o],a,!1).forEach(u=>{const l=(0,E.$Vfc)(u);if(r.push("-g",l),R.$j){const h=(0,m.$ul)(l);h!==l&&r.push("-g",h)}});const d=y([o],t,void 0,!1);return d.globArgs.forEach(u=>{const l=`!${(0,E.$Vfc)(u)}`;if(r.push("-g",l),R.$j){const h=(0,m.$ul)(l);h!==l&&r.push("-g",h)}}),o.disregardIgnoreFiles!==!1?r.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),o.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),o.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:d.siblingClauses}}function y(n,o,a,t=!0){const r=[];let d={};return n.forEach(u=>{const l=Object.assign({},u.excludePattern||{},o||{}),h=w(l,t?u.folder.fsPath:void 0,a);r.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:r,siblingClauses:d}}function S(n,o,a=!0){const t=[];return n.forEach(r=>{const d=Object.assign({},o||{},r.includePattern||{}),u=w(d,a?r.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function w(n,o,a){const t=[],r={};return Object.keys(n).forEach(d=>{if(a&&a.has(d)||!d)return;const u=n[d];d=s(o?c(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof u=="boolean"&&u?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):u&&u.when&&(r[d]=u)}),{globArgs:t,siblingClauses:r}}function c(n,o){return F.$hc(o)?o:F.$ic(n,o)}e.$Zfc=c;function s(n){return n=p.$Ne(n,"\\"),p.$Ne(n,"/")}function i(n){return L.$Wf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$1fc=i}),define(ke[375],Se([1,0,50,55,16,376,19,43,34,77,33,12,37,13,18,30,36,373,130]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=e.$2fc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&E.$Bj(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Dq)(this.b).normalizedLowercase),this.u=u.excludePattern&&E.$Bj(u.excludePattern),this.t=new Map,u.folderQueries.forEach(l=>{const h=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),k=l.folder.fsPath;u.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==k).forEach(D=>{(0,A.$1f)(D,k)&&(h[m.$kc(k,D)]=!0)}),this.t.set(k,new t(h,k))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,l,h,k,D){if(this.m=f.$Md.create(!1),this.l)return D(null,this.j);l.forEach($=>{const b=m.$mc($.fsPath);this.u&&this.u($.fsPath,b)||this.J(h,{relativePath:$.fsPath,searchPath:void 0})}),this.r=f.$Md.create(!1),this.w(u,($,b)=>{this.x(this.y,this,$,h,k,v=>{if(v){const C=(0,p.$Fi)(v);console.error(C),this.q.push(C),b(v,void 0)}else b(null,void 0)})},($,b)=>{this.m.stop();const v=$?R.$Gb($)[0]:null;D(v,this.j)})}w(u,l,h){const k=new Array(u.length),D=new Array(u.length);let $=!1,b=0;if(u.length===0)return h(null,[]);u.forEach((v,C)=>{l(v,(N,j)=>{if(N?($=!0,k[C]=null,D[C]=N):(k[C]=j,D[C]=null),++b===u.length)return h($?D:null,k)})})}x(u,l,...h){try{u.apply(l,h)}catch(k){h[h.length-1](k)}}y(u,l,h,k){const D=u.folder.fsPath,$=P.$j,b=()=>M&&M.kill();n.add(b);let v=W=>{n.delete(b),v=()=>{},k(W)},C="";const N=this.D(),j=(0,s.$Yfc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),M=j.cmd,O=!Object.keys(j.siblingClauses).length,z=j.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let T=`${j.rgDiskPath} ${z}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),h({message:T}),this.s=0,this.z(M,"utf8",h,(W,V,de)=>{if(W){v(W);return}if(this.j){v();return}const Z=(C+($?g.$tl(V||""):V)).split(`
`);if(de){const J=Z.length;Z[J-1]=Z[J-1].trim(),Z[J-1]||Z.pop()}else C=Z.pop()||"";if(Z.length&&Z[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=Z.length,O){for(const J of Z)if(this.J(l,{base:D,relativePath:J,searchPath:this.N(u,J)}),this.j){b();break}(de||this.j)&&v();return}this.G(u,N,D,Z,l),de&&(this.H(N,D,l),v())})}spawnFindCmd(u){const l=this.t.get(u.folder.fsPath),h=l.getBasenameTerms(),k=l.getPathTerms(),D=["-L","."];if(h.length||k.length){D.push("-not","(","(");for(const $ of h)D.push("-name",$),D.push("-o");for(const $ of k)D.push("-path",$),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),I.spawn("find",D,{cwd:u.folder.fsPath})}readStdout(u,l,h){let k="";this.z(u,l,()=>{},(D,$,b)=>{if(D){h(D);return}k+=$,b&&h(null,k)})}z(u,l,h,k){let D=(v,C,N)=>{(v||N)&&(D=()=>{},this.r?.stop()),k(v,C,N)},$=!1;u.stdout?(this.A(u.stdout,l,D),u.stdout.once("data",()=>$=!0)):h({message:"stdout is null"});let b;u.stderr?b=this.B(u.stderr):h({message:"stderr is null"}),u.on("error",v=>{D(v)}),u.on("close",v=>{let C;!$&&(C=this.C(b,l))&&r(C)?D(new Error(`command failed with error code ${v}: ${this.C(b,l)}`)):(this.g&&v===0&&(this.j=!0),D(null,"",!0))})}A(u,l,h){const k=new L.StringDecoder(l);return u.on("data",D=>{h(null,k.write(D))}),k}B(u){const l=[];return u.on("data",h=>{l.push(h)}),l}C(u,l){const h=new L.StringDecoder(l);return u.map(k=>h.write(k)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:l},h,k,D){k.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(u,this.b)});const $=b=>{const v=m.$mc(b),C=m.$lc(b);let N=l[C];N||(N=l[C]=[],$(C)),N.push({base:h,relativePath:b,basename:v,searchPath:this.N(u,b)})};k.forEach($)}H({rootEntries:u,pathToEntries:l},h,k){const D=this,$=this.t.get(h),b=this.b;function v(C){D.o++;const N=(0,c.$gJ)(()=>C.map(j=>j.basename));for(let j=0,M=C.length;j<M;j++){const O=C[j],{relativePath:z,basename:T}=O;if($.test(z,T,b!==T?N:void 0))continue;const W=l[z];if(W)v(W);else{if(D.p++,z===b)continue;D.J(k,O)}if(D.j)break}}v(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,l,h,k,D){const $=u.folder,b=(0,c.$gJ)(()=>h);this.w(h,(v,C)=>{if(this.l||this.j)return C(null);const N=l?[l,v].join(m.sep):v;if(this.t.get(u.folder.fsPath).test(N,v,this.a.filePattern!==v?b:void 0))return C(null);const j=[$.fsPath,N].join(m.sep);F.lstat(j,(M,O)=>{if(M||this.l||this.j)return C(null);this.L(j,O,(z,T)=>z||this.l||this.j?C(null):T.isDirectory()?(this.o++,this.M(j,O,(W,V)=>W||this.l||this.j||(V=V||"",this.v[V])?C(null):(this.v[V]=!0,w.Promises.readdir(j).then(de=>{if(this.l||this.j)return C(null);this.I(u,N,de,k,ee=>C(ee||null))},de=>{C(null)})))):(this.p++,N===this.b||this.h&&S.$Ff(T.size)&&T.size>this.h||this.J(k,{base:$.fsPath,relativePath:N,searchPath:this.N(u,N)}),C(null,void 0)))})},v=>{const C=v&&R.$Gb(v);return D(C&&C.length>0?C[0]:void 0)})}J(u,l){this.K(l)&&(!this.d||this.d(l.relativePath,m.$mc(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(l))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,c.$bJ)(u,this.c)}return!0}L(u,l,h){return l.isSymbolicLink()?F.stat(u,h):h(null,l)}M(u,l,h){return l.isSymbolicLink()?F.realpath(u,(k,D)=>k?h(k):h(null,D)):h(null,u)}N(u,l){return u.folderName?m.$ic(u.folderName,l):l}}e.$2fc=o;class a{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new o(u)}search(u,l,h){this.c.walk(this.a,this.b,u,l,(k,D)=>{h(k,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$3fc=a;class t{constructor(u,l){this.expression=u,this.c=l,this.d(u)}d(u){let l,h;Object.keys(u).filter(k=>u[k]).forEach(k=>{m.$hc(k)?(l=l||E.$wj(),l[k]=u[k]):(h=h||E.$wj(),h[k]=u[k])}),this.a=l&&E.$Bj(l,{trimForExclusions:!0}),this.b=h&&E.$Bj(h,{trimForExclusions:!0})}test(u,l,h){return this.b&&this.b(u,l,h)||this.a&&this.a(m.$ic(this.c,u),l,h)}getBasenameTerms(){const u=[];return this.a&&u.push(...E.$Dj(this.a)),this.b&&u.push(...E.$Dj(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...E.$Ej(this.a)),this.b&&u.push(...E.$Ej(this.b)),u}}function r(d){const u=d.trim().split(`
`),l=u[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return y.$tf(u[u.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ke[377],Se([1,0,98,22,186,21]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.DecodeStreamErrorKind=e.$VC=e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=e.$OC=void 0,e.$OC="utf8",e.$PC="utf8bom",e.$QC="utf16be",e.$RC="utf16le";function R(l){return[e.$OC,e.$PC,e.$QC,e.$RC].some(h=>h===l)}e.$SC=R,e.$TC=[254,255],e.$UC=[255,254],e.$VC=[239,187,191];const p=512,E=512,g=512*8,A=512*128;var P;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class f extends Error{constructor(h,k){super(h),this.decodeStreamErrorKind=k}}e.$WC=f;class y{static async create(h){let k;if(h!==e.$OC)k=(await(0,m.$NC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(h));else{const D=new TextDecoder;k={write($){return D.decode($,{stream:!0})},end(){return D.decode()}}}return new y(k)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function S(l,h){const k=h.minBytesRequiredForDetection??h.guessEncoding?g:E;return new Promise((D,$)=>{const b=(0,I.$5d)(O=>O.join("")),v=[];let C=0,N;const j=new L.$1d,M=async()=>{try{const O=await u({buffer:F.$ee.concat(v),bytesRead:C},h.guessEncoding);if(O.seemsBinary&&h.acceptTextOnly)throw new f("Stream is binary but only text is accepted for decoding",1);O.encoding=await h.overwriteEncoding(O.encoding),N=await y.create(O.encoding);const z=N.write(F.$ee.concat(v).buffer);b.write(z),v.length=0,C=0,D({stream:b,detected:O})}catch(O){j.cancel(),b.destroy(),$(O)}};(0,I.$9d)(l,{onData:async O=>{N?b.write(N.write(O.buffer)):(v.push(O),C+=O.byteLength,C>=k&&(l.pause(),await M(),setTimeout(()=>l.resume())))},onError:O=>b.error(O),onEnd:async()=>{N||await M(),b.end(N?.end())}},j.token)})}e.$XC=S;async function w(l,h,k){const $=(await(0,m.$NC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(h),k);let b=!1,v=!1;return{read(){if(v)return null;const C=l.read();if(typeof C!="string"){if(v=!0,!b&&k?.addBOM)switch(h){case e.$OC:case e.$PC:return F.$ee.wrap(Uint8Array.from(e.$VC));case e.$QC:return F.$ee.wrap(Uint8Array.from(e.$TC));case e.$RC:return F.$ee.wrap(Uint8Array.from(e.$UC))}const N=$.end();return N&&N.length>0?(b=!0,F.$ee.wrap(N)):null}return b=!0,F.$ee.wrap($.write(C))}}}e.$YC=w;async function c(l){return(await(0,m.$NC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(l))}e.$ZC=c;function s(l){return l===e.$PC||l===null?e.$OC:l}e.$1C=s;function i(l,h){if(!l||h<e.$TC.length)return null;const k=l.readUInt8(0),D=l.readUInt8(1);if(k===e.$TC[0]&&D===e.$TC[1])return e.$QC;if(k===e.$UC[0]&&D===e.$UC[1])return e.$RC;if(h<e.$VC.length)return null;const $=l.readUInt8(2);return k===e.$VC[0]&&D===e.$VC[1]&&$===e.$VC[2]?e.$PC:null}e.$2C=i;const n=["ascii","utf-16","utf-32"];async function o(l){const h=await(0,m.$NC)("jschardet","dist/jschardet.min.js"),k=l.slice(0,A),D=r(k.buffer),$=h.detect(D);if(!$||!$.encoding)return null;const b=$.encoding.toLowerCase();return 0<=n.indexOf(b)?null:t($.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(l){const h=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function r(l){let h="";for(let k=0;k<l.length;k++)h+=String.fromCharCode(l[k]);return h}function d(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=l.match(/windows(\d+)/);return h?"windows-"+h[1]:l}}}e.$3C=d;function u({buffer:l,bytesRead:h},k){let D=i(l,h),$=!1;if(D!==e.$QC&&D!==e.$RC&&l){let b=!0,v=!0,C=!1;for(let N=0;N<h&&N<p;N++){const j=N%2===1,M=l.readUInt8(N)===0;if(M&&(C=!0),b&&(j&&!M||!j&&M)&&(b=!1),v&&(j&&M||!j&&!M)&&(v=!1),M&&!b&&!v)break}C&&(b?D=e.$RC:v?D=e.$QC:$=!0)}return k&&!$&&!D&&l?o(l.slice(0,h)).then(b=>({seemsBinary:!1,encoding:b})):{seemsBinary:$,encoding:D}}e.$4C=u,e.$5C={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[157],Se([1,0,377,30,156]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;class L extends m.$Yec{constructor(p,E,g=F,A="searchProcess"){super(p,E,{readdir:P=>g.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,I.$3C)(P)},A)}}e.$$fc=L}),define(ke[158],Se([1,0,50,393,376,19,74,34,16,13,2,36,94,394,374,119]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=e.$8fc=e.$7fc=e.$6fc=e.$5fc=e.$4fc=void 0;const c=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(v){this.a=v}provideTextSearchResults(v,C,N,j){return this.a.appendLine(`provideTextSearchResults ${v.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise((M,O)=>{j.onCancellationRequested(()=>J());const z=r(v,C),T=C.folder.fsPath,W=z.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");this.a.appendLine(`${c} ${W}
 - cwd: ${T}`);let V=I.spawn(c,z,{cwd:T});V.on("error",K=>{console.error(K),this.a.appendLine("Error: "+(K&&K.message)),O((0,P.$0I)(new P.$8I(K&&K.message,P.SearchErrorCode.rgProcessError)))});let de=!1;const ee=new o(C.maxResults,T,C.previewOptions);ee.on("result",K=>{de=!0,x="",N.report(K)});let Z=!1;const J=()=>{Z=!0,V?.kill(),ee?.cancel()};let ae=!1;ee.on("hitLimit",()=>{ae=!0,J()});let x="";V.stdout.on("data",K=>{ee.handleData(K),de||(x+=K)});let Ee=!1;V.stdout.once("data",()=>Ee=!0);let le="";V.stderr.on("data",K=>{const U=K.toString();this.a.appendLine(U),le.length+U.length<1e6&&(le+=U)}),V.on("close",()=>{if(this.a.appendLine(Ee?"Got data from stdout":"No data from stdout"),this.a.appendLine(de?"Got result from parser":"No result from parser"),x&&this.a.appendLine(`Got data without result: ${x}`),this.a.appendLine(""),Z)M({limitHit:ae});else{ee.flush(),V=null;let K;le&&!Ee&&(K=i(le))?O((0,P.$0I)(new P.$8I(K.message,K.code))):M({limitHit:ae})}})})}}e.$4fc=s;function i(b){const v=b.split(`
`),C=v[0].trim();if(v.some(j=>j.startsWith("regex parse error")))return new P.$8I(n(v),P.SearchErrorCode.regexParseError);const N=C.match(/grep config error: unknown encoding: (.*)/);if(N)return new P.$8I(`Unknown encoding: ${N[1]}`,P.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new P.$8I(C.charAt(0).toUpperCase()+C.substr(1),P.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new P.$8I(C.charAt(0).toUpperCase()+C.substr(1),P.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new P.$8I(C,P.SearchErrorCode.regexParseError)}function n(b){const v=["Regex parse error"],C=b.filter(N=>N.startsWith("PCRE2:"));if(C.length>=1){const N=C[0].replace("PCRE2:","");if(N.indexOf(":")!==-1&&N.split(":").length>=2){const j=N.split(":")[1];v.push(":"+j)}}return v.join("")}class o extends F.EventEmitter{constructor(v,C,N){super(),this.g=v,this.h=C,this.j=N,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new m.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(v,C){return super.on(v,C),this}handleData(v){if(this.b)return;const C=typeof v=="string"?v:this.d.write(v);this.k(C)}k(v){let C=v.indexOf(`
`);const N=this.a+v;if(C>=0)C+=this.a.length;else{this.a=N;return}let j=0;for(;C>=0;)this.m(N.substring(j,C).trim()),j=C+1,C=N.indexOf(`
`,j);this.a=N.substring(j)}m(v){if(this.b||!v)return;let C;try{C=JSON.parse(v)}catch{throw new Error(`malformed line from rg: ${v}`)}if(C.type==="match"){const N=a(C.data.path),j=A.URI.file(E.$ic(this.h,N)),M=this.n(C.data,j);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const N=a(C.data.path),j=A.URI.file(E.$ic(this.h,N));this.o(C.data,j).forEach(O=>this.p(O))}}n(v,C){const N=v.line_number-1,j=a(v.lines),M=Buffer.from(j);let O=0,z=0,T=N;v.submatches.length===0&&v.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const W=(0,L.$Gb)(v.submatches.map((V,de)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ee=a(V.match),Z=M.slice(O,V.start).toString(),J=t(Z),ae=J.numLines>0?J.lastLineLength:J.lastLineLength+z,x=t(ee),Ee=J.numLines+T,le=x.numLines+Ee,K=x.numLines>0?x.lastLineLength:x.lastLineLength+ae;return O=V.end,z=K,T=le,new f.$RI(Ee,ae,le,K)}));return(0,w.$Wfc)(C,j,W,this.j)}o(v,C){const N=a(v.lines),j=v.line_number;return N.replace(/\r?\n$/,"").split(`
`).map((M,O)=>({text:M,uri:C,lineNumber:j+O}))}p(v){this.emit("result",v)}}e.$5fc=o;function a(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const v=/\n/g;let C=0,N=-1,j;for(;j=v.exec(b);)C++,N=j.index;const M=N>=0?b.length-N-1:b.length;return{numLines:C,lastLineLength:M}}function r(b,v){const C=["--hidden","--no-require-git"];C.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:N,otherIncludes:j}=(0,R.$J)(v.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const O=new Set;j.forEach(z=>{O.add(z)}),C.push("-g","!*"),O.forEach(z=>{d(z).map(w.$Vfc).forEach(T=>{C.push("-g",T)})})}N&&N.length&&N.forEach(O=>{C.push("-g",O)}),v.excludes.map(w.$Vfc).forEach(O=>C.push("-g",`!${O}`)),v.maxFileSize&&C.push("--max-filesize",v.maxFileSize+""),v.useIgnoreFiles?v.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),v.followSymlinks&&C.push("--follow"),v.encoding&&v.encoding!=="utf8"&&C.push("--encoding",v.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,g.$Ie)(b.pattern),b.isRegExp=!0),v.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),b.isRegExp&&(b.pattern=u(b.pattern),C.push("--engine","auto"));let M;if(b.isWordMatch){const z=(0,g.$Qe)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",z)}else if(b.isRegExp){let O=h(b.pattern);O=k(O),C.push("--regexp",O)}else M=b.pattern,C.push("--fixed-strings");return C.push("--no-config"),v.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),b.isMultiline&&C.push("--multiline"),v.beforeContext&&C.push("--before-context",v.beforeContext+""),v.afterContext&&C.push("--after-context",v.afterContext+""),C.push("--"),M&&C.push(M),C.push("."),C}e.$6fc=r;function d(b){return $(b).flatMap(C=>{const N=(0,p.$zj)(C,"/");return N.map((j,M)=>N.slice(0,M+1).join("/"))})}function u(b){const v=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(v);)b=b.replace(v,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(C);)b=b.replace(C,"$1\\x{$2}");return b}e.$7fc=u;const l=b=>b.type==="Assertion"&&b.kind==="lookbehind";function h(b){let v;try{v=new y.RegExpParser().parsePattern(b)}catch{return b}let C="",N=0;const j=(z,T,W)=>{C+=b.slice(N,z)+W,N=T},M=[];return new y.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const T=M[0];if(!T)j(z.start,z.end,"\\r?\\n");else if(!M.some(l))if(T.type==="CharacterClass")if(T.negate){const W=b.slice(T.start+2,z.start)+b.slice(z.end,T.end-1);T.parent?.type==="Quantifier"?j(T.start,T.end,W?`[^${W}]`:"."):j(T.start,T.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=b.slice(T.start+1,z.start)+b.slice(z.end,T.end-1);j(T.start,T.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else T.type==="Quantifier"&&j(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){M.unshift(z)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(z){M.unshift(z)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(z){M.unshift(z)},onCharacterClassLeave(){M.shift()},onAssertionEnter(z){l(z)&&M.push(z)},onAssertionLeave(z){M[0]===z&&M.shift()}}).visit(v),C+=b.slice(N),C}e.$8fc=h;function k(b){return b.replace(/\n/g,"\\r?\\n")}e.$9fc=k;function D(b){let v=!1,C=!1,N="",j="";for(let M=0;M<b.length;M++){const O=b[M];switch(O){case"\\":C?(v?j+="\\"+O:N+="\\"+O,C=!1):C=!0;break;case"{":if(C)v?j+=O:N+=O,C=!1;else{if(v)return{strInBraces:N+"{"+j+"{"+b.substring(M+1)};v=!0}break;case"}":if(C)v?j+=O:N+=O,C=!1;else{if(v)return{fixedStart:N,strInBraces:j,fixedEnd:b.substring(M+1)};N+=O}break;default:v?j+=(C?"\\":"")+O:N+=(C?"\\":"")+O,C=!1;break}}return{strInBraces:N+(v?"{"+j:"")}}function $(b){const{fixedStart:v,strInBraces:C,fixedEnd:N}=D(b);if(v===void 0||N===void 0)return[C];let j=(0,p.$zj)(C,",");j.length||(j=[""]);const M=$(N);return j.flatMap(O=>{const z=v+O;return M.map(T=>z+T)})}e.$0fc=$}),define(ke[378],Se([1,0,21,158,64,17]),function(me,e,I,F,m,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=void 0;class R{constructor(g){this.b=g,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(g,A,P,f){const y=new F.$4fc(this.b);if(A.folder.scheme===L.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:L.Schemas.file})},w=new m.$$u(c=>P.report({...c,uri:c.uri.with({scheme:A.folder.scheme})}));return this.c(f,c=>y.provideTextSearchResults(g,S,w,c))}else return this.c(f,S=>y.provideTextSearchResults(g,A,P,S))}async c(g,A){const P=p(g);this.a.add(P);const f=await A(P.token);return this.a.delete(P),f}d(){this.a.forEach(g=>g.cancel())}}e.$bgc=R;function p(E){const g=new I.$1d;return E.onCancellationRequested(()=>g.cancel()),g}}),define(ke[379],Se([1,0,30,158,157]),function(me,e,I,F,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class L{constructor(E){this.a=E}search(E,g,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(y){A({message:y})}},f=new m.$$fc(this.a,new F.$4fc(P),I);return new Promise((y,S)=>f.search(w=>{g(w.map(R))},E).then(w=>y({limitHit:w.limitHit,type:"success",stats:w.stats}),S))}}e.$_fc=L;function R(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce((E,g)=>{if(g.ranges){const A=g;return E+(Array.isArray(A.ranges)?A.ranges.length:1)}else return E+1},0)}}}),define(ke[380],Se([1,0,19,10,11,4,130,16,37,2,31,36,375,379]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class S{static{this.a=512}constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let a;const t=s(o),r=new L.$Qd({onDidAddFirstListener:()=>{a=(0,F.$Kg)(d=>this.doFileSearchWithEngine(f.$3fc,t,u=>r.fire(u),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}textSearch(o){let a;const t=s(o),r=new L.$Qd({onDidAddFirstListener:()=>{a=(0,F.$Kg)(d=>this.f(t,u=>r.fire(u),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}f(o,a,t){return o.maxFileSize=this.g().maxFileSize,new y.$_fc(o).search(t,a,a)}g(){return{maxFileSize:16*A.$Lk.GB}}doFileSearch(o,a,t){return this.doFileSearchWithEngine(f.$3fc,o,a,t)}doFileSearchWithEngine(o,a,t,r,d=S.a){let u=0;const l=k=>{Array.isArray(k)?(u+=k.length,t(k.map(D=>this.h(D)))):k.relativePath?(u++,t(this.h(k))):t(k)};if(a.sortByScore){let k=this.l(a,l,r);if(!k){const D=a.maxResults?Object.assign({},a,{maxResults:null}):a,$=new o(D);k=this.j($,a,t,l,r)}return new Promise((D,$)=>{k.then(([b,v])=>{const C=v.map(N=>this.h(N));this.o(C,t,d),D(b)},$)})}const h=new o(a);return this.r(h,l,d,r).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}h(o){return{path:o.base?(0,p.$ic)(o.base,o.relativePath):o.relativePath}}j(o,a,t,r,d){const u=new L.$Qd;let l=(0,F.$Kg)(k=>{let D=[];const $=b=>{Array.isArray(b)?D=b:(r(b),u.fire(b))};return this.r(o,$,-1,k).then(b=>[b,D])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const k={promise:l,event:u.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=k,l.then(()=>{k.resolved=!0},D=>{delete h.resultsToSearchCache[a.filePattern||""]}),l=this.s(l)}return l.then(([k,D])=>{const $=h?h.scorerCache:Object.create(null),b=(typeof a.maxResults!="number"||a.maxResults>0)&&E.$Md.create(!1);return this.n(a,D,$,d).then(v=>{const C=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:v.length},messages:k.messages,limitHit:k.limitHit||typeof a.maxResults=="number"&&D.length>a.maxResults},v]})})}k(o){const a=this.b[o];return a||(this.b[o]=new w)}l(o,a,t){const r=o.cacheKey&&this.b[o.cacheKey];if(!r)return;const d=this.q(r,o.filePattern||"",a,t);if(d)return d.then(([u,l,h])=>{const k=E.$Md.create(!1);return this.n(o,l,r.scorerCache,t).then(D=>{const $=k.elapsed(),b={fromCache:!0,detailStats:h,type:this.d,resultCount:l.length,sortingTime:$};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&l.length>o.maxResults,stats:b},D]})})}n(o,a,t,r){const d=(0,R.$Dq)(o.filePattern||""),u=(h,k)=>(0,R.$Cq)(h,k,d,!0,c,t),l=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return I.$Fb(a,u,l,1e4,r)}o(o,a,t){if(t&&t>0)for(let r=0;r<o.length;r+=t)a(o.slice(r,r+t));else a(o)}q(o,a,t,r){const d=E.$Md.create(!1),u=a.indexOf(p.sep)>=0;let l;for(const $ in o.resultsToSearchCache)if(a.startsWith($)){if(u&&$.indexOf(p.sep)<0&&$!=="")continue;const b=o.resultsToSearchCache[$];l={promise:this.s(b.promise),event:b.event,resolved:b.resolved};break}if(!l)return null;const h=d.elapsed(),k=E.$Md.create(!1),D=l.event(t);return r&&r.onCancellationRequested(()=>{D.dispose()}),l.promise.then(([$,b])=>{if(r&&r.isCancellationRequested)throw(0,m.$5)();const v=[],C=(0,R.$Dq)(a).normalizedLowercase;for(const N of b)(0,P.$bJ)(N,C)&&v.push(N);return[$,v,{cacheWasResolved:l.resolved,cacheLookupTime:h,cacheFilterTime:k.elapsed(),cacheEntryCount:b.length}]})}r(o,a,t,r){return new Promise((d,u)=>{let l=[];r?.onCancellationRequested(()=>o.cancel()),o.search(h=>{h&&(t?(l.push(h),t>0&&l.length>=t&&(a(l),l=[])):a(h))},h=>{a(h)},(h,k)=>{l.length&&a(l),h?u(h):d(k)})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return o.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return o.finally(a)}}}}e.$agc=S;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const c=new class{getItemLabel(n){return(0,p.$mc)(n.relativePath)}getItemDescription(n){return(0,p.$lc)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>g.URI.revive(o))}}function i(n){return{...n,folder:g.URI.revive(n.folder)}}}),define(ke[381],Se([1,0,3,17,2,30,15,27,20,97,67,36,380,378,119,157]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;let c=class extends g.$4ec{constructor(i,n,o,a){super(i,o,a),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new I.$Qc;const t=new S.$Xfc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new y.$bgc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$Xfc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new y.$bgc(i))),this.x.add(this.z(F.Schemas.file,new f.$agc("fileSearchProvider")))}z(i,n){const o=this.d++;return this.v=n,this.t=o,this.c.$registerFileSearchProvider(o,this.o(i)),(0,I.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults(i,n,o,a){const t=(0,g.$5ec)(o);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,o,a)}doInternalFileSearchWithCustomCallback(i,n,o){const a=t=>{if((0,P.$aJ)(t)&&(t=[t]),Array.isArray(t)){o(t.map(r=>m.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,o,a){return this.doInternalFileSearchWithCustomCallback(o,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new w.$$fc(i,n,void 0,"textSearchProvider")}};e.$cgc=c,e.$cgc=c=He([Be(0,E.$BM),Be(1,p.$RM),Be(2,A.$Jdc),Be(3,R.$cj)],c)}),define(ke[120],Se([1,0,395,62,63,396,22,11,4,3,16,12,32,82,83]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0;class w{traceSocketEvent(b,v){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,v)}constructor(b,v=""){this.f=!0,this.debugLabel=v,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,p.$Z)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(b){const v=C=>{this.traceSocketEvent("read",C),b(R.$ee.wrap(C))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(b){const v=C=>{b({type:0,hadError:C,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(b){const v=()=>{b()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(b){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,p.$Z)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,p.$Z)(v)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$Jh=w;var c;(function($){$[$.MinHeaderByteSize=2]="MinHeaderByteSize",$[$.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var s;(function($){$[$.PeekHeader=1]="PeekHeader",$[$.ReadHeader=2]="ReadHeader",$[$.ReadBody=3]="ReadBody",$[$.Fin=4]="Fin"})(s||(s={}));class i extends g.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(b,v){this.socket.traceSocketEvent(b,v)}constructor(b,v,C,N){super(),this.f=this.B(new E.$Qd),this.g=this.B(new E.$Qd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:C?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new n(this,v,C,N,this.f,(j,M)=>this.m(j,M))),this.B(this.a.onError(j=>{console.error(j),(0,p.$Z)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new S.$Eh,this.B(this.socket.onData(j=>this.n(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this.f.event(b)}onClose(b){return this.g.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let v=0;for(;v<b.byteLength;)this.a.writeMessage(b.slice(v,Math.min(v+262144,b.byteLength)),{compressed:!0,opcode:2}),v+=262144}m(b,{compressed:v,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let N=2;b.byteLength<126?N+=0:b.byteLength<2**16?N+=2:N+=8;const j=R.$ee.alloc(N),M=v?64:0,O=C&15;if(j.writeUInt8(128|M|O,0),b.byteLength<126)j.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){j.writeUInt8(126,1);let z=1;j.writeUInt8(b.byteLength>>>8&255,++z),j.writeUInt8(b.byteLength>>>0&255,++z)}else{j.writeUInt8(127,1);let z=1;j.writeUInt8(0,++z),j.writeUInt8(0,++z),j.writeUInt8(0,++z),j.writeUInt8(0,++z),j.writeUInt8(b.byteLength>>>24&255,++z),j.writeUInt8(b.byteLength>>>16&255,++z),j.writeUInt8(b.byteLength>>>8&255,++z),j.writeUInt8(b.byteLength>>>0&255,++z)}this.socket.write(R.$ee.concat([j,b]))}end(){this.h=!0,this.socket.end()}n(b){if(b.byteLength!==0){for(this.b.acceptChunk(b);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const v=this.b.peek(this.j.readLen),C=v.readUInt8(0),N=(C&128)>>>7,j=(C&64)>>>6,M=C&15,O=v.readUInt8(1),z=(O&128)>>>7,T=O&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const v=this.b.read(this.j.readLen),C=v.readUInt8(1),N=(C&128)>>>7;let j=C&127,M=1;j===126?j=v.readUInt8(++M)*2**8+v.readUInt8(++M):j===127&&(j=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let O=0;N&&(O=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=3,this.j.readLen=j,this.j.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const v=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",v),t(v,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",v),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Kh=i;class n extends g.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$ee.alloc(0)}constructor(b,v,C,N,j,M){super(),this.n=b,this.r=j,this.s=M,this.a=this.B(new E.$Qd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$Qd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new E.$Qd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new o(this.n,N,C,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(O=>this.a.fire(O))),this.B(this.f.onError(O=>this.a.fire(O)))):(this.b=null,this.f=null)}writeMessage(b,v){this.g.push({data:b,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:b,options:v}=this.g.shift();if(this.f&&v.compressed){const C=await this.w(this.f,b);this.s(C,v)}else this.s(b,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(b,v){return new Promise((C,N)=>{b.write(v),b.flush(j=>C(j))})}acceptFrame(b,v,C){this.h.push({data:b,isCompressed:v,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const b=this.h.shift();if(this.b&&b.isCompressed){const v=await this.C(this.b,b.data,b.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(b.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(b,v,C){return new Promise((N,j)=>{b.write(v),C&&b.write(R.$ee.fromByteArray([0,0,255,255])),b.flush(M=>N(M))})}}class o extends g.$Rc{get recordedInflateBytes(){return this.j?R.$ee.concat(this.f):R.$ee.alloc(0)}constructor(b,v,C,N){super(),this.h=b,this.j=v,this.a=this.B(new E.$Qd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(R.$ee.wrap(j))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(b){this.j&&this.f.push(b.clone()),this.h.traceSocketEvent("zlibInflateWrite",b),this.b.write(b.buffer)}flush(b){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const v=R.$ee.concat(this.g);this.g.length=0,b(v)})}}class a extends g.$Rc{constructor(b,v){super(),this.g=b,this.a=this.B(new E.$Qd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(R.$ee.wrap(C))})}write(b){this.g.traceSocketEvent("zlibDeflateWrite",b.buffer),this.b.write(b.buffer)}flush(b){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let v=R.$ee.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),b(v)})}}function t($,b){if(b===0)return;const v=$.byteLength>>>2;for(let z=0;z<v;z++){const T=$.readUInt32BE(z*4);$.writeUInt32BE(T^b,z*4)}const C=v*4,N=$.byteLength-C,j=b>>>24&255,M=b>>>16&255,O=b>>>8&255;N>=1&&$.writeUInt8($.readUInt8(C)^j,C),N>=2&&$.writeUInt8($.readUInt8(C+1)^M,C+1),N>=3&&$.writeUInt8($.readUInt8(C+2)^O,C+2)}e.$Lh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function d(){const $=(0,f.$hg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${$}-sock`;const b=process.platform!=="darwin"&&e.$Lh?e.$Lh:(0,m.tmpdir)(),v=(0,A.$ic)(b,`vscode-ipc-${$}.sock`);return l(v),v}e.$Mh=d;function u($,b,v){const C=(0,I.createHash)("md5").update($).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${v}-${b}-sock`;const N=v.substr(0,4),j=b.substr(0,6),M=C.substr(0,8);let O;return process.platform!=="darwin"&&e.$Lh&&!process.env.VSCODE_PORTABLE?O=(0,A.$ic)(e.$Lh,`vscode-${M}-${N}-${j}.sock`):O=(0,A.$ic)($,`${N}-${j}.sock`),l(O),O}e.$Nh=u;function l($){const b=r[P.$u];typeof b=="number"&&$.length>=b&&console.warn(`WARNING: IPC handle "${$}" is longer than ${b} chars, try a shorter --user-data-dir`)}class h extends y.$yh{static b(b){const v=E.Event.fromNodeEventEmitter(b,"connection");return E.Event.map(v,C=>({protocol:new S.$Fh(new w(C,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(C,"close"))}))}constructor(b){super(h.b(b)),this.d=b}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Oh=h;function k($){return new Promise((b,v)=>{const C=(0,F.createServer)();C.on("error",v),C.listen($,()=>{C.removeListener("error",v),b(new h(C))})})}e.$Ph=k;function D($,b){return new Promise((v,C)=>{const N=(0,F.createConnection)($,()=>{N.removeListener("error",C),v(S.$Gh.fromSocket(new w(N,`ipc-client${b}`),b))});N.once("error",C)})}e.$Qh=D}),define(ke[382],Se([1,0,62,63,166,120,10,3,12,44,15,138,258,259,109,88,22]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=e.$F9b=e.$E9b=e.$D9b=void 0;async function s(t,r,d,u,l){let h;for(let k=3;k&&(h?.dispose(),h=await new i(t,r,d,u,l).waitForReady(),!(l&&m.$kg[l]||!m.$kg[h.tunnelLocalPort]));k--);return h}class i extends p.$Rc{constructor(r,d,u,l,h){super(),this.m=d,this.n=h,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=I.createServer(),this.c=new R.$Vg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,d=(0,w.$kv)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,m.$lg)(r,2,1e3,d),l=null;return this.b.listen(u,this.m),await this.c.wait(),l=this.b.address(),l||(u=0,this.b.listen(u,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(r){r.pause();const d=(0,w.$iv)(this.tunnelRemoteHost)||(0,w.$kv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,f.$$k)(this.a,d,this.tunnelRemotePort),l=u.getSocket(),h=u.readEntireBuffer();u.dispose(),h.byteLength>0&&r.write(h.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),l.end()}),r.on("close",()=>l.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),l instanceof L.$Jh?l.socket.destroy():l.end()}),l instanceof L.$Jh?this.t(r,l):this.s(r,l),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),l.end()})}s(r,d){d.onClose(()=>r.destroy()),d.onEnd(()=>r.end()),d.onData(u=>r.write(u.buffer)),r.on("data",u=>d.write(c.$ee.wrap(u))),r.resume()}t(r,d){const u=d.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.$D9b=i;let n=class extends w.$nv{constructor(r,d,u,l,h){super(d,h),this.u=r,this.v=u,this.w=l}isPortPrivileged(r){return(0,w.$lv)(r,this.l,E.OS,F.release())}s(r,d,u,l,h,k,D,$){const b=this.r(d,u);if(b)return++b.refcount,b.value;if((0,w.$fv)(r))return this.t(r,d,u,h,k,D,$);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${u} on local port ${h}.`);const v={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},C=s(v,l,d,u,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,u,C),C}}};e.$E9b=n,e.$E9b=n=He([Be(0,y.$5k),Be(1,A.$cj),Be(2,S.$8k),Be(3,P.$uj),Be(4,g.$oi)],n);let o=class extends n{constructor(r,d,u,l,h){super(r,d,u,l,h)}};e.$F9b=o,e.$F9b=o=He([Be(0,y.$5k),Be(1,A.$cj),Be(2,S.$8k),Be(3,P.$uj),Be(4,g.$oi)],o);let a=class extends p.$Rc{constructor(r,d,u,l,h){super(),this.b=r,this.c=d,this.f=u,this.g=l,this.h=h,this.a=new Map}async openTunnel(r,d,u,l,h,k,D,$,b){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${l} on local port ${k}.`),!this.a.has(r)){const v=new o(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(r,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(d,u,l,h,k,D,$,b)}};e.$G9b=a,e.$G9b=a=He([Be(0,y.$5k),Be(1,A.$cj),Be(2,P.$uj),Be(3,S.$8k),Be(4,g.$oi)],a)}),define(ke[383],Se([1,0,120,278,55,35,2,15,40]),function(me,e,I,F,m,L,R,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=void 0;class g{constructor(f,y,S){this.b=f,this.c=y,this.f=S,this.a=F.createServer((w,c)=>this.h(w,c)),this.g().catch(w=>(y.error(w),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",f=>this.c.error(f))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(f,y){const S=(c,s)=>{y.writeHead(c,{"content-type":"application/json"}),y.end(JSON.stringify(s||null),i=>i&&this.c.error(i))},w=[];f.setEncoding("utf8"),f.on("data",c=>w.push(c)),f.on("end",async()=>{try{const c=JSON.parse(w.join(""));let s;switch(c.type){case"open":s=await this.i(c);break;case"openExternal":s=await this.j(c);break;case"status":s=await this.l(c);break;case"extensionManagement":s=await this.k(c);break;default:S(404,`Unknown message type: ${c.type}`);break}S(200,s)}catch(c){const s=c instanceof Error?c.message:JSON.stringify(c);S(500,s),this.c.error("Error while processing pipe request",c)}})}async i(f){const{fileURIs:y,folderURIs:S,forceNewWindow:w,diffMode:c,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:a,remoteAuthority:t}=f,r=[];if(Array.isArray(S))for(const h of S)try{r.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(y))for(const h of y)try{(0,E.$ni)(h)?r.push({workspaceUri:R.URI.parse(h)}):r.push({fileUri:R.URI.parse(h)})}catch{}const d=a?R.URI.file(a):void 0,l={forceNewWindow:w,diffMode:c,mergeMode:s,addMode:i,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,l)}async j(f){for(const y of f.uris){const S=R.URI.parse(y),w=S.scheme==="file"?S:y;await this.b.executeCommand("_remoteCLI.openExternal",w)}}async k(f){const y=w=>w?.map(c=>/\.vsix$/i.test(c)?R.URI.parse(c):c),S={list:f.list,install:y(f.install),uninstall:y(f.uninstall),force:f.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(f){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&m.existsSync(this.f)&&m.unlinkSync(this.f)}}e.$3M=g;let A=class extends g{constructor(f,y){super(f,y,(0,I.$Mh)())}};e.$4M=A,e.$4M=A=He([Be(0,L.$XM),Be(1,p.$cj)],A)}),define(ke[384],Se([1,0,56,371,366,277,47,351,2,17,7,383,103,349,350]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class w extends m.$Ifc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(d,u,l){return d=t(d),i.a.has(d)?i.a.get(d).load(d,E.URI.file((0,f.$aq)(u.filename)),h=>o.apply(this,[h,u,l])):o.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(r,d)=>a.call(this,t(r),d);const t=r=>{for(const d of i.b){const u=d(r);if(u){r=u;break}}return r}}}class c extends R.$hec{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(y.$fgc);const i=this.h.invokeFunction(F.$Efc);if(this.h.createInstance(p.$egc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(P.$4M);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$ggc),await this.h.createInstance(w,i,{mine:this.J,all:this.L}).install(),I.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,L.$dgc)(this.j,o,this,this.s,this.z,this.f),I.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,o){if(n.scheme!==g.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&I.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&I.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const o=i[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$hgc=c}),define(ke[385],Se([1,0,50,22,4,3,123,12,23,2,30,15,257,65,109,88,382,27,20,73,360]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=e.$ogc=e.$ngc=e.$mgc=e.$lgc=e.$kgc=e.$jgc=e.$igc=void 0;function a(b){const v=b.trim().split(`
`),C=[];return v.forEach(j=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);M&&M.length>=3&&C.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),C.reduce((j,M)=>(j[M.socket]=M,j),{})}e.$igc=a;function t(...b){const v=[].concat(...b.map(d));return[...new Map(v.filter(C=>C.st==="0A").map(C=>{const N=C.local_address.split(":");return{socket:parseInt(C.inode,10),ip:r(N[0]),port:parseInt(N[1],16)}}).map(C=>[C.ip+":"+C.port,C])).values()]}e.$jgc=t;function r(b){let v="";if(b.length===8)for(let C=b.length-2;C>=0;C-=2)v+=parseInt(b.substr(C,2),16),C!==0&&(v+=".");else for(let C=0;C<b.length;C+=8){const N=b.substring(C,C+8);let j="";for(let M=8;M>=2;M-=2)j+=N.substring(M-2,M),(M===6||M===2)&&(j=parseInt(j,16).toString(16),v+=`${j}`,j="",C+M!==b.length-6&&(v+=":"))}return v}e.$kgc=r;function d(b){const v=b.trim().split(`
`),C=v.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return v.map(j=>j.trim().split(/\s+/).reduce((M,O,z)=>(M[C[z]||z]=O,M),{}))}e.$lgc=d;function u(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function l(b){const v=b.trim().split(`
`),C=[];return v.forEach(N=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);j&&j.length>=4&&C.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),C}e.$mgc=l;async function h(b,v,C){const N=C.reduce((M,O)=>(M[O.pid]=O,M),{}),j=[];return b.forEach(({socket:M,ip:O,port:z})=>{const T=v[M]?v[M].pid:void 0,W=T?N[T]?.cmd:void 0;T&&W&&!u(W)&&j.push({host:O,port:z,detail:W,pid:T})}),j}e.$ngc=h;function k(b,v,C){const N=new Map,j=l(v);for(const M of b){const O=C.get(M.port);if(O){N.set(M.port,O);continue}const z=j.find(T=>T.cmd.includes(`${M.port}`));if(z){let T=z,W;do W=j.find(V=>V.ppid===T.pid),W&&(T=W);while(W);N.set(M.port,{host:M.ip,port:M.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else N.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return N}e.$ogc=k;let D=class extends n.$Vwb{constructor(v,C,N,j){super(v,C,N),this.D=C,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,p.$k&&C.remote.isRemote&&C.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let C;this.y&&(C=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new R.$Wl;let j=0;for(;this.C;){const M=new Date().getTime(),O=(await this.I()).filter(W=>(0,w.$iv)(W.host)||(0,w.$kv)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(W=>W.port).join(", ")}`);const z=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${z} ms.`),j++>3&&N.update(z),(!C||JSON.stringify(C)!==JSON.stringify(O))&&(C=O,await this.a.$onFoundNewCandidates(C));const T=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(W=>setTimeout(()=>W(),T))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",C="";try{v=await A.Promises.readFile("/proc/net/tcp","utf8"),C=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(v,C),j=await new Promise(ee=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,J,ae)=>{ee(J)})}),M=a(j),O=await A.Promises.readdir("/proc"),z=[];for(const ee of O)try{const Z=Number(ee),J=E.$yg(g.URI.file("/proc"),ee);if((await A.Promises.stat(J.fsPath)).isDirectory()&&!isNaN(Z)){const x=await A.Promises.readlink(E.$yg(J,"cwd").fsPath),Ee=await A.Promises.readFile(E.$yg(J,"cmdline").fsPath,"utf8");z.push({pid:Z,cwd:x,cmd:Ee})}}catch{}const T=[],W=N.filter(ee=>{const Z=M[ee.socket];return Z||T.push(ee),Z}),V=h(W,M,z);let de;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const ee=await new Promise(Z=>{(0,I.exec)("ps -F -A -l | grep root",(J,ae,x)=>{Z(ae)})});this.z=k(T,ee,this.z),de=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${de.map(Z=>Z.port).join(", ")}`)}return V.then(ee=>de?ee.concat(de):ee)}w(v){return async C=>{const N=new c.$D9b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,O,z,T){const W=await v.makeConnection();return $.connect(W,O,z,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new y.$Vk(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",C.remoteAddress.host||"localhost",C.remoteAddress.port,C.localAddressPort);await N.waitForReady();const j=new m.$Qd;return{localAddress:(0,o.$WJ)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{N.dispose(),j.fire(),j.dispose()}}}}};e.$pgc=D,e.$pgc=D=He([Be(0,i.$BM),Be(1,s.$RM),Be(2,P.$cj),Be(3,S.$8k)],D);class $ extends f.$_pb{static connect(v,C,N,j){const M=new L.$Qc,O={onClose:M.add(new m.$Qd),onData:M.add(new m.$Qd),onEnd:M.add(new m.$Qd)};M.add(v.onDidReceiveMessage(T=>O.onData.fire(F.$ee.wrap(T)))),M.add(v.onDidEnd(()=>O.onEnd.fire())),M.add(v.onDidClose(T=>O.onClose.fire({type:0,error:T,hadError:!!T})));const z=new $(v,j,O);return z.B(M),(0,f.$$pb)(z,C,N,j,O)}constructor(v,C,N){super(C,N),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[386],Se([1,0,106,354,369,368,381,384,385,96,47,97,95,46,73,92,353,352,15,370,58,272,105,109,140]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$Cr)(A.$iec,p.$hgc,0),(0,I.$Cr)(i.$dj,s.$rgc,1),(0,I.$Cr)(i.$cj,new t.$Rh(a.$Hfc,[!1],!0)),(0,I.$Cr)(r.$8k,d.$I9b,1),(0,I.$Cr)(w.$6dc,c.$qgc,0),(0,I.$Cr)(g.$Sec,L.$Ufc,0),(0,I.$Cr)(P.$3ec,R.$cgc,0),(0,I.$Cr)(f.$Nec,m.$Mfc,0),(0,I.$Cr)(y.$8dc,F.$Lfc,0),(0,I.$Cr)(S.$Uwb,E.$pgc,0),(0,I.$Cr)(o.$Qec,n.$sgc,0)}),define(ke[397],Se([1,0,62,398,56,11,83,120,255,114,367,22,30,103,10,133,279,293,372,386]),function(me,e,I,F,m,L,R,p,E,g,A,P,f,y,S,w,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const i=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,h=l._load;l._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const n=process.exit.bind(process);function o(l){process.exit=function(h){if(l)n(h);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(l){n()};function t(){const l=(0,s.$Gm)(process.env);if(l.type===3)return new Promise((h,k)=>{const D=$=>{const b=$[0],v=new R.$Hh;b.on("message",C=>v.fire(P.$ee.wrap(C.data))),b.on("close",()=>{a("renderer closed the MessagePort")}),b.start(),h({onMessage:v.event,send:C=>b.postMessage(C.buffer)})};process.parentPort.on("message",$=>D($.ports))});if(l.type===2)return new Promise((h,k)=>{let D=null;const $=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,v=3e5,C=new S.$0g(()=>a("renderer disconnected for too long (1)"),b),N=new S.$0g(()=>a("renderer disconnected for too long (2)"),v);process.on("message",(M,O)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const z=P.$ee.wrap(Buffer.from(M.initialDataChunk,"base64"));let T;if(M.skipWebSocketFrames)T=new p.$Jh(O,"extHost-socket");else{const W=P.$ee.wrap(Buffer.from(M.inflateBytes,"base64"));T=new p.$Kh(new p.$Jh(O,"extHost-socket"),M.permessageDeflate,W,!1)}D?(C.cancel(),N.cancel(),D.beginAcceptReconnection(T,z),D.endAcceptReconnection(),D.sendResume()):(clearTimeout($),D=new R.$Ih({socket:T,initialChunk:z}),D.sendResume(),D.onDidDispose(()=>a("renderer disconnected")),h(D),D.onSocketClose(()=>{C.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(N.isScheduled())return;C.isScheduled()&&N.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const h=l.pipeName;return new Promise((k,D)=>{const $=I.createConnection(h,()=>{$.removeListener("error",D);const b=new R.$Ih({socket:new p.$Jh($,"extHost-renderer")});b.sendResume(),k(b)});$.once("error",D),$.on("close",()=>{a("renderer closed the socket")})})}}async function r(){const l=await t();return new class{constructor(){this.a=new R.$Hh,this.onMessage=this.a.event,this.b=!1,l.onMessage(h=>{(0,g.$hm)(h,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||l.send(h)}async drain(){if(l.drain)return l.drain()}}}function d(l){return new Promise(h=>{const k=l.onMessage(D=>{k.dispose();const $=JSON.parse(D.toString()),b=$.commit,v=E.default.commit;if(b&&v&&b!==v&&n(55),$.parentPid){let C=0;setInterval(function(){try{process.kill($.parentPid,0),C=0}catch(j){j&&j.code==="EPERM"?(C++,C>=3&&a(`parent process ${$.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):a(`parent process ${$.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let N;try{N=globalThis._VSCODE_NODE_MODULES["native-watchdog"],N.start($.parentPid)}catch(j){(0,L.$Z)(j)}}l.send((0,g.$gm)(0)),h({protocol:l,initData:$})});l.send((0,g.$gm)(1))})}async function u(){const l=[];process.on("unhandledRejection",(C,N)=>{l.push(N),setTimeout(()=>{const j=l.indexOf(N);j>=0&&N.catch(M=>{l.splice(j,1),(0,L.$3)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),C&&(0,L.$Z)(C))})},1e3)}),process.on("rejectionHandled",C=>{const N=l.indexOf(C);N>=0&&l.splice(N,1)}),process.on("uncaughtException",function(C){(0,L.$Y)(C)||(0,L.$Z)(C)}),m.mark("code/extHost/willConnectToRenderer");const h=await r();m.mark("code/extHost/didConnectToRenderer");const k=await d(h);m.mark("code/extHost/didWaitForInitData");const{initData:D}=k;o(!!D.environment.extensionTestsLocationURI),D.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,D.environment.skipWorkspaceStorageLock=(0,w.boolean)(i.skipWorkspaceStorageLock,!1);const $=new class{constructor(){this.pid=process.pid}exit(N){n(N)}fsExists(N){return f.Promises.exists(N)}fsRealpath(N){return(0,y.$_p)(N)}};let b=null;D.remote.authority&&i.transformURIs&&(b=(0,c.$Gr)(D.remote.authority));const v=new A.$Kfc(k.protocol,D,$,b);a=C=>v.terminate(C)}u().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/60c8cddf1ae631ce52714d885adba2cdc889415b/core/vs/workbench/api/node/extensionHostProcess.js.map
