/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/async","vs/base/common/strings","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/stopwatch","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ve){for(var e=[],E=0,L=ve.length;E<L;E++)e[E]=Pe[ve[E]];return e};define(Pe[67],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=void 0;function E(R){return($,D,g)=>{let A=null,S=null;if(typeof g.value=="function"?(A="value",S=g.value):typeof g.get=="function"&&(A="get",S=g.get),!S)throw new Error("not supported");g[A]=R(S,D)}}function L(R,$,D){let g=null,A=null;if(typeof D.value=="function"?(g="value",A=D.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(g="get",A=D.get),!A)throw new Error("not supported");const S=`$memoize$${$}`;D[g]=function(...a){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,a)}),this[S]}}e.$mh=L;function P(R,$,D){return E((g,A)=>{const S=`$debounce$${A}`,a=`$debounce$result$${A}`;return function(...v){this[a]||(this[a]=D?D():void 0),clearTimeout(this[S]),$&&(this[a]=$(this[a],...v),v=[this[a]]),this[S]=setTimeout(()=>{g.apply(this,v),this[a]=D?D():void 0},R)}})}e.$nh=P;function M(R,$,D){return E((g,A)=>{const S=`$throttle$timer$${A}`,a=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,p=`$throttle$pending$${A}`;return function(...f){if(this[a]||(this[a]=D?D():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),$&&(this[a]=$(this[a],...f)),this[p])return;const t=this[v]+R;t<=Date.now()?(this[v]=Date.now(),g.apply(this,[this[a]]),this[a]=D?D():void 0):(this[p]=!0,this[S]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),g.apply(this,[this[a]]),this[a]=D?D():void 0},t-Date.now()))}})}e.$oh=M}),define(Pe[89],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=void 0;class E{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$GM=E,e.$HM=new E("id#")}),define(Pe[119],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var L;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var P;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(r){r.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(r,s=!1){let c=0;const h=r.length;let b="",m=0,I=16,k=0;function d(z){let F=0,N=0;for(;F<z;){const x=r.charCodeAt(c);if(x>=48&&x<=57)N=N*16+x-48;else if(x>=65&&x<=70)N=N*16+x-65+10;else if(x>=97&&x<=102)N=N*16+x-97+10;else break;c++,F++}return F<z&&(N=-1),N}function w(z){c=z,b="",m=0,I=16,k=0}function y(){const z=c;if(r.charCodeAt(c)===48)c++;else for(c++;c<r.length&&g(r.charCodeAt(c));)c++;if(c<r.length&&r.charCodeAt(c)===46)if(c++,c<r.length&&g(r.charCodeAt(c)))for(c++;c<r.length&&g(r.charCodeAt(c));)c++;else return k=3,r.substring(z,c);let F=c;if(c<r.length&&(r.charCodeAt(c)===69||r.charCodeAt(c)===101))if(c++,(c<r.length&&r.charCodeAt(c)===43||r.charCodeAt(c)===45)&&c++,c<r.length&&g(r.charCodeAt(c))){for(c++;c<r.length&&g(r.charCodeAt(c));)c++;F=c}else k=3;return r.substring(z,F)}function C(){let z="",F=c;for(;;){if(c>=h){z+=r.substring(F,c),k=2;break}const N=r.charCodeAt(c);if(N===34){z+=r.substring(F,c),c++;break}if(N===92){if(z+=r.substring(F,c),c++,c>=h){k=2;break}switch(r.charCodeAt(c++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const J=d(4);J>=0?z+=String.fromCharCode(J):k=4;break}default:k=5}F=c;continue}if(N>=0&&N<=31)if(D(N)){z+=r.substring(F,c),k=2;break}else k=6;c++}return z}function W(){if(b="",k=0,m=c,c>=h)return m=h,I=17;let z=r.charCodeAt(c);if($(z)){do c++,b+=String.fromCharCode(z),z=r.charCodeAt(c);while($(z));return I=15}if(D(z))return c++,b+=String.fromCharCode(z),z===13&&r.charCodeAt(c)===10&&(c++,b+=`
`),I=14;switch(z){case 123:return c++,I=1;case 125:return c++,I=2;case 91:return c++,I=3;case 93:return c++,I=4;case 58:return c++,I=6;case 44:return c++,I=5;case 34:return c++,b=C(),I=10;case 47:{const F=c-1;if(r.charCodeAt(c+1)===47){for(c+=2;c<h&&!D(r.charCodeAt(c));)c++;return b=r.substring(F,c),I=12}if(r.charCodeAt(c+1)===42){c+=2;const N=h-1;let x=!1;for(;c<N;){if(r.charCodeAt(c)===42&&r.charCodeAt(c+1)===47){c+=2,x=!0;break}c++}return x||(c++,k=1),b=r.substring(F,c),I=13}return b+=String.fromCharCode(z),c++,I=16}case 45:if(b+=String.fromCharCode(z),c++,c===h||!g(r.charCodeAt(c)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=y(),I=11;default:for(;c<h&&H(z);)c++,z=r.charCodeAt(c);if(m!==c){switch(b=r.substring(m,c),b){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return b+=String.fromCharCode(z),c++,I=16}}function H(z){if($(z)||D(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let z;do z=W();while(z>=12&&z<=15);return z}return{setPosition:w,getPosition:()=>c,scan:s?U:W,getToken:()=>I,getTokenValue:()=>b,getTokenOffset:()=>m,getTokenLength:()=>c-m,getTokenError:()=>k}}e.$Zm=R;function $(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function D(r){return r===10||r===13||r===8232||r===8233}function g(r){return r>=48&&r<=57}var A;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(A||(A={}));function S(r,s){const c=[],h=new Object;let b;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function k(d,w,y,C){m.value=d,m.offset=w,m.length=y,m.type=C,m.colonOffset=void 0,b=m}try{u(r,{onObjectBegin:(d,w)=>{if(s<=d)throw h;b=void 0,I=s>d,c.push("")},onObjectProperty:(d,w,y)=>{if(s<w||(k(d,w,y,"property"),c[c.length-1]=d,s<=w+y))throw h},onObjectEnd:(d,w)=>{if(s<=d)throw h;b=void 0,c.pop()},onArrayBegin:(d,w)=>{if(s<=d)throw h;b=void 0,c.push(0)},onArrayEnd:(d,w)=>{if(s<=d)throw h;b=void 0,c.pop()},onLiteralValue:(d,w,y)=>{if(s<w||(k(d,w,y,l(d)),s<=w+y))throw h},onSeparator:(d,w,y)=>{if(s<=w)throw h;if(d===":"&&b&&b.type==="property")b.colonOffset=w,I=!1,b=void 0;else if(d===","){const C=c[c.length-1];typeof C=="number"?c[c.length-1]=C+1:(I=!0,c[c.length-1]=""),b=void 0}}})}catch(d){if(d!==h)throw d}return{path:c,previousNode:b,isAtPropertyKey:I,matches:d=>{let w=0;for(let y=0;w<d.length&&y<c.length;y++)if(d[w]===c[y]||d[w]==="*")w++;else if(d[w]!=="**")return!1;return w===d.length}}}e.$1m=S;function a(r,s=[],c=M.DEFAULT){let h=null,b=[];const m=[];function I(d){Array.isArray(b)?b.push(d):h!==null&&(b[h]=d)}return u(r,{onObjectBegin:()=>{const d={};I(d),m.push(b),b=d,h=null},onObjectProperty:d=>{h=d},onObjectEnd:()=>{b=m.pop()},onArrayBegin:()=>{const d=[];I(d),m.push(b),b=d,h=null},onArrayEnd:()=>{b=m.pop()},onLiteralValue:I,onError:(d,w,y)=>{s.push({error:d,offset:w,length:y})}},c),b[0]}e.$2m=a;function v(r,s=[],c=M.DEFAULT){let h={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(d){h.type==="property"&&(h.length=d-h.offset,h=h.parent)}function m(d){return h.children.push(d),d}u(r,{onObjectBegin:d=>{h=m({type:"object",offset:d,length:-1,parent:h,children:[]})},onObjectProperty:(d,w,y)=>{h=m({type:"property",offset:w,length:-1,parent:h,children:[]}),h.children.push({type:"string",value:d,offset:w,length:y,parent:h})},onObjectEnd:(d,w)=>{h.length=d+w-h.offset,h=h.parent,b(d+w)},onArrayBegin:(d,w)=>{h=m({type:"array",offset:d,length:-1,parent:h,children:[]})},onArrayEnd:(d,w)=>{h.length=d+w-h.offset,h=h.parent,b(d+w)},onLiteralValue:(d,w,y)=>{m({type:l(d),offset:w,length:y,parent:h,value:d}),b(w+y)},onSeparator:(d,w,y)=>{h.type==="property"&&(d===":"?h.colonOffset=w:d===","&&b(w))},onError:(d,w,y)=>{s.push({error:d,offset:w,length:y})}},c);const k=h.children[0];return k&&delete k.parent,k}e.$3m=v;function p(r,s){if(!r)return;let c=r;for(const h of s)if(typeof h=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let b=!1;for(const m of c.children)if(Array.isArray(m.children)&&m.children[0].value===h){c=m.children[1],b=!0;break}if(!b)return}else{const b=h;if(c.type!=="array"||b<0||!Array.isArray(c.children)||b>=c.children.length)return;c=c.children[b]}return c}e.$4m=p;function f(r){if(!r.parent||!r.parent.children)return[];const s=f(r.parent);if(r.parent.type==="property"){const c=r.parent.children[0].value;s.push(c)}else if(r.parent.type==="array"){const c=r.parent.children.indexOf(r);c!==-1&&s.push(c)}return s}e.$5m=f;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const c of r.children){const h=c.children[1];h&&(s[c.children[0].value]=t(h))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$6m=t;function i(r,s,c=!1){return s>=r.offset&&s<r.offset+r.length||c&&s===r.offset+r.length}e.$7m=i;function n(r,s,c=!1){if(i(r,s,c)){const h=r.children;if(Array.isArray(h))for(let b=0;b<h.length&&h[b].offset<=s;b++){const m=n(h[b],s,c);if(m)return m}return r}}e.$8m=n;function u(r,s,c=M.DEFAULT){const h=R(r,!1);function b(se){return se?()=>se(h.getTokenOffset(),h.getTokenLength()):()=>!0}function m(se){return se?Re=>se(Re,h.getTokenOffset(),h.getTokenLength()):()=>!0}const I=b(s.onObjectBegin),k=m(s.onObjectProperty),d=b(s.onObjectEnd),w=b(s.onArrayBegin),y=b(s.onArrayEnd),C=m(s.onLiteralValue),W=m(s.onSeparator),H=b(s.onComment),U=m(s.onError),z=c&&c.disallowComments,F=c&&c.allowTrailingComma;function N(){for(;;){const se=h.scan();switch(h.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(se){case 12:case 13:z?x(10):H();break;case 16:x(1);break;case 15:case 14:break;default:return se}}}function x(se,Re=[],oe=[]){if(U(se),Re.length+oe.length>0){let X=h.getToken();for(;X!==17;){if(Re.indexOf(X)!==-1){N();break}else if(oe.indexOf(X)!==-1)break;X=N()}}}function J(se){const Re=h.getTokenValue();return se?C(Re):k(Re),N(),!0}function Ee(){switch(h.getToken()){case 11:{let se=0;try{se=JSON.parse(h.getTokenValue()),typeof se!="number"&&(x(2),se=0)}catch{x(2)}C(se);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return N(),!0}function De(){return h.getToken()!==10?(x(3,[],[2,5]),!1):(J(!1),h.getToken()===6?(W(":"),N(),be()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function Ce(){I(),N();let se=!1;for(;h.getToken()!==2&&h.getToken()!==17;){if(h.getToken()===5){if(se||x(4,[],[]),W(","),N(),h.getToken()===2&&F)break}else se&&x(6,[],[]);De()||x(4,[],[2,5]),se=!0}return d(),h.getToken()!==2?x(7,[2],[]):N(),!0}function fe(){w(),N();let se=!1;for(;h.getToken()!==4&&h.getToken()!==17;){if(h.getToken()===5){if(se||x(4,[],[]),W(","),N(),h.getToken()===4&&F)break}else se&&x(6,[],[]);be()||x(4,[],[4,5]),se=!0}return y(),h.getToken()!==4?x(8,[4],[]):N(),!0}function be(){switch(h.getToken()){case 3:return fe();case 1:return Ce();case 10:return J(!0);default:return Ee()}}return N(),h.getToken()===17?c.allowEmptyContent?!0:(x(4,[],[]),!1):be()?(h.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$9m=u;function o(r,s){const c=R(r),h=[];let b,m=0,I;do switch(I=c.getPosition(),b=c.scan(),b){case 12:case 13:case 17:m!==I&&h.push(r.substring(m,I)),s!==void 0&&h.push(c.getTokenValue().replace(/[^\r\n]/g,s)),m=c.getPosition();break}while(b!==17);return h.join("")}e.$0m=o;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$$m=l}),function(ve,e){typeof define=="function"&&define.amd?define(Pe[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ve=typeof globalThis<"u"?globalThis:ve||self,e(ve.marked={}))}(this,function(ve){"use strict";function e(he,ue){for(var we=0;we<ue.length;we++){var ee=ue[we];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(he,ee.key,ee)}}function E(he,ue,we){return ue&&e(he.prototype,ue),we&&e(he,we),Object.defineProperty(he,"prototype",{writable:!1}),he}function L(he,ue){if(he){if(typeof he=="string")return P(he,ue);var we=Object.prototype.toString.call(he).slice(8,-1);if(we==="Object"&&he.constructor&&(we=he.constructor.name),we==="Map"||we==="Set")return Array.from(he);if(we==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(we))return P(he,ue)}}function P(he,ue){(ue==null||ue>he.length)&&(ue=he.length);for(var we=0,ee=new Array(ue);we<ue;we++)ee[we]=he[we];return ee}function M(he,ue){var we=typeof Symbol<"u"&&he[Symbol.iterator]||he["@@iterator"];if(we)return(we=we.call(he)).next.bind(we);if(Array.isArray(he)||(we=L(he))||ue&&he&&typeof he.length=="number"){we&&(he=we);var ee=0;return function(){return ee>=he.length?{done:!0}:{done:!1,value:he[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ve.defaults=R();function $(he){ve.defaults=he}var D=/[&<>"']/,g=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(ue){return a[ue]};function p(he,ue){if(ue){if(D.test(he))return he.replace(g,v)}else if(A.test(he))return he.replace(S,v);return he}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(he){return he.replace(f,function(ue,we){return we=we.toLowerCase(),we==="colon"?":":we.charAt(0)==="#"?we.charAt(1)==="x"?String.fromCharCode(parseInt(we.substring(2),16)):String.fromCharCode(+we.substring(1)):""})}var i=/(^|[^\[])\^/g;function n(he,ue){he=typeof he=="string"?he:he.source,ue=ue||"";var we={replace:function(de,ie){return ie=ie.source||ie,ie=ie.replace(i,"$1"),he=he.replace(de,ie),we},getRegex:function(){return new RegExp(he,ue)}};return we}var u=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(he,ue,we){if(he){var ee;try{ee=decodeURIComponent(t(we)).replace(u,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ue&&!o.test(we)&&(we=b(ue,we));try{we=encodeURI(we).replace(/%25/g,"%")}catch{return null}return we}var r={},s=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,h=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(he,ue){r[" "+he]||(s.test(he)?r[" "+he]=he+"/":r[" "+he]=d(he,"/",!0)),he=r[" "+he];var we=he.indexOf(":")===-1;return ue.substring(0,2)==="//"?we?ue:he.replace(c,"$1")+ue:ue.charAt(0)==="/"?we?ue:he.replace(h,"$1")+ue:he+ue}var m={exec:function(){}};function I(he){for(var ue=1,we,ee;ue<arguments.length;ue++){we=arguments[ue];for(ee in we)Object.prototype.hasOwnProperty.call(we,ee)&&(he[ee]=we[ee])}return he}function k(he,ue){var we=he.replace(/\|/g,function(ie,ce,me){for(var Ie=!1,T=ce;--T>=0&&me[T]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ee=we.split(/ \|/),de=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ue)ee.splice(ue);else for(;ee.length<ue;)ee.push("");for(;de<ee.length;de++)ee[de]=ee[de].trim().replace(/\\\|/g,"|");return ee}function d(he,ue,we){var ee=he.length;if(ee===0)return"";for(var de=0;de<ee;){var ie=he.charAt(ee-de-1);if(ie===ue&&!we)de++;else if(ie!==ue&&we)de++;else break}return he.slice(0,ee-de)}function w(he,ue){if(he.indexOf(ue[1])===-1)return-1;for(var we=he.length,ee=0,de=0;de<we;de++)if(he[de]==="\\")de++;else if(he[de]===ue[0])ee++;else if(he[de]===ue[1]&&(ee--,ee<0))return de;return-1}function y(he){he&&he.sanitize&&!he.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(he,ue){if(ue<1)return"";for(var we="";ue>1;)ue&1&&(we+=he),ue>>=1,he+=he;return we+he}function W(he,ue,we,ee){var de=ue.href,ie=ue.title?p(ue.title):null,ce=he[1].replace(/\\([\[\]])/g,"$1");if(he[0].charAt(0)!=="!"){ee.state.inLink=!0;var me={type:"link",raw:we,href:de,title:ie,text:ce,tokens:ee.inlineTokens(ce)};return ee.state.inLink=!1,me}return{type:"image",raw:we,href:de,title:ie,text:p(ce)}}function H(he,ue){var we=he.match(/^(\s+)(?:```)/);if(we===null)return ue;var ee=we[1];return ue.split(`
`).map(function(de){var ie=de.match(/^\s+/);if(ie===null)return de;var ce=ie[0];return ce.length>=ee.length?de.slice(ee.length):de}).join(`
`)}var U=function(){function he(we){this.options=we||ve.defaults}var ue=he.prototype;return ue.space=function(ee){var de=this.rules.block.newline.exec(ee);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ue.code=function(ee){var de=this.rules.block.code.exec(ee);if(de){var ie=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:d(ie,`
`)}}},ue.fences=function(ee){var de=this.rules.block.fences.exec(ee);if(de){var ie=de[0],ce=H(ie,de[3]||"");return{type:"code",raw:ie,lang:de[2]?de[2].trim():de[2],text:ce}}},ue.heading=function(ee){var de=this.rules.block.heading.exec(ee);if(de){var ie=de[2].trim();if(/#$/.test(ie)){var ce=d(ie,"#");(this.options.pedantic||!ce||/ $/.test(ce))&&(ie=ce.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:ie,tokens:this.lexer.inline(ie)}}},ue.hr=function(ee){var de=this.rules.block.hr.exec(ee);if(de)return{type:"hr",raw:de[0]}},ue.blockquote=function(ee){var de=this.rules.block.blockquote.exec(ee);if(de){var ie=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},ue.list=function(ee){var de=this.rules.block.list.exec(ee);if(de){var ie,ce,me,Ie,T,V,G,Q,q,_,le,Oe,Be=de[1].trim(),Je=Be.length>1,Ge={type:"list",raw:"",ordered:Je,start:Je?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Je?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Je?Be:"[*+-]");for(var _e=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(Oe=!1,!(!(de=_e.exec(ee))||this.rules.block.hr.test(ee)));){if(ie=de[0],ee=ee.substring(ie.length),Q=de[2].split(`
`,1)[0],q=ee.split(`
`,1)[0],this.options.pedantic?(Ie=2,le=Q.trimLeft()):(Ie=de[2].search(/[^ ]/),Ie=Ie>4?1:Ie,le=Q.slice(Ie),Ie+=de[1].length),V=!1,!Q&&/^ *$/.test(q)&&(ie+=q+`
`,ee=ee.substring(q.length+1),Oe=!0),!Oe)for(var Ye=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");ee&&(_=ee.split(`
`,1)[0],Q=_,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Ye.test(Q)||xe.test(ee)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())le+=`
`+Q.slice(Ie);else if(!V)le+=`
`+Q;else break;!V&&!Q.trim()&&(V=!0),ie+=_+`
`,ee=ee.substring(_.length+1)}Ge.loose||(G?Ge.loose=!0:/\n *\n *$/.test(ie)&&(G=!0)),this.options.gfm&&(ce=/^\[[ xX]\] /.exec(le),ce&&(me=ce[0]!=="[ ] ",le=le.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:ie,task:!!ce,checked:me,loose:!1,text:le}),Ge.raw+=ie}Ge.items[Ge.items.length-1].raw=ie.trimRight(),Ge.items[Ge.items.length-1].text=le.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(T=0;T<ze;T++){this.lexer.state.top=!1,Ge.items[T].tokens=this.lexer.blockTokens(Ge.items[T].text,[]);var ut=Ge.items[T].tokens.filter(function(Z){return Z.type==="space"}),Y=ut.every(function(Z){for(var ye=Z.raw.split(""),je=0,Ne=M(ye),Ze;!(Ze=Ne()).done;){var nt=Ze.value;if(nt===`
`&&(je+=1),je>1)return!0}return!1});!Ge.loose&&ut.length&&Y&&(Ge.loose=!0,Ge.items[T].loose=!0)}return Ge}},ue.html=function(ee){var de=this.rules.block.html.exec(ee);if(de){var ie={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ce=this.options.sanitizer?this.options.sanitizer(de[0]):p(de[0]);ie.type="paragraph",ie.text=ce,ie.tokens=this.lexer.inline(ce)}return ie}},ue.def=function(ee){var de=this.rules.block.def.exec(ee);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ie=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:de[0],href:de[2],title:de[3]}}},ue.table=function(ee){var de=this.rules.block.table.exec(ee);if(de){var ie={type:"table",header:k(de[1]).map(function(G){return{text:G}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=de[0];var ce=ie.align.length,me,Ie,T,V;for(me=0;me<ce;me++)/^ *-+: *$/.test(ie.align[me])?ie.align[me]="right":/^ *:-+: *$/.test(ie.align[me])?ie.align[me]="center":/^ *:-+ *$/.test(ie.align[me])?ie.align[me]="left":ie.align[me]=null;for(ce=ie.rows.length,me=0;me<ce;me++)ie.rows[me]=k(ie.rows[me],ie.header.length).map(function(G){return{text:G}});for(ce=ie.header.length,Ie=0;Ie<ce;Ie++)ie.header[Ie].tokens=this.lexer.inline(ie.header[Ie].text);for(ce=ie.rows.length,Ie=0;Ie<ce;Ie++)for(V=ie.rows[Ie],T=0;T<V.length;T++)V[T].tokens=this.lexer.inline(V[T].text);return ie}}},ue.lheading=function(ee){var de=this.rules.block.lheading.exec(ee);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ue.paragraph=function(ee){var de=this.rules.block.paragraph.exec(ee);if(de){var ie=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:ie,tokens:this.lexer.inline(ie)}}},ue.text=function(ee){var de=this.rules.block.text.exec(ee);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ue.escape=function(ee){var de=this.rules.inline.escape.exec(ee);if(de)return{type:"escape",raw:de[0],text:p(de[1])}},ue.tag=function(ee){var de=this.rules.inline.tag.exec(ee);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):p(de[0]):de[0]}},ue.link=function(ee){var de=this.rules.inline.link.exec(ee);if(de){var ie=de[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ce=d(ie.slice(0,-1),"\\");if((ie.length-ce.length)%2===0)return}else{var me=w(de[2],"()");if(me>-1){var Ie=de[0].indexOf("!")===0?5:4,T=Ie+de[1].length+me;de[2]=de[2].substring(0,me),de[0]=de[0].substring(0,T).trim(),de[3]=""}}var V=de[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);Q&&(V=Q[1],G=Q[3])}else G=de[3]?de[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(ie)?V=V.slice(1):V=V.slice(1,-1)),W(de,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ue.reflink=function(ee,de){var ie;if((ie=this.rules.inline.reflink.exec(ee))||(ie=this.rules.inline.nolink.exec(ee))){var ce=(ie[2]||ie[1]).replace(/\s+/g," ");if(ce=de[ce.toLowerCase()],!ce||!ce.href){var me=ie[0].charAt(0);return{type:"text",raw:me,text:me}}return W(ie,ce,ie[0],this.lexer)}},ue.emStrong=function(ee,de,ie){ie===void 0&&(ie="");var ce=this.rules.inline.emStrong.lDelim.exec(ee);if(ce&&!(ce[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ce[1]||ce[2]||"";if(!me||me&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Ie=ce[0].length-1,T,V,G=Ie,Q=0,q=ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,de=de.slice(-1*ee.length+Ie);(ce=q.exec(de))!=null;)if(T=ce[1]||ce[2]||ce[3]||ce[4]||ce[5]||ce[6],!!T){if(V=T.length,ce[3]||ce[4]){G+=V;continue}else if((ce[5]||ce[6])&&Ie%3&&!((Ie+V)%3)){Q+=V;continue}if(G-=V,!(G>0)){if(V=Math.min(V,V+G+Q),Math.min(Ie,V)%2){var _=ee.slice(1,Ie+ce.index+V);return{type:"em",raw:ee.slice(0,Ie+ce.index+V+1),text:_,tokens:this.lexer.inlineTokens(_)}}var le=ee.slice(2,Ie+ce.index+V-1);return{type:"strong",raw:ee.slice(0,Ie+ce.index+V+1),text:le,tokens:this.lexer.inlineTokens(le)}}}}}},ue.codespan=function(ee){var de=this.rules.inline.code.exec(ee);if(de){var ie=de[2].replace(/\n/g," "),ce=/[^ ]/.test(ie),me=/^ /.test(ie)&&/ $/.test(ie);return ce&&me&&(ie=ie.substring(1,ie.length-1)),ie=p(ie,!0),{type:"codespan",raw:de[0],text:ie}}},ue.br=function(ee){var de=this.rules.inline.br.exec(ee);if(de)return{type:"br",raw:de[0]}},ue.del=function(ee){var de=this.rules.inline.del.exec(ee);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ue.autolink=function(ee,de){var ie=this.rules.inline.autolink.exec(ee);if(ie){var ce,me;return ie[2]==="@"?(ce=p(this.options.mangle?de(ie[1]):ie[1]),me="mailto:"+ce):(ce=p(ie[1]),me=ce),{type:"link",raw:ie[0],text:ce,href:me,tokens:[{type:"text",raw:ce,text:ce}]}}},ue.url=function(ee,de){var ie;if(ie=this.rules.inline.url.exec(ee)){var ce,me;if(ie[2]==="@")ce=p(this.options.mangle?de(ie[0]):ie[0]),me="mailto:"+ce;else{var Ie;do Ie=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Ie!==ie[0]);ce=p(ie[0]),ie[1]==="www."?me="http://"+ce:me=ce}return{type:"link",raw:ie[0],text:ce,href:me,tokens:[{type:"text",raw:ce,text:ce}]}}},ue.inlineText=function(ee,de){var ie=this.rules.inline.text.exec(ee);if(ie){var ce;return this.lexer.state.inRawBlock?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):p(ie[0]):ie[0]:ce=p(this.options.smartypants?de(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ce}}},he}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=I({},z),z.gfm=I({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=I({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=n(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=n(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=n(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=n(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=n(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=n(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=n(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=n(F.reflink).replace("label",F._label).replace("ref",z._label).getRegex(),F.nolink=n(F.nolink).replace("ref",z._label).getRegex(),F.reflinkSearch=n(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=I({},F),F.pedantic=I({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=I({},F.normal,{escape:n(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=n(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=I({},F.gfm,{br:n(F.br).replace("{2,}","*").getRegex(),text:n(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(he){return he.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(he){var ue="",we,ee,de=he.length;for(we=0;we<de;we++)ee=he.charCodeAt(we),Math.random()>.5&&(ee="x"+ee.toString(16)),ue+="&#"+ee+";";return ue}var J=function(){function he(we){this.tokens=[],this.tokens.links=Object.create(null),this.options=we||ve.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:z.normal,inline:F.normal};this.options.pedantic?(ee.block=z.pedantic,ee.inline=F.pedantic):this.options.gfm&&(ee.block=z.gfm,this.options.breaks?ee.inline=F.breaks:ee.inline=F.gfm),this.tokenizer.rules=ee}he.lex=function(ee,de){var ie=new he(de);return ie.lex(ee)},he.lexInline=function(ee,de){var ie=new he(de);return ie.inlineTokens(ee)};var ue=he.prototype;return ue.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ue.blockTokens=function(ee,de){var ie=this;de===void 0&&(de=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(G,Q,q){return Q+"    ".repeat(q.length)});for(var ce,me,Ie,T;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(ce=G.call({lexer:ie},ee,de))?(ee=ee.substring(ce.raw.length),de.push(ce),!0):!1}))){if(ce=this.tokenizer.space(ee)){ee=ee.substring(ce.raw.length),ce.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ce);continue}if(ce=this.tokenizer.code(ee)){ee=ee.substring(ce.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ce.raw,me.text+=`
`+ce.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ce);continue}if(ce=this.tokenizer.fences(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.heading(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.hr(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.blockquote(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.list(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.html(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.def(ee)){ee=ee.substring(ce.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ce.raw,me.text+=`
`+ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ce.tag]||(this.tokens.links[ce.tag]={href:ce.href,title:ce.title});continue}if(ce=this.tokenizer.table(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.lheading(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(Ie=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=ee.slice(1),q=void 0;ie.options.extensions.startBlock.forEach(function(_){q=_.call({lexer:this},Q),typeof q=="number"&&q>=0&&(G=Math.min(G,q))}),G<1/0&&G>=0&&(Ie=ee.substring(0,G+1))}(),this.state.top&&(ce=this.tokenizer.paragraph(Ie))){me=de[de.length-1],T&&me.type==="paragraph"?(me.raw+=`
`+ce.raw,me.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ce),T=Ie.length!==ee.length,ee=ee.substring(ce.raw.length);continue}if(ce=this.tokenizer.text(ee)){ee=ee.substring(ce.raw.length),me=de[de.length-1],me&&me.type==="text"?(me.raw+=`
`+ce.raw,me.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ce);continue}if(ee){var V="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,de},ue.inline=function(ee,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:ee,tokens:de}),de},ue.inlineTokens=function(ee,de){var ie=this;de===void 0&&(de=[]);var ce,me,Ie,T=ee,V,G,Q;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(T))!=null;)q.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(T=T.slice(0,V.index)+"["+C("a",V[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(T))!=null;)T=T.slice(0,V.index)+"["+C("a",V[0].length-2)+"]"+T.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(T))!=null;)T=T.slice(0,V.index)+"++"+T.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(ce=le.call({lexer:ie},ee,de))?(ee=ee.substring(ce.raw.length),de.push(ce),!0):!1}))){if(ce=this.tokenizer.escape(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.tag(ee)){ee=ee.substring(ce.raw.length),me=de[de.length-1],me&&ce.type==="text"&&me.type==="text"?(me.raw+=ce.raw,me.text+=ce.text):de.push(ce);continue}if(ce=this.tokenizer.link(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(ce.raw.length),me=de[de.length-1],me&&ce.type==="text"&&me.type==="text"?(me.raw+=ce.raw,me.text+=ce.text):de.push(ce);continue}if(ce=this.tokenizer.emStrong(ee,T,Q)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.codespan(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.br(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.del(ee)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(ce=this.tokenizer.autolink(ee,x)){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(!this.state.inLink&&(ce=this.tokenizer.url(ee,x))){ee=ee.substring(ce.raw.length),de.push(ce);continue}if(Ie=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var le=1/0,Oe=ee.slice(1),Be=void 0;ie.options.extensions.startInline.forEach(function(Je){Be=Je.call({lexer:this},Oe),typeof Be=="number"&&Be>=0&&(le=Math.min(le,Be))}),le<1/0&&le>=0&&(Ie=ee.substring(0,le+1))}(),ce=this.tokenizer.inlineText(Ie,N)){ee=ee.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(Q=ce.raw.slice(-1)),G=!0,me=de[de.length-1],me&&me.type==="text"?(me.raw+=ce.raw,me.text+=ce.text):de.push(ce);continue}if(ee){var _="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(_);break}else throw new Error(_)}}return de},E(he,null,[{key:"rules",get:function(){return{block:z,inline:F}}}]),he}(),Ee=function(){function he(we){this.options=we||ve.defaults}var ue=he.prototype;return ue.code=function(ee,de,ie){var ce=(de||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(ee,ce);me!=null&&me!==ee&&(ie=!0,ee=me)}return ee=ee.replace(/\n$/,"")+`
`,ce?'<pre><code class="'+this.options.langPrefix+p(ce,!0)+'">'+(ie?ee:p(ee,!0))+`</code></pre>
`:"<pre><code>"+(ie?ee:p(ee,!0))+`</code></pre>
`},ue.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ue.html=function(ee){return ee},ue.heading=function(ee,de,ie,ce){if(this.options.headerIds){var me=this.options.headerPrefix+ce.slug(ie);return"<h"+de+' id="'+me+'">'+ee+"</h"+de+`>
`}return"<h"+de+">"+ee+"</h"+de+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(ee,de,ie){var ce=de?"ol":"ul",me=de&&ie!==1?' start="'+ie+'"':"";return"<"+ce+me+`>
`+ee+"</"+ce+`>
`},ue.listitem=function(ee){return"<li>"+ee+`</li>
`},ue.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(ee){return"<p>"+ee+`</p>
`},ue.table=function(ee,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+de+`</table>
`},ue.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ue.tablecell=function(ee,de){var ie=de.header?"th":"td",ce=de.align?"<"+ie+' align="'+de.align+'">':"<"+ie+">";return ce+ee+("</"+ie+`>
`)},ue.strong=function(ee){return"<strong>"+ee+"</strong>"},ue.em=function(ee){return"<em>"+ee+"</em>"},ue.codespan=function(ee){return"<code>"+ee+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(ee){return"<del>"+ee+"</del>"},ue.link=function(ee,de,ie){if(ee=l(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var ce='<a href="'+p(ee)+'"';return de&&(ce+=' title="'+de+'"'),ce+=">"+ie+"</a>",ce},ue.image=function(ee,de,ie){if(ee=l(this.options.sanitize,this.options.baseUrl,ee),ee===null)return ie;var ce='<img src="'+ee+'" alt="'+ie+'"';return de&&(ce+=' title="'+de+'"'),ce+=this.options.xhtml?"/>":">",ce},ue.text=function(ee){return ee},he}(),De=function(){function he(){}var ue=he.prototype;return ue.strong=function(ee){return ee},ue.em=function(ee){return ee},ue.codespan=function(ee){return ee},ue.del=function(ee){return ee},ue.html=function(ee){return ee},ue.text=function(ee){return ee},ue.link=function(ee,de,ie){return""+ie},ue.image=function(ee,de,ie){return""+ie},ue.br=function(){return""},he}(),Ce=function(){function he(){this.seen={}}var ue=he.prototype;return ue.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(ee,de){var ie=ee,ce=0;if(this.seen.hasOwnProperty(ie)){ce=this.seen[ee];do ce++,ie=ee+"-"+ce;while(this.seen.hasOwnProperty(ie))}return de||(this.seen[ee]=ce,this.seen[ie]=0),ie},ue.slug=function(ee,de){de===void 0&&(de={});var ie=this.serialize(ee);return this.getNextSafeSlug(ie,de.dryrun)},he}(),fe=function(){function he(we){this.options=we||ve.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new Ce}he.parse=function(ee,de){var ie=new he(de);return ie.parse(ee)},he.parseInline=function(ee,de){var ie=new he(de);return ie.parseInline(ee)};var ue=he.prototype;return ue.parse=function(ee,de){de===void 0&&(de=!0);var ie="",ce,me,Ie,T,V,G,Q,q,_,le,Oe,Be,Je,Ge,_e,Ye,xe,it,tt,ze=ee.length;for(ce=0;ce<ze;ce++){if(le=ee[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(tt=this.options.extensions.renderers[le.type].call({parser:this},le),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){ie+=tt||"";continue}switch(le.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(le.tokens),le.depth,t(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(q="",Q="",T=le.header.length,me=0;me<T;me++)Q+=this.renderer.tablecell(this.parseInline(le.header[me].tokens),{header:!0,align:le.align[me]});for(q+=this.renderer.tablerow(Q),_="",T=le.rows.length,me=0;me<T;me++){for(G=le.rows[me],Q="",V=G.length,Ie=0;Ie<V;Ie++)Q+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:le.align[Ie]});_+=this.renderer.tablerow(Q)}ie+=this.renderer.table(q,_);continue}case"blockquote":{_=this.parse(le.tokens),ie+=this.renderer.blockquote(_);continue}case"list":{for(Oe=le.ordered,Be=le.start,Je=le.loose,T=le.items.length,_="",me=0;me<T;me++)_e=le.items[me],Ye=_e.checked,xe=_e.task,Ge="",_e.task&&(it=this.renderer.checkbox(Ye),Je?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=it+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=it+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(_e.tokens,Je),_+=this.renderer.listitem(Ge,xe,Ye);ie+=this.renderer.list(_,Oe,Be);continue}case"html":{ie+=this.renderer.html(le.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(_=le.tokens?this.parseInline(le.tokens):le.text;ce+1<ze&&ee[ce+1].type==="text";)le=ee[++ce],_+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);ie+=de?this.renderer.paragraph(_):_;continue}default:{var ut='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(ut);return}else throw new Error(ut)}}}return ie},ue.parseInline=function(ee,de){de=de||this.renderer;var ie="",ce,me,Ie,T=ee.length;for(ce=0;ce<T;ce++){if(me=ee[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Ie=this.options.extensions.renderers[me.type].call({parser:this},me),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){ie+=Ie||"";continue}switch(me.type){case"escape":{ie+=de.text(me.text);break}case"html":{ie+=de.html(me.text);break}case"link":{ie+=de.link(me.href,me.title,this.parseInline(me.tokens,de));break}case"image":{ie+=de.image(me.href,me.title,me.text);break}case"strong":{ie+=de.strong(this.parseInline(me.tokens,de));break}case"em":{ie+=de.em(this.parseInline(me.tokens,de));break}case"codespan":{ie+=de.codespan(me.text);break}case"br":{ie+=de.br();break}case"del":{ie+=de.del(this.parseInline(me.tokens,de));break}case"text":{ie+=de.text(me.text);break}default:{var V='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return ie},he}();function be(he,ue,we){if(typeof he>"u"||he===null)throw new Error("marked(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");if(typeof ue=="function"&&(we=ue,ue=null),ue=I({},be.defaults,ue||{}),y(ue),we){var ee=ue.highlight,de;try{de=J.lex(he,ue)}catch(T){return we(T)}var ie=function(V){var G;if(!V)try{ue.walkTokens&&be.walkTokens(de,ue.walkTokens),G=fe.parse(de,ue)}catch(Q){V=Q}return ue.highlight=ee,V?we(V):we(null,G)};if(!ee||ee.length<3||(delete ue.highlight,!de.length))return ie();var ce=0;be.walkTokens(de,function(T){T.type==="code"&&(ce++,setTimeout(function(){ee(T.text,T.lang,function(V,G){if(V)return ie(V);G!=null&&G!==T.text&&(T.text=G,T.escaped=!0),ce--,ce===0&&ie()})},0))}),ce===0&&ie();return}function me(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+p(T.message+"",!0)+"</pre>";throw T}try{var Ie=J.lex(he,ue);if(ue.walkTokens){if(ue.async)return Promise.all(be.walkTokens(Ie,ue.walkTokens)).then(function(){return fe.parse(Ie,ue)}).catch(me);be.walkTokens(Ie,ue.walkTokens)}return fe.parse(Ie,ue)}catch(T){me(T)}}be.options=be.setOptions=function(he){return I(be.defaults,he),$(be.defaults),be},be.getDefaults=R,be.defaults=ve.defaults,be.use=function(){for(var he=arguments.length,ue=new Array(he),we=0;we<he;we++)ue[we]=arguments[we];var ee=I.apply(void 0,[{}].concat(ue)),de=be.defaults.extensions||{renderers:{},childTokens:{}},ie;ue.forEach(function(ce){if(ce.extensions&&(ie=!0,ce.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var T=de.renderers?de.renderers[Ie.name]:null;T?de.renderers[Ie.name]=function(){for(var V=arguments.length,G=new Array(V),Q=0;Q<V;Q++)G[Q]=arguments[Q];var q=Ie.renderer.apply(this,G);return q===!1&&(q=T.apply(this,G)),q}:de.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Ie.level]?de[Ie.level].unshift(Ie.tokenizer):de[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?de.startBlock?de.startBlock.push(Ie.start):de.startBlock=[Ie.start]:Ie.level==="inline"&&(de.startInline?de.startInline.push(Ie.start):de.startInline=[Ie.start]))}Ie.childTokens&&(de.childTokens[Ie.name]=Ie.childTokens)})),ce.renderer&&function(){var Ie=be.defaults.renderer||new Ee,T=function(Q){var q=Ie[Q];Ie[Q]=function(){for(var _=arguments.length,le=new Array(_),Oe=0;Oe<_;Oe++)le[Oe]=arguments[Oe];var Be=ce.renderer[Q].apply(Ie,le);return Be===!1&&(Be=q.apply(Ie,le)),Be}};for(var V in ce.renderer)T(V);ee.renderer=Ie}(),ce.tokenizer&&function(){var Ie=be.defaults.tokenizer||new U,T=function(Q){var q=Ie[Q];Ie[Q]=function(){for(var _=arguments.length,le=new Array(_),Oe=0;Oe<_;Oe++)le[Oe]=arguments[Oe];var Be=ce.tokenizer[Q].apply(Ie,le);return Be===!1&&(Be=q.apply(Ie,le)),Be}};for(var V in ce.tokenizer)T(V);ee.tokenizer=Ie}(),ce.walkTokens){var me=be.defaults.walkTokens;ee.walkTokens=function(Ie){var T=[];return T.push(ce.walkTokens.call(this,Ie)),me&&(T=T.concat(me.call(this,Ie))),T}}ie&&(ee.extensions=de),be.setOptions(ee)})},be.walkTokens=function(he,ue){for(var we=[],ee=function(){var me=ie.value;switch(we=we.concat(ue.call(be,me)),me.type){case"table":{for(var Ie=M(me.header),T;!(T=Ie()).done;){var V=T.value;we=we.concat(be.walkTokens(V.tokens,ue))}for(var G=M(me.rows),Q;!(Q=G()).done;)for(var q=Q.value,_=M(q),le;!(le=_()).done;){var Oe=le.value;we=we.concat(be.walkTokens(Oe.tokens,ue))}break}case"list":{we=we.concat(be.walkTokens(me.items,ue));break}default:be.defaults.extensions&&be.defaults.extensions.childTokens&&be.defaults.extensions.childTokens[me.type]?be.defaults.extensions.childTokens[me.type].forEach(function(Be){we=we.concat(be.walkTokens(me[Be],ue))}):me.tokens&&(we=we.concat(be.walkTokens(me.tokens,ue)))}},de=M(he),ie;!(ie=de()).done;)ee();return we},be.parseInline=function(he,ue){if(typeof he>"u"||he===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");ue=I({},be.defaults,ue||{}),y(ue);try{var we=J.lexInline(he,ue);return ue.walkTokens&&be.walkTokens(we,ue.walkTokens),fe.parseInline(we,ue)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+p(ee.message+"",!0)+"</pre>";throw ee}},be.Parser=fe,be.parser=fe.parse,be.Renderer=Ee,be.TextRenderer=De,be.Lexer=J,be.lexer=J.lex,be.Tokenizer=U,be.Slugger=Ce,be.parse=be;var se=be.options,Re=be.setOptions,oe=be.use,X=be.walkTokens,j=be.parseInline,ne=be,pe=fe.parse,re=J.lex;ve.Lexer=J,ve.Parser=fe,ve.Renderer=Ee,ve.Slugger=Ce,ve.TextRenderer=De,ve.Tokenizer=U,ve.getDefaults=R,ve.lexer=re,ve.marked=be,ve.options=se,ve.parse=ne,ve.parseInline=j,ve.parser=pe,ve.setOptions=Re,ve.use=oe,ve.walkTokens=X,Object.defineProperty(ve,"__esModule",{value:!0})}),define(Pe[121],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=e.rot=e.$Tl=void 0;function E($,D,g){return Math.min(Math.max($,D),g)}e.$Tl=E;function L($,D){return(D+$%D)%D}e.rot=L;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Vl=P;class M{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Wl=M;class R{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const g=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Xl=R}),function(){function ve(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function R(D){M.push(D,Date.now())}function $(){const D=[];for(let g=0;g<M.length;g+=2)D.push({name:M[g],startTime:M[g+1]});return D}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ve():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(P+R.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ve(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ve()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=E(L))}(),function(ve,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var L in E)(typeof exports=="object"?exports:ve)[L]=E[L]}}(typeof self<"u"?self:this,function(){return function(ve){var e={};function E(L){if(e[L])return e[L].exports;var P=e[L]={i:L,l:!1,exports:{}};return ve[L].call(P.exports,P,P.exports,E),P.l=!0,P.exports}return E.m=ve,E.c=e,E.d=function(L,P,M){E.o(L,P)||Object.defineProperty(L,P,{enumerable:!0,get:M})},E.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},E.t=function(L,P){if(1&P&&(L=E(L)),8&P||4&P&&typeof L=="object"&&L&&L.__esModule)return L;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:L}),2&P&&typeof L!="string")for(var R in L)E.d(M,R,function($){return L[$]}.bind(null,R));return M},E.n=function(L){var P=L&&L.__esModule?function(){return L.default}:function(){return L};return E.d(P,"a",P),P},E.o=function(L,P){return Object.prototype.hasOwnProperty.call(L,P)},E.p="",E(E.s=0)}([function(ve,e,E){(function(L){var P;e=ve.exports=oe,P=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],D=e.src=[],g=0,A=g++;D[A]="0|[1-9]\\d*";var S=g++;D[S]="[0-9]+";var a=g++;D[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=g++;D[v]="("+D[A]+")\\.("+D[A]+")\\.("+D[A]+")";var p=g++;D[p]="("+D[S]+")\\.("+D[S]+")\\.("+D[S]+")";var f=g++;D[f]="(?:"+D[A]+"|"+D[a]+")";var t=g++;D[t]="(?:"+D[S]+"|"+D[a]+")";var i=g++;D[i]="(?:-("+D[f]+"(?:\\."+D[f]+")*))";var n=g++;D[n]="(?:-?("+D[t]+"(?:\\."+D[t]+")*))";var u=g++;D[u]="[0-9A-Za-z-]+";var o=g++;D[o]="(?:\\+("+D[u]+"(?:\\."+D[u]+")*))";var l=g++,r="v?"+D[v]+D[i]+"?"+D[o]+"?";D[l]="^"+r+"$";var s="[v=\\s]*"+D[p]+D[n]+"?"+D[o]+"?",c=g++;D[c]="^"+s+"$";var h=g++;D[h]="((?:<|>)?=?)";var b=g++;D[b]=D[S]+"|x|X|\\*";var m=g++;D[m]=D[A]+"|x|X|\\*";var I=g++;D[I]="[v=\\s]*("+D[m]+")(?:\\.("+D[m]+")(?:\\.("+D[m]+")(?:"+D[i]+")?"+D[o]+"?)?)?";var k=g++;D[k]="[v=\\s]*("+D[b]+")(?:\\.("+D[b]+")(?:\\.("+D[b]+")(?:"+D[n]+")?"+D[o]+"?)?)?";var d=g++;D[d]="^"+D[h]+"\\s*"+D[I]+"$";var w=g++;D[w]="^"+D[h]+"\\s*"+D[k]+"$";var y=g++;D[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=g++;D[C]="(?:~>?)";var W=g++;D[W]="(\\s*)"+D[C]+"\\s+",$[W]=new RegExp(D[W],"g");var H=g++;D[H]="^"+D[C]+D[I]+"$";var U=g++;D[U]="^"+D[C]+D[k]+"$";var z=g++;D[z]="(?:\\^)";var F=g++;D[F]="(\\s*)"+D[z]+"\\s+",$[F]=new RegExp(D[F],"g");var N=g++;D[N]="^"+D[z]+D[I]+"$";var x=g++;D[x]="^"+D[z]+D[k]+"$";var J=g++;D[J]="^"+D[h]+"\\s*("+s+")$|^$";var Ee=g++;D[Ee]="^"+D[h]+"\\s*("+r+")$|^$";var De=g++;D[De]="(\\s*)"+D[h]+"\\s*("+s+"|"+D[I]+")",$[De]=new RegExp(D[De],"g");var Ce=g++;D[Ce]="^\\s*("+D[I]+")\\s+-\\s+("+D[I]+")\\s*$";var fe=g++;D[fe]="^\\s*("+D[k]+")\\s+-\\s+("+D[k]+")\\s*$";var be=g++;D[be]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)P(se,D[se]),$[se]||($[se]=new RegExp(D[se]));function Re(q,_){if(q instanceof oe)return q;if(typeof q!="string"||q.length>M||!(_?$[c]:$[l]).test(q))return null;try{return new oe(q,_)}catch{return null}}function oe(q,_){if(q instanceof oe){if(q.loose===_)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof oe))return new oe(q,_);P("SemVer",q,_),this.loose=_;var le=q.trim().match(_?$[c]:$[l]);if(!le)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Be=+Oe;if(Be>=0&&Be<R)return Be}return Oe}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=Re,e.valid=function(q,_){var le=Re(q,_);return le?le.version:null},e.clean=function(q,_){var le=Re(q.trim().replace(/^[=v]+/,""),_);return le?le.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(q){return P("SemVer.compare",this.version,this.loose,q),q instanceof oe||(q=new oe(q,this.loose)),this.compareMain(q)||this.comparePre(q)},oe.prototype.compareMain=function(q){return q instanceof oe||(q=new oe(q,this.loose)),j(this.major,q.major)||j(this.minor,q.minor)||j(this.patch,q.patch)},oe.prototype.comparePre=function(q){if(q instanceof oe||(q=new oe(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var _=0;do{var le=this.prerelease[_],Oe=q.prerelease[_];if(P("prerelease compare",_,le,Oe),le===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(le===void 0)return-1;if(le!==Oe)return j(le,Oe)}while(++_)},oe.prototype.inc=function(q,_){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,_,le,Oe){typeof le=="string"&&(Oe=le,le=void 0);try{return new oe(q,le).inc(_,Oe).version}catch{return null}},e.diff=function(q,_){if(he(q,_))return null;var le=Re(q),Oe=Re(_);if(le.prerelease.length||Oe.prerelease.length){for(var Be in le)if((Be==="major"||Be==="minor"||Be==="patch")&&le[Be]!==Oe[Be])return"pre"+Be;return"prerelease"}for(var Be in le)if((Be==="major"||Be==="minor"||Be==="patch")&&le[Be]!==Oe[Be])return Be},e.compareIdentifiers=j;var X=/^[0-9]+$/;function j(q,_){var le=X.test(q),Oe=X.test(_);return le&&Oe&&(q=+q,_=+_),le&&!Oe?-1:Oe&&!le?1:q<_?-1:q>_?1:0}function ne(q,_,le){return new oe(q,le).compare(new oe(_,le))}function pe(q,_,le){return ne(q,_,le)>0}function re(q,_,le){return ne(q,_,le)<0}function he(q,_,le){return ne(q,_,le)===0}function ue(q,_,le){return ne(q,_,le)!==0}function we(q,_,le){return ne(q,_,le)>=0}function ee(q,_,le){return ne(q,_,le)<=0}function de(q,_,le,Oe){var Be;switch(_){case"===":typeof q=="object"&&(q=q.version),typeof le=="object"&&(le=le.version),Be=q===le;break;case"!==":typeof q=="object"&&(q=q.version),typeof le=="object"&&(le=le.version),Be=q!==le;break;case"":case"=":case"==":Be=he(q,le,Oe);break;case"!=":Be=ue(q,le,Oe);break;case">":Be=pe(q,le,Oe);break;case">=":Be=we(q,le,Oe);break;case"<":Be=re(q,le,Oe);break;case"<=":Be=ee(q,le,Oe);break;default:throw new TypeError("Invalid operator: "+_)}return Be}function ie(q,_){if(q instanceof ie){if(q.loose===_)return q;q=q.value}if(!(this instanceof ie))return new ie(q,_);P("comparator",q,_),this.loose=_,this.parse(q),this.semver===ce?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(q,_){return j(_,q)},e.major=function(q,_){return new oe(q,_).major},e.minor=function(q,_){return new oe(q,_).minor},e.patch=function(q,_){return new oe(q,_).patch},e.compare=ne,e.compareLoose=function(q,_){return ne(q,_,!0)},e.rcompare=function(q,_,le){return ne(_,q,le)},e.sort=function(q,_){return q.sort(function(le,Oe){return e.compare(le,Oe,_)})},e.rsort=function(q,_){return q.sort(function(le,Oe){return e.rcompare(le,Oe,_)})},e.gt=pe,e.lt=re,e.eq=he,e.neq=ue,e.gte=we,e.lte=ee,e.cmp=de,e.Comparator=ie;var ce={};function me(q,_){if(q instanceof me)return q.loose===_?q:new me(q.raw,_);if(q instanceof ie)return new me(q.value,_);if(!(this instanceof me))return new me(q,_);if(this.loose=_,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function T(q,_,le,Oe,Be,Je,Ge,_e,Ye,xe,it,tt,ze){return((_=Ie(le)?"":Ie(Oe)?">="+le+".0.0":Ie(Be)?">="+le+"."+Oe+".0":">="+_)+" "+(_e=Ie(Ye)?"":Ie(xe)?"<"+(+Ye+1)+".0.0":Ie(it)?"<"+Ye+"."+(+xe+1)+".0":tt?"<="+Ye+"."+xe+"."+it+"-"+tt:"<="+_e)).trim()}function V(q,_){for(var le=0;le<q.length;le++)if(!q[le].test(_))return!1;if(_.prerelease.length){for(le=0;le<q.length;le++)if(P(q[le].semver),q[le].semver!==ce&&q[le].semver.prerelease.length>0){var Oe=q[le].semver;if(Oe.major===_.major&&Oe.minor===_.minor&&Oe.patch===_.patch)return!0}return!1}return!0}function G(q,_,le){try{_=new me(_,le)}catch{return!1}return _.test(q)}function Q(q,_,le,Oe){var Be,Je,Ge,_e,Ye;switch(q=new oe(q,Oe),_=new me(_,Oe),le){case">":Be=pe,Je=ee,Ge=re,_e=">",Ye=">=";break;case"<":Be=re,Je=we,Ge=pe,_e="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(q,_,Oe))return!1;for(var xe=0;xe<_.set.length;++xe){var it=_.set[xe],tt=null,ze=null;if(it.forEach(function(ut){ut.semver===ce&&(ut=new ie(">=0.0.0")),tt=tt||ut,ze=ze||ut,Be(ut.semver,tt.semver,Oe)?tt=ut:Ge(ut.semver,ze.semver,Oe)&&(ze=ut)}),tt.operator===_e||tt.operator===Ye||(!ze.operator||ze.operator===_e)&&Je(q,ze.semver)||ze.operator===Ye&&Ge(q,ze.semver))return!1}return!0}ie.prototype.parse=function(q){var _=this.loose?$[J]:$[Ee],le=q.match(_);if(!le)throw new TypeError("Invalid comparator: "+q);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new oe(le[2],this.loose):this.semver=ce},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(q){return P("Comparator.test",q,this.loose),this.semver===ce||(typeof q=="string"&&(q=new oe(q,this.loose)),de(q,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(q,_){if(!(q instanceof ie))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new me(q.value,_),G(this.value,le,_);if(q.operator==="")return le=new me(this.value,_),G(q.semver,le,_);var Oe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Je=this.semver.version===q.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),_e=de(this.semver,"<",q.semver,_)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ye=de(this.semver,">",q.semver,_)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Oe||Be||Je&&Ge||_e||Ye},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(q){var _=this.loose;q=q.trim(),P("range",q,_);var le=_?$[fe]:$[Ce];q=q.replace(le,T),P("hyphen replace",q),q=q.replace($[De],"$1$2$3"),P("comparator trim",q,$[De]),q=(q=(q=q.replace($[W],"$1~")).replace($[F],"$1^")).split(/\s+/).join(" ");var Oe=_?$[J]:$[Ee],Be=q.split(" ").map(function(Je){return function(Ge,_e){return P("comp",Ge),Ge=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){P("caret",tt,ze);var ut=ze?$[x]:$[N];return tt.replace(ut,function(Y,Z,ye,je,Ne){var Ze;return P("caret",tt,Y,Z,ye,je,Ne),Ie(Z)?Ze="":Ie(ye)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(je)?Ze=Z==="0"?">="+Z+"."+ye+".0 <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+".0 <"+(+Z+1)+".0.0":Ne?(P("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ze=Z==="0"?ye==="0"?">="+Z+"."+ye+"."+je+Ne+" <"+Z+"."+ye+"."+(+je+1):">="+Z+"."+ye+"."+je+Ne+" <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+"."+je+Ne+" <"+(+Z+1)+".0.0"):(P("no pr"),Ze=Z==="0"?ye==="0"?">="+Z+"."+ye+"."+je+" <"+Z+"."+ye+"."+(+je+1):">="+Z+"."+ye+"."+je+" <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+"."+je+" <"+(+Z+1)+".0.0"),P("caret return",Ze),Ze})}(it,xe)}).join(" ")}(Ge,_e),P("caret",Ge),Ge=function(Ye,xe){return Ye.trim().split(/\s+/).map(function(it){return function(tt,ze){var ut=ze?$[U]:$[H];return tt.replace(ut,function(Y,Z,ye,je,Ne){var Ze;return P("tilde",tt,Y,Z,ye,je,Ne),Ie(Z)?Ze="":Ie(ye)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(je)?Ze=">="+Z+"."+ye+".0 <"+Z+"."+(+ye+1)+".0":Ne?(P("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Ze=">="+Z+"."+ye+"."+je+Ne+" <"+Z+"."+(+ye+1)+".0"):Ze=">="+Z+"."+ye+"."+je+" <"+Z+"."+(+ye+1)+".0",P("tilde return",Ze),Ze})}(it,xe)}).join(" ")}(Ge,_e),P("tildes",Ge),Ge=function(Ye,xe){return P("replaceXRanges",Ye,xe),Ye.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var ut=ze?$[w]:$[d];return tt.replace(ut,function(Y,Z,ye,je,Ne,Ze){P("xRange",tt,Y,Z,ye,je,Ne,Ze);var nt=Ie(ye),$t=nt||Ie(je),bt=$t||Ie(Ne);return Z==="="&&bt&&(Z=""),nt?Y=Z===">"||Z==="<"?"<0.0.0":"*":Z&&bt?($t&&(je=0),bt&&(Ne=0),Z===">"?(Z=">=",$t?(ye=+ye+1,je=0,Ne=0):bt&&(je=+je+1,Ne=0)):Z==="<="&&(Z="<",$t?ye=+ye+1:je=+je+1),Y=Z+ye+"."+je+"."+Ne):$t?Y=">="+ye+".0.0 <"+(+ye+1)+".0.0":bt&&(Y=">="+ye+"."+je+".0 <"+ye+"."+(+je+1)+".0"),P("xRange return",Y),Y})}(it,xe)}).join(" ")}(Ge,_e),P("xrange",Ge),Ge=function(Ye,xe){return P("replaceStars",Ye,xe),Ye.trim().replace($[be],"")}(Ge,_e),P("stars",Ge),Ge}(Je,_)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Je){return!!Je.match(Oe)})),Be=Be.map(function(Je){return new ie(Je,_)})},me.prototype.intersects=function(q,_){if(!(q instanceof me))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(Oe){return q.set.some(function(Be){return Be.every(function(Je){return Oe.intersects(Je,_)})})})})},e.toComparators=function(q,_){return new me(q,_).set.map(function(le){return le.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new oe(q,this.loose));for(var _=0;_<this.set.length;_++)if(V(this.set[_],q))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(q,_,le){var Oe=null,Be=null;try{var Je=new me(_,le)}catch{return null}return q.forEach(function(Ge){Je.test(Ge)&&(Oe&&Be.compare(Ge)!==-1||(Be=new oe(Oe=Ge,le)))}),Oe},e.minSatisfying=function(q,_,le){var Oe=null,Be=null;try{var Je=new me(_,le)}catch{return null}return q.forEach(function(Ge){Je.test(Ge)&&(Oe&&Be.compare(Ge)!==1||(Be=new oe(Oe=Ge,le)))}),Oe},e.validRange=function(q,_){try{return new me(q,_).range||"*"}catch{return null}},e.ltr=function(q,_,le){return Q(q,_,"<",le)},e.gtr=function(q,_,le){return Q(q,_,">",le)},e.outside=Q,e.prerelease=function(q,_){var le=Re(q,_);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(q,_,le){return q=new me(q,le),_=new me(_,le),q.intersects(_)},e.coerce=function(q){if(q instanceof oe)return q;if(typeof q!="string")return null;var _=q.match($[y]);return _==null?null:Re((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,E(1))},function(ve,e){var E,L,P=ve.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(t){if(E===setTimeout)return setTimeout(t,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(t,0);try{return E(t,0)}catch{try{return E.call(null,t,0)}catch{return E.call(this,t,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var D,g=[],A=!1,S=-1;function a(){A&&D&&(A=!1,D.length?g=D.concat(g):S=-1,g.length&&v())}function v(){if(!A){var t=$(a);A=!0;for(var i=g.length;i;){for(D=g,g=[];++S<i;)D&&D[S].run();S=-1,i=g.length}D=null,A=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function f(){}P.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)i[n-1]=arguments[n];g.push(new p(t,i)),g.length!==1||A||$(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=f,P.addListener=f,P.once=f,P.off=f,P.removeListener=f,P.removeAllListeners=f,P.emit=f,P.prependListener=f,P.prependOnceListener=f,P.listeners=function(t){return[]},P.binding=function(t){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(t){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Pe[122],Ae([1,0,11,6]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=void 0;function P(o){const l=o;return l?typeof l.read=="function":!1}e.$2d=P;function M(o){const l=o;return l?[l.on,l.pause,l.resume,l.destroy].every(r=>typeof r=="function"):!1}e.$3d=M;function R(o){const l=o;return l?M(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$4d=R;function $(o,l){return new D(o,l)}e.$5d=$;class D{constructor(l,r){this.e=l,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(r=>r(l))}h(l){this.c.error.length===0?(0,E.$Z)(l):this.c.error.slice(0).forEach(r=>r(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,r){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(l,r){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const c=s.indexOf(r);c>=0&&s.splice(c,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(o,l){const r=[];let s;for(;(s=o.read())!==null;)r.push(s);return l(r)}e.$6d=g;function A(o,l,r){const s=[];let c;for(;(c=o.read())!==null&&s.length<r;)s.push(c);return c===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof c<"u"){const h=c;return c=void 0,h}return o.read()}}}e.$7d=A;function S(o,l){return new Promise((r,s)=>{const c=[];a(o,{onData:h=>{l&&c.push(h)},onError:h=>{l?s(h):r(void 0)},onEnd:()=>{r(l?l(c):void 0)}})})}e.$8d=S;function a(o,l,r){o.on("error",s=>{r?.isCancellationRequested||l.onError(s)}),o.on("end",()=>{r?.isCancellationRequested||l.onEnd()}),o.on("data",s=>{r?.isCancellationRequested||l.onData(s)})}e.$9d=a;function v(o,l){return new Promise((r,s)=>{const c=new L.$Qc,h=[],b=k=>{if(h.push(k),h.length>l)return c.dispose(),o.pause(),r({stream:o,buffer:h,ended:!1})},m=k=>(c.dispose(),s(k)),I=()=>(c.dispose(),r({stream:o,buffer:h,ended:!0}));c.add((0,L.$Pc)(()=>o.removeListener("error",m))),o.on("error",m),c.add((0,L.$Pc)(()=>o.removeListener("end",I))),o.on("end",I),c.add((0,L.$Pc)(()=>o.removeListener("data",b))),o.on("data",b)})}e.$0d=v;function p(o,l){const r=$(l);return r.end(o),r}e.$$d=p;function f(){const o=$(()=>{throw new Error("not supported")});return o.end(),o}e.$_d=f;function t(o){let l=!1;return{read:()=>l?null:(l=!0,o)}}e.$ae=t;function i(o,l,r){const s=$(r);return a(o,{onData:c=>s.write(l.data(c)),onError:c=>s.error(l.error?l.error(c):c),onEnd:()=>s.end()}),s}e.$be=i;function n(o,l,r){let s=!1;return{read:()=>{const c=l.read();return s?c:(s=!0,c!==null?r([o,c]):o)}}}e.$ce=n;function u(o,l,r){let s=!1;const c=$(r);return a(l,{onData:h=>s?c.write(h):(s=!0,c.write(r([o,h]))),onError:h=>c.error(h),onEnd:()=>{s||(s=!0,c.write(o)),c.end()}}),c}e.$de=u}),define(Pe[24],Ae([1,0,44,122]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;const P=typeof Buffer<"u",M=new E.$U(()=>new Uint8Array(256));let R,$;class D{static alloc(y){return P?new D(Buffer.allocUnsafe(y)):new D(new Uint8Array(y))}static wrap(y){return P&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new D(y)}static fromString(y,C){return!(C?.dontUseNodeBuffer||!1)&&P?new D(Buffer.from(y)):(R||(R=new TextEncoder),new D(R.encode(y)))}static fromByteArray(y){const C=D.alloc(y.length);for(let W=0,H=y.length;W<H;W++)C.buffer[W]=y[W];return C}static concat(y,C){if(typeof C>"u"){C=0;for(let U=0,z=y.length;U<z;U++)C+=y[U].byteLength}const W=D.alloc(C);let H=0;for(let U=0,z=y.length;U<z;U++){const F=y[U];W.set(F,H),H+=F.byteLength}return W}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=D.alloc(this.byteLength);return y.set(this),y}toString(){return P?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(y,C){return new D(this.buffer.subarray(y,C))}set(y,C){if(y instanceof D)this.buffer.set(y.buffer,C);else if(y instanceof Uint8Array)this.buffer.set(y,C);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),C);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return a(this.buffer,y)}writeUInt32BE(y,C){v(this.buffer,y,C)}readUInt32LE(y){return p(this.buffer,y)}writeUInt32LE(y,C){f(this.buffer,y,C)}readUInt8(y){return t(this.buffer,y)}writeUInt8(y,C){i(this.buffer,y,C)}indexOf(y,C=0){return g(this.buffer,y instanceof D?y.buffer:y,C)}}e.$ee=D;function g(w,y,C=0){const W=y.byteLength,H=w.byteLength;if(W===0)return 0;if(W===1)return w.indexOf(y[0]);if(W>H-C)return-1;const U=M.value;U.fill(y.length);for(let x=0;x<y.length;x++)U[y[x]]=y.length-x-1;let z=C+y.length-1,F=z,N=-1;for(;z<H;)if(w[z]===y[F]){if(F===0){N=z;break}z--,F--}else z+=Math.max(y.length-F,U[w[z]]),F=y.length-1;return N}e.$fe=g;function A(w,y){return w[y+0]<<0>>>0|w[y+1]<<8>>>0}e.$ge=A;function S(w,y,C){w[C+0]=y&255,y=y>>>8,w[C+1]=y&255}e.$he=S;function a(w,y){return w[y]*2**24+w[y+1]*2**16+w[y+2]*2**8+w[y+3]}e.$ie=a;function v(w,y,C){w[C+3]=y,y=y>>>8,w[C+2]=y,y=y>>>8,w[C+1]=y,y=y>>>8,w[C]=y}e.$je=v;function p(w,y){return w[y+0]<<0>>>0|w[y+1]<<8>>>0|w[y+2]<<16>>>0|w[y+3]<<24>>>0}e.$ke=p;function f(w,y,C){w[C+0]=y&255,y=y>>>8,w[C+1]=y&255,y=y>>>8,w[C+2]=y&255,y=y>>>8,w[C+3]=y&255}e.$le=f;function t(w,y){return w[y]}e.$me=t;function i(w,y,C){w[C]=y}e.$ne=i;function n(w){return L.$6d(w,y=>D.concat(y))}e.$oe=n;function u(w){return L.$ae(w)}e.$pe=u;function o(w){return L.$8d(w,y=>D.concat(y))}e.$qe=o;async function l(w){return w.ended?D.concat(w.buffer):D.concat([...w.buffer,await o(w.stream)])}e.$re=l;function r(w){return L.$$d(w,y=>D.concat(y))}e.$se=r;function s(w){return L.$be(w,{data:y=>typeof y=="string"?D.fromString(y):D.wrap(y)},y=>D.concat(y))}e.$te=s;function c(w){return L.$5d(y=>D.concat(y),w)}e.$ue=c;function h(w,y){return L.$ce(w,y,C=>D.concat(C))}e.$ve=h;function b(w,y){return L.$de(w,y,C=>D.concat(C))}e.$we=b;function m(w){let y=0,C=0,W=0;const H=new Uint8Array(Math.floor(w.length/4*3)),U=F=>{switch(C){case 3:H[W++]=y|F,C=0;break;case 2:H[W++]=y|F>>>2,y=F<<6,C=3;break;case 1:H[W++]=y|F>>>4,y=F<<4,C=2;break;default:y=F<<2,C=1}};for(let F=0;F<w.length;F++){const N=w.charCodeAt(F);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${w[F]}`)}}const z=W;for(;C>0;)U(0);return D.wrap(H).slice(0,z)}e.$xe=m;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:w},y=!0,C=!1){const W=C?k:I;let H="";const U=w.byteLength%3;let z=0;for(;z<w.byteLength-U;z+=3){const F=w[z+0],N=w[z+1],x=w[z+2];H+=W[F>>>2],H+=W[(F<<4|N>>>4)&63],H+=W[(N<<2|x>>>6)&63],H+=W[x&63]}if(U===1){const F=w[z+0];H+=W[F>>>2],H+=W[F<<4&63],y&&(H+="==")}else if(U===2){const F=w[z+0],N=w[z+1];H+=W[F>>>2],H+=W[(F<<4|N>>>4)&63],H+=W[N<<2&63],y&&(H+="=")}return H}e.$ye=d}),define(Pe[123],Ae([1,0,28,13]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.FuzzyScore=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.or=void 0;function P(...ie){return function(ce,me){for(let Ie=0,T=ie.length;Ie<T;Ie++){const V=ie[Ie](ce,me);if(V)return V}return null}}e.or=P,e.$Hj=M.bind(void 0,!1),e.$Ij=M.bind(void 0,!0);function M(ie,ce,me){if(!me||me.length<ce.length)return null;let Ie;return ie?Ie=L.$6e(me,ce):Ie=me.indexOf(ce)===0,Ie?ce.length>0?[{start:0,end:ce.length}]:[]:null}function R(ie,ce){const me=ce.toLowerCase().indexOf(ie.toLowerCase());return me===-1?null:[{start:me,end:me+ie.length}]}e.$Jj=R;function $(ie,ce){return D(ie.toLowerCase(),ce.toLowerCase(),0,0)}e.$Kj=$;function D(ie,ce,me,Ie){if(me===ie.length)return[];if(Ie===ce.length)return null;if(ie[me]===ce[Ie]){let T=null;return(T=D(ie,ce,me+1,Ie+1))?i({start:Ie,end:Ie+1},T):null}return D(ie,ce,me,Ie+1)}function g(ie){return 97<=ie&&ie<=122}function A(ie){return 65<=ie&&ie<=90}e.$Lj=A;function S(ie){return 48<=ie&&ie<=57}function a(ie){return ie===32||ie===9||ie===10||ie===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>v.add(ie.charCodeAt(0)));function p(ie){return a(ie)||v.has(ie)}function f(ie,ce){return ie===ce||p(ie)&&p(ce)}function t(ie){return g(ie)||A(ie)||S(ie)}function i(ie,ce){return ce.length===0?ce=[ie]:ie.end===ce[0].start?ce[0].start=ie.start:ce.unshift(ie),ce}function n(ie,ce){for(let me=ce;me<ie.length;me++){const Ie=ie.charCodeAt(me);if(A(Ie)||S(Ie)||me>0&&!t(ie.charCodeAt(me-1)))return me}return ie.length}function u(ie,ce,me,Ie){if(me===ie.length)return[];if(Ie===ce.length)return null;if(ie[me]!==ce[Ie].toLowerCase())return null;{let T=null,V=Ie+1;for(T=u(ie,ce,me+1,Ie+1);!T&&(V=n(ce,V))<ce.length;)T=u(ie,ce,me+1,V),V++;return T===null?null:i({start:Ie,end:Ie+1},T)}}function o(ie){let ce=0,me=0,Ie=0,T=0,V=0;for(let le=0;le<ie.length;le++)V=ie.charCodeAt(le),A(V)&&ce++,g(V)&&me++,t(V)&&Ie++,S(V)&&T++;const G=ce/ie.length,Q=me/ie.length,q=Ie/ie.length,_=T/ie.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:q,numericPercent:_}}function l(ie){const{upperPercent:ce,lowerPercent:me}=ie;return me===0&&ce>.6}function r(ie){const{upperPercent:ce,lowerPercent:me,alphaPercent:Ie,numericPercent:T}=ie;return me>.2&&ce<.8&&Ie>.6&&T<.2}function s(ie){let ce=0,me=0,Ie=0,T=0;for(let V=0;V<ie.length;V++)Ie=ie.charCodeAt(V),A(Ie)&&ce++,g(Ie)&&me++,a(Ie)&&T++;return(ce===0||me===0)&&T===0?ie.length<=30:ce<=5}function c(ie,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!s(ie)||ce.length>60)return null;const me=o(ce);if(!r(me)){if(!l(me))return null;ce=ce.toLowerCase()}let Ie=null,T=0;for(ie=ie.toLowerCase();T<ce.length&&(Ie=u(ie,ce,0,T))===null;)T=n(ce,T+1);return Ie}e.$Mj=c;function h(ie,ce,me=!1){if(!ce||ce.length===0)return null;let Ie=null,T=0;for(ie=ie.toLowerCase(),ce=ce.toLowerCase();T<ce.length&&(Ie=b(ie,ce,0,T,me))===null;)T=m(ce,T+1);return Ie}e.$Nj=h;function b(ie,ce,me,Ie,T){if(me===ie.length)return[];if(Ie===ce.length)return null;if(f(ie.charCodeAt(me),ce.charCodeAt(Ie))){let V=null,G=Ie+1;if(V=b(ie,ce,me+1,Ie+1,T),!T)for(;!V&&(G=m(ce,G))<ce.length;)V=b(ie,ce,me+1,G,T),G++;return V?ie.charCodeAt(me)!==ce.charCodeAt(Ie)?V:i({start:Ie,end:Ie+1},V):null}else return null}function m(ie,ce){for(let me=ce;me<ie.length;me++)if(p(ie.charCodeAt(me))||me>0&&p(ie.charCodeAt(me-1)))return me;return ie.length}const I=P(e.$Ij,c,R),k=P(e.$Ij,c,$),d=new E.$Cc(1e4);function w(ie,ce,me=!1){if(typeof ie!="string"||typeof ce!="string")return null;let Ie=d.get(ie);Ie||(Ie=new RegExp(L.$Oe(ie),"i"),d.set(ie,Ie));const T=Ie.exec(ce);return T?[{start:T.index,end:T.index+T[0].length}]:me?k(ie,ce):I(ie,ce)}e.$Oj=w;function y(ie,ce){const me=pe(ie,ie.toLowerCase(),0,ce,ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return me?W(me):null}e.$Pj=y;function C(ie,ce,me,Ie,T,V){const G=Math.min(13,ie.length);for(;me<G;me++){const Q=pe(ie,ce,me,Ie,T,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,V]}e.$Qj=C;function W(ie){if(typeof ie>"u")return[];const ce=[],me=ie[1];for(let Ie=ie.length-1;Ie>1;Ie--){const T=ie[Ie]+me,V=ce[ce.length-1];V&&V.end===T?V.end=T+1:ce.push({start:T,end:T+1})}return ce}e.$Rj=W;const H=128;function U(){const ie=[],ce=[];for(let me=0;me<=H;me++)ce[me]=0;for(let me=0;me<=H;me++)ie.push(ce.slice(0));return ie}function z(ie){const ce=[];for(let me=0;me<=ie;me++)ce[me]=0;return ce}const F=z(2*H),N=z(2*H),x=U(),J=U(),Ee=U(),De=!1;function Ce(ie,ce,me,Ie,T){function V(Q,q,_=" "){for(;Q.length<q;)Q=_+Q;return Q}let G=` |   |${Ie.split("").map(Q=>V(Q,3)).join("|")}
`;for(let Q=0;Q<=me;Q++)Q===0?G+=" |":G+=`${ce[Q-1]}|`,G+=ie[Q].slice(0,T+1).map(q=>V(q.toString(),3)).join("|")+`
`;return G}function fe(ie,ce,me,Ie){ie=ie.substr(ce),me=me.substr(Ie),console.log(Ce(J,ie,ie.length,me,me.length)),console.log(Ce(Ee,ie,ie.length,me,me.length)),console.log(Ce(x,ie,ie.length,me,me.length))}function be(ie,ce){if(ce<0||ce>=ie.length)return!1;const me=ie.codePointAt(ce);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$lf(me)}}function se(ie,ce){if(ce<0||ce>=ie.length)return!1;switch(ie.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function Re(ie,ce,me){return ce[ie]!==me[ie]}function oe(ie,ce,me,Ie,T,V,G=!1){for(;ce<me&&T<V;)ie[ce]===Ie[T]&&(G&&(F[ce]=T),ce+=1),T+=1;return ce===me}e.$Sj=oe;var X;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(X||(X={}));var j;(function(ie){ie.Default=[-100,0];function ce(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}ie.isDefault=ce})(j||(e.FuzzyScore=j={}));class ne{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ce,me){this.firstMatchCanBeWeak=ce,this.boostFullMatch=me}}e.$Tj=ne;function pe(ie,ce,me,Ie,T,V,G=ne.default){const Q=ie.length>H?H:ie.length,q=Ie.length>H?H:Ie.length;if(me>=Q||V>=q||Q-me>q-V||!oe(ce,me,Q,T,V,q,!0))return;re(Q,q,me,V,ce,T);let _=1,le=1,Oe=me,Be=V;const Je=[!1];for(_=1,Oe=me;Oe<Q;_++,Oe++){const it=F[Oe],tt=N[Oe],ze=Oe+1<Q?N[Oe+1]:q;for(le=it-V+1,Be=it;Be<ze;le++,Be++){let ut=Number.MIN_SAFE_INTEGER,Y=!1;Be<=tt&&(ut=he(ie,ce,Oe,me,Ie,T,Be,q,V,x[_-1][le-1]===0,Je));let Z=0;ut!==Number.MAX_SAFE_INTEGER&&(Y=!0,Z=ut+J[_-1][le-1]);const ye=Be>it,je=ye?J[_][le-1]+(x[_][le-1]>0?-5:0):0,Ne=Be>it+1&&x[_][le-1]>0,Ze=Ne?J[_][le-2]+(x[_][le-2]>0?-5:0):0;if(Ne&&(!ye||Ze>=je)&&(!Y||Ze>=Z))J[_][le]=Ze,Ee[_][le]=3,x[_][le]=0;else if(ye&&(!Y||je>=Z))J[_][le]=je,Ee[_][le]=2,x[_][le]=0;else if(Y)J[_][le]=Z,Ee[_][le]=1,x[_][le]=x[_-1][le-1]+1;else throw new Error("not possible")}}if(De&&fe(ie,me,Ie,V),!Je[0]&&!G.firstMatchCanBeWeak)return;_--,le--;const Ge=[J[_][le],V];let _e=0,Ye=0;for(;_>=1;){let it=le;do{const tt=Ee[_][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);_e>1&&ce[me+_-1]===T[V+le-1]&&!Re(it+V-1,Ie,T)&&_e+1>x[_][it]&&(it=le),it===le?_e++:_e=1,Ye||(Ye=it),_--,le=it-1,Ge.push(le)}q===Q&&G.boostFullMatch&&(Ge[0]+=2);const xe=Ye-Q;return Ge[0]-=xe,Ge}e.$Uj=pe;function re(ie,ce,me,Ie,T,V){let G=ie-1,Q=ce-1;for(;G>=me&&Q>=Ie;)T[G]===V[Q]&&(N[G]=Q,G--),Q--}function he(ie,ce,me,Ie,T,V,G,Q,q,_,le){if(ce[me]!==V[G])return Number.MIN_SAFE_INTEGER;let Oe=1,Be=!1;return G===me-Ie?Oe=ie[me]===T[G]?7:5:Re(G,T,V)&&(G===0||!Re(G-1,T,V))?(Oe=ie[me]===T[G]?7:5,Be=!0):be(V,G)&&(G===0||!be(V,G-1))?Oe=5:(be(V,G-1)||se(V,G-1))&&(Oe=5,Be=!0),Oe>1&&me===Ie&&(le[0]=!0),Be||(Be=Re(G,T,V)||be(V,G-1)||se(V,G-1)),me===Ie?G>q&&(Oe-=Be?3:5):_?Oe+=Be?2:0:Oe+=Be?0:1,G+1===Q&&(Oe-=Be?3:5),Oe}function ue(ie,ce,me,Ie,T,V,G){return ee(ie,ce,me,Ie,T,V,!0,G)}e.$Vj=ue;function we(ie,ce,me,Ie,T,V,G){return ee(ie,ce,me,Ie,T,V,!1,G)}e.$Wj=we;function ee(ie,ce,me,Ie,T,V,G,Q){let q=pe(ie,ce,me,Ie,T,V,Q);if(q&&!G)return q;if(ie.length>=3){const _=Math.min(7,ie.length-1);for(let le=me+1;le<_;le++){const Oe=de(ie,le);if(Oe){const Be=pe(Oe,Oe.toLowerCase(),me,Ie,T,V,Q);Be&&(Be[0]-=3,(!q||Be[0]>q[0])&&(q=Be))}}}return q}function de(ie,ce){if(ce+1>=ie.length)return;const me=ie[ce],Ie=ie[ce+1];if(me!==Ie)return ie.slice(0,ce)+Ie+me+ie.slice(ce+2)}}),define(Pe[31],Ae([1,0,13]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(L||(L={})),function(P){const M="error",R="warning",$="warn",D="info",g="ignore";function A(a){return a?E.$5e(M,a)?P.Error:E.$5e(R,a)||E.$5e($,a)?P.Warning:E.$5e(D,a)?P.Info:P.Ignore:P.Ignore}P.fromValue=A;function S(a){switch(a){case P.Error:return M;case P.Warning:return R;case P.Info:return D;default:return g}}P.toString=S}(L||(L={})),e.default=L}),define(Pe[124],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Nd=Symbol("MicrotaskDelay")}),define(Pe[51],Ae([1,0,18,13]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0;class P{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const p=v.charCodeAt(0),f=this.b.charCodeAt(this.c);return p-f}value(){return this.b[this.c]}}e.$Wh=P;class M{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,L.$Ye)(v,this.b,0,v.length,this.c,this.d):(0,L.$1e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Xh=M;class R{constructor(v=!0,p=!0){this.f=v,this.g=p}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let p=v.length-1;p>=0;p--,this.c--){const f=this.b.charCodeAt(p);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,L.$Ye)(v,this.b,0,v.length,this.d,this.e):(0,L.$1e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Yh=R;var $;(function(a){a[a.Scheme=1]="Scheme",a[a.Authority=2]="Authority",a[a.Path=3]="Path",a[a.Query=4]="Query",a[a.Fragment=5]="Fragment"})($||($={}));class D{constructor(v,p){this.f=v,this.g=p,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,L.$Ze)(v,this.c.scheme);if(this.d[this.e]===2)return(0,L.$Ze)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,L.$Xe)(v,this.c.query);if(this.d[this.e]===5)return(0,L.$Xe)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Zh=D;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(a){a[a.Left=-1]="Left",a[a.Mid=0]="Mid",a[a.Right=1]="Right"})(A||(A={}));class S{static forUris(v=()=>!1,p=()=>!1){return new S(new D(v,p))}static forPaths(v=!1){return new S(new R(void 0,!v))}static forStrings(){return new S(new P)}static forConfigKeys(){return new S(new M)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,p){if(p){const f=p.slice(0);(0,E.$Wb)(f);for(const t of f)this.set(t,v)}else{const f=v.slice(0);(0,E.$Wb)(f);for(const t of f)this.set(t[0],t[1])}}set(v,p){const f=this.b.reset(v);let t;this.c||(this.c=new g,this.c.segment=f.value());const i=[];for(t=this.c;;){const u=f.cmp(t.segment);if(u>0)t.left||(t.left=new g,t.left.segment=f.value()),i.push([-1,t]),t=t.left;else if(u<0)t.right||(t.right=new g,t.right.segment=f.value()),i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new g,t.mid.segment=f.value()),i.push([0,t]),t=t.mid;else break}const n=t.value;t.value=p,t.key=v;for(let u=i.length-1;u>=0;u--){const o=i[u][1];o.updateHeight();const l=o.balanceFactor();if(l<-1||l>1){const r=i[u][0],s=i[u+1][0];if(r===1&&s===1)i[u][1]=o.rotateLeft();else if(r===-1&&s===-1)i[u][1]=o.rotateRight();else if(r===1&&s===-1)o.right=i[u+1][1]=i[u+1][1].rotateRight(),i[u][1]=o.rotateLeft();else if(r===-1&&s===1)o.left=i[u+1][1]=i[u+1][1].rotateLeft(),i[u][1]=o.rotateRight();else throw new Error;if(u>0)switch(i[u-1][0]){case-1:i[u-1][1].left=i[u][1];break;case 1:i[u-1][1].right=i[u][1];break;case 0:i[u-1][1].mid=i[u][1];break}else this.c=i[0][1]}}return n}get(v){return this.d(v)?.value}d(v){const p=this.b.reset(v);let f=this.c;for(;f;){const t=p.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(p.hasNext())p.next(),f=f.mid;else break}return f}has(v){const p=this.d(v);return!(p?.value===void 0&&p?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,p){const f=this.b.reset(v),t=[];let i=this.c;for(;i;){const n=f.cmp(i.segment);if(n>0)t.push([-1,i]),i=i.left;else if(n<0)t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const n=this.f(i.right);if(n.key){const{key:u,value:o,segment:l}=n;this.e(n.key,!1),i.key=u,i.value=o,i.segment=l}}else{const n=i.left??i.right;if(t.length>0){const[u,o]=t[t.length-1];switch(u){case-1:o.left=n;break;case 0:o.mid=n;break;case 1:o.right=n;break}}else this.c=n}for(let n=t.length-1;n>=0;n--){const u=t[n][1];u.updateHeight();const o=u.balanceFactor();if(o>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),t[n][1]=u.rotateLeft()):o<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),t[n][1]=u.rotateRight()),n>0)switch(t[n-1][0]){case-1:t[n-1][1].left=t[n][1];break;case 1:t[n-1][1].right=t[n][1];break;case 0:t[n-1][1].mid=t[n][1];break}else this.c=t[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const p=this.b.reset(v);let f=this.c,t;for(;f;){const i=p.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if(p.hasNext())p.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(v){return this.g(v,!1)}g(v,p){const f=this.b.reset(v);let t=this.c;for(;t;){const i=f.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[p,f]of this)v(f,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const p=[];return this.j(v,p),p[Symbol.iterator]()}j(v,p){v&&(v.left&&this.j(v.left,p),v.value&&p.push([v.key,v.value]),v.mid&&this.j(v.mid,p),v.right&&this.j(v.right,p))}_isBalanced(){const v=p=>{if(!p)return!0;const f=p.balanceFactor();return f<-1||f>1?!1:v(p.left)&&v(p.right)};return v(this.c)}}e.$1h=S}),define(Pe[45],Ae([1,0,90]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$1j=e.ThemeColor=void 0;var L;(function(R){function $(D){return D&&typeof D=="object"&&typeof D.id=="string"}R.isThemeColor=$})(L||(e.ThemeColor=L={}));function P(R){return{id:R}}e.$1j=P;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function D(n){const u=$.exec(n.id);if(!u)return D(E.$Zj.error);const[,o,l]=u,r=["codicon","codicon-"+o];return l&&r.push("codicon-modifier-"+l.substring(1)),r}R.asClassNameArray=D;function g(n){return D(n).join(" ")}R.asClassName=g;function A(n){return"."+D(n).join(".")}R.asCSSSelector=A;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}R.isThemeIcon=S;const a=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(n){const u=a.exec(n);if(!u)return;const[,o]=u;return{id:o}}R.fromString=v;function p(n){return{id:n}}R.fromId=p;function f(n,u){let o=n.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),u&&(o=`${o}~${u}`),{id:o}}R.modify=f;function t(n){const u=n.id.lastIndexOf("~");if(u!==-1)return n.id.substring(u+1)}R.getModifier=t;function i(n,u){return n.id===u.id&&n.color?.id===u.color?.id}R.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Pe[125],Ae([1,0,123,13,45]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=void 0;const M="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function D(i){return i.replace($,(n,u)=>u?n:`\\${n}`)}e.$2j=D;const g=new RegExp(`\\\\${R.source}`,"g");function A(i){return i.replace(g,n=>`\\${n}`)}e.$3j=A;const S=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function a(i){return i.indexOf(M)===-1?i:i.replace(S,(n,u,o,l)=>o?n:u||l||"")}e.$4j=a;function v(i){return i?i.replace(/\$\((.*?)\)/g,(n,u)=>` ${u} `).trim():""}e.$5j=v;const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(i){p.lastIndex=0;let n="";const u=[];let o=0;for(;;){const l=p.lastIndex,r=p.exec(i),s=i.substring(l,r?.index);if(s.length>0){n+=s;for(let c=0;c<s.length;c++)u.push(o)}if(!r)break;o+=r[0].length}return{text:n,iconOffsets:u}}e.$6j=f;function t(i,n,u=!1){const{text:o,iconOffsets:l}=n;if(!l||l.length===0)return(0,E.$Oj)(i,o,u);const r=(0,L.$Me)(o," "),s=o.length-r.length,c=(0,E.$Oj)(i,r,u);if(c)for(const h of c){const b=l[h.start+s]+s;h.start+=b,h.end+=b}return c}e.$7j=t}),define(Pe[38],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(P){return E.test(P)}e.$gg=L,e.$hg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function($){for(let D=0;D<$.length;D++)$[D]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let D=0,g="";return g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+="-",g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g+=R[M[D++]],g}}()}),define(Pe[126],Ae([1,0,18,68,38]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.$7s=e.$6s=e.$5s=void 0;function M(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$5s=M;function R(S,a,v){const p={id:(0,P.$hg)(),name:S,uri:a,data:v};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$6s=R;class ${constructor(){this.a=new Map}get size(){let a=0;for(const v of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const v=[...this.a.keys()];return L.Iterable.some(this,([p,f])=>f.asFile())&&v.push("files"),A(D(a),v)}get(a){return this.a.get(this.b(a))?.[0]}append(a,v){const p=this.a.get(a);p?p.push(v):this.a.set(this.b(a),[v])}replace(a,v){this.a.set(this.b(a),[v])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,v]of this.a)for(const p of v)yield[a,p]}b(a){return D(a)}}e.$7s=$;function D(S){return S.toLowerCase()}function g(S,a){return A(D(S),a.map(D))}e.$8s=g;function A(S,a){if(S==="*/*")return a.length>0;if(a.includes(S))return!0;const v=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[p,f,t]=v;return t==="*"?a.some(i=>i.startsWith(f+"/")):!1}e.$9s=Object.freeze({create:S=>(0,E.$Lb)(S.map(a=>a.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$9s.split(S).filter(a=>!a.startsWith("#"))})}),define(Pe[127],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var E;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function L(P){let M=0,R=0,$=0,D=0;for(let g=0,A=P.length;g<A;g++){const S=P.charCodeAt(g);S===13?(M===0&&(R=g),M++,g+1<A&&P.charCodeAt(g+1)===10?(D|=2,g++):D|=3,$=g+1):S===10&&(D|=1,M===0&&(R=g),M++,$=g+1)}return M===0&&(R=P.length),[M,R,P.length-$,D]}e.$_s=L}),define(Pe[128],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0,e.$9r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[129],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class L{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let D=0,g=$.notIn.length;D<g;D++)switch($.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,D){if($.getTokenCount()===0)return!0;const g=$.findTokenIndexAtOffset(D-2),A=$.getStandardTokenType(g);return this.isOK(A)}g($,D){for(let g=$;g<=D;g++){const A=String.fromCharCode(g);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$vt=L;class P{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of $)M(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),M(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),M(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),M(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&M(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.$wt=P;function M(R,$,D){R.has($)?R.get($).push(D):R.set($,[D])}}),define(Pe[130],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.$rB=e.NodeColor=e.$qB=void 0;class E{constructor(t,i){this.piece=t,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$rB)return P(this.right);let t=this;for(;t.parent!==e.$rB&&t.parent.left!==t;)t=t.parent;return t.parent===e.$rB?e.$rB:t.parent}prev(){if(this.left!==e.$rB)return M(this.left);let t=this;for(;t.parent!==e.$rB&&t.parent.right!==t;)t=t.parent;return t.parent===e.$rB?e.$rB:t.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$qB=E;var L;(function(f){f[f.Black=0]="Black",f[f.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$rB=new E(null,0),e.$rB.parent=e.$rB,e.$rB.left=e.$rB,e.$rB.right=e.$rB,e.$rB.color=0;function P(f){for(;f.left!==e.$rB;)f=f.left;return f}e.$sB=P;function M(f){for(;f.right!==e.$rB;)f=f.right;return f}e.$tB=M;function R(f){return f===e.$rB?0:f.size_left+f.piece.length+R(f.right)}function $(f){return f===e.$rB?0:f.lf_left+f.piece.lineFeedCnt+$(f.right)}function D(){e.$rB.parent=e.$rB}function g(f,t){const i=t.right;i.size_left+=t.size_left+(t.piece?t.piece.length:0),i.lf_left+=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),t.right=i.left,i.left!==e.$rB&&(i.left.parent=t),i.parent=t.parent,t.parent===e.$rB?f.root=i:t.parent.left===t?t.parent.left=i:t.parent.right=i,i.left=t,t.parent=i}e.$uB=g;function A(f,t){const i=t.left;t.left=i.right,i.right!==e.$rB&&(i.right.parent=t),i.parent=t.parent,t.size_left-=i.size_left+(i.piece?i.piece.length:0),t.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),t.parent===e.$rB?f.root=i:t===t.parent.right?t.parent.right=i:t.parent.left=i,i.right=t,t.parent=i}e.$vB=A;function S(f,t){let i,n;if(t.left===e.$rB?(n=t,i=n.right):t.right===e.$rB?(n=t,i=n.left):(n=P(t.right),i=n.right),n===f.root){f.root=i,i.color=0,t.detach(),D(),f.root.parent=e.$rB;return}const u=n.color===1;if(n===n.parent.left?n.parent.left=i:n.parent.right=i,n===t?(i.parent=n.parent,p(f,i)):(n.parent===t?i.parent=n:i.parent=n.parent,p(f,i),n.left=t.left,n.right=t.right,n.parent=t.parent,n.color=t.color,t===f.root?f.root=n:t===t.parent.left?t.parent.left=n:t.parent.right=n,n.left!==e.$rB&&(n.left.parent=n),n.right!==e.$rB&&(n.right.parent=n),n.size_left=t.size_left,n.lf_left=t.lf_left,p(f,n)),t.detach(),i.parent.left===i){const l=R(i),r=$(i);if(l!==i.parent.size_left||r!==i.parent.lf_left){const s=l-i.parent.size_left,c=r-i.parent.lf_left;i.parent.size_left=l,i.parent.lf_left=r,v(f,i.parent,s,c)}}if(p(f,i.parent),u){D();return}let o;for(;i!==f.root&&i.color===0;)i===i.parent.left?(o=i.parent.right,o.color===1&&(o.color=0,i.parent.color=1,g(f,i.parent),o=i.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.right.color===0&&(o.left.color=0,o.color=1,A(f,o),o=i.parent.right),o.color=i.parent.color,i.parent.color=0,o.right.color=0,g(f,i.parent),i=f.root)):(o=i.parent.left,o.color===1&&(o.color=0,i.parent.color=1,A(f,i.parent),o=i.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.left.color===0&&(o.right.color=0,o.color=1,g(f,o),o=i.parent.left),o.color=i.parent.color,i.parent.color=0,o.left.color=0,A(f,i.parent),i=f.root));i.color=0,D()}e.$wB=S;function a(f,t){for(p(f,t);t!==f.root&&t.parent.color===1;)if(t.parent===t.parent.parent.left){const i=t.parent.parent.right;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&(t=t.parent,g(f,t)),t.parent.color=0,t.parent.parent.color=1,A(f,t.parent.parent))}else{const i=t.parent.parent.left;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&(t=t.parent,A(f,t)),t.parent.color=0,t.parent.parent.color=1,g(f,t.parent.parent))}f.root.color=0}e.$xB=a;function v(f,t,i,n){for(;t!==f.root&&t!==e.$rB;)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=n),t=t.parent}e.$yB=v;function p(f,t){let i=0,n=0;if(t!==f.root){for(;t!==f.root&&t===t.parent.right;)t=t.parent;if(t!==f.root)for(t=t.parent,i=R(t.left)-t.size_left,n=$(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=n;t!==f.root&&(i!==0||n!==0);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=n),t=t.parent}}e.$zB=p}),define(Pe[91],Ae([1,0,131,29,92,130,93]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=void 0;const $=65535;function D(i){let n;return i[i.length-1]<65536?n=new Uint16Array(i.length):n=new Uint32Array(i.length),n.set(i,0),n}class g{constructor(n,u,o,l,r){this.lineStarts=n,this.cr=u,this.lf=o,this.crlf=l,this.isBasicASCII=r}}function A(i,n=!0){const u=[0];let o=1;for(let l=0,r=i.length;l<r;l++){const s=i.charCodeAt(l);s===13?l+1<r&&i.charCodeAt(l+1)===10?(u[o++]=l+2,l++):u[o++]=l+1:s===10&&(u[o++]=l+1)}return n?D(u):u}e.$GB=A;function S(i,n){i.length=0,i[0]=0;let u=1,o=0,l=0,r=0,s=!0;for(let h=0,b=n.length;h<b;h++){const m=n.charCodeAt(h);m===13?h+1<b&&n.charCodeAt(h+1)===10?(r++,i[u++]=h+2,h++):(o++,i[u++]=h+1):m===10?(l++,i[u++]=h+1):s&&m!==9&&(m<32||m>126)&&(s=!1)}const c=new g(D(i),o,l,r,s);return i.length=0,c}e.$HB=S;class a{constructor(n,u,o,l,r){this.bufferIndex=n,this.start=u,this.end=o,this.lineFeedCnt=l,this.length=r}}e.$IB=a;class v{constructor(n,u){this.buffer=n,this.lineStarts=u}}e.$JB=v;class p{constructor(n,u){this.a=[],this.c=n,this.d=u,this.b=0,n.root!==M.$rB&&n.iterate(n.root,o=>(o!==M.$rB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class f{constructor(n){this.a=n,this.b=[]}get(n){for(let u=this.b.length-1;u>=0;u--){const o=this.b[u];if(o.nodeStartOffset<=n&&o.nodeStartOffset+o.node.piece.length>=n)return o}return null}get2(n){for(let u=this.b.length-1;u>=0;u--){const o=this.b[u];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<n&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=n)return o}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let u=!1;const o=this.b;for(let l=0;l<o.length;l++){const r=o[l];if(r.node.parent===null||r.nodeStartOffset>=n){o[l]=null,u=!0;continue}}if(u){const l=[];for(const r of o)r!==null&&l.push(r);this.b=l}}}class t{constructor(n,u,o){this.create(n,u,o)}create(n,u,o){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=M.$rB,this.b=1,this.c=0,this.d=u,this.e=u.length,this.f=o;let l=null;for(let r=0,s=n.length;r<s;r++)if(n[r].buffer.length>0){n[r].lineStarts||(n[r].lineStarts=A(n[r].buffer));const c=new a(r+1,{line:0,column:0},{line:n[r].lineStarts.length-1,column:n[r].buffer.length-n[r].lineStarts[n[r].lineStarts.length-1]},n[r].lineStarts.length-1,n[r].buffer.length);this.a.push(n[r]),l=this.S(l,c)}this.h=new f(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const u=$,o=u-Math.floor(u/3),l=o*2;let r="",s=0;const c=[];if(this.iterate(this.root,h=>{const b=this.R(h),m=b.length;if(s<=o||s+m<l)return r+=b,s+=m,!0;const I=r.replace(/\r\n|\r|\n/g,n);return c.push(new v(I,A(I))),r=b,s=m,!0}),s>0){const h=r.replace(/\r\n|\r|\n/g,n);c.push(new v(h,A(h)))}this.create(c,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new p(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let u=0;return this.iterate(this.root,l=>{if(l===M.$rB)return!0;const r=this.R(l),s=r.length,c=n.G(u),h=n.G(u+s),b=n.getValueInRange2(c,h);return u+=s,r===b})}getOffsetAt(n,u){let o=0,l=this.root;for(;l!==M.$rB;)if(l.left!==M.$rB&&l.lf_left+1>=n)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=n){o+=l.size_left;const r=this.B(l,n-l.lf_left-2);return o+=r+u-1}else n-=l.lf_left+l.piece.lineFeedCnt,o+=l.size_left+l.piece.length,l=l.right;return o}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let u=this.root,o=0;const l=n;for(;u!==M.$rB;)if(u.size_left!==0&&u.size_left>=n)u=u.left;else if(u.size_left+u.piece.length>=n){const r=this.A(u,n-u.size_left);if(o+=u.lf_left+r.index,r.index===0){const s=this.getOffsetAt(o+1,1),c=l-s;return new E.$ys(o+1,c+1)}return new E.$ys(o+1,r.remainder+1)}else if(n-=u.size_left+u.piece.length,o+=u.lf_left+u.piece.lineFeedCnt,u.right===M.$rB){const r=this.getOffsetAt(o+1,1),s=l-n-r;return new E.$ys(o+1,s+1)}else u=u.right;return new E.$ys(1,1)}getValueInRange(n,u){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const o=this.H(n.startLineNumber,n.startColumn),l=this.H(n.endLineNumber,n.endColumn),r=this.getValueInRange2(o,l);return u?u!==this.d||!this.f?r.replace(/\r\n|\r|\n/g,u):u===this.getEOL()&&this.f?r:r.replace(/\r\n|\r|\n/g,u):r}getValueInRange2(n,u){if(n.node===u.node){const c=n.node,h=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);return h.substring(b+n.remainder,b+u.remainder)}let o=n.node;const l=this.a[o.piece.bufferIndex].buffer,r=this.u(o.piece.bufferIndex,o.piece.start);let s=l.substring(r+n.remainder,r+o.piece.length);for(o=o.next();o!==M.$rB;){const c=this.a[o.piece.bufferIndex].buffer,h=this.u(o.piece.bufferIndex,o.piece.start);if(o===u.node){s+=c.substring(h,h+u.remainder);break}else s+=c.substr(h,o.piece.length);o=o.next()}return s}getLinesContent(){const n=[];let u=0,o="",l=!1;return this.iterate(this.root,r=>{if(r===M.$rB)return!0;const s=r.piece;let c=s.length;if(c===0)return!0;const h=this.a[s.bufferIndex].buffer,b=this.a[s.bufferIndex].lineStarts,m=s.start.line,I=s.end.line;let k=b[m]+s.start.column;if(l&&(h.charCodeAt(k)===10&&(k++,c--),n[u++]=o,o="",l=!1,c===0))return!0;if(m===I)return!this.f&&h.charCodeAt(k+c-1)===13?(l=!0,o+=h.substr(k,c-1)):o+=h.substr(k,c),!0;o+=this.f?h.substring(k,Math.max(k,b[m+1]-this.e)):h.substring(k,b[m+1]).replace(/(\r\n|\r|\n)$/,""),n[u++]=o;for(let d=m+1;d<I;d++)o=this.f?h.substring(b[d],b[d+1]-this.e):h.substring(b[d],b[d+1]).replace(/(\r\n|\r|\n)$/,""),n[u++]=o;return!this.f&&h.charCodeAt(b[I]+s.end.column-1)===13?(l=!0,s.end.column===0?u--:o=h.substr(b[I],s.end.column-1)):o=h.substr(b[I],s.end.column),!0}),l&&(n[u++]=o,o=""),n[u++]=o,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const u=n.node.next();if(!u)return 0;const o=this.a[u.piece.bufferIndex],l=this.u(u.piece.bufferIndex,u.piece.start);return o.buffer.charCodeAt(l)}else{const u=this.a[n.node.piece.bufferIndex],l=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return u.buffer.charCodeAt(l)}}getLineCharCode(n,u){const o=this.H(n,u+1);return this.l(o)}getLineLength(n){if(n===this.getLineCount()){const u=this.getOffsetAt(n,1);return this.getLength()-u}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const u=this.G(n);return this.l(u)}findMatchesInNode(n,u,o,l,r,s,c,h,b,m,I){const k=this.a[n.piece.bufferIndex],d=this.u(n.piece.bufferIndex,n.piece.start),w=this.u(n.piece.bufferIndex,r),y=this.u(n.piece.bufferIndex,s);let C;const W={line:0,column:0};let H,U;u._wordSeparators?(H=k.buffer.substring(w,y),U=z=>z+w,u.reset(0)):(H=k.buffer,U=z=>z,u.reset(w));do if(C=u.next(H),C){if(U(C.index)>=y)return m;this.s(n,U(C.index)-d,W);const z=this.t(n.piece.bufferIndex,r,W),F=W.line===r.line?W.column-r.column+l:W.column+1,N=F+C[0].length;if(I[m++]=(0,R.$CB)(new L.$zs(o+z,F,o+z,N),C,h),U(C.index)+C[0].length>=y||m>=b)return m}while(C);return m}findMatchesLineByLine(n,u,o,l){const r=[];let s=0;const c=new R.$FB(u.wordSeparators,u.regex);let h=this.H(n.startLineNumber,n.startColumn);if(h===null)return[];const b=this.H(n.endLineNumber,n.endColumn);if(b===null)return[];let m=this.s(h.node,h.remainder);const I=this.s(b.node,b.remainder);if(h.node===b.node)return this.findMatchesInNode(h.node,c,n.startLineNumber,n.startColumn,m,I,u,o,l,s,r),r;let k=n.startLineNumber,d=h.node;for(;d!==b.node;){const y=this.t(d.piece.bufferIndex,m,d.piece.end);if(y>=1){const W=this.a[d.piece.bufferIndex].lineStarts,H=this.u(d.piece.bufferIndex,d.piece.start),U=W[m.line+y],z=k===n.startLineNumber?n.startColumn:1;if(s=this.findMatchesInNode(d,c,k,z,m,this.s(d,U-H),u,o,l,s,r),s>=l)return r;k+=y}const C=k===n.startLineNumber?n.startColumn-1:0;if(k===n.endLineNumber){const W=this.getLineContent(k).substring(C,n.endColumn-1);return s=this.n(u,c,W,n.endLineNumber,C,s,r,o,l),r}if(s=this.n(u,c,this.getLineContent(k).substr(C),k,C,s,r,o,l),s>=l)return r;k++,h=this.H(k,1),d=h.node,m=this.s(h.node,h.remainder)}if(k===n.endLineNumber){const y=k===n.startLineNumber?n.startColumn-1:0,C=this.getLineContent(k).substring(y,n.endColumn-1);return s=this.n(u,c,C,n.endLineNumber,y,s,r,o,l),r}const w=k===n.startLineNumber?n.startColumn:1;return s=this.findMatchesInNode(b.node,c,k,w,m,I,u,o,l,s,r),r}n(n,u,o,l,r,s,c,h,b){const m=n.wordSeparators;if(!h&&n.simpleSearch){const k=n.simpleSearch,d=k.length,w=o.length;let y=-d;for(;(y=o.indexOf(k,y+d))!==-1;)if((!m||(0,R.$EB)(m,o,w,y,d))&&(c[s++]=new P.$Qu(new L.$zs(l,y+1+r,l,y+1+d+r),null),s>=b))return s;return s}let I;u.reset(0);do if(I=u.next(o),I&&(c[s++]=(0,R.$CB)(new L.$zs(l,I.index+1+r,l,I.index+1+I[0].length+r),I,h),s>=b))return s;while(I);return s}insert(n,u,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==M.$rB){const{node:l,remainder:r,nodeStartOffset:s}=this.G(n),c=l.piece,h=c.bufferIndex,b=this.s(l,r);if(l.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&s+c.length===n&&u.length<$){this.F(l,u),this.y();return}if(s===n)this.o(u,l),this.h.validate(n);else if(s+l.piece.length>n){const m=[];let I=new a(c.bufferIndex,b,c.end,this.t(c.bufferIndex,b,c.end),this.u(h,c.end)-this.u(h,b));if(this.K()&&this.M(u)&&this.I(l,r)===10){const y={line:I.start.line+1,column:0};I=new a(I.bufferIndex,y,I.end,this.t(I.bufferIndex,y,I.end),I.length-1),u+=`
`}if(this.K()&&this.L(u))if(this.I(l,r-1)===13){const y=this.s(l,r-1);this.C(l,y),u="\r"+u,l.piece.length===0&&m.push(l)}else this.C(l,b);else this.C(l,b);const k=this.w(u);I.length>0&&this.S(l,I);let d=l;for(let w=0;w<k.length;w++)d=this.S(d,k[w]);this.v(m)}else this.q(u,l)}else{const l=this.w(u);let r=this.T(null,l[0]);for(let s=1;s<l.length;s++)r=this.S(r,l[s])}this.y()}delete(n,u){if(this.j.lineNumber=0,this.j.value="",u<=0||this.root===M.$rB)return;const o=this.G(n),l=this.G(n+u),r=o.node,s=l.node;if(r===s){const k=this.s(r,o.remainder),d=this.s(r,l.remainder);if(o.nodeStartOffset===n){if(u===r.piece.length){const w=r.next();(0,M.$wB)(this,r),this.N(w),this.y();return}this.D(r,d),this.h.validate(n),this.N(r),this.y();return}if(o.nodeStartOffset+r.piece.length===n+u){this.C(r,k),this.O(r),this.y();return}this.E(r,k,d),this.y();return}const c=[],h=this.s(r,o.remainder);this.C(r,h),this.h.validate(n),r.piece.length===0&&c.push(r);const b=this.s(s,l.remainder);this.D(s,b),s.piece.length===0&&c.push(s);const m=r.next();for(let k=m;k!==M.$rB&&k!==s;k=k.next())c.push(k);const I=r.piece.length===0?r.prev():r;this.v(c),this.O(I),this.y()}o(n,u){const o=[];if(this.K()&&this.M(n)&&this.L(u)){const s=u.piece,c={line:s.start.line+1,column:0},h=new a(s.bufferIndex,c,s.end,this.t(s.bufferIndex,c,s.end),s.length-1);u.piece=h,n+=`
`,(0,M.$yB)(this,u,-1,-1),u.piece.length===0&&o.push(u)}const l=this.w(n);let r=this.T(u,l[l.length-1]);for(let s=l.length-2;s>=0;s--)r=this.T(r,l[s]);this.N(r),this.v(o)}q(n,u){this.Q(n,u)&&(n+=`
`);const o=this.w(n),l=this.S(u,o[0]);let r=l;for(let s=1;s<o.length;s++)r=this.S(r,o[s]);this.N(l)}s(n,u,o){const l=n.piece,r=n.piece.bufferIndex,s=this.a[r].lineStarts,h=s[l.start.line]+l.start.column+u;let b=l.start.line,m=l.end.line,I=0,k=0,d=0;for(;b<=m&&(I=b+(m-b)/2|0,d=s[I],I!==m);)if(k=s[I+1],h<d)m=I-1;else if(h>=k)b=I+1;else break;return o?(o.line=I,o.column=h-d,null):{line:I,column:h-d}}t(n,u,o){if(o.column===0)return o.line-u.line;const l=this.a[n].lineStarts;if(o.line===l.length-1)return o.line-u.line;const r=l[o.line+1],s=l[o.line]+o.column;if(r>s+1)return o.line-u.line;const c=s-1;return this.a[n].buffer.charCodeAt(c)===13?o.line-u.line+1:o.line-u.line}u(n,u){return this.a[n].lineStarts[u.line]+u.column}v(n){for(let u=0;u<n.length;u++)(0,M.$wB)(this,n[u])}w(n){if(n.length>$){const m=[];for(;n.length>$;){const k=n.charCodeAt($-1);let d;k===13||k>=55296&&k<=56319?(d=n.substring(0,$-1),n=n.substring($-1)):(d=n.substring(0,$),n=n.substring($));const w=A(d);m.push(new a(this.a.length,{line:0,column:0},{line:w.length-1,column:d.length-w[w.length-1]},w.length-1,d.length)),this.a.push(new v(d,w))}const I=A(n);return m.push(new a(this.a.length,{line:0,column:0},{line:I.length-1,column:n.length-I[I.length-1]},I.length-1,n.length)),this.a.push(new v(n,I)),m}let u=this.a[0].buffer.length;const o=A(n,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===u&&u!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let m=0;m<o.length;m++)o[m]+=u+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+n,u+=1}else{if(u!==0)for(let m=0;m<o.length;m++)o[m]+=u;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=n}const r=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,c=r-this.a[0].lineStarts[s],h={line:s,column:c},b=new a(0,l,h,this.t(0,l,h),r-u);return this.g=h,[b]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,u=0){let o=this.root,l="";const r=this.h.get2(n);if(r){o=r.node;const s=this.B(o,n-r.nodeStartLineNumber-1),c=this.a[o.piece.bufferIndex].buffer,h=this.u(o.piece.bufferIndex,o.piece.start);if(r.nodeStartLineNumber+o.piece.lineFeedCnt===n)l=c.substring(h+s,h+o.piece.length);else{const b=this.B(o,n-r.nodeStartLineNumber);return c.substring(h+s,h+b-u)}}else{let s=0;const c=n;for(;o!==M.$rB;)if(o.left!==M.$rB&&o.lf_left>=n-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>n-1){const h=this.B(o,n-o.lf_left-2),b=this.B(o,n-o.lf_left-1),m=this.a[o.piece.bufferIndex].buffer,I=this.u(o.piece.bufferIndex,o.piece.start);return s+=o.size_left,this.h.set({node:o,nodeStartOffset:s,nodeStartLineNumber:c-(n-1-o.lf_left)}),m.substring(I+h,I+b-u)}else if(o.lf_left+o.piece.lineFeedCnt===n-1){const h=this.B(o,n-o.lf_left-2),b=this.a[o.piece.bufferIndex].buffer,m=this.u(o.piece.bufferIndex,o.piece.start);l=b.substring(m+h,m+o.piece.length);break}else n-=o.lf_left+o.piece.lineFeedCnt,s+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==M.$rB;){const s=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const c=this.B(o,0),h=this.u(o.piece.bufferIndex,o.piece.start);return l+=s.substring(h,h+c-u),l}else{const c=this.u(o.piece.bufferIndex,o.piece.start);l+=s.substr(c,o.piece.length)}o=o.next()}return l}y(){let n=this.root,u=1,o=0;for(;n!==M.$rB;)u+=n.lf_left+n.piece.lineFeedCnt,o+=n.size_left+n.piece.length,n=n.right;this.b=u,this.c=o,this.h.validate(this.c)}A(n,u){const o=n.piece,l=this.s(n,u),r=l.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===u){const s=this.t(n.piece.bufferIndex,o.start,l);if(s!==r)return{index:s,remainder:0}}return{index:r,remainder:l.column}}B(n,u){if(u<0)return 0;const o=n.piece,l=this.a[o.bufferIndex].lineStarts,r=o.start.line+u+1;return r>o.end.line?l[o.end.line]+o.end.column-l[o.start.line]-o.start.column:l[r]-l[o.start.line]-o.start.column}C(n,u){const o=n.piece,l=o.lineFeedCnt,r=this.u(o.bufferIndex,o.end),s=u,c=this.u(o.bufferIndex,s),h=this.t(o.bufferIndex,o.start,s),b=h-l,m=c-r,I=o.length+m;n.piece=new a(o.bufferIndex,o.start,s,h,I),(0,M.$yB)(this,n,m,b)}D(n,u){const o=n.piece,l=o.lineFeedCnt,r=this.u(o.bufferIndex,o.start),s=u,c=this.t(o.bufferIndex,s,o.end),h=this.u(o.bufferIndex,s),b=c-l,m=r-h,I=o.length+m;n.piece=new a(o.bufferIndex,s,o.end,c,I),(0,M.$yB)(this,n,m,b)}E(n,u,o){const l=n.piece,r=l.start,s=l.end,c=l.length,h=l.lineFeedCnt,b=u,m=this.t(l.bufferIndex,l.start,b),I=this.u(l.bufferIndex,u)-this.u(l.bufferIndex,r);n.piece=new a(l.bufferIndex,l.start,b,m,I),(0,M.$yB)(this,n,I-c,m-h);const k=new a(l.bufferIndex,o,s,this.t(l.bufferIndex,o,s),this.u(l.bufferIndex,s)-this.u(l.bufferIndex,o)),d=this.S(n,k);this.N(d)}F(n,u){this.Q(u,n)&&(u+=`
`);const o=this.K()&&this.L(u)&&this.M(n),l=this.a[0].buffer.length;this.a[0].buffer+=u;const r=A(u,!1);for(let d=0;d<r.length;d++)r[d]+=l;if(o){const d=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-d}}this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1));const s=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[s],h={line:s,column:c},b=n.piece.length+u.length,m=n.piece.lineFeedCnt,I=this.t(0,n.piece.start,h),k=I-m;n.piece=new a(n.piece.bufferIndex,n.piece.start,h,I,b),this.g=h,(0,M.$yB)(this,n,u.length,k)}G(n){let u=this.root;const o=this.h.get(n);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:n-o.nodeStartOffset};let l=0;for(;u!==M.$rB;)if(u.size_left>n)u=u.left;else if(u.size_left+u.piece.length>=n){l+=u.size_left;const r={node:u,remainder:n-u.size_left,nodeStartOffset:l};return this.h.set(r),r}else n-=u.size_left+u.piece.length,l+=u.size_left+u.piece.length,u=u.right;return null}H(n,u){let o=this.root,l=0;for(;o!==M.$rB;)if(o.left!==M.$rB&&o.lf_left>=n-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>n-1){const r=this.B(o,n-o.lf_left-2),s=this.B(o,n-o.lf_left-1);return l+=o.size_left,{node:o,remainder:Math.min(r+u-1,s),nodeStartOffset:l}}else if(o.lf_left+o.piece.lineFeedCnt===n-1){const r=this.B(o,n-o.lf_left-2);if(r+u-1<=o.piece.length)return{node:o,remainder:r+u-1,nodeStartOffset:l};u-=o.piece.length-r;break}else n-=o.lf_left+o.piece.lineFeedCnt,l+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==M.$rB;){if(o.piece.lineFeedCnt>0){const r=this.B(o,0),s=this.J(o);return{node:o,remainder:Math.min(u-1,r),nodeStartOffset:s}}else if(o.piece.length>=u-1){const r=this.J(o);return{node:o,remainder:u-1,nodeStartOffset:r}}else u-=o.piece.length;o=o.next()}return null}I(n,u){if(n.piece.lineFeedCnt<1)return-1;const o=this.a[n.piece.bufferIndex],l=this.u(n.piece.bufferIndex,n.piece.start)+u;return o.buffer.charCodeAt(l)}J(n){if(!n)return 0;let u=n.size_left;for(;n!==this.root;)n.parent.right===n&&(u+=n.parent.size_left+n.parent.piece.length),n=n.parent;return u}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$rB||n.piece.lineFeedCnt===0)return!1;const u=n.piece,o=this.a[u.bufferIndex].lineStarts,l=u.start.line,r=o[l]+u.start.column;return l===o.length-1||o[l+1]>r+1?!1:this.a[u.bufferIndex].buffer.charCodeAt(r)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$rB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const u=n.prev();this.M(u)&&this.P(u,n)}}O(n){if(this.K()&&this.M(n)){const u=n.next();this.L(u)&&this.P(n,u)}}P(n,u){const o=[],l=this.a[n.piece.bufferIndex].lineStarts;let r;n.piece.end.column===0?r={line:n.piece.end.line-1,column:l[n.piece.end.line]-l[n.piece.end.line-1]-1}:r={line:n.piece.end.line,column:n.piece.end.column-1};const s=n.piece.length-1,c=n.piece.lineFeedCnt-1;n.piece=new a(n.piece.bufferIndex,n.piece.start,r,c,s),(0,M.$yB)(this,n,-1,-1),n.piece.length===0&&o.push(n);const h={line:u.piece.start.line+1,column:0},b=u.piece.length-1,m=this.t(u.piece.bufferIndex,h,u.piece.end);u.piece=new a(u.piece.bufferIndex,h,u.piece.end,m,b),(0,M.$yB)(this,u,-1,-1),u.piece.length===0&&o.push(u);const I=this.w(`\r
`);this.S(n,I[0]);for(let k=0;k<o.length;k++)(0,M.$wB)(this,o[k])}Q(n,u){if(this.K()&&this.M(n)){const o=u.next();if(this.L(o)){if(n+=`
`,o.piece.length===1)(0,M.$wB)(this,o);else{const l=o.piece,r={line:l.start.line+1,column:0},s=l.length-1,c=this.t(l.bufferIndex,r,l.end);o.piece=new a(l.bufferIndex,r,l.end,c,s),(0,M.$yB)(this,o,-1,-1)}return!0}}return!1}iterate(n,u){if(n===M.$rB)return u(M.$rB);const o=this.iterate(n.left,u);return o&&u(n)&&this.iterate(n.right,u)}R(n){if(n===M.$rB)return"";const u=this.a[n.piece.bufferIndex],o=n.piece,l=this.u(o.bufferIndex,o.start),r=this.u(o.bufferIndex,o.end);return u.buffer.substring(l,r)}getPieceContent(n){const u=this.a[n.bufferIndex],o=this.u(n.bufferIndex,n.start),l=this.u(n.bufferIndex,n.end);return u.buffer.substring(o,l)}S(n,u){const o=new M.$qB(u,1);if(o.left=M.$rB,o.right=M.$rB,o.parent=M.$rB,o.size_left=0,o.lf_left=0,this.root===M.$rB)this.root=o,o.color=0;else if(n.right===M.$rB)n.right=o,o.parent=n;else{const r=(0,M.$sB)(n.right);r.left=o,o.parent=r}return(0,M.$xB)(this,o),o}T(n,u){const o=new M.$qB(u,1);if(o.left=M.$rB,o.right=M.$rB,o.parent=M.$rB,o.size_left=0,o.lf_left=0,this.root===M.$rB)this.root=o,o.color=0;else if(n.left===M.$rB)n.left=o,o.parent=n;else{const l=(0,M.$tB)(n.left);l.right=o,o.parent=l}return(0,M.$xB)(this,o),o}U(n){let u="";return this.iterate(n,o=>(u+=this.R(o),!0)),u}}e.$KB=t}),define(Pe[132],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w8=e.$v8=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$v8=E;class L{constructor(M){this.identifier=M}}e.$w8=L}),define(Pe[133],Ae([9,10]),function(ve,e){return ve.create("vs/base/common/actions",e)}),define(Pe[134],Ae([1,0,5,6,133]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=void 0;class M extends L.$Rc{constructor(a,v="",p="",f=!0,t){super(),this.h=this.B(new E.$Qd),this.onDidChange=this.h.event,this.w=!0,this.j=a,this.m=v,this.u=p,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(a){this.D(a)}D(a){this.m!==a&&(this.m=a,this.h.fire({label:a}))}get tooltip(){return this.n||""}set tooltip(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.h.fire({tooltip:a}))}get class(){return this.u}set class(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.h.fire({class:a}))}get enabled(){return this.w}set enabled(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.h.fire({enabled:a}))}get checked(){return this.z}set checked(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.h.fire({checked:a}))}async run(a,v){this.C&&await this.C(a)}}e.$zi=M;class R extends L.$Rc{constructor(){super(...arguments),this.f=this.B(new E.$Qd),this.onWillRun=this.f.event,this.m=this.B(new E.$Qd),this.onDidRun=this.m.event}async run(a,v){if(!a.enabled)return;this.f.fire({action:a});let p;try{await this.u(a,v)}catch(f){p=f}this.m.fire({action:a,error:p})}async u(a,v){await a.run(v)}}e.$Ai=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let v=[];for(const p of a)p.length&&(v.length?v=[...v,new $,...p]:v=p);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Bi=$;class D{get actions(){return this.a}constructor(a,v,p,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=v,this.class=f,this.a=p}async run(){}}e.$Ci=D;class g extends M{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,P.localize(0,null),void 0,!1)}}e.$Di=g;function A(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...a)=>S.run(...a),tooltip:S.label}}e.$Ei=A}),define(Pe[135],Ae([9,10]),function(ve,e){return ve.create("vs/base/common/date",e)}),define(Pe[136],Ae([1,0,135]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=void 0;const L=60,P=L*60,M=P*24,R=M*7,$=M*30,D=M*365;function g(S,a,v,p){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,E.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!p&&f<30)return(0,E.localize)(1,null);let t;return f<L?(t=f,a?t===1?v?(0,E.localize)(2,null,t):(0,E.localize)(3,null,t):v?(0,E.localize)(4,null,t):(0,E.localize)(5,null,t):t===1?v?(0,E.localize)(6,null,t):(0,E.localize)(7,null,t):v?(0,E.localize)(8,null,t):(0,E.localize)(9,null,t)):f<P?(t=Math.floor(f/L),a?t===1?v?(0,E.localize)(10,null,t):(0,E.localize)(11,null,t):v?(0,E.localize)(12,null,t):(0,E.localize)(13,null,t):t===1?v?(0,E.localize)(14,null,t):(0,E.localize)(15,null,t):v?(0,E.localize)(16,null,t):(0,E.localize)(17,null,t)):f<M?(t=Math.floor(f/P),a?t===1?v?(0,E.localize)(18,null,t):(0,E.localize)(19,null,t):v?(0,E.localize)(20,null,t):(0,E.localize)(21,null,t):t===1?v?(0,E.localize)(22,null,t):(0,E.localize)(23,null,t):v?(0,E.localize)(24,null,t):(0,E.localize)(25,null,t)):f<R?(t=Math.floor(f/M),a?t===1?(0,E.localize)(26,null,t):(0,E.localize)(27,null,t):t===1?(0,E.localize)(28,null,t):(0,E.localize)(29,null,t)):f<$?(t=Math.floor(f/R),a?t===1?v?(0,E.localize)(30,null,t):(0,E.localize)(31,null,t):v?(0,E.localize)(32,null,t):(0,E.localize)(33,null,t):t===1?v?(0,E.localize)(34,null,t):(0,E.localize)(35,null,t):v?(0,E.localize)(36,null,t):(0,E.localize)(37,null,t)):f<D?(t=Math.floor(f/$),a?t===1?v?(0,E.localize)(38,null,t):(0,E.localize)(39,null,t):v?(0,E.localize)(40,null,t):(0,E.localize)(41,null,t):t===1?v?(0,E.localize)(42,null,t):(0,E.localize)(43,null,t):v?(0,E.localize)(44,null,t):(0,E.localize)(45,null,t)):(t=Math.floor(f/D),a?t===1?v?(0,E.localize)(46,null,t):(0,E.localize)(47,null,t):v?(0,E.localize)(48,null,t):(0,E.localize)(49,null,t):t===1?v?(0,E.localize)(50,null,t):(0,E.localize)(51,null,t):v?(0,E.localize)(52,null,t):(0,E.localize)(53,null,t))}e.$im=g;function A(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$jm=A}),define(Pe[137],Ae([9,10]),function(ve,e){return ve.create("vs/base/common/errorMessage",e)}),define(Pe[39],Ae([1,0,18,16,137]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=void 0;function M(S,a){return a&&(S.stack||S.stacktrace)?P.localize(0,null,$(S),R(S.stack)||R(S.stacktrace)):$(S)}function R(S){return Array.isArray(S)?S.join(`
`):S}function $(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?P.localize(1,null,S.message):S.message||P.localize(2,null)}function D(S=null,a=!1){if(!S)return P.localize(3,null);if(Array.isArray(S)){const v=E.$Gb(S),p=D(v[0],a);return v.length>1?P.localize(4,null,p,v.length):p}if(L.$Bf(S))return S;if(S.detail){const v=S.detail;if(v.error)return M(v.error,a);if(v.exception)return M(v.exception,a)}return S.stack?M(S,a):S.message?S.message:P.localize(5,null)}e.$Fi=D;function g(S){const a=S;return a instanceof Error&&Array.isArray(a.actions)}e.$Gi=g;function A(S,a){let v;return typeof S=="string"?v=new Error(S):v=S,v.actions=a,v}e.$Hi=A}),define(Pe[138],Ae([1,0,44,19]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=void 0;const P=new E.$U(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),M=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(k,d,w=!1){const y=k||"",C=d||"",W=P.value.collator.compare(y,C);return P.value.collatorIsNumeric&&W===0&&y!==C?y<C?-1:1:W}e.$mq=$;function D(k,d){const w=M.value.collator;return k=k||"",d=d||"",o(w,k,d)}e.$nq=D;function g(k,d){const w=M.value.collator;return k=k||"",d=d||"",c(k,d)||o(w,k,d)}e.$oq=g;function A(k,d){const w=M.value.collator;return k=k||"",d=d||"",s(k,d)||o(w,k,d)}e.$pq=A;function S(k,d){return k=k||"",d=d||"",k===d?0:k<d?-1:1}e.$qq=S;function a(k,d){const[w,y]=n(k),[C,W]=n(d);let H=P.value.collator.compare(y,W);if(H===0){if(P.value.collatorIsNumeric&&y!==W)return y<W?-1:1;if(H=P.value.collator.compare(w,C),P.value.collatorIsNumeric&&H===0&&w!==C)return w<C?-1:1}return H}e.$rq=a;function v(k,d){k=k||"",d=d||"";const w=u(k),y=u(d),C=M.value.collator,W=R.value.collator;return o(W,w,y)||o(C,k,d)}e.$sq=v;function p(k,d){k=k||"",d=d||"";const w=u(k),y=u(d),C=M.value.collator,W=R.value.collator;return o(W,w,y)||c(k,d)||o(C,k,d)}e.$tq=p;function f(k,d){k=k||"",d=d||"";const w=u(k),y=u(d),C=M.value.collator,W=R.value.collator;return o(W,w,y)||s(k,d)||o(C,k,d)}e.$uq=f;function t(k,d){k=k||"",d=d||"";const w=u(k).toLowerCase(),y=u(d).toLowerCase();return w!==y?w<y?-1:1:k!==d?k<d?-1:1:0}e.$vq=t;const i=/^(.*?)(\.([^.]*))?$/;function n(k,d=!1){const w=k?i.exec(k):[];let y=[w&&w[1]||"",w&&w[3]||""];return d&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function u(k){const d=k?i.exec(k):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function o(k,d,w){const y=k.compare(d,w);return y!==0?y:d.length!==w.length?d.length<w.length?-1:1:0}function l(k){const d=k.charAt(0);return d.toLocaleUpperCase()!==d}function r(k){const d=k.charAt(0);return d.toLocaleLowerCase()!==d}function s(k,d){return l(k)&&r(d)?-1:r(k)&&l(d)?1:0}function c(k,d){return r(k)&&l(d)?-1:l(k)&&r(d)?1:0}function h(k,d,w=!1){return w||(k=k&&k.toLowerCase(),d=d&&d.toLowerCase()),k===d?0:k<d?-1:1}function b(k,d,w=!1){const y=k.split(L.sep),C=d.split(L.sep),W=y.length-1,H=C.length-1;let U,z;for(let F=0;;F++){if(U=W===F,z=H===F,U&&z)return $(y[F],C[F],w);if(U)return-1;if(z)return 1;const N=h(y[F],C[F],w);if(N!==0)return N}}e.$wq=b;function m(k,d,w){const y=k.toLowerCase(),C=d.toLowerCase(),W=I(k,d,w);if(W)return W;const H=y.endsWith(w),U=C.endsWith(w);if(H!==U)return H?-1:1;const z=$(y,C);return z!==0?z:y.localeCompare(C)}e.$xq=m;function I(k,d,w){const y=k.toLowerCase(),C=d.toLowerCase(),W=y.startsWith(w),H=C.startsWith(w);if(W!==H)return W?-1:1;if(W&&H){if(y.length<C.length)return-1;if(y.length>C.length)return 1}return 0}e.$yq=I}),define(Pe[46],Ae([1,0,19,21,13,16]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function R(m){return m===47||m===92}e.$Tf=R;function $(m){return m.replace(/[\\/]/g,E.$fc.sep)}e.$Uf=$;function D(m){return m.indexOf("/")===-1&&(m=$(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Vf=D;function g(m,I=E.$fc.sep){if(!m)return"";const k=m.length,d=m.charCodeAt(0);if(R(d)){if(R(m.charCodeAt(1))&&!R(m.charCodeAt(2))){let y=3;const C=y;for(;y<k&&!R(m.charCodeAt(y));y++);if(C!==y&&!R(m.charCodeAt(y+1))){for(y+=1;y<k;y++)if(R(m.charCodeAt(y)))return m.slice(0,y+1).replace(/[\\/]/g,I)}}return I}else if(i(d)&&m.charCodeAt(1)===58)return R(m.charCodeAt(2))?m.slice(0,2)+I:m.slice(0,2);let w=m.indexOf("://");if(w!==-1){for(w+=3;w<k;w++)if(R(m.charCodeAt(w)))return m.slice(0,w+1)}return""}e.$Wf=g;function A(m){if(!L.$i||!m||m.length<5)return!1;let I=m.charCodeAt(0);if(I!==92||(I=m.charCodeAt(1),I!==92))return!1;let k=2;const d=k;for(;k<m.length&&(I=m.charCodeAt(k),I!==92);k++);return!(d===k||(I=m.charCodeAt(k+1),isNaN(I)||I===92))}e.$Xf=A;const S=/[\\/:\*\?"<>\|]/g,a=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(m,I=L.$i){const k=I?S:a;return!(!m||m.length===0||/^\s+$/.test(m)||(k.lastIndex=0,k.test(m))||I&&v.test(m)||m==="."||m===".."||I&&m[m.length-1]==="."||I&&m.length!==m.trim().length||m.length>255)}e.$Yf=p;function f(m,I,k){const d=m===I;return!k||d?d:!m||!I?!1:(0,P.$5e)(m,I)}e.$Zf=f;function t(m,I,k,d=E.sep){if(m===I)return!0;if(!m||!I||I.length>m.length)return!1;if(k){if(!(0,P.$6e)(m,I))return!1;if(I.length===m.length)return!0;let y=I.length;return I.charAt(I.length-1)===d&&y--,m.charAt(y)===d}return I.charAt(I.length-1)!==d&&(I+=d),m.indexOf(I)===0}e.$1f=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$2f=i;function n(m,I){return L.$i&&m.endsWith(":")&&(m+=E.sep),(0,E.$hc)(m)||(m=(0,E.$ic)(I,m)),m=(0,E.$gc)(m),L.$i?(m=(0,P.$Ne)(m,E.sep),m.endsWith(":")&&(m+=E.sep)):(m=(0,P.$Ne)(m,E.sep),m||(m=E.sep)),m}e.$3f=n;function u(m){const I=(0,E.$gc)(m);return L.$i?m.length>3?!1:o(I)&&(m.length===2||I.charCodeAt(2)===92):I===E.$fc.sep}e.$4f=u;function o(m,I=L.$i){return I?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$5f=o;function l(m,I=L.$i){return o(m,I)?m[0]:void 0}e.$6f=l;function r(m,I,k){return I.length>m.length?-1:m===I?0:(k&&(m=m.toLowerCase(),I=I.toLowerCase()),m.indexOf(I))}e.$7f=r;function s(m){const I=m.split(":");let k,d,w;for(const y of I){const C=Number(y);(0,M.$Ff)(C)?d===void 0?d=C:w===void 0&&(w=C):k=k?[k,y].join(":"):y}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:d!==void 0?d:void 0,column:w!==void 0?w:d!==void 0?1:void 0}}e.$8f=s;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(m,I,k=8){let d="";for(let y=0;y<k;y++){let C;y===0&&L.$i&&!I&&(k===3||k===4)?C=h:C=c,d+=C.charAt(Math.floor(Math.random()*C.length))}let w;return I?w=`${I}-${d}`:w=d,m?(0,E.$ic)(m,w):w}e.$9f=b}),define(Pe[69],Ae([1,0,19]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(A){const S=(0,E.$nc)(A),a=L[S.toLowerCase()];return a!==void 0?a:R(A)}e.$Wr=M;function R(A){const S=(0,E.$nc)(A);return P[S.toLowerCase()]}e.$Xr=R;function $(A){for(const S in P)if(P[S]===A)return S}e.$Yr=$;const D=/^(.+)\/(.+?)(;.+)?$/;function g(A,S){const a=D.exec(A);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:S?void 0:A}e.$Zr=g}),define(Pe[52],Ae([1,0,24,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rh=e.$qh=e.$ph=void 0;function P(D){return JSON.stringify(D,R)}e.$ph=P;function M(D){let g=JSON.parse(D);return g=$(g),g}e.$qh=M;function R(D,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function $(D,g=0){if(!D||g>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return L.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 17:return new Date(D.source)}if(D instanceof E.$ee||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let A=0;A<D.length;++A)D[A]=$(D[A],g+1);else for(const A in D)Object.hasOwnProperty.call(D,A)&&(D[A]=$(D[A],g+1))}return D}e.$rh=$}),define(Pe[14],Ae([1,0,11,21,2]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.Schemas=void 0;var M;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$0f="vscode-tkn",e.$$f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${M.vscodeRemoteResource}`}set(A,S,a){this.a[A]=S,this.b[A]=a}setConnectionToken(A,S){this.c[A]=S}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(t){return E.$Z(t),A}const S=A.authority;let a=this.a[S];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const v=this.b[S],p=this.c[S];let f=`path=${encodeURIComponent(A.path)}`;return typeof p=="string"&&(f+=`&${e.$$f}=${encodeURIComponent(p)}`),P.URI.from({scheme:L.$o?this.d:M.vscodeRemoteResource,authority:`${a}:${v}`,path:this.f,query:f})}}e.$_f=new R,e.$ag="vs/../../extensions",e.$bg="vs/../../node_modules",e.$cg="vs/../../node_modules.asar",e.$dg="vs/../../node_modules.asar.unpacked",e.$eg="vscode-app";class ${static{this.a=e.$eg}asBrowserUri(A){const S=this.b(A,ve);return this.uriToBrowserUri(S)}uriToBrowserUri(A){return A.scheme===M.vscodeRemote?e.$_f.rewrite(A):A.scheme===M.file&&(L.$m||L.$q===`${M.vscodeFileResource}://${$.a}`)?A.with({scheme:M.vscodeFileResource,authority:A.authority||$.a,query:null,fragment:null}):A}asFileUri(A){const S=this.b(A,ve);return this.uriToFileUri(S)}uriToFileUri(A){return A.scheme===M.vscodeFileResource?A.with({scheme:M.file,authority:A.authority!==$.a?A.authority:null,query:null,fragment:null}):A}b(A,S){return P.URI.isUri(A)?A:P.URI.parse(S.toUrl(A))}}e.$fg=new $;var D;(function(g){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(A.get("3"));const S="vscode-coi";function a(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:P.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const t=f?.get(S);if(t)return A.get(t)}g.getHeadersFromQuery=a;function v(p,f,t){if(!globalThis.crossOriginIsolated)return;const i=f&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(S,i):p[S]=i}g.addSearchParam=v})(D||(e.COI=D={}))}),define(Pe[25],Ae([1,0,46,14,19,21,13,2]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ig=e.DataUri=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=void 0;function D(v){return(0,$.$vc)(v,!0)}e.$mg=D;class g{constructor(p){this.a=p}compare(p,f,t=!1){return p===f?0:(0,R.$Xe)(this.getComparisonKey(p,t),this.getComparisonKey(f,t))}isEqual(p,f,t=!1){return p===f?!0:!p||!f?!1:this.getComparisonKey(p,t)===this.getComparisonKey(f,t)}getComparisonKey(p,f=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,f,t=!1){if(p.scheme===f.scheme){if(p.scheme===L.Schemas.file)return E.$1f(D(p),D(f),this.a(p))&&p.query===f.query&&(t||p.fragment===f.fragment);if((0,e.$Dg)(p.authority,f.authority))return E.$1f(p.path,f.path,this.a(p),"/")&&p.query===f.query&&(t||p.fragment===f.fragment)}return!1}joinPath(p,...f){return $.URI.joinPath(p,...f)}basenameOrAuthority(p){return(0,e.$vg)(p)||p.authority}basename(p){return P.$fc.basename(p.path)}extname(p){return P.$fc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let f;return p.scheme===L.Schemas.file?f=$.URI.file(P.$lc(D(p))).path:(f=P.$fc.dirname(p.path),p.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),f="/")),p.with({path:f})}normalizePath(p){if(!p.path.length)return p;let f;return p.scheme===L.Schemas.file?f=$.URI.file(P.$gc(D(p))).path:f=P.$fc.normalize(p.path),p.with({path:f})}relativePath(p,f){if(p.scheme!==f.scheme||!(0,e.$Dg)(p.authority,f.authority))return;if(p.scheme===L.Schemas.file){const n=P.$kc(D(p),D(f));return M.$i?E.$Uf(n):n}let t=p.path||"/";const i=f.path||"/";if(this.a(p)){let n=0;for(const u=Math.min(t.length,i.length);n<u&&!(t.charCodeAt(n)!==i.charCodeAt(n)&&t.charAt(n).toLowerCase()!==i.charAt(n).toLowerCase());n++);t=i.substr(0,n)+t.substr(n)}return P.$fc.relative(t,i)}resolvePath(p,f){if(p.scheme===L.Schemas.file){const t=$.URI.file(P.$jc(D(p),f));return p.with({authority:t.authority,path:t.path})}return f=E.$Vf(f),p.with({path:P.$fc.resolve(p.path,f)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,f){return p===f||p!==void 0&&f!==void 0&&(0,R.$5e)(p,f)}hasTrailingPathSeparator(p,f=P.sep){if(p.scheme===L.Schemas.file){const t=D(p);return t.length>E.$Wf(t).length&&t[t.length-1]===f}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,f=P.sep){return(0,e.$Eg)(p,f)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,f=P.sep){let t=!1;if(p.scheme===L.Schemas.file){const i=D(p);t=i!==void 0&&i.length===E.$Wf(i).length&&i[i.length-1]===f}else{f="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Eg)(p,f)?p.with({path:p.path+"/"}):p}}e.$ng=g,e.$og=new g(()=>!1),e.$pg=new g(v=>v.scheme===L.Schemas.file?!M.$k:!0),e.$qg=new g(v=>!0),e.$rg=e.$og.isEqual.bind(e.$og),e.$sg=e.$og.isEqualOrParent.bind(e.$og),e.$tg=e.$og.getComparisonKey.bind(e.$og),e.$ug=e.$og.basenameOrAuthority.bind(e.$og),e.$vg=e.$og.basename.bind(e.$og),e.$wg=e.$og.extname.bind(e.$og),e.$xg=e.$og.dirname.bind(e.$og),e.$yg=e.$og.joinPath.bind(e.$og),e.$zg=e.$og.normalizePath.bind(e.$og),e.$Ag=e.$og.relativePath.bind(e.$og),e.$Bg=e.$og.resolvePath.bind(e.$og),e.$Cg=e.$og.isAbsolutePath.bind(e.$og),e.$Dg=e.$og.isEqualAuthority.bind(e.$og),e.$Eg=e.$og.hasTrailingPathSeparator.bind(e.$og),e.$Fg=e.$og.removeTrailingPathSeparator.bind(e.$og),e.$Gg=e.$og.addTrailingPathSeparator.bind(e.$og);function A(v,p){const f=[];for(let t=0;t<v.length;t++){const i=p(v[t]);v.some((n,u)=>u===t?!1:(0,e.$sg)(i,p(n)))||f.push(v[t])}return f}e.$Hg=A;var S;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function p(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(u=>{const[o,l]=u.split(":");o&&l&&t.set(o,l)});const n=f.path.substring(0,f.path.indexOf(";"));return n&&t.set(v.META_DATA_MIME,n),t}v.parseMetaData=p})(S||(e.DataUri=S={}));function a(v,p,f){if(p){let t=v.path;return t&&t[0]!==P.$fc.sep&&(t=P.$fc.sep+t),v.with({scheme:f,authority:p,path:t})}return v.with({scheme:f})}e.$Ig=a}),define(Pe[12],Ae([1,0,20,11,5,6,25,21,124]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.Promises=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0;function g(pe){return!!pe&&typeof pe.then=="function"}e.$Jg=g;function A(pe){const re=new E.$1d,he=pe(re.token),ue=new Promise((we,ee)=>{const de=re.token.onCancellationRequested(()=>{de.dispose(),re.dispose(),ee(new L.$4)});Promise.resolve(he).then(ie=>{de.dispose(),re.dispose(),we(ie)},ie=>{de.dispose(),re.dispose(),ee(ie)})});return new class{cancel(){re.cancel()}then(we,ee){return ue.then(we,ee)}catch(we){return this.then(void 0,we)}finally(we){return ue.finally(we)}}}e.$Kg=A;function S(pe,re,he){return new Promise((ue,we)=>{const ee=re.onCancellationRequested(()=>{ee.dispose(),ue(he)});pe.then(ue,we).finally(()=>ee.dispose())})}e.$Lg=S;function a(pe,re){return new Promise((he,ue)=>{const we=re.onCancellationRequested(()=>{we.dispose(),ue(new L.$4)});pe.then(he,ue).finally(()=>we.dispose())})}e.$Mg=a;async function v(pe){let re=-1;const he=pe.map((ue,we)=>ue.then(ee=>(re=we,ee)));try{return await Promise.race(he)}finally{pe.forEach((ue,we)=>{we!==re&&ue.cancel()})}}e.$Ng=v;function p(pe,re,he){let ue;const we=setTimeout(()=>{ue?.(void 0),he?.()},re);return Promise.race([pe.finally(()=>clearTimeout(we)),new Promise(ee=>ue=ee)])}e.$Og=p;function f(pe){return new Promise((re,he)=>{const ue=pe();g(ue)?ue.then(re,he):re(ue)})}e.$Pg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(re){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=re,!this.b){const he=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(he,he).then(ue)})}return new Promise((he,ue)=>{this.b.then(he,ue)})}return this.a=re(),new Promise((he,ue)=>{this.a.then(we=>{this.a=null,he(we)},we=>{this.a=null,ue(we)})})}dispose(){this.f=!0}}e.$Qg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(re){return this.a=this.a.then(()=>re(),()=>re())}}e.$Rg=i;class n{constructor(){this.a=new Map}queue(re,he){const we=(this.a.get(re)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(re)===we&&this.a.delete(re)});return this.a.set(re,we),we}}e.$Sg=n;const u=(pe,re)=>{let he=!0;const ue=setTimeout(()=>{he=!1,re()},pe);return{isTriggered:()=>he,dispose:()=>{clearTimeout(ue),he=!1}}},o=pe=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,pe())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};class l{constructor(re){this.defaultDelay=re,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(re,he=this.defaultDelay){this.g=re,this.h(),this.b||(this.b=new Promise((we,ee)=>{this.d=we,this.f=ee}).then(()=>{if(this.b=null,this.d=null,this.g){const we=this.g;return this.g=null,we()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=he===D.$Nd?o(ue):u(he,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Tg=l;class r{constructor(re){this.a=new l(re),this.b=new t}trigger(re,he){return this.a.trigger(()=>this.b.queue(re),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ug=r;class s{constructor(){this.a=!1,this.b=new Promise((re,he)=>{this.d=re})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Vg=s;class c extends s{constructor(re){super(),this.f=setTimeout(()=>this.open(),re)}open(){clearTimeout(this.f),super.open()}}e.$Wg=c;function h(pe,re){return re?new Promise((he,ue)=>{const we=setTimeout(()=>{ee.dispose(),he()},pe),ee=re.onCancellationRequested(()=>{clearTimeout(we),ee.dispose(),ue(new L.$4)})}):A(he=>h(pe,he))}e.$Xg=h;function b(pe,re=0,he){const ue=setTimeout(()=>{pe(),he&&we.dispose()},re),we=(0,M.$Pc)(()=>{clearTimeout(ue),he?.deleteAndLeak(we)});return he?.add(we),we}e.$Yg=b;function m(pe){const re=[];let he=0;const ue=pe.length;function we(){return he<ue?pe[he++]():null}function ee(de){de!=null&&re.push(de);const ie=we();return ie?ie.then(ee):Promise.resolve(re)}return Promise.resolve(null).then(ee)}e.$Zg=m;function I(pe,re=ue=>!!ue,he=null){let ue=0;const we=pe.length,ee=()=>{if(ue>=we)return Promise.resolve(he);const de=pe[ue++];return Promise.resolve(de()).then(ce=>re(ce)?Promise.resolve(ce):ee())};return ee()}e.$1g=I;function k(pe,re=ue=>!!ue,he=null){if(pe.length===0)return Promise.resolve(he);let ue=pe.length;const we=()=>{ue=-1;for(const ee of pe)ee.cancel?.()};return new Promise((ee,de)=>{for(const ie of pe)ie.then(ce=>{--ue>=0&&re(ce)?(we(),ee(ce)):ue===0&&ee(he)}).catch(ce=>{--ue>=0&&(we(),de(ce))})})}e.$2g=k;class d{constructor(re){this.a=0,this.d=re,this.f=[],this.b=0,this.g=new P.$Qd}get onDrained(){return this.g.event}get size(){return this.a}queue(re){return this.a++,new Promise((he,ue)=>{this.f.push({factory:re,c:he,e:ue}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const re=this.f.shift();this.b++;const he=re.factory();he.then(re.c,re.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$3g=d;class w extends d{constructor(){super(1)}}e.$4g=w;class y{constructor(){this.a=new De,this.b=0}queue(re){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,re())):this.a.run(this.b++,re())}}e.$5g=y;class C{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const re=new be;return this.b.add(re),re.p}g(){for(const[,re]of this.a)if(re.size>0)return!1;return!0}queueFor(re,he=R.$og){const ue=he.getComparisonKey(re);let we=this.a.get(ue);if(!we){we=new w;const ee=this.f++,de=P.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$Zc),this.d.set(ee,de),this.a.set(ue,we)}return we}h(){this.g()&&this.j()}j(){for(const re of this.b)re.complete();this.b.clear()}dispose(){for(const[,re]of this.a)re.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$6g=C;class W{constructor(re,he){this.a=-1,typeof re=="function"&&typeof he=="number"&&this.setIfNotSet(re,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(re,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,re()},he)}setIfNotSet(re,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,re()},he))}}e.$7g=W;class H{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(re,he,ue=globalThis){this.cancel();const we=ue.setInterval(()=>{re()},he);this.d=(0,M.$Pc)(()=>{ue.clearInterval(we),this.d=void 0})}dispose(){this.cancel()}}e.$8g=H;class U{constructor(re,he){this.b=-1,this.a=re,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(re=this.d){this.cancel(),this.b=setTimeout(this.f,re)}get delay(){return this.d}set delay(re){this.d=re}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$9g=U;class z{constructor(re,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=re,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(re=this.b){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(re/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$0g=z;class F extends U{constructor(re,he){super(re,he),this.j=[]}work(re){this.j.push(re),this.isScheduled()||this.schedule()}h(){const re=this.j;this.j=[],this.a?.(re)}dispose(){this.j=[],super.dispose()}}e.$$g=F;class N extends M.$Rc{constructor(re,he){super(),this.g=re,this.h=he,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(re){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+re.length>this.g.maxBufferedWork)return!1}else if(this.pending+re.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of re)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$_g=N,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$bh=(pe,re)=>{(0,$.$B)(()=>{if(he)return;const ue=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let he=!1;return{dispose(){he||(he=!0)}}}:e.$bh=(pe,re,he)=>{const ue=pe.requestIdleCallback(re,typeof he=="number"?{timeout:he}:void 0);let we=!1;return{dispose(){we||(we=!0,pe.cancelIdleCallback(ue))}}},e.$ah=pe=>(0,e.$bh)(globalThis,pe)}();class x{constructor(re,he){this.g=!1,this.d=()=>{try{this.j=he()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$bh)(re,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$ch=x;class J extends x{constructor(re){super(globalThis,re)}}e.$dh=J;async function Ee(pe,re,he){let ue;for(let we=0;we<he;we++)try{return await pe()}catch(ee){ue=ee,await h(re)}throw ue}e.$eh=Ee;class De{isRunning(re){return typeof re=="number"?this.a?.taskId===re:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(re,he,ue){return this.a={taskId:re,cancel:()=>ue?.(),promise:he},he.then(()=>this.d(re),()=>this.d(re)),he}d(re){this.a&&re===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const re=this.b;this.b=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}queue(re){if(this.b)this.b.run=re;else{let he,ue;const we=new Promise((ee,de)=>{he=ee,ue=de});this.b={run:re,promise:we,promiseResolve:he,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$fh=De;class Ce{constructor(re,he=()=>Date.now()){this.d=re,this.f=he,this.a=0,this.b=0}increment(){const re=this.f();return re-this.a>this.d&&(this.a=re,this.b=0),this.b++,this.b}}e.$gh=Ce;var fe;(function(pe){pe[pe.Resolved=0]="Resolved",pe[pe.Rejected=1]="Rejected"})(fe||(fe={}));class be{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((re,he)=>{this.a=re,this.b=he})}complete(re){return new Promise(he=>{this.a(re),this.d={outcome:0,value:re},he()})}error(re){return new Promise(he=>{this.b(re),this.d={outcome:1,value:re},he()})}cancel(){return this.error(new L.$4)}}e.$hh=be;var se;(function(pe){async function re(ue){let we;const ee=await Promise.all(ue.map(de=>de.then(ie=>ie,ie=>{we||(we=ie)})));if(typeof we<"u")throw we;return ee}pe.settled=re;function he(ue){return new Promise(async(we,ee)=>{try{await ue(we,ee)}catch(de){ee(de)}})}pe.withAsyncBody=he})(se||(e.Promises=se={}));var Re;(function(pe){pe[pe.Initial=0]="Initial",pe[pe.DoneOK=1]="DoneOK",pe[pe.DoneError=2]="DoneError"})(Re||(Re={}));class oe{static fromArray(re){return new oe(he=>{he.emitMany(re)})}static fromPromise(re){return new oe(async he=>{he.emitMany(await re)})}static fromPromises(re){return new oe(async he=>{await Promise.all(re.map(async ue=>he.emitOne(await ue)))})}static merge(re){return new oe(async he=>{await Promise.all(re.map(async ue=>{for await(const we of ue)he.emitOne(we)}))})}static{this.EMPTY=oe.fromArray([])}constructor(re){this.a=0,this.b=[],this.d=null,this.f=new P.$Qd,queueMicrotask(async()=>{const he={emitOne:ue=>this.g(ue),emitMany:ue=>this.h(ue),reject:ue=>this.k(ue)};try{await Promise.resolve(re(he)),this.j()}catch(ue){this.k(ue)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(re<this.b.length)return{done:!1,value:this.b[re++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(re,he){return new oe(async ue=>{for await(const we of re)ue.emitOne(he(we))})}map(re){return oe.map(this,re)}static filter(re,he){return new oe(async ue=>{for await(const we of re)he(we)&&ue.emitOne(we)})}filter(re){return oe.filter(this,re)}static coalesce(re){return oe.filter(re,he=>!!he)}coalesce(){return oe.coalesce(this)}static async toPromise(re){const he=[];for await(const ue of re)he.push(ue);return he}toPromise(){return oe.toPromise(this)}g(re){this.a===0&&(this.b.push(re),this.f.fire())}h(re){this.a===0&&(this.b=this.b.concat(re),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(re){this.a===0&&(this.a=2,this.d=re,this.f.fire())}}e.$ih=oe;class X extends oe{constructor(re,he){super(he),this.l=re}cancel(){this.l.cancel()}}e.$jh=X;function j(pe){const re=new E.$1d,he=pe(re.token);return new X(re,async ue=>{const we=re.token.onCancellationRequested(()=>{we.dispose(),re.dispose(),ue.reject(new L.$4)});try{for await(const ee of he){if(re.token.isCancellationRequested)return;ue.emitOne(ee)}we.dispose(),re.dispose()}catch(ee){we.dispose(),re.dispose(),ue.reject(ee)}})}e.$kh=j;class ne{constructor(){this.a=new be,this.b=new oe(ue=>{if(re){ue.reject(re);return}return he&&ue.emitMany(he),this.d=we=>ue.reject(we),this.f=we=>ue.emitOne(we),this.a.p});let re,he;this.f=ue=>{he||(he=[]),he.push(ue)},this.d=ue=>{re||(re=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(re){this.d(re),this.a.complete()}emitOne(re){this.f(re)}}e.$lh=ne}),define(Pe[33],Ae([1,0,18,12,46,28,19,21,13]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=void 0;function g(){return Object.create(null)}e.$wj=g,e.$xj="**",e.$yj="/";const A="[/\\\\]",S="[^/\\\\]",a=/\//g;function v(Ee,De){switch(Ee){case 0:return"";case 1:return`${S}*?`;default:return`(?:${A}|${S}+${A}${De?`|${A}${S}+`:""})*?`}}function p(Ee,De){if(!Ee)return[];const Ce=[];let fe=!1,be=!1,se="";for(const Re of Ee){switch(Re){case De:if(!fe&&!be){Ce.push(se),se="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":be=!0;break;case"]":be=!1;break}se+=Re}return se&&Ce.push(se),Ce}e.$zj=p;function f(Ee){if(!Ee)return"";let De="";const Ce=p(Ee,e.$yj);if(Ce.every(fe=>fe===e.$xj))De=".*";else{let fe=!1;Ce.forEach((be,se)=>{if(be===e.$xj){if(fe)return;De+=v(2,se===Ce.length-1)}else{let Re=!1,oe="",X=!1,j="";for(const ne of be){if(ne!=="}"&&Re){oe+=ne;continue}if(X&&(ne!=="]"||!j)){let pe;ne==="-"?pe=ne:(ne==="^"||ne==="!")&&!j?pe="^":ne===e.$yj?pe="":pe=(0,D.$Ie)(ne),j+=pe;continue}switch(ne){case"{":Re=!0;continue;case"[":X=!0;continue;case"}":{const re=`(?:${p(oe,",").map(he=>f(he)).join("|")})`;De+=re,Re=!1,oe="";break}case"]":{De+="["+j+"]",X=!1,j="";break}case"?":De+=S;continue;case"*":De+=v(1);continue;default:De+=(0,D.$Ie)(ne)}}se<Ce.length-1&&(Ce[se+1]!==e.$xj||se+2<Ce.length)&&(De+=A)}fe=be===e.$xj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new M.$Cc(1e4),s=function(){return!1},c=function(){return null};function h(Ee,De){if(!Ee)return c;let Ce;typeof Ee!="string"?Ce=Ee.pattern:Ce=Ee,Ce=Ce.trim();const fe=`${Ce}_${!!De.trimForExclusions}`;let be=r.get(fe);if(be)return b(be,Ee);let se;return t.test(Ce)?be=I(Ce.substr(4),Ce):(se=i.exec(m(Ce,De)))?be=k(se[1],Ce):(De.trimForExclusions?u:n).test(Ce)?be=d(Ce,De):(se=o.exec(m(Ce,De)))?be=w(se[1].substr(1),Ce,!0):(se=l.exec(m(Ce,De)))?be=w(se[1],Ce,!1):be=y(Ce),r.set(fe,be),b(be,Ee)}function b(Ee,De){if(typeof De=="string")return Ee;const Ce=function(fe,be){return(0,P.$1f)(fe,De.base,!$.$k)?Ee((0,D.$Me)(fe.substr(De.base.length),R.sep),be):null};return Ce.allBasenames=Ee.allBasenames,Ce.allPaths=Ee.allPaths,Ce.basenames=Ee.basenames,Ce.patterns=Ee.patterns,Ce}function m(Ee,De){return De.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,De){return function(Ce,fe){return typeof Ce=="string"&&Ce.endsWith(Ee)?De:null}}function k(Ee,De){const Ce=`/${Ee}`,fe=`\\${Ee}`,be=function(Re,oe){return typeof Re!="string"?null:oe?oe===Ee?De:null:Re===Ee||Re.endsWith(Ce)||Re.endsWith(fe)?De:null},se=[Ee];return be.basenames=se,be.patterns=[De],be.allBasenames=se,be}function d(Ee,De){const Ce=x(Ee.slice(1,-1).split(",").map(oe=>h(oe,De)).filter(oe=>oe!==c),Ee),fe=Ce.length;if(!fe)return c;if(fe===1)return Ce[0];const be=function(oe,X){for(let j=0,ne=Ce.length;j<ne;j++)if(Ce[j](oe,X))return Ee;return null},se=Ce.find(oe=>!!oe.allBasenames);se&&(be.allBasenames=se.allBasenames);const Re=Ce.reduce((oe,X)=>X.allPaths?oe.concat(X.allPaths):oe,[]);return Re.length&&(be.allPaths=Re),be}function w(Ee,De,Ce){const fe=R.sep===R.$fc.sep,be=fe?Ee:Ee.replace(a,R.sep),se=R.sep+be,Re=R.$fc.sep+Ee;let oe;return Ce?oe=function(X,j){return typeof X=="string"&&(X===be||X.endsWith(se)||!fe&&(X===Ee||X.endsWith(Re)))?De:null}:oe=function(X,j){return typeof X=="string"&&(X===be||!fe&&X===Ee)?De:null},oe.allPaths=[(Ce?"*/":"./")+Ee],oe}function y(Ee){try{const De=new RegExp(`^${f(Ee)}$`);return function(Ce){return De.lastIndex=0,typeof Ce=="string"&&De.test(Ce)?Ee:null}}catch{return c}}function C(Ee,De,Ce){return!Ee||typeof De!="string"?!1:W(Ee)(De,void 0,Ce)}e.$Aj=C;function W(Ee,De={}){if(!Ee)return s;if(typeof Ee=="string"||H(Ee)){const Ce=h(Ee,De);if(Ce===c)return s;const fe=function(be,se){return!!Ce(be,se)};return Ce.allBasenames&&(fe.allBasenames=Ce.allBasenames),Ce.allPaths&&(fe.allPaths=Ce.allPaths),fe}return F(Ee,De)}e.$Bj=W;function H(Ee){const De=Ee;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$Cj=H;function U(Ee){return Ee.allBasenames||[]}e.$Dj=U;function z(Ee){return Ee.allPaths||[]}e.$Ej=z;function F(Ee,De){const Ce=x(Object.getOwnPropertyNames(Ee).map(oe=>N(oe,Ee[oe],De)).filter(oe=>oe!==c)),fe=Ce.length;if(!fe)return c;if(!Ce.some(oe=>!!oe.requiresSiblings)){if(fe===1)return Ce[0];const oe=function(ne,pe){let re;for(let he=0,ue=Ce.length;he<ue;he++){const we=Ce[he](ne,pe);if(typeof we=="string")return we;(0,L.$Jg)(we)&&(re||(re=[]),re.push(we))}return re?(async()=>{for(const he of re){const ue=await he;if(typeof ue=="string")return ue}return null})():null},X=Ce.find(ne=>!!ne.allBasenames);X&&(oe.allBasenames=X.allBasenames);const j=Ce.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return j.length&&(oe.allPaths=j),oe}const be=function(oe,X,j){let ne,pe;for(let re=0,he=Ce.length;re<he;re++){const ue=Ce[re];ue.requiresSiblings&&j&&(X||(X=(0,R.$mc)(oe)),ne||(ne=X.substr(0,X.length-(0,R.$nc)(oe).length)));const we=ue(oe,X,ne,j);if(typeof we=="string")return we;(0,L.$Jg)(we)&&(pe||(pe=[]),pe.push(we))}return pe?(async()=>{for(const re of pe){const he=await re;if(typeof he=="string")return he}return null})():null},se=Ce.find(oe=>!!oe.allBasenames);se&&(be.allBasenames=se.allBasenames);const Re=Ce.reduce((oe,X)=>X.allPaths?oe.concat(X.allPaths):oe,[]);return Re.length&&(be.allPaths=Re),be}function N(Ee,De,Ce){if(De===!1)return c;const fe=h(Ee,Ce);if(fe===c)return c;if(typeof De=="boolean")return fe;if(De){const be=De.when;if(typeof be=="string"){const se=(Re,oe,X,j)=>{if(!j||!fe(Re,oe))return null;const ne=be.replace("$(basename)",()=>X),pe=j(ne);return(0,L.$Jg)(pe)?pe.then(re=>re?Ee:null):pe?Ee:null};return se.requiresSiblings=!0,se}}return fe}function x(Ee,De){const Ce=Ee.filter(oe=>!!oe.basenames);if(Ce.length<2)return Ee;const fe=Ce.reduce((oe,X)=>{const j=X.basenames;return j?oe.concat(j):oe},[]);let be;if(De){be=[];for(let oe=0,X=fe.length;oe<X;oe++)be.push(De)}else be=Ce.reduce((oe,X)=>{const j=X.patterns;return j?oe.concat(j):oe},[]);const se=function(oe,X){if(typeof oe!="string")return null;if(!X){let ne;for(ne=oe.length;ne>0;ne--){const pe=oe.charCodeAt(ne-1);if(pe===47||pe===92)break}X=oe.substr(ne)}const j=fe.indexOf(X);return j!==-1?be[j]:null};se.basenames=fe,se.patterns=be,se.allBasenames=fe;const Re=Ee.filter(oe=>!oe.basenames);return Re.push(se),Re}function J(Ee,De){return(0,E.$tb)(Ee,De,(Ce,fe)=>typeof Ce=="string"&&typeof fe=="string"?Ce===fe:typeof Ce!="string"&&typeof fe!="string"?Ce.base===fe.base&&Ce.pattern===fe.pattern:!1)}e.$Fj=J}),define(Pe[53],Ae([1,0,11,125,25,13,2]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class D{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,E.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=a(this.supportThemeIcons?(0,L.$2j)(i):i).replace(/([ \t]+)/g,(u,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(i,n,u){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),u&&(this.value+=` "${this.c(this.c(u,'"'),")")}"`),this.value+=")",this}c(i,n){const u=new RegExp((0,M.$Ie)(n),"g");return i.replace(u,(o,l)=>i.charAt(l-1)!=="\\"?`\\${o}`:o)}}e.$8j=D;function g(t){return A(t)?!t.value:Array.isArray(t)?t.every(g):!0}e.$9j=g;function A(t){return t instanceof D?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$0j=A;function S(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,P.$rg)(R.URI.from(t.baseUri),R.URI.from(i.baseUri)))}e.$$j=S;function a(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$_j=a;function v(t){return t.replace(/"/g,"&quot;")}e.$ak=v;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$bk=p;function f(t){const i=[],n=t.split("|").map(o=>o.trim());t=n[0];const u=n[1];if(u){const o=/height=(\d+)/.exec(u),l=/width=(\d+)/.exec(u),r=o?o[1]:"",s=l?l[1]:"",c=isFinite(parseInt(s)),h=isFinite(parseInt(r));c&&i.push(`width="${s}"`),h&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.$ck=f}),define(Pe[94],Ae([1,0,18,46,19,21,25,13]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=void 0;function D(h,b){const{os:m,tildify:I,relative:k}=b;if(k){const y=g(h,k,m);if(typeof y=="string")return y}let d=h.fsPath;if(m===1&&!M.$i?d=d.replace(/\//g,"\\"):m!==1&&M.$i&&(d=d.replace(/\\/g,"/")),m!==1&&I?.userHome){const y=I.userHome.fsPath;let C;h.scheme!==I.userHome.scheme&&h.path[0]===P.$fc.sep&&h.path[1]!==P.$fc.sep?C=I.userHome.with({path:h.path}).fsPath:C=d,d=a(C,y,m)}return(m===1?P.$ec:P.$fc).normalize(A(d,m===1))}e.$xv=D;function g(h,b,m){const I=m===1?P.$ec:P.$fc,k=m===3?R.$og:R.$qg,d=b.getWorkspace(),w=(0,E.$Nb)(d.folders);if(!w)return;h.scheme!==w.uri.scheme&&h.path[0]===P.$fc.sep&&h.path[1]!==P.$fc.sep&&(h=w.uri.with({path:h.path}));const y=b.getWorkspaceFolder(h);if(!y)return;let C;if(k.isEqual(y.uri,h)?C="":C=k.relativePath(y.uri,h)??"",C&&(C=I.normalize(C)),d.folders.length>1&&!b.noPrefix){const W=y.name?y.name:k.basenameOrAuthority(y.uri);C=C?`${W} \u2022 ${C}`:W}return C}function A(h,b=M.$i){return(0,L.$5f)(h,b)?h.charAt(0).toUpperCase()+h.slice(1):h}e.$yv=A;let S=Object.create(null);function a(h,b,m=M.OS){if(m===1||!h||!b)return h;let I=S.original===b?S.normalized:void 0;I||(I=b,M.$i&&(I=(0,L.$Uf)(I)),I=`${(0,$.$Ne)(I,P.$fc.sep)}${P.$fc.sep}`,S={original:b,normalized:I});let k=h;return M.$i&&(k=(0,L.$Uf)(k)),(m===3?k.startsWith(I):(0,$.$6e)(k,I))?`~/${k.substr(I.length)}`:h}e.$zv=a;function v(h,b){return h.replace(/^~($|\/|\\)/,`${b}$1`)}e.$Av=v;const p="\u2026",f="\\\\",t="~";function i(h,b=P.sep){const m=new Array(h.length);let I=!1;for(let k=0;k<h.length;k++){const d=h[k];if(d===""){m[k]=`.${b}`;continue}if(!d){m[k]=d;continue}I=!0;let w="",y=d;y.indexOf(f)===0?(w=y.substr(0,y.indexOf(f)+f.length),y=y.substr(y.indexOf(f)+f.length)):y.indexOf(b)===0?(w=y.substr(0,y.indexOf(b)+b.length),y=y.substr(y.indexOf(b)+b.length)):y.indexOf(t)===0&&(w=y.substr(0,y.indexOf(t)+t.length),y=y.substr(y.indexOf(t)+t.length));const C=y.split(b);for(let W=1;I&&W<=C.length;W++)for(let H=C.length-W;I&&H>=0;H--){I=!1;let U=C.slice(H,H+W).join(b);for(let z=0;!I&&z<h.length;z++)if(z!==k&&h[z]&&h[z].indexOf(U)>-1){const F=H+W===C.length,N=H>0&&h[z].indexOf(b)>-1?b+U:U,x=h[z].endsWith(N);I=!F||x}if(!I){let z="";(C[0].endsWith(":")||w!=="")&&(H===1&&(H=0,W++,U=C[0]+b+U),H>0&&(z=C[0]+b),z=w+z),H>0&&(z=z+p+b),z=z+U,H+W<C.length&&(z=z+b+p),m[k]=z}}I&&(m[k]=d)}return m}e.$Bv=i;var n;(function(h){h[h.TEXT=0]="TEXT",h[h.VARIABLE=1]="VARIABLE",h[h.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function u(h,b=Object.create(null)){const m=[];let I=!1,k="";for(const d of h)if(d==="$"||I&&d==="{")k&&m.push({value:k,type:n.TEXT}),k="",I=!0;else if(d==="}"&&I){const w=b[k];if(typeof w=="string")w.length&&m.push({value:w,type:n.VARIABLE});else if(w){const y=m[m.length-1];(!y||y.type!==n.SEPARATOR)&&m.push({value:w.label,type:n.SEPARATOR})}k="",I=!1}else k+=d;return k&&!I&&m.push({value:k,type:n.TEXT}),m.filter((d,w)=>{if(d.type===n.SEPARATOR){const y=m[w-1],C=m[w+1];return[y,C].every(W=>W&&(W.type===n.VARIABLE||W.type===n.TEXT)&&W.value.length>0)}return!0}).map(d=>d.value).join("")}e.$Cv=u;function o(h,b){return M.$j||b?h.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):h.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$Dv=o;function l(h,b){return M.$j||b?h.replace(/\(&&\w\)|&&/g,""):M.$i?h.replace(/&&|&/g,m=>m==="&"?"&&":"&"):h.replace(/&&/g,"_")}e.$Ev=l;function r(h){return h.replace(/&/g,"&&")}e.$Fv=r;function s(h){if(h.endsWith("]")){const b=h.lastIndexOf(" [",h.length-2);if(b!==-1){const m=c(h.substring(0,b));return{name:m.name,parentPath:m.parentPath+h.substring(b)}}}return c(h)}e.$Gv=s;function c(h){const b=h.indexOf("/")!==-1?P.$fc:P.$ec,m=b.basename(h),I=b.dirname(h);return m.length?{name:m,parentPath:I}:{name:I,parentPath:""}}}),define(Pe[139],Ae([1,0,24,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=void 0;function P(S){return S.toJSON()}class M{constructor(a){this.a=a}transformIncoming(a){const v=this.a.transformIncoming(a);return v===a?a:P(L.URI.from(v))}transformOutgoing(a){const v=this.a.transformOutgoing(a);return v===a?a:P(L.URI.from(v))}transformOutgoingURI(a){const v=this.a.transformOutgoing(a);return v===a?a:L.URI.from(v)}transformOutgoingScheme(a){return this.a.transformOutgoingScheme(a)}}e.$Qm=M,e.$Rm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function R(S,a,v){if(!S||v>200)return null;if(typeof S=="object"){if(S instanceof L.URI)return a.transformOutgoing(S);for(const p in S)if(Object.hasOwnProperty.call(S,p)){const f=R(S[p],a,v+1);f!==null&&(S[p]=f)}}return null}function $(S,a){const v=R(S,a,0);return v===null?S:v}e.$Sm=$;function D(S,a,v,p){if(!S||p>200)return null;if(typeof S=="object"){if(S.$mid===1)return v?L.URI.revive(a.transformIncoming(S)):a.transformIncoming(S);if(S instanceof E.$ee)return null;for(const f in S)if(Object.hasOwnProperty.call(S,f)){const t=D(S[f],a,v,p+1);t!==null&&(S[f]=t)}}return null}function g(S,a){const v=D(S,a,!1,0);return v===null?S:v}e.$Tm=g;function A(S,a){const v=D(S,a,!0,0);return v===null?S:v}e.$Um=A}),define(Pe[140],Ae([1,0,13,21,24]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=void 0;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function D(){return $||($=new TextDecoder("UTF-16BE")),$}let g;function A(){return g||(g=L.$D()?R():D()),g}e.$Rs=A;function S(p,f,t){const i=new Uint16Array(p.buffer,f,t);return t>0&&(i[0]===65279||i[0]===65534)?a(p,f,t):R().decode(i)}e.$Ss=S;function a(p,f,t){const i=[];let n=0;for(let u=0;u<t;u++){const o=P.$ge(p,f);f+=2,i[n++]=String.fromCharCode(o)}return i.join("")}class v{constructor(f){this.a=f|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const f=new Uint16Array(this.b.buffer,0,this.d);return A().decode(f)}f(){const f=this.e();this.d=0,this.c===null?this.c=[f]:this.c[this.c.length]=f}appendCharCode(f){const t=this.a-this.d;t<=1&&(t===0||E.$9e(f))&&this.f(),this.b[this.d++]=f}appendASCIICharCode(f){this.d===this.a&&this.f(),this.b[this.d++]=f}appendString(f){const t=f.length;if(this.d+t>=this.a){this.f(),this.c[this.c.length]=f;return}for(let i=0;i<t;i++)this.b[this.d++]=f.charCodeAt(i)}}e.$Ts=v}),define(Pe[141],Ae([1,0,24,140]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;function P(D){return D.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(g,A,S,a){this.oldPosition=g,this.oldText=A,this.newPosition=S,this.newText=a}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(g){return 4+2*g.length}static c(g,A,S){const a=A.length;E.$je(g,a,S),S+=4;for(let v=0;v<a;v++)E.$he(g,A.charCodeAt(v),S),S+=2;return S}static d(g,A){const S=E.$ie(g,A);return A+=4,(0,L.$Ss)(g,A,S)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(g,A){return E.$je(g,this.oldPosition,A),A+=4,E.$je(g,this.newPosition,A),A+=4,A=M.c(g,this.oldText,A),A=M.c(g,this.newText,A),A}static read(g,A,S){const a=E.$ie(g,A);A+=4;const v=E.$ie(g,A);A+=4;const p=M.d(g,A);A+=M.a(p);const f=M.d(g,A);return A+=M.a(f),S.push(new M(a,p,v,f)),A}}e.$Us=M;function R(D,g){return D===null||D.length===0?g:new $(D,g).compress()}e.$Vs=R;class ${constructor(g,A){this.a=g,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let g=0,A=0,S=this.n(g),a=this.l(A);for(;g<this.f||A<this.h;){if(S===null){this.k(a),a=this.l(++A);continue}if(a===null){this.m(S),S=this.n(++g);continue}if(a.oldEnd<=S.newPosition){this.k(a),a=this.l(++A);continue}if(S.newEnd<=a.oldPosition){this.m(S),S=this.n(++g);continue}if(a.oldPosition<S.newPosition){const[i,n]=$.r(a,S.newPosition-a.oldPosition);this.k(i),a=n;continue}if(S.newPosition<a.oldPosition){const[i,n]=$.q(S,a.oldPosition-S.newPosition);this.m(i),S=n;continue}let f,t;if(a.oldEnd===S.newEnd)f=S,t=a,S=this.n(++g),a=this.l(++A);else if(a.oldEnd<S.newEnd){const[i,n]=$.q(S,a.oldLength);f=i,t=a,S=n,a=this.l(++A)}else{const[i,n]=$.r(a,S.newLength);f=S,t=i,S=this.n(++g),a=n}this.d[this.e++]=new M(f.oldPosition,f.oldText,t.newPosition,t.newText),this.g+=f.newLength-f.oldLength,this.j+=t.newLength-t.oldLength}const v=$.s(this.d);return $.t(v)}k(g){this.d[this.e++]=$.o(this.g,g),this.j+=g.newLength-g.oldLength}l(g){return g<this.h?this.c[g]:null}m(g){this.d[this.e++]=$.p(this.j,g),this.g+=g.newLength-g.oldLength}n(g){return g<this.f?this.a[g]:null}static o(g,A){return new M(A.oldPosition-g,A.oldText,A.newPosition,A.newText)}static p(g,A){return new M(A.oldPosition,A.oldText,A.newPosition+g,A.newText)}static q(g,A){const S=g.newText.substr(0,A),a=g.newText.substr(A);return[new M(g.oldPosition,g.oldText,g.newPosition,S),new M(g.oldEnd,"",g.newPosition+A,a)]}static r(g,A){const S=g.oldText.substr(0,A),a=g.oldText.substr(A);return[new M(g.oldPosition,S,g.newPosition,g.newText),new M(g.oldPosition+A,a,g.newEnd,"")]}static s(g){if(g.length===0)return g;const A=[];let S=0,a=g[0];for(let v=1;v<g.length;v++){const p=g[v];a.oldEnd===p.oldPosition?a=new M(a.oldPosition,a.oldText+p.oldText,a.newPosition,a.newText+p.newText):(A[S++]=a,a=p)}return A[S++]=a,A}static t(g){if(g.length===0)return g;const A=[];let S=0;for(let a=0;a<g.length;a++){const v=g[a];v.oldText!==v.newText&&(A[S++]=v)}return A}}}),define(Pe[142],Ae([1,0,33,19]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=void 0;function P(M,R,$,D,g,A){if(Array.isArray(M)){let S=0;for(const a of M){const v=P(a,R,$,D,g,A);if(v===10)return v;v>S&&(S=v)}return S}else{if(typeof M=="string")return D?M==="*"?5:M===$?10:0:0;if(M){const{language:S,pattern:a,scheme:v,hasAccessToAllModels:p,notebookType:f}=M;if(!D&&!p)return 0;f&&g&&(R=g);let t=0;if(v)if(v===R.scheme)t=10;else if(v==="*")t=5;else return 0;if(S)if(S===$)t=10;else if(S==="*")t=Math.max(t,5);else return 0;if(f)if(f===A)t=10;else if(f==="*"&&A!==void 0)t=Math.max(t,5);else return 0;if(a){let i;if(typeof a=="string"?i=a:i={...a,base:(0,L.$gc)(a.base)},i===R.fsPath||(0,E.$Aj)(i,R.fsPath))t=10;else return 0}return t}else return 0}}e.$KE=P}),define(Pe[143],Ae([1,0,5,13,29,92,91,127,141,6]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=void 0;class A extends g.$Rc{constructor(a,v,p,f,t,i,n){super(),this.m=this.B(new E.$Qd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!i,this.g=f,this.h=t,this.c=new R.$KB(a,p,n)}equals(a){return!(a instanceof A)||this.f!==a.f||this.getEOL()!==a.getEOL()?!1:this.c.equal(a.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(a){return this.c.createSnapshot(a?this.f:"")}getOffsetAt(a,v){return this.c.getOffsetAt(a,v)}getPositionAt(a){return this.c.getPositionAt(a)}getRangeAt(a,v){const p=a+v,f=this.getPositionAt(a),t=this.getPositionAt(p);return new P.$zs(f.lineNumber,f.column,t.lineNumber,t.column)}getValueInRange(a,v=0){if(a.isEmpty())return"";const p=this.n(v);return this.c.getValueInRange(a,p)}getValueLengthInRange(a,v=0){if(a.isEmpty())return 0;if(a.startLineNumber===a.endLineNumber)return a.endColumn-a.startColumn;const p=this.getOffsetAt(a.startLineNumber,a.startColumn),f=this.getOffsetAt(a.endLineNumber,a.endColumn);let t=0;const i=this.n(v),n=this.getEOL();if(i.length!==n.length){const u=i.length-n.length,o=a.endLineNumber-a.startLineNumber;t=u*o}return f-p+t}getCharacterCountInRange(a,v=0){if(this.j){let p=0;const f=a.startLineNumber,t=a.endLineNumber;for(let i=f;i<=t;i++){const n=this.getLineContent(i),u=i===f?a.startColumn-1:0,o=i===t?a.endColumn-1:n.length;for(let l=u;l<o;l++)L.$9e(n.charCodeAt(l))?(p=p+1,l=l+1):p=p+1}return p+=this.n(v).length*(t-f),p}return this.getValueLengthInRange(a,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(a){return this.c.getLineContent(a)}getLineCharCode(a,v){return this.c.getLineCharCode(a,v)}getCharCode(a){return this.c.getCharCode(a)}getLineLength(a){return this.c.getLineLength(a)}getLineMinColumn(a){return 1}getLineMaxColumn(a){return this.getLineLength(a)+1}getLineFirstNonWhitespaceColumn(a){const v=L.$Te(this.getLineContent(a));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(a){const v=L.$Ve(this.getLineContent(a));return v===-1?0:v+2}n(a){switch(a){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(a){this.c.setEOL(a)}applyEdits(a,v,p){let f=this.g,t=this.h,i=this.j,n=!0,u=[];for(let b=0;b<a.length;b++){const m=a[b];n&&m._isTracked&&(n=!1);const I=m.range;if(m.text){let C=!0;i||(C=!L.$hf(m.text),i=C),!f&&C&&(f=L.$gf(m.text)),!t&&C&&(t=L.$jf(m.text))}let k="",d=0,w=0,y=0;if(m.text){let C;[d,w,y,C]=(0,$.$_s)(m.text);const W=this.getEOL();C===0||C===(W===`\r
`?2:1)?k=m.text:k=m.text.replace(/\r\n|\r|\n/g,W)}u[b]={sortIndex:b,identifier:m.identifier||null,range:I,rangeOffset:this.getOffsetAt(I.startLineNumber,I.startColumn),rangeLength:this.getValueLengthInRange(I),text:k,eolCount:d,firstLineLength:w,lastLineLength:y,forceMoveMarkers:!!m.forceMoveMarkers,isAutoWhitespaceEdit:m.isAutoWhitespaceEdit||!1}}u.sort(A.u);let o=!1;for(let b=0,m=u.length-1;b<m;b++){const I=u[b].range.getEndPosition(),k=u[b+1].range.getStartPosition();if(k.isBeforeOrEqual(I)){if(k.isBefore(I))throw new Error("Overlapping ranges are not allowed!");o=!0}}n&&(u=this.s(u));const l=p||v?A._getInverseEditRanges(u):[],r=[];if(v)for(let b=0;b<u.length;b++){const m=u[b],I=l[b];if(m.isAutoWhitespaceEdit&&m.range.isEmpty())for(let k=I.startLineNumber;k<=I.endLineNumber;k++){let d="";k===I.startLineNumber&&(d=this.getLineContent(m.range.startLineNumber),L.$Te(d)!==-1)||r.push({lineNumber:k,oldContent:d})}}let s=null;if(p){let b=0;s=[];for(let m=0;m<u.length;m++){const I=u[m],k=l[m],d=this.getValueInRange(I.range),w=I.rangeOffset+b;b+=I.text.length-d.length,s[m]={sortIndex:I.sortIndex,identifier:I.identifier,range:k,text:d,textChange:new D.$Us(I.rangeOffset,d,w,I.text)}}o||s.sort((m,I)=>m.sortIndex-I.sortIndex)}this.g=f,this.h=t,this.j=i;const c=this.t(u);let h=null;if(v&&r.length>0){r.sort((b,m)=>m.lineNumber-b.lineNumber),h=[];for(let b=0,m=r.length;b<m;b++){const I=r[b].lineNumber;if(b>0&&r[b-1].lineNumber===I)continue;const k=r[b].oldContent,d=this.getLineContent(I);d.length===0||d===k||L.$Te(d)!==-1||h.push(I)}}return this.m.fire(),new M.$Uu(s,c,h)}s(a){return a.length<1e3?a:[this._toSingleEditOperation(a)]}_toSingleEditOperation(a){let v=!1;const p=a[0].range,f=a[a.length-1].range,t=new P.$zs(p.startLineNumber,p.startColumn,f.endLineNumber,f.endColumn);let i=p.startLineNumber,n=p.startColumn;const u=[];for(let c=0,h=a.length;c<h;c++){const b=a[c],m=b.range;v=v||b.forceMoveMarkers,u.push(this.getValueInRange(new P.$zs(i,n,m.startLineNumber,m.startColumn))),b.text.length>0&&u.push(b.text),i=m.endLineNumber,n=m.endColumn}const o=u.join(""),[l,r,s]=(0,$.$_s)(o);return{sortIndex:0,identifier:a[0].identifier,range:t,rangeOffset:this.getOffsetAt(t.startLineNumber,t.startColumn),rangeLength:this.getValueLengthInRange(t,0),text:o,eolCount:l,firstLineLength:r,lastLineLength:s,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(a){a.sort(A.w);const v=[];for(let p=0;p<a.length;p++){const f=a[p],t=f.range.startLineNumber,i=f.range.startColumn,n=f.range.endLineNumber,u=f.range.endColumn;if(t===n&&i===u&&f.text.length===0)continue;f.text?(this.c.delete(f.rangeOffset,f.rangeLength),this.c.insert(f.rangeOffset,f.text,!0)):this.c.delete(f.rangeOffset,f.rangeLength);const o=new P.$zs(t,i,n,u);v.push({range:o,rangeLength:f.rangeLength,text:f.text,rangeOffset:f.rangeOffset,forceMoveMarkers:f.forceMoveMarkers})}return v}findMatchesLineByLine(a,v,p,f){return this.c.findMatchesLineByLine(a,v,p,f)}getPieceTree(){return this.c}static _getInverseEditRange(a,v){const p=a.startLineNumber,f=a.startColumn,[t,i,n]=(0,$.$_s)(v);let u;if(v.length>0){const o=t+1;o===1?u=new P.$zs(p,f,p,f+i):u=new P.$zs(p,f,p+o-1,n+1)}else u=new P.$zs(p,f,p,f);return u}static _getInverseEditRanges(a){const v=[];let p=0,f=0,t=null;for(let i=0,n=a.length;i<n;i++){const u=a[i];let o,l;t?t.range.endLineNumber===u.range.startLineNumber?(o=p,l=f+(u.range.startColumn-t.range.endColumn)):(o=p+(u.range.startLineNumber-t.range.endLineNumber),l=u.range.startColumn):(o=u.range.startLineNumber,l=u.range.startColumn);let r;if(u.text.length>0){const s=u.eolCount+1;s===1?r=new P.$zs(o,l,o,l+u.firstLineLength):r=new P.$zs(o,l,o+s-1,u.lastLineLength+1)}else r=new P.$zs(o,l,o,l);p=r.endLineNumber,f=r.endColumn,v.push(r),t=u}return v}static u(a,v){const p=P.$zs.compareRangesUsingEnds(a.range,v.range);return p===0?a.sortIndex-v.sortIndex:p}static w(a,v){const p=P.$zs.compareRangesUsingEnds(a.range,v.range);return p===0?v.sortIndex-a.sortIndex:-p}}e.$LB=A}),define(Pe[144],Ae([1,0,13,91,143]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class M{constructor(D,g,A,S,a,v,p,f,t){this.a=D,this.b=g,this.c=A,this.d=S,this.e=a,this.f=v,this.g=p,this.h=f,this.j=t}k(D){const g=this.c+this.d+this.e,A=this.c+this.e;return g===0?D===1?`
`:`\r
`:A>g/2?`\r
`:`
`}create(D){const g=this.k(D),A=this.a;if(this.j&&(g===`\r
`&&(this.c>0||this.d>0)||g===`
`&&(this.c>0||this.e>0)))for(let a=0,v=A.length;a<v;a++){const p=A[a].buffer.replace(/\r\n|\r|\n/g,g),f=(0,L.$GB)(p);A[a]=new L.$JB(p,f)}const S=new P.$LB(A,this.b,g,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(D){return this.a[0].buffer.substr(0,D).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(D){if(D.length===0)return;this.a.length===0&&E.$pf(D)&&(this.b=E.$of,D=D.substr(1));const g=D.charCodeAt(D.length-1);g===13||g>=55296&&g<=56319?(this.m(D.substr(0,D.length-1),!1),this.c=!0,this.d=g):(this.m(D,!1),this.c=!1,this.d=g)}m(D,g){!g&&D.length===0||(this.c?this.n(String.fromCharCode(this.d)+D):this.n(D))}n(D){const g=(0,L.$HB)(this.e,D);this.a.push(new L.$JB(D,g.lineStarts)),this.f+=g.cr,this.g+=g.lf,this.h+=g.crlf,g.isBasicASCII||(this.l=!1,this.j||(this.j=E.$gf(D)),this.k||(this.k=E.$jf(D)))}finish(D=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,D)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const D=this.a[this.a.length-1];D.buffer+=String.fromCharCode(this.d);const g=(0,L.$GB)(D.buffer);D.lineStarts=g,this.d===13&&this.f++}}}e.$MB=R}),define(Pe[95],Ae([1,0,24,21]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$=e.$E$=void 0;var P;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(P||(P={}));function M(S){for(let a=0,v=S.length;a<v;a+=4){const p=S[a+0],f=S[a+1],t=S[a+2],i=S[a+3];S[a+0]=i,S[a+1]=t,S[a+2]=f,S[a+3]=p}}function R(S){const a=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return L.$D()||M(a),E.$ee.wrap(a)}function $(S){const a=S.buffer;if(L.$D()||M(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const v=new Uint8Array(a.byteLength);return v.set(a),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function D(S){const a=new Uint32Array(g(S));let v=0;if(a[v++]=S.id,S.type==="full")a[v++]=1,a[v++]=S.data.length,a.set(S.data,v),v+=S.data.length;else{a[v++]=2,a[v++]=S.deltas.length;for(const p of S.deltas)a[v++]=p.start,a[v++]=p.deleteCount,p.data?(a[v++]=p.data.length,a.set(p.data,v),v+=p.data.length):a[v++]=0}return R(a)}e.$E$=D;function g(S){let a=0;if(a+=1+1,S.type==="full")a+=1+S.data.length;else{a+=1,a+=(1+1+1)*S.deltas.length;for(const v of S.deltas)v.data&&(a+=v.data.length)}return a}function A(S){const a=$(S);let v=0;const p=a[v++];if(a[v++]===1){const n=a[v++],u=a.subarray(v,v+n);return v+=n,{id:p,type:"full",data:u}}const t=a[v++],i=[];for(let n=0;n<t;n++){const u=a[v++],o=a[v++],l=a[v++];let r;l>0&&(r=a.subarray(v,v+l),v+=l),i[n]={start:u,deleteCount:o,data:r}}return{id:p,type:"delta",deltas:i}}e.$F$=A}),define(Pe[145],Ae([9,10]),function(ve,e){return ve.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Ae([1,0,18,26,21,128,147,145]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=g;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class S{constructor(Z,ye,je,Ne){this.id=Z,this.name=ye,this.defaultValue=je,this.schema=Ne}applyUpdate(Z,ye){return v(Z,ye)}compute(Z,ye,je){return je}}class a{constructor(Z,ye){this.newValue=Z,this.didChange=ye}}e.ApplyUpdateResult=a;function v(Y,Z){if(typeof Y!="object"||typeof Z!="object"||!Y||!Z)return new a(Z,Y!==Z);if(Array.isArray(Y)||Array.isArray(Z)){const je=Array.isArray(Y)&&Array.isArray(Z)&&E.$tb(Y,Z);return new a(Z,!je)}let ye=!1;for(const je in Z)if(Z.hasOwnProperty(je)){const Ne=v(Y[je],Z[je]);Ne.didChange&&(Y[je]=Ne.newValue,ye=!0)}return new a(Y,ye)}class p{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,ye){return v(Z,ye)}validate(Z){return this.defaultValue}}class f{constructor(Z,ye,je,Ne){this.id=Z,this.name=ye,this.defaultValue=je,this.schema=Ne}applyUpdate(Z,ye){return v(Z,ye)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,ye,je){return je}}function t(Y,Z){return typeof Y>"u"?Z:Y==="false"?!1:!!Y}e.boolean=t;class i extends f{constructor(Z,ye,je,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=je),super(Z,ye,je,Ne)}validate(Z){return t(Z,this.defaultValue)}}function n(Y,Z,ye,je){if(typeof Y>"u")return Z;let Ne=parseInt(Y,10);return isNaN(Ne)?Z:(Ne=Math.max(ye,Ne),Ne=Math.min(je,Ne),Ne|0)}e.clampedInt=n;class u extends f{static clampedInt(Z,ye,je,Ne){return n(Z,ye,je,Ne)}constructor(Z,ye,je,Ne,Ze,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=je,nt.minimum=Ne,nt.maximum=Ze),super(Z,ye,je,nt),this.minimum=Ne,this.maximum=Ze}validate(Z){return u.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function o(Y,Z,ye,je){if(typeof Y>"u")return Z;const Ne=l.float(Y,Z);return l.clamp(Ne,ye,je)}e.clampedFloat=o;class l extends f{static clamp(Z,ye,je){return Z<ye?ye:Z>je?je:Z}static float(Z,ye){if(typeof Z=="number")return Z;if(typeof Z>"u")return ye;const je=parseFloat(Z);return isNaN(je)?ye:je}constructor(Z,ye,je,Ne,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=je),super(Z,ye,je,Ze),this.validationFn=Ne}validate(Z){return this.validationFn(l.float(Z,this.defaultValue))}}class r extends f{static string(Z,ye){return typeof Z!="string"?ye:Z}constructor(Z,ye,je,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=je),super(Z,ye,je,Ne)}validate(Z){return r.string(Z,this.defaultValue)}}function s(Y,Z,ye,je){return typeof Y!="string"?Z:je&&Y in je?je[Y]:ye.indexOf(Y)===-1?Z:Y}e.stringSet=s;class c extends f{constructor(Z,ye,je,Ne,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ne,Ze.default=je),super(Z,ye,je,Ze),this.c=Ne}validate(Z){return s(Z,this.defaultValue,this.c)}}class h extends S{constructor(Z,ye,je,Ne,Ze,nt,$t=void 0){typeof $t<"u"&&($t.type="string",$t.enum=Ze,$t.default=Ne),super(Z,ye,je,$t),this.c=Ze,this.d=nt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function b(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ye,je){return je===0?Z.accessibilitySupport:je}}class I extends S{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{insertSpace:t(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function d(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function y(Y){switch(Y){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function C(Y){switch(Y){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class W extends p{constructor(){super(141)}compute(Z,ye,je){const Ne=["monaco-editor"];return ye.get(39)&&Ne.push(ye.get(39)),Z.extraEditorClassName&&Ne.push(Z.extraEditorClassName),ye.get(73)==="default"?Ne.push("mouse-default"):ye.get(73)==="copy"&&Ne.push("mouse-copy"),ye.get(111)&&Ne.push("showUnused"),ye.get(139)&&Ne.push("showDeprecated"),Ne.join(" ")}}class H extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Z,ye,je){return je&&Z.emptySelectionClipboard}}class U extends S{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:$.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:$.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{cursorMoveOnType:t(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":s(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":s(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ye.loop,this.defaultValue.loop)}}}class z extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?z.OFF:Z==="true"?z.ON:Z:Z?z.ON:z.OFF}}e.EditorFontLigatures=z;class F extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?F.OFF:Z==="true"?F.TRANSLATE:Z:Z?F.TRANSLATE:F.OFF}compute(Z,ye,je){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=F;class N extends p{constructor(){super(50)}compute(Z,ye,je){return Z.fontInfo}}class x extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Z){const ye=l.float(Z,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(ye,6,100)}compute(Z,ye,je){return Z.fontInfo.fontSize}}class J extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:J.d,maximum:J.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:J.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(u.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,J.d,J.e))}}class Ee extends S{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...ye},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...ye},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:je,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:je,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:je,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:je,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:je,description:$.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{multiple:s(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??s(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??s(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??s(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??s(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??s(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends S{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:$.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:t(ye.enabled,this.defaultValue.enabled),delay:u.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:t(ye.sticky,this.defaultValue.sticky),hidingDelay:u.clampedInt(ye.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(ye.above,this.defaultValue.above)}}}var Ce;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(Ce||(e.RenderMinimap=Ce={}));class fe extends p{constructor(){super(144)}compute(Z,ye,je){return fe.computeLayout(ye,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const ye=Z.height/Z.lineHeight,je=Math.floor(Z.paddingTop/Z.lineHeight);let Ne=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Ne=Math.max(Ne,ye-1));const Ze=(je+Z.viewLineCount+Ne)/(Z.pixelRatio*Z.height),nt=Math.floor(Z.viewLineCount/Ze);return{typicalViewportLineCount:ye,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Ne,desiredRatio:Ze,minimapLineCount:nt}}static c(Z,ye){const je=Z.outerWidth,Ne=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const nt=ye.stableMinimapLayoutInput,$t=nt&&Z.outerHeight===nt.outerHeight&&Z.lineHeight===nt.lineHeight&&Z.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===nt.pixelRatio&&Z.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Z.paddingTop===nt.paddingTop&&Z.paddingBottom===nt.paddingBottom&&Z.minimap.enabled===nt.minimap.enabled&&Z.minimap.side===nt.minimap.side&&Z.minimap.size===nt.minimap.size&&Z.minimap.showSlider===nt.minimap.showSlider&&Z.minimap.renderCharacters===nt.minimap.renderCharacters&&Z.minimap.maxColumn===nt.minimap.maxColumn&&Z.minimap.scale===nt.minimap.scale&&Z.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Z.isViewportWrapping===nt.isViewportWrapping,bt=Z.lineHeight,Pt=Z.typicalHalfwidthCharacterWidth,Kt=Z.scrollBeyondLastLine,Ht=Z.minimap.renderCharacters;let vt=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Ut=Z.minimap.maxColumn,Ot=Z.minimap.size,Gt=Z.minimap.side,Bt=Z.verticalScrollbarWidth,kt=Z.viewLineCount,Ft=Z.remainingWidth,jt=Z.isViewportWrapping,Qt=Ht?2:3;let Wt=Math.floor(Ze*Ne);const Vt=Wt/Ze;let Nt=!1,at=!1,dt=Qt*vt,At=vt/Ze,qt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Se,extraLinesBeyondLastLine:Le,desiredRatio:$e,minimapLineCount:K}=fe.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:Kt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Ne,lineHeight:bt,pixelRatio:Ze});if(kt/K>1)Nt=!0,at=!0,vt=1,dt=1,At=vt/Ze;else{let Ue=!1,Qe=vt+1;if(Ot==="fit"){const qe=Math.ceil((Se+kt+Le)*dt);jt&&$t&&Ft<=ye.stableFitRemainingWidth?(Ue=!0,Qe=ye.stableFitMaxMinimapScale):Ue=qe>Wt}if(Ot==="fill"||Ue){Nt=!0;const qe=vt;dt=Math.min(bt*Ze,Math.max(1,Math.floor(1/$e))),jt&&$t&&Ft<=ye.stableFitRemainingWidth&&(Qe=ye.stableFitMaxMinimapScale),vt=Math.min(Qe,Math.max(1,Math.floor(dt/Qt))),vt>qe&&(qt=Math.min(2,vt/qe)),At=vt/Ze/qt,Wt=Math.ceil(Math.max(Jt,Se+kt+Le)*dt),jt?(ye.stableMinimapLayoutInput=Z,ye.stableFitRemainingWidth=Ft,ye.stableFitMaxMinimapScale=vt):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const Rt=Math.floor(Ut*At),ot=Math.min(Rt,Math.max(0,Math.floor((Ft-Bt-2)*At/(Pt+At)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Ze*ot);const Tt=wt/Ze;wt=Math.floor(wt*qt);const Ct=Ht?1:2,We=Gt==="left"?0:je-ot-Bt;return{renderMinimap:Ct,minimapLeft:We,minimapWidth:ot,minimapHeightIsEditorHeight:Nt,minimapIsSampling:at,minimapScale:vt,minimapLineHeight:dt,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Tt,minimapCanvasOuterHeight:Vt}}static computeLayout(Z,ye){const je=ye.outerWidth|0,Ne=ye.outerHeight|0,Ze=ye.lineHeight|0,nt=ye.lineNumbersDigitCount|0,$t=ye.typicalHalfwidthCharacterWidth,bt=ye.maxDigitWidth,Pt=ye.pixelRatio,Kt=ye.viewLineCount,Ht=Z.get(136),vt=Ht==="inherit"?Z.get(135):Ht,Ut=vt==="inherit"?Z.get(131):vt,Ot=Z.get(134),Gt=ye.isDominatedByLongLines,Bt=Z.get(57),kt=Z.get(67).renderType!==0,Ft=Z.get(68),jt=Z.get(105),Qt=Z.get(84),Wt=Z.get(72),Vt=Z.get(103),Nt=Vt.verticalScrollbarSize,at=Vt.verticalHasArrows,dt=Vt.arrowSize,At=Vt.horizontalScrollbarSize,qt=Z.get(43),Rt=Z.get(110)!=="never";let ot=Z.get(65);qt&&Rt&&(ot+=16);let wt=0;if(kt){const Et=Math.max(nt,Ft);wt=Math.round(Et*bt)}let Tt=0;Bt&&(Tt=Ze*ye.glyphMarginDecorationLaneCount);let Ct=0,We=Ct+Tt,Jt=We+wt,Se=Jt+ot;const Le=je-Tt-wt-ot;let $e=!1,K=!1,Me=-1;vt==="inherit"&&Gt?($e=!0,K=!0):Ut==="on"||Ut==="bounded"?K=!0:Ut==="wordWrapColumn"&&(Me=Ot);const Ue=fe.c({outerWidth:je,outerHeight:Ne,lineHeight:Ze,typicalHalfwidthCharacterWidth:$t,pixelRatio:Pt,scrollBeyondLastLine:jt,paddingTop:Qt.top,paddingBottom:Qt.bottom,minimap:Wt,verticalScrollbarWidth:Nt,viewLineCount:Kt,remainingWidth:Le,isViewportWrapping:K},ye.memory||new A);Ue.renderMinimap!==0&&Ue.minimapLeft===0&&(Ct+=Ue.minimapWidth,We+=Ue.minimapWidth,Jt+=Ue.minimapWidth,Se+=Ue.minimapWidth);const Qe=Le-Ue.minimapWidth,qe=Math.max(1,Math.floor((Qe-Nt-2)/$t)),et=at?dt:0;return K&&(Me=Math.max(1,qe),Ut==="bounded"&&(Me=Math.min(Me,Ot))),{width:je,height:Ne,glyphMarginLeft:Ct,glyphMarginWidth:Tt,glyphMarginDecorationLaneCount:ye.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:wt,decorationsLeft:Jt,decorationsWidth:ot,contentLeft:Se,contentWidth:Qe,minimap:Ue,viewportColumn:qe,isWordWrapMinified:$e,isViewportWrapping:K,wrappingColumn:Me,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:At,overviewRuler:{top:et,width:Nt,height:Ne-2*et,right:0}}}}e.EditorLayoutInfoComputer=fe;class be extends S{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Z){return s(Z,"simple",["simple","advanced"])}compute(Z,ye,je){return ye.get(2)===2?"advanced":je}}class se extends S{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:$.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:t(Z.enabled,this.defaultValue.enabled)}}}class Re extends S{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:$.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:t(ye.enabled,this.defaultValue.enabled),maxLineCount:u.clampedInt(ye.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(ye.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(ye.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class oe extends S{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:$.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:s(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:u.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(ye.fontFamily,this.defaultValue.fontFamily),padding:t(ye.padding,this.defaultValue.padding)}}}class X extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):u.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,ye,je){return je<0?u.clampedInt(-je*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class j extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>l.clamp(Z,0,150),{markdownDescription:$.localize(63,null)})}compute(Z,ye,je){return Z.fontInfo.lineHeight}}class ne extends S{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:Z.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:$.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:t(ye.enabled,this.defaultValue.enabled),autohide:t(ye.autohide,this.defaultValue.autohide),size:s(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ye.side,this.defaultValue.side,["right","left"]),showSlider:s(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ye.renderCharacters,this.defaultValue.renderCharacters),scale:u.clampedInt(ye.scale,1,1,3),maxColumn:u.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(Y){return Y==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class re extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{top:u.clampedInt(ye.top,0,0,1e3),bottom:u.clampedInt(ye.bottom,0,0,1e3)}}}class he extends S{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:$.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:t(ye.enabled,this.defaultValue.enabled),cycle:t(ye.cycle,this.defaultValue.cycle)}}}class ue extends p{constructor(){super(142)}compute(Z,ye,je){return Z.pixelRatio}}class we extends S{constructor(){const Z={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:Z.strings,description:$.localize(82,null)},comments:{anyOf:ye,default:Z.comments,description:$.localize(83,null)},other:{anyOf:ye,default:Z.other,description:$.localize(84,null)}},default:Z,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Pt=Z?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:ye,comments:je,strings:Ne}=Z,Ze=["on","inline","off"];let nt,$t,bt;return typeof ye=="boolean"?nt=ye?"on":"off":nt=s(ye,this.defaultValue.other,Ze),typeof je=="boolean"?$t=je?"on":"off":$t=s(je,this.defaultValue.comments,Ze),typeof Ne=="boolean"?bt=Ne?"on":"off":bt=s(Ne,this.defaultValue.strings,Ze),{other:nt,comments:$t,strings:bt}}}var ee;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class de extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(Z){let ye=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(ye=4,je=Z):Z==="interval"?ye=3:Z==="relative"?ye=2:Z==="on"?ye=1:ye=0),{renderType:ye,renderFn:je}}}function ie(Y){const Z=Y.get(98);return Z==="editable"?Y.get(91):Z!=="on"}e.filterValidationDecorations=ie;class ce extends S{constructor(){const Z=[],ye={type:"number",description:$.localize(91,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:Z,description:$.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const ye=[];for(const je of Z)if(typeof je=="number")ye.push({column:u.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Ne=je;ye.push({column:u.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ye.sort((je,Ne)=>je.column-Ne.column),ye}return this.defaultValue}}class me extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ie(Y,Z){if(typeof Y!="string")return Z;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends S{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z,je=u.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=u.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:u.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(ye.vertical,this.defaultValue.vertical),horizontal:Ie(ye.horizontal,this.defaultValue.horizontal),useShadows:t(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:u.clampedInt(ye.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:u.clampedInt(ye.verticalSliderSize,Ne,0,1e3),scrollByPage:t(ye.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(ye.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends S{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:$.localize(112,null)}})}applyUpdate(Z,ye){let je=!1;ye.allowedCharacters&&Z&&(L.$dn(Z.allowedCharacters,ye.allowedCharacters)||(Z={...Z,allowedCharacters:ye.allowedCharacters},je=!0)),ye.allowedLocales&&Z&&(L.$dn(Z.allowedLocales,ye.allowedLocales)||(Z={...Z,allowedLocales:ye.allowedLocales},je=!0));const Ne=super.applyUpdate(Z,ye);return je?new a(Ne.newValue,!0):Ne}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{nonBasicASCII:_(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:_(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:_(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,ye){if(typeof Z!="object"||!Z)return ye;const je={};for(const[Ne,Ze]of Object.entries(Z))Ze===!0&&(je[Ne]=!0);return je}}class G extends S{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(114,null),$.localize(115,null)],description:$.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:$.localize(117,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:t(ye.enabled,this.defaultValue.enabled),mode:s(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(ye.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ye.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends S{constructor(){const Z={enabled:M.$9r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$9r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:$.localize(119,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:t(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends S{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],default:Z.bracketPairs,description:$.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:Z.bracketPairsHorizontal,description:$.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:$.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:$.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(130,null),$.localize(131,null),$.localize(132,null)],default:Z.highlightActiveIndentation,description:$.localize(133,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{bracketPairs:_(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:_(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:_(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function _(Y,Z,ye){const je=ye.indexOf(Y);return je===-1?Z:ye[je]}class le extends S{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(134,null),$.localize(135,null)],default:Z.insertMode,description:$.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:$.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:$.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:$.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(140,null),$.localize(141,null),$.localize(142,null),$.localize(143,null)],default:Z.selectionMode,markdownDescription:$.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:$.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:$.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:$.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:$.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:$.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{insertMode:s(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(ye.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ye.showIcons,this.defaultValue.showIcons),showStatusBar:t(ye.showStatusBar,this.defaultValue.showStatusBar),preview:t(ye.preview,this.defaultValue.preview),previewMode:s(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ye.showMethods,this.defaultValue.showMethods),showFunctions:t(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ye.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ye.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ye.showFields,this.defaultValue.showFields),showVariables:t(ye.showVariables,this.defaultValue.showVariables),showClasses:t(ye.showClasses,this.defaultValue.showClasses),showStructs:t(ye.showStructs,this.defaultValue.showStructs),showInterfaces:t(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ye.showModules,this.defaultValue.showModules),showProperties:t(ye.showProperties,this.defaultValue.showProperties),showEvents:t(ye.showEvents,this.defaultValue.showEvents),showOperators:t(ye.showOperators,this.defaultValue.showOperators),showUnits:t(ye.showUnits,this.defaultValue.showUnits),showValues:t(ye.showValues,this.defaultValue.showValues),showConstants:t(ye.showConstants,this.defaultValue.showConstants),showEnums:t(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ye.showKeywords,this.defaultValue.showKeywords),showWords:t(ye.showWords,this.defaultValue.showWords),showColors:t(ye.showColors,this.defaultValue.showColors),showFiles:t(ye.showFiles,this.defaultValue.showFiles),showReferences:t(ye.showReferences,this.defaultValue.showReferences),showFolders:t(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ye.showSnippets,this.defaultValue.showSnippets),showUsers:t(ye.showUsers,this.defaultValue.showUsers),showIssues:t(ye.showIssues,this.defaultValue.showIssues)}}}class Oe extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(183,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class Je extends S{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(184,null),$.localize(185,null),$.localize(186,null),$.localize(187,null)],description:$.localize(188,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,ye,je){return ye.get(2)===2?0:je}}class Ge extends p{constructor(){super(145)}compute(Z,ye,je){const Ne=ye.get(144);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class _e extends S{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(191,null),$.localize(192,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:t(ye.enabled,this.defaultValue.enabled),showDropSelector:s(ye.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ye extends S{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:$.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:t(ye.enabled,this.defaultValue.enabled),showPasteSelector:s(ye.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?it:P.$k?tt:xe,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var ut;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=89]="quickSuggestions",Y[Y.quickSuggestionsDelay=90]="quickSuggestionsDelay",Y[Y.readOnly=91]="readOnly",Y[Y.readOnlyMessage=92]="readOnlyMessage",Y[Y.renameOnType=93]="renameOnType",Y[Y.renderControlCharacters=94]="renderControlCharacters",Y[Y.renderFinalNewline=95]="renderFinalNewline",Y[Y.renderLineHighlight=96]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=98]="renderValidationDecorations",Y[Y.renderWhitespace=99]="renderWhitespace",Y[Y.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Y[Y.roundedSelection=101]="roundedSelection",Y[Y.rulers=102]="rulers",Y[Y.scrollbar=103]="scrollbar",Y[Y.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=105]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=106]="scrollPredominantAxis",Y[Y.selectionClipboard=107]="selectionClipboard",Y[Y.selectionHighlight=108]="selectionHighlight",Y[Y.selectOnLineNumbers=109]="selectOnLineNumbers",Y[Y.showFoldingControls=110]="showFoldingControls",Y[Y.showUnused=111]="showUnused",Y[Y.snippetSuggestions=112]="snippetSuggestions",Y[Y.smartSelect=113]="smartSelect",Y[Y.smoothScrolling=114]="smoothScrolling",Y[Y.stickyScroll=115]="stickyScroll",Y[Y.stickyTabStops=116]="stickyTabStops",Y[Y.stopRenderingLineAfter=117]="stopRenderingLineAfter",Y[Y.suggest=118]="suggest",Y[Y.suggestFontSize=119]="suggestFontSize",Y[Y.suggestLineHeight=120]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Y[Y.suggestSelection=122]="suggestSelection",Y[Y.tabCompletion=123]="tabCompletion",Y[Y.tabIndex=124]="tabIndex",Y[Y.unicodeHighlighting=125]="unicodeHighlighting",Y[Y.unusualLineTerminators=126]="unusualLineTerminators",Y[Y.useShadowDOM=127]="useShadowDOM",Y[Y.useTabStops=128]="useTabStops",Y[Y.wordBreak=129]="wordBreak",Y[Y.wordSeparators=130]="wordSeparators",Y[Y.wordWrap=131]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=134]="wordWrapColumn",Y[Y.wordWrapOverride1=135]="wordWrapOverride1",Y[Y.wordWrapOverride2=136]="wordWrapOverride2",Y[Y.wrappingIndent=137]="wrappingIndent",Y[Y.wrappingStrategy=138]="wrappingStrategy",Y[Y.showDeprecated=139]="showDeprecated",Y[Y.inlayHints=140]="inlayHints",Y[Y.editorClassName=141]="editorClassName",Y[Y.pixelRatio=142]="pixelRatio",Y[Y.tabFocusMode=143]="tabFocusMode",Y[Y.layoutInfo=144]="layoutInfo",Y[Y.wrappingInfo=145]="wrappingInfo",Y[Y.defaultColorDecorators=146]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(ut||(e.EditorOption=ut={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(197,null)})),acceptSuggestionOnEnter:ze(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(198,null),""],markdownDescription:$.localize(199,null)})),accessibilitySupport:ze(new m),accessibilityPageSize:ze(new u(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(200,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",$.localize(201,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:ze(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(203,null),$.localize(204,null),""],description:$.localize(205,null)})),autoClosingComments:ze(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(206,null),$.localize(207,null),""],description:$.localize(208,null)})),autoClosingDelete:ze(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(209,null),""],description:$.localize(210,null)})),autoClosingOvertype:ze(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(211,null),""],description:$.localize(212,null)})),autoClosingQuotes:ze(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(213,null),$.localize(214,null),""],description:$.localize(215,null)})),autoIndent:ze(new h(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null)],description:$.localize(221,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(222,null),$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(116,"stickyTabStops",!1,{description:$.localize(226,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:$.localize(227,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:$.localize(228,null)})),codeLensFontSize:ze(new u(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(229,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:$.localize(230,null)})),colorDecoratorActivatedOn:ze(new c(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(231,null),$.localize(232,null),$.localize(233,null)],description:$.localize(234,null)})),colorDecoratorsLimit:ze(new u(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(235,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:$.localize(236,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(237,null)})),cursorBlinking:ze(new h(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:$.localize(238,null)})),cursorSmoothCaretAnimation:ze(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null)],description:$.localize(242,null)})),cursorStyle:ze(new h(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:$.localize(243,null)})),cursorSurroundingLines:ze(new u(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(244,null)})),cursorSurroundingLinesStyle:ze(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(245,null),$.localize(246,null)],markdownDescription:$.localize(247,null)})),cursorWidth:ze(new u(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(248,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:$.localize(249,null)})),emptySelectionClipboard:ze(new H),dropIntoEditor:ze(new _e),stickyScroll:ze(new Re),experimentalWhitespaceRendering:ze(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(250,null),$.localize(251,null),$.localize(252,null)],description:$.localize(253,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new l(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:$.localize(254,null)})),find:ze(new U),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:$.localize(255,null)})),foldingStrategy:ze(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(256,null),$.localize(257,null)],description:$.localize(258,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:$.localize(259,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:$.localize(260,null)})),foldingMaximumRegions:ze(new u(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(261,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(262,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(263,null)})),fontInfo:ze(new N),fontLigatures2:ze(new z),fontSize:ze(new x),fontWeight:ze(new J),fontVariations:ze(new F),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:$.localize(264,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:$.localize(265,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:$.localize(266,null)})),gotoLocation:ze(new Ee),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:$.localize(267,null)})),hover:ze(new De),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>l.clamp(Y,-5,20),{description:$.localize(268,null)})),lightbulb:ze(new se),lineDecorationsWidth:ze(new X),lineHeight:ze(new j),lineNumbers:ze(new de),lineNumbersMinChars:ze(new u(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:$.localize(269,null)})),links:ze(new i(70,"links",!0,{description:$.localize(270,null)})),matchBrackets:ze(new c(71,"matchBrackets","always",["always","near","never"],{description:$.localize(271,null)})),minimap:ze(new ne),mouseStyle:ze(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new l(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:$.localize(272,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(273,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:$.localize(274,null)})),multiCursorModifier:ze(new h(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[$.localize(275,null),$.localize(276,null)],markdownDescription:$.localize(277,null)})),multiCursorPaste:ze(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(278,null),$.localize(279,null)],markdownDescription:$.localize(280,null)})),multiCursorLimit:ze(new u(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(281,null)})),occurrencesHighlight:ze(new i(81,"occurrencesHighlight",!0,{description:$.localize(282,null)})),multiDocumentOccurrencesHighlight:ze(new i(80,"multiDocumentOccurrencesHighlight",!1,{description:$.localize(283,null)})),overviewRulerBorder:ze(new i(82,"overviewRulerBorder",!0,{description:$.localize(284,null)})),overviewRulerLanes:ze(new u(83,"overviewRulerLanes",3,0,3)),padding:ze(new re),pasteAs:ze(new Ye),parameterHints:ze(new he),peekWidgetDefaultFocus:ze(new c(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(285,null),$.localize(286,null)],description:$.localize(287,null)})),definitionLinkOpensInPeek:ze(new i(88,"definitionLinkOpensInPeek",!1,{description:$.localize(288,null)})),quickSuggestions:ze(new we),quickSuggestionsDelay:ze(new u(90,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(289,null)})),readOnly:ze(new i(91,"readOnly",!1)),readOnlyMessage:ze(new me),renameOnType:ze(new i(93,"renameOnType",!1,{description:$.localize(290,null),markdownDeprecationMessage:$.localize(291,null)})),renderControlCharacters:ze(new i(94,"renderControlCharacters",!0,{description:$.localize(292,null),restricted:!0})),renderFinalNewline:ze(new c(95,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(293,null)})),renderLineHighlight:ze(new c(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(294,null)],description:$.localize(295,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(97,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(296,null)})),renderValidationDecorations:ze(new c(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new c(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(297,null),$.localize(298,null),$.localize(299,null),""],description:$.localize(300,null)})),revealHorizontalRightPadding:ze(new u(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(101,"roundedSelection",!0,{description:$.localize(301,null)})),rulers:ze(new ce),scrollbar:ze(new T),scrollBeyondLastColumn:ze(new u(104,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(302,null)})),scrollBeyondLastLine:ze(new i(105,"scrollBeyondLastLine",!0,{description:$.localize(303,null)})),scrollPredominantAxis:ze(new i(106,"scrollPredominantAxis",!0,{description:$.localize(304,null)})),selectionClipboard:ze(new i(107,"selectionClipboard",!0,{description:$.localize(305,null),included:P.$k})),selectionHighlight:ze(new i(108,"selectionHighlight",!0,{description:$.localize(306,null)})),selectOnLineNumbers:ze(new i(109,"selectOnLineNumbers",!0)),showFoldingControls:ze(new c(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(307,null),$.localize(308,null),$.localize(309,null)],description:$.localize(310,null)})),showUnused:ze(new i(111,"showUnused",!0,{description:$.localize(311,null)})),showDeprecated:ze(new i(139,"showDeprecated",!0,{description:$.localize(312,null)})),inlayHints:ze(new oe),snippetSuggestions:ze(new c(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(313,null),$.localize(314,null),$.localize(315,null),$.localize(316,null)],description:$.localize(317,null)})),smartSelect:ze(new Oe),smoothScrolling:ze(new i(114,"smoothScrolling",!1,{description:$.localize(318,null)})),stopRenderingLineAfter:ze(new u(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new le),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new i(148,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(319,null)})),suggestFontSize:ze(new u(119,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new u(120,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(121,"suggestOnTriggerCharacters",!0,{description:$.localize(322,null)})),suggestSelection:ze(new c(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(323,null),$.localize(324,null),$.localize(325,null)],description:$.localize(326,null)})),tabCompletion:ze(new c(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(327,null),$.localize(328,null),$.localize(329,null)],description:$.localize(330,null)})),tabIndex:ze(new u(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new V),unusualLineTerminators:ze(new c(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(331,null),$.localize(332,null),$.localize(333,null)],description:$.localize(334,null)})),useShadowDOM:ze(new i(127,"useShadowDOM",!0)),useTabStops:ze(new i(128,"useTabStops",!0,{description:$.localize(335,null)})),wordBreak:ze(new c(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(336,null),$.localize(337,null)],description:$.localize(338,null)})),wordSeparators:ze(new r(130,"wordSeparators",R.$0r,{description:$.localize(339,null)})),wordWrap:ze(new c(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(340,null),$.localize(341,null),$.localize(342,null),$.localize(343,null)],description:$.localize(344,null)})),wordWrapBreakAfterCharacters:ze(new r(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new u(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(345,null)})),wordWrapOverride1:ze(new c(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new c(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new i(146,"defaultColorDecorators",!1,{markdownDescription:$.localize(346,null)})),pixelRatio:ze(new ue),tabFocusMode:ze(new i(143,"tabFocusMode",!1,{markdownDescription:$.localize(347,null)})),layoutInfo:ze(new fe),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Je),wrappingStrategy:ze(new be)}}),define(Pe[148],Ae([9,10]),function(ve,e){return ve.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Ae([9,10]),function(ve,e){return ve.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Ae([9,10]),function(ve,e){return ve.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Ae([9,10]),function(ve,e){return ve.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Ae([9,10]),function(ve,e){return ve.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Ae([9,10]),function(ve,e){return ve.create("vs/platform/files/common/files",e)}),define(Pe[154],Ae([9,10]),function(ve,e){return ve.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Ae([9,10]),function(ve,e){return ve.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Ae([9,10]),function(ve,e){return ve.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostChat",e)}),define(Pe[158],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[159],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[160],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[161],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[162],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[163],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[164],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[165],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[166],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[167],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[168],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[169],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[170],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[171],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/common/configuration",e)}),define(Pe[172],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/common/editor",e)}),define(Pe[173],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/common/views",e)}),define(Pe[174],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[175],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[176],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[177],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[178],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[179],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[180],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[181],Ae([9,10]),function(ve,e){return ve.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[182],Ae([1,0,11,150]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.TokenType=void 0;var P;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(P||(e.TokenType=P={}));function M(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const R=(0,L.localize)(3,null),$=(0,L.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const S=this.d,a=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:a};this.g.push({offset:S,lexeme:a,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const S=this.c.substring(this.d,this.e),a=D.b.get(S);a?this.k(a):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,S=!1,a=!1;for(;;){if(A>=this.c.length){this.e=A,this.l($);return}const p=this.c.charCodeAt(A);if(S)S=!1;else if(p===47&&!a){A++;break}else p===91?a=!0:p===92?S=!0:p===93&&(a=!1);A++}for(;A<this.c.length&&D.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Pi=D}),define(Pe[183],Ae([1,0,25,31,152,296]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function D(i){return i=i.trim(),i==="*"||R.test(i)}e.$Qo=D;function g(i){if(!D(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=i.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$Ro=g;function A(i){if(!i)return null;const n=i.majorBase,u=i.majorMustEqual,o=i.minorBase;let l=i.minorMustEqual;const r=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(n===0||(l=!1),s=!1);let c=0;if(i.preRelease){const h=$.exec(i.preRelease);if(h){const[,b,m,I]=h;c=Date.UTC(Number(b),Number(m)-1,Number(I))}}return{majorBase:n,majorMustEqual:u,minorBase:o,minorMustEqual:l,patchBase:r,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:c}}e.$So=A;function S(i,n,u){let o;typeof i=="string"?o=A(g(i)):o=i;let l;n instanceof Date?l=n.getTime():typeof n=="string"&&(l=new Date(n).getTime());let r;if(typeof u=="string"?r=A(g(u)):r=u,!o||!r)return!1;const s=o.majorBase,c=o.minorBase,h=o.patchBase;let b=r.majorBase,m=r.minorBase,I=r.patchBase;const k=r.notBefore;let d=r.majorMustEqual,w=r.minorMustEqual,y=r.patchMustEqual;return r.isMinimum?s>b?!0:s<b?!1:c>m?!0:c<m||l&&l<k?!1:h>=I:(s===1&&b===0&&(!d||!w||!y)&&(b=1,m=0,I=0,d=!0,w=!1,y=!1),s<b?!1:s>b?!d:c<m?!1:c>m?!w:h<I?!1:h>I?!y:!(l&&l<k))}e.$To=S;function a(i,n,u,o,l){const r=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return r.push([L.default.Error,P.localize(0,null)]),r;if(typeof o.name!="string")return r.push([L.default.Error,P.localize(1,null,"name")]),r;if(typeof o.version!="string")return r.push([L.default.Error,P.localize(2,null,"version")]),r;if(!o.engines)return r.push([L.default.Error,P.localize(3,null,"engines")]),r;if(typeof o.engines.vscode!="string")return r.push([L.default.Error,P.localize(4,null,"engines.vscode")]),r;if(typeof o.extensionDependencies<"u"&&!t(o.extensionDependencies))return r.push([L.default.Error,P.localize(5,null,"extensionDependencies")]),r;if(typeof o.activationEvents<"u"){if(!t(o.activationEvents))return r.push([L.default.Error,P.localize(6,null,"activationEvents")]),r;if(typeof o.main>"u"&&typeof o.browser>"u")return r.push([L.default.Error,P.localize(7,null,"activationEvents","main","browser")]),r}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&r.push([L.default.Warning,P.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return r.push([L.default.Error,P.localize(9,null,"main")]),r;{const h=(0,E.$yg)(u,o.main);(0,E.$sg)(h,u)||r.push([L.default.Warning,P.localize(10,null,h.path,u.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return r.push([L.default.Error,P.localize(11,null,"browser")]),r;{const h=(0,E.$yg)(u,o.browser);(0,E.$sg)(h,u)||r.push([L.default.Warning,P.localize(12,null,h.path,u.path)])}}if(!M.valid(o.version))return r.push([L.default.Error,P.localize(13,null)]),r;const s=[];if(!v(i,n,o,l,s))for(const h of s)r.push([L.default.Error,h]);return r}e.$Uo=a;function v(i,n,u,o,l){return o||typeof u.main>"u"&&typeof u.browser>"u"?!0:f(i,n,u.engines.vscode,l)}e.$Vo=v;function p(i,n,u){return i==="*"||f(n,u,i)}e.$Wo=p;function f(i,n,u,o=[]){const l=A(g(u));if(!l)return o.push(P.localize(14,null,u)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return o.push(P.localize(15,null,u)),!1}else if(!l.majorMustEqual)return o.push(P.localize(16,null,u)),!1;return S(i,n,l)?!0:(o.push(P.localize(17,null,i,u)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let n=0,u=i.length;n<u;n++)if(typeof i[n]!="string")return!1;return!0}}),define(Pe[70],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=void 0;class E{constructor(P,M=[],R=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$Rh=E}),define(Pe[71],Ae([1,0,70]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const L=[];var P;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M($,D,g){D instanceof E.$Rh||(D=new E.$Rh(D,[],!!g)),L.push([$,D])}e.$Cr=M;function R(){return L}e.$Dr=R}),define(Pe[184],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;class E{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$gq=E;class L{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const $=this.lookupOrInsertNode(M),D=this.lookupOrInsertNode(R);$.outgoing.set(D.key,D),D.incoming.set($.key,$)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let $=this.a.get(R);return $||($=new E(R,M),this.a.set(R,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,$]of this.a)M.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const $=new Set([M]),D=this.c(R,$);if(D)return D}}c(M,R){for(const[$,D]of M.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const g=this.c(D,R);if(g)return g;R.delete($)}}}e.$hq=L}),define(Pe[4],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(D){return D[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(E||(e._util=E={})),e.$Th=P("instantiationService");function L(R,$,D){$[E.DI_TARGET]===$?$[E.DI_DEPENDENCIES].push({id:R,index:D}):($[E.DI_DEPENDENCIES]=[{id:R,index:D}],$[E.DI_TARGET]=$)}function P(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const $=function(D,g,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L($,D,A)};return $.toString=()=>R,E.serviceIds.set(R,$),$}e.$Uh=P;function M(R){return R}e.$Vh=M}),define(Pe[40],Ae([1,0,16,2,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.ConfigurationTarget=e.$qi=e.$pi=e.$oi=void 0,e.$oi=(0,P.$Uh)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.$pi=M;function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof L.URI)}e.$qi=R;var $;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ri=D;function g(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$si=g;function A(i,n){const u=Object.create(null);for(const o in i)S(u,o,i[o],n);return u}e.$ti=A;function S(i,n,u,o){const l=n.split("."),r=l.pop();let s=i;for(let c=0;c<l.length;c++){const h=l[c];let b=s[h];switch(typeof b){case"undefined":b=s[h]=Object.create(null);break;case"object":break;default:o(`Ignoring ${n} as ${l.slice(0,c+1).join(".")} is ${JSON.stringify(b)}`);return}s=b}if(typeof s=="object"&&s!==null)try{s[r]=u}catch{o(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${n} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.$ui=S;function a(i,n){const u=n.split(".");v(i,u)}e.$vi=a;function v(i,n){const u=n.shift();if(n.length===0){delete i[u];return}if(Object.keys(i).indexOf(u)!==-1){const o=i[u];typeof o=="object"&&!Array.isArray(o)&&(v(o,n),Object.keys(o).length===0&&delete i[u])}}function p(i,n,u){function o(s,c){let h=s;for(const b of c){if(typeof h!="object"||h===null)return;h=h[b]}return h}const l=n.split("."),r=o(i,l);return typeof r>"u"?u:r}e.$wi=p;function f(i,n,u){Object.keys(n).forEach(o=>{o!=="__proto__"&&(o in i?E.$Df(i[o])&&E.$Df(n[o])?f(i[o],n[o],u):u&&(i[o]=n[o]):i[o]=n[o])})}e.$xi=f;function t(i){return i.replace(/[\[\]]/g,"")}e.$yi=t}),define(Pe[34],Ae([1,0,21,13,182,4,149,11]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.ContextKeyExprType=e.$Qi=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",E.$j),D.set("isLinux",E.$k),D.set("isWindows",E.$i),D.set("isWeb",E.$o),D.set("isMacNative",E.$j&&!E.$o),D.set("isEdge",E.$H),D.set("isFirefox",E.$F),D.set("isChrome",E.$E),D.set("isSafari",E.$G);function g(X,j){if(D.get(X)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(X,j)}e.$Qi=g;const A=Object.prototype.hasOwnProperty;var S;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const a={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),p=(0,R.localize)(1,null),f=(0,R.localize)(2,null),t=(0,R.localize)(3,null),i=(0,R.localize)(4,null),n=(0,R.localize)(5,null),u=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=a){this.k=j,this.d=new P.$Pi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const pe=this.D(),re=pe.type===17?n:void 0;throw this.h.push({message:i,offset:pe.offset,lexeme:P.$Pi.getLexeme(pe),additionalInfo:re}),l.c}return ne}catch(ne){if(ne!==l.c)throw ne;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const ne=this.o();j.push(ne)}return j.length===1?j[0]:r.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const ne=this.s();j.push(ne)}return j.length===1?j[0]:r.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,t),ne?.negate()}case 17:return this.z(),C.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const ne=this.l();return this.A(1,t),ne}case 17:{const ne=j.lexeme;if(this.z(),this.y(9)){const re=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),re.type!==10)throw this.B("REGEX",re);const he=re.lexeme,ue=he.lastIndexOf("/"),we=ue===he.length-1?void 0:this.w(he.substring(ue+1));let ee;try{ee=new RegExp(he.substring(1,ue),we)}catch{throw this.B("REGEX",re)}return N.create(ne,ee)}switch(re.type){case 10:case 19:{const he=[re.lexeme];this.z();let ue=this.D(),we=0;for(let me=0;me<re.lexeme.length;me++)re.lexeme.charCodeAt(me)===40?we++:re.lexeme.charCodeAt(me)===41&&we--;for(;!this.E()&&ue.type!==15&&ue.type!==16;){switch(ue.type){case 0:we++;break;case 1:we--;break;case 10:case 18:for(let me=0;me<ue.lexeme.length;me++)ue.lexeme.charCodeAt(me)===40?we++:re.lexeme.charCodeAt(me)===41&&we--}if(we<0)break;he.push(P.$Pi.getLexeme(ue)),this.z(),ue=this.D()}const ee=he.join(""),de=ee.lastIndexOf("/"),ie=de===ee.length-1?void 0:this.w(ee.substring(de+1));let ce;try{ce=new RegExp(ee.substring(1,de),ie)}catch{throw this.B("REGEX",re)}return r.regex(ne,ce)}case 18:{const he=re.lexeme;this.z();let ue=null;if(!(0,L.$Ee)(he)){const we=he.indexOf("/"),ee=he.lastIndexOf("/");if(we!==ee&&we>=0){const de=he.slice(we+1,ee),ie=he[ee+1]==="i"?"i":"";try{ue=new RegExp(de,ie)}catch{throw this.B("REGEX",re)}}}if(ue===null)throw this.B("REGEX",re);return N.create(ne,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const re=this.u();return r.notIn(ne,re)}switch(this.D().type){case 3:{this.z();const re=this.u();if(this.x().type===18)return r.equals(ne,re);switch(re){case"true":return r.has(ne);case"false":return r.not(ne);default:return r.equals(ne,re)}}case 4:{this.z();const re=this.u();if(this.x().type===18)return r.notEquals(ne,re);switch(re){case"true":return r.not(ne);case"false":return r.has(ne);default:return r.notEquals(ne,re)}}case 5:return this.z(),z.create(ne,this.u());case 6:return this.z(),F.create(ne,this.u());case 7:return this.z(),H.create(ne,this.u());case 8:return this.z(),U.create(ne,this.u());case 13:return this.z(),r.in(ne,this.u());default:return r.has(ne)}}case 20:throw this.h.push({message:u,offset:j.offset,lexeme:"",additionalInfo:o}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,ne){if(this.C(j))return this.z();throw this.B(ne,this.D())}B(j,ne,pe){const re=(0,R.localize)(8,null,j,P.$Pi.getLexeme(ne)),he=ne.offset,ue=P.$Pi.getLexeme(ne);return this.h.push({message:re,offset:he,lexeme:ue,additionalInfo:pe}),l.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ri=l;class r{static false(){return b.INSTANCE}static true(){return m.INSTANCE}static has(j){return I.create(j)}static equals(j,ne){return k.create(j,ne)}static notEquals(j,ne){return y.create(j,ne)}static regex(j,ne){return N.create(j,ne)}static in(j,ne){return d.create(j,ne)}static notIn(j,ne){return w.create(j,ne)}static not(j){return C.create(j)}static and(...j){return Ee.create(j,null,!0)}static or(...j){return De.create(j,null,!0)}static greater(j,ne){return H.create(j,ne)}static greaterEquals(j,ne){return U.create(j,ne)}static smaller(j,ne){return z.create(j,ne)}static smallerEquals(j,ne){return F.create(j,ne)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$Si=r;function s(X){const j=new l({regexParsingWithErrorRecovery:!1});return X.map(ne=>(j.parse(ne),j.lexingErrors.length>0?j.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,R.localize)(9,null,pe.additionalInfo):(0,R.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}e.$Ti=s;function c(X,j){const ne=X?X.substituteConstants():void 0,pe=j?j.substituteConstants():void 0;return!ne&&!pe?!0:!ne||!pe?!1:ne.equals(pe)}e.$Ui=c;function h(X,j){return X.cmp(j)}class b{static{this.INSTANCE=new b}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return m.INSTANCE}}e.$Vi=b;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return b.INSTANCE}}e.$Wi=m;class I{static create(j,ne=null){const pe=D.get(j);return typeof pe=="boolean"?pe?m.INSTANCE:b.INSTANCE:new I(j,ne)}constructor(j,ne){this.key=j,this.c=ne,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:fe(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=D.get(this.key);return typeof j=="boolean"?j?m.INSTANCE:b.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Xi=I;class k{static create(j,ne,pe=null){if(typeof ne=="boolean")return ne?I.create(j,pe):C.create(j,pe);const re=D.get(j);return typeof re=="boolean"?ne===(re?"true":"false")?m.INSTANCE:b.INSTANCE:new k(j,ne,pe)}constructor(j,ne,pe){this.c=j,this.d=ne,this.f=pe,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=D.get(this.c);if(typeof j=="boolean"){const ne=j?"true":"false";return this.d===ne?m.INSTANCE:b.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Yi=k;class d{static create(j,ne){return new d(j,ne)}constructor(j,ne){this.d=j,this.f=ne,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:be(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const ne=j.getValue(this.f),pe=j.getValue(this.d);return Array.isArray(ne)?ne.includes(pe):typeof pe=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Zi=d;class w{static create(j,ne){return new w(j,ne)}constructor(j,ne){this.d=j,this.f=ne,this.type=11,this.c=d.create(j,ne)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$1i=w;class y{static create(j,ne,pe=null){if(typeof ne=="boolean")return ne?C.create(j,pe):I.create(j,pe);const re=D.get(j);return typeof re=="boolean"?ne===(re?"true":"false")?b.INSTANCE:m.INSTANCE:new y(j,ne,pe)}constructor(j,ne,pe){this.c=j,this.d=ne,this.f=pe,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=D.get(this.c);if(typeof j=="boolean"){const ne=j?"true":"false";return this.d===ne?b.INSTANCE:m.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$2i=y;class C{static create(j,ne=null){const pe=D.get(j);return typeof pe=="boolean"?pe?b.INSTANCE:m.INSTANCE:new C(j,ne)}constructor(j,ne){this.c=j,this.d=ne,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:fe(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=D.get(this.c);return typeof j=="boolean"?j?b.INSTANCE:m.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$3i=C;function W(X,j){if(typeof X=="string"){const ne=parseFloat(X);isNaN(ne)||(X=ne)}return typeof X=="string"||typeof X=="number"?j(X):b.INSTANCE}class H{static create(j,ne,pe=null){return W(ne,re=>new H(j,re,pe))}constructor(j,ne,pe){this.c=j,this.d=ne,this.f=pe,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$4i=H;class U{static create(j,ne,pe=null){return W(ne,re=>new U(j,re,pe))}constructor(j,ne,pe){this.c=j,this.d=ne,this.f=pe,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$5i=U;class z{static create(j,ne,pe=null){return W(ne,re=>new z(j,re,pe))}constructor(j,ne,pe){this.c=j,this.d=ne,this.f=pe,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$6i=z;class F{static create(j,ne,pe=null){return W(ne,re=>new F(j,re,pe))}constructor(j,ne,pe){this.c=j,this.d=ne,this.f=pe,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:be(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.$7i=F;class N{static create(j,ne){return new N(j,ne)}constructor(j,ne){this.d=j,this.f=ne,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const ne=this.f?this.f.source:"",pe=j.f?j.f.source:"";return ne<pe?-1:ne>pe?1:0}equals(j){if(j.type===this.type){const ne=this.f?this.f.source:"",pe=j.f?j.f.source:"";return this.d===j.d&&ne===pe}return!1}substituteConstants(){return this}evaluate(j){const ne=j.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$8i=N;class x{static create(j){return new x(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new x(this.c.map(j))}negate(){return this.c}}e.$9i=x;function J(X){let j=null;for(let ne=0,pe=X.length;ne<pe;ne++){const re=X[ne].substituteConstants();if(X[ne]!==re&&j===null){j=[];for(let he=0;he<ne;he++)j[he]=X[he]}j!==null&&(j[ne]=re)}return j===null?X:j}class Ee{static create(j,ne,pe){return Ee.d(j,ne,pe)}constructor(j,ne){this.expr=j,this.c=ne,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let ne=0,pe=this.expr.length;ne<pe;ne++){const re=h(this.expr[ne],j.expr[ne]);if(re!==0)return re}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].equals(j.expr[ne]))return!1;return!0}return!1}substituteConstants(){const j=J(this.expr);return j===this.expr?this:Ee.create(j,this.c,!1)}evaluate(j){for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].evaluate(j))return!1;return!0}static d(j,ne,pe){const re=[];let he=!1;for(const ue of j)if(ue){if(ue.type===1){he=!0;continue}if(ue.type===0)return b.INSTANCE;if(ue.type===6){re.push(...ue.expr);continue}re.push(ue)}if(re.length===0&&he)return m.INSTANCE;if(re.length!==0){if(re.length===1)return re[0];re.sort(h);for(let ue=1;ue<re.length;ue++)re[ue-1].equals(re[ue])&&(re.splice(ue,1),ue--);if(re.length===1)return re[0];for(;re.length>1;){const ue=re[re.length-1];if(ue.type!==9)break;re.pop();const we=re.pop(),ee=re.length===0,de=De.create(ue.expr.map(ie=>Ee.create([ie,we],null,pe)),null,ee);de&&(re.push(de),re.sort(h))}if(re.length===1)return re[0];if(pe){for(let ue=0;ue<re.length;ue++)for(let we=ue+1;we<re.length;we++)if(re[ue].negate().equals(re[we]))return b.INSTANCE;if(re.length===1)return re[0]}return new Ee(re,ne)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const ne of this.expr)j.push(...ne.keys());return j}map(j){return new Ee(this.expr.map(ne=>ne.map(j)),null)}negate(){if(!this.c){const j=[];for(const ne of this.expr)j.push(ne.negate());this.c=De.create(j,this,!0)}return this.c}}e.$0i=Ee;class De{static create(j,ne,pe){return De.d(j,ne,pe)}constructor(j,ne){this.expr=j,this.c=ne,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let ne=0,pe=this.expr.length;ne<pe;ne++){const re=h(this.expr[ne],j.expr[ne]);if(re!==0)return re}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].equals(j.expr[ne]))return!1;return!0}return!1}substituteConstants(){const j=J(this.expr);return j===this.expr?this:De.create(j,this.c,!1)}evaluate(j){for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(this.expr[ne].evaluate(j))return!0;return!1}static d(j,ne,pe){let re=[],he=!1;if(j){for(let ue=0,we=j.length;ue<we;ue++){const ee=j[ue];if(ee){if(ee.type===0){he=!0;continue}if(ee.type===1)return m.INSTANCE;if(ee.type===9){re=re.concat(ee.expr);continue}re.push(ee)}}if(re.length===0&&he)return b.INSTANCE;re.sort(h)}if(re.length!==0){if(re.length===1)return re[0];for(let ue=1;ue<re.length;ue++)re[ue-1].equals(re[ue])&&(re.splice(ue,1),ue--);if(re.length===1)return re[0];if(pe){for(let ue=0;ue<re.length;ue++)for(let we=ue+1;we<re.length;we++)if(re[ue].negate().equals(re[we]))return m.INSTANCE;if(re.length===1)return re[0]}return new De(re,ne)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const ne of this.expr)j.push(...ne.keys());return j}map(j){return new De(this.expr.map(ne=>ne.map(j)),null)}negate(){if(!this.c){const j=[];for(const ne of this.expr)j.push(ne.negate());for(;j.length>1;){const ne=j.shift(),pe=j.shift(),re=[];for(const he of oe(ne))for(const ue of oe(pe))re.push(Ee.create([he,ue],null,!1));j.unshift(De.create(re,null,!1))}this.c=De.create(j,this,!0)}return this.c}}e.$$i=De;class Ce extends I{static{this.d=[]}static all(){return Ce.d.values()}constructor(j,ne,pe){super(j,null),this.f=ne,typeof pe=="object"?Ce.d.push({...pe,key:j}):pe!==!0&&Ce.d.push({key:j,description:pe,type:ne!=null?typeof ne:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return k.create(this.key,j)}notEqualsTo(j){return y.create(this.key,j)}}e.$_i=Ce,e.$aj=(0,M.$Uh)("contextKeyService");function fe(X,j){return X<j?-1:X>j?1:0}function be(X,j,ne,pe){return X<ne?-1:X>ne?1:j<pe?-1:j>pe?1:0}function se(X,j){if(X.type===0||j.type===1)return!0;if(X.type===9)return j.type===9?Re(X.expr,j.expr):!1;if(j.type===9){for(const ne of j.expr)if(se(X,ne))return!0;return!1}if(X.type===6){if(j.type===6)return Re(j.expr,X.expr);for(const ne of X.expr)if(se(ne,j))return!0;return!1}return X.equals(j)}e.$bj=se;function Re(X,j){let ne=0,pe=0;for(;ne<X.length&&pe<j.length;){const re=X[ne].cmp(j[pe]);if(re<0)return!1;re===0&&ne++,pe++}return ne===X.length}function oe(X){return X.type===9?X.expr:[X]}}),define(Pe[185],Ae([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=void 0,e.$2h=(0,E.$Uh)("environmentService"),e.$3h=(0,E.$Vh)(e.$2h)}),define(Pe[96],Ae([1,0,151,4]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$co=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0,e.$3n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$4n=new RegExp(e.$3n),e.$5n="__web_extension",e.$6n="skipWalkthrough",e.$7n="extensionsSync",e.$8n="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$9n=P;function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$0n=M;function R(i,n){switch(i){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$$n=R;function $(i,n){return n==="web"&&!i.includes("web")}e.$_n=$;function D(i,n,u){return $(n,u)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===u}e.$ao=D;function g(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$bo=g;var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var S;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var a;(function(i){i.Install="install",i.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var v;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$co=(0,L.$Uh)("extensionGalleryService");var p;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var f;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class t extends Error{constructor(n,u){super(n),this.code=u,this.name=u}}e.$do=t,e.$eo=(0,L.$Uh)("extensionManagementService"),e.$fo="extensionsIdentifiers/disabled",e.$go="extensionsIdentifiers/enabled",e.$ho=(0,L.$Uh)("IGlobalExtensionEnablementService"),e.$io=(0,L.$Uh)("IExtensionTipsService"),e.$jo=(0,E.localize)(0,null),e.$ko={value:e.$jo,original:"Extensions"},e.$lo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Pe[41],Ae([1,0,51,19,13,16,2,153,4,21,14,44]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.FileKind=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileOperationResult=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileChangeType=e.$vk=e.FileOperation=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileSystemProviderErrorCode=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.FileSystemProviderCapabilities=e.$fk=e.FilePermission=e.FileType=e.$ek=e.$dk=void 0,e.$dk=(0,D.$Uh)("fileService");function a(se){return se.create===!0}e.$ek=a;var v;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var p;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function f(se){const Re=se;return!!Re&&typeof Re.onDidChange=="function"}e.$fk=f;var t;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(se){return!!(se.capabilities&2)}e.$gk=i;function n(se){return!!(se.capabilities&8)}e.$hk=n;function u(se){return!!(se.capabilities&131072)}e.$ik=u;function o(se){return!!(se.capabilities&4)}e.$jk=o;function l(se){return!!(se.capabilities&16)}e.$kk=l;function r(se){return i(se)?!!(se.capabilities&16384):!1}e.$lk=r;function s(se){return i(se)?!!(se.capabilities&32768):!1}e.$mk=s;function c(se){return!!(se.capabilities&65536)}e.$nk=c;function h(se){return!!(se.capabilities&2048)}e.$ok=h;var b;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(b||(e.FileSystemProviderErrorCode=b={}));class m extends Error{static create(Re,oe){const X=new m(Re.toString(),oe);return d(X,oe),X}constructor(Re,oe){super(Re),this.code=oe}}e.$pk=m;function I(se,Re){return m.create(se,Re)}e.$qk=I;function k(se){return se||I((0,$.localize)(0,null),b.Unknown)}e.$rk=k;function d(se,Re){return se.name=Re?`${Re} (FileSystemError)`:"FileSystemError",se}e.$sk=d;function w(se){if(!se)return b.Unknown;if(se instanceof m)return se.code;const Re=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!Re)return b.Unknown;switch(Re[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.$tk=w;function y(se){if(se instanceof F)return se.fileOperationResult;switch(w(se)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 9;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileTooLarge:return 7;default:return 10}}e.$uk=y;var C;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class W{constructor(Re,oe,X){this.resource=Re,this.operation=oe,this.target=X}isOperation(Re){return this.operation===Re}}e.$vk=W;var H;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(H||(e.FileChangeType=H={}));class U{static{this.a=null}constructor(Re,oe){this.c=oe,this.b=void 0,this.d=new S.$U(()=>{const X=E.$1h.forUris(()=>this.c);return X.fill(this.rawAdded.map(j=>[j,!0])),X}),this.f=new S.$U(()=>{const X=E.$1h.forUris(()=>this.c);return X.fill(this.rawUpdated.map(j=>[j,!0])),X}),this.g=new S.$U(()=>{const X=E.$1h.forUris(()=>this.c);return X.fill(this.rawDeleted.map(j=>[j,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of Re){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==U.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(Re,...oe){return this.h(Re,{includeChildren:!1},...oe)}affects(Re,...oe){return this.h(Re,{includeChildren:!0},...oe)}h(Re,oe,...X){if(!Re)return!1;const j=X.length>0;return!!((!j||X.includes(1))&&(this.d.value.get(Re)||oe.includeChildren&&this.d.value.findSuperstr(Re))||(!j||X.includes(0))&&(this.f.value.get(Re)||oe.includeChildren&&this.f.value.findSuperstr(Re))||(!j||X.includes(2))&&(this.g.value.findSubstr(Re)||oe.includeChildren&&this.g.value.findSuperstr(Re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Re){return this.b===Re}hasCorrelation(){return typeof this.b=="number"}}e.$wk=U;function z(se,Re,oe){return!se||!Re||se===Re||Re.length>se.length?!1:(Re.charAt(Re.length-1)!==L.sep&&(Re+=L.sep),oe?(0,P.$6e)(se,Re):se.indexOf(Re)===0)}e.$xk=z;class F extends Error{constructor(Re,oe,X){super(Re),this.fileOperationResult=oe,this.options=X}}e.$yk=F;class N extends F{constructor(Re,oe,X,j){super(Re,oe,j),this.fileOperationResult=oe,this.size=X}}e.$zk=N;class x extends F{constructor(Re,oe,X){super(Re,2,X),this.stat=oe}}e.$Ak=x;var J;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$Bk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Ck={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Dk="files.associations",e.$Ek="files.exclude",e.$Fk="files.readonlyInclude",e.$Gk="files.readonlyExclude",e.$Hk="files.readonlyFromPermissions";var Ee;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ee||(e.FileKind=Ee={})),e.$Ik="";function De(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$Jk=De;async function Ce(se,Re){if(!Re.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(oe=>{const X=Re.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===se.scheme&&j.added&&(X.dispose(),oe())})})}e.$Kk=Ce;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(Re){return(0,M.$Ff)(Re)||(Re=0),Re<fe.KB?(0,$.localize)(1,null,Re.toFixed(0)):Re<fe.MB?(0,$.localize)(2,null,(Re/fe.KB).toFixed(2)):Re<fe.GB?(0,$.localize)(3,null,(Re/fe.MB).toFixed(2)):Re<fe.TB?(0,$.localize)(4,null,(Re/fe.GB).toFixed(2)):(0,$.localize)(5,null,(Re/fe.TB).toFixed(2))}}e.$Lk=fe;function be(se){const Re=typeof se=="string"||se?.scheme===A.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===A.Schemas.file?1024*fe.MB:Re?10*fe.MB:g.$o?50*fe.MB:1024*fe.MB}e.$Mk=be}),define(Pe[72],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class E{constructor(...P){this.a=new Map;for(const[M,R]of P)this.set(M,R)}set(P,M){const R=this.a.get(P);return this.a.set(P,M),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Sh=E}),define(Pe[186],Ae([1,0,12,11,6,70,184,4,72,187]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=void 0;const A=!1;class S extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class a{constructor(t=new D.$Sh,i=!1,n,u=A){this.f=t,this.g=i,this.h=n,this.i=u,this.o=new Set,this.f.set($.$Th,this),this._globalGraph=u?n?._globalGraph??new R.$hq(o=>o):void 0}createChild(t){return new a(t,this.g,this,this.i)}invokeFunction(t,...i){const n=p.traceInvocation(this.i,t);let u=!1;try{return t({get:l=>{if(u)throw(0,L.$7)("service accessor is only valid during the invocation of its target method");const r=this.m(l,n);if(!r)throw new Error(`[invokeFunction] unknown service '${l}'`);return r}},...i)}finally{u=!0,n.stop()}}createInstance(t,...i){let n,u;return t instanceof M.$Rh?(n=p.traceCreation(this.i,t.ctor),u=this.j(t.ctor,t.staticArguments.concat(i),n)):(n=p.traceCreation(this.i,t),u=this.j(t,i,n)),n.stop(),u}j(t,i=[],n){const u=$._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),o=[];for(const r of u){const s=this.m(r.id,n);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),o.push(s)}const l=u.length>0?u[0].index:i.length;if(i.length!==l){console.trace(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${i.length} static arguments`);const r=l-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,l)}return Reflect.construct(t,i.concat(o))}k(t,i){if(this.f.get(t)instanceof M.$Rh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const n=this.l(t);return n instanceof M.$Rh?this.q(t,n,i.branch(t,!0)):(i.branch(t,!1),n)}q(t,i,n){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,n)}finally{this.o.delete(t)}}r(t,i,n){const u=new R.$hq(r=>r.id.toString());let o=0;const l=[{id:t,desc:i,_trace:n}];for(;l.length;){const r=l.pop();if(u.lookupOrInsertNode(r),o++>1e3)throw new S(u);for(const s of $._util.getServiceDependencies(r.desc.ctor)){const c=this.l(s.id);if(c||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),c instanceof M.$Rh){const h={id:s.id,desc:c,_trace:r._trace.branch(s.id,!0)};u.insertEdge(r,h),l.push(h)}}}for(;;){const r=u.roots();if(r.length===0){if(!u.isEmpty())throw new S(u);break}for(const{data:s}of r){if(this.l(s.id)instanceof M.$Rh){const h=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,h)}u.removeNode(s)}}return this.l(t)}s(t,i,n=[],u,o){if(this.f.get(t)instanceof M.$Rh)return this.t(t,i,n,u,o);if(this.h)return this.h.s(t,i,n,u,o);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,n=[],u,o){if(u){const l=new a(void 0,this.g,this,this.i);l.c=String(t);const r=new Map,s=new E.$dh(()=>{const c=l.j(i,n,o);for(const[h,b]of r){const m=c[h];if(typeof m=="function")for(const I of b)m.apply(c,I)}return r.clear(),c});return new Proxy(Object.create(null),{get(c,h){if(!s.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let I=r.get(h);return I||(I=new g.$1c,r.set(h,I)),(d,w,y)=>{const C=I.push([d,w,y]);return(0,P.$Pc)(C)}}if(h in c)return c[h];const b=s.value;let m=b[h];return typeof m!="function"||(m=m.bind(b),c[h]=m),m},set(c,h,b){return s.value[h]=b,!0},getPrototypeOf(c){return i.prototype}})}else return this.j(i,n,o)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$iq=a;var v;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(v||(v={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,i){return t?new p(1,i.name):p.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const n=new p(3,t.toString());return this.h.push([t,i,n]),n}stop(){const t=Date.now()-this.g;p.f+=t;let i=!1;function n(o,l){const r=[],s=new Array(o+1).join("	");for(const[c,h,b]of l.h)if(h&&b){i=!0,r.push(`${s}CREATES -> ${c}`);const m=n(o+1,b);m&&r.push(m)}else r.push(`${s}uses -> ${c}`);return r.join(`
`)}const u=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||i)&&p.all.add(u.join(`
`))}}e.$jq=p}),define(Pe[15],Ae([1,0,39,5,97,6,28,21,25,16,2,34,4]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.log=e.$fj=e.LogLevel=e.$ej=e.$dj=e.$cj=void 0,e.$cj=(0,a.$Uh)("logService"),e.$dj=(0,a.$Uh)("loggerService");function v(){return new Date().toISOString()}function p(d){return(0,g.$Ff)(d)}e.$ej=p;var f;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$fj=f.Info;function t(d,w,y){switch(w){case f.Trace:d.trace(y);break;case f.Debug:d.debug(y);break;case f.Info:d.info(y);break;case f.Warning:d.warn(y);break;case f.Error:d.error(y);break;case f.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=t;function i(d,w=!1){let y="";for(let C=0;C<d.length;C++){let W=d[C];if(W instanceof Error&&(W=(0,E.$Fi)(W,w)),typeof W=="object")try{W=JSON.stringify(W)}catch{}y+=(C>0?" ":"")+W}return y}class n extends M.$Rc{constructor(){super(...arguments),this.b=e.$fj,this.c=this.B(new L.$Qd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==f.Off&&this.b<=w}}e.$hj=n;class u extends n{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...y){this.f(f.Trace)&&this.g(f.Trace,i([w,...y],!0))}debug(w,...y){this.f(f.Debug)&&this.g(f.Debug,i([w,...y]))}info(w,...y){this.f(f.Info)&&this.g(f.Info,i([w,...y]))}warn(w,...y){this.f(f.Warning)&&this.g(f.Warning,i([w,...y]))}error(w,...y){if(this.f(f.Error))if(w instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=w.stack,this.g(f.Error,i(C))}else this.g(f.Error,i([w,...y]))}flush(){}}e.$ij=u;class o extends n{constructor(w=e.$fj){super(),this.setLevel(w),this.g=!$.$i}trace(w,...y){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...y):console.log(`[main ${v()}]`,w,...y))}debug(w,...y){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...y):console.log(`[main ${v()}]`,w,...y))}info(w,...y){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...y):console.log(`[main ${v()}]`,w,...y))}warn(w,...y){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,w,...y):console.warn(`[main ${v()}]`,w,...y))}error(w,...y){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,w,...y):console.error(`[main ${v()}]`,w,...y))}dispose(){}flush(){}}e.$jj=o;class l extends n{constructor(w=e.$fj,y=!0){super(),this.g=y,this.setLevel(w)}trace(w,...y){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...y):console.log(w,...y))}debug(w,...y){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...y):console.log(w,...y))}info(w,...y){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...y):console.log(w,...y))}warn(w,...y){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...y):console.log(w,...y))}error(w,...y){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...y):console.error(w,...y))}dispose(){}flush(){}}e.$kj=l;class r extends n{constructor(w,y=e.$fj){super(),this.g=w,this.setLevel(y)}trace(w,...y){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(w),...y])}debug(w,...y){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(w),...y])}info(w,...y){this.f(f.Info)&&this.g.log(f.Info,[this.h(w),...y])}warn(w,...y){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(w),...y])}error(w,...y){this.f(f.Error)&&this.g.log(f.Error,[this.h(w),...y])}h(w){return typeof w=="string"?w:(0,E.$Fi)(w,this.f(f.Trace))}dispose(){}flush(){}}e.$lj=r;class s extends n{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const y of this.g)y.setLevel(w);super.setLevel(w)}trace(w,...y){for(const C of this.g)C.trace(w,...y)}debug(w,...y){for(const C of this.g)C.debug(w,...y)}info(w,...y){for(const C of this.g)C.info(w,...y)}warn(w,...y){for(const C of this.g)C.warn(w,...y)}error(w,...y){for(const C of this.g)C.error(w,...y)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$mj=s;class c extends M.$Rc{constructor(w,y,C){if(super(),this.h=w,this.j=y,this.b=new R.$zc,this.c=this.B(new L.$Qd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Qd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Qd),this.onDidChangeVisibility=this.g.event,C)for(const W of C)this.b.set(W.resource,{logger:void 0,info:W})}m(w){return(0,g.$Bf)(w)?[...this.b.values()].find(y=>y.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,y){const C=this.n(w),W=(0,g.$Bf)(w)?w:y?.id??(0,P.$Ii)(C.toString()).toString(16);let H=this.b.get(C)?.logger;const U=y?.logLevel==="always"?f.Trace:y?.logLevel;H||(H=this.s(C,U??this.getLogLevel(C)??this.h,{...y,id:W}));const z={logger:H,info:{resource:C,id:W,logLevel:U,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(z.info),this.b.set(C,z),H}n(w){return(0,g.$Bf)(w)?(0,D.$yg)(this.j,`${w}.log`):w}setLogLevel(w,y){if(A.URI.isUri(w)){const C=w,W=y,H=this.b.get(C);H&&W!==H.info.logLevel&&(H.info.logLevel=W===this.h?void 0:W,H.logger?.setLevel(W),this.b.set(H.info.resource,H),this.f.fire([C,W]))}else{this.h=w;for(const[C,W]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,y){const C=this.m(w);C&&y!==!C.info.hidden&&(C.info.hidden=!y,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,y]))}getLogLevel(w){let y;return w&&(y=this.b.get(w)?.info.logLevel),y??this.h}registerLogger(w){const y=this.b.get(w.resource);y?y.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const y=this.b.get(w);y&&(y.logger&&y.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$nj=c;class h{constructor(){this.onDidChangeLogLevel=new L.$Qd().event}setLevel(w){}getLevel(){return f.Info}trace(w,...y){}debug(w,...y){}info(w,...y){}warn(w,...y){}error(w,...y){}critical(w,...y){}dispose(){}flush(){}}e.$oj=h;class b extends h{}e.$pj=b;function m(d){if(d.verbose)return f.Trace;if(typeof d.logLevel=="string"){const w=k(d.logLevel.toLowerCase());if(w!==void 0)return w}return e.$fj}e.$qj=m;function I(d){switch(d){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$rj=I;function k(d){switch(d){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$sj=k,e.$tj=new S.$_i("logLevel",I(f.Info))}),define(Pe[188],Ae([1,0,6,15]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=void 0;class P extends E.$Rc{constructor(R,$=[]){super(),this.a=new L.$mj([R,...$]),this.B(R.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$YN=P}),define(Pe[98],Ae([1,0,31,154,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(D){function g(p,f){return f-p}D.compare=g;const A=Object.create(null);A[D.Error]=(0,L.localize)(0,null),A[D.Warning]=(0,L.localize)(1,null),A[D.Info]=(0,L.localize)(2,null);function S(p){return A[p]||""}D.toString=S;function a(p){switch(p){case E.default.Error:return D.Error;case E.default.Warning:return D.Warning;case E.default.Info:return D.Info;case E.default.Ignore:return D.Hint}}D.fromSeverity=a;function v(p){switch(p){case D.Error:return E.default.Error;case D.Warning:return E.default.Warning;case D.Info:return E.default.Info;case D.Hint:return E.default.Ignore}}D.toSeverity=v}(R||(e.MarkerSeverity=R={}));var $;(function(D){const g="";function A(a){return S(a,!0)}D.makeKey=A;function S(a,v){const p=[g];return a.source?p.push(a.source.replace("\xA6","\\\xA6")):p.push(g),a.code?typeof a.code=="string"?p.push(a.code.replace("\xA6","\\\xA6")):p.push(a.code.value.replace("\xA6","\\\xA6")):p.push(g),a.severity!==void 0&&a.severity!==null?p.push(R.toString(a.severity)):p.push(g),a.message&&v?p.push(a.message.replace("\xA6","\\\xA6")):p.push(g),a.startLineNumber!==void 0&&a.startLineNumber!==null?p.push(a.startLineNumber.toString()):p.push(g),a.startColumn!==void 0&&a.startColumn!==null?p.push(a.startColumn.toString()):p.push(g),a.endLineNumber!==void 0&&a.endLineNumber!==null?p.push(a.endLineNumber.toString()):p.push(g),a.endColumn!==void 0&&a.endColumn!==null?p.push(a.endColumn.toString()):p.push(g),p.push(g),p.join("\xA6")}D.makeKeyOptionalMessage=S})($||(e.IMarkerData=$={})),e.$ft=(0,P.$Uh)("markerService")}),define(Pe[189],Ae([1,0,5,31,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$6u=e.Severity=void 0,e.Severity=L.default,e.$6u=(0,P.$Uh)("notificationService");var M;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var $;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class D{constructor(){this.progress=new g,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$7u=D;class g{infinite(){}done(){}total(S){}worked(S){}}e.$8u=g}),define(Pe[99],Ae([1,0,13,2,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RU=e.$QU=e.$PU=e.$OU=e.$NU=void 0,e.$NU=(0,P.$Uh)("openerService");function M(g,A){return L.URI.isUri(g)?(0,E.$5e)(g.scheme,A):(0,E.$6e)(g,A+":")}e.$OU=M;function R(g,...A){return A.some(S=>M(g,S))}e.$PU=R;function $(g,A){return g.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$QU=$;function D(g){let A;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return S&&(A={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},g=g.with({fragment:""})),{selection:A,uri:g}}e.$RU=D}),define(Pe[190],Ae([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=void 0,e.$uj=(0,E.$Uh)("productService"),e.$vj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(ve,e,E,L){var P=arguments.length,M=P<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,E):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ve,e,E,L);else for(var $=ve.length-1;$>=0;$--)(R=ve[$])&&(M=(P<3?R(M):P>3?R(e,E,M):R(e,E))||M);return P>3&&M&&Object.defineProperty(e,E,M),M},Ve=this&&this.__param||function(ve,e){return function(E,L){e(E,L,ve)}};define(Pe[54],Ae([1,0,12,20,6,4]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.ProgressLocation=e.$9u=void 0,e.$9u=(0,M.$Uh)("progressService");var R;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$0u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(a){this.b=a}report(a){this.a=a,this.b(this.a)}}e.$$u=$;class D{get value(){return this.a}constructor(a){this.e=a}report(a){this.b?this.b.push(a):this.b=[a],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const a=this.b.shift();this.a=a,await this.e(this.a)}}finally{this.c=!1;const a=this.d;this.d=void 0,a?.()}}drain(){return this.c?new Promise(a=>{const v=this.d;this.d=()=>{v?.(),a()}}):Promise.resolve()}}e.$_u=D;let g=class extends P.$Rc{constructor(a,v){super(),this.a=new E.$hh,v.withProgress(a,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Pc)(()=>this.a.complete()))}report(a){this.b?this.b.report(a):this.c=a}};e.$av=g,e.$av=g=Ke([Ve(1,e.$9u)],g);class A extends P.$Rc{constructor(a){super(),this.g=a,this.a=0,this.b=this.B(new P.$Qc)}start(a){this.stop();const v=++this.a,p=new L.$1d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},a),this.b.add((0,P.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Pc)(()=>p.cancel())),this.b.add((0,P.$Pc)(()=>this.c?this.c.done():void 0)),{id:v,token:p.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(a){this.a===a&&this.b.clear()}}e.$bv=A,e.$cv=(0,M.$Uh)("editorProgressService")}),define(Pe[30],Ae([1,0,55,16]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;class P{constructor(){this.a=new Map}add(R,$){E.ok(L.$Bf(R)),E.ok(L.$Df($)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$ln=new P}),define(Pe[73],Ae([1,0,5,30]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0,e.$mn={JSONContribution:"base.contributions.json"};function P($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new E.$Qd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,g){this.a[P(D)]=g,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;L.$ln.add(e.$mn.JSONContribution,R)}),define(Pe[56],Ae([1,0,18,5,16,148,40,73,30]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.ConfigurationScope=e.$qn=e.EditPresentationTypes=void 0;var g;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$qn={Configuration:"base.contributions.configuration"};var A;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn="vscode://schemas/settings/resourceLanguage",e.$yn="vscode://schemas/settings/configurationDefaults";const S=D.$ln.as($.$mn.JSONContribution);class a{constructor(){this.h=new Set,this.i=new L.$Qd,this.onDidSchemaChange=this.i.event,this.j=new L.$Qd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$xn,this.g),this.v()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const c=new Set;this.n(r,s,c),S.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(r){const s=new Set;this.o(r,s),S.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const c=new Set;this.o(s,c),this.n(r,!1,c),S.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(r){const s=new Set;this.k(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(r,s){const c=[];for(const{overrides:h,source:b}of r)for(const m in h)if(s.add(m),e.$An.test(m)){const I=this.a.get(m),k=I?.valuesSources??new Map;if(b)for(const C of Object.keys(h[m]))k.set(C,b);const d={...I?.value||{},...h[m]};this.a.set(m,{source:b,value:d,valuesSources:k});const w=(0,R.$yi)(m),y={type:"object",default:d,description:M.localize(1,null,w),$ref:e.$xn,defaultDefaultValue:d,source:P.$Bf(b)?void 0:b,defaultValueSource:b};c.push(...f(m)),this.d[m]=y,this.b.properties[m]=y}else{this.a.set(m,{value:h[m],source:b});const I=this.d[m];I&&(this.w(m,I),this.r(m,I))}this.m(c)}deregisterDefaultConfigurations(r){const s=new Set;this.l(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(r,s){for(const{overrides:c,source:h}of r)for(const b in c){const m=this.a.get(b),I=P.$Bf(h)?h:h?.id,k=P.$Bf(m?.source)?m?.source:m?.source?.id;if(I===k)if(s.add(b),this.a.delete(b),e.$An.test(b))delete this.d[b],delete this.b.properties[b];else{const d=this.d[b];d&&(this.w(b,d),this.r(b,d))}}this.u()}deltaConfiguration(r){let s=!1;const c=new Set;r.removedDefaults&&(this.l(r.removedDefaults,c),s=!0),r.addedDefaults&&(this.k(r.addedDefaults,c),s=!0),r.removedConfigurations&&this.o(r.removedConfigurations,c),r.addedConfigurations&&this.n(r.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const s of r)this.h.add(s);this.u()}n(r,s,c){r.forEach(h=>{this.p(h,s,h.extensionInfo,h.restrictedProperties,void 0,c),this.c.push(h),this.q(h)})}o(r,s){const c=h=>{if(h.properties)for(const b in h.properties){s.add(b);const m=this.d[b];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[b],this.s(b,h.properties[b])}h.allOf?.forEach(b=>c(b))};for(const h of r){c(h);const b=this.c.indexOf(h);b!==-1&&this.c.splice(b,1)}}p(r,s=!0,c,h,b=3,m){b=P.$Kf(r.scope)?b:r.scope;const I=r.properties;if(I)for(const d in I){const w=I[d];if(s&&u(d,w)){delete I[d];continue}if(w.source=c,w.defaultDefaultValue=I[d].default,this.w(d,w),e.$An.test(d)?w.scope=void 0:(w.scope=P.$Kf(w.scope)?b:w.scope,w.restricted=P.$Kf(w.restricted)?!!h?.includes(d):w.restricted),I[d].hasOwnProperty("included")&&!I[d].included){this.f[d]=I[d],delete I[d];continue}else this.d[d]=I[d],I[d].policy?.name&&this.e.set(I[d].policy.name,d);!I[d].deprecationMessage&&I[d].markdownDeprecationMessage&&(I[d].deprecationMessage=I[d].markdownDeprecationMessage),m.add(d)}const k=r.allOf;if(k)for(const d of k)this.p(d,s,c,h,b,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const s=c=>{const h=c.properties;if(h)for(const m in h)this.r(m,h[m]);c.allOf?.forEach(s)};s(r)}r(r,s){switch(e.$rn.properties[r]=s,s.scope){case 1:e.$sn.properties[r]=s;break;case 2:e.$tn.properties[r]=s;break;case 6:e.$un.properties[r]=s;break;case 3:e.$vn.properties[r]=s;break;case 4:e.$wn.properties[r]=s;break;case 5:e.$wn.properties[r]=s,this.g.properties[r]=s;break}}s(r,s){switch(delete e.$rn.properties[r],s.scope){case 1:delete e.$sn.properties[r];break;case 2:delete e.$tn.properties[r];break;case 6:delete e.$un.properties[r];break;case 3:delete e.$vn.properties[r];break;case 4:case 5:delete e.$wn.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const s=`[${r}]`,c={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$xn};this.w(s,c),e.$rn.properties[s]=c,e.$sn.properties[s]=c,e.$tn.properties[s]=c,e.$un.properties[s]=c,e.$vn.properties[s]=c,e.$wn.properties[s]=c}}v(){const r={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$xn};e.$rn.patternProperties[e.$zn]=r,e.$sn.patternProperties[e.$zn]=r,e.$tn.patternProperties[e.$zn]=r,e.$un.patternProperties[e.$zn]=r,e.$vn.patternProperties[e.$zn]=r,e.$wn.patternProperties[e.$zn]=r,this.i.fire()}w(r,s){const c=this.a.get(r);let h=c?.value,b=c?.source;P.$If(h)&&(h=s.defaultDefaultValue,b=void 0),P.$If(h)&&(h=i(s.type)),s.default=h,s.defaultValueSource=b}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.$zn=`^(${v})+$`,e.$An=new RegExp(e.$zn);function f(l){const r=[];if(e.$An.test(l)){let s=p.exec(l);for(;s?.length;){const c=s[1].trim();c&&r.push(c),s=p.exec(l)}}return(0,E.$Lb)(r)}e.$Bn=f;function t(l){return l.reduce((r,s)=>`${r}[${s}]`,"")}e.$Cn=t;function i(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Dn=i;const n=new a;D.$ln.add(e.$qn.Configuration,n);function u(l,r){return l.trim()?e.$An.test(l)?M.localize(7,null,l):n.getConfigurationProperties()[l]!==void 0?M.localize(8,null,l):r.policy?.name&&n.getPolicyConfigurations().get(r.policy?.name)!==void 0?M.localize(9,null,l,r.policy?.name,n.getPolicyConfigurations().get(r.policy?.name)):null:M.localize(6,null)}e.$En=u;function o(){const l=[],r=n.getConfigurationProperties();for(const s of Object.keys(r))l.push([s,r[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$Fn=o}),define(Pe[191],Ae([1,0,18,5,119,6,28,26,16,2,40,56,30]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=void 0;function v(s){return Object.isFrozen(s)?s:$.$an(s)}class p{constructor(c={},h=[],b=[],m){this.b=c,this.c=h,this.d=b,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(h=>{if(h instanceof p)return h;const b=new f("");return b.parseRaw(h),b.configurationModel});this.f=c.reduce((h,b)=>b===h?b:h.merge(b),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,A.$wi)(this.contents,c):this.contents}inspect(c,h){const b=this.rawConfiguration.getValue(c),m=h?this.rawConfiguration.getOverrideValue(c,h):void 0,I=h?this.rawConfiguration.override(h).getValue(c):b;return{value:b,override:m,merged:I}}getOverrideValue(c,h){const b=this.i(h);return b?c?(0,A.$wi)(b,c):b:void 0}getKeysForOverrideIdentifier(c){const h=[];for(const b of this.overrides)b.identifiers.includes(c)&&h.push(...b.keys);return E.$Lb(h)}getAllOverrideIdentifiers(){const c=[];for(const h of this.overrides)c.push(...h.identifiers);return E.$Lb(c)}override(c){let h=this.a.get(c);return h||(h=this.g(c),this.a.set(c,h)),h}merge(...c){const h=$.$_m(this.contents),b=$.$_m(this.overrides),m=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const k of c)if(I.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(h,k.contents);for(const d of k.overrides){const[w]=b.filter(y=>E.$tb(y.identifiers,d.identifiers));w?(this.h(w.contents,d.contents),w.keys.push(...d.keys),w.keys=E.$Lb(w.keys)):b.push($.$_m(d))}for(const d of k.keys)m.indexOf(d)===-1&&m.push(d)}return new p(h,m,b,I.every(k=>k instanceof p)?void 0:I)}g(c){const h=this.i(c);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const b={};for(const m of E.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let I=this.contents[m];const k=h[m];k&&(typeof I=="object"&&typeof k=="object"?(I=$.$_m(I),this.h(I,k)):I=k),b[m]=I}return new p(b,this.keys,this.overrides)}h(c,h){for(const b of Object.keys(h)){if(b in c&&D.$Df(c[b])&&D.$Df(h[b])){this.h(c[b],h[b]);continue}c[b]=$.$_m(h[b])}}i(c){let h=null,b=null;const m=I=>{I&&(b?this.h(b,I):b=$.$_m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===c?h=I.contents:I.identifiers.includes(c)&&m(I.contents);return m(h),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,h){this.j(c,h,!0)}setValue(c,h){this.j(c,h,!1)}removeValue(c){const h=this.keys.indexOf(c);h!==-1&&(this.keys.splice(h,1),(0,A.$vi)(this.contents,c),S.$An.test(c)&&this.overrides.splice(this.overrides.findIndex(b=>E.$tb(b.identifiers,(0,S.$Bn)(c))),1))}j(c,h,b){(0,A.$ui)(this.contents,c,h,m=>console.error(m)),b=b||this.keys.indexOf(c)===-1,b&&this.keys.push(c),S.$An.test(c)&&this.overrides.push({identifiers:(0,S.$Bn)(c),keys:Object.keys(this.contents[c]),contents:(0,A.$ti)(this.contents[c],m=>console.error(m))})}}e.$Gn=p;class f{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,h){if(!D.$Kf(c)){const b=this.g(c);this.parseRaw(b,h)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,h){this.a=c;const{contents:b,keys:m,overrides:I,restricted:k,hasExcludedProperties:d}=this.h(c,h);this.b=new p(b,m,I,d?[c]:void 0),this.c=k||[]}g(c){let h={},b=null,m=[];const I=[],k=[];function d(y){Array.isArray(m)?m.push(y):b!==null&&(m[b]=y)}const w={onObjectBegin:()=>{const y={};d(y),I.push(m),m=y,b=null},onObjectProperty:y=>{b=y},onObjectEnd:()=>{m=I.pop()},onArrayBegin:()=>{const y=[];d(y),I.push(m),m=y,b=null},onArrayEnd:()=>{m=I.pop()},onLiteralValue:d,onError:(y,C,W)=>{k.push({error:y,offset:C,length:W})}};if(c)try{P.$9m(c,w),h=m[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return h}h(c,h){const b=a.$ln.as(S.$qn.Configuration).getConfigurationProperties(),m=this.i(c,b,!0,h);c=m.raw;const I=(0,A.$ti)(c,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(c),d=this.j(c,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:I,keys:k,overrides:d,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(c,h,b,m){let I=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:I};const k={},d=[];for(const w in c)if(S.$An.test(w)&&b){const y=this.i(c[w],h,!1,m);k[w]=y.raw,I=I||y.hasExcludedProperties,d.push(...y.restricted)}else{const y=h[w],C=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&d.push(w),!m.exclude?.includes(w)&&(m.include?.includes(w)||(C===void 0||m.scopes===void 0||m.scopes.includes(C))&&!(m.skipRestricted&&y?.restricted))?k[w]=c[w]:I=!0}return{raw:k,restricted:d,hasExcludedProperties:I}}j(c,h){const b=[];for(const m of Object.keys(c))if(S.$An.test(m)){const I={};for(const k in c[m])I[k]=c[m][k];b.push({identifiers:(0,S.$Bn)(m),keys:Object.keys(I),contents:(0,A.$ti)(I,h)})}return b}}e.$Hn=f;class t extends M.$Rc{constructor(c,h,b,m){super(),this.c=c,this.f=h,this.g=m,this.b=this.B(new L.$Qd),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(b.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&b.isEqual(I.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$In=t;class i{constructor(c,h,b,m,I,k,d,w,y,C,W,H,U){this.a=c,this.b=h,this.c=b,this.overrideIdentifiers=m,this.d=I,this.f=k,this.g=d,this.h=w,this.i=y,this.j=C,this.k=W,this.l=H,this.m=U}get value(){return v(this.c)}n(c,h,b){const m=c.inspect(h,b);return{get value(){return v(m.value)},get override(){return v(m.override)},get merged(){return v(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(c,h,b,m,I=new p,k=new p,d=new R.$zc,w=new p,y=new R.$zc){this.c=c,this.d=h,this.f=b,this.g=m,this.h=I,this.i=k,this.j=d,this.l=w,this.m=y,this.a=null,this.b=new R.$zc,this.n=null}getValue(c,h,b){return this.q(c,h,b).getValue(c)}updateValue(c,h,b={}){let m;b.resource?(m=this.m.get(b.resource),m||(m=new p,this.m.set(b.resource,m))):m=this.l,h===void 0?m.removeValue(c):m.setValue(c,h),b.resource||(this.a=null)}inspect(c,h,b){const m=this.q(c,h,b),I=this.u(h.resource,b),k=h.resource?this.m.get(h.resource)||this.l:this.l,d=new Set;for(const w of m.overrides)for(const y of w.identifiers)m.getOverrideValue(c,y)!==void 0&&d.add(y);return new i(c,h,m.getValue(c),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,I||void 0,k)}keys(c){const h=this.u(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,h){this.j.set(c,h),this.b.delete(c)}deleteFolderConfiguration(c){this.p.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,h){const b=[];if(!h){const{added:m,updated:I,removed:k}=l(this.c,c);h=[...m,...I,...k]}for(const m of h)for(const I of(0,S.$Bn)(m)){const k=this.c.getKeysForOverrideIdentifier(I),d=c.getKeysForOverrideIdentifier(I),w=[...d.filter(y=>k.indexOf(y)===-1),...k.filter(y=>d.indexOf(y)===-1),...k.filter(y=>!$.$dn(this.c.override(I).getValue(y),c.override(I).getValue(y)))];b.push([I,w])}return this.updateDefaultConfiguration(c),{keys:h,overrides:b}}compareAndUpdatePolicyConfiguration(c){const{added:h,updated:b,removed:m}=l(this.d,c),I=[...h,...b,...m];return I.length&&this.updatePolicyConfiguration(c),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:h,updated:b,removed:m,overrides:I}=l(this.applicationConfiguration,c),k=[...h,...b,...m];return k.length&&this.updateApplicationConfiguration(c),{keys:k,overrides:I}}compareAndUpdateLocalUserConfiguration(c){const{added:h,updated:b,removed:m,overrides:I}=l(this.localUserConfiguration,c),k=[...h,...b,...m];return k.length&&this.updateLocalUserConfiguration(c),{keys:k,overrides:I}}compareAndUpdateRemoteUserConfiguration(c){const{added:h,updated:b,removed:m,overrides:I}=l(this.remoteUserConfiguration,c),k=[...h,...b,...m];return k.length&&this.updateRemoteUserConfiguration(c),{keys:k,overrides:I}}compareAndUpdateWorkspaceConfiguration(c){const{added:h,updated:b,removed:m,overrides:I}=l(this.workspaceConfiguration,c),k=[...h,...b,...m];return k.length&&this.updateWorkspaceConfiguration(c),{keys:k,overrides:I}}compareAndUpdateFolderConfiguration(c,h){const b=this.p.get(c),{added:m,updated:I,removed:k,overrides:d}=l(b,h),w=[...m,...I,...k];return(w.length||!b)&&this.updateFolderConfiguration(c,h),{keys:w,overrides:d}}compareAndDeleteFolderConfiguration(c){const h=this.p.get(c);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:b,updated:m,removed:I,overrides:k}=l(h,void 0);return{keys:[...b,...m,...I],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(c,h,b){let m=this.r(h,b);return h.overrideIdentifier&&(m=m.override(h.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(m=m.merge(this.d)),m}r({resource:c},h){let b=this.s();if(h&&c){const m=h.getFolder(c);m&&(b=this.t(m.uri)||b);const I=this.m.get(c);I&&(b=b.merge(I))}return b}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(c){let h=this.b.get(c);if(!h){const b=this.s(),m=this.j.get(c);m?(h=b.merge(m),this.b.set(c,h)):h=b}return h}u(c,h){if(h&&c){const b=h.getFolder(c);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,h)=>{const{contents:b,overrides:m,keys:I}=this.j.get(h);return c.push([h,{contents:b,overrides:m,keys:I}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(h=>c.add(h)),this.userConfiguration.keys.forEach(h=>c.add(h)),this.i.keys.forEach(h=>c.add(h)),this.j.forEach(h=>h.keys.forEach(b=>c.add(b))),[...c.values()]}v(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.i.getAllOverrideIdentifiers().forEach(h=>c.add(h)),this.j.forEach(h=>h.getAllOverrideIdentifiers().forEach(b=>c.add(b))),[...c.values()]}w(c){const h=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(b=>h.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(b=>h.add(b)),this.i.getKeysForOverrideIdentifier(c).forEach(b=>h.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(c).forEach(m=>h.add(m))),[...h.values()]}static parse(c){const h=this.x(c.defaults),b=this.x(c.policy),m=this.x(c.application),I=this.x(c.user),k=this.x(c.workspace),d=c.folders.reduce((w,y)=>(w.set(g.URI.revive(y[0]),this.x(y[1])),w),new R.$zc);return new n(h,b,m,I,new p,k,d,new p,new R.$zc)}static x(c){return new p(c.contents,c.keys,c.overrides)}}e.$Jn=n;function u(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const c=new Set,h=new Map;for(const m of s)m.keys.forEach(I=>c.add(I)),m.overrides.forEach(([I,k])=>{const d=(0,R.$wc)(h,I,new Set);k.forEach(w=>d.add(w))});const b=[];return h.forEach((m,I)=>b.push([I,[...m.values()]])),{keys:[...c.values()],overrides:b}}e.$Kn=u;class o{constructor(c,h,b,m){this.change=c,this.f=h,this.g=b,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of c.keys)this.affectedKeys.add(I);for(const[,I]of c.overrides)for(const k of I)this.affectedKeys.add(k);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(c,h){const b=this.a+c,m=this.d.indexOf(b);if(m<0)return!1;const I=m+b.length;if(I>=this.d.length)return!1;const k=this.d.charCodeAt(I);if(k!==this.b&&k!==this.c)return!1;if(h){const d=this.previousConfiguration?this.previousConfiguration.getValue(c,h,this.f?.workspace):void 0,w=this.g.getValue(c,h,this.h);return!$.$dn(d,w)}return!0}}e.$Ln=o;function l(s,c){const{added:h,removed:b,updated:m}=r(c?.rawConfiguration,s?.rawConfiguration),I=[],k=s?.getAllOverrideIdentifiers()||[],d=c?.getAllOverrideIdentifiers()||[];if(c){const w=d.filter(y=>!k.includes(y));for(const y of w)I.push([y,c.getKeysForOverrideIdentifier(y)])}if(s){const w=k.filter(y=>!d.includes(y));for(const y of w)I.push([y,s.getKeysForOverrideIdentifier(y)])}if(c&&s){for(const w of k)if(d.includes(w)){const y=r({contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)},{contents:c.getOverrideValue(void 0,w)||{},keys:c.getKeysForOverrideIdentifier(w)});I.push([w,[...y.added,...y.removed,...y.updated]])}}return{added:h,removed:b,updated:m,overrides:I}}function r(s,c){const h=s?c?s.keys.filter(I=>c.keys.indexOf(I)===-1):[...s.keys]:[],b=c?s?c.keys.filter(I=>s.keys.indexOf(I)===-1):[...c.keys]:[],m=[];if(s&&c){for(const I of c.keys)if(s.keys.indexOf(I)!==-1){const k=(0,A.$wi)(c.contents,I),d=(0,A.$wi)(s.contents,I);$.$dn(k,d)||m.push(I)}}return{added:h,removed:b,updated:m}}}),define(Pe[100],Ae([1,0,11,4]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.RemoteAuthorityResolverErrorCode=e.$Wk=e.$Vk=e.RemoteConnectionType=e.$Uk=void 0,e.$Uk=(0,L.$Uh)("remoteAuthorityResolverService");var P;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Vk=M;class R{constructor(S,a){this.host=S,this.port=a,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Wk=R;var $;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class D extends E.$ab{static isNotAvailable(S){return S instanceof D&&S._code===$.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof D&&S._code===$.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof D&&S._code===$.NoResolverFound}static isInvalidAuthority(S){return S instanceof D&&S._code===$.InvalidAuthority}static isHandled(S){return S instanceof D&&S.isHandled}constructor(S,a=$.Unknown,v){super(S),this._message=S,this._code=a,this._detail=v,this.isHandled=a===$.NotAvailable&&v===!0,Object.setPrototypeOf(this,D.prototype)}}e.$Xk=D;function g(A){const S=A.indexOf("+");return S===-1?A:A.substring(0,S)}e.$Yk=g}),define(Pe[57],Ae([1,0,14]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=void 0;function L(g){return g.scheme===E.Schemas.vscodeRemote?g.authority:void 0}e.$Zk=L;function P(g){if(!g)return;const A=g.indexOf("+");return A<0?g:g.substr(0,A)}e.$1k=P;function M(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$2k=M;function R(g){const{host:A,port:S}=D(g);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:S}}e.$3k=R;function $(g,A){let{host:S,port:a}=D(g);return typeof a>"u"&&(a=A),{host:S,port:a}}e.$4k=$;function D(g){const A=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const a=g.match(/(.*):(\d+)$/);return a?{host:a[1],port:parseInt(a[2],10)}:{host:g,port:void 0}}}),define(Pe[22],Ae([1,0,13,4,57]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.TargetPlatform=e.ExtensionType=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=void 0,e.$5l="extensions.user.cache",e.$6l="extensions.builtin.cache",e.$7l="undefined_publisher",e.$8l=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$9l=M,e.$0l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class D{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const n=typeof t=="string"?t:t.value,u=typeof i=="string"?i:i.value;return E.$5e(n,u)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$$l=D;class g{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(D.toKey(t))}delete(t){return this.c.delete(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}}e.$_l=g;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(D.toKey(t))}get(t){return this.c.get(D.toKey(t))}has(t){return this.c.has(D.toKey(t))}set(t,i){this.c.set(D.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$am=A;function S(f){return a(f)}e.$bm=S;function a(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$cm=a;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$dm=v;function p(f,t){if(t){const i=`onResolveRemoteAuthority:${(0,P.$1k)(t)}`;return!!f.activationEvents?.includes(i)}return!1}e.$em=p,e.$fm=(0,L.$Uh)("IBuiltinExtensionsScannerService")}),define(Pe[101],Ae([1,0,11,22]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.$cF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const D of R){const g=this.readActivationEvents(D);g.length>0&&($[L.$$l.toKey(D.identifier)]=g)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let D=0;D<$.length;D++)$[D]==="onUri"&&($[D]=`onUri:${L.$$l.toKey(R.identifier)}`);if(!R.contributes)return $;for(const D in R.contributes){const g=this.a.get(D);if(!g)continue;const A=R.contributes[D],S=Array.isArray(A)?A:[A];try{g(S,$)}catch(a){(0,E.$Z)(a)}}return $}}e.$cF=P,e.$dF=new P}),define(Pe[192],Ae([1,0,21,74,38]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=void 0;function M(D){if(E.$u===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function R(D,g,A,S,a,v,p,f,t){const i=Object.create(null);i["common.machineId"]=v,i["common.sqmId"]=p,i.sessionID=(0,P.$hg)()+Date.now(),i.commitHash=S,i.version=a,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,E.$h)(E.$u),i["common.nodePlatform"]=L.$cc,i["common.nodeArch"]=A,i["common.product"]=t||"desktop",f&&(i["common.msftInternal"]=f);let n=0;const u=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(i["common.snap"]="true");const o=M(g);return o&&(i["common.platformDetail"]=o),i}e.$mo=R;function $(D){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const A=g.toLowerCase();return D.some(S=>A===S)}e.$no=$}),define(Pe[193],Ae([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=void 0,e.$hl=(0,E.$Uh)("telemetryService"),e.$il=(0,E.$Uh)("customEndpointTelemetryService"),e.$jl="telemetry.currentSessionDate",e.$kl="telemetry.firstSessionDate",e.$ll="telemetry.lastSessionDate",e.$ml="telemetry.machineId",e.$nl="telemetry.sqmId",e.$ol="telemetry",e.$pl="telemetry.telemetryLevel",e.$ql="telemetry.enableCrashReporter",e.$rl="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Pe[58],Ae([1,0,26,16,5,40,57,192,193]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;class g{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$oo=g;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$po=A,e.$qo=new A;class S{async publicLog(b,m,I){}async publicLogError(b,m,I){}}e.$ro=S,e.$so="telemetry",e.$to="extensionTelemetryLog",e.$uo={log:()=>null,flush:()=>Promise.resolve(null)};function a(h,b){return P.Event.debounce(b.onDidChangeConfiguration,(I,k)=>{const d=I?new Set([...I.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:d}},1e3,!0)(I=>{I.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,M.$ri)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$vo=a;function v(h,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!h.enableTelemetry)}e.$wo=v;function p(h,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||h.enableTelemetry&&h.aiConfig?.ariaKey)}e.$xo=p;function f(h){const b=h.getValue(D.$pl),m=h.getValue(D.$ql);if(h.getValue(D.$rl)===!1||m===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$yo=f;function t(h){const b={},m={},I={};u(h,I);for(let k in I){k=k.length>150?k.substr(k.length-149):k;const d=I[k];typeof d=="number"?m[k]=d:typeof d=="boolean"?m[k]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${d.length}`),b[k]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(b[k]=d)}return{properties:b,measurements:m}}e.$zo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(h){if(!h)return"none";const b=(0,R.$1k)(h);return i.has(b)?b:"other"}e.$Ao=n;function u(h,b,m=0,I){if(h)for(const k of Object.getOwnPropertyNames(h)){const d=h[k],w=I?I+k:k;Array.isArray(d)?b[w]=(0,E.$en)(d):d instanceof Date?b[w]=d.toISOString():(0,L.$Df)(d)?m<2?u(d,b,m+1,w+"."):b[w]=(0,E.$en)(d):b[w]=d}}function o(h,b){const m=h.msftInternalDomains||[],I=b.getValue("telemetry.internalTesting");return(0,$.$no)(m)||I}e.$Bo=o;function l(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.$Co=l;function r(h,b){if(!h||!h.includes("/")&&!h.includes("\\"))return h;let m=h;const I=[];for(const y of b)for(;;){const C=y.exec(h);if(!C)break;I.push([C.index,y.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(m="";;){const y=d.exec(h);if(!y)break;const C=I.some(([W,H])=>y.index<H&&W<d.lastIndex);!k.test(y[0])&&!C&&(m+=h.substring(w,y.index)+"<REDACTED: user-file-path>",w=d.lastIndex)}return w<h.length&&(m+=h.substr(w)),m}function s(h){if(!h)return h;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of b)if(m.regex.test(h))return`<REDACTED: ${m.label}>`;return h}function c(h,b){return(0,E.$bn)(h,m=>{if(m instanceof g||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let I=m.replaceAll("%20"," ");I=r(I,b);for(const k of b)I=I.replace(k,"");return I=s(I),I}})}e.$Do=c}),define(Pe[194],Ae([1,0,13,96,22,21,2,11,74,58]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0;function A(c,h){return c.uuid&&h.uuid?c.uuid===h.uuid:c.id===h.id?!0:(0,E.$Ze)(c.id,h.id)===0}e.$Eo=A;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(h){const b=h.manifest?h.manifest.version:h.version,m=h.manifest?h.targetPlatform:h.properties.targetPlatform;return new a(h.identifier,b,m)}static parse(h){const b=S.exec(h);return b&&b[1]&&b[2]?new a({id:b[1]},b[2],b[4]||void 0):null}constructor(h,b,m="undefined"){this.version=b,this.targetPlatform=m,this.id=h.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(h){return h instanceof a?A(this,h)&&this.version===h.version&&this.targetPlatform===h.targetPlatform:!1}}e.$Fo=a;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(c){const h=v.exec(c);return h&&h[1]?[t(h[1]),h[2]]:[t(c),void 0]}e.$Go=p;function f(c,h){return`${c}.${h}`}e.$Ho=f;function t(c){return c.toLowerCase()}e.$Io=t;function i(c,h){return t(f(c??P.$7l,h))}e.$Jo=i;function n(c,h){const b=[],m=I=>{for(const k of b)if(k.some(d=>A(h(d),h(I))))return k;return null};for(const I of c){const k=m(I);k?k.push(I):b.push([I])}return b}e.$Ko=n;function u(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$Lo=u;function o(c){return{id:new g.$oo(c.identifier.id),name:new g.$oo(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$Mo=o,e.$No=new P.$$l("pprice.better-merge");function l(c,h){const b=[],m=h.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const I=m.shift();if(I&&b.every(k=>!A(k.identifier,{id:I}))){const k=c.filter(d=>A(d.identifier,{id:I}));k.length===1&&(b.push(k[0]),m.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.$Oo=l;async function r(c,h){if(!M.$k)return!1;let b;try{b=(await c.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await c.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){h.debug("Error while getting the os-release file.",(0,$.$9)(I))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(c,h){const b=await r(c,h),m=(0,L.$$n)(b?"alpine":M.$u,D.$dc);return h.debug("ComputeTargetPlatform:",m),m}e.$Po=s}),define(Pe[195],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function E(D){return[...D.entries()]}e.$qr=E;function L(D){return D?[...D.entries()]:[]}e.$rr=L;function P(D){return new Map(D)}e.$sr=P;function M(D){return new Map(D??[])}e.$tr=M;function R(D){return Array.from(D.entries()).map(g=>[g[0],E(g[1].map),L(g[1].descriptionMap)])}e.$ur=R;function $(D){return new Map(D.map(g=>[g[0],{map:P(g[1]),descriptionMap:M(g[2])}]))}e.$vr=$}),define(Pe[196],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qqb=void 0;class E{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,M,R=5){const $=M(D=>{const g=typeof D=="string"?D:D.data;let A=this.a.get(P);if(A){A.data.push(g);return}const S=setTimeout(()=>this.flushBuffer(P),R);A={data:[g],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(P),$.dispose()}},this.a.set(P,A)});return $}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const M=this.a.get(P);M&&(this.a.delete(P),this.b(P,M.data.join("")))}}e.$qqb=E}),define(Pe[197],Ae([1,0,12,90,45,5,16,2,155,73,30]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.IconFontDefinition=e.IconContribution=e.$$v=void 0,e.$$v={IconContribution:"base.contributions.icons"};var S;(function(o){function l(r,s){let c=r.defaults;for(;P.ThemeIcon.isThemeIcon(c);){const h=p.getIcon(c.id);if(!h)return;c=h.defaults}return c}o.getDefinition=l})(S||(e.IconContribution=S={}));var a;(function(o){function l(s){return{weight:s.weight,style:s.style,src:s.src.map(c=>({format:c.format,location:c.location.toString()}))}}o.toJSONObject=l;function r(s){const c=h=>(0,R.$Bf)(h)?h:void 0;if(s&&Array.isArray(s.src)&&s.src.every(h=>(0,R.$Bf)(h.format)&&(0,R.$Bf)(h.location)))return{weight:c(s.weight),style:c(s.style),src:s.src.map(h=>({format:h.format,location:$.URI.parse(h.location)}))}}o.fromJSONObject=r})(a||(e.IconFontDefinition=a={}));class v{constructor(){this.a=new M.$Qd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,r,s,c){const h=this.b[l];if(h){if(s&&!h.description){h.description=s,this.d.properties[l].markdownDescription=`${s} $(${l})`;const I=this.e.enum.indexOf(l);I!==-1&&(this.e.enumDescriptions[I]=s),this.a.fire()}return h}const b={id:l,description:s,defaults:r,deprecationMessage:c};this.b[l]=b;const m={$ref:"#/definitions/icons"};return c&&(m.deprecationMessage=c),s&&(m.markdownDescription=`${s}: $(${l})`),this.d.properties[l]=m,this.e.enum.push(l),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const r=this.e.enum.indexOf(l);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,r){const s=this.f[l];return s||(this.f[l]=r,this.a.fire(),r)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(h,b)=>h.id.localeCompare(b.id),r=h=>{for(;P.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(h=>this.b[h]);for(const h of c.filter(b=>!!b.description).sort(l))s.push(`|<i class="${r(h)}"></i>|${h.id}|${P.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const h of c.filter(b=>!P.ThemeIcon.isThemeIcon(b.defaults)).sort(l))s.push(`|<i class="${r(h)}"></i>|${h.id}|`);return s.join(`
`)}}const p=new v;A.$ln.add(e.$$v.IconContribution,p);function f(o,l,r,s){return p.registerIcon(o,l,r,s)}e.$_v=f;function t(){return p}e.$aw=t;function i(){const o=(0,L.$Xj)();for(const l in o){const r="\\"+o[l].toString(16);p.registerIcon(l,{fontCharacter:r})}}i(),e.$bw="vscode://schemas/icons";const n=A.$ln.as(g.$mn.JSONContribution);n.registerSchema(e.$bw,p.getIconSchema());const u=new E.$9g(()=>n.notifySchemaChanged(e.$bw),200);p.onDidChange(()=>{u.isScheduled()||u.schedule()}),e.$cw=f("widget-close",L.$Zj.close,(0,D.localize)(2,null)),e.$dw=f("goto-previous-location",L.$Zj.arrowUp,(0,D.localize)(3,null)),e.$ew=f("goto-next-location",L.$Zj.arrowDown,(0,D.localize)(4,null)),e.$fw=P.ThemeIcon.modify(L.$Zj.sync,"spin"),e.$gw=P.ThemeIcon.modify(L.$Zj.loading,"spin")}),define(Pe[198],Ae([1,0,5,40,4,15]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,P.$Uh)("tunnelService"),e.$ev=(0,P.$Uh)("sharedTunnelsService");var R;(function(t){t.Http="http",t.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})($||(e.TunnelPrivacyId=$={}));function D(t){return!!t.forwardPort}e.$fv=D;var g;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function A(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$gv=A,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(t){return e.$hv.indexOf(t)>=0}e.$iv=S,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(t){return e.$jv.indexOf(t)>=0}e.$kv=a;function v(t,i,n,u){if(n===1)return!1;if(n===2&&a(i)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(o?.length===4&&parseInt(o[1])>=18)return!1}return t<1024}e.$lv=v;class p{constructor(i,n,u){this.remoteAddress=i,this.localAddress=n,this.b=u,this.a=new E.$Qd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=p;let f=class{constructor(i,n){this.j=i,this.k=n,this.a=new E.$Qd,this.onTunnelOpened=this.a.event,this.b=new E.$Qd,this.onTunnelClosed=this.b.event,this.c=new E.$Qd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],n=Array.from(this.e.values());for(const u of n){const o=Array.from(u.values());for(const l of o){const r=await l.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:n}of i.values())await n.then(u=>typeof u!="string"?u?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,n,u,o,l){this.p(i,n,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:n,localAddress:u,privacy:o,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,n){(a(i)||S(i))&&(i=e.$hv[0]);const u=this.r(i,n);if(u)return++u.refcount,u.value}openTunnel(i,n,u,o,l,r=!1,s,c){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${u} on local port ${l}.`);const h=this.f??i;if(!h)return;if(n||(n="localhost"),o||(o=this.l),this.f&&this.i.has(u)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.s(h,n,u,o,l,r,s,c);return b?b.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,u),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,u);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(m);return(m.tunnelRemoteHost!==n||m.tunnelRemotePort!==u)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&m.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const n=this.e.get(i.tunnelRemoteHost);if(n){const u=n.get(i.tunnelRemotePort);u&&(u.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,u))}}}}async o(i,n,u){if(u.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${n}.`);const o=u.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(n),o}}async closeTunnel(i,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${n} `);const u=this.e.get(i);if(u&&u.has(n)){const o=u.get(n);o.refcount=0,await this.o(i,n,o)}}p(i,n,u){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(n,{refcount:1,value:u})}async q(i,n){const u=this.e.get(i);if(u){const o=u.get(n),l=o?await o.value:void 0;(!l||typeof l=="string")&&u.delete(n),u.size===0&&this.e.delete(i)}}r(i,n){const u=[i];S(i)?(u.push(...e.$hv),u.push(...e.$jv)):a(i)&&u.push(...e.$jv);const o=u.map(l=>this.e.get(l));for(const l of o){const r=l?.get(n);if(r)return r}}canTunnel(i){return!!A(i)}t(i,n,u,o,l,r,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${u} on local port ${o}.`);const c=u;this.i.add(c);const h=o===void 0?u:o,b={elevationRequired:l?this.isPortPrivileged(h):!1},m={remoteAddress:{host:n,port:u},localAddressPort:o,privacy:r,public:r?r!==$.Private:void 0,protocol:s},I=i.forwardPort(m,b);return I?(this.p(n,u,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(c)})):this.i.delete(c),I}};e.$nv=f,e.$nv=f=Ke([Ve(0,M.$cj),Ve(1,L.$oi)],f)}),define(Pe[199],Ae([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ov=void 0,e.$ov=(0,E.$Uh)("editSessionIdentityService");var L;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Pe[200],Ae([1,0,14]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=void 0;function L(D){return D.scheme!==E.Schemas.file&&D.scheme!==E.Schemas.vscodeRemote}e.$6J=L;function P(D){if(D.folders.length)return D.folders.every(g=>L(g.uri))?D.folders[0].uri:void 0;if(D.configuration&&L(D.configuration))return D.configuration}e.$7J=P;function M(D){return P(D)?.scheme}e.$8J=M;function R(D){return P(D)?.authority}e.$9J=R;function $(D){return P(D)!==void 0}e.$0J=$}),define(Pe[47],Ae([1,0,156,19,51,25,2,4,14]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.WorkbenchState=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0,e.$4h=(0,$.$Uh)("contextService");function g(h){const b=h;return typeof b?.id=="string"&&R.URI.isUri(b.uri)}e.$5h=g;function A(h){return typeof h?.id=="string"&&!g(h)&&!a(h)}e.$6h=A,e.$7h={id:"ext-dev"},e.$8h={id:"empty-window"};function S(h,b){if(typeof h=="string"||typeof h>"u")return typeof h=="string"?{id:(0,L.$mc)(h)}:b?e.$7h:e.$8h;const m=h;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$9h=S;function a(h){const b=h;return typeof b?.id=="string"&&R.URI.isUri(b.configPath)}e.$0h=a;function v(h){const b=h;if(b?.uri)return{id:b.id,uri:R.URI.revive(b.uri)};const m=h;if(m?.configPath)return{id:m.id,configPath:R.URI.revive(m.configPath)};if(h?.id)return{id:h.id}}e.$$h=v;var p;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function f(h){const b=h;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.$_h=f;function t(h){const b=h;return!!(b&&typeof b=="object"&&R.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.$ai=t;class i{constructor(b,m,I,k,d){this.h=b,this.j=I,this.k=k,this.l=d,this.c=P.$1h.forUris(this.l,()=>!0),this.folders=m}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=P.$1h.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$bi=i;class n{constructor(b,m){this.raw=m,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,M.$yg)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ci=n;function u(h){return new n({uri:h,index:0,name:(0,M.$ug)(h)},{uri:h.toString()})}e.$di=u,e.$ei="code-workspace",e.$fi=`.${e.$ei}`,e.$gi=[{name:(0,E.localize)(0,null),extensions:[e.$ei]}],e.$hi="workspace.json";function o(h,b){return M.$pg.isEqualOrParent(h,b.untitledWorkspacesHome)}e.$ii=o;function l(h){let b;return R.URI.isUri(h)?b=h:b=h.configuration,b?.scheme===D.Schemas.tmp}e.$ji=l,e.$ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(h){return h.id===e.$ki}e.$li=r;function s(h,b){return!o(h,b)&&!l(h)}e.$mi=s;function c(h){return(typeof h=="string"?(0,L.$nc)(h):(0,M.$wg)(h))===e.$fi}e.$ni=c}),define(Pe[75],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class E{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const M=this.c++;return this.b.set(M,P),this.e(),M}get(P,M){return this.b.has(P)?this.b.get(P)[M]:void 0}delete(P){this.b.delete(P),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$wdc=E}),define(Pe[42],Ae([1,0,14,25,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=e.$ydc=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new L.$ng($=>{const D=this.b.get($.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos($,D){D===null?this.b.delete($.scheme):this.b.set($.scheme,D)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$ydc=M,e.$zdc=(0,P.$Uh)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0,e.$RM=(0,E.$Uh)("IExtHostInitDataService")}),define(Pe[201],Ae([1,0,162,15,188,27]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;let R=class extends P.$YN{constructor(D,g,A){const S=A.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",a=A.remote.isRemote?(0,E.localize)(0,null):D?(0,E.localize)(1,null):(0,E.localize)(2,null);super(g.createLogger(S,{name:a}))}};e.$Hfc=R,e.$Hfc=R=Ke([Ve(1,L.$dj),Ve(2,M.$RM)],R)}),define(Pe[202],Ae([1,0,12]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=void 0;class L{constructor(R,$,D){this.h=new Map,this.a=R,this.b=$,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new E.$9g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of g.values())A.complete()}catch(A){for(const S of g.values())S.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let D=this.f[R];return typeof D>"u"&&(D=$),D}update(R,$){this.f[R]=$;const D=this.h.get(R);if(D!==void 0)return D.p;const g=new E.$hh;return this.h.set(R,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$2dc=L;class P extends L{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$3dc=P}),define(Pe[203],Ae([1,0,5,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class P{constructor(R){this.c=R,this.a=new E.$Qd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Qd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,D,g){const S=this.c.getNotebookDocument(L.URI.revive(R)).acceptModelChanged($.value,D,g);this.b.fire(S)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(L.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(L.URI.revive(R));this.a.fire($.apiNotebook)}}e.$ofc=P}),define(Pe[17],Ae([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=void 0,e.$BM=(0,E.$Uh)("IExtHostRpcService");class L{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$CM=L}),define(Pe[204],Ae([1,0,22,5]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class P{#e;constructor(R,$){this.b=new L.$Qd,this.onDidChange=this.b.event,this.a=E.$$l.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$bec=P}),define(Pe[59],Ae([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=e.$Jdc=void 0,e.$Jdc=(0,E.$Uh)("IURITransformerService");class L{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$Kdc=L}),define(Pe[205],Ae([1,0,24]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdb=e.$idb=void 0;class L{constructor(){this.buffers=[]}add(D){let g=this.buffers.indexOf(D);return g<0&&(g=this.buffers.length,this.buffers.push(D)),g}}function P($,D){if(D.serializeBuffersForPostMessage){const g=new L,S=JSON.stringify($,(v,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p)};if(ArrayBuffer.isView(p)){const f=M(p);if(f)return{$$vscode_array_buffer_reference$$:!0,index:g.add(p.buffer),view:{type:f,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),a=g.buffers.map(v=>{const p=new Uint8Array(v);return E.$ee.wrap(p)});return{message:S,buffers:a}}else return{message:JSON.stringify($),buffers:[]}}e.$idb=P;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,D){const g=D.map(a=>{const v=new ArrayBuffer(a.byteLength);return new Uint8Array(v).set(a.buffer),v}),A=D.length?(a,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const p=v,{index:f}=p,t=g[f];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return v}:void 0;return{message:JSON.parse($,A),arrayBuffers:g}}e.$jdb=R}),define(Pe[102],Ae([1,0,172,16,2,6,4,30,41,14,39,134,31]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AE=e.$zE=e.$yE=e.EditorsOrder=e.$xE=e.CloseDirection=e.$wE=e.$vE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.EditorInputCapabilities=e.$mE=e.SaveReason=e.Verbosity=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.$eE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=void 0,e.$_D={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$aE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$bE="workbench.editor.sidebysideEditor",e.$cE="workbench.editors.textDiffEditor",e.$dE="workbench.editors.binaryResourceDiffEditor";var v;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var p;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function f(oe){const X=oe;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.$eE=f;function t(oe,X,j){for(const ne of j.visibleEditorPanes)if(ne.group.id===X&&oe.matches(ne.input))return ne.getViewState()}e.$fE=t;function i(oe){if(I(oe))return!1;const X=oe;return P.URI.isUri(X?.resource)}e.$gE=i;function n(oe){if(I(oe))return!1;const X=oe;return X?.original!==void 0&&X.modified!==void 0}e.$hE=n;function u(oe){if(I(oe))return!1;const X=oe;return Array.isArray(X?.resources)}e.$iE=u;function o(oe){if(I(oe)||n(oe))return!1;const X=oe;return X?.primary!==void 0&&X.secondary!==void 0}e.$jE=o;function l(oe){if(I(oe))return!1;const X=oe;return X?X.resource===void 0||X.resource.scheme===g.Schemas.untitled||X.forceUntitled===!0:!1}e.$kE=l;function r(oe){if(I(oe))return!1;const X=oe;return P.URI.isUri(X?.base?.resource)&&P.URI.isUri(X?.input1?.resource)&&P.URI.isUri(X?.input2?.resource)&&P.URI.isUri(X?.result?.resource)}e.$lE=r;var s;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var c;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class h{constructor(){this.a=new Map}registerSource(X,j){let ne=this.a.get(X);return ne||(ne={source:X,label:j},this.a.set(X,ne)),ne.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.$mE=new h;var b;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(b||(e.EditorInputCapabilities=b={}));class m extends M.$Rc{}e.$nE=m;function I(oe){return oe instanceof m}e.$oE=I;function k(oe){const X=oe;return P.URI.isUri(X?.preferredResource)}function d(oe){const X=oe;return I(X?.primary)&&I(X?.secondary)}e.$pE=d;function w(oe){const X=oe;return I(X?.modified)&&I(X?.original)}e.$qE=w;function y(oe,X,j,ne,pe){return Re(ne,[(0,S.$Ei)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const re={...j,limits:{size:Number.MAX_VALUE}};oe.openEditor(X,re)}}),(0,S.$Ei)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}e.$rE=y;function C(oe){return I(oe?.editor)}e.$sE=C;function W(oe){const X=oe;return C(oe)&&X?.group!==void 0}e.$tE=W;function H(oe){const X=oe;return typeof X?.groupId=="number"&&I(X.editor)}e.$uE=H;var U;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var z;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var F;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class N{getOriginalUri(X,j){if(!X)return;if(r(X))return e.$wE.getOriginalUri(X.result,j);if(j?.supportSideBySide){const{primary:pe,secondary:re}=this.a(X);if(pe&&re){if(j?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(pe,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===F.ANY)return this.getOriginalUri(pe,{filterByScheme:j.filterByScheme})??this.getOriginalUri(re,{filterByScheme:j.filterByScheme});X=j.supportSideBySide===F.PRIMARY?pe:re}}if(n(X)||u(X)||o(X)||r(X))return;const ne=k(X)?X.preferredResource:X.resource;return!ne||!j||!j.filterByScheme?ne:this.b(ne,j.filterByScheme)}a(X){return d(X)||o(X)?{primary:X.primary,secondary:X.secondary}:w(X)||n(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,j){if(!X)return;if(r(X))return e.$wE.getCanonicalUri(X.result,j);if(j?.supportSideBySide){const{primary:pe,secondary:re}=this.a(X);if(pe&&re){if(j?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(pe,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===F.ANY)return this.getCanonicalUri(pe,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:j.filterByScheme});X=j.supportSideBySide===F.PRIMARY?pe:re}}if(n(X)||u(X)||o(X)||r(X))return;const ne=X.resource;return!ne||!j||!j.filterByScheme?ne:this.b(ne,j.filterByScheme)}b(X,j){if(Array.isArray(j)){if(j.some(ne=>X.scheme===ne))return X}else if(j===X.scheme)return X}}var x;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(x||(e.EditorCloseMethod=x={}));function J(oe,X,j,ne){if(!oe.isSticky(X))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return j===x.MOUSE||j===x.KEYBOARD;case"mouse":return j===x.MOUSE;case"keyboard":return j===x.KEYBOARD}return!1}e.$vE=J,e.$wE=new N;var Ee;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(Ee||(e.CloseDirection=Ee={}));class De{constructor(){this.c=new Map,this.d=new Map}start(X){const j=this.a=X.get(R.$Th);for(const[ne,pe]of this.c)this.e(ne,pe,j);this.c.clear()}e(X,j,ne){const pe=ne.createInstance(j);this.d.set(X,pe)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,L.$Mf)(this.b)}registerEditorSerializer(X,j){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,j,this.a):this.c.set(X,j),(0,M.$Pc)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}$.$ln.add(e.$_D.EditorFactory,new De);async function Ce(oe,X,j){return!oe||!oe.length?[]:await Promise.all(oe.map(async ne=>{const pe=P.URI.revive(ne.fileUri);if(!pe){j.info("Cannot resolve the path because it is not valid.",ne);return}if(!await X.canHandleResource(pe)){j.info("Cannot resolve the path because it cannot be handled",ne);return}let he=ne.exists,ue=ne.type;if(typeof he!="boolean"||typeof ue!="number")try{ue=(await X.stat(pe)).isDirectory?D.FileType.Directory:D.FileType.Unknown,he=!0}catch(ee){j.error(ee),he=!1}if(!he&&ne.openOnlyIfExists){j.info("Cannot resolve the path because it does not exist",ne);return}if(ue===D.FileType.Directory){j.info("Cannot resolve the path because it is a directory",ne);return}const we={...ne.options,pinned:!0};return he?{resource:pe,options:we}:{resource:pe,options:we,forceUntitled:!0}}))}e.$xE=Ce;var fe;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(fe||(e.EditorsOrder=fe={}));function be(oe){const X=oe;if(!X)return!1;const j=X;if(j.modified)return be(j.modified);const ne=X;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$yE=be;function se(oe){return(0,A.$Gi)(oe)}e.$zE=se;function Re(oe,X,j){const ne=(0,A.$Hi)(oe,X);return ne.forceMessage=j?.forceMessage,ne.forceSeverity=j?.forceSeverity,ne.allowDialog=j?.allowDialog,ne}e.$AE=Re}),define(Pe[206],Ae([1,0,5,173,4,6,28,30,18,26,90,197]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JE=e.$IE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$HE=e.$GE=e.ViewContentGroups=e.$FE=e.$EE=e.ViewContainerLocation=e.Extensions=e.$DE=e.$CE=e.$BE=void 0,e.$BE="views",e.$CE=(0,L.localize)(0,null),e.$DE=(0,S.$_v)("default-view-icon",A.$Zj.window,(0,L.localize)(1,null));var a;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(a||(e.Extensions=a={}));var v;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$EE=[0,1,2];function p(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$FE=p;class f extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Qd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Qd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.$Qb)([...this.g.values()])}registerViewContainer(c,h,b){const m=this.get(c.id);if(m)return m;const I=c;return I.openCommandActionDescriptor=b?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,R.$wc)(this.g,h,[]).push(I),b?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:h}),I}deregisterViewContainer(c){for(const h of this.g.keys()){const b=this.g.get(h),m=b?.indexOf(c);if(m!==-1){b?.splice(m,1),b.length===0&&this.g.delete(h),this.f.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(b=>b?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(h=>this.getViewContainerLocation(h)===c)}}$.$ln.add(a.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,c){const h=s.group??t.More,b=c.group??t.More;return h!==b?h.localeCompare(b):(s.order??5)-(c.order??5)}class n extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Qd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Qd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Qd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Qd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:b})=>this.r(h,b)),this.c.fire(c)}deregisterViews(c,h){const b=this.s(c,h);b.length&&this.f.fire({views:b,viewContainer:h})}moveViews(c,h){for(const b of this.m.keys())if(b!==h){const m=this.s(c,b);m.length&&(this.r(m,h),this.g.fire({views:m,from:b,to:h}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const h of this.j){const b=(this.m.get(h)||[]).filter(m=>m.id===c)[0];if(b)return b}return null}getViewContainer(c){for(const h of this.j)if((this.m.get(h)||[]).filter(m=>m.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this.n.add(c,h),this.h.fire(c),(0,M.$Pc)(()=>{this.n.delete(c,h),this.h.fire(c)})}registerViewWelcomeContent2(c,h){const b=new Map;for(const[m,I]of h)this.n.add(c,I),b.set(m,(0,M.$Pc)(()=>{this.n.delete(c,I),this.h.fire(c)}));return this.h.fire(c),b}getViewWelcomeContent(c){const h=[];return this.n.forEach(c,b=>h.push(b)),h.sort(i)}r(c,h){let b=this.m.get(h);b||(b=[],this.m.set(h,b),this.j.push(h));for(const m of c){if(this.getView(m.id)!==null)throw new Error((0,L.localize)(2,null,m.id));b.push(m)}}s(c,h){const b=this.m.get(h);if(!b)return[];const m=[],I=[];for(const k of b)c.includes(k)?m.push(k):I.push(k);return m.length&&(I.length?this.m.set(h,I):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),m}}$.$ln.add(a.ViewsRegistry,new n),e.$GE=(0,P.$Uh)("viewsService"),e.$HE=(0,P.$Uh)("viewDescriptorService");var u;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(u||(e.ViewVisibilityState=u={}));var o;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class l{constructor(c,h){this.c=!1,this.d=!1,(0,g.$cn)(this,c),this.d=!!h,this.resolve=async b=>{if(h&&!this.c){const m=await h(b);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}b.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$IE=l;class r extends Error{constructor(c){super((0,L.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$JE=r}),define(Pe[207],Ae([1,0,2,29,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$$E=e.$0E=void 0;function M(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof E.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(L.$zs.isIRange)}e.$0E=M;function R(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(M)}e.$$E=R;var $;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var D;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(D||(e.InteractiveSessionCopyKind=D={})),e.$_E=(0,P.$Uh)("IChatService")}),define(Pe[208],Ae([1,0,5,12,174]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Qd,this.n=new E.$Qd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,D,g,A){const S={command:$};if(D&&Object.keys(D).length>0&&(S.arguments=D),this.s("request",S),typeof A=="number"){const a=setTimeout(()=>{clearTimeout(a);const v=this.f.get(S.seq);if(v){this.f.delete(S.seq);const p={type:"response",seq:0,request_seq:S.seq,success:!1,command:$,message:(0,P.localize)(0,null,A,$)};v(p)}},A)}return g&&this.f.set(S.seq,g),S.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,D){return $.type!=="event"||D.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,L.$Xg)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const D=$,g=this.f.get(D.request_seq);g&&(this.f.delete(D.request_seq),g(D));break}}}}s($,D){D.type=$,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((D,g)=>$.set(g,D)),await(0,L.$Xg)(500),$.forEach((D,g)=>{D({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Odb=M}),define(Pe[209],Ae([1,0,175,34,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$mH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$lH=e.MemoryRangeType=e.$kH=e.State=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=void 0,e.$hG="workbench.view.debug",e.$iG="workbench.debug.variablesView",e.$jG="workbench.debug.watchExpressionsView",e.$kG="workbench.debug.callStackView",e.$lG="workbench.debug.loadedScriptsView",e.$mG="workbench.debug.breakPointsView",e.$nG="workbench.debug.disassemblyView",e.$oG="workbench.panel.repl",e.$pG="workbench.panel.repl.view",e.$qG=new L.$_i("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$rG=new L.$_i("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$sG=new L.$_i("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$tG="debugUx",e.$uG=new L.$_i(e.$tG,"default",{type:"string",description:E.localize(3,null)}),e.$vG=new L.$_i("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$wG=new L.$_i("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$xG=new L.$_i("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$yG=new L.$_i("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$zG=new L.$_i("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$AG=new L.$_i("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$BG=new L.$_i("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$CG=new L.$_i("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$DG=new L.$_i("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$EG=new L.$_i("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$FG=new L.$_i("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$GG=new L.$_i("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$HG=new L.$_i("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$IG=new L.$_i("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$JG=new L.$_i("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$KG=new L.$_i("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$LG=new L.$_i("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$MG=new L.$_i("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$NG=new L.$_i("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$OG=new L.$_i("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$PG=new L.$_i("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$QG=new L.$_i("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$RG=new L.$_i("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$SG=new L.$_i("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$TG=new L.$_i("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$UG=new L.$_i("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$VG=new L.$_i("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$WG=new L.$_i("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$XG=new L.$_i("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$YG=new L.$_i("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$ZG=new L.$_i("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$1G=new L.$_i("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$2G=new L.$_i("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$3G=new L.$_i("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$4G=new L.$_i("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$5G=new L.$_i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$6G=new L.$_i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$7G=new L.$_i("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$8G=new L.$_i("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$9G=new L.$_i("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$0G=new L.$_i("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$$G=new L.$_i("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$_G=new L.$_i("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$aH=new L.$_i("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$bH=new L.$_i("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$cH=new L.$_i("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$dH=new L.$_i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$eH=new L.$_i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=a=>E.localize(52,null,a);e.$fH=M,e.$gH="editor.contrib.debug",e.$hH="editor.contrib.breakpoint",e.$iH="debug",e.$jH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(a){a[a.Inactive=0]="Inactive",a[a.Initializing=1]="Initializing",a[a.Stopped=2]="Stopped",a[a.Running=3]="Running"})(R||(e.State=R={}));function $(a){switch(a){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$kH=$;var D;(function(a){a[a.Valid=0]="Valid",a[a.Unreadable=1]="Unreadable",a[a.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$lH="vscode-debug-memory";var g;(function(a){a[a.Initial=1]="Initial",a[a.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var A;(function(a){a.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$mH=(0,P.$Uh)("debugService");var S;(function(a){a[a.CONDITION=0]="CONDITION",a[a.HIT_COUNT=1]="HIT_COUNT",a[a.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Pe[210],Ae([1,0,13,2,19,26,14,29,20,18]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.$IF=void 0;const A=/{([^}]+)}/g;function S(k,d,w){return k.replace(A,function(y,C){return d&&C.length>0&&C[0]!=="_"?y:w&&w.hasOwnProperty(C)?w[C]:y})}e.$IF=S;function a(k){const d={};for(const w of Object.keys(k))w.startsWith("!")||(d[w]=k[w]);return d}e.$JF=a;function v(k){return k.configuration.request==="attach"&&!p(k)&&(!k.parentSession||v(k.parentSession))}e.$KF=v;function p(k){let d=k.configuration.type;if(d)return d==="vslsShare"&&(d=k.configuration.adapterProxy.configuration.type),(0,E.$5e)(d,"extensionhost")||(0,E.$5e)(d,"pwa-extensionhost")?k:k.parentSession?p(k.parentSession):void 0}e.$LF=p;function f(k){return k.type&&(k.label||k.program||k.runtime)}e.$MF=f;function t(k,d,w){let y,C=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let H=null;for(;H=W.exec(k);){const U=H.index+1,z=U+H[0].length;if(U<=d&&z>=w){y=H[0],C=U;break}}if(y){const U=/\w+/g;let z=null;for(;(z=U.exec(y))&&!(z.index+1+C+z[0].length>=w););z&&(y=y.substring(0,U.lastIndex))}return y?{start:C,end:C+y.length-1}:{start:0,end:0}}e.$NF=t;async function i(k,d,w,y){if(k.evaluatableExpressionProvider.has(d)){const C=k.evaluatableExpressionProvider.ordered(d),W=(0,g.$Gb)(await Promise.all(C.map(async H=>{try{return await H.provideEvaluatableExpression(d,w,y??D.CancellationToken.None)}catch{return}})));if(W.length>0){let H=W[0].expression;const U=W[0].range;return H||(H=d.getLineContent(w.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:H}}}else{const C=d.getLineContent(w.lineNumber),{start:W,end:H}=t(C,w.column,w.column),U=C.substring(W-1,H);return{matchingExpression:U,range:new $.$zs(w.lineNumber,W,w.lineNumber,W+U.length)}}return null}e.$OF=i;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function u(k){return!!(k&&k.match(n))}e.$PF=u;function o(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(u(k.path))return L.URI.parse(k.path);if((0,P.$hc)(k.path))return L.URI.file(k.path)}return k.path}function l(k){if(typeof k.path=="object"){const d=L.URI.revive(k.path);if(d)return d.scheme===R.Schemas.file?d.fsPath:d.toString()}return k.path}function r(k,d){const w=d?o:l,y=(0,M.$_m)(k);return c(y,(C,W)=>{C&&W&&(W.path=w(W))}),y}e.$QF=r;function s(k,d){const w=d?o:l,y=(0,M.$_m)(k);return c(y,(C,W)=>{!C&&W&&(W.path=w(W))}),y}e.$RF=s;function c(k,d){switch(k.type){case"event":{const w=k;switch(w.event){case"output":d(!1,w.body.source);break;case"loadedSource":d(!1,w.body.source);break;case"breakpoint":d(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=k;switch(w.command){case"setBreakpoints":d(!0,w.arguments.source);break;case"breakpointLocations":d(!0,w.arguments.source);break;case"source":d(!0,w.arguments.source);break;case"gotoTargets":d(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(y=>d(!1,y));break;default:break}break}case"response":{const w=k;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(y=>d(!1,y.source));break;case"loadedSources":w.body.sources.forEach(y=>d(!1,y));break;case"scopes":w.body.scopes.forEach(y=>d(!1,y.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(y=>d(!1,y.source));break;case"setBreakpoints":w.body.breakpoints.forEach(y=>d(!1,y.source));break;case"disassemble":w.body?.instructions.forEach(C=>d(!1,C.location));break;default:break}break}}}function h(k){return k.filter(d=>!d.presentation?.hidden).sort((d,w)=>d.presentation?w.presentation?d.presentation.group?w.presentation.group?d.presentation.group!==w.presentation.group?d.presentation.group.localeCompare(w.presentation.group):b(d.presentation.order,w.presentation.order):-1:w.presentation.group?1:b(d.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$SF=h;function b(k,d){return typeof k!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:k-d}async function m(k,d){const w=k.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(w!=="none"&&(await d.saveAll(),w==="allEditorsInActiveGroup")){const y=d.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await d.save({editor:y.input,groupId:y.group.id})}await k.reloadConfiguration()}e.$TF=m;const I=(k,d)=>!k||!d?k===d:k.name===d.name&&k.path===d.path&&k.sourceReference===d.sourceReference;e.$UF=I}),define(Pe[76],Ae([1,0,24,33,68,69,14,19,21,34]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=e.$EI=e.$DI=e.$CI=e.CellStatusbarAlignment=e.$BI=e.$AI=e.$zI=e.NotebookEditorPriority=e.$yI=e.$xI=e.$wI=e.$vI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$uI=e.$tI=e.$sI=e.$rI=e.CellKind=e.$qI=e.$pI=e.$oI=void 0,e.$oI="workbench.editor.notebook",e.$pI="workbench.editor.notebookTextDiffEditor",e.$qI="workbench.editor.interactive";var A;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(A||(e.CellKind=A={})),e.$rI=["application/json","application/javascript","text/html","image/svg+xml",M.$Vr.latex,M.$Vr.markdown,"image/png","image/jpeg",M.$Vr.text],e.$sI=[M.$Vr.latex,M.$Vr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Vr.text],e.$tI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$uI="_notAvailable";var S;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var a;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(a||(e.NotebookCellExecutionState=a={}));var v;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var p;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var f;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var u;(function(N){N.scheme=R.Schemas.vscodeNotebookCell;const x=["W","X","Y","Z","a","b","c","d","e","f"],J=new RegExp(`^[${x.join("")}]+`),Ee=7;function De(oe,X){const j=X.toString(Ee),pe=`${j.length<x.length?x[j.length-1]:"z"}${j}s${(0,E.$ye)(E.$ee.fromString(oe.scheme),!0,!0)}`;return oe.with({scheme:N.scheme,fragment:pe})}N.generate=De;function Ce(oe){if(oe.scheme!==N.scheme)return;const X=oe.fragment.indexOf("s");if(X<0)return;const j=parseInt(oe.fragment.substring(0,X).replace(J,""),Ee),ne=(0,E.$xe)(oe.fragment.substring(X+1)).toString();if(!isNaN(j))return{handle:j,notebook:oe.with({scheme:ne,fragment:null})}}N.parse=Ce;function fe(oe,X){return oe.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${X??""},${oe.scheme!==R.Schemas.file?oe.scheme:""}`})}N.generateCellOutputUri=fe;function be(oe){if(oe.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const X=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!X)return;const j=X[1]&&X[1]!==""?X[1]:void 0,ne=X[2];return{outputId:j,notebook:oe.with({scheme:ne||R.Schemas.file,fragment:null})}}N.parseCellOutputUri=be;function se(oe,X,j){return N.generate(oe,X).with({scheme:j})}N.generateCellPropertyUri=se;function Re(oe,X){if(oe.scheme===X)return N.parse(oe.with({scheme:N.scheme}))}N.parseCellPropertyUri=Re})(u||(e.CellUri=u={}));const o=N=>D.$i?N.replace(/\//g,"\\"):N;class l{constructor(x=[],J=e.$rI){this.e=J,this.d=[...new Set(x)].map(Ee=>({pattern:Ee,matches:L.$Bj(o(Ee))}))}sort(x){const J=new Map(P.Iterable.map(x,De=>[De,o(De)]));let Ee=[];for(const{matches:De}of this.d)for(const[Ce,fe]of J)if(De(fe)){Ee.push(Ce),J.delete(Ce);break}return J.size&&(Ee=Ee.concat([...J.keys()].sort((De,Ce)=>this.e.indexOf(De)-this.e.indexOf(Ce)))),Ee}prioritize(x,J){const Ee=this.f(x);if(Ee===-1){this.d.unshift({pattern:x,matches:L.$Bj(o(x))});return}const De=new Set(J.map(fe=>this.f(fe,Ee)));De.delete(-1);const Ce=Array.from(De).sort();this.d.splice(Ee+1,0,...Ce.map(fe=>this.d[fe]));for(let fe=Ce.length-1;fe>=0;fe--)this.d.splice(Ce[fe],1)}toArray(){return this.d.map(x=>x.pattern)}f(x,J=this.d.length){const Ee=o(x);for(let De=0;De<J;De++)if(this.d[De].matches(Ee))return De;return-1}}e.$vI=l;function r(N,x,J,Ee=(De,Ce)=>De===Ce){const De=[];function Ce(se,Re,oe){if(Re===0&&oe.length===0)return;const X=De[De.length-1];X&&X.start+X.deleteCount===se?(X.deleteCount+=Re,X.toInsert.push(...oe)):De.push({start:se,deleteCount:Re,toInsert:oe})}let fe=0,be=0;for(;;){if(fe===N.length){Ce(fe,0,x.slice(be));break}if(be===x.length){Ce(fe,N.length-fe,[]);break}const se=N[fe],Re=x[be];if(Ee(se,Re)){fe+=1,be+=1;continue}J(Re)?(Ce(fe,1,[]),fe+=1):(Ce(fe,0,[Re]),be+=1)}return De}e.$wI=r,e.$xI=new g.$_i("notebookEditorCursorAtBoundary","none"),e.$yI=new g.$_i("notebookEditorCursorAtLineBoundary","none");var s;(function(N){N.default="default",N.option="option"})(s||(e.NotebookEditorPriority=s={}));function c(N){const x=N;return!!((typeof x.include=="string"||L.$Cj(x.include))&&(typeof x.exclude=="string"||L.$Cj(x.exclude)))}e.$zI=c;function h(N,x,J){if(Array.isArray(N.viewType)&&N.viewType.indexOf(x)>=0||N.viewType===x)return!0;if(N.filenamePattern){const Ee=c(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,De=c(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(L.$Aj(Ee,(0,$.$mc)(J.fsPath).toLowerCase()))return!(De&&L.$Aj(De,(0,$.$mc)(J.fsPath).toLowerCase()))}return!1}e.$AI=h,e.$BI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var b;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class m{static{this.d="notebook/"}static create(x){return`${m.d}${x}`}static parse(x){if(x.startsWith(m.d))return x.substring(m.d.length)}}e.$CI=m;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$DI=I;const k=new TextDecoder;function d(N){const x=[];let J=!1;for(const fe of N)(x.length===0||J)&&(x.push(fe),J=!0);let Ee=C(x);const De=E.$ee.concat(x.map(fe=>E.$ee.wrap(fe))),Ce=F(De);return Ee=Ee||Ce.byteLength!==De.byteLength,{data:Ce,didCompression:Ee}}e.$EI=d,e.$FI=`${String.fromCharCode(27)}[A`;const w=e.$FI.split("").map(N=>N.charCodeAt(0)),y=10;function C(N){let x=!1;return N.forEach((J,Ee)=>{if(Ee===0||J.length<e.$FI.length)return;const De=N[Ee-1],Ce=J.subarray(0,e.$FI.length);if(Ce[0]===w[0]&&Ce[1]===w[1]&&Ce[2]===w[2]){const fe=De.lastIndexOf(y);if(fe===-1)return;x=!0,N[Ee-1]=De.subarray(0,fe),N[Ee]=J.subarray(e.$FI.length)}}),x}function W(N){let x=N;do N=x,x=N.replace(/[^\n]\x08/gm,"");while(x.length<N.length);return N}function H(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const x=N.match(/^(.*)\r+/m)[1];let J=N.match(/\r+(.*)$/m)[1];J=J+x.slice(J.length,x.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,J)}return N}const U="\b".charCodeAt(0),z="\r".charCodeAt(0);function F(N){return!N.buffer.includes(U)&&!N.buffer.includes(z)?N:E.$ee.fromString(H(W(k.decode(N.buffer))))}}),define(Pe[7],Ae([1,0,18,11,53,28,69,13,16,2,38,22,41,100,76]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p){"use strict";var f,t,i,n,u,o,l,r,s,c,h,b,m,I,k,d,w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$qM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.TestRunProfileKind=e.TestResultState=e.$9L=e.$8L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7L=e.$6L=e.$5L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.ColorThemeKind=e.$XL=e.$WL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VL=e.DebugConsoleMode=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PL=e.$OL=e.FileChangeType=e.$NL=e.$ML=e.$LL=e.$KL=e.InlineCompletionTriggerKind=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.ConfigurationTarget=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$nL=e.ViewBadge=e.ProgressLocation=e.$mL=e.$lL=e.TaskScope=e.ShellQuoting=e.$kL=e.$jL=e.$iL=e.TaskPanelKind=e.TaskRevealKind=e.$hL=e.TerminalLocation=e.$gL=e.$fL=e.$eL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$dL=e.$cL=e.$bL=e.$aL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$_K=e.StatusBarAlignment=e.ViewColumn=e.$$K=e.$0K=e.$9K=e.$8K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$7K=e.$6K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.LanguageStatusSeverity=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.CodeActionTriggerKind=e.$TK=e.$SK=e.SymbolTag=e.SymbolKind=e.$RK=e.DocumentHighlightKind=e.$QK=e.$PK=e.$OK=e.$NK=e.DiagnosticSeverity=e.DiagnosticTag=e.$MK=e.$LK=e.FileEditType=e.$KK=e.$JK=e.$IK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function C(B){return Object.assign(B,{apply:function(...ae){if(ae.length===0)return Reflect.construct(B,[]);{const ke=ae.length===1?[]:ae[1];return Reflect.construct(B,ke,ae[0].constructor)}},call:function(...ae){if(ae.length===0)return Reflect.construct(B,[]);{const[ke,...He]=ae;return Reflect.construct(B,He,ke.constructor)}}})}var W;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var H;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(H||(e.TerminalQuickFixType=H={}));let U=f=class{static from(...O){let ae=O;return new f(function(){if(ae){for(const ke of ae)ke&&typeof ke.dispose=="function"&&ke.dispose();ae=void 0}})}#e;constructor(O){this.#e=O}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$BK=U,e.$BK=U=f=Ke([C],U);let z=t=class{static Min(...O){if(O.length===0)throw new TypeError;let ae=O[0];for(let ke=1;ke<O.length;ke++){const He=O[ke];He.isBefore(ae)&&(ae=He)}return ae}static Max(...O){if(O.length===0)throw new TypeError;let ae=O[0];for(let ke=1;ke<O.length;ke++){const He=O[ke];He.isAfter(ae)&&(ae=He)}return ae}static isPosition(O){if(!O)return!1;if(O instanceof t)return!0;const{line:ae,character:ke}=O;return typeof ae=="number"&&typeof ke=="number"}static of(O){if(O instanceof t)return O;if(this.isPosition(O))return new t(O.line,O.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(O,ae){if(O<0)throw(0,L.$6)("line must be non-negative");if(ae<0)throw(0,L.$6)("character must be non-negative");this.c=O,this.e=ae}isBefore(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<O.e}isBeforeOrEqual(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<=O.e}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this.c===O.c&&this.e===O.e}compareTo(O){return this.c<O.c?-1:this.c>O.line?1:this.e<O.e?-1:this.e>O.e?1:0}translate(O,ae=0){if(O===null||ae===null)throw(0,L.$6)();let ke;return typeof O>"u"?ke=0:typeof O=="number"?ke=O:(ke=typeof O.lineDelta=="number"?O.lineDelta:0,ae=typeof O.characterDelta=="number"?O.characterDelta:0),ke===0&&ae===0?this:new t(this.line+ke,this.character+ae)}with(O,ae=this.character){if(O===null||ae===null)throw(0,L.$6)();let ke;return typeof O>"u"?ke=this.line:typeof O=="number"?ke=O:(ke=typeof O.line=="number"?O.line:this.line,ae=typeof O.character=="number"?O.character:this.character),ke===this.line&&ae===this.character?this:new t(ke,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$CK=z,e.$CK=z=t=Ke([C],z);let F=i=class{static isRange(O){return O instanceof i?!0:O?z.isPosition(O.start)&&z.isPosition(O.end):!1}static of(O){if(O instanceof i)return O;if(this.isRange(O))return new i(O.start,O.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(O,ae,ke,He){let Xe,st;if(typeof O=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof He=="number"?(Xe=new z(O,ae),st=new z(ke,He)):z.isPosition(O)&&z.isPosition(ae)&&(Xe=z.of(O),st=z.of(ae)),!Xe||!st)throw new Error("Invalid arguments");Xe.isBefore(st)?(this.c=Xe,this.e=st):(this.c=st,this.e=Xe)}contains(O){return i.isRange(O)?this.contains(O.start)&&this.contains(O.end):z.isPosition(O)?!(z.of(O).isBefore(this.c)||this.e.isBefore(O)):!1}isEqual(O){return this.c.isEqual(O.c)&&this.e.isEqual(O.e)}intersection(O){const ae=z.Max(O.start,this.c),ke=z.Min(O.end,this.e);if(!ae.isAfter(ke))return new i(ae,ke)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ae=z.Min(O.start,this.c),ke=z.Max(O.end,this.end);return new i(ae,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(O,ae=this.end){if(O===null||ae===null)throw(0,L.$6)();let ke;return O?z.isPosition(O)?ke=O:(ke=O.start||this.start,ae=O.end||this.end):ke=this.start,ke.isEqual(this.c)&&ae.isEqual(this.end)?this:new i(ke,ae)}toJSON(){return[this.start,this.end]}};e.$DK=F,e.$DK=F=i=Ke([C],F);let N=n=class extends F{static isSelection(O){return O instanceof n?!0:O?F.isRange(O)&&z.isPosition(O.anchor)&&z.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(O,ae,ke,He){let Xe,st;if(typeof O=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof He=="number"?(Xe=new z(O,ae),st=new z(ke,He)):z.isPosition(O)&&z.isPosition(ae)&&(Xe=z.of(O),st=z.of(ae)),!Xe||!st)throw new Error("Invalid arguments");super(Xe,st),this.f=Xe,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$EK=N,e.$EK=N=n=Ke([C],N);const x=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,L.$6)("connectionToken")};class J{static isResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.host=="string"&&typeof O.port=="number"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,ae,ke){if(typeof O!="string"||O.length===0)throw(0,L.$6)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,L.$6)("port");typeof ke<"u"&&x(ke),this.host=O,this.port=Math.round(ae),this.connectionToken=ke}}e.$FK=J;class Ee{static isManagedResolvedAuthority(O){return O&&typeof O=="object"&&typeof O.makeConnection=="function"&&(O.connectionToken===void 0||typeof O.connectionToken=="string")}constructor(O,ae){this.makeConnection=O,this.connectionToken=ae,typeof ae<"u"&&x(ae)}}e.$GK=Ee;class De extends Error{static NotAvailable(O,ae){return new De(O,v.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(O){return new De(O,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(O,ae=v.RemoteAuthorityResolverErrorCode.Unknown,ke){super(O),this._message=O,this._code=ae,this._detail=ke,Object.setPrototypeOf(this,De.prototype)}}e.$HK=De;var Ce;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(Ce||(e.EndOfLine=Ce={}));var fe;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(fe||(e.EnvironmentVariableMutatorType=fe={}));let be=u=class{static isTextEdit(O){return O instanceof u?!0:O?F.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ae){return new u(O,ae)}static insert(O,ae){return u.replace(new F(O,O),ae)}static delete(O){return u.replace(O,"")}static setEndOfLine(O){const ae=new u(new F(new z(0,0),new z(0,0)),"");return ae.newEol=O,ae}get range(){return this.c}set range(O){if(O&&!F.isRange(O))throw(0,L.$6)("range");this.c=O}get newText(){return this.e||""}set newText(O){if(O&&typeof O!="string")throw(0,L.$6)("newText");this.e=O}get newEol(){return this.f}set newEol(O){if(O&&typeof O!="number")throw(0,L.$6)("newEol");this.f=O}constructor(O,ae){this.c=O,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$IK=be,e.$IK=be=u=Ke([C],be);let se=o=class{static isNotebookCellEdit(O){return O instanceof o?!0:O?xt.isNotebookRange(O)&&Array.isArray(O.newCells):!1}static replaceCells(O,ae){return new o(O,ae)}static insertCells(O,ae){return new o(new xt(O,O),ae)}static deleteCells(O){return new o(O,[])}static updateCellMetadata(O,ae){const ke=new o(new xt(O,O),[]);return ke.newCellMetadata=ae,ke}static updateNotebookMetadata(O){const ae=new o(new xt(0,0),[]);return ae.newNotebookMetadata=O,ae}constructor(O,ae){this.range=O,this.newCells=ae}};e.$JK=se,e.$JK=se=o=Ke([C],se);class Re{static isSnippetTextEdit(O){return O instanceof Re?!0:O?F.isRange(O.range)&&j.isSnippetString(O.snippet):!1}static replace(O,ae){return new Re(O,ae)}static insert(O,ae){return Re.replace(new F(O,O),ae)}constructor(O,ae){this.range=O,this.snippet=ae}}e.$KK=Re;var oe;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(oe||(e.FileEditType=oe={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(O,ae,ke,He){this.c.push({_type:1,from:O,to:ae,options:ke,metadata:He})}createFile(O,ae,ke){this.c.push({_type:1,from:void 0,to:O,options:ae,metadata:ke})}deleteFile(O,ae,ke){this.c.push({_type:1,from:O,to:void 0,options:ae,metadata:ke})}e(O,ae,ke){this.c.push({_type:3,metadata:ke,uri:O,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(O,ae,ke,He){const Xe=ae.start,st=ae.end;(Xe!==st||ke.length>0)&&this.c.push({_type:5,uri:O,index:Xe,count:st-Xe,cells:ke,metadata:He})}g(O,ae,ke,He){this.c.push({_type:3,metadata:He,uri:O,edit:{editType:3,index:ae,metadata:ke}})}replace(O,ae,ke,He){this.c.push({_type:2,uri:O,edit:new be(ae,ke),metadata:He})}insert(O,ae,ke,He){this.replace(O,new F(ae,ae),ke,He)}delete(O,ae,ke){this.replace(O,ae,"",ke)}has(O){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===O.toString())}set(O,ae){if(ae)for(const ke of ae){if(!ke)continue;let He,Xe;Array.isArray(ke)?(He=ke[0],Xe=ke[1]):He=ke,se.isNotebookCellEdit(He)?He.newCellMetadata?this.g(O,He.range.start,He.newCellMetadata,Xe):He.newNotebookMetadata?this.e(O,He.newNotebookMetadata,Xe):this.f(O,He.range,He.newCells,Xe):Re.isSnippetTextEdit(He)?this.c.push({_type:6,uri:O,range:He.range,edit:He.snippet,metadata:Xe}):this.c.push({_type:2,uri:O,edit:He,metadata:Xe})}else{for(let ke=0;ke<this.c.length;ke++){const He=this.c[ke];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===O.toString()&&(this.c[ke]=void 0);break}}(0,E.$Hb)(this.c)}}get(O){const ae=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===O.toString()&&ae.push(ke.edit);return ae}entries(){const O=new M.$zc;for(const ae of this.c)if(ae._type===2){let ke=O.get(ae.uri);ke||(ke=[ae.uri,[]],O.set(ae.uri,ke)),ke[1].push(ae.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$LK=X,e.$LK=X=Ke([C],X);let j=l=class{static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static c(O){return O.replace(/\$|}|\\/g,"\\$&")}constructor(O){this.e=1,this.value=O||""}appendText(O){return this.value+=l.c(O),this}appendTabstop(O=this.e++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ae=this.e++){if(typeof O=="function"){const ke=new l;ke.e=this.e,O(ke),this.e=ke.e,O=ke.value}else O=l.c(O);return this.value+="${",this.value+=ae,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ae=this.e++){const ke=O.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(O,ae){if(typeof ae=="function"){const ke=new l;ke.e=this.e,ae(ke),this.e=ke.e,ae=ke.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$MK=j,e.$MK=j=l=Ke([C],j);var ne;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var pe;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(pe||(e.DiagnosticSeverity=pe={}));let re=r=class{static isLocation(O){return O instanceof r?!0:O?F.isRange(O.range)&&g.URI.isUri(O.uri):!1}constructor(O,ae){if(this.uri=O,ae)if(F.isRange(ae))this.range=F.of(ae);else if(z.isPosition(ae))this.range=new F(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$NK=re,e.$NK=re=r=Ke([C],re);let he=class{static is(O){return O?typeof O.message=="string"&&O.location&&F.isRange(O.location.range)&&g.URI.isUri(O.location.uri):!1}constructor(O,ae){this.location=O,this.message=ae}static isEqual(O,ae){return O===ae?!0:!O||!ae?!1:O.message===ae.message&&O.location.range.isEqual(ae.location.range)&&O.location.uri.toString()===ae.location.uri.toString()}};e.$OK=he,e.$OK=he=Ke([C],he);let ue=class{constructor(O,ae,ke=pe.Error){if(!F.isRange(O))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=O,this.message=ae,this.severity=ke}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ae){return O===ae?!0:!O||!ae?!1:O.message===ae.message&&O.severity===ae.severity&&O.code===ae.code&&O.severity===ae.severity&&O.source===ae.source&&O.range.isEqual(ae.range)&&(0,E.$tb)(O.tags,ae.tags)&&(0,E.$tb)(O.relatedInformation,ae.relatedInformation,he.isEqual)}};e.$PK=ue,e.$PK=ue=Ke([C],ue);let we=class{constructor(O,ae){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=ae}};e.$QK=we,e.$QK=we=Ke([C],we);var ee;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ee||(e.DocumentHighlightKind=ee={}));let de=class{constructor(O,ae=ee.Text){this.range=O,this.kind=ae}toJSON(){return{range:this.range,kind:ee[this.kind]}}};e.$RK=de,e.$RK=de=Ke([C],de);var ie;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var ce;(function(B){B[B.Deprecated=1]="Deprecated"})(ce||(e.SymbolTag=ce={}));let me=s=class{static validate(O){if(!O.name)throw new Error("name must not be falsy")}constructor(O,ae,ke,He,Xe){this.name=O,this.kind=ae,this.containerName=Xe,typeof ke=="string"&&(this.containerName=ke),He instanceof re?this.location=He:ke instanceof F&&(this.location=new re(He,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.$SK=me,e.$SK=me=s=Ke([C],me);let Ie=c=class{static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children?.forEach(c.validate)}constructor(O,ae,ke,He,Xe){this.name=O,this.detail=ae,this.kind=ke,this.range=He,this.selectionRange=Xe,this.children=[],c.validate(this)}};e.$TK=Ie,e.$TK=Ie=c=Ke([C],Ie);var T;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(T||(e.CodeActionTriggerKind=T={}));let V=class{constructor(O,ae){this.title=O,this.kind=ae}};e.$UK=V,e.$UK=V=Ke([C],V);let G=class{static{h=this}static{this.c="."}constructor(O){this.value=O}append(O){return new h(this.value?this.value+h.c+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+h.c)}};e.$VK=G,e.$VK=G=h=Ke([C],G),G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let Q=class{constructor(O,ae){if(this.range=O,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$WK=Q,e.$WK=Q=Ke([C],Q);class q{constructor(O,ae,ke,He,Xe,st){this.kind=O,this.name=ae,this.detail=ke,this.uri=He,this.range=Xe,this.selectionRange=st}}e.$XK=q;class _{constructor(O,ae){this.fromRanges=ae,this.from=O}}e.$YK=_;class le{constructor(O,ae){this.fromRanges=ae,this.to=O}}e.$ZK=le;var Oe;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Be=class{constructor(O,ae){this.range=O,this.command=ae}get isResolved(){return!!this.command}};e.$1K=Be,e.$1K=Be=Ke([C],Be);let Je=b=class{#e;static isMarkdownString(O){return O instanceof b?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}constructor(O,ae=!1){this.#e=new P.$8j(O,{supportThemeIcons:ae})}get value(){return this.#e.value}set value(O){this.#e.value=O}get isTrusted(){return this.#e.isTrusted}set isTrusted(O){this.#e.isTrusted=O}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(O){this.#e.supportThemeIcons=O}get supportHtml(){return this.#e.supportHtml}set supportHtml(O){this.#e.supportHtml=O}get baseUri(){return this.#e.baseUri}set baseUri(O){this.#e.baseUri=O}appendText(O){return this.#e.appendText(O),this}appendMarkdown(O){return this.#e.appendMarkdown(O),this}appendCodeblock(O,ae){return this.#e.appendCodeblock(ae??"",O),this}};e.$2K=Je,e.$2K=Je=b=Ke([C],Je);let Ge=class{constructor(O,ae){this.label=O,this.documentation=ae}};e.$3K=Ge,e.$3K=Ge=Ke([C],Ge);let _e=class{constructor(O,ae){this.label=O,this.documentation=ae,this.parameters=[]}};e.$4K=_e,e.$4K=_e=Ke([C],_e);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$5K=Ye,e.$5K=Ye=Ke([C],Ye);var xe;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var it;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(O){this.value=O}};e.$6K=tt,e.$6K=tt=Ke([C],tt);let ze=class{constructor(O,ae,ke){this.position=O,this.label=ae,this.kind=ke}};e.$7K=ze,e.$7K=ze=Ke([C],ze);var ut;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ut||(e.CompletionTriggerKind=ut={}));var Y;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var Z;(function(B){B[B.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let ye=class{constructor(O,ae){this.label=O,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$8K=ye,e.$8K=ye=Ke([C],ye);let je=class{constructor(O=[],ae=!1){this.items=O,this.isIncomplete=ae}};e.$9K=je,e.$9K=je=Ke([C],je);let Ne=class{constructor(O,ae,ke){this.insertText=O,this.range=ae,this.command=ke}};e.$0K=Ne,e.$0K=Ne=Ke([C],Ne);let Ze=class{constructor(O){this.commands=void 0,this.suppressSuggestions=void 0,this.items=O}};e.$$K=Ze,e.$$K=Ze=Ke([C],Ze);var nt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var $t;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})($t||(e.StatusBarAlignment=$t={}));function bt(B,O){return`${S.$$l.toKey(B)}.${O}`}e.$_K=bt;var Pt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Kt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var vt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(vt||(e.TextEditorSelectionChangeKind=vt={}));var Ut;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ot;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(B){function O(ae){switch(ae){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(vt||(e.TextEditorSelectionChangeKind=vt={}));var Gt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(B){function O(ae){switch(ae){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=O}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(O,ae){if(ae&&!g.URI.isUri(ae))throw(0,L.$6)("target");if(!F.isRange(O)||O.isEmpty)throw(0,L.$6)("range");this.range=O,this.target=ae}};e.$aL=Bt,e.$aL=Bt=Ke([C],Bt);let kt=class{constructor(O,ae,ke,He){this.red=O,this.green=ae,this.blue=ke,this.alpha=He}};e.$bL=kt,e.$bL=kt=Ke([C],kt);let Ft=class{constructor(O,ae){if(ae&&!(ae instanceof kt))throw(0,L.$6)("color");if(!F.isRange(O)||O.isEmpty)throw(0,L.$6)("range");this.range=O,this.color=ae}};e.$cL=Ft,e.$cL=Ft=Ke([C],Ft);let jt=class{constructor(O){if(!O||typeof O!="string")throw(0,L.$6)("label");this.label=O}};e.$dL=jt,e.$dL=jt=Ke([C],jt);var Qt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Qt||(e.ColorFormat=Qt={}));var Wt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var Vt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));class Nt{constructor(O,ae,ke){if(this.startIndex=O,this.length=ae,this.tooltip=ke,typeof O!="number"||O<0)throw(0,L.$6)("startIndex");if(typeof ae!="number"||ae<1)throw(0,L.$6)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.$6)("tooltip")}}e.$eL=Nt;class at{constructor(O){this.uri=O}}e.$fL=at;class dt{constructor(O){this.terminalCommand=O}}e.$gL=dt;var At;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(At||(e.TerminalLocation=At={}));class qt{constructor(O){if(this.options=O,typeof O!="object")throw(0,L.$6)("options")}}e.$hL=qt;var Rt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var ot;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ot||(e.TaskPanelKind=ot={}));let wt=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(O){switch(O){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(O,ae){if(this.label=ae,typeof O!="string"||typeof ae!="string")throw(0,L.$6)("name");this.c=O}get id(){return this.c}};e.$iL=wt,e.$iL=wt=m=Ke([C],wt);function Tt(B){let O="";for(let ae=0;ae<B.length;ae++)O+=B[ae].replace(/,/g,",,")+",";return O}let Ct=class{constructor(O,ae,ke){if(typeof O!="string")throw(0,L.$6)("process");this.e=[],this.c=O,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=ke):this.f=ae)}get process(){return this.c}set process(O){if(typeof O!="string")throw(0,L.$6)("process");this.c=O}get args(){return this.e}set args(O){Array.isArray(O)||(O=[]),this.e=O}get options(){return this.f}set options(O){this.f=O}computeId(){const O=[];if(O.push("process"),this.c!==void 0&&O.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)O.push(ae);return Tt(O)}};e.$jL=Ct,e.$jL=Ct=Ke([C],Ct);let We=class{constructor(O,ae,ke){if(this.f=[],Array.isArray(ae)){if(!O)throw(0,L.$6)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,L.$6)("command");this.e=O,this.f=ae,this.g=ke}else{if(typeof O!="string")throw(0,L.$6)("commandLine");this.c=O,this.g=ae}}get commandLine(){return this.c}set commandLine(O){if(typeof O!="string")throw(0,L.$6)("commandLine");this.c=O}get command(){return this.e?this.e:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,L.$6)("command");this.e=O}get args(){return this.f}set args(O){this.f=O||[]}get options(){return this.g}set options(O){this.g=O}computeId(){const O=[];if(O.push("shell"),this.c!==void 0&&O.push(this.c),this.e!==void 0&&O.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)O.push(typeof ae=="string"?ae:ae.value);return Tt(O)}};e.$kL=We,e.$kL=We=Ke([C],We);var Jt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Se;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Se||(e.TaskScope=Se={}));class Le{constructor(O){this.c=O}computeId(){return"customExecution"+(0,A.$hg)()}set callback(O){this.c=O}get callback(){return this.c}}e.$lL=Le;let $e=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(O,ae,ke,He,Xe,st){this.j=!1,this.k=this.definition=O;let lt;typeof ae=="string"?(this.m=this.name=ae,this.t=this.source=ke,this.execution=He,lt=Xe,this.j=!0):ae===Se.Global||ae===Se.Workspace?(this.target=ae,this.m=this.name=ke,this.t=this.source=He,this.execution=Xe,lt=st):(this.target=ae,this.m=this.name=ke,this.t=this.source=He,this.execution=Xe,lt=st),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(O){this.h=O}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ct?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof Le?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,A.$hg)()}}get definition(){return this.k}set definition(O){if(O==null)throw(0,L.$6)("Kind can't be undefined or null");this.z(),this.k=O}get scope(){return this.l}set target(O){this.z(),this.l=O}get name(){return this.m}set name(O){if(typeof O!="string")throw(0,L.$6)("name");this.z(),this.m=O}get execution(){return this.n}set execution(O){O===null&&(O=void 0),this.z(),this.n=O;const ae=this.k.type;(I.g===ae||I.e===ae||I.f===ae||I.c===ae)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(O){if(Array.isArray(O))this.z(),this.o=O,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.z(),this.r=O}get source(){return this.t}set source(O){if(typeof O!="string"||O.length===0)throw(0,L.$6)("source must be a string of length > 0");this.z(),this.t=O}get group(){return this.u}set group(O){O===null&&(O=void 0),this.z(),this.u=O}get detail(){return this.y}set detail(O){O===null&&(O=void 0),this.y=O}get presentationOptions(){return this.w}set presentationOptions(O){O==null&&(O=Object.create(null)),this.z(),this.w=O}get runOptions(){return this.x}set runOptions(O){O==null&&(O=Object.create(null)),this.z(),this.x=O}};e.$mL=$e,e.$mL=$e=I=Ke([C],$e);var K;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(K||(e.ProgressLocation=K={}));var Me;(function(B){function O(ae){const ke=ae;return(0,D.$Ff)(ke.value)?ke.tooltip&&!(0,D.$Bf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}B.isViewBadge=O})(Me||(e.ViewBadge=Me={}));let Ue=k=class{static isTreeItem(O,ae){const ke=O;if(ke.checkboxState!==void 0){const He=(0,D.$Ff)(ke.checkboxState)?ke.checkboxState:(0,D.$Df)(ke.checkboxState)&&(0,D.$Ff)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Xe=!(0,D.$Ff)(ke.checkboxState)&&(0,D.$Df)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(He===void 0||He!==qe.Checked&&He!==qe.Unchecked||Xe!==void 0&&!(0,D.$Bf)(Xe))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(O instanceof k)return!0;if(ke.label!==void 0&&!(0,D.$Bf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,D.$Bf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,D.$Bf)(ke.iconPath)&&!g.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,D.$Bf)(ke.iconPath.id))){const He=ke.iconPath;if(!He||!(0,D.$Bf)(He.light)&&!g.URI.isUri(He.light)&&!(0,D.$Bf)(He.dark)&&!g.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,D.$Bf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!g.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,D.$Bf)(ke.tooltip)&&!(ke.tooltip instanceof Je)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Qe.None&&ke.collapsibleState>Qe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,D.$Bf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(O,ae=Qe.None){this.collapsibleState=ae,g.URI.isUri(O)?this.resourceUri=O:this.label=O}};e.$nL=Ue,e.$nL=Ue=k=Ke([C],Ue);var Qe;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Qe||(e.TreeItemCollapsibleState=Qe={}));var qe;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(O){this.value=O}};e.$oL=et,e.$oL=et=Ke([C],et);class Et extends et{}e.$pL=Et;class Dt extends Et{#e;constructor(O){super(""),this.#e=O}asFile(){return this.#e}}e.$qL=Dt;class gt{constructor(O,ae,ke,He){this.name=O,this.uri=ae,this._itemId=ke,this.c=He}data(){return this.c()}}e.$rL=gt;let ht=class{#e=new Map;constructor(O){for(const[ae,ke]of O??[]){const He=this.#e.get(this.#t(ae));He?He.push(ke):this.#e.set(this.#t(ae),[ke])}}get(O){return this.#e.get(this.#t(O))?.[0]}set(O,ae){this.#e.set(this.#t(O),[ae])}forEach(O,ae){for(const[ke,He]of this.#e)for(const Xe of He)O.call(ae,Xe,ke,this)}*[Symbol.iterator](){for(const[O,ae]of this.#e)for(const ke of ae)yield[O,ke]}#t(O){return O.toLowerCase()}};e.$sL=ht,e.$sL=ht=Ke([C],ht);let ft=class{constructor(O){this.insertText=O}};e.$tL=ft,e.$tL=ft=Ke([C],ft);let ui=class{constructor(O,ae){this.label=ae,this.insertText=O}};e.$uL=ui,e.$uL=ui=Ke([C],ui);let St=class{constructor(O,ae){this.id=O,this.color=ae}static isThemeIcon(O){return typeof O.id!="string"?(console.log("INVALID ThemeIcon, invalid id",O.id),!1):!0}};e.$vL=St,e.$vL=St=Ke([C],St),St.File=new St("file"),St.Folder=new St("folder");let Si=class{constructor(O){this.id=O}};e.$wL=Si,e.$wL=Si=Ke([C],Si);var li;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(li||(e.ConfigurationTarget=li={}));let $i=class{get base(){return this.c}set base(O){this.c=O,this.e=g.URI.file(O)}get baseUri(){return this.e}set baseUri(O){this.e=O,this.c=O.fsPath}constructor(O,ae){if(typeof O!="string"&&(!O||!g.URI.isUri(O)&&!g.URI.isUri(O.uri)))throw(0,L.$6)("base");if(typeof ae!="string")throw(0,L.$6)("pattern");typeof O=="string"?this.baseUri=g.URI.file(O):g.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$xL=$i,e.$xL=$i=Ke([C],$i);const It=new WeakMap;function gn(B,O){It.set(B,O)}e.$yL=gn;let ri=class{constructor(O,ae,ke,He){this.enabled=typeof O=="boolean"?O:!0,typeof ae=="string"&&(this.condition=ae),typeof ke=="string"&&(this.hitCondition=ke),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=It.get(this)??(0,A.$hg)()),this.c}};e.$zL=ri,e.$zL=ri=Ke([C],ri);let yt=class extends ri{constructor(O,ae,ke,He,Xe){if(super(ae,ke,He,Xe),O===null)throw(0,L.$6)("location");this.location=O}};e.$AL=yt,e.$AL=yt=Ke([C],yt);let pi=class extends ri{constructor(O,ae,ke,He,Xe){super(ae,ke,He,Xe),this.functionName=O}};e.$BL=pi,e.$BL=pi=Ke([C],pi);let vi=class extends ri{constructor(O,ae,ke,He,Xe,st,lt){if(super(He,Xe,st,lt),!ae)throw(0,L.$6)("dataId");this.label=O,this.dataId=ae,this.canPersist=ke}};e.$CL=vi,e.$CL=vi=Ke([C],vi);let si=class{constructor(O,ae,ke){this.command=O,this.args=ae||[],this.options=ke}};e.$DL=si,e.$DL=si=Ke([C],si);let Ii=class{constructor(O,ae){this.port=O,this.host=ae}};e.$EL=Ii,e.$EL=Ii=Ke([C],Ii);let Ci=class{constructor(O){this.path=O}};e.$FL=Ci,e.$FL=Ci=Ke([C],Ci);let Mt=class{constructor(O){this.implementation=O}};e.$GL=Mt,e.$GL=Mt=Ke([C],Mt);let bi=class{constructor(O,ae,ke){this.session=O,this.threadId=ae,this.frameId=ke}};e.$HL=bi,e.$HL=bi=Ke([C],bi);let Pi=class{constructor(O,ae){this.session=O,this.threadId=ae}};e.$IL=Pi,e.$IL=Pi=Ke([C],Pi);let oi=class{constructor(O,ae){this.range=O,this.expression=ae}};e.$JL=oi,e.$JL=oi=Ke([C],oi);var hi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(hi||(e.InlineCompletionTriggerKind=hi={}));let ct=class{constructor(O,ae){this.range=O,this.text=ae}};e.$KL=ct,e.$KL=ct=Ke([C],ct);let Ai=class{constructor(O,ae,ke=!0){this.range=O,this.variableName=ae,this.caseSensitiveLookup=ke}};e.$LL=Ai,e.$LL=Ai=Ke([C],Ai);let Yt=class{constructor(O,ae){this.range=O,this.expression=ae}};e.$ML=Yt,e.$ML=Yt=Ke([C],Yt);let ii=class{constructor(O,ae){this.frameId=O,this.stoppedLocation=ae}};e.$NL=ii,e.$NL=ii=Ke([C],ii);var Ri;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Mi=d=class extends Error{static FileExists(O){return new d(O,a.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(O){return new d(O,a.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(O){return new d(O,a.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(O){return new d(O,a.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(O){return new d(O,a.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(O){return new d(O,a.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}constructor(O,ae=a.FileSystemProviderErrorCode.Unknown,ke){super(g.URI.isUri(O)?O.toString(!0):O),this.code=ke?.name??"Unknown",(0,a.$sk)(this,ae),Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$OL=Mi,e.$OL=Mi=d=Ke([C],Mi);let Li=class{constructor(O,ae,ke){this.start=O,this.end=ae,this.kind=ke}};e.$PL=Li,e.$PL=Li=Ke([C],Li);var Zi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Zi||(e.FoldingRangeKind=Zi={}));var Fi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Fi||(e.CommentThreadCollapsibleState=Fi={}));var Xi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Xi||(e.CommentMode=Xi={}));var Ti;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Ti||(e.CommentState=Ti={}));var ai;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(ai||(e.CommentThreadState=ai={}));class mn{constructor(O,ae=[]){this.tokenTypes=O,this.tokenModifiers=ae}}e.$QL=mn;function Oi(B){return typeof B>"u"||(0,D.$Cf)(B)}class di{constructor(O){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,O){this.l=!0;for(let ae=0,ke=O.tokenTypes.length;ae<ke;ae++)this.j.set(O.tokenTypes[ae],ae);for(let ae=0,ke=O.tokenModifiers.length;ae<ke;ae++)this.k.set(O.tokenModifiers[ae],ae)}}push(O,ae,ke,He,Xe){if(typeof O=="number"&&typeof ae=="number"&&typeof ke=="number"&&typeof He=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.n(O,ae,ke,He,Xe);if(F.isRange(O)&&typeof ae=="string"&&Oi(ke))return this.m(O,ae,ke);throw(0,L.$6)()}m(O,ae,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ae))throw new Error("`tokenType` is not in the provided legend");const He=O.start.line,Xe=O.start.character,st=O.end.character-O.start.character,lt=this.j.get(ae);let zt=0;if(ke)for(const Xt of ke){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Xt);zt|=1<<ei>>>0}this.n(He,Xe,st,lt,zt)}n(O,ae,ke,He,Xe){if(this.f&&(O<this.c||O===this.c&&ae<this.e)){this.f=!1;const zt=this.g.length/5|0;let Xt=0,ei=0;for(let ti=0;ti<zt;ti++){let ni=this.g[5*ti],Qi=this.g[5*ti+1];ni===0?(ni=Xt,Qi+=ei):ni+=Xt,this.g[5*ti]=ni,this.g[5*ti+1]=Qi,Xt=ni,ei=Qi}}let st=O,lt=ae;this.f&&this.h>0&&(st-=this.c,st===0&&(lt-=this.e)),this.g[this.h++]=st,this.g[this.h++]=lt,this.g[this.h++]=ke,this.g[this.h++]=He,this.g[this.h++]=Xe,this.c=O,this.e=ae}static o(O){const ae=[],ke=O.length/5|0;for(let lt=0;lt<ke;lt++)ae[lt]=lt;ae.sort((lt,zt)=>{const Xt=O[5*lt],ei=O[5*zt];if(Xt===ei){const ti=O[5*lt+1],ni=O[5*zt+1];return ti-ni}return Xt-ei});const He=new Uint32Array(O.length);let Xe=0,st=0;for(let lt=0;lt<ke;lt++){const zt=5*ae[lt],Xt=O[zt+0],ei=O[zt+1],ti=O[zt+2],ni=O[zt+3],Qi=O[zt+4],Cn=Xt-Xe,Tn=Cn===0?ei-st:ei,Ji=5*lt;He[Ji+0]=Cn,He[Ji+1]=Tn,He[Ji+2]=ti,He[Ji+3]=ni,He[Ji+4]=Qi,Xe=Xt,st=ei}return He}build(O){return this.f?new Ni(new Uint32Array(this.g),O):new Ni(di.o(this.g),O)}}e.$RL=di;class Ni{constructor(O,ae){this.resultId=ae,this.data=O}}e.$SL=Ni;class $n{constructor(O,ae,ke){this.start=O,this.deleteCount=ae,this.data=ke}}e.$TL=$n;class fi{constructor(O,ae){this.resultId=ae,this.edits=O}}e.$UL=fi;var Yi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Yi||(e.DebugConsoleMode=Yi={}));let zi=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$VL=zi,e.$VL=zi=Ke([C],zi);var xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var gi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(gi||(e.InputBoxValidationSeverity=gi={}));var _i;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class pn{static validate(O){if(typeof O.badge=="string"){let ae=(0,$.$cf)(O.badge,0);if(ae<O.badge.length&&(ae+=(0,$.$cf)(O.badge,ae)),O.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(O.badge&&!St.isThemeIcon(O.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}constructor(O,ae,ke){this.badge=O,this.tooltip=ae,this.color=ke}}e.$WL=pn;let Ui=class{constructor(O){this.kind=O}};e.$XL=Ui,e.$XL=Ui=Ke([C],Ui);var mi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(mi||(e.ColorThemeKind=mi={}));class xt{static isNotebookRange(O){return O instanceof xt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(O,ae){if(O<0)throw(0,L.$6)("start must be positive");if(ae<0)throw(0,L.$6)("end must be positive");O<=ae?(this.c=O,this.e=ae):(this.c=ae,this.e=O)}with(O){let ae=this.c,ke=this.e;return O.start!==void 0&&(ae=O.start),O.end!==void 0&&(ke=O.end),ae===this.c&&ke===this.e?this:new xt(ae,ke)}}e.$YL=xt;class wi{static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ae=>wi.isNotebookCellData(ae))}static isNotebookCellData(O){return!0}constructor(O,ae,ke,He,Xe,st,lt){this.kind=O,this.value=ae,this.languageId=ke,this.mime=He,this.outputs=Xe??[],this.metadata=st,this.executionSummary=lt,wi.validate(this)}}e.$ZL=wi;class en{constructor(O){this.cells=O}}e.$1L=en;class Zt{static isNotebookCellOutputItem(O){return O instanceof Zt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const ae={name:O.name,message:O.message,stack:O.stack};return Zt.json(ae,"application/vnd.code.notebook.error")}static stdout(O){return Zt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Zt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,ae="application/octet-stream"){return new Zt(O,ae)}static#e=new TextEncoder;static text(O,ae=R.$Vr.text){const ke=Zt.#e.encode(String(O));return new Zt(ke,ae)}static json(O,ae="text/x-json"){const ke=JSON.stringify(O,void 0,"	");return Zt.text(ke,ae)}constructor(O,ae){this.data=O,this.mime=ae;const ke=(0,R.$Zr)(ae,!0);if(!ke)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$2L=Zt;class yi{static isNotebookCellOutput(O){return O instanceof yi?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&Array.isArray(O.items)}static ensureUniqueMimeTypes(O,ae=!1){const ke=new Set,He=new Set;for(let Xe=0;Xe<O.length;Xe++){const st=O[Xe],lt=(0,R.$Zr)(st.mime);if(!ke.has(lt)||(0,p.$DI)(lt)){ke.add(lt);continue}He.add(Xe),ae&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return He.size===0?O:O.filter((Xe,st)=>!He.has(st))}constructor(O,ae,ke){this.items=yi.ensureUniqueMimeTypes(O,!0),typeof ae=="string"?(this.id=ae,this.metadata=ke):(this.id=(0,A.$hg)(),this.metadata=ae??ke)}}e.$3L=yi;var tn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var rn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rn||(e.NotebookCellStatusBarAlignment=rn={}));var Ei;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ei||(e.NotebookEditorRevealType=Ei={}));class sn{constructor(O,ae){this.text=O,this.alignment=ae}}e.$4L=sn;var Te;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Te||(e.NotebookControllerAffinity=Te={}));var _t;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(_t||(e.NotebookControllerAffinity2=_t={}));class on{constructor(O,ae=[]){this.uri=O,this.provides=(0,E.$2b)(ae)}}e.$5L=on;class mt{constructor(O){this.label=O}}e.$6L=mt;let Bi=class{constructor(O,ae){this.label=O,this.timestamp=ae}};e.$7L=Bi,e.$7L=Bi=Ke([C],Bi);var an;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var ji;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(ji||(e.ExtensionRuntime=ji={}));var cn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class Di{constructor(O,ae){this.ranges=O,this.wordPattern=ae}}e.$8L=Di;class vn{constructor(O){this.c=O}get autoForwardAction(){return this.c}}e.$9L=vn;var un;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let ki=class{constructor(O=void 0,ae=void 0,ke=void 0,He=!1){this.include=O,this.exclude=ae,this.profile=ke,this.continuous=He}};e.$0L=ki,e.$0L=ki=Ke([C],ki);let Wi=w=class{static diff(O,ae,ke){const He=new w(O);return He.expectedOutput=ae,He.actualOutput=ke,He}constructor(O){this.message=O}};e.$$L=Wi,e.$$L=Wi=w=Ke([C],Wi);let Vi=class{constructor(O){this.id=O}};e.$_L=Vi,e.$_L=Vi=Ke([C],Vi);let ci=class{constructor(O,ae){this.covered=O,this.total=ae}};e.$aM=ci,e.$aM=ci=Ke([C],ci);let qi=y=class{static fromDetails(O,ae){const ke=new ci(0,0),He=new ci(0,0),Xe=new ci(0,0);for(const lt of ae)if("branches"in lt){ke.total+=1,ke.covered+=lt.executionCount>0?1:0;for(const zt of lt.branches)He.total+=1,He.covered+=zt.executionCount>0?1:0}else Xe.total+=1,Xe.covered+=lt.executionCount>0?1:0;const st=new y(O,ke,He.total>0?He:void 0,Xe.total>0?Xe:void 0);return st.detailedCoverage=ae,st}constructor(O,ae,ke,He){this.uri=O,this.statementCoverage=ae,this.branchCoverage=ke,this.functionCoverage=He}};e.$bM=qi,e.$bM=qi=y=Ke([C],qi);let Ki=class{constructor(O,ae,ke=[]){this.executionCount=O,this.location=ae,this.branches=ke}};e.$cM=Ki,e.$cM=Ki=Ke([C],Ki);let Hi=class{constructor(O,ae){this.executionCount=O,this.location=ae}};e.$dM=Hi,e.$dM=Hi=Ke([C],Hi);let Gi=class{constructor(O,ae){this.executionCount=O,this.location=ae}};e.$eM=Gi,e.$eM=Gi=Ke([C],Gi);var hn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(hn||(e.ExternalUriOpenerPriority=hn={}));var dn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(dn||(e.WorkspaceTrustState=dn={}));var fn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(fn||(e.PortAutoForwardAction=fn={}));class te{constructor(O,ae,ke,He,Xe,st){this.kind=O,this.name=ae,this.detail=ke,this.uri=He,this.range=Xe,this.selectionRange=st}}e.$fM=te;class ge{constructor(O){this.uri=O}}e.$gM=ge;class Fe{constructor(O,ae){this.original=O,this.modified=ae}}e.$hM=Fe;class rt{constructor(O,ae,ke,He){this.base=O,this.input1=ae,this.input2=ke,this.result=He}}e.$iM=rt;class pt{constructor(O,ae){this.uri=O,this.viewType=ae}}e.$jM=pt;class Lt{constructor(O){this.viewType=O}}e.$kM=Lt;class Pn{constructor(O,ae){this.uri=O,this.notebookType=ae}}e.$lM=Pn;class An{constructor(O,ae,ke){this.original=O,this.modified=ae,this.notebookType=ke}}e.$mM=An;class Rn{constructor(){}}e.$nM=Rn;class Mn{constructor(O,ae){this.uri=O,this.inputBoxUri=ae}}e.$oM=Mn;class Ln{constructor(O){this.providerId=O}}e.$pM=Ln;var bn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));var Dn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Fn{constructor(O,ae){this.role=O,this.content=ae}}e.$qM=Fn;var kn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var In;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}))}),define(Pe[103],Ae([1,0,55,14,13,297,147,7,18]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.$DM=void 0;const g=new Map;function A(p,f){f?g.set(p,f):g.delete(p)}e.$DM=A;function S(p){return g.get(p)}class a extends M.$2u{constructor(f,t,i,n,u,o,l,r){super(t,i,n,u),this.c=f,this.m=o,this.q=l,this.notebook=r,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,D.$tb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===L.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,i){return f.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,E.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,E.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,n=t.start.line,u=t.end.line,o=[];o.push(this.f[n].substring(t.start.character));for(let l=n+1;l<u;l++)o.push(this.f[l]);return o.push(this.f[u].substring(0,t.end.character)),o.join(i)}t(f){let t;if(f instanceof $.$CK?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new v(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),i=this.f[t.index].length;return new $.$CK(t.index,Math.min(t.remainder,i))}w(f){if(!(f instanceof $.$DK))throw new Error("Invalid argument");const t=this.x(f.start),i=this.x(f.end);return t===f.start&&i===f.end?f:new $.$DK(t.line,t.character,i.line,i.character)}x(f){if(!(f instanceof $.$CK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:i}=f,n=!1;if(t<0)t=0,i=0,n=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,n=!0;else{const u=this.f[t].length;i<0?(i=0,n=!0):i>u&&(i=u,n=!0)}return n?new $.$CK(t,i):f}y(f,t){const i=this.x(f);if(!t)t=S(this.m);else if((0,P.$Re)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const n=(0,R.$bs)(i.character+1,(0,R.$_r)(t),this.f[i.line],0);if(n)return new $.$DK(i.line,n.startColumn-1,i.line,n.endColumn-1)}}e.$EM=a;class v{constructor(f,t,i){this.a=f,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$DK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$DK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$FM=v}),define(Pe[211],Ae([1,0,7,17,5]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=void 0;let M=class{constructor($){this.a=new E.$XL(E.ColorThemeKind.Dark),this.b=new P.$Qd}get activeColorTheme(){return this.a}$onColorThemeChange($){let D;switch($){case"light":D=E.ColorThemeKind.Light;break;case"hcDark":D=E.ColorThemeKind.HighContrast;break;case"hcLight":D=E.ColorThemeKind.HighContrastLight;break;default:D=E.ColorThemeKind.Dark}this.a=new E.$XL(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$0ec=M,e.$0ec=M=Ke([Ve(0,L.$BM)],M)}),define(Pe[212],Ae([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=e.CellExecutionUpdateType=void 0;var L;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$HI=(0,E.$Uh)("INotebookExecutionService")}),define(Pe[213],Ae([1,0,6,29,144,93]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LOb=void 0;class R extends E.$Rc{constructor(D,g,A){super(),this._source=D,this.b=g,this.c=A,this.a=void 0}f(D){const g=D.getLineCount();return new L.$zs(1,1,g,this.g(D,g))}g(D,g){if(g<1||g>D.getLineCount())throw new Error("Illegal value for lineNumber");return D.getLineLength(g)+1}get inputTextBuffer(){if(!this.b){const D=new P.$MB;D.acceptChunk(this._source);const g=D.finish(!0),{textBuffer:A,disposable:S}=g.create(1);this.b=A,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(D=>{const g=new P.$MB;g.acceptChunk(D);const A=g.finish(!0),{textBuffer:S,disposable:a}=A.create(1);return this.B(a),S})),this.a}findInInputs(D){const A=new M.$AB(D,!1,!1,null).parseSearchRequest();if(!A)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,A,!0,5e3)}findInOutputs(D){const A=new M.$AB(D,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(S=>{const a=S.findMatchesLineByLine(this.f(S),A,!0,5e3);if(a.length!==0)return{textBuffer:S,matches:a}}).filter(S=>!!S):[]}}e.$LOb=R}),define(Pe[48],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var L;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class P{static fromExtHostTestItem(R,$,D=R.parent){if(R._isRoot)return new P([$]);const g=[R.id];for(let A=D;A&&A.id!==$;A=A.parent)g.push(A.id);return g.push($),new P(g.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new P(R.split("\0"))}static join(R,$){return new P([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:P.isChild(R,$)?2:P.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$pJ=P}),define(Pe[60],Ae([1,0,2,29,48]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$vJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$uJ=e.$tJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$sJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$rJ=e.$qJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var R;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var $;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$qJ=[2,4,8,16,32,64];const D=k=>"runId"in k;e.$rJ=D;var g;(function(k){k.serialize=d=>({range:d.range.toJSON(),uri:d.uri.toJSON()}),k.deserialize=d=>({range:L.$zs.lift(d.range),uri:E.URI.revive(d.uri)})})(g||(e.IRichLocation=g={}));var A;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(A||(e.TestMessageType=A={}));var S;(function(k){k.serialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,contextValue:d.contextValue,location:d.location&&g.serialize(d.location)}),k.deserialize=d=>({message:d.message,type:0,expected:d.expected,actual:d.actual,contextValue:d.contextValue,location:d.location&&g.deserialize(d.location)})})(S||(e.ITestErrorMessage=S={}));const a=(k,d)=>`${d?"s":"e"}${k}`;e.$sJ=a;var v;(function(k){k.serialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&g.serialize(d.location)}),k.deserialize=d=>({message:d.message,type:1,offset:d.offset,length:d.length,location:d.location&&g.deserialize(d.location)})})(v||(e.ITestOutputMessage=v={}));var p;(function(k){k.serialize=d=>d.type===0?S.serialize(d):v.serialize(d),k.deserialize=d=>d.type===0?S.deserialize(d):v.deserialize(d)})(p||(e.ITestMessage=p={}));var f;(function(k){k.serializeWithoutMessages=d=>({state:d.state,duration:d.duration,messages:[]}),k.serialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(p.serialize)}),k.deserialize=d=>({state:d.state,duration:d.duration,messages:d.messages.map(p.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",i=(k,d)=>k+t+d;e.$tJ=i;const n=k=>{const d=k.indexOf(t);return{ctrlId:k.slice(0,d),tagId:k.slice(d+1)}};e.$uJ=n;var u;(function(k){k.serialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?.toJSON(),range:d.range?.toJSON()||null,description:d.description,error:d.error,sortText:d.sortText}),k.deserialize=d=>({extId:d.extId,label:d.label,tags:d.tags,busy:d.busy,children:void 0,uri:d.uri?E.URI.revive(d.uri):void 0,range:d.range?L.$zs.lift(d.range):null,description:d.description,error:d.error,sortText:d.sortText})})(u||(e.ITestItem=u={}));var o;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var l;(function(k){k.serialize=d=>({expand:d.expand,item:u.serialize(d.item)}),k.deserialize=d=>({controllerId:P.$pJ.root(d.item.extId),expand:d.expand,item:u.deserialize(d.item)})})(l||(e.InternalTestItem=l={}));var r;(function(k){k.serialize=d=>{let w;return d.item&&(w={},d.item.label!==void 0&&(w.label=d.item.label),d.item.tags!==void 0&&(w.tags=d.item.tags),d.item.busy!==void 0&&(w.busy=d.item.busy),d.item.uri!==void 0&&(w.uri=d.item.uri?.toJSON()),d.item.range!==void 0&&(w.range=d.item.range?.toJSON()),d.item.description!==void 0&&(w.description=d.item.description),d.item.error!==void 0&&(w.error=d.item.error),d.item.sortText!==void 0&&(w.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:w}},k.deserialize=d=>{let w;return d.item&&(w={},d.item.label!==void 0&&(w.label=d.item.label),d.item.tags!==void 0&&(w.tags=d.item.tags),d.item.busy!==void 0&&(w.busy=d.item.busy),d.item.range!==void 0&&(w.range=d.item.range?L.$zs.lift(d.item.range):null),d.item.description!==void 0&&(w.description=d.item.description),d.item.error!==void 0&&(w.error=d.item.error),d.item.sortText!==void 0&&(w.sortText=d.item.sortText)),{extId:d.extId,expand:d.expand,item:w}}})(r||(e.ITestItemUpdate=r={}));const s=(k,d)=>{d.expand!==void 0&&(k.expand=d.expand),d.item!==void 0&&(k.item=k.item?Object.assign(k.item,d.item):d.item)};e.$vJ=s;var c;(function(k){k.serializeWithoutMessages=d=>({...l.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.serializeWithoutMessages)}),k.serialize=d=>({...l.serialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.serialize)}),k.deserialize=d=>({...l.deserialize(d),ownComputedState:d.ownComputedState,computedState:d.computedState,tasks:d.tasks.map(f.deserialize),retired:!0})})(c||(e.TestResultItem=c={}));var h;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(h||(e.DetailType=h={}));var b;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(b||(e.TestDiffOpType=b={}));var m;(function(k){k.deserialize=d=>d.op===0?{op:d.op,item:l.deserialize(d.item)}:d.op===1?{op:d.op,item:r.deserialize(d.item)}:d.op===2?{op:d.op,uri:E.URI.revive(d.uri),docv:d.docv}:d,k.serialize=d=>d.op===0?{op:d.op,item:l.serialize(d.item)}:d.op===1?{op:d.op,item:r.serialize(d.item)}:d})(m||(e.TestsDiffOp=m={}));class I{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(d){const w=this.o();for(const y of d)switch(y.op){case 0:this.j(l.deserialize(y.item),w);break;case 1:this.k(r.deserialize(y.item),w);break;case 3:this.l(y.itemId,w);break;case 5:this.m(y.itemId);break;case 4:this.updatePendingRoots(y.amount);break;case 6:this.c.set(y.tag.id,y.tag);break;case 7:this.c.delete(y.id);break}w.complete?.()}j(d,w){const y=P.$pJ.parentId(d.item.extId)?.toString();let C;if(!y)C=this.p(d),this.f.add(C),this.d.set(d.item.extId,C);else if(this.d.has(y)){const W=this.d.get(y);W.children.add(d.item.extId),C=this.p(d,W),this.d.set(d.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(d)}`);return}return w.add?.(C),d.expand===2&&this.g++,C}k(d,w){const y=this.d.get(d.extId);if(y)return d.expand!==void 0&&(y.expand===2&&this.g--,d.expand===2&&this.g++),(0,e.$vJ)(y,d),w.update?.(y),y}l(d,w){const y=this.d.get(d);if(!y)return;const C=P.$pJ.parentId(y.item.extId)?.toString();C?this.d.get(C).children.delete(y.item.extId):this.f.delete(y);const W=[[d]];for(;W.length;)for(const H of W.pop()){const U=this.d.get(H);U&&(W.push(U.children),this.d.delete(H),w.remove?.(U,U!==y),U.expand===2&&this.g--)}}m(d){}updatePendingRoots(d){this.h+=d}o(){return{}}}e.$wJ=I}),define(Pe[77],Ae([1,0,12,5,6,55,60,48]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.TestItemEventOp=void 0;var D;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const g=(n,u)=>n===u,S=Object.entries({range:(n,u)=>n===u?!0:!n||!u?!1:n.equalsRange(u),busy:g,label:g,description:g,error:g,sortText:g,tags:(n,u)=>!(n.length!==u.length||n.some(o=>!u.includes(o)))}),a=(n,u)=>{let o;for(const[l,r]of S)r(n[l],u[l])||(o?o[l]=u[l]:o={[l]:u[l]});return o};class v extends P.$Rc{get root(){return this.s.root}constructor(u){super(),this.s=u,this.f=this.B(new E.$9g(()=>this.flushDiff(),200)),this.g=this.B(new L.$Qd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(u){this.h=u;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const u=this.m;return this.m=[],u}pushDiff(u){switch(u.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===u.uri){o.docv=u.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===u.item.extId){(0,R.$vJ)(o.item,u.item);return}if(o.op===0&&o.item.item.extId===u.item.extId){(0,R.$vJ)(o.item,u.item);return}}break}}this.m.push(u),this.f.isScheduled()||this.f.schedule()}expand(u,o){const l=this.tree.get(u);if(l){if((l.expandLevels===void 0||o>l.expandLevels)&&(l.expandLevels=o),l.expand===1){const r=this.L(l);return r.isOpen()?this.J(l,o-1):r.wait().then(()=>this.J(l,o-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,o-1)):this.J(l,o-1)}}dispose(){for(const u of this.tree.values())this.s.getApiFor(u.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(u,o){switch(o.op){case 3:this.N($.$pJ.joinToString(u.fullId,o.id));break;case 0:this.y(o.item,u);break;case 5:for(const l of o.ops)this.u(u,l);break;case 1:this.z(o.new,o.old,u.fullId.toString());break;case 2:this.I(u);break;case 4:this.pushDiff({op:1,item:{extId:u.fullId.toString(),item:o.update}});break;case 6:this.w(u.actual.uri);break;default:(0,M.$3c)(o)}}w(u){u&&this.pushDiff({op:2,uri:u,docv:this.s.getDocumentVersion(u)})}y(u,o){const l=$.$pJ.fromExtHostTestItem(u,this.root.id,o?.actual),r=this.s.getApiFor(u);r.parent&&r.parent!==o?.actual&&this.s.getChildren(r.parent).delete(u.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:u,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},u.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(u,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(u)}}),this.H(u,s,o);return}if(s.actual===u){this.G(u,s,o);return}if(s.actual.uri?.toString()!==u.uri?.toString())return this.N(l.toString()),this.y(u,o);const c=this.s.getChildren(s.actual),h=s.actual,b=a(this.s.toITestItem(h),this.s.toITestItem(u));this.s.getApiFor(h).listener=void 0,s.actual=u,s.expand=0,b&&(b.hasOwnProperty("tags")&&(this.z(u.tags,h.tags,l.toString()),delete b.tags),this.u(s,{op:4,update:b})),this.H(u,s,o);for(const[m,I]of c)this.s.getChildren(u).get(I.id)||this.N($.$pJ.joinToString(l,I.id));this.w(s.actual.uri)}z(u,o,l){const r=new Set(o.map(s=>s.id));for(const s of u)r.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:l,item:{tags:u.map(s=>(0,R.$tJ)(this.s.controllerId,s.id))}}}),r.forEach(this.D,this)}C(u){const o=this.j.get(u.id);o?o.refCount++:(this.j.set(u.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$tJ)(this.s.controllerId,u.id)}}))}D(u){const o=this.j.get(u);o&&!--o.refCount&&(this.j.delete(u),this.pushDiff({op:7,id:(0,R.$tJ)(this.s.controllerId,u)}))}F(u,o){this.s.getApiFor(u).parent=o&&o.actual!==this.root?o.actual:void 0}G(u,o,l){this.F(u,l);const r=this.s.getApiFor(u);r.parent=l?.actual,r.listener=s=>this.u(o,s),this.I(o)}H(u,o,l){this.G(u,o,l);for(const[r,s]of this.s.getChildren(u))this.y(s,o)}I(u){let o;this.h?u.resolveBarrier?o=u.resolveBarrier.isOpen()?3:2:o=u.actual.canResolveChildren?1:0:o=0,o!==u.expand&&(u.expand=o,this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:o}}),o===1&&u.expandLevels!==void 0&&this.L(u))}J(u,o){if(o<0)return;const l=[];for(const[r,s]of this.s.getChildren(u.actual)){const c=this.expand($.$pJ.joinToString(u.fullId,s.id),o);(0,E.$Jg)(c)&&l.push(c)}if(l.length)return Promise.all(l).then(()=>{})}L(u){if(u.resolveBarrier)return u.resolveBarrier;if(!this.h){const s=new E.$Vg;return s.open(),s}u.expand=2,this.M(u);const o=u.resolveBarrier=new E.$Vg,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let r;try{r=this.h(u.actual===this.root?void 0:u.actual)}catch(s){l(s)}return(0,E.$Jg)(r)?r.catch(l).then(()=>{o.open(),this.I(u)}):(o.open(),this.I(u)),u.resolveBarrier}M(u){this.pushDiff({op:1,item:{extId:u.fullId.toString(),expand:u.expand}})}N(u){const o=this.tree.get(u);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:u});const l=[o];for(;l.length;){const r=l.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.D(s.id);this.tree.delete(r.fullId.toString());for(const[s,c]of this.s.getChildren(r.actual))l.push(this.tree.get($.$pJ.joinToString(r.fullId,c.id)))}}}flushDiff(){const u=this.collectDiff();u.length&&this.g.fire(u)}}e.$rM=v;class p extends Error{constructor(u){super(`Attempted to insert a duplicate test item ID ${u}`)}}e.$sM=p;class f extends Error{constructor(u){super(`TestItem with ID "${u}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$tM=f;class t extends Error{constructor(u,o,l){super(`TestItem with ID "${u}" is from controller "${o}" and cannot be added as a child of an item from controller "${l}".`)}}e.$uM=t;const i=(n,u,o)=>{let l=new Map;return{get size(){return l.size},forEach(r,s){for(const c of l.values())r.call(s,c,this)},[Symbol.iterator](){return l.entries()},replace(r){const s=new Map,c=new Set(l.keys()),h={op:5,ops:[]};for(const b of r){if(!(b instanceof o))throw new f(b.id);const m=u(b).controllerId;if(m!==n.controllerId)throw new t(b.id,m,n.controllerId);if(s.has(b.id))throw new p(b.id);s.set(b.id,b),c.delete(b.id),h.ops.push({op:0,item:b})}for(const b of c.keys())h.ops.push({op:3,id:b});n.listener?.(h),l=s},add(r){if(!(r instanceof o))throw new f(r.id);l.set(r.id,r),n.listener?.({op:0,item:r})},delete(r){l.delete(r)&&n.listener?.({op:3,id:r})},get(r){return l.get(r)},toJSON(){return Array.from(l.values())}}};e.$vM=i}),define(Pe[104],Ae([1,0,77]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0;const L=new WeakMap,P=(R,$)=>{const D={controllerId:$};return L.set(R,D),D};e.$wM=P;const M=R=>{const $=L.get(R);if(!$)throw new E.$tM(R?.id||"<unknown>");return $};e.$xM=M}),define(Pe[78],Ae([1,0,14,2]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cub=e.$bub=e.$aub=e.$_tb=e.$$tb=void 0,e.$$tb="vscode-cdn.net",e.$_tb=`vscode-resource.${e.$$tb}`,e.$aub=`'self' https://*.${e.$$tb}`;function P($,D){return $.scheme===E.Schemas.http||$.scheme===E.Schemas.https?$:(D&&D.authority&&D.isRemote&&$.scheme===E.Schemas.file&&($=L.URI.from({scheme:E.Schemas.vscodeRemote,authority:D.authority,path:$.path})),L.URI.from({scheme:E.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$_tb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$bub=P;function M($){return $.replace(/./g,D=>{const g=D.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?D:"-"+g.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(D,g)=>String.fromCharCode(parseInt(g,16)))}e.$cub=R}),define(Pe[214],Ae([1,0,5,6,78]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;class M{constructor($,D,g){this.d=$,this.e=D,this.f=g,this.a=0,this.b=new L.$Qc,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const A=D.getVisibleTextEditors();for(const S of this.c.values())A.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,D,g,A,S){let a;for(const u of this.e.getVisibleTextEditors(!0))if(u.value===$){a=u;break}if(!a)throw new Error("not a visible editor");const v=this,p=this.a++,f=new E.$Qd,t=new E.$Qd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(u){return(0,P.$bub)(u,v.f)}get cspSource(){return P.$aub}set options(u){this.b=u,v.d.$setOptions(p,u)}get options(){return this.b}set html(u){this.a=u,v.d.$setHtml(p,u)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(u){return v.d.$postMessage(p,u)}},n=new class{constructor(){this.editor=$,this.line=D,this.height=g,this.webview=i,this.onDidDispose=t.event}dispose(){v.c.has(p)&&(v.c.delete(p),v.d.$disposeEditorInset(p),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(p,a.id,a.value.document.uri,D+1,g,A||{},S.identifier,S.extensionLocation),this.c.set(p,{editor:$,inset:n,onDidReceiveMessage:f}),n}$onDidDispose($){const D=this.c.get($);D&&D.inset.dispose()}$onDidReceiveMessage($,D){this.c.get($)?.onDidReceiveMessage.fire(D)}}e.$Hec=M}),define(Pe[215],Ae([1,0,4]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=e.VariableKind=e.$nN=void 0,e.$nN=(0,E.$Uh)("configurationResolverService");var L;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class P extends Error{constructor(R,$){super($),this.variable=R}}e.$oN=P}),define(Pe[216],Ae([1,0,19,74,16,26,21,94,178,215,13]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,p,f,t){this.h=new Map,this.a=v,this.b=p,this.g=f,t&&(this.c=t.then(i=>this.i(i)))}i(v){if(R.$i){const p=Object.create(null);return Object.keys(v).forEach(f=>{p[f.toLowerCase()]=v[f]}),p}return v}resolveWithEnvironment(v,p,f){return this.l({env:this.i(v),userHome:void 0},p?p.uri:void 0,f)}async resolveAsync(v,p){const f={env:await this.c,userHome:await this.g};return this.l(f,v?v.uri:void 0,p)}async j(v,p,f,t){const i=M.$_m(p);R.$i&&i.windows?Object.keys(i.windows).forEach(u=>i[u]=i.windows[u]):R.$j&&i.osx?Object.keys(i.osx).forEach(u=>i[u]=i.osx[u]):R.$k&&i.linux&&Object.keys(i.linux).forEach(u=>i[u]=i.linux[u]),delete i.windows,delete i.osx,delete i.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,v?v.uri:void 0,i,f,t)}async resolveAnyAsync(v,p,f){return this.j(v,p,f)}async resolveAnyMap(v,p,f){const t=new Map;return{newConfig:await this.j(v,p,f,t),resolvedVariables:t}}resolveWithInteractionReplace(v,p,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,p,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,p){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,p)}async l(v,p,f,t,i){if(P.$Bf(f))return this.m(v,p,f,t,i);if(Array.isArray(f))return Promise.all(f.map(n=>this.l(v,p,n,t,i)));if(P.$Df(f)){const n=Object.create(null),u=await Promise.all(Object.keys(f).map(async o=>[await this.m(v,p,o,t,i),await this.l(v,p,f[o],t,i)]));for(const[o,l]of u)n[o]=l;return n}return f}m(v,p,f,t,i){return(0,A.$We)(f,S.VARIABLE_REGEXP,async(n,u)=>{if(u.includes(S.VARIABLE_LHS))return n;let o=await this.o(v,n,u,p,t);return i?.set(u,o),o!==n&&P.$Bf(o)&&o.match(S.VARIABLE_REGEXP)&&(o=await this.m(v,p,o,t,i)),o})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,p,f,t,i){let n;const u=f.split(":");u.length>1&&(f=u[0],n=u[1]);const o=s=>{const c=this.a.getFilePath();if(c)return(0,$.$yv)(c);throw new g.$oN(s,(0,D.localize)(0,null,p))},l=s=>{const c=o(s);if(this.a.getWorkspaceFolderPathForFile){const h=this.a.getWorkspaceFolderPathForFile();if(h)return(0,$.$yv)(h)}throw new g.$oN(s,(0,D.localize)(1,null,p,E.$mc(c)))},r=s=>{if(n){const c=this.a.getFolderUri(n);if(c)return c;throw new g.$oN(s,(0,D.localize)(2,null,p,n))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new g.$oN(s,(0,D.localize)(3,null,p)):new g.$oN(s,(0,D.localize)(4,null,p))};switch(f){case"env":if(n){if(v.env){const s=v.env[R.$i?n.toLowerCase():n];if(P.$Bf(s))return s}return""}throw new g.$oN(g.VariableKind.Env,(0,D.localize)(5,null,p));case"config":if(n){const s=this.a.getConfigurationValue(t,n);if(P.$Kf(s))throw new g.$oN(g.VariableKind.Config,(0,D.localize)(6,null,p,n));if(P.$Df(s))throw new g.$oN(g.VariableKind.Config,(0,D.localize)(7,null,p,n));return s}throw new g.$oN(g.VariableKind.Config,(0,D.localize)(8,null,p));case"command":return this.p(g.VariableKind.Command,p,n,i,"command");case"input":return this.p(g.VariableKind.Input,p,n,i,"input");case"extensionInstallFolder":if(n){const s=await this.a.getExtension(n);if(!s)throw new g.$oN(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,p,n));return this.n(s.extensionLocation)}throw new g.$oN(g.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,p));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,$.$yv)(this.n(r(g.VariableKind.WorkspaceFolder)));case"cwd":return t||n?(0,$.$yv)(this.n(r(g.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$yv)(E.$mc(this.n(r(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new g.$oN(g.VariableKind.UserHome,(0,D.localize)(11,null,p))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$oN(g.VariableKind.LineNumber,(0,D.localize)(12,null,p))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$oN(g.VariableKind.SelectedText,(0,D.localize)(13,null,p))}case"file":return o(g.VariableKind.File);case"fileWorkspaceFolder":return l(g.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||n?E.$kc(this.n(r(g.VariableKind.RelativeFile)),o(g.VariableKind.RelativeFile)):o(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$lc(o(g.VariableKind.RelativeFileDirname));if(t||n){const c=E.$kc(this.n(r(g.VariableKind.RelativeFileDirname)),s);return c.length===0?".":c}return s}case"fileDirname":return E.$lc(o(g.VariableKind.FileDirname));case"fileExtname":return E.$nc(o(g.VariableKind.FileExtname));case"fileBasename":return E.$mc(o(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$mc(o(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$nc(s).length)}case"fileDirnameBasename":return E.$mc(E.$lc(o(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||p}case"execInstallFolder":{const s=this.a.getAppRoot();return s||p}case"pathSeparator":return E.sep;default:try{const s=n?`${f}:${n}`:f;return this.p(g.VariableKind.Unknown,p,s,i,void 0)}catch{return p}}}}p(v,p,f,t,i){if(f&&t){const n=i===void 0?t[f]:t[i+":"+f];if(typeof n=="string")return n;throw new g.$oN(v,(0,D.localize)(14,null,p))}return p}}e.$CN=S}),define(Pe[105],Ae([1,0,4,102]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IC=e.$HC=e.OpenEditorContext=e.GroupsOrder=e.$GC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$FC=void 0,e.$FC=(0,E.$Uh)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var M;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var D;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function g(p){const f=p;return(0,L.$oE)(f?.editor)&&(0,L.$oE)(f?.replacement)}e.$GC=g;var A;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var S;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function a(p){const f=p;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$HC=a;function v(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$IC=v}),define(Pe[217],Ae([1,0,4,105]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.$LC=e.$KC=e.$JC=void 0,e.$JC=(0,E.$Uh)("editorService"),e.$KC=-1,e.$LC=-2;function P(M){const R=M;return typeof M=="number"||(0,L.$HC)(R)}e.$MC=P}),define(Pe[218],Ae([1,0,4,185]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TJ=void 0,e.$TJ=(0,E.$Vh)(L.$2h)}),define(Pe[106],Ae([1,0,22,5,19,6]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q5b=e.$P5b=e.$O5b=e.$N5b=e.$M5b=void 0;class R{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$M5b=R;class ${static isHostExtension(i,n,u){if(n.getExtensionDescription(i))return!1;const o=u.getExtensionDescription(i);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(i,n){this.j=i,this.c=new L.$Qd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(p),this.f=new E.$am,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const u of n)this.h.has(u)||this.h.set(u,[]),this.h.get(u).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=f(this.e,n),this.e=this.e.concat(i);const u=$.l(this.e);return this.e=f(this.e,u.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,u)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,c){this.addNode(s),this.addNode(c),this.c.has(s)?this.c.get(s).push(c):this.c.set(s,[c])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,c){const h=n.getArcs(s);for(let b=0;b<h.length;b++)if(!c.has(h[b]))return!1;return!0}getNodes(){return this.e}},u=new E.$am;for(const s of i)if(u.set(s.identifier,s),s.extensionDependencies)for(const c of s.extensionDependencies)n.addArc(E.$$l.toKey(s.identifier),E.$$l.toKey(c));const o=new Set;n.getNodes().filter(s=>n.getArcs(s).length===0).forEach(s=>o.add(s));const l=n.getNodes().filter(s=>!o.has(s));let r;do{r=!1;for(let s=0;s<l.length;s++){const c=l[s];n.hasOnlyGoodArcs(c,o)&&(l.splice(s,1),s--,o.add(c),r=!0)}}while(r);return l.map(s=>u.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$N5b=$;class D{constructor(i,n){this.versionId=i,this.extensions=n}}e.$O5b=D;class g{constructor(i){this.d=new a,this.c=new $(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new A(this,n)}deltaExtensions(i,n,u){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,u)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$P5b=g;class A extends M.$Rc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$Q5b=A;class S{constructor(i){this.name=i,this.promise=new Promise((n,u)=>{this.c=n})}resolve(i){this.c(i)}}class a{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new S(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const u=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{n&&(clearTimeout(u),n=!1,this.d=!1,this.e())};i.resolve((0,M.$Pc)(o))}}var v;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(v||(v={}));function p(t,i){const n=t.isBuiltin?0:t.isUnderDevelopment?2:1,u=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==u)return n-u;const o=P.$fc.basename(t.extensionLocation.path),l=P.$fc.basename(i.extensionLocation.path);return o<l?-1:o>l?1:0}function f(t,i){const n=new E.$_l(i);return t.filter(u=>!n.has(u.identifier))}}),define(Pe[79],Ae([1,0,24]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$hm=e.$gm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(L||(e.UIKind=L={}));var P;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var M;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(g){const A=E.$ee.alloc(1);switch(g){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$gm=R;function $(g,A){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$hm=$;var D;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Pe[61],Ae([1,0,4,5,15,27,79,57,58,26,2,6,166]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.$TM=e.$SM=void 0;let v=class extends S.$Rc{constructor(i,n){super(),this.s=i,this.t=n,this.a=this.B(new L.$Qd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$Qd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:D.$to,name:(0,a.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(u=>{(0,P.$ej)(u)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,n,u){const o=this.getTelemetryDetails(),l=new p(n,u,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),r=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...r,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(i,n,u){this.f=i,this.g=n,this.c=u??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const n=Object.create(null);switch(n["common.extname"]=`${i.publisher}.${i.name}`,n["common.extversion"]=i.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$1k)((0,D.$Ao)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const n=this.getTelemetryDetails();this.r.forEach((u,o)=>{const l=u.filter(r=>!r.isDisposed);l.length===0?this.r.delete(o):this.r.set(o,l)}),this.r.forEach(u=>{for(const o of u)o.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,n){const o=this.r.get(i.value)?.filter(r=>!r.isDisposed);if(!o)return this.r.delete(i.value),!1;let l=!1;for(const r of o)r.ignoreUnhandledExtHostErrors||(r.logError(n),l=!0);return l}};e.$SM=v,e.$SM=v=Ke([Ve(0,M.$RM),Ve(1,P.$dj)],v);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,n,u,o,l,r,s){this.g=u,this.h=o,this.i=l,this.j=r,this.a=new L.$Qd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,n){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let n="properties"in i?i.properties??{}:i;return n=(0,D.$Do)(n,[]),this.c&&(n=(0,g.$cn)(n,this.c)),this.b||(n=(0,g.$cn)(n,this.j)),"properties"in i?i.properties=n:i=n,i}k(i,n){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(i,n),this.h.trace(i,n))}logUsage(i,n){this.d.isUsageEnabled&&this.k(i,n)}logError(i,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,n);else{const u={name:i.name,message:i.message,stack:i.stack,cause:i.cause},o=(0,D.$Do)(u,[]),l=new Error(o.message,{cause:o.cause});l.stack=o.stack,l.name=o.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(l,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const i=this,n={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$TM=p;function f(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$UM=f,e.$VM=(0,E.$Uh)("IExtHostTelemetry")}),define(Pe[23],Ae([1,0,5,2,194,101,22,4]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=e.$BF=e.ActivationKind=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=e.ExtensionHostStartup=e.$vF=e.$uF=e.$tF=e.$sF=void 0,e.$sF=Object.freeze({identifier:new R.$$l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$tF="extensions.webWorker",e.$uF=(0,$.$Uh)("extensionService");class D{constructor(l){this.dependency=l}}e.$vF=D;var g;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,r,s){this.c=l,this.d=r.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$dF.createActivationEventsMap(this.d)}}set(l,r,s){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const c=[],h=[],b=[],m=[],I=S(this.d),k=S(r),d=(H,U)=>H.extensionLocation.toString()===U.extensionLocation.toString()||H.isBuiltin===U.isBuiltin||H.isUserBuiltin===U.isUserBuiltin||H.isUnderDevelopment===U.isUnderDevelopment;for(const H of this.d){const U=k.get(H.identifier);if(!U){c.push(H.identifier),I.delete(H.identifier);continue}if(!d(H,U)){c.push(H.identifier),I.delete(H.identifier);continue}}for(const H of r){const U=I.get(H.identifier);if(!U){h.push(H);continue}if(!d(U,H)){c.push(U.identifier),I.delete(U.identifier);continue}}const w=new R.$_l(this.e),y=new R.$_l(s);for(const H of this.e)y.has(H)||b.push(H);for(const H of s)w.has(H)||m.push(H);const C=M.$dF.createActivationEventsMap(h),W={versionId:l,toRemove:c,toAdd:h,addActivationEvents:C,myToRemove:b,myToAdd:m};return this.delta(W),W}delta(l){if(this.c>=l.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:c,myToAdd:h}=l,b=new R.$_l(r),m=new R.$_l(c);for(let I=0;I<this.d.length;I++)b.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)m.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of s)this.d.push(I);for(const I of h)this.e.push(I);return this.f=null,l}containsExtension(l){for(const r of this.e)if(R.$$l.equals(r,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const r of this.d){if(!this.containsExtension(r.identifier))continue;const s=M.$dF.readActivationEvents(r);for(const c of s)l.add(c)}return l}}e.$wF=A;function S(o){const l=new R.$am;for(const r of o)l.set(r.identifier,r);return l}function a(o,l){return o.enabledApiProposals?o.enabledApiProposals.includes(l):!1}e.$xF=a;function v(o,l){if(!a(o,l))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$yF=v;class p{constructor(l,r,s,c){this.codeLoadingTime=l,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=c}}e.$zF=p;class f{constructor(l,r){this.description=l,this.value=r}}e.$AF=f;var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.$Jo)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$BF=i;function n(o,l){return{identifier:new R.$$l((0,P.$Ho)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!l,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$CF=n;class u{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$DF=u}),define(Pe[219],Ae([1,0,11,106,22,23,15,12]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=e.$Xdc=e.$Wdc=e.$Vdc=e.$Udc=e.$Tdc=void 0;class D{static{this.NONE=new D(!1,-1,-1,-1)}constructor(i,n,u,o){this.startup=i,this.codeLoadingTime=n,this.activateCallTime=u,this.activateResolvedTime=o}}e.$Tdc=D;class g{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,n){return i===-1||n===-1?-1:n-i}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Udc=g;class A{constructor(i,n,u,o,l,r){this.activationFailed=i,this.activationFailedError=n,this.activationTimes=u,this.module=o,this.exports=l,this.subscriptions=r}}e.$Vdc=A;class S extends A{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wdc=S;class a extends A{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Xdc=a;class v extends A{constructor(i){super(!0,i,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,n,u,o){this.g=o,this.a=i,this.b=n,this.c=u,this.d=new P.$am,this.f=Object.create(null)}dispose(){for(const[i,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const i=[];for(const[n,u]of this.d)i.push(u.wait());await Promise.all(i)}isActivated(i){const n=this.d.get(i);return!!(n&&n.value)}getActivatedExtension(i){const n=this.d.get(i);if(!n||!n.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return n.value}async activateByEvent(i,n){if(this.f[i])return;const u=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(u.map(o=>({id:o.identifier,reason:{startup:n,extensionId:o.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,n){const u=this.a.getExtensionDescription(i);if(!u)throw new Error(`Extension '${i}' is not known`);return this.h([{id:u.identifier,reason:n}])}async h(i){const n=i.filter(u=>!this.isActivated(u.id)).map(u=>this.j(u));await Promise.all(n.map(u=>u.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const n=this.a.getExtensionDescription(i.id);if(!n){const l=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this.k(i,null,[],new v(l));return this.c.onExtensionActivationError(i.id,l,new M.$vF(i.id.value)),r}const u=[],o=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const l of o){if(this.m(l))continue;const r=this.d.get(l);if(r){u.push(r);continue}if(this.l(l)){u.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;u.push(this.j({id:s.identifier,reason:i.reason}));continue}const c=n.displayName||n.identifier.value,h=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${l}'`),b=this.k(i,n.displayName,[],new v(h));return this.c.onExtensionActivationError(n.identifier,h,new M.$vF(l)),b}return this.k(i,n.displayName,u,null)}k(i,n,u,o){const l=new f(i.id,n,i.reason,u,o,this.c,this.g);return this.d.set(i.id,l),l}l(i){return L.$N5b.isHostExtension(i,this.a,this.b)}m(i){const n=this.b.getExtensionDescription(i);return n?!n.main&&!n.browser:!1}};e.$Ydc=p,e.$Ydc=p=Ke([Ve(3,R.$cj)],p);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,n,u,o,l,r,s){this.c=i,this.d=n,this.f=u,this.g=o,this.h=l,this.j=r,this.k=s,this.a=new $.$Vg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const n=this.g[i];if(n.value&&!n.value.activationFailed){this.g.splice(i,1),i--;continue}if(n.value&&n.value.activationFailed){const u=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);u.detail=n.value.activationFailedError,this.h=new v(u),this.j.onExtensionActivationError(this.c,u,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const n=new Error;if(i&&i.name&&(n.name=i.name),i&&i.message?n.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(n.stack=i.stack),this.h=new v(n),this.b&&E.$3(i))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};f=Ke([Ve(6,R.$cj)],f)}),define(Pe[8],Ae([1,0,18,24,126,220,53,28,120,52,69,26,16,2,29,80,98,104,102,76,48,60,217,7,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o,l,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$AM=e.$zM=e.MarkdownString=e.$yM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(Se){function Le(K){const{selectionStartLineNumber:Me,selectionStartColumn:Ue,positionLineNumber:Qe,positionColumn:qe}=K,et=new s.$CK(Me-1,Ue-1),Et=new s.$CK(Qe-1,qe-1);return new s.$EK(et,Et)}Se.to=Le;function $e(K){const{anchor:Me,active:Ue}=K;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Se.from=$e})(h||(e.Selection=h={}));var b;(function(Se){function Le(K){if(!K)return;const{start:Me,end:Ue}=K;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Se.from=Le;function $e(K){if(!K)return;const{startLineNumber:Me,startColumn:Ue,endLineNumber:Qe,endColumn:qe}=K;return new s.$DK(Me-1,Ue-1,Qe-1,qe-1)}Se.to=$e})(b||(e.Range=b={}));var m;(function(Se){function Le($e){switch($e){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Se.to=Le})(m||(e.TokenType=m={}));var I;(function(Se){function Le(K){return new s.$CK(K.lineNumber-1,K.column-1)}Se.to=Le;function $e(K){return{lineNumber:K.line+1,column:K.character+1}}Se.from=$e})(I||(e.Position=I={}));var k;(function(Se){function Le(Me,Ue,Qe){return(0,E.$Gb)((0,E.$2b)(Me).map(qe=>$e(qe,Ue,Qe)))}Se.from=Le;function $e(Me,Ue,Qe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Qe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:K(Me.scheme,Ue),pattern:Y.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Qe?.isBuiltin}}function K(Me,Ue){return Ue&&typeof Me=="string"?Ue.transformOutgoingScheme(Me):Me}})(k||(e.DocumentSelector=k={}));var d;(function(Se){function Le(K){switch(K){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Se.from=Le;function $e(K){switch(K){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Se.to=$e})(d||(e.DiagnosticTag=d={}));var w;(function(Se){function Le(K){let Me;return K.code&&((0,a.$Bf)(K.code)||(0,a.$Ff)(K.code)?Me=String(K.code):Me={value:String(K.code.value),target:K.code.target}),{...b.from(K.range),message:K.message,source:K.source,code:Me,severity:C.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(y.from),tags:Array.isArray(K.tags)?(0,E.$Gb)(K.tags.map(d.from)):void 0}}Se.from=Le;function $e(K){const Me=new s.$PK(b.to(K),K.message,C.to(K.severity));return Me.source=K.source,Me.code=(0,a.$Bf)(K.code)?K.code:K.code?.value,Me.relatedInformation=K.relatedInformation&&K.relatedInformation.map(y.to),Me.tags=K.tags&&(0,E.$Gb)(K.tags.map(d.to)),Me}Se.to=$e})(w||(e.Diagnostic=w={}));var y;(function(Se){function Le(K){return{...b.from(K.location.range),message:K.message,resource:K.location.uri}}Se.from=Le;function $e(K){return new s.$OK(new s.$NK(K.resource,b.to(K)),K.message)}Se.to=$e})(y||(e.DiagnosticRelatedInformation=y={}));var C;(function(Se){function Le(K){switch(K){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Se.from=Le;function $e(K){switch(K){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Se.to=$e})(C||(e.DiagnosticSeverity=C={}));var W;(function(Se){function Le(K){return typeof K=="number"&&K>=s.ViewColumn.One?K-1:K===s.ViewColumn.Beside?r.$LC:r.$KC}Se.from=Le;function $e(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=$e})(W||(e.ViewColumn=W={}));function H(Se){return typeof Se.range<"u"}function U(Se){return Se.length===0?!0:!!H(Se[0])}e.$yM=U;var z;(function(Se){function Le(qe){return qe.map(Se.from)}Se.fromMany=Le;function $e(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function K(qe){let et;if($e(qe)){const{language:ht,value:ft}=qe;et={value:"```"+ht+`
`+ft+"\n```\n"}}else s.$2K.isMarkdownString(qe)?et={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?et={value:qe}:et={value:""};const Et=Object.create(null);et.uris=Et;const Dt=ht=>{try{let ft=v.URI.parse(ht,!0);ft=ft.with({query:Me(ft.query,Et)}),Et[ht]=ft}catch{}return""},gt=new D.marked.Renderer;return gt.link=Dt,gt.image=ht=>typeof ht=="string"?Dt(R.$ck(ht).href):"",(0,D.marked)(et.value,{renderer:gt}),et}Se.from=K;function Me(qe,et){if(!qe)return qe;let Et;try{Et=(0,g.$qh)(qe)}catch{}if(!Et)return qe;let Dt=!1;return Et=(0,S.$bn)(Et,gt=>{if(v.URI.isUri(gt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ht]=gt,Dt=!0,ht}else return}),Dt?JSON.stringify(Et):qe}function Ue(qe){const et=new s.$2K(qe.value,qe.supportThemeIcons);return et.isTrusted=qe.isTrusted,et.supportHtml=qe.supportHtml,et.baseUri=qe.baseUri?v.URI.from(qe.baseUri):void 0,et}Se.to=Ue;function Qe(qe){if(qe)return typeof qe=="string"?qe:Se.from(qe)}Se.fromStrict=Qe})(z||(e.MarkdownString=z={}));function F(Se){return U(Se)?Se.map(Le=>({range:b.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?z.fromMany(Le.hoverMessage):Le.hoverMessage?z.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Se.map(Le=>({range:b.from(Le)}))}e.$zM=F;function N(Se){return typeof Se>"u"?Se:typeof Se=="string"?v.URI.file(Se):Se}e.$AM=N;var x;(function(Se){function Le($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?N($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}Se.from=Le})(x||(e.ThemableDecorationAttachmentRenderOptions=x={}));var J;(function(Se){function Le($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?N($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?x.from($e.before):void 0,after:$e.after?x.from($e.after):void 0}}Se.from=Le})(J||(e.ThemableDecorationRenderOptions=J={}));var Ee;(function(Se){function Le($e){if(typeof $e>"u")return $e;switch($e){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Le})(Ee||(e.DecorationRangeBehavior=Ee={}));var De;(function(Se){function Le($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?Ee.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?J.from($e.light):void 0,dark:$e.dark?J.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?N($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?x.from($e.before):void 0,after:$e.after?x.from($e.after):void 0}}Se.from=Le})(De||(e.DecorationRenderOptions=De={}));var Ce;(function(Se){function Le(K){return{text:K.newText,eol:K.newEol&&xe.from(K.newEol),range:b.from(K.range)}}Se.from=Le;function $e(K){const Me=new s.$IK(b.to(K.range),K.text);return Me.newEol=typeof K.eol>"u"?void 0:xe.to(K.eol),Me}Se.to=$e})(Ce||(e.TextEdit=Ce={}));var fe;(function(Se){function Le(K,Me){const Ue={edits:[]};if(K instanceof s.$LK){const Qe=new $.$Ac;for(const qe of K._allEntries())qe._type===1&&v.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of K._allEntries())if(qe._type===1){let et;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?et={type:"base64",value:(0,L.$ye)(L.$ee.wrap(qe.options.contents))}:et={type:"dataTransferItem",id:qe.options.contents._itemId}),Ue.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:et},metadata:qe.metadata})}else qe._type===2?Ue.edits.push({resource:qe.uri,textEdit:Ce.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ue.edits.push({resource:qe.uri,textEdit:{range:b.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ue.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ue.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(bt.from)}})}return Ue}Se.from=Le;function $e(K){const Me=new s.$LK,Ue=new $.$zc;for(const Qe of K.edits)if(Qe.textEdit){const qe=Qe,et=v.URI.revive(qe.resource),Et=b.to(qe.textEdit.range),Dt=qe.textEdit.text,gt=qe.textEdit.insertAsSnippet;let ht;gt?ht=s.$KK.replace(Et,new s.$MK(Dt)):ht=s.$IK.replace(Et,Dt);const ft=Ue.get(et);ft?ft.push(ht):Ue.set(et,[ht])}else Me.renameFile(v.URI.revive(Qe.oldResource),v.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of Ue)Me.set(Qe,qe);return Me}Se.to=$e})(fe||(e.WorkspaceEdit=fe={}));var be;(function(Se){const Le=Object.create(null);Le[s.SymbolKind.File]=0,Le[s.SymbolKind.Module]=1,Le[s.SymbolKind.Namespace]=2,Le[s.SymbolKind.Package]=3,Le[s.SymbolKind.Class]=4,Le[s.SymbolKind.Method]=5,Le[s.SymbolKind.Property]=6,Le[s.SymbolKind.Field]=7,Le[s.SymbolKind.Constructor]=8,Le[s.SymbolKind.Enum]=9,Le[s.SymbolKind.Interface]=10,Le[s.SymbolKind.Function]=11,Le[s.SymbolKind.Variable]=12,Le[s.SymbolKind.Constant]=13,Le[s.SymbolKind.String]=14,Le[s.SymbolKind.Number]=15,Le[s.SymbolKind.Boolean]=16,Le[s.SymbolKind.Array]=17,Le[s.SymbolKind.Object]=18,Le[s.SymbolKind.Key]=19,Le[s.SymbolKind.Null]=20,Le[s.SymbolKind.EnumMember]=21,Le[s.SymbolKind.Struct]=22,Le[s.SymbolKind.Event]=23,Le[s.SymbolKind.Operator]=24,Le[s.SymbolKind.TypeParameter]=25;function $e(Me){return typeof Le[Me]=="number"?Le[Me]:6}Se.from=$e;function K(Me){for(const Ue in Le)if(Le[Ue]===Me)return Number(Ue);return s.SymbolKind.Property}Se.to=K})(be||(e.SymbolKind=be={}));var se;(function(Se){function Le(K){switch(K){case s.SymbolTag.Deprecated:return 1}}Se.from=Le;function $e(K){switch(K){case 1:return s.SymbolTag.Deprecated}}Se.to=$e})(se||(e.SymbolTag=se={}));var Re;(function(Se){function Le(K){return{name:K.name,kind:be.from(K.kind),tags:K.tags&&K.tags.map(se.from),containerName:K.containerName,location:pe.from(K.location)}}Se.from=Le;function $e(K){const Me=new s.$SK(K.name,be.to(K.kind),K.containerName,pe.to(K.location));return Me.tags=K.tags&&K.tags.map(se.to),Me}Se.to=$e})(Re||(e.WorkspaceSymbol=Re={}));var oe;(function(Se){function Le(K){const Me={name:K.name||"!!MISSING: name!!",detail:K.detail,range:b.from(K.range),selectionRange:b.from(K.selectionRange),kind:be.from(K.kind),tags:K.tags?.map(se.from)??[]};return K.children&&(Me.children=K.children.map(Le)),Me}Se.from=Le;function $e(K){const Me=new s.$TK(K.name,K.detail,be.to(K.kind),b.to(K.range),b.to(K.selectionRange));return(0,E.$Kb)(K.tags)&&(Me.tags=K.tags.map(se.to)),K.children&&(Me.children=K.children.map($e)),Me}Se.to=$e})(oe||(e.DocumentSymbol=oe={}));var X;(function(Se){function Le(K){const Me=new s.$XK(be.to(K.kind),K.name,K.detail||"",v.URI.revive(K.uri),b.to(K.range),b.to(K.selectionRange));return Me._sessionId=K._sessionId,Me._itemId=K._itemId,Me}Se.to=Le;function $e(K,Me,Ue){if(Me=Me??K._sessionId,Ue=Ue??K._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,name:K.name,detail:K.detail,kind:be.from(K.kind),uri:K.uri,range:b.from(K.range),selectionRange:b.from(K.selectionRange),tags:K.tags?.map(se.from)}}Se.from=$e})(X||(e.CallHierarchyItem=X={}));var j;(function(Se){function Le($e){return new s.$YK(X.to($e.from),$e.fromRanges.map(K=>b.to(K)))}Se.to=Le})(j||(e.CallHierarchyIncomingCall=j={}));var ne;(function(Se){function Le($e){return new s.$ZK(X.to($e.to),$e.fromRanges.map(K=>b.to(K)))}Se.to=Le})(ne||(e.CallHierarchyOutgoingCall=ne={}));var pe;(function(Se){function Le(K){return{range:K.range&&b.from(K.range),uri:K.uri}}Se.from=Le;function $e(K){return new s.$NK(v.URI.revive(K.uri),b.to(K.range))}Se.to=$e})(pe||(e.location=pe={}));var re;(function(Se){function Le(K){const Me=K,Ue=K;return{originSelectionRange:Me.originSelectionRange?b.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ue.uri,range:b.from(Me.targetRange?Me.targetRange:Ue.range),targetSelectionRange:Me.targetSelectionRange?b.from(Me.targetSelectionRange):void 0}}Se.from=Le;function $e(K){return{targetUri:v.URI.revive(K.uri),targetRange:b.to(K.range),targetSelectionRange:K.targetSelectionRange?b.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?b.to(K.originSelectionRange):void 0}}Se.to=$e})(re||(e.DefinitionLink=re={}));var he;(function(Se){function Le(K){return{range:b.from(K.range),contents:z.fromMany(K.contents)}}Se.from=Le;function $e(K){return new s.$QK(K.contents.map(z.to),b.to(K.range))}Se.to=$e})(he||(e.Hover=he={}));var ue;(function(Se){function Le(K){return{range:b.from(K.range),expression:K.expression}}Se.from=Le;function $e(K){return new s.$JL(b.to(K.range),K.expression)}Se.to=$e})(ue||(e.EvaluatableExpression=ue={}));var we;(function(Se){function Le(K){if(K instanceof s.$KL)return{type:"text",range:b.from(K.range),text:K.text};if(K instanceof s.$LL)return{type:"variable",range:b.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof s.$ML)return{type:"expression",range:b.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Le;function $e(K){switch(K.type){case"text":return{range:b.to(K.range),text:K.text};case"variable":return{range:b.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:b.to(K.range),expression:K.expression}}}Se.to=$e})(we||(e.InlineValue=we={}));var ee;(function(Se){function Le(K){return{frameId:K.frameId,stoppedLocation:b.from(K.stoppedLocation)}}Se.from=Le;function $e(K){return new s.$NL(K.frameId,b.to(K.stoppedLocation))}Se.to=$e})(ee||(e.InlineValueContext=ee={}));var de;(function(Se){function Le(K){return{range:b.from(K.range),kind:K.kind}}Se.from=Le;function $e(K){return new s.$RK(b.to(K.range),K.kind)}Se.to=$e})(de||(e.DocumentHighlight=de={}));var ie;(function(Se){function Le($e){switch($e){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Se.to=Le})(ie||(e.CompletionTriggerKind=ie={}));var ce;(function(Se){function Le($e){return{triggerKind:ie.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}Se.to=Le})(ce||(e.CompletionContext=ce={}));var me;(function(Se){function Le(K){switch(K){case s.CompletionItemTag.Deprecated:return 1}}Se.from=Le;function $e(K){switch(K){case 1:return s.CompletionItemTag.Deprecated}}Se.to=$e})(me||(e.CompletionItemTag=me={}));var Ie;(function(Se){const Le=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function $e(Ue){return Le.get(Ue)??9}Se.from=$e;const K=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Me(Ue){return K.get(Ue)??s.CompletionItemKind.Property}Se.to=Me})(Ie||(e.CompletionItemKind=Ie={}));var T;(function(Se){function Le($e,K){const Me=new s.$8K($e.label);return Me.insertText=$e.insertText,Me.kind=Ie.to($e.kind),Me.tags=$e.tags?.map(me.to),Me.detail=$e.detail,Me.documentation=R.$0j($e.documentation)?z.to($e.documentation):$e.documentation,Me.sortText=$e.sortText,Me.filterText=$e.filterText,Me.preselect=$e.preselect,Me.commitCharacters=$e.commitCharacters,p.$zs.isIRange($e.range)?Me.range=b.to($e.range):typeof $e.range=="object"&&(Me.range={inserting:b.to($e.range.insert),replacing:b.to($e.range.replace)}),Me.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&1),typeof $e.insertTextRules<"u"&&$e.insertTextRules&4?Me.insertText=new s.$MK($e.insertText):(Me.insertText=$e.insertText,Me.textEdit=Me.range instanceof s.$DK?new s.$IK(Me.range,Me.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Me.additionalTextEdits=$e.additionalTextEdits.map(Ue=>Ce.to(Ue))),Me.command=K&&$e.command?K.fromInternal($e.command):void 0,Me}Se.to=Le})(T||(e.CompletionItem=T={}));var V;(function(Se){function Le(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:z.fromStrict(K.documentation)}}Se.from=Le;function $e(K){return{label:K.label,documentation:R.$0j(K.documentation)?z.to(K.documentation):K.documentation}}Se.to=$e})(V||(e.ParameterInformation=V={}));var G;(function(Se){function Le(K){return{label:K.label,documentation:z.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(V.from):[],activeParameter:K.activeParameter}}Se.from=Le;function $e(K){return{label:K.label,documentation:R.$0j(K.documentation)?z.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(V.to):[],activeParameter:K.activeParameter}}Se.to=$e})(G||(e.SignatureInformation=G={}));var Q;(function(Se){function Le(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(G.from):[]}}Se.from=Le;function $e(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(G.to):[]}}Se.to=$e})(Q||(e.SignatureHelp=Q={}));var q;(function(Se){function Le($e,K){const Me=new s.$7K(I.to(K.position),typeof K.label=="string"?K.label:K.label.map(_.to.bind(void 0,$e)),K.kind&&le.to(K.kind));return Me.textEdits=K.textEdits&&K.textEdits.map(Ce.to),Me.tooltip=R.$0j(K.tooltip)?z.to(K.tooltip):K.tooltip,Me.paddingLeft=K.paddingLeft,Me.paddingRight=K.paddingRight,Me}Se.to=Le})(q||(e.InlayHint=q={}));var _;(function(Se){function Le($e,K){const Me=new s.$6K(K.label);return Me.tooltip=R.$0j(K.tooltip)?z.to(K.tooltip):K.tooltip,f.Command.is(K.command)&&(Me.command=$e.fromInternal(K.command)),K.location&&(Me.location=pe.to(K.location)),Me}Se.to=Le})(_||(e.InlayHintLabelPart=_={}));var le;(function(Se){function Le(K){return K}Se.from=Le;function $e(K){return K}Se.to=$e})(le||(e.InlayHintKind=le={}));var Oe;(function(Se){function Le(K){return{range:b.from(K.range),url:K.target,tooltip:K.tooltip}}Se.from=Le;function $e(K){let Me;if(K.url)try{Me=typeof K.url=="string"?v.URI.parse(K.url,!0):v.URI.revive(K.url)}catch{}return new s.$aL(b.to(K.range),Me)}Se.to=$e})(Oe||(e.DocumentLink=Oe={}));var Be;(function(Se){function Le(K){const Me=new s.$dL(K.label);return K.textEdit&&(Me.textEdit=Ce.to(K.textEdit)),K.additionalTextEdits&&(Me.additionalTextEdits=K.additionalTextEdits.map(Ue=>Ce.to(Ue))),Me}Se.to=Le;function $e(K){return{label:K.label,textEdit:K.textEdit?Ce.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Me=>Ce.from(Me)):void 0}}Se.from=$e})(Be||(e.ColorPresentation=Be={}));var Je;(function(Se){function Le(K){return new s.$bL(K[0],K[1],K[2],K[3])}Se.to=Le;function $e(K){return[K.red,K.green,K.blue,K.alpha]}Se.from=$e})(Je||(e.Color=Je={}));var Ge;(function(Se){function Le(K){return{range:b.from(K.range)}}Se.from=Le;function $e(K){return new s.$WK(b.to(K.range))}Se.to=$e})(Ge||(e.SelectionRange=Ge={}));var _e;(function(Se){function Le($e){switch($e){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Se.to=Le})(_e||(e.TextDocumentSaveReason=_e={}));var Ye;(function(Se){function Le(K){switch(K){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Le;function $e(K){switch(K){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Se.to=$e})(Ye||(e.TextEditorLineNumbersStyle=Ye={}));var xe;(function(Se){function Le(K){if(K===s.EndOfLine.CRLF)return 1;if(K===s.EndOfLine.LF)return 0}Se.from=Le;function $e(K){if(K===1)return s.EndOfLine.CRLF;if(K===0)return s.EndOfLine.LF}Se.to=$e})(xe||(e.EndOfLine=xe={}));var it;(function(Se){function Le($e){if(typeof $e=="object")return $e.viewId;switch($e){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Le})(it||(e.ProgressLocation=it={}));var tt;(function(Se){function Le(K){const Me={start:K.start+1,end:K.end+1};return K.kind&&(Me.kind=ze.from(K.kind)),Me}Se.from=Le;function $e(K){const Me={start:K.start-1,end:K.end-1};return K.kind&&(Me.kind=ze.to(K.kind)),Me}Se.to=$e})(tt||(e.FoldingRange=tt={}));var ze;(function(Se){function Le(K){if(K)switch(K){case s.FoldingRangeKind.Comment:return f.$ot.Comment;case s.FoldingRangeKind.Imports:return f.$ot.Imports;case s.FoldingRangeKind.Region:return f.$ot.Region}}Se.from=Le;function $e(K){if(K)switch(K.value){case f.$ot.Comment.value:return s.FoldingRangeKind.Comment;case f.$ot.Imports.value:return s.FoldingRangeKind.Imports;case f.$ot.Region.value:return s.FoldingRangeKind.Region}}Se.to=$e})(ze||(e.FoldingRangeKind=ze={}));var ut;(function(Se){function Le($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?b.from($e.selection):void 0,override:typeof $e.override=="boolean"?n.$aE.id:void 0}}Se.from=Le})(ut||(e.TextEditorOpenOptions=ut={}));var Y;(function(Se){function Le(Ue){return Ue instanceof s.$xL?Ue.toJSON():typeof Ue=="string"?Ue:$e(Ue)||K(Ue)?new s.$xL(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Se.from=Le;function $e(Ue){const Qe=Ue;return Qe?v.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function K(Ue){const Qe=Ue;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Me(Ue){return typeof Ue=="string"?Ue:new s.$xL(v.URI.revive(Ue.baseUri),Ue.pattern)}Se.to=Me})(Y||(e.GlobPattern=Y={}));var Z;(function(Se){function Le($e){if($e){if(Array.isArray($e))return $e.map(Le);if(typeof $e=="string")return $e;{const K=$e;return{language:K.language,scheme:K.scheme,pattern:Y.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Se.from=Le})(Z||(e.LanguageSelector=Z={}));var ye;(function(Se){function Le(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Me=>Array.isArray(Me)&&Me.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&v.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Qe=>Qe instanceof s.$DK)))}Se.is=Le;function $e(K){return{documents:K.documents.map(Me=>Me.map(Ue=>({uri:v.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Qe=>b.from(Qe))})))}}Se.from=$e})(ye||(e.MappedEditsContext=ye={}));var je;(function(Se){function Le(K){return{start:K.start,end:K.end}}Se.from=Le;function $e(K){return new s.$YL(K.start,K.end)}Se.to=$e})(je||(e.NotebookRange=je={}));var Ne;(function(Se){function Le(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Se.to=Le;function $e(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Se.from=$e})(Ne||(e.NotebookCellExecutionSummary=Ne={}));var Ze;(function(Se){function Le($e){if($e===u.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if($e===u.NotebookCellExecutionState.Pending)return;if($e===u.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}Se.to=Le})(Ze||(e.NotebookCellExecutionState=Ze={}));var nt;(function(Se){function Le(K){switch(K){case s.NotebookCellKind.Markup:return u.CellKind.Markup;case s.NotebookCellKind.Code:default:return u.CellKind.Code}}Se.from=Le;function $e(K){switch(K){case u.CellKind.Markup:return s.NotebookCellKind.Markup;case u.CellKind.Code:default:return s.NotebookCellKind.Code}}Se.to=$e})(nt||(e.NotebookCellKind=nt={}));var $t;(function(Se){function Le(K){const Me={metadata:K.metadata??Object.create(null),cells:[]};for(const Ue of K.cells)s.$ZL.validate(Ue),Me.cells.push(bt.from(Ue));return Me}Se.from=Le;function $e(K){const Me=new s.$1L(K.cells.map(bt.to));return(0,a.$Of)(K.metadata)||(Me.metadata=K.metadata),Me}Se.to=$e})($t||(e.NotebookData=$t={}));var bt;(function(Se){function Le(K){return{cellKind:nt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ne.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Kt.from):[]}}Se.from=Le;function $e(K){return new s.$ZL(nt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Kt.to):void 0,K.metadata,K.internalMetadata?Ne.to(K.internalMetadata):void 0)}Se.to=$e})(bt||(e.NotebookCellData=bt={}));var Pt;(function(Se){function Le(K){return{mime:K.mime,valueBytes:L.$ee.wrap(K.data)}}Se.from=Le;function $e(K){return new s.$2L(K.valueBytes.buffer,K.mime)}Se.to=$e})(Pt||(e.NotebookCellOutputItem=Pt={}));var Kt;(function(Se){function Le(K){return{outputId:K.id,items:K.items.map(Pt.from),metadata:K.metadata}}Se.from=Le;function $e(K){const Me=K.items.map(Pt.to);return new s.$3L(Me,K.outputId,K.metadata)}Se.to=$e})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Se){function Le(Me){return K(Me)?{include:Y.from(Me.include)??void 0,exclude:Y.from(Me.exclude)??void 0}:Y.from(Me)??void 0}Se.from=Le;function $e(Me){return K(Me)?{include:Y.to(Me.include),exclude:Y.to(Me.exclude)}:Y.to(Me)}Se.to=$e;function K(Me){const Ue=Me;return Ue?!(0,a.$Kf)(Ue.include)&&!(0,a.$Kf)(Ue.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var vt;(function(Se){function Le($e,K,Me){const Ue=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ue,Me),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}Se.from=Le})(vt||(e.NotebookStatusBarItem=vt={}));var Ut;(function(Se){function Le($e,K,Me){const Ue=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:K.toInternal(Ue,Me),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}Se.from=Le})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Ot;(function(Se){function Le($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}Se.from=Le})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Se){function Le(K){return{uri:K.uri,provides:K.provides}}Se.from=Le;function $e(K){return new s.$5L(v.URI.revive(K.uri),K.provides)}Se.to=$e})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Se){function Le(K){return{message:z.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:b.from(K.location.range),uri:K.location.uri}}}Se.from=Le;function $e(K){const Me=new s.$$L(typeof K.message=="string"?K.message:z.to(K.message));return Me.actualOutput=K.actual,Me.expectedOutput=K.expected,Me.contextValue=K.contextValue,Me.location=K.location?pe.to(K.location):void 0,Me}Se.to=$e})(Bt||(e.TestMessage=Bt={}));var kt;(function(Se){Se.namespace=l.$tJ,Se.denamespace=l.$uJ})(kt||(e.TestTag=kt={}));var Ft;(function(Se){function Le(K){const Me=(0,i.$xM)(K).controllerId;return{extId:o.$pJ.fromExtHostTestItem(K,Me).toString(),label:K.label,uri:v.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Ue=>kt.namespace(Me,Ue.id)),range:p.$zs.lift(b.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&z.fromStrict(K.error)||null}}Se.from=Le;function $e(K){return{parent:void 0,error:void 0,id:o.$pJ.fromString(K.extId).localId,label:K.label,uri:v.URI.revive(K.uri),tags:(K.tags||[]).map(Me=>{const{tagId:Ue}=kt.denamespace(Me);return new s.$_L(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Se.toPlain=$e})(Ft||(e.TestItem=Ft={})),function(Se){function Le(K){return{id:K.id}}Se.from=Le;function $e(K){return new s.$_L(K.id)}Se.to=$e}(kt||(e.TestTag=kt={}));var jt;(function(Se){const Le=(K,Me)=>{const Ue=[];for(const[qe,et]of Me)o.$pJ.compare(et.item.extId,qe)===2&&(Me.delete(qe),Ue.push(et));const Qe={...Ft.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(et=>et.type===0).map(Bt.to)})),children:Ue.map(qe=>Le(qe,Me))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function $e(K){const Me=[],Ue=new Map;for(const Qe of K.items){Ue.set(Qe.item.extId,Qe);const qe=o.$pJ.root(Qe.item.extId);K.request.targets.some(et=>et.controllerId===qe&&et.testIds.includes(Qe.item.extId))&&Me.push(Qe)}return{completedAt:K.completedAt,results:Me.map(Qe=>Le(Qe,Ue))}}Se.to=$e})(jt||(e.TestResults=jt={}));var Qt;(function(Se){function Le(Ue){return{covered:Ue.covered,total:Ue.covered}}function $e(Ue){return"line"in Ue?I.from(Ue):b.from(Ue)}function K(Ue){return"branches"in Ue?{count:Ue.executionCount,location:$e(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&$e(Qe.location)})):void 0}:{type:0,count:Ue.executionCount,location:$e(Ue.location)}}Se.fromDetailed=K;function Me(Ue){return{uri:Ue.uri,statement:Le(Ue.statementCoverage),branch:Ue.branchCoverage&&Le(Ue.branchCoverage),function:Ue.functionCoverage&&Le(Ue.functionCoverage),details:Ue.detailedCoverage?.map(K)}}Se.fromFile=Me})(Qt||(e.TestCoverage=Qt={}));var Wt;(function(Se){function Le($e){switch($e){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Se.to=Le})(Wt||(e.CodeActionTriggerKind=Wt={}));var Vt;(function(Se){function Le(K){const Me=new s.$fM(be.to(K.kind),K.name,K.detail||"",v.URI.revive(K.uri),b.to(K.range),b.to(K.selectionRange));return Me._sessionId=K._sessionId,Me._itemId=K._itemId,Me}Se.to=Le;function $e(K,Me,Ue){if(Me=Me??K._sessionId,Ue=Ue??K._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,kind:be.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:b.from(K.range),selectionRange:b.from(K.selectionRange),tags:K.tags?.map(se.from)}}Se.from=$e})(Vt||(e.TypeHierarchyItem=Vt={}));var Nt;(function(Se){function Le($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}Se.from=Le})(Nt||(e.ViewBadge=Nt={}));var at;(function(Se){function Le(Ue,Qe,qe){const et=Qe.fileData;return et?new s.$qL(new s.$rL(et.name,v.URI.revive(et.uri),et.id,(0,M.$cb)(()=>qe(et.id)))):Ue===A.$Vr.uriList&&Qe.uriListData?new s.$pL(Me(Qe.uriListData)):new s.$pL(Qe.asString)}Se.to=Le;async function $e(Ue,Qe){const qe=await Qe.asString();if(Ue===A.$Vr.uriList)return{asString:qe,fileData:void 0,uriListData:K(qe)};const et=Qe.asFile();return{asString:qe,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Se.from=$e;function K(Ue){return P.$9s.split(Ue).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return v.URI.parse(Qe)}catch{}return Qe})}function Me(Ue){return P.$9s.create(Ue.map(Qe=>typeof Qe=="string"?Qe:v.URI.revive(Qe)))}})(at||(e.DataTransferItem=at={}));var dt;(function(Se){function Le(K,Me){const Ue=K.items.map(([Qe,qe])=>[Qe,at.to(Qe,qe,Me)]);return new s.$sL(Ue)}Se.toDataTransfer=Le;async function $e(K){const Me={items:[]},Ue=[];for(const[Qe,qe]of K)Ue.push((async()=>{Me.items.push([Qe,await at.from(Qe,qe)])})());return await Promise.all(Ue),Me}Se.from=$e})(dt||(e.DataTransfer=dt={}));var At;(function(Se){function Le(K){return{message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}Se.to=Le;function $e(K){return{kind:"reply",message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}Se.from=$e})(At||(e.ChatReplyFollowup=At={}));var qt;(function(Se){function Le($e){return typeof $e=="string"?{title:$e,message:$e,kind:"reply"}:"commandId"in $e?{kind:"command",title:$e.title??"",commandId:$e.commandId??"",when:$e.when??"",args:$e.args}:At.from($e)}Se.from=Le})(qt||(e.ChatFollowup=qt={}));var Rt;(function(Se){function Le(K){const Me=new s.$qM(ot.to(K.role),K.content);return Me.name=K.name,Me}Se.to=Le;function $e(K){return{role:ot.from(K.role),content:K.content,name:K.name}}Se.from=$e})(Rt||(e.ChatMessage=Rt={}));var ot;(function(Se){function Le(K){switch(K){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Se.to=Le;function $e(K){switch(K){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Se.from=$e})(ot||(e.ChatMessageRole=ot={}));var wt;(function(Se){function Le(Me){const Ue={};for(const Qe of Object.keys(Me))Ue[Qe]=Me[Qe].map(Se.to);return Ue}Se.objectTo=Le;function $e(Me){return{level:Tt.to(Me.level),value:Me.value,description:Me.description}}Se.to=$e;function K(Me){return{level:Tt.from(Me.level),value:Me.value,description:Me.description}}Se.from=K})(wt||(e.ChatVariable=wt={}));var Tt;(function(Se){function Le(K){switch(K){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Se.to=Le;function $e(K){switch(K){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Se.from=$e})(Tt||(e.ChatVariableLevel=Tt={}));var Ct;(function(Se){function Le($e){switch($e){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Se.to=Le})(Ct||(e.InteractiveEditorResponseFeedbackKind=Ct={}));var We;(function(Se){function Le($e,K){return"placeholder"in K&&"resolvedContent"in K?{placeholder:K.placeholder}:"responseId"in K?{requestId:K.responseId}:"markdownContent"in K?((0,c.$yF)($e,"chatAgents2Additions"),{content:z.from(K.markdownContent)}):"content"in K?typeof K.content=="string"?K:((0,c.$yF)($e,"chatAgents2Additions"),{content:z.from(K.content)}):"documents"in K?{documents:K.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(Ue=>b.from(Ue))}))}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:b.from(K.reference.range)}:K.reference}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:b.from(K.inlineReference.range)}:K.inlineReference,title:K.title}:("agentName"in K&&(0,c.$yF)($e,"chatAgents2Additions"),K)}Se.from=Le})(We||(e.ChatResponseProgress=We={}));var Jt;(function(Se){function Le($e,K,Me){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand}:"uri"in $e?{uri:$e.uri}:K.toInternal($e,Me)}Se.from=Le})(Jt||(e.TerminalQuickFix=Jt={}))}),define(Pe[221],Ae([1,0,2,11,7,8,187]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;class ${constructor(g,A,S,a={timeout:1500,errors:3}){this.c=g,this.d=A,this.f=S,this.g=a,this.a=new R.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(A,S,a)=>{const p={dispose:this.a.push([A,S,g])};return Array.isArray(a)&&a.push(p),p}}async $participateInSave(g,A){const S=E.URI.revive(g);let a=!1;const v=setTimeout(()=>a=!0,this.g.timeout),p=[];try{for(const f of[...this.a]){if(a)break;const t=this.d.getDocument(S),i=await this.h(f,{document:t,reason:M.TextDocumentSaveReason.to(A)});p.push(i)}}finally{clearTimeout(v)}return p}h([g,A,S],a){const v=this.b.get(g);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(S,g,A,a).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const f=this.b.get(g);this.b.set(g,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,A,S,a){const v=[],p=Date.now(),{document:f,reason:t}=a,{version:i}=f,n=Object.freeze({document:f,reason:t,waitUntil(u){if(Object.isFrozen(v))throw(0,L.$7)("waitUntil can not be called async");v.push(Promise.resolve(u))}});try{A.apply(S,[n])}catch(u){return Promise.reject(u)}return Object.freeze(v),new Promise((u,o)=>{const l=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(v).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(l),u(r)}).catch(r=>{clearTimeout(l),o(r)})}).then(u=>{const o={edits:[]};for(const l of u)if(Array.isArray(l)&&l.every(r=>r instanceof P.$IK))for(const{newText:r,newEol:s,range:c}of l)o.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:c&&M.Range.from(c),text:r,eol:s&&M.EndOfLine.from(s)}});if(o.edits.length!==0)return i===f.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$Sdc=$}),define(Pe[222],Ae([1,0,14,2,8,7,76]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=e.$6ec=void 0;class ${constructor(S,a,v,p){this.start=S,this.deletedCount=a,this.deletedItems=v,this.items=p}asApiEvent(){return{range:new M.$YL(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(S,a){return{EOL:a.eol,lines:a.source,languageId:a.language,uri:a.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,a,v){this.notebook=S,this.h=a,this.j=v,this.handle=v.handle,this.uri=L.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(P.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return S.g},set mime(p){S.g=p},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(v)}return this.f}setOutputs(S){this.a=S.map(P.NotebookCellOutput.to)}setOutputItems(S,a,v){const p=v.map(P.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===S);if(f&&(a||(f.items.length=0),f.items.push(...p),f.items.length>1&&f.items.every(t=>R.$DI(t.mime)))){const t=new Map,i=[];f.items.forEach(n=>{let u;t.has(n.mime)?u=t.get(n.mime):(u=[],t.set(n.mime,u),i.push(n.mime)),u.push(n.data)}),f.items.length=0,i.forEach(n=>{const u=R.$EI(t.get(n));f.items.push({mime:n,data:u.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$6ec=D;class g{static{this.a=0}constructor(S,a,v,p,f){this.k=S,this.l=a,this.m=v,this.uri=p,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,a={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(v){return v=S.n(v),S.b[v].apiCell},getCells(v){return(v?S.p(v):S.b).map(f=>f.apiCell)},save(){return S.q()}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,a,v){this.g=S.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:v});const p={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},f=[];for(const i of S.rawEvents)i.kind===R.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,p.contentChanges):i.kind===R.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,p.contentChanges):i.kind===R.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===R.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),f.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),f.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<f.length;i++){const n=f[i],u=t.get(n.cell);if(u===void 0){const o=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});t.set(n.cell,o-1)}else p.cellChanges[u]={...p.cellChanges[u],...n}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let a=S.start|0,v=S.end|0;return a<0&&(a=0),v>this.b.length&&(v=this.b.length),S.with({start:a,end:v})}p(S){S=this.o(S);const a=[];for(let v=S.start;v<S.end;v++)a.push(this.b[v]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,a,v){if(this.j)return;const p=[],f=[],t=[];if(S.reverse().forEach(i=>{const u=i[2].map(r=>{const s=new D(this,this.l,r);return a||f.push(D.asModelAddData(this.apiNotebook,r)),s}),o=new $(i[0],i[1],[],u),l=this.b.splice(i[0],i[1],...u);for(const r of l)t.push(r.uri),o.deletedItems.push(r.apiCell);p.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),v)for(const i of p)v.push(i.asApiEvent())}s(S,a,v,p){const f=this.b.splice(S,a);this.b.splice(v,0,...f);const t=[new $(S,a,f.map(i=>i.apiCell),[]),new $(v,0,[],f)];for(const i of t)p.push(i.asApiEvent())}t(S,a){this.b[S].setOutputs(a)}u(S,a,v,p){this.b[S].setOutputItems(a,v,p)}v(S,a){const v=this.b[S];v.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(v.uri,a)}w(S,a){const v=this.b[S];v.apiCell.mime=a}x(S,a){this.b[S].setMetadata(a)}y(S,a){this.b[S].setInternalMetadata(a)}getCellFromApiCell(S){return this.b.find(a=>a.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(a=>a.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$7ec=g}),define(Pe[223],Ae([1,0,5,2,8,7]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;class R{constructor(D,g,A,S={timeout:1500,errors:3}){this.b=D,this.c=g,this.d=A,this.f=S,this.a=new E.$Sd}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(g,A,S)=>{const a=function(p){g.call(A,p)};return a.extension=D,this.a.event(a,void 0,S)}}async $participateInSave(D,g,A){const S=L.URI.revive(D),a=this.c.getNotebookDocument(S);if(!a)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:a.apiNotebook,reason:P.TextDocumentSaveReason.to(g)},A,async(f,t)=>{const i=Date.now(),n=await await Promise.resolve(f);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof M.$LK?v.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const p={edits:[]};for(const f of v){const{edits:t}=P.WorkspaceEdit.from(f);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$ufc=R}),define(Pe[107],Ae([1,0,11,8,7]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,D,g,A,S,a){this.id=$,this.f=D,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=A,this.c=a}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(D){this.selections=[D]},get selections(){return $.a},set selections(D){if(!Array.isArray(D)||!D.every(P.$YL.isNotebookRange))throw(0,E.$6)("selections");$.a=D,$.g(D)},get visibleRanges(){return $.b},revealRange(D,g){$.f.$tryRevealRange($.id,L.NotebookRange.from(D),g??P.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(L.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$8ec=M}),define(Pe[224],Ae([1,0,11,5,15,8]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;let R=class{constructor(D,g){this.c=D,this.d=g,this.a=new L.$Qd({onListenerError:E.$1}),this.b=new L.$Qd({onListenerError:E.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,g);const A=this.d.getEditorById(D);g.visibleRanges&&A._acceptVisibleRanges(g.visibleRanges.ranges.map(M.NotebookRange.to)),g.selections&&A._acceptSelections(g.selections.selections.map(M.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const g in D)this.d.getEditorById(g)._acceptViewColumn(M.ViewColumn.to(D[g]))}};e.$nfc=R,e.$nfc=R=Ke([Ve(0,P.$cj)],R)}),define(Pe[225],Ae([1,0,8,54,164,20,67,11]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;class D{constructor(a){this.b=0,this.c=new Map,this.a=a}async withProgress(a,v,p){const f=this.b++,{title:t,location:i,cancellable:n}=v,u={label:(0,P.localize)(0,null,a.displayName||a.name),id:a.identifier.value};return this.a.$startProgress(f,{location:E.ProgressLocation.from(i),title:t,source:u,cancellable:n},a.isUnderDevelopment?void 0:a.identifier.value).catch($.$1),this.d(f,p,!!n)}d(a,v,p){let f;p&&(f=new M.$1d,this.c.set(a,f));const t=n=>{this.a.$progressEnd(n),this.c.delete(n),f?.dispose()};let i;try{i=v(new A(this.a,a),p&&f?f.token:M.CancellationToken.None)}catch(n){throw t(a),n}return i.then(n=>t(a),n=>t(a)),i}$acceptProgressCanceled(a){const v=this.c.get(a);v&&(v.cancel(),this.c.delete(a))}}e.$rec=D;function g(S,a){return S.message=a.message,typeof a.increment=="number"&&(typeof S.increment=="number"?S.increment+=a.increment:S.increment=a.increment),S}class A extends L.$$u{constructor(a,v){super(p=>this.throttledReport(p)),this.c=a,this.d=v}throttledReport(a){this.c.$progressReport(this.d,a)}}Ke([(0,R.$oh)(100,(S,a)=>g(S,a),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Pe[108],Ae([1,0,29,104,48,77,60,8,2]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=e.$NM=void 0;const g=(u,o,l,r)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(c){if(!l(s,c)){const h=s;s=c,u.listener?.(r(c,h))}}}},A=(u,o)=>u===o,S={range:(u,o)=>u===o?!0:!u||!o?!1:u.isEqual(o),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(u,o)=>!(u.length!==o.length||u.some(l=>!o.find(r=>l.id===r.id)))},a=u=>o=>({op:4,update:u(o)}),v=(u,o)=>({range:(()=>{let l;const r=a(s=>({range:E.$zs.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return l},set(s){u.listener?.({op:6}),S.range(l,s)||(l=s,u.listener?.(r(s)))}}})(),label:g(u,o,S.label,a(l=>({label:l}))),description:g(u,void 0,S.description,a(l=>({description:l}))),sortText:g(u,void 0,S.sortText,a(l=>({sortText:l}))),canResolveChildren:g(u,!1,S.canResolveChildren,l=>({op:2,state:l})),busy:g(u,!1,S.busy,a(l=>({busy:l}))),error:g(u,void 0,S.error,a(l=>({error:$.MarkdownString.fromStrict(l)||null}))),tags:g(u,[],S.tags,(l,r)=>({op:1,new:l.map($.TestTag.from),old:r.map($.TestTag.from)}))}),p=u=>{const o=P.$pJ.fromString(u.extId),l=new t(o.controllerId,o.localId,u.label,D.URI.revive(u.uri)||void 0);return l.range=$.Range.to(u.range||void 0),l.description=u.description||void 0,l.sortText=u.sortText||void 0,l.tags=u.tags.map(r=>$.TestTag.to({id:(0,R.$uJ)(r).tagId})),l},f=u=>{let o;for(const l of u.tests){const r=p(l.item);(0,L.$xM)(r).parent=o,o=r}return o};e.$NM=f;class t{constructor(o,l,r,s){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const c=(0,L.$wM)(this,o);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof i?void 0:c.parent}},children:{value:(0,M.$vM)(c,L.$xM,t),enumerable:!0,writable:!1},...v(c,r)})}}e.$OM=t;class i extends t{constructor(o,l){super(o,o,l,void 0),this._isRoot=!0}}e.$PM=i;class n extends M.$rM{constructor(o,l,r){super({controllerId:o,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:L.$xM,getChildren:s=>s.children,root:new i(o,l),toITestItem:$.TestItem.from})}}e.$QM=n}),define(Pe[109],Ae([1,0,55,11,89,8,7]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=e.$IM=void 0;class ${static{this.c=new P.$GM("TextEditorDecorationType")}constructor(a,v,p){const f=$.c.nextId();a.$registerTextEditorDecorationType(v.identifier,f,M.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:f,dispose(){a.$removeTextEditorDecorationType(f)}})}}e.$IM=$;class D{constructor(a,v){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,v){this.k();let p=null;if(a instanceof R.$CK)p=new R.$DK(a,a);else if(a instanceof R.$DK)p=a;else throw new Error("Unrecognized location");this.l(p,v,!1)}insert(a,v){this.k(),this.l(new R.$DK(a,a),v,!0)}delete(a){this.k();let v=null;if(a instanceof R.$DK)v=a;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(a,v,p){const f=this.c.validateRange(a);this.g.push({range:f,text:v,forceMoveMarkers:p})}setEndOfLine(a){if(this.k(),a!==R.EndOfLine.LF&&a!==R.EndOfLine.CRLF)throw(0,L.$6)("endOfLine");this.h=a}}class g{constructor(a,v,p,f){this.c=a,this.d=v,this._accept(p),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.insertSpaces,this.j=a.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(a.lineNumbers)}l(a){if(a==="auto")return"auto";if(typeof a=="number"){const v=Math.floor(a);return v>0?v:null}if(typeof a=="string"){const v=parseInt(a,10);return isNaN(v)?null:v>0?v:null}return null}m(a){const v=this.l(a);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const v=Math.floor(a);return v>0?v:null}if(typeof a=="string"){const v=parseInt(a,10);return isNaN(v)?null:v>0?v:null}return null}o(a){const v=this.n(a);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(a){return a==="auto"?"auto":a==="false"?!1:!!a}q(a){const v=this.p(a);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(a){this.j!==a&&(this.j=a,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}t(a){this.k!==a&&(this.k=a,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(a)})))}assign(a){const v={};let p=!1;if(typeof a.tabSize<"u"){const f=this.l(a.tabSize);f==="auto"?(p=!0,v.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,p=!0,v.tabSize=f)}if(typeof a.indentSize<"u"){const f=this.n(a.indentSize);f==="tabSize"?(p=!0,v.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,p=!0,v.indentSize=f)}if(typeof a.insertSpaces<"u"){const f=this.p(a.insertSpaces);f==="auto"?(p=!0,v.insertSpaces=f):this.h!==f&&(this.h=f,p=!0,v.insertSpaces=f)}typeof a.cursorStyle<"u"&&this.j!==a.cursorStyle&&(this.j=a.cursorStyle,p=!0,v.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.k!==a.lineNumbers&&(this.k=a.lineNumbers,p=!0,v.lineNumbers=M.TextEditorLineNumbersStyle.from(a.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(a,v){v.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(p)})}}e.$JM=g;class A{constructor(a,v,p,f,t,i,n,u){this.id=a,this.j=v,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new g(this.j,this.id,i,p),this.e=n,this.f=u;const o=this;this.value=Object.freeze({get document(){return f.value},set document(l){throw new L.$8("document")},get selection(){return o.c&&o.c[0]},set selection(l){if(!(l instanceof R.$EK))throw(0,L.$6)("selection");o.c=[l],o.l()},get selections(){return o.c},set selections(l){if(!Array.isArray(l)||l.some(r=>!(r instanceof R.$EK)))throw(0,L.$6)("selections");o.c=l,o.l()},get visibleRanges(){return o.e},set visibleRanges(l){throw new L.$8("visibleRanges")},get options(){return o.d.value},set options(l){o.g||o.d.assign(l)},get viewColumn(){return o.f},set viewColumn(l){throw new L.$8("viewColumn")},edit(l,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(f.value,r);return l(s),o.m(s)},insertSnippet(l,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!r||Array.isArray(r)&&r.length===0)c=o.c.map(h=>M.Range.from(h));else if(r instanceof R.$CK){const{lineNumber:h,column:b}=M.Position.from(r);c=[{startLineNumber:h,startColumn:b,endLineNumber:h,endColumn:b}]}else if(r instanceof R.$DK)c=[M.Range.from(r)];else{c=[];for(const h of r)if(h instanceof R.$DK)c.push(M.Range.from(h));else{const{lineNumber:b,column:m}=M.Position.from(h);c.push({startLineNumber:b,startColumn:m,endLineNumber:b,endColumn:m})}}return v.$tryInsertSnippet(a,f.value.version,l.value,c,s)},setDecorations(l,r){const s=r.length===0;s&&!o.h.has(l.key)||(s?o.h.delete(l.key):o.h.add(l.key),o.n(()=>{if(M.$yM(r))return v.$trySetDecorations(a,l.key,M.$zM(r));{const c=new Array(4*r.length);for(let h=0,b=r.length;h<b;h++){const m=r[h];c[4*h]=m.start.line+1,c[4*h+1]=m.start.character+1,c[4*h+2]=m.end.line+1,c[4*h+3]=m.end.character+1}return v.$trySetDecorationsFast(a,l.key,c)}}))},revealRange(l,r){o.n(()=>v.$tryRevealRange(a,M.Range.from(l),r||R.TextEditorRevealType.Default))},show(l){v.$tryShowEditor(a,M.ViewColumn.from(l))},hide(){v.$tryHideEditor(a)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,E.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,E.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,E.ok)(!this.g),this.f=a}_acceptSelections(a){(0,E.ok)(!this.g),this.c=a}async l(){const a=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const v=a.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const p=v.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const n=p[t].end;if(p[t+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=v.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,f,{setEndOfLine:typeof v.setEndOfLine=="number"?M.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$KM=A}),define(Pe[226],Ae([1,0,168,25,2,5,6,206,12,7,16,18,8,53,20,132,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;function i(o,l){if((0,A.$Bf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let r;return Array.isArray(o.highlights)&&(r=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:o.label,highlights:r}}}class n extends R.$Rc{constructor(l,r,s){super(),this.f=l,this.g=r,this.h=s,this.a=new Map,this.b=new f.$v8;function c(h){return h&&h.$treeViewId&&(h.$treeItemHandle||h.$selectedTreeItems||h.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:h=>c(h)?this.r(h):Array.isArray(h)&&h.length>0?h.map(b=>c(b)?this.r(b):b):h})}registerTreeDataProvider(l,r,s){const c=this.createTreeView(l,{treeDataProvider:r},s);return{dispose:()=>c.dispose()}}createTreeView(l,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=r.dragAndDropController?.dropMimeTypes??[],h=r.dragAndDropController?.dragMimeTypes??[],b=!!r.dragAndDropController?.handleDrag,m=!!r.dragAndDropController?.handleDrop,I=this.m(l,r,s),k={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:c,dragMimeTypes:h,hasHandleDrag:b,hasHandleDrop:m,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},d=this.f.$registerTreeViewDataProvider(l,k),w={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$yF)(s,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$yF)(s,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(y){(0,v.$0j)(y)&&(0,t.$yF)(s,"treeViewMarkdownMessage"),I.message=y},get title(){return I.title},set title(y){I.title=y},get description(){return I.description},set description(y){I.description=y},get badge(){return I.badge},set badge(y){y!==void 0&&g.ViewBadge.isViewBadge(y)?I.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(I.badge=void 0)},reveal:(y,C)=>I.reveal(y,C),dispose:async()=>{await d,this.a.delete(l),I.dispose()}};return this.B(w),w}$getChildren(l,r){const s=this.a.get(l);return s?s.getChildren(r):Promise.reject(new $.$JE(l))}async $handleDrop(l,r,s,c,h,b,m,I){const k=this.a.get(l);if(!k)return Promise.reject(new $.$JE(l));const d=a.DataTransfer.toDataTransfer(s,async w=>(await this.f.$resolveDropFileData(l,r,w)).buffer);return m===l&&I&&await this.j(d,k,I,h,b),k.onDrop(d,c,h)}async j(l,r,s,c,h){const b=this.b.removeDragOperationTransfer(h);if(b)(await b)?.forEach((m,I)=>{m&&l.set(I,m)});else if(h&&r.handleDrag){const m=r.handleDrag(s,l,c);this.b.addDragOperationTransfer(h,m),await m}return l}async $handleDrag(l,r,s,c){const h=this.a.get(l);if(!h)return Promise.reject(new $.$JE(l));const b=await this.j(new g.$sL,h,r,c,s);if(!(!b||c.isCancellationRequested))return a.DataTransfer.from(b)}async $hasResolve(l){const r=this.a.get(l);if(!r)throw new $.$JE(l);return r.hasResolve}$resolve(l,r,s){const c=this.a.get(l);if(!c)throw new $.$JE(l);return c.resolveTreeItem(r,s)}$setExpanded(l,r,s){const c=this.a.get(l);if(!c)throw new $.$JE(l);c.setExpanded(r,s)}$setSelectionAndFocus(l,r,s){const c=this.a.get(l);if(!c)throw new $.$JE(l);c.setSelectionAndFocus(r,s)}$setVisible(l,r){const s=this.a.get(l);if(!s){if(!r)return;throw new $.$JE(l)}s.setVisible(r)}$changeCheckboxState(l,r){const s=this.a.get(l);if(!s)throw new $.$JE(l);s.setCheckboxState(r)}m(l,r,s){const c=this.B(new u(l,r,this.f,this.g.converter,this.h,s));return this.a.set(l,c),c}r(l){const r=this.a.get(l.$treeViewId);return r&&"$treeItemHandle"in l?r.getExtensionElement(l.$treeItemHandle):r&&"$focusedTreeItem"in l&&l.$focusedTreeItem?r.focusedElement:null}}e.$yec=n;class u extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.$Kf)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,r,s,c,h,b){if(super(),this.I=l,this.J=s,this.L=c,this.M=h,this.N=b,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Qd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Qd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Qd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Qd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Qd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Qd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Qd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$1d,b.contributes&&b.contributes.views)for(const d in b.contributes.views)for(const w of b.contributes.views[d])w.id===l&&(this.P=w.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>this.F.fire({message:!1,element:d})));let m,I;const k=M.Event.debounce(this.F.event,(d,w)=>(d||(d={message:!1,elements:[]}),w.element!==!1&&(m||(m=new Promise(y=>I=y),this.G=this.G.then(()=>m)),Array.isArray(w.element)?d.elements.push(...w.element):d.elements.push(w.element)),w.message&&(d.message=!0),d),200,!0);this.B(k(({message:d,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const y=I;return m=null,this.$(w).then(()=>y())})),d&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const r=l?this.getExtensionElement(l):void 0;if(l&&!r)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.X(l);return s||(s=await this.Y(r)),s?s.map(c=>c.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,r){r=r||{select:!0,focus:!1};const s=(0,A.$Kf)(r.select)?!0:r.select,c=(0,A.$Kf)(r.focus)?!1:r.focus,h=(0,A.$Kf)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(b=>this.W(l,b[b.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:b.map(I=>I.item)},{select:s,focus:c,expand:h})),b=>this.M.error(b)):this.J.$reveal(this.I,void 0,{select:s,focus:c,expand:h})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=a.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,r){const s=this.getExtensionElement(l);s&&(r?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(l,r){const s=!(0,S.$tb)(this.s,l);this.s=l;const c=this.t!==r;this.t=r,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const r=(await Promise.all(l.map(async s=>{const c=this.getExtensionElement(s.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(l,r,s){const c=[];for(const h of l){const b=this.getExtensionElement(h);b&&c.push(b)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,r,s){const c=r?this.getExtensionElement(r):void 0;if(!(!c&&r||!this.g?.handleDrop))return(0,D.$Pg)(()=>this.g?.handleDrop?this.g.handleDrop(c,l,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,r){if(!this.f.resolveTreeItem)return;const s=this.j.get(l);if(s){const c=this.m.get(s);if(c){const h=await this.f.resolveTreeItem(c.extensionItem,s,r)??c.extensionItem;return this.hb(h),c.item.tooltip=this.eb(h.tooltip),c.item.command=this.fb(c.disposableStore,h.command),c.item}}}S(l){return this.U(l).then(r=>r?this.S(r).then(s=>this.W(r,s[s.length-1]).then(c=>(s.push(c),s))):Promise.resolve([]))}U(l){const r=this.m.get(l);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,D.$Pg)(()=>this.f.getParent(l))}W(l,r){const s=this.m.get(l);return s?Promise.resolve(s):(0,D.$Pg)(()=>this.f.getTreeItem(l)).then(c=>this.kb(l,c,r,!0)).then(c=>this.getChildren(r?r.item.handle:void 0).then(()=>{const h=this.getExtensionElement(c);if(h){const b=this.m.get(h);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let r;if(typeof l=="string"){const s=this.getExtensionElement(l);r=s?this.m.get(s):void 0}else r=l;return r&&r.children||void 0}return this.h}async Y(l){this.rb(l);const r=new p.$1d(this.Z.token);try{const s=l?this.m.get(l):void 0,c=await this.f.getChildren(l);if(r.token.isCancellationRequested)return;const h=await Promise.all((0,S.$Gb)(c||[]).map(async b=>{const m=await this.f.getTreeItem(b);return m&&!r.token.isCancellationRequested?this.db(b,m,s):null}));return r.token.isCancellationRequested?void 0:(0,S.$Gb)(h)}finally{r.dispose()}}$(l){if(l.some(s=>!s))return this.Z.dispose(!0),this.Z=new p.$1d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(l);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(l){const r=new Set,s=l.map(h=>this.m.get(h));for(const h of s)if(h&&!r.has(h.item.handle)){let b=h;for(;b&&b.parent&&s.findIndex(m=>b&&b.parent&&m&&m.item.handle===b.parent.item.handle)===-1;){const m=this.j.get(b.parent.item.handle);b=m?this.m.get(m):void 0}b&&!b.parent&&r.add(h.item.handle)}const c=[];return r.forEach(h=>{const b=this.j.get(h);if(b){const m=this.m.get(b);m&&(!m.parent||!r.has(m.parent.item.handle))&&c.push(h)}}),c}bb(l){const r={};return Promise.all(l.map(s=>this.cb(s).then(c=>{c&&(r[s]=c.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(l){const r=this.getExtensionElement(l);if(r){const s=this.m.get(r);if(s)return this.rb(r),(0,D.$Pg)(()=>this.f.getTreeItem(r)).then(c=>{if(c){const h=this.ib(r,c,s.parent);return this.pb(r,h,s,s.parent),s.dispose(),h}return null})}return Promise.resolve(null)}db(l,r,s){const c=this.ib(l,r,s);if(r.id&&this.j.has(c.item.handle))throw new Error((0,E.localize)(0,null,r.id));return this.ob(l,c),this.qb(c,s),c}eb(l){return g.$2K.isMarkdownString(l)?a.MarkdownString.from(l):l}fb(l,r){return r?{...this.L.toInternal(r,l),originalId:r.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let r,s,c;return typeof l.checkboxState=="number"?r=l.checkboxState:(r=l.checkboxState.state,s=l.checkboxState.tooltip,c=l.checkboxState.accessibilityInformation),{isChecked:r===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:c}}hb(l){if(!g.$nL.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,r,s){this.hb(r);const c=this.B(new R.$Qc),h=this.kb(l,r,s),b=this.lb(r);return{item:{handle:h,parentHandle:s?s.item.handle:void 0,label:i(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(c,r.command),contextValue:r.contextValue,icon:b,iconDark:this.mb(r)||b,themeIcon:this.jb(r),collapsibleState:(0,A.$Kf)(r.collapsibleState)?g.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(l){return l.iconPath instanceof g.$vL?l.iconPath:void 0}kb(l,{id:r,label:s,resourceUri:c},h,b){if(r)return`${u.b}/${r}`;const m=i(s,this.N),I=h?h.item.handle:u.a;let k=m?m.label:c?(0,L.$vg)(c):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const d=this.m.has(l)?this.m.get(l).item.handle:void 0,w=this.X(h)||[];let y,C=0;do{if(y=`${I}/${C}:${k}`,b||!this.j.has(y)||d===y)break;C++}while(C<=w.length);return y}lb(l){if(l.iconPath&&!(l.iconPath instanceof g.$vL))return typeof l.iconPath=="string"||P.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof g.$vL)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return P.URI.isUri(l)?l:P.URI.file(l)}ob(l,r){this.j.set(r.item.handle,l),this.m.set(l,r)}pb(l,r,s,c){this.j.delete(r.item.handle),this.m.delete(l),r.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(l,r);const h=this.X(c)||[],b=h.filter(m=>m.item.handle===s.item.handle)[0];b&&h.splice(h.indexOf(b),1,r)}qb(l,r){r?(r.children||(r.children=[]),r.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const r=this.m.get(l);if(r){if(r.children)for(const s of r.children){const c=this.j.get(s.item.handle);c&&this.sb(c)}r.children=void 0}}else this.tb()}sb(l){const r=this.m.get(l);if(r){if(r.children)for(const s of r.children){const c=this.j.get(s.item.handle);c&&this.sb(c)}this.m.delete(l),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[227],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[228],Ae([1,0,180,11,31,96,73,30,22,227,190,101]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=void 0;const a=$.$ln.as(R.$mn.JSONContribution);class v{constructor(l,r,s){this.a=l,this.b=r,this.c=s}d(l,r){this.a({type:l,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(P.default.Error,l)}warn(l){this.d(P.default.Warning,l)}info(l){this.d(P.default.Info,l)}}e.$mF=v;class p{static a(l){const r=new D.$_l;for(let s=0,c=l.length;s<c;s++)r.add(l[s].description.identifier);return r}static compute(l,r){if(!l||!l.length)return new p(r,[]);if(!r||!r.length)return new p([],l);const s=this.a(l),c=this.a(r),h=r.filter(m=>!s.has(m.description.identifier)),b=l.filter(m=>!c.has(m.description.identifier));return new p(h,b)}constructor(l,r){this.added=l,this.removed=r}}e.$nF=p;class f{constructor(l,r){this.name=l,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=p.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,L.$Z)(l)}}}e.$oF=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$pF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.$0l},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"*",description:E.localize(42,null),body:"*"}]}},badges:{type:"array",description:E.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(44,null)},href:{type:"string",description:E.localize(45,null)},description:{type:"string",description:E.localize(46,null)}}}},markdown:{type:"string",description:E.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$3n}},extensionPack:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$3n}},extensionKind:{description:E.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(52,null)},{body:["workspace"],description:E.localize(53,null)},{body:["ui","workspace"],description:E.localize(54,null)},{body:["workspace","ui"],description:E.localize(55,null)},{body:[],description:E.localize(56,null)}]},capabilities:{description:E.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(60,null),E.localize(61,null),E.localize(62,null)]},description:{type:"string",markdownDescription:E.localize(63,null)}}},untrustedWorkspaces:{description:E.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(66,null),E.localize(67,null),E.localize(68,null)]},restrictedConfigurations:{description:E.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(70,null)}}}}},sponsor:{description:E.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(73,null),type:"string"},"vscode:uninstall":{description:E.localize(74,null),type:"string"}}},icon:{type:"string",description:E.localize(75,null)},l10n:{type:"string",description:E.localize(76,null)},pricing:{type:"string",markdownDescription:E.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const r=new f(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,r),l.activationEventsGenerator&&S.$dF.register(l.extensionPoint,l.activationEventsGenerator),e.$pF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,a.registerSchema(i,e.$pF),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$qF=n;const u={ExtensionsRegistry:"ExtensionsRegistry"};$.$ln.add(u.ExtensionsRegistry,new n),e.$rF=$.$ln.as(u.ExtensionsRegistry),a.registerSchema(i,e.$pF),a.registerSchema(A.$vj,{properties:{extensionEnabledApiProposals:{description:E.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(Pe[229],Ae([1,0,176,16,26,228,34,5]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var g;(function(a){function v(p,f,t){if(!p)return;const i=L.$Bf(p.type)?p.type:void 0;if(!i||i.length===0){t.error(E.localize(3,null));return}const n=[];if(Array.isArray(p.required))for(const u of p.required)L.$Bf(u)&&n.push(u);return{extensionId:f.value,taskType:i,required:n,properties:p.properties?P.$_m(p.properties):{},when:p.when?R.$Si.deserialize(p.when):void 0}}a.from=v})(g||(g={}));const A=M.$rF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,v)=>{for(const p of a)p.type&&v.push(`onTaskType:${p.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:D}});class S{constructor(){this.d=new $.$Qd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,p)=>{A.setHandler((f,t)=>{this.c=void 0;try{for(const i of t.removed){const n=i.value;for(const u of n)this.a&&u.type&&this.a[u.type]&&delete this.a[u.type]}for(const i of t.added){const n=i.value;for(const u of n){const o=g.from(u,i.description.identifier,i.collector);o&&(this.a[o.taskType]=o)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const p of this.all()){const f={type:"object",additionalProperties:!1};p.required.length>0&&(f.required=p.required.slice(0)),p.properties!==void 0?f.properties=P.$_m(p.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[p.taskType]},v.push(f)}this.c={oneOf:v}}return this.c}}e.$9F=new S}),define(Pe[230],Ae([1,0,177,16,25,26,34,229]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$gG=e.JsonSchemaVersion=e.ExecutionEngine=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$aG=e.ShellQuoting=e.$_F=e.$$F=e.$0F=void 0,e.$0F="settings",e.$$F=new R.$_i("taskRunning",!1,E.localize(0,null)),e.$_F={value:E.localize(1,null),original:"Tasks"};var D;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.$aG="$customized",function(F){function N(x){if(!x)return F.Strong;switch(x.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=N}(D||(e.ShellQuoting=D={}));var g;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var A;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(A||(e.RevealKind=A={})),function(F){function N(x){switch(x.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=N}(A||(e.RevealKind=A={}));var S;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(F){function N(x){switch(x.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=N}(S||(e.RevealProblemKind=S={}));var a;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(a||(e.PanelKind=a={})),function(F){function N(x){switch(x.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=N}(a||(e.PanelKind=a={}));var v;(function(F){F.defaults={echo:!0,reveal:A.Always,revealProblems:S.Never,focus:!1,panel:a.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var p;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(F){function N(J){switch(J.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=N;function x(J){switch(J){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=x}(p||(e.RuntimeType=p={}));var f;(function(F){function N(x){return L.$Bf(x)?x:x.value}F.value=N})(f||(e.CommandString=f={}));var t;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function N(J){return J===F.Clean._id||J===F.Build._id||J===F.Rebuild._id||J===F.Test._id}F.is=N;function x(J){if(J!==void 0)return L.$Bf(J)?N(J)?{_id:J,isDefault:!1}:void 0:J}F.from=x})(t||(e.TaskGroup=t={}));var i;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var n;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function N(x){switch(x){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=N})(n||(e.TaskSourceKind=n={}));var u;(function(F){F.parallel="parallel",F.sequence="sequence"})(u||(e.DependsOrder=u={}));var o;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var l;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class r{constructor(N,x,J,Ee,De,Ce){this._label="",this._id=N,x&&(this._label=x),J&&(this.type=J),this.runOptions=Ee,this.configurationProperties=De,this._source=Ce}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,x=!1){if(N===void 0)return!1;if(L.$Bf(N))return N===this._label||N===this.configurationProperties.identifier||x&&N===this._id;const J=this.getDefinition(!0);return J!==void 0&&J._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$bG=r;class s extends r{constructor(N,x,J,Ee,De,Ce,fe,be){super(N,J,void 0,fe,be,x),this.command={},this._source=x,this.hasDefinedMatchers=Ce,De&&(this.command=De)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let x;switch(this.command?this.command.runtime:void 0){case p.Shell:x="shell";break;case p.Process:x="process";break;case p.CustomExecution:x="customExecution";break;case void 0:x="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:x,_key:this._id,id:this._id}}}static is(N){return N instanceof s}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$0F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let x=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(x+=this._source.kind);const J={type:e.$aG,folder:N,id:x};return JSON.stringify(J)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$vg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new s(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$cG=s;class c extends r{constructor(N,x,J,Ee,De,Ce,fe){super(N,J,Ee,Ce,fe,x),this._source=x,this.configures=De}static is(N){return N instanceof c}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$vg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$0F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let x=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(x+=this._source.kind);const J={type:e.$aG,folder:N,id:x};return JSON.stringify(J)}}e.$dG=c;class h extends r{constructor(N,x,J,Ee,De,Ce,fe,be,se){super(N,J,Ee,be,se,x),this.defines=De,this.hasDefinedMatchers=fe,this.command=Ce,this.icon=se.icon,this.hide=se.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof h}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new h(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$eG=h;class b extends r{constructor(N,x,J,Ee,De,Ce){super(N,J,Ee,De,Ce,x),this._source=x}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new b(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$fG=b;var m;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(F){F._default=F.Terminal}(m||(e.ExecutionEngine=m={}));var I;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class k{constructor(N){this.c=new Map;for(let x=0;x<N.length;x++)this.c.set(N[x].uri.toString(),x)}compare(N,x){const J=N.getWorkspaceFolder(),Ee=x.getWorkspaceFolder();if(J&&Ee){let De=this.c.get(J.uri.toString());De=De===void 0?0:De+1;let Ce=this.c.get(Ee.uri.toString());return Ce=Ce===void 0?0:Ce+1,De===Ce?N._label.localeCompare(x._label):De-Ce}else return!J&&Ee?-1:J&&!Ee?1:0}}e.$gG=k;var d;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(d||(e.TaskEventKind=d={}));var w;(function(F){F.SingleRun="singleRun",F.Background="background"})(w||(e.TaskRunType=w={}));var y;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var C;(function(F){function N(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?"background":"singleRun",group:be.configurationProperties.group,__task:be}}function x(be,se,Re){return{...N(be),kind:"start",terminalId:se,resolvedVariables:Re}}F.start=x;function J(be,se,Re){return{...N(be),kind:"processStarted",terminalId:se,processId:Re}}F.processStarted=J;function Ee(be,se,Re){return{...N(be),kind:"processEnded",terminalId:se,exitCode:Re}}F.processEnded=Ee;function De(be,se,Re){return{...N(be),kind:"terminated",exitReason:Re,terminalId:se}}F.terminated=De;function Ce(be,se,Re){return{...N(se),kind:be,terminalId:Re}}F.general=Ce;function fe(){return{kind:"changed"}}F.changed=fe})(C||(e.TaskEvent=C={}));var W;(function(F){function N(J){const Ee=Object.keys(J).sort();let De="";for(const Ce of Ee){let fe=J[Ce];fe instanceof Object?fe=N(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),De+=Ce+","+fe+","}return De}function x(J){const De={_key:N(J),type:J.taskType};return Object.assign(De,J),De}F.create=x})(W||(e.KeyedTaskIdentifier=W={}));var H;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(H||(e.TaskSettingId=H={}));var U;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var z;(function(F){function N(x,J){const Ee=$.$9F.get(x.type);if(Ee===void 0){const be=M.$_m(x);return delete be._key,W.create(be)}const De=Object.create(null);De.type=Ee.taskType;const Ce=new Set;Ee.required.forEach(be=>Ce.add(be));const fe=Ee.properties;for(const be of Object.keys(fe)){const se=x[be];if(se!=null)De[be]=se;else if(Ce.has(be)){const Re=fe[be];if(Re.default!==void 0)De[be]=M.$_m(Re.default);else switch(Re.type){case"boolean":De[be]=!1;break;case"number":case"integer":De[be]=0;break;case"string":De[be]="";break;default:J.error(E.localize(2,null,JSON.stringify(x,void 0,0),be));return}}}return W.create(De)}F.createTaskIdentifier=N})(z||(e.TaskDefinition=z={}))}),define(Pe[231],Ae([1,0,11]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S5b=e.$R5b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$Z)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$R5b=L;class P extends L{constructor(){super(),this.h=!0,this.i=new E.$4}}e.$S5b=P}),define(Pe[49],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=void 0;class E{static{this.count=0}constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++E.count}}e.$tv=E;const L=[];function P($){const D=new E($);return L[D.nid]=D,D}e.$uv=P;function M($){return L[$].sid}e.$vv=M;class R{constructor(D){this.value=D}}e.$wv=R}),define(Pe[3],Ae([1,0,49]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AK=e.$zK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$yK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var P;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var M;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var D;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var g;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var A;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class S{static{this.a=0}static mixin(t){return t._id=S.a++,t}}e.$yK=S;var a;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var v;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var p;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$zK={MainThreadAuthentication:(0,E.$uv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$uv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$uv)("MainThreadChatProvider"),MainThreadChatAgents:(0,E.$uv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,E.$uv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$uv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$uv)("MainThreadClipboard"),MainThreadCommands:(0,E.$uv)("MainThreadCommands"),MainThreadComments:(0,E.$uv)("MainThreadComments"),MainThreadConfiguration:(0,E.$uv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$uv)("MainThreadConsole"),MainThreadDebugService:(0,E.$uv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$uv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$uv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$uv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$uv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$uv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$uv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$uv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$uv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$uv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$uv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$uv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$uv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$uv)("MainThreadLanguages"),MainThreadLogger:(0,E.$uv)("MainThreadLogger"),MainThreadMessageService:(0,E.$uv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$uv)("MainThreadOutputService"),MainThreadProgress:(0,E.$uv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$uv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$uv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$uv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$uv)("MainThreadSecretState"),MainThreadStorage:(0,E.$uv)("MainThreadStorage"),MainThreadSpeech:(0,E.$uv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$uv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$uv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$uv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$uv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$uv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$uv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$uv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$uv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$uv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$uv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$uv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$uv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$uv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$uv)("MainThreadSCM"),MainThreadSearch:(0,E.$uv)("MainThreadSearch"),MainThreadShare:(0,E.$uv)("MainThreadShare"),MainThreadTask:(0,E.$uv)("MainThreadTask"),MainThreadWindow:(0,E.$uv)("MainThreadWindow"),MainThreadLabelService:(0,E.$uv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$uv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$uv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$uv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$uv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$uv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$uv)("MainThreadInteractive"),MainThreadChat:(0,E.$uv)("MainThreadChat"),MainThreadInlineChat:(0,E.$uv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$uv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$uv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$uv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$uv)("MainThreadTimeline"),MainThreadTesting:(0,E.$uv)("MainThreadTesting"),MainThreadLocalization:(0,E.$uv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$uv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$uv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$uv)("MainThreadIssueReporter")},e.$AK={ExtHostCommands:(0,E.$uv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$uv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$uv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$uv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$uv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$uv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$uv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$uv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$uv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$uv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$uv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$uv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$uv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$uv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$uv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$uv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$uv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$uv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$uv)("ExtHostStatusBar"),ExtHostShare:(0,E.$uv)("ExtHostShare"),ExtHostExtensionService:(0,E.$uv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$uv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$uv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$uv)("ExtHostSCM"),ExtHostSearch:(0,E.$uv)("ExtHostSearch"),ExtHostTask:(0,E.$uv)("ExtHostTask"),ExtHostWorkspace:(0,E.$uv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$uv)("ExtHostWindow"),ExtHostWebviews:(0,E.$uv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$uv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$uv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$uv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$uv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$uv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$uv)("ExtHostProgress"),ExtHostComments:(0,E.$uv)("ExtHostComments"),ExtHostSecretState:(0,E.$uv)("ExtHostSecretState"),ExtHostStorage:(0,E.$uv)("ExtHostStorage"),ExtHostUrls:(0,E.$uv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$uv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$uv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$uv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$uv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$uv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$uv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$uv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$uv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$uv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$uv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$uv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$uv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$uv)("ExtHostChat"),ExtHostChatAgents:(0,E.$uv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,E.$uv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$uv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$uv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$uv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$uv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$uv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$uv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$uv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$uv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$uv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$uv)("ExtHostTimeline"),ExtHostTesting:(0,E.$uv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$uv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$uv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$uv)("ExtHostIssueReporter")}}),define(Pe[232],Ae([1,0,3,7]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$zK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,D){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(R);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation($,D)??[]}getRelatedInformation(R,$,D){return this.c.$getAiRelatedInformation($,D)}registerRelatedInformationProvider(R,$,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiRelatedInformationProvider(g,$),new L.$BK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Afc=P}),define(Pe[81],Ae([1,0,4,15,3,17]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=e.$Ddc=e.$Cdc=void 0,e.$Cdc=(0,E.$Uh)("IExtHostApiDeprecationService");let R=class{constructor(D,g){this.c=g,this.a=new Set,this.b=D.getProxy(P.$zK.MainThreadTelemetry)}report(D,g,A){const S=this.d(D,g);this.a.has(S)||(this.a.add(S),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:D}))}d(D,g){return`${D}-${g.identifier.value}`}};e.$Ddc=R,e.$Ddc=R=Ke([Ve(0,M.$BM),Ve(1,L.$cj)],R),e.$Edc=Object.freeze(new class{report($,D,g){}})}),define(Pe[233],Ae([1,0,5,3,7,22]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class R{constructor(g){this.b=new Map,this.c=[],this.d=new E.$Qd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=g.getProxy(L.$zK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,A,S,a={}){const v=M.$$l.toKey(g.identifier),p=[...S].sort().join(" ");return await this.f.getOrCreate(`${v} ${A} ${p}`,async()=>{await this.a.$ensureProvider(A);const f=g.displayName||g.name;return this.a.$getSession(A,S,v,f,a)})}async getSessions(g,A,S){const a=M.$$l.toKey(g.identifier),v=[...S].sort().join(" ");return await this.g.getOrCreate(`${a} ${v}`,async()=>{await this.a.$ensureProvider(A);const p=g.displayName||g.name;return this.a.$getSessions(A,S,a,p)})}async removeSession(g,A){const S=this.b.get(g);return S?S.provider.removeSession(A):this.a.$removeSession(g,A)}registerAuthenticationProvider(g,A,S,a){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:A,provider:S,options:a??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===g)||this.c.push({id:g,label:A});const v=S.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(g,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(g,A,a?.supportsMultipleAccounts??!1),new P.$BK(()=>{v.dispose(),this.b.delete(g);const p=this.c.findIndex(f=>f.id===g);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,A,S){const a=this.b.get(g);if(a)return Promise.resolve(a.provider.createSession(A,S));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,A){const S=this.b.get(g);if(S)return Promise.resolve(S.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,A){const S=this.b.get(g);if(S)return Promise.resolve(S.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,A){return this.d.fire({provider:{id:g,label:A}}),Promise.resolve()}}e.$$ec=R;class ${constructor(){this.a=new Map}getOrCreate(g,A){const S=this.a.get(g);if(S)return S;const a=A().finally(()=>this.a.delete(g));return this.a.set(g,a),a}}}),define(Pe[234],Ae([1,0,3,17,8]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;let M=class{constructor($,D){this.a=$.getProxy(E.$zK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>D.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,D,g){const A=P.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,g?.isRefactoring??!1)}};e.$efc=M,e.$efc=M=Ke([Ve(0,L.$BM)],M)}),define(Pe[235],Ae([1,0,12,5,68,6,50,157,3,8]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class A{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=A.a++}}class S{static{this.a=0}constructor(v,p){this.h=p,this.b=new Map,this.d=new Map,this.e=new L.$Qd,this.onDidPerformUserAction=this.e.event,this.g=v.getProxy(D.$zK.MainThreadChat)}registerChatProvider(v,p,f){const t=new A(v,f);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,p),(0,M.$Pc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(v,p){const f=P.Iterable.find(this.d.keys(),t=>this.d.get(t)===v)??0;typeof f=="number"&&this.g.$transferChatSession(f,p)}sendInteractiveRequestToProvider(v,p){this.g.$sendRequestToProvider(v,p)}async $prepareChat(v,p,f){const t=this.b.get(v);if(!t)return;const i=await t.provider.prepareSession(p,f);if(!i)return;const n=S.a++;return this.d.set(n,i),{id:n,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(v,p){const f=this.b.get(v);if(!f||!f.provider.provideWelcomeMessage)return;const t=await f.provider.provideWelcomeMessage(p);if(t)return t.map(i=>typeof i=="string"?i:Array.isArray(i)?i.map(n=>g.ChatReplyFollowup.from(n)):g.MarkdownString.from(i))}async $provideFollowups(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,f))?.map(u=>g.ChatFollowup.from(u))}async $provideSampleQuestions(v,p){const f=this.b.get(v);if(!f||!f.provider.provideSampleQuestions)return;const t=await f.provider.provideSampleQuestions(p);if(t)return t?.map(i=>g.ChatReplyFollowup.from(i))}$removeRequest(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);i&&t.provider.removeRequest&&t.provider.removeRequest(i,f)}async $provideReply(v,p,f,t){const i=this.b.get(v);if(!i)return;const n=this.d.get(p);if(!n)return;const u={session:n,message:f.message,variables:{}};if(f.variables)for(const h of Object.keys(f.variables))u.variables[h]=f.variables[h].map(g.ChatVariable.to);const o=R.$Md.create(!1);let l;const r={report:h=>{if(t.isCancellationRequested)return;typeof l>"u"&&(l=o.elapsed());const b=g.ChatResponseProgress.from(i.extension,h);if("placeholder"in h&&"resolvedContent"in h){const m=Promise.all([this.g.$acceptResponseProgress(v,p,b),h.resolvedContent]);(0,E.$Lg)(m,t).then(I=>{if(!I)return;const[k,d]=I;this.g.$acceptResponseProgress(v,p,d,k??void 0)})}else this.g.$acceptResponseProgress(v,p,b)}};let s;try{s=await i.provider.provideResponseWithProgress(u,r,t),s||(s={errorDetails:{message:(0,$.localize)(0,null)}})}catch(h){s={errorDetails:{message:(0,$.localize)(1,null,h.message),responseIsIncomplete:!0}},this.h.error(h)}try{if(n.saveState&&this.d.has(p)){const h=n.saveState();this.g.$acceptChatState(p,h)}}catch(h){this.h.warn(h)}const c={firstProgress:l??0,totalElapsed:o.elapsed()};return{errorDetails:s.errorDetails,timings:c}}async $provideSlashCommands(v,p,f){const t=this.b.get(v);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,f))?.map(u=>({...u,kind:g.CompletionItemKind.from(u.kind)}))}$releaseSession(v){this.d.delete(v)}async $onDidPerformUserAction(v){this.e.fire(v)}}e.$sfc=S}),define(Pe[236],Ae([1,0,12,6,54,3,8,7]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cfc=void 0;class D{static{this.a=0}constructor(S,a,v){this.d=a,this.e=v,this.b=new Map,this.c=S.getProxy(M.$zK.MainThreadChatAgents)}registerAgent(S,a,v,p){const f=D.a++;return this.b.set(f,{extension:S,agent:v}),this.c.$registerAgent(f,a,p),(0,L.$Pc)(()=>{this.c.$unregisterAgent(f),this.b.delete(f)})}async $invokeAgent(S,a,v,p,f){const t=this.b.get(S);if(!t){this.e.warn(`[CHAT](${S}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function n(){if(i)throw new Error("Only valid while executing the command")}const u=new E.$hh;f.onCancellationRequested(()=>u.complete()),setTimeout(()=>u.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,u.p);const o=t.agent({role:$.ChatMessageRole.User,content:v},{history:p.history.map(R.ChatMessage.to)},new P.$$u(l=>{n(),this.c.$handleProgressChunk(a,{content:g(l.message)?l.message:l.message.value})}),f);try{return await(0,E.$Lg)(Promise.resolve(o).then(l=>{if(l&&"followUp"in l)return{followUp:l?.followUp?.map(s=>R.ChatFollowup.from(s))}}),f)}finally{i=!0,u.complete()}}}e.$Cfc=D;function g(A){return!!A&&typeof A=="object"&&"treeData"in A}}),define(Pe[237],Ae([1,0,12,20,39,5,50,16,2,158,54,3,8,7,207,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=void 0;class t{static{this.a=0}constructor(u,o,l){this.i=o,this.j=l,this.b=new Map,this.g=new Map,this.h=new Map,this.d=u.getProxy(S.$zK.MainThreadChatAgents2)}createChatAgent(u,o,l){const r=t.a++,s=new i(u,o,this.d,r,l);return this.b.set(r,s),this.d.$registerAgent(r,o,{}),s.apiAgent}async $invokeAgent(u,o,l,r,s,c){this.g.delete(o);const h=this.b.get(u);if(!h)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let b=!1;function m(){if(b)throw new Error("Only valid while executing the command")}const I=new E.$hh;c.onCancellationRequested(()=>I.complete()),setTimeout(()=>I.complete(),10*1e3),this.i.allowListExtensionWhile(h.extension.identifier,I.p);const k=r.command?await h.validateSlashCommand(r.command):void 0,d=R.$Md.create(!1);let w;try{const y=h.invoke({prompt:r.message,variables:a.ChatVariable.objectTo(r.variables),slashCommand:k},{history:s.history.map(a.ChatMessage.to)},new A.$$u(C=>{m(),typeof w>"u"&&"content"in C&&(w=d.elapsed());const W=a.ChatResponseProgress.from(h.extension,C);if("placeholder"in C&&"resolvedContent"in C){const H=Promise.all([this.d.$handleProgressChunk(l,W),C.resolvedContent]);(0,E.$Lg)(H,c).then(U=>{if(!U)return;const[z,F]=U;this.d.$handleProgressChunk(l,F,z??void 0)})}else this.d.$handleProgressChunk(l,W)}),c);return await(0,E.$Lg)(Promise.resolve(y).then(C=>{if(C){this.g.set(o,C);let W=this.h.get(o);W||(W=new Map,this.h.set(o,W)),W.set(l,C);const H={firstProgress:w,totalElapsed:d.elapsed()};return{errorDetails:C.errorDetails,timings:H}}else this.g.delete(o)}),c)}catch(y){return this.j.error(y,h.extension),{errorDetails:{message:(0,g.localize)(0,null,(0,P.$Fi)(y)),responseIsIncomplete:!0}}}finally{b=!0,I.complete()}}$releaseSession(u){this.g.delete(u),this.h.delete(u)}async $provideSlashCommands(u,o){const l=this.b.get(u);return l?l.provideSlashCommand(o):[]}$provideFollowups(u,o,l){const r=this.b.get(u);if(!r)return Promise.resolve([]);const s=this.g.get(o);return s?r.provideFollowups(s,l):Promise.resolve([])}$acceptFeedback(u,o,l,r){const s=this.b.get(u);if(!s)return;const c=this.h.get(o)?.get(l);if(!c)return;let h;switch(r){case p.InteractiveSessionVoteDirection.Down:h=v.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:h=v.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze({result:c,kind:h}))}$acceptAction(u,o,l,r){const s=this.b.get(u);if(!s)return;const c=this.h.get(o)?.get(l);c&&r.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:r.action,result:c}))}}e.$Dfc=t;class i{constructor(u,o,l,r,s){this.extension=u,this.n=o,this.o=l,this.q=r,this.r=s,this.l=new M.$Qd,this.m=new M.$Qd}acceptFeedback(u){this.l.fire(u)}acceptAction(u){this.m.fire(u)}async validateSlashCommand(u){this.b||(await this.provideSlashCommand(L.CancellationToken.None),(0,$.$Lf)(this.b));const o=this.b.find(l=>l.name===u);if(!o)throw new Error(`Unknown slashCommand: ${u}`);return o}async provideSlashCommand(u){if(!this.a)return[];const o=await this.a.provideSlashCommands(u);return o?(this.b=o,o.map(l=>({name:l.name,description:l.description,followupPlaceholder:l.followupPlaceholder,shouldRepopulate:l.shouldRepopulate}))):[]}async provideFollowups(u,o){if(!this.d)return[];const l=await this.d.provideFollowups(u,o);return l?l.map(r=>a.ChatFollowup.from(r)):[]}get apiAgent(){let u=!1,o=!1;const l=()=>{u||o||(o=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof D.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$vL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),o=!1}))},r=this;return{get name(){return r.n},get description(){return r.g??""},set description(s){r.g=s,l()},get fullName(){return r.h??r.extension.displayName??r.extension.name},set fullName(s){r.h=s,l()},get iconPath(){return r.i},set iconPath(s){r.i=s,l()},get slashCommandProvider(){return r.a},set slashCommandProvider(s){r.a=s,l()},get followupProvider(){return r.d},set followupProvider(s){r.d=s,l()},get isDefault(){return(0,f.$yF)(r.extension,"defaultChatAgent"),r.j},set isDefault(s){(0,f.$yF)(r.extension,"defaultChatAgent"),r.j=s,l()},get isSecondary(){return(0,f.$yF)(r.extension,"defaultChatAgent"),r.k},set isSecondary(s){(0,f.$yF)(r.extension,"defaultChatAgent"),r.k=s,l()},get onDidReceiveFeedback(){return r.l.event},onDidPerformAction:(0,f.$xF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){u=!0,r.a=void 0,r.d=void 0,r.l.dispose(),r.o.$unregisterAgent(r.q)}}}invoke(u,o,l,r){return this.r(u,o,l,r)}}}),define(Pe[238],Ae([1,0,20,6,3,8,54,22,12,5]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class A{constructor(p,f){this.stream=new D.$lh,this.stream=f??new D.$lh;const t=this;this.apiObj={option:p,response:t.stream.asyncIterable}}}class S{constructor(p,f){this.a=new g.$Qd,this.b=new Map,this.c=new D.$lh,this.d=!1;const t=this;this.apiObject={result:p,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){f.cancel()}},p.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(p){if(this.d)return;let f=this.b.get(p.index);f||(this.b.size===0?f=new A(p.index,this.c):f=new A(p.index),this.b.set(p.index,f),this.a.fire(f.apiObj)),f.stream.emitOne(p.part)}}class a{static{this.a=1}constructor(p,f){this.d=f,this.c=new Map,this.e=new Map,this.f=new $.$am,this.b=p.getProxy(P.$zK.MainThreadChatProvider)}registerProvider(p,f,t,i){const n=a.a++;return this.c.set(n,{extension:p,provider:t}),this.b.$registerProvider(n,f,{extension:p,displayName:i.name??p.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(p,f,t,i,n){const u=this.c.get(p);if(!u)return;const o=new R.$$u(async l=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${u.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:l.index,part:l.part})});return u.provider.provideChatResponse(t.map(M.ChatMessage.to),i,o,n)}allowListExtensionWhile(p,f){this.f.set(p,f),f.finally(()=>this.f.delete(p))}async requestChatResponseProvider(p,f){if(!this.f.has(p))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(p)},makeRequest(i,n,u){if(!t.f.has(p))throw new Error("Access to chat has been revoked");const o=new E.$1d(u),l=Math.random()*1e6|0,r=t.b.$fetchResponse(p,f,l,i.map(M.ChatMessage.from),n??{},o.token),s=new S(r,o);return t.e.set(l,{res:s}),r.finally(()=>{t.e.delete(l)}),s.apiObject}}}async $handleResponseFragment(p,f){const t=this.e.get(p);t&&t.res.handleFragment(f)}}e.$xfc=a}),define(Pe[239],Ae([1,0,6,3,11,8]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zfc=void 0;class R{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(L.$zK.MainThreadChatVariables)}async $resolveVariable(D,g,A){const S=this.b.get(D);if(S)try{const a=await S.resolver.resolve(S.data.name,{message:g},A);if(a)return a.map(M.ChatVariable.from)}catch(a){(0,P.$1)(a)}}registerVariableResolver(D,g,A,S){const a=R.a++;return this.b.set(a,{extension:D.identifier,data:{name:g,description:A},resolver:S}),this.c.$registerVariable(a,{name:g,description:A}),(0,E.$Pc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$zfc=R}),define(Pe[240],Ae([1,0,3]),function(ve,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class L{constructor(M){const R=M.getProxy(E.$zK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$Hdc=L}),define(Pe[32],Ae([1,0,16,7,8,26,3,18,15,52,29,131,2,6,4,17,108,24,49,39,50,58,61]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=void 0;let s=class{#e;#t;#i;constructor(k,d,w){this.b=new Map,this.c=new Map,this.#e=k.getProxy(R.$zK.MainThreadCommands),this.d=d,this.#i=w,this.#t=k.getProxy(R.$zK.MainThreadTelemetry),this.converter=new c(this,y=>{const C=this.c.get(y);return C?.result===b.Void?C:void 0},d),this.f=[{processArgument(y){return(0,g.$rh)(y)}},{processArgument(y){return(0,M.$bn)(y,function(C){if(A.$zs.isIRange(C))return P.Range.to(C);if(S.$ys.isIPosition(C))return P.Position.to(C);if(A.$zs.isIRange(C.range)&&a.URI.isUri(C.uri))return P.location.to(C);if(C instanceof i.$ee)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const d=this.registerCommand(!1,k.id,async(...w)=>{const y=k.args.map((W,H)=>{if(!W.validate(w[H]))throw new Error(`Invalid argument '${W.name}' when running '${k.id}', received: ${typeof w[H]=="object"?JSON.stringify(w[H],null,"	"):w[H]} `);return W.convert(w[H])}),C=await this.executeCommand(k.internalId,...y);return k.result.convert(C,w,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new L.$BK(()=>{d.dispose(),this.c.delete(k.id)})}registerCommand(k,d,w,y,C,W){if(this.d.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this.b.has(d))throw new Error(`command '${d}' already exists`);return this.b.set(d,{callback:w,thisArg:y,metadata:C,extension:W}),k&&this.#e.$registerCommand(d),new L.$BK(()=>{this.b.delete(d)&&k&&this.#e.$unregisterCommand(d)})}executeCommand(k,...d){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,d,!0)}async g(k,d,w){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,d,!1);{let y=!1;const C=(0,M.$bn)(d,function(W){if(W instanceof L.$CK)return P.Position.from(W);if(W instanceof L.$DK)return P.Range.from(W);if(W instanceof L.$NK)return P.location.from(W);if(L.$YL.isNotebookRange(W))return P.NotebookRange.from(W);if(W instanceof ArrayBuffer)return y=!0,i.$ee.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return y=!0,i.$ee.wrap(W);if(W instanceof i.$ee)return y=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(k,y?new n.$wv(C):C,w);return(0,g.$rh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(k,d,!1);throw W}}}async h(k,d,w){const y=this.b.get(k);if(!y)throw new Error("Unknown command");const{callback:C,thisArg:W,metadata:H}=y;if(H?.args)for(let z=0;z<H.args.length;z++)try{(0,E.$Sf)(d[z],H.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${H.args[z].name}' - ${H.args[z].description}`)}const U=o.$Md.create();try{return await C.apply(W,d)}catch(z){if(k===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...d);F&&(k=F.command)}if(this.d.error(z,k,y.extension?.identifier),!w)throw z;if(y.extension?.identifier){const F=this.#i.onExtensionError(y.extension.identifier,z);this.d.trace("forwarded error to extension?",F,y.extension?.identifier)}throw new class extends Error{constructor(){super((0,u.$Fi)(z)),this.id=k,this.source=y.extension?.displayName??y.extension?.name}}}finally{this.j(y,k,U.elapsed())}}j(k,d,w){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new l.$oo(d),duration:w})}$executeContributedCommand(k,...d){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const w=this.b.get(k);return w?(d=d.map(y=>this.f.reduce((C,W)=>W.processArgument(C,w.extension?.identifier),y)),this.h(k,d,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(d=>(k&&(d=d.filter(w=>w[0]!=="_")),d))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[d,w]of this.b){const{metadata:y}=w;y&&(k[d]=y)}return Promise.resolve(k)}};e.$WM=s,e.$WM=s=Ke([Ve(0,f.$BM),Ve(1,D.$cj),Ve(2,r.$VM)],s),e.$XM=(0,p.$Uh)("IExtHostCommands");class c{constructor(k,d,w){this.d=k,this.f=d,this.g=w,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,d){if(!k)return;const w={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return w;const y=this.f(k.command);if(y)w.id=y.internalId,w.arguments=y.args.map((C,W)=>C.convert(k.arguments&&k.arguments[W]));else if((0,$.$Kb)(k.arguments)){const C=`${k.command} /${++this.c}`;this.b.set(C,k),d.add((0,v.$Pc)(()=>{this.b.delete(C),this.g.trace("CommandsConverter#DISPOSE",C)})),w.$ident=C,w.id=this.delegatingCommandId,w.arguments=[C],this.g.trace("CommandsConverter#CREATE",k.command,C)}return w}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const d=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],d?d.command:"MISSING"),d?this.d.executeCommand(d.command,...d.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$YM=c;class h{static{this.Uri=new h("uri","Uri of a text document",k=>a.URI.isUri(k),k=>k)}static{this.Position=new h("position","A position in a text document",k=>L.$CK.isPosition(k),P.Position.from)}static{this.Range=new h("range","A range in a text document",k=>L.$DK.isRange(k),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",k=>L.$EK.isSelection(k),P.Selection.from)}static{this.Number=new h("number","",k=>typeof k=="number",k=>k)}static{this.String=new h("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=h.Arr(h.String)}static Arr(k){return new h(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,d=>Array.isArray(d)&&d.every(w=>k.validate(w)),d=>d.map(w=>k.convert(w)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",k=>k instanceof L.$XK,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",k=>k instanceof L.$fM,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",k=>k instanceof t.$OM,P.TestItem.from)}constructor(k,d,w,y){this.name=k,this.description=d,this.validate=w,this.convert=y}optional(){return new h(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,d){return new h(k??this.name,d??this.description,this.validate,this.convert)}}e.$ZM=h;class b{static{this.Void=new b("no result",k=>k)}constructor(k,d){this.description=k,this.convert=d}}e.$1M=b;class m{constructor(k,d,w,y,C){this.id=k,this.internalId=d,this.description=w,this.args=y,this.result=C}}e.$2M=m}),define(Pe[241],Ae([1,0,18,14,2,80,95,34,99,32,8,7]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;const a=[new g.$2M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of DocumentHighlight-instances.",p(A.DocumentHighlight.to))),new g.$2M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$ZM.Uri],new g.$1M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,E.$Jb)(t))return;class n extends S.$SK{static to(o){const l=new n(o.name,A.SymbolKind.to(o.kind),o.containerName||"",new S.$NK(i[0],A.Range.to(o.range)));return l.detail=o.detail,l.range=l.location.range,l.selectionRange=A.Range.to(o.selectionRange),l.children=o.children?o.children.map(n.to):[],l}}return t.map(n.to)})),new g.$2M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$ZM.Uri,new g.$ZM("options","Formatting options",t=>!0,t=>t)],new g.$1M("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$2M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$ZM.Uri,g.$ZM.Range,new g.$ZM("options","Formatting options",t=>!0,t=>t)],new g.$1M("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$2M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$ZM.Uri,g.$ZM.Position,new g.$ZM("ch","Trigger character",t=>typeof t=="string",t=>t),new g.$ZM("options","Formatting options",t=>!0,t=>t)],new g.$1M("A promise that resolves to an array of TextEdits.",p(A.TextEdit.to))),new g.$2M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$2M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$2M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$2M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",f)),new g.$2M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location-instances.",p(A.location.to))),new g.$2M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Hover-instances.",p(A.Hover.to))),new g.$2M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$ZM.Uri,new g.$ZM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>S.$CK.isPosition(i)),t=>t.map(A.Position.from))],new g.$1M("A promise that resolves to an array of ranges.",t=>t.map(i=>{let n;for(const u of i.reverse())n=new S.$WK(A.Range.to(u),n);return n}))),new g.$2M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$ZM.String.with("query","Search string")],new g.$1M("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(A.WorkspaceSymbol.to))),new g.$2M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(A.CallHierarchyItem.to))),new g.$2M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$ZM.CallHierarchyItem],new g.$1M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(A.CallHierarchyIncomingCall.to))),new g.$2M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$ZM.CallHierarchyItem],new g.$1M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(A.CallHierarchyOutgoingCall.to))),new g.$2M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:A.Range.to(t.range),placeholder:t.text}})),new g.$2M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$ZM.Uri,g.$ZM.Position,g.$ZM.String.with("newName","The new symbol name")],new g.$1M("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return A.WorkspaceEdit.to(t)}})),new g.$2M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$ZM.Uri,g.$ZM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$1M("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(A.DocumentLink.to))),new g.$2M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$ZM.Uri],new g.$1M("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$QL(t.tokenTypes,t.tokenModifiers)})),new g.$2M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$ZM.Uri],new g.$1M("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$F$)(t);if(i.type==="full")return new S.$SL(i.data,void 0)})),new g.$2M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$ZM.Uri,g.$ZM.Range.optional()],new g.$1M("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$QL(t.tokenTypes,t.tokenModifiers)})),new g.$2M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$ZM.Uri,g.$ZM.Range],new g.$1M("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$F$)(t);if(i.type==="full")return new S.$SL(i.data,void 0)})),new g.$2M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$ZM.Uri,g.$ZM.Position,g.$ZM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$ZM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$1M("A promise that resolves to a CompletionList-instance.",(t,i,n)=>{if(!t)return new S.$9K([]);const u=t.suggestions.map(o=>A.CompletionItem.to(o,n));return new S.$9K(u,t.incomplete)})),new g.$2M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$ZM.Uri,g.$ZM.Position,g.$ZM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$1M("A promise that resolves to SignatureHelp.",t=>{if(t)return A.SignatureHelp.to(t)})),new g.$2M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$ZM.Uri,g.$ZM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$1M("A promise that resolves to an array of CodeLens-instances.",(t,i,n)=>p(u=>new S.$1K(A.Range.to(u.range),u.command&&n.fromInternal(u.command)))(t))),new g.$2M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$ZM.Uri,new g.$ZM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.$DK.isRange(t),t=>S.$EK.isSelection(t)?A.Selection.from(t):A.Range.from(t)),g.$ZM.String.with("kind","Code action kind to return code actions for").optional(),g.$ZM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$1M("A promise that resolves to an array of Command-instances.",(t,i,n)=>p(u=>{if(u._isSynthetic){if(!u.command)throw new Error("Synthetic code actions must have a command");return n.fromInternal(u.command)}else{const o=new S.$UK(u.title,u.kind?new S.$VK(u.kind):void 0);return u.edit&&(o.edit=A.WorkspaceEdit.to(u.edit)),u.command&&(o.command=n.fromInternal(u.command)),o.isPreferred=u.isPreferred,o}})(t))),new g.$2M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$ZM.Uri],new g.$1M("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new S.$cL(A.Range.to(i.range),A.Color.to(i.color))):[])),new g.$2M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$ZM("color","The color to show and insert",t=>t instanceof S.$bL,A.Color.from),new g.$ZM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:A.Range.from(t.range)}))],new g.$1M("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(A.ColorPresentation.to):[])),new g.$2M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$ZM.Uri,g.$ZM.Range],new g.$1M("A promise that resolves to an array of Inlay objects",(t,i,n)=>t.map(A.InlayHint.to.bind(void 0,n)))),new g.$2M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$ZM.Uri],new g.$1M("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(A.FoldingRange.to)})),new g.$2M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$1M("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>A.NotebookExclusiveDocumentPattern.to(i))})))),new g.$2M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$ZM.Uri,g.$ZM.Range,new g.$ZM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof S.$DK,t=>A.InlineValueContext.from(t))],new g.$1M("A promise that resolves to an array of InlineValue objects",t=>t.map(A.InlineValue.to))),new g.$2M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$ZM("uriOrString","Uri-instance or string (only http/https)",t=>P.URI.isUri(t)||typeof t=="string"&&(0,D.$PU)(t,L.Schemas.http,L.Schemas.https),t=>t),new g.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional(),g.$ZM.String.with("label","").optional()],g.$1M.Void),new g.$2M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$ZM.Uri.with("resource","Resource to open"),g.$ZM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[A.ViewColumn.from(t),void 0]:[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)])).optional()],g.$1M.Void),new g.$2M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$ZM.Uri.with("left","Left-hand side resource of the diff editor"),g.$ZM.Uri.with("right","Right-hand side resource of the diff editor"),g.$ZM.String.with("title","Human readable title for the diff editor").optional(),new g.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[A.ViewColumn.from(t.viewColumn),A.TextEditorOpenOptions.from(t)]).optional()],g.$1M.Void),new g.$2M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$ZM.String.with("title","Human readable title for the changes editor"),new g.$ZM("resourceList","List of resources to compare",t=>{for(const i of t){if(i.length!==3)return!1;const[n,u,o]=i;if(!P.URI.isUri(n)||!P.URI.isUri(u)&&u!==void 0&&u!==null||!P.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},t=>t)],g.$1M.Void),new g.$2M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$2M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$ZM.TypeHierarchyItem],new g.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$2M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$ZM.TypeHierarchyItem],new g.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(A.TypeHierarchyItem.to))),new g.$2M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$ZM.TestItem],g.$1M.Void),new g.$2M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$ZM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$1M.Void),new g.$2M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$ZM.String.with("name","The context key name"),new g.$ZM("value","The context key value",()=>!0,t=>t)],g.$1M.Void),new g.$2M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$ZM.Uri,g.$ZM.StringArray,new g.$ZM("MappedEditsContext","Mapped Edits Context",t=>A.MappedEditsContext.is(t),t=>A.MappedEditsContext.from(t))],new g.$1M("A promise that resolves to a workspace edit or null",t=>t?A.WorkspaceEdit.to(t):null))];class v{static register(i){a.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",$.$Ti)}}e.$Gdc=v;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function f(t){if(!Array.isArray(t))return;const i=[];for(const n of t)M.$kt(n)?i.push(A.DefinitionLink.to(n)):i.push(A.location.to(n));return i}}),define(Pe[242],Ae([1,0,12,67,5,6,2,80,22,8,7,3,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;function v(p,f,t){const i=p.getProxy(S.$zK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new D.$am,f.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const I=this.b.get(m.handle);return I?I.value:m}else if(m&&m.$mid===7){const I=this.b.get(m.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.commentThreadHandle);return k?k.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);return k?m.$mid===8?k.value:{thread:k.value,text:m.text}:m}else if(m&&m.$mid===10){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const d=m.commentUniqueId,w=k.getCommentByUniqueId(d);return w||m}else if(m&&m.$mid===11){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const d=m.text,w=m.commentUniqueId,y=k.getCommentByUniqueId(w);return y?(typeof y.body=="string"?y.body=d:y.body=new A.$2K(d),y):m}return m}})}createCommentController(m,I,k){const d=n.a++,w=new o(m,d,I,k);this.b.set(w.handle,w);const y=this.c.get(m.identifier)||[];return y.push(w),this.c.set(m.identifier,y),w.value}async $createCommentThreadTemplate(m,I,k){const d=this.b.get(m);d&&d.$createCommentThreadTemplate(I,k)}async $updateCommentThreadTemplate(m,I,k){const d=this.b.get(m);d&&d.$updateCommentThreadTemplate(I,k)}$deleteCommentThread(m,I){this.b.get(m)?.$deleteCommentThread(I)}$provideCommentingRanges(m,I,k){const d=this.b.get(m);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const w=t.getDocument(R.URI.revive(I));return(0,E.$Pg)(async()=>{const y=await d.commentingRangeProvider.provideCommentingRanges(w,k);let C;return Array.isArray(y)?C={ranges:y,fileComments:!1}:y?C={ranges:y.ranges||[],fileComments:y.fileComments||!1}:C=y??void 0,C}).then(y=>{let C;return y&&(C={ranges:y.ranges.map(W=>g.Range.from(W)),fileComments:y.fileComments}),C})}$toggleReaction(m,I,k,d,w){const y=this.b.get(m);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,E.$Pg)(()=>{const C=y.getCommentThread(I);if(C){const W=C.getCommentByUniqueId(d.uniqueIdInThread);if(y!==void 0&&W&&y.reactionHandler)return y.reactionHandler(W,s(w))}return Promise.resolve(void 0)})}}class u{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,I,k,d,w,y,C,W){this.m=I,this.n=k,this.o=d,this.p=w,this.q=y,this.extensionDescription=C,this.r=W,this.handle=u.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Qd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,g.Range.from(this.p),C.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const H=this;this.value={get uri(){return H.uri},get range(){return H.range},set range(U){H.range=U},get comments(){return H.comments},set comments(U){H.comments=U},get collapsibleState(){return H.collapsibleState},set collapsibleState(U){H.collapsibleState=U},get canReply(){return H.canReply},set canReply(U){H.canReply=U},get contextValue(){return H.contextValue},set contextValue(U){H.contextValue=U},get label(){return H.label},set label(U){H.label=U},get state(){return H.state},set state(U){H.state=U},dispose:()=>{H.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const m=k=>Object.prototype.hasOwnProperty.call(this.b,k),I={};m("range")&&(I.range=g.Range.from(this.p)),m("label")&&(I.label=this.label),m("contextValue")&&(I.contextValue=this.contextValue??null),m("comments")&&(I.comments=this.q.map(k=>l(this,k,this.k,this.extensionDescription))),m("collapsibleState")&&(I.collapseState=c(this.g)),m("canReply")&&(I.canReply=this.canReply),m("state")&&(I.state=h(this.h)),m("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(m){for(const I of this.k){const k=I[0],d=I[1];if(m===d)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,L.$nh)(100)],u.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,I,k,d){this.f=m,this.g=I,this.h=k,this.i=d,this.a=new Map,i.$registerCommentController(this.handle,k,d,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(y){w.options=y},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(y){w.commentingRangeProvider=y},get reactionHandler(){return w.reactionHandler},set reactionHandler(y){w.reactionHandler=y},createCommentThread(y,C,W){return w.createCommentThread(y,C,W).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,I,k){I===void 0&&(0,a.$yF)(this.f,"fileComments");const d=new u(this.id,this.handle,void 0,m,I,k,this.f,!1);return this.a.set(d.handle,d),d}$createCommentThreadTemplate(m,I){const k=new u(this.id,this.handle,void 0,R.URI.revive(m),g.Range.to(I),[],this.f,!0);return k.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(m,I){const k=this.a.get(m);k&&(k.range=g.Range.to(I))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function l(b,m,I,k){let d=I.get(m);return d||(d=++b.commentHandle,I.set(m,d)),m.state!==void 0&&(0,a.$yF)(k,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:d,body:typeof m.body=="string"?m.body:g.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(w=>r(w)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function r(b){return{label:b.label,iconPath:b.iconPath?g.$AM(b.iconPath):void 0,count:b.count,hasReacted:b.authorHasReacted}}function s(b){return{label:b.label||"",count:b.count||0,iconPath:b.iconPath?R.URI.revive(b.iconPath):"",authorHasReacted:b.hasReacted||!1}}function c(b){if(b!==void 0)switch(b){case A.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function h(b){if(b!==void 0)switch(b){case A.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new n}e.$Idc=v}),define(Pe[243],Ae([1,0,26,3,27,17]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;let R=class{constructor(A,S){this.a=A.getProxy(L.$zK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,S){const a=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){a.e(A,S,v,arguments)}})}e(A,S,a,v){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:D(v,this.b)}),this.c&&this.f(A,a,v)}};e.$Gfc=R,e.$Gfc=R=Ke([Ve(0,M.$BM),Ve(1,P.$RM)],R);const $=1e5;function D(g,A){const S=[];if(g.length)for(let a=0;a<g.length;a++){let v=g[a];if(typeof v>"u")v="undefined";else if(v instanceof Error){const p=v;p.stack?v=p.stack:v=p.toString()}S.push(v)}if(A){const a=new Error().stack;a&&S.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,E.$en)(S);return a.length>$?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Pe[110],Ae([1,0,2,3,7,4,17,15,18,13,19,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=void 0;let v=class{static{a=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(L.$zK.MainThreadDecorations)}registerFileDecorationProvider(f,t){const i=a.c++;this.f.set(i,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const n=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(u=>{if(!u){this.g.$onDidChange(i,null);return}const o=(0,D.$2b)(u);if(o.length<=a.d){this.g.$onDidChange(i,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,o.length);const l=o.map(c=>({uri:c,rank:(0,g.$Je)(c.path,"/")})),r=(0,D.$yb)(l,(c,h)=>c.rank-h.rank||(0,g.$Xe)(c.uri.path,h.uri.path)),s=[];e:for(const c of r){let h;for(const b of c){const m=(0,A.$lc)(b.uri.path);if(h!==m&&(h=m,s.push(b.uri)>=a.d))break e}}this.g.$onDidChange(i,s)});return new P.$BK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(f,t,i){if(!this.f.has(f))return Object.create(null);const n=Object.create(null),{provider:u,extensionDescription:o}=this.f.get(f);return await Promise.all(t.map(async l=>{try{const{uri:r,id:s}=l,c=await Promise.resolve(u.provideFileDecoration(E.URI.revive(r),i));if(!c)return;try{P.$WL.validate(c),c.badge&&typeof c.badge!="string"&&(0,S.$yF)(o,"codiconDecoration"),n[s]=[c.propagate,c.tooltip,c.badge,c.color]}catch(h){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${h}`)}}catch(r){this.h.error(r)}})),n}};e.$Jec=v,e.$Jec=v=a=Ke([Ve(0,R.$BM),Ve(1,$.$cj)],v),e.$Kec=(0,M.$Uh)("IExtHostDecorations")}),define(Pe[244],Ae([1,0,159,98,2,3,7,8,5,15,28,42]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=e.$Adc=void 0;class v{#e;#t;#i;constructor(t,i,n,u,o,l,r,s){this.d=t,this.e=i,this.f=n,this.g=u,this.h=o,this.c=!1,this.f=Math.max(u,n),this.#i=new A.$zc(c=>l.getComparisonKey(c)),this.#e=r,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let n=[];if(P.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),n=[t]}else if(Array.isArray(t)){n=[];let l;t=[...t].sort(v.k);for(const r of t){const[s,c]=r;if((!l||s.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=s,n.push(s),this.#i.set(s,[])),c)this.#i.get(s)?.push(...c);else{const h=this.#i.get(s);h&&(h.length=0)}}}if(this.#t.fire(n),!this.#e)return;const u=[];let o=0;for(const l of n){let r=[];const s=this.#i.get(l);if(s)if(s.length>this.g){r=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let h=0;h<4;h++)for(const b of s)if(b.severity===c[h]&&r.push({...$.Diagnostic.from(b),modelVersionId:this.h(l)})===this.g)break e;r.push({severity:L.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(c=>({...$.Diagnostic.from(c),modelVersionId:this.h(l)}));if(u.push([l,r]),o+=r.length,o>this.f)break}this.#e.$changeMany(this.e,u)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[n,u]of this)t.call(i,n,u,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Adc=v;let p=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*a.d}static _mapper(t){const i=new A.$zc;for(const n of t)i.set(n,n);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,n,u){this.j=i,this.k=n,this.l=u,this.g=new Map,this.h=new D.$Ud({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.h.event,a._mapper),this.f=t.getProxy(M.$zK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:n,f:u,h:o,j:l,k:r,l:s}=this,c=new class{$changeMany(m,I){u.$changeMany(m,I),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,I.length===0?"CLEARING":I)}$clear(m){u.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){u.dispose()}};let h;if(!i)i="_generated_diagnostic_collection_name_#"+a.c++,h=i;else if(!n.has(i))h=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do h=i+a.c++;while(n.has(h))}return new class extends v{constructor(){super(i,h,a.e,a.d,m=>s.getDocument(m)?.version,r.extUri,c,o),n.set(h,this)}dispose(){super.dispose(),n.delete(h)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,n=[];for(const u of this.g.values())u.forEach((o,l)=>{let r=i.get(o.toString());typeof r>"u"&&(r=n.length,i.set(o.toString(),r),n.push([o,[]])),n[r][1]=n[r][1].concat(...l)});return n}}m(t){let i=[];for(const n of this.g.values())n.has(t)&&(i=i.concat(n.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",n=new v(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,u=>{},this.k.extUri,void 0,this.h);this.g.set(i,n),this.n=n}for(const[i,n]of t)this.n.set(P.URI.revive(i),n.map($.Diagnostic.to))}};e.$Bdc=p,e.$Bdc=p=a=Ke([Ve(1,g.$cj),Ve(2,S.$zdc)],p)}),define(Pe[245],Ae([1,0,2,3,23]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;class M{constructor($){this.a=$.getProxy(L.$zK.MainThreadDialogs)}showOpenDialog($,D){return D?.allowUIResources&&(0,P.$yF)($,"showLocal"),this.a.$showOpenDialog(D).then(g=>g?g.map(A=>E.URI.revive(A)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(D=>D?E.URI.revive(D):void 0)}}e.$Qdc=M}),define(Pe[246],Ae([1,0,11,2,7,3,14,20,13]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class g{static{this.a=0}constructor(S,a,v){this.d=a,this.e=v,this.b=new Map,this.c=S.getProxy(M.$zK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,a){if(Object.keys(R.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const v=g.a++;this.b.set(v,a),this.c.$registerTextContentProvider(v,S);let p;return typeof a.onDidChange=="function"&&(p=a.onDidChange(f=>{if(f.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(v,f).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(f);if(!i)return;const n=(0,D.$Se)(t);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(f,t)},E.$Z)})),new P.$BK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(S,a){const v=this.b.get(S);return v?Promise.resolve(v.provideTextDocumentContent(L.URI.revive(a),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$Rdc=g}),define(Pe[247],Ae([1,0,5,6,2,3,103,8,16,26,7,11]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class a{constructor(p,f){this.a=new E.$Qd({onListenerError:S.$1}),this.b=new E.$Qd({onListenerError:S.$1}),this.c=new E.$Qd({onListenerError:S.$1}),this.d=new E.$Qd({onListenerError:S.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Qc,this.h=new Map,this.f=p.getProxy(M.$zK.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const f=this.g.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this.g.getDocument(p);if(f)return Promise.resolve(f);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(i=>{this.h.delete(p.toString());const n=P.URI.revive(i);return(0,D.$Mf)(this.g.getDocument(n))},i=>(this.h.delete(p.toString()),Promise.reject(i))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(f=>P.URI.revive(f))}$acceptModelLanguageChanged(p,f){const t=P.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(f),this.a.fire(i.document)}$acceptModelSaved(p){const f=P.URI.revive(p),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,f){const t=P.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,t){const i=P.URI.revive(p),n=this.g.getDocument(i);if(!n)throw new Error("unknown document");n._acceptIsDirty(t),n.onEvents(f);let u;f.isUndoing?u=A.TextDocumentChangeReason.Undo:f.isRedoing&&(u=A.TextDocumentChangeReason.Redo),this.c.fire((0,g.$an)({document:n.document,contentChanges:f.changes.map(o=>({range:$.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:u}))}setWordDefinitionFor(p,f){(0,R.$DM)(p,f)}}e.$xdc=a}),define(Pe[62],Ae([1,0,55,5,6,2,4,3,103,17,109,8,15,28,14,68,44]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=void 0;class i{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(o,l){this.h=o,this.i=l,this.a=null,this.b=new Map,this.c=new v.$zc,this.d=new L.$Qd,this.e=new L.$Qd,this.f=new L.$Qd,this.g=new L.$Qd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const l=[],r=[],s=[];if(o.removedDocuments)for(const c of o.removedDocuments){const h=M.URI.revive(c),b=this.c.get(h);b?.unref()&&(this.c.delete(h),l.push(b.value))}if(o.addedDocuments)for(const c of o.addedDocuments){const h=M.URI.revive(c.uri);let b=this.c.get(h);if(b&&h.scheme!==p.Schemas.vscodeNotebookCell&&h.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${h} already exists!'`);b||(b=new i(new D.$EM(this.h.getProxy($.$zK.MainThreadDocuments),h,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(h,b),r.push(b.value)),b.ref()}if(o.removedEditors)for(const c of o.removedEditors){const h=this.b.get(c);this.b.delete(c),h&&s.push(h)}if(o.addedEditors)for(const c of o.addedEditors){const h=M.URI.revive(c.documentUri);E.ok(this.c.has(h),`document '${h}' does not exist`),E.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const b=this.c.get(h).value,m=new A.$KM(c.id,this.h.getProxy($.$zK.MainThreadTextEditors),this.i,new t.$U(()=>b.document),c.selections.map(S.Selection.to),c.options,c.visibleRanges.map(I=>S.Range.to(I)),typeof c.editorPosition=="number"?S.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,m)}o.newActiveEditor!==void 0&&(E.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,P.$Mc)(l),(0,P.$Mc)(s),o.removedDocuments&&this.e.fire(l),o.addedDocuments&&this.d.fire(r),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return f.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const l=this.b.get(this.a);return o?l:l?.value}allEditors(){return[...this.b.values()]}};e.$LM=n,e.$LM=n=Ke([Ve(0,g.$BM),Ve(1,a.$cj)],n),e.$MM=(0,R.$Uh)("IExtHostDocumentsAndEditors")}),define(Pe[63],Ae([1,0,248,5,16,2,4,3,17,8,7]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=e.$Oec=void 0,e.$Oec=(0,R.$Uh)("IExtHostEditorTabs");class S{constructor(t,i,n){this.e=n,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$gM(M.URI.revive(this.b.input.uri));case 2:return new A.$hM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new A.$iM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new A.$jM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$kM(this.b.input.viewType);case 4:return new A.$lM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$mM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$nM;case 9:return new A.$oM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$pM(this.b.input.providerId);default:return}}}class a{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const n of t.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return g.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(n=>n.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(n=>n.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const n=new S(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,n),t.tabDto.isActive&&(this.d=n.tabId),n}else if(t.kind===1){const n=this.c.splice(t.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(t.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,n),n}const i=this.c.find(n=>n.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let v=class{constructor(t){this.b=new L.$Qd,this.c=new L.$Qd,this.e=[],this.a=t.getProxy($.$zK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(n=>n.apiObject))},get activeTabGroup(){const n=t.d;return(0,P.$Mf)(t.e.find(o=>o.groupId===n)?.apiObject)},close:async(n,u)=>{const o=Array.isArray(n)?n:[n];return o.length?p(o[0])?this.j(o,u):this.i(o,u):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(c=>c.groupId)),n=new Set(t.map(c=>c.groupId)),u=(0,E.$K)(i,n),o=this.e.filter(c=>u.removed.includes(c.groupId)).map(c=>c.apiObject),l=[],r=[];this.e=t.map(c=>{const h=new a(c,()=>this.d);return u.added.includes(h.groupId)?l.push(h.apiObject):r.push(h.apiObject),h});const s=(0,P.$Mf)(t.find(c=>c.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:l,closed:o,changed:r}))}$acceptTabGroupUpdate(t){const i=this.e.find(n=>n.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(u=>u.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const n=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(t){for(const i of this.e)for(const n of i.tabs)if(n.apiObject===t)return n}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const n=[];for(const u of t){const o=this.g(u);if(!o)throw new Error("Tab close: Invalid tab not found!");n.push(o.tabId)}return this.a.$closeTab(n,i)}async j(t,i){const n=[];for(const u of t){const o=this.h(u);if(!o)throw new Error("Group close: Invalid group not found!");n.push(o.groupId)}return this.a.$closeGroup(n,i)}};e.$Pec=v,e.$Pec=v=Ke([Ve(0,D.$BM)],v);function p(f){return f.tabs!==void 0}}),define(Pe[249],Ae([1,0,3,7]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$zK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,D){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(R);if(!g)throw new Error("Embedding vector provider not found");const A=await g.provideEmbeddingVector($,D);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,$,D){const g=this.b;return this.b++,this.a.set(g,D),this.c.$registerAiEmbeddingVectorProvider($,g),new L.$BK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Bfc=P}),define(Pe[250],Ae([1,0,2,3,6,7,8,298,13,24,23,53]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lec=void 0;class a{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let i,n,u=14,o=14;for(const l of f){let r=i?(0,D.$7e)(i,l):0;for(r===0?n=1:n=o;r<l.length;r++)r+1===l.length?(u=o,o=9):o+=1,t.push([n,l.toUpperCase().charCodeAt(r),o]),t.push([n,l.toLowerCase().charCodeAt(r),o]),n=o;i=l,o=u}t.push([9,58,10]),t.push([10,47,12]),this.b=new $.$GZ(t)}}provideDocumentLinks(f){this.c();const t=[],i=$.$HZ.computeLinks({getLineContent(n){return f.lineAt(n-1).text},getLineCount(){return f.lineCount}},this.b);for(const n of i){const u=R.DocumentLink.to(n);u.target&&t.push(u)}return t}}class v{constructor(f,t){this.i=t,this.b=new a,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(L.$zK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,i,n={}){if(v.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const u=this.h++;this.b.add(t),this.d.add(t),this.c.set(u,i);let o=2;n.isCaseSensitive&&(o+=1024),n.isReadonly&&(o+=2048),typeof i.copy=="function"&&(o+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,A.$yF)(f,"fsChunks"),o+=4);let l;n.isReadonly&&(0,S.$0j)(n.isReadonly)&&((0,A.$yF)(f,"readonlyMessage"),l={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(u,t,o,l).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=i.onDidChangeFile(s=>{const c=[];for(const h of s){const{uri:b,type:m}=h;if(b.scheme!==t)continue;let I;switch(m){case M.FileChangeType.Changed:I=0;break;case M.FileChangeType.Created:I=1;break;case M.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:b,type:I})}this.a.$onFileSystemChange(u,c)});return(0,P.$Pc)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(u),this.a.$unregisterProvider(u)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:i,mtime:n,size:u,permissions:o}=f;return{type:t,ctime:i,mtime:n,size:u,permissions:o}}$stat(f,t){return Promise.resolve(this.l(f).stat(E.URI.revive(t))).then(i=>v.k(i))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(E.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(E.URI.revive(t))).then(i=>g.$ee.wrap(i))}$writeFile(f,t,i,n){return Promise.resolve(this.l(f).writeFile(E.URI.revive(t),i.buffer,n))}$delete(f,t,i){return Promise.resolve(this.l(f).delete(E.URI.revive(t),i))}$rename(f,t,i,n){return Promise.resolve(this.l(f).rename(E.URI.revive(t),E.URI.revive(i),n))}$copy(f,t,i,n){const u=this.l(f);if(!u.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(u.copy(E.URI.revive(t),E.URI.revive(i),n))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(E.URI.revive(t)))}$watch(f,t,i,n){const u=this.l(f).watch(E.URI.revive(i),n);this.f.set(t,u)}$unwatch(f,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(f,t,i){const n=this.l(f);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(t),i))}$close(f,t){const i=this.l(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(f,t,i,n){const u=this.l(f);if(!u.read)throw new Error('FileSystemProvider does not implement "read"');const o=g.$ee.alloc(n);return Promise.resolve(u.read(t,i,o.buffer,0,n)).then(l=>o.slice(0,l))}$write(f,t,i,n){const u=this.l(f);if(!u.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(u.write(t,i,n.buffer,0,n.byteLength))}l(f){const t=this.c.get(f);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$lec=v}),define(Pe[64],Ae([1,0,3,41,7,24,4,17,42,6,12,25,14]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=void 0;let p=v=class{constructor(t,i){this.b=new Map,this.c=new A.$6g,this.a=t.getProxy(E.$zK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(u){try{let o;const l=n.b.get(u.scheme);return l?(await n.a.$ensureActivation(u.scheme),o=await l.impl.stat(u)):o=await n.a.$stat(u),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===L.FilePermission.Readonly?1:void 0}}catch(o){v.e(o)}},async readDirectory(u){try{const o=n.b.get(u.scheme);return o?(await n.a.$ensureActivation(u.scheme),(await o.impl.readDirectory(u)).slice()):await n.a.$readdir(u)}catch(o){return v.e(o)}},async createDirectory(u){try{const o=n.b.get(u.scheme);return o&&!o.isReadonly?(await n.a.$ensureActivation(u.scheme),await n.d(o.impl,o.extUri,u)):await n.a.$mkdir(u)}catch(o){return v.e(o)}},async readFile(u){try{const o=n.b.get(u.scheme);return o?(await n.a.$ensureActivation(u.scheme),(await o.impl.readFile(u)).slice()):(await n.a.$readFile(u)).buffer}catch(o){return v.e(o)}},async writeFile(u,o){try{const l=n.b.get(u.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(u.scheme),await n.d(l.impl,l.extUri,l.extUri.dirname(u)),await n.c.queueFor(u).queue(()=>Promise.resolve(l.impl.writeFile(u,o,{create:!0,overwrite:!0})))):await n.a.$writeFile(u,M.$ee.wrap(o))}catch(l){return v.e(l)}},async delete(u,o){try{const l=n.b.get(u.scheme);return l&&!l.isReadonly?(await n.a.$ensureActivation(u.scheme),await l.impl.delete(u,{recursive:!1,...o})):await n.a.$delete(u,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(l){return v.e(l)}},async rename(u,o,l){try{return await n.a.$rename(u,o,{overwrite:!1,...l})}catch(r){return v.e(r)}},async copy(u,o,l){try{return await n.a.$copy(u,o,{overwrite:!1,...l})}catch(r){return v.e(r)}},isWritableFileSystem(u){const o=i.getCapabilities(u);if(typeof o=="number")return!(o&2048)}})}async d(t,i,n){const u=[];for(;!i.isEqual(n,i.dirname(n));)try{if(!((await t.stat(n)).type&L.FileType.Directory))throw P.$OL.FileExists(`Unable to create folder '${n.scheme===a.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(L.$tk(o)!==L.FileSystemProviderErrorCode.FileNotFound)throw o;u.push(i.basename(n)),n=i.dirname(n)}for(let o=u.length-1;o>=0;o--){n=i.joinPath(n,u[o]);try{await t.createDirectory(n)}catch(l){if(L.$tk(l)!==L.FileSystemProviderErrorCode.FileExists)throw l}}}static e(t){if(t instanceof P.$OL)throw t;if(t instanceof L.$pk)switch(t.code){case L.FileSystemProviderErrorCode.FileExists:throw P.$OL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$OL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$OL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$OL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$OL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$OL.Unavailable(t.message);default:throw new P.$OL(t.message,t.name)}if(!(t instanceof Error))throw new P.$OL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw P.$OL.Unavailable(t.message);switch(t.name){case L.FileSystemProviderErrorCode.FileExists:throw P.$OL.FileExists(t.message);case L.FileSystemProviderErrorCode.FileNotFound:throw P.$OL.FileNotFound(t.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw P.$OL.FileNotADirectory(t.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw P.$OL.FileIsADirectory(t.message);case L.FileSystemProviderErrorCode.NoPermissions:throw P.$OL.NoPermissions(t.message);case L.FileSystemProviderErrorCode.Unavailable:throw P.$OL.Unavailable(t.message);default:throw new P.$OL(t.message,t.name)}}addFileSystemProvider(t,i,n){return this.b.set(t,{impl:i,extUri:n?.isCaseSensitive?S.$og:S.$qg,isReadonly:!!n?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??S.$og}};e.$4dc=p,e.$4dc=p=v=Ke([Ve(0,$.$BM),Ve(1,D.$zdc)],p),e.$5dc=(0,R.$Uh)("IExtHostConsumerFileSystem")}),define(Pe[251],Ae([1,0,5,33,2,3,8,7,44]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mec=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,p,f,t,i,n){this.a=Math.random(),this.b=new E.$Qd,this.c=new E.$Qd,this.d=new E.$Qd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const u=(0,L.$Bj)(i),o=typeof i=="string",l=n?.correlate,r=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(l&&typeof s.session>"u")){if(!n?.ignoreCreateEvents)for(const c of s.created){const h=P.URI.revive(c);u(h.fsPath)&&(!o||p.getWorkspaceFolder(h))&&this.b.fire(h)}if(!n?.ignoreChangeEvents)for(const c of s.changed){const h=P.URI.revive(c);u(h.fsPath)&&(!o||p.getWorkspaceFolder(h))&&this.c.fire(h)}if(!n?.ignoreDeleteEvents)for(const c of s.deleted){const h=P.URI.revive(c);u(h.fsPath)&&(!o||p.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=$.$BK.from(this.i(v,f,i,n,n?.correlate),this.b,this.c,this.d,r)}i(v,p,f,t,i){const n=$.$BK.from();if(typeof f=="string")return n;const u=v.getProxy(M.$zK.MainThreadFileSystemEventService);let o=!1;return(f.pattern.includes(L.$xj)||f.pattern.includes(L.$yj))&&(o=!0),u.$watch(p.identifier.value,this.a,f.baseUri,{recursive:o,excludes:t?.excludes??[]},!!i),$.$BK.from({dispose:()=>u.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new D.$U(()=>this.a.created.map(P.URI.revive)),this.c=new D.$U(()=>this.a.changed.map(P.URI.revive)),this.d=new D.$U(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(v,p,f){this.j=v,this.k=p,this.l=f,this.a=new E.$Qd,this.b=new E.$Qd,this.c=new E.$Qd,this.d=new E.$Qd,this.g=new E.$Sd,this.h=new E.$Sd,this.i=new E.$Sd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,p,f,t){return new g(this.j,v,p,this.a.event,R.GlobPattern.from(f),t)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,p){switch(v){case 2:this.b.fire(Object.freeze({files:p.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(f=>P.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(f=>P.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,p){return(f,t,i)=>{const n=function(o){f.call(t,o)};return n.extension=v,p.event(n,void 0,i)}}async $onWillRunFileOperation(v,p,f,t){switch(v){case 2:return await this.n(this.g,{files:p.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},f,t);case 1:return await this.n(this.i,{files:p.map(i=>P.URI.revive(i.target))},f,t);case 0:case 3:return await this.n(this.h,{files:p.map(i=>P.URI.revive(i.target))},f,t)}}async n(v,p,f,t){const i=new Set,n=[];if(await v.fireAsync(p,t,async(o,l)=>{const r=Date.now(),s=await Promise.resolve(o);s instanceof $.$LK&&(n.push([l.extension,s]),i.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-r>f&&this.k.warn("SLOW file-participant",l.extension.identifier)}),t.isCancellationRequested||n.length===0)return;const u={edits:[]};for(const[,o]of n){const{edits:l}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});u.edits=u.edits.concat(l)}return{edit:u,extensionNames:Array.from(i)}}}e.$mec=S}),define(Pe[252],Ae([1,0,6,2,3,8,7,32,12]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;class g{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=g.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class S{static{this.a=0}constructor(v,p,f,t){this.f=f,this.g=t,this.b=new Map,this.d=new Map,this.e=v.getProxy(P.$zK.MainThreadInlineChat),p.registerApiCommand(new $.$2M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$ZM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?M.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?M.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?M.Position.from(i.position):void 0}})],$.$1M.Void))}registerProvider(v,p,f){const t=new g(v,p);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,f.label,v.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,E.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(v,p,f,t){const i=this.b.get(v);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(L.URI.revive(p)),u=M.Selection.to(f),o=await i.provider.prepareInteractiveEditorSession({document:n,selection:u},t);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(u))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=S.a++;return this.d.set(l,new A(o)),{id:l,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(r=>({command:r.command,detail:r.detail,refer:r.refer,executeImmediately:r.executeImmediately})),wholeRange:M.Range.from(o.wholeRange),message:o.message}}async $provideResponse(v,p,f,t){const i=this.b.get(v);if(!i)return;const n=this.d.get(p.id);if(!n)return;const u={prompt:f.prompt,selection:M.Selection.to(f.selection),wholeRange:M.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let o=!1;const l={report:async b=>{if(!f.live&&b.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||t.isCancellationRequested||await this.e.$handleProgressChunk(f.requestId,{message:b.message,edits:b.edits?.map(M.TextEdit.from),editsShouldBeInstant:b.editsShouldBeInstant,slashCommand:b.slashCommand?.command,markdownFragment:R.$2K.isMarkdownString(b.content)?b.content.value:b.content})}},r=Promise.resolve(i.provider.provideInteractiveEditorResponse(n.session,u,l,t));let s;try{s=await(0,D.$Lg)(r,t)}finally{o=!0}if(!s)return;const c=n.responses.push(s)-1,h={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(S.h(s)){const{edits:b,contents:m}=s,I=m!==void 0?M.MarkdownString.from(m):void 0;return b instanceof R.$LK?{...h,id:c,type:"bulkEdit",edits:M.WorkspaceEdit.from(b),message:I}:{...h,id:c,type:"editorEdit",edits:b.map(M.TextEdit.from),message:I}}return{...h,id:c,type:"message",message:M.MarkdownString.from(s.contents)}}$handleFeedback(v,p,f,t){const i=this.b.get(v),n=this.d.get(p),u=n?.responses[f];if(i&&u){const o=M.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(n.session,u,o)}}$releaseSession(v,p){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$tfc=S}),define(Pe[253],Ae([1,0,2,32]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class P{constructor(R,$,D,g,A){this.a=$,this.b=D,this.c=g;const S=new L.$2M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$ZM("showOptions","Show Options",a=>!0,a=>a),new L.$ZM("resource","Interactive resource Uri",a=>!0,a=>a),new L.$ZM("controllerId","Notebook controller Id",a=>!0,a=>a),new L.$ZM("title","Interactive editor title",a=>!0,a=>a)],new L.$1M("Notebook and input URI",a=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const v=this.a.getEditorById(a.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:E.URI.revive(a.notebookUri),inputUri:E.URI.revive(a.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:E.URI.revive(a.notebookUri),inputUri:E.URI.revive(a.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(R,$,D,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:D,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$pfc=P}),define(Pe[254],Ae([1,0,3,7]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$zK.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(R);if(!D)throw new Error("Issue request handler not found");const g=await D.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const g=await D.provideIssueData($);if(!g)throw new Error("Issue data provider returned no result");return g}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const D=this.b.get(R);if(!D)throw new Error("Issue data provider not found");const g=await D.provideIssueTemplate($);if(!g)throw new Error("Issue template provider returned no result");return g}registerIssueUriRequestHandler(R,$){const D=R.identifier.value;return this.a.set(D,$),this.c.$registerIssueUriRequestHandler(D),new L.$BK(()=>{this.c.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}registerIssueDataProvider(R,$){const D=R.identifier.value;return this.b.set(D,$),this.c.$registerIssueDataProvider(D),new L.$BK(()=>{this.c.$unregisterIssueDataProvider(D),this.b.delete(D)})}}e.$vfc=P}),define(Pe[255],Ae([1,0,6,3]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(L.$zK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,E.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$Iec=P}),define(Pe[256],Ae([1,0,2,26,8,7,80,3,13,29,18,16,299,20,22,6,95,89,75,50,11,12,23,161]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o,l,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class c{constructor(T,V){this.d=T,this.e=V}async provideDocumentSymbols(T,V){const G=this.d.getDocument(T),Q=await this.e.provideDocumentSymbols(G,V);if(!(0,A.$Jb)(Q))return Q[0]instanceof M.$TK?Q.map(P.DocumentSymbol.from):c.f(Q)}static f(T){T=T.slice(0).sort((Q,q)=>{let _=Q.location.range.start.compareTo(q.location.range.start);return _===0&&(_=q.location.range.end.compareTo(Q.location.range.end)),_});const V=[],G=[];for(const Q of T){const q={name:Q.name||"!!MISSING: name!!",kind:P.SymbolKind.from(Q.kind),tags:Q.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:P.Range.from(Q.location.range),selectionRange:P.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(q),V.push(q);break}const _=G[G.length-1];if(g.$zs.containsRange(_.range,q.range)&&!g.$zs.equalsRange(_.range,q.range)){_.children?.push(q),G.push(q);break}G.pop()}}return V}}class h{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(T,V,G){this.g=T,this.h=V,this.j=G,this.e=new n.$wdc("CodeLens"),this.f=new Map}async provideCodeLenses(T,V){const G=this.g.getDocument(T),Q=await this.j.provideCodeLenses(G,V);if(!Q||V.isCancellationRequested)return;const q=this.e.add(Q),_=new f.$Qc;this.f.set(q,_);const le={cacheId:q,lenses:[]};for(let Oe=0;Oe<Q.length;Oe++)le.lenses.push({cacheId:[q,Oe],range:P.Range.from(Q[Oe].range),command:this.h.toInternal(Q[Oe].command,_)});return le}async resolveCodeLens(T,V){const G=T.cacheId&&this.e.get(...T.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,V),Q||(Q=G),V.isCancellationRequested)return;const q=T.cacheId&&this.f.get(T.cacheId[0]);if(q)return T.command=this.h.toInternal(Q.command??h.d,q),T}releaseCodeLenses(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}}function b(Ie){return Array.isArray(Ie)?Ie.map(P.DefinitionLink.from):Ie?[P.DefinitionLink.from(Ie)]:[]}class m{constructor(T,V){this.d=T,this.e=V}async provideDefinition(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideDefinition(Q,q,G);return b(_)}}class I{constructor(T,V){this.d=T,this.e=V}async provideDeclaration(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideDeclaration(Q,q,G);return b(_)}}class k{constructor(T,V){this.d=T,this.e=V}async provideImplementation(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideImplementation(Q,q,G);return b(_)}}class d{constructor(T,V){this.d=T,this.e=V}async provideTypeDefinition(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideTypeDefinition(Q,q,G);return b(_)}}class w{constructor(T,V){this.d=T,this.e=V}async provideHover(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideHover(Q,q,G);if(!(!_||(0,A.$Jb)(_.contents)))return _.range||(_.range=Q.getWordRangeAtPosition(q)),_.range||(_.range=new M.$DK(q,q)),P.Hover.from(_)}}class y{constructor(T,V){this.d=T,this.e=V}async provideEvaluatableExpression(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideEvaluatableExpression(Q,q,G);if(_)return P.EvaluatableExpression.from(_)}}class C{constructor(T,V){this.d=T,this.e=V}async provideInlineValues(T,V,G,Q){const q=this.d.getDocument(T),_=await this.e.provideInlineValues(q,P.Range.to(V),P.InlineValueContext.to(G),Q);if(Array.isArray(_))return _.map(le=>P.InlineValue.from(le))}}class W{constructor(T,V){this.d=T,this.e=V}async provideDocumentHighlights(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideDocumentHighlights(Q,q,G);if(Array.isArray(_))return _.map(P.DocumentHighlight.from)}}class H{constructor(T,V){this.d=T,this.e=V}async provideLinkedEditingRanges(T,V,G){const Q=this.d.getDocument(T),q=P.Position.to(V),_=await this.e.provideLinkedEditingRanges(Q,q,G);if(_&&Array.isArray(_.ranges))return{ranges:(0,A.$Gb)(_.ranges.map(P.Range.from)),wordPattern:_.wordPattern}}}class U{constructor(T,V){this.d=T,this.e=V}async provideReferences(T,V,G,Q){const q=this.d.getDocument(T),_=P.Position.to(V),le=await this.e.provideReferences(q,_,G,Q);if(Array.isArray(le))return le.map(P.location.from)}}class z{static{this.d=1e3}constructor(T,V,G,Q,q,_,le){this.g=T,this.h=V,this.j=G,this.k=Q,this.l=q,this.m=_,this.n=le,this.e=new n.$wdc("CodeAction"),this.f=new Map}async provideCodeActions(T,V,G,Q){const q=this.g.getDocument(T),_=a.$Bs.isISelection(V)?P.Selection.to(V):P.Range.to(V),le=[];for(const Ye of this.j.getDiagnostics(T))if(_.intersection(Ye.range)&&le.push(Ye)>z.d)break;const Oe={diagnostics:le,only:G.only?new M.$VK(G.only):void 0,triggerKind:P.CodeActionTriggerKind.to(G.trigger)},Be=await this.k.provideCodeActions(q,_,Oe,Q);if(!(0,A.$Kb)(Be)||Q.isCancellationRequested)return;const Je=this.e.add(Be),Ge=new f.$Qc;this.f.set(Je,Ge);const _e=[];for(let Ye=0;Ye<Be.length;Ye++){const xe=Be[Ye];xe&&(z.o(xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),_e.push({_isSynthetic:!0,title:xe.title,command:this.h.toInternal(xe,Ge)})):(Oe.only&&(xe.kind?Oe.only.contains(xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),_e.push({cacheId:[Je,Ye],title:xe.title,command:xe.command&&this.h.toInternal(xe.command,Ge),diagnostics:xe.diagnostics&&xe.diagnostics.map(P.Diagnostic.from),edit:xe.edit&&P.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,isAI:(0,r.$xF)(this.m,"codeActionAI")?xe.isAI:!1,disabled:xe.disabled?.reason})))}return{cacheId:Je,actions:_e}}async resolveCodeAction(T,V){const[G,Q]=T,q=this.e.get(G,Q);if(!q||z.o(q))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(q,V)??q;let le;_.edit&&(le=P.WorkspaceEdit.from(_.edit,void 0));let Oe;if(_.command){const Be=this.f.get(G);Be&&(Oe=this.h.toInternal(_.command,Be))}return{edit:le,command:Oe}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class F{static toInternalProviderId(T,V){return T+"."+V}constructor(T,V,G,Q,q){this.d=T,this.e=V,this.f=G,this.g=Q,this.h=q}async prepareDocumentPaste(T,V,G,Q){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(T),_=V.map(Be=>P.Range.to(Be)),le=P.DataTransfer.toDataTransfer(G,()=>{throw new o.$0});if(await this.f.prepareDocumentPaste(q,_,le,Q),Q.isCancellationRequested)return;const Oe=Array.from(le).filter(([,Be])=>!(Be instanceof M.$pL));return P.DataTransfer.from(Oe)}async providePasteEdits(T,V,G,Q,q){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(V),le=G.map(Je=>P.Range.to(Je)),Oe=P.DataTransfer.toDataTransfer(Q,async Je=>(await this.d.$resolvePasteFileData(this.g,T,Je)).buffer),Be=await this.f.provideDocumentPasteEdits(_,le,Oe,q);if(Be)return{label:Be.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Be.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:F.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof Be.insertText=="string"?Be.insertText:{snippet:Be.insertText.value},additionalEdit:Be.additionalEdit?P.WorkspaceEdit.from(Be.additionalEdit,void 0):void 0}}}class N{constructor(T,V){this.d=T,this.e=V}async provideDocumentFormattingEdits(T,V,G){const Q=this.d.getDocument(T),q=await this.e.provideDocumentFormattingEdits(Q,V,G);if(Array.isArray(q))return q.map(P.TextEdit.from)}}class x{constructor(T,V){this.d=T,this.e=V}async provideDocumentRangeFormattingEdits(T,V,G,Q){const q=this.d.getDocument(T),_=P.Range.to(V),le=await this.e.provideDocumentRangeFormattingEdits(q,_,G,Q);if(Array.isArray(le))return le.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,V,G,Q){(0,S.$Lf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(T),_=V.map(P.Range.to),le=await this.e.provideDocumentRangesFormattingEdits(q,_,G,Q);if(Array.isArray(le))return le.map(P.TextEdit.from)}}class J{constructor(T,V){this.d=T,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,V,G,Q,q){const _=this.d.getDocument(T),le=P.Position.to(V),Oe=await this.e.provideOnTypeFormattingEdits(_,le,G,Q,q);if(Array.isArray(Oe))return Oe.map(P.TextEdit.from)}}class Ee{constructor(T,V){this.e=T,this.f=V,this.d=new n.$wdc("WorkspaceSymbols")}async provideWorkspaceSymbols(T,V){const G=await this.e.provideWorkspaceSymbols(T,V);if(!(0,A.$Kb)(G))return{symbols:[]};const Q=this.d.add(G),q={cacheId:Q,symbols:[]};for(let _=0;_<G.length;_++){const le=G[_];if(!le||!le.name){this.f.warn("INVALID SymbolInformation",le);continue}q.symbols.push({...P.WorkspaceSymbol.from(le),cacheId:[Q,_]})}return q}async resolveWorkspaceSymbol(T,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const G=this.d.get(...T.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,V);return Q&&(0,L.$cn)(T,P.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class De{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,V,G){this.d=T,this.e=V,this.f=G}async provideRenameEdits(T,V,G,Q){const q=this.d.getDocument(T),_=P.Position.to(V);try{const le=await this.e.provideRenameEdits(q,_,G,Q);return le?P.WorkspaceEdit.from(le):void 0}catch(le){const Oe=De.g(le);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(le)}}async resolveRenameLocation(T,V,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(T),q=P.Position.to(V);try{const _=await this.e.prepareRename(Q,q,G);let le,Oe;if(M.$DK.isRange(_)?(le=_,Oe=Q.getText(_)):(0,S.$Df)(_)&&(le=_.range,Oe=_.placeholder),!le||!Oe)return;if(le.start.line>q.line||le.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(le),text:Oe}}catch(_){const le=De.g(_);return le?{rejectReason:le,range:void 0,text:void 0}:Promise.reject(_)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class Ce{constructor(T,V){this.resultId=T,this.tokens=V}}class fe{constructor(T,V){this.f=T,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,V,G){const Q=this.f.getDocument(T),q=V!==0?this.d.get(V):null;let _=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,q.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return q&&this.d.delete(V),_?(_=fe.h(_),this.o(fe.n(q,_),_)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return fe.j(T)?fe.k(T)?T:new M.$SL(new Uint32Array(T.data),T.resultId):fe.l(T)?fe.m(T)?T:new M.$UL(T.edits.map(V=>new M.$TL(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const V of T.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(T,V){if(!fe.j(V)||!T||!T.tokens)return V;const G=T.tokens,Q=G.length,q=V.data,_=q.length;let le=0;const Oe=Math.min(Q,_);for(;le<Oe&&G[le]===q[le];)le++;if(le===Q&&le===_)return new M.$UL([],V.resultId);let Be=0;const Je=Oe-le;for(;Be<Je&&G[Q-Be-1]===q[_-Be-1];)Be++;return new M.$UL([{start:le,deleteCount:Q-le-Be,data:q.subarray(le,_-Be)}],V.resultId)}o(T,V){if(fe.j(T)){const G=this.e++;return this.d.set(G,new Ce(T.resultId,T.data)),(0,t.$E$)({id:G,type:"full",data:T.data})}if(fe.l(T)){const G=this.e++;return fe.j(V)?this.d.set(G,new Ce(V.resultId,V.data)):this.d.set(G,new Ce(T.resultId)),(0,t.$E$)({id:G,type:"delta",deltas:(T.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class be{constructor(T,V){this.d=T,this.e=V}async provideDocumentRangeSemanticTokens(T,V,G){const Q=this.d.getDocument(T),q=await this.e.provideDocumentRangeSemanticTokens(Q,P.Range.to(V),G);return q?this.f(q):null}f(T){return(0,t.$E$)({id:0,type:"full",data:T.data})}}class se{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,V,G,Q,q){this.f=T,this.g=V,this.h=G,this.j=Q,this.k=q,this.d=new n.$wdc("CompletionItem"),this.e=new Map}async provideCompletionItems(T,V,G,Q){const q=this.f.getDocument(T),_=P.Position.to(V),le=q.getWordRangeAtPosition(_)||new M.$DK(_,_),Oe=le.with({end:_}),Be=new u.$Md,Je=await this.h.provideCompletionItems(q,_,Q,P.CompletionContext.to(G));if(!Je||Q.isCancellationRequested)return;const Ge=Array.isArray(Je)?new M.$9K(Je):Je,_e=se.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Ye=new f.$Qc;this.e.set(_e,Ye);const xe=[],it={x:_e,b:xe,a:{replace:P.Range.from(le),insert:P.Range.from(Oe)},c:Ge.isIncomplete||void 0,d:Be.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],ut=this.l(ze,[_e,tt],Oe,le);xe.push(ut)}return it}async resolveCompletionItem(T,V){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...T);if(!G)return;const Q=this.l(G,T),q=await this.h.resolveCompletionItem(G,V);if(!q)return;const _=this.l(q,T);return(Q.h!==_.h||Q.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==_.n||Q.o!==_.o||!(0,L.$dn)(Q.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,V,G,Q){const q=this.e.get(V[0]);if(!q)throw Error("DisposableStore is missing...");const _=this.g.toInternal(T.command,q),le={x:V,a:T.label,b:T.kind!==void 0?P.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(P.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:P.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(P.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),le.h=T.textEdit.newText):typeof T.insertText=="string"?le.h=T.insertText:T.insertText instanceof M.$MK&&(le.h=T.insertText.value,le.i|=4);let Oe;return T.textEdit?Oe=T.textEdit.range:T.range&&(Oe=T.range),M.$DK.isRange(Oe)?le.j=P.Range.from(Oe):Oe&&(!G?.isEqual(Oe.inserting)||!Q?.isEqual(Oe.replacing))&&(le.j={insert:P.Range.from(Oe.inserting),replace:P.Range.from(Oe.replacing)}),le}}class Re{async provideInlineCompletions(T,V,G,Q){}disposeCompletions(T){}handleDidShowCompletionItem(T,V,G){}handlePartialAccept(T,V,G){}}class oe extends Re{constructor(T,V,G,Q){super(),this.f=T,this.g=V,this.h=G,this.j=Q,this.d=new X,this.e=(0,r.$xF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$xF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,V,G,Q){const q=this.g.getDocument(T),_=P.Position.to(V),le=await this.h.provideInlineCompletionItems(q,_,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:P.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!le||Q.isCancellationRequested)return;const Oe=Array.isArray(le)?le:le.items,Be=this.e?Array.isArray(le)?[]:le.commands||[]:[],Je=this.e&&!Array.isArray(le)?le.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Oe}),items:Oe.map((Ye,xe)=>{let it;Ye.command&&(Ge||(Ge=new f.$Qc),it=this.j.toInternal(Ye.command,Ge));const tt=Ye.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ye.filterText,range:Ye.range?P.Range.from(Ye.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Ye.completeBracketPairs:!1}}),commands:Be.map(Ye=>(Ge||(Ge=new f.$Qc),this.j.toInternal(Ye,Ge))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,V,G){const Q=this.d.get(T)?.items[V];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(T,V,G){const Q=this.d.get(T)?.items[V];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const V=this.e++;return this.d.set(V,T),V}disposeReferenceId(T){const V=this.d.get(T);return this.d.delete(T),V}get(T){return this.d.get(T)}}class j{constructor(T,V){this.e=T,this.f=V,this.d=new n.$wdc("SignatureHelp")}async provideSignatureHelp(T,V,G,Q){const q=this.e.getDocument(T),_=P.Position.to(V),le=this.g(G),Oe=await this.f.provideSignatureHelp(q,_,Q,le);if(Oe){const Be=this.d.add([Oe]);return{...P.SignatureHelp.from(Oe),id:Be}}}g(T){let V;if(T.activeSignatureHelp){const G=P.SignatureHelp.to(T.activeSignatureHelp),Q=this.d.get(T.activeSignatureHelp.id,0);Q?(V=Q,V.activeSignature=G.activeSignature,V.activeParameter=G.activeParameter):V=G}return{...T,activeSignatureHelp:V}}releaseSignatureHelp(T){this.d.delete(T)}}class ne{constructor(T,V,G,Q,q){this.f=T,this.g=V,this.h=G,this.j=Q,this.k=q,this.d=new n.$wdc("InlayHints"),this.e=new Map}async provideInlayHints(T,V,G){const Q=this.f.getDocument(T),q=P.Range.to(V),_=await this.h.provideInlayHints(Q,q,G);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${V}`);return}if(G.isCancellationRequested)return;const le=this.d.add(_);this.e.set(le,new f.$Qc);const Oe={hints:[],cacheId:le};for(let Be=0;Be<_.length;Be++)this.l(_[Be],q)&&Oe.hints.push(this.m(_[Be],[le,Be]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${V}`),Oe}async resolveInlayHint(T,V){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...T);if(!G)return;const Q=await this.h.resolveInlayHint(G,V);if(Q&&this.l(Q))return this.m(Q,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,V){return T.label.length===0||Array.isArray(T.label)&&T.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(V&&!V.contains(T.position))}m(T,V){const G=this.e.get(V[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:V,tooltip:P.MarkdownString.fromStrict(T.tooltip),position:P.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(P.TextEdit.from),kind:T.kind&&P.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};return typeof T.label=="string"?Q.label=T.label:Q.label=T.label.map(q=>{const _={label:q.value};return _.tooltip=P.MarkdownString.fromStrict(q.tooltip),M.$NK.isLocation(q.location)&&(_.location=P.location.from(q.location)),q.command&&(_.command=this.g.toInternal(q.command,G)),_}),Q}}class pe{constructor(T,V){this.e=T,this.f=V,this.d=new n.$wdc("DocumentLink")}async provideLinks(T,V){const G=this.e.getDocument(T),Q=await this.f.provideDocumentLinks(G,V);if(!(!Array.isArray(Q)||Q.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(pe.g).map(P.DocumentLink.from)};{const q=this.d.add(Q),_={links:[],cacheId:q};for(let le=0;le<Q.length;le++){if(!pe.g(Q[le]))continue;const Oe=P.DocumentLink.from(Q[le]);Oe.cacheId=[q,le],_.links.push(Oe)}return _}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,V){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...T);if(!G)return;const Q=await this.f.resolveDocumentLink(G,V);if(!(!Q||!pe.g(Q)))return P.DocumentLink.from(Q)}releaseLinks(T){this.d.delete(T)}}class re{constructor(T,V){this.d=T,this.e=V}async provideColors(T,V){const G=this.d.getDocument(T),Q=await this.e.provideDocumentColors(G,V);return Array.isArray(Q)?Q.map(_=>({color:P.Color.from(_.color),range:P.Range.from(_.range)})):[]}async provideColorPresentations(T,V,G){const Q=this.d.getDocument(T),q=P.Range.to(V.range),_=P.Color.to(V.color),le=await this.e.provideColorPresentations(_,{document:Q,range:q},G);if(Array.isArray(le))return le.map(P.ColorPresentation.from)}}class he{constructor(T,V){this.d=T,this.e=V}async provideFoldingRanges(T,V,G){const Q=this.d.getDocument(T),q=await this.e.provideFoldingRanges(Q,V,G);if(Array.isArray(q))return q.map(P.FoldingRange.from)}}class ue{constructor(T,V,G){this.d=T,this.e=V,this.f=G}async provideSelectionRanges(T,V,G){const Q=this.d.getDocument(T),q=V.map(P.Position.to),_=await this.e.provideSelectionRanges(Q,q,G);if(!(0,A.$Kb)(_))return[];if(_.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const le=[];for(let Oe=0;Oe<q.length;Oe++){const Be=[];le.push(Be);let Je=q[Oe],Ge=_[Oe];for(;;){if(!Ge.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(P.SelectionRange.from(Ge)),!Ge.parent)break;Je=Ge.range,Ge=Ge.parent}}return le}}class we{constructor(T,V){this.f=T,this.g=V,this.d=new i.$GM(""),this.e=new Map}async prepareSession(T,V,G){const Q=this.f.getDocument(T),q=P.Position.to(V),_=await this.g.prepareCallHierarchy(Q,q,G);if(!_)return;const le=this.d.nextId();return this.e.set(le,new Map),Array.isArray(_)?_.map(Oe=>this.h(le,Oe)):[this.h(le,_)]}async provideCallsTo(T,V,G){const Q=this.j(T,V);if(!Q)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(q)return q.map(_=>({from:this.h(T,_.from),fromRanges:_.fromRanges.map(le=>P.Range.from(le))}))}async provideCallsFrom(T,V,G){const Q=this.j(T,V);if(!Q)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(q)return q.map(_=>({to:this.h(T,_.to),fromRanges:_.fromRanges.map(le=>P.Range.from(le))}))}releaseSession(T){this.e.delete(T)}h(T,V){const G=this.e.get(T),Q=P.CallHierarchyItem.from(V,T,G.size.toString(36));return G.set(Q._itemId,V),Q}j(T,V){return this.e.get(T)?.get(V)}}class ee{constructor(T,V){this.f=T,this.g=V,this.d=new i.$GM(""),this.e=new Map}async prepareSession(T,V,G){const Q=this.f.getDocument(T),q=P.Position.to(V),_=await this.g.prepareTypeHierarchy(Q,q,G);if(!_)return;const le=this.d.nextId();return this.e.set(le,new Map),Array.isArray(_)?_.map(Oe=>this.h(le,Oe)):[this.h(le,_)]}async provideSupertypes(T,V,G){const Q=this.j(T,V);if(!Q)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(Q,G);if(q)return q.map(_=>this.h(T,_))}async provideSubtypes(T,V,G){const Q=this.j(T,V);if(!Q)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(Q,G);if(q)return q.map(_=>this.h(T,_))}releaseSession(T){this.e.delete(T)}h(T,V){const G=this.e.get(T),Q=P.TypeHierarchyItem.from(V,T,G.size.toString(36));return G.set(Q._itemId,V),Q}j(T,V){return this.e.get(T)?.get(V)}}class de{static toInternalProviderId(T,V){return T+"."+V}constructor(T,V,G,Q,q){this.d=T,this.e=V,this.f=G,this.g=Q,this.h=q}async provideDocumentOnDropEdits(T,V,G,Q,q){const _=this.e.getDocument(V),le=P.Position.to(G),Oe=P.DataTransfer.toDataTransfer(Q,async Je=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,Je)).buffer),Be=await this.f.provideDocumentDropEdits(_,le,Oe,q);if(Be)return{label:Be.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Be.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:de.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof Be.insertText=="string"?Be.insertText:{snippet:Be.insertText.value},additionalEdit:Be.additionalEdit?P.WorkspaceEdit.from(Be.additionalEdit,void 0):void 0}}}class ie{constructor(T,V){this.d=T,this.e=V}async provideMappedEdits(T,V,G,Q){const q=E.URI.revive(T),_=this.d.getDocument(q),le=G.documents.map(Je=>Je.map(Ge=>({uri:E.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(_e=>P.Range.to(_e))}))),Oe={documents:le,selections:le[0]?.[0]?.ranges??[]},Be=await this.e.provideMappedEdits(_,V,Oe,Q);return Be?P.WorkspaceEdit.from(Be):null}}class ce{constructor(T,V){this.adapter=T,this.extension=V}}class me{static{this.d=0}constructor(T,V,G,Q,q,_,le,Oe){this.g=V,this.h=G,this.j=Q,this.k=q,this.l=_,this.m=le,this.n=Oe,this.f=new Map,this.e=T.getProxy($.$zK.MainThreadLanguageFeatures)}o(T,V){return P.DocumentSelector.from(T,this.g,V)}p(T){return new M.$BK(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return me.d++}async s(T,V,G,Q,q,_=!1){const le=this.f.get(T);if(!le||!(le.adapter instanceof V))return Q;const Oe=Date.now();_||this.l.trace(`[${le.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Be=G(le.adapter,le.extension);return Promise.resolve(Be).catch(Je=>{(0,o.$3)(Je)||(this.l.error(`[${le.extension.identifier.value}] provider FAILED`),this.l.error(Je),this.n.onExtensionError(le.extension.identifier,Je))}).finally(()=>{_||this.l.trace(`[${le.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),v.CancellationToken.isCancellationToken(q)?(0,l.$Mg)(Be,q):Be}t(T,V){const G=this.q();return this.f.set(G,new ce(T,V)),G}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,V,G,Q){const q=this.t(new c(this.h,G),T),_=Q&&Q.label||me.u(T);return this.e.$registerDocumentSymbolProvider(q,this.o(V,T),_),this.p(q)}$provideDocumentSymbols(T,V,G){return this.s(T,c,Q=>Q.provideDocumentSymbols(E.URI.revive(V),G),void 0,G)}registerCodeLensProvider(T,V,G){const Q=this.q(),q=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new ce(new h(this.h,this.j.converter,G),T)),this.e.$registerCodeLensSupport(Q,this.o(V,T),q);let _=this.p(Q);if(q!==void 0){const le=G.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(q));_=M.$BK.from(_,le)}return _}$provideCodeLenses(T,V,G){return this.s(T,h,Q=>Q.provideCodeLenses(E.URI.revive(V),G),void 0,G)}$resolveCodeLens(T,V,G){return this.s(T,h,Q=>Q.resolveCodeLens(V,G),void 0,void 0)}$releaseCodeLenses(T,V){this.s(T,h,G=>Promise.resolve(G.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(T,V,G){const Q=this.t(new m(this.h,G),T);return this.e.$registerDefinitionSupport(Q,this.o(V,T)),this.p(Q)}$provideDefinition(T,V,G,Q){return this.s(T,m,q=>q.provideDefinition(E.URI.revive(V),G,Q),[],Q)}registerDeclarationProvider(T,V,G){const Q=this.t(new I(this.h,G),T);return this.e.$registerDeclarationSupport(Q,this.o(V,T)),this.p(Q)}$provideDeclaration(T,V,G,Q){return this.s(T,I,q=>q.provideDeclaration(E.URI.revive(V),G,Q),[],Q)}registerImplementationProvider(T,V,G){const Q=this.t(new k(this.h,G),T);return this.e.$registerImplementationSupport(Q,this.o(V,T)),this.p(Q)}$provideImplementation(T,V,G,Q){return this.s(T,k,q=>q.provideImplementation(E.URI.revive(V),G,Q),[],Q)}registerTypeDefinitionProvider(T,V,G){const Q=this.t(new d(this.h,G),T);return this.e.$registerTypeDefinitionSupport(Q,this.o(V,T)),this.p(Q)}$provideTypeDefinition(T,V,G,Q){return this.s(T,d,q=>q.provideTypeDefinition(E.URI.revive(V),G,Q),[],Q)}registerHoverProvider(T,V,G,Q){const q=this.t(new w(this.h,G),T);return this.e.$registerHoverProvider(q,this.o(V,T)),this.p(q)}$provideHover(T,V,G,Q){return this.s(T,w,q=>q.provideHover(E.URI.revive(V),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(T,V,G,Q){const q=this.t(new y(this.h,G),T);return this.e.$registerEvaluatableExpressionProvider(q,this.o(V,T)),this.p(q)}$provideEvaluatableExpression(T,V,G,Q){return this.s(T,y,q=>q.provideEvaluatableExpression(E.URI.revive(V),G,Q),void 0,Q)}registerInlineValuesProvider(T,V,G,Q){const q=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new C(this.h,G),T);this.e.$registerInlineValuesProvider(_,this.o(V,T),q);let le=this.p(_);if(q!==void 0){const Oe=G.onDidChangeInlineValues(Be=>this.e.$emitInlineValuesEvent(q));le=M.$BK.from(le,Oe)}return le}$provideInlineValues(T,V,G,Q,q){return this.s(T,C,_=>_.provideInlineValues(E.URI.revive(V),G,Q,q),void 0,q)}registerDocumentHighlightProvider(T,V,G){const Q=this.t(new W(this.h,G),T);return this.e.$registerDocumentHighlightProvider(Q,this.o(V,T)),this.p(Q)}$provideDocumentHighlights(T,V,G,Q){return this.s(T,W,q=>q.provideDocumentHighlights(E.URI.revive(V),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(T,V,G){const Q=this.t(new H(this.h,G),T);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(V,T)),this.p(Q)}$provideLinkedEditingRanges(T,V,G,Q){return this.s(T,H,async q=>{const _=await q.provideLinkedEditingRanges(E.URI.revive(V),G,Q);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?me.w(_.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(T,V,G){const Q=this.t(new U(this.h,G),T);return this.e.$registerReferenceSupport(Q,this.o(V,T)),this.p(Q)}$provideReferences(T,V,G,Q,q){return this.s(T,U,_=>_.provideReferences(E.URI.revive(V),G,Q,q),void 0,q)}registerCodeActionProvider(T,V,G,Q){const q=new f.$Qc,_=this.t(new z(this.h,this.j.converter,this.k,G,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(_,this.o(V,T),{providedKinds:Q?.providedCodeActionKinds?.map(le=>le.value),documentation:Q?.documentation?.map(le=>({kind:le.kind.value,command:this.j.converter.toInternal(le.command,q)}))},me.u(T),!!G.resolveCodeAction),q.add(this.p(_)),q}$provideCodeActions(T,V,G,Q,q){return this.s(T,z,_=>_.provideCodeActions(E.URI.revive(V),G,Q,q),void 0,q)}$resolveCodeAction(T,V,G){return this.s(T,z,Q=>Q.resolveCodeAction(V,G),{},void 0)}$releaseCodeActions(T,V){this.s(T,z,G=>Promise.resolve(G.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(T,V,G){const Q=this.t(new N(this.h,G),T);return this.e.$registerDocumentFormattingSupport(Q,this.o(V,T),T.identifier,T.displayName||T.name),this.p(Q)}$provideDocumentFormattingEdits(T,V,G,Q){return this.s(T,N,q=>q.provideDocumentFormattingEdits(E.URI.revive(V),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(T,V,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",q=this.t(new x(this.h,G),T);return this.e.$registerRangeFormattingSupport(q,this.o(V,T),T.identifier,T.displayName||T.name,Q),this.p(q)}$provideDocumentRangeFormattingEdits(T,V,G,Q,q){return this.s(T,x,_=>_.provideDocumentRangeFormattingEdits(E.URI.revive(V),G,Q,q),void 0,q)}$provideDocumentRangesFormattingEdits(T,V,G,Q,q){return this.s(T,x,_=>_.provideDocumentRangesFormattingEdits(E.URI.revive(V),G,Q,q),void 0,q)}registerOnTypeFormattingEditProvider(T,V,G,Q){const q=this.t(new J(this.h,G),T);return this.e.$registerOnTypeFormattingSupport(q,this.o(V,T),Q,T.identifier),this.p(q)}$provideOnTypeFormattingEdits(T,V,G,Q,q,_){return this.s(T,J,le=>le.provideOnTypeFormattingEdits(E.URI.revive(V),G,Q,q,_),void 0,_)}registerWorkspaceSymbolProvider(T,V){const G=this.t(new Ee(V,this.l),T);return this.e.$registerNavigateTypeSupport(G,typeof V.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(T,V,G){return this.s(T,Ee,Q=>Q.provideWorkspaceSymbols(V,G),{symbols:[]},G)}$resolveWorkspaceSymbol(T,V,G){return this.s(T,Ee,Q=>Q.resolveWorkspaceSymbol(V,G),void 0,void 0)}$releaseWorkspaceSymbols(T,V){this.s(T,Ee,G=>G.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(T,V,G){const Q=this.t(new De(this.h,G,this.l),T);return this.e.$registerRenameSupport(Q,this.o(V,T),De.supportsResolving(G)),this.p(Q)}$provideRenameEdits(T,V,G,Q,q){return this.s(T,De,_=>_.provideRenameEdits(E.URI.revive(V),G,Q,q),void 0,q)}$resolveRenameLocation(T,V,G,Q){return this.s(T,De,q=>q.resolveRenameLocation(E.URI.revive(V),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(T,V,G,Q){const q=this.t(new fe(this.h,G),T),_=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(V,T),Q,_);let le=this.p(q);if(_){const Oe=G.onDidChangeSemanticTokens(Be=>this.e.$emitDocumentSemanticTokensEvent(_));le=M.$BK.from(le,Oe)}return le}$provideDocumentSemanticTokens(T,V,G,Q){return this.s(T,fe,q=>q.provideDocumentSemanticTokens(E.URI.revive(V),G,Q),null,Q)}$releaseDocumentSemanticTokens(T,V){this.s(T,fe,G=>G.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,V,G,Q){const q=this.t(new be(this.h,G),T);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(V,T),Q),this.p(q)}$provideDocumentRangeSemanticTokens(T,V,G,Q){return this.s(T,be,q=>q.provideDocumentRangeSemanticTokens(E.URI.revive(V),G,Q),null,Q)}registerCompletionItemProvider(T,V,G,Q){const q=this.t(new se(this.h,this.j.converter,G,this.m,T),T);return this.e.$registerCompletionsProvider(q,this.o(V,T),Q,se.supportsResolving(G),T.identifier),this.p(q)}$provideCompletionItems(T,V,G,Q,q){return this.s(T,se,_=>_.provideCompletionItems(E.URI.revive(V),G,Q,q),void 0,q)}$resolveCompletionItem(T,V,G){return this.s(T,se,Q=>Q.resolveCompletionItem(V,G),void 0,G)}$releaseCompletionItems(T,V){this.s(T,se,G=>G.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(T,V,G,Q){const q=new oe(T,this.h,G,this.j.converter),_=this.t(q,T);return this.e.$registerInlineCompletionsSupport(_,this.o(V,T),q.supportsHandleEvents,p.$$l.toKey(T.identifier.value),Q?.yieldTo?.map(le=>p.$$l.toKey(le))||[]),this.p(_)}$provideInlineCompletions(T,V,G,Q,q){return this.s(T,Re,_=>_.provideInlineCompletions(E.URI.revive(V),G,Q,q),void 0,q)}$handleInlineCompletionDidShow(T,V,G,Q){this.s(T,Re,async q=>{q.handleDidShowCompletionItem(V,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,V,G,Q){this.s(T,Re,async q=>{q.handlePartialAccept(V,G,Q)},void 0,void 0)}$freeInlineCompletionsList(T,V){this.s(T,Re,async G=>{G.disposeCompletions(V)},void 0,void 0)}registerSignatureHelpProvider(T,V,G,Q){const q=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,_=this.t(new j(this.h,G),T);return this.e.$registerSignatureHelpProvider(_,this.o(V,T),q),this.p(_)}$provideSignatureHelp(T,V,G,Q,q){return this.s(T,j,_=>_.provideSignatureHelp(E.URI.revive(V),G,Q,q),void 0,q)}$releaseSignatureHelp(T,V){this.s(T,j,G=>G.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(T,V,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new ne(this.h,this.j.converter,G,this.l,T),T);this.e.$registerInlayHintsProvider(q,this.o(V,T),typeof G.resolveInlayHint=="function",Q,me.u(T));let _=this.p(q);if(Q!==void 0){const le=G.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(Q));_=M.$BK.from(_,le)}return _}$provideInlayHints(T,V,G,Q){return this.s(T,ne,q=>q.provideInlayHints(E.URI.revive(V),G,Q),void 0,Q)}$resolveInlayHint(T,V,G){return this.s(T,ne,Q=>Q.resolveInlayHint(V,G),void 0,G)}$releaseInlayHints(T,V){this.s(T,ne,G=>G.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(T,V,G){const Q=this.t(new pe(this.h,G),T);return this.e.$registerDocumentLinkProvider(Q,this.o(V,T),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(T,V,G){return this.s(T,pe,Q=>Q.provideLinks(E.URI.revive(V),G),void 0,G,V.scheme==="output")}$resolveDocumentLink(T,V,G){return this.s(T,pe,Q=>Q.resolveLink(V,G),void 0,void 0,!0)}$releaseDocumentLinks(T,V){this.s(T,pe,G=>G.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(T,V,G){const Q=this.t(new re(this.h,G),T);return this.e.$registerDocumentColorProvider(Q,this.o(V,T)),this.p(Q)}$provideDocumentColors(T,V,G){return this.s(T,re,Q=>Q.provideColors(E.URI.revive(V),G),[],G)}$provideColorPresentations(T,V,G,Q){return this.s(T,re,q=>q.provideColorPresentations(E.URI.revive(V),G,Q),void 0,Q)}registerFoldingRangeProvider(T,V,G){const Q=this.q(),q=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new ce(new he(this.h,G),T)),this.e.$registerFoldingRangeProvider(Q,this.o(V,T),T.identifier,q);let _=this.p(Q);if(q!==void 0){const le=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));_=M.$BK.from(_,le)}return _}$provideFoldingRanges(T,V,G,Q){return this.s(T,he,q=>q.provideFoldingRanges(E.URI.revive(V),G,Q),void 0,Q)}registerSelectionRangeProvider(T,V,G){const Q=this.t(new ue(this.h,G,this.l),T);return this.e.$registerSelectionRangeProvider(Q,this.o(V,T)),this.p(Q)}$provideSelectionRanges(T,V,G,Q){return this.s(T,ue,q=>q.provideSelectionRanges(E.URI.revive(V),G,Q),[],Q)}registerCallHierarchyProvider(T,V,G){const Q=this.t(new we(this.h,G),T);return this.e.$registerCallHierarchyProvider(Q,this.o(V,T)),this.p(Q)}$prepareCallHierarchy(T,V,G,Q){return this.s(T,we,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(T,V,G,Q){return this.s(T,we,q=>q.provideCallsTo(V,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(T,V,G,Q){return this.s(T,we,q=>q.provideCallsFrom(V,G,Q),void 0,Q)}$releaseCallHierarchy(T,V){this.s(T,we,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(T,V,G){const Q=this.t(new ee(this.h,G),T);return this.e.$registerTypeHierarchyProvider(Q,this.o(V,T)),this.p(Q)}$prepareTypeHierarchy(T,V,G,Q){return this.s(T,ee,q=>Promise.resolve(q.prepareSession(E.URI.revive(V),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(T,V,G,Q){return this.s(T,ee,q=>q.provideSupertypes(V,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(T,V,G,Q){return this.s(T,ee,q=>q.provideSubtypes(V,G,Q),void 0,Q)}$releaseTypeHierarchy(T,V){this.s(T,ee,G=>Promise.resolve(G.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(T,V,G,Q){const q=this.q();this.f.set(q,new ce(new de(this.e,this.h,G,q,T),T));const _=(0,r.$xF)(T,"dropMetadata")&&Q?de.toInternalProviderId(T.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(V,T),_,(0,r.$xF)(T,"dropMetadata")?Q:void 0),this.p(q)}$provideDocumentOnDropEdits(T,V,G,Q,q,_){return this.s(T,de,le=>Promise.resolve(le.provideDocumentOnDropEdits(V,E.URI.revive(G),Q,q,_)),void 0,void 0)}registerMappedEditsProvider(T,V,G){const Q=this.t(new ie(this.h,G),T);return this.e.$registerMappedEditsProvider(Q,this.o(V,T)),this.p(Q)}$provideMappedEdits(T,V,G,Q,q){return this.s(T,ie,_=>Promise.resolve(_.provideMappedEdits(V,G,Q,q)),null,q)}registerDocumentPasteEditProvider(T,V,G,Q){const q=this.q();this.f.set(q,new ce(new F(this.e,this.h,G,q,T),T));const _=F.toInternalProviderId(T.identifier.value,Q.id);return this.e.$registerPasteEditProvider(q,this.o(V,T),_,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(T,V,G,Q,q){return this.s(T,F,_=>_.prepareDocumentPaste(E.URI.revive(V),G,Q,q),void 0,q)}$providePasteEdits(T,V,G,Q,q,_){return this.s(T,F,le=>le.providePasteEdits(V,E.URI.revive(G),Q,q,_),void 0,_)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:me.w(T.decreaseIndentPattern),increaseIndentPattern:me.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?me.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?me.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:me.w(T.beforeText),afterText:T.afterText?me.w(T.afterText):void 0,previousLineText:T.previousLineText?me.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(me.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(V=>M.SyntaxTokenType.toString(V)):void 0}}static D(T){return T.map(me.C)}setLanguageConfiguration(T,V,G){const{wordPattern:Q}=G;if(Q&&(0,D.$Re)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(V,Q):this.h.setWordDefinitionFor(V,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const q=this.q(),_={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?me.w(G.wordPattern):void 0,indentationRules:G.indentationRules?me.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?me.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?me.D(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,V,_),this.p(q)}$setWordDefinitions(T){for(const V of T)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$Fdc=me}),define(Pe[257],Ae([1,0,3,8,7,31,12,6,23]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=void 0;class g{constructor(S,a,v,p){this.c=a,this.d=v,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$zK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,a){await this.a.$changeLanguage(S,a);const v=this.c.getDocumentData(S);if(!v)throw new Error(`document '${S.toString()}' NOT found`);return v.document}async tokenAtPosition(S,a){const v=S.version,p=L.Position.from(a),f=await this.a.$tokensAtPosition(S.uri,p),t={type:P.StandardTokenType.Other,range:S.getWordRangeAtPosition(a)??new P.$DK(a.line,a.character,a.line,a.character)};if(!f)return t;const i={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!i.range.contains(a)||v!==S.version?t:i}createLanguageStatusItem(S,a,v){const p=this.f++,f=this.a,t=this.g,i=`${S.identifier.value}/${a}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);t.add(i);const n={selector:v,id:a,name:S.displayName??S.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let u;const o=new $.$Qc,l=()=>{if(u?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${a}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}u=(0,R.$Yg)(()=>{o.clear(),this.a.$setLanguageStatus(p,{id:i,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===P.LanguageStatusSeverity.Error?M.default.Error:n.severity===P.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,o),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},r={dispose(){o.dispose(),u?.dispose(),f.$removeLanguageStatus(p),t.delete(i)},get id(){return n.id},get name(){return n.name},set name(s){n.name=s,l()},get selector(){return n.selector},set selector(s){n.selector=s,l()},get text(){return n.text},set text(s){n.text=s,l()},set text2(s){(0,D.$yF)(S,"languageStatusText"),n.text=s,l()},get text2(){return(0,D.$yF)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(s){n.detail=s,l()},get severity(){return n.severity},set severity(s){n.severity=s,l()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(s){n.accessibilityInformation=s,l()},get command(){return n.command},set command(s){n.command=s,l()},get busy(){return n.busy},set busy(s){n.busy=s,l()}};return l(),r}}e.$nec=g}),define(Pe[82],Ae([1,0,21,13,2,4,15,3,27,17]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=e.$cec=void 0;let A=class{constructor(a,v,p){this.f=p,this.d=new Map,this.a=v.getProxy($.$zK.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===E.$g}getMessage(a,v){const{message:p,args:f,comment:t}=v;if(this.c)return(0,L.$Ge)(p,f??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const n=this.d.get(a)?.contents[i];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,L.$Ge)(n??p,f??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let v;const p=await this.g(a);if(!p){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(p),t=JSON.parse(f);v=a.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${a.identifier.value} from ${p}: ${f.message}`);return}v&&this.d.set(a.identifier.value,{contents:v,uri:p})}async g(a){if(a.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return P.URI.revive(v)}return a.l10n?P.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$cec=A,e.$cec=A=Ke([Ve(0,D.$RM),Ve(1,g.$BM),Ve(2,R.$cj)],A),e.$dec=(0,M.$Uh)("IExtHostLocalizationService")}),define(Pe[258],Ae([1,0,15,3,27,17,2,52]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;let D=class extends E.$nj{constructor(S,a){super(a.logLevel,a.logsLocation,a.loggers.map(v=>(0,$.$rh)(v))),this.r=S.getProxy(L.$zK.MainThreadLogger)}$setLogLevel(S,a){a?this.setLogLevel(R.URI.revive(a),S):this.setLogLevel(S)}setVisibility(S,a){super.setVisibility(S,a),this.r.$setVisibility(S,a)}s(S,a,v){return new g(this.r,S,a,v)}};e.$Ffc=D,e.$Ffc=D=Ke([Ve(0,M.$BM),Ve(1,P.$RM)],D);class g extends E.$ij{constructor(S,a,v,p){super(p?.logLevel==="always"),this.r=S,this.s=a,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(a,p).then(()=>{this.u(this.n),this.m=!0})}g(S,a){const v=[[S,a]];this.m?this.u(v):this.n.push(...v)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Ae([1,0,3,4,6,17,24]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=e.$eec=void 0,e.$eec=(0,L.$Uh)("IExtHostManagedSockets");let $=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$zK.MainThreadManagedSockets)}setFactory(S,a){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new D(S,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const a=++this.b,v=await this.c.makeConnection(),p=new P.$Qc;return this.d.set(a,new g(a,v,p)),p.add((0,P.$Pc)(()=>this.d.delete(a))),p.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),p.dispose()})),p.add(v.onDidClose(f=>{this.a.$onDidManagedSocketClose(a,f?.stack??f?.message),p.dispose()})),p.add(v.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(a,R.$ee.wrap(f)))),a}$remoteSocketWrite(S,a){this.d.get(S)?.actual.send(a.buffer)}$remoteSocketEnd(S){const a=this.d.get(S);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$fec=$,e.$fec=$=Ke([Ve(0,M.$BM)],$);class D{constructor(S,a){this.socketFactoryId=S,this.makeConnection=a}}class g extends P.$Rc{constructor(S,a,v){super(),this.socketId=S,this.actual=a,this.B(v)}}}),define(Pe[259],Ae([1,0,3,15,23]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;function M($){return $&&$.title}let R=class{constructor(D,g){this.b=g,this.a=D.getProxy(E.$zK.MainThreadMessageService)}showMessage(D,g,A,S,a){const v={source:{identifier:D.identifier,label:D.displayName||D.name}};let p;typeof S=="string"||M(S)?p=[S,...a]:(v.modal=S?.modal,v.useCustom=S?.useCustom,v.detail=S?.detail,p=a),v.useCustom&&(0,P.$yF)(D,"resolvers");const f=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")f.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:u}=i;f.push({title:n,isCloseAffordance:!!u,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(g,A,v,f).then(t=>{if(typeof t=="number")return p[t]})}};e.$oec=R,e.$oec=R=Ke([Ve(1,L.$cj)],R)}),define(Pe[260],Ae([1,0,18,12,20,5,6,28,2,22,15,3,32,8,7,78,212,23,49]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=e.$kfc=void 0;let u=class{constructor(m,I,k,d,w){this.l=I,this.m=k,this.n=d,this.o=w,this.b=new $.$zc,this.c=new $.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Qd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=m.getProxy(S.$zK.MainThreadNotebookKernels);const y=new a.$2M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$ZM("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const W=this.m.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:W}}else if(C&&"notebookEditor"in C){const W=this.m.getIdByEditor(C.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return C})],a.$1M.Void);this.n.registerApiCommand(y)}createNotebookController(m,I,k,d,w,y){for(const be of this.i.values())if(be.controller.id===I&&g.$$l.equals(m.identifier,be.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const C=this.j++,W=this;this.o.trace(`NotebookController[${C}], CREATED by ${m.identifier.value}, ${I}`);const H=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${m.identifier}'`);let U=!1;const z=new M.$Qd,F=new M.$Qd,N={id:h(m.identifier,I),notebookType:k,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:d||m.identifier.value,preloads:y?y.map(v.NotebookRendererScript.from):[]};let x=w??H,J;this.a.$addKernel(C,N).catch(be=>{console.log(be),U=!0});let Ee=0;const De=()=>{if(U)return;const be=++Ee;Promise.resolve().then(()=>{be===Ee&&this.a.$updateKernel(C,N)})},Ce=new $.$zc,fe={get id(){return I},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return N.label},set label(be){N.label=be??m.displayName??m.name,De()},get detail(){return N.detail??""},set detail(be){N.detail=be,De()},get description(){return N.description??""},set description(be){N.description=be,De()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(be){N.supportedLanguages=be,De()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(be){N.supportsExecutionOrder=be,De()},get rendererScripts(){return N.preloads?N.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(be){x=be??H},get interruptHandler(){return J},set interruptHandler(be){J=be,N.supportsInterrupt=!!be,De()},createNotebookCellExecution(be){if(U)throw new Error("notebook controller is DISPOSED");if(!Ce.has(be.notebook.uri))throw W.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Ce.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${be.notebook.uri.toString()}`);return W._createNotebookCellExecution(be,h(m.identifier,this.id))},createNotebookExecution(be){if((0,i.$yF)(m,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!Ce.has(be.uri))throw W.o.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Ce.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${be.uri.toString()}`);return W._createNotebookExecution(be,h(m.identifier,this.id))},dispose:()=>{U||(this.o.trace(`NotebookController[${C}], DISPOSED`),U=!0,this.i.delete(C),z.dispose(),F.dispose(),this.a.$removeKernel(C))},updateNotebookAffinity(be,se){se===p.NotebookControllerAffinity2.Hidden&&(0,i.$yF)(m,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(C,be.uri,se)},onDidReceiveMessage:F.event,postMessage(be,se){return(0,i.$yF)(m,"notebookMessaging"),W.a.$postMessage(C,se&&W.m.getIdByEditor(se),be)},asWebviewUri(be){return(0,i.$yF)(m,"notebookMessaging"),(0,f.$bub)(be,W.l.remote)}};return this.i.set(C,{extensionId:m.identifier,controller:fe,onDidReceiveMessage:F,onDidChangeSelection:z,associatedNotebooks:Ce}),fe}getIdByController(m){for(const[I,k]of this.i)if(k.controller===m)return h(k.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,I){const k=this.f++,d=this;this.o.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(k,I);const w={dispose:()=>{this.e.delete(k),d.a.$removeKernelDetectionTask(k)}};return this.e.set(k,w),w}registerKernelSourceActionProvider(m,I,k){const d=this.h++,w=typeof k.onDidChangeNotebookKernelSourceActions=="function"?d:void 0,y=this;this.g.set(d,k),this.o.trace(`NotebookKernelSourceActionProvider[${d}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(d,d,I);let C;return w!==void 0&&(C=k.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(d),y.a.$removeKernelSourceActionProvider(d,d),C?.dispose()}}}async $provideKernelSourceActions(m,I){const k=this.g.get(m);if(k){const d=new R.$Qc;return(await k.provideNotebookKernelSourceActions(I)??[]).map(y=>v.NotebookKernelSourceAction.from(y,this.n.converter,d))}return[]}$acceptNotebookAssociation(m,I,k){const d=this.i.get(m);if(d){const w=this.m.getNotebookDocument(D.URI.revive(I));k?d.associatedNotebooks.set(w.uri,!0):d.associatedNotebooks.delete(w.uri),this.o.trace(`NotebookController[${m}] ASSOCIATE notebook`,w.uri.toString(),k),d.onDidChangeSelection.fire({selected:k,notebook:w.apiNotebook})}}async $executeCells(m,I,k){const d=this.i.get(m);if(!d)return;const w=this.m.getNotebookDocument(D.URI.revive(I)),y=[];for(const C of k){const W=w.getCell(C);W&&y.push(W.apiCell)}try{this.o.trace(`NotebookController[${m}] EXECUTE cells`,w.uri.toString(),y.length),await d.controller.executeHandler.call(d.controller,y,w.apiNotebook,d.controller)}catch(C){this.o.error(`NotebookController[${m}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(m,I,k){const d=this.i.get(m);if(!d)return;const w=this.m.getNotebookDocument(D.URI.revive(I));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,w.apiNotebook);else for(const y of k){const C=w.getCell(y);C&&this.b.get(C.uri)?.cancel()}if(d.controller.interruptHandler){const y=this.c.get(w.uri);k.length&&Array.isArray(y)&&y.length&&y.forEach(C=>C.dispose())}}$acceptKernelMessageFromRenderer(m,I,k){const d=this.i.get(m);if(!d)return;const w=this.m.getEditorById(I);d.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:k}))}$cellExecutionChanged(m,I,k){const w=this.m.getNotebookDocument(D.URI.revive(m)).getCell(I);if(w){const y=k?v.NotebookCellExecutionState.to(k):p.NotebookCellExecutionState.Idle;y!==void 0&&this.k.fire({cell:w.apiCell,state:y})}}_createNotebookCellExecution(m,I){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const d=this.m.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!d)throw new Error("invalid cell");if(this.b.has(d.uri))throw new Error(`duplicate execution for ${d.uri}`);const w=new l(I,d,this.a);this.b.set(d.uri,w);const y=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),y.dispose(),this.b.delete(d.uri))});return w.asApiObject()}_createNotebookExecution(m,I){const k=this.m.getNotebookDocument(m.uri),d=m.getCells().find(C=>{const W=k.getCellFromApiCell(C);return W&&this.b.has(W.uri)});if(d)throw new Error(`duplicate cell execution for ${d.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const w=new s(I,k,this.a),y=w.onDidChangeState(()=>{w.state===r.Resolved&&(w.dispose(),y.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[w,y]),w.asApiObject()}};e.$kfc=u,e.$kfc=u=Ke([Ve(4,A.$cj)],u);var o;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(o||(o={}));class l extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,k){super(),this.m=I,this.n=k,this.b=l.a++,this.c=new M.$Qd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new P.$1d),this.h=new c(10,d=>this.s(d)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const I=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new n.$wv(I))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let I=this.m;if(m&&(I=this.m.notebook.getCellFromApiCell(m)),!I)throw new Error("INVALID cell");return I.handle}y(m){return m.map(I=>{const k=p.$3L.ensureUniqueMimeTypes(I.items,!0);return k===I.items?v.NotebookCellOutput.from(I):v.NotebookCellOutput.from({items:k,id:I.id,metadata:I.metadata})})}async z(m,I,k){const d=this.w(I),w=this.y((0,E.$2b)(m));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:d,append:k,outputs:w})}async C(m,I,k){return m=p.$3L.ensureUniqueMimeTypes((0,E.$2b)(m),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:m.map(v.NotebookCellOutputItem.from),outputId:I.id,append:k})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(k){m.j=k,m.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(k){if(m.f===o.Resolved||m.f===o.Started)throw new Error("Cannot call start again");m.f=o.Started,m.c.fire(),m.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,d){if(m.f===o.Resolved)throw new Error("Cannot call resolve twice");m.f=o.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new n.$wv({runEndTime:d,lastRunSuccess:k}))},clearOutput(k){return m.t(),m.z([],k,!1)},appendOutput(k,d){return m.t(),m.z(k,d,!0)},replaceOutput(k,d){return m.t(),m.z(k,d,!1)},appendOutputItems(k,d){return m.t(),m.C(k,d,!0)},replaceOutputItems(k,d){return m.t(),m.C(k,d,!1)}})}}var r;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(r||(r={}));class s extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,I,k){super(),this.h=I,this.j=k,this.b=s.a++,this.c=new M.$Qd,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new P.$1d),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor(m,I){this.e=m,this.f=I,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new L.$hh,this.b=Date.now(),(0,L.$Xg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>m.complete())}}function h(b,m){return`${b.value}/${m}`}e.$lfc=h}),define(Pe[261],Ae([1,0,5,3,107]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class M{constructor($,D){this.c=D,this.a=new Map,this.b=$.getProxy(L.$zK.MainThreadNotebookRenderers)}$postRendererMessage($,D,g){const A=this.c.getEditorById($);this.a.get(D)?.fire({editor:A.apiEditor,message:g})}createRendererMessaging($,D){if(!$.contributes?.notebookRenderer?.some(A=>A.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(A,S,a)=>this.d(D).event(A,S,a),postMessage:(A,S)=>{P.$8ec.apiEditorsToExtHost.has(A)&&([A,S]=[S,A]);const a=S&&P.$8ec.apiEditorsToExtHost.get(S);return this.b.$postMessage(a?.id,D,A)}}}d($){let D=this.a.get($);return D||(D=new E.$Qd({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete($)}}),this.a.set($,D),D)}}e.$mfc=M}),define(Pe[262],Ae([1,0,6,16,2,23,3]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class ${constructor(g){this.b=new Map,this.a=g.getProxy(R.$zK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,A,S){if((0,M.$yF)(g,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,S),this.a.$registerProfileContentHandler(A,S.name,S.description,g.identifier.value),(0,E.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(g,A,S,a){const v=this.b.get(g);if(!v)throw new Error(`Unknown handler with id: ${g}`);return v.saveProfile(A,S,a)}async $readProfile(g,A,S){const a=this.b.get(g);if(!a)throw new Error(`Unknown handler with id: ${g}`);return a.readProfile((0,L.$Bf)(A)?A:P.URI.revive(A),S)}}e.$qfc=$}),define(Pe[263],Ae([1,0,2,3,12,8]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class R{static{this.a=0}constructor(D,g){this.d=g,this.c=new Map,this.b=D.getProxy(L.$zK.MainThreadQuickDiff)}$provideOriginalResource(D,g,A){const S=E.URI.revive(g),a=this.c.get(D);return a?(0,P.$Pg)(()=>a.provideOriginalResource(S,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(D,g,A,S){const a=R.a++;return this.c.set(a,g),this.b.$registerQuickDiffProvider(a,M.DocumentSelector.from(D,this.d),A,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$rfc=R}),define(Pe[264],Ae([1,0,20,5,6,3,2,7,11,18,31,45,23,8]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;function p(f,t,i){const n=f.getProxy(M.$zK.MainThreadQuickOpen);class u{constructor(I,k){this.e=new Map,this.f=0,this.a=I,this.b=k}showQuickPick(I,k,d,w=E.CancellationToken.None){this.c=void 0;const y=Promise.resolve(k),C=++this.f,W=n.$show(C,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},w),H={},U=W.then(()=>H);return Promise.race([U,y]).then(z=>{if(z===H)return;const F=(0,a.$xF)(I,"quickPickItemTooltip");return y.then(N=>{const x=[];for(let J=0;J<N.length;J++){const Ee=N[J];if(typeof Ee=="string")x.push({label:Ee,handle:J});else if(Ee.kind===$.QuickPickItemKind.Separator)x.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!F&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const De=Ee.iconPath?c(Ee.iconPath):void 0;x.push({label:Ee.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:F?v.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:J})}}return d&&typeof d.onDidSelectItem=="function"&&(this.c=J=>{d.onDidSelectItem(N[J])}),n.$setItems(C,x),W.then(J=>{if(typeof J=="number")return N[J];if(Array.isArray(J))return J.map(Ee=>N[Ee])})})}).then(void 0,z=>{if(!(0,D.$3)(z))return n.$setError(C,z),Promise.reject(z)})}$onItemSelected(I){this.c?.(I)}showInput(I,k=E.CancellationToken.None){return this.d=I?.validateInput,n.$input(I,typeof this.d=="function",k).then(void 0,d=>{if(!(0,D.$3)(d))return Promise.reject(d)})}async $validateInput(I){if(!this.d)return;const k=await this.d(I);if(!k||typeof k=="string")return k;let d;switch(k.severity){case $.InputBoxValidationSeverity.Info:d=A.default.Info;break;case $.InputBoxValidationSeverity.Warning:d=A.default.Warning;break;case $.InputBoxValidationSeverity.Error:d=A.default.Error;break;default:d=k.message?A.default.Error:A.default.Ignore;break}return{content:k.message,severity:d}}async showWorkspaceFolderPick(I,k=E.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!d)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(y=>y.uri.toString()===d.uri.toString())}createQuickPick(I){const k=new h(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(I){const k=new b(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(I,k){this.e.get(I)?._fireDidChangeValue(k)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,k){const d=this.e.get(I);d instanceof h&&d._fireDidChangeActive(k)}$onDidChangeSelection(I,k){const d=this.e.get(I);d instanceof h&&d._fireDidChangeSelection(k)}$onDidTriggerButton(I,k){this.e.get(I)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(I,k,d){const w=this.e.get(I);w instanceof h&&w._fireDidTriggerItemButton(k,d)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class o{static{this.a=1}constructor(I,k){this.x=I,this.y=k,this._id=h.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$Qd,this.q=new L.$Qd,this.r=new L.$Qd,this.s=new L.$Qd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((k,d)=>{const w=k===$.$VL.Back?-1:d;this.o.set(w,k)}),this.z({buttons:I.map((k,d)=>({...c(k.iconPath),tooltip:k.tooltip,handle:k===$.$VL.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const k=this.o.get(I);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(I){if(!this.v){for(const k of Object.keys(I)){const d=I[k];this.u[k]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function l(m){if(m instanceof $.$vL)return{id:m.id};const I=s(m),k=r(m);return{dark:typeof I=="string"?R.URI.file(I):I,light:typeof k=="string"?R.URI.file(k):k}}function r(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function c(m){const I=l(m);let k,d;return"id"in I?d=S.ThemeIcon.asClassName(I):k=I,{iconPath:k,iconClass:d}}class h extends o{constructor(I,k){super(I.identifier,k),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$Qd,this.L=[],this.M=new L.$Qd,this.N=new L.$Qd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((w,y)=>{this.C.set(y,w),this.D.set(w,y)});const k=(0,a.$xF)(this.O,"quickPickItemTooltip"),d=[];for(let w=0;w<I.length;w++){const y=I[w];if(y.kind===$.QuickPickItemKind.Separator)d.push({type:"separator",label:y.label});else{y.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const C=y.iconPath?c(y.iconPath):void 0;d.push({handle:w,label:y.label,iconPath:C?.iconPath,iconClass:C?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:k?v.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((W,H)=>({...c(W.iconPath),tooltip:W.tooltip,handle:H}))})}}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(I){const k=(0,g.$Gb)(I.map(d=>this.C.get(d)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(I){const k=(0,g.$Gb)(I.map(d=>this.C.get(d)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(I,k){const d=this.C.get(I);if(!d||!d.buttons||!d.buttons.length)return;const w=d.buttons[k];w&&this.N.fire({button:w,item:d})}}class b extends o{constructor(I,k){super(I.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:A.default.Error}):this.z({validationMessage:I.message,severity:I.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new u(t,i)}e.$sec=p}),define(Pe[265],Ae([1,0,2,5,67,6,12,3,18,138,15,22,45,8,23,14]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=void 0;function i(y){if(y)return typeof y.iconPath=="string"?E.URI.file(y.iconPath):E.URI.isUri(y.iconPath)||a.ThemeIcon.isThemeIcon(y.iconPath)?y.iconPath:void 0}function n(y){if(y?.icon){if(E.URI.isUri(y.icon))return y.icon;if(a.ThemeIcon.isThemeIcon(y.icon))return y.icon;{const C=y.icon;return{light:C.light,dark:C.dark}}}else return}function u(y){if(y.icon){if(E.URI.isUri(y.icon))return y.icon;if(a.ThemeIcon.isThemeIcon(y.icon))return y.icon;{const C=y.icon;return{light:C.light,dark:C.dark}}}else return}function o(y,C){if(!y.iconPath&&!C.iconPath)return 0;if(y.iconPath){if(!C.iconPath)return 1}else return-1;const W=typeof y.iconPath=="string"?y.iconPath:E.URI.isUri(y.iconPath)?y.iconPath.fsPath:y.iconPath.id,H=typeof C.iconPath=="string"?C.iconPath:E.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,g.$wq)(W,H)}function l(y,C){let W=0;if(y.strikeThrough!==C.strikeThrough)return y.strikeThrough?1:-1;if(y.faded!==C.faded)return y.faded?1:-1;if(y.tooltip!==C.tooltip)return(y.tooltip||"").localeCompare(C.tooltip||"");if(W=o(y,C),W!==0)return W;if(y.light&&C.light)W=o(y.light,C.light);else{if(y.light)return 1;if(C.light)return-1}if(W!==0)return W;if(y.dark&&C.dark)W=o(y.dark,C.dark);else{if(y.dark)return 1;if(C.dark)return-1}return W}function r(y,C){if(y.command!==C.command)return y.command<C.command?-1:1;if(y.title!==C.title)return y.title<C.title?-1:1;if(y.tooltip!==C.tooltip){if(y.tooltip!==void 0&&C.tooltip!==void 0)return y.tooltip<C.tooltip?-1:1;if(y.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(y.arguments===C.arguments)return 0;if(y.arguments)if(C.arguments){if(y.arguments.length!==C.arguments.length)return y.arguments.length-C.arguments.length}else return 1;else return-1;for(let W=0;W<y.arguments.length;W++){const H=y.arguments[W],U=C.arguments[W];if(H!==U)return H<U?-1:1}return 0}function s(y,C){let W=(0,g.$wq)(y.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(W!==0)return W;if(y.command&&C.command)W=r(y.command,C.command);else{if(y.command)return 1;if(C.command)return-1}if(W!==0)return W;if(y.decorations&&C.decorations)W=l(y.decorations,C.decorations);else{if(y.decorations)return 1;if(C.decorations)return-1}return W}function c(y,C){for(let W=0;W<y.length;W++)if(y[W]!==C[W])return!1;return!0}function h(y,C){return y.command===C.command&&y.title===C.title&&y.tooltip===C.tooltip&&(y.arguments&&C.arguments?c(y.arguments,C.arguments):y.arguments===C.arguments)}function b(y,C){return(0,D.$tb)(y,C,h)}function m(y,C){return y===C?!0:!y||!C?!1:y.id===C.id&&y.label===C.label&&y.upstream?.id===C.upstream?.id&&y.upstream?.label===C.upstream?.label}class I{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,p.$yF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,p.$yF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,p.$yF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,p.$yF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=C;const W=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:n(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,W??null)}get document(){return(0,p.$yF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,W,H,U,z,F){this.m=C,this.n=W,this.o=z,this.p=F,this.d="",this.e=new L.$Qd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=H,this.#e=U}showValidationMessage(C,W){(0,p.$yF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,W)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$tec=I;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,W,H,U,z){this.q=C,this.s=W,this.t=H,this.u=U,this.v=z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$Qd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$Qd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,W){const H=this.h.get(C);return H?(0,R.$Pg)(()=>this.s.executeCommand(H.command,...H.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(s),H=(0,D.$Cb)(this.o,C,s).map(F=>{const N=F.toInsert.map(x=>{const J=this.e++;this.g.set(J,x);const Ee=x.resourceUri;let De;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"||x.command.command==="vscode.changes"){const pe=new M.$Qc;De=this.s.converter.toInternal(x.command,pe),this.j.set(J,pe)}else this.h.set(J,x.command);const Ce=i(x.decorations),fe=x.decorations&&i(x.decorations.light)||Ce,be=x.decorations&&i(x.decorations.dark)||Ce,se=[fe,be],Re=x.decorations&&x.decorations.tooltip||"",oe=x.decorations&&!!x.decorations.strikeThrough,X=x.decorations&&!!x.decorations.faded,j=x.contextValue||"";return{rawResource:[J,Ee,se,Re,oe,X,j,De],handle:J}});return{start:F.start,deleteCount:F.deleteCount,toInsert:N}}),U=H.map(({start:F,deleteCount:N,toInsert:x})=>[F,N,x.map(J=>J.rawResource)]),z=H.reverse();for(const{start:F,deleteCount:N,toInsert:x}of z){const J=x.map(De=>De.handle),Ee=this.n.splice(F,N,...J);for(const De of Ee)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=C,U}dispose(){this.l=!0,this.m.fire()}}class d{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let W;(0,p.$xF)(this.y,"quickDiffProvider")&&(W=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:W})}get historyProvider(){return(0,p.$yF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,p.$yF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{m(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,p.$yF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const W=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,W??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new M.$Qc,this.p=C;const W=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:W})}get actionButton(){return(0,p.$yF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,p.$yF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=C;const W=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(H=>H.map(U=>this.z.converter.toInternal(U,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:W??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&b(this.u,C))return;this.t.value=new M.$Qc,this.u=C;const W=(C||[]).map(H=>this.z.converter.toInternal(H,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:W})}get selected(){return this.v}constructor(C,W,H,U,z,F,N){this.y=C,this.z=U,this.A=z,this.B=F,this.C=N,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new L.$Qd,this.onDidChangeSelection=this.w.event,this.x=d.d++,this.D=new Map,this.E=new Set,this.#e=H;const x=E.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${z}/scm${this.x}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this.f=new I(C,U,W,this.#e,this.x,x),this.#e.$registerSourceControl(this.x,z,F,N,x)}createResourceGroup(C,W){const H=new k(this.#e,this.z,this.x,C,W),U=L.Event.once(H.onDidDispose)(()=>this.D.delete(H));return this.D.set(H,U),this.eventuallyAddResourceGroups(),H}eventuallyAddResourceGroups(){const C=[],W=[];for(const[H,U]of this.D){U.dispose();const z=H.onDidUpdateResourceStates(()=>{this.E.add(H),this.eventuallyUpdateResourceStates()});L.Event.once(H.onDidDispose)(()=>{this.E.delete(H),z.dispose(),this.e.delete(H.handle),this.#e.$unregisterGroup(this.x,H.handle)}),C.push([H.handle,H.id,H.label,H.features]);const F=H._takeResourceStateSnapshot();F.length>0&&W.push([H.handle,F]),this.e.set(H.handle,H)}this.#e.$registerGroups(this.x,C,W),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(W=>{const H=W._takeResourceStateSnapshot();H.length!==0&&C.push([W.handle,H])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$nh)(100)],d.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$nh)(100)],d.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(C,W,H,U){this.l=W,this.m=H,this.n=U,this.g=new Map,this.h=new S.$am,this.j=new L.$Qd,this.e=C.getProxy($.$zK.MainThreadSCM),this.f=C.getProxy($.$zK.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:z=>{if(z&&z.$mid===3){const F=this.g.get(z.sourceControlHandle);if(!F)return z;const N=F.getResourceGroup(z.groupHandle);return N?N.getResourceState(z.handle):z}else if(z&&z.$mid===4){const F=this.g.get(z.sourceControlHandle);return F?F.getResourceGroup(z.groupHandle):z}else if(z&&z.$mid===5){const F=this.g.get(z.handle);return F||z}return z}})}createSourceControl(C,W,H,U){this.n.trace("ExtHostSCM#createSourceControl",C.identifier.value,W,H,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const z=t.d++,F=new d(C,this.m,this.e,this.l,W,H,U);this.g.set(z,F);const N=this.h.get(C.identifier)||[];return N.push(F),this.h.set(C.identifier,N),F}getLastInputBox(C){this.n.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const W=this.h.get(C.identifier),H=W&&W[W.length-1];return H&&H.inputBox}$provideOriginalResource(C,W,H){const U=E.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",C,U.toString());const z=this.g.get(C);return!z||!z.quickDiffProvider||!z.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Pg)(()=>z.quickDiffProvider.provideOriginalResource(U,H)).then(F=>F||null)}$onInputBoxValueChange(C,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",C);const H=this.g.get(C);return H&&H.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(C,W,H,U){this.n.trace("ExtHostSCM#$executeResourceCommand",C,W,H);const z=this.g.get(C);if(!z)return Promise.resolve(void 0);const F=z.getResourceGroup(W);return F?F.$executeResourceCommand(H,U):Promise.resolve(void 0)}$validateInput(C,W,H){this.n.trace("ExtHostSCM#$validateInput",C);const U=this.g.get(C);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Pg)(()=>U.inputBox.validateInput(W,H)).then(z=>{if(!z)return Promise.resolve(void 0);const F=v.MarkdownString.fromStrict(z.message);return F?Promise.resolve([F,z.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.g.get(C)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,W,H){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupBase(W,H)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,W,H,U){return await this.g.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,H,U)??void 0}async $provideHistoryItems(C,W,H,U){return(await this.g.get(C)?.historyProvider?.provideHistoryItems(W,H,U))?.map(N=>({...N,icon:u(N)}))??void 0}async $provideHistoryItemChanges(C,W,H){return await this.g.get(C)?.historyProvider?.provideHistoryItemChanges(W,H)??void 0}};e.$uec=w,e.$uec=w=t=Ke([Ve(3,A.$cj)],w)}),define(Pe[84],Ae([1,0,3,5,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=void 0;class M{constructor($){this.b=new L.$Qd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(E.$zK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,D){return this.a.$getPassword($,D)}store($,D,g){return this.a.$setPassword($,D,g)}delete($,D){return this.a.$deletePassword($,D)}}e.$_dc=M,e.$aec=(0,P.$Uh)("IExtHostSecretState")}),define(Pe[266],Ae([1,0,3,8,2]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class M{static{this.a=0}constructor($,D){this.d=D,this.c=new Map,this.b=$.getProxy(E.$zK.MainThreadShare)}async $provideShare($,D,g){return await this.c.get($)?.provideShare({selection:L.Range.to(D.selection),resourceUri:P.URI.revive(D.resourceUri)},g)??void 0}registerShareProvider($,D){const g=M.a++;return this.c.set(g,D),this.b.$registerShareProvider(g,L.DocumentSelector.from($,this.d),D.id,D.label,D.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$wfc=M}),define(Pe[267],Ae([1,0,20,6,3]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(P.$zK.MainThreadSpeech)}async $createSpeechToTextSession($,D){const g=this.c.get($);if(!g)return;const A=new L.$Qc,S=new E.$1d;this.d.set(D,S);const a=A.add(g.provideSpeechToTextSession(S.token));A.add(a.onDidChange(v=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(D,v)})),A.add(S.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,D,g){const A=M.a++;return this.c.set(A,g),this.b.$registerProvider(A,D,{extension:$,displayName:$.value}),(0,L.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$yfc=M}),define(Pe[268],Ae([1,0,7,3,165,6,8,16]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=void 0;class D{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$wL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$wL("statusBarItem.warningForeground")]])}#e;#t;constructor(a,v,p,f,t,i=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=a,this.#t=v,t&&f){this.c=(0,E.$_K)(f.identifier,t);const u=p.get(this.c);u&&(i=u.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=u.priority,this.j=!0,this.name=u.name,this.text=u.text,this.tooltip=u.tooltip,this.command=u.command,this.accessibilityInformation=u.accessibilityInformation)}else this.c=String(D.a++);this.e=f,this.f=t,this.g=i,this.h=this.u(n)}u(a){if((0,$.$Ff)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!D.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let v;this.m?v=this.m:v=(0,P.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=D.b.get(this.o.id));const f=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,v,this.k,f,this.r?.internal,p,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$vec=D;class g{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const v={message:a};return this.b.unshift(v),this.c(),new E.$BK(()=>{const p=this.b.indexOf(v);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(a,v){this.e=new Map,this.a=a.getProxy(L.$zK.MainThreadStatusBar),this.b=v,this.c=new g(this)}$acceptStaticEntries(a){for(const v of a)this.e.set(v.entryId,v)}createStatusBarEntry(a,v,p,f){return new D(this.a,this.b,this.e,a,v,p,f)}setStatusBarMessage(a,v){const p=this.c.setMessage(a);let f;return typeof v=="number"?f=setTimeout(()=>p.dispose(),v):typeof v<"u"&&v.then(()=>p.dispose(),()=>p.dispose()),new E.$BK(()=>{p.dispose(),clearTimeout(f)})}}e.$wec=A}),define(Pe[85],Ae([1,0,3,5,4]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=e.$Zdc=void 0;class M{constructor($,D){this.c=D,this.b=new L.$Qd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(E.$zK.MainThreadStorage)}registerExtensionStorageKeysToSync($,D){this.a.$registerExtensionStorageKeysToSync($,D)}async initializeExtensionStorage($,D,g){const A=await this.a.$initializeExtensionStorage($,D);let S;return A&&(S=this.d($,D,A)),S||g}setValue($,D,g){return this.a.$setValue($,D,g)}$acceptValue($,D,g){const A=this.d($,D,g);A&&this.b.fire({shared:$,key:D,value:A})}d($,D,g){try{return JSON.parse(g)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${$}): ${A}`)}}}e.$Zdc=M,e.$1dc=(0,P.$Uh)("IExtHostStorage")}),define(Pe[86],Ae([1,0,4,27,15,64,2]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=void 0,e.$6dc=(0,E.$Uh)("IExtensionStoragePaths");let $=class{constructor(g,A,S){this.d=A,this.f=S,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(g){return R.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,A=await this.g(g);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(g){if(this.c)return R.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return R.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$7dc=$,e.$7dc=$=Ke([Ve(0,L.$RM),Ve(1,P.$cj),Ve(2,M.$5dc)],$)}),define(Pe[65],Ae([1,0,5,3,4,2,17,6,7,167,11,195,20,38,196,45,12,8,32]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=e.$0dc=e.$9dc=e.$8dc=void 0,e.$8dc=(0,P.$Uh)("IExtHostTerminalService");class u{constructor(d,w,y,C){this.l=d,this._id=w,this.m=y,this.n=C,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(H=>this.f=H);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(H,U=!0){W.q(),W.l.$sendText(W._id,H,U)},show(H){W.q(),W.l.$show(W._id,H)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(d,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??w?.cwd??void 0,env:d.env??void 0,icon:b(d.iconPath)??void 0,color:f.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(d.location,w?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,w,y,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:y,color:f.ThemeColor.isThemeColor(C)?C.id:void 0,location:this.o(d,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(d,w){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in d?{viewColumn:i.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.n=d}setExitStatus(d,w){this.h=Object.freeze({code:d,reason:w})}setDimensions(d,w){return d===this.d&&w===this.g||d===0||w===0?!1:(this.d=d,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(d){this.k=d}_setProcessId(d){this.f?(this.f(d),this.f=void 0):this.b.then(w=>{w!==d&&(this.b=Promise.resolve(d))})}}e.$9dc=u;class o{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new E.$Qd,this.onProcessData=this.a.event,this.b=new E.$Qd,this.d=new E.$Qd,this.onDidChangeProperty=this.d.event,this.f=new E.$Qd,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,w){this.g.setDimensions?.({columns:d,rows:w})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,r=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,w,y){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Qd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Qd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Qd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Qd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Qd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Qd,this.onDidChangeShell=this.N.event,this.O=new E.$Qd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Qd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(L.$zK.MainThreadTerminalService),this.y=new p.$qqb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:C=>{const W=H=>{const U=H;return this.W(U.instanceId)?.value};switch(C?.$mid){case 15:return W(C);default:{if(Array.isArray(C))for(let H=0;H<C.length&&C[H].$mid===15;H++)C[H]=W(C[H]);return C}}}}),this.B({dispose:()=>{for(const[C,W]of this.g)W.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,w){const y=new u(this.a,(0,v.$hg)(),d,d.name),C=new o(d.pty);return y.createExtensionTerminal(d.location,this.R(d,w).resolvedExtHostIdentifier,b(d.iconPath),m(d.color)).then(W=>{const H=this.S(W,C);this.h[W]=H}),this.f.push(y),y.value}R(d,w){if(w=w||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const y=d.location.parentTerminal;if(y){const C=this.f.find(W=>W.value===y);C&&(w.resolvedExtHostIdentifier=C._id)}}else d.location&&typeof d.location!="object"?w.location=d.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(d,w){if(!this.W(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const C=new o(w),W=this.S(d,C);this.h[d]=W}async $acceptActiveTerminalChanged(d){const w=this.b;if(d===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const y=this.W(d);y&&(this.b=y,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,w){const y=this.W(d);y&&this.O.fire({terminal:y.value,data:w})}async $acceptTerminalDimensions(d,w,y){const C=this.W(d);C&&C.setDimensions(w,y)&&this.L.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptDidExecuteCommand(d,w){const y=this.W(d);y&&this.P.fire({terminal:y.value,...w})}async $acceptTerminalMaximumDimensions(d,w,y){this.g.get(d)?.resize(w,y)}async $acceptTerminalTitleChange(d,w){const y=this.W(d);y&&(y.name=w)}async $acceptTerminalClosed(d,w,y){const C=this.Y(this.f,d);if(C!==null){const W=this.f.splice(C,1)[0];W.setExitStatus(w,y),this.H.fire(W.value)}}$acceptTerminalOpened(d,w,y,C){if(w){const U=this.Y(this.f,w);if(U!==null){this.f[U]._id=d,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const W={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:M.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},H=new u(this.a,d,W,y);this.f.push(H),this.I.fire(H.value),H.isOpen=!0}async $acceptTerminalProcessId(d,w){this.W(d)?._setProcessId(w)}async $startExtensionTerminal(d,w){const y=this.W(d);if(!y)return{message:(0,g.localize)(0,null,d)};y.isOpen||await new Promise(W=>{const H=this.onDidOpenTerminal(async U=>{U===y.value&&(H.dispose(),W())})});const C=this.g.get(d);C?C.startSendingEvents(w):this.j[d]={initialDimensions:w}}S(d,w){const y=new $.$Qc;y.add(w.onProcessReady(W=>this.a.$sendProcessReady(d,W.pid,W.cwd,W.windowsPty))),y.add(w.onDidChangeProperty(W=>this.a.$sendProcessProperty(d,W))),this.y.startBuffering(d,w.onProcessData),y.add(w.onProcessExit(W=>this.U(d,W))),this.g.set(d,w);const C=this.j[d];return C&&w instanceof o&&(w.startSendingEvents(C.initialDimensions),delete this.j[d]),y}$acceptProcessAckDataEvent(d,w){this.g.get(d)?.acknowledgeDataEvent(w)}$acceptProcessInput(d,w){this.g.get(d)?.input(w)}$acceptTerminalInteraction(d){const w=this.W(d);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(d,w){this.W(d)?.setSelection(w)}$acceptProcessResize(d,w,y){try{this.g.get(d)?.resize(w,y)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(d,w){this.g.get(d)?.shutdown(w)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(d,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(w=>this.a.$sendProcessProperty(d,{type:"cwd",value:w}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new D.$BK(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,w,y){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,y),this.a.$registerProfileProvider(w,d.identifier.value),new D.$BK(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(d,w,y){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,y),this.a.$registerQuickFixProvider(d,w),new D.$BK(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,w){const y=new a.$1d().token;if(y.isCancellationRequested)return;const C=this.D.get(d);if(!C)return;const W=await C.provideTerminalQuickFixes(w,y);if(W===null||Array.isArray(W)&&W.length===0)return;const H=new $.$Qc;if(this.w.value=H,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.Q.converter,H):void 0;const U=[];for(const z of W){const F=i.TerminalQuickFix.from(z,this.Q.converter,H);F&&U.push(F)}return U}async $createContributedProfileTerminal(d,w){const y=new a.$1d().token;let C=await this.C.get(d)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(C&&!("options"in C)&&(C={options:C}),!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,w);return}this.createTerminalFromOptions(C.options,w)}}async $provideLinks(d,w){const y=this.W(d);if(!y)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const W=new a.$1d;this.G.set(d,W);const H=[],U={terminal:y.value,line:w},z=[];for(const x of this.z)z.push(t.Promises.withAsyncBody(async J=>{W.token.onCancellationRequested(()=>J({provider:x,links:[]}));const Ee=await x.provideTerminalLinks(U,W.token)||[];W.token.isCancellationRequested||J({provider:x,links:Ee})}));const F=await Promise.all(z);if(W.token.isCancellationRequested)return[];const N=new Map;for(const x of F)x&&x.links.length>0&&H.push(...x.links.map(J=>{const Ee={id:l++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return N.set(Ee.id,{provider:x.provider,link:J}),Ee}));return this.F.set(d,N),H}$activateLink(d,w){const y=this.F.get(d)?.get(w);y&&y.provider.handleTerminalLink(y.link)}U(d,w){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const y=this.h[d];y&&(y.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,w)}W(d){return this.X(this.f,d)}X(d,w){const y=this.Y(d,w);return y!==null?d[y]:null}Y(d,w){const y=d.findIndex(C=>C._id===w);return y===-1?null:y}getEnvironmentVariableCollection(d){let w=this.n.get(d.identifier.value);return w||(w=new s,this.$(d.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(d,w){const y=(0,S.$qr)(w.map),C=(0,S.$rr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(d,w.persistent,y.length===0?void 0:y,C)}$initEnvironmentVariableCollections(d){d.forEach(w=>{const y=w[0],C=new s(w[1]);this.$(y,C)})}$acceptDefaultProfile(d,w){const y=this.s;this.s=d,this.u=w,y?.path!==d.path&&this.N.fire(d.path)}$(d,w){this.n.set(d,w),w.onDidChangeCollection(()=>{this.Z(d,w)})}};e.$0dc=r,e.$0dc=r=Ke([Ve(1,n.$XM),Ve(2,R.$BM)],r);class s{get persistent(){return this.b}set persistent(d){this.b=d,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(d){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Qd,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const w=this.h(d);let y=this.a.get(w);return y||(y=new c(this,d),this.a.set(w,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(d,w,y,C){this.f(d,{value:w,type:D.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:C})}append(d,w,y,C){this.f(d,{value:w,type:D.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:C})}prepend(d,w,y,C){this.f(d,{value:w,type:D.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:C})}f(d,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(d,w.scope),C=this.map.get(y),W=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!C||C.value!==w.value||C.type!==w.type||C.options?.applyAtProcessCreation!==W.applyAtProcessCreation||C.options?.applyAtShellIntegration!==W.applyAtShellIntegration||C.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const H=this.g(d,w.scope),U={variable:d,...w,options:W};this.map.set(H,U),this.d.fire()}}get(d,w){const y=this.g(d,w),C=this.map.get(y);return C?I(C):void 0}g(d,w){const y=this.h(w);return y.length?`${d}:::${y}`:d}h(d){return this.j(d?.workspaceFolder)??""}j(d){return d?d.uri.toString():void 0}getVariableMap(d){const w=new Map;for(const[y,C]of this.map)this.h(C.scope)===this.h(d)&&w.set(C.variable,I(C));return w}delete(d,w){const y=this.g(d,w);this.map.delete(y),this.d.fire()}clear(d){if(d?.workspaceFolder){for(const[w,y]of this.map)y.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(w);this.k(d)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(d,w){const y=this.h(w),C=this.descriptionMap.get(y);if(!C||C.description!==d){let W;typeof d=="string"?W=d:W=d?.value.split(`

`)[0];const H={description:W,scope:w};this.descriptionMap.set(y,H),this.d.fire()}}getDescription(d){const w=this.h(d);return this.descriptionMap.get(w)?.description}k(d){const w=this.h(d);this.descriptionMap.delete(w)}}class c{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,w){this.b=d,this.d=w,this.a=new E.$Qd}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,w,y){this.b.replace(d,w,y,this.d)}append(d,w,y){this.b.append(d,w,y,this.d)}prepend(d,w,y){this.b.prepend(d,w,y,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,w){this.b.getVariableMap(this.d).forEach((y,C)=>d.call(w,C,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let h=class extends r{constructor(d,w){super(!1,d,w)}createTerminal(d,w,y){throw new A.$$}createTerminalFromOptions(d,w){throw new A.$$}};e.$$dc=h,e.$$dc=h=Ke([Ve(0,n.$XM),Ve(1,R.$BM)],h);function b(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function m(k){return f.ThemeColor.isThemeColor(k)?k:void 0}function I(k){const d={...k};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Pe[269],Ae([1,0,300,12,24,20,5,220,97,6,26,16,38,3,17,108,8,7,48,77,60,23]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.$hfc=e.$gfc=e.$ffc=void 0;let r=class extends g.$Rc{constructor(U,z,F){super(),this.u=F,this.f=this.B(new R.$Qd),this.g=new Map,this.s=this.B(new R.$Qd),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(v.$zK.MainThreadTesting),this.m=new y(this.h),this.j=new b(this.h),z.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const x=N,J=x.tests[x.tests.length-1].item.extId;return this.g.get(n.$pJ.root(J))?.collection.tree.get(J)?.actual??(0,f.$NM)(N)}case 18:{const{extId:x,message:J}=N;return{test:this.g.get(n.$pJ.root(x))?.collection.tree.get(x)?.actual,message:t.TestMessage.to(J)}}default:return N}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await z.executeCommand("_testing.getExplorerSelection"),x=J=>{const Ee=this.g.get(n.$pJ.root(J));if(Ee)return n.$pJ.isRoot(J)?Ee.controller:Ee.collection.tree.get(J)?.actual};return{include:N?.include.map(x).filter(S.$Jf)||[],exclude:N?.exclude.map(x).filter(S.$Jf)||[]}})}createTestController(U,z,F,N){if(this.g.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const x=new g.$Qc,J=x.add(new f.$QM(z,F,this.u));J.root.label=F;const Ee=new Map,De=new Set,Ce=this.h,fe={items:J.root.children,get label(){return F},set label(se){F=se,J.root.label=se,Ce.$updateController(z,{label:F})},get refreshHandler(){return N},set refreshHandler(se){N=se,Ce.$updateController(z,{canRefresh:!!se})},get id(){return z},createRunProfile:(se,Re,oe,X,j,ne)=>{let pe=(0,D.$Ii)(se);for(;Ee.has(pe);)pe++;return new C(this.h,Ee,U,De,this.s.event,z,pe,se,Re,oe,X,j,ne)},createTestItem(se,Re,oe){return new f.$OM(z,se,Re,oe)},createTestRun:(se,Re,oe=!0)=>this.j.createTestRun(U,z,J,se,Re,oe),invalidateTestResults:se=>{if(se===void 0)this.h.$markTestRetired(void 0);else{const Re=se instanceof Array?se:[se];this.h.$markTestRetired(Re.map(oe=>n.$pJ.fromExtHostTestItem(oe,z).toString()))}},set resolveHandler(se){J.resolveHandler=se},get resolveHandler(){return J.resolveHandler},dispose:()=>{x.dispose()}};Ce.$registerTestController(z,F,!!N),x.add((0,g.$Pc)(()=>Ce.$unregisterTestController(z)));const be={controller:fe,collection:J,profiles:Ee,extension:U,activeProfiles:De};return this.g.set(z,be),x.add((0,g.$Pc)(()=>this.g.delete(z))),x.add(J.onDidGenerateDiff(se=>Ce.$publishDiff(z,se.map(o.TestsDiffOp.serialize)))),fe}createTestObserver(){return this.m.checkout()}async runTests(U,z=M.CancellationToken.None){const F=m(U);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.g.get(F.controllerId);if(!N)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(x=>n.$pJ.fromExtHostTestItem(x,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:W[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:U.exclude?.map(x=>x.id)},z)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,z,F){return(0,E.$qb)(this.j.trackers,x=>x.id===U?x.getCoverage(z):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(U,z,F,N){return(0,E.$qb)(this.j.trackers,J=>J.id===U?J.getCoverage(z):void 0)?.resolveFileCoverage(F,N)??Promise.resolve([])}$configureRunProfile(U,z){this.g.get(U)?.profiles.get(z)?.configureHandler?.()}$setActiveRunProfiles(U){const z=new Map;for(const[F,N]of Object.entries(U)){const x=this.g.get(F);if(!x)continue;const J=new Map,Ee=N.filter(Ce=>!x.activeProfiles.has(Ce)),De=[...x.activeProfiles].filter(Ce=>!N.includes(Ce));for(const Ce of Ee)J.set(Ce,!0),x.activeProfiles.add(Ce);for(const Ce of De)J.set(Ce,!1),x.activeProfiles.delete(Ce);J.size&&z.set(F,J)}this.s.fire(z)}async $refreshTests(U,z){await this.g.get(U)?.controller.refreshHandler?.(z)}$publishTestResults(U){this.results=Object.freeze(U.map(z=>(0,A.$an)(t.TestResults.to(z))).concat(this.results).sort((z,F)=>F.completedAt-z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,z){const F=this.g.get(n.$pJ.fromString(U).controllerId)?.collection;F&&(await F.expand(U,z<0?1/0:z),F.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(o.TestsDiffOp.deserialize))}async $runControllerTests(U,z){return Promise.all(U.map(F=>this.w(F,!1,z)))}async $startContinuousRun(U,z){const F=new M.$1d(z),N=await Promise.all(U.map(x=>this.w(x,!0,F.token)));return!z.isCancellationRequested&&!N.some(x=>x.error)&&await new Promise(x=>z.onCancellationRequested(x)),F.dispose(!0),N}async w(U,z,F){const N=this.g.get(U.controllerId);if(!N)return{};const{collection:x,profiles:J,extension:Ee}=N,De=J.get(U.profileId);if(!De)return{};const Ce=U.testIds.map(Re=>x.tree.get(Re)).filter(S.$Jf),fe=U.excludeExtIds.map(Re=>N.collection.tree.get(Re)).filter(S.$Jf).filter(Re=>Ce.some(oe=>oe.fullId.compare(Re.fullId)===2));if(!Ce.length)return{};const be=new i.$0L(Ce.some(Re=>Re.actual instanceof f.$PM)?void 0:Ce.map(Re=>Re.actual),fe.map(Re=>Re.actual),De,z),se=(0,o.$rJ)(U)&&this.j.prepareForMainThreadTestRun(be,I.fromInternal(U,N.collection),Ee,F);try{return await De.runHandler(be,F),{}}catch(Re){return{error:String(Re)}}finally{se&&(se.hasRunningTasks&&!F.isCancellationRequested&&await R.Event.toPromise(se.onEnd),se.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$ffc=r,e.$ffc=r=Ke([Ve(0,p.$BM)],r);const s=1e4;var c;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(c||(c={}));class h extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(U,z,F){super(),this.m=U,this.s=z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Qd),this.onEnd=this.j.event,this.h=this.B(new M.$1d(F));const N=this.B(new L.$9g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>N.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const z=this.m.id,F=this.m.controllerId,N=(0,a.$hg)(),x=new k(this.s,z,N),J=fe=>(be,...se)=>{if(De){console.warn(`Setting the state of test "${be.id}" is a no-op after the run ends.`);return}this.m.isIncluded(be)&&(this.y(be),fe(be,...se))},Ee=(fe,be)=>{const se=be instanceof Array?be.map(t.TestMessage.from):[t.TestMessage.from(be)];if(fe.uri&&fe.range){const Re={range:t.Range.from(fe.range),uri:fe.uri};for(const oe of se)oe.location=oe.location||Re}this.s.$appendTestMessagesInRun(z,N,n.$pJ.fromExtHostTestItem(fe,F).toString(),se)};let De=!1;const Ce={isPersisted:this.m.isPersisted,token:this.h.token,name:U,get coverageProvider(){return x.coverageProvider},set coverageProvider(fe){x.coverageProvider=fe},enqueued:J(fe=>{this.s.$updateTestStateInRun(z,N,n.$pJ.fromExtHostTestItem(fe,F).toString(),1)}),skipped:J(fe=>{this.s.$updateTestStateInRun(z,N,n.$pJ.fromExtHostTestItem(fe,F).toString(),5)}),started:J(fe=>{this.s.$updateTestStateInRun(z,N,n.$pJ.fromExtHostTestItem(fe,F).toString(),2)}),errored:J((fe,be,se)=>{Ee(fe,be),this.s.$updateTestStateInRun(z,N,n.$pJ.fromExtHostTestItem(fe,F).toString(),6,se)}),failed:J((fe,be,se)=>{Ee(fe,be),this.s.$updateTestStateInRun(z,N,n.$pJ.fromExtHostTestItem(fe,F).toString(),4,se)}),passed:J((fe,be)=>{this.s.$updateTestStateInRun(z,N,n.$pJ.fromExtHostTestItem(fe,this.m.controllerId).toString(),3,be)}),appendOutput:(fe,be,se)=>{De||(se&&(this.m.isIncluded(se)?this.y(se):se=void 0),this.s.$appendOutputToRun(z,N,P.$ee.fromString(fe),be&&t.location.from(be),se&&n.$pJ.fromExtHostTestItem(se,F).toString()))},end:()=>{De||(De=!0,this.s.$finishedTestRunTask(z,N),this.f.delete(N),this.f.size||this.w())}};return this.f.set(N,{run:Ce,coverage:x}),this.s.$startedTestRunTask(z,{id:N,name:U,running:!0}),Ce}u(){for(const{run:U}of this.f.values())U.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(U){if(!(U instanceof f.$OM))throw new u.$tM(U.id);if(this.g.has(n.$pJ.fromExtHostTestItem(U,this.m.controllerId).toString()))return;const z=[],F=this.m.colllection.root;for(;;){const N=t.TestItem.from(U);if(z.unshift(N),this.g.has(N.extId)||(this.g.add(N.extId),U===F))break;U=U.parent||F}this.s.$addTestsToRun(this.m.controllerId,this.m.id,z)}dispose(){this.w(),super.dispose()}}class b{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,z,F,N){return this.f(U,z,F,N)}cancelRunById(U){for(const z of this.c.values())if(z.id===U){z.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,z,F,N,x,J){const Ee=this.c.get(N);if(Ee)return Ee.createRun(x);const De=I.fromPublic(z,F,N,J),Ce=m(N);this.d.$startedExtensionTestRun({controllerId:z,continuous:!!N.continuous,profile:Ce&&{group:W[Ce.kind],id:Ce.profileId},exclude:N.exclude?.map(be=>n.$pJ.fromExtHostTestItem(be,F.root.id).toString())??[],id:De.id,include:N.include?.map(be=>n.$pJ.fromExtHostTestItem(be,F.root.id).toString())??[F.root.id],persist:J});const fe=this.f(N,De,U);return R.Event.once(fe.onEnd)(()=>{this.d.$finishedExtensionTestRun(De.id),fe.dispose()}),fe.createRun(x)}f(U,z,F,N){const x=new h(z,this.d,N);return this.c.set(U,x),R.Event.once(x.onEnd)(()=>this.c.delete(U)),x}}e.$gfc=b;const m=H=>{if(H.profile){if(!(H.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class I{static fromPublic(U,z,F,N){return new I(U,(0,a.$hg)(),F.include?.map(x=>n.$pJ.fromExtHostTestItem(x,U).toString())??[U],F.exclude?.map(x=>n.$pJ.fromExtHostTestItem(x,U).toString())??[],N,z)}static fromInternal(U,z){return new I(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,z)}constructor(U,z,F,N,x,J){this.controllerId=U,this.id=z,this.isPersisted=x,this.colllection=J,this.c=F.map(Ee=>Ee+"\0"),this.d=N.map(Ee=>Ee+"\0")}isIncluded(U){const z=n.$pJ.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const F of this.d)if(z===F||z.startsWith(F))return!1;for(const F of this.c)if(z===F||z.startsWith(F))return!0;return!1}}e.$hfc=I;class k{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,z,F){this.f=U,this.g=z,this.h=F}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(z){throw this.d=void 0,z}}async resolveFileCoverage(U,z){const F=await this.d;let N=F?.[U];return!this.c||!F||!N?[]:(N.detailedCoverage||(N=F[U]=await this.c.resolveFileCoverage?.(N,z)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class d{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const z=n.$pJ.parentId(U.item.extId);if(z&&this.g.has(z.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:z,f:F}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...z].map(N=>N.revived)},get removed(){return[...F].map(N=>N.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends o.$wJ{constructor(){super(...arguments),this.q=new R.$Qd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,z){return{...U,revived:t.TestItem.toPlain(U.item),depth:z?z.depth+1:0,children:new Set}}o(){return new d(this.q)}}class y{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(z=>z.revived)},dispose:(0,$.$cb)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class C{#e;#t;#i;#o;#r;get label(){return this.d}set label(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}get isSelected(){return(0,l.$yF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,l.$yF)(this.#t,"testingActiveProfile"),R.Event.chain(this.#o,U=>U.map(z=>z.get(this.controllerId)?.get(this.profileId)).filter(S.$Jf))}constructor(U,z,F,N,x,J,Ee,De,Ce,fe,be=!1,se=void 0,Re=!1){this.controllerId=J,this.profileId=Ee,this.d=De,this.kind=Ce,this.runHandler=fe,this.f=be,this._tag=se,this.g=Re,this.#e=U,this.#r=z,this.#t=F,this.#i=N,this.#o=x,z.set(Ee,this);const oe=W[Ce];if(typeof oe!="number")throw new Error(`Unknown TestRunProfile.group ${Ce}`);this.#e.$publishTestRunProfile({profileId:Ee,controllerId:J,tag:se?t.TestTag.namespace(this.controllerId,se.id):null,label:De,group:oe,isDefault:be,hasConfigurationHandler:!1,supportsContinuousRun:Re})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$ifc=C;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[270],Ae([1,0,18,11,5,3,109,8,7]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class g{constructor(S,a){this.i=a,this.a=new P.$Qd({onListenerError:L.$1}),this.b=new P.$Qd({onListenerError:L.$1}),this.c=new P.$Qd({onListenerError:L.$1}),this.d=new P.$Qd({onListenerError:L.$1}),this.f=new P.$Qd({onListenerError:L.$1}),this.g=new P.$Qd({onListenerError:L.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(M.$zK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const a=this.i.allEditors();return S?a:a.map(v=>v.value)}async showTextDocument(S,a,v){let p;typeof a=="number"?p={position:$.ViewColumn.from(a),preserveFocus:v}:typeof a=="object"?p={position:$.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?$.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:p={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(S.uri,p),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,a){return new R.$IM(this.h,S,a).value}$acceptEditorPropertiesChanged(S,a){const v=this.i.getEditor(S);if(!v)throw new Error("unknown text editor");if(a.options&&v._acceptOptions(a.options),a.selections){const p=a.selections.selections.map($.Selection.to);v._acceptSelections(p)}if(a.visibleRanges){const p=E.$Gb(a.visibleRanges.map($.Range.to));v._acceptVisibleRanges(p)}if(a.options&&this.b.fire({textEditor:v.value,options:{...a.options,lineNumbers:$.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const p=D.TextEditorSelectionChangeKind.fromValue(a.selections.source),f=a.selections.selections.map($.Selection.to);this.a.fire({textEditor:v.value,selections:f,kind:p})}if(a.visibleRanges){const p=E.$Gb(a.visibleRanges.map($.Range.to));this.c.fire({textEditor:v.value,visibleRanges:p})}}$acceptEditorPositionData(S){for(const a in S){const v=this.i.getEditor(a);if(!v)throw new Error("Unknown text editor");const p=$.ViewColumn.to(S[a]);v.value.viewColumn!==p&&(v._acceptViewColumn(p),this.d.fire({textEditor:v.value,viewColumn:p}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$xec=g}),define(Pe[271],Ae([1,0,2,4,3,6,7,8,22,16]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=e.$_ec=void 0,e.$_ec=(0,L.$Uh)("IExtHostTimeline");class A{constructor(v,p){this.b=new Map,this.c=new Map,this.a=v.getProxy(P.$zK.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&D.$$l.equals(t,this.b.get(f.source)?.extension)){const i=f.uri===void 0?void 0:E.URI.revive(f.uri);return this.c.get(f.source)?.get(S(i))?.get(f.handle)}else return;return f}})}async $getTimeline(v,p,f,t){return this.b.get(v)?.provider.provideTimeline(E.URI.revive(p),f,t)}registerTimelineProvider(v,p,f,t){const i=new M.$Qc,n=this.d(p.id,t,i).bind(this);let u;p.onDidChange&&(u=p.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:p.id}),this));const o=this.c;return this.f({...p,scheme:v,onDidChange:void 0,async provideTimeline(l,r,s){r?.resetCache&&(i.clear(),o.get(p.id)?.clear());const c=await p.provideTimeline(l,r,s);if(c==null)return;const h=n(l,r);return{...c,source:p.id,items:c.items.map(h)}},dispose(){for(const l of o.values())l.get(p.id)?.clear();u?.dispose(),i.dispose()}},f)}d(v,p,f){return(t,i)=>{let n;if(i?.cacheResults){let u=this.c.get(v);u===void 0&&(u=new Map,this.c.set(v,u));const o=S(t);n=u.get(o),n===void 0&&(n=new Map,u.set(o,n))}return u=>{const{iconPath:o,...l}=u,r=`${v}|${u.id??u.timestamp}`;n?.set(r,u);let s,c,h;u.iconPath&&(o instanceof R.$vL?h={id:o.id,color:o.color}:E.URI.isUri(o)?(s=o,c=o):{light:s,dark:c}=o);let b;return R.$2K.isMarkdownString(l.tooltip)?b=$.MarkdownString.from(l.tooltip):(0,g.$Bf)(l.tooltip)?b=l.tooltip:R.$2K.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=$.MarkdownString.from(l.detail)):(0,g.$Bf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=l.detail),{...l,id:l.id??void 0,handle:r,source:v,command:u.command?p.toInternal(u.command,f):void 0,icon:s,iconDark:c,themeIcon:h,tooltip:b,accessibilityInformation:u.accessibilityInformation}}}}f(v,p){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:p}),(0,M.$Pc)(()=>{for(const t of this.c.values())t.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$afc=A;function S(a){return a?.toString()}}),define(Pe[87],Ae([1,0,20,5,6,169,4,15,198,3,27,17,7]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vwb=e.$Uwb=e.TunnelDtoConverter=void 0;class v extends D.$mv{}var p;(function(t){function i(u){return{remoteAddress:u.remoteAddress,localAddress:u.localAddress,public:!!u.public,privacy:u.privacy??(u.public?D.TunnelPrivacyId.Public:D.TunnelPrivacyId.Private),protocol:u.protocol}}t.fromApiTunnel=i;function n(u){return{remoteAddress:{host:u.tunnelRemoteHost,port:u.tunnelRemotePort},localAddress:u.localAddress,public:u.privacy!==D.TunnelPrivacyId.ConstantPrivate&&u.privacy!==D.TunnelPrivacyId.ConstantPrivate,privacy:u.privacy,protocol:u.protocol}}t.fromServiceTunnel=n})(p||(e.TunnelDtoConverter=p={})),e.$Uwb=(0,R.$Uh)("IExtHostTunnelService");let f=class extends P.$Rc{constructor(i,n,u){super(),this.s=u,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$Qd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(g.$zK.MainThreadTunnelService)}async openTunnel(i,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const u=await this.a.$openTunnel(n,i.displayName);if(u){const o=new v(u.remoteAddress,u.localAddress,()=>this.a.$closeTunnel(u.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,n){const u=this.u();return this.r.set(u,{selector:i,provider:n}),this.a.$registerPortsAttributesProvider(i,u),new a.$BK(()=>{this.r.delete(u),this.a.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(i,n,u,o,l){const r=[];for(const c of i){const h=this.r.get(c);if(!h)return[];r.push(...await Promise.all(n.map(async b=>{let m;try{m=await h.provider.providePortAttributes({port:b,pid:u,commandLine:o},l)}catch{m=await h.provider.providePortAttributes(b,u,o,l)}return{providedAttributes:m,port:b}})))}const s=r.filter(c=>!!c.providedAttributes);return s.length>0?s.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,l)=>await i.provideTunnel(o,l,new E.$1d().token)??void 0;const u=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(u),Promise.resolve((0,P.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,n){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const u=i.tunnelFactory??(n?this.w(n):void 0);if(u){this.b=u;let o=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const l=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,P.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,n){if(this.g.has(i.host)){const u=this.g.get(i.host);u.has(i.port)&&(n&&u.get(i.port).disposeListener.dispose(),await u.get(i.port).tunnel.dispose(),u.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this.b(i,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const o=await u;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const l=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:o,disposeListener:l}),p.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(u){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),u instanceof Error)return u.message}}async $applyCandidateFilter(i){const n=await Promise.all(i.map(o=>this.f(o.host,o.port,o.detail??""))),u=i.filter((o,l)=>n[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(o=>o.port).join(", ")} to ${u.map(o=>o.port).join(", ")}`),u}};e.$Vwb=f,e.$Vwb=f=Ke([Ve(0,S.$BM),Ve(1,A.$RM),Ve(2,$.$cj)],f)}),define(Pe[272],Ae([1,0,6,14,2,3]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;class R{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(D){this.c=new Map,this.b=D.getProxy(M.$zK.MainThreadUriOpeners)}registerExternalUriOpener(D,g,A,S){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const a=S.schemes.find(v=>!R.a.has(v));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(g,A),this.b.$registerUriOpener(g,S.schemes,D,S.label),(0,E.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(D,g,A){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener with id: ${D}`);const a=P.URI.revive(g);return S.canOpenExternalUri(a,A)}async $openUri(D,g,A){const S=this.c.get(D);if(!S)throw new Error(`Unknown opener id: '${D}'`);return S.openExternalUri(P.URI.revive(g.resolvedUri),{sourceUri:P.URI.revive(g.sourceUri)},A)}}e.$jfc=R}),define(Pe[273],Ae([1,0,3,2,6,11,22]),function(ve,e,E,L,P,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class ${static{this.a=0}constructor(g){this.c=new R.$_l,this.d=new Map,this.b=g.getProxy(E.$zK.MainThreadUrls)}registerUriHandler(g,A){const S=g.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const a=$.a++;return this.c.add(S),this.d.set(a,A),this.b.$registerUriHandler(a,S,g.displayName||g.name),(0,P.$Pc)(()=>{this.c.delete(S),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(g,A){const S=this.d.get(g);if(!S)return Promise.resolve(void 0);try{S.handleUri(L.URI.revive(A))}catch(a){(0,M.$Z)(a)}return Promise.resolve(void 0)}async createAppUri(g){return L.URI.revive(await this.b.$createAppUri(g))}}e.$zec=$}),define(Pe[66],Ae([1,0,5,6,14,26,2,183,205,78,3]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=e.$Dec=e.$Cec=e.$Bec=e.$Aec=void 0;class S{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,l,r,s,c,h,b){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Qd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Qd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=l,this.#s=r,this.#o=s,this.#r=c,this.#n=h,this.#l=a(h),this.#d=v(h),this.#i=b}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,g.$bub)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===P.Schemas.https||o.scheme===P.Schemas.http){let l=o.toString();return l.endsWith("/")||(l+="/"),l+" "+g.$aub}return g.$aub}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),M.$dn(this.#s,o)||this.#t.$setOptions(this.#e,t(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const l=(0,D.$idb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const l=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,c,h,b,m,I)=>{const k=R.URI.from({scheme:b||"file",path:decodeURIComponent(m)}),d=(0,g.$bub)(k,{isRemote:l,authority:r}).toString();return`${c}${d}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,c,h,b,m,I)=>{const k=R.URI.from({scheme:b||"file",path:decodeURIComponent(m)}),d=(0,g.$bub)(k,{isRemote:l,authority:r}).toString();return`${c}${d}${I}`})}}e.$Aec=S;function a(u){try{const o=(0,$.$So)((0,$.$Ro)(u.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$Bec=a;function v(u){try{const o=(0,$.$So)((0,$.$Ro)(u.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class p extends L.$Rc{constructor(o,l,r,s,c){super(),this.c=l,this.f=r,this.g=s,this.h=c,this.b=new Map,this.a=o.getProxy(A.$zK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,l,r){const s=this.j(o);if(s){const{message:c}=(0,D.$jdb)(l,r.value);s._onMessageEmitter.fire(c)}}$onMissingCsp(o,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,l,r){const s=new S(o,this.a,i(l),this.c,this.f,r,this.h);this.b.set(o,s);const c=s._onDidDispose(()=>{c.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Cec=p;function f(u){return{id:u.identifier,location:u.extensionLocation}}e.$Dec=f;function t(u,o,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||n(u,o)}}e.$Eec=t;function i(u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots?.map(o=>R.URI.from(o))}}function n(u,o){return[...(o?.getWorkspaceFolders()||[]).map(l=>l.uri),u.extensionLocation]}}),define(Pe[274],Ae([1,0,20,97,6,14,25,2,8,66,75,3,7]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class v{constructor(s,c){this.document=s,this.b=c,this.a=1,this.c=new A.$wdc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,c){await this.f(s).undo(),c||this.disposeBackup()}async redo(s,c){await this.f(s).redo(),c||this.disposeBackup()}disposeEdits(s){for(const c of s)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this.a++;return(0,R.$yg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const c=this.c.get(s,0);if(!c)throw new Error("No edit found");return c}}class p{constructor(){this.a=new Map}get(s,c){return this.a.get(this.b(s,c))}add(s,c,h){const b=this.b(s,c.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${s} resource:${c.uri}`);const m=new v(c,h);return this.a.set(b,m),m}delete(s,c){const h=this.b(s,c.uri);this.a.delete(h)}b(s,c){return`${s}@@@${c}`}}var f;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(s,c,h){return this.b(0,s,c,h)}addCustomProvider(s,c,h){return this.b(1,s,c,h)}get(s){return this.a.get(s)}b(s,c,h,b){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:s,extension:h,provider:b}),new a.$BK(()=>this.a.delete(c))}}class i{constructor(s,c,h,b,m){this.d=c,this.f=h,this.g=b,this.h=m,this.b=new t,this.c=new p,this.a=s.getProxy(S.$zK.MainThreadCustomEditors)}registerCustomEditorProvider(s,c,h,b){const m=new P.$Qc;return u(h)?(m.add(this.b.addTextProvider(c,s,h)),this.a.$registerTextEditorProvider((0,g.$Dec)(s),c,b.webviewOptions||{},{supportsMove:!!h.moveCustomTextEditor},(0,g.$Bec)(s))):(m.add(this.b.addCustomProvider(c,s,h)),n(h)&&m.add(h.onDidChangeCustomDocument(I=>{const k=this.i(c,I.document.uri);if(o(I)){const d=k.addEdit(I);this.a.$onDidEdit(I.document.uri,c,d,I.label)}else this.a.$onContentChange(I.document.uri,c)})),this.a.$registerCustomEditorProvider((0,g.$Dec)(s),c,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,g.$Bec)(s))),a.$BK.from(m,new a.$BK(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(s,c,h,b,m){const I=this.b.get(c);if(!I)throw new Error(`No provider found for '${c}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${c}'`);const k=$.URI.revive(s),d=await I.provider.openCustomDocument(k,{backupId:h,untitledDocumentData:b?.buffer},m);let w;return n(I.provider)&&this.f&&(w=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(c,d,w),{editable:n(I.provider)}}async $disposeCustomDocument(s,c){const h=this.b.get(c);if(!h)throw new Error(`No provider found for '${c}'`);if(h.type!==1)throw new Error(`Invalid provider type for '${c}'`);const b=$.URI.revive(s),{document:m}=this.i(c,b);this.c.delete(c,m),m.dispose()}async $resolveCustomEditor(s,c,h,b,m,I){const k=this.b.get(h);if(!k)throw new Error(`No provider found for '${h}'`);const d=D.ViewColumn.to(m),w=this.g.createNewWebview(c,b.contentOptions,k.extension),y=this.h.createNewWebviewPanel(c,h,b.title,d,b.options,w,b.active),C=$.URI.revive(s);switch(k.type){case 1:{const{document:W}=this.i(h,C);return k.provider.resolveCustomEditor(W,y,I)}case 0:{const W=this.d.getDocument(C);return k.provider.resolveCustomTextEditor(W,y,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,c,h){this.i(c,s).disposeEdits(h)}async $onMoveCustomEditor(s,c,h){const b=this.b.get(h);if(!b)throw new Error(`No provider found for '${h}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${h}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const I=$.URI.revive(c),k=this.d.getDocument(I);await b.provider.moveCustomTextEditor(k,m,E.CancellationToken.None)}async $undo(s,c,h,b){return this.i(c,s).undo(h,b)}async $redo(s,c,h,b){return this.i(c,s).redo(h,b)}async $revert(s,c,h){const b=this.i(c,s);await this.j(c).revertCustomDocument(b.document,h),b.disposeBackup()}async $onSave(s,c,h){const b=this.i(c,s);await this.j(c).saveCustomDocument(b.document,h),b.disposeBackup()}async $onSaveAs(s,c,h,b){const m=this.i(c,s);return this.j(c).saveCustomDocumentAs(m.document,$.URI.revive(h),b)}async $backup(s,c,h){const b=this.i(c,s),I=await this.j(c).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},h);return b.updateBackup(I),I.id}i(s,c){const h=this.c.get(s,$.URI.revive(c));if(!h)throw new Error("No custom document found");return h}j(s){const h=this.b.get(s)?.provider;if(!h||!n(h))throw new Error("Custom document is not editable");return h}}e.$dfc=i;function n(r){return!!r.onDidChangeCustomDocument}function u(r){return typeof r.resolveCustomTextEditor=="function"}function o(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function l(r){const s=r.scheme===M.Schemas.file||r.scheme===M.Schemas.untitled?r.fsPath:r.toString();return(0,L.$Ii)(s)+""}}),define(Pe[275],Ae([1,0,5,6,2,38,8,66,3,7]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class A extends L.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(p,f,t,i){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Qd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Qd),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=f,this.#o=t,this.#i=i.viewType,this.#r=i.panelOptions,this.#s=i.viewColumn,this.#n=i.title,this.#u=i.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(p){this.c(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#s=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!f})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends L.$Rc{static c(){return(0,M.$hg)()}constructor(p,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=p.getProxy(D.$zK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,f,t,i,n={}){const u=typeof i=="object"?i.viewColumn:i,o={viewColumn:R.ViewColumn.from(u),preserveFocus:typeof i=="object"&&!!i.preserveFocus},l=(0,$.$Bec)(p),r=S.c();this.f.$createWebviewPanel((0,$.$Dec)(p),r,f,{title:t,panelOptions:a(n),webviewOptions:(0,$.$Eec)(p,this.m,n),serializeBuffersForPostMessage:l},o);const s=this.j.createNewWebview(r,n,p);return this.createNewWebviewPanel(r,f,t,u,n,s,!0)}$onDidChangeWebviewPanelViewStates(p){const f=Object.keys(p);f.sort((t,i)=>{const n=p[t],u=p[i];return n.active?1:u.active?-1:+n.visible-+u.visible});for(const t of f){const i=this.getWebviewPanel(t);if(!i)continue;const n=p[t];i._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:p}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,$.$Bec)(p)}),new g.$BK(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(p,f,t,i){const n=this.h.get(f);if(!n)throw new Error(`No serializer found for '${f}'`);const{serializer:u,extension:o}=n,l=this.j.createNewWebview(p,t.webviewOptions,o),r=this.createNewWebviewPanel(p,f,t.title,i,t.panelOptions,l,t.active);await u.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(p,f,t,i,n,u,o){const l=new A(p,this.f,u,{viewType:f,title:t,viewColumn:i,panelOptions:n,active:o});return this.g.set(p,l),l}getWebviewPanel(p){return this.g.get(p)}}e.$cfc=S;function a(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Pe[276],Ae([1,0,5,6,66,8,3,7]),function(ve,e,E,L,P,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class D extends L.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(S,a,v,p,f,t){super(),this.#r=!1,this.#u=this.B(new E.$Qd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Qd),this.onDidDispose=this.#l.event,this.#i=v,this.#a=p,this.#e=S,this.#t=a,this.#o=f,this.#n=t}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#s}set description(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#r||(this.#n=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#r)throw new Error("Webview is disposed")}}class g{constructor(S,a){this.d=a,this.b=new Map,this.c=new Map,this.a=S.getProxy(R.$zK.MainThreadWebviewViews)}registerWebviewViewProvider(S,a,v,p){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:v,extension:S}),this.a.$registerWebviewViewProvider((0,P.$Dec)(S),a,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Bec)(S)}),new $.$BK(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(S,a,v,p,f){const t=this.b.get(a);if(!t)throw new Error(`No view provider found for '${a}'`);const{provider:i,extension:n}=t,u=this.d.createNewWebview(S,{},n),o=new D(S,this.a,a,v,u,!0);this.c.set(S,o),await i.resolveWebviewView(o,{state:p},f)}async $onDidChangeWebviewViewVisibility(S,a){this.e(S)._setVisible(a)}async $disposeWebviewView(S){const a=this.e(S);this.c.delete(S),a.dispose(),this.d.deleteWebview(S)}e(S){const a=this.c.get(S);if(!a)throw new Error("No webview found");return a}}e.$bfc=g}),define(Pe[111],Ae([1,0,5,3,2,14,13,4,17,23]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=e.$Fec=void 0;let S=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const p=this.d;return{get focused(){return p.focused},get active(){return(0,g.$yF)(v,"windowActivity"),p.active}}}constructor(v){this.c=new E.$Qd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(L.$zK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:f})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,p){p!==this.d[v]&&(this.d={...this.d,[v]:p},this.c.fire(this.d))}openUri(v,p){let f;if(typeof v=="string"){f=v;try{v=P.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Ee)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,f,p)}async asExternalUri(v,p){if((0,R.$Ee)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(v,p);return P.URI.from(f)}};e.$Fec=S,e.$Fec=S=A=Ke([Ve(0,D.$BM)],S),e.$Gec=(0,$.$Uh)("IExtHostWindow")}),define(Pe[277],Ae([1,0,243,27,17]),function(ve,e,E,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;let M=class extends E.$Gfc{constructor($,D){super($,D)}f($,D,g){D.apply(console,g)}};e.$Ohc=M,e.$Ohc=M=Ke([Ve(0,P.$BM),Ve(1,L.$RM)],M)}),define(Pe[278],Ae([1,0,12,24,20,11,5,6,139,231,49]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=e.ResponsiveState=e.RequestInitiator=e.$U5b=e.$T5b=void 0;function a(y,C){try{return JSON.stringify(y,C)}catch{return"null"}}const v="$$ref$$",p={[v]:-1};class f{constructor(C,W){this.jsonString=C,this.referencedBuffers=W}}function t(y,C=null,W=!1){const H=[];return{jsonString:(W?a:JSON.stringify)(y,(z,F)=>{if(typeof F>"u")return p;if(typeof F=="object"){if(F instanceof L.$ee){const N=H.push(F)-1;return{[v]:N}}if(C)return C(z,F)}return F}),referencedBuffers:H}}e.$T5b=t;function i(y,C,W){return JSON.parse(y,(H,U)=>{if(U){const z=U[v];if(typeof z=="number")return C[z];if(W&&U.$mid===1)return W.transformIncoming(U)}return U})}e.$U5b=i;function n(y,C){return JSON.stringify(y,C)}function u(y){return y?(C,W)=>W&&W.$mid===1?y.transformOutgoing(W):W:null}var o;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var l;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const r=()=>{},s=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class h extends $.$Rc{static{S=s}static{this.a=3*1e3}constructor(C,W=null,H=null){super(),this[S]=!0,this.b=this.B(new R.$Qd),this.onDidChangeResponsiveState=this.b.event,this.c=C,this.f=W,this.g=H,this.h=u(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,z=A.$tv.count;U<z;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$9g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(C=>{const W=this.w[C];delete this.w[C],W.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(C){this.z===0&&(this.C=Date.now()+h.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(C){this.C=Date.now()+h.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(C){this.y!==C&&(this.y=C,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(C){return this.g?(0,D.$Tm)(C,this.g):C}getProxy(C){const{nid:W,sid:H}=C;return this.s[W]||(this.s[W]=this.J(W,H)),this.s[W]}J(C,W){const H={get:(U,z)=>(typeof z=="string"&&!U[z]&&z.charCodeAt(0)===36&&(U[z]=(...F)=>this.U(C,z,F)),z===c?W:U[z])};return new Proxy(Object.create(null),H)}set(C,W){return this.m[C.nid]=W,W}assertRegistered(C){for(let W=0,H=C.length;W<H;W++){const U=C[W];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(C){if(this.j)return;const W=C.byteLength,H=m.read(C,0),U=H.readUInt8(),z=H.readUInt32();switch(U){case 1:case 2:{let{rpcId:F,method:N,args:x}=k.deserializeRequestJSONArgs(H);this.g&&(x=(0,D.$Tm)(x,this.g)),this.M(W,z,F,N,x,U===2);break}case 3:case 4:{let{rpcId:F,method:N,args:x}=k.deserializeRequestMixedArgs(H);this.g&&(x=(0,D.$Tm)(x,this.g)),this.M(W,z,F,N,x,U===4);break}case 5:{this.f?.logIncoming(W,z,0,"ack"),this.G(z);break}case 6:{this.N(W,z);break}case 7:{this.O(W,z,void 0);break}case 9:{let F=k.deserializeReplyOKJSON(H);this.g&&(F=(0,D.$Tm)(F,this.g)),this.O(W,z,F);break}case 10:{const F=k.deserializeReplyOKJSONWithBuffers(H,this.g);this.O(W,z,F);break}case 8:{const F=k.deserializeReplyOKVSBuffer(H);this.O(W,z,F);break}case 11:{let F=k.deserializeReplyErrError(H);this.g&&(F=(0,D.$Tm)(F,this.g)),this.P(W,z,F);break}case 12:{this.P(W,z,void 0);break}default:console.error("received unexpected message"),console.error(C)}}M(C,W,H,U,z,F){this.f?.logIncoming(C,W,1,`receiveRequest ${(0,A.$vv)(H)}.${U}(`,z);const N=String(W);let x,J;if(F){const De=new P.$1d;z.push(De.token),x=this.Q(H,U,z),J=()=>De.cancel()}else x=this.Q(H,U,z),J=r;this.u[N]=J;const Ee=k.serializeAcknowledged(W);this.f?.logOutgoing(Ee.byteLength,W,1,"ack"),this.c.send(Ee),x.then(De=>{delete this.u[N];const Ce=k.serializeReplyOK(W,De,this.h);this.f?.logOutgoing(Ce.byteLength,W,1,"reply:",De),this.c.send(Ce)},De=>{delete this.u[N];const Ce=k.serializeReplyErr(W,De);this.f?.logOutgoing(Ce.byteLength,W,1,"replyErr:",De),this.c.send(Ce)})}N(C,W){this.f?.logIncoming(C,W,1,"receiveCancel");const H=String(W);this.u[H]?.()}O(C,W,H){this.f?.logIncoming(C,W,0,"receiveReply:",H);const U=String(W);if(!this.w.hasOwnProperty(U))return;const z=this.w[U];delete this.w[U],z.resolveOk(H)}P(C,W,H){this.f?.logIncoming(C,W,0,"receiveReplyErr:",H);const U=String(W);if(!this.w.hasOwnProperty(U))return;const z=this.w[U];delete this.w[U];let F;H&&(H.$isError?(F=new Error,F.name=H.name,F.message=H.message,F.stack=H.stack):F=H),z.resolveErr(F)}Q(C,W,H){try{return Promise.resolve(this.S(C,W,H))}catch(U){return Promise.reject(U)}}S(C,W,H){const U=this.m[C];if(!U)throw new Error("Unknown actor "+(0,A.$vv)(C));const z=U[W];if(typeof z!="function")throw new Error("Unknown method "+W+" on actor "+(0,A.$vv)(C));return z.apply(U,H)}U(C,W,H){if(this.j)return new g.$S5b;let U=null;if(H.length>0&&P.CancellationToken.isCancellationToken(H[H.length-1])&&(U=H.pop()),U&&U.isCancellationRequested)return Promise.reject(M.$5());const z=k.serializeRequestArguments(H,this.h),F=++this.t,N=String(F),x=new g.$R5b,J=new $.$Qc;U&&J.add(U.onCancellationRequested(()=>{const De=k.serializeCancel(F);this.f?.logOutgoing(De.byteLength,F,0,"cancel"),this.c.send(k.serializeCancel(F))})),this.w[N]=new b(x,J),this.F(F);const Ee=k.serializeRequest(F,C,W,z,!!U);return this.f?.logOutgoing(Ee.byteLength,F,0,`request: ${(0,A.$vv)(C)}.${W}(`,H),this.c.send(Ee),x}}e.$V5b=h;class b{constructor(C,W){this.a=C,this.b=W}resolveOk(C){this.a.resolveOk(C),this.b.dispose()}resolveErr(C){this.a.resolveErr(C),this.b.dispose()}}class m{static alloc(C,W,H){const U=new m(L.$ee.alloc(H+1+4),0);return U.writeUInt8(C),U.writeUInt32(W),U}static read(C,W){return new m(C,W)}get buffer(){return this.a}constructor(C,W){this.a=C,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(C){this.a.writeUInt8(C,this.b),this.b+=1}readUInt8(){const C=this.a.readUInt8(this.b);return this.b+=1,C}writeUInt32(C){this.a.writeUInt32BE(C,this.b),this.b+=4}readUInt32(){const C=this.a.readUInt32BE(this.b);return this.b+=4,C}static sizeShortString(C){return 1+C.byteLength}writeShortString(C){this.a.writeUInt8(C.byteLength,this.b),this.b+=1,this.a.set(C,this.b),this.b+=C.byteLength}readShortString(){const C=this.a.readUInt8(this.b);this.b+=1;const H=this.a.slice(this.b,this.b+C).toString();return this.b+=C,H}static sizeLongString(C){return 4+C.byteLength}writeLongString(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readLongString(){const C=this.a.readUInt32BE(this.b);this.b+=4;const H=this.a.slice(this.b,this.b+C).toString();return this.b+=C,H}writeBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}static sizeVSBuffer(C){return 4+C.byteLength}writeVSBuffer(C){this.a.writeUInt32BE(C.byteLength,this.b),this.b+=4,this.a.set(C,this.b),this.b+=C.byteLength}readVSBuffer(){const C=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+C);return this.b+=C,W}static sizeMixedArray(C){let W=0;W+=1;for(let H=0,U=C.length;H<U;H++){const z=C[H];switch(W+=1,z.type){case 1:W+=this.sizeLongString(z.value);break;case 2:W+=this.sizeVSBuffer(z.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(z.value);for(let F=0;F<z.buffers.length;++F)W+=this.sizeVSBuffer(z.buffers[F]);break;case 4:break}}return W}writeMixedArray(C){this.a.writeUInt8(C.length,this.b),this.b+=1;for(let W=0,H=C.length;W<H;W++){const U=C[W];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let z=0;z<U.buffers.length;++z)this.writeBuffer(U.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const C=this.a.readUInt8(this.b);this.b+=1;const W=new Array(C);for(let H=0;H<C;H++)switch(this.readUInt8()){case 1:W[H]=this.readLongString();break;case 2:W[H]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),F=this.readLongString(),N=[];for(let x=0;x<z;++x)N.push(this.readVSBuffer());W[H]=new A.$wv(i(F,N,null));break}case 4:W[H]=void 0;break}return W}}var I;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(I||(I={}));class k{static a(C){for(let W=0,H=C.length;W<H;W++)if(C[W]instanceof L.$ee||C[W]instanceof A.$wv||typeof C[W]>"u")return!0;return!1}static serializeRequestArguments(C,W){if(this.a(C)){const H=[];for(let U=0,z=C.length;U<z;U++){const F=C[U];if(F instanceof L.$ee)H[U]={type:2,value:F};else if(typeof F>"u")H[U]={type:4};else if(F instanceof A.$wv){const{jsonString:N,referencedBuffers:x}=t(F.value,W);H[U]={type:3,value:L.$ee.fromString(N),buffers:x}}else H[U]={type:1,value:L.$ee.fromString(n(F,W))}}return{type:1,args:H}}return{type:0,args:n(C,W)}}static serializeRequest(C,W,H,U,z){switch(U.type){case 0:return this.b(C,W,H,U.args,z);case 1:return this.c(C,W,H,U.args,z)}}static b(C,W,H,U,z){const F=L.$ee.fromString(H),N=L.$ee.fromString(U);let x=0;x+=m.sizeUInt8(),x+=m.sizeShortString(F),x+=m.sizeLongString(N);const J=m.alloc(z?2:1,C,x);return J.writeUInt8(W),J.writeShortString(F),J.writeLongString(N),J.buffer}static deserializeRequestJSONArgs(C){const W=C.readUInt8(),H=C.readShortString(),U=C.readLongString();return{rpcId:W,method:H,args:JSON.parse(U)}}static c(C,W,H,U,z){const F=L.$ee.fromString(H);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(F),N+=m.sizeMixedArray(U);const x=m.alloc(z?4:3,C,N);return x.writeUInt8(W),x.writeShortString(F),x.writeMixedArray(U),x.buffer}static deserializeRequestMixedArgs(C){const W=C.readUInt8(),H=C.readShortString(),U=C.readMixedArray(),z=new Array(U.length);for(let F=0,N=U.length;F<N;F++){const x=U[F];typeof x=="string"?z[F]=JSON.parse(x):z[F]=x}return{rpcId:W,method:H,args:z}}static serializeAcknowledged(C){return m.alloc(5,C,0).buffer}static serializeCancel(C){return m.alloc(6,C,0).buffer}static serializeReplyOK(C,W,H){if(typeof W>"u")return this.d(C);if(W instanceof L.$ee)return this.e(C,W);if(W instanceof A.$wv){const{jsonString:U,referencedBuffers:z}=t(W.value,H,!0);return this.g(C,U,z)}else return this.f(C,a(W,H))}static d(C){return m.alloc(7,C,0).buffer}static e(C,W){let H=0;H+=m.sizeVSBuffer(W);const U=m.alloc(8,C,H);return U.writeVSBuffer(W),U.buffer}static deserializeReplyOKVSBuffer(C){return C.readVSBuffer()}static f(C,W){const H=L.$ee.fromString(W);let U=0;U+=m.sizeLongString(H);const z=m.alloc(9,C,U);return z.writeLongString(H),z.buffer}static g(C,W,H){const U=L.$ee.fromString(W);let z=0;z+=m.sizeUInt32,z+=m.sizeLongString(U);for(const N of H)z+=m.sizeVSBuffer(N);const F=m.alloc(10,C,z);F.writeUInt32(H.length),F.writeLongString(U);for(const N of H)F.writeBuffer(N);return F.buffer}static deserializeReplyOKJSON(C){const W=C.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(C,W){const H=C.readUInt32(),U=C.readLongString(),z=[];for(let F=0;F<H;++F)z.push(C.readVSBuffer());return new A.$wv(i(U,z,W))}static serializeReplyErr(C,W){const H=W?a(M.$2(W),null):void 0;if(typeof H!="string")return this.h(C);const U=L.$ee.fromString(H);let z=0;z+=m.sizeLongString(U);const F=m.alloc(11,C,z);return F.writeLongString(U),F.buffer}static deserializeReplyErrError(C){const W=C.readLongString();return JSON.parse(W)}static h(C){return m.alloc(12,C,0).buffer}}var d;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var w;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(w||(w={}))}),define(Pe[279],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;const E=function(M){const R=$=>{globalThis.removeEventListener("message",R);const D=$.data;Object.defineProperties(globalThis,{postMessage:{value(g,A){D.postMessage(g,A)}},onmessage:{get(){return D.onmessage},set(g){D.onmessage=g}}}),D.addEventListener("message",g=>{globalThis.dispatchEvent(new MessageEvent("message",{data:g.data,ports:g.ports?[...g.ports]:void 0}))}),D.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class L extends EventTarget{constructor(M,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${E})('${R}'))`,g=new Blob([D],{type:"application/javascript"}),A=URL.createObjectURL(g),S=new MessageChannel,a=A,v={type:"_newWorker",id:a,port:S.port2,url:A,options:$};M(v,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:a}),URL.revokeObjectURL(A),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(p){S.port1.onmessage=p}},onmessageerror:{get(){return S.port1.onmessageerror},set(p){S.port1.onmessageerror=p}}}),S.port1.addEventListener("messageerror",p=>{const f=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(f)}),S.port1.addEventListener("message",p=>{const f=new MessageEvent("message",{data:p.data});this.dispatchEvent(f)}),S.port1.start()}}e.$Qhc=L}),define(Pe[280],Ae([1,0,5,30,34,4]),function(ve,e,E,L,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SJ=e.$RJ=e.OutputChannelUpdateMode=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=void 0,e.$HJ="text/x-code-output",e.$IJ="output",e.$JJ="Log",e.$KJ="text/x-code-log-output",e.$LJ="log",e.$MJ="workbench.panel.output",e.$NJ=new P.$_i("inOutput",!1),e.$OJ=new P.$_i("activeLogOutput",!1),e.$PJ=new P.$_i("outputView.scrollLock",!1),e.$QJ=(0,M.$Uh)("outputService");var R;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$RJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new E.$Qd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Qd,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(A=>g.push(A)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}L.$ln.add(e.$RJ.OutputChannels,new $),e.$SJ=new P.$_i("activeOutputChannel","")}),define(Pe[112],Ae([1,0,3,4,17,22,15,280,64,27,42,136,24,16,41,5,6]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=void 0;class i extends R.$ij{get disposed(){return this.n}constructor(l,r,s,c,h){super(),this.id=l,this.name=r,this.r=s,this.s=c,this.extension=h,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,l)}replace(l){const r=this.m;this.info(l),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(l,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:r))}hide(){this.s.$close(this.id)}g(l,r){this.m+=a.$ee.fromString(r).byteLength,(0,R.log)(this.r,l,r),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends i{appendLine(l){this.append(l)}}let u=class{constructor(l,r,s,c,h,b){this.i=r,this.j=s,this.k=c,this.l=h,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(E.$zK.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,S.$jm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel(l,r,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const c=typeof r=="object"&&r.log,h=(0,v.$Bf)(r)?r:void 0;if((0,v.$Bf)(h)&&!h.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const m=this.i.environment.extensionLogLevel?.find(([k])=>M.$$l.equals(s.identifier,k))?.[1];m&&(b=(0,R.$sj)(m));const I=c?this.o(l,b,s):this.n(l,h,s);return I.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),c?this.r(l,b??this.m.getLevel(),I):this.q(l,I)}async n(l,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,h=this.k.extUri.joinPath(c,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(h,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(l,h,r,s.identifier.value);return new i(m,l,b,this.a,s)}async o(l,r,s){const c=await this.p(s),h=l.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(c,`${h}.log`),m=`${s.identifier.value}.${h}`,I=this.l.createLogger(b,{id:m,name:l,logLevel:r,extensionId:s.identifier.value});return new n(m,l,I,this.a,s)}p(l){let r=this.d.get(l.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(c){if((0,p.$tk)(c)!==p.FileSystemProviderErrorCode.FileExists)throw c}return s})())}return r}q(l,r){let s=!1;const c=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return l},append(h){c(),r.then(b=>b.append(h))},appendLine(h){c(),r.then(b=>b.appendLine(h))},clear(){c(),r.then(h=>h.clear())},replace(h){c(),r.then(b=>b.replace(h))},show(h,b){c(),r.then(m=>m.show(h,b))},hide(){c(),r.then(h=>h.hide())},dispose(){s=!0,r.then(h=>h.dispose())}}}r(l,r,s){const c=new t.$Qc,h=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},b=c.add(new f.$Qd);function m(I){r=I,b.fire(I)}return s.then(I=>{c.add(I),I.logLevel!==r&&m(I.logLevel),c.add(I.onDidChangeLogLevel(k=>m(k)))}),{...this.q(l,s),get logLevel(){return r},onDidChangeLogLevel:b.event,trace(I,...k){h(),s.then(d=>d.trace(I,...k))},debug(I,...k){h(),s.then(d=>d.debug(I,...k))},info(I,...k){h(),s.then(d=>d.info(I,...k))},warn(I,...k){h(),s.then(d=>d.warn(I,...k))},error(I,...k){h(),s.then(d=>d.error(I,...k))},dispose(){c.dispose()}}}};e.$pec=u,e.$pec=u=Ke([Ve(0,P.$BM),Ve(1,g.$RM),Ve(2,D.$5dc),Ve(3,A.$zdc),Ve(4,R.$dj),Ve(5,R.$cj)],u),e.$qec=(0,L.$Uh)("IExtHostOutputService")}),define(Pe[113],Ae([1,0,4,12]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=void 0,e.$ym=(0,E.$Uh)("remoteAgentService"),e.$zm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const D=await P.getRoundTripTime();if(D===void 0)return;M=Math.min(M,D/2),await(0,L.$Xg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce(($,D)=>$+D,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce(($,D)=>$+D,0)/this.average.length,high:(()=>typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[281],Ae([1,0,171,56,30,47,40,6,5,113,21]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=void 0,e.$qH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$rH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$sH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$tH={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new D.$Qd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const a=new S;P.$ln.add(e.$tH.ConfigurationMigration,a);let v=class extends $.$Rc{constructor(t,i){super(),this.a=t,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const u of n.added)await this.f(u,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(t){await this.f(void 0,t);for(const i of this.b.getWorkspace().folders)await this.f(i,t)}async f(t,i){await Promise.all(i.map(n=>this.g(n,{resource:t?.uri})))}async g(t,i){const n=this.a.inspect(t.key,i);if(await this.h(t,i,n,"userValue",2),await this.h(t,i,n,"userLocalValue",3),await this.h(t,i,n,"userRemoteValue",4),await this.h(t,i,n,"workspaceFolderValue",6),await this.h(t,i,n,"workspaceValue",5),typeof i.overrideIdentifier>"u"&&typeof n.overrideIdentifiers<"u")for(const u of n.overrideIdentifiers)await this.g(t,{resource:i.resource,overrideIdentifier:u})}async h(t,i,n,u,o){const l=n[u];if(typeof l>"u")return;const r=h=>this.a.inspect(h,i)[u],s=await t.migrateFn(l,r),c=Array.isArray(s)?s:[[t.key,s]];await Promise.allSettled(c.map(async([h,b])=>this.a.updateValue(h,b.value,i,o)))}};e.$uH=v,e.$uH=v=Ke([Ve(0,R.$oi),Ve(1,M.$4h)],v);let p=class extends $.$Rc{constructor(t){super(),(async()=>{if(!A.$i&&(await t.getEnvironment())?.os!==1)return;P.$ln.as(L.$qn.Configuration).registerConfiguration({...e.$sH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$vH=p,e.$vH=p=Ke([Ve(0,g.$ym)],p)}),define(Pe[282],Ae([1,0,33,14,19,25,179,281,56,4,30]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccb=e.$Bcb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Acb=e.$zcb=void 0,e.$zcb=(0,g.$Uh)("editorResolverService"),e.$Acb="workbench.editorAssociations";const S=A.$ln.as(D.$qn.Configuration),a={...$.$rH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(a);var v;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(v||(e.RegisteredEditorPriority=v={}));var p;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function f(i){switch(i){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$Bcb=f;function t(i,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const l=typeof i=="string"&&i.indexOf(P.$fc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$vg)(n);return E.$Aj(typeof i=="string"?i.toLowerCase():i,l.toLowerCase())}e.$Ccb=t}),define(Pe[283],Ae([1,0,46,14,19,21,25,2,4,200,47,218,113]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.$$J=void 0,e.$$J=(0,D.$Uh)("pathService");let p=v=class{constructor(t,i,n,u){this.d=t,this.e=i,this.f=n,this.g=u,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??t})()}hasValidBasename(t,i,n){return typeof i=="string"||typeof i>"u"?this.a.then(u=>this.h(t,u,i)):this.h(t,i,n)}h(t,i,n){return t.scheme===L.Schemas.file||t.scheme===L.Schemas.vscodeRemote?(0,E.$Yf)(n??(0,R.$vg)(t),i===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,g.$8J)(i.getWorkspace());if(n)return n;const u=i.getWorkspace().folders[0];if(u)return u.uri.scheme;const o=i.getWorkspace().configuration;return o?o.scheme:L.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?P.$ec:P.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const u=t.indexOf("/",2);u===-1?(i=t.substring(2),t="/"):(i=t.substring(2,u),t=t.substring(u)||"/")}return $.URI.from({scheme:L.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$_J=p,e.$_J=p=v=Ke([Ve(1,a.$ym),Ve(2,S.$TJ),Ve(3,A.$4h)],p)}),define(Pe[114],Ae([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$RI=e.$QI=void 0;class E{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new E(0,0)}with(R){return new E(0,0)}}e.$QI=E;class L{constructor(R,$,D,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,$),this.end=new E(D,g)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.$RI=L;var P;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Pe[43],Ae([1,0,18,33,26,46,13,4,19,11,114,12]),function(ve,e,E,L,P,M,R,$,D,g,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.SearchErrorCode=e.$7I=e.$6I=e.SearchSortOrder=e.ViewMode=e.$5I=e.$4I=e.$3I=e.$2I=e.SearchCompletionExitCode=e.$1I=e.$ZI=e.$YI=e.QueryType=e.SearchProviderType=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$SI="workbench.view.search",e.$TI="workbench.panel.search",e.$UI="workbench.view.search",e.$VI="search-result",e.$WI="search.exclude";const a="\u27EA ",v=" characters skipped \u27EB",p=(a.length+v.length+5)*2;e.$XI=(0,$.$Uh)("searchService");var f;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text"})(t||(e.QueryType=t={}));function i(fe){return!!fe.preview}e.$YI=i;function n(fe){return!!fe.resource}e.$ZI=n;function u(fe){return!!fe.message}e.$1I=u;var o;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class l{constructor(be){this.resource=be,this.results=[]}}e.$2I=l;class r{constructor(be,se,Re,oe){this.ranges=se,this.webviewIndex=oe;const X=Array.isArray(se)?se:[se];if(Re&&Re.matchLines===1&&s(X)){be=(0,R.$uf)(be,Re.matchLines);let j="",ne=0,pe=0;const re=Math.floor(Re.charsPerLine/5),he=[];for(const ue of X){const we=Math.max(ue.startColumn-re,0),ee=ue.startColumn+Re.charsPerLine;if(we>pe+re+p){const de=a+(we-pe)+v;j+=de+be.slice(we,ee),ne+=we-(pe+de.length)}else j+=be.slice(pe,ee);he.push(new h(0,ue.startColumn-ne,ue.endColumn-ne)),pe=ee}this.preview={text:j,matches:Array.isArray(this.ranges)?he:he[0]}}else{const j=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:be,matches:(0,E.$1b)(se,ne=>new c(ne.startLineNumber-j,ne.startColumn,ne.endLineNumber-j,ne.endColumn))}}}}e.$3I=r;function s(fe){const be=fe[0].startLineNumber;for(const se of fe)if(se.startLineNumber!==be||se.endLineNumber!==be)return!1;return!0}class c{constructor(be,se,Re,oe){this.startLineNumber=be,this.startColumn=se,this.endLineNumber=Re,this.endColumn=oe}}e.$4I=c;class h extends c{constructor(be,se,Re){super(be,se,be,Re)}}e.$5I=h;var b;(function(fe){fe.List="list",fe.Tree="tree"})(b||(e.ViewMode=b={}));var m;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function I(fe,be=!0){const se=fe&&fe.files&&fe.files.exclude,Re=be&&fe&&fe.search&&fe.search.exclude;if(!se&&!Re)return;if(!se||!Re)return se||Re;let oe=Object.create(null);return oe=P.$cn(oe,P.$_m(se)),oe=P.$cn(oe,P.$_m(Re),!0),oe}e.$6I=I;function k(fe,be){return fe.excludePattern&&L.$Aj(fe.excludePattern,be)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&L.$Aj(fe.includePattern,be)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(se=>{const Re=se.folder.fsPath;if(M.$1f(be,Re)){const oe=D.$kc(Re,be);return!se.includePattern||!!L.$Aj(se.includePattern,oe)}else return!1}):!1:!0}e.$7I=k;var d;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(d||(e.SearchErrorCode=d={}));class w extends Error{constructor(be,se){super(be),this.code=se}}e.$8I=w;function y(fe){const be=fe.message;if((0,g.$3)(fe))return new w(be,d.canceled);try{const se=JSON.parse(be);return new w(se.message,se.code)}catch{return new w(be,d.other)}}e.$9I=y;function C(fe){const be={message:fe.message,code:fe.code};return new Error(JSON.stringify(be))}e.$0I=C;function W(fe){return fe.type==="error"?!0:fe.type==="success"}e.$$I=W;function H(fe){return fe.type==="success"}e.$_I=H;function U(fe){return!!fe.path}e.$aJ=U;function z(fe,be){const se=fe.searchPath?fe.searchPath:fe.relativePath;return(0,R.$rf)(se,be)}e.$bJ=z;class F{constructor(be){this.path=be,this.results=[]}addMatch(be){this.results.push(be)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$cJ=F;function N(fe,be){const se={...fe||{},...be||{}};return Object.keys(se).filter(Re=>{const oe=se[Re];return typeof oe=="boolean"&&oe})}e.$dJ=N;class x{constructor(be,se){this.c=null,this.a={...be.excludePattern||{},...se.excludePattern||{}},this.b=L.$Bj(this.a);let Re=be.includePattern;se.includePattern&&(Re?Re={...Re,...se.includePattern}:Re=se.includePattern),Re&&(this.c=L.$Bj(Re))}matchesExcludesSync(be,se,Re){return!!(this.b&&this.b(be,se,Re))}includedInQuerySync(be,se,Re){return!(this.b&&this.b(be,se,Re)||this.c&&!this.c(be,se,Re))}includedInQuery(be,se,Re){const oe=this.b(be,se,Re),X=()=>this.c?!!this.c(be,se,Re):!0;return(0,S.$Jg)(oe)?oe.then(j=>j?!1:X()):X()}hasSiblingExcludeClauses(){return J(this.a)}}e.$eJ=x;function J(fe){for(const be in fe)if(typeof fe[be]!="boolean")return!0;return!1}function Ee(fe){if(!fe)return;let be;return se=>(be||(be=(fe()||Promise.resolve([])).then(Re=>Re?Ce(Re):{})),be.then(Re=>!!Re[se]))}e.$fJ=Ee;function De(fe){if(!fe)return;let be;return se=>{if(!be){const Re=fe();be=Re?Ce(Re):{}}return!!be[se]}}e.$gJ=De;function Ce(fe){const be={};for(const se of fe)be[se]=!0;return be}}),define(Pe[35],Ae([1,0,18,12,20,5,6,51,14,121,25,13,2,170,4,15,189,47,42,27,17,8,7,59,43,3,52]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o,l,r,s,c,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=void 0;function m(H,U,z){return new A.$ng(F=>w(F,z)).isEqual(H,U)}function I(H,U,z){return m(H.uri,U.uri,z)?0:(0,S.$Xe)(H.uri.toString(),U.uri.toString())}function k(H,U,z){return H.index!==U.index?H.index<U.index?-1:1:m(H.uri,U.uri,z)?(0,S.$Xe)(H.name,U.name):(0,S.$Xe)(H.uri.toString(),U.uri.toString())}function d(H,U,z,F){const N=H.slice(0).sort((J,Ee)=>z(J,Ee,F)),x=U.slice(0).sort((J,Ee)=>z(J,Ee,F));return(0,E.$Db)(N,x,(J,Ee)=>z(J,Ee,F))}function w(H,U){const z=U.getCapabilities(H.scheme);return!(z&&z&1024)}class y extends i.$bi{static toExtHostWorkspace(U,z,F,N){if(!U)return{workspace:null,added:[],removed:[]};const{id:x,name:J,folders:Ee,configuration:De,transient:Ce,isUntitled:fe}=U,be=[],se=z;z?Ee.forEach((j,ne)=>{const pe=a.URI.revive(j.uri),re=y.o(F||z,pe,N);re?(re.name=j.name,re.index=j.index,be.push(re)):be.push({uri:pe,name:j.name,index:ne})}):be.push(...Ee.map(({uri:j,name:ne,index:pe})=>({uri:a.URI.revive(j),name:ne,index:pe}))),be.sort((j,ne)=>j.index<ne.index?-1:1);const Re=new y(x,J,be,!!Ce,De?a.URI.revive(De):null,!!fe,j=>w(j,N)),{added:oe,removed:X}=d(se?se.workspaceFolders:[],Re.workspaceFolders,I,N);return{workspace:Re,added:oe,removed:X}}static o(U,z,F){for(let N=0;N<U.folders.length;N++){const x=U.workspaceFolders[N];if(m(x.uri,z,F))return x}}constructor(U,z,F,N,x,J,Ee){super(U,F.map(De=>new i.$ci(De)),N,x,Ee),this.t=z,this.u=J,this.q=[],this.s=$.$1h.forUris(Ee),F.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(U,z){return z&&this.s.get(U)&&(U=(0,A.$xg)(U)),this.s.findSubstr(U)}resolveWorkspaceFolder(U){return this.s.get(U)}}let C=class{constructor(U,z,F,N,x){this.c=new M.$Qd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Qd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Sd,this.B=new Map,this.h=N,this.s=F,this.t=x,this.j=new g.$Vl,this.k=new L.$Vg,this.o=U.getProxy(h.$zK.MainThreadWorkspace),this.q=U.getProxy(h.$zK.MainThreadMessageService);const J=z.workspace;this.l=J?new y(J.id,J.name,[],!!J.transient,J.configuration?a.URI.revive(J.configuration):null,!!J.isUntitled,Ee=>w(Ee,F)):void 0}$initializeWorkspace(U,z){this.v=z,this.$acceptWorkspaceData(U),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:D.Schemas.untitled,path:(0,A.$vg)((0,A.$xg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(U,z,F,...N){const x=[];if(Array.isArray(N)&&N.forEach(fe=>{a.URI.isUri(fe.uri)&&!x.some(be=>m(be.uri,fe.uri,this.s))&&x.push({uri:fe.uri,name:fe.name||(0,A.$ug)(fe.uri)})}),this.n||[z,F].some(fe=>typeof fe!="number"||fe<0)||F===0&&x.length===0)return!1;const J=this.x?this.x.workspaceFolders:[];if(z+F>J.length)return!1;const Ee=J.slice(0);Ee.splice(z,F,...x.map(fe=>({uri:fe.uri,name:fe.name||(0,A.$ug)(fe.uri),index:void 0})));for(let fe=0;fe<Ee.length;fe++){const be=Ee[fe];if(Ee.some((se,Re)=>Re!==fe&&m(be.uri,se.uri,this.s)))return!1}Ee.forEach((fe,be)=>fe.index=be);const{added:De,removed:Ce}=d(J,Ee,k,this.s);if(De.length===0&&Ce.length===0)return!1;if(this.o){const fe=U.displayName||U.name;this.o.$updateWorkspaceFolders(fe,z,F,x).then(void 0,be=>{this.n=void 0;const se={source:{identifier:U.identifier,label:U.displayName||U.name}};this.q.$showMessage(t.Severity.Error,(0,v.localize)(0,null,fe,be.toString()),se,[])})}return this.y(Ee),!0}getWorkspaceFolder(U,z){if(this.x)return this.x.getWorkspaceFolder(U,z)}async getWorkspaceFolder2(U,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(U,z)}async resolveWorkspaceFolder(U){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(U)}getPath(){if(!this.x)return;const{folders:U}=this.x;if(U.length!==0)return U[0].uri.fsPath}getRelativePath(U,z){let F,N="";if(typeof U=="string"?(F=a.URI.file(U),N=U):typeof U<"u"&&(F=U,N=U.fsPath),!F)return N;const x=this.getWorkspaceFolder(F,!0);if(!x)return N;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let J=(0,A.$Ag)(x.uri,F);return z&&x.name&&(J=`${x.name}/${J}`),J}y(U){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:U,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:z,added:F,removed:N}=y.toExtHostWorkspace(U,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:N}))}findFiles(U,z,F,N,x=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let J;if(z===null?J=!1:z&&(typeof z=="string"?J=z:J=z.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:Ee,folder:De}=W(l.GlobPattern.from(U));return this.o.$startFileSearch(Ee??null,De??null,J??null,F??null,x).then(Ce=>Array.isArray(Ce)?Ce.map(fe=>a.URI.revive(fe)):[])}async findTextInFiles(U,z,F,N,x=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const J=this.j.getNext(),Ee=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:De,folder:Ce}=W(l.GlobPattern.from(z.include)),fe=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,be={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:Ee,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:De,excludePattern:fe},se=!1;if(this.u[J]=Re=>{if(se)return;const oe=a.URI.revive(Re.resource);Re.results.forEach(X=>{const j=(0,b.$rh)(X);(0,c.$YI)(j)?F({uri:oe,preview:{text:j.preview.text,matches:(0,E.$1b)(j.preview.matches,ne=>new r.$DK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,E.$1b)(j.ranges,ne=>new r.$DK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):F({uri:oe,text:j.text,lineNumber:j.lineNumber})})},x.isCancellationRequested)return{};try{const Re=await this.o.$startTextSearch(U,Ce??null,be,J,x);return delete this.u[J],Re||{}}catch(Re){throw delete this.u[J],Re}}$handleTextSearchResult(U,z){this.u[z]?.(U)}async save(U){const z=await this.o.$save(U,{saveAs:!1});return a.URI.revive(z)}async saveAs(U){const z=await this.o.$save(U,{saveAs:!0});return a.URI.revive(z)}saveAll(U){return this.o.$saveAll(U)}resolveProxy(U){return this.o.$resolveProxy(U)}get trusted(){return this.v}requestWorkspaceTrust(U){return this.o.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(U,z){if(this.w.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.w.set(U,z);const F=this.t.transformOutgoingScheme(U),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,F),(0,R.$Pc)(()=>{this.w.delete(U),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(U,z){this.h.info("Getting edit session identifier for workspaceFolder",U);const F=await this.resolveWorkspaceFolder(a.URI.revive(U));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const N=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!N),!N)return;const x=await N.provideEditSessionIdentity(F,z);if(this.h.info("Provider returned edit session identifier: ",x),!!x)return x}async $provideEditSessionIdentityMatch(U,z,F,N){this.h.info("Getting edit session identifier for workspaceFolder",U);const x=await this.resolveWorkspaceFolder(a.URI.revive(U));if(!x){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",x);const J=this.w.get(x.uri.scheme);if(this.h.info(`Provider for scheme ${x.uri.scheme} is defined: `,!!J),!J)return;const Ee=await J.provideEditSessionIdentityMatch?.(z,F,N);if(this.h.info("Provider returned edit session identifier match result: ",Ee),!!Ee)return Ee}getOnWillCreateEditSessionIdentityEvent(U){return(z,F,N)=>{const x=function(Ee){z.call(F,Ee)};return x.extension=U,this.A.event(x,void 0,N)}}async $onWillCreateEditSessionIdentity(U,z,F){const N=await this.resolveWorkspaceFolder(a.URI.revive(U));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},z,async(x,J)=>{const Ee=Date.now();await Promise.resolve(x),Date.now()-Ee>F&&this.h.warn("SLOW edit session create-participant",J.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(U,z){if(this.B.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.B.set(U,z);const F=this.t.transformOutgoingScheme(U),N=this.z++;return this.o.$registerCanonicalUriProvider(N,F),(0,R.$Pc)(()=>{this.B.delete(U),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(U,z,F){const N=this.B.get(U.scheme);if(!N)return;const x=await N.provideCanonicalUri?.(a.URI.revive(U),z,F);if(x)return x}async $provideCanonicalUri(U,z,F){return this.provideCanonicalUri(a.URI.revive(U),{targetScheme:z},F)}};e.$Ldc=C,e.$Ldc=C=Ke([Ve(0,o.$BM),Ve(1,u.$RM),Ve(2,n.$zdc),Ve(3,f.$cj),Ve(4,s.$Jdc)],C),e.$Mdc=(0,p.$Uh)("IExtHostWorkspace");function W(H){let U,z;return H&&(typeof H=="string"?U=H:(U=H.pattern,z=a.URI.revive(H.baseUri))),{includePattern:U,folder:z}}}),define(Pe[36],Ae([1,0,26,5,35,3,7,191,56,16,12,4,17,15,2]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.$Odc=e.$Ndc=void 0;function f(s,c){if(c){const h=c.split(".");let b=s;for(let m=0;b&&m<h.length;m++)b=b[h[m]];return b}}function t(s){return s instanceof p.URI}function i(s){return s&&s.uri instanceof p.URI&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function u(s){return s&&s.uri instanceof p.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function o(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(n(s))return{overrideIdentifier:s.languageId};if(u(s))return{resource:s.uri};if(s===null)return{resource:null}}let l=class{constructor(c,h,b){this.a=c.getProxy(M.$zK.MainThreadConfiguration),this.c=h,this.b=b,this.d=new A.$Vg,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new r(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,h){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(c,h))}};e.$Ndc=l,e.$Ndc=l=Ke([Ve(0,a.$BM),Ve(1,P.$Mdc),Ve(2,v.$cj)],l);class r{constructor(c,h,b,m){this.a=new L.$Qd,this.b=c,this.f=m,this.c=h,this.e=$.$Jn.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,h){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Jn.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(h,b))}getConfiguration(c,h,b){const m=o(h)||{},I=this.g(c?f(this.e.getValue(void 0,m,this.c.workspace),c):this.e.getValue(void 0,m,this.c.workspace));c&&this.h(c,m,b?.identifier);function k(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(w){return typeof f(I,w)<"u"},get:(w,y)=>{this.h(c?`${c}.${w}`:w,m,b?.identifier);let C=f(I,w);if(typeof C>"u")C=y;else{let W;const H=(U,z)=>{if((0,g.$Df)(U)){let F;const N=()=>{W=W||(0,E.$_m)(I),F=F||f(W,z)};return new Proxy(U,{get:(x,J)=>{if(typeof J=="string"&&J.toLowerCase()==="tojson")return N(),()=>F;if(W)return F=F||f(W,z),F[J];const Ee=x[J];return typeof J=="string"?H(Ee,`${z}.${J}`):Ee},set:(x,J,Ee)=>(N(),F&&(F[J]=Ee),!0),deleteProperty:(x,J)=>(N(),F&&delete F[J],!0),defineProperty:(x,J,Ee)=>(N(),F&&Object.defineProperty(F,J,Ee),!0)})}return Array.isArray(U)?(0,E.$_m)(U):U};C=H(C,w)}return C},update:(w,y,C,W)=>{w=c?`${c}.${w}`:w;const H=k(C);return y!==void 0?this.b.$updateConfigurationOption(H,w,y,m,W):this.b.$removeConfigurationOption(H,w,m,W)},inspect:w=>{w=c?`${c}.${w}`:w;const y=this.e.inspect(w,m,this.c.workspace);if(y)return{key:w,defaultValue:(0,E.$_m)(y.policy?.value??y.default?.value),globalValue:(0,E.$_m)(y.user?.value??y.application?.value),workspaceValue:(0,E.$_m)(y.workspace?.value),workspaceFolderValue:(0,E.$_m)(y.workspaceFolder?.value),defaultLanguageValue:(0,E.$_m)(y.default?.override),globalLanguageValue:(0,E.$_m)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,E.$_m)(y.workspace?.override),workspaceFolderLanguageValue:(0,E.$_m)(y.workspaceFolder?.override),languageIds:(0,E.$_m)(y.overrideIdentifiers)}}};return typeof I=="object"&&(0,E.$cn)(d,I,!1),Object.freeze(d)}g(c){const h=b=>(0,g.$Df)(b)?new Proxy(b,{get:(m,I)=>h(m[I]),set:(m,I,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(m,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(m,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return h(c)}h(c,h,b){const m=D.$An.test(c)?4:this.d.get(c),I=b?`[${b.value}] `:"";if(m===4){typeof h?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){h?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,h){const b=new $.$Ln(c,h,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,I)=>b.affectsConfiguration(m,o(I))})}k(c){return c.reduce((h,b)=>(h.set(b[0],b[1]),h),new Map)}}e.$Odc=r,e.$Pdc=(0,S.$Uh)("IExtHostConfiguration")}),define(Pe[115],Ae([1,0,2,12,5,3,7,35,62,36,20,65,17,27,4,14,21,15,81,230,11]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=e.$Mec=e.$Lec=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(l||(l={}));var r;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(r||(r={}));var s;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(s||(s={}));var c;(function(H){function U(N){if(N){const x=N;return x&&!!x.process}else return!1}H.is=U;function z(N){if(N==null)return;const x={process:N.process,args:N.args};return N.options&&(x.options=s.from(N.options)),x}H.from=z;function F(N){if(N!=null)return new R.$jL(N.process,N.args,N.options)}H.to=F})(c||(c={}));var h;(function(H){function U(F){if(F!=null)return F}H.from=U;function z(F){if(F!=null)return F}H.to=z})(h||(h={}));var b;(function(H){function U(N){if(N){const x=N;return x&&(!!x.commandLine||!!x.command)}else return!1}H.is=U;function z(N){if(N==null)return;const x={};return N.commandLine!==void 0?x.commandLine=N.commandLine:(x.command=N.command,x.args=N.args),N.options&&(x.options=h.from(N.options)),x}H.from=z;function F(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new R.$kL(N.commandLine,N.options):new R.$kL(N.command,N.args?N.args:[],N.options)}H.to=F})(b||(b={}));var m;(function(H){function U(N){if(N){const x=N;return x&&x.customExecution==="customExecution"}else return!1}H.is=U;function z(N){return{customExecution:"customExecution"}}H.from=z;function F(N,x){return x.get(N)}H.to=F})(m||(e.CustomExecutionDTO=m={}));var I;(function(H){function U(z,F){let N;return z.scope!==void 0&&typeof z.scope!="number"?N=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&F&&F.workspaceFile?N=F.workspaceFile:N=u.$0F),{id:z._id,workspaceFolder:N}}H.from=U})(I||(e.TaskHandleDTO=I={}));var k;(function(H){function U(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}H.from=U})(k||(k={}));var d;(function(H){function U(N,x){if(N==null)return[];const J=[];for(const Ee of N){const De=z(Ee,x);De&&J.push(De)}return J}H.fromMany=U;function z(N,x){if(N==null)return;let J;N.execution instanceof R.$jL?J=c.from(N.execution):N.execution instanceof R.$kL?J=b.from(N.execution):N.execution&&N.execution instanceof R.$lL&&(J=m.from(N.execution));const Ee=l.from(N.definition);let De;return N.scope?typeof N.scope=="number"?De=N.scope:De=N.scope.uri:De=R.TaskScope.Workspace,!Ee||!De?void 0:{_id:N._id,definition:Ee,name:N.name,source:{extensionId:x.identifier.value,label:N.source,scope:De},execution:J,isBackground:N.isBackground,group:k.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}H.from=z;async function F(N,x,J){if(N==null)return;let Ee;c.is(N.execution)?Ee=c.to(N.execution):b.is(N.execution)?Ee=b.to(N.execution):m.is(N.execution)&&(Ee=m.to(N._id,J));const De=l.to(N.definition);let Ce;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Ce=N.source.scope:Ce=await x.resolveWorkspaceFolder(E.URI.revive(N.source.scope)):Ce=R.TaskScope.Workspace),!De||!Ce)return;const fe=new R.$mL(De,Ce,N.name,N.source.label,Ee,N.problemMatchers);return N.isBackground!==void 0&&(fe.isBackground=N.isBackground),N.group!==void 0&&(fe.group=R.$iL.from(N.group._id),fe.group&&N.group.isDefault&&(fe.group=new R.$iL(fe.group.id,fe.group.label),N.group.isDefault===!0&&(fe.group.isDefault=N.group.isDefault))),N.presentationOptions&&(fe.presentationOptions=r.to(N.presentationOptions)),N._id&&(fe._id=N._id),N.detail&&(fe.detail=N.detail),fe}H.to=F})(d||(e.TaskDTO=d={}));var w;(function(H){function U(F){return F}H.from=U;function z(F){if(F)return Object.assign(Object.create(null),F)}H.to=z})(w||(w={}));class y{#e;constructor(U,z,F){this._id=z,this.a=F,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let C=class{constructor(U,z,F,N,x,J,Ee,De){this.q=new P.$Qd,this.r=new P.$Qd,this.s=new P.$Qd,this.t=new P.$Qd,this.a=U.getProxy(M.$zK.MainThreadTask),this.b=F,this.c=N,this.d=x,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,z,F){if(!F)return new R.$BK(()=>{});const N=this.w();return this.j.set(N,{type:z,provider:F,extension:U}),this.a.$registerTaskProvider(N,z),new R.$BK(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(U,z){this.a.$registerTaskSystem(U,z)}fetchTasks(U){return this.a.$fetchTasks(w.from(U)).then(async z=>{const F=[];for(const N of z){const x=await d.to(N,this.b,this.m);x&&F.push(x)}return F})}get taskExecutions(){const U=[];return this.k.forEach(z=>U.push(z)),U}terminateTask(U){if(!(U instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,z,F){const N=this.m.get(U.id);N&&(this.o.set(U.id,N),this.e.attachPtyToTerminal(z,await N.callback(F))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const z=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const z=await this.y(U.id);this.s.fire({execution:z,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const z=await this.y(U.id);this.t.fire({execution:z,exitCode:U.exitCode})}$provideTasks(U,z){const F=this.j.get(U);if(!F)return Promise.reject(new Error("no handler found"));const N=[],x=(0,L.$Pg)(()=>F.provider.provideTasks(A.CancellationToken.None)).then(J=>this.u(z,N,F,J));return new Promise(J=>{x.then(Ee=>{Promise.all(N).then(()=>{J(Ee)})})})}async $resolveTask(U,z){const F=this.j.get(U);if(!F)return Promise.reject(new Error("no handler found"));if(z.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${F.type}].`);const N=await d.to(z,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const x=await F.provider.resolveTask(N,A.CancellationToken.None);if(!x)return;this.z(x,F);const J=d.from(x,F.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(J.execution)&&await this.x(J,x,!0),await this.v(J)}w(){return this.h++}async x(U,z,F){const N=await this.a.$createTaskId(U);!F&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,z.execution)),this.m.set(N,z.execution)}async y(U,z){if(typeof U=="string"){const x=this.l.get(U);if(!x)throw new o.$ab("Unexpected: The specified task is missing an execution");return x}const F=this.l.get(U.id);if(F)return F;const N=new Promise((x,J)=>{function Ee(De,Ce,fe){fe?x(new y(De,Ce.id,fe)):J("Unexpected: Task does not exist.")}z?Ee(this,U,z):d.to(U.task,this.b,this.m).then(De=>Ee(this,U,De))});return this.l.set(U.id,N),N.then(x=>(this.k.set(U.id,x),x),x=>Promise.reject(x))}z(U,z){U._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const F=this.n.values();let N=F.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=F.next()}};e.$Lec=C,e.$Lec=C=Ke([Ve(0,a.$BM),Ve(1,v.$RM),Ve(2,$.$Mdc),Ve(3,D.$MM),Ve(4,g.$Pdc),Ve(5,S.$8dc),Ve(6,i.$cj),Ve(7,n.$Cdc)],C);let W=class extends C{constructor(U,z,F,N,x,J,Ee,De){super(U,z,F,N,x,J,Ee,De),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(U,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const F=d.from(z,U);if(F===void 0)throw new Error("Task is not valid");if(m.is(F.execution))await this.x(F,z,!1);else throw new o.$$;const N=await this.y(await this.a.$getTaskExecution(F),z);return this.a.$executeTask(F).catch(x=>{throw new Error(x)}),N}u(U,z,F,N){const x=[];if(N)for(const J of N){if(this.z(J,F),!J.definition||!U[J.definition.type]){const De=J.source?J.source:"No task source";this.f.warn(`The task [${De}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`)}const Ee=d.from(J,F.extension);Ee&&m.is(Ee.execution)?(x.push(Ee),z.push(this.x(Ee,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:x,extension:F.extension}}async v(U){if(m.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,z,F){}};e.$Mec=W,e.$Mec=W=Ke([Ve(0,a.$BM),Ve(1,v.$RM),Ve(2,$.$Mdc),Ve(3,D.$MM),Ve(4,g.$Pdc),Ve(5,S.$8dc),Ve(6,i.$cj),Ve(7,n.$Cdc)],W),e.$Nec=(0,p.$Uh)("IExtHostTask")}),define(Pe[284],Ae([1,0,43,29]),function(ve,e,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xK=e.$wK=e.$vK=void 0;function P(R){return"cellResults"in R}e.$vK=P,e.$wK="rawCell#";function M(R,$){let D=-1;const g=[];let A=[];return R.forEach(a=>{a.range.startLineNumber!==D&&A.length>0&&(g.push([...A]),A=[]),A.push(a),D=a.range.endLineNumber}),A.length>0&&g.push([...A]),g.map(a=>{const v=[],p=a[0].range.startLineNumber,f=a[a.length-1].range.endLineNumber;for(let t=p;t<=f;t++)v.push($.getLineContent(t));return new E.$3I(v.join(`
`)+`
`,a.map(t=>new L.$zs(t.range.startLineNumber-1,t.range.startColumn-1,t.range.endLineNumber-1,t.range.endColumn-1)))})}e.$xK=M}),define(Pe[285],Ae([1,0,163,24,5,6,28,13,16,2,41,75,3,32,8,7,49,222,107,11,26,14,213,284,282]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o,l,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,I,k,d,w,y){this.q=k,this.r=d,this.s=w,this.t=y,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new P.$Qd({onListenerError:u.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Qd({onListenerError:u.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Qd({onListenerError:u.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Qd({onListenerError:u.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$wdc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(a.$zK.MainThreadNotebook),this.c=m.getProxy(a.$zK.MainThreadNotebookDocuments),this.d=m.getProxy(a.$zK.MainThreadNotebookEditors),this.i=I.converter,I.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const W=C.notebookEditor?.notebookUri,H=C.cell.handle,z=this.g.get(W)?.getCell(H);if(z)return z.apiCell}if(C&&C.$mid===14){const W=C.uri,H=this.g.get(W);if(H)return H.apiNotebook}return C}}),h.B(I)}getEditorById(m){const I=this.h.get(m);if(!I)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return I}getIdByEditor(m){for(const[I,k]of this.h)if(k.apiEditor===m)return I}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,I){const k=this.g.get(m);if(!k&&!I)throw new Error(`NO notebook document for '${m}'`);return k}static u(m,I){if(!I)return;const k=I.filenamePattern.map(d=>p.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(I.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${I.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:I.displayName,filenamePattern:k,exclusive:I.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,I,k){const d=h.a++,w=typeof k.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(d,k),this.b.$registerNotebookCellStatusBarItemProvider(d,w,I);let y;return w!==void 0&&(y=k.onDidChangeCellStatusBarItems(C=>this.b.$emitCellStatusBarEvent(w))),new f.$BK(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,w),y?.dispose()})}async createNotebookDocument(m){const I=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&p.NotebookData.from(m.content)});return g.URI.revive(I)}async openNotebookDocument(m){const I=this.g.get(m);if(I)return I.apiNotebook;const k=await this.c.$tryOpenNotebook(m),d=this.g.get(g.URI.revive(k));return(0,D.$Mf)(d?.apiNotebook)}async showNotebookDocument(m,I){g.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let k;typeof I=="object"?k={position:p.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selections:I.selections&&I.selections.map(p.NotebookRange.from),pinned:typeof I.preview=="boolean"?!I.preview:void 0}:k={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,k),w=d&&this.h.get(d)?.apiEditor;if(w)return w;throw d?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,I,k,d){const w=this.f.get(m),y=g.URI.revive(I),C=this.g.get(y);if(!C||!w)return;const W=C.getCellFromIndex(k);if(!W)return;const H=await w.provideCellStatusBarItems(W.apiCell,d);if(!H)return;const U=new M.$Qc,z=this.p.add([U]),N=(Array.isArray(H)?H:[H]).map(x=>p.NotebookStatusBarItem.from(x,this.i,U));return{cacheId:z,items:N}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,I,k,d,w){if((0,$.$Ee)(I))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:I,serializer:k,options:d}),this.b.$registerNotebookSerializer(y,{id:m.identifier,location:m.extensionLocation},I,p.NotebookDocumentContentOptions.from(d),h.u(m,w)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(m,I,k){const d=this.x.get(m);if(!d)throw new Error("NO serializer found");const w=await d.serializer.deserializeNotebook(I.buffer,k);return new t.$wv(p.NotebookData.from(w))}async $notebookToData(m,I,k){const d=this.x.get(m);if(!d)throw new Error("NO serializer found");const w=await d.serializer.serializeNotebook(p.NotebookData.to(I.value),k);return L.$ee.wrap(w)}async $saveNotebook(m,I,k,d,w){const y=g.URI.revive(I),C=this.x.get(m);if(!C)throw new Error("NO serializer found");const W=this.g.get(y);if(!W)throw new Error("Document NOT found");if(W.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new A.$yk((0,E.localize)(0,null,this.z(y)),6);await this.y(y,d);const H={metadata:(0,o.$hn)(W.apiNotebook.metadata,x=>!(C.options?.transientDocumentMetadata??{})[x]),cells:[]};for(const x of W.apiNotebook.getCells()){const J=new f.$ZL(x.kind,x.document.getText(),x.document.languageId,x.mime,C.options?.transientOutputs?[]:[...x.outputs],x.metadata,x.executionSummary);J.metadata=(0,o.$hn)(x.metadata,Ee=>!(C.options?.transientCellMetadata??{})[Ee]),H.cells.push(J)}const U=await C.serializer.serializeNotebook(H,w);await this.s.value.writeFile(y,U);const z=this.s.getFileSystemProviderExtUri(y.scheme),F=await this.s.value.stat(y);return{name:z.basename(y),isFile:(F.type&A.FileType.File)!==0,isDirectory:(F.type&A.FileType.Directory)!==0,isSymbolicLink:(F.type&A.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((F.permissions??0)&A.FilePermission.Locked),etag:A.$Jk({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(m,I,k,d,w){const y=this.x.get(m)?.serializer;if(!y)return{limitHit:!1,results:[]};const C=new R.$Ac;await(async(F,N,x)=>{await Promise.all(F.map(async J=>await Promise.all(J.filenamePatterns.map(Ee=>{const De={...x,type:1,filePattern:Ee};return this.t.doInternalFileSearchWithCustomCallback(De,N,Ce=>{Ce.forEach(fe=>{C.has(fe)||d.some(se=>J.isFromSettings&&!se.isFromSettings?!1:se.filenamePatterns.some(Re=>(0,c.$Ccb)(Re,fe)))||C.add(fe)})})}))))})(k,w,I);const H=new R.$zc;let U=!1;const z=Array.from(C).map(async F=>{const N=[];try{if(w.isCancellationRequested)return;if(I.maxResults&&[...H.values()].reduce((De,Ce)=>De+Ce.cellResults.length,0)>I.maxResults){U=!0;return}const x=[],J=this.g.get(F);if(J)J.apiNotebook.getCells().forEach(Ce=>x.push({input:Ce.document.getText(),outputs:Ce.outputs.flatMap(fe=>fe.items.map(be=>be.data.toString()))}));else{const De=await this.s.value.readFile(F),Ce=L.$ee.fromString(De.toString()),fe=await y.deserializeNotebook(Ce.buffer,w);if(w.isCancellationRequested)return;p.NotebookData.from(fe).cells.forEach(se=>x.push({input:se.source,outputs:se.outputs.flatMap(Re=>Re.items.map(oe=>oe.valueBytes.toString()))}))}if(w.isCancellationRequested)return;x.forEach((De,Ce)=>{const fe=I.contentPattern.pattern,be=new r.$LOb(De.input,void 0,De.outputs),se=be.findInInputs(fe),Re=be.findInOutputs(fe),oe=Re.flatMap(X=>(0,s.$xK)(X.matches,X.textBuffer)).map((X,j)=>(X.webviewIndex=j,X));if(se.length>0||Re.length>0){const X={index:Ce,contentResults:(0,s.$xK)(se,be.inputTextBuffer),webviewResults:oe};N.push(X)}});const Ee={resource:F,cellResults:N};H.set(F,Ee);return}catch{return}});return await Promise.all(z),{limitHit:U,results:[...H.values()]}}async y(m,I){const k=await this.s.value.stat(m);if(typeof I?.mtime=="number"&&typeof I.etag=="string"&&I.etag!==A.$Ik&&typeof k.mtime=="number"&&typeof k.size=="number"&&I.mtime<k.mtime&&I.etag!==A.$Jk({mtime:I.mtime,size:k.size}))throw new A.$yk((0,E.localize)(1,null),3,I)}z(m){return m.scheme===l.Schemas.file?m.fsPath:m.toString()}A(m,I,k){if(this.h.has(I))throw new Error(`editor with id ALREADY EXSIST: ${I}`);const d=new n.$8ec(I,this.d,m,k.visibleRanges.map(p.NotebookRange.to),k.selections.map(p.NotebookRange.to),typeof k.viewColumn=="number"?p.ViewColumn.to(k.viewColumn):void 0);this.h.set(I,d)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const k of m.value.removedDocuments){const d=g.URI.revive(k),w=this.g.get(d);w&&(w.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(w.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===d.toString()&&this.h.delete(y.id)}if(m.value.addedDocuments){const k=[];for(const d of m.value.addedDocuments){const w=g.URI.revive(d.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const y=new i.$7ec(this.c,this.q,this.r,w,d);k.push(...d.cells.map(C=>i.$6ec.asModelAddData(y.apiNotebook,C))),this.g.get(w)?.dispose(),this.g.set(w,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(y.apiNotebook)}}if(m.value.addedEditors)for(const k of m.value.addedEditors){if(this.h.has(k.id))return;const d=g.URI.revive(k.documentUri),w=this.g.get(d);w&&this.A(w,k.id,k)}const I=[];if(m.value.removedEditors)for(const k of m.value.removedEditors){const d=this.h.get(k);d&&(this.h.delete(k),this.k?.id===d.id&&(this.k=void 0),I.push(d))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const k=new Set;this.l.forEach(d=>k.add(d.id));for(const d of this.h.values()){const w=k.has(d.id);d._acceptVisibility(w)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const I=v.$ZM.String.with("notebookType","A notebook type"),k=new v.$2M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[I,new v.$ZM("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>L.$ee.wrap(w))],new v.$1M("Notebook Data",w=>p.NotebookData.to(w.value))),d=new v.$2M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[I,new v.$ZM("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new t.$wv(p.NotebookData.from(w)))],new v.$1M("Bytes",w=>w.buffer));m.registerApiCommand(k),m.registerApiCommand(d)}}e.$9ec=h}),define(Pe[286],Ae([1,0,19,20,39,33,25,50,43]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class g{constructor(a,v,p){this.k=a,this.l=v,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&M.$Bj(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&M.$Bj(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const v=this.k.folderQueries||[];return new Promise((p,f)=>{const t=i=>{this.f++,a(i)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const n=i.toString(),u=E.$mc(n);this.j&&this.j(n,u)||this.v(t,{base:i,basename:u})}),Promise.all(v.map(i=>this.p(i,t))).then(i=>{p({limitHit:this.e,stats:i[0]||void 0})},i=>{f(new Error((0,P.$Fi)(i)))})})}async p(a,v){const p=new L.$1d,f=this.q(a),t=this.r(),i=new D.$eJ(this.k,a),n=!i.hasSiblingExcludeClauses();let u;try{this.h.add(p),u=$.$Md.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,p.token),l=u.elapsed(),r=$.$Md.create();return this.g&&!this.e||(o&&o.forEach(s=>{const c=E.$fc.relative(a.folder.path,s.path);if(n){const h=E.$mc(s.path);this.v(v,{base:a.folder,relativePath:c,basename:h});return}this.s(t,a.folder,c,v)}),this.g&&!this.e)?null:(this.u(t,i,v),{providerTime:l,postProcessTime:r.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(a){const v=(0,D.$dJ)(this.k.includePattern,a.includePattern),p=(0,D.$dJ)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:p,includes:v,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},v,p,f){if(p===this.a){const i=E.$mc(this.a);this.v(f,{base:v,relativePath:this.a,basename:i})}function t(i){const n=E.$mc(i),u=E.$lc(i);let o=a[u];o||(o=a[u]=[],t(u)),o.push({base:v,relativePath:i,basename:n})}t(p)}u({rootEntries:a,pathToEntries:v},p,f){const t=this,i=this.a;function n(u){const o=(0,D.$gJ)(()=>u.map(l=>l.basename));for(let l=0,r=u.length;l<r;l++){const s=u[l],{relativePath:c,basename:h}=s;if(p.matchesExcludesSync(c,h,i!==h?o:void 0))continue;const b=v[c];if(b)n(b);else{if(c===i)continue;t.v(f,s)}if(t.e)break}}n(a)}v(a,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,v,p,f){const t=this.c(a.cacheKey),i=new g(a,v,t&&t.token);let n=0;const u=o=>{n+=o.length,p(o.map(l=>this.d(l)))};return this.e(i,A.a,u,f).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:o.stats}}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new L.$1d),this.b.get(a)}d(a){return a.relativePath?{resource:R.$yg(a.base,a.relativePath)}:{resource:a.base}}e(a,v,p,f){const t=f.onCancellationRequested(()=>{a.cancel()}),i=u=>{u&&(n.push(u),v>0&&n.length>=v&&(p(n),n=[]))};let n=[];return a.search(i).then(u=>(n.length&&p(n),t.dispose(),u),u=>(n.length&&p(n),t.dispose(),Promise.reject(u)))}}e.$Xec=A}),define(Pe[287],Ae([1,0,18,248,33,94,28,14,19,25,13,16,2,93,181,40,15,47,105,283,43]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$aK=void 0;let l=class{constructor(w,y,C,W,H){this.a=w,this.b=y,this.c=C,this.d=W,this.e=H}text(w,y,C={}){w=this.f(w,C);const W=this.a.getValue(),H=y&&y.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(y?.map(i.$di),C),type:2,contentPattern:w,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:W.search.usePCRE2||H||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(w,y){const C=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const W={...w,wordSeparators:C.editor.wordSeparators};return this.j(w,y)&&(W.isCaseSensitive=!0),this.k(w)&&(W.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),W}file(w,y={}){return{...this.h(w,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(w,y){return w?(w=Array.isArray(w)?w.map(b):b(w),y?this.parseSearchPaths(w):{pattern:s(...Array.isArray(w)?w:[w])}):{}}h(w=[],y={}){const C=this.g(y.includePattern,y.expandPatterns),W=this.g(y.excludePattern,y.expandPatterns),H=w.length>1,U=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(N=>this.q(N,y,W)):w.map(N=>this.r(N,y,W,H))).filter(N=>!!N),z={_reason:y._reason,folderQueries:U,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:W.pattern,includePattern:C.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const N=E.$Gb(E.$Qb(this.c.groups.map(Ee=>Ee.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const x=N.filter(Ee=>(0,o.$7I)(z,Ee.fsPath)),J=this.i(x);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...z,...J}}const F=y.extraFileResources&&y.extraFileResources.filter(N=>(0,o.$7I)(z,N.fsPath));return z.extraFileResources=F&&F.length?F:void 0,z}i(w){const y=[],C=new R.$zc,W={};let H=!1;return w.forEach(U=>{if(U.scheme===$.Schemas.walkThrough)return;if((0,g.$Cg)(U)){const F=this.b.getWorkspaceFolder(U)?.uri??U.with({path:D.$lc(U.fsPath)});let N=C.get(F);N||(H=!0,N={folder:F,includePattern:{}},y.push(N),C.set(F,N));const x=D.$kc(F.fsPath,U.fsPath);(0,S.$Mf)(N.includePattern)[x.replace(/\\/g,"/")]=!0}else U.fsPath&&(H=!0,W[U.fsPath]=!0)}),{folderQueries:y,includePattern:W,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}j(w,y){if(y.isSmartCase){if(w.isRegExp){if(A.$sf(w.pattern,!0))return!0}else if(A.$sf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,v.$BB)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const y=J=>D.$hc(J)||/^\.\.?([\/\\]|$)/.test(J),W=(Array.isArray(w)?w:c(w)).map(J=>{const Ee=this.e.resolvedUserHome;return Ee?(0,M.$Av)(J,Ee.scheme===$.Schemas.file?Ee.fsPath:Ee.path):J}),H=L.$J(W,J=>y(J)?"searchPaths":"exprSegments"),U=(H.exprSegments||[]).map(J=>A.$Ne(J,"/")).map(J=>A.$Ne(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),h(J))),z={},F=this.m(H.searchPaths||[]);F&&F.length&&(z.searchPaths=F);const N=E.$Qb(U),x=s(...N);return x&&(z.pattern=x),z}l(w,y){return y.disregardExcludeSettings?void 0:(0,o.$6I)(w,!y.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const y=w.flatMap(W=>{let{pathPortion:H,globPortion:U}=r(W);return U&&(U=m(U)),this.n(H).flatMap(F=>this.o(F,U))}),C=new Map;return y.forEach(W=>{const H=W.searchPath.toString(),U=C.get(H);U?W.pattern&&(U.pattern=U.pattern||{},U.pattern[W.pattern]=!0):C.set(H,{searchPath:W.searchPath,pattern:W.pattern?s(W.pattern):void 0})}),Array.from(C.values())}n(w){if(D.$hc(w)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==$.Schemas.file?[{searchPath:y[0].uri.with({path:w})}]:[{searchPath:a.URI.file(D.$gc(w))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(w=b(w),w.startsWith("../")||w===".."){const W=D.$fc.resolve(y.path,w);return[{searchPath:y.with({path:W})}]}const C=m(w);return[{searchPath:y,pattern:C}]}else{if(w==="./"||w===".\\")return[];{const y=w.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(H=>{const U=y.match(new RegExp(`^${A.$Ie(H.name)}(?:/(.*)|$)`));return U?{match:U,folder:H}:null}).filter(S.$Jf);if(W.length)return W.map(H=>{const U=H.match[1];return{searchPath:H.folder.uri,pattern:U&&m(U)}});{const H=w.match(/\.[\/\\](.+)[\/\\]?/),U=H?H[1]:w,z=p.localize(0,null,U);throw new Error(z)}}}}o(w,y){const C=w.pattern&&y?`${w.pattern}/${y}`:w.pattern||y,W=[{searchPath:w.searchPath,pattern:C}];return C&&!C.endsWith("**")&&W.push({searchPath:w.searchPath,pattern:C+"/**"}),W}q(w,y,C){const W=this.r((0,i.$di)(w.searchPath),y,C,!1);return W?{...W,includePattern:w.pattern}:null}r(w,y,C,W){let H;const U=a.URI.isUri(w)?w:w.uri;if(C.searchPaths){const J=C.searchPaths.filter(Ee=>(0,g.$rg)(Ee.searchPath,U))[0];if(J&&!J.pattern)return null;J&&(H=J.pattern)}const z=this.a.getValue({resource:U}),N={...this.l(z,y)||{},...H||{}},x=a.URI.isUri(w)?(0,g.$vg)(w):w.name;return{folder:U,folderName:W?x:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!z.search.followSymlinks}}};e.$aK=l,e.$aK=l=Ke([Ve(0,f.$oi),Ve(1,i.$4h),Ve(2,n.$FC),Ve(3,t.$cj),Ve(4,u.$$J)],l);function r(d){const w=d.match(/[\*\{\}\(\)\[\]\?]/);if(w){const y=w.index,C=d.substr(0,y).match(/[/|\\][^/\\]*$/);if(C){let W=d.substr(0,C.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:d.substr((C.index||0)+1)}}}return{pathPortion:d}}function s(...d){return d.length?d.reduce((w,y)=>(w[y]=!0,w),Object.create(null)):void 0}function c(d){return P.$zj(d,",").map(w=>w.trim()).filter(w=>!!w.length)}function h(d){return[`**/${d}/**`,`**/${d}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function b(d){return d.replace(/\\/g,"/")}function m(d){return b(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(d){return d.replace(/([?*[\]])/g,"[$1]")}function k(d,w){d=E.$Lb(d,W=>W.toString());const y=[],C=w.getWorkspace();return d&&d.forEach(W=>{let H;if(w.getWorkbenchState()===2)H=(0,g.$Ag)(C.folders[0].uri,W),H&&H!=="."&&(H="./"+H);else{const U=w.getWorkspaceFolder(W);if(U){const z=U.name;if(C.folders.filter(N=>N.name===z).length===1){const N=(0,g.$Ag)(U.uri,W);N===""?H=`./${U.name}`:H=`./${U.name}/${N}`}else H=W.fsPath}}H&&y.push(I(H))}),y}e.$bK=k}),define(Pe[288],Ae([1,0,25,2,20,11,4,287,43,47]),function(ve,e,E,L,P,M,R,$,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qb=e.$9qb=void 0;const A=7e3;function S(f,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],u=[];for(const h of i)if(/^workspaceContains:/.test(h)){const b=h.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||f.forceUsingSearch?u.push(b):n.push(b)}if(n.length===0&&u.length===0)return Promise.resolve(void 0);let o;const l=new Promise((h,b)=>{o=h}),r=h=>o({activationEvent:h}),s=Promise.all(n.map(h=>a(f,h,r))).then(()=>{}),c=v(f,t.identifier,u,r);return Promise.all([s,c]).then(()=>{o(void 0)}),l}e.$9qb=S;async function a(f,t,i){for(const n of f.folders)if(await f.exists(E.$yg(L.URI.revive(n),t))){i(`workspaceContains:${t}`);return}}async function v(f,t,i,n){if(i.length===0)return Promise.resolve(void 0);const u=new P.$1d,o=f.checkExists(f.folders,i,u.token),l=setTimeout(async()=>{u.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},A);let r=!1;try{r=await o}catch(s){M.$3(s)||M.$Z(s)}u.dispose(),clearTimeout(l),r&&n(`workspaceContains:${i.join(",")}`)}function p(f,t,i,n){const u=f.get(R.$Th),o=f.get(D.$XI),r=u.createInstance($.$aK).file(t.map(s=>(0,g.$di)(L.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return o.fileSearch(r,n).then(s=>!!s.limitHit,s=>M.$3(s)?!1:Promise.reject(s))}e.$0qb=p}),define(Pe[37],Ae([1,0,160,19,88,25,12,6,51,2,15,3,36,219,85,35,23,106,11,22,24,202,7,100,4,27,86,17,72,87,65,5,288,84,204,14,82,50,21,83]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o,l,r,s,c,h,b,m,I,k,d,w,y,C,W,H,U,z,F,N){"use strict";var x;Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=e.$jec=e.$iec=e.$hec=e.$gec=void 0,e.$gec=(0,c.$Uh)("IHostUtils");let J=x=class extends $.$Rc{constructor(X,j,ne,pe,re,he,ue,we,ee,de,ie,ce){super(),this.X=ce,this.a=this.B(new w.$Qd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=j,this.g=ne,this.f=ue,this.j=pe,this.m=re,this.s=he,this.t=ee,this.u=de,this.w=ie,this.y=this.g.getProxy(S.$zK.MainThreadWorkspace),this.z=this.g.getProxy(S.$zK.MainThreadTelemetry),this.C=this.g.getProxy(S.$zK.MainThreadExtensionService),this.D=new R.$Vg,this.F=new R.$Vg,this.G=new R.$Vg,this.H=new R.$Vg,this.I=new Re(this.f.extensions.activationEvents),this.L=new i.$N5b(this.I,this.f.extensions.allExtensions);const me=new u.$_l(this.f.extensions.myExtensions);this.J=new i.$N5b(this.I,be(this.L,me)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Ce(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Ce(this.J)}`)),this.M=new p.$Zdc(this.g,this.s),this.N=new C.$_dc(this.g),this.O=we,this.h=X.createChild(new I.$Sh([p.$1dc,this.M],[C.$aec,this.N])),this.P=this.B(new v.$Ydc(this.J,this.L,{onExtensionActivationError:(Ie,T,V)=>{this.C.$onExtensionActivationError(Ie,n.$2(T),V)},actualActivateExtension:async(Ie,T)=>{if(i.$N5b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,T),new v.$Xdc;const V=this.J.getExtensionDescription(Ie);return this.db(V,T)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(X){n.$Z(X)}}async Y(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(re=>re.identifier).filter(re=>this.isActivated(re)).map(re=>this.cb(re))}catch{}await Promise.all(X)}terminate(X,j=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(pe=>{this.s.error(pe)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$Xg)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${j}`):this.s.info(`Extension host exiting with code ${j}`),this.s.flush(),this.s.dispose(),this.c.exit(j)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const j=await this.C.$getExtension(X);return j&&{...j,identifier:new u.$$l(j.identifier.value),extensionLocation:g.URI.revive(j.extensionLocation)}}Z(X,j){return this.P.activateByEvent(X,j)}$(X,j){return this.P.activateById(X,j)}activateByIdWithErrors(X,j){return this.$(X,j).then(()=>{const ne=this.P.getActivatedExtension(X);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async ab(X){if(X.scheme===H.Schemas.file&&this.c.fsRealpath){const j=await this.c.fsRealpath(X.fsPath);return g.URI.file(j)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(X=>new se(X))),this.Q}async bb(X){const j=D.$1h.forUris(ne=>M.$pg.ignorePathCasing(ne));return await Promise.all(X.map(async ne=>{if(this.ub(ne)){const pe=await this.ab(ne.extensionLocation);j.set(pe,ne)}})),j}cb(X){let j=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return j;const ne=this.P.getActivatedExtension(X);if(!ne)return j;try{typeof ne.module.deactivate=="function"&&(j=Promise.resolve(ne.module.deactivate()).then(void 0,pe=>(this.s.error(pe),Promise.resolve(void 0))))}catch(pe){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(pe)}try{(0,$.$Mc)(ne.subscriptions)}catch(pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(pe)}return j}async db(X,j){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.fb(X,j).then(ne=>{const pe=ne.activationTimes;return this.C.$onDidActivateExtension(X.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,j),this.eb(X,j,"success",pe),ne},ne=>{throw this.eb(X,j,"failure"),ne})}eb(X,j,ne,pe){const re=De(X,j);this.z.$publicLog2("extensionActivationTimes",{...re,...pe||{},outcome:ne})}fb(X,j){const ne=De(X,j);this.z.$publicLog2("activatePlugin",ne);const pe=this.ub(X);if(!pe)return Promise.resolve(new v.$Wdc(v.$Tdc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${j.startup}, activationEvent: '${j.activationEvent}'${X.identifier.value!==j.extensionId.value?`, root cause: ${j.extensionId.value}`:""}`),this.s.flush();const re=new v.$Udc(j.startup);return Promise.all([this.vb(X,(0,M.$yg)(X.extensionLocation,pe),re),this.gb(X)]).then(he=>(P.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),x.hb(this.s,X.identifier,he[0],he[1],re))).then(he=>(P.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),he))}gb(X){const j=new l.$3dc(X,this.M),ne=new l.$2dc(X.identifier.value,!1,this.M),pe=new W.$bec(X,this.N),re=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,he=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([j.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ue=this;let we,ee;const de=(0,t.$xF)(X,"ipc")?this.f.messagePorts?.get(u.$$l.toKey(X.identifier)):void 0;return Object.freeze({globalState:j,workspaceState:ne,secrets:pe,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(ie){return L.$ic(X.extensionLocation.fsPath,ie)},get storagePath(){return ue.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return ue.O.globalValue(X).fsPath},get logPath(){return L.$ic(ue.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return g.URI.joinPath(ue.f.logsLocation,X.identifier.value)},get storageUri(){return ue.O.workspaceValue(X)},get globalStorageUri(){return ue.O.globalValue(X)},get extensionMode(){return re},get extension(){return we===void 0&&(we=new fe(ue,X.identifier,X,he,!1)),we},get extensionRuntime(){return(0,t.$yF)(X,"extensionRuntime"),ue.extensionRuntime},get environmentVariableCollection(){return ue.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!ee){if(!de)return;const ie=w.Event.buffer(w.Event.fromDOMEventEmitter(de,"message",ce=>ce.data));de.start(),ee={onDidReceiveMessage:ie,postMessage:de.postMessage.bind(de)}}return ee}})})}static hb(X,j,ne,pe,re){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(X,j,ne,pe,re).then(he=>new v.$Vdc(!1,null,re.build(),ne,he,pe.subscriptions))}static ib(X,j,ne,pe,re){if(typeof ne.activate=="function")try{re.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${j.value}`);const he=typeof global=="object"?global:self,ue=ne.activate.apply(he,[pe]);return re.activateCallStop(),re.activateResolveStart(),Promise.resolve(ue).then(we=>(re.activateResolveStop(),we))}catch(he){return Promise.reject(he)}else return Promise.resolve(ne)}jb(X,j){this.$(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:j}).then(void 0,ne=>{this.s.error(ne)})}kb(X,j=0){const pe=Date.now();(0,F.$B)(()=>{for(let re=j;re<X.length;re+=1){const he=X[re];for(const ue of he.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-pe>50){this.kb(X,re);break}else this.jb(he,ue)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(X=>{const j=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(j)this.kb(ne);else for(const pe of ne)if(pe.activationEvents)for(const re of pe.activationEvents)re==="onStartupFinished"&&this.jb(pe,re)})}mb(){const X=this.Z("*",!0).then(void 0,he=>{this.s.error(he)});this.B(this.j.onDidChangeWorkspace(he=>this.nb(he.added)));const j=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(j),pe=this.pb(),re=Promise.all([pe,X,ne]).then(()=>{});return Promise.race([re,(0,R.$Xg)(1e4)]).then(()=>{this.lb()}),re}nb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(j=>this.ob(X,j))).then(()=>{})}async ob(X,j){if(this.isActivated(j.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.s,folders:X.map(he=>he.uri),forceUsingSearch:ne||!this.c.fsExists,exists:he=>this.c.fsExists(he.fsPath),checkExists:(he,ue,we)=>this.y.$checkExists(he,ue,we)},re=await(0,y.$9qb)(pe,j);if(re)return this.$(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:re.activationEvent}).then(void 0,he=>this.s.error(he))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(X){throw console.error(X),X}}async qb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:j}=this.f.environment;if(!X||!j)throw new Error(E.localize(0,null));const ne=await this.vb(null,j,new v.$Udc(!1));if(!ne||typeof ne.run!="function")throw new Error(E.localize(1,null,j.toString()));return new Promise((pe,re)=>{const he=(ee,de)=>{ee?(F.$t&&this.s.error("Test runner called back with error",ee),re(ee)):(F.$t&&(de?this.s.info(`Test runner called back with ${de} failures.`):this.s.info("Test runner called back with successful outcome.")),pe(typeof de=="number"&&de>0?1:0))},ue=(0,M.$mg)(j),we=ne.run(ue,he);we&&we.then&&we.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),pe(0)}).catch(ee=>{F.$t&&this.s.error("Test runner finished with error",ee),re(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Xg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,j){return this.R[X]=j,(0,$.$Pc)(()=>{delete this.R[X]})}async getRemoteExecServer(X){const{resolver:j}=await this.sb(X);return j?.resolveExecServer?.(X,{resolveAttempt:0})}async sb(X){const j=X.indexOf("+");if(j===-1)throw new r.$HK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=X.substr(0,j);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(X,j){const ne=z.$Md.create(!1),pe=()=>`[resolveAuthority(${(0,s.$Yk)(X)},${j})][${ne.elapsed()}ms] `,re=Q=>this.s.info(`${pe()}${Q}`),he=Q=>this.s.warn(`${pe()}${Q}`),ue=(Q,q=void 0)=>this.s.error(`${pe()}${Q}`,q),we=Q=>{if(Q instanceof r.$HK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},ee=async Q=>{re(`activating resolver for ${Q}...`);const{resolver:q,authorityPrefix:_}=await this.sb(Q);if(!q)throw ue(`no resolver for ${_}`),new r.$HK(`No remote extension installed to resolve ${_}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:_,remoteAuthority:Q}},de=X.split(/@|%40/g).reverse();re(`activating remote resolvers ${de.join(" -> ")}`);let ie;try{ie=await Promise.all(de.map(ee)).catch(async Q=>{if(!(Q instanceof r.$HK)||Q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return he(`resolving nested authorities failed: ${Q.message}`),[await ee(X)]})}catch(Q){return we(Q)}const ce=new R.$8g;ce.cancelAndSet(()=>re("waiting..."),1e3);let me,Ie;for(const[Q,{authorityPrefix:q,resolver:_,remoteAuthority:le}]of ie.entries())try{if(Q===ie.length-1)re("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${q}`),me=await _.resolve(le,{resolveAttempt:j,execServer:Ie}),P.mark(`code/extHost/didResolveAuthorityOK/${q}`),re("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(_,r.$GK.isManagedResolvedAuthority(me)?me:void 0));else{if(re(`invoking resolveExecServer() for ${le}`),P.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await _.resolveExecServer?.(le,{resolveAttempt:j,execServer:Ie}),!Ie)throw new r.$HK(`Exec server was not available for ${le}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Oe){return P.mark(`code/extHost/didResolveAuthorityError/${q}`),ue("returned an error",Oe),ce.dispose(),we(Oe)}ce.dispose();const T={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures},V={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};re(`returned ${r.$GK.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let G;if(r.$GK.isManagedResolvedAuthority(me)){const Q=j;this.X.setFactory(Q,me.makeConnection),G={authority:X,connectTo:new s.$Vk(Q),connectionToken:me.connectionToken}}else G={authority:X,connectTo:new s.$Wk(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:G,options:V,tunnelInformation:T}}}async $getCanonicalURI(X,j){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Yk)(X)})`);const{resolver:ne}=await this.sb(X);if(!ne)return null;const pe=g.URI.revive(j);if(typeof ne.getCanonicalURI>"u")return pe;const re=await(0,R.$Pg)(()=>ne.getCanonicalURI(pe));return re||pe}$startExtensionHost(X){X.toAdd.forEach(pe=>pe.extensionLocation=g.URI.revive(pe.extensionLocation));const{globalRegistry:j,myExtensions:ne}=Ee(this.I,this.L,this.J,X);return this.L.set(j.getAllExtensionDescriptions()),this.J.set(ne),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Ce(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Ce(this.J)}`)),this.rb()}$activateByEvent(X,j){return j===1?this.D.wait().then(ne=>this.Z(X,!1)):this.G.wait().then(ne=>this.Z(X,!1))}async $activate(X,j){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.$(X,j),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(he=>he.extensionLocation=g.URI.revive(he.extensionLocation));const{globalRegistry:j,myExtensions:ne}=Ee(this.I,this.L,this.J,X),pe=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.L.set(j.getAllExtensionDescriptions()),this.J.set(ne),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Ce(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Ce(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const j=o.$ee.alloc(X),ne=Math.random()%256;for(let pe=0;pe<X;pe++)j.writeUInt8(ne,pe);return j}async $updateRemoteConnectionData(X){this.W=X,this.a.fire()}};e.$hec=J,e.$hec=J=x=Ke([Ve(0,c.$Th),Ve(1,e.$gec),Ve(2,m.$BM),Ve(3,f.$Mdc),Ve(4,a.$Pdc),Ve(5,A.$cj),Ve(6,h.$RM),Ve(7,b.$6dc),Ve(8,k.$Uwb),Ve(9,d.$8dc),Ve(10,U.$dec),Ve(11,N.$eec)],J);function Ee(oe,X,j,ne){oe.addActivationEvents(ne.addActivationEvents);const pe=new i.$N5b(oe,X.getAllExtensionDescriptions());pe.deltaExtensions(ne.toAdd,ne.toRemove);const re=new u.$_l(j.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of ne.myToRemove)re.delete(ue);for(const ue of ne.myToAdd)re.add(ue);const he=be(pe,re);return{globalRegistry:pe,myExtensions:he}}function De(oe,X){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function Ce(oe){return oe.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$iec=(0,c.$Uh)("IExtHostExtensionService");class fe{#e;#t;#i;constructor(X,j,ne,pe,re){this.#e=X,this.#t=j,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=L.$gc((0,M.$mg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=pe,this.isFromDifferentExtensionHost=re}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$jec=fe;function be(oe,X){return oe.getAllExtensionDescriptions().filter(j=>X.has(j.identifier))}class se{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$kec=se;class Re{constructor(X){this.a=new u.$am,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const j of Object.keys(X))this.a.set(j,X[j])}}}),define(Pe[289],Ae([1,0,88,2,3,36,23,22,17,27,4,37,15,13]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;let f=class{constructor(o,l,r,s,c,h,b){this.c=o,this.d=l,this.e=r,this.f=s,this.g=c,this.h=h,this.i=b,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new i(this.c,l,this.d,o,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,l,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const l of o.nodeModuleName)this.a.set(l,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(l=>o.alternativeModuleName(l))}};e.$Ifc=f,e.$Ifc=f=Ke([Ve(2,A.$Th),Ve(3,M.$Pdc),Ve(4,S.$iec),Ve(5,g.$RM),Ve(6,a.$cj)],f);let t=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&p.a.size){const l=(0,v.$Ie)(this.c(o.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${c}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const l=this.b.exec(this.c(o));if(!l)return;const[,r,s,c]=l,h=p.a.get(s);if(h!==void 0)return console.warn(`${s} as been renamed to ${h}, please update your imports`),r+h+c}c(o){return o.replace(/\\/g,"/")}};t=p=Ke([Ve(0,g.$RM)],t);class i{constructor(o,l,r,s,c){this.c=o,this.d=l,this.e=r,this.f=s,this.g=c,this.nodeModuleName="vscode",this.a=new $.$am}load(o,l){const r=this.d.findSubstr(l);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((c,h)=>s+=`	${h} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$sF,this.e,this.f)}return this.b}}let n=class{constructor(o,l,r){this.e=o,this.f=l,this.nodeModuleName=["open","opn"],this.d=r.getProxy(P.$zK.MainThreadTelemetry);const s=r.getProxy(P.$zK.MainThreadWindow);this.c=(c,h)=>{const b=L.URI.parse(c);return h?this.g(c,h):b.scheme==="http"||b.scheme==="https"?s.$openUri(b,c,{allowTunneling:!0}):b.scheme==="mailto"||b.scheme===this.f?s.$openUri(b,c,{}):this.g(c,h)}}load(o,l,r){const s=this.e.findSubstr(l);return s&&(this.a=s.identifier.value,this.h()),this.b=r(o),this.c}g(o,l){return this.i(),this.b(o,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ke([Ve(2,D.$BM)],n)}),define(Pe[116],Ae([1,0,44,6,19,74,4,62,63,37,7,35,216,36]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=void 0,e.$Qec=(0,R.$Uh)("IExtHostVariableResolverProvider");class p extends a.$CN{constructor(i,n,u,o,l,r,s){function c(){if(u){const h=u.activeEditor();if(h)return h.document.uri;const b=o.tabGroups.all.find(m=>m.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof A.$hM||b.input instanceof A.$mM)return b.input.modified;if(b.input instanceof A.$gM||b.input instanceof A.$lM||b.input instanceof A.$jM)return b.input.uri}}}super({getFolderUri:h=>{const b=r.folders.filter(m=>m.name===h);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(h,b)=>l.getConfiguration(void 0,h).get(b),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const h=c();if(h)return P.$gc(h.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const h=c();if(h){const b=n.getWorkspaceFolder(h);if(b)return P.$gc(b.uri.fsPath)}}},getSelectedText:()=>{if(u){const h=u.activeEditor();if(h&&!h.selection.isEmpty)return h.document.getText(h.selection)}},getLineNumber:()=>{if(u){const h=u.activeEditor();if(h)return String(h.selection.end.line+1)}},getExtension:h=>i.getExtension(h)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let f=class extends L.$Rc{constructor(i,n,u,o,l){super(),this.b=i,this.c=n,this.g=u,this.h=o,this.j=l,this.a=new E.$U(async()=>{const r=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async h=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,r,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$Rec=f,e.$Rec=f=Ke([Ve(0,g.$iec),Ve(1,S.$Mdc),Ve(2,$.$MM),Ve(3,v.$Pdc),Ve(4,D.$Oec)],f)}),define(Pe[117],Ae([1,0,12,5,2,4,3,63,37,17,7,35,208,210,36,116]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=e.$Vec=e.$Uec=e.$Tec=e.$Sec=void 0,e.$Sec=(0,M.$Uh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,c,h,b,m,I){this.E=c,this.F=h,this.G=b,this.H=m,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new L.$Qd,this.n=new L.$Qd,this.o=new L.$Qd,this.u=new L.$Qd,this.k=s.getProxy(R.$zK.MainThreadDebugService),this.y=new L.$Qd,this.A=new L.$Qd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(d=>{this.J(k)}),this.J(k)})}asDebugSourceUri(s,c){const h=s;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let b=`debug:${encodeURIComponent(h.path||"")}`,m="?";return c&&(b+=`${m}session=${encodeURIComponent(c.id)}`,m="&"),b+=`${m}ref=${h.sourceReference}`,P.URI.parse(b)}else{if(h.path)return P.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const c=[];for(const h of s.getAllExtensionDescriptions())if(h.contributes){const b=h.contributes.debuggers;if(b&&b.length>0)for(const m of b)(0,v.$MF)(m)&&c.push(m.type)}this.k.$registerDebugTypes(c)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(c=>s.push(c)),s}addBreakpoints(s){const c=s.filter(m=>{const I=m.id;return this.w.has(I)?!1:(this.w.set(I,m),!0)});this.U(c,[],[]);const h=[],b=new Map;for(const m of c)if(m instanceof A.$AL){let I=b.get(m.location.uri.toString());I||(I={type:"sourceMulti",uri:m.location.uri,lines:[]},b.set(m.location.uri.toString(),I),h.push(I)),I.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof A.$BL&&h.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(h)}removeBreakpoints(s){const c=s.filter(I=>this.w.delete(I.id));this.U([],c,[]);const h=c.filter(I=>I instanceof A.$AL).map(I=>I.id),b=c.filter(I=>I instanceof A.$BL).map(I=>I.id),m=c.filter(I=>I instanceof A.$CL).map(I=>I.id);return this.k.$unregisterBreakpoints(h,b,m)}startDebugging(s,c,h){return this.k.$startDebugging(s?s.uri:void 0,c,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,c,h){if(!c)return new A.$BK(()=>{});const b=this.d++;return this.f.push({type:s,handle:b,provider:c}),this.k.$registerDebugConfigurationProvider(s,h,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,b),new A.$BK(()=>{this.f=this.f.filter(m=>m.provider!==c),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(s,c,h){if(!h)return new A.$BK(()=>{});if(!this.Q(s,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.N(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:c,handle:b,factory:h}),this.k.$registerDebugAdapterDescriptorFactory(c,b),new A.$BK(()=>{this.h=this.h.filter(m=>m.factory!==h),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(s,c){if(!c)return new A.$BK(()=>{});const h=this.i++;return this.j.push({type:s,handle:h,factory:c}),new A.$BK(()=>{this.j=this.j.filter(b=>b.factory!==c)})}async $runInTerminal(s,c){return Promise.resolve(void 0)}async $substituteVariables(s,c){let h;const b=await this.W(s);return b&&(h={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(h,c)}K(s,c){if(s.type==="implementation")return new o(s.implementation)}L(){}async $startDASession(s,c){const h=this,b=await this.V(c);return this.S(this.N(b.type),b).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const I=this.M(m),k=this.K(I,b);if(!k)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const d=k;return this.B.set(s,d),this.R(b).then(w=>(w&&this.C.set(s,w),d.onMessage(async y=>{if(y.type==="request"&&y.command==="handshake"){const C=y,W={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const H=await this.D.sign(C.arguments.value);W.body={signature:H},d.sendResponse(W)}else throw new Error("no signer")}catch(H){W.success=!1,W.message=H.message,d.sendResponse(W)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(y),y=(0,v.$RF)(y,!0),h.k.$acceptDAMessage(s,y)}),d.onError(y=>{w&&w.onError&&w.onError(y),this.k.$acceptDAError(s,y.name,y.message,y.stack)}),d.onExit(y=>{w&&w.onExit&&w.onExit(y??void 0,void 0),this.k.$acceptDAExit(s,y??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),d.startSession()))})}$sendDAMessage(s,c){c=(0,v.$QF)(c,!1);const h=this.C.get(s);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(c),this.B.get(s)?.sendMessage(c)}$stopDASession(s){const c=this.C.get(s);this.C.delete(s),c&&c.onWillStopSession&&c.onWillStopSession();const h=this.B.get(s);return this.B.delete(s),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const c=[],h=[],b=[];if(s.added)for(const m of s.added){const I=m.id;if(I&&!this.w.has(I)){let k;if(m.type==="function")k=new A.$BL(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")k=new A.$CL(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const d=P.URI.revive(m.uri);k=new A.$AL(new A.$NK(d,new A.$CK(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,A.$yL)(k,I),this.w.set(I,k),c.push(k)}}if(s.removed)for(const m of s.removed){const I=this.w.get(m);I&&(this.w.delete(m),h.push(I))}if(s.changed){for(const m of s.changed)if(m.id){const I=this.w.get(m.id);if(I){if(I instanceof A.$BL&&m.type==="function"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.functionName=m.functionName}else if(I instanceof A.$AL&&m.type==="source"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.location=new A.$NK(P.URI.revive(m.uri),new A.$CK(m.line,m.character))}b.push(I)}}}this.U(c,h,b)}async $acceptStackFrameFocus(s){let c;const h=s.sessionId?await this.V(s.sessionId):void 0;if(!h)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?c=new A.$IL(h,s.threadId):c=new A.$HL(h,s.threadId,s.frameId),this.z=c,this.A.fire(this.z)}$provideDebugConfigurations(s,c,h){return(0,E.$Pg)(async()=>{const b=this.P(s);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(c);return b.provideDebugConfigurations(m,h)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(s,c,h,b){return(0,E.$Pg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(c);return m.resolveDebugConfiguration(I,h,b)})}$resolveDebugConfigurationWithSubstitutedVariables(s,c,h,b){return(0,E.$Pg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(c);return m.resolveDebugConfigurationWithSubstitutedVariables(I,h,b)})}async $provideDebugAdapter(s,c){const h=this.O(s);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.V(c);return this.S(h,b).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(s){const c=await this.V(s);this.m.fire(c)}async $acceptDebugSessionTerminated(s){const c=await this.V(s);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,c){(await this.V(s))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(s,c){const b={session:await this.V(s),event:c.event,body:c.body};this.u.fire(b)}M(s){if(s instanceof A.$DL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$EL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$FL)return{type:"pipeServer",path:s.path};if(s instanceof A.$GL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const c=this.h.filter(h=>h.type===s);if(c.length>0)return c[0].factory}O(s){const c=this.h.filter(h=>h.handle===s);if(c.length>0)return c[0].factory}P(s){const c=this.f.filter(h=>h.handle===s);if(c.length>0)return c[0].provider}Q(s,c){if(s.contributes){const h=s.contributes.debuggers;if(h&&h.length>0){for(const b of h)if(b.label&&b.type&&b.type===c)return!0}}return!1}R(s){const h=s.configuration.type,b=this.j.filter(m=>m.type===h||m.type==="*").map(m=>(0,E.$Pg)(()=>m.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(b).then(m=>{const I=m.filter(k=>!!k);if(I.length>0)return new u(I)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(s,c){const h=c.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new A.$EL(h));if(s){const m=await this.F.getExtensionRegistry();return(0,E.$Pg)(()=>s.createDebugAdapterDescriptor(c,this.T(c,m))).then(I=>{if(I)return I})}const b=await this.F.getExtensionRegistry();return Promise.resolve(this.T(c,b))}T(s,c){}U(s,c,h){(s.length>0||c.length>0||h.length>0)&&this.y.fire(Object.freeze({added:s,removed:c,changed:h}))}async V(s){if(s)if(typeof s=="string"){const c=this.l.get(s);if(c)return c}else{let c=this.l.get(s.id);if(!c){const h=await this.W(s.folderUri),b=s.parent?this.l.get(s.parent):void 0;c=new i(this.k,s.id,s.type,s.name,h,s.configuration,b),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(s){if(s){const c=P.URI.revive(s);return this.E.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};e.$Tec=t,e.$Tec=t=Ke([Ve(0,g.$BM),Ve(1,S.$Mdc),Ve(2,D.$iec),Ve(3,p.$Pdc),Ve(4,$.$Oec),Ve(5,f.$Qec)],t);class i{constructor(s,c,h,b,m,I,k){this.d=s,this.f=c,this.g=h,this.h=b,this.i=m,this.j=I,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,c){return this.d.$customDebugAdapterRequest(this.f,s,c)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Uec=i;class n{constructor(s){this.value=Object.freeze({append(c){s.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.$Vec=n;class u{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(c=>c.onError?c.onError(s):void 0)}onExit(s,c){this.d.forEach(h=>h.onExit?h.onExit(s,c):void 0)}}class o extends a.$Odb{constructor(s){super(),this.h=s,s.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends t{constructor(s,c,h,b,m,I){super(s,c,h,b,m,I)}};e.$Wec=l,e.$Wec=l=Ke([Ve(0,g.$BM),Ve(1,S.$Mdc),Ve(2,D.$iec),Ve(3,p.$Pdc),Ve(4,$.$Oec),Ve(5,f.$Qec)],l)}),define(Pe[290],Ae([1,0,11,88,2,3,278,15,71,72,27,186,17,59,37,61]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=e.$Jfc=void 0;class t{static async installEarlyHandler(u){Error.stackTraceLimit=100;const o=u.get($.$cj),r=u.get(a.$BM).getProxy(M.$zK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{o.error(s);const c=E.$2(s);r.$onUnexpectedError(c)})}static async installFullHandler(u){const o=u.get($.$cj),l=u.get(a.$BM),r=u.get(p.$iec),s=u.get(f.$VM),c=l.getProxy(M.$zK.MainThreadExtensionService),h=l.getProxy(M.$zK.MainThreadErrors),b=await r.getExtensionPathIndex(),m=new WeakMap;function I(w,y){if(m.has(w))return m.get(w).stack;let C="",W,H;for(const z of y)C+=`
	at ${z.toString()}`,H=z.getFileName(),!W&&H&&(W=b.findSubstr(P.URI.file(H)));const U=`${w.name||"Error"}: ${w.message||""}${C}`;return m.set(w,{extensionIdentifier:W?.identifier,stack:U}),U}const k=Symbol("prepareStackTrace wrapped");let d=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return d},set(w){if(w===I||!w||w[k]){d=w||I;return}d=function(y,C){return I(y,C),w.call(Error,y,C)},Object.assign(d,{[k]:!0})}}),E.setUnexpectedErrorHandler(w=>{o.error(w);const y=E.$2(w),C=m.get(w);if(!C?.extensionIdentifier){h.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(C.extensionIdentifier,y);const W=s.onExtensionError(C.extensionIdentifier,w);o.trace("forwarded error to extension?",W,C)})}}e.$Jfc=t;class i{constructor(u,o,l,r,s){this.a=l,this.b=new R.$V5b(u,null,r),o=i.e(o,this.b);const c=new g.$Sh(...(0,D.$Dr)());c.set(A.$RM,{_serviceBrand:void 0,...o,messagePorts:s}),c.set(a.$BM,new a.$CM(this.b)),c.set(v.$Jdc,new v.$Kdc(r)),c.set(p.$gec,l);const h=new S.$iq(c,!0);h.invokeFunction(t.installEarlyHandler),this.d=h.invokeFunction(b=>b.get($.$cj)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=h.invokeFunction(b=>b.get(p.$iec)),this.c.initialize(),h.invokeFunction(t.installFullHandler)}async asBrowserUri(u){const o=this.b.getProxy(M.$zK.MainThreadExtensionService);return P.URI.revive(await o.$asBrowserUri(u))}terminate(u){this.c.terminate(u)}static e(u,o){u.extensions.allExtensions.forEach(r=>{r.extensionLocation=P.URI.revive(o.transformIncomingURIs(r.extensionLocation))}),u.environment.appRoot=P.URI.revive(o.transformIncomingURIs(u.environment.appRoot));const l=u.environment.extensionDevelopmentLocationURI;return l&&(u.environment.extensionDevelopmentLocationURI=l.map(r=>P.URI.revive(o.transformIncomingURIs(r)))),u.environment.extensionTestsLocationURI=P.URI.revive(o.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=P.URI.revive(o.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=P.URI.revive(o.transformIncomingURIs(u.environment.workspaceStorageHome)),u.environment.extensionTelemetryLogResource=P.URI.revive(o.transformIncomingURIs(u.environment.extensionTelemetryLogResource)),u.nlsBaseUrl=P.URI.revive(o.transformIncomingURIs(u.nlsBaseUrl)),u.logsLocation=P.URI.revive(o.transformIncomingURIs(u.logsLocation)),u.workspace=o.transformIncomingURIs(u.workspace),u}}e.$Kfc=i}),define(Pe[291],Ae([1,0,18,12,20,39,14,19,25,2,43]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=e.$1ec=e.$Zec=e.$Yec=void 0;class S{constructor(n,u,o,l){this.d=n,this.e=u,this.f=o,this.g=l,this.a=null,this.b=!1,this.c=0}search(n,u){const o=this.d.folderQueries||[],l=new P.$1d(u);return new Promise((r,s)=>{this.a=new v(n);let c=!1;const h=(b,m)=>{if(!c&&!this.b){const I=this.h(b);f(b)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,c=!0,l.cancel(),b=this.j(b,this.d.maxResults-this.c));const k=this.h(b);this.c+=k,(k>0||!f(b))&&this.a.add(b,m)}};Promise.all(o.map((b,m)=>this.k(b,I=>h(I,m),l.token))).then(b=>{l.dispose(),this.a.flush();const m=b.some(I=>!!I&&!!I.limitHit);r({limitHit:this.b||m,messages:(0,E.$Qb)(b.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},b=>{l.dispose();const m=(0,M.$Fi)(b);s(new Error(m))})})}h(n){return f(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,u){const o=Array.isArray(n.ranges)?n.ranges:[n.ranges],l=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:o.slice(0,u),preview:{matches:l.slice(0,u),text:n.preview.text},uri:n.uri}}async k(n,u,o){const l=new A.$eJ(this.d,n),r=[],s={report:b=>{if(!this.l(b))return;const m=n.folder.scheme===R.Schemas.file?(0,A.$fJ)(()=>this.f.readdir(D.$xg(b.uri))):void 0,I=D.$Ag(n.folder,b.uri);if(I){const k=l.includedInQuery(I,$.$mc(I),m);(0,L.$Jg)(k)?r.push(k.then(d=>{d&&u(b)})):k&&u(b)}}},c=this.n(n),h=await this.e.provideTextSearchResults(a(this.d.contentPattern),c,s,o);return r.length&&await Promise.all(r),h}l(n){if(f(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const u=(0,A.$dJ)(this.d.includePattern,n.includePattern),o=(0,A.$dJ)(this.d.excludePattern,n.excludePattern),l={folder:g.URI.from(n.folder),excludes:o,includes:u,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$Yec=S;function a(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class v{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new t(512,u=>this.g(u))}add(n,u){this.d&&(this.b!==u||!D.$rg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=u,this.d={resource:n.uri,results:[]}),this.d.results.push(p(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Zec=v;function p(i){return f(i)?{preview:{matches:(0,E.$1b)(i.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:i.preview.text},ranges:(0,E.$1b)(i.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function f(i){return!!i.preview}e.$1ec=f;class t{static{this.a=4e3}static{this.b=50}constructor(n,u){this.g=n,this.h=u,this.c=0,this.d=[],this.e=0}addItem(n,u){n&&this.j(n,u)}addItems(n,u){n&&this.k(n,u)}j(n,u){this.d.push(n),this.e+=u,this.l()}k(n,u){this.d=this.d.concat(n),this.e+=u,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$2ec=t}),define(Pe[118],Ae([1,0,6,3,4,286,17,59,15,2,291]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=e.$4ec=e.$3ec=void 0,e.$3ec=(0,P.$Uh)("IExtHostSearch");let S=class{constructor(f,t,i){this.k=f,this.l=t,this.n=i,this.c=this.k.getProxy(L.$zK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$Xec}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(f)),(0,E.$Pc)(()=>{this.g.delete(f),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(f)),(0,E.$Pc)(()=>{this.i.delete(f),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(f,t,i,n){const u=a(i),o=this.h.get(f);if(o)return this.j.fileSearch(u,o,l=>{this.c.$handleFileMatch(f,t,l.map(r=>r.resource))},n);throw new Error("unknown provider: "+f)}async doInternalFileSearchWithCustomCallback(f,t,i){return{messages:[]}}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,i,n){const u=this.e.get(f);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const o=a(i);return this.q(o,u).search(r=>this.c.$handleTextMatch(f,t,r),n)}$enableExtensionHostSearch(){}q(f,t){return new A.$Yec(f,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$4ec=S,e.$4ec=S=Ke([Ve(0,R.$BM),Ve(1,$.$Jdc),Ve(2,D.$cj)],S);function a(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(v),extraFileResources:p.extraFileResources&&p.extraFileResources.map(f=>g.URI.revive(f))}}e.$5ec=a;function v(p){return{...p,folder:g.URI.revive(p.folder)}}}),define(Pe[292],Ae([1,0,20,11,5,31,2,146,92,129,142,41,3,79,241,240,32,242,36,244,245,246,221,247,62,37,250,251,256,257,259,112,225,264,265,268,85,65,270,226,8,7,58,273,66,111,35,22,214,255,57,110,115,117,118,15,59,17,27,285,211,87,81,233,271,86,64,276,274,275,234,42,269,272,84,63,61,260,114,261,14,99,224,203,253,6,23,209,82,199,262,263,235,252,223,254,83,266,238,267,239,232,249,236,237]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o,l,r,s,c,h,b,m,I,k,d,w,y,C,W,H,U,z,F,N,x,J,Ee,De,Ce,fe,be,se,Re,oe,X,j,ne,pe,re,he,ue,we,ee,de,ie,ce,me,Ie,T,V,G,Q,q,_,le,Oe,Be,Je,Ge,_e,Ye,xe,it,tt,ze,ut,Y,Z,ye,je,Ne,Ze,nt,$t,bt,Pt,Kt,Ht,vt,Ut,Ot,Gt,Bt,kt,Ft,jt,Qt,Wt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;function Nt(at){const dt=at.get(ee.$RM),At=at.get(Oe.$zdc),qt=at.get(G.$5dc),Rt=at.get(h.$iec),ot=at.get(be.$Mdc),wt=at.get(Ye.$VM),Tt=at.get(n.$Pdc),Ct=at.get(ue.$Jdc),We=at.get(we.$BM),Jt=at.get(U.$1dc),Se=at.get(V.$6dc),Le=at.get(he.$dj),$e=at.get(he.$cj),K=at.get(ce.$Uwb),Me=at.get(me.$Cdc),Ue=at.get(fe.$Gec),Qe=at.get(Ge.$aec),qe=at.get(_e.$Oec),et=at.get(Ot.$eec);We.set(a.$AK.ExtHostFileSystemInfo,At),We.set(a.$AK.ExtHostLogLevelServiceShape,Le),We.set(a.$AK.ExtHostWorkspace,ot),We.set(a.$AK.ExtHostConfiguration,Tt),We.set(a.$AK.ExtHostExtensionService,Rt),We.set(a.$AK.ExtHostStorage,Jt),We.set(a.$AK.ExtHostTunnelService,K),We.set(a.$AK.ExtHostWindow,Ue),We.set(a.$AK.ExtHostSecretState,Qe),We.set(a.$AK.ExtHostTelemetry,wt),We.set(a.$AK.ExtHostEditorTabs,qe),We.set(a.$AK.ExtHostManagedSockets,et);const Et=We.set(a.$AK.ExtHostDecorations,at.get(j.$Kec)),Dt=We.set(a.$AK.ExtHostDocumentsAndEditors,at.get(c.$MM)),gt=We.set(a.$AK.ExtHostCommands,at.get(t.$XM)),ht=We.set(a.$AK.ExtHostTerminalService,at.get(z.$8dc)),ft=We.set(a.$AK.ExtHostDebugService,at.get(pe.$Sec)),ui=We.set(a.$AK.ExtHostSearch,at.get(re.$3ec)),St=We.set(a.$AK.ExtHostTask,at.get(ne.$Nec)),Si=We.set(a.$AK.ExtHostOutputService,at.get(w.$qec)),li=We.set(a.$AK.ExtHostLocalization,at.get(nt.$dec)),$i=We.set(a.$AK.ExtHostUrls,new De.$zec(We)),It=We.set(a.$AK.ExtHostDocuments,new s.$xdc(We,Dt)),gn=We.set(a.$AK.ExtHostDocumentContentProviders,new l.$Rdc(We,Dt,$e)),ri=We.set(a.$AK.ExtHostDocumentSaveParticipant,new r.$Sdc($e,It,We.getProxy(a.$zK.MainThreadBulkEdits))),yt=We.set(a.$AK.ExtHostNotebook,new de.$9ec(We,gt,Dt,It,qt,ui)),pi=We.set(a.$AK.ExtHostNotebookDocuments,new Z.$ofc(yt)),vi=We.set(a.$AK.ExtHostNotebookEditors,new Y.$nfc($e,yt)),si=We.set(a.$AK.ExtHostNotebookKernels,new xe.$kfc(We,dt,yt,gt,$e)),Ii=We.set(a.$AK.ExtHostNotebookRenderers,new tt.$mfc(We,yt)),Ci=We.set(a.$AK.ExtHostNotebookDocumentSaveParticipant,new vt.$ufc($e,yt,We.getProxy(a.$zK.MainThreadBulkEdits))),Mt=We.set(a.$AK.ExtHostEditors,new F.$xec(We,Dt)),bi=We.set(a.$AK.ExtHostTreeViews,new N.$yec(We.getProxy(a.$zK.MainThreadTreeViews),gt,$e)),Pi=We.set(a.$AK.ExtHostEditorInsets,new Re.$Hec(We.getProxy(a.$zK.MainThreadEditorInsets),Mt,dt.remote)),oi=We.set(a.$AK.ExtHostDiagnostics,new u.$Bdc(We,$e,At,Dt)),hi=We.set(a.$AK.ExtHostLanguages,new k.$nec(We,It,gt.converter,Ct)),ct=We.set(a.$AK.ExtHostLanguageFeatures,new I.$Fdc(We,Ct,It,gt,oi,$e,Me,wt)),Ai=We.set(a.$AK.ExtHostFileSystem,new b.$lec(We,ct)),Yt=We.set(a.$AK.ExtHostFileSystemEventService,new m.$mec(We,$e,Dt)),ii=We.set(a.$AK.ExtHostQuickOpen,(0,C.$sec)(We,ot,gt)),Ri=We.set(a.$AK.ExtHostSCM,new W.$uec(We,gt,It,$e)),Mi=We.set(a.$AK.ExtHostQuickDiff,new Pt.$rfc(We,Ct)),Li=We.set(a.$AK.ExtHostShare,new Gt.$wfc(We,Ct)),Zi=We.set(a.$AK.ExtHostComments,(0,i.$Idc)(We,gt,It)),Fi=We.set(a.$AK.ExtHostProgress,new y.$rec(We.getProxy(a.$zK.MainThreadProgress))),Xi=We.set(a.$AK.ExtHosLabelService,new oe.$Iec(We)),Ti=We.set(a.$AK.ExtHostTheming,new ie.$0ec(We)),ai=We.set(a.$AK.ExtHostAuthentication,new Ie.$$ec(We)),mn=We.set(a.$AK.ExtHostTimeline,new T.$afc(We,gt)),Oi=We.set(a.$AK.ExtHostWebviews,new Ce.$Cec(We,dt.remote,ot,$e,Me)),di=We.set(a.$AK.ExtHostWebviewPanels,new _.$cfc(We,Oi,ot)),Ni=We.set(a.$AK.ExtHostCustomEditors,new q.$dfc(We,It,Se,Oi,di)),$n=We.set(a.$AK.ExtHostWebviewViews,new Q.$bfc(We,Oi)),fi=We.set(a.$AK.ExtHostTesting,new Be.$ffc(We,gt,Dt)),Yi=We.set(a.$AK.ExtHostUriOpeners,new Je.$jfc(We)),zi=We.set(a.$AK.ExtHostProfileContentHandlers,new bt.$qfc(We));We.set(a.$AK.ExtHostInteractive,new ye.$pfc(We,yt,Dt,gt,$e));const xi=We.set(a.$AK.ExtHostInlineChat,new Ht.$tfc(We,gt,It,$e)),gi=We.set(a.$AK.ExtHostChatProvider,new Bt.$xfc(We,$e)),_i=We.set(a.$AK.ExtHostChatAgents,new Wt.$Cfc(We,gi,$e)),pn=We.set(a.$AK.ExtHostChatAgents2,new Vt.$Dfc(We,gi,$e)),Ui=We.set(a.$AK.ExtHostChatVariables,new Ft.$zfc(We)),mi=We.set(a.$AK.ExtHostChat,new Kt.$sfc(We,$e)),xt=We.set(a.$AK.ExtHostAiRelatedInformation,new jt.$Afc(We)),wi=We.set(a.$AK.ExtHostAiEmbeddingVector,new Qt.$Bfc(We)),en=We.set(a.$AK.ExtHostIssueReporter,new Ut.$vfc(We)),Zt=We.set(a.$AK.ExtHostStatusBar,new H.$wec(We,gt.converter)),yi=We.set(a.$AK.ExtHostSpeech,new kt.$yfc(We)),tn=Object.values(a.$AK);We.assertRegistered(tn);const nn=new le.$efc(We,Dt),rn=new f.$Hdc(We),Ei=new d.$oec(We,$e),sn=new o.$Qdc(We);return p.$Gdc.register(gt),function(Te,_t,on){const mt=function(){let te=!Te.isUnderDevelopment;function ge(){te||($e.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Fe(rt){if(Array.isArray(rt))rt.forEach(Fe);else if(typeof rt=="string")ge();else{const pt=rt;typeof pt.scheme>"u"&&ge(),typeof pt.exclusive=="boolean"&&(0,Ne.$yF)(Te,"documentFiltersExclusive")}return rt}}(),Bi={getSession(te,ge,Fe){return ai.getSession(Te,te,ge,Fe)},getSessions(te,ge){return(0,Ne.$yF)(Te,"authGetSessions"),ai.getSessions(Te,te,ge)},async hasSession(te,ge){return(0,Ne.$yF)(Te,"authSession"),!!await ai.getSession(Te,te,ge,{silent:!0})},get onDidChangeSessions(){return ai.onDidChangeSessions},registerAuthenticationProvider(te,ge,Fe,rt){return ai.registerAuthenticationProvider(te,ge,Fe,rt)}},an={registerCommand(te,ge,Fe){return gt.registerCommand(!0,te,ge,Fe,void 0,Te)},registerTextEditorCommand(te,ge,Fe){return gt.registerCommand(!0,te,(...rt)=>{const pt=Mt.getActiveTextEditor();if(!pt){$e.warn("Cannot execute "+te+" because there is no active text editor.");return}return pt.edit(Lt=>{ge.apply(Fe,[pt,Lt,...rt])}).then(Lt=>{Lt||$e.warn("Edits from command "+te+" were not applied.")},Lt=>{$e.warn("An error occurred while running command "+te,Lt)})},void 0,void 0,Te)},registerDiffInformationCommand:(te,ge,Fe)=>((0,Ne.$yF)(Te,"diffCommand"),gt.registerCommand(!0,te,async(...rt)=>{const pt=Dt.activeEditor(!0);if(!pt){$e.warn("Cannot execute "+te+" because there is no active text editor.");return}const Lt=await Mt.getDiffInformation(pt.id);ge.apply(Fe,[Lt,...rt])},void 0,void 0,Te)),executeCommand(te,...ge){return gt.executeCommand(te,...ge)},getCommands(te=!1){return gt.getCommands(te)}},ji={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return ht.getDefaultShell(!1)},get onDidChangeShell(){return ht.onDidChangeShell},get isTelemetryEnabled(){return wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return wt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$yF)(Te,"telemetry"),wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$yF)(Te,"telemetry"),wt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ye.$UM)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ge){return Ye.$TM.validateSender(te),wt.instantiateLogger(Te,te,ge)},openExternal(te,ge){return Ue.openUri(te,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===dt.environment.appUriScheme)return $i.createAppUri(te);try{return await Ue.asExternalUri(te,{allowTunneling:!!dt.remote.authority})}catch(ge){if((0,ut.$OU)(te,ze.Schemas.http)||(0,ut.$OU)(te,ze.Schemas.https))return te;throw ge}},get remoteName(){return(0,X.$1k)(dt.remote.authority)},get remoteAuthority(){return(0,Ne.$yF)(Te,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return $e.getLevel()},get onDidChangeLogLevel(){return $e.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Ne.$yF)(Te,"handleIssueUri"),en.registerIssueUriRequestHandler(Te,te)},registerIssueDataProvider(te){return(0,Ne.$yF)(Te,"handleIssueUri"),en.registerIssueDataProvider(Te,te)},get appQuality(){return(0,Ne.$yF)(Te,"resolvers"),dt.quality},get appCommit(){return(0,Ne.$yF)(Te,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(ji);const cn={createTestController(te,ge,Fe){return fi.createTestController(Te,te,ge,Fe)},createTestObserver(){return(0,Ne.$yF)(Te,"testObserver"),fi.createTestObserver()},runTests(te){return(0,Ne.$yF)(Te,"testObserver"),fi.runTests(te)},get onDidChangeTestResults(){return(0,Ne.$yF)(Te,"testObserver"),fi.onResultsChanged},get testResults(){return(0,Ne.$yF)(Te,"testObserver"),fi.results}},Di=dt.remote.isRemote?J.ExtensionKind.Workspace:J.ExtensionKind.UI,vn={getExtension(te,ge){(0,Ne.$xF)(Te,"extensionsAny")||(ge=!1);const Fe=_t.mine.getExtensionDescription(te);if(Fe)return new h.$jec(Rt,Te.identifier,Fe,Di,!1);if(ge){const rt=_t.all.getExtensionDescription(te);if(rt)return new h.$jec(Rt,Te.identifier,rt,Di,!0)}},get all(){const te=[];for(const ge of _t.mine.getAllExtensionDescriptions())te.push(new h.$jec(Rt,Te.identifier,ge,Di,!1));return te},get allAcrossExtensionHosts(){(0,Ne.$yF)(Te,"extensionsAny");const te=new se.$_l(_t.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ge=[];for(const Fe of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Fe.identifier);ge.push(new h.$jec(Rt,Te.identifier,Fe,Di,rt))}return ge},get onDidChange(){return(0,Ne.$xF)(Te,"extensionsAny")?P.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},un={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Te.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(te,ge){return hi.changeLanguage(te.uri,ge)},match(te,ge){const Fe=It.getDocumentData(ge.uri)?.notebook;return(0,A.$KE)(x.LanguageSelector.from(te),ge.uri,ge.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(te,ge,Fe){return ct.registerCodeActionProvider(Te,mt(te),ge,Fe)},registerDocumentPasteEditProvider(te,ge,Fe){return(0,Ne.$yF)(Te,"documentPaste"),ct.registerDocumentPasteEditProvider(Te,mt(te),ge,Fe)},registerCodeLensProvider(te,ge){return ct.registerCodeLensProvider(Te,mt(te),ge)},registerDefinitionProvider(te,ge){return ct.registerDefinitionProvider(Te,mt(te),ge)},registerDeclarationProvider(te,ge){return ct.registerDeclarationProvider(Te,mt(te),ge)},registerImplementationProvider(te,ge){return ct.registerImplementationProvider(Te,mt(te),ge)},registerTypeDefinitionProvider(te,ge){return ct.registerTypeDefinitionProvider(Te,mt(te),ge)},registerHoverProvider(te,ge){return ct.registerHoverProvider(Te,mt(te),ge,Te.identifier)},registerEvaluatableExpressionProvider(te,ge){return ct.registerEvaluatableExpressionProvider(Te,mt(te),ge,Te.identifier)},registerInlineValuesProvider(te,ge){return ct.registerInlineValuesProvider(Te,mt(te),ge,Te.identifier)},registerDocumentHighlightProvider(te,ge){return ct.registerDocumentHighlightProvider(Te,mt(te),ge)},registerLinkedEditingRangeProvider(te,ge){return ct.registerLinkedEditingRangeProvider(Te,mt(te),ge)},registerReferenceProvider(te,ge){return ct.registerReferenceProvider(Te,mt(te),ge)},registerRenameProvider(te,ge){return ct.registerRenameProvider(Te,mt(te),ge)},registerDocumentSymbolProvider(te,ge,Fe){return ct.registerDocumentSymbolProvider(Te,mt(te),ge,Fe)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Te,te)},registerDocumentFormattingEditProvider(te,ge){return ct.registerDocumentFormattingEditProvider(Te,mt(te),ge)},registerDocumentRangeFormattingEditProvider(te,ge){return ct.registerDocumentRangeFormattingEditProvider(Te,mt(te),ge)},registerOnTypeFormattingEditProvider(te,ge,Fe,...rt){return ct.registerOnTypeFormattingEditProvider(Te,mt(te),ge,[Fe].concat(rt))},registerDocumentSemanticTokensProvider(te,ge,Fe){return ct.registerDocumentSemanticTokensProvider(Te,mt(te),ge,Fe)},registerDocumentRangeSemanticTokensProvider(te,ge,Fe){return ct.registerDocumentRangeSemanticTokensProvider(Te,mt(te),ge,Fe)},registerSignatureHelpProvider(te,ge,Fe,...rt){return typeof Fe=="object"?ct.registerSignatureHelpProvider(Te,mt(te),ge,Fe):ct.registerSignatureHelpProvider(Te,mt(te),ge,typeof Fe>"u"?[]:[Fe,...rt])},registerCompletionItemProvider(te,ge,...Fe){return ct.registerCompletionItemProvider(Te,mt(te),ge,Fe)},registerInlineCompletionItemProvider(te,ge,Fe){return ge.handleDidShowCompletionItem&&(0,Ne.$yF)(Te,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$yF)(Te,"inlineCompletionsAdditions"),Fe&&(0,Ne.$yF)(Te,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Te,mt(te),ge,Fe)},registerDocumentLinkProvider(te,ge){return ct.registerDocumentLinkProvider(Te,mt(te),ge)},registerColorProvider(te,ge){return ct.registerColorProvider(Te,mt(te),ge)},registerFoldingRangeProvider(te,ge){return ct.registerFoldingRangeProvider(Te,mt(te),ge)},registerSelectionRangeProvider(te,ge){return ct.registerSelectionRangeProvider(Te,te,ge)},registerCallHierarchyProvider(te,ge){return ct.registerCallHierarchyProvider(Te,te,ge)},registerTypeHierarchyProvider(te,ge){return ct.registerTypeHierarchyProvider(Te,te,ge)},setLanguageConfiguration:(te,ge)=>ct.setLanguageConfiguration(Te,te,ge),getTokenInformationAtPosition(te,ge){return(0,Ne.$yF)(Te,"tokenInformation"),hi.tokenAtPosition(te,ge)},registerInlayHintsProvider(te,ge){return ct.registerInlayHintsProvider(Te,te,ge)},createLanguageStatusItem(te,ge){return hi.createLanguageStatusItem(Te,te,ge)},registerDocumentDropEditProvider(te,ge,Fe){return ct.registerDocumentOnDropEditProvider(Te,te,ge,(0,Ne.$xF)(Te,"dropMetadata")?Fe:void 0)}},ln={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return ht.activeTerminal},get terminals(){return ht.terminals},async showTextDocument(te,ge,Fe){const rt=await(R.URI.isUri(te)?Promise.resolve(ki.openTextDocument(te)):Promise.resolve(te));return Mt.showTextDocument(rt,ge,Fe)},createTextEditorDecorationType(te){return Mt.createTextEditorDecorationType(Te,te)},onDidChangeActiveTextEditor(te,ge,Fe){return Mt.onDidChangeActiveTextEditor(te,ge,Fe)},onDidChangeVisibleTextEditors(te,ge,Fe){return Mt.onDidChangeVisibleTextEditors(te,ge,Fe)},onDidChangeTextEditorSelection(te,ge,Fe){return Mt.onDidChangeTextEditorSelection(te,ge,Fe)},onDidChangeTextEditorOptions(te,ge,Fe){return Mt.onDidChangeTextEditorOptions(te,ge,Fe)},onDidChangeTextEditorVisibleRanges(te,ge,Fe){return Mt.onDidChangeTextEditorVisibleRanges(te,ge,Fe)},onDidChangeTextEditorViewColumn(te,ge,Fe){return Mt.onDidChangeTextEditorViewColumn(te,ge,Fe)},onDidCloseTerminal(te,ge,Fe){return ht.onDidCloseTerminal(te,ge,Fe)},onDidOpenTerminal(te,ge,Fe){return ht.onDidOpenTerminal(te,ge,Fe)},onDidChangeActiveTerminal(te,ge,Fe){return ht.onDidChangeActiveTerminal(te,ge,Fe)},onDidChangeTerminalDimensions(te,ge,Fe){return(0,Ne.$yF)(Te,"terminalDimensions"),ht.onDidChangeTerminalDimensions(te,ge,Fe)},onDidChangeTerminalState(te,ge,Fe){return ht.onDidChangeTerminalState(te,ge,Fe)},onDidWriteTerminalData(te,ge,Fe){return(0,Ne.$yF)(Te,"terminalDataWriteEvent"),ht.onDidWriteTerminalData(te,ge,Fe)},onDidExecuteTerminalCommand(te,ge,Fe){return(0,Ne.$yF)(Te,"terminalExecuteCommandEvent"),ht.onDidExecuteTerminalCommand(te,ge,Fe)},get state(){return Ue.getState(Te)},onDidChangeWindowState(te,ge,Fe){return Ue.onDidChangeWindowState(te,ge,Fe)},showInformationMessage(te,...ge){return Ei.showMessage(Te,M.default.Info,te,ge[0],ge.slice(1))},showWarningMessage(te,...ge){return Ei.showMessage(Te,M.default.Warning,te,ge[0],ge.slice(1))},showErrorMessage(te,...ge){return Ei.showMessage(Te,M.default.Error,te,ge[0],ge.slice(1))},showQuickPick(te,ge,Fe){return ii.showQuickPick(Te,te,ge,Fe)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,ge){return ii.showInput(te,ge)},showOpenDialog(te){return sn.showOpenDialog(Te,te)},showSaveDialog(te){return sn.showSaveDialog(te)},createStatusBarItem(te,ge,Fe){let rt,pt,Lt;return typeof te=="string"?(rt=te,pt=ge,Lt=Fe):(pt=te,Lt=ge),Zt.createStatusBarEntry(Te,rt,pt,Lt)},setStatusBarMessage(te,ge){return Zt.setStatusBarMessage(te,ge)},withScmProgress(te){return Me.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Fi.withProgress(Te,{location:J.ProgressLocation.SourceControl},(ge,Fe)=>te({report(rt){}}))},withProgress(te,ge){return Fi.withProgress(Te,te,ge)},createOutputChannel(te,ge){return Si.createOutputChannel(te,ge,Te)},createWebviewPanel(te,ge,Fe,rt){return di.createWebviewPanel(Te,te,ge,Fe,rt)},createWebviewTextEditorInset(te,ge,Fe,rt){return(0,Ne.$yF)(Te,"editorInsets"),Pi.createWebviewEditorInset(te,ge,Fe,rt,Te)},createTerminal(te,ge,Fe){return typeof te=="object"?"pty"in te?ht.createExtensionTerminal(te):ht.createTerminalFromOptions(te):ht.createTerminal(te,ge,Fe)},registerTerminalLinkProvider(te){return ht.registerLinkProvider(te)},registerTerminalProfileProvider(te,ge){return ht.registerProfileProvider(Te,te,ge)},registerTerminalQuickFixProvider(te,ge){return(0,Ne.$yF)(Te,"terminalQuickFixProvider"),ht.registerTerminalQuickFixProvider(te,Te.identifier.value,ge)},registerTreeDataProvider(te,ge){return bi.registerTreeDataProvider(te,ge,Te)},createTreeView(te,ge){return bi.createTreeView(te,ge,Te)},registerWebviewPanelSerializer:(te,ge)=>di.registerWebviewPanelSerializer(Te,te,ge),registerCustomEditorProvider:(te,ge,Fe={})=>Ni.registerCustomEditorProvider(Te,te,ge,Fe),registerFileDecorationProvider(te){return Et.registerFileDecorationProvider(te,Te)},registerUriHandler(te){return $i.registerUriHandler(Te,te)},createQuickPick(){return ii.createQuickPick(Te)},createInputBox(){return ii.createInputBox(Te)},get activeColorTheme(){return Ti.activeColorTheme},onDidChangeActiveColorTheme(te,ge,Fe){return Ti.onDidChangeActiveColorTheme(te,ge,Fe)},registerWebviewViewProvider(te,ge,Fe){return $n.registerWebviewViewProvider(Te,te,ge,Fe?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ge,Fe){return yt.onDidChangeActiveNotebookEditor(te,ge,Fe)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,ge,Fe){return vi.onDidChangeNotebookEditorSelection(te,ge,Fe)},onDidChangeNotebookEditorVisibleRanges(te,ge,Fe){return vi.onDidChangeNotebookEditorVisibleRanges(te,ge,Fe)},showNotebookDocument(te,ge){return yt.showNotebookDocument(te,ge)},registerExternalUriOpener(te,ge,Fe){return(0,Ne.$yF)(Te,"externalUriOpener"),Yi.registerExternalUriOpener(Te.identifier,te,ge,Fe)},registerProfileContentHandler(te,ge){return(0,Ne.$yF)(Te,"profileContentHandlers"),zi.registrProfileContentHandler(Te,te,ge)},registerQuickDiffProvider(te,ge,Fe,rt){return(0,Ne.$yF)(Te,"quickDiffProvider"),Mi.registerQuickDiffProvider(mt(te),ge,Fe,rt)},get tabGroups(){return qe.tabGroups},registerShareProvider(te,ge){return(0,Ne.$yF)(Te,"shareProvider"),Li.registerShareProvider(mt(te),ge)}},ki={get rootPath(){return Me.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw new L.$8("rootPath")},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw new L.$8("name")},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw new L.$8("workspaceFile")},updateWorkspaceFolders:(te,ge,...Fe)=>ot.updateWorkspaceFolders(Te,te,ge||0,...Fe),onDidChangeWorkspaceFolders:function(te,ge,Fe){return ot.onDidChangeWorkspace(te,ge,Fe)},asRelativePath:(te,ge)=>ot.getRelativePath(te,ge),findFiles:(te,ge,Fe,rt)=>ot.findFiles(te,ge,Fe,Te.identifier,rt),findTextInFiles:(te,ge,Fe,rt)=>{(0,Ne.$yF)(Te,"findTextInFiles");let pt,Lt;return typeof ge=="object"?(pt=ge,Lt=Fe):(pt={},Lt=ge,rt=Fe),ot.findTextInFiles(te,pt||{},Lt,Te.identifier,rt)},save:te=>((0,Ne.$yF)(Te,"saveEditor"),ot.save(te)),saveAs:te=>((0,Ne.$yF)(Te,"saveEditor"),ot.saveAs(te)),saveAll:te=>ot.saveAll(te),applyEdit(te,ge){return nn.applyWorkspaceEdit(te,Te,ge)},createFileSystemWatcher:(te,ge,Fe,rt)=>{let pt;return typeof ge=="boolean"?pt={ignoreCreateEvents:!!ge,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!rt,correlate:!1}:ge&&((0,Ne.$yF)(Te,"createFileSystemWatcher"),pt={...ge,correlate:!0}),Yt.createFileSystemWatcher(ot,Te,te,pt)},get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new L.$8("textDocuments")},openTextDocument(te){let ge;const Fe=te;if(typeof te=="string")ge=Promise.resolve(R.URI.file(te));else if(R.URI.isUri(te))ge=Promise.resolve(te);else if(!Fe||typeof Fe=="object")ge=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(rt=>It.ensureDocumentData(rt).then(pt=>pt.document))},onDidOpenTextDocument:(te,ge,Fe)=>It.onDidAddDocument(te,ge,Fe),onDidCloseTextDocument:(te,ge,Fe)=>It.onDidRemoveDocument(te,ge,Fe),onDidChangeTextDocument:(te,ge,Fe)=>It.onDidChangeDocument(te,ge,Fe),onDidSaveTextDocument:(te,ge,Fe)=>It.onDidSaveDocument(te,ge,Fe),onWillSaveTextDocument:(te,ge,Fe)=>ri.getOnWillSaveTextDocumentEvent(Te)(te,ge,Fe),get notebookDocuments(){return yt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ge){let Fe;if(R.URI.isUri(te))Fe=te,await yt.openNotebookDocument(te);else if(typeof te=="string")Fe=R.URI.revive(await yt.createNotebookDocument({viewType:te,content:ge}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(te,ge,Fe){return pi.onDidSaveNotebookDocument(te,ge,Fe)},onDidChangeNotebookDocument(te,ge,Fe){return pi.onDidChangeNotebookDocument(te,ge,Fe)},onWillSaveNotebookDocument(te,ge,Fe){return Ci.getOnWillSaveNotebookDocumentEvent(Te)(te,ge,Fe)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(te,ge,Fe,rt){return yt.registerNotebookSerializer(Te,te,ge,Fe,(0,Ne.$xF)(Te,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,ge,Fe)=>on.onDidChangeConfiguration(te,ge,Fe),getConfiguration(te,ge){return ge=arguments.length===1?void 0:ge,on.getConfiguration(te,ge,Te)},registerTextDocumentContentProvider(te,ge){return gn.registerTextDocumentContentProvider(te,ge)},registerTaskProvider:(te,ge)=>(Me.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Te,te,ge)),registerFileSystemProvider(te,ge,Fe){return(0,je.$Oc)(Ai.registerFileSystemProvider(Te,te,ge,Fe),qt.addFileSystemProvider(te,ge,Fe))},get fs(){return qt.value},registerFileSearchProvider:(te,ge)=>((0,Ne.$yF)(Te,"fileSearchProvider"),ui.registerFileSearchProvider(te,ge)),registerTextSearchProvider:(te,ge)=>((0,Ne.$yF)(Te,"textSearchProvider"),ui.registerTextSearchProvider(te,ge)),registerRemoteAuthorityResolver:(te,ge)=>((0,Ne.$yF)(Te,"resolvers"),Rt.registerRemoteAuthorityResolver(te,ge)),registerResourceLabelFormatter:te=>((0,Ne.$yF)(Te,"resolvers"),Xi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ne.$yF)(Te,"resolvers"),Rt.getRemoteExecServer(te)),onDidCreateFiles:(te,ge,Fe)=>Yt.onDidCreateFile(te,ge,Fe),onDidDeleteFiles:(te,ge,Fe)=>Yt.onDidDeleteFile(te,ge,Fe),onDidRenameFiles:(te,ge,Fe)=>Yt.onDidRenameFile(te,ge,Fe),onWillCreateFiles:(te,ge,Fe)=>Yt.getOnWillCreateFileEvent(Te)(te,ge,Fe),onWillDeleteFiles:(te,ge,Fe)=>Yt.getOnWillDeleteFileEvent(Te)(te,ge,Fe),onWillRenameFiles:(te,ge,Fe)=>Yt.getOnWillRenameFileEvent(Te)(te,ge,Fe),openTunnel:te=>((0,Ne.$yF)(Te,"tunnels"),K.openTunnel(Te,te).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Ne.$yF)(Te,"tunnels"),K.getTunnels()},onDidChangeTunnels:(te,ge,Fe)=>((0,Ne.$yF)(Te,"tunnels"),K.onDidChangeTunnels(te,ge,Fe)),registerPortAttributesProvider:(te,ge)=>((0,Ne.$yF)(Te,"portsAttributes"),K.registerPortsAttributesProvider(te,ge)),registerTunnelProvider:(te,ge)=>((0,Ne.$yF)(Te,"tunnelFactory"),K.registerTunnelProvider(te,ge)),registerTimelineProvider:(te,ge)=>((0,Ne.$yF)(Te,"timeline"),mn.registerTimelineProvider(te,ge,Te.identifier,gt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>((0,Ne.$yF)(Te,"workspaceTrust"),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ge,Fe)=>ot.onDidGrantWorkspaceTrust(te,ge,Fe),registerEditSessionIdentityProvider:(te,ge)=>((0,Ne.$yF)(Te,"editSessionIdentityProvider"),ot.registerEditSessionIdentityProvider(te,ge)),onWillCreateEditSessionIdentity:(te,ge,Fe)=>((0,Ne.$yF)(Te,"editSessionIdentityProvider"),ot.getOnWillCreateEditSessionIdentityEvent(Te)(te,ge,Fe)),registerCanonicalUriProvider:(te,ge)=>((0,Ne.$yF)(Te,"canonicalUriProvider"),ot.registerCanonicalUriProvider(te,ge)),getCanonicalUri:(te,ge,Fe)=>((0,Ne.$yF)(Te,"canonicalUriProvider"),ot.provideCanonicalUri(te,ge,Fe))},Wi={get inputBox(){return Me.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Te)},createSourceControl(te,ge,Fe){return Ri.createSourceControl(Te,te,ge,Fe)}},Vi={createCommentController(te,ge){return Zi.createCommentController(Te,te,ge)}},ci={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},get stackFrameFocus(){return ft.stackFrameFocus},onDidStartDebugSession(te,ge,Fe){return ft.onDidStartDebugSession(te,ge,Fe)},onDidTerminateDebugSession(te,ge,Fe){return ft.onDidTerminateDebugSession(te,ge,Fe)},onDidChangeActiveDebugSession(te,ge,Fe){return ft.onDidChangeActiveDebugSession(te,ge,Fe)},onDidReceiveDebugSessionCustomEvent(te,ge,Fe){return ft.onDidReceiveDebugSessionCustomEvent(te,ge,Fe)},onDidChangeBreakpoints(te,ge,Fe){return ft.onDidChangeBreakpoints(te,ge,Fe)},onDidChangeStackFrameFocus(te,ge,Fe){return(0,Ne.$yF)(Te,"debugFocus"),ft.onDidChangeStackFrameFocus(te,ge,Fe)},registerDebugConfigurationProvider(te,ge,Fe){return ft.registerDebugConfigurationProvider(te,ge,Fe||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ge){return ft.registerDebugAdapterDescriptorFactory(Te,te,ge)},registerDebugAdapterTrackerFactory(te,ge){return ft.registerDebugAdapterTrackerFactory(te,ge)},startDebugging(te,ge,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ft.startDebugging(te,ge,{parentSession:Fe}):ft.startDebugging(te,ge,Fe||{})},stopDebugging(te){return ft.stopDebugging(te)},addBreakpoints(te){return ft.addBreakpoints(te)},removeBreakpoints(te){return ft.removeBreakpoints(te)},asDebugSourceUri(te,ge){return ft.asDebugSourceUri(te,ge)}},qi={registerTaskProvider:(te,ge)=>St.registerTaskProvider(Te,te,ge),fetchTasks:te=>St.fetchTasks(te),executeTask:te=>St.executeTask(Te,te),get taskExecutions(){return St.taskExecutions},onDidStartTask:(te,ge,Fe)=>St.onDidStartTask(te,ge,Fe),onDidEndTask:(te,ge,Fe)=>St.onDidEndTask(te,ge,Fe),onDidStartTaskProcess:(te,ge,Fe)=>St.onDidStartTaskProcess(te,ge,Fe),onDidEndTaskProcess:(te,ge,Fe)=>St.onDidEndTaskProcess(te,ge,Fe)},Ki={createNotebookController(te,ge,Fe,rt,pt){return si.createNotebookController(Te,te,ge,Fe,rt,(0,Ne.$xF)(Te,"notebookMessaging")?pt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ge)=>yt.registerNotebookCellStatusBarItemProvider(Te,te,ge),createRendererMessaging(te){return Ii.createRendererMessaging(Te,te)},createNotebookControllerDetectionTask(te){return(0,Ne.$yF)(Te,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Te,te)},registerKernelSourceActionProvider(te,ge){return(0,Ne.$yF)(Te,"notebookKernelSource"),si.registerKernelSourceActionProvider(Te,te,ge)},onDidChangeNotebookCellExecutionState(te,ge,Fe){return(0,Ne.$yF)(Te,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,ge,Fe)}},Hi={t(...te){if(typeof te[0]=="string"){const ge=te.shift(),Fe=!te||typeof te[0]!="object"?te:te[0];return li.getMessage(Te.identifier.value,{message:ge,args:Fe})}return li.getMessage(Te.identifier.value,te[0])},get bundle(){return li.getBundle(Te.identifier.value)},get uri(){return li.getBundleUri(Te.identifier.value)}},Gi={_version:1,registerInteractiveEditorSessionProvider(te,ge){return(0,Ne.$yF)(Te,"interactive"),xi.registerProvider(Te,te,ge={label:ge?.label??Te.displayName??Te.name})},registerInteractiveSessionProvider(te,ge){return(0,Ne.$yF)(Te,"interactive"),mi.registerChatProvider(Te,te,ge)},sendInteractiveRequestToProvider(te,ge){return(0,Ne.$yF)(Te,"interactive"),mi.sendInteractiveRequestToProvider(te,ge)},get onDidPerformUserAction(){return(0,Ne.$yF)(Te,"interactiveUserActions"),mi.onDidPerformUserAction},transferChatSession(te,ge){return(0,Ne.$yF)(Te,"interactive"),mi.transferChatSession(te,ge)}},hn={getRelatedInformation(te,ge){return(0,Ne.$yF)(Te,"aiRelatedInformation"),xt.getRelatedInformation(Te,te,ge)},registerRelatedInformationProvider(te,ge){return(0,Ne.$yF)(Te,"aiRelatedInformation"),xt.registerRelatedInformationProvider(Te,te,ge)},registerEmbeddingVectorProvider(te,ge){return(0,Ne.$yF)(Te,"aiRelatedInformation"),wi.registerEmbeddingVectorProvider(Te,te,ge)}},dn={registerChatResponseProvider(te,ge,Fe){return(0,Ne.$yF)(Te,"chatProvider"),gi.registerProvider(Te.identifier,te,ge,Fe)},requestChatAccess(te){return(0,Ne.$yF)(Te,"chatRequestAccess"),gi.requestChatResponseProvider(Te.identifier,te)},registerVariable(te,ge,Fe){return(0,Ne.$yF)(Te,"chatVariables"),Ui.registerVariableResolver(Te,te,ge,Fe)},registerMappedEditsProvider(te,ge){return(0,Ne.$yF)(Te,"mappedEditsProvider"),ct.registerMappedEditsProvider(Te,te,ge)},createChatAgent(te,ge){return(0,Ne.$yF)(Te,"chatAgents2"),pn.createChatAgent(Te,te,ge)},registerAgent(te,ge,Fe){return(0,Ne.$yF)(Te,"chatAgents"),_i.registerAgent(Te.identifier,te,ge,Fe)}},fn={registerSpeechProvider(te,ge){return(0,Ne.$yF)(Te,"speech"),yi.registerProvider(Te.identifier,te,ge)}};return{version:dt.version,ai:hn,authentication:Bi,commands:an,comments:Vi,chat:dn,debug:ci,env:ji,extensions:vn,interactive:Gi,l10n:Hi,languages:un,notebooks:Ki,scm:Wi,speech:fn,tasks:qi,tests:cn,window:ln,workspace:ki,Breakpoint:J.$zL,TerminalOutputAnchor:J.TerminalOutputAnchor,ChatAgentResultFeedbackKind:J.ChatAgentResultFeedbackKind,ChatMessage:J.$qM,ChatMessageRole:J.ChatMessageRole,ChatVariableLevel:J.ChatVariableLevel,CallHierarchyIncomingCall:J.$YK,CallHierarchyItem:J.$XK,CallHierarchyOutgoingCall:J.$ZK,CancellationError:L.$4,CancellationTokenSource:E.$1d,CandidatePortSource:a.CandidatePortSource,CodeAction:J.$UK,CodeActionKind:J.$VK,CodeActionTriggerKind:J.CodeActionTriggerKind,CodeLens:J.$1K,Color:J.$bL,ColorInformation:J.$cL,ColorPresentation:J.$dL,ColorThemeKind:J.ColorThemeKind,CommentMode:J.CommentMode,CommentState:J.CommentState,CommentThreadCollapsibleState:J.CommentThreadCollapsibleState,CommentThreadState:J.CommentThreadState,CompletionItem:J.$8K,CompletionItemKind:J.CompletionItemKind,CompletionItemTag:J.CompletionItemTag,CompletionList:J.$9K,CompletionTriggerKind:J.CompletionTriggerKind,ConfigurationTarget:J.ConfigurationTarget,CustomExecution:J.$lL,DebugAdapterExecutable:J.$DL,DebugAdapterInlineImplementation:J.$GL,DebugAdapterNamedPipeServer:J.$FL,DebugAdapterServer:J.$EL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:J.DebugConsoleMode,DecorationRangeBehavior:J.DecorationRangeBehavior,Diagnostic:J.$PK,DiagnosticRelatedInformation:J.$OK,DiagnosticSeverity:J.DiagnosticSeverity,DiagnosticTag:J.DiagnosticTag,Disposable:J.$BK,DocumentHighlight:J.$RK,DocumentHighlightKind:J.DocumentHighlightKind,DocumentLink:J.$aL,DocumentSymbol:J.$TK,EndOfLine:J.EndOfLine,EnvironmentVariableMutatorType:J.EnvironmentVariableMutatorType,EvaluatableExpression:J.$JL,InlineValueText:J.$KL,InlineValueVariableLookup:J.$LL,InlineValueEvaluatableExpression:J.$ML,InlineCompletionTriggerKind:J.InlineCompletionTriggerKind,EventEmitter:P.$Qd,ExtensionKind:J.ExtensionKind,ExtensionMode:J.ExtensionMode,ExternalUriOpenerPriority:J.ExternalUriOpenerPriority,FileChangeType:J.FileChangeType,FileDecoration:J.$WL,FileDecoration2:J.$WL,FileSystemError:J.$OL,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:J.$PL,FoldingRangeKind:J.FoldingRangeKind,FunctionBreakpoint:J.$BL,InlineCompletionItem:J.$0K,InlineCompletionList:J.$$K,Hover:J.$QK,IndentAction:g.IndentAction,Location:J.$NK,MarkdownString:J.$2K,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:J.$3K,PortAutoForwardAction:J.PortAutoForwardAction,Position:J.$CK,ProcessExecution:J.$jL,ProgressLocation:J.ProgressLocation,QuickInputButtons:J.$VL,Range:J.$DK,RelativePattern:J.$xL,Selection:J.$EK,SelectionRange:J.$WK,SemanticTokens:J.$SL,SemanticTokensBuilder:J.$RL,SemanticTokensEdit:J.$TL,SemanticTokensEdits:J.$UL,SemanticTokensLegend:J.$QL,ShellExecution:J.$kL,ShellQuoting:J.ShellQuoting,SignatureHelp:J.$5K,SignatureHelpTriggerKind:J.SignatureHelpTriggerKind,SignatureInformation:J.$4K,SnippetString:J.$MK,SourceBreakpoint:J.$AL,StandardTokenType:J.StandardTokenType,StatusBarAlignment:J.StatusBarAlignment,SymbolInformation:J.$SK,SymbolKind:J.SymbolKind,SymbolTag:J.SymbolTag,Task:J.$mL,TaskGroup:J.$iL,TaskPanelKind:J.TaskPanelKind,TaskRevealKind:J.TaskRevealKind,TaskScope:J.TaskScope,TerminalLink:J.$eL,TerminalQuickFixExecuteTerminalCommand:J.$gL,TerminalQuickFixOpener:J.$fL,TerminalLocation:J.TerminalLocation,TerminalProfile:J.$hL,TerminalExitReason:J.TerminalExitReason,TextDocumentSaveReason:J.TextDocumentSaveReason,TextEdit:J.$IK,SnippetTextEdit:J.$KK,TextEditorCursorStyle:$.TextEditorCursorStyle,TextEditorLineNumbersStyle:J.TextEditorLineNumbersStyle,TextEditorRevealType:J.TextEditorRevealType,TextEditorSelectionChangeKind:J.TextEditorSelectionChangeKind,SyntaxTokenType:J.SyntaxTokenType,TextDocumentChangeReason:J.TextDocumentChangeReason,ThemeColor:J.$wL,ThemeIcon:J.$vL,TreeItem:J.$nL,TreeItemCheckboxState:J.TreeItemCheckboxState,TreeItemCollapsibleState:J.TreeItemCollapsibleState,TypeHierarchyItem:J.$fM,UIKind:v.UIKind,Uri:R.URI,ViewColumn:J.ViewColumn,WorkspaceEdit:J.$LK,DocumentDropEdit:J.$tL,DocumentPasteEdit:J.$uL,InlayHint:J.$7K,InlayHintLabelPart:J.$6K,InlayHintKind:J.InlayHintKind,RemoteAuthorityResolverError:J.$HK,ResolvedAuthority:J.$FK,ManagedResolvedAuthority:J.$GK,SourceControlInputBoxValidationType:J.SourceControlInputBoxValidationType,ExtensionRuntime:J.ExtensionRuntime,TimelineItem:J.$7L,NotebookRange:J.$YL,NotebookCellKind:J.NotebookCellKind,NotebookCellExecutionState:J.NotebookCellExecutionState,NotebookCellData:J.$ZL,NotebookData:J.$1L,NotebookRendererScript:J.$5L,NotebookCellStatusBarAlignment:J.NotebookCellStatusBarAlignment,NotebookEditorRevealType:J.NotebookEditorRevealType,NotebookCellOutput:J.$3L,NotebookCellOutputItem:J.$2L,NotebookCellStatusBarItem:J.$4L,NotebookControllerAffinity:J.NotebookControllerAffinity,NotebookControllerAffinity2:J.NotebookControllerAffinity2,NotebookEdit:J.$JK,NotebookKernelSourceAction:J.$6L,PortAttributes:J.$9L,LinkedEditingRanges:J.$8L,TestResultState:J.TestResultState,TestRunRequest:J.$0L,TestMessage:J.$$L,TestMessage2:J.$$L,TestTag:J.$_L,TestRunProfileKind:J.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:J.$sL,DataTransferItem:J.$oL,CoveredCount:J.$aM,FileCoverage:J.$bM,StatementCoverage:J.$cM,BranchCoverage:J.$dM,FunctionCoverage:J.$eM,WorkspaceTrustState:J.WorkspaceTrustState,LanguageStatusSeverity:J.LanguageStatusSeverity,QuickPickItemKind:J.QuickPickItemKind,InputBoxValidationSeverity:J.InputBoxValidationSeverity,TabInputText:J.$gM,TabInputTextDiff:J.$hM,TabInputTextMerge:J.$iM,TabInputCustom:J.$jM,TabInputNotebook:J.$lM,TabInputNotebookDiff:J.$mM,TabInputWebview:J.$kM,TabInputTerminal:J.$nM,TabInputInteractiveWindow:J.$oM,TabInputChat:J.$pM,TelemetryTrustedValue:Ee.$oo,LogLevel:he.LogLevel,EditSessionIdentityMatch:$t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:J.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:J.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:J.InteractiveEditorResponseFeedbackKind,StackFrameFocus:J.$HL,ThreadFocus:J.$IL,RelatedInformationType:J.RelatedInformationType,SpeechToTextStatus:J.SpeechToTextStatus}}}e.$Efc=Nt}),define(Pe[293],Ae([1,0,71,112,35,110,36,32,62,65,115,117,118,85,87,81,111,64,42,84,61,63,258,15,116,82,83]),function(ve,e,E,L,P,M,R,$,D,g,A,S,a,v,p,f,t,i,n,u,o,l,r,s,c,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Cr)(h.$dec,h.$cec,1),(0,E.$Cr)(s.$dj,r.$Ffc,1),(0,E.$Cr)(f.$Cdc,f.$Ddc,1),(0,E.$Cr)($.$XM,$.$WM,0),(0,E.$Cr)(R.$Pdc,R.$Ndc,0),(0,E.$Cr)(i.$5dc,i.$4dc,0),(0,E.$Cr)(S.$Sec,S.$Wec,0),(0,E.$Cr)(M.$Kec,M.$Jec,0),(0,E.$Cr)(D.$MM,D.$LM,0),(0,E.$Cr)(b.$eec,b.$fec,0),(0,E.$Cr)(n.$zdc,n.$ydc,0),(0,E.$Cr)(L.$qec,L.$pec,1),(0,E.$Cr)(a.$3ec,a.$4ec,0),(0,E.$Cr)(v.$1dc,v.$Zdc,0),(0,E.$Cr)(A.$Nec,A.$Mec,0),(0,E.$Cr)(g.$8dc,g.$$dc,0),(0,E.$Cr)(p.$Uwb,p.$Vwb,0),(0,E.$Cr)(t.$Gec,t.$Fec,0),(0,E.$Cr)(P.$Mdc,P.$Ldc,0),(0,E.$Cr)(u.$aec,u.$_dc,0),(0,E.$Cr)(o.$VM,o.$SM,0),(0,E.$Cr)(l.$Oec,l.$Pec,0),(0,E.$Cr)(c.$Qec,c.$Rec,0)}),define(Pe[294],Ae([1,0,292,37,2,289,7,12,277]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Phc=void 0;class g extends M.$Ifc{j(){}getModule(v,p){for(const f of this.b){const t=f(v);if(t){v=t;break}}if(this.a.has(v))return this.a.get(v).load(v,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends L.$hec{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(D.$Ohc);const v=this.h.invokeFunction(E.$Efc);this.r=this.h.createInstance(g,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(v){return v.browser}async vb(v,p,f){p=p.with({path:S(p.path,".js")});const t=v?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=P.URI.revive(await this.C.$asBrowserUri(p)),n=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),n.status!==200)throw new Error(n.statusText);const u=await n.text(),o=`${p.toString(!0)}#vscode-extension`,l=`${u}
//# sourceURL=${o}`;let r;try{r=new Function("module","exports","require",l)}catch(b){throw console.error(t?`Loading code for extension ${t} failed: ${b.message}`:`Loading code failed: ${b.message}`),console.error(`${p.toString(!0)}${typeof b.line=="number"?` line ${b.line}`:""}${typeof b.column=="number"?` column ${b.column}`:""}`),console.error(b),b}v&&await this.w.initializeLocalizedMessages(v);const s={},c={exports:s},h=b=>{const m=this.r.getModule(b,p);if(m===void 0)throw new Error(`Cannot load module '${b}'`);return m};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(c,s,h),c.exports!==s?c.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(v){}async zb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+v;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,$.$Xg)(10)}}e.$Phc=A;function S(a,v){return a.endsWith(v)?a:a+v}}),define(Pe[295],Ae([1,0,70,71,15,37,201,86,294]),function(ve,e,E,L,P,M,R,$,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.$Cr)(P.$cj,new E.$Rh(R.$Hfc,[!0],!0)),(0,L.$Cr)(M.$iec,D.$Phc,0),(0,L.$Cr)($.$6dc,$.$7dc,0)}),define(Pe[301],Ae([1,0,24,5,79,290,279,19,88,14,2,293,295]),function(ve,e,E,L,P,M,R,$,D,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(r){return/^(file|vscode-remote):/i.test(r)}const p=fetch.bind(self);function f(r){self.fetch=async function(s,c){return s instanceof Request||v(String(s))&&(s=(await r(A.URI.parse(String(s)))).toString(!0)),p(s,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,c,h,b,m){(async()=>(v(c.toString())&&(c=(await r(A.URI.parse(c.toString()))).toString(!0)),super.open(s,c,h??!0,b,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,c){if(/^file:/i.test(s.toString()))s=g.$fg.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const b=`(${function(d){function w(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const y=fetch.bind(self);self.fetch=function(W,H){return W instanceof Request?y(W,H):y(w(W),H)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,H,U,z,F){return super.open(W,w(H),U??!0,z,F)}};const C=importScripts.bind(self);self.importScripts=(...W)=>{C(...W.map(w))},C(d)}.toString()}('${s}'))`;c=c||{},c.name=c.name||$.$mc(s.toString());const m=new Blob([b],{type:"application/javascript"}),I=URL.createObjectURL(m);return new r(I,c)}}else self.Worker=class extends R.$Qhc{constructor(r,s){super(a,r,{name:$.$mc(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){S()}};class i{constructor(){const s=new MessageChannel,c=new L.$Qd;let h=!1;a(s.port2,[s.port2]),s.port1.onmessage=b=>{const{data:m}=b;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const I=E.$ee.wrap(new Uint8Array(m,0,m.byteLength));if((0,P.$hm)(I,2)){h=!0,u("received terminate message from renderer");return}c.fire(I)},this.protocol={onMessage:c.event,send:b=>{if(!h){const m=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);s.port1.postMessage(m,[m])}}}}}function n(r){return new Promise(s=>{const c=r.onMessage(h=>{c.dispose();const b=JSON.parse(h.toString());r.send((0,P.$gm)(0)),s({protocol:r,initData:b})});r.send((0,P.$gm)(1))})}let u=r=>S();function o(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function l(){D.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(s){o(s)&&n(r.protocol).then(c=>{D.mark("code/extHost/didWaitForInitData");const h=new M.$Kfc(c.protocol,c.initData,t,null,s.data);f(b=>h.asBrowserUri(b)),u=b=>h.terminate(b)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/60c8cddf1ae631ce52714d885adba2cdc889415b/core/vs/workbench/api/worker/extensionHostWorker.js.map
