/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var G=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],V=function(W){for(var e=[],P=0,S=W.length;P<S;P++)e[P]=G[W[P]];return e};define(G[21],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class P{static get(){const v=new Map,A=new Map,s=new Map,c=new Map;function t(f,i){f.has(i.detail)||f.set(i.detail,-i.timestamp)}function r(f,i){const n=f.get(i.detail);n&&(n>=0||f.set(i.detail,n+i.timestamp))}let h=[];typeof W=="function"&&typeof W.getStats=="function"&&(h=W.getStats().slice(0).sort((f,i)=>f.timestamp-i.timestamp));for(const f of h)switch(f.type){case 10:t(v,f);break;case 11:case 12:r(v,f);break;case 21:t(A,f);break;case 22:r(A,f);break;case 33:t(s,f);break;case 34:r(s,f);break;case 31:t(c,f);break;case 32:r(c,f);break}let o=0;s.forEach(f=>o+=f);function l(f){const i=[];return f.forEach((n,a)=>i.push([a,n])),i}return{amdLoad:l(v),amdInvoke:l(A),nodeRequire:l(s),nodeEval:l(c),nodeRequireTotal:o}}static toMarkdownTable(v,A){let s="";const c=[];return v.forEach((t,r)=>{c[r]=t.length}),A.forEach(t=>{t.forEach((r,h)=>{typeof r>"u"&&(r=t[h]="-");const o=r.toString().length;c[h]=Math.max(o,c[h])})}),v.forEach((t,r)=>{s+=`| ${t+" ".repeat(c[r]-t.toString().length)} `}),s+=`|
`,v.forEach((t,r)=>{s+=`| ${"-".repeat(c[r])} `}),s+=`|
`,A.forEach(t=>{t.forEach((r,h)=>{typeof r<"u"&&(s+=`| ${r+" ".repeat(c[h]-r.toString().length)} `)}),s+=`|
`}),s}}e.$T=P}),define(G[4],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qd=e.$pd=e.$od=void 0;let P;function S(n){P=n}e.$od=S;function v(){return P}e.$pd=v;class A{constructor(){this.a=0,this.d=new WeakMap}b(a){return s([c(f("|  ",this.a)),a])}c(a){return a.hadValue?a.didChange?[c(" "),r(h(a.oldValue,70),{color:"red",strikeThrough:!0}),c(" "),r(h(a.newValue,60),{color:"green"})]:[c(" (unchanged)")]:[c(" "),r(h(a.newValue,60),{color:"green"}),c(" (initial)")]}handleObservableChanged(a,b){console.log(...this.b([t("observable value changed"),r(a.debugName,{color:"BlueViolet"}),...this.c(b)]))}formatChanges(a){if(a.size!==0)return r(" (changed deps: "+[...a].map(b=>b.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(a){const b=a.handleChange;this.d.set(a,new Set),a.handleChange=(C,B)=>(this.d.get(a).add(C),b.apply(a,[C,B]))}handleDerivedRecomputed(a,b){const C=this.d.get(a);console.log(...this.b([t("derived recomputed"),r(a.debugName,{color:"BlueViolet"}),...this.c(b),this.formatChanges(C),{data:[{fn:a._computeFn}]}])),C.clear()}handleFromEventObservableTriggered(a,b){console.log(...this.b([t("observable from event triggered"),r(a.debugName,{color:"BlueViolet"}),...this.c(b),{data:[{fn:a._getValue}]}]))}handleAutorunCreated(a){const b=a.handleChange;this.d.set(a,new Set),a.handleChange=(C,B)=>(this.d.get(a).add(C),b.apply(a,[C,B]))}handleAutorunTriggered(a){const b=this.d.get(a);console.log(...this.b([t("autorun"),r(a.debugName,{color:"BlueViolet"}),this.formatChanges(b),{data:[{fn:a._runFn}]}])),b.clear(),this.a++}handleAutorunFinished(a){this.a--}handleBeginTransaction(a){let b=a.getDebugName();b===void 0&&(b=""),console.log(...this.b([t("transaction"),r(b,{color:"BlueViolet"}),{data:[{fn:a._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$qd=A;function s(n){const a=new Array,b=[];let C="";function B(I){if("length"in I)for(const g of I)g&&B(g);else"text"in I?(C+=`%c${I.text}`,a.push(I.style),I.data&&b.push(...I.data)):"data"in I&&b.push(...I.data)}B(n);const L=[C,...a];return L.push(...b),L}function c(n){return r(n,{color:"black"})}function t(n){return r(i(`${n}: `,10),{color:"black",bold:!0})}function r(n,a={color:"black"}){function b(B){return Object.entries(B).reduce((L,[I,g])=>`${L}${I}:${g};`,"")}const C={color:a.color};return a.strikeThrough&&(C["text-decoration"]="line-through"),a.bold&&(C["font-weight"]="bold"),{text:n,style:b(C)}}function h(n,a){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=a?`"${n}"`:`"${n.substr(0,a-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?o(n,a):l(n,a);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function o(n,a){let b="[ ",C=!0;for(const B of n){if(C||(b+=", "),b.length-5>a){b+="...";break}C=!1,b+=`${h(B,a-b.length)}`}return b+=" ]",b}function l(n,a){let b="{ ",C=!0;for(const[B,L]of Object.entries(n)){if(C||(b+=", "),b.length-5>a){b+="...";break}C=!1,b+=`${B}: ${h(L,a-b.length)}`}return b+=" }",b}function f(n,a){let b="";for(let C=1;C<=a;C++)b+=n;return b}function i(n,a){for(;n.length<a;)n+=" ";return n}}),define(G[5],V([0,1,4]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=void 0;let S;function v(m){S=m}e.$xd=v;let A;function s(m){A=m}e.$yd=s;class c{get TChange(){return null}reportChanges(){this.get()}read(k){return k?k.readObservable(this):this.get()}map(k,F){const T=F===void 0?void 0:k,d=F===void 0?k:F;return A({owner:T,debugName:()=>{const j=E(d);if(j!==void 0)return j;const z=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(d.toString());if(z)return`${this.debugName}.${z[2]}`;if(!T)return`${this.debugName} (mapped)`}},j=>d(this.read(j),j))}recomputeInitiallyAndOnChange(k,F){return k.add(S(this,F)),this}}e.$zd=c;class t extends c{constructor(){super(...arguments),this.c=new Set}addObserver(k){const F=this.c.size;this.c.add(k),F===0&&this.f()}removeObserver(k){this.c.delete(k)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Ad=t;function r(m,k){const F=new i(m,k);try{m(F)}finally{F.finish()}}e.$Bd=r;let h;function o(m){if(h)m(h);else{const k=new i(m,void 0);h=k;try{m(k)}finally{k.finish(),h=void 0}}}e.$Cd=o;async function l(m,k){const F=new i(m,k);try{await m(F)}finally{F.finish()}}e.$Dd=l;function f(m,k,F){m?k(m):r(k,F)}e.$Ed=f;class i{constructor(k,F){this._fn=k,this.b=F,this.a=[],(0,P.$pd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():E(this._fn)}updateObserver(k,F){this.a.push({observer:k,observable:F}),k.beginUpdate(F)}finish(){const k=this.a;for(let F=0;F<k.length;F++){const{observer:T,observable:d}=k[F];T.endUpdate(d)}this.a=null,(0,P.$pd)()?.handleEndTransaction()}}e.$Fd=i;const n=new Map,a=new WeakMap;function b(m,k,F,T,d){const j=a.get(m);if(j)return j;const D=C(m,k,F,T,d);if(D){let z=n.get(D)??0;z++,n.set(D,z);const p=z===1?D:`${D}#${z}`;return a.set(m,p),p}}e.$Gd=b;function C(m,k,F,T,d){const j=a.get(m);if(j)return j;const D=T?I(T)+".":"";let z;if(k!==void 0)if(typeof k=="function"){if(z=k(),z!==void 0)return D+z}else return D+k;if(F!==void 0&&(z=E(F),z!==void 0))return D+z;if(T!==void 0){for(const p in T)if(T[p]===d)return D+p}}const B=new Map,L=new WeakMap;function I(m){const k=L.get(m);if(k)return k;const F=g(m);let T=B.get(F)??0;T++,B.set(F,T);const d=T===1?F:`${F}#${T}`;return L.set(m,d),d}function g(m){const k=m.constructor;return k?k.name:"Object"}function E(m){const k=m.toString(),T=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(k);return(T?T[1]:void 0)?.trim()}e.$Hd=E;function w(m,k){return typeof m=="string"?new O(void 0,m,k):new O(m,void 0,k)}e.$Id=w;class O extends t{get debugName(){return b(this,this.d,void 0,this.b,this)??"ObservableValue"}constructor(k,F,T){super(),this.b=k,this.d=F,this.a=T}get(){return this.a}set(k,F,T){if(this.a===k)return;let d;F||(F=d=new i(()=>{},()=>`Setting ${this.debugName}`));try{const j=this.a;this.e(k),(0,P.$pd)()?.handleObservableChanged(this,{oldValue:j,newValue:k,change:T,didChange:!0,hadValue:!0});for(const D of this.c)F.updateObserver(D,this),D.handleChange(this,T)}finally{d&&d.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(k){this.a=k}}e.$Jd=O;function U(m,k){return typeof m=="string"?new $(void 0,m,k):new $(m,void 0,k)}e.$Kd=U;class $ extends O{e(k){this.a!==k&&(this.a&&this.a.dispose(),this.a=k)}dispose(){this.a?.dispose()}}e.$Ld=$}),define(G[9],V([0,1,42,2,5,4]),function(W,e,P,S,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=void 0;function s(i){return new l(void 0,i,void 0,void 0)}e.$7c=s;function c(i,n){return new l(i.debugName,n,void 0,void 0)}e.$8c=c;function t(i,n){return new l(i.debugName,n,i.createEmptyChangeSummary,i.handleChange)}e.$9c=t;function r(i,n){const a=new S.$Qc,b=t({debugName:i.debugName??(()=>(0,v.$Hd)(n)),createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(C,B)=>{a.clear(),n(C,B,a)});return(0,S.$Pc)(()=>{b.dispose(),a.dispose()})}e.$0c=r;function h(i){const n=new S.$Qc,a=c({debugName:()=>(0,v.$Hd)(i)||"(anonymous)"},b=>{n.clear(),i(b,n)});return(0,S.$Pc)(()=>{a.dispose(),n.dispose()})}e.$$c=h;var o;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(o||(o={}));class l{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const a=this.h();if(a!==void 0)return a}const n=(0,v.$Hd)(this._runFn);return n!==void 0?n:"(anonymous)"}constructor(n,a,b,C){this.h=n,this._runFn=a,this.i=b,this.j=C,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,A.$pd)()?.handleAutorunCreated(this),this.k(),(0,S.$Ic)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,S.$Jc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const a=this.c;try{if(!a){(0,A.$pd)()?.handleAutorunTriggered(this);const b=this.g;this.g=this.i?.(),this._runFn(this,b)}}finally{a||(0,A.$pd)()?.handleAutorunFinished(this);for(const b of this.f)b.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,P.$5c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,a){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:a,didChange:C=>C===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const a=n.get();return this.e.add(n),this.f.delete(n),a}}e.$_c=l,function(i){i.Observer=l}(s||(e.$7c=s={}));function f(i,n){let a;return c({debugName:()=>(0,v.$Hd)(n)},b=>{const C=i.read(b),B=a;a=C,n({lastValue:B,newValue:C})})}e.$ad=f}),define(G[10],V([0,1,6,2,5,4]),function(W,e,P,S,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=void 0;const s=(i,n)=>i===n;function c(i,n){return n!==void 0?new f(i,void 0,n,void 0,void 0,void 0,s):new f(void 0,void 0,i,void 0,void 0,void 0,s)}e.$rd=c;function t(i,n){return new f(i.owner,i.debugName,n,void 0,void 0,void 0,i.equalityComparer??s)}e.$sd=t;function r(i,n){return new f(i.owner,i.debugName,n,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??s)}e.$td=r;function h(i,n){let a,b;n===void 0?(a=i,b=void 0):(b=i,a=n);const C=new S.$Qc;return new f(b,()=>(0,v.$Hd)(a)??"(anonymous)",B=>(C.clear(),a(B,C)),void 0,void 0,()=>C.dispose(),s)}e.$ud=h;function o(i,n){let a,b;n===void 0?(a=i,b=void 0):(b=i,a=n);const C=new S.$Qc;return new f(b,()=>(0,v.$Hd)(a)??"(anonymous)",B=>{C.clear();const L=a(B);return L&&C.add(L),L},void 0,void 0,()=>C.dispose(),s)}e.$vd=o,(0,v.$yd)(t);var l;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(l||(l={}));class f extends v.$Ad{get debugName(){return(0,v.$Gd)(this,this.p,this._computeFn,this.n,this)??"(anonymous)"}constructor(n,a,b,C,B,L=void 0,I){super(),this.n=n,this.p=a,this._computeFn=b,this.q=C,this.s=B,this.t=L,this.u=I,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.q?.(),(0,A.$pd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.k)n.removeObserver(this);this.k.clear(),this.t?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.q?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.k)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.w()}while(this.e!==3);return this.h}}w(){if(this.e===3)return;const n=this.l;this.l=this.k,this.k=n;const a=this.e!==0,b=this.h;this.e=3;const C=this.m;this.m=this.q?.();try{this.h=this._computeFn(this,C)}finally{for(const L of this.l)L.removeObserver(this);this.l.clear()}const B=a&&!this.u(b,this.h);if((0,A.$pd)()?.handleDerivedRecomputed(this,{oldValue:b,newValue:this.h,change:void 0,didChange:B,hadValue:a}),B)for(const L of this.c)L.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.j++;const a=this.j===1;if(this.e===3&&(this.e=1,!a))for(const b of this.c)b.handlePossibleChange(this);if(a)for(const b of this.c)b.beginUpdate(this)}endUpdate(n){if(this.j--,this.j===0){const a=[...this.c];for(const b of a)b.endUpdate(this)}if(this.j<0)throw new P.$bb}handlePossibleChange(n){if(this.e===3&&this.k.has(n)&&!this.l.has(n)){this.e=1;for(const a of this.c)a.handlePossibleChange(this)}}handleChange(n,a){if(this.k.has(n)&&!this.l.has(n)){const b=this.s?this.s({changedObservable:n,change:a,didChange:B=>B===n},this.m):!0,C=this.e===3;if(b&&(this.e===1||C)&&(this.e=2,C))for(const B of this.c)B.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const a=n.get();return this.k.add(n),this.l.delete(n),a}addObserver(n){const a=!this.c.has(n)&&this.j>0;super.addObserver(n),a&&n.beginUpdate(this)}removeObserver(n){const a=this.c.has(n)&&this.j>0;super.removeObserver(n),a&&n.endUpdate(this)}}e.$wd=f}),define(G[22],V([0,1,2,9,5,10,4]),function(W,e,P,S,v,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=void 0;function c(w){return new t(w)}e.$bd=c;class t extends v.$zd{constructor(O){super(),this.a=O}get debugName(){return this.toString()}get(){return this.a}addObserver(O){}removeObserver(O){}toString(){return`Const: ${this.a}`}}function r(w){const O=(0,v.$Id)("promiseValue",{});return w.then(U=>{O.set({value:U},void 0)}),O}e.$cd=r;function h(w,O){return new Promise(U=>{let $=!1,m=!1;const k=w.map(T=>({isFinished:O(T),state:T})),F=(0,S.$7c)(T=>{const{isFinished:d,state:j}=k.read(T);d&&($?F.dispose():m=!0,U(j))});$=!0,m&&F.dispose()})}e.$dd=h;function o(w,O){return new l(w,O)}e.$ed=o;class l extends v.$Ad{constructor(O,U){super(),this.h=O,this._getValue=U,this.b=!1,this.l=$=>{const m=this._getValue($),k=this.a,F=!this.b||k!==m;let T=!1;F&&(this.a=m,this.b&&(T=!0,(0,v.$Ed)(l.globalTransaction,d=>{(0,s.$pd)()?.handleFromEventObservableTriggered(this,{oldValue:k,newValue:m,change:void 0,didChange:F,hadValue:this.b});for(const j of this.c)d.updateObserver(j,this),j.handleChange(this,void 0)},()=>{const d=this.j();return"Event fired"+(d?`: ${d}`:"")})),this.b=!0),T||(0,s.$pd)()?.handleFromEventObservableTriggered(this,{oldValue:k,newValue:m,change:void 0,didChange:F,hadValue:this.b})}}j(){return(0,v.$Hd)(this._getValue)}get debugName(){const O=this.j();return"From Event"+(O?`: ${O}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$fd=l,function(w){w.Observer=l;function O(U,$){let m=!1;l.globalTransaction===void 0&&(l.globalTransaction=U,m=!0);try{$()}finally{m&&(l.globalTransaction=void 0)}}w.batchEventsGlobally=O}(o||(e.$ed=o={}));function f(w,O){return new i(w,O)}e.$gd=f;class i extends v.$Ad{constructor(O,U){super(),this.debugName=O,this.b=U,this.h=()=>{(0,v.$Bd)($=>{for(const m of this.c)$.updateObserver(m,this),m.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function n(w){return typeof w=="string"?new a(w):new a(void 0,w)}e.$hd=n;class a extends v.$Ad{get debugName(){return(0,v.$Gd)(this,this.a,void 0,this.b,this)??"Observable Signal"}constructor(O,U){super(),this.a=O,this.b=U}trigger(O,U){if(!O){(0,v.$Bd)($=>{this.trigger($,U)},()=>`Trigger signal ${this.debugName}`);return}for(const $ of this.c)O.updateObserver($,this),$.handleChange(this,U)}get(){}}function b(w,O,U){const $=(0,v.$Id)("debounced",void 0);let m;return U.add((0,S.$7c)(k=>{const F=w.read(k);m&&clearTimeout(m),m=setTimeout(()=>{(0,v.$Bd)(T=>{$.set(F,T)})},O)})),$}e.$id=b;function C(w,O,U){const $=(0,v.$Id)("triggeredRecently",!1);let m;return U.add(w(()=>{$.set(!0,void 0),m&&clearTimeout(m),m=setTimeout(()=>{$.set(!1,void 0)},O)})),$}e.$jd=C;function B(w){const O=new I(!1,void 0);return w.addObserver(O),(0,P.$Pc)(()=>{w.removeObserver(O)})}e.$kd=B;function L(w,O){const U=new I(!0,O);return w.addObserver(U),O?O(w.get()):w.reportChanges(),(0,P.$Pc)(()=>{w.removeObserver(U)})}e.$ld=L,(0,v.$xd)(L);class I{constructor(O,U){this.b=O,this.c=U,this.a=0}beginUpdate(O){this.a++}endUpdate(O){this.a--,this.a===0&&this.b&&(this.c?this.c(O.get()):O.reportChanges())}handlePossibleChange(O){}handleChange(O,U){}}function g(w){let O;return(0,A.$rd)($=>(O=w($,O),O))}e.$md=g;function E(w,O){let U;const $=(0,v.$Id)("derivedObservableWithWritableCache.counter",0),m=(0,A.$rd)(w,k=>($.read(k),U=O(k,U),U));return Object.assign(m,{clearCache:k=>{U=void 0,$.set($.get()+1,k)}})}e.$nd=E}),define(G[11],V([0,1,5,10,9,22,4]),function(W,e,P,S,v,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.$Id}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.$Kd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.$Bd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.$Ed}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$rd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$sd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$td}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$ud}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$7c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$ad}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$9c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$$c}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$8c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$0c}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return A.$bd}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return A.$id}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return A.$md}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return A.$nd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return A.$kd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return A.$ld}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return A.$ed}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return A.$cd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return A.$hd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return A.$gd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return A.$dd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return A.$jd}}),!1&&(0,s.$od)(new s.$qd)}),define(G[23],V([0,1,6,2]),function(W,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=void 0;function v(L){const I=L;return I?typeof I.read=="function":!1}e.$2d=v;function A(L){const I=L;return I?[I.on,I.pause,I.resume,I.destroy].every(g=>typeof g=="function"):!1}e.$3d=A;function s(L){const I=L;return I?A(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.$4d=s;function c(L,I){return new t(L,I)}e.$5d=c;class t{constructor(I,g){this.e=I,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(g=>g(I))}h(I){this.c.error.length===0?(0,P.$Z)(I):this.c.error.slice(0).forEach(g=>g(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,g){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(I,g){if(this.a.destroyed)return;let E;switch(I){case"data":E=this.c.data;break;case"end":E=this.c.end;break;case"error":E=this.c.error;break}if(E){const w=E.indexOf(g);w>=0&&E.splice(w,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(E=>E())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(L,I){const g=[];let E;for(;(E=L.read())!==null;)g.push(E);return I(g)}e.$6d=r;function h(L,I,g){const E=[];let w;for(;(w=L.read())!==null&&E.length<g;)E.push(w);return w===null&&E.length>0?I(E):{read:()=>{if(E.length>0)return E.shift();if(typeof w<"u"){const O=w;return w=void 0,O}return L.read()}}}e.$7d=h;function o(L,I){return new Promise((g,E)=>{const w=[];l(L,{onData:O=>{I&&w.push(O)},onError:O=>{I?E(O):g(void 0)},onEnd:()=>{g(I?I(w):void 0)}})})}e.$8d=o;function l(L,I,g){L.on("error",E=>{g?.isCancellationRequested||I.onError(E)}),L.on("end",()=>{g?.isCancellationRequested||I.onEnd()}),L.on("data",E=>{g?.isCancellationRequested||I.onData(E)})}e.$9d=l;function f(L,I){return new Promise((g,E)=>{const w=new S.$Qc,O=[],U=k=>{if(O.push(k),O.length>I)return w.dispose(),L.pause(),g({stream:L,buffer:O,ended:!1})},$=k=>(w.dispose(),E(k)),m=()=>(w.dispose(),g({stream:L,buffer:O,ended:!0}));w.add((0,S.$Pc)(()=>L.removeListener("error",$))),L.on("error",$),w.add((0,S.$Pc)(()=>L.removeListener("end",m))),L.on("end",m),w.add((0,S.$Pc)(()=>L.removeListener("data",U))),L.on("data",U)})}e.$0d=f;function i(L,I){const g=c(I);return g.end(L),g}e.$$d=i;function n(){const L=c(()=>{throw new Error("not supported")});return L.end(),L}e.$_d=n;function a(L){let I=!1;return{read:()=>I?null:(I=!0,L)}}e.$ae=a;function b(L,I,g){const E=c(g);return l(L,{onData:w=>E.write(I.data(w)),onError:w=>E.error(I.error?I.error(w):w),onEnd:()=>E.end()}),E}e.$be=b;function C(L,I,g){let E=!1;return{read:()=>{const w=I.read();return E?w:(E=!0,w!==null?g([L,w]):L)}}}e.$ce=C;function B(L,I,g){let E=!1;const w=c(g);return l(I,{onData:O=>E?w.write(O):(E=!0,w.write(g([L,O]))),onError:O=>w.error(O),onEnd:()=>{E||(E=!0,w.write(L)),w.end()}}),w}e.$de=B}),define(G[12],V([0,1,43,23]),function(W,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;const v=typeof Buffer<"u",A=new P.$U(()=>new Uint8Array(256));let s,c;class t{static alloc(d){return v?new t(Buffer.allocUnsafe(d)):new t(new Uint8Array(d))}static wrap(d){return v&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new t(d)}static fromString(d,j){return!(j?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(d)):(s||(s=new TextEncoder),new t(s.encode(d)))}static fromByteArray(d){const j=t.alloc(d.length);for(let D=0,z=d.length;D<z;D++)j.buffer[D]=d[D];return j}static concat(d,j){if(typeof j>"u"){j=0;for(let p=0,H=d.length;p<H;p++)j+=d[p].byteLength}const D=t.alloc(j);let z=0;for(let p=0,H=d.length;p<H;p++){const K=d[p];D.set(K,z),z+=K.byteLength}return D}constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}clone(){const d=t.alloc(this.byteLength);return d.set(this),d}toString(){return v?this.buffer.toString():(c||(c=new TextDecoder),c.decode(this.buffer))}slice(d,j){return new t(this.buffer.subarray(d,j))}set(d,j){if(d instanceof t)this.buffer.set(d.buffer,j);else if(d instanceof Uint8Array)this.buffer.set(d,j);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),j);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return l(this.buffer,d)}writeUInt32BE(d,j){f(this.buffer,d,j)}readUInt32LE(d){return i(this.buffer,d)}writeUInt32LE(d,j){n(this.buffer,d,j)}readUInt8(d){return a(this.buffer,d)}writeUInt8(d,j){b(this.buffer,d,j)}indexOf(d,j=0){return r(this.buffer,d instanceof t?d.buffer:d,j)}}e.$ee=t;function r(T,d,j=0){const D=d.byteLength,z=T.byteLength;if(D===0)return 0;if(D===1)return T.indexOf(d[0]);if(D>z-j)return-1;const p=A.value;p.fill(d.length);for(let X=0;X<d.length;X++)p[d[X]]=d.length-X-1;let H=j+d.length-1,K=H,_=-1;for(;H<z;)if(T[H]===d[K]){if(K===0){_=H;break}H--,K--}else H+=Math.max(d.length-K,p[T[H]]),K=d.length-1;return _}e.$fe=r;function h(T,d){return T[d+0]<<0>>>0|T[d+1]<<8>>>0}e.$ge=h;function o(T,d,j){T[j+0]=d&255,d=d>>>8,T[j+1]=d&255}e.$he=o;function l(T,d){return T[d]*2**24+T[d+1]*2**16+T[d+2]*2**8+T[d+3]}e.$ie=l;function f(T,d,j){T[j+3]=d,d=d>>>8,T[j+2]=d,d=d>>>8,T[j+1]=d,d=d>>>8,T[j]=d}e.$je=f;function i(T,d){return T[d+0]<<0>>>0|T[d+1]<<8>>>0|T[d+2]<<16>>>0|T[d+3]<<24>>>0}e.$ke=i;function n(T,d,j){T[j+0]=d&255,d=d>>>8,T[j+1]=d&255,d=d>>>8,T[j+2]=d&255,d=d>>>8,T[j+3]=d&255}e.$le=n;function a(T,d){return T[d]}e.$me=a;function b(T,d,j){T[j]=d}e.$ne=b;function C(T){return S.$6d(T,d=>t.concat(d))}e.$oe=C;function B(T){return S.$ae(T)}e.$pe=B;function L(T){return S.$8d(T,d=>t.concat(d))}e.$qe=L;async function I(T){return T.ended?t.concat(T.buffer):t.concat([...T.buffer,await L(T.stream)])}e.$re=I;function g(T){return S.$$d(T,d=>t.concat(d))}e.$se=g;function E(T){return S.$be(T,{data:d=>typeof d=="string"?t.fromString(d):t.wrap(d)},d=>t.concat(d))}e.$te=E;function w(T){return S.$5d(d=>t.concat(d),T)}e.$ue=w;function O(T,d){return S.$ce(T,d,j=>t.concat(j))}e.$ve=O;function U(T,d){return S.$de(T,d,j=>t.concat(j))}e.$we=U;function $(T){let d=0,j=0,D=0;const z=new Uint8Array(Math.floor(T.length/4*3)),p=K=>{switch(j){case 3:z[D++]=d|K,j=0;break;case 2:z[D++]=d|K>>>2,d=K<<6,j=3;break;case 1:z[D++]=d|K>>>4,d=K<<4,j=2;break;default:d=K<<2,j=1}};for(let K=0;K<T.length;K++){const _=T.charCodeAt(K);if(_>=65&&_<=90)p(_-65);else if(_>=97&&_<=122)p(_-97+26);else if(_>=48&&_<=57)p(_-48+52);else if(_===43||_===45)p(62);else if(_===47||_===95)p(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${T[K]}`)}}const H=D;for(;j>0;)p(0);return t.wrap(z).slice(0,H)}e.$xe=$;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function F({buffer:T},d=!0,j=!1){const D=j?k:m;let z="";const p=T.byteLength%3;let H=0;for(;H<T.byteLength-p;H+=3){const K=T[H+0],_=T[H+1],X=T[H+2];z+=D[K>>>2],z+=D[(K<<4|_>>>4)&63],z+=D[(_<<2|X>>>6)&63],z+=D[X&63]}if(p===1){const K=T[H+0];z+=D[K>>>2],z+=D[K<<4&63],d&&(z+="==")}else if(p===2){const K=T[H+0],_=T[H+1];z+=D[K>>>2],z+=D[(K<<4|_>>>4)&63],z+=D[_<<2&63],d&&(z+="=")}return z}e.$ye=F}),define(G[24],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Nd=Symbol("MicrotaskDelay")}),define(G[13],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var P;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function S(v){let A=0,s=0,c=0,t=0;for(let r=0,h=v.length;r<h;r++){const o=v.charCodeAt(r);o===13?(A===0&&(s=r),A++,r+1<h&&v.charCodeAt(r+1)===10?(t|=2,r++):t|=3,c=r+1):o===10&&(t|=1,A===0&&(s=r),A++,c=r+1)}return A===0&&(s=v.length),[A,s,v.length-c,t]}e.$_s=S}),define(G[14],V([0,1]),function(W,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var A;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(A||(e.StandardTokenType=A={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class c{static getLanguageId(r){return(r&255)>>>0}static getTokenType(r){return(r&768)>>>8}static containsBalancedBrackets(r){return(r&1024)!==0}static getFontStyle(r){return(r&30720)>>>11}static getForeground(r){return(r&16744448)>>>15}static getBackground(r){return(r&4278190080)>>>24}static getClassNameFromMetadata(r){let o="mtk"+this.getForeground(r);const l=this.getFontStyle(r);return l&1&&(o+=" mtki"),l&2&&(o+=" mtkb"),l&4&&(o+=" mtku"),l&8&&(o+=" mtks"),o}static getInlineStyleFromMetadata(r,h){const o=this.getForeground(r),l=this.getFontStyle(r);let f=`color: ${h[o]};`;l&1&&(f+="font-style: italic;"),l&2&&(f+="font-weight: bold;");let i="";return l&4&&(i+=" underline"),l&8&&(i+=" line-through"),i&&(f+=`text-decoration:${i};`),f}static getPresentationFromMetadata(r){const h=this.getForeground(r),o=this.getFontStyle(r);return{foreground:h,italic:!!(o&1),bold:!!(o&2),underline:!!(o&4),strikethrough:!!(o&8)}}}e.$0s=c}),define(G[25],V([0,1,26]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QB=void 0;class S{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,c){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=c}replace(s,c,t){if(s>=this.a.length)return;if(c===0){this.insert(s,t);return}else if(t===0){this.delete(s,c);return}const r=this.a.slice(0,s),h=this.a.slice(s+c),o=v(t,this.b);this.a=r.concat(o,h)}delete(s,c){c===0||s>=this.a.length||this.a.splice(s,c)}insert(s,c){if(c===0||s>=this.a.length)return;const t=[];for(let r=0;r<c;r++)t[r]=this.b;this.a=(0,P.$Vb)(this.a,s,t)}}e.$QB=S;function v(A,s){const c=[];for(let t=0;t<A;t++)c[t]=s;return c}}),define(G[7],V([0,1,14]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=void 0;class S{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,c){const t=S.defaultTokenMetadata,r=new Uint32Array(2);return r[0]=s.length,r[1]=t,new S(r,s,c)}constructor(s,c,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=c,this.d=t}equals(s){return s instanceof S?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,c,t){if(this.c!==s.c||this.b!==s.b)return!1;const r=c<<1,h=r+(t<<1);for(let o=r;o<h;o++)if(this.a[o]!==s.a[o])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const c=this.a[(s<<1)+1],t=P.$0s.getLanguageId(c);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const c=this.a[(s<<1)+1];return P.$0s.getTokenType(c)}getForeground(s){const c=this.a[(s<<1)+1];return P.$0s.getForeground(c)}getClassName(s){const c=this.a[(s<<1)+1];return P.$0s.getClassNameFromMetadata(c)}getInlineStyle(s,c){const t=this.a[(s<<1)+1];return P.$0s.getInlineStyleFromMetadata(t,c)}getPresentation(s){const c=this.a[(s<<1)+1];return P.$0s.getPresentationFromMetadata(c)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return S.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,c,t){return new v(this,s,c,t)}static convertToEndOffset(s,c){const r=(s.length>>>1)-1;for(let h=0;h<r;h++)s[h<<1]=s[h+1<<1];s[r<<1]=c}static findIndexInTokensArray(s,c){if(s.length<=2)return 0;let t=0,r=(s.length>>>1)-1;for(;t<r;){const h=t+Math.floor((r-t)/2),o=s[h<<1];if(o===c)return h+1;o<c?t=h+1:o>c&&(r=h)}return t}withInserted(s){if(s.length===0)return this;let c=0,t=0,r="";const h=new Array;let o=0;for(;;){const l=c<this.b?this.a[c<<1]:-1,f=t<s.length?s[t]:null;if(l!==-1&&(f===null||l<=f.offset)){r+=this.c.substring(o,l);const i=this.a[(c<<1)+1];h.push(r.length,i),c++,o=l}else if(f){if(f.offset>o){r+=this.c.substring(o,f.offset);const i=this.a[(c<<1)+1];h.push(r.length,i),o=f.offset}r+=f.text,h.push(r.length,f.tokenMetadata),t++}else break}return new S(new Uint32Array(h),r,this.d)}}e.$at=S;class v{constructor(s,c,t,r){this.a=s,this.b=c,this.c=t,this.d=r,this.e=s.findTokenIndexAtOffset(c),this.f=0;for(let h=this.e,o=s.getCount();h<o&&!(s.getStartOffset(h)>=t);h++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof v?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const c=this.a.getEndOffset(this.e+s);return Math.min(this.c,c)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,c){return this.a.getInlineStyle(this.e+s,c)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(G[27],V([0,1,7]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=void 0,e.$bt=new Uint32Array(0).buffer;class S{static deleteBeginning(s,c){return s===null||s===e.$bt?s:S.delete(s,0,c)}static deleteEnding(s,c){if(s===null||s===e.$bt)return s;const t=v(s),r=t[t.length-2];return S.delete(s,c,r)}static delete(s,c,t){if(s===null||s===e.$bt||c===t)return s;const r=v(s),h=r.length>>>1;if(c===0&&r[r.length-2]===t)return e.$bt;const o=P.$at.findIndexInTokensArray(r,c),l=o>0?r[o-1<<1]:0,f=r[o<<1];if(t<f){const C=t-c;for(let B=o;B<h;B++)r[B<<1]-=C;return s}let i,n;l!==c?(r[o<<1]=c,i=o+1<<1,n=c):(i=o<<1,n=l);const a=t-c;for(let C=o+1;C<h;C++){const B=r[C<<1]-a;B>n&&(r[i++]=B,r[i++]=r[(C<<1)+1],n=B)}if(i===r.length)return s;const b=new Uint32Array(i);return b.set(r.subarray(0,i),0),b.buffer}static append(s,c){if(c===e.$bt)return s;if(s===e.$bt)return c;if(s===null)return s;if(c===null)return null;const t=v(s),r=v(c),h=r.length>>>1,o=new Uint32Array(t.length+r.length);o.set(t,0);let l=t.length;const f=t[t.length-2];for(let i=0;i<h;i++)o[l++]=r[i<<1]+f,o[l++]=r[(i<<1)+1];return o.buffer}static insert(s,c,t){if(s===null||s===e.$bt)return s;const r=v(s),h=r.length>>>1;let o=P.$at.findIndexInTokensArray(r,c);o>0&&r[o-1<<1]===c&&o--;for(let l=o;l<h;l++)r[l<<1]+=t;return s}}e.$ct=S;function v(A){return A instanceof Uint32Array?A:new Uint32Array(A)}e.$dt=v}),define(G[28],V([0,1,26,12,44,13,27,15]),function(W,e,P,S,v,A,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0;class t{static deserialize(h,o,l){const f=new Uint32Array(h.buffer),i=(0,S.$ie)(h,o);o+=4;const n=(0,S.$ie)(h,o);o+=4;const a=[];for(let b=0;b<n;b++){const C=(0,S.$ie)(h,o);o+=4,a.push(f.subarray(o/4,o/4+C/4)),o+=C}return l.push(new t(i,a)),o}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(h,o){this.a=h,this.b=o}getLineRange(){return new c.$Is(this.a,this.a+this.b.length)}getLineTokens(h){return this.b[h-this.a]}appendLineTokens(h){this.b.push(h)}serializeSize(){let h=0;h+=4,h+=4;for(let o=0;o<this.b.length;o++){const l=this.b[o];if(!(l instanceof Uint32Array))throw new Error("Not supported!");h+=4,h+=l.byteLength}return h}serialize(h,o){(0,S.$je)(h,this.a,o),o+=4,(0,S.$je)(h,this.b.length,o),o+=4;for(let l=0;l<this.b.length;l++){const f=this.b[l];if(!(f instanceof Uint32Array))throw new Error("Not supported!");(0,S.$je)(h,f.byteLength,o),o+=4,h.set(new Uint8Array(f.buffer),o),o+=f.byteLength}return o}applyEdit(h,o){const[l,f]=(0,A.$_s)(o);this.c(h),this.d(new v.$ys(h.startLineNumber,h.startColumn),l,f)}c(h){if(h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn)return;const o=h.startLineNumber-this.a,l=h.endLineNumber-this.a;if(l<0){const f=l-o;this.a-=f;return}if(!(o>=this.b.length)){if(o<0&&l>=this.b.length){this.a=0,this.b=[];return}if(o===l){this.b[o]=s.$ct.delete(this.b[o],h.startColumn-1,h.endColumn-1);return}if(o>=0)if(this.b[o]=s.$ct.deleteEnding(this.b[o],h.startColumn-1),l<this.b.length){const f=s.$ct.deleteBeginning(this.b[l],h.endColumn-1);this.b[o]=s.$ct.append(this.b[o],f),this.b.splice(o+1,l-o)}else this.b[o]=s.$ct.append(this.b[o],null),this.b=this.b.slice(0,o+1);else{const f=-o;this.a-=f,this.b[l]=s.$ct.deleteBeginning(this.b[l],h.endColumn-1),this.b=this.b.slice(l)}}}d(h,o,l){if(o===0&&l===0)return;const f=h.lineNumber-this.a;if(f<0){this.a+=o;return}if(!(f>=this.b.length)){if(o===0){this.b[f]=s.$ct.insert(this.b[f],h.column-1,l);return}this.b[f]=s.$ct.deleteEnding(this.b[f],h.column-1),this.b[f]=s.$ct.insert(this.b[f],h.column-1,l),this.e(h.lineNumber,o)}}e(h,o){if(o===0)return;const l=[];for(let f=0;f<o;f++)l[f]=null;this.b=P.$Vb(this.b,h,l)}}e.$et=t}),define(G[16],V([0,1,12,28]),function(W,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RB=void 0;class v{static deserialize(s){let c=0;const t=(0,P.$ie)(s,c);c+=4;const r=[];for(let h=0;h<t;h++)c=S.$et.deserialize(s,c,r);return r}constructor(){this.a=[]}add(s,c){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(c);return}}this.a.push(new S.$et(s,[c]))}finalize(){return this.a}serialize(){const s=this.b(),c=new Uint8Array(s);return this.c(c),c}b(){let s=0;s+=4;for(let c=0;c<this.a.length;c++)s+=this.a[c].serializeSize();return s}c(s){let c=0;(0,P.$je)(s,this.a.length,c),c+=4;for(let t=0;t<this.a.length;t++)c=this.a[t].serialize(s,c)}}e.$RB=v}),define(G[29],V([0,1,30,3,31,45]),function(W,e,P,S,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function s($){return $===47||$===92}e.$Tf=s;function c($){return $.replace(/[\\/]/g,P.$fc.sep)}e.$Uf=c;function t($){return $.indexOf("/")===-1&&($=c($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Vf=t;function r($,m=P.$fc.sep){if(!$)return"";const k=$.length,F=$.charCodeAt(0);if(s(F)){if(s($.charCodeAt(1))&&!s($.charCodeAt(2))){let d=3;const j=d;for(;d<k&&!s($.charCodeAt(d));d++);if(j!==d&&!s($.charCodeAt(d+1))){for(d+=1;d<k;d++)if(s($.charCodeAt(d)))return $.slice(0,d+1).replace(/[\\/]/g,m)}}return m}else if(b(F)&&$.charCodeAt(1)===58)return s($.charCodeAt(2))?$.slice(0,2)+m:$.slice(0,2);let T=$.indexOf("://");if(T!==-1){for(T+=3;T<k;T++)if(s($.charCodeAt(T)))return $.slice(0,T+1)}return""}e.$Wf=r;function h($){if(!S.$i||!$||$.length<5)return!1;let m=$.charCodeAt(0);if(m!==92||(m=$.charCodeAt(1),m!==92))return!1;let k=2;const F=k;for(;k<$.length&&(m=$.charCodeAt(k),m!==92);k++);return!(F===k||(m=$.charCodeAt(k+1),isNaN(m)||m===92))}e.$Xf=h;const o=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i($,m=S.$i){const k=m?o:l;return!(!$||$.length===0||/^\s+$/.test($)||(k.lastIndex=0,k.test($))||m&&f.test($)||$==="."||$===".."||m&&$[$.length-1]==="."||m&&$.length!==$.trim().length||$.length>255)}e.$Yf=i;function n($,m,k){const F=$===m;return!k||F?F:!$||!m?!1:(0,v.$5e)($,m)}e.$Zf=n;function a($,m,k,F=P.sep){if($===m)return!0;if(!$||!m||m.length>$.length)return!1;if(k){if(!(0,v.$6e)($,m))return!1;if(m.length===$.length)return!0;let d=m.length;return m.charAt(m.length-1)===F&&d--,$.charAt(d)===F}return m.charAt(m.length-1)!==F&&(m+=F),$.indexOf(m)===0}e.$1f=a;function b($){return $>=65&&$<=90||$>=97&&$<=122}e.$2f=b;function C($,m){return S.$i&&$.endsWith(":")&&($+=P.sep),(0,P.$hc)($)||($=(0,P.$ic)(m,$)),$=(0,P.$gc)($),S.$i?($=(0,v.$Ne)($,P.sep),$.endsWith(":")&&($+=P.sep)):($=(0,v.$Ne)($,P.sep),$||($=P.sep)),$}e.$3f=C;function B($){const m=(0,P.$gc)($);return S.$i?$.length>3?!1:L(m)&&($.length===2||m.charCodeAt(2)===92):m===P.$fc.sep}e.$4f=B;function L($,m=S.$i){return m?b($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$5f=L;function I($,m=S.$i){return L($,m)?$[0]:void 0}e.$6f=I;function g($,m,k){return m.length>$.length?-1:$===m?0:(k&&($=$.toLowerCase(),m=m.toLowerCase()),$.indexOf(m))}e.$7f=g;function E($){const m=$.split(":");let k,F,T;for(const d of m){const j=Number(d);(0,A.$Ff)(j)?F===void 0?F=j:T===void 0&&(T=j):k=k?[k,d].join(":"):d}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:F!==void 0?F:void 0,column:T!==void 0?T:F!==void 0?1:void 0}}e.$8f=E;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",O="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U($,m,k=8){let F="";for(let d=0;d<k;d++){let j;d===0&&S.$i&&!m&&(k===3||k===4)?j=O:j=w,F+=j.charAt(Math.floor(Math.random()*j.length))}let T;return m?T=`${m}-${F}`:T=F,$?(0,P.$ic)($,T):T}e.$9f=U}),define(G[17],V([0,1,6,3,8]),function(W,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.Schemas=void 0;var A;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.vscodeManagedRemoteResource="vscode-managed-remote-resource",r.vscodeUserData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeInteractiveInput="vscode-interactive-input",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.vscodeChatSesssion="vscode-chat-editor",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp",r.vsls="vsls",r.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$0f="vscode-tkn",e.$$f="tkn";class s{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${A.vscodeRemoteResource}`}set(h,o,l){this.a[h]=o,this.b[h]=l}setConnectionToken(h,o){this.c[h]=o}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(a){return P.$Z(a),h}const o=h.authority;let l=this.a[o];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const f=this.b[o],i=this.c[o];let n=`path=${encodeURIComponent(h.path)}`;return typeof i=="string"&&(n+=`&${e.$$f}=${encodeURIComponent(i)}`),v.URI.from({scheme:S.$o?this.d:A.vscodeRemoteResource,authority:`${l}:${f}`,path:this.f,query:n})}}e.$_f=new s,e.$ag="vs/../../extensions",e.$bg="vs/../../node_modules",e.$cg="vs/../../node_modules.asar",e.$dg="vs/../../node_modules.asar.unpacked",e.$eg="vscode-app";class c{static{this.a=e.$eg}asBrowserUri(h){const o=this.b(h,W);return this.uriToBrowserUri(o)}uriToBrowserUri(h){return h.scheme===A.vscodeRemote?e.$_f.rewrite(h):h.scheme===A.file&&(S.$m||S.$q===`${A.vscodeFileResource}://${c.a}`)?h.with({scheme:A.vscodeFileResource,authority:h.authority||c.a,query:null,fragment:null}):h}asFileUri(h){const o=this.b(h,W);return this.uriToFileUri(o)}uriToFileUri(h){return h.scheme===A.vscodeFileResource?h.with({scheme:A.file,authority:h.authority!==c.a?h.authority:null,query:null,fragment:null}):h}b(h,o){return v.URI.isUri(h)?h:v.URI.parse(o.toUrl(h))}}e.$fg=new c;var t;(function(r){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);r.CoopAndCoep=Object.freeze(h.get("3"));const o="vscode-coi";function l(i){let n;typeof i=="string"?n=new URL(i).searchParams:i instanceof URL?n=i.searchParams:v.URI.isUri(i)&&(n=new URL(i.toString(!0)).searchParams);const a=n?.get(o);if(a)return h.get(a)}r.getHeadersFromQuery=l;function f(i,n,a){if(!globalThis.crossOriginIsolated)return;const b=n&&a?"3":a?"2":"1";i instanceof URLSearchParams?i.set(o,b):i[o]=b}r.addSearchParam=f})(t||(e.COI=t={}))}),define(G[32],V([0,1,21,17,3,8]),function(W,e,P,S,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=void 0;class s{constructor(l,f,i){this.id=l,this.dependencies=f,this.callback=i}}class c{static{this.INSTANCE=new c}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(l,f,i)=>{typeof l!="string"&&(i=f,f=l,l=null),(typeof f!="object"||!Array.isArray(f))&&(i=f,f=null),this.c.push(new s(l,f,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){if(l.startsWith(window.location.origin)||l.startsWith("vscode-file://vscode-app"))return l;throw new Error(`[trusted_script_src] Invalid script url: ${l}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(l){return l}})))}async load(l){this.g();const f=await(this.a?this.i(l):this.b?this.h(l):this.j(l));if(!f)throw new Error(`Did not receive a define call from script ${l}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${l}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(l){return new Promise((f,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const a=()=>{n.removeEventListener("load",b),n.removeEventListener("error",C)},b=B=>{a(),f(this.c.pop())},C=B=>{a(),i(B)};n.addEventListener("load",b),n.addEventListener("error",C),this.f&&(l=this.f.createScriptURL(l)),n.setAttribute("src",l),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(l){return new Promise((f,i)=>{try{this.f&&(l=this.f.createScriptURL(l)),importScripts(l),f(this.c.pop())}catch(n){i(n)}})}async j(l){try{const f=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,a=A.URI.parse(l).fsPath,b=f.readFileSync(a).toString(),C=n.wrap(b.replace(/^#!.*/,""));return new i.Script(C).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const t=new Map;let r={};typeof globalThis.require=="object"&&(r=globalThis.require.paths??{});async function h(o,l,f){if(P.$S){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),r[o]&&(o=r[o]);const i=`${o}/${l}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const B=`${f&&!v.$o?S.$cg:S.$bg}/${i}`;n=S.$fg.asBrowserUri(B).toString(!0)}const a=c.INSTANCE.load(n);return t.set(i,a),a}else return await new Promise((i,n)=>{W([o],i,n)})}e.$NC=h}),define(G[18],V([0,1,29,17,30,3,31,8]),function(W,e,P,S,v,A,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ig=e.DataUri=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=void 0;function t(f){return(0,c.$vc)(f,!0)}e.$mg=t;class r{constructor(i){this.a=i}compare(i,n,a=!1){return i===n?0:(0,s.$Xe)(this.getComparisonKey(i,a),this.getComparisonKey(n,a))}isEqual(i,n,a=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,a)===this.getComparisonKey(n,a)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,a=!1){if(i.scheme===n.scheme){if(i.scheme===S.Schemas.file)return P.$1f(t(i),t(n),this.a(i))&&i.query===n.query&&(a||i.fragment===n.fragment);if((0,e.$Dg)(i.authority,n.authority))return P.$1f(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(a||i.fragment===n.fragment)}return!1}joinPath(i,...n){return c.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$vg)(i)||i.authority}basename(i){return v.$fc.basename(i.path)}extname(i){return v.$fc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===S.Schemas.file?n=c.URI.file(v.$lc(t(i))).path:(n=v.$fc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===S.Schemas.file?n=c.URI.file(v.$gc(t(i))).path:n=v.$fc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Dg)(i.authority,n.authority))return;if(i.scheme===S.Schemas.file){const C=v.$kc(t(i),t(n));return A.$i?P.$Uf(C):C}let a=i.path||"/";const b=n.path||"/";if(this.a(i)){let C=0;for(const B=Math.min(a.length,b.length);C<B&&!(a.charCodeAt(C)!==b.charCodeAt(C)&&a.charAt(C).toLowerCase()!==b.charAt(C).toLowerCase());C++);a=b.substr(0,C)+a.substr(C)}return v.$fc.relative(a,b)}resolvePath(i,n){if(i.scheme===S.Schemas.file){const a=c.URI.file(v.$jc(t(i),n));return i.with({authority:a.authority,path:a.path})}return n=P.$Vf(n),i.with({path:v.$fc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,s.$5e)(i,n)}hasTrailingPathSeparator(i,n=v.sep){if(i.scheme===S.Schemas.file){const a=t(i);return a.length>P.$Wf(a).length&&a[a.length-1]===n}else{const a=i.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=v.sep){return(0,e.$Eg)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=v.sep){let a=!1;if(i.scheme===S.Schemas.file){const b=t(i);a=b!==void 0&&b.length===P.$Wf(b).length&&b[b.length-1]===n}else{n="/";const b=i.path;a=b.length===1&&b.charCodeAt(b.length-1)===47}return!a&&!(0,e.$Eg)(i,n)?i.with({path:i.path+"/"}):i}}e.$ng=r,e.$og=new r(()=>!1),e.$pg=new r(f=>f.scheme===S.Schemas.file?!A.$k:!0),e.$qg=new r(f=>!0),e.$rg=e.$og.isEqual.bind(e.$og),e.$sg=e.$og.isEqualOrParent.bind(e.$og),e.$tg=e.$og.getComparisonKey.bind(e.$og),e.$ug=e.$og.basenameOrAuthority.bind(e.$og),e.$vg=e.$og.basename.bind(e.$og),e.$wg=e.$og.extname.bind(e.$og),e.$xg=e.$og.dirname.bind(e.$og),e.$yg=e.$og.joinPath.bind(e.$og),e.$zg=e.$og.normalizePath.bind(e.$og),e.$Ag=e.$og.relativePath.bind(e.$og),e.$Bg=e.$og.resolvePath.bind(e.$og),e.$Cg=e.$og.isAbsolutePath.bind(e.$og),e.$Dg=e.$og.isEqualAuthority.bind(e.$og),e.$Eg=e.$og.hasTrailingPathSeparator.bind(e.$og),e.$Fg=e.$og.removeTrailingPathSeparator.bind(e.$og),e.$Gg=e.$og.addTrailingPathSeparator.bind(e.$og);function h(f,i){const n=[];for(let a=0;a<f.length;a++){const b=i(f[a]);f.some((C,B)=>B===a?!1:(0,e.$sg)(b,i(C)))||n.push(f[a])}return n}e.$Hg=h;var o;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function i(n){const a=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(B=>{const[L,I]=B.split(":");L&&I&&a.set(L,I)});const C=n.path.substring(0,n.path.indexOf(";"));return C&&a.set(f.META_DATA_MIME,C),a}f.parseMetaData=i})(o||(e.DataUri=o={}));function l(f,i,n){if(i){let a=f.path;return a&&a[0]!==v.$fc.sep&&(a=v.$fc.sep+a),f.with({scheme:n,authority:i,path:a})}return f.with({scheme:n})}e.$Ig=l}),define(G[19],V([0,1,46,6,33,2,18,3,24]),function(W,e,P,S,v,A,s,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.Promises=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=void 0;function r(M){return!!M&&typeof M.then=="function"}e.$Jg=r;function h(M){const u=new P.$1d,y=M(u.token),N=new Promise((R,q)=>{const Z=u.token.onCancellationRequested(()=>{Z.dispose(),u.dispose(),q(new S.$4)});Promise.resolve(y).then(Y=>{Z.dispose(),u.dispose(),R(Y)},Y=>{Z.dispose(),u.dispose(),q(Y)})});return new class{cancel(){u.cancel()}then(R,q){return N.then(R,q)}catch(R){return this.then(void 0,R)}finally(R){return N.finally(R)}}}e.$Kg=h;function o(M,u,y){return new Promise((N,R)=>{const q=u.onCancellationRequested(()=>{q.dispose(),N(y)});M.then(N,R).finally(()=>q.dispose())})}e.$Lg=o;function l(M,u){return new Promise((y,N)=>{const R=u.onCancellationRequested(()=>{R.dispose(),N(new S.$4)});M.then(y,N).finally(()=>R.dispose())})}e.$Mg=l;async function f(M){let u=-1;const y=M.map((N,R)=>N.then(q=>(u=R,q)));try{return await Promise.race(y)}finally{M.forEach((N,R)=>{R!==u&&N.cancel()})}}e.$Ng=f;function i(M,u,y){let N;const R=setTimeout(()=>{N?.(void 0),y?.()},u);return Promise.race([M.finally(()=>clearTimeout(R)),new Promise(q=>N=q)])}e.$Og=i;function n(M){return new Promise((u,y)=>{const N=M();r(N)?N.then(u,y):u(N)})}e.$Pg=n;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const y=()=>{if(this.b=null,this.f)return;const N=this.queue(this.d);return this.d=null,N};this.b=new Promise(N=>{this.a.then(y,y).then(N)})}return new Promise((y,N)=>{this.b.then(y,N)})}return this.a=u(),new Promise((y,N)=>{this.a.then(R=>{this.a=null,y(R)},R=>{this.a=null,N(R)})})}dispose(){this.f=!0}}e.$Qg=a;class b{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$Rg=b;class C{constructor(){this.a=new Map}queue(u,y){const R=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(u)===R&&this.a.delete(u)});return this.a.set(u,R),R}}e.$Sg=C;const B=(M,u)=>{let y=!0;const N=setTimeout(()=>{y=!1,u()},M);return{isTriggered:()=>y,dispose:()=>{clearTimeout(N),y=!1}}},L=M=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,M())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class I{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,y=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((R,q)=>{this.d=R,this.f=q}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const N=()=>{this.a=null,this.d?.(null)};return this.a=y===t.$Nd?L(N):B(y,N),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Tg=I;class g{constructor(u){this.a=new I(u),this.b=new a}trigger(u,y){return this.a.trigger(()=>this.b.queue(u),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ug=g;class E{constructor(){this.a=!1,this.b=new Promise((u,y)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Vg=E;class w extends E{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$Wg=w;function O(M,u){return u?new Promise((y,N)=>{const R=setTimeout(()=>{q.dispose(),y()},M),q=u.onCancellationRequested(()=>{clearTimeout(R),q.dispose(),N(new S.$4)})}):h(y=>O(M,y))}e.$Xg=O;function U(M,u=0,y){const N=setTimeout(()=>{M(),y&&R.dispose()},u),R=(0,A.$Pc)(()=>{clearTimeout(N),y?.deleteAndLeak(R)});return y?.add(R),R}e.$Yg=U;function $(M){const u=[];let y=0;const N=M.length;function R(){return y<N?M[y++]():null}function q(Z){Z!=null&&u.push(Z);const Y=R();return Y?Y.then(q):Promise.resolve(u)}return Promise.resolve(null).then(q)}e.$Zg=$;function m(M,u=N=>!!N,y=null){let N=0;const R=M.length,q=()=>{if(N>=R)return Promise.resolve(y);const Z=M[N++];return Promise.resolve(Z()).then(J=>u(J)?Promise.resolve(J):q())};return q()}e.$1g=m;function k(M,u=N=>!!N,y=null){if(M.length===0)return Promise.resolve(y);let N=M.length;const R=()=>{N=-1;for(const q of M)q.cancel?.()};return new Promise((q,Z)=>{for(const Y of M)Y.then(J=>{--N>=0&&u(J)?(R(),q(J)):N===0&&q(y)}).catch(J=>{--N>=0&&(R(),Z(J))})})}e.$2g=k;class F{constructor(u){this.a=0,this.d=u,this.f=[],this.b=0,this.g=new v.$Qd}get onDrained(){return this.g.event}get size(){return this.a}queue(u){return this.a++,new Promise((y,N)=>{this.f.push({factory:u,c:y,e:N}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const u=this.f.shift();this.b++;const y=u.factory();y.then(u.c,u.e),y.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$3g=F;class T extends F{constructor(){super(1)}}e.$4g=T;class d{constructor(){this.a=new ee,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$5g=d;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new x;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueFor(u,y=s.$og){const N=y.getComparisonKey(u);let R=this.a.get(N);if(!R){R=new T;const q=this.f++,Z=v.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(N),this.h(),this.d?.deleteAndDispose(q),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$Zc),this.d.set(q,Z),this.a.set(N,R)}return R}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$6g=j;class D{constructor(u,y){this.a=-1,typeof u=="function"&&typeof y=="number"&&this.setIfNotSet(u,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},y)}setIfNotSet(u,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},y))}}e.$7g=D;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(u,y,N=globalThis){this.cancel();const R=N.setInterval(()=>{u()},y);this.d=(0,A.$Pc)(()=>{N.clearInterval(R),this.d=void 0})}dispose(){this.cancel()}}e.$8g=z;class p{constructor(u,y){this.b=-1,this.a=u,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$9g=p;class H{constructor(u,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=u,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$0g=H;class K extends p{constructor(u,y){super(u,y),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$$g=K;class _ extends A.$Rc{constructor(u,y){super(),this.g=u,this.h=y,this.a=[],this.b=this.B(new A.$Sc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of u)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new p(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$_g=_,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$bh=(M,u)=>{(0,c.$B)(()=>{if(y)return;const N=Date.now()+15;u(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let y=!1;return{dispose(){y||(y=!0)}}}:e.$bh=(M,u,y)=>{const N=M.requestIdleCallback(u,typeof y=="number"?{timeout:y}:void 0);let R=!1;return{dispose(){R||(R=!0,M.cancelIdleCallback(N))}}},e.$ah=M=>(0,e.$bh)(globalThis,M)}();class X{constructor(u,y){this.g=!1,this.d=()=>{try{this.j=y()}catch(N){this.l=N}finally{this.g=!0}},this.f=(0,e.$bh)(u,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$ch=X;class re extends X{constructor(u){super(globalThis,u)}}e.$dh=re;async function ae(M,u,y){let N;for(let R=0;R<y;R++)try{return await M()}catch(q){N=q,await O(u)}throw N}e.$eh=ae;class ee{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,y,N){return this.a={taskId:u,cancel:()=>N?.(),promise:y},y.then(()=>this.d(u),()=>this.d(u)),y}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{let y,N;const R=new Promise((q,Z)=>{y=q,N=Z});this.b={run:u,promise:R,promiseResolve:y,promiseReject:N}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$fh=ee;class he{constructor(u,y=()=>Date.now()){this.d=u,this.f=y,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$gh=he;var te;(function(M){M[M.Resolved=0]="Resolved",M[M.Rejected=1]="Rejected"})(te||(te={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,y)=>{this.a=u,this.b=y})}complete(u){return new Promise(y=>{this.a(u),this.d={outcome:0,value:u},y()})}error(u){return new Promise(y=>{this.b(u),this.d={outcome:1,value:u},y()})}cancel(){return this.error(new S.$4)}}e.$hh=x;var ne;(function(M){async function u(N){let R;const q=await Promise.all(N.map(Z=>Z.then(Y=>Y,Y=>{R||(R=Y)})));if(typeof R<"u")throw R;return q}M.settled=u;function y(N){return new Promise(async(R,q)=>{try{await N(R,q)}catch(Z){q(Z)}})}M.withAsyncBody=y})(ne||(e.Promises=ne={}));var ie;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(ie||(ie={}));class Q{static fromArray(u){return new Q(y=>{y.emitMany(u)})}static fromPromise(u){return new Q(async y=>{y.emitMany(await u)})}static fromPromises(u){return new Q(async y=>{await Promise.all(u.map(async N=>y.emitOne(await N)))})}static merge(u){return new Q(async y=>{await Promise.all(u.map(async N=>{for await(const R of N)y.emitOne(R)}))})}static{this.EMPTY=Q.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new v.$Qd,queueMicrotask(async()=>{const y={emitOne:N=>this.g(N),emitMany:N=>this.h(N),reject:N=>this.k(N)};try{await Promise.resolve(u(y)),this.j()}catch(N){this.k(N)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(u,y){return new Q(async N=>{for await(const R of u)N.emitOne(y(R))})}map(u){return Q.map(this,u)}static filter(u,y){return new Q(async N=>{for await(const R of u)y(R)&&N.emitOne(R)})}filter(u){return Q.filter(this,u)}static coalesce(u){return Q.filter(u,y=>!!y)}coalesce(){return Q.coalesce(this)}static async toPromise(u){const y=[];for await(const N of u)y.push(N);return y}toPromise(){return Q.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}e.$ih=Q;class se extends Q{constructor(u,y){super(y),this.l=u}cancel(){this.l.cancel()}}e.$jh=se;function oe(M){const u=new P.$1d,y=M(u.token);return new se(u,async N=>{const R=u.token.onCancellationRequested(()=>{R.dispose(),u.dispose(),N.reject(new S.$4)});try{for await(const q of y){if(u.token.isCancellationRequested)return;N.emitOne(q)}R.dispose(),u.dispose()}catch(q){R.dispose(),u.dispose(),N.reject(q)}})}e.$kh=oe;class ue{constructor(){this.a=new x,this.b=new Q(N=>{if(u){N.reject(u);return}return y&&N.emitMany(y),this.d=R=>N.reject(R),this.f=R=>N.emitOne(R),this.a.p});let u,y;this.f=N=>{y||(y=[]),y.push(N)},this.d=N=>{u||(u=N)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(u){this.d(u),this.a.complete()}emitOne(u){this.f(u)}}e.$lh=ue}),define(G[20],V([0,1,34]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PB=e.$OB=e.$NB=void 0,e.$NB=new class{clone(){return this}equals(A){return this===A}};function S(A,s){return new P.$ht([new P.$gt(0,"",A)],s)}e.$OB=S;function v(A,s){const c=new Uint32Array(2);return c[0]=0,c[1]=(A<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new P.$it(c,s===null?e.$NB:s)}e.$PB=v}),define(G[35],V([0,1,19,6,3,36,13,15,47,20,25,16,7]),function(W,e,P,S,v,A,s,c,t,r,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.$SB=void 0;var f;(function(I){I[I.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(f||(f={}));class i{constructor(g,E){this.tokenizationSupport=E,this.a=this.tokenizationSupport.getInitialState(),this.store=new a(g)}getStartState(g){return this.store.getStartState(g,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$SB=i;class n extends i{constructor(g,E,w,O){super(g,E),this._textModel=w,this._languageIdCodec=O}updateTokensUntilLine(g,E){const w=this._textModel.getLanguageId();for(;;){const O=this.getFirstInvalidLine();if(!O||O.lineNumber>E)break;const U=this._textModel.getLineContent(O.lineNumber),$=B(this._languageIdCodec,w,this.tokenizationSupport,U,!0,O.startState);g.add(O.lineNumber,$.tokens),this.store.setEndState(O.lineNumber,$.endState)}}getTokenTypeIfInsertingCharacter(g,E){const w=this.getStartState(g.lineNumber);if(!w)return 0;const O=this._textModel.getLanguageId(),U=this._textModel.getLineContent(g.lineNumber),$=U.substring(0,g.column-1)+E+U.substring(g.column-1),m=B(this._languageIdCodec,O,this.tokenizationSupport,$,!0,w),k=new l.$at(m.tokens,$,this._languageIdCodec);if(k.getCount()===0)return 0;const F=k.findTokenIndexAtOffset(g.column-1);return k.getStandardTokenType(F)}tokenizeLineWithEdit(g,E,w){const O=g.lineNumber,U=g.column,$=this.getStartState(O);if(!$)return null;const m=this._textModel.getLineContent(O),k=m.substring(0,U-1)+w+m.substring(U-1+E),F=this._textModel.getLanguageIdAtPosition(O,0),T=B(this._languageIdCodec,F,this.tokenizationSupport,k,!0,$);return new l.$at(T.tokens,k,this._languageIdCodec)}isCheapToTokenize(g){const E=this.store.getFirstInvalidEndStateLineNumberOrMax();return g<E||g===E&&this._textModel.getLineLength(g)<2048}tokenizeHeuristically(g,E,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(E<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(g,w),{heuristicTokens:!1};let O=this.b(E);const U=this._textModel.getLanguageId();for(let $=E;$<=w;$++){const m=this._textModel.getLineContent($),k=B(this._languageIdCodec,U,this.tokenizationSupport,m,!0,O);g.add($,k.tokens),O=k.endState}return{heuristicTokens:!0}}b(g){let E=this._textModel.getLineFirstNonWhitespaceColumn(g);const w=[];let O=null;for(let m=g-1;E>1&&m>=1;m--){const k=this._textModel.getLineFirstNonWhitespaceColumn(m);if(k!==0&&k<E&&(w.push(this._textModel.getLineContent(m)),E=k,O=this.getStartState(m),O))break}O||(O=this.tokenizationSupport.getInitialState()),w.reverse();const U=this._textModel.getLanguageId();let $=O;for(const m of w)$=B(this._languageIdCodec,U,this.tokenizationSupport,m,!1,$).endState;return $}}e.$TB=n;class a{constructor(g){this.d=g,this.a=new b,this.b=new C,this.b.addRange(new t.$Gs(1,g+1))}getEndState(g){return this.a.getEndState(g)}setEndState(g,E){if(!E)throw new S.$bb("Cannot set null/undefined state");this.b.delete(g);const w=this.a.setEndState(g,E);return w&&g<this.d&&this.b.addRange(new t.$Gs(g+1,g+2)),w}acceptChange(g,E){this.d+=E-g.length,this.a.acceptChange(g,E),this.b.addRangeAndResize(new t.$Gs(g.startLineNumber,g.endLineNumberExclusive),E)}acceptChanges(g){for(const E of g){const[w]=(0,s.$_s)(E.text);this.acceptChange(new c.$Is(E.range.startLineNumber,E.range.endLineNumber+1),w+1)}}invalidateEndStateRange(g){this.b.addRange(new t.$Gs(g.startLineNumber,g.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(g,E){return g===1?E:this.getEndState(g-1)}getFirstInvalidLine(g){const E=this.getFirstInvalidEndStateLineNumber();if(E===null)return null;const w=this.getStartState(E,g);if(!w)throw new S.$bb("Start state must be defined");return{lineNumber:E,startState:w}}}e.$UB=a;class b{constructor(){this.a=new h.$QB(null)}getEndState(g){return this.a.get(g)}setEndState(g,E){const w=this.a.get(g);return w&&w.equals(E)?!1:(this.a.set(g,E),!0)}acceptChange(g,E){let w=g.length;E>0&&w>0&&(w--,E--),this.a.replace(g.startLineNumber,w,E)}acceptChanges(g){for(const E of g){const[w]=(0,s.$_s)(E.text);this.acceptChange(new c.$Is(E.range.startLineNumber,E.range.endLineNumber+1),w+1)}}}e.$VB=b;class C{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const g=this.a[0];return g.start+1===g.endExclusive?this.a.shift():this.a[0]=new t.$Gs(g.start+1,g.endExclusive),g.start}delete(g){const E=this.a.findIndex(w=>w.contains(g));if(E!==-1){const w=this.a[E];w.start===g?w.endExclusive===g+1?this.a.splice(E,1):this.a[E]=new t.$Gs(g+1,w.endExclusive):w.endExclusive===g+1?this.a[E]=new t.$Gs(w.start,g):this.a.splice(E,1,new t.$Gs(w.start,g),new t.$Gs(g+1,w.endExclusive))}}addRange(g){t.$Gs.addRange(g,this.a)}addRangeAndResize(g,E){let w=0;for(;!(w>=this.a.length||g.start<=this.a[w].endExclusive);)w++;let O=w;for(;!(O>=this.a.length||g.endExclusive<this.a[O].start);)O++;const U=E-g.length;for(let $=O;$<this.a.length;$++)this.a[$]=this.a[$].delta(U);if(w===O){const $=new t.$Gs(g.start,g.start+E);$.isEmpty||this.a.splice(w,0,$)}else{const $=Math.min(g.start,this.a[w].start),m=Math.max(g.endExclusive,this.a[O-1].endExclusive),k=new t.$Gs($,m+U);k.isEmpty?this.a.splice(w,O-w):this.a.splice(w,O-w,k)}}toString(){return this.a.map(g=>g.toString()).join(" + ")}}e.$WB=C;function B(I,g,E,w,O,U){let $=null;if(E)try{$=E.tokenizeEncoded(w,O,U.clone())}catch(m){(0,S.$Z)(m)}return $||($=(0,r.$PB)(I.encodeLanguageId(g),U)),l.$at.convertToEndOffset($.tokens,w.length),$}class L{constructor(g,E){this.b=g,this.d=E,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,P.$ah)(g=>{this.f=!1,this.h(g)}))}h(g){const E=Date.now()+g.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<E?(0,v.$B)(w):this.g())};w()}j(){const g=this.b._textModel.getLineCount(),E=new o.$RB,w=A.$Md.create(!1);do if(w.elapsed()>1||this.l(E)>=g)break;while(this.k());this.d.setTokens(E.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(g){const E=this.b?.getFirstInvalidLine();return E?(this.b.updateTokensUntilLine(g,E.lineNumber),E.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(g,E){this.b.store.invalidateEndStateRange(new c.$Is(g,E))}}e.$XB=L}),define(G[37],V([0,1,33,2,36,14,34]),function(W,e,P,S,v,A,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mFb=void 0;class c extends S.$Rc{constructor(r,h,o,l,f,i,n){super(),this.c=r,this.f=h,this.g=o,this.h=l,this.j=f,this.m=i,this.n=n,this.a=[],this.b=this.B(new P.$Qd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(r,h,o){throw new Error("Not supported!")}createBackgroundTokenizer(r,h){if(this.h)return this.h(r,h)}tokenizeEncoded(r,h,o){const l=Math.random()*1e4<1,f=this.n||l,i=f?new v.$Md(!0):void 0,n=this.c.tokenizeLine2(r,o,500);if(f){const b=i.elapsed();(l||b>32)&&this.m(b,r.length,l)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${r.substring(0,100)}`),new s.$it(n.tokens,o);if(this.g){const b=this.a,C=n.tokens;for(let B=0,L=C.length>>>1;B<L;B++){const I=C[(B<<1)+1],g=A.$0s.getLanguageId(I);b[g]||(b[g]=!0,this.b.fire(g))}}let a;return o.equals(n.ruleStack)?a=o:a=n.ruleStack,new s.$it(n.tokens,a)}}e.$mFb=c}),define(G[38],V([0,1,20,2,11]),function(W,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nFb=void 0;class A extends S.$Rc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(c,t,r){super(),this.a=c,this.b=t,this.c=r,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(c,t,r){throw new Error("Not supported!")}tokenizeEncoded(c,t,r){return c.length>=this.c.get()?(0,P.$PB)(this.a,r):this.b.tokenizeEncoded(c,t,r)}createBackgroundTokenizer(c,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(c,t)}}e.$nFb=A}),define(G[39],V([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(W,e,P,S,v,A,s,c,t,r,h,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sFb=void 0;class f extends c.$2u{constructor(a,b,C,B,L,I,g,E){super(a,b,C,B),this.s=L,this.t=I,this.u=g,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new S.$9g(()=>this.w(),10),this.c.set(E,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(a,b){this.t=a,this.u=b,this.v()}onEvents(a){super.onEvents(a),this.a?.store.acceptChanges(a.changes),this.q.schedule()}acceptMaxTokenizationLineLength(a){this.c.set(a,void 0)}retokenize(a,b){this.a&&(this.a.store.invalidateEndStateRange(new s.$Is(a,b)),this.q.schedule())}async v(){this.a=null;const a=this.t,b=this.u,C=await this.s.getOrCreateGrammar(a,b);if(!(this.b||a!==this.t||b!==this.u||!C)){if(C.grammar){const B=new l.$nFb(this.u,new o.$mFb(C.grammar,C.initialState,!1,void 0,()=>!1,(L,I,g)=>{this.s.reportTokenizationTime(L,a,C.sourceExtensionId,I,g)},!1),this.c);this.a=new t.$SB(this.f.length,B)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:b}=await(0,P.$NC)("vscode-textmate","release/main.js");this.m=b}const a=new Date().getTime();for(;;){let b=0;const C=new r.$RB,B=new i;for(;;){const g=this.a.getFirstInvalidLine();if(g===null||b>200)break;b++;const E=this.f[g.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded(E,!0,g.startState);if(this.a.store.setEndState(g.lineNumber,w.endState)){const U=this.m(g.startState,w.endState);B.setState(g.lineNumber,U)}else B.setState(g.lineNumber,null);if(h.$at.convertToEndOffset(w.tokens,E.length),C.add(g.lineNumber,w.tokens),new Date().getTime()-a>20)break}if(b===0)break;const L=B.getStateDeltas();if(this.s.setTokensAndStates(this.h,C.serialize(),L),new Date().getTime()-a>20){(0,A.$B)(()=>this.w());return}}}}e.$sFb=f;class i{constructor(){this.a=-1,this.b=[]}setState(a,b){a===this.a+1?this.b[this.b.length-1].stateDeltas.push(b):this.b.push({startLineNumber:a,stateDeltas:[b]}),this.a=a}getStateDeltas(){return this.b}}}),define(G[40],V([0,1,18]),function(W,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pFb=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(A){if(this.a[A.scopeName]){const s=this.a[A.scopeName];P.$rg(s.location,A.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${A.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${A.location.toString()}`)}this.a[A.scopeName]=A}getGrammarDefinition(A){return this.a[A]||null}}e.$pFb=S}),define(G[41],V([0,1,2,40]),function(W,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rFb=e.$qFb=void 0,e.$qFb="No TM Grammar registered for this language.";class v extends P.$Rc{constructor(s,c,t,r){super(),this.a=s,this.b=t.INITIAL,this.c=new S.$pFb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:r,loadGrammar:async h=>{const o=this.c.getGrammarDefinition(h);if(!o)return this.a.logTrace(`No grammar found for scope ${h}`),null;const l=o.location;try{const f=await this.a.readFile(l);return t.parseRawGrammar(f,l.path)}catch(f){return this.a.logError(`Unable to load and parse grammar for scope ${h} from ${l}`,f),null}},getInjections:h=>{const o=h.split(".");let l=[];for(let f=1;f<=o.length;f++){const i=o.slice(0,f).join(".");l=[...l,...this.f[i]||[]]}return l}}));for(const h of c){if(this.c.register(h),h.injectTo){for(const o of h.injectTo){let l=this.f[o];l||(this.f[o]=l=[]),l.push(h.scopeName)}if(h.embeddedLanguages)for(const o of h.injectTo){let l=this.g[o];l||(this.g[o]=l=[]),l.push(h.embeddedLanguages)}}h.language&&this.h.set(h.language,h.scopeName)}}has(s){return this.h.has(s)}setTheme(s,c){this.j.setTheme(s,c)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,c){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$qFb);const r=this.c.getGrammarDefinition(t);if(!r)throw new Error(e.$qFb);const h=r.embeddedLanguages;if(this.g[t]){const f=this.g[t];for(const i of f)for(const n of Object.keys(i))h[n]=i[n]}const o=Object.keys(h).length>0;let l;try{l=await this.j.loadGrammarWithConfiguration(t,c,{embeddedLanguages:h,tokenTypes:r.tokenTypes,balancedBracketSelectors:r.balancedBracketSelectors,unbalancedBracketSelectors:r.unbalancedBracketSelectors})}catch(f){throw f.message&&f.message.startsWith("No grammar provided for")?new Error(e.$qFb):f}return{languageId:s,grammar:l,initialState:this.b,containsEmbeddedLanguages:o,sourceExtensionId:r.sourceExtensionId}}}e.$rFb=v}),define(G[49],V([0,1,8,41,39]),function(W,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function A(c,t){return new s(c,t)}e.create=A;class s{constructor(t,r){this.f=r,this.b=new Map,this.c=[],this.a=t.host;const h=r.grammarDefinitions.map(o=>({location:P.URI.revive(o.location),language:o.language,scopeName:o.scopeName,embeddedLanguages:o.embeddedLanguages,tokenTypes:o.tokenTypes,injectTo:o.injectTo,balancedBracketSelectors:o.balancedBracketSelectors,unbalancedBracketSelectors:o.unbalancedBracketSelectors,sourceExtensionId:o.sourceExtensionId}));this.d=this.g(h)}async g(t){const r=this.f.textmateMainUri,h=await new Promise((n,a)=>{W([r],n,a)}),o=await new Promise((n,a)=>{W([this.f.onigurumaMainUri],n,a)}),f=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await o.loadWASM(f);const i=Promise.resolve({createOnigScanner:n=>o.createOnigScanner(n),createOnigString:n=>o.createOnigString(n)});return new S.$rFb({logTrace:n=>{},logError:(n,a)=>console.error(n,a),readFile:n=>this.a.readFile(n)},t,h,i)}acceptNewModel(t){const r=P.URI.revive(t.uri),h=this;this.b.set(t.controllerId,new v.$sFb(r,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(o,l){const f=await h.d;return f?(h.c[l]||(h.c[l]=f.createGrammar(o,l)),h.c[l]):Promise.resolve(null)},setTokensAndStates(o,l,f){h.a.setTokensAndStates(t.controllerId,o,l,f)},reportTokenizationTime(o,l,f,i,n){h.a.reportTokenizationTime(o,l,f,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,r){this.b.get(t).onEvents(r)}retokenize(t,r,h){this.b.get(t).retokenize(r,h)}acceptModelLanguageChanged(t,r,h){this.b.get(t).onLanguageId(r,h)}acceptRemovedModel(t){const r=this.b.get(t);r&&(r.dispose(),this.b.delete(t))}async acceptTheme(t,r){(await this.d)?.setTheme(t,r)}acceptMaxTokenizationLineLength(t,r){this.b.get(t).acceptMaxTokenizationLineLength(r)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/60c8cddf1ae631ce52714d885adba2cdc889415b/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
